/*************************************************************************
 *
 * Parallaxis Compiler Projects
 * ----------------------------
 *
 * name   :  StdProcs.c
 * desc   :  handling of buildin functions and procedures
 * Authors:  lampke
 *
 ************************************************************************/
#ifndef StdProcs_h
#define StdProcs_h

#include "parallaxis.h"
#include "BigSet.h"
#include "Symbols.h"

/*************************************************************************
 * name :  ParamCount
 * in   :  Identifier of StdProc, number of parameters, pointer to BITSET
 * out  :  TRUE, if StdProc support paramCount parameters
 *         FALSE and supported numbers of parameters in BITSET, otherwise
 ************************************************************************/
extern BOOLEAN StdProcs_ParamCount( tStdProc proc, unsigned long param,
  BITSET *params );

extern void StdProcs_Init( void );

#endif
