/*************************************************************************
 *
 * Parallaxis Compiler Projects
 * ----------------------------
 *
 * name  :  Pointer.c
 * desc  :  generates global and local pointernames
 * author:  lampke
 *
 ************************************************************************/

#include "Idents.h"			  /* Reuse-Library */
#include "parallaxis.h"
#include "GenIdents.h"
#include "Symbols.h"
#include "Pointer.h"

static BOOLEAN isInitialised = FALSE;

/*
 * global variables
 */

tCObjects Pointer_GlobalPtrs = NoCObjects;
tCObjects Pointer_LocalPtrs  = NoCObjects;

/*
 * global function implementation
 */

/*---------------------------------------------------------------------------*/

void Pointer_GenGlobalPtrs( tCObjects GlobalPtrs )
{
  while ( GlobalPtrs != NoCObjects ) {
    GlobalPtrs->SymCObjects.CObject =
      GenIdents_GlobalPtr( GlobalPtrs->SymCObjects.M2Object->SymVar.Ident );
    GlobalPtrs = GlobalPtrs->SymCObjects.Next;
  } /* endwhile */
}

/*---------------------------------------------------------------------------*/

void Pointer_GenLocalPtrs( tCObjects LocalPtrs )
{
  while ( LocalPtrs != NoCObjects ) {
    LocalPtrs->SymCObjects.CObject = GenIdents_LocalPtr();
    LocalPtrs = LocalPtrs->SymCObjects.Next;
  } /* endwhile */
}

/*---------------------------------------------------------------------------*/

tIdent Pointer_GetGlobalPtr( tObject M2Object )
{
  return( Symbols_LookUp( M2Object, Pointer_GlobalPtrs ) );
}

/*---------------------------------------------------------------------------*/

tIdent Pointer_GetLocalPtr( tObject M2Object )
{
  return( Symbols_LookUp( M2Object, Pointer_LocalPtrs ) );
}

/*---------------------------------------------------------------------------*/

void Pointer_Init( void )
{
  if ( !isInitialised ) {
    isInitialised = TRUE;

    GenIdents_Init();

    Pointer_GlobalPtrs = NoCObjects;
    Pointer_LocalPtrs  = NoCObjects;
  } /* endif */
}
