#include <stdio.h>
#include <string.h>

#include "SYSTEM_.h"

/*
 *	Implementation of standard functions
 */

CARDINAL argc()
{
  return SYSTEM_argc;
}

CARDINAL LEN
#ifdef __STDC__
(CONFIGURATION Config)
#else
(Config) CONFIGURATION Config;
#endif
{
  return Config.Dimensions;
}

INTEGER ABSI
#ifdef __STDC__
(register INTEGER x)
#else
(x) register INTEGER x;
#endif
{
  return (x < 0 ? -x : x);
}

REAL ABSR
#ifdef __STDC__
(register REAL x)
#else
(x) register REAL x;
#endif
{
  return (x < 0 ? -x : x);
}

CHAR CAP
#ifdef __STDC__
(register CHAR ch)
#else
(ch) register CHAR ch;
#endif
{
   return (ch >= 'a' && ch <= 'z' ? ch - 'a' + 'A' : ch);
}

/*
 *	Implementation of standard procedures
 */

extern void argv
#ifdef __STDC__
(CARDINAL index, CHAR arg[], CARDINAL arg_length)
#else
(index, arg, arg_length)
CARDINAL index;
CHAR arg[];
CARDINAL arg_length;
#endif
{
  (void) strncpy( arg, SYSTEM_argv[index], arg_length - 1 );
}

/*
 *	Implementation of set operators
 */

unsigned long SET_RANGE1
#ifdef __STDC__
(register CARDINAL lo, register CARDINAL hi)
#else
(lo, hi) register CARDINAL lo, hi;
#endif
{
    return (lo <= hi ? ~0X0L >> lo << lo + SYSTEM_MaxSet - hi >> SYSTEM_MaxSet - hi : 0X0L);
}

/*
 *	Implementation of compiler functions
 */

void CaseError
#ifdef __STDC__
(char file[], int line)
#else
(file, line) char file[]; int line;
#endif
{
  (void) fprintf (stderr, "\"%s\", line %1d: case expression out of range\n", file, line);
  exit(1);
}

void ReturnError
#ifdef __STDC__
(char file[], int line)
#else
(file, line) char file[]; int line;
#endif
{
  (void) fprintf (stderr, "\"%s\", line %1d: missing return from function\n", file, line);
  exit(1);
}

/*
 *	Main program
 */

extern void BEGIN_MODULE();

unsigned int SYSTEM_argc;
char **SYSTEM_argv;
char **SYSTEM_envp;

BOOLEAN Done;
char termCH;

int main
#ifdef __STDC__
(int argc, char *argv[], char *envp[])
#else
(argc, argv, envp)
int argc;
char *argv[], *envp[];
#endif
{
  SYSTEM_argc = argc;
  SYSTEM_argv = argv;
  SYSTEM_envp = envp;

  BEGIN_MODULE();

  exit(0);
}
