/* $Id: Scanner.c,v 2.16 1992/08/18 09:05:32 grosch rel $ */

# define bool		char
# define true		1
# define false		0
# define StdIn		0
 
# include "Scanner.h"
# include "Source.h"
# include "System.h"
# include "General.h"
# include "DynArray.h"
# include "Positions.h"
# include <stdio.h>
 
# if defined __STDC__ | defined __cplusplus
#  include <stdlib.h>
# else
/* extern char * malloc ();
   extern void free (); */
# endif

# define yyTabSpace	8

# define yyStart(State)	{ yyPreviousStart = yyStartState; yyStartState = State; }
# define yyPrevious	{ yyStateRange s = yyStartState; \
	 		yyStartState = yyPreviousStart; yyPreviousStart = s; }
# define yyEcho		{ char * yyEnd = TokenPtr + TokenLength; \
			char yyCh = * yyEnd; * yyEnd = '\0'; \
	 		(void) fputs (TokenPtr, stdout); * yyEnd = yyCh; }
# define yyLess(n)	{ yyChBufferIndex -= TokenLength - n; TokenLength = n; }
# define yyTab		yyLineStart -= yyTabSpace - 1 - ((unsigned char *) TokenPtr - yyLineStart - 1) % yyTabSpace
# define yyTab1(a)	yyLineStart -= yyTabSpace - 1 - ((unsigned char *) TokenPtr - yyLineStart + a - 1) % yyTabSpace
# define yyTab2(a,b)	yyLineStart -= yyTabSpace - 1 - ((unsigned char *) TokenPtr - yyLineStart + a - 1) % yyTabSpace
# define yyEol(Column)	{ yyLineCount ++; yyLineStart = yyChBufferIndex - 1 - Column; }
# define output(c)	(void) putchar ((int) c)
# define unput(c)	* (-- yyChBufferIndex) = c

# define yyDNoState		0
# define yyFileStackSize	16
# define yyInitBufferSize	1024 * 8 + 256
# define yyFirstCh	(unsigned char) '\0'
# define yyLastCh	(unsigned char) '\177'
# define yyEolCh	(unsigned char) '\12'
# define yyEobCh	(unsigned char) '\177'
# define yyDStateCount	288
# define yyTableSize	888
# define yyEobState	29
# define yyDefaultState	30
# define STD	1
# define Comment	3
# define Str1	5
# define Str2	7
 
static void yyExit () { Exit (1); }

typedef unsigned short	yyStateRange;
typedef struct { yyStateRange yyCheck, yyNext; } yyCombType;
 
	char *		TokenPtr	;
	short		TokenLength	;
	tScanAttribute	Attribute	;
	void		(* Scanner_Exit) () = yyExit;
 
static	yyCombType	yyComb		[yyTableSize   + 1] = {{1, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{1, 32},
{1, 31},
{37, 38},
{39, 38},
{1, 37},
{40, 38},
{41, 38},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{1, 33},
{0, 0},
{1, 282},
{1, 206},
{0, 0},
{0, 0},
{1, 278},
{1, 284},
{1, 226},
{1, 225},
{1, 217},
{1, 244},
{1, 259},
{1, 193},
{1, 237},
{1, 216},
{1, 12},
{1, 12},
{1, 12},
{1, 12},
{1, 12},
{1, 12},
{1, 12},
{1, 12},
{1, 22},
{1, 22},
{1, 48},
{1, 263},
{1, 190},
{1, 207},
{1, 203},
{23, 20},
{191, 192},
{1, 50},
{1, 79},
{1, 163},
{1, 186},
{1, 71},
{1, 136},
{42, 143},
{25, 27},
{1, 104},
{25, 27},
{42, 43},
{1, 58},
{1, 211},
{1, 241},
{1, 171},
{1, 145},
{1, 123},
{1, 65},
{1, 53},
{1, 100},
{1, 83},
{1, 42},
{1, 75},
{3, 32},
{3, 31},
{16, 19},
{1, 245},
{3, 39},
{1, 232},
{1, 231},
{43, 44},
{44, 45},
{5, 280},
{5, 279},
{45, 46},
{46, 47},
{5, 40},
{50, 51},
{51, 52},
{50, 209},
{7, 280},
{7, 279},
{53, 62},
{50, 173},
{7, 41},
{54, 55},
{3, 34},
{55, 56},
{56, 57},
{48, 49},
{58, 59},
{60, 61},
{63, 64},
{65, 66},
{3, 288},
{5, 35},
{3, 285},
{53, 54},
{1, 240},
{1, 162},
{1, 238},
{1, 276},
{5, 283},
{7, 36},
{28, 29},
{7, 281},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{48, 189},
{48, 233},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{67, 68},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{9, 9},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{68, 69},
{69, 70},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{73, 74},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{12, 23},
{59, 60},
{12, 12},
{12, 12},
{12, 12},
{12, 12},
{12, 12},
{12, 12},
{12, 12},
{12, 12},
{12, 22},
{12, 22},
{62, 63},
{75, 92},
{75, 76},
{59, 81},
{76, 77},
{77, 78},
{62, 160},
{81, 82},
{12, 16},
{12, 17},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{83, 84},
{84, 85},
{85, 86},
{86, 87},
{88, 89},
{89, 90},
{90, 91},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{92, 93},
{93, 94},
{94, 95},
{96, 97},
{13, 13},
{98, 99},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{13, 13},
{14, 14},
{14, 14},
{14, 14},
{14, 14},
{14, 14},
{14, 14},
{14, 14},
{14, 14},
{14, 14},
{14, 14},
{15, 15},
{15, 15},
{15, 15},
{15, 15},
{15, 15},
{15, 15},
{15, 15},
{15, 15},
{15, 15},
{15, 15},
{101, 102},
{14, 25},
{102, 103},
{106, 107},
{79, 106},
{107, 108},
{72, 73},
{15, 15},
{15, 15},
{15, 15},
{15, 15},
{15, 15},
{15, 15},
{72, 132},
{15, 18},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{79, 80},
{108, 109},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{110, 111},
{21, 21},
{112, 113},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{21, 21},
{22, 22},
{22, 22},
{22, 22},
{22, 22},
{22, 22},
{22, 22},
{22, 22},
{22, 22},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{24, 24},
{22, 26},
{22, 15},
{66, 167},
{66, 227},
{71, 96},
{97, 161},
{71, 184},
{100, 101},
{111, 112},
{97, 98},
{104, 105},
{111, 260},
{113, 114},
{114, 115},
{100, 188},
{66, 88},
{71, 72},
{104, 110},
{104, 202},
{66, 67},
{115, 116},
{116, 117},
{117, 118},
{118, 119},
{100, 177},
{119, 120},
{120, 121},
{121, 122},
{123, 124},
{124, 125},
{125, 126},
{126, 127},
{127, 128},
{128, 129},
{129, 130},
{130, 131},
{132, 133},
{133, 134},
{134, 135},
{136, 137},
{137, 138},
{138, 139},
{136, 256},
{139, 140},
{140, 141},
{141, 142},
{143, 144},
{145, 154},
{146, 147},
{147, 148},
{145, 146},
{148, 149},
{149, 150},
{150, 151},
{151, 152},
{152, 153},
{154, 155},
{155, 156},
{156, 157},
{157, 158},
{158, 159},
{163, 164},
{164, 165},
{165, 166},
{167, 219},
{168, 169},
{169, 170},
{171, 172},
{173, 174},
{174, 175},
{175, 176},
{177, 178},
{178, 179},
{180, 181},
{167, 168},
{163, 180},
{181, 246},
{182, 183},
{184, 185},
{171, 208},
{190, 191},
{186, 267},
{193, 194},
{195, 196},
{181, 195},
{186, 214},
{196, 197},
{197, 198},
{198, 199},
{181, 182},
{199, 200},
{186, 187},
{200, 201},
{190, 234},
{209, 210},
{190, 236},
{190, 205},
{190, 277},
{203, 204},
{203, 235},
{211, 212},
{212, 213},
{213, 264},
{214, 215},
{217, 218},
{219, 220},
{220, 221},
{221, 222},
{223, 224},
{226, 287},
{227, 228},
{228, 229},
{229, 230},
{237, 239},
{241, 242},
{242, 243},
{246, 247},
{247, 248},
{248, 249},
{212, 223},
{249, 250},
{250, 251},
{251, 252},
{252, 253},
{253, 254},
{254, 255},
{256, 257},
{257, 258},
{260, 261},
{261, 262},
{264, 265},
{265, 266},
{267, 268},
{268, 269},
{269, 270},
{270, 271},
{271, 272},
{272, 273},
{273, 274},
{274, 275},
{285, 286},
{288, 287},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
};
static	yyCombType *	yyBasePtr	[yyDStateCount + 1] = {& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [79],
& yyComb [0],
& yyComb [88],
& yyComb [0],
& yyComb [96],
& yyComb [0],
& yyComb [131],
& yyComb [258],
& yyComb [0],
& yyComb [339],
& yyComb [359],
& yyComb [434],
& yyComb [444],
& yyComb [1],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [517],
& yyComb [596],
& yyComb [17],
& yyComb [604],
& yyComb [29],
& yyComb [0],
& yyComb [0],
& yyComb [2],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [1],
& yyComb [0],
& yyComb [2],
& yyComb [4],
& yyComb [5],
& yyComb [6],
& yyComb [28],
& yyComb [12],
& yyComb [20],
& yyComb [18],
& yyComb [0],
& yyComb [79],
& yyComb [0],
& yyComb [26],
& yyComb [27],
& yyComb [0],
& yyComb [38],
& yyComb [31],
& yyComb [30],
& yyComb [44],
& yyComb [0],
& yyComb [36],
& yyComb [321],
& yyComb [48],
& yyComb [0],
& yyComb [319],
& yyComb [49],
& yyComb [0],
& yyComb [49],
& yyComb [597],
& yyComb [80],
& yyComb [185],
& yyComb [190],
& yyComb [0],
& yyComb [590],
& yyComb [435],
& yyComb [213],
& yyComb [0],
& yyComb [326],
& yyComb [317],
& yyComb [330],
& yyComb [0],
& yyComb [437],
& yyComb [0],
& yyComb [324],
& yyComb [0],
& yyComb [339],
& yyComb [334],
& yyComb [346],
& yyComb [344],
& yyComb [0],
& yyComb [352],
& yyComb [357],
& yyComb [339],
& yyComb [0],
& yyComb [377],
& yyComb [375],
& yyComb [383],
& yyComb [0],
& yyComb [370],
& yyComb [598],
& yyComb [385],
& yyComb [0],
& yyComb [597],
& yyComb [433],
& yyComb [426],
& yyComb [0],
& yyComb [602],
& yyComb [0],
& yyComb [434],
& yyComb [434],
& yyComb [449],
& yyComb [0],
& yyComb [477],
& yyComb [594],
& yyComb [490],
& yyComb [597],
& yyComb [606],
& yyComb [604],
& yyComb [599],
& yyComb [619],
& yyComb [601],
& yyComb [614],
& yyComb [609],
& yyComb [611],
& yyComb [0],
& yyComb [605],
& yyComb [626],
& yyComb [616],
& yyComb [620],
& yyComb [624],
& yyComb [622],
& yyComb [627],
& yyComb [629],
& yyComb [0],
& yyComb [619],
& yyComb [617],
& yyComb [616],
& yyComb [0],
& yyComb [622],
& yyComb [620],
& yyComb [634],
& yyComb [632],
& yyComb [635],
& yyComb [629],
& yyComb [0],
& yyComb [626],
& yyComb [0],
& yyComb [630],
& yyComb [631],
& yyComb [644],
& yyComb [644],
& yyComb [646],
& yyComb [630],
& yyComb [634],
& yyComb [648],
& yyComb [0],
& yyComb [645],
& yyComb [641],
& yyComb [636],
& yyComb [652],
& yyComb [640],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [658],
& yyComb [641],
& yyComb [656],
& yyComb [0],
& yyComb [657],
& yyComb [645],
& yyComb [660],
& yyComb [0],
& yyComb [659],
& yyComb [0],
& yyComb [648],
& yyComb [666],
& yyComb [643],
& yyComb [0],
& yyComb [653],
& yyComb [665],
& yyComb [0],
& yyComb [657],
& yyComb [668],
& yyComb [655],
& yyComb [0],
& yyComb [672],
& yyComb [0],
& yyComb [674],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [697],
& yyComb [2],
& yyComb [0],
& yyComb [682],
& yyComb [0],
& yyComb [676],
& yyComb [681],
& yyComb [665],
& yyComb [677],
& yyComb [673],
& yyComb [676],
& yyComb [0],
& yyComb [0],
& yyComb [699],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [688],
& yyComb [0],
& yyComb [683],
& yyComb [695],
& yyComb [679],
& yyComb [679],
& yyComb [0],
& yyComb [0],
& yyComb [724],
& yyComb [0],
& yyComb [694],
& yyComb [682],
& yyComb [700],
& yyComb [0],
& yyComb [701],
& yyComb [0],
& yyComb [0],
& yyComb [729],
& yyComb [687],
& yyComb [706],
& yyComb [705],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [729],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [697],
& yyComb [693],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [705],
& yyComb [708],
& yyComb [695],
& yyComb [700],
& yyComb [718],
& yyComb [700],
& yyComb [712],
& yyComb [707],
& yyComb [709],
& yyComb [0],
& yyComb [709],
& yyComb [712],
& yyComb [0],
& yyComb [0],
& yyComb [708],
& yyComb [707],
& yyComb [0],
& yyComb [0],
& yyComb [716],
& yyComb [724],
& yyComb [0],
& yyComb [724],
& yyComb [722],
& yyComb [718],
& yyComb [724],
& yyComb [714],
& yyComb [726],
& yyComb [721],
& yyComb [723],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [761],
& yyComb [0],
& yyComb [0],
& yyComb [761],
};
static	yyStateRange	yyDefault	[yyDStateCount + 1] = {0,
13,
1,
21,
3,
10,
5,
9,
7,
28,
28,
28,
15,
28,
28,
28,
15,
15,
0,
0,
0,
28,
12,
14,
28,
24,
16,
24,
0,
0,
0,
28,
28,
0,
21,
10,
9,
28,
0,
21,
10,
9,
13,
13,
13,
13,
13,
13,
28,
0,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
0,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
0,
28,
28,
0,
28,
0,
13,
13,
13,
13,
13,
13,
13,
13,
28,
0,
0,
0,
0,
13,
13,
13,
13,
13,
13,
13,
13,
0,
28,
0,
13,
13,
13,
13,
13,
13,
0,
28,
13,
13,
13,
13,
0,
0,
0,
0,
0,
0,
28,
0,
0,
0,
13,
13,
13,
0,
0,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
0,
13,
13,
13,
0,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
13,
0,
0,
0,
31,
32,
0,
0,
0,
0,
11,
0,
0,
11,
};
static	yyStateRange	yyEobTrans	[yyDStateCount + 1] = {0,
0,
0,
21,
21,
10,
10,
9,
9,
9,
10,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
21,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
21,
10,
9,
0,
0,
21,
10,
9,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
};

static	yyStateRange	yyInitStateStack [yyInitBufferSize] = {0};
static	yyStateRange *	yyStateStack	= yyInitStateStack;
static	unsigned long	yyStateStackSize= yyInitBufferSize;
static	yyStateRange	yyStartState	= 0;
static	yyStateRange	yyPreviousStart	= 1;

static  short		yySourceFile	;
static	bool		yyEof		;
static	unsigned char *	yyChBufferPtr	;
static	unsigned char *	yyChBufferStart	;
static	unsigned long	yyChBufferSize	;
static	unsigned char *	yyChBufferIndex	= ((unsigned char *) yyComb) + 2; /* dirty trick */
static	int		yyBytesRead	;
static	int		yyLineCount	;
static	unsigned char *	yyLineStart	;

static	struct {
	short		yySourceFile	;
	bool		yyEof		;
	unsigned char *	yyChBufferPtr	;
	unsigned char *	yyChBufferStart	;
	unsigned long	yyChBufferSize	;
	unsigned char *	yyChBufferIndex	;
	int		yyBytesRead	;
	int		yyLineCount	;
	unsigned char *	yyLineStart	;
	} yyFileStack [yyFileStackSize + 1], * yyFileStackPtr = yyFileStack;

static	unsigned char	yyToLower	[] = {
'\0', '\1', '\2', '\3', '\4', '\5', '\6', '\7',
'\10', '\11', '\12', '\13', '\14', '\15', '\16', '\17',
'\20', '\21', '\22', '\23', '\24', '\25', '\26', '\27',
'\30', '\31', '\32', '\33', '\34', '\35', '\36', '\37',
' ', '!', '"', '#', '$', '%', '&', '\'', '(', ')', '*', '+', ',', '-', '.', '/',
'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '<', '=', '>', '?',
'@', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o',
'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '[', '\\', ']', '^', '_',
'`', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o',
'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~', '\177',
'\200', '\201', '\202', '\203', '\204', '\205', '\206', '\207',
'\210', '\211', '\212', '\213', '\214', '\215', '\216', '\217',
'\220', '\221', '\222', '\223', '\224', '\225', '\226', '\227',
'\230', '\231', '\232', '\233', '\234', '\235', '\236', '\237',
'\240', '\241', '\242', '\243', '\244', '\245', '\246', '\247',
'\250', '\251', '\252', '\253', '\254', '\255', '\256', '\257',
'\260', '\261', '\262', '\263', '\264', '\265', '\266', '\267',
'\270', '\271', '\272', '\273', '\274', '\275', '\276', '\277',
'\300', '\301', '\302', '\303', '\304', '\305', '\306', '\307',
'\310', '\311', '\312', '\313', '\314', '\315', '\316', '\317',
'\320', '\321', '\322', '\323', '\324', '\325', '\326', '\327',
'\330', '\331', '\332', '\333', '\334', '\335', '\336', '\337',
'\340', '\341', '\342', '\343', '\344', '\345', '\346', '\347',
'\350', '\351', '\352', '\353', '\354', '\355', '\356', '\357',
'\360', '\361', '\362', '\363', '\364', '\365', '\366', '\367',
'\370', '\371', '\372', '\373', '\374', '\375', '\376', '\377',
};

static	unsigned char	yyToUpper	[] = {
'\0', '\1', '\2', '\3', '\4', '\5', '\6', '\7',
'\10', '\11', '\12', '\13', '\14', '\15', '\16', '\17',
'\20', '\21', '\22', '\23', '\24', '\25', '\26', '\27',
'\30', '\31', '\32', '\33', '\34', '\35', '\36', '\37',
' ', '!', '"', '#', '$', '%', '&', '\'', '(', ')', '*', '+', ',', '-', '.', '/',
'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '<', '=', '>', '?',
'@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', '\\', ']', '^', '_',
'`', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '{', '|', '}', '~', '\177',
'\200', '\201', '\202', '\203', '\204', '\205', '\206', '\207',
'\210', '\211', '\212', '\213', '\214', '\215', '\216', '\217',
'\220', '\221', '\222', '\223', '\224', '\225', '\226', '\227',
'\230', '\231', '\232', '\233', '\234', '\235', '\236', '\237',
'\240', '\241', '\242', '\243', '\244', '\245', '\246', '\247',
'\250', '\251', '\252', '\253', '\254', '\255', '\256', '\257',
'\260', '\261', '\262', '\263', '\264', '\265', '\266', '\267',
'\270', '\271', '\272', '\273', '\274', '\275', '\276', '\277',
'\300', '\301', '\302', '\303', '\304', '\305', '\306', '\307',
'\310', '\311', '\312', '\313', '\314', '\315', '\316', '\317',
'\320', '\321', '\322', '\323', '\324', '\325', '\326', '\327',
'\330', '\331', '\332', '\333', '\334', '\335', '\336', '\337',
'\340', '\341', '\342', '\343', '\344', '\345', '\346', '\347',
'\350', '\351', '\352', '\353', '\354', '\355', '\356', '\357',
'\360', '\361', '\362', '\363', '\364', '\365', '\366', '\367',
'\370', '\371', '\372', '\373', '\374', '\375', '\376', '\377',
};
 
static	void	yyInitialize	();
static	void	yyErrorMessage	ARGS((int yyErrorCode));
static	char	input		();
/* line 72 "parallaxis.rex" */


#include <math.h>
#include <string.h>
#include <ctype.h>

static char Word[256];
static int NestingLevel = 0;

void ErrorAttribute
#if defined __STDC__
(int Token, tScanAttribute *pAttribute)
#else
(Token, pAttribute) int Token; tScanAttribute *pAttribute;
#endif
{
  pAttribute->Position = Attribute.Position;
  switch (Token) {
  case 1 /* Ident */:
    pAttribute->Ident.Ident = NoIdent;
    break;
  case 2 /* IntConst */:
    pAttribute->IntConst.Integer = 0L;
    pAttribute->IntConst.Kind = IntDecimal;
    break;
  case 3 /* RealConst */:
    pAttribute->RealConst.String = PutString("0.0", 3);
    break;
  case 4 /* CharConst */:
    pAttribute->CharConst.Char = '?';
    break;
  case 5 /* StringConst */:
    pAttribute->StringConst.String = PutString("", 0);
    break;
  }
}


 
int GetToken ()
{
   register	yyStateRange	yyState;
   register	yyStateRange *	yyStatePtr;
   register	unsigned char * yyChBufferIndexReg;
   register	yyCombType * *	yyBasePtrReg = yyBasePtr;
/* line 113 "parallaxis.rex" */


char String[256], S[256];


   
yyBegin:
   yyState		= yyStartState;		/* initialize */
   yyStatePtr		= & yyStateStack [1];
   yyChBufferIndexReg 	= yyChBufferIndex;
   TokenPtr	 	= (char *) yyChBufferIndexReg;
 
   /* ASSERT yyChBuffer [yyChBufferIndex] == first character */
 
yyContinue:		/* continue after sentinel or skipping blanks */
   for (;;) {		/* execute as many state transitions as possible */
					/* determine next state and get next character */
      register yyCombType * yyTablePtr = (yyBasePtrReg [yyState] + * yyChBufferIndexReg ++);
      if (yyTablePtr->yyCheck == yyState) {
	 yyState = yyTablePtr->yyNext;
	 * yyStatePtr ++ = yyState;		/* push state */
	 goto yyContinue;
      }
      yyChBufferIndexReg --;			/* reconsider character */
      if ((yyState = yyDefault [yyState]) == yyDNoState) break;
   }
 
   for (;;) {					/* search for last final state */
      TokenLength = yyChBufferIndexReg - (unsigned char *) TokenPtr;
      yyChBufferIndex = yyChBufferIndexReg;
switch (* -- yyStatePtr) {
case 287:;
/* line 164 "parallaxis.rex" */
{NestingLevel++; yyStart(Comment);
} yy1: goto yyBegin;
case 286:;
/* line 165 "parallaxis.rex" */
{NestingLevel--; if (NestingLevel == 0) yyStart(STD);
} yy2: goto yyBegin;
case 11:;
case 21:;
case 34:;
case 39:;
case 285:;
case 288:;
/* line 167 "parallaxis.rex" */
{
} yy3: goto yyBegin;
case 12:;
case 22:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 171 "parallaxis.rex" */
{(void)GetWord(Word);
                           Attribute.IntConst.Integer = atoi(Word);
                           Attribute.IntConst.Kind = IntDecimal;
                           return 2;
} yy4: goto yyBegin;
case 20:;
yyChBufferIndex -= 2;
TokenLength -= 2;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 171 "parallaxis.rex" */
{(void)GetWord(Word);
                           Attribute.IntConst.Integer = atoi(Word);
                           Attribute.IntConst.Kind = IntDecimal;
                           return 2;
} yy5: goto yyBegin;
case 19:;
yyChBufferIndex -= 2;
TokenLength -= 2;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 171 "parallaxis.rex" */
{(void)GetWord(Word);
                           Attribute.IntConst.Integer = atoi(Word);
                           Attribute.IntConst.Kind = IntDecimal;
                           return 2;
} yy6: goto yyBegin;
case 16:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 175 "parallaxis.rex" */
{(void)sscanf(TokenPtr, "%lo", &Attribute.IntConst.Integer);
                           Attribute.IntConst.Kind = IntOctal;
                           return 2;
} yy7: goto yyBegin;
case 17:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 180 "parallaxis.rex" */
{(void)sscanf(TokenPtr, "%lo", &Attribute.IntConst.Integer);
			   Attribute.CharConst.Char = (char) Attribute.IntConst.Integer;
                           return 4;
} yy8: goto yyBegin;
case 18:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 184 "parallaxis.rex" */
{(void)sscanf(TokenPtr, "%lx", &Attribute.IntConst.Integer);
                           Attribute.IntConst.Kind = IntHexadecimal;
                           return 2;
} yy9: goto yyBegin;
case 14:;
case 23:;
case 24:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 188 "parallaxis.rex" */
{(void)GetWord(Word);
                           Attribute.RealConst.String = PutString(Word, strlen(Word));
                           return 3;
} yy10: goto yyBegin;
case 284:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 192 "parallaxis.rex" */
{String[0] = '\0'; yyStart(Str1);
} yy11: goto yyBegin;
case 10:;
case 35:;
case 40:;
/* line 193 "parallaxis.rex" */
{(void)GetWord(S); (void)strcat(String, S);
} yy12: goto yyBegin;
case 283:;
/* line 194 "parallaxis.rex" */
{Attribute.StringConst.String = PutString(String, strlen(String));
                            yyStart(STD); return 5;
} yy13: goto yyBegin;
case 282:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 197 "parallaxis.rex" */
{String[0] = '\0'; yyStart(Str2);
} yy14: goto yyBegin;
case 9:;
case 36:;
case 41:;
/* line 198 "parallaxis.rex" */
{(void)GetWord(S); (void)strcat(String, S);
} yy15: goto yyBegin;
case 281:;
/* line 199 "parallaxis.rex" */
{Attribute.StringConst.String = PutString(String, strlen(String));
                            yyStart(STD); return 5;
} yy16: goto yyBegin;
case 280:;
/* line 202 "parallaxis.rex" */
{(void)strcat(String, "\t"); yyTab;
} yy17: goto yyBegin;
case 279:;
/* line 203 "parallaxis.rex" */
{Message( "unclosed string", xxError, Attribute.Position );
                            Attribute.StringConst.String = PutString( String, strlen(String) );
                            yyEol(0); yyStart(STD); return 5; 
} yy18: goto yyBegin;
case 278:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 207 "parallaxis.rex" */
{return 36;
} yy19: goto yyBegin;
case 277:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 208 "parallaxis.rex" */
{return 40;
} yy20: goto yyBegin;
case 276:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 209 "parallaxis.rex" */
{return 15;
} yy21: goto yyBegin;
case 275:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 211 "parallaxis.rex" */
{ return 6; 
} yy22: goto yyBegin;
case 266:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 212 "parallaxis.rex" */
{ return 7; 
} yy23: goto yyBegin;
case 263:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 213 "parallaxis.rex" */
{ return 8; 
} yy24: goto yyBegin;
case 262:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 214 "parallaxis.rex" */
{ return 9; 
} yy25: goto yyBegin;
case 259:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 215 "parallaxis.rex" */
{ return 10; 
} yy26: goto yyBegin;
case 258:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 216 "parallaxis.rex" */
{ return 11; 
} yy27: goto yyBegin;
case 255:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 217 "parallaxis.rex" */
{ return 12; 
} yy28: goto yyBegin;
case 245:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 218 "parallaxis.rex" */
{ return 13; 
} yy29: goto yyBegin;
case 244:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 219 "parallaxis.rex" */
{ return 14; 
} yy30: goto yyBegin;
case 243:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 220 "parallaxis.rex" */
{ return 15; 
} yy31: goto yyBegin;
case 240:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 221 "parallaxis.rex" */
{ return 16; 
} yy32: goto yyBegin;
case 239:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 222 "parallaxis.rex" */
{ return 17; 
} yy33: goto yyBegin;
case 238:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 223 "parallaxis.rex" */
{ return 18; 
} yy34: goto yyBegin;
case 237:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 224 "parallaxis.rex" */
{ return 19; 
} yy35: goto yyBegin;
case 236:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 225 "parallaxis.rex" */
{ return 20; 
} yy36: goto yyBegin;
case 235:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 226 "parallaxis.rex" */
{ return 21; 
} yy37: goto yyBegin;
case 234:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 227 "parallaxis.rex" */
{ return 22; 
} yy38: goto yyBegin;
case 217:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 228 "parallaxis.rex" */
{ return 23; 
} yy39: goto yyBegin;
case 233:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 229 "parallaxis.rex" */
{ return 24; 
} yy40: goto yyBegin;
case 232:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 230 "parallaxis.rex" */
{ return 25; 
} yy41: goto yyBegin;
case 231:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 231 "parallaxis.rex" */
{ return 26; 
} yy42: goto yyBegin;
case 230:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 232 "parallaxis.rex" */
{ return 27; 
} yy43: goto yyBegin;
case 226:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 233 "parallaxis.rex" */
{ return 28; 
} yy44: goto yyBegin;
case 225:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 234 "parallaxis.rex" */
{ return 29; 
} yy45: goto yyBegin;
case 224:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 235 "parallaxis.rex" */
{ return 30; 
} yy46: goto yyBegin;
case 222:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 236 "parallaxis.rex" */
{ return 31; 
} yy47: goto yyBegin;
case 218:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 237 "parallaxis.rex" */
{ return 32; 
} yy48: goto yyBegin;
case 216:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 238 "parallaxis.rex" */
{ return 33; 
} yy49: goto yyBegin;
case 215:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 239 "parallaxis.rex" */
{ return 34; 
} yy50: goto yyBegin;
case 213:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 240 "parallaxis.rex" */
{ return 35; 
} yy51: goto yyBegin;
case 210:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 241 "parallaxis.rex" */
{ return 36; 
} yy52: goto yyBegin;
case 193:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 242 "parallaxis.rex" */
{ return 37; 
} yy53: goto yyBegin;
case 208:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 243 "parallaxis.rex" */
{ return 38; 
} yy54: goto yyBegin;
case 207:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 244 "parallaxis.rex" */
{ return 39; 
} yy55: goto yyBegin;
case 206:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 245 "parallaxis.rex" */
{ return 40; 
} yy56: goto yyBegin;
case 190:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 246 "parallaxis.rex" */
{ return 41; 
} yy57: goto yyBegin;
case 205:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 247 "parallaxis.rex" */
{ return 42; 
} yy58: goto yyBegin;
case 203:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 248 "parallaxis.rex" */
{ return 43; 
} yy59: goto yyBegin;
case 204:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 249 "parallaxis.rex" */
{ return 44; 
} yy60: goto yyBegin;
case 202:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 250 "parallaxis.rex" */
{ return 45; 
} yy61: goto yyBegin;
case 201:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 251 "parallaxis.rex" */
{ return 46; 
} yy62: goto yyBegin;
case 48:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 252 "parallaxis.rex" */
{ return 47; 
} yy63: goto yyBegin;
case 194:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 253 "parallaxis.rex" */
{ return 48; 
} yy64: goto yyBegin;
case 192:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 254 "parallaxis.rex" */
{ return 49; 
} yy65: goto yyBegin;
case 138:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 255 "parallaxis.rex" */
{ return 50; 
} yy66: goto yyBegin;
case 189:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 256 "parallaxis.rex" */
{ return 51; 
} yy67: goto yyBegin;
case 188:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 257 "parallaxis.rex" */
{ return 52; 
} yy68: goto yyBegin;
case 187:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 258 "parallaxis.rex" */
{ return 53; 
} yy69: goto yyBegin;
case 185:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 259 "parallaxis.rex" */
{ return 54; 
} yy70: goto yyBegin;
case 183:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 260 "parallaxis.rex" */
{ return 55; 
} yy71: goto yyBegin;
case 179:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 261 "parallaxis.rex" */
{ return 56; 
} yy72: goto yyBegin;
case 176:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 262 "parallaxis.rex" */
{ return 57; 
} yy73: goto yyBegin;
case 172:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 263 "parallaxis.rex" */
{ return 58; 
} yy74: goto yyBegin;
case 170:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 264 "parallaxis.rex" */
{ return 59; 
} yy75: goto yyBegin;
case 166:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 265 "parallaxis.rex" */
{ return 60; 
} yy76: goto yyBegin;
case 162:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 266 "parallaxis.rex" */
{ return 61; 
} yy77: goto yyBegin;
case 161:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 267 "parallaxis.rex" */
{ return 62; 
} yy78: goto yyBegin;
case 160:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 268 "parallaxis.rex" */
{ return 63; 
} yy79: goto yyBegin;
case 159:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 269 "parallaxis.rex" */
{ return 64; 
} yy80: goto yyBegin;
case 153:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 270 "parallaxis.rex" */
{ return 65; 
} yy81: goto yyBegin;
case 144:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 271 "parallaxis.rex" */
{ return 66; 
} yy82: goto yyBegin;
case 142:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 272 "parallaxis.rex" */
{ return 67; 
} yy83: goto yyBegin;
case 135:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 273 "parallaxis.rex" */
{ return 68; 
} yy84: goto yyBegin;
case 131:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 274 "parallaxis.rex" */
{ return 69; 
} yy85: goto yyBegin;
case 122:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 275 "parallaxis.rex" */
{ return 70; 
} yy86: goto yyBegin;
case 109:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 276 "parallaxis.rex" */
{ return 71; 
} yy87: goto yyBegin;
case 105:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 277 "parallaxis.rex" */
{ return 72; 
} yy88: goto yyBegin;
case 103:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 278 "parallaxis.rex" */
{ return 73; 
} yy89: goto yyBegin;
case 99:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 279 "parallaxis.rex" */
{ return 74; 
} yy90: goto yyBegin;
case 95:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 280 "parallaxis.rex" */
{ return 75; 
} yy91: goto yyBegin;
case 91:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 281 "parallaxis.rex" */
{ return 76; 
} yy92: goto yyBegin;
case 87:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 282 "parallaxis.rex" */
{ return 77; 
} yy93: goto yyBegin;
case 82:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 283 "parallaxis.rex" */
{ return 78; 
} yy94: goto yyBegin;
case 80:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 284 "parallaxis.rex" */
{ return 79; 
} yy95: goto yyBegin;
case 78:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 285 "parallaxis.rex" */
{ return 80; 
} yy96: goto yyBegin;
case 74:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 286 "parallaxis.rex" */
{ return 81; 
} yy97: goto yyBegin;
case 70:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 287 "parallaxis.rex" */
{ return 82; 
} yy98: goto yyBegin;
case 64:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 288 "parallaxis.rex" */
{ return 83; 
} yy99: goto yyBegin;
case 61:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 289 "parallaxis.rex" */
{ return 84; 
} yy100: goto yyBegin;
case 57:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 290 "parallaxis.rex" */
{ return 85; 
} yy101: goto yyBegin;
case 52:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 291 "parallaxis.rex" */
{ return 86; 
} yy102: goto yyBegin;
case 49:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 292 "parallaxis.rex" */
{ return 88; 
} yy103: goto yyBegin;
case 47:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 293 "parallaxis.rex" */
{ return 89; 
} yy104: goto yyBegin;
case 13:;
case 42:;
case 43:;
case 44:;
case 45:;
case 46:;
case 50:;
case 51:;
case 53:;
case 54:;
case 55:;
case 56:;
case 58:;
case 59:;
case 60:;
case 62:;
case 63:;
case 65:;
case 66:;
case 67:;
case 68:;
case 69:;
case 71:;
case 72:;
case 73:;
case 75:;
case 76:;
case 77:;
case 79:;
case 81:;
case 83:;
case 84:;
case 85:;
case 86:;
case 88:;
case 89:;
case 90:;
case 92:;
case 93:;
case 94:;
case 96:;
case 97:;
case 98:;
case 100:;
case 101:;
case 102:;
case 104:;
case 106:;
case 107:;
case 108:;
case 110:;
case 111:;
case 112:;
case 113:;
case 114:;
case 115:;
case 116:;
case 117:;
case 118:;
case 119:;
case 120:;
case 121:;
case 123:;
case 124:;
case 125:;
case 126:;
case 127:;
case 128:;
case 129:;
case 130:;
case 132:;
case 133:;
case 134:;
case 136:;
case 137:;
case 139:;
case 140:;
case 141:;
case 143:;
case 145:;
case 146:;
case 147:;
case 148:;
case 149:;
case 150:;
case 151:;
case 152:;
case 154:;
case 155:;
case 156:;
case 157:;
case 158:;
case 163:;
case 164:;
case 165:;
case 167:;
case 168:;
case 169:;
case 171:;
case 173:;
case 174:;
case 175:;
case 177:;
case 178:;
case 180:;
case 181:;
case 182:;
case 184:;
case 186:;
case 195:;
case 196:;
case 197:;
case 198:;
case 199:;
case 200:;
case 209:;
case 211:;
case 212:;
case 214:;
case 219:;
case 220:;
case 221:;
case 223:;
case 227:;
case 228:;
case 229:;
case 241:;
case 242:;
case 246:;
case 247:;
case 248:;
case 249:;
case 250:;
case 251:;
case 252:;
case 253:;
case 254:;
case 256:;
case 257:;
case 260:;
case 261:;
case 264:;
case 265:;
case 267:;
case 268:;
case 269:;
case 270:;
case 271:;
case 272:;
case 273:;
case 274:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 296 "parallaxis.rex" */
{ Attribute.Ident.Ident = MakeIdent(TokenPtr, TokenLength);
                            return 1; 
} yy105: goto yyBegin;
case 38:;
/* line 299 "parallaxis.rex" */
{ yyEol( 0 ); 
} yy106: goto yyBegin;
case 33:;
{/* BlankAction */
while (* yyChBufferIndexReg ++ == ' ') ;
TokenPtr = (char *) -- yyChBufferIndexReg;
yyState = yyStartState;
yyStatePtr = & yyStateStack [1];
goto yyContinue;
} yy107: goto yyBegin;
case 32:;
{/* TabAction */
yyLineStart -= 7 - ((unsigned char *) TokenPtr - yyLineStart - 1) & 0x7; /* % 8 */
} yy108: goto yyBegin;
case 31:;
{/* EolAction */
yyLineCount ++;
yyLineStart = yyChBufferIndexReg - 1;
} yy109: goto yyBegin;
case 1:;
case 2:;
case 3:;
case 4:;
case 5:;
case 6:;
case 7:;
case 8:;
case 15:;
case 25:;
case 26:;
case 27:;
case 28:;
case 37:;
case 191:;
	 /* non final states */
	 yyChBufferIndexReg --;			/* return character */
	 break;
 
case 30:
	 Attribute.Position.Line   = yyLineCount;
	 Attribute.Position.Column = yyChBufferIndexReg - yyLineStart;
      /* TokenLength   = 1; */
	 yyChBufferIndex = ++ yyChBufferIndexReg;
	 {
/* line 121 "parallaxis.rex" */


if ( iscntrl(*TokenPtr) ) {
  sprintf( String, "0x%02X", *TokenPtr );
  MessageI( "illegal character", xxError, Attribute.Position, xxString, String );
} else {
  MessageI( "illegal character", xxError, Attribute.Position, xxCharacter, TokenPtr );
}


	 }
	 goto yyBegin;
 
      case yyDNoState:				/* automatic initialization */
	 yyInitialize ();
	 yySourceFile = StdIn;
	 goto yyBegin;

case 29:
	 yyChBufferIndex = -- yyChBufferIndexReg; /* undo last state transition */
	 if (-- TokenLength == 0) {		/* get previous state */
	    yyState = yyStartState;
	 } else {
	    yyState = * (yyStatePtr - 1);
	 }

	 if (yyChBufferIndex != & yyChBufferStart [yyBytesRead]) {
						/* end of buffer sentinel in buffer */
	    if ((yyState = yyEobTrans [yyState]) == yyDNoState) continue;
	    yyChBufferIndexReg ++;
	    * yyStatePtr ++ = yyState;		/* push state */
	    goto yyContinue;
	 }
						/* end of buffer reached */
	 {  /* copy initial part of token in front of the input buffer */
	    register char * yySource = TokenPtr;
	    register char * yyTarget = TokenPtr = (char *) & yyChBufferPtr [yyMaxAlign - TokenLength % yyMaxAlign];
	    if (yySource != yyTarget) {
	       while (yySource < (char *) yyChBufferIndexReg) * yyTarget ++ = * yySource ++;
	       yyLineStart += (unsigned char *) yyTarget - yyChBufferStart - yyBytesRead;
	       yyChBufferStart = (unsigned char *) yyTarget;
	    } else {
	       yyChBufferStart = yyChBufferIndexReg;
	    }
	 }

	 if (! yyEof) {				/* read buffer and restart */
	    int yyChBufferFree = (int) Exp2 (Log2 (yyChBufferSize - 4 - yyMaxAlign - TokenLength));
	    if (yyChBufferFree < yyChBufferSize / 8) {
	       register int yyDelta;
	       register unsigned char * yyOldChBufferPtr = yyChBufferPtr;
	       ExtendArray ((char * *) & yyChBufferPtr, & yyChBufferSize, sizeof (char));
	       if (yyChBufferPtr == NULL) yyErrorMessage (1);
	       yyDelta = yyChBufferPtr - yyOldChBufferPtr;
	       yyChBufferStart	+= yyDelta;
	       yyLineStart	+= yyDelta;
	       TokenPtr	+= yyDelta;
	       yyChBufferFree = (int) Exp2 (Log2 (yyChBufferSize - 4 - yyMaxAlign - TokenLength));
	       if (yyStateStackSize < yyChBufferSize) {
		  yyStateRange * yyOldStateStack = yyStateStack;
		  ExtendArray ((char * *) & yyStateStack, & yyStateStackSize, sizeof (yyStateRange));
		  if (yyStateStack == NULL) yyErrorMessage (1);
		  yyStatePtr	+= yyStateStack - yyOldStateStack;
	       }
	    }
	    yyChBufferIndex = yyChBufferIndexReg = yyChBufferStart;
	    yyBytesRead = GetLine (yySourceFile, (char *) yyChBufferIndex, yyChBufferFree);
	    if (yyBytesRead <= 0) { yyBytesRead = 0; yyEof = true; }
	    yyChBufferStart [yyBytesRead    ] = yyEobCh;
	    yyChBufferStart [yyBytesRead + 1] = '\0';
	    goto yyContinue;
	 }

	 if (TokenLength == 0) {		/* end of file reached */
	    Attribute.Position.Line   = yyLineCount;
	    Attribute.Position.Column = yyChBufferIndexReg - yyLineStart;
	    CloseFile ();
	    if (yyFileStackPtr == yyFileStack) {
/* line 134 "parallaxis.rex" */


if (yyStartState == Comment) {
  Message( "unclosed comment", xxError, Attribute.Position );
  NestingLevel = 0;
}
if (yyStartState != STD) {
  yyStart(STD);
}


	    }
	    if (yyFileStackPtr == yyFileStack) return EofToken;
	    goto yyBegin;
	 }
	 break;
 
      default:
	 yyErrorMessage (0);
      }
   }
}
 
void BeginFile
# if defined __STDC__ | defined __cplusplus
   (char * yyFileName)
# else
   (yyFileName) char * yyFileName;
# endif
   {
      yyInitialize ();
      yySourceFile = BeginSource (yyFileName);
   }

static void yyInitialize ()
   {
      if (yyFileStackPtr >= yyFileStack + yyFileStackSize) yyErrorMessage (2);
      yyFileStackPtr ++;			/* push file */
      yyFileStackPtr->yySourceFile	= yySourceFile		;
      yyFileStackPtr->yyEof		= yyEof			;
      yyFileStackPtr->yyChBufferPtr	= yyChBufferPtr		;
      yyFileStackPtr->yyChBufferStart	= yyChBufferStart	;
      yyFileStackPtr->yyChBufferSize	= yyChBufferSize	;
      yyFileStackPtr->yyChBufferIndex	= yyChBufferIndex	;
      yyFileStackPtr->yyBytesRead	= yyBytesRead		;
      yyFileStackPtr->yyLineCount	= yyLineCount		;
      yyFileStackPtr->yyLineStart	= yyLineStart		;
						/* initialize file state */
      yyChBufferSize	   = yyInitBufferSize;
      MakeArray ((char * *) & yyChBufferPtr, & yyChBufferSize, sizeof (char));
      if (yyChBufferPtr == NULL) yyErrorMessage (1);
      yyChBufferStart	   = & yyChBufferPtr [yyMaxAlign];
      yyChBufferStart [-1] = yyEolCh;		/* begin of line indicator */
      yyChBufferStart [ 0] = yyEobCh;		/* end of buffer sentinel */
      yyChBufferStart [ 1] = '\0';
      yyChBufferIndex	   = yyChBufferStart;
      yyEof		   = false;
      yyBytesRead	   = 0;
      yyLineCount	   = 1;
      yyLineStart	   = & yyChBufferStart [-1];
      if (yyStartState == 0) {
	 yyStartState	   = STD;
	 yyStateStack [0]  = yyDefaultState;	/* stack underflow sentinel */
      }
   }

void CloseFile ()
   {
      if (yyFileStackPtr == yyFileStack) yyErrorMessage (3);
      CloseSource (yySourceFile);
      ReleaseArray ((char * *) & yyChBufferPtr, & yyChBufferSize, sizeof (char));
						/* pop file */
      yySourceFile	= yyFileStackPtr->yySourceFile		;
      yyEof		= yyFileStackPtr->yyEof			;
      yyChBufferPtr	= yyFileStackPtr->yyChBufferPtr		;
      yyChBufferStart	= yyFileStackPtr->yyChBufferStart	;
      yyChBufferSize	= yyFileStackPtr->yyChBufferSize	;
      yyChBufferIndex	= yyFileStackPtr->yyChBufferIndex	;
      yyBytesRead	= yyFileStackPtr->yyBytesRead		;
      yyLineCount	= yyFileStackPtr->yyLineCount		;
      yyLineStart	= yyFileStackPtr->yyLineStart		;
      yyFileStackPtr --;		
   }
 
int GetWord
# if defined __STDC__ | defined __cplusplus
   (char * yyWord)
# else
   (yyWord) char * yyWord;
# endif
   {
      register char * yySource			= TokenPtr;
      register char * yyTarget			= yyWord;
      register char * yyChBufferIndexReg	= (char *) yyChBufferIndex;
   
      do {				/* ASSERT word is not empty */
	 * yyTarget ++ = * yySource ++;
      } while (yySource < yyChBufferIndexReg);
      * yyTarget = '\0';
      return yyChBufferIndexReg - TokenPtr;
   }
 
int GetLower
# if defined __STDC__ | defined __cplusplus
   (char * yyWord)
# else
   (yyWord) char * yyWord;
# endif
   {
      register char * yySource			= TokenPtr;
      register char * yyTarget			= yyWord;
      register char * yyChBufferIndexReg	= (char *) yyChBufferIndex;
   
      do {				/* ASSERT word is not empty */
	 * yyTarget ++ = yyToLower [* yySource ++];
      } while (yySource < yyChBufferIndexReg);
      * yyTarget = '\0';
      return yyChBufferIndexReg - TokenPtr;
   }
 
int GetUpper
# if defined __STDC__ | defined __cplusplus
   (char * yyWord)
# else
   (yyWord) char * yyWord;
# endif
   {
      register char * yySource			= TokenPtr;
      register char * yyTarget			= yyWord;
      register char * yyChBufferIndexReg	= (char *) yyChBufferIndex;
   
      do {				/* ASSERT word is not empty */
	 * yyTarget ++ = yyToUpper [* yySource ++];
      } while (yySource < yyChBufferIndexReg);
      * yyTarget = '\0';
      return yyChBufferIndexReg - TokenPtr;
   }
 
static char input ()
   {
      if (yyChBufferIndex == & yyChBufferStart [yyBytesRead]) {
	 if (! yyEof) {
	    yyLineStart -= yyBytesRead;
	    yyChBufferIndex = yyChBufferStart = yyChBufferPtr;
	    yyBytesRead = GetLine (yySourceFile, (char *) yyChBufferIndex,
	       (int) Exp2 (Log2 (yyChBufferSize)));
	    if (yyBytesRead <= 0) { yyBytesRead = 0; yyEof = true; }
	    yyChBufferStart [yyBytesRead    ] = yyEobCh;
	    yyChBufferStart [yyBytesRead + 1] = '\0';
	 }
      }
      if (yyChBufferIndex == & yyChBufferStart [yyBytesRead]) return '\0';
      else return * yyChBufferIndex ++;
   }

void BeginScanner ()
   {
   }
 
void CloseScanner ()
   {
   }
 
static void yyErrorMessage
# if defined __STDC__ | defined __cplusplus
   (int yyErrorCode)
# else
   (yyErrorCode) int yyErrorCode;
# endif
   {
      WritePosition (stderr, Attribute.Position);
      switch (yyErrorCode) {
      case 0: (void) fprintf (stderr, ": Scanner: internal error\n"); break;
      case 1: (void) fprintf (stderr, ": Scanner: out of memory\n"); break;
      case 2: (void) fprintf (stderr, ": Scanner: too many nested include files\n"); break;
      case 3: (void) fprintf (stderr, ": Scanner: file stack underflow (too many calls of CloseFile)\n"); break;
      }
      Scanner_Exit ();
   }
