/*************************************************************************
 *
 * Parallaxis Compiler Projects
 * ----------------------------
 *
 * name :  With
 * desc :  Stack for the administration of the pointer variables
 *         generated for the translation of WITH statements.
 * rcs  :  $Author: keller $
 *
 ************************************************************************/

#ifndef _With_H
#define _With_H

#include "Idents.h"			  /* Reuse-Library */
#include "Symbols.h"

/*************************************************************************
 * name: With_Push
 * in  :
 * out :
 ************************************************************************/

extern void With_Push( tIdent pWithId, tObjects pFields );

/*************************************************************************
 * name: With_Pop
 * in  :
 * out :
 ************************************************************************/

extern void With_Pop( void );

/*************************************************************************
 * name: With_GetField
 * in  :
 * out :
 ************************************************************************/

extern tIdent With_GetField( tIdent fieldId );

/*************************************************************************
 * name: With_Free
 * in  :
 * out :
 ************************************************************************/

extern void With_Free( void );

/*************************************************************************
 * name: With_Init
 * in  :
 * out :
 ************************************************************************/

extern void With_Init( void );

#endif
