/*************************************************************************
 *
 * Parallaxis Compiler Projects
 * ----------------------------
 *
 * name  :  pointer.h
 * desc  :
 * author:  lampke
 *
 ************************************************************************/

#ifndef _Pointer_h
#define _Pointer_h

#include "parallaxis.h"
#include "Symbols.h"

/*
 * pointer to CObjects
 */

extern tCObjects Pointer_GlobalPtrs;
extern tCObjects Pointer_LocalPtrs;

/*************************************************************************
 * name: Pointer_GenGlobalPtr
 * in  :
 * out : generates CIdentifiers for pointers
 ************************************************************************/

extern void Pointer_GenGlobalPtrs( tCObjects GlobalPtrs );

/*************************************************************************
 * name: Pointer_GenLocalPtr
 * in  :
 * out : generates CIdentifier for localPointer
 ************************************************************************/

extern void Pointer_GenLocalPtrs( tCObjects LocalPtrs );

/*************************************************************************
 * name: Pointer_GetGlobalPtr
 * in  :
 * out : return Identifier
 ************************************************************************/

extern tIdent Pointer_GetGlobalPtr( tObject M2Object );

/*************************************************************************
 * name: Pointer_GetLocalPtr
 * in  :
 * out : return Identifier
 ************************************************************************/

extern tIdent Pointer_GetLocalPtr( tObject M2Object );

/*************************************************************************
 * name: Pointer_Init
 * in  :
 * out : init
 ************************************************************************/

extern void Pointer_Init( void );

#endif
