# ifndef yyScanner
# define yyScanner

/* $Id: Scanner.h,v 2.6 1992/08/07 15:29:41 grosch rel $ */

# if defined __STDC__ | defined __cplusplus
# define ARGS(parameters)	parameters
# else
# define ARGS(parameters)	()
# endif

/* line 14 "parallaxis.rex" */


#include "StringMem.h"			  /* Reuse-Library */
#include "Idents.h"			  /* Reuse-Library */
#include "parallaxis.h"
#include "Positions.h"
#include "Errors.h"
#include "Tree.h"

#if defined __STDC__
#define ARGS(parameters)       parameters
#else
#define ARGS(parameters)       ()
#endif

typedef struct {
  tPosition yyPos;
  tIdent Ident;
} yyIdent;

typedef struct {
  tPosition yyPos;
  unsigned long Integer;
  unsigned long Kind;
} yyIntConst;

typedef struct {
  tPosition yyPos;
  tStringRef String;
} yyRealConst;

typedef struct {
  tPosition yyPos;
  unsigned char Char;
} yyCharConst;

typedef struct {
  tPosition yyPos;
  tStringRef String;
} yyStringConst;

typedef union {
  tPosition Position;
  yyIdent Ident;
  yyIntConst IntConst;
  yyRealConst RealConst;
  yyCharConst CharConst;
  yyStringConst StringConst;
} tScanAttribute;

extern void ErrorAttribute ARGS((int Token, tScanAttribute * pAttribute));
/* Returns in parameter 'Attribute' */
/* default values for the attributes of token 'Token' */


 
# define EofToken	0
 
# ifdef lex_interface
#    define GetToken	yylex
#    define TokenLength	yyleng
# endif

extern	char *		TokenPtr	;
extern	short		TokenLength	;
extern	tScanAttribute	Attribute	;
extern	void		(* Scanner_Exit) ()	;
 
extern	void		BeginScanner	();
extern	void		BeginFile	ARGS ((char * yyFileName));
extern	int		GetToken	();
extern	int		GetWord		ARGS ((char * yyWord));
extern	int		GetLower	ARGS ((char * yyWord));
extern	int		GetUpper	ARGS ((char * yyWord));
extern	void		CloseFile	();
extern	void		CloseScanner	();

# endif
