/*************************************************************************
 *
 * Parallaxis Compiler Projects
 * ----------------------------
 *
 * name :  Statist.h
 * desc :  functions to show statistics to the user
 * rcs  :  $Author: keller $
 *
 ************************************************************************/

#include <stdio.h>
#include <time.h>
#include "Memory.h"			  /* Reuse-Library */
#include "Tree.h"
#include "Statist.h"

static BOOLEAN isInitialised = FALSE;

/*
 * local variables
 */
static clock_t Start, Step, Stop;

/*
 * local function prototypes
 */

/*
 * local function implementation
 */

/*
 * Global variables
 */

/*
 * global function implementation
 */
/*------- WritePhase -------------------------------------------------------*/
void Statist_WritePhase( char *phase )
{
   fprintf( stderr, "\n--- %50s ---\n", phase );
}

/*------- StartOver --------------------------------------------------------*/

void Statist_StartOver( void )
{
   Start = clock();
   Step  = Start;
   Stop  = Start;
}

/*------- WriteMemory ------------------------------------------------------*/

void Statist_WriteMemory( void )
{
   fprintf( stderr, "Memory        : %8ld Bytes\n", MemoryUsed );
   fprintf( stderr, "Heap - Tree   : %8ld Bytes\n", Tree_HeapUsed );
   fprintf( stderr, "Heap - Symbols: %8ld Bytes\n", Symbols_HeapUsed );
}

/*------- WriteStepTime ----------------------------------------------------*/

void Statist_WriteStepTime( void )
{
   Stop = clock();
   fprintf( stderr, "time needed   : %8.2f s\n",
            (float)(Stop - Step)/CLOCKS_PER_SEC );
   Step = Stop;
}

/*------- WriteCompTime ----------------------------------------------------*/
void Statist_WriteCompTime( void )
{
   Stop = clock();
   fprintf( stderr, "total time    : %8.2f s\n",
            (float)(Stop - Start)/CLOCKS_PER_SEC );
}

void Statist_Init( void )
{
   if ( !isInitialised ) {
      isInitialised = TRUE;
      Statist_StartOver();
   } /* endif */
}

