/*************************************************************************
 *
 * Parallaxis Compiler Projects
 * ----------------------------
 *
 * name :  With.c
 * desc :  stack for the identnrs of Withs
 * rcs  :  $Author: keller $
 *
 ************************************************************************/

#include "DynArray.h"			  /* Reuse-Library */
#include "Idents.h"			  /* Reuse-Library */
#include "parallaxis.h"
#include "Symbols.h"
#include "With.h"

static BOOLEAN isInitialised = FALSE;

/*
 * local
 */

#define With_InitialSize 16

typedef struct {
  tIdent WithId;
  tObjects Fields;
} tWithStackElem;

static long WithStackPtr, WithStackSize;
static tWithStackElem *WithStack;

/*
 * global function implementation
 */

/*---------------------------------------------------------------------------*/

void With_Push( tIdent pWithId, tObjects pFields )
{
  if ( WithStackPtr == WithStackSize ) {
    ExtendArray( (char **) &WithStack, &WithStackSize,
      sizeof( tWithStackElem ) );
  }
  WithStack[WithStackPtr].WithId = pWithId;
  WithStack[WithStackPtr].Fields = pFields;
  WithStackPtr++;
}

/*---------------------------------------------------------------------------*/

void With_Pop( void )
{
  WithStackPtr--;
}

/*---------------------------------------------------------------------------*/

tIdent With_GetField( tIdent FieldId )
{
  long StackIndex;

  StackIndex = WithStackPtr - 1;

  for (;;) {
    if ( Symbols_Identify2( FieldId, WithStack[StackIndex].Fields ) !=
           NoObject ) {
      return WithStack[StackIndex].WithId;
    }
    StackIndex--;
  }
}

/*---------------------------------------------------------------------------*/

void With_Free( void )
{
  ReleaseArray( (char **) &WithStack, &WithStackSize,
    sizeof( tWithStackElem) );
}

/*---------------------------------------------------------------------------*/

void With_Init( void )
{
  if ( !isInitialised ) {
    isInitialised = TRUE;

    WithStackSize = With_InitialSize;
    WithStackPtr = 0;
    MakeArray( (char **) &WithStack, &WithStackSize, sizeof( tWithStackElem) );
  }
}
