/*************************************************************************
 *
 * Parallaxis Compiler Projects
 * ----------------------------
 *
 * name  :  GetDefMods.h
 * desc  :  read in all definition modules which the current compilation
 *          unit depends on an dadd them to syntaxtree
 * author:  lampke
 *
 ************************************************************************/

#ifndef GetDefMods_h
#define GetDefMods_h

#include "Tree.h"
#include "parallaxis.h"

/*************************************************************************
 * name :  Usage
 * in   :  The current compilation unit 'CompUnit'.
 *         PRECONDITION: Tree^.Kind IN {DefMod, ProgMod}
 * out  :  a tree which is a list of all the modules that make up
 *         the current compilation unit ('CompUnit' and all the
 *         definition modules it depends on.)
 *         The tree is topologially ordered such that each module
 *         depends only on modules preceding it in the module list.
 *         Therefor the current compilation unit is always the last
 *         element on the list.
 *         POSTCONDITION: Tree^.Kind = ROOT
 ************************************************************************/
extern tTree GetDefMods_GetDefModules( tTree CompUnit );

extern void GetDefMods_Init( void );

#endif
