#include "SYSTEM_PVM.h"
#include "ImageIO.h"
ImageIO_color ImageIO_c_black = {0, 0, 0};
ImageIO_color ImageIO_c_white = {255, 255, 255};
ImageIO_color ImageIO_c_red = {255, 0, 0};
ImageIO_color ImageIO_c_green = {0, 255, 0};
ImageIO_color ImageIO_c_blue = {0, 0, 255};

typedef struct S_11 {
    CHAR A[100 - 1 + 1];
} string;
static void error ARGS((CHAR mes[], CARDINAL ));
static void read_i ARGS((INTEGER *i));
#define C_8_maxcol 255
#define C_7_maxcol 255
#define maxcol 255


static void error
#ifdef __STDC__
(CHAR mes[], CARDINAL O_1)
#else
(mes, O_1)
CHAR mes[];
CARDINAL O_1;
#endif
{
  CARDINAL L_PE = PE;
  OPEN_ARRAY_LOCALS

  ALLOC_OPEN_ARRAYS(O_1 * sizeof(CHAR), 1)
  COPY_OPEN_ARRAY(mes, O_1, CHAR)

  WriteString("ERROR: ");
  WriteString(mes);
  WriteLn();
  exit(1);
  FREE_OPEN_ARRAYS
  PE = L_PE;
}

static void read_i
#ifdef __STDC__
(INTEGER *i)
#else
(i)
INTEGER *i;
#endif
{
  string s;
  CARDINAL L_PE = PE;


  ReadInt(i);
  while (!Done) {
    while (termCH != EOL) {
      ReadString(s.A);
      if (!Done) {
        error("image comment", 14L);
      }
    }
    ReadInt(i);
  }
  PE = L_PE;
}

void ImageIO_read_c_image
#ifdef __STDC__
(ImageIO_color im[], CHAR filename[], CARDINAL O_2, CARDINAL *width, CARDINAL *height, CONFIGURATION OPEN_VECTOR)
#else
(im, filename, O_2, width, height, OPEN_VECTOR)
ImageIO_color im[];
CHAR filename[];
CARDINAL O_2;
CARDINAL *width, *height;
CONFIGURATION OPEN_VECTOR;
#endif
{
  CHAR ch;
  INTEGER x_pos, y_pos, pos, C_11_maxcol;
  CARDINAL max_height, max_width;
  string magic;
  CARDINAL L_PE = PE;
  BOOLEAN_ELEM_PTR H_1107, H_1108;
  OPEN_ARRAY_LOCALS

  ALLOC_OPEN_ARRAYS(O_2 * sizeof(CHAR), 1)
  COPY_OPEN_ARRAY(filename, O_2, CHAR)
  H_1107 = READ_ACTIVE(OPEN_VECTOR);
  H_1108 = READ_ELSE(OPEN_VECTOR);

  {
    ImageIO_color *H_840 = (void *) malloc(sizeof(*(H_840)) * LOCAL_NUM_PEs(OPEN_VECTOR));
    INTEGER H_844;
    ImageIO_color *H_834 = (void *) malloc(sizeof(*(H_834)) * LOCAL_NUM_PEs(OPEN_VECTOR));
    INTEGER H_838;
    INTEGER H_845;
    INTEGER H_832;
    INTEGER H_846;
    FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
      H_840[PE] = im[PE];
    }
    H_844 = UPPER(OPEN_VECTOR, 1);
    FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
      H_834[PE] = im[PE];
    }
    H_838 = LOWER(OPEN_VECTOR, 1);
    H_845 = H_844 - H_838;
    H_832 = 1;
    H_846 = H_845 + H_832;
    max_width = H_846;
    free(H_840);
    free(H_834);
  }
  {
    ImageIO_color *H_856 = (void *) malloc(sizeof(*(H_856)) * LOCAL_NUM_PEs(OPEN_VECTOR));
    INTEGER H_860;
    ImageIO_color *H_850 = (void *) malloc(sizeof(*(H_850)) * LOCAL_NUM_PEs(OPEN_VECTOR));
    INTEGER H_854;
    INTEGER H_861;
    INTEGER H_848;
    INTEGER H_862;
    FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
      H_856[PE] = im[PE];
    }
    H_860 = UPPER(OPEN_VECTOR, 2);
    FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
      H_850[PE] = im[PE];
    }
    H_854 = LOWER(OPEN_VECTOR, 2);
    H_861 = H_860 - H_854;
    H_848 = 1;
    H_862 = H_861 + H_848;
    max_height = H_862;
    free(H_856);
    free(H_850);
  }
  OpenInput(filename);
  if (!Done) {
    error("file not found", 15L);
  }
  WriteString("reading color  image '");
  WriteString(filename);
  WriteString("' .. ");
  ReadString(magic.A);
  if ((strcmp(magic.A, "P6") != 0)) {
    error("wrong file format - please use ppm P6", 38L);
  }
  read_i(width);
  read_i(height);
  read_i(&C_11_maxcol);
  Read(&ch);
  WriteInt(*height, 1);
  WriteString(" x ");
  WriteInt(*width, 1);
  WriteString(" Pixels - max color ");
  WriteInt(C_11_maxcol, 1);
  WriteLn();
  if (*height > max_height || *width > max_width) {
    error("image too large", 16L);
  }
  if (C_11_maxcol == 255) {
    {
      INTEGER B_1 = 1, B_2 = *height;

      if (B_1 <= B_2)
        for (y_pos = B_1;; y_pos += 1) {
          {
            INTEGER B_3 = 1, B_4 = *width;

            if (B_3 <= B_4)
              for (x_pos = B_3;; x_pos += 1) {
                pos = (y_pos - 1) * max_width + x_pos;
                Read(&ch);
                {
                  if (IS_IN_LOCAL_ID_RANGE(OPEN_VECTOR, pos)) {
                    im[CHECK_PE_NUMBER(OPEN_VECTOR, pos - (OPEN_VECTOR.ID_range[me].start_ID), __FILE__, __LINE__)].red = ORD(ch);
                  }
                }
                Read(&ch);
                {
                  if (IS_IN_LOCAL_ID_RANGE(OPEN_VECTOR, pos)) {
                    im[CHECK_PE_NUMBER(OPEN_VECTOR, pos - (OPEN_VECTOR.ID_range[me].start_ID), __FILE__, __LINE__)].green = ORD(ch);
                  }
                }
                Read(&ch);
                {
                  if (IS_IN_LOCAL_ID_RANGE(OPEN_VECTOR, pos)) {
                    im[CHECK_PE_NUMBER(OPEN_VECTOR, pos - (OPEN_VECTOR.ID_range[me].start_ID), __FILE__, __LINE__)].blue = ORD(ch);
                  }
                }
                if (x_pos >= B_4) break;
              }
          }
          if (y_pos >= B_2) break;
        }
    }
  } else {
    {
      INTEGER B_5 = 1, B_6 = *height;

      if (B_5 <= B_6)
        for (y_pos = B_5;; y_pos += 1) {
          {
            INTEGER B_7 = 1, B_8 = *width;

            if (B_7 <= B_8)
              for (x_pos = B_7;; x_pos += 1) {
                pos = (y_pos - 1) * max_width + x_pos;
                Read(&ch);
                {
                  if (IS_IN_LOCAL_ID_RANGE(OPEN_VECTOR, pos)) {
                    im[CHECK_PE_NUMBER(OPEN_VECTOR, pos - (OPEN_VECTOR.ID_range[me].start_ID), __FILE__, __LINE__)].red = ORD(ch) * 255 / C_11_maxcol;
                  }
                }
                Read(&ch);
                {
                  if (IS_IN_LOCAL_ID_RANGE(OPEN_VECTOR, pos)) {
                    im[CHECK_PE_NUMBER(OPEN_VECTOR, pos - (OPEN_VECTOR.ID_range[me].start_ID), __FILE__, __LINE__)].green = ORD(ch) * 255 / C_11_maxcol;
                  }
                }
                Read(&ch);
                {
                  if (IS_IN_LOCAL_ID_RANGE(OPEN_VECTOR, pos)) {
                    im[CHECK_PE_NUMBER(OPEN_VECTOR, pos - (OPEN_VECTOR.ID_range[me].start_ID), __FILE__, __LINE__)].blue = ORD(ch) * 255 / C_11_maxcol;
                  }
                }
                if (x_pos >= B_8) break;
              }
          }
          if (y_pos >= B_6) break;
        }
    }
  }
  CloseInput();
  PUSH_ACTIVE(OPEN_VECTOR);
  { BOOLEAN *H_1109 = (BOOLEAN *) malloc(sizeof(BOOLEAN) * LOCAL_NUM_PEs(OPEN_VECTOR));
    {
      ImageIO_color *H_1070 = (void *) malloc(sizeof(*(H_1070)) * LOCAL_NUM_PEs(OPEN_VECTOR));
      INTEGER *H_1074;
      ImageIO_color *H_1064 = (void *) malloc(sizeof(*(H_1064)) * LOCAL_NUM_PEs(OPEN_VECTOR));
      INTEGER H_1068;
      INTEGER *H_1075 = (void *) malloc(sizeof(*(H_1075)) * LOCAL_NUM_PEs(OPEN_VECTOR));
      CARDINAL H_1062;
      BOOLEAN *H_1076 = (void *) malloc(sizeof(*(H_1076)) * LOCAL_NUM_PEs(OPEN_VECTOR));
      ImageIO_color *H_1055 = (void *) malloc(sizeof(*(H_1055)) * LOCAL_NUM_PEs(OPEN_VECTOR));
      INTEGER *H_1059;
      ImageIO_color *H_1049 = (void *) malloc(sizeof(*(H_1049)) * LOCAL_NUM_PEs(OPEN_VECTOR));
      INTEGER H_1053;
      INTEGER *H_1060 = (void *) malloc(sizeof(*(H_1060)) * LOCAL_NUM_PEs(OPEN_VECTOR));
      CARDINAL H_1047;
      BOOLEAN *H_1061 = (void *) malloc(sizeof(*(H_1061)) * LOCAL_NUM_PEs(OPEN_VECTOR));
      BOOLEAN *H_1077 = (void *) malloc(sizeof(*(H_1077)) * LOCAL_NUM_PEs(OPEN_VECTOR));
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        H_1070[PE] = im[PE];
      }
      H_1074 = DIM(OPEN_VECTOR, 1);
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        H_1064[PE] = im[PE];
      }
      H_1068 = LOWER(OPEN_VECTOR, 1);
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        H_1075[PE] = H_1074[PE] - H_1068;
      }
      H_1062 = *width;
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        H_1076[PE] = H_1075[PE] >= ((INTEGER) H_1062);
      }
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        H_1055[PE] = im[PE];
      }
      H_1059 = DIM(OPEN_VECTOR, 2);
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        H_1049[PE] = im[PE];
      }
      H_1053 = LOWER(OPEN_VECTOR, 2);
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        H_1060[PE] = H_1059[PE] - H_1053;
      }
      H_1047 = *height;
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        H_1061[PE] = H_1060[PE] >= ((INTEGER) H_1047);
      }
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        H_1077[PE] = H_1076[PE] || H_1061[PE];
      }
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        H_1109[PE] = H_1077[PE];
      } /* end FOR_ALL_LOCAL_ACTIVES */
      free(H_1070);
      free(H_1074);
      free(H_1064);
      free(H_1075);
      free(H_1076);
      free(H_1055);
      free(H_1059);
      free(H_1049);
      free(H_1060);
      free(H_1061);
      free(H_1077);
    }
    FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
      if (!H_1109[PE]) { SET_INACTIVE(OPEN_VECTOR, PE); }
    } /* end FOR_ALL_LOCAL_ACTIVES */
    if (IS_ANY_ACTIVE(OPEN_VECTOR)) {
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        im[PE] = ImageIO_c_white;
      }
    }
    free(H_1109);
  }
  POP_ACTIVE(OPEN_VECTOR);
  FREE_OPEN_ARRAYS
  PE = L_PE;
}

void ImageIO_read_g_image
#ifdef __STDC__
(ImageIO_gray im[], CHAR filename[], CARDINAL O_3, CARDINAL *width, CARDINAL *height, CONFIGURATION OPEN_VECTOR)
#else
(im, filename, O_3, width, height, OPEN_VECTOR)
ImageIO_gray im[];
CHAR filename[];
CARDINAL O_3;
CARDINAL *width, *height;
CONFIGURATION OPEN_VECTOR;
#endif
{
  CHAR ch;
  INTEGER x_pos, y_pos, pos, C_10_maxcol;
  CARDINAL max_height, max_width;
  string magic;
  CARDINAL L_PE = PE;
  BOOLEAN_ELEM_PTR H_1110, H_1111;
  OPEN_ARRAY_LOCALS

  ALLOC_OPEN_ARRAYS(O_3 * sizeof(CHAR), 1)
  COPY_OPEN_ARRAY(filename, O_3, CHAR)
  H_1110 = READ_ACTIVE(OPEN_VECTOR);
  H_1111 = READ_ELSE(OPEN_VECTOR);

  {
    ImageIO_gray *H_644 = (void *) malloc(sizeof(*(H_644)) * LOCAL_NUM_PEs(OPEN_VECTOR));
    INTEGER H_648;
    ImageIO_gray *H_638 = (void *) malloc(sizeof(*(H_638)) * LOCAL_NUM_PEs(OPEN_VECTOR));
    INTEGER H_642;
    INTEGER H_649;
    INTEGER H_636;
    INTEGER H_650;
    FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
      H_644[PE] = im[PE];
    }
    H_648 = UPPER(OPEN_VECTOR, 1);
    FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
      H_638[PE] = im[PE];
    }
    H_642 = LOWER(OPEN_VECTOR, 1);
    H_649 = H_648 - H_642;
    H_636 = 1;
    H_650 = H_649 + H_636;
    max_width = H_650;
    free(H_644);
    free(H_638);
  }
  {
    ImageIO_gray *H_660 = (void *) malloc(sizeof(*(H_660)) * LOCAL_NUM_PEs(OPEN_VECTOR));
    INTEGER H_664;
    ImageIO_gray *H_654 = (void *) malloc(sizeof(*(H_654)) * LOCAL_NUM_PEs(OPEN_VECTOR));
    INTEGER H_658;
    INTEGER H_665;
    INTEGER H_652;
    INTEGER H_666;
    FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
      H_660[PE] = im[PE];
    }
    H_664 = UPPER(OPEN_VECTOR, 2);
    FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
      H_654[PE] = im[PE];
    }
    H_658 = LOWER(OPEN_VECTOR, 2);
    H_665 = H_664 - H_658;
    H_652 = 1;
    H_666 = H_665 + H_652;
    max_height = H_666;
    free(H_660);
    free(H_654);
  }
  OpenInput(filename);
  if (!Done) {
    error("file not found", 15L);
  }
  WriteString("reading gray   image '");
  WriteString(filename);
  WriteString("' .. ");
  ReadString(magic.A);
  if ((strcmp(magic.A, "P5") != 0)) {
    error("wrong file format - please use pgm P5", 38L);
  }
  read_i(width);
  read_i(height);
  read_i(&C_10_maxcol);
  Read(&ch);
  WriteInt(*height, 1);
  WriteString(" x ");
  WriteInt(*width, 1);
  WriteString(" Pixels - max color ");
  WriteInt(C_10_maxcol, 1);
  WriteLn();
  if (*height > max_height || *width > max_width) {
    error("image too large", 16L);
  }
  if (C_10_maxcol == 255) {
    {
      INTEGER B_9 = 1, B_10 = *height;

      if (B_9 <= B_10)
        for (y_pos = B_9;; y_pos += 1) {
          {
            INTEGER B_11 = 1, B_12 = *width;

            if (B_11 <= B_12)
              for (x_pos = B_11;; x_pos += 1) {
                pos = (y_pos - 1) * max_width + x_pos;
                Read(&ch);
                {
                  if (IS_IN_LOCAL_ID_RANGE(OPEN_VECTOR, pos)) {
                    im[CHECK_PE_NUMBER(OPEN_VECTOR, pos - (OPEN_VECTOR.ID_range[me].start_ID), __FILE__, __LINE__)] = ORD(ch);
                  }
                }
                if (x_pos >= B_12) break;
              }
          }
          if (y_pos >= B_10) break;
        }
    }
  } else {
    {
      INTEGER B_13 = 1, B_14 = *height;

      if (B_13 <= B_14)
        for (y_pos = B_13;; y_pos += 1) {
          {
            INTEGER B_15 = 1, B_16 = *width;

            if (B_15 <= B_16)
              for (x_pos = B_15;; x_pos += 1) {
                pos = (y_pos - 1) * max_width + x_pos;
                Read(&ch);
                {
                  if (IS_IN_LOCAL_ID_RANGE(OPEN_VECTOR, pos)) {
                    im[CHECK_PE_NUMBER(OPEN_VECTOR, pos - (OPEN_VECTOR.ID_range[me].start_ID), __FILE__, __LINE__)] = ORD(ch) * 255 / C_10_maxcol;
                  }
                }
                if (x_pos >= B_16) break;
              }
          }
          if (y_pos >= B_14) break;
        }
    }
  }
  CloseInput();
  PUSH_ACTIVE(OPEN_VECTOR);
  { BOOLEAN *H_1112 = (BOOLEAN *) malloc(sizeof(BOOLEAN) * LOCAL_NUM_PEs(OPEN_VECTOR));
    {
      ImageIO_gray *H_820 = (void *) malloc(sizeof(*(H_820)) * LOCAL_NUM_PEs(OPEN_VECTOR));
      INTEGER *H_824;
      ImageIO_gray *H_814 = (void *) malloc(sizeof(*(H_814)) * LOCAL_NUM_PEs(OPEN_VECTOR));
      INTEGER H_818;
      INTEGER *H_825 = (void *) malloc(sizeof(*(H_825)) * LOCAL_NUM_PEs(OPEN_VECTOR));
      CARDINAL H_812;
      BOOLEAN *H_826 = (void *) malloc(sizeof(*(H_826)) * LOCAL_NUM_PEs(OPEN_VECTOR));
      ImageIO_gray *H_805 = (void *) malloc(sizeof(*(H_805)) * LOCAL_NUM_PEs(OPEN_VECTOR));
      INTEGER *H_809;
      ImageIO_gray *H_799 = (void *) malloc(sizeof(*(H_799)) * LOCAL_NUM_PEs(OPEN_VECTOR));
      INTEGER H_803;
      INTEGER *H_810 = (void *) malloc(sizeof(*(H_810)) * LOCAL_NUM_PEs(OPEN_VECTOR));
      CARDINAL H_797;
      BOOLEAN *H_811 = (void *) malloc(sizeof(*(H_811)) * LOCAL_NUM_PEs(OPEN_VECTOR));
      BOOLEAN *H_827 = (void *) malloc(sizeof(*(H_827)) * LOCAL_NUM_PEs(OPEN_VECTOR));
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        H_820[PE] = im[PE];
      }
      H_824 = DIM(OPEN_VECTOR, 1);
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        H_814[PE] = im[PE];
      }
      H_818 = LOWER(OPEN_VECTOR, 1);
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        H_825[PE] = H_824[PE] - H_818;
      }
      H_812 = *width;
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        H_826[PE] = H_825[PE] >= ((INTEGER) H_812);
      }
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        H_805[PE] = im[PE];
      }
      H_809 = DIM(OPEN_VECTOR, 2);
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        H_799[PE] = im[PE];
      }
      H_803 = LOWER(OPEN_VECTOR, 2);
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        H_810[PE] = H_809[PE] - H_803;
      }
      H_797 = *height;
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        H_811[PE] = H_810[PE] >= ((INTEGER) H_797);
      }
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        H_827[PE] = H_826[PE] || H_811[PE];
      }
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        H_1112[PE] = H_827[PE];
      } /* end FOR_ALL_LOCAL_ACTIVES */
      free(H_820);
      free(H_824);
      free(H_814);
      free(H_825);
      free(H_826);
      free(H_805);
      free(H_809);
      free(H_799);
      free(H_810);
      free(H_811);
      free(H_827);
    }
    FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
      if (!H_1112[PE]) { SET_INACTIVE(OPEN_VECTOR, PE); }
    } /* end FOR_ALL_LOCAL_ACTIVES */
    if (IS_ANY_ACTIVE(OPEN_VECTOR)) {
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        im[PE] = ImageIO_g_white;
      }
    }
    free(H_1112);
  }
  POP_ACTIVE(OPEN_VECTOR);
  FREE_OPEN_ARRAYS
  PE = L_PE;
}

void ImageIO_read_b_image
#ifdef __STDC__
(ImageIO_binary im[], CHAR filename[], CARDINAL O_4, CARDINAL *width, CARDINAL *height, CONFIGURATION OPEN_VECTOR)
#else
(im, filename, O_4, width, height, OPEN_VECTOR)
ImageIO_binary im[];
CHAR filename[];
CARDINAL O_4;
CARDINAL *width, *height;
CONFIGURATION OPEN_VECTOR;
#endif
{
  CHAR ch;
  INTEGER count, num, C_9_maxcol, pos, x_pos, y_pos, max_height, max_width;
  string magic;
  CARDINAL L_PE = PE;
  BOOLEAN_ELEM_PTR H_1113, H_1114;
  OPEN_ARRAY_LOCALS

  ALLOC_OPEN_ARRAYS(O_4 * sizeof(CHAR), 1)
  COPY_OPEN_ARRAY(filename, O_4, CHAR)
  H_1113 = READ_ACTIVE(OPEN_VECTOR);
  H_1114 = READ_ELSE(OPEN_VECTOR);

  {
    BOOLEAN *H_455 = (void *) malloc(sizeof(*(H_455)) * LOCAL_NUM_PEs(OPEN_VECTOR));
    INTEGER H_459;
    BOOLEAN *H_449 = (void *) malloc(sizeof(*(H_449)) * LOCAL_NUM_PEs(OPEN_VECTOR));
    INTEGER H_453;
    INTEGER H_460;
    INTEGER H_447;
    INTEGER H_461;
    FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
      H_455[PE] = im[PE];
    }
    H_459 = UPPER(OPEN_VECTOR, 1);
    FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
      H_449[PE] = im[PE];
    }
    H_453 = LOWER(OPEN_VECTOR, 1);
    H_460 = H_459 - H_453;
    H_447 = 1;
    H_461 = H_460 + H_447;
    max_width = H_461;
    free(H_455);
    free(H_449);
  }
  {
    BOOLEAN *H_471 = (void *) malloc(sizeof(*(H_471)) * LOCAL_NUM_PEs(OPEN_VECTOR));
    INTEGER H_475;
    BOOLEAN *H_465 = (void *) malloc(sizeof(*(H_465)) * LOCAL_NUM_PEs(OPEN_VECTOR));
    INTEGER H_469;
    INTEGER H_476;
    INTEGER H_463;
    INTEGER H_477;
    FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
      H_471[PE] = im[PE];
    }
    H_475 = UPPER(OPEN_VECTOR, 2);
    FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
      H_465[PE] = im[PE];
    }
    H_469 = LOWER(OPEN_VECTOR, 2);
    H_476 = H_475 - H_469;
    H_463 = 1;
    H_477 = H_476 + H_463;
    max_height = H_477;
    free(H_471);
    free(H_465);
  }
  OpenInput(filename);
  if (!Done) {
    error("file not found", 15L);
  }
  WriteString("reading binary image '");
  WriteString(filename);
  WriteString("' .. ");
  ReadString(magic.A);
  if ((strcmp(magic.A, "P4") != 0)) {
    error("wrong file format - please use pbm P4", 38L);
  }
  read_i(width);
  read_i(height);
  Read(&ch);
  WriteInt(*height, 1);
  WriteString(" x ");
  WriteInt(*width, 1);
  WriteString(" Pixels");
  WriteLn();
  if (((INTEGER) (*height)) > max_height || ((INTEGER) (*width)) > max_width) {
    error("image too large", 16L);
  }
  y_pos = 1;
  x_pos = 1;
  count = 0;
  while (y_pos <= ((INTEGER) (*height))) {
    if (count == 0) {
      Read(&ch);
      num = ORD(ch);
      count = 8;
    }
    pos = (y_pos - 1) * max_width + x_pos;
    {
      if (IS_IN_LOCAL_ID_RANGE(OPEN_VECTOR, pos)) {
        im[CHECK_PE_NUMBER(OPEN_VECTOR, pos - (OPEN_VECTOR.ID_range[me].start_ID), __FILE__, __LINE__)] = num >= ((INTEGER) pow((double) 2, (double) 7));
      }
    }
    DEC(count);
    num = MOD1(2 * num, 256);
    INC(x_pos);
    if (x_pos > ((INTEGER) (*width))) {
      INC(y_pos);
      x_pos = 1;
      count = 0;
    }
  }
  CloseInput();
  PUSH_ACTIVE(OPEN_VECTOR);
  { BOOLEAN *H_1115 = (BOOLEAN *) malloc(sizeof(BOOLEAN) * LOCAL_NUM_PEs(OPEN_VECTOR));
    {
      BOOLEAN *H_624 = (void *) malloc(sizeof(*(H_624)) * LOCAL_NUM_PEs(OPEN_VECTOR));
      INTEGER *H_628;
      BOOLEAN *H_618 = (void *) malloc(sizeof(*(H_618)) * LOCAL_NUM_PEs(OPEN_VECTOR));
      INTEGER H_622;
      INTEGER *H_629 = (void *) malloc(sizeof(*(H_629)) * LOCAL_NUM_PEs(OPEN_VECTOR));
      CARDINAL H_616;
      BOOLEAN *H_630 = (void *) malloc(sizeof(*(H_630)) * LOCAL_NUM_PEs(OPEN_VECTOR));
      BOOLEAN *H_609 = (void *) malloc(sizeof(*(H_609)) * LOCAL_NUM_PEs(OPEN_VECTOR));
      INTEGER *H_613;
      BOOLEAN *H_603 = (void *) malloc(sizeof(*(H_603)) * LOCAL_NUM_PEs(OPEN_VECTOR));
      INTEGER H_607;
      INTEGER *H_614 = (void *) malloc(sizeof(*(H_614)) * LOCAL_NUM_PEs(OPEN_VECTOR));
      CARDINAL H_601;
      BOOLEAN *H_615 = (void *) malloc(sizeof(*(H_615)) * LOCAL_NUM_PEs(OPEN_VECTOR));
      BOOLEAN *H_631 = (void *) malloc(sizeof(*(H_631)) * LOCAL_NUM_PEs(OPEN_VECTOR));
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        H_624[PE] = im[PE];
      }
      H_628 = DIM(OPEN_VECTOR, 1);
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        H_618[PE] = im[PE];
      }
      H_622 = LOWER(OPEN_VECTOR, 1);
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        H_629[PE] = H_628[PE] - H_622;
      }
      H_616 = *width;
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        H_630[PE] = H_629[PE] >= ((INTEGER) H_616);
      }
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        H_609[PE] = im[PE];
      }
      H_613 = DIM(OPEN_VECTOR, 2);
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        H_603[PE] = im[PE];
      }
      H_607 = LOWER(OPEN_VECTOR, 2);
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        H_614[PE] = H_613[PE] - H_607;
      }
      H_601 = *height;
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        H_615[PE] = H_614[PE] >= ((INTEGER) H_601);
      }
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        H_631[PE] = H_630[PE] || H_615[PE];
      }
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        H_1115[PE] = H_631[PE];
      } /* end FOR_ALL_LOCAL_ACTIVES */
      free(H_624);
      free(H_628);
      free(H_618);
      free(H_629);
      free(H_630);
      free(H_609);
      free(H_613);
      free(H_603);
      free(H_614);
      free(H_615);
      free(H_631);
    }
    FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
      if (!H_1115[PE]) { SET_INACTIVE(OPEN_VECTOR, PE); }
    } /* end FOR_ALL_LOCAL_ACTIVES */
    if (IS_ANY_ACTIVE(OPEN_VECTOR)) {
      FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
        im[PE] = ImageIO_b_white;
      }
    }
    free(H_1115);
  }
  POP_ACTIVE(OPEN_VECTOR);
  FREE_OPEN_ARRAYS
  PE = L_PE;
}

void ImageIO_write_c_image
#ifdef __STDC__
(ImageIO_color im[], CHAR filename[], CARDINAL O_5, CARDINAL width, CARDINAL height, CONFIGURATION OPEN_VECTOR)
#else
(im, filename, O_5, width, height, OPEN_VECTOR)
ImageIO_color im[];
CHAR filename[];
CARDINAL O_5;
CARDINAL width, height;
CONFIGURATION OPEN_VECTOR;
#endif
{
  INTEGER max_width, pos, x_pos, y_pos;
  CARDINAL L_PE = PE;
  OPEN_ARRAY_LOCALS

  ALLOC_OPEN_ARRAYS(O_5 * sizeof(CHAR), 1)
  COPY_OPEN_ARRAY(filename, O_5, CHAR)

  {
    ImageIO_color *H_338 = (void *) malloc(sizeof(*(H_338)) * LOCAL_NUM_PEs(OPEN_VECTOR));
    INTEGER H_342;
    ImageIO_color *H_332 = (void *) malloc(sizeof(*(H_332)) * LOCAL_NUM_PEs(OPEN_VECTOR));
    INTEGER H_336;
    INTEGER H_343;
    INTEGER H_330;
    INTEGER H_344;
    FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
      H_338[PE] = im[PE];
    }
    H_342 = UPPER(OPEN_VECTOR, 1);
    FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
      H_332[PE] = im[PE];
    }
    H_336 = LOWER(OPEN_VECTOR, 1);
    H_343 = H_342 - H_336;
    H_330 = 1;
    H_344 = H_343 + H_330;
    max_width = H_344;
    free(H_338);
    free(H_332);
  }
  WriteString("writing color  image '");
  WriteString(filename);
  WriteString("' .. ");
  WriteInt(height, 1);
  WriteString(" x ");
  WriteInt(width, 1);
  WriteString(" Pixels - max color ");
  WriteInt(C_8_maxcol, 1);
  WriteLn();
  OpenOutput(filename);
  WriteString("P6");
  WriteLn();
  WriteString("# CREATOR: Parallaxis-III Univ. Stuttgart");
  WriteLn();
  WriteInt(width, 1);
  Write(' ');
  WriteInt(height, 1);
  WriteLn();
  WriteInt(C_8_maxcol, 1);
  WriteLn();
  {
    INTEGER B_17 = 1, B_18 = height;

    if (B_17 <= B_18)
      for (y_pos = B_17;; y_pos += 1) {
        {
          INTEGER B_19 = 1, B_20 = width;

          if (B_19 <= B_20)
            for (x_pos = B_19;; x_pos += 1) {
              pos = (y_pos - 1) * max_width + x_pos;
              {
                {
                  register ImageIO_color *W_1 = &im[CHECK_PE_NUMBER(OPEN_VECTOR, pos - (OPEN_VECTOR.ID_range[me].start_ID), __FILE__, __LINE__)];

                  Write(CHR(W_1->red));
                  Write(CHR(W_1->green));
                  Write(CHR(W_1->blue));
                }
              }
              if (x_pos >= B_20) break;
            }
        }
        if (y_pos >= B_18) break;
      }
  }
  CloseOutput();
  FREE_OPEN_ARRAYS
  PE = L_PE;
}

void ImageIO_write_g_image
#ifdef __STDC__
(ImageIO_gray im[], CHAR filename[], CARDINAL O_6, CARDINAL width, CARDINAL height, CONFIGURATION OPEN_VECTOR)
#else
(im, filename, O_6, width, height, OPEN_VECTOR)
ImageIO_gray im[];
CHAR filename[];
CARDINAL O_6;
CARDINAL width, height;
CONFIGURATION OPEN_VECTOR;
#endif
{
  INTEGER max_width, pos, x_pos, y_pos;
  CARDINAL L_PE = PE;
  OPEN_ARRAY_LOCALS

  ALLOC_OPEN_ARRAYS(O_6 * sizeof(CHAR), 1)
  COPY_OPEN_ARRAY(filename, O_6, CHAR)

  {
    ImageIO_gray *H_234 = (void *) malloc(sizeof(*(H_234)) * LOCAL_NUM_PEs(OPEN_VECTOR));
    INTEGER H_238;
    ImageIO_gray *H_228 = (void *) malloc(sizeof(*(H_228)) * LOCAL_NUM_PEs(OPEN_VECTOR));
    INTEGER H_232;
    INTEGER H_239;
    INTEGER H_226;
    INTEGER H_240;
    FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
      H_234[PE] = im[PE];
    }
    H_238 = UPPER(OPEN_VECTOR, 1);
    FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
      H_228[PE] = im[PE];
    }
    H_232 = LOWER(OPEN_VECTOR, 1);
    H_239 = H_238 - H_232;
    H_226 = 1;
    H_240 = H_239 + H_226;
    max_width = H_240;
    free(H_234);
    free(H_228);
  }
  WriteString("writing gray   image '");
  WriteString(filename);
  WriteString("' .. ");
  WriteInt(height, 1);
  WriteString(" x ");
  WriteInt(width, 1);
  WriteString(" Pixels - max color ");
  WriteInt(C_7_maxcol, 1);
  WriteLn();
  OpenOutput(filename);
  WriteString("P5");
  WriteLn();
  WriteString("# CREATOR: Parallaxis-III Univ. Stuttgart");
  WriteLn();
  WriteInt(width, 1);
  Write(' ');
  WriteInt(height, 1);
  WriteLn();
  WriteInt(C_7_maxcol, 1);
  WriteLn();
  {
    INTEGER B_21 = 1, B_22 = height;

    if (B_21 <= B_22)
      for (y_pos = B_21;; y_pos += 1) {
        {
          INTEGER B_23 = 1, B_24 = width;

          if (B_23 <= B_24)
            for (x_pos = B_23;; x_pos += 1) {
              pos = (y_pos - 1) * max_width + x_pos;
              {
                ImageIO_gray H_323;
                CHAR H_325;
                if (IS_IN_LOCAL_ID_RANGE(OPEN_VECTOR, pos)) {
                  H_323 = im[CHECK_PE_NUMBER(OPEN_VECTOR, pos - (OPEN_VECTOR.ID_range[me].start_ID), __FILE__, __LINE__)];
                  (void) pvm_initsend(PvmDataDefault);
                  if (me > 0) {
                    (void) PVM_MCAST(&task_ids[0], me, INTER_TASK_TAG);
                  }
                  if (me < n_tasks - 1) {
                    (void) PVM_MCAST(&task_ids[me+1], n_tasks - me - 1, INTER_TASK_TAG);
                  }
                } else {
                  (void) pvm_recv(task_ids[TASK_INDEX_HOLDING_ID(pos, OPEN_VECTOR)], INTER_TASK_TAG);
                }
                H_325 = CHR(H_323);
                Write(H_325);
              }
              if (x_pos >= B_24) break;
            }
        }
        if (y_pos >= B_22) break;
      }
  }
  CloseOutput();
  FREE_OPEN_ARRAYS
  PE = L_PE;
}

void ImageIO_write_b_image
#ifdef __STDC__
(ImageIO_binary im[], CHAR filename[], CARDINAL O_7, CARDINAL width, CARDINAL height, CONFIGURATION OPEN_VECTOR)
#else
(im, filename, O_7, width, height, OPEN_VECTOR)
ImageIO_binary im[];
CHAR filename[];
CARDINAL O_7;
CARDINAL width, height;
CONFIGURATION OPEN_VECTOR;
#endif
{
  INTEGER max_width, count, x_pos, y_pos, pos;
  CARDINAL b8;
  CARDINAL L_PE = PE;
  OPEN_ARRAY_LOCALS

  ALLOC_OPEN_ARRAYS(O_7 * sizeof(CHAR), 1)
  COPY_OPEN_ARRAY(filename, O_7, CHAR)

  {
    BOOLEAN *H_70 = (void *) malloc(sizeof(*(H_70)) * LOCAL_NUM_PEs(OPEN_VECTOR));
    INTEGER H_74;
    BOOLEAN *H_64 = (void *) malloc(sizeof(*(H_64)) * LOCAL_NUM_PEs(OPEN_VECTOR));
    INTEGER H_68;
    INTEGER H_75;
    INTEGER H_62;
    INTEGER H_76;
    FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
      H_70[PE] = im[PE];
    }
    H_74 = UPPER(OPEN_VECTOR, 1);
    FOR_ALL_LOCAL_ACTIVES(OPEN_VECTOR) {
      H_64[PE] = im[PE];
    }
    H_68 = LOWER(OPEN_VECTOR, 1);
    H_75 = H_74 - H_68;
    H_62 = 1;
    H_76 = H_75 + H_62;
    max_width = H_76;
    free(H_70);
    free(H_64);
  }
  WriteString("writing binary image '");
  WriteString(filename);
  WriteString("' .. ");
  WriteInt(height, 1);
  WriteString(" x ");
  WriteInt(width, 1);
  WriteString(" Pixels");
  WriteLn();
  OpenOutput(filename);
  WriteString("P4");
  WriteLn();
  WriteString("# CREATOR: Parallaxis-III Univ. Stuttgart");
  WriteLn();
  WriteInt(width, 1);
  Write(' ');
  WriteInt(height, 1);
  WriteLn();
  y_pos = 1;
  x_pos = 1;
  count = 0;
  b8 = 0;
  while (y_pos <= ((INTEGER) height)) {
    pos = (y_pos - 1) * max_width + x_pos;
    {
      INTEGER H_155;
      CARDINAL H_154;
      INTEGER H_156;
      BOOLEAN H_151;
      CARDINAL H_153;
      INTEGER H_157;
      H_155 = 2;
      H_154 = b8;
      H_156 = H_155 * H_154;
      if (IS_IN_LOCAL_ID_RANGE(OPEN_VECTOR, pos)) {
        H_151 = im[CHECK_PE_NUMBER(OPEN_VECTOR, pos - (OPEN_VECTOR.ID_range[me].start_ID), __FILE__, __LINE__)];
        (void) pvm_initsend(PvmDataDefault);
        PVM_PKBOOLEAN(&(H_151), 1);
        if (me > 0) {
          (void) PVM_MCAST(&task_ids[0], me, INTER_TASK_TAG);
        }
        if (me < n_tasks - 1) {
          (void) PVM_MCAST(&task_ids[me+1], n_tasks - me - 1, INTER_TASK_TAG);
        }
      } else {
        (void) pvm_recv(task_ids[TASK_INDEX_HOLDING_ID(pos, OPEN_VECTOR)], INTER_TASK_TAG);
        PVM_UPKBOOLEAN(&(H_151), 1);
      }
      H_153 = ORD(H_151);
      H_157 = H_156 + H_153;
      b8 = H_157;
    }
    INC(count);
    if (count == 8) {
      Write(CHR(b8));
      count = 0;
      b8 = 0;
    }
    INC(x_pos);
    if (x_pos > ((INTEGER) width)) {
      INC(y_pos);
      x_pos = 1;
      if (count > 0) {
        b8 = b8 * ((INTEGER) pow((double) 2, (double) (8 - count)));
        Write(CHR(b8));
        count = 0;
        b8 = 0;
      }
    }
  }
  if (count > 0) {
    b8 = b8 * ((INTEGER) pow((double) 2, (double) (8 - count)));
    Write(CHR(b8));
  }
  CloseOutput();
  FREE_OPEN_ARRAYS
  PE = L_PE;
}

void BEGIN_ImageIO()
{
  static BOOLEAN IsInitialized = FALSE;

  if (!IsInitialized) {
    IsInitialized = TRUE;


  }
}
