# include "Symbols.h"
# define yyALLOC(ptr, size)	if ((ptr = (tSymbols) Symbols_PoolFreePtr) >= (tSymbols) Symbols_PoolMaxPtr) \
  ptr = Symbols_Alloc (); \
  Symbols_PoolFreePtr += size;
# define yyFREE(ptr, size)	
# ifdef __cplusplus
extern "C" {
# include <stdio.h>
# include "yySymbols.w"
# include "System.h"
# include "General.h"
# include "Memory.h"
# include "DynArray.h"
# include "StringMem.h"
# include "Idents.h"
# include "Sets.h"
# include "Positions.h"
}
# else
# include <stdio.h>
# include "yySymbols.w"
# include "System.h"
# include "General.h"
# include "Memory.h"
# include "DynArray.h"
# include "StringMem.h"
# include "Idents.h"
# include "Sets.h"
# include "Positions.h"
# endif

/* line 334 "symbols.cg" */


#include  <stdio.h>
#include  "Idents.h"			  /* Reuse-Library */
#include  "Values.h"
#include  "Tree.h"
#include  "Types.h"

/*
#include "common.w"
#include "symbols.w"
#include "browser.w"
#include "symbrowse.w"
*/

#include "browser.w"
#include "symbrowse.w"
/*-----------------------------------------------------------------------*/

/*
 * local variables
 */
static tObjects   Result;
static tCObjects  Result1;
static tCObjects  ValueOpens;
static tCObjects  VAROpens;
static tObjects   PreDef_Objects;

/*
 * local function prototypes
 */
static BOOLEAN  CheckCycleType  (tType Type);
static BOOLEAN  CheckCycleObject(tObject Object);
static tType    GroundTypeType  (tType Type);
static tType    GroundTypeObject(tObject Object);
static void     Filter          (tObjects Objects);
static void     Pointers        (BOOLEAN GlobalPtrs, tObjects Objects);
static void     OpenArray       (tObjects Objects);
static tObjects GetConnections  (tObject Object, tObjects Objects,
                                  tObjects Connections);

static void     BasicType       (char *Name, tType Type);
static void     StdConst        (char *Name, tValue Value);
static void     StdVar          (char *Name, tType Type, ADDRESS TypeTree);
static void     StdProcedure    (char *Name, INDEX StdProc);
static tObjects Predef          (void);

/*-----------------------------------------------------------------------*/

/*
 * local function implementation
 */

static BOOLEAN CheckCycleType(tType Type)
{
  BOOLEAN cycle;

  if (Type->Kind == kSymQualident) {
    if (Type->yyHead.yyMark != 0) {
      return TRUE;
    } else {
      Type->yyHead.yyMark = 1;
      cycle = CheckCycleObject(Type->SymQualident.Object);
      Type->yyHead.yyMark = 0;
      return cycle;
    }
  } else {
    return FALSE;
  }
}


static BOOLEAN CheckCycleObject(tObject Object)
{
  if (Object->Kind == kSymTypeDecl) {
    return CheckCycleType(Object->SymTypeDecl.Type);
  } else {
    return FALSE;
  }
}


static tType GroundTypeType(tType Type)
{
  if (Type->Kind == kSymQualident) {
    return GroundTypeObject(Type->SymQualident.Object);
  } else {
    return Type;
  }
}


static tType GroundTypeObject(tObject Object)
{
  if (Object->Kind == kSymTypeDecl) {
    return Symbols_GroundType(Object->SymTypeDecl.Type);
  } else if (Object->Kind == kSymOpaque) {
    return Object->SymOpaque.Type;
  } else {
    return NoType;
  }
}


static void Filter(tObjects Objects)
{
  while (Objects != NoObjects) {
    if (Objects->Kind != kSymUnion) {
      switch (Objects->SymElem.Object->Kind) {
      case kSymConst:
      case kSymEnumLiteral:
      case kSymTypeDecl:
      case kSymVar:
      case kSymConfig:
      case kSymConnect:
        Result = mSymElem(Objects->SymElem.Ident, FALSE,
          Objects->SymElem.Object, Result);
        break;
      }
      Objects = Objects->SymElem.Next;
    } else {
      Filter(Objects->SymUnion.Objects1);
      Objects = Objects->SymUnion.Objects2;
    }
  }
}


static void Pointers(BOOLEAN GlobalPtrs, tObjects Objects)
{
  tObject  Object;

  while (Objects != NoObjects) {
    if (Objects->Kind != kSymUnion) {
      if (!Objects->SymElem.IsPseudoObj) {
        Object = Objects->SymElem.Object;
        switch (Object->Kind) {
        case kSymVar:
          if (Object->SymVar.NestedUse) {
            Result1 = mSymCObjects(Object, Result1);
          }
          break;
        case kSymProcBody:
          if (GlobalPtrs) {
            Pointers(GlobalPtrs, Object->SymProcBody.Locals);
          } 
          break;
        case kSymModule:
          Pointers(GlobalPtrs, Object->SymModule.Locals);
          break;
        }
      }
      Objects = Objects->SymElem.Next;
    } else {
       Pointers(GlobalPtrs, Objects->SymUnion.Objects1);
       Objects = Objects->SymUnion.Objects2;
    }
  }
}


static void OpenArray(tObjects Objects)
{
  while (Objects != NoObjects) {
    if (Objects->Kind != kSymUnion) {
      if (Symbols_IsOpenArray(Objects->SymElem.Object)) {
        if (Symbols_IsVAR(Objects->SymElem.Object)) {
          VAROpens = mSymCObjects(Objects->SymElem.Object, VAROpens);
        } else {
          ValueOpens = mSymCObjects(Objects->SymElem.Object, ValueOpens);
        }
      }
      Objects = Objects->SymElem.Next;
    } else {
      OpenArray(Objects->SymUnion.Objects1);
      Objects = Objects->SymUnion.Objects2;
    }
  }
}


static tObjects GetConnections(tObject Object, tObjects Objects,
  tObjects Connections)
{
  while (Objects != NoObjects) {
    if (Objects->Kind != kSymUnion) {
      if (Objects->SymElem.Object->Kind == kSymConnect &&
          Objects->SymElem.Object->SymConnect.SourceConfig == Object) {
        Connections = mSymElem(Objects->SymElem.Ident, FALSE,
          Objects->SymElem.Object, Connections);
      }
      Objects = Objects->SymElem.Next;
    } else {
      Connections = GetConnections(Object, Objects->SymUnion.Objects1,
        Connections);
      Objects = Objects->SymUnion.Objects2;
    }
  }
  return Connections;
}

/*-----------------------------------------------------------------------*/

/*
 * procedures to construct object descriptions for predefined objects
 */

/*****************************************************************************
 *  Function:	static void BasicType(char *Name, tType Type)
 *
 *  Parameters:	Name:	name of the type  (e.g. "ADDRESS")
 *              Type:	type
 *      
 *  Result:	-
 *
 *  Description:
 *  ------------
 *  Pre-define a type: reserve the identifier, create a SymTypeDecl-
 *  object and insert type and C-identifier. Add this object to the list
 *  of predefined objects. 
 *****************************************************************************/

static void BasicType(char *Name, tType Type)
{
   tIdent ident;
   tObject object;

   ident = MakeIdent(Name, strlen(Name));
   object = mSymTypeDeclSetType(mSymTypeDecl(ident, 0), Type);
   object->SymTypeDecl.CIdent = ident;
   PreDef_Objects = mSymElem(ident, FALSE, object, PreDef_Objects);
}


/*****************************************************************************
 *  Function:	static void StdConst(char *Name, tValue Value)
 *
 *  Parameters:	Name:	name of the constant (e.g. "TRUE")
 *		Value:  value of the constant
 *      
 *  Result:	-
 *
 *  Description:
 *  ------------
 *  Pre-define a constant: reserve the identifier, create a SymConst-
 *  object and insert value and C-identifier. Add this object to the
 *  list of predefined objects.
 *****************************************************************************/

static void StdConst(char *Name, tValue Value)
{
   tIdent ident;
   tObject object;

   ident = MakeIdent(Name, strlen(Name));
   object = mSymConstSetValue(mSymConst(ident), Value);
   object->SymConst.CIdent = ident;
   PreDef_Objects = mSymElem(ident, FALSE, object, PreDef_Objects);
}


/*****************************************************************************
 *  Function:	static void StdVar(char *Name, tType Type, ADDRESS TypeTree)
 *
 *  Parameters:	Name:	name of the variable (e.g. "Done")
 *		Type:	type of the variable
 *		TypeTree: pointer to a tree for the type
 *      
 *  Result:	-
 *
 *  Description:
 *  ------------
 *  Pre-define a variable: reserve the identifier, create a SymVar-
 *  object and insert the C-identifier. Add this object to the list of
 *  predefined objects.
 *****************************************************************************/

static void StdVar(char *Name, tType Type, ADDRESS TypeTree)
{
   tIdent ident;
   tObject object;

   ident = MakeIdent(Name, strlen(Name));
   object = mSymVar(ident, Type, FALSE, 0, FALSE, FALSE, TypeTree);
   object->SymConst.CIdent = ident;
   PreDef_Objects = mSymElem(ident, FALSE, object, PreDef_Objects);
}


/*****************************************************************************
 *  Function:	static void StdProcedure(char *Name, INDEX StdProc)
 *
 *  Parameters:	Name:	name of the procedure (e.g. "WriteInt")
 *              StdProc: serial number of the procedure
 *      
 *  Result:	-
 *
 *  Description:
 *  ------------
 *  Pre-define a standard procedure: reserve the identifier, create a
 *  SymStdProcType-type and a SymStdProc-object, insert the
 *  C-identifier and add the object to the list of predefined objects.
 *****************************************************************************/

static void StdProcedure(char *Name, INDEX StdProc)
{
   tIdent ident;
   tObject object;

   ident = MakeIdent(Name, strlen(Name));
   object = mSymStdProc(ident, StdProc, mSymStdProcType(StdProc));
   object->SymStdProc.CIdent = ident;
   PreDef_Objects = mSymElem(ident, FALSE, object, PreDef_Objects);
}


/*****************************************************************************
 *  Function:	static tObjects Predef(void)
 *
 *  Parameters:	-
 *      
 *  Result:	Object list containing all predefined objects
 *
 *  Description:
 *  ------------
 *  Create the objects that are predefined. This is the SYSTEM-Module
 *  and a lot of standard procedures, constants and types.
 *****************************************************************************/

static tObjects Predef(void)
{
   /* Step 1: Create a SymModule-object for the SYSTEM-Module */

   PreDef_Objects = NoObjects;

   BasicType   ("ADDRESS",   TypeADDRESS);
   BasicType   ("WORD",      TypeWORD);
   BasicType   ("BYTE",      TypeWORD);

   StdProcedure("ADR",       eSystemAdr);
   StdProcedure("TSIZE",     eSystemTSize);

   ModuleSYSTEM = mSymModuleSetObjects(mSymModule(IdentSYSTEM, PreDef_Objects),
     PreDef_Objects);
   ModuleSYSTEM->SymModule.CIdent = IdentSYSTEM;


   /* Step 2: Create a list of predefined objects. */

   PreDef_Objects = NoObjects;

   BasicType   ("INTEGER",   TypeINTEGER);
   BasicType   ("CARDINAL",  TypeCARDINAL);
   BasicType   ("REAL",      TypeREAL);
   BasicType   ("BOOLEAN",   TypeBOOLEAN);
   BasicType   ("CHAR",      TypeCHAR);
   BasicType   ("BITSET",    TypeBITSET);
   BasicType   ("PROC",      TypePROC);

   StdConst    ("NIL",       Values_Nil);
   StdConst    ("TRUE",      Values_True);
   StdConst    ("FALSE",     Values_False);

   StdProcedure("ABS",       eSystemAbs);
   StdProcedure("CAP",       eSystemCap);
   StdProcedure("CHR",       eSystemChr);
   StdProcedure("DIM",       eSystemDim);
   StdProcedure("DIM2ID",    eSystemDim2Id);
   StdProcedure("EVEN",      eSystemEven);
   StdProcedure("FLOAT",     eSystemFloat);
   StdProcedure("HIGH",      eSystemHigh);
   StdProcedure("ID",        eSystemId);
   StdProcedure("ID2DIM",    eSystemId2Dim);
   StdProcedure("LEN",       eSystemLen);
   StdProcedure("LOWER",     eSystemLower);
   StdProcedure("MAX",       eSystemMax);
   StdProcedure("MIN",       eSystemMin);
   StdProcedure("ODD",       eSystemOdd);
   StdProcedure("ORD",       eSystemOrd);
   StdProcedure("RANK",      eSystemRank);
   StdProcedure("SIZE",      eSystemSize);
   StdProcedure("UPPER",     eSystemUpper);
   StdProcedure("TRUNC",     eSystemTrunc);
   StdProcedure("VAL",       eSystemVal);
   StdProcedure("DEC",       eSystemDec);
   StdProcedure("EXCL",      eSystemExcl);
   StdProcedure("HALT",      eSystemHalt);
   StdProcedure("INC",       eSystemInc);
   StdProcedure("INCL",      eSystemIncl);
   StdProcedure("NEW",       eSystemNew);
   StdProcedure("DISPOSE",   eSystemDispose);

   StdProcedure("SUM",       eSystemSum);
   StdProcedure("PRODUCT",   eSystemProduct);
   StdProcedure("AND",       eSystemAnd);
   StdProcedure("OR",        eSystemOr);
   StdProcedure("FIRST",     eSystemFirst);
   StdProcedure("LAST",      eSystemLast);

   StdConst    ("pi",        Values_Pi);

   StdProcedure("sqrt",      eSystemSqrt);
   StdProcedure("exp",       eSystemExponent);
   StdProcedure("ln",        eSystemLn);
   StdProcedure("sin",       eSystemSin);
   StdProcedure("arcsin",    eSystemArcSin);
   StdProcedure("cos",       eSystemCos);
   StdProcedure("arccos",    eSystemArcCos);
   StdProcedure("tan",       eSystemTan);
   StdProcedure("arctan",    eSystemArcTan);
   StdProcedure("arctan2",   eSystemArcTan2);
   StdProcedure("ceiling",   eSystemCeiling);
   StdProcedure("floor",     eSystemFloor);
   StdProcedure("round",     eSystemRound);
   StdProcedure("RandomCard",eSystemCardRandom);
   StdProcedure("RandomInt", eSystemIntRandom);
   StdProcedure("RandomReal",eSystemRealRandom);
   StdProcedure("RandomBool",eSystemBoolRandom);
   StdProcedure("RandomChar",eSystemCharRandom);

   StdConst    ("EOL",       Values_EOL);

   StdVar      ("Done",      TypeBOOLEAN, Tree_Boolean);
   StdVar      ("termCH",    TypeCHAR, Tree_Char);

   StdProcedure("OpenOutput",  eSystemOpenOutput);
   StdProcedure("CloseOutput", eSystemCloseOutput);
   StdProcedure("OpenInput",   eSystemOpenInput);
   StdProcedure("CloseInput",  eSystemCloseInput);
   StdProcedure("Write",       eSystemWrite);
   StdProcedure("WriteInt",    eSystemWriteInt);
   StdProcedure("WriteCard",   eSystemWriteCard);
   StdProcedure("WriteReal",   eSystemWriteReal);
   StdProcedure("WriteFixPt",  eSystemWriteFixPt);
   StdProcedure("WriteBool",   eSystemWriteBoolean);
   StdProcedure("WriteString", eSystemWriteString);
   StdProcedure("WriteLn",     eSystemWriteLn);
   StdProcedure("Read",        eSystemRead);
   StdProcedure("ReadInt",     eSystemReadInt);
   StdProcedure("ReadCard",    eSystemReadCard);
   StdProcedure("ReadReal",    eSystemReadReal);
   StdProcedure("ReadBool",    eSystemReadBoolean);
   StdProcedure("ReadString",  eSystemReadString);

   StdProcedure("argc",        eSystemArgc);
   StdProcedure("argv",        eSystemArgv);

   return PreDef_Objects;
}

/*-----------------------------------------------------------------------*/

/*
 * Global variables
 */
tObject    NoObject;	     /* default, error, or no object	   */
tType      NoType;	     /* default, error, or no type	   */

tObject    OpenVectorConfig; /* stores name of open vector configs */

tObjects   Predefs;	     /* predefined objects		   */

tObject    ModuleSYSTEM;     /* module SYSTEM			   */

tIdent     IdentALLOC,	     /* identifier ALLOCATE		   */
           IdentDEALLOC,     /* identifier DEALLOCATE		   */
           IdentSYSTEM;	     /* identifier of module SYSTEM	   */

/*-----------------------------------------------------------------------*/

/*
 * predefined types
 */

tType      TypeINTEGER,
           TypeCARDINAL,
           TypeREAL,
           TypeBOOLEAN,
           TypeCHAR,
           TypeBITSET,
           TypePROC,
           TypeWORD,
           TypeADDRESS,
           TypeIntCard,
           TypeNil,
           TypeString,
           TypeStringChar,
           TypeVoid;

/*-----------------------------------------------------------------------*/

/*****************************************************************************
 *  Function:	tObjects Symbols_Union(tObjects Objects1, tObjects Objects2)
 *
 *  Parameters:	Objects1,
 *		Objects2: the two lists of objects
 *      
 *  Result:	a new list of objects consisting of the union of the two
 *              given lists.
 *
 *  Description:
 *  ------------
 *  Unite the two given lists. If one of the two lists is empty, simply
 *  return the other list. Else insert a SymUnion node as tree node with the
 *  two lists as branches:
 *
 *   SymUnion ------> Objects1
 *       |
 *       +----------> Objects2
 *
 *  This does not involve a search of the end of one list as would be needed
 *  in a simple concatenation of the lists.
 *****************************************************************************/

tObjects Symbols_Union(tObjects Objects1, tObjects Objects2)
{
  if (Objects1 == NoObjects) {
    return Objects2;
  } else if (Objects2 == NoObjects) {
    return Objects1;
  } else {
    return mSymUnion(Objects1, Objects2);
  }
}

/*
 * generate a list with configurations
 * every configuration is only added once
 */
tConfigs Symbols_AddConfig(tConfigs Configs, tType Type)
{
  tObject Config;
  tConfigs TempConfigs;

  if (Type->Kind == kSymVector || Type->Kind == kSymConfiguration) {
    if (Type->Kind == kSymVector) {
      Config = Type->SymVector.Config;
    } else {
      Config = Type->SymConfiguration.Config;
    }
    TempConfigs = Configs;
    while (TempConfigs != NoConfigs &&
           TempConfigs->SymConfigs.Object != Config) {
      /* end of list not reached and configuration not found */
      TempConfigs = TempConfigs->SymConfigs.Next;
    }
    if (TempConfigs == NoConfigs) {
      /* end of list reached => config not found => add config */
      return mSymConfigs(Config, Configs);
    }
  }
  return Configs;
}

/*-----------------------------------------------------------------------*/

/*
 * procedures to extend object descriptions
 */

tIdent Symbols_DefineCIdent(tObject Object, tIdent CIdent)
{
  Object->SymObject.CIdent = CIdent;
  return CIdent;
}

tObject mSymConstSetValue(tObject Object, tValue Value)
{
  Object->SymConst.Value = Value;
  return Object;
}

tObject mSymModuleSetObjects(tObject Object, tObjects Objects)
{
  Object->SymModule.Objects = Objects;
  return Object;
}

tObject mSymModuleSetLocals(tObject Object, tObjects Locals)
{
  Object->SymModule.Locals = Locals;
  return Object;
}

tObject mSymProcSetLocals(tObject Object, tObjects Locals, BOOLEAN IsExported)
{
  Object->SymProcBody.IsExported = IsExported;
  Object->SymProcBody.Locals = Locals;
  return Object;
}

tObject mSymTypeDeclSetType(tObject Object, tType Type)
{
  Object->SymTypeDecl.Type = Type;
  return Object;
}

tObject mSymOpaqueSetType(tObject Object, tType Type)
{
  Object->SymOpaque.Type = Type;
  return Object;
}

tObject mSymConfigGroup(tObject Object, INDEX NewConfigGroup)
{
  Object->SymConfig.ConfigGroup = NewConfigGroup;
  return Object;
}

tObject mSymConfigTypeView(tObject Object, tType Type, tObject View)
{
  Object->SymConfig.Type = Type;
  Object->SymConfig.View = View;
  return Object;
}

tObject mSymConfigTypes(tObject Object, tTypes Types)
{
  Object->SymConfig.Indexes = Types;
  return Object;
}

tObject mSymConfigConnections(tObject Object, tObjects Connections)
{
  Object->SymConfig.Connections = Connections;
  return Object;
}

tObject mSymConfigBounds(tObject Object, tEnv Env)
{
  tTypes Types = Object->SymConfig.Indexes;
  unsigned long Rank;
  long Len;

  Rank = 0;
  Len = 1;
  while (Types != NoTypes) {
    Rank++;
    if (((tTree)(Types->SymTypes.Type->SymSubrange.LwbExpr))->Expr.IsP3Const
	&& ((tTree)(Types->SymTypes.Type->SymSubrange.UpbExpr))->Expr.IsP3Const)
    {
    	Values_ComputeConstant(Types->SymTypes.Type->SymSubrange.LwbExpr,
    	  Env, &(Types->SymTypes.Type->SymSubrange.Lwb));
    	Values_ComputeConstant(Types->SymTypes.Type->SymSubrange.UpbExpr,
    	  Env, &(Types->SymTypes.Type->SymSubrange.Upb));
    	Len *=
    	  (Values_ValueToInt(&(Types->SymTypes.Type->SymSubrange.Upb)) -
    	   Values_ValueToInt(&(Types->SymTypes.Type->SymSubrange.Lwb)) + 1);
    }
    else
    {
        Len = 0;
    }
    Types = Types->SymTypes.Next;
  }
  Object->SymConfig.Rank = Rank;
  Object->SymConfig.Len = Len;
  return Object;
}

tObject mSymConnectConfigs(tObject Object, tObject Source, tObject Dest)
{
  Object->SymConnect.SourceConfig = Source;
  Object->SymConnect.DestConfig = Dest;
  return Object;
}

tObjects mSymConnectElems(ADDRESS tree)
{
  tTree    Actuals = (tTree)tree;
  tObjects Objects = NoObjects;
  tIdent   Ident;

  while (Actuals->Kind != kNoActual) {
    if (Actuals->Kind == kActualExpr &&
        Actuals->ActualExpr.Expr->Kind == kQualid0) {
      Ident = Actuals->ActualExpr.Expr->Qualid0.Ident;
      Objects = mSymElem(Ident, FALSE,
        mSymVar(Ident, TypeIntCard, FALSE, 0, FALSE, TRUE, Tree_Integer),
        Objects);
      /* no renaming of implicit declared index variables */
      Objects->SymElem.Object->SymVar.CIdent = Ident;
    }
    Actuals = Actuals->Actual.Next;
  }
  return(Objects);
}

/*-----------------------------------------------------------------------*/

/*
 * procedures to extend type descriptions
 */

tType mSymOpaqueTypeFullType(tType Type, tType FullType)
{
  Type->SymOpaqueType.Type = FullType;
  return Type;
}

tType mSymVectorConfig(tType Type, tObject Config)
{
  Type->SymVector.Config = Config;
  return Type;
}

tType mSymVectorBaseType(tType Type, BOOLEAN IsOpen, tType BaseType)
{
  Type->SymVector.IsOpen = IsOpen;
  Type->SymVector.Type   = BaseType;
  return Type;
}

tType mSymArrayIndexElem(tType Type, BOOLEAN IsOpen, tType IndexType,
  tType ElemType)
{
  Type->SymArray.IsOpen    = IsOpen;
  Type->SymArray.IndexType = IndexType;
  Type->SymArray.ElemType  = ElemType;
  return Type;
}

tType mSymEnumerationLiteral(tType Type, tObjects EnumLiterals, INDEX MaxValue)
{
  Type->SymEnumeration.Objects  = EnumLiterals;
  Type->SymEnumeration.MaxValue = MaxValue;
  return Type;
}

tType mSymPointerTargetType(tType Type, tType TargetType)
{
  Type->SymPointer.Type = TargetType;
  return Type;
}

tType mSymProcTypeFormalsResult(tType Type, tTypes FormalTypes, tType ResultType)
{
  Type->SymProcType.Types = FormalTypes;
  Type->SymProcType.Type  = ResultType;
  return Type;
}

tType mSymRecordFields(tType Type, tObjects Fields)
{
  Type->SymRecord.Objects = Fields;
  return Type;
}

tType mSymSetBaseType(tType Type, tType BaseType)
{
  Type->SymSet.Type = BaseType;
  return Type;
}

tType mSymSubrangeBaseType(tType Type, tType BaseType)
{
   Type->SymSubrange.Type = BaseType;
   return Type;
}

tType mSymSubrangeBounds(tType Type, tValue Lwb, tValue Upb)
{
  if (Type->SymSubrange.Type == TypeVoid) {
    switch (Lwb.Kind) {
    case eCardinal  : Type->SymSubrange.Type = TypeCARDINAL; break;
    case eInteger   : Type->SymSubrange.Type = TypeINTEGER;  break;
    case eBoolean   : Type->SymSubrange.Type = TypeBOOLEAN;  break;
    case eChar      :
    case eStringChar: Type->SymSubrange.Type = TypeCHAR;     break;
    case eEnum      :
      Type->SymSubrange.Type = Symbols_GetType(Lwb.value.enumValue);
      break;
    default         : break;
    } /* endswitch */
  } /* endif */
  return Type;
}

BOOLEAN Symbols_NestedUseVar(tObject Object, USHORT Level)
{
  if (Object->Kind != kSymVar || Object->SymVar.Level == 0 ||
       Object->SymVar.Level == Level) {
    return FALSE;
  } else {
    Object->SymVar.NestedUse = TRUE;
    return TRUE;
  } /* endif */
}

/*-----------------------------------------------------------------------*/

tVoid mSymVoid1(tObject Object, tVoid Void)
{ return cVoid; }

tVoid mSymVoid2(tVoid Void1, tVoid Void2)
{ return cVoid; }

/*-----------------------------------------------------------------------*/

/*
 * procedures for identification
 */

tType Symbols_GroundType(tType Type)
{
  /* test for cycles like: TYPE t1 = t2; t2 = t1; */
  if (CheckCycleType(Type)) {
    return NoType;
  } else {
    return GroundTypeType(Type);
  } /* endif */
}



/*****************************************************************************
 *  Function:	INDEX Symbols_GetConfigGroup(tObject Object, INDEX ConfigGroupIn,
 *                               tObject View, tPosition Pos, tIdent *Ident) 
 *
 *  Parameters:	Object:        object description (gets modified)
 *		ConfigGroupIn: preliminary configuration group number
 * 		View:          pointer to target configuration
 *		Pos:           position of declaration
 *		Ident:	       pointer to the name of the configuration	
 *                            
 *  Result:	corrected configuration group number
 *
 *  Description:
 *  ------------
 *  Compute the correct configuration group number by scanning the chain of
 *  "View"-configurations and giving the number of the last configuration.
 *  It is also checked if the chain contains cycles. This would result in an
 *  endless loop inside the compiler. The check is done by marking the
 *  visited nodes. If a marked node is reached again, a cycle is found. In
 *  any case the marks are cleared again after the check.
 *  Remark: As a side effect, the View-entry of Object is set to point
 *  directly to the basic configuration. 
 *****************************************************************************/

INDEX Symbols_GetConfigGroup(tObject Object, INDEX ConfigGroupIn, tObject View, tPosition Pos, tIdent *Ident)
{
     INDEX NewConfigGroup;
     tObject current;
     BOOLEAN found;

     /* no View -> use the given number; */
     if (View == NoObject) return ConfigGroupIn;

     /* scan chain of SymConfigs */
     current = View;
     found = FALSE;
     do {
	  if (current->SymConfig.Visited) {
	       /* Error: cycle in configuration group */ 
	       NewConfigGroup = ConfigGroupIn;
	       ErrorMessageI( xxConfigCycle, xxError, Pos, xxIdent, Ident );
	       found = TRUE;
	  } else if (current->SymConfig.View==NoObject) {
	       /* last SymConfig in chain found: get ConfigGroup and set */
	       /* View directly to this last SymConfig */
	       NewConfigGroup = current->SymConfig.ConfigGroup;
	       found = TRUE;
	       /* now set View to point directly to the basic configuration */
	       Object->SymConfig.View = current;
	  } else {
	       /* mark current entry and skip to next SymConfig entry */
	       current->SymConfig.Visited = TRUE;
	       current = current->SymConfig.View;
	  }
     } while (!found);

     /* clear marks */
     current = View;
     while (current->SymConfig.Visited)
     {
	  current->SymConfig.Visited = FALSE;
	  current = current->SymConfig.View;
     }
     return NewConfigGroup;
}


/*****************************************************************************
 *  Function:	tObject Symbols_Identify(tIdent Ident , tEnv Env)
 *
 *  Parameters:	Ident:	identifier to search the object for
 * 		Env:	environment in which the object is searched
 *                            
 *  Result:		requested object
 *
 *  Description:
 *  ------------
 *  Look in the given environment Env for the identifier Ident and
 *  return the associated object. This is done by searching in the
 *  first object list (the objects declared in the current context).
 *  If it is not found there, the next object list (with objects
 *  declared in the surrounding context) is checked and so on. If the
 *  identifier is not found at all, NoObject is returned.
 *****************************************************************************/

tObject Symbols_Identify(tIdent Ident , tEnv Env)
{
  tSymbols Object;

  while (Env != NoEnv) {
    Object = Symbols_Identify2(Ident, Env->SymEnv.Objects);
    if (Object != NoObject) {
      return Object;
    } /* endif */
    Env = Env->SymEnv.HiddenEnv;
  } /* endwhile */
  return NoObject;
}

/*****************************************************************************
 *  Function:	tObject Symbols_Identify2(tIdent Ident, tObjects Objects)
 *
 *  Parameters:	Ident:	 identifier to look for
 *		Objects: list of objects to search in
 *      
 *  Result:		 requested object
 *
 *  Description:
 *  ------------
 *  Search the identifier Ident in the object list Objects. If it is
 *  not found, NoObject is returned.
 *  When a node is a joint of two lists (SymUnion), the first list is
 *  searched recursively and the second is scanned iteratively.
 *****************************************************************************/

tObject Symbols_Identify2(tIdent Ident, tObjects Objects)
{
  tSymbols Object;

  while (Objects != NoObjects) {
    if (Objects->Kind != kSymUnion) {
      if (Objects->SymElem.Ident == Ident) {
        return Objects->SymElem.Object;
      } /* endif */
      Objects = Objects->SymElem.Next;
    } else {
      Object = Symbols_Identify2(Ident, Objects->SymUnion.Objects1);
      if (Object != NoObject) {
        return Object;
      } /* endif */
      Objects = Objects->SymUnion.Objects2;
    } /* endif */
  } /* endwhile */
  return NoObject;
}

BOOLEAN Symbols_IsDeclared(tIdent Ident, tObjects Objects)
{ return(Symbols_Identify2(Ident, Objects) != NoObject); }


tIdent Symbols_LookUp(tObject M2Object, tCObjects Objects)
{
  while (Objects != NoCObjects) {
    if (Objects->SymCObjects.M2Object == M2Object) {
      return Objects->SymCObjects.CObject;
    } /* endif */
    Objects = Objects->SymCObjects.Next;
  } /* endwhile */
  return NoIdent;
}

extern BOOLEAN Symbols_IsRedeclared (tIdent Ident, tLocalIds LocalIds)
{
  while (LocalIds != NoLocalIds) {
    if (Ident == LocalIds->SymLocalIds.Ident) {
      return TRUE;
    }
    LocalIds = LocalIds->SymLocalIds.Next;
  }
  return FALSE;
}

BOOLEAN Symbols_ConnectionIsDeclared(tObject Object, tConnects Connects, tIdent *CIdent)
{
  while (Connects != NoConnects) {
    if (Object->SymConnect.Ident ==
        Connects->SymConnects.Object->SymConnect.Ident) {
      *CIdent = Connects->SymConnects.CIdent;
      return TRUE;
    }
    Connects = Connects->SymConnects.Next;
  }
  return FALSE;
}

/*-----------------------------------------------------------------------*/

/*
 * procedures for configurations and connections
 */

tObjects Symbols_GetConnections(tIdent Ident , tEnv Env)
{
  tObjects Connections = NoObjects;
  tObject  Object      = Symbols_Identify(Ident, Env);

  while (Env != NoEnv) {
    Connections = GetConnections(Object, Env->SymEnv.Objects, Connections);
    Env = Env->SymEnv.HiddenEnv;
  } /* endwhile */
  return Connections;
}

INDEX Symbols_GetConfigRank(tObject Object)
{
  tTypes actuals;
  INDEX count = 0;
  
  if (Object->Kind == kSymConfig) {
    actuals = Object->SymConfig.Indexes;
    while (actuals != NoTypes) {
      count++;
      actuals = actuals->SymTypes.Next;
    }
  }
  return count;
}

tType Symbols_GetReduceType(tType FktType, tType Type)
{
  tType BaseType, Param1Type, Param2Type;
  tTypes FktTypes;

  BaseType = Symbols_GetVectorBaseType(Type);
  if (BaseType != NoType) {
    if (BaseType->Kind == kSymSubrange) {
      /* Basetype of Subrange is also allowed */
      BaseType = BaseType->SymSubrange.Type;
    }
    if (FktType->Kind == kSymStdProcType) {
      switch (FktType->SymStdProcType.StdProc) {
      case eSystemSum:
      case eSystemProduct:
      case eSystemMax:
      case eSystemMin:
        if (BaseType == TypeCARDINAL || BaseType == TypeINTEGER ||
            BaseType == TypeIntCard || BaseType == TypeREAL) {
          return BaseType;
        };
        break;
      case eSystemAnd:
      case eSystemOr:
        if (BaseType->Kind == kSymBoolean) {
          return BaseType;
        }
        break;
      case eSystemFirst:
      case eSystemLast:
        return BaseType;
      default:
        return mSymError(xxNoReduceFunction, -1L, -1L);
      }
      return mSymError(xxArgumentTypeIncomp, 1L, (ULONG)Type);
    } else {
      if (FktType->Kind == kSymProcType) {
        FktTypes = FktType->SymProcType.Types;
        if (Symbols_Count(FktTypes) == 2) {
          (void) Symbols_Head(FktTypes, &Param1Type);
          FktTypes = Symbols_Tail(FktTypes);
          (void) Symbols_Head(FktTypes, &Param2Type);
          if (Symbols_GetVectorBaseType(Param1Type) == BaseType) {
            if (Symbols_GetVectorBaseType(Param2Type) == BaseType) {
              if (Symbols_GetVectorBaseType(FktType->SymProcType.Type) ==
                   BaseType) {
                return BaseType;
              } else {
                return mSymError(xxResultTypeIncomp, -1L, -1L);
              }
            } else {
              return mSymError(xxArgumentTypeIncomp, 2L, (ULONG)Param2Type);
            }
          } else {
            return mSymError(xxArgumentTypeIncomp, 1L, (ULONG)Param1Type);
          }
        } else {
          return mSymError(xxIllegalArgCount, -1L, -1L);
        }
      } else {
        return mSymError(xxNoReduceFunction, -1L, -1L);
      }
    }
  } else {
    return mSymError(xxArgumentTypeIncomp, 1L, (ULONG)Type);
  }
}

tType Symbols_GetMoveReceiveType(tType ExprType, tObject ConnectObj)
{
  if (ConnectObj->Kind == kSymConnect) {
    if (ExprType->Kind == kSymVector) {
      if (ExprType->SymVector.Config == ConnectObj->SymConnect.SourceConfig ||
          ExprType->SymVector.Config->SymConfig.ConfigGroup == 
          ConnectObj->SymConnect.SourceConfig->SymConfig.ConfigGroup ||
          (ExprType->SymVector.Config->SymConfig.IsRespecified &&
           ConnectObj->SymConnect.SourceConfig->SymConfig.IsGeneric)) {
        if (ConnectObj->SymConnect.SourceConfig ==
            ConnectObj->SymConnect.DestConfig ||
            ConnectObj->SymConnect.SourceConfig->SymConfig.ConfigGroup ==
            ConnectObj->SymConnect.DestConfig->SymConfig.ConfigGroup) {
          return ExprType;
        } else {
          return Symbols_ExtendToVectorType(
                   ConnectObj->SymConnect.DestConfig->SymConfig.Type,
                   ExprType->SymVector.Type);
        }
      } else {
        return mSymError(xxArgumentTypeIncomp, 1L, (ULONG) ExprType);
      }
    } else {
      return mSymError(xxVectorExpected, -1L, -1L);
    }
  } else {
    return mSymError(xxConnectionExpected, -1L, -1L);
  }
}

tType Symbols_GetProcType(tType Type)
{
  if (Type->Kind == kSymVector) {
    return Type->SymVector.Type;
  } else {
    return mSymError(xxVectorExpected, -1L, -1L);
  }
}

tType Symbols_GetDimType(tType Type, tTypes Types)
{
  tType ActualType;
  unsigned long Parameter = 1;

  if (Type->Kind == kSymVector) {
    if (Symbols_GetConfigRank(Type->SymVector.Config) ==
         Symbols_Count(Types)) {
      while (Types != NoTypes) {
        (void) Symbols_Head(Types, &ActualType);
        if (!Symbols_IsInt(ActualType)) {
          return mSymError(xxArgumentTypeIncomp, Parameter, (ULONG)ActualType);
        }
        Types = Symbols_Tail(Types);
        Parameter++;
      }
      return Type->SymVector.Type;
    } else {
      return mSymError(xxIllegalArgCount,-1L, -1L);
    }
    return Type->SymVector.Type;
  } else {
    return mSymError(xxVectorExpected, -1L, -1L);
  }
}

tType Symbols_ExtendToVectorType(tType Vector, tType Scalar)
{
  if (Vector->Kind == kSymVector) {
    return mSymVectorBaseType(mSymVectorConfig(
      mSymVector(Vector->SymVector.TypeObj), Vector->SymVector.Config) ,
      Vector->SymVector.IsOpen, Scalar);
  } else if (Vector->Kind == kSymConfiguration) {
    return mSymVectorBaseType(mSymVectorConfig(
      mSymVector(NoObject), Vector->SymConfiguration.Config),
      FALSE, Scalar);
  } else {
    return Scalar;
  }
}

tObjects Symbols_MakeVectorList(tObjects Objects, tType Type)
{
  tObject OldObject, NewObject;

  if (Objects != NoObjects) {
    switch (Objects->Kind) {
    case kSymElem:
      /* replaces all types of record fields with 'VECTOR Type OF Oldtype' */
      OldObject = Objects->SymElem.Object;
      NewObject = mSymField(
        OldObject->SymField.Ident,
        mSymVectorBaseType(mSymVectorConfig(
          mSymVector(Type->SymVector.TypeObj), Type->SymVector.Config) ,
          Type->SymVector.IsOpen, OldObject->SymField.Type),
        OldObject->SymField.Selectors);
      NewObject->SymField.CIdent = OldObject->SymField.CIdent;
      return mSymElem(
        Objects->SymElem.Ident,
        Objects->SymElem.IsPseudoObj,
        NewObject,
        Symbols_MakeVectorList(Objects->SymElem.Next, Type));
    case kSymUnion:
      return mSymUnion(
        Symbols_MakeVectorList(Objects->SymUnion.Objects1, Type),
        Symbols_MakeVectorList(Objects->SymUnion.Objects2, Type));
    }
  }
  return NoObjects;
}

/*-----------------------------------------------------------------------*/

/*
 * procedures to collect object descriptions
 */

tObjects Symbols_Filter(tObjects Objects)
{
  Result = NoObjects;
  Filter(Objects);
  return Result;
}

tCObjects Symbols_Pointers(BOOLEAN GlobalPtrs, tObjects Objects)
{
  Result1 = NoCObjects;
  Pointers(GlobalPtrs, Objects);
  return Result1;
}

void Symbols_OpenArrays(tObjects Objects, tCObjects *valueOpens, tCObjects *varOpens)
{
  ValueOpens  = NoCObjects;
  VAROpens    = NoCObjects;
  OpenArray(Objects);
  *valueOpens = ValueOpens;
  *varOpens   = VAROpens;
}

/*-----------------------------------------------------------------------*/

/*
 * procedures for 'safe' access to object and type descriptions
 */

tSelectors Symbols_GetSelectors(tObject Object)
{
  if (Object->Kind == kSymField) {
    return Object->SymField.Selectors;
  } else {
    return NoSelectors;
  } /* endif */
}

tObjects Symbols_GetExport1(tObject Object)
{
  if (Object->Kind == kSymModule) {
    return Object->SymModule.ExportList;
  } else {
    return NoObjects;
  } /* endif */
}

tObjects Symbols_GetExport2(tObject Object)
{
  if (Object->Kind == kSymModule) {
    return Object->SymModule.Objects;
  } else {
     return NoObjects;
  } /* endif */
}

/*****************************************************************************
 *  Function:	tObjects Symbols_GetObjects(tObject Object)
 *
 *  Parameters:	Object:	object whose object list is requested
 *      
 *  Result:		the requested object list
 *
 *  Description:
 *  ------------
 *  The object list of an object referenced by a qualified identifier
 *  is returned. This may either be a record, or a module. In case of
 *  a module the object list of this module is returned. In case of a
 *  record, the object list of the record is returned. If the object
 *  is a vector object, a new list is created containing only VECTOR
 *  components (refer to Symbols_MakeVectorList()).
 *  If the given object is neither module nor variable or record
 *  field, NoObjects is returned (probably indicating an error).
 *****************************************************************************/

tObjects Symbols_GetObjects(tObject Object)
{
  if (Object->Kind == kSymVar && Object->SymVar.Type->Kind == kSymRecord) {
    return Object->SymVar.Type->SymRecord.Objects;
  } else if (Object->Kind == kSymField &&
              Object->SymField.Type->Kind == kSymRecord) {
    return Object->SymField.Type->SymRecord.Objects;
  } else if (Object->Kind == kSymVar &&
              Object->SymVar.Type->Kind == kSymVector &&
              Object->SymVar.Type->SymVector.Type->Kind == kSymRecord) {
    return Symbols_MakeVectorList(
      Object->SymVar.Type->SymVector.Type->SymRecord.Objects,
      Object->SymVar.Type);
  } else if (Object->Kind == kSymField &&
              Object->SymField.Type->Kind == kSymVector &&
              Object->SymField.Type->SymVector.Type->Kind == kSymRecord) {
    return Symbols_MakeVectorList(
      Object->SymField.Type->SymVector.Type->SymRecord.Objects,
      Object->SymField.Type);
  } else if (Object->Kind == kSymModule) {
    return Object->SymModule.Objects;
  } else {
    return NoObjects;
  } /* endif */
}

tType Symbols_GetType(tObject Object)
{
  switch (Object->Kind) {
  case kSymConst      :
    return (tType)Values_TypeOfValue(&Object->SymConst.Value);
  case kSymEnumLiteral: return Object->SymEnumLiteral.Type;
  case kSymField      : return Object->SymField.Type;
  case kSymModule     : return TypeVoid;
  case kSymProcBody   : return Object->SymProcBody.Type;
  case kSymProcHead   : return Object->SymProcHead.Type;
  case kSymTypeDecl   : return Object->SymTypeDecl.Type;
  case kSymOpaque     : return Object->SymOpaque.Type;
  case kSymVar        : return Object->SymVar.Type;
  case kSymConfig     : return Object->SymConfig.Type;
  case kSymStdProc    : return Object->SymStdProc.Type;
  default             : return NoType;
  } /* endswitch */
}

tIdent Symbols_GetTypeIdent (tType Type)
{
  if (Symbols_IsType(Type, kSymConstructor)) {
    return(Type->SymConstructor.TypeObj->SymObject.Ident);
  } else {
    return NoIdent;
  } /* endif */
}

tType Symbols_GetVectorBaseType(tType Type)
{
  if (Type->Kind == kSymVector) {
    return Type->SymVector.Type;
  } else {
    return NoType;
  } /* endif */
}

tType Symbols_GetIndexType (tType Type)
{
  switch (Type->Kind) {
  case kSymVector     : return Symbols_GetIndexType(Type->SymVector.Type);
  case kSymArray      : return Type->SymArray.IndexType;
  default             : return NoType;
  }
}

tType Symbols_GetElemType(tType Type)
{
  if (Type->Kind == kSymArray) {
    return Type->SymArray.ElemType;
  } else if (Type->Kind == kSymVector &&
             Type->SymVector.Type->Kind == kSymArray) {
    /* generates a 'VECTOR Vectortype OF Array.ElemType' */
    return mSymVectorBaseType(mSymVectorConfig(
      mSymVector(Type->SymVector.TypeObj), Type->SymVector.Config) ,
      Type->SymVector.IsOpen, Type->SymVector.Type->SymArray.ElemType);
  } else {
    return NoType;
  } /* endif */
}

/* as long as other versions do not code this correctly

   VAR a: ARRAY [a..b] OF ARRAY [a..b] OF T;
       v: conf OF ARRAY [a..b] OF T;
   ...
   LOAD(v, a);

   the MPL-version does not do it either
   look for any use of 'Symbols_GetArraysElemType' in
   'code_MPL.puma' and 'parallaxis.cg' whenever other
   versions change their coding
*/

#if 0
int Symbols_GetArrayDims(tType Type)
{
  /* returns the number of array dimensions for 'Type' and
   * 0 if 'Type' is not an array
   */
  if (Type->Kind == kSymArray) {
    return 1 + Symbols_GetArrayDims(Type->SymArray.ElemType);
  } else {
    return 0;
  }
}

tType Symbols_GetArraysElemType(tType VType, tType Type)
{
  /* Gets the ElemType which should match the scalar type of the
   * vector. Used to get the ElemType for LOAD and STORE.
   */
  if (Type->Kind == kSymArray) {
    int VDims = Symbols_GetArrayDims(Symbols_GetVectorBaseType(VType));
    int ADims = Symbols_GetArrayDims(Type);

    if (ADims > VDims) {		/* correct use of LOAD & STORE */
      int DCount = 1;
      tType HType = Type->SymArray.ElemType;

      while (ADims-DCount > VDims) {
        DCount++;
        HType = HType->SymArray.ElemType;
      }
      return HType;
    } else {		/* incorrect use should */
      return Type;	/* result in semantic error */
    }
  } else {
    return NoType;
  }
}

#else
tType Symbols_GetArraysElemType(tType Type)
{
  /* Gets the ElemType which is NOT an array from arrays. Used to get the
   * ElemType for LOAD and STORE.
   */
  if (Type->Kind == kSymArray) {
    return Symbols_GetArraysElemType(Type->SymArray.ElemType);
  } else {
    return Type;
  }
}
#endif

tType Symbols_GetTargetType(tType Type)
{
  if (Type->Kind == kSymPointer) {
    return Type->SymPointer.Type;
  } else if (Type->Kind == kSymOpaqueType) {
    return Symbols_GetTargetType(Type->SymOpaqueType.Type);
  } else if (Type->Kind == kSymVector &&
             Type->SymVector.Type->Kind == kSymPointer) {
    /* generates a 'VECTOR Vectortype OF Pointer.Type' */
    return mSymVectorBaseType(mSymVectorConfig(
      mSymVector(Type->SymVector.TypeObj), Type->SymVector.Config) ,
      Type->SymVector.IsOpen, Type->SymVector.Type->SymPointer.Type);
  } else if (Type->Kind == kSymVector &&
             Type->SymVector.Type->Kind == kSymOpaqueType) {
    /* generates a 'VECTOR Vectortype OF TargetType' */
    return mSymVectorBaseType(mSymVectorConfig(
      mSymVector(Type->SymVector.TypeObj), Type->SymVector.Config) ,
      Type->SymVector.IsOpen,
      Symbols_GetTargetType(Type->SymVector.Type->SymOpaqueType.Type));
  } else {
    return NoType;
  } /* endif */
}

tType Symbols_GetSetBaseType(tType Type)
{
  if (Type->Kind == kSymSet) {
    return Type->SymSet.Type;
  } else {
    return NoType;
  } /* endif */
}

tType Symbols_GetSubrangeBaseType(tType Type)
{
  if (Type->Kind == kSymSubrange) {
    return Type->SymSubrange.Type;
  } else {
    return NoType;
  } /* endif */
}

tTypes Symbols_GetFormals(tType Type)
{
  if (Type->Kind == kSymProcType) {
    return Type->SymProcType.Types;
  } else if (Type->Kind == kSymStdProcType) {
    return NoTypes;
  } else if (Type->Kind == kSymVector &&
              Type->SymVector.Config->Kind == kSymConfig) {
    return Type->SymVector.Config->SymConfig.Indexes;
  } else {
    return NoTypes;
  } /* endif */
}

tType Symbols_GetResultType(tType Type)
{
  /* get the result type of a function without checks */
  if (Type->Kind == kSymProcType) {
/*####    fprintf(stderr, "Symbols_GetResultType: Type->SymProcType.Type=0x%x\n",Type->SymProcType.Type); */
    return Type->SymProcType.Type;
  } else {
    return NoType;
  } /* endif */
}
/*#####*/
/*returns FALSE if a Varpar is expected and the Formal is no lvalue */
/*For this purpose we use the attribute IsLval which is constructed */
/*in the module Lval of parallaxis.cg    ### Schwenzer              */

BOOLEAN Symbols_VarParMatchesLval(tType Formal, tType Actual)
{

  return ((!Formal->SymTypes.IsVAR)||
    (Formal->SymTypes.IsVAR && Actual->SymTypes.IsLval));
}
tType Symbols_GetResultType2(tType Type, tTypes Actuals)
{
  /* get the result type of a function call and checks the actuals */
  /* Problem: If the first actual is considered to be erroneous, the following */
  /* actuals wont be examined */
  tTypes Formals;
  tType Formal, Actual, OpenVectorType, GenericConfigType;
  unsigned long Parameter = 1;

  if (Type->Kind == kSymProcType) {
    Formals = Type->SymProcType.Types;
    OpenVectorType = NoType;
    GenericConfigType = NoType;
    if (Symbols_Count(Formals) == Symbols_Count(Actuals)) {
      while (Formals != NoTypes) {
        /* fetch the next actual and the corresponding next formal */
        (void) Symbols_Head(Formals, &Formal);
        (void) Symbols_Head(Actuals, &Actual);
        if (!Types_IsParameterCompatible(Formal, Actual)) {
          return mSymError(xxArgumentTypeIncomp, Parameter, (ULONG)Actual);
        }
	/*##### The formal parameter is a Var-Param, hence the actual must be an l-Value */
		if (!Symbols_VarParMatchesLval(Formals, Actuals))
	  return mSymError(xxVarParNotLval, Parameter, (ULONG)Actual);

        if (Formal->Kind == kSymVector &&
            Formal->SymVector.IsOpen) {
          /* formal type is open vectors */
          if (OpenVectorType == NoType) {
            /* no open vector parameter found up to now: make result type with
             * the actual's configuration and the result type's scalar
             */
            OpenVectorType = Symbols_ExtendToVectorType(Actual,
              Type->SymProcType.Type->SymVector.Type);
          } else if (!Types_VectorsCompatible(OpenVectorType, Actual)) {
            /* previous found open vector parameter and actual formal do not
             * match
             */
            return mSymError(xxWrongConfigParams,-1L, -1L);
          }
        }
	/*####	fprintf(stderr, "Symbols_getResultType2: Formal=0x%x\n",Formal);*/
        if (Formal->Kind == kSymVector &&
            Formal->SymVector.Config != NULL &&
            Formal->SymVector.Config->Kind == kSymConfig &&
            Formal->SymVector.Config->SymConfig.IsGeneric) {
          if (GenericConfigType == NoType) {
            GenericConfigType = Symbols_ExtendToVectorType(Actual,
              Type->SymProcType.Type->SymVector.Type);
          } else if (!Types_VectorsCompatible(GenericConfigType, Actual)) {
            return mSymError(xxWrongGenericParams,-1L, -1L);
          }
        }
        Formals = Symbols_Tail(Formals);
        Actuals = Symbols_Tail(Actuals);
        Parameter++;
      }
      if (Type->SymProcType.Type->Kind == kSymVector) {
        if (Type->SymProcType.Type->SymVector.IsOpen) {
          /* result is an open vector: return concrete vector */
          return OpenVectorType;
        } else if (Type->SymProcType.Type->SymVector.Config->SymConfig.IsGeneric) {
          /* result is a generic config: return concrete vector */
          return GenericConfigType;
        } else {
          return Type->SymProcType.Type;
        }
      } else {
        return Type->SymProcType.Type;
      }
    } else {
      return mSymError(xxIllegalArgCount, Symbols_Count(Actuals), -1L);
    }
    return Type->SymVector.Type;
  } else {
    return NoType;
  }
}

tType Symbols_GetResultType3(tType Type, tTypes Actuals)
{
  /* get the result type of type casts, record and array initialisators
   * and checks the actuals
   */
  tType Actual;
  tTypes ActualsPtr;

  switch (Type->Kind) {
  case kSymNoType       : return mSymError(xxNotDeclared, -1L, -1L);
  case kSymConfiguration:
    if (Symbols_Count(Actuals) == 1) {
      (void) Symbols_Head(Actuals, &Actual);
      return Symbols_ExtendToVectorType(Type, Actual);
    } else {
      return mSymError(xxIllegalArgCount, Symbols_Count(Actuals), -1L);
    }
  case kSymInteger  :
  case kSymCardinal :
  case kSymReal     :
  case kSymBoolean  :
  case kSymChar     :
  case kSymBitset   :
  case kSymWord     :
  case kSymAddress  :
    if (Symbols_Count(Actuals) == 1) {
      (void) Symbols_Head(Actuals, &Actual);
      if (Symbols_IsVectorType(Actual)) {
        return Symbols_ExtendToVectorType(Actual, Type);
      } else {
        return Type;
      }
    } else {
      return mSymError(xxIllegalArgCount, Symbols_Count(Actuals), -1L);
    }
  case kSymArray   :
  case kSymRecord  :
    ActualsPtr = Actuals;
    while (ActualsPtr != NoTypes) {
      (void) Symbols_Head(ActualsPtr, &Actual);
      if (Symbols_IsVectorType(Actual)) {
        return mSymError(xxVectorInInit, -1L, -1L);
      }
      ActualsPtr = Symbols_Tail(ActualsPtr);
    }
    return Type;
  default          : return mSymError(xxNoTypeCast, -1L, -1L);
  }
}

tObjects Symbols_GetFields(tType Type)
{
  if (Type->Kind == kSymRecord) {
    return Type->SymRecord.Objects;
  } else if (Type->Kind == kSymVector &&
              Type->SymVector.Type->Kind == kSymRecord) {
    /* copy the list with the record fields and make every member a 
     * 'VECTOR Type OF mytype'
     */
    return Symbols_MakeVectorList(Type->SymVector.Type->SymRecord.Objects,
      Type);
  } else {
    return NoObjects;
  } /* endif */
}

/*-----------------------------------------------------------------------*/

BOOLEAN Symbols_Head(tTypes Types, tType *Type)
{
  if (Types != NoTypes) {
    *Type = Types->SymTypes.Type;
    return Types->SymTypes.IsVAR;
  } else {
    *Type = NoType;
    return FALSE;
  } /* endif */
}

tTypes Symbols_Tail(tTypes Types)
{
  if (Types != NoTypes) {
    return Types->SymTypes.Next;
  } else {
    return NoTypes;
  } /* endif */
}

INDEX Symbols_Count(tTypes Types)
{
  INDEX count = 0;

  while (Types != NoTypes) {
    Types = Types->SymTypes.Next;
    count++;
  } /* endwhile */
  return count;
}

/*-----------------------------------------------------------------------*/

tObject Symbols_GetLiteral(tObjects Objects, USHORT Index)
{
  tObject Object;

  while (Objects != NoObjects) {
    Object = Objects->SymElem.Object;
    if (Object->SymEnumLiteral.Index == Index) {
      return Object;
    } /* endif */
    Objects = Objects->SymElem.Next;
  } /* endwhile */
  return NoObject;
}

/*-----------------------------------------------------------------------*/

/*
 * predicates on objects and types
 */

BOOLEAN Symbols_IsExported(tObject Object)
{ return Object->Kind == kSymProcBody && Object->SymProcBody.IsExported; }

BOOLEAN Symbols_IsOpenArray(tObject Object)
{ return (Object->Kind == kSymVar && Symbols_IsOpen(Object->SymVar.Type)); }

BOOLEAN Symbols_IsVAR(tObject Object)
{ return (Object->Kind == kSymVar && Object->SymVar.IsVAR); }

BOOLEAN Symbols_IsProcedure(tObject Object)
{ return Object->Kind == kSymProcBody || Object->Kind == kSymProcHead; }

BOOLEAN Symbols_IsOfType(tObject Object)
{ return Object->Kind == kSymTypeDecl || Object->Kind == kSymOpaque; }

BOOLEAN Symbols_IsForward(USHORT PosPointerTo, tObject TypeObj)
{
  if (TypeObj->Kind == kSymTypeDecl) {
    return(TypeObj->SymTypeDecl.TypePos > PosPointerTo);
  } else if (TypeObj->Kind == kSymOpaque) {
    return(TypeObj->SymOpaque.TypePos > PosPointerTo);
  } else {
    return FALSE;
  } /* endif */
}

BOOLEAN Symbols_IsBoolType(tType Type)
{
  switch (Type->Kind) {
  case kSymVector     : return Symbols_IsBoolType(Type->SymVector.Type);
  case kSymSubrange   : return Symbols_IsBoolType(Type->SymSubrange.Type);
  case kSymBoolean    : return TRUE;
  default             : return FALSE;
  }
}

BOOLEAN Symbols_IsIntType(tType Type)
{
  switch (Type->Kind) {
  case kSymVector     : return Symbols_IsIntType(Type->SymVector.Type);
  case kSymSubrange   : return Symbols_IsIntType(Type->SymSubrange.Type);
  case kSymCardinal   :
  case kSymInteger    :
  case kSymIntCard    : return TRUE;
  default             : return FALSE;
  }
}

BOOLEAN Symbols_IsInt(tType Type)
{
  switch (Type->Kind) {
  case kSymSubrange   : return Symbols_IsInt(Type->SymSubrange.Type);
  case kSymCardinal   :
  case kSymInteger    :
  case kSymIntCard    : return TRUE;
  default             : return FALSE;
  }
}

BOOLEAN Symbols_IsRealType(tType Type)
{
  switch (Type->Kind) {
  case kSymVector     : return Symbols_IsRealType(Type->SymVector.Type);
  case kSymReal       : return TRUE;
  default             : return FALSE;
  }
}


BOOLEAN Symbols_IsCharType(tType Type)
{
  switch (Type->Kind) {
  case kSymVector     : return Symbols_IsCharType(Type->SymVector.Type);
  case kSymSubrange   : return Symbols_IsCharType(Type->SymSubrange.Type);
  case kSymChar       :
  case kSymStringChar : return TRUE;
  default             : return FALSE;
  }
}


BOOLEAN Symbols_IsSetType(tType Type)
{
  switch (Type->Kind) {
  case kSymVector     : return Symbols_IsSetType(Type->SymVector.Type);
  case kSymSubrange   : return Symbols_IsSetType(Type->SymSubrange.Type);
  case kSymBitset     :
  case kSymSet        : return TRUE;
  default             : return FALSE;
  }
}


BOOLEAN Symbols_IsEnumType(tType Type)
{
  switch (Type->Kind) {
  case kSymVector     : return Symbols_IsEnumType(Type->SymVector.Type);
  case kSymEnumeration: return TRUE;
  default             : return FALSE;
  }
}


BOOLEAN Symbols_IsStringType(tType Type)
{
  switch (Type->Kind) {
  case kSymVector     : return Symbols_IsStringType(Type->SymVector.Type);
  case kSymArray      : return Type->SymArray.ElemType == TypeCHAR;
  case kSymString     :
  case kSymStringChar : return TRUE;
  default             : return FALSE;
  }
}


BOOLEAN Symbols_IsVectorType(tType Type)
{
  switch (Type->Kind) {
  case kSymConfiguration:
  case kSymVector     : return TRUE;
  default             : return FALSE;
  }
}

BOOLEAN Symbols_IsArrayType(tType Type)
{
  switch (Type->Kind) {
  case kSymVector     : return Symbols_IsArrayType(Type->SymVector.Type);
  case kSymArray      : return TRUE;
  default             : return FALSE;
  }
}

BOOLEAN Symbols_IsArrayOfInt(tType Type)
{
  switch (Type->Kind) {
  case kSymVector     : return Symbols_IsArrayOfInt(Type->SymVector.Type);
  case kSymArray      : return Symbols_IsInt(Type->SymArray.ElemType);
  default             : return FALSE;
  }
}

BOOLEAN Symbols_IsINTEGER(tType Type)
{
  switch (Type->Kind) {
  case kSymVector     : return Symbols_IsINTEGER(Type->SymVector.Type);
  case kSymInteger    : return TRUE;
  default             : return FALSE;
  }
}

BOOLEAN Symbols_IsCARDINAL(tType Type)
{
  switch (Type->Kind) {
  case kSymVector     : return Symbols_IsCARDINAL(Type->SymVector.Type);
  case kSymCardinal   : return TRUE;
  default             : return FALSE;
  }
}

BOOLEAN Symbols_IsOpen(tType Type)
{
  switch (Type->Kind) {
  case kSymVector     : if (Type->SymVector.Type != NULL) {
                          return Symbols_IsOpen(Type->SymVector.Type);
                        }
  case kSymArray      : return Type->SymArray.IsOpen;
  default             : return FALSE;
  }
}

BOOLEAN Symbols_IsFunctioncall(tType Type)
/* for function and procedure calls it is examined if it needs
 * a separate computation in parallel expressions
 */
{
  switch (Type->Kind) {
  case kSymStdProcType  :
    switch (Type->SymStdProcType.StdProc) {
    case eSystemDim     :
    case eSystemDim2Id  :
    case eSystemId      : return TRUE;
    default             : return FALSE;
    }
  case kSymProc         :
  case kSymProcType     : return TRUE; /* is a user defined procedure */
  case kSymInteger      :
  case kSymCardinal     :
  case kSymReal         :
  case kSymBoolean      :
  case kSymChar         :
  case kSymBitset       :
  case kSymWord         :
  case kSymAddress      : return FALSE; /* is a type cast */
  case kSymConfiguration: return FALSE; /* is a vector type cast */
  case kSymArray        : return TRUE;  /* array initialisation */
  case kSymRecord       : return TRUE;  /* record initialisation */
  default               : return TRUE;  /* error */
  }
}

BOOLEAN Symbols_IsRandom(tType Type)
{
  if (Type->Kind != kSymStdProcType) return FALSE;
  switch (Type->SymStdProcType.StdProc) {
    case eSystemCardRandom:
    case eSystemIntRandom :
    case eSystemRealRandom:
    case eSystemBoolRandom:
    case eSystemCharRandom: return TRUE;
    default: return FALSE;
  }
}
  

BOOLEAN Symbols_IsReduceFunction(tType Type)
{
  if (Type->Kind == kSymStdProcType) {
    switch (Type->SymStdProcType.StdProc) {
    case eSystemSum:
    case eSystemProduct:
    case eSystemMax:
    case eSystemMin:
    case eSystemAnd:
    case eSystemOr:
    case eSystemFirst:
    case eSystemLast:
      return TRUE;
    default:
      return FALSE;
    }
  } else {
    return Type->Kind == kSymProcType &&
           Symbols_Count(Type->SymProcType.Types) == 2;
  }
}

/*-----------------------------------------------------------------------*/

/*
 *  procedures for output during developement
 */

void Symbols_WriteEnv(FILE *f, tEnv Env)
{
  while (Env != NoEnv) {
    Symbols_WriteObjects(f, Env->SymEnv.Objects);
    fprintf(f, "/\n");
    Env = Env->SymEnv.HiddenEnv;
  }
}


void Symbols_WriteObjects(FILE *f, tObjects Objects)
{
  while (Objects != NoObjects) {
    if (Objects->Kind != kSymUnion) {
      WriteIdent(f, Objects->SymElem.Ident);
      fprintf(f, " ");
      Objects = Objects->SymElem.Next;
    } else {
      Symbols_WriteObjects(f, Objects->SymUnion.Objects1);
      Objects = Objects->SymUnion.Objects2;
    }
  }
}




static void yyExit () { Exit (1); }

void (* Symbols_Exit) () = yyExit;

# define yyBlockSize 20480

typedef struct yysBlock {
 char yyBlock [yyBlockSize];
 struct yysBlock * yySuccessor;
} yytBlock, * yytBlockPtr;

tSymbols SymbolsRoot;
unsigned long Symbols_HeapUsed = 0;

static yytBlockPtr yyBlockList	= (yytBlockPtr) NoSymbols;
char * Symbols_PoolFreePtr	= (char *) NoSymbols;
char * Symbols_PoolMaxPtr	= (char *) NoSymbols;
static unsigned short yyMaxSize	= 0;
unsigned short Symbols_NodeSize [56 + 1] = { 0,
 sizeof (ySymObject),
 sizeof (ySymNoObject),
 sizeof (ySymConst),
 sizeof (ySymEnumLiteral),
 sizeof (ySymModule),
 sizeof (ySymField),
 sizeof (ySymProcBody),
 sizeof (ySymProcHead),
 sizeof (ySymTypeDecl),
 sizeof (ySymOpaque),
 sizeof (ySymVar),
 sizeof (ySymConfig),
 sizeof (ySymConnect),
 sizeof (ySymStdProc),
 sizeof (ySymExpr),
 sizeof (ySymType),
 sizeof (ySymNoType),
 sizeof (ySymError),
 sizeof (ySymInteger),
 sizeof (ySymCardinal),
 sizeof (ySymReal),
 sizeof (ySymBoolean),
 sizeof (ySymChar),
 sizeof (ySymBitset),
 sizeof (ySymProc),
 sizeof (ySymWord),
 sizeof (ySymAddress),
 sizeof (ySymIntCard),
 sizeof (ySymNil),
 sizeof (ySymString),
 sizeof (ySymStringChar),
 sizeof (ySymVoid),
 sizeof (ySymStdProcType),
 sizeof (ySymQualident),
 sizeof (ySymConstructor),
 sizeof (ySymOpaqueType),
 sizeof (ySymConfiguration),
 sizeof (ySymVector),
 sizeof (ySymArray),
 sizeof (ySymEnumeration),
 sizeof (ySymPointer),
 sizeof (ySymProcType),
 sizeof (ySymRecord),
 sizeof (ySymSet),
 sizeof (ySymSubrange),
 sizeof (ySymObjects),
 sizeof (ySymElem),
 sizeof (ySymUnion),
 sizeof (ySymCObjects),
 sizeof (ySymTypes),
 sizeof (ySymEnv),
 sizeof (ySymSelectors),
 sizeof (ySymStringPar),
 sizeof (ySymConfigs),
 sizeof (ySymConnects),
 sizeof (ySymLocalIds),
};
char * Symbols_NodeName [56 + 1] = {
 "NoSymbols",
 "SymObject",
 "SymNoObject",
 "SymConst",
 "SymEnumLiteral",
 "SymModule",
 "SymField",
 "SymProcBody",
 "SymProcHead",
 "SymTypeDecl",
 "SymOpaque",
 "SymVar",
 "SymConfig",
 "SymConnect",
 "SymStdProc",
 "SymExpr",
 "SymType",
 "SymNoType",
 "SymError",
 "SymInteger",
 "SymCardinal",
 "SymReal",
 "SymBoolean",
 "SymChar",
 "SymBitset",
 "SymProc",
 "SymWord",
 "SymAddress",
 "SymIntCard",
 "SymNil",
 "SymString",
 "SymStringChar",
 "SymVoid",
 "SymStdProcType",
 "SymQualident",
 "SymConstructor",
 "SymOpaqueType",
 "SymConfiguration",
 "SymVector",
 "SymArray",
 "SymEnumeration",
 "SymPointer",
 "SymProcType",
 "SymRecord",
 "SymSet",
 "SymSubrange",
 "SymObjects",
 "SymElem",
 "SymUnion",
 "SymCObjects",
 "SymTypes",
 "SymEnv",
 "SymSelectors",
 "SymStringPar",
 "SymConfigs",
 "SymConnects",
 "SymLocalIds",
};
static Symbols_tKind yyTypeRange [56 + 1] = { 0,
 kSymExpr,
 kSymNoObject,
 kSymConst,
 kSymEnumLiteral,
 kSymModule,
 kSymField,
 kSymProcBody,
 kSymProcHead,
 kSymTypeDecl,
 kSymOpaque,
 kSymVar,
 kSymConfig,
 kSymConnect,
 kSymStdProc,
 kSymExpr,
 kSymSubrange,
 kSymNoType,
 kSymError,
 kSymInteger,
 kSymCardinal,
 kSymReal,
 kSymBoolean,
 kSymChar,
 kSymBitset,
 kSymProc,
 kSymWord,
 kSymAddress,
 kSymIntCard,
 kSymNil,
 kSymString,
 kSymStringChar,
 kSymVoid,
 kSymStdProcType,
 kSymQualident,
 kSymSubrange,
 kSymOpaqueType,
 kSymConfiguration,
 kSymVector,
 kSymArray,
 kSymEnumeration,
 kSymPointer,
 kSymProcType,
 kSymRecord,
 kSymSet,
 kSymSubrange,
 kSymUnion,
 kSymElem,
 kSymUnion,
 kSymCObjects,
 kSymTypes,
 kSymEnv,
 kSymSelectors,
 kSymStringPar,
 kSymConfigs,
 kSymConnects,
 kSymLocalIds,
};

tSymbols Symbols_Alloc ()
{
 register yytBlockPtr yyBlockPtr = yyBlockList;
 register int i;

 if (yyMaxSize == 0)
  for (i = 1; i <= 56; i ++) {
   Symbols_NodeSize [i] = (Symbols_NodeSize [i] + yyMaxAlign - 1) & yyAlignMasks [yyMaxAlign];
   yyMaxSize = Max (Symbols_NodeSize [i], yyMaxSize);
  }
 yyBlockList = (yytBlockPtr) Alloc (sizeof (yytBlock));
 yyBlockList->yySuccessor = yyBlockPtr;
 Symbols_PoolFreePtr = yyBlockList->yyBlock;
 Symbols_PoolMaxPtr = Symbols_PoolFreePtr + yyBlockSize - yyMaxSize + 1;
 Symbols_HeapUsed += yyBlockSize;
 return (tSymbols) Symbols_PoolFreePtr;
}

tSymbols MakeSymbols
# if defined __STDC__ | defined __cplusplus
 (Symbols_tKind yyKind)
# else
 (yyKind) Symbols_tKind yyKind;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [yyKind])
 yyt->Kind = yyKind;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

bool Symbols_IsType
# if defined __STDC__ | defined __cplusplus
 (register tSymbols yyt, register Symbols_tKind yyKind)
# else
 (yyt, yyKind) register tSymbols yyt; register Symbols_tKind yyKind;
# endif
{
 return yyt != NoSymbols && yyKind <= yyt->Kind && yyt->Kind <= yyTypeRange [yyKind];
}


tSymbols mSymObject
# if defined __STDC__ | defined __cplusplus
(tIdent pIdent)
# else
(pIdent)
tIdent pIdent;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymObject])
 yyt->Kind = kSymObject;
 yyt->yyHead.yyMark = 0;
 yyt->SymObject.Ident = pIdent;
 begintIdent(yyt->SymObject.CIdent)
 return yyt;
}

tSymbols mSymNoObject
# if defined __STDC__ | defined __cplusplus
(tIdent pIdent)
# else
(pIdent)
tIdent pIdent;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymNoObject])
 yyt->Kind = kSymNoObject;
 yyt->yyHead.yyMark = 0;
 yyt->SymNoObject.Ident = pIdent;
 begintIdent(yyt->SymNoObject.CIdent)
 return yyt;
}

tSymbols mSymConst
# if defined __STDC__ | defined __cplusplus
(tIdent pIdent)
# else
(pIdent)
tIdent pIdent;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymConst])
 yyt->Kind = kSymConst;
 yyt->yyHead.yyMark = 0;
 yyt->SymConst.Ident = pIdent;
 begintIdent(yyt->SymConst.CIdent)
 begintValue(yyt->SymConst.Value)
 return yyt;
}

tSymbols mSymEnumLiteral
# if defined __STDC__ | defined __cplusplus
(tIdent pIdent, tSymbols pType, INDEX pIndex)
# else
(pIdent, pType, pIndex)
tIdent pIdent;
tSymbols pType;
INDEX pIndex;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymEnumLiteral])
 yyt->Kind = kSymEnumLiteral;
 yyt->yyHead.yyMark = 0;
 yyt->SymEnumLiteral.Ident = pIdent;
 begintIdent(yyt->SymEnumLiteral.CIdent)
 yyt->SymEnumLiteral.Type = pType;
 yyt->SymEnumLiteral.Index = pIndex;
 return yyt;
}

tSymbols mSymModule
# if defined __STDC__ | defined __cplusplus
(tIdent pIdent, tSymbols pExportList)
# else
(pIdent, pExportList)
tIdent pIdent;
tSymbols pExportList;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymModule])
 yyt->Kind = kSymModule;
 yyt->yyHead.yyMark = 0;
 yyt->SymModule.Ident = pIdent;
 begintIdent(yyt->SymModule.CIdent)
 yyt->SymModule.ExportList = pExportList;
 begintSymbols(yyt->SymModule.Objects)
 begintSymbols(yyt->SymModule.Locals)
 return yyt;
}

tSymbols mSymField
# if defined __STDC__ | defined __cplusplus
(tIdent pIdent, tSymbols pType, tSymbols pSelectors)
# else
(pIdent, pType, pSelectors)
tIdent pIdent;
tSymbols pType;
tSymbols pSelectors;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymField])
 yyt->Kind = kSymField;
 yyt->yyHead.yyMark = 0;
 yyt->SymField.Ident = pIdent;
 begintIdent(yyt->SymField.CIdent)
 yyt->SymField.Type = pType;
 yyt->SymField.Selectors = pSelectors;
 return yyt;
}

tSymbols mSymProcBody
# if defined __STDC__ | defined __cplusplus
(tIdent pIdent, tSymbols pType)
# else
(pIdent, pType)
tIdent pIdent;
tSymbols pType;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymProcBody])
 yyt->Kind = kSymProcBody;
 yyt->yyHead.yyMark = 0;
 yyt->SymProcBody.Ident = pIdent;
 begintIdent(yyt->SymProcBody.CIdent)
 yyt->SymProcBody.Type = pType;
 beginBOOLEAN(yyt->SymProcBody.IsExported)
 begintSymbols(yyt->SymProcBody.Locals)
 return yyt;
}

tSymbols mSymProcHead
# if defined __STDC__ | defined __cplusplus
(tIdent pIdent, tSymbols pType)
# else
(pIdent, pType)
tIdent pIdent;
tSymbols pType;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymProcHead])
 yyt->Kind = kSymProcHead;
 yyt->yyHead.yyMark = 0;
 yyt->SymProcHead.Ident = pIdent;
 begintIdent(yyt->SymProcHead.CIdent)
 yyt->SymProcHead.Type = pType;
 return yyt;
}

tSymbols mSymTypeDecl
# if defined __STDC__ | defined __cplusplus
(tIdent pIdent, INDEX pTypePos)
# else
(pIdent, pTypePos)
tIdent pIdent;
INDEX pTypePos;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymTypeDecl])
 yyt->Kind = kSymTypeDecl;
 yyt->yyHead.yyMark = 0;
 yyt->SymTypeDecl.Ident = pIdent;
 begintIdent(yyt->SymTypeDecl.CIdent)
 yyt->SymTypeDecl.TypePos = pTypePos;
 begintSymbols(yyt->SymTypeDecl.Type)
 return yyt;
}

tSymbols mSymOpaque
# if defined __STDC__ | defined __cplusplus
(tIdent pIdent, INDEX pTypePos)
# else
(pIdent, pTypePos)
tIdent pIdent;
INDEX pTypePos;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymOpaque])
 yyt->Kind = kSymOpaque;
 yyt->yyHead.yyMark = 0;
 yyt->SymOpaque.Ident = pIdent;
 begintIdent(yyt->SymOpaque.CIdent)
 yyt->SymOpaque.TypePos = pTypePos;
 begintSymbols(yyt->SymOpaque.Type)
 return yyt;
}

tSymbols mSymVar
# if defined __STDC__ | defined __cplusplus
(tIdent pIdent, tSymbols pType, BOOLEAN pIsVAR, INDEX pLevel, BOOLEAN pNestedUse, BOOLEAN pIsDimIndex, ADDRESS pTypeTree)
# else
(pIdent, pType, pIsVAR, pLevel, pNestedUse, pIsDimIndex, pTypeTree)
tIdent pIdent;
tSymbols pType;
BOOLEAN pIsVAR;
INDEX pLevel;
BOOLEAN pNestedUse;
BOOLEAN pIsDimIndex;
ADDRESS pTypeTree;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymVar])
 yyt->Kind = kSymVar;
 yyt->yyHead.yyMark = 0;
 yyt->SymVar.Ident = pIdent;
 begintIdent(yyt->SymVar.CIdent)
 yyt->SymVar.Type = pType;
 yyt->SymVar.IsVAR = pIsVAR;
 yyt->SymVar.Level = pLevel;
 yyt->SymVar.NestedUse = pNestedUse;
 yyt->SymVar.IsDimIndex = pIsDimIndex;
 yyt->SymVar.TypeTree = pTypeTree;
 return yyt;
}

tSymbols mSymConfig
# if defined __STDC__ | defined __cplusplus
(tIdent pIdent, INDEX pConfigGroup, INDEX pLevel, BOOLEAN pNestedUse, BOOLEAN pIsGeneric, BOOLEAN pIsRespecified, BOOLEAN pVisited)
# else
(pIdent, pConfigGroup, pLevel, pNestedUse, pIsGeneric, pIsRespecified, pVisited)
tIdent pIdent;
INDEX pConfigGroup;
INDEX pLevel;
BOOLEAN pNestedUse;
BOOLEAN pIsGeneric;
BOOLEAN pIsRespecified;
BOOLEAN pVisited;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymConfig])
 yyt->Kind = kSymConfig;
 yyt->yyHead.yyMark = 0;
 yyt->SymConfig.Ident = pIdent;
 begintIdent(yyt->SymConfig.CIdent)
 yyt->SymConfig.ConfigGroup = pConfigGroup;
 yyt->SymConfig.Level = pLevel;
 yyt->SymConfig.NestedUse = pNestedUse;
 yyt->SymConfig.IsGeneric = pIsGeneric;
 yyt->SymConfig.IsRespecified = pIsRespecified;
 yyt->SymConfig.Visited = pVisited;
 begintSymbols(yyt->SymConfig.Type)
 begintSymbols(yyt->SymConfig.Indexes)
 begintSymbols(yyt->SymConfig.Connections)
 begintSymbols(yyt->SymConfig.View)
 beginULONG(yyt->SymConfig.Rank)
 beginLONG(yyt->SymConfig.Len)
 return yyt;
}

tSymbols mSymConnect
# if defined __STDC__ | defined __cplusplus
(tIdent pIdent, INDEX pLevel, BOOLEAN pNestedUse, BOOLEAN pIndexUsed)
# else
(pIdent, pLevel, pNestedUse, pIndexUsed)
tIdent pIdent;
INDEX pLevel;
BOOLEAN pNestedUse;
BOOLEAN pIndexUsed;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymConnect])
 yyt->Kind = kSymConnect;
 yyt->yyHead.yyMark = 0;
 yyt->SymConnect.Ident = pIdent;
 begintIdent(yyt->SymConnect.CIdent)
 yyt->SymConnect.Level = pLevel;
 yyt->SymConnect.NestedUse = pNestedUse;
 yyt->SymConnect.IndexUsed = pIndexUsed;
 begintSymbols(yyt->SymConnect.SourceConfig)
 begintSymbols(yyt->SymConnect.DestConfig)
 return yyt;
}

tSymbols mSymStdProc
# if defined __STDC__ | defined __cplusplus
(tIdent pIdent, INDEX pStdProc, tSymbols pType)
# else
(pIdent, pStdProc, pType)
tIdent pIdent;
INDEX pStdProc;
tSymbols pType;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymStdProc])
 yyt->Kind = kSymStdProc;
 yyt->yyHead.yyMark = 0;
 yyt->SymStdProc.Ident = pIdent;
 begintIdent(yyt->SymStdProc.CIdent)
 yyt->SymStdProc.StdProc = pStdProc;
 yyt->SymStdProc.Type = pType;
 return yyt;
}

tSymbols mSymExpr
# if defined __STDC__ | defined __cplusplus
(tIdent pIdent, ADDRESS pExpr)
# else
(pIdent, pExpr)
tIdent pIdent;
ADDRESS pExpr;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymExpr])
 yyt->Kind = kSymExpr;
 yyt->yyHead.yyMark = 0;
 yyt->SymExpr.Ident = pIdent;
 begintIdent(yyt->SymExpr.CIdent)
 yyt->SymExpr.Expr = pExpr;
 return yyt;
}

tSymbols mSymType
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymType])
 yyt->Kind = kSymType;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tSymbols mSymNoType
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymNoType])
 yyt->Kind = kSymNoType;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tSymbols mSymError
# if defined __STDC__ | defined __cplusplus
(INDEX pErrorType, LONG pInfo1, LONG pInfo2)
# else
(pErrorType, pInfo1, pInfo2)
INDEX pErrorType;
LONG pInfo1;
LONG pInfo2;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymError])
 yyt->Kind = kSymError;
 yyt->yyHead.yyMark = 0;
 yyt->SymError.ErrorType = pErrorType;
 yyt->SymError.Info1 = pInfo1;
 yyt->SymError.Info2 = pInfo2;
 return yyt;
}

tSymbols mSymInteger
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymInteger])
 yyt->Kind = kSymInteger;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tSymbols mSymCardinal
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymCardinal])
 yyt->Kind = kSymCardinal;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tSymbols mSymReal
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymReal])
 yyt->Kind = kSymReal;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tSymbols mSymBoolean
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymBoolean])
 yyt->Kind = kSymBoolean;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tSymbols mSymChar
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymChar])
 yyt->Kind = kSymChar;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tSymbols mSymBitset
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymBitset])
 yyt->Kind = kSymBitset;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tSymbols mSymProc
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymProc])
 yyt->Kind = kSymProc;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tSymbols mSymWord
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymWord])
 yyt->Kind = kSymWord;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tSymbols mSymAddress
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymAddress])
 yyt->Kind = kSymAddress;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tSymbols mSymIntCard
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymIntCard])
 yyt->Kind = kSymIntCard;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tSymbols mSymNil
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymNil])
 yyt->Kind = kSymNil;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tSymbols mSymString
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymString])
 yyt->Kind = kSymString;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tSymbols mSymStringChar
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymStringChar])
 yyt->Kind = kSymStringChar;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tSymbols mSymVoid
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymVoid])
 yyt->Kind = kSymVoid;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tSymbols mSymStdProcType
# if defined __STDC__ | defined __cplusplus
(INDEX pStdProc)
# else
(pStdProc)
INDEX pStdProc;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymStdProcType])
 yyt->Kind = kSymStdProcType;
 yyt->yyHead.yyMark = 0;
 yyt->SymStdProcType.StdProc = pStdProc;
 return yyt;
}

tSymbols mSymQualident
# if defined __STDC__ | defined __cplusplus
(tSymbols pObject)
# else
(pObject)
tSymbols pObject;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymQualident])
 yyt->Kind = kSymQualident;
 yyt->yyHead.yyMark = 0;
 yyt->SymQualident.Object = pObject;
 return yyt;
}

tSymbols mSymConstructor
# if defined __STDC__ | defined __cplusplus
(tSymbols pTypeObj)
# else
(pTypeObj)
tSymbols pTypeObj;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymConstructor])
 yyt->Kind = kSymConstructor;
 yyt->yyHead.yyMark = 0;
 yyt->SymConstructor.TypeObj = pTypeObj;
 return yyt;
}

tSymbols mSymOpaqueType
# if defined __STDC__ | defined __cplusplus
(tSymbols pTypeObj)
# else
(pTypeObj)
tSymbols pTypeObj;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymOpaqueType])
 yyt->Kind = kSymOpaqueType;
 yyt->yyHead.yyMark = 0;
 yyt->SymOpaqueType.TypeObj = pTypeObj;
 begintSymbols(yyt->SymOpaqueType.Type)
 return yyt;
}

tSymbols mSymConfiguration
# if defined __STDC__ | defined __cplusplus
(tSymbols pTypeObj, tSymbols pConfig)
# else
(pTypeObj, pConfig)
tSymbols pTypeObj;
tSymbols pConfig;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymConfiguration])
 yyt->Kind = kSymConfiguration;
 yyt->yyHead.yyMark = 0;
 yyt->SymConfiguration.TypeObj = pTypeObj;
 yyt->SymConfiguration.Config = pConfig;
 return yyt;
}

tSymbols mSymVector
# if defined __STDC__ | defined __cplusplus
(tSymbols pTypeObj)
# else
(pTypeObj)
tSymbols pTypeObj;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymVector])
 yyt->Kind = kSymVector;
 yyt->yyHead.yyMark = 0;
 yyt->SymVector.TypeObj = pTypeObj;
 begintSymbols(yyt->SymVector.Config)
 begintSymbols(yyt->SymVector.Type)
 beginBOOLEAN(yyt->SymVector.IsOpen)
 return yyt;
}

tSymbols mSymArray
# if defined __STDC__ | defined __cplusplus
(tSymbols pTypeObj, tIdent pStructId)
# else
(pTypeObj, pStructId)
tSymbols pTypeObj;
tIdent pStructId;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymArray])
 yyt->Kind = kSymArray;
 yyt->yyHead.yyMark = 0;
 yyt->SymArray.TypeObj = pTypeObj;
 yyt->SymArray.StructId = pStructId;
 begintSymbols(yyt->SymArray.IndexType)
 begintSymbols(yyt->SymArray.ElemType)
 beginBOOLEAN(yyt->SymArray.IsOpen)
 return yyt;
}

tSymbols mSymEnumeration
# if defined __STDC__ | defined __cplusplus
(tSymbols pTypeObj)
# else
(pTypeObj)
tSymbols pTypeObj;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymEnumeration])
 yyt->Kind = kSymEnumeration;
 yyt->yyHead.yyMark = 0;
 yyt->SymEnumeration.TypeObj = pTypeObj;
 beginINDEX(yyt->SymEnumeration.MaxValue)
 begintSymbols(yyt->SymEnumeration.Objects)
 return yyt;
}

tSymbols mSymPointer
# if defined __STDC__ | defined __cplusplus
(tSymbols pTypeObj)
# else
(pTypeObj)
tSymbols pTypeObj;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymPointer])
 yyt->Kind = kSymPointer;
 yyt->yyHead.yyMark = 0;
 yyt->SymPointer.TypeObj = pTypeObj;
 begintSymbols(yyt->SymPointer.Type)
 return yyt;
}

tSymbols mSymProcType
# if defined __STDC__ | defined __cplusplus
(tSymbols pTypeObj)
# else
(pTypeObj)
tSymbols pTypeObj;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymProcType])
 yyt->Kind = kSymProcType;
 yyt->yyHead.yyMark = 0;
 yyt->SymProcType.TypeObj = pTypeObj;
 begintSymbols(yyt->SymProcType.Types)
 begintSymbols(yyt->SymProcType.Type)
 return yyt;
}

tSymbols mSymRecord
# if defined __STDC__ | defined __cplusplus
(tSymbols pTypeObj, tIdent pStructId)
# else
(pTypeObj, pStructId)
tSymbols pTypeObj;
tIdent pStructId;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymRecord])
 yyt->Kind = kSymRecord;
 yyt->yyHead.yyMark = 0;
 yyt->SymRecord.TypeObj = pTypeObj;
 yyt->SymRecord.StructId = pStructId;
 begintSymbols(yyt->SymRecord.Objects)
 return yyt;
}

tSymbols mSymSet
# if defined __STDC__ | defined __cplusplus
(tSymbols pTypeObj)
# else
(pTypeObj)
tSymbols pTypeObj;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymSet])
 yyt->Kind = kSymSet;
 yyt->yyHead.yyMark = 0;
 yyt->SymSet.TypeObj = pTypeObj;
 begintSymbols(yyt->SymSet.Type)
 return yyt;
}

tSymbols mSymSubrange
# if defined __STDC__ | defined __cplusplus
(tSymbols pTypeObj, ADDRESS pLwbExpr, ADDRESS pUpbExpr)
# else
(pTypeObj, pLwbExpr, pUpbExpr)
tSymbols pTypeObj;
ADDRESS pLwbExpr;
ADDRESS pUpbExpr;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymSubrange])
 yyt->Kind = kSymSubrange;
 yyt->yyHead.yyMark = 0;
 yyt->SymSubrange.TypeObj = pTypeObj;
 yyt->SymSubrange.LwbExpr = pLwbExpr;
 yyt->SymSubrange.UpbExpr = pUpbExpr;
 begintSymbols(yyt->SymSubrange.Type)
 begintValue(yyt->SymSubrange.Lwb)
 begintValue(yyt->SymSubrange.Upb)
 return yyt;
}

tSymbols mSymObjects
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymObjects])
 yyt->Kind = kSymObjects;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tSymbols mSymElem
# if defined __STDC__ | defined __cplusplus
(tIdent pIdent, BOOLEAN pIsPseudoObj, tSymbols pObject, tSymbols pNext)
# else
(pIdent, pIsPseudoObj, pObject, pNext)
tIdent pIdent;
BOOLEAN pIsPseudoObj;
tSymbols pObject;
tSymbols pNext;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymElem])
 yyt->Kind = kSymElem;
 yyt->yyHead.yyMark = 0;
 yyt->SymElem.Ident = pIdent;
 yyt->SymElem.IsPseudoObj = pIsPseudoObj;
 yyt->SymElem.Object = pObject;
 yyt->SymElem.Next = pNext;
 return yyt;
}

tSymbols mSymUnion
# if defined __STDC__ | defined __cplusplus
(tSymbols pObjects1, tSymbols pObjects2)
# else
(pObjects1, pObjects2)
tSymbols pObjects1;
tSymbols pObjects2;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymUnion])
 yyt->Kind = kSymUnion;
 yyt->yyHead.yyMark = 0;
 yyt->SymUnion.Objects1 = pObjects1;
 yyt->SymUnion.Objects2 = pObjects2;
 return yyt;
}

tSymbols mSymCObjects
# if defined __STDC__ | defined __cplusplus
(tObject pM2Object, tSymbols pNext)
# else
(pM2Object, pNext)
tObject pM2Object;
tSymbols pNext;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymCObjects])
 yyt->Kind = kSymCObjects;
 yyt->yyHead.yyMark = 0;
 yyt->SymCObjects.M2Object = pM2Object;
 yyt->SymCObjects.Next = pNext;
 begintIdent(yyt->SymCObjects.CObject)
 return yyt;
}

tSymbols mSymTypes
# if defined __STDC__ | defined __cplusplus
(BOOLEAN pIsVAR, BOOLEAN pIsLval, tSymbols pType, tSymbols pNext)
# else
(pIsVAR, pIsLval, pType, pNext)
BOOLEAN pIsVAR;
BOOLEAN pIsLval;
tSymbols pType;
tSymbols pNext;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymTypes])
 yyt->Kind = kSymTypes;
 yyt->yyHead.yyMark = 0;
 yyt->SymTypes.IsVAR = pIsVAR;
 yyt->SymTypes.IsLval = pIsLval;
 yyt->SymTypes.Type = pType;
 yyt->SymTypes.Next = pNext;
 return yyt;
}

tSymbols mSymEnv
# if defined __STDC__ | defined __cplusplus
(tSymbols pObjects, tSymbols pHiddenEnv)
# else
(pObjects, pHiddenEnv)
tSymbols pObjects;
tSymbols pHiddenEnv;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymEnv])
 yyt->Kind = kSymEnv;
 yyt->yyHead.yyMark = 0;
 yyt->SymEnv.Objects = pObjects;
 yyt->SymEnv.HiddenEnv = pHiddenEnv;
 return yyt;
}

tSymbols mSymSelectors
# if defined __STDC__ | defined __cplusplus
(tIdent pSelector, tSymbols pNext)
# else
(pSelector, pNext)
tIdent pSelector;
tSymbols pNext;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymSelectors])
 yyt->Kind = kSymSelectors;
 yyt->yyHead.yyMark = 0;
 yyt->SymSelectors.Selector = pSelector;
 yyt->SymSelectors.Next = pNext;
 return yyt;
}

tSymbols mSymStringPar
# if defined __STDC__ | defined __cplusplus
(tIdent pCString, tSymbols pFormalType, ADDRESS pM2String, tSymbols pNext)
# else
(pCString, pFormalType, pM2String, pNext)
tIdent pCString;
tSymbols pFormalType;
ADDRESS pM2String;
tSymbols pNext;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymStringPar])
 yyt->Kind = kSymStringPar;
 yyt->yyHead.yyMark = 0;
 yyt->SymStringPar.CString = pCString;
 yyt->SymStringPar.FormalType = pFormalType;
 yyt->SymStringPar.M2String = pM2String;
 yyt->SymStringPar.Next = pNext;
 return yyt;
}

tSymbols mSymConfigs
# if defined __STDC__ | defined __cplusplus
(tSymbols pObject, tSymbols pNext)
# else
(pObject, pNext)
tSymbols pObject;
tSymbols pNext;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymConfigs])
 yyt->Kind = kSymConfigs;
 yyt->yyHead.yyMark = 0;
 yyt->SymConfigs.Object = pObject;
 yyt->SymConfigs.Next = pNext;
 begintIdent(yyt->SymConfigs.ActiveIdent)
 begintIdent(yyt->SymConfigs.ElseIdent)
 return yyt;
}

tSymbols mSymConnects
# if defined __STDC__ | defined __cplusplus
(tSymbols pObject, tSymbols pNext, tIdent pCIdent)
# else
(pObject, pNext, pCIdent)
tSymbols pObject;
tSymbols pNext;
tIdent pCIdent;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymConnects])
 yyt->Kind = kSymConnects;
 yyt->yyHead.yyMark = 0;
 yyt->SymConnects.Object = pObject;
 yyt->SymConnects.Next = pNext;
 yyt->SymConnects.CIdent = pCIdent;
 return yyt;
}

tSymbols mSymLocalIds
# if defined __STDC__ | defined __cplusplus
(tIdent pIdent, tSymbols pNext)
# else
(pIdent, pNext)
tIdent pIdent;
tSymbols pNext;
# endif
{
 register tSymbols yyt;
 yyALLOC (yyt, Symbols_NodeSize [kSymLocalIds])
 yyt->Kind = kSymLocalIds;
 yyt->yyHead.yyMark = 0;
 yyt->SymLocalIds.Ident = pIdent;
 yyt->SymLocalIds.Next = pNext;
 return yyt;
}

typedef tSymbols * yyPtrtTree;

static FILE * yyf;

static void yyMark
# if defined __STDC__ | defined __cplusplus
 (register tSymbols yyt)
# else
 (yyt) register tSymbols yyt;
# endif
{
 for (;;) {
  if (yyt == NoSymbols || ++ yyt->yyHead.yyMark > 1) return;

  switch (yyt->Kind) {
case kSymEnumLiteral:
yyt = yyt->SymEnumLiteral.Type; break;
case kSymModule:
yyMark (yyt->SymModule.ExportList);
yyMark (yyt->SymModule.Objects);
yyt = yyt->SymModule.Locals; break;
case kSymField:
yyMark (yyt->SymField.Type);
yyt = yyt->SymField.Selectors; break;
case kSymProcBody:
yyMark (yyt->SymProcBody.Type);
yyt = yyt->SymProcBody.Locals; break;
case kSymProcHead:
yyt = yyt->SymProcHead.Type; break;
case kSymTypeDecl:
yyt = yyt->SymTypeDecl.Type; break;
case kSymOpaque:
yyt = yyt->SymOpaque.Type; break;
case kSymVar:
yyt = yyt->SymVar.Type; break;
case kSymConfig:
yyMark (yyt->SymConfig.Type);
yyMark (yyt->SymConfig.Indexes);
yyMark (yyt->SymConfig.Connections);
yyt = yyt->SymConfig.View; break;
case kSymConnect:
yyMark (yyt->SymConnect.SourceConfig);
yyt = yyt->SymConnect.DestConfig; break;
case kSymStdProc:
yyt = yyt->SymStdProc.Type; break;
case kSymQualident:
yyt = yyt->SymQualident.Object; break;
case kSymConstructor:
yyt = yyt->SymConstructor.TypeObj; break;
case kSymOpaqueType:
yyMark (yyt->SymOpaqueType.TypeObj);
yyt = yyt->SymOpaqueType.Type; break;
case kSymConfiguration:
yyMark (yyt->SymConfiguration.TypeObj);
yyt = yyt->SymConfiguration.Config; break;
case kSymVector:
yyMark (yyt->SymVector.TypeObj);
yyMark (yyt->SymVector.Config);
yyt = yyt->SymVector.Type; break;
case kSymArray:
yyMark (yyt->SymArray.TypeObj);
yyMark (yyt->SymArray.IndexType);
yyt = yyt->SymArray.ElemType; break;
case kSymEnumeration:
yyMark (yyt->SymEnumeration.TypeObj);
yyt = yyt->SymEnumeration.Objects; break;
case kSymPointer:
yyMark (yyt->SymPointer.TypeObj);
yyt = yyt->SymPointer.Type; break;
case kSymProcType:
yyMark (yyt->SymProcType.TypeObj);
yyMark (yyt->SymProcType.Types);
yyt = yyt->SymProcType.Type; break;
case kSymRecord:
yyMark (yyt->SymRecord.TypeObj);
yyt = yyt->SymRecord.Objects; break;
case kSymSet:
yyMark (yyt->SymSet.TypeObj);
yyt = yyt->SymSet.Type; break;
case kSymSubrange:
yyMark (yyt->SymSubrange.TypeObj);
yyt = yyt->SymSubrange.Type; break;
case kSymElem:
yyMark (yyt->SymElem.Object);
yyt = yyt->SymElem.Next; break;
case kSymUnion:
yyMark (yyt->SymUnion.Objects1);
yyt = yyt->SymUnion.Objects2; break;
case kSymCObjects:
yyt = yyt->SymCObjects.Next; break;
case kSymTypes:
yyMark (yyt->SymTypes.Type);
yyt = yyt->SymTypes.Next; break;
case kSymEnv:
yyMark (yyt->SymEnv.Objects);
yyt = yyt->SymEnv.HiddenEnv; break;
case kSymSelectors:
yyt = yyt->SymSelectors.Next; break;
case kSymStringPar:
yyMark (yyt->SymStringPar.FormalType);
yyt = yyt->SymStringPar.Next; break;
case kSymConfigs:
yyMark (yyt->SymConfigs.Object);
yyt = yyt->SymConfigs.Next; break;
case kSymConnects:
yyMark (yyt->SymConnects.Object);
yyt = yyt->SymConnects.Next; break;
case kSymLocalIds:
yyt = yyt->SymLocalIds.Next; break;
  default: return;
  }
 }
}

# define yyInitTreeStoreSize 32
# define yyMapToTree(yyLabel) yyTreeStorePtr [yyLabel]

static unsigned long yyTreeStoreSize = yyInitTreeStoreSize;
static tSymbols yyTreeStore [yyInitTreeStoreSize];
static tSymbols * yyTreeStorePtr = yyTreeStore;
static int yyLabelCount;
static short yyRecursionLevel = 0;

static Symbols_tLabel yyMapToLabel
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 register int yyi;
 for (yyi = 1; yyi <= yyLabelCount; yyi ++) if (yyTreeStorePtr [yyi] == yyt) return yyi;
 if (++ yyLabelCount == yyTreeStoreSize)
  ExtendArray ((char * *) & yyTreeStorePtr, & yyTreeStoreSize, sizeof (tSymbols));
 yyTreeStorePtr [yyLabelCount] = yyt;
 return yyLabelCount;
}

static void yyWriteSymbols ();

static void yyWriteNl () { (void) putc ('\n', yyf); }

static void yyWriteSelector
# if defined __STDC__ | defined __cplusplus
 (char * yys)
# else
 (yys) char * yys;
# endif
{
 register int yyi = 16 - strlen (yys);
 (void) fputs (yys, yyf);
 while (yyi -- > 0) (void) putc (' ', yyf);
 (void) fputs (" = ", yyf);
}

static void yyWriteHex
# if defined __STDC__ | defined __cplusplus
 (unsigned char * yyx, int yysize)
# else
 (yyx, yysize) unsigned char * yyx; int yysize;
# endif
{ register int yyi; for (yyi = 0; yyi < yysize; yyi ++) (void) fprintf (yyf, "%02x ", yyx [yyi]); }

static void yyWriteAdr
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 if (yyt == NoSymbols) (void) fputs ("NoSymbols", yyf);
 else yyWriteHex ((unsigned char *) & yyt, sizeof (yyt));
 yyWriteNl ();
}

static void yWriteNodeSymObject
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yyWriteSelector ("Ident"); writetIdent (yyt->SymObject.Ident) yyWriteNl ();
 yyWriteSelector ("CIdent"); writetIdent (yyt->SymObject.CIdent) yyWriteNl ();
}

static void yWriteNodeSymNoObject
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yWriteNodeSymObject (yyt); 
}

static void yWriteNodeSymConst
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yWriteNodeSymObject (yyt); 
 yyWriteSelector ("Value"); writetValue (yyt->SymConst.Value) yyWriteNl ();
}

static void yWriteNodeSymEnumLiteral
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yWriteNodeSymObject (yyt); 
 yyWriteSelector ("Type"); yyWriteAdr (yyt->SymEnumLiteral.Type);
 yyWriteSelector ("Index"); writeINDEX (yyt->SymEnumLiteral.Index) yyWriteNl ();
}

static void yWriteNodeSymModule
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yWriteNodeSymObject (yyt); 
 yyWriteSelector ("ExportList"); yyWriteAdr (yyt->SymModule.ExportList);
 yyWriteSelector ("Objects"); yyWriteAdr (yyt->SymModule.Objects);
 yyWriteSelector ("Locals"); yyWriteAdr (yyt->SymModule.Locals);
}

static void yWriteNodeSymField
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yWriteNodeSymObject (yyt); 
 yyWriteSelector ("Type"); yyWriteAdr (yyt->SymField.Type);
 yyWriteSelector ("Selectors"); yyWriteAdr (yyt->SymField.Selectors);
}

static void yWriteNodeSymProcBody
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yWriteNodeSymObject (yyt); 
 yyWriteSelector ("Type"); yyWriteAdr (yyt->SymProcBody.Type);
 yyWriteSelector ("IsExported"); writeBOOLEAN (yyt->SymProcBody.IsExported) yyWriteNl ();
 yyWriteSelector ("Locals"); yyWriteAdr (yyt->SymProcBody.Locals);
}

static void yWriteNodeSymProcHead
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yWriteNodeSymObject (yyt); 
 yyWriteSelector ("Type"); yyWriteAdr (yyt->SymProcHead.Type);
}

static void yWriteNodeSymTypeDecl
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yWriteNodeSymObject (yyt); 
 yyWriteSelector ("TypePos"); writeINDEX (yyt->SymTypeDecl.TypePos) yyWriteNl ();
 yyWriteSelector ("Type"); yyWriteAdr (yyt->SymTypeDecl.Type);
}

static void yWriteNodeSymOpaque
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yWriteNodeSymObject (yyt); 
 yyWriteSelector ("TypePos"); writeINDEX (yyt->SymOpaque.TypePos) yyWriteNl ();
 yyWriteSelector ("Type"); yyWriteAdr (yyt->SymOpaque.Type);
}

static void yWriteNodeSymVar
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yWriteNodeSymObject (yyt); 
 yyWriteSelector ("Type"); yyWriteAdr (yyt->SymVar.Type);
 yyWriteSelector ("IsVAR"); writeBOOLEAN (yyt->SymVar.IsVAR) yyWriteNl ();
 yyWriteSelector ("Level"); writeINDEX (yyt->SymVar.Level) yyWriteNl ();
 yyWriteSelector ("NestedUse"); writeBOOLEAN (yyt->SymVar.NestedUse) yyWriteNl ();
 yyWriteSelector ("IsDimIndex"); writeBOOLEAN (yyt->SymVar.IsDimIndex) yyWriteNl ();
 yyWriteSelector ("TypeTree"); writeADDRESS (yyt->SymVar.TypeTree) yyWriteNl ();
}

static void yWriteNodeSymConfig
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yWriteNodeSymObject (yyt); 
 yyWriteSelector ("ConfigGroup"); writeINDEX (yyt->SymConfig.ConfigGroup) yyWriteNl ();
 yyWriteSelector ("Level"); writeINDEX (yyt->SymConfig.Level) yyWriteNl ();
 yyWriteSelector ("NestedUse"); writeBOOLEAN (yyt->SymConfig.NestedUse) yyWriteNl ();
 yyWriteSelector ("IsGeneric"); writeBOOLEAN (yyt->SymConfig.IsGeneric) yyWriteNl ();
 yyWriteSelector ("IsRespecified"); writeBOOLEAN (yyt->SymConfig.IsRespecified) yyWriteNl ();
 yyWriteSelector ("Visited"); writeBOOLEAN (yyt->SymConfig.Visited) yyWriteNl ();
 yyWriteSelector ("Type"); yyWriteAdr (yyt->SymConfig.Type);
 yyWriteSelector ("Indexes"); yyWriteAdr (yyt->SymConfig.Indexes);
 yyWriteSelector ("Connections"); yyWriteAdr (yyt->SymConfig.Connections);
 yyWriteSelector ("View"); yyWriteAdr (yyt->SymConfig.View);
 yyWriteSelector ("Rank"); writeULONG (yyt->SymConfig.Rank) yyWriteNl ();
 yyWriteSelector ("Len"); writeLONG (yyt->SymConfig.Len) yyWriteNl ();
}

static void yWriteNodeSymConnect
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yWriteNodeSymObject (yyt); 
 yyWriteSelector ("Level"); writeINDEX (yyt->SymConnect.Level) yyWriteNl ();
 yyWriteSelector ("NestedUse"); writeBOOLEAN (yyt->SymConnect.NestedUse) yyWriteNl ();
 yyWriteSelector ("IndexUsed"); writeBOOLEAN (yyt->SymConnect.IndexUsed) yyWriteNl ();
 yyWriteSelector ("SourceConfig"); yyWriteAdr (yyt->SymConnect.SourceConfig);
 yyWriteSelector ("DestConfig"); yyWriteAdr (yyt->SymConnect.DestConfig);
}

static void yWriteNodeSymStdProc
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yWriteNodeSymObject (yyt); 
 yyWriteSelector ("StdProc"); writeINDEX (yyt->SymStdProc.StdProc) yyWriteNl ();
 yyWriteSelector ("Type"); yyWriteAdr (yyt->SymStdProc.Type);
}

static void yWriteNodeSymExpr
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yWriteNodeSymObject (yyt); 
 yyWriteSelector ("Expr"); writeADDRESS (yyt->SymExpr.Expr) yyWriteNl ();
}

static void yWriteNodeSymError
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yyWriteSelector ("ErrorType"); writeINDEX (yyt->SymError.ErrorType) yyWriteNl ();
 yyWriteSelector ("Info1"); writeLONG (yyt->SymError.Info1) yyWriteNl ();
 yyWriteSelector ("Info2"); writeLONG (yyt->SymError.Info2) yyWriteNl ();
}

static void yWriteNodeSymStdProcType
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yyWriteSelector ("StdProc"); writeINDEX (yyt->SymStdProcType.StdProc) yyWriteNl ();
}

static void yWriteNodeSymQualident
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yyWriteSelector ("Object"); yyWriteAdr (yyt->SymQualident.Object);
}

static void yWriteNodeSymConstructor
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yyWriteSelector ("TypeObj"); yyWriteAdr (yyt->SymConstructor.TypeObj);
}

static void yWriteNodeSymOpaqueType
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yWriteNodeSymConstructor (yyt); 
 yyWriteSelector ("Type"); yyWriteAdr (yyt->SymOpaqueType.Type);
}

static void yWriteNodeSymConfiguration
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yWriteNodeSymConstructor (yyt); 
 yyWriteSelector ("Config"); yyWriteAdr (yyt->SymConfiguration.Config);
}

static void yWriteNodeSymVector
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yWriteNodeSymConstructor (yyt); 
 yyWriteSelector ("Config"); yyWriteAdr (yyt->SymVector.Config);
 yyWriteSelector ("Type"); yyWriteAdr (yyt->SymVector.Type);
 yyWriteSelector ("IsOpen"); writeBOOLEAN (yyt->SymVector.IsOpen) yyWriteNl ();
}

static void yWriteNodeSymArray
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yWriteNodeSymConstructor (yyt); 
 yyWriteSelector ("StructId"); writetIdent (yyt->SymArray.StructId) yyWriteNl ();
 yyWriteSelector ("IndexType"); yyWriteAdr (yyt->SymArray.IndexType);
 yyWriteSelector ("ElemType"); yyWriteAdr (yyt->SymArray.ElemType);
 yyWriteSelector ("IsOpen"); writeBOOLEAN (yyt->SymArray.IsOpen) yyWriteNl ();
}

static void yWriteNodeSymEnumeration
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yWriteNodeSymConstructor (yyt); 
 yyWriteSelector ("MaxValue"); writeINDEX (yyt->SymEnumeration.MaxValue) yyWriteNl ();
 yyWriteSelector ("Objects"); yyWriteAdr (yyt->SymEnumeration.Objects);
}

static void yWriteNodeSymPointer
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yWriteNodeSymConstructor (yyt); 
 yyWriteSelector ("Type"); yyWriteAdr (yyt->SymPointer.Type);
}

static void yWriteNodeSymProcType
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yWriteNodeSymConstructor (yyt); 
 yyWriteSelector ("Types"); yyWriteAdr (yyt->SymProcType.Types);
 yyWriteSelector ("Type"); yyWriteAdr (yyt->SymProcType.Type);
}

static void yWriteNodeSymRecord
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yWriteNodeSymConstructor (yyt); 
 yyWriteSelector ("StructId"); writetIdent (yyt->SymRecord.StructId) yyWriteNl ();
 yyWriteSelector ("Objects"); yyWriteAdr (yyt->SymRecord.Objects);
}

static void yWriteNodeSymSet
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yWriteNodeSymConstructor (yyt); 
 yyWriteSelector ("Type"); yyWriteAdr (yyt->SymSet.Type);
}

static void yWriteNodeSymSubrange
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yWriteNodeSymConstructor (yyt); 
 yyWriteSelector ("LwbExpr"); writeADDRESS (yyt->SymSubrange.LwbExpr) yyWriteNl ();
 yyWriteSelector ("UpbExpr"); writeADDRESS (yyt->SymSubrange.UpbExpr) yyWriteNl ();
 yyWriteSelector ("Type"); yyWriteAdr (yyt->SymSubrange.Type);
 yyWriteSelector ("Lwb"); writetValue (yyt->SymSubrange.Lwb) yyWriteNl ();
 yyWriteSelector ("Upb"); writetValue (yyt->SymSubrange.Upb) yyWriteNl ();
}

static void yWriteNodeSymElem
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yyWriteSelector ("Ident"); writetIdent (yyt->SymElem.Ident) yyWriteNl ();
 yyWriteSelector ("IsPseudoObj"); writeBOOLEAN (yyt->SymElem.IsPseudoObj) yyWriteNl ();
 yyWriteSelector ("Object"); yyWriteAdr (yyt->SymElem.Object);
 yyWriteSelector ("Next"); yyWriteAdr (yyt->SymElem.Next);
}

static void yWriteNodeSymUnion
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yyWriteSelector ("Objects1"); yyWriteAdr (yyt->SymUnion.Objects1);
 yyWriteSelector ("Objects2"); yyWriteAdr (yyt->SymUnion.Objects2);
}

static void yWriteNodeSymCObjects
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yyWriteSelector ("M2Object"); writetObject (yyt->SymCObjects.M2Object) yyWriteNl ();
 yyWriteSelector ("Next"); yyWriteAdr (yyt->SymCObjects.Next);
 yyWriteSelector ("CObject"); writetIdent (yyt->SymCObjects.CObject) yyWriteNl ();
}

static void yWriteNodeSymTypes
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yyWriteSelector ("IsVAR"); writeBOOLEAN (yyt->SymTypes.IsVAR) yyWriteNl ();
 yyWriteSelector ("IsLval"); writeBOOLEAN (yyt->SymTypes.IsLval) yyWriteNl ();
 yyWriteSelector ("Type"); yyWriteAdr (yyt->SymTypes.Type);
 yyWriteSelector ("Next"); yyWriteAdr (yyt->SymTypes.Next);
}

static void yWriteNodeSymEnv
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yyWriteSelector ("Objects"); yyWriteAdr (yyt->SymEnv.Objects);
 yyWriteSelector ("HiddenEnv"); yyWriteAdr (yyt->SymEnv.HiddenEnv);
}

static void yWriteNodeSymSelectors
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yyWriteSelector ("Selector"); writetIdent (yyt->SymSelectors.Selector) yyWriteNl ();
 yyWriteSelector ("Next"); yyWriteAdr (yyt->SymSelectors.Next);
}

static void yWriteNodeSymStringPar
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yyWriteSelector ("CString"); writetIdent (yyt->SymStringPar.CString) yyWriteNl ();
 yyWriteSelector ("FormalType"); yyWriteAdr (yyt->SymStringPar.FormalType);
 yyWriteSelector ("M2String"); writeADDRESS (yyt->SymStringPar.M2String) yyWriteNl ();
 yyWriteSelector ("Next"); yyWriteAdr (yyt->SymStringPar.Next);
}

static void yWriteNodeSymConfigs
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yyWriteSelector ("Object"); yyWriteAdr (yyt->SymConfigs.Object);
 yyWriteSelector ("Next"); yyWriteAdr (yyt->SymConfigs.Next);
 yyWriteSelector ("ActiveIdent"); writetIdent (yyt->SymConfigs.ActiveIdent) yyWriteNl ();
 yyWriteSelector ("ElseIdent"); writetIdent (yyt->SymConfigs.ElseIdent) yyWriteNl ();
}

static void yWriteNodeSymConnects
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yyWriteSelector ("Object"); yyWriteAdr (yyt->SymConnects.Object);
 yyWriteSelector ("Next"); yyWriteAdr (yyt->SymConnects.Next);
 yyWriteSelector ("CIdent"); writetIdent (yyt->SymConnects.CIdent) yyWriteNl ();
}

static void yWriteNodeSymLocalIds
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yyWriteSelector ("Ident"); writetIdent (yyt->SymLocalIds.Ident) yyWriteNl ();
 yyWriteSelector ("Next"); yyWriteAdr (yyt->SymLocalIds.Next);
}

void WriteSymbolsNode
# if defined __STDC__ | defined __cplusplus
 (FILE * yyyf, tSymbols yyt)
# else
 (yyyf, yyt) FILE * yyyf; tSymbols yyt;
# endif
{
 yyf = yyyf;
 if (yyt == NoSymbols) { (void) fputs ("NoSymbols\n", yyf); return; }

 switch (yyt->Kind) {
case kSymObject: (void) fputs (Symbols_NodeName [kSymObject], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymObject (yyt); break;
case kSymNoObject: (void) fputs (Symbols_NodeName [kSymNoObject], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymNoObject (yyt); break;
case kSymConst: (void) fputs (Symbols_NodeName [kSymConst], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymConst (yyt); break;
case kSymEnumLiteral: (void) fputs (Symbols_NodeName [kSymEnumLiteral], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymEnumLiteral (yyt); break;
case kSymModule: (void) fputs (Symbols_NodeName [kSymModule], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymModule (yyt); break;
case kSymField: (void) fputs (Symbols_NodeName [kSymField], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymField (yyt); break;
case kSymProcBody: (void) fputs (Symbols_NodeName [kSymProcBody], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymProcBody (yyt); break;
case kSymProcHead: (void) fputs (Symbols_NodeName [kSymProcHead], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymProcHead (yyt); break;
case kSymTypeDecl: (void) fputs (Symbols_NodeName [kSymTypeDecl], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymTypeDecl (yyt); break;
case kSymOpaque: (void) fputs (Symbols_NodeName [kSymOpaque], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymOpaque (yyt); break;
case kSymVar: (void) fputs (Symbols_NodeName [kSymVar], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymVar (yyt); break;
case kSymConfig: (void) fputs (Symbols_NodeName [kSymConfig], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymConfig (yyt); break;
case kSymConnect: (void) fputs (Symbols_NodeName [kSymConnect], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymConnect (yyt); break;
case kSymStdProc: (void) fputs (Symbols_NodeName [kSymStdProc], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymStdProc (yyt); break;
case kSymExpr: (void) fputs (Symbols_NodeName [kSymExpr], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymExpr (yyt); break;
case kSymType: (void) fputs (Symbols_NodeName [kSymType], yyf); (void) fputc ('\n', yyf);
 break;
case kSymNoType: (void) fputs (Symbols_NodeName [kSymNoType], yyf); (void) fputc ('\n', yyf);
 break;
case kSymError: (void) fputs (Symbols_NodeName [kSymError], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymError (yyt); break;
case kSymInteger: (void) fputs (Symbols_NodeName [kSymInteger], yyf); (void) fputc ('\n', yyf);
 break;
case kSymCardinal: (void) fputs (Symbols_NodeName [kSymCardinal], yyf); (void) fputc ('\n', yyf);
 break;
case kSymReal: (void) fputs (Symbols_NodeName [kSymReal], yyf); (void) fputc ('\n', yyf);
 break;
case kSymBoolean: (void) fputs (Symbols_NodeName [kSymBoolean], yyf); (void) fputc ('\n', yyf);
 break;
case kSymChar: (void) fputs (Symbols_NodeName [kSymChar], yyf); (void) fputc ('\n', yyf);
 break;
case kSymBitset: (void) fputs (Symbols_NodeName [kSymBitset], yyf); (void) fputc ('\n', yyf);
 break;
case kSymProc: (void) fputs (Symbols_NodeName [kSymProc], yyf); (void) fputc ('\n', yyf);
 break;
case kSymWord: (void) fputs (Symbols_NodeName [kSymWord], yyf); (void) fputc ('\n', yyf);
 break;
case kSymAddress: (void) fputs (Symbols_NodeName [kSymAddress], yyf); (void) fputc ('\n', yyf);
 break;
case kSymIntCard: (void) fputs (Symbols_NodeName [kSymIntCard], yyf); (void) fputc ('\n', yyf);
 break;
case kSymNil: (void) fputs (Symbols_NodeName [kSymNil], yyf); (void) fputc ('\n', yyf);
 break;
case kSymString: (void) fputs (Symbols_NodeName [kSymString], yyf); (void) fputc ('\n', yyf);
 break;
case kSymStringChar: (void) fputs (Symbols_NodeName [kSymStringChar], yyf); (void) fputc ('\n', yyf);
 break;
case kSymVoid: (void) fputs (Symbols_NodeName [kSymVoid], yyf); (void) fputc ('\n', yyf);
 break;
case kSymStdProcType: (void) fputs (Symbols_NodeName [kSymStdProcType], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymStdProcType (yyt); break;
case kSymQualident: (void) fputs (Symbols_NodeName [kSymQualident], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymQualident (yyt); break;
case kSymConstructor: (void) fputs (Symbols_NodeName [kSymConstructor], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymConstructor (yyt); break;
case kSymOpaqueType: (void) fputs (Symbols_NodeName [kSymOpaqueType], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymOpaqueType (yyt); break;
case kSymConfiguration: (void) fputs (Symbols_NodeName [kSymConfiguration], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymConfiguration (yyt); break;
case kSymVector: (void) fputs (Symbols_NodeName [kSymVector], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymVector (yyt); break;
case kSymArray: (void) fputs (Symbols_NodeName [kSymArray], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymArray (yyt); break;
case kSymEnumeration: (void) fputs (Symbols_NodeName [kSymEnumeration], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymEnumeration (yyt); break;
case kSymPointer: (void) fputs (Symbols_NodeName [kSymPointer], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymPointer (yyt); break;
case kSymProcType: (void) fputs (Symbols_NodeName [kSymProcType], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymProcType (yyt); break;
case kSymRecord: (void) fputs (Symbols_NodeName [kSymRecord], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymRecord (yyt); break;
case kSymSet: (void) fputs (Symbols_NodeName [kSymSet], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymSet (yyt); break;
case kSymSubrange: (void) fputs (Symbols_NodeName [kSymSubrange], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymSubrange (yyt); break;
case kSymObjects: (void) fputs (Symbols_NodeName [kSymObjects], yyf); (void) fputc ('\n', yyf);
 break;
case kSymElem: (void) fputs (Symbols_NodeName [kSymElem], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymElem (yyt); break;
case kSymUnion: (void) fputs (Symbols_NodeName [kSymUnion], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymUnion (yyt); break;
case kSymCObjects: (void) fputs (Symbols_NodeName [kSymCObjects], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymCObjects (yyt); break;
case kSymTypes: (void) fputs (Symbols_NodeName [kSymTypes], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymTypes (yyt); break;
case kSymEnv: (void) fputs (Symbols_NodeName [kSymEnv], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymEnv (yyt); break;
case kSymSelectors: (void) fputs (Symbols_NodeName [kSymSelectors], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymSelectors (yyt); break;
case kSymStringPar: (void) fputs (Symbols_NodeName [kSymStringPar], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymStringPar (yyt); break;
case kSymConfigs: (void) fputs (Symbols_NodeName [kSymConfigs], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymConfigs (yyt); break;
case kSymConnects: (void) fputs (Symbols_NodeName [kSymConnects], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymConnects (yyt); break;
case kSymLocalIds: (void) fputs (Symbols_NodeName [kSymLocalIds], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSymLocalIds (yyt); break;
 default: ;
 }
}

static short yyIndentLevel;

void WriteSymbols
# if defined __STDC__ | defined __cplusplus
 (FILE * yyyf, tSymbols yyt)
# else
 (yyyf, yyt) FILE * yyyf; tSymbols yyt;
# endif
{
 short yySaveLevel = yyIndentLevel;
 yyf = yyyf;
 if (yyRecursionLevel ++ == 0) yyLabelCount = 0;
 yyMark (yyt);
 yyIndentLevel = 0;
 yyWriteSymbols (yyt);
 yyIndentLevel = yySaveLevel;
 yyRecursionLevel --;
}

static void yyIndentSelector
# if defined __STDC__ | defined __cplusplus
 (char * yys)
# else
 (yys) char * yys;
# endif
{
 register int yyi;
 for (yyi = 1; yyi <= yyIndentLevel; yyi ++) (void) putc (' ', yyf);
 yyWriteSelector (yys);
}

static void yyIndentSelectorTree
# if defined __STDC__ | defined __cplusplus
 (char * yys, tSymbols yyt)
# else
 (yys, yyt) char * yys; tSymbols yyt;
# endif
{ yyIndentSelector (yys); writetSymbols (yyt) }

static void yWriteSymObject
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymObject], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Ident"); writetIdent (yyt->SymObject.Ident) yyWriteNl ();
 yyIndentSelector ("CIdent"); writetIdent (yyt->SymObject.CIdent) yyWriteNl ();
}

static void yWriteSymNoObject
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymNoObject], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Ident"); writetIdent (yyt->SymNoObject.Ident) yyWriteNl ();
 yyIndentSelector ("CIdent"); writetIdent (yyt->SymNoObject.CIdent) yyWriteNl ();
}

static void yWriteSymConst
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymConst], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Ident"); writetIdent (yyt->SymConst.Ident) yyWriteNl ();
 yyIndentSelector ("CIdent"); writetIdent (yyt->SymConst.CIdent) yyWriteNl ();
 yyIndentSelector ("Value"); writetValue (yyt->SymConst.Value) yyWriteNl ();
}

static void yWriteSymEnumLiteral
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymEnumLiteral], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Ident"); writetIdent (yyt->SymEnumLiteral.Ident) yyWriteNl ();
 yyIndentSelector ("CIdent"); writetIdent (yyt->SymEnumLiteral.CIdent) yyWriteNl ();
 yyIndentSelector ("Index"); writeINDEX (yyt->SymEnumLiteral.Index) yyWriteNl ();
}

static void yWriteSymModule
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymModule], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Ident"); writetIdent (yyt->SymModule.Ident) yyWriteNl ();
 yyIndentSelector ("CIdent"); writetIdent (yyt->SymModule.CIdent) yyWriteNl ();
 yyIndentSelectorTree ("ExportList", yyt->SymModule.ExportList);
 yyIndentSelectorTree ("Objects", yyt->SymModule.Objects);
}

static void yWriteSymField
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymField], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Ident"); writetIdent (yyt->SymField.Ident) yyWriteNl ();
 yyIndentSelector ("CIdent"); writetIdent (yyt->SymField.CIdent) yyWriteNl ();
 yyIndentSelectorTree ("Type", yyt->SymField.Type);
}

static void yWriteSymProcBody
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymProcBody], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Ident"); writetIdent (yyt->SymProcBody.Ident) yyWriteNl ();
 yyIndentSelector ("CIdent"); writetIdent (yyt->SymProcBody.CIdent) yyWriteNl ();
 yyIndentSelectorTree ("Type", yyt->SymProcBody.Type);
 yyIndentSelector ("IsExported"); writeBOOLEAN (yyt->SymProcBody.IsExported) yyWriteNl ();
}

static void yWriteSymProcHead
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymProcHead], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Ident"); writetIdent (yyt->SymProcHead.Ident) yyWriteNl ();
 yyIndentSelector ("CIdent"); writetIdent (yyt->SymProcHead.CIdent) yyWriteNl ();
}

static void yWriteSymTypeDecl
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymTypeDecl], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Ident"); writetIdent (yyt->SymTypeDecl.Ident) yyWriteNl ();
 yyIndentSelector ("CIdent"); writetIdent (yyt->SymTypeDecl.CIdent) yyWriteNl ();
 yyIndentSelector ("TypePos"); writeINDEX (yyt->SymTypeDecl.TypePos) yyWriteNl ();
}

static void yWriteSymOpaque
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymOpaque], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Ident"); writetIdent (yyt->SymOpaque.Ident) yyWriteNl ();
 yyIndentSelector ("CIdent"); writetIdent (yyt->SymOpaque.CIdent) yyWriteNl ();
 yyIndentSelector ("TypePos"); writeINDEX (yyt->SymOpaque.TypePos) yyWriteNl ();
}

static void yWriteSymVar
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymVar], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Ident"); writetIdent (yyt->SymVar.Ident) yyWriteNl ();
 yyIndentSelector ("CIdent"); writetIdent (yyt->SymVar.CIdent) yyWriteNl ();
 yyIndentSelector ("IsVAR"); writeBOOLEAN (yyt->SymVar.IsVAR) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->SymVar.Level) yyWriteNl ();
 yyIndentSelector ("NestedUse"); writeBOOLEAN (yyt->SymVar.NestedUse) yyWriteNl ();
 yyIndentSelector ("IsDimIndex"); writeBOOLEAN (yyt->SymVar.IsDimIndex) yyWriteNl ();
 yyIndentSelector ("TypeTree"); writeADDRESS (yyt->SymVar.TypeTree) yyWriteNl ();
}

static void yWriteSymConfig
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymConfig], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Ident"); writetIdent (yyt->SymConfig.Ident) yyWriteNl ();
 yyIndentSelector ("CIdent"); writetIdent (yyt->SymConfig.CIdent) yyWriteNl ();
 yyIndentSelector ("ConfigGroup"); writeINDEX (yyt->SymConfig.ConfigGroup) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->SymConfig.Level) yyWriteNl ();
 yyIndentSelector ("NestedUse"); writeBOOLEAN (yyt->SymConfig.NestedUse) yyWriteNl ();
 yyIndentSelector ("IsGeneric"); writeBOOLEAN (yyt->SymConfig.IsGeneric) yyWriteNl ();
 yyIndentSelector ("IsRespecified"); writeBOOLEAN (yyt->SymConfig.IsRespecified) yyWriteNl ();
 yyIndentSelector ("Visited"); writeBOOLEAN (yyt->SymConfig.Visited) yyWriteNl ();
 yyIndentSelectorTree ("Type", yyt->SymConfig.Type);
 yyIndentSelectorTree ("Indexes", yyt->SymConfig.Indexes);
 yyIndentSelectorTree ("Connections", yyt->SymConfig.Connections);
 yyIndentSelector ("Rank"); writeULONG (yyt->SymConfig.Rank) yyWriteNl ();
 yyIndentSelector ("Len"); writeLONG (yyt->SymConfig.Len) yyWriteNl ();
}

static void yWriteSymConnect
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymConnect], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Ident"); writetIdent (yyt->SymConnect.Ident) yyWriteNl ();
 yyIndentSelector ("CIdent"); writetIdent (yyt->SymConnect.CIdent) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->SymConnect.Level) yyWriteNl ();
 yyIndentSelector ("NestedUse"); writeBOOLEAN (yyt->SymConnect.NestedUse) yyWriteNl ();
 yyIndentSelector ("IndexUsed"); writeBOOLEAN (yyt->SymConnect.IndexUsed) yyWriteNl ();
 yyIndentSelectorTree ("SourceConfig", yyt->SymConnect.SourceConfig);
}

static void yWriteSymStdProc
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymStdProc], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Ident"); writetIdent (yyt->SymStdProc.Ident) yyWriteNl ();
 yyIndentSelector ("CIdent"); writetIdent (yyt->SymStdProc.CIdent) yyWriteNl ();
 yyIndentSelector ("StdProc"); writeINDEX (yyt->SymStdProc.StdProc) yyWriteNl ();
}

static void yWriteSymExpr
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymExpr], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Ident"); writetIdent (yyt->SymExpr.Ident) yyWriteNl ();
 yyIndentSelector ("CIdent"); writetIdent (yyt->SymExpr.CIdent) yyWriteNl ();
 yyIndentSelector ("Expr"); writeADDRESS (yyt->SymExpr.Expr) yyWriteNl ();
}

static void yWriteSymError
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymError], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("ErrorType"); writeINDEX (yyt->SymError.ErrorType) yyWriteNl ();
 yyIndentSelector ("Info1"); writeLONG (yyt->SymError.Info1) yyWriteNl ();
 yyIndentSelector ("Info2"); writeLONG (yyt->SymError.Info2) yyWriteNl ();
}

static void yWriteSymStdProcType
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymStdProcType], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("StdProc"); writeINDEX (yyt->SymStdProcType.StdProc) yyWriteNl ();
}

static void yWriteSymQualident
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymQualident], yyf); (void) fputc ('\n', yyf);
}

static void yWriteSymConstructor
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymConstructor], yyf); (void) fputc ('\n', yyf);
}

static void yWriteSymOpaqueType
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymOpaqueType], yyf); (void) fputc ('\n', yyf);
 yyIndentSelectorTree ("TypeObj", yyt->SymOpaqueType.TypeObj);
}

static void yWriteSymConfiguration
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymConfiguration], yyf); (void) fputc ('\n', yyf);
 yyIndentSelectorTree ("TypeObj", yyt->SymConfiguration.TypeObj);
}

static void yWriteSymVector
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymVector], yyf); (void) fputc ('\n', yyf);
 yyIndentSelectorTree ("TypeObj", yyt->SymVector.TypeObj);
 yyIndentSelectorTree ("Config", yyt->SymVector.Config);
 yyIndentSelector ("IsOpen"); writeBOOLEAN (yyt->SymVector.IsOpen) yyWriteNl ();
}

static void yWriteSymArray
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymArray], yyf); (void) fputc ('\n', yyf);
 yyIndentSelectorTree ("TypeObj", yyt->SymArray.TypeObj);
 yyIndentSelector ("StructId"); writetIdent (yyt->SymArray.StructId) yyWriteNl ();
 yyIndentSelectorTree ("IndexType", yyt->SymArray.IndexType);
 yyIndentSelector ("IsOpen"); writeBOOLEAN (yyt->SymArray.IsOpen) yyWriteNl ();
}

static void yWriteSymEnumeration
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymEnumeration], yyf); (void) fputc ('\n', yyf);
 yyIndentSelectorTree ("TypeObj", yyt->SymEnumeration.TypeObj);
 yyIndentSelector ("MaxValue"); writeINDEX (yyt->SymEnumeration.MaxValue) yyWriteNl ();
}

static void yWriteSymPointer
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymPointer], yyf); (void) fputc ('\n', yyf);
 yyIndentSelectorTree ("TypeObj", yyt->SymPointer.TypeObj);
}

static void yWriteSymProcType
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymProcType], yyf); (void) fputc ('\n', yyf);
 yyIndentSelectorTree ("TypeObj", yyt->SymProcType.TypeObj);
 yyIndentSelectorTree ("Types", yyt->SymProcType.Types);
}

static void yWriteSymRecord
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymRecord], yyf); (void) fputc ('\n', yyf);
 yyIndentSelectorTree ("TypeObj", yyt->SymRecord.TypeObj);
 yyIndentSelector ("StructId"); writetIdent (yyt->SymRecord.StructId) yyWriteNl ();
}

static void yWriteSymSet
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymSet], yyf); (void) fputc ('\n', yyf);
 yyIndentSelectorTree ("TypeObj", yyt->SymSet.TypeObj);
}

static void yWriteSymSubrange
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymSubrange], yyf); (void) fputc ('\n', yyf);
 yyIndentSelectorTree ("TypeObj", yyt->SymSubrange.TypeObj);
 yyIndentSelector ("LwbExpr"); writeADDRESS (yyt->SymSubrange.LwbExpr) yyWriteNl ();
 yyIndentSelector ("UpbExpr"); writeADDRESS (yyt->SymSubrange.UpbExpr) yyWriteNl ();
 yyIndentSelector ("Lwb"); writetValue (yyt->SymSubrange.Lwb) yyWriteNl ();
 yyIndentSelector ("Upb"); writetValue (yyt->SymSubrange.Upb) yyWriteNl ();
}

static void yWriteSymElem
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymElem], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Ident"); writetIdent (yyt->SymElem.Ident) yyWriteNl ();
 yyIndentSelector ("IsPseudoObj"); writeBOOLEAN (yyt->SymElem.IsPseudoObj) yyWriteNl ();
 yyIndentSelectorTree ("Object", yyt->SymElem.Object);
}

static void yWriteSymUnion
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymUnion], yyf); (void) fputc ('\n', yyf);
 yyIndentSelectorTree ("Objects1", yyt->SymUnion.Objects1);
}

static void yWriteSymCObjects
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymCObjects], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("M2Object"); writetObject (yyt->SymCObjects.M2Object) yyWriteNl ();
 yyIndentSelector ("CObject"); writetIdent (yyt->SymCObjects.CObject) yyWriteNl ();
}

static void yWriteSymTypes
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymTypes], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("IsVAR"); writeBOOLEAN (yyt->SymTypes.IsVAR) yyWriteNl ();
 yyIndentSelector ("IsLval"); writeBOOLEAN (yyt->SymTypes.IsLval) yyWriteNl ();
 yyIndentSelectorTree ("Type", yyt->SymTypes.Type);
}

static void yWriteSymEnv
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymEnv], yyf); (void) fputc ('\n', yyf);
 yyIndentSelectorTree ("Objects", yyt->SymEnv.Objects);
}

static void yWriteSymSelectors
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymSelectors], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Selector"); writetIdent (yyt->SymSelectors.Selector) yyWriteNl ();
}

static void yWriteSymStringPar
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymStringPar], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("CString"); writetIdent (yyt->SymStringPar.CString) yyWriteNl ();
 yyIndentSelectorTree ("FormalType", yyt->SymStringPar.FormalType);
 yyIndentSelector ("M2String"); writeADDRESS (yyt->SymStringPar.M2String) yyWriteNl ();
}

static void yWriteSymConfigs
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymConfigs], yyf); (void) fputc ('\n', yyf);
 yyIndentSelectorTree ("Object", yyt->SymConfigs.Object);
 yyIndentSelector ("ActiveIdent"); writetIdent (yyt->SymConfigs.ActiveIdent) yyWriteNl ();
 yyIndentSelector ("ElseIdent"); writetIdent (yyt->SymConfigs.ElseIdent) yyWriteNl ();
}

static void yWriteSymConnects
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymConnects], yyf); (void) fputc ('\n', yyf);
 yyIndentSelectorTree ("Object", yyt->SymConnects.Object);
 yyIndentSelector ("CIdent"); writetIdent (yyt->SymConnects.CIdent) yyWriteNl ();
}

static void yWriteSymLocalIds
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 (void) fputs (Symbols_NodeName [kSymLocalIds], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Ident"); writetIdent (yyt->SymLocalIds.Ident) yyWriteNl ();
}

static void yyWriteSymbols
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{ unsigned short yyLevel = yyIndentLevel;
 for (;;) {
  if (yyt == NoSymbols) { (void) fputs (" NoSymbols\n", yyf); goto yyExit;
  } else if (yyt->yyHead.yyMark == 0) { (void) fprintf (yyf, "^%d\n", yyMapToLabel (yyt)); goto yyExit;
  } else if (yyt->yyHead.yyMark > 1) {
   register int yyi;
   (void) fprintf (yyf, "\n%06d:", yyMapToLabel (yyt));
   for (yyi = 8; yyi <= yyIndentLevel; yyi ++) (void) putc (' ', yyf);
  } else (void) putc (' ', yyf);
  yyt->yyHead.yyMark = 0;
  yyIndentLevel += 2;

  switch (yyt->Kind) {
case kSymObject: yWriteSymObject (yyt); goto yyExit;
case kSymNoObject: yWriteSymNoObject (yyt); goto yyExit;
case kSymConst: yWriteSymConst (yyt); goto yyExit;
case kSymEnumLiteral: yWriteSymEnumLiteral (yyt); yyIndentSelector ("Type"); yyt = yyt->SymEnumLiteral.Type; break;
case kSymModule: yWriteSymModule (yyt); yyIndentSelector ("Locals"); yyt = yyt->SymModule.Locals; break;
case kSymField: yWriteSymField (yyt); yyIndentSelector ("Selectors"); yyt = yyt->SymField.Selectors; break;
case kSymProcBody: yWriteSymProcBody (yyt); yyIndentSelector ("Locals"); yyt = yyt->SymProcBody.Locals; break;
case kSymProcHead: yWriteSymProcHead (yyt); yyIndentSelector ("Type"); yyt = yyt->SymProcHead.Type; break;
case kSymTypeDecl: yWriteSymTypeDecl (yyt); yyIndentSelector ("Type"); yyt = yyt->SymTypeDecl.Type; break;
case kSymOpaque: yWriteSymOpaque (yyt); yyIndentSelector ("Type"); yyt = yyt->SymOpaque.Type; break;
case kSymVar: yWriteSymVar (yyt); yyIndentSelector ("Type"); yyt = yyt->SymVar.Type; break;
case kSymConfig: yWriteSymConfig (yyt); yyIndentSelector ("View"); yyt = yyt->SymConfig.View; break;
case kSymConnect: yWriteSymConnect (yyt); yyIndentSelector ("DestConfig"); yyt = yyt->SymConnect.DestConfig; break;
case kSymStdProc: yWriteSymStdProc (yyt); yyIndentSelector ("Type"); yyt = yyt->SymStdProc.Type; break;
case kSymExpr: yWriteSymExpr (yyt); goto yyExit;
case kSymType: (void) fputs (Symbols_NodeName [kSymType], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kSymNoType: (void) fputs (Symbols_NodeName [kSymNoType], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kSymError: yWriteSymError (yyt); goto yyExit;
case kSymInteger: (void) fputs (Symbols_NodeName [kSymInteger], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kSymCardinal: (void) fputs (Symbols_NodeName [kSymCardinal], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kSymReal: (void) fputs (Symbols_NodeName [kSymReal], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kSymBoolean: (void) fputs (Symbols_NodeName [kSymBoolean], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kSymChar: (void) fputs (Symbols_NodeName [kSymChar], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kSymBitset: (void) fputs (Symbols_NodeName [kSymBitset], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kSymProc: (void) fputs (Symbols_NodeName [kSymProc], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kSymWord: (void) fputs (Symbols_NodeName [kSymWord], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kSymAddress: (void) fputs (Symbols_NodeName [kSymAddress], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kSymIntCard: (void) fputs (Symbols_NodeName [kSymIntCard], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kSymNil: (void) fputs (Symbols_NodeName [kSymNil], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kSymString: (void) fputs (Symbols_NodeName [kSymString], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kSymStringChar: (void) fputs (Symbols_NodeName [kSymStringChar], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kSymVoid: (void) fputs (Symbols_NodeName [kSymVoid], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kSymStdProcType: yWriteSymStdProcType (yyt); goto yyExit;
case kSymQualident: yWriteSymQualident (yyt); yyIndentSelector ("Object"); yyt = yyt->SymQualident.Object; break;
case kSymConstructor: yWriteSymConstructor (yyt); yyIndentSelector ("TypeObj"); yyt = yyt->SymConstructor.TypeObj; break;
case kSymOpaqueType: yWriteSymOpaqueType (yyt); yyIndentSelector ("Type"); yyt = yyt->SymOpaqueType.Type; break;
case kSymConfiguration: yWriteSymConfiguration (yyt); yyIndentSelector ("Config"); yyt = yyt->SymConfiguration.Config; break;
case kSymVector: yWriteSymVector (yyt); yyIndentSelector ("Type"); yyt = yyt->SymVector.Type; break;
case kSymArray: yWriteSymArray (yyt); yyIndentSelector ("ElemType"); yyt = yyt->SymArray.ElemType; break;
case kSymEnumeration: yWriteSymEnumeration (yyt); yyIndentSelector ("Objects"); yyt = yyt->SymEnumeration.Objects; break;
case kSymPointer: yWriteSymPointer (yyt); yyIndentSelector ("Type"); yyt = yyt->SymPointer.Type; break;
case kSymProcType: yWriteSymProcType (yyt); yyIndentSelector ("Type"); yyt = yyt->SymProcType.Type; break;
case kSymRecord: yWriteSymRecord (yyt); yyIndentSelector ("Objects"); yyt = yyt->SymRecord.Objects; break;
case kSymSet: yWriteSymSet (yyt); yyIndentSelector ("Type"); yyt = yyt->SymSet.Type; break;
case kSymSubrange: yWriteSymSubrange (yyt); yyIndentSelector ("Type"); yyt = yyt->SymSubrange.Type; break;
case kSymObjects: (void) fputs (Symbols_NodeName [kSymObjects], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kSymElem: yWriteSymElem (yyt); yyIndentSelector ("Next"); yyt = yyt->SymElem.Next; break;
case kSymUnion: yWriteSymUnion (yyt); yyIndentSelector ("Objects2"); yyt = yyt->SymUnion.Objects2; break;
case kSymCObjects: yWriteSymCObjects (yyt); yyIndentSelector ("Next"); yyt = yyt->SymCObjects.Next; break;
case kSymTypes: yWriteSymTypes (yyt); yyIndentSelector ("Next"); yyt = yyt->SymTypes.Next; break;
case kSymEnv: yWriteSymEnv (yyt); yyIndentSelector ("HiddenEnv"); yyt = yyt->SymEnv.HiddenEnv; break;
case kSymSelectors: yWriteSymSelectors (yyt); yyIndentSelector ("Next"); yyt = yyt->SymSelectors.Next; break;
case kSymStringPar: yWriteSymStringPar (yyt); yyIndentSelector ("Next"); yyt = yyt->SymStringPar.Next; break;
case kSymConfigs: yWriteSymConfigs (yyt); yyIndentSelector ("Next"); yyt = yyt->SymConfigs.Next; break;
case kSymConnects: yWriteSymConnects (yyt); yyIndentSelector ("Next"); yyt = yyt->SymConnects.Next; break;
case kSymLocalIds: yWriteSymLocalIds (yyt); yyIndentSelector ("Next"); yyt = yyt->SymLocalIds.Next; break;
  default: goto yyExit;
  }
 }
yyExit:
 yyIndentLevel = yyLevel;
}

# define yyNil	0374
# define yyNoLabel	0375
# define yyLabelDef	0376
# define yyLabelUse	0377

# define yyyWrite	1
# define yyyRead	2
# define yyyQuit	3

static char yyyString [32], yyCh;
static int yyLength, yyState;

static bool yyyIsEqual
# if defined __STDC__ | defined __cplusplus
 (char * yya)
# else
 (yya) char * yya;
# endif
{
 register int yyi;
 if (yyLength >= 0 && yyyString [yyLength] == ' ') {
  if (yyLength != strlen (yya)) return false;
  for (yyi = 0; yyi < yyLength; yyi ++)
   if (yyyString [yyi] != yya [yyi]) return false;
 } else {
  if (yyLength >= strlen (yya)) return false;
  for (yyi = 0; yyi <= yyLength; yyi ++)
   if (yyyString [yyi] != yya [yyi]) return false;
 }
 return true;
}

void QuerySymbols
# if defined __STDC__ | defined __cplusplus
 (tSymbols yyt)
# else
 (yyt) tSymbols yyt;
# endif
{
 yyState = yyyWrite;
 for (;;) {
  switch (yyState) {
  case yyyQuit : return;
  case yyyWrite: WriteSymbolsNode (stdout, yyt); yyState = yyyRead;
  case yyyRead : (void) printf ("? "); yyLength = -1; yyCh = getc (stdin);
   while (yyCh != '\n' && yyCh > 0)
    { yyyString [++ yyLength] = yyCh; yyCh = getc (stdin); }
   if (yyCh < 0) { (void) fputs ("QueryTree: eof reached\n", stderr);
    yyState = yyyQuit; return; }
   if      (yyyIsEqual ("parent")) { yyState = yyyWrite; return; }
   else if (yyyIsEqual ("quit"  )) { yyState = yyyQuit ; return; }
   else if (yyt != NoSymbols) {
    switch (yyt->Kind) {
case kSymEnumLiteral: if (false) ;
else if (yyyIsEqual ("Type")) QuerySymbols (yyt->SymEnumLiteral.Type);
break;
case kSymModule: if (false) ;
else if (yyyIsEqual ("ExportList")) QuerySymbols (yyt->SymModule.ExportList);
else if (yyyIsEqual ("Objects")) QuerySymbols (yyt->SymModule.Objects);
else if (yyyIsEqual ("Locals")) QuerySymbols (yyt->SymModule.Locals);
break;
case kSymField: if (false) ;
else if (yyyIsEqual ("Type")) QuerySymbols (yyt->SymField.Type);
else if (yyyIsEqual ("Selectors")) QuerySymbols (yyt->SymField.Selectors);
break;
case kSymProcBody: if (false) ;
else if (yyyIsEqual ("Type")) QuerySymbols (yyt->SymProcBody.Type);
else if (yyyIsEqual ("Locals")) QuerySymbols (yyt->SymProcBody.Locals);
break;
case kSymProcHead: if (false) ;
else if (yyyIsEqual ("Type")) QuerySymbols (yyt->SymProcHead.Type);
break;
case kSymTypeDecl: if (false) ;
else if (yyyIsEqual ("Type")) QuerySymbols (yyt->SymTypeDecl.Type);
break;
case kSymOpaque: if (false) ;
else if (yyyIsEqual ("Type")) QuerySymbols (yyt->SymOpaque.Type);
break;
case kSymVar: if (false) ;
else if (yyyIsEqual ("Type")) QuerySymbols (yyt->SymVar.Type);
break;
case kSymConfig: if (false) ;
else if (yyyIsEqual ("Type")) QuerySymbols (yyt->SymConfig.Type);
else if (yyyIsEqual ("Indexes")) QuerySymbols (yyt->SymConfig.Indexes);
else if (yyyIsEqual ("Connections")) QuerySymbols (yyt->SymConfig.Connections);
else if (yyyIsEqual ("View")) QuerySymbols (yyt->SymConfig.View);
break;
case kSymConnect: if (false) ;
else if (yyyIsEqual ("SourceConfig")) QuerySymbols (yyt->SymConnect.SourceConfig);
else if (yyyIsEqual ("DestConfig")) QuerySymbols (yyt->SymConnect.DestConfig);
break;
case kSymStdProc: if (false) ;
else if (yyyIsEqual ("Type")) QuerySymbols (yyt->SymStdProc.Type);
break;
case kSymQualident: if (false) ;
else if (yyyIsEqual ("Object")) QuerySymbols (yyt->SymQualident.Object);
break;
case kSymConstructor: if (false) ;
else if (yyyIsEqual ("TypeObj")) QuerySymbols (yyt->SymConstructor.TypeObj);
break;
case kSymOpaqueType: if (false) ;
else if (yyyIsEqual ("TypeObj")) QuerySymbols (yyt->SymOpaqueType.TypeObj);
else if (yyyIsEqual ("Type")) QuerySymbols (yyt->SymOpaqueType.Type);
break;
case kSymConfiguration: if (false) ;
else if (yyyIsEqual ("TypeObj")) QuerySymbols (yyt->SymConfiguration.TypeObj);
else if (yyyIsEqual ("Config")) QuerySymbols (yyt->SymConfiguration.Config);
break;
case kSymVector: if (false) ;
else if (yyyIsEqual ("TypeObj")) QuerySymbols (yyt->SymVector.TypeObj);
else if (yyyIsEqual ("Config")) QuerySymbols (yyt->SymVector.Config);
else if (yyyIsEqual ("Type")) QuerySymbols (yyt->SymVector.Type);
break;
case kSymArray: if (false) ;
else if (yyyIsEqual ("TypeObj")) QuerySymbols (yyt->SymArray.TypeObj);
else if (yyyIsEqual ("IndexType")) QuerySymbols (yyt->SymArray.IndexType);
else if (yyyIsEqual ("ElemType")) QuerySymbols (yyt->SymArray.ElemType);
break;
case kSymEnumeration: if (false) ;
else if (yyyIsEqual ("TypeObj")) QuerySymbols (yyt->SymEnumeration.TypeObj);
else if (yyyIsEqual ("Objects")) QuerySymbols (yyt->SymEnumeration.Objects);
break;
case kSymPointer: if (false) ;
else if (yyyIsEqual ("TypeObj")) QuerySymbols (yyt->SymPointer.TypeObj);
else if (yyyIsEqual ("Type")) QuerySymbols (yyt->SymPointer.Type);
break;
case kSymProcType: if (false) ;
else if (yyyIsEqual ("TypeObj")) QuerySymbols (yyt->SymProcType.TypeObj);
else if (yyyIsEqual ("Types")) QuerySymbols (yyt->SymProcType.Types);
else if (yyyIsEqual ("Type")) QuerySymbols (yyt->SymProcType.Type);
break;
case kSymRecord: if (false) ;
else if (yyyIsEqual ("TypeObj")) QuerySymbols (yyt->SymRecord.TypeObj);
else if (yyyIsEqual ("Objects")) QuerySymbols (yyt->SymRecord.Objects);
break;
case kSymSet: if (false) ;
else if (yyyIsEqual ("TypeObj")) QuerySymbols (yyt->SymSet.TypeObj);
else if (yyyIsEqual ("Type")) QuerySymbols (yyt->SymSet.Type);
break;
case kSymSubrange: if (false) ;
else if (yyyIsEqual ("TypeObj")) QuerySymbols (yyt->SymSubrange.TypeObj);
else if (yyyIsEqual ("Type")) QuerySymbols (yyt->SymSubrange.Type);
break;
case kSymElem: if (false) ;
else if (yyyIsEqual ("Object")) QuerySymbols (yyt->SymElem.Object);
else if (yyyIsEqual ("Next")) QuerySymbols (yyt->SymElem.Next);
break;
case kSymUnion: if (false) ;
else if (yyyIsEqual ("Objects1")) QuerySymbols (yyt->SymUnion.Objects1);
else if (yyyIsEqual ("Objects2")) QuerySymbols (yyt->SymUnion.Objects2);
break;
case kSymCObjects: if (false) ;
else if (yyyIsEqual ("Next")) QuerySymbols (yyt->SymCObjects.Next);
break;
case kSymTypes: if (false) ;
else if (yyyIsEqual ("Type")) QuerySymbols (yyt->SymTypes.Type);
else if (yyyIsEqual ("Next")) QuerySymbols (yyt->SymTypes.Next);
break;
case kSymEnv: if (false) ;
else if (yyyIsEqual ("Objects")) QuerySymbols (yyt->SymEnv.Objects);
else if (yyyIsEqual ("HiddenEnv")) QuerySymbols (yyt->SymEnv.HiddenEnv);
break;
case kSymSelectors: if (false) ;
else if (yyyIsEqual ("Next")) QuerySymbols (yyt->SymSelectors.Next);
break;
case kSymStringPar: if (false) ;
else if (yyyIsEqual ("FormalType")) QuerySymbols (yyt->SymStringPar.FormalType);
else if (yyyIsEqual ("Next")) QuerySymbols (yyt->SymStringPar.Next);
break;
case kSymConfigs: if (false) ;
else if (yyyIsEqual ("Object")) QuerySymbols (yyt->SymConfigs.Object);
else if (yyyIsEqual ("Next")) QuerySymbols (yyt->SymConfigs.Next);
break;
case kSymConnects: if (false) ;
else if (yyyIsEqual ("Object")) QuerySymbols (yyt->SymConnects.Object);
else if (yyyIsEqual ("Next")) QuerySymbols (yyt->SymConnects.Next);
break;
case kSymLocalIds: if (false) ;
else if (yyyIsEqual ("Next")) QuerySymbols (yyt->SymLocalIds.Next);
break;
    default: ;
    }
   }
  }
 }
}

void BeginSymbols ()
{
/* line 2318 "symbols.cg" */

  Errors_Init();
  Values_Init();

  NoObject = mSymNoObject(NoIdent);
  NoObject->SymNoObject.CIdent = NoIdent;

  NoType            = mSymNoType();

  OpenVectorConfig = mSymConfig(NoIdent, 0, 0, FALSE, FALSE, FALSE, FALSE);
  OpenVectorConfig->SymConfig.CIdent = MakeIdent("OPEN_VECTOR", 11);

  IdentSYSTEM       = MakeIdent("SYSTEM", 6);
  IdentALLOC        = MakeIdent("ALLOCATE", 8);
  IdentDEALLOC      = MakeIdent("DEALLOCATE", 10);

  TypeINTEGER       = mSymInteger();
  TypeCARDINAL      = mSymCardinal();
  TypeREAL          = mSymReal();
  TypeBOOLEAN       = mSymBoolean();
  TypeCHAR          = mSymChar();
  TypeBITSET        = mSymBitset();
  TypePROC          = mSymProc();
  TypeWORD          = mSymWord();
  TypeADDRESS       = mSymAddress();
  TypeIntCard       = mSymIntCard();
  TypeNil           = mSymNil();
  TypeString        = mSymString();
  TypeStringChar    = mSymStringChar();
  TypeVoid          = mSymVoid();

  Predefs           = Predef();

}

void CloseSymbols ()
{
}
