/* In this section the macros for the TCL-browser are defined.
   The output normally is in the syntax of the Tcl-language.
   So it can directly used by the eval-statement of Tcl.
*/
#define yytout(yyt) (void)fprintf(yyf, " {%s}:", #yyt);



/* The string :SELECTOR: tells EXPECT that a new selector is displayed */
#undef yyWriteSelector
#define yyWriteSelector(yys) (void) getc(stdin);(void) fputs (":SELECTOR:", yyf);(void) fputs (yys, yyf)
/*****************************************************************************/
/* If the EXPECT detects the String 'BUTTON' a button for the child is constructed.
   Clicking on the button causes EXPECT to send the name of the chooosen selector
   to the browser constructed by ast. This browser in turn sends all selectors of this child
   to the output (as tcl-commands) which is read by expect
*/
#undef yyWriteAdr
#define yyWriteAdr(yyt) if (yyt == NoTree) (void) fputs ("NoTree", yyf);\
			else (void) fprintf (yyf, ":BUTTON:%s:\n", #yyt);
/*****************************************************************************/
/* This macro 'overloads' the original C-function WriteTreeNode
   For synchronizing purposes the output of the C-WriteTreeNode
   is embedded in the Strings ":BEGINTREENODE:" and ":ENDTREENODE:\n"
   the getc(stdin) statements are also for synchronizing purposes
*/
#undef WriteTreeNode
#define WriteTreeNode(yyf, tTree) { \
(void)getc(stdin); \
fputs(":BEGINTREENODE:", yyf); \
WriteTreeNode(yyf, tTree); \
(void) getc(stdin);\
fputs(":ENDTREENODE:\n", yyf); }

#define Simple(a, name, modifyer)\
(void)fprintf(yyf, ":%s $winpath $nodename ", #name);\
(void)fprintf( yyf, #modifyer, a); yytout(a);
/* Some macros have identical behaviour: they print a hex-dump of 
   the selector
*/
#undef writeHexgeneric
#define writeHexgeneric(a,name) \
(void)fprintf( yyf, ":set eintrag { "); \
yyWriteHex ((unsigned char *) & a, sizeof (a)); \
(void)fprintf( yyf, " }\n"); (void)fprintf( yyf, name);\
(void)fprintf( yyf, " $winpath    $nodename $eintrag");yytout(a);
