

/* These macros are used by symbols.cg and by parallaxis.cg
They used to be part of these two files
*/
#undef begintIdent
#define begintIdent(a)     a = NoIdent;

#undef readCHAR
#define readCHAR(a)       (void)fscanf( yyf, "%c", &a );

#undef equalCHAR
#define equalCHAR(a,b)     a == b

#undef readUCHAR
#define readUCHAR(a)      (void)fscanf( yyf, "%c", &a );

#undef equalUCHAR
#define equalUCHAR(a,b)    a == b

#undef readSHORT
#define readSHORT(a)      (void)fscanf( yyf, "%hd", &a );

#undef equalSHORT
#define equalSHORT(a,b)    a == b

#undef readUSHORT
#define readUSHORT(a)     (void)fscanf( yyf, "%hu", &a );

#undef equalUSHORT
#define equalUSHORT(a,b)   a == b

#undef readLONG
#define readLONG(a)       (void)fscanf( yyf, "%ld", &a );

#undef equalLONG
#define equalLONG(a,b)     a == b

#undef readULONG
#define readULONG(a)      (void)fscanf( yyf, "%lu", &a );

#undef writeULONG
#define writeULONG(a)     (void)fprintf( yyf, "%lu", a );

#undef equalULONG
#define equalULONG(a,b)    a == b

#undef beginINDEX
#define beginINDEX(a)      a = 0;

#undef readINDEX
#define readINDEX(a)      (void)fscanf( yyf, "%lu", &a );

#undef equalINDEX
#define equalINDEX(a,b)    a == b

#undef beginBOOLEAN
#define beginBOOLEAN(a)    a = FALSE;

#undef readBOOLEAN
#define readBOOLEAN(a)     a = (fgetc(yyf) == 'T');

#undef equalBOOLEAN
#define equalBOOLEAN(a,b)  a == b

#undef beginADDRESS
#define beginADDRESS(a)    a = NULL;

#undef readADDRESS
#define readADDRESS(a)    (void)fscanf( yyf, "%p", &a );

#undef equalADDRESS
#define equalADDRESS(a,b)  a == b

#undef begintValue
#define begintValue(a)     a = Values_Error;

#undef begintObjects
#define begintObjects(a)   a = (tObjects)0L;

#undef begintType
#define begintType(a)      a = (tType)0L;

#undef begintObject
#define begintObject(a)    a = (tObject)0L;

#undef begintIdents
#define begintIdents(a)    a = (tIdents)0L;

#undef begintSelectors
#define begintSelectors(a) a = (tSelectors)0L;

#undef begintStrings
#define begintStrings(a)   a = (tStrings)0L;
/********************************************************************************/
/* In this section the macros which are used by the procedures QueryTree and WriteTree
   are defined. We can use the terminaldriven browser or the Expect-driven browser.
   At the moment this decision must be made before compiling the Parallaxis-compiler and not
   when using it. But I think this is sufficient, because the Browser is only
   for feveloping purposes.
*/
   
#include "Tree.h"
#ifdef DEVELOP
/********************************************************************************/
#ifndef TCLBROWSER
/* These are the macros for the terminal-driven browser.
   Very interesting things don't happen
*/
#undef writetIdent
#define writetIdent(a)    (void)fprintf( yyf, "%4d -> ", a ); WriteIdent (yyf, a);

#undef writeCHAR
#define writeCHAR(a)      (void)fprintf( yyf, "%c", a );

#undef writeUCHAR
#define writeUCHAR(a)     (void)fprintf( yyf, "%c", a );

#undef writeSHORT
#define writeSHORT(a)     (void)fprintf( yyf, "%hd", a );

#undef writeUSHORT
#define writeUSHORT(a)    (void)fprintf( yyf, "%hu", a );

#undef writeLONG
#define writeLONG(a)      (void)fprintf( yyf, "%ld", a );

#undef writeINDEX
#define writeINDEX(a)     (void)fprintf( yyf, "%lu", a );

#undef writeBOOLEAN
#define writeBOOLEAN(a)   (void)fputc( a ? 'T' : 'F', yyf );

#undef writeADDRESS
#define writeADDRESS(a)   (void)fprintf( yyf, "%p", a );

#undef writetValue
#define writetValue(a)     Values_WriteValue(yyf, &a);

#else
/********************************************************************************/
#include "browsegeneral.w"


#undef writetObjects
#define writetObjects(a)\
fputs(":writetObjects $winpath  $nodename { ", yyf);\
Symbols_WriteObjects(yyf, a); fputs(" } ", yyf);yytout(a);

#undef writeBOOLEAN
#define writeBOOLEAN(a) if(a) (void)fprintf( yyf, ":writeBOOLEAN $winpath $nodename YES"); \
                        else  (void)fprintf( yyf, ":writeBOOLEAN $winpath $nodename NO");yytout(a);

#undef writeINDEX
#define writeINDEX(a) Simple(a, writeINDEX, %lu)
#undef writeCHAR
#define writeCHAR(a) Simple(a, writeCHAR, %c)
#undef writeUCHAR
#define writeUCHAR(a) Simple(a, writeUCHAR, %c)
#undef writeSHORT
#define writeSHORT(a) Simple(a, writeSHORT, %hd)
#undef writeLONG
#define writeLONG(a) Simple(a, writeLONG, %ld)
#undef writeULONG
#define writeULONG(a) Simple(a, writeULONG, %lu)
#undef writeADDRESS
#define writeADDRESS(a) Simple(a, writeADDRESS, %p)

#undef writetIdent
#define writetIdent(a) (void)fprintf( yyf, ":set tIdent %4d; set varname \"\"; set varname ", a);\
WriteIdent(yyf, a); \
(void)fprintf( yyf, "\nwritetIdent $winpath $nodename $tIdent $varname");yytout(a);



#undef writetValue
#define writetValue(a)   (void)fprintf( yyf, ":set eintrag {");  Values_WriteValue(yyf, &a);\
(void)fprintf( yyf, " }\nwritetValue $winpath  $nodename $eintrag");yytout(a);



#undef writetEnv
#define writetEnv(a) (void)fprintf( yyf, ":set eintrag { ");\
Symbols_WriteEnv( yyf, a );\
(void)fprintf( yyf,"}\nwritetEnv $winpath $nodename $eintrag");yytout(a);


extern void Symbols_WriteEnv     (FILE *f, tEnv Env);
extern void Symbols_WriteObjects (FILE *f, tObjects Objects);

#undef writetPosition
#define writetPosition(Position) {char filename[260];GetString(Position.File, filename);\
(void)fprintf( yyf, ":set filename %s;  set linepos %4d;\
set columnpos %3d; writetPosition $winpath    $nodename $filename $linepos $columnpos",\
 filename, Position.Line, Position.Column);yytout(Position);};


#undef writetConnects
#define writetConnects(a) writeHexgeneric(a,"writetConnects")

#undef writetConfigs
#define writetConfigs(a)  writeHexgeneric(a,"writetConfigs")

#undef writetLocalIds
#define writetLocalIds(a) writeHexgeneric(a,"writetLocalIds")

#undef writetIdents
#define writetIdents(a)   writeHexgeneric(a,"writetIdents")

#undef writetVoid
#define writetVoid(a)     writeHexgeneric(a,"writetVoid")

#undef writetLocalids
#define writetLocalids(a) writeHexgeneric(a,"writetLocalids")

#undef writetStringRef
#define writetStringRef(a) \
(void)fprintf( yyf, ":set eintrag "); \
WriteString (yyf, a); \
(void)fprintf( yyf, "\n writetStringRef $winpath $nodename $eintrag");yytout(a);




extern void start_QuerySymbols();
#undef writetObject
#define writetObject(a)    if (Options_IsOptionSet(Options_eWriteSymbolsTree)) {\
   (void)fprintf( yyf, ":set symnodename %s;\
   set address { %p } ; writetObject $winpath $nodename $symnodename $address 1",\
   Symbols_NodeName[a ? a->Kind : 0], a ); yytout(a);(void)fprintf(yyf, "\n");\
} else { \
   (void)fprintf( yyf, ":set symnodename %s;\
   set address { %p } ; writetObject $winpath $nodename $symnodename $address 0",\
   Symbols_NodeName[a ? a->Kind : 0], a ); yytout(a);\
}

#undef writetType
#define writetType(a)  if (Options_IsOptionSet(Options_eWriteSymbolsTree)) { \
   (void)fprintf( yyf, ":set symnodename %s;\
   set address { %p } ; writetObject $winpath $nodename $symnodename $address 1",\
   Symbols_NodeName[a ? a->Kind : 0], a ); yytout(a);(void)fprintf(yyf, "\n");\
} else { \
   (void)fprintf( yyf, ":set symnodename %s;\
    set address { %p } ; writetType $winpath $nodename $symnodename $address 0",\
    Symbols_NodeName[a ? a->Kind : 0], a ); yytout(a);\
}
#undef writetTypes
#define writetTypes(a)  if (Options_IsOptionSet(Options_eWriteSymbolsTree)) { \
   (void)fprintf( yyf, ":set symnodename %s;\
   set address { %p } ; writetObject $winpath $nodename $symnodename $address 1",\
   Symbols_NodeName[a ? a->Kind : 0], a ); yytout(a);(void)fprintf(yyf, "\n");\
} else { \
   (void)fprintf( yyf, ":set symnodename %s;\
    set address { %p } ; writetType $winpath $nodename $symnodename $address 0",\
    Symbols_NodeName[a ? a->Kind : 0], a ); yytout(a);\
}



#undef writetCObjects
#define writetCObjects(a)\
   (void)fprintf( yyf, ":set eintrag %s;\
    writetCObjects $winpath $nodename $eintrag %p",\
    Symbols_NodeName[a ? a->Kind : 0], a );yytout(a); \

#undef writetStrings
#define writetStrings(a) { \
   (void)fprintf( yyf, ":set eintrag %s;\
   writetStrings $winpath $nodename $eintrag %p",\
   Symbols_NodeName[a ? a->Kind : 0], a ); yytout(a);\
}

#endif /*TCLBROWSER*/
#endif /*DEVELOP*/
