/*************************************************************************
 *
 * Parallaxis Compiler Projects
 * ----------------------------
 *
 * name  :  AssocTab.h
 * desc  :  associate identifiers with objects of arbitrary type
 * author:  lampke
 *
 ************************************************************************/

#ifndef AssocTab_h
#define AssocTab_h

#include "Idents.h"			  /* Reuse-Library */
#include "parallaxis.h"

/*************************************************************************
 * name :  AssocTab_Begin
 * in   :
 * out  :
 ************************************************************************/
extern void AssocTab_Begin( void );

/*************************************************************************
 * name :  AssocTab_PutAssoc
 * in   :  'Object' pointer is associated with identifier 'Ident'
 * out  :
 ************************************************************************/
extern void AssocTab_PutAssoc( tIdent Ident, void *Object );

/*************************************************************************
 * name :  AssocTab_GetAssoc
 * in   :  'Ident' the association is wanted for
 * out  :  'Object' pointer
 ************************************************************************/
extern void AssocTab_GetAssoc( tIdent Ident, void **Object );

/*************************************************************************
 * name :  AssocTab_Close
 * in   :
 * out  :
 ************************************************************************/
extern void AssocTab_Close( void );

#endif
