/*************************************************************************
 *
 * Parallaxis Compiler Projects
 * ----------------------------
 *
 * name  :  Positions.c
 * desc  :  Positions (filename, line, column) of tokens in a file
 *          are handeled by this module
 * author:  lampke
 *
 ************************************************************************/

#include <string.h>
#include "FileIO.h"
#include "Positions.h"

static BOOLEAN isInitialised = FALSE;

tPosition NoPosition = { 0, 0, 0 };

int Compare
# if defined __STDC__
(tPosition Position1, tPosition Position2)
# else
(Position1, Position2) tPosition Position1, Position2;
# endif
{
  if (Position1.File   < Position2.File  ) return -1;
  if (Position1.File   > Position2.File  ) return  1;
  if (Position1.Line   < Position2.Line  ) return -1;
  if (Position1.Line   > Position2.Line  ) return  1;
  if (Position1.Column < Position2.Column) return -1;
  if (Position1.Column > Position2.Column) return  1;
  return 0;
}

void WritePosition
# if defined __STDC__
(FILE * File, tPosition Position)
# else
(File, Position) FILE * File; tPosition Position;
# endif
{
  static char string[260];
  unsigned long i;

  GetString(Position.File, string);
  if (!Compare(Position, NoPosition)) {
    for (i = 0; i < strlen(string); i++) {
      (void)fprintf(File, " ");
    }
    (void)fprintf(File, "              ");
  } else {
    GetString(Position.File, string);
    (void)fprintf(File, "%s line %4d,%3d", string, Position.Line,
      Position.Column);
  } /* endif */
}

void Positions_Init( void )
{
  if ( !isInitialised ) {
    isInitialised = TRUE;
    NoPosition.File = NoIdent;
  } /* endif */
}

