/*************************************************************************
 *
 * Parallaxis Compiler Projects
 * ----------------------------
 *
 * name  :  Positions.h
 * desc  :
 * author:  lampke
 *
 ************************************************************************/

#ifndef yyPositions
#define yyPositions

#include <stdio.h>
#include "Idents.h"			  /* Reuse-Library */
#include "parallaxis.h"

#if defined __STDC__
#define ARGS(parameters)       parameters
#else
#define ARGS(parameters)       ()
#endif

typedef struct {
  tIdent File;
  unsigned short Line;
  unsigned short Column;
} tPosition;

extern tPosition NoPosition;
                        /* A default position (NoIdent, 0, 0).          */

extern int Compare ARGS((tPosition Position1, tPosition Position2));
                        /* Returns -1 if Position1 < Position2.         */
                        /* Returns  0 if Position1 = Position2.         */
                        /* Returns  1 if Position1 > Position2.         */

extern void WritePosition ARGS((FILE * File, tPosition Position));
                        /* The 'Position' is printed on the 'File'.     */

extern void Positions_Init( void );

# endif
