/*************************************************************************
 *
 * Parallaxis Compiler Projects
 * ----------------------------
 *
 * name  :  UniqueIds.h
 * desc  :  generate unique C identifiers from modula identifiers
 * author:  lampke
 *
 ************************************************************************/

#ifndef UniqueIds_h
#define UniqueIds_h

#include "Idents.h"			  /* Reuse-Library */
#include "parallaxis.h"

typedef enum {
  cIdents
} tIdents;

typedef enum {
   eKeywords, eConsts, eTypes, eVars, eModuleVars, eProcs, eFields
} tIdentClass;

/*************************************************************************
 * name :  UniqueIds_Begin
 * in   :
 * out  :
 ************************************************************************/
void UniqueIds_Begin( void );

/*************************************************************************
 * name :  UniqueIds_EnterProc
 * in   :
 * out  :
 ************************************************************************/
tIdents UniqueIds_EnterProc( tIdents Idents);

/*************************************************************************
 * name :  UniqueIds_LeaveProc
 * in   :
 * out  :
 ************************************************************************/
tIdents UniqueIds_LeaveProc( tIdents Idents );

/*************************************************************************
 * name :  UniqueIds_DeclareIdent
 * in   :
 * out  :
 ************************************************************************/
extern tIdents UniqueIds_DeclareIdent( tIdents Idents, tIdentClass IdentClass,
  tIdent Ident );

/*************************************************************************
 * name :  UniqueIds_NameConflict
 * in   :
 * out  :
 ************************************************************************/
extern BOOLEAN UniqueIds_NameConflict( tIdents Idents, tIdentClass IdentClass,
  tIdent Ident );

/*************************************************************************
 * name :  UniqueIds_Close
 * in   :
 * out  :
 ************************************************************************/
void UniqueIds_Close( void );

extern void UniqueIds_Init( void );

#endif
