# ifndef yyTree
# define yyTree

# if defined __STDC__ | defined __cplusplus
# define ARGS(parameters)	parameters
# else
# define ARGS(parameters)	()
# endif

/* line 23 "parallaxis.cg" */


# include "Idents.h"			  /* Reuse-Library */
# include "StringMem.h"			  /* Reuse-Library */
# include "parallaxis.h"
# include "Options.h"
# include "Positions.h"
# include "Symbols.h"
# include "UniqueIds.h"



# ifndef bool
# define bool char
# endif
# define NoTree (tTree) 0L
# define kROOT 1
# define kCompUnits 2
# define kNoCompUnit 3
# define kCompUnit 4
# define kDefMod 5
# define kImplMod 6
# define kImports 7
# define kNoImport 8
# define kImport 9
# define kFrom 10
# define kObjects 11
# define kImpIds 12
# define kNoImpId 13
# define kImpId 14
# define kExports 15
# define kNoExport 16
# define kExport 17
# define kExpIds 18
# define kNoExpId 19
# define kExpId 20
# define kDecls 21
# define kNoDecl 22
# define kDecl 23
# define kVar 24
# define kObject 25
# define kConnectFrom 26
# define kConnectDecls 27
# define kConfig 28
# define kConst 29
# define kTypeDecl 30
# define kProc 31
# define kProcHead 32
# define kOpaque 33
# define kConnectDests 34
# define kNoConnectDest 35
# define kConnectDest 36
# define kConnectDestUni 37
# define kConnectDestBi 38
# define kVarIds 39
# define kNoVarId 40
# define kVarId 41
# define kFormals 42
# define kNoFormal 43
# define kFormal 44
# define kParIds 45
# define kNoParId 46
# define kParId 47
# define kType 48
# define kVector 49
# define kArray 50
# define kRecord 51
# define kSetType 52
# define kPointer 53
# define kProcType 54
# define kSimpleType 55
# define kEnumeration 56
# define kSubrange 57
# define kPrimaryType 58
# define kVoid 59
# define kTypeId 60
# define kTypeId0 61
# define kTypeId1 62
# define kFields 63
# define kNoField 64
# define kField 65
# define kRecordSect 66
# define kVariantSect 67
# define kFieldIds 68
# define kNoFieldId 69
# define kFieldId 70
# define kTagField 71
# define kTagField1 72
# define kTagField2 73
# define kVariants 74
# define kNoVariant 75
# define kVariant 76
# define kFormalTypes 77
# define kNoFormalType 78
# define kFormalType 79
# define kEnumIds 80
# define kNoEnumId 81
# define kEnumId 82
# define kExpr 83
# define kNoExpr 84
# define kMultiples 85
# define kLastMultiple 86
# define kMultiple 87
# define kBinary 88
# define kUnary 89
# define kIntConst 90
# define kRealConst 91
# define kStringConst 92
# define kCharConst 93
# define kFuncCall 94
# define kMove 95
# define kReceive 96
# define kReduce 97
# define kSet 98
# define kBitSet 99
# define kDesignator 100
# define kQualid 101
# define kQualid0 102
# define kQualid1 103
# define kProcessor 104
# define kDimensions 105
# define kSelect 106
# define kSubscript 107
# define kDeref 108
# define kDirSpec 109
# define kFuncSpec 110
# define kProcSpec 111
# define kDimSpec 112
# define kElems 113
# define kNoElem 114
# define kElem 115
# define kElemExpr 116
# define kElemRange 117
# define kActuals 118
# define kNoActual 119
# define kActual 120
# define kActualExpr 121
# define kActualRange 122
# define kActualReduce 123
# define kActualStar 124
# define kStmts 125
# define kNoStmt 126
# define kStmt 127
# define kAssign 128
# define kCall 129
# define kIf 130
# define kCase 131
# define kWhile 132
# define kRepeat 133
# define kLoop 134
# define kLooppar 135
# define kFor 136
# define kWith 137
# define kAll 138
# define kSend 139
# define kLoad 140
# define kStore 141
# define kExit 142
# define kReturn0 143
# define kReturn1 144
# define kElsifs 145
# define kNoElsif 146
# define kElsif 147
# define kCases 148
# define kNoCase 149
# define kCases1 150
# define kLabels 151
# define kNoLabel 152
# define kLabel 153
# define kLabelExpr 154
# define kLabelRange 155

typedef unsigned char Tree_tKind;
typedef unsigned short Tree_tMark;
typedef unsigned short Tree_tLabel;
typedef union Tree_Node * tTree;
typedef void (* Tree_tProcTree) ();
/* line 35 "parallaxis.cg" */

					/* Kind of compilation unit: 	*/
# define ModTypeDef      1              /* "DEFINITION MODULE" 		*/
# define ModTypeFor      2		/* "FOREIGN MODULE" 		*/
# define ModTypeImp      3		/* "IMPLEMENTATION MODULE" 	*/
# define ModTypeProg     4		/* (Program-) "MODULE" 		*/

					/* Operators: 			*/
# define OpEqual         1              /* equal: 	     "="	*/
# define OpNotEqual      2		/* not equal:	     "<>", "#" 	*/
# define OpLess          3		/* less:	     "<"	*/
# define OpLessEqual     4		/* less or equal:    "<="	*/
# define OpGreater       5		/* greater:	     ">"	*/
# define OpGreaterEqual  6		/* greater or equal: ">="	*/
# define OpIn            7		/* in:		     "IN"	*/
# define OpPlus          8		/* plus:	     "+"	*/
# define OpMinus         9		/* minus:	     "-"	*/
# define OpOr           10		/* logical or:	     "OR"	*/
# define OpTimes        11		/* times:	     "*"	*/
# define OpDivide       12		/* divide:	     "/"	*/
# define OpDiv          13		/* integer divide:   "DIV"	*/
# define OpMod          14		/* integer modulo:   "MOD"	*/
# define OpAnd          15		/* logical and:	     "AND", "&"	*/
# define OpPower        16		/* power:	     "**"	*/
# define OpNot          17		/* logical not:	     "NOT", "~"	*/

					/* Kind of integer constant:	*/
# define IntDecimal      1              /* decimal constant		*/
# define IntOctal        2		/* octal constant		*/
# define IntHexadecimal  3		/* hexadecimal constant		*/

extern tTree NoExpr;
extern tTree NoQualid;
extern tTree Tree_Integer;
extern tTree Tree_Boolean;
extern tTree Tree_Char;

extern tPosition Tree_LeftmostPos( tTree expr );
extern char     *Tree_DesignatorName( tTree designator, char *buffer );


# ifndef Tree_NodeHead
# define Tree_NodeHead
# endif
typedef struct { Tree_tKind yyKind; Tree_tMark yyMark; Tree_NodeHead } Tree_tNodeHead;
typedef struct { Tree_tNodeHead yyHead; tTree CompUnits; } yROOT;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tVoid Objects2; tObjects Objects3; tVoid Objects4In; tVoid Objects4Out; tEnv Env1; tVoid Env2; tEnv Env3; INDEX ConfigGroupIn; tIdent ImplIdent; tObjects ImplTypes; INDEX PosIn; INDEX PosOut; tIdents IdsIn; tIdents IdsOut; } yCompUnits;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tVoid Objects2; tObjects Objects3; tVoid Objects4In; tVoid Objects4Out; tEnv Env1; tVoid Env2; tEnv Env3; INDEX ConfigGroupIn; tIdent ImplIdent; tObjects ImplTypes; INDEX PosIn; INDEX PosOut; tIdents IdsIn; tIdents IdsOut; } yNoCompUnit;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tVoid Objects2; tObjects Objects3; tVoid Objects4In; tVoid Objects4Out; tEnv Env1; tVoid Env2; tEnv Env3; INDEX ConfigGroupIn; tIdent ImplIdent; tObjects ImplTypes; INDEX PosIn; INDEX PosOut; tIdents IdsIn; tIdents IdsOut; tTree Next; INDEX Kind; tIdent Ident; tPosition Pos; tObject Object; tIdent RealName; } yCompUnit;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tVoid Objects2; tObjects Objects3; tVoid Objects4In; tVoid Objects4Out; tEnv Env1; tVoid Env2; tEnv Env3; INDEX ConfigGroupIn; tIdent ImplIdent; tObjects ImplTypes; INDEX PosIn; INDEX PosOut; tIdents IdsIn; tIdents IdsOut; tTree Next; INDEX Kind; tIdent Ident; tPosition Pos; tObject Object; tIdent RealName; tTree Imports; tTree Exports; tTree Decls; } yDefMod;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tVoid Objects2; tObjects Objects3; tVoid Objects4In; tVoid Objects4Out; tEnv Env1; tVoid Env2; tEnv Env3; INDEX ConfigGroupIn; tIdent ImplIdent; tObjects ImplTypes; INDEX PosIn; INDEX PosOut; tIdents IdsIn; tIdents IdsOut; tTree Next; INDEX Kind; tIdent Ident; tPosition Pos; tObject Object; tIdent RealName; tTree Imports; tTree Decls; tTree Stmts; tPosition BeginPos; tObjects DefObjects1; tObjects DefObjects3; tCObjects GlobalPtrs; tStrings Strings; } yImplMod;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tObjects Objects2; tEnv Env1; tEnv Env2; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; } yImports;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tObjects Objects2; tEnv Env1; tEnv Env2; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; } yNoImport;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tObjects Objects2; tEnv Env1; tEnv Env2; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; tTree Next; } yImport;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tObjects Objects2; tEnv Env1; tEnv Env2; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; tTree Next; tIdent Ident; tPosition Pos; tTree ImpIds; tObject Object1; tObject Object2; } yFrom;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tObjects Objects2; tEnv Env1; tEnv Env2; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; tTree Next; tTree ImpIds; } yObjects;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tObjects Objects2; tEnv Env1; tEnv Env2; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; } yImpIds;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tObjects Objects2; tEnv Env1; tEnv Env2; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; } yNoImpId;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tObjects Objects2; tEnv Env1; tEnv Env2; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; tTree Next; tIdent Ident; tPosition Pos; tType Type; tObject Object1; tObject Object2; BOOLEAN IsRedeclared; } yImpId;
typedef struct { Tree_tNodeHead yyHead; } yExports;
typedef struct { Tree_tNodeHead yyHead; } yNoExport;
typedef struct { Tree_tNodeHead yyHead; BOOLEAN Qualified; tTree ExpIds; } yExport;
typedef struct { Tree_tNodeHead yyHead; } yExpIds;
typedef struct { Tree_tNodeHead yyHead; } yNoExpId;
typedef struct { Tree_tNodeHead yyHead; tTree Next; tIdent Ident; tPosition Pos; } yExpId;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tVoid Objects2; tObjects Objects3; tObjects Objects4In; tObjects Objects4Out; tEnv Env1; tVoid Env2; tEnv Env3; tEnv Env4; INDEX ConfigGroupIn; INDEX ConfigGroupOut; tObjects DefTypes; tObjects DefObjects; tObjects ImplTypes; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tConnects ConnectsIn; tConnects ConnectsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; INDEX Level; BOOLEAN GlobalPtrs; } yDecls;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tVoid Objects2; tObjects Objects3; tObjects Objects4In; tObjects Objects4Out; tEnv Env1; tVoid Env2; tEnv Env3; tEnv Env4; INDEX ConfigGroupIn; INDEX ConfigGroupOut; tObjects DefTypes; tObjects DefObjects; tObjects ImplTypes; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tConnects ConnectsIn; tConnects ConnectsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; INDEX Level; BOOLEAN GlobalPtrs; } yNoDecl;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tVoid Objects2; tObjects Objects3; tObjects Objects4In; tObjects Objects4Out; tEnv Env1; tVoid Env2; tEnv Env3; tEnv Env4; INDEX ConfigGroupIn; INDEX ConfigGroupOut; tObjects DefTypes; tObjects DefObjects; tObjects ImplTypes; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tConnects ConnectsIn; tConnects ConnectsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; INDEX Level; BOOLEAN GlobalPtrs; tTree Next; } yDecl;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tVoid Objects2; tObjects Objects3; tObjects Objects4In; tObjects Objects4Out; tEnv Env1; tVoid Env2; tEnv Env3; tEnv Env4; INDEX ConfigGroupIn; INDEX ConfigGroupOut; tObjects DefTypes; tObjects DefObjects; tObjects ImplTypes; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tConnects ConnectsIn; tConnects ConnectsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; INDEX Level; BOOLEAN GlobalPtrs; tTree Next; tTree VarIds; tTree Type; BOOLEAN IsGlobal; } yVar;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tVoid Objects2; tObjects Objects3; tObjects Objects4In; tObjects Objects4Out; tEnv Env1; tVoid Env2; tEnv Env3; tEnv Env4; INDEX ConfigGroupIn; INDEX ConfigGroupOut; tObjects DefTypes; tObjects DefObjects; tObjects ImplTypes; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tConnects ConnectsIn; tConnects ConnectsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; INDEX Level; BOOLEAN GlobalPtrs; tTree Next; tIdent Ident; tPosition Pos; tIdent CIdent; BOOLEAN IsRedeclared; } yObject;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tVoid Objects2; tObjects Objects3; tObjects Objects4In; tObjects Objects4Out; tEnv Env1; tVoid Env2; tEnv Env3; tEnv Env4; INDEX ConfigGroupIn; INDEX ConfigGroupOut; tObjects DefTypes; tObjects DefObjects; tObjects ImplTypes; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tConnects ConnectsIn; tConnects ConnectsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; INDEX Level; BOOLEAN GlobalPtrs; tTree Next; tIdent Ident; tPosition Pos; tIdent CIdent; BOOLEAN IsRedeclared; tTree From; tTree To; tTree ConnectDecls; tObject Object; } yConnectFrom;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tVoid Objects2; tObjects Objects3; tObjects Objects4In; tObjects Objects4Out; tEnv Env1; tVoid Env2; tEnv Env3; tEnv Env4; INDEX ConfigGroupIn; INDEX ConfigGroupOut; tObjects DefTypes; tObjects DefObjects; tObjects ImplTypes; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tConnects ConnectsIn; tConnects ConnectsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; INDEX Level; BOOLEAN GlobalPtrs; tTree Next; tIdent Ident; tPosition Pos; tIdent CIdent; BOOLEAN IsRedeclared; tTree Index; BOOLEAN BiDirectional; tTree Config; tTree Actuals; tTree DirIn; tObject Object; tObjects IndexObjects; tObject LeftConfigObj; tObject RightConfigObj; tValue IndexVal; BOOLEAN FirstDeclaration; tIdent PrevCIdent; } yConnectDecls;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tVoid Objects2; tObjects Objects3; tObjects Objects4In; tObjects Objects4Out; tEnv Env1; tVoid Env2; tEnv Env3; tEnv Env4; INDEX ConfigGroupIn; INDEX ConfigGroupOut; tObjects DefTypes; tObjects DefObjects; tObjects ImplTypes; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tConnects ConnectsIn; tConnects ConnectsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; INDEX Level; BOOLEAN GlobalPtrs; tTree Next; tIdent Ident; tPosition Pos; tIdent CIdent; BOOLEAN IsRedeclared; tTree Actuals; BOOLEAN Respecified; tTree Qualid; tObject Object; tType Type; INDEX NewConfigGroup; tObject View; BOOLEAN HasVariableSize; } yConfig;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tVoid Objects2; tObjects Objects3; tObjects Objects4In; tObjects Objects4Out; tEnv Env1; tVoid Env2; tEnv Env3; tEnv Env4; INDEX ConfigGroupIn; INDEX ConfigGroupOut; tObjects DefTypes; tObjects DefObjects; tObjects ImplTypes; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tConnects ConnectsIn; tConnects ConnectsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; INDEX Level; BOOLEAN GlobalPtrs; tTree Next; tIdent Ident; tPosition Pos; tIdent CIdent; BOOLEAN IsRedeclared; tTree Expr; tObject Object; } yConst;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tVoid Objects2; tObjects Objects3; tObjects Objects4In; tObjects Objects4Out; tEnv Env1; tVoid Env2; tEnv Env3; tEnv Env4; INDEX ConfigGroupIn; INDEX ConfigGroupOut; tObjects DefTypes; tObjects DefObjects; tObjects ImplTypes; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tConnects ConnectsIn; tConnects ConnectsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; INDEX Level; BOOLEAN GlobalPtrs; tTree Next; tIdent Ident; tPosition Pos; tIdent CIdent; BOOLEAN IsRedeclared; tTree Type; tObject Object; tType Type1; tType Type2; } yTypeDecl;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tVoid Objects2; tObjects Objects3; tObjects Objects4In; tObjects Objects4Out; tEnv Env1; tVoid Env2; tEnv Env3; tEnv Env4; INDEX ConfigGroupIn; INDEX ConfigGroupOut; tObjects DefTypes; tObjects DefObjects; tObjects ImplTypes; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tConnects ConnectsIn; tConnects ConnectsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; INDEX Level; BOOLEAN GlobalPtrs; tTree Next; tIdent Ident; tPosition Pos; tIdent CIdent; BOOLEAN IsRedeclared; tTree Formals; tTree ResultType; tTree Decls; tTree Stmts; tPosition BeginPos; tObject Object; tType Type; BOOLEAN HasOpenVector; tCObjects ValueOpens; tCObjects VAROpens; tCObjects LocalPtrs; tStrings Strings; } yProc;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tVoid Objects2; tObjects Objects3; tObjects Objects4In; tObjects Objects4Out; tEnv Env1; tVoid Env2; tEnv Env3; tEnv Env4; INDEX ConfigGroupIn; INDEX ConfigGroupOut; tObjects DefTypes; tObjects DefObjects; tObjects ImplTypes; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tConnects ConnectsIn; tConnects ConnectsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; INDEX Level; BOOLEAN GlobalPtrs; tTree Next; tIdent Ident; tPosition Pos; tIdent CIdent; BOOLEAN IsRedeclared; tTree Formals; tTree ResultType; tObject Object; tType Type; BOOLEAN HasOpenVector; } yProcHead;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tVoid Objects2; tObjects Objects3; tObjects Objects4In; tObjects Objects4Out; tEnv Env1; tVoid Env2; tEnv Env3; tEnv Env4; INDEX ConfigGroupIn; INDEX ConfigGroupOut; tObjects DefTypes; tObjects DefObjects; tObjects ImplTypes; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tConnects ConnectsIn; tConnects ConnectsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; INDEX Level; BOOLEAN GlobalPtrs; tTree Next; tIdent Ident; tPosition Pos; tIdent CIdent; BOOLEAN IsRedeclared; tObject Object; tType Type1; tType FullType; tType Type2; } yOpaque;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tVoid Objects2; tObjects Objects3; tObjects Objects4In; tObjects Objects4Out; tObject LeftConfigObj; tObject RightConfigObj; tEnv Env1; tVoid Env2; tEnv Env3; tEnv Env4; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tConnects ConnectsIn; tConnects ConnectsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX Level; } yConnectDests;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tVoid Objects2; tObjects Objects3; tObjects Objects4In; tObjects Objects4Out; tObject LeftConfigObj; tObject RightConfigObj; tEnv Env1; tVoid Env2; tEnv Env3; tEnv Env4; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tConnects ConnectsIn; tConnects ConnectsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX Level; } yNoConnectDest;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tVoid Objects2; tObjects Objects3; tObjects Objects4In; tObjects Objects4Out; tObject LeftConfigObj; tObject RightConfigObj; tEnv Env1; tVoid Env2; tEnv Env3; tEnv Env4; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tConnects ConnectsIn; tConnects ConnectsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX Level; tTree Next; tTree Expr; tTree Config; tTree Actuals; tIdent DestDimId; tIdent DestIdsId; } yConnectDest;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tVoid Objects2; tObjects Objects3; tObjects Objects4In; tObjects Objects4Out; tObject LeftConfigObj; tObject RightConfigObj; tEnv Env1; tVoid Env2; tEnv Env3; tEnv Env4; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tConnects ConnectsIn; tConnects ConnectsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX Level; tTree Next; tTree Expr; tTree Config; tTree Actuals; tIdent DestDimId; tIdent DestIdsId; } yConnectDestUni;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects1; tVoid Objects2; tObjects Objects3; tObjects Objects4In; tObjects Objects4Out; tObject LeftConfigObj; tObject RightConfigObj; tEnv Env1; tVoid Env2; tEnv Env3; tEnv Env4; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tConnects ConnectsIn; tConnects ConnectsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX Level; tTree Next; tTree Expr; tTree Config; tTree Actuals; tIdent DestDimId; tIdent DestIdsId; tIdent Ident; tPosition Pos; tTree Index; tObject Object; tValue IndexVal; tIdent CIdent; BOOLEAN FirstDeclaration; tIdent PrevCIdent; tIdent BiDirIdsId; tIdent IsinBiDirConnId; } yConnectDestBi;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tType Type; ADDRESS TypeTree; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX Level; } yVarIds;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tType Type; ADDRESS TypeTree; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX Level; } yNoVarId;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tType Type; ADDRESS TypeTree; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX Level; tTree Next; tIdent Ident; tPosition Pos; tObject Object; tIdent CIdent; BOOLEAN IsRedeclared; } yVarId;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tTypes Types; tEnv Env1; tVoid Env2; tEnv Env3; BOOLEAN HasOpenVector; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX Level; } yFormals;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tTypes Types; tEnv Env1; tVoid Env2; tEnv Env3; BOOLEAN HasOpenVector; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX Level; } yNoFormal;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tTypes Types; tEnv Env1; tVoid Env2; tEnv Env3; BOOLEAN HasOpenVector; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX Level; tTree Next; BOOLEAN IsVAR; tTree ParIds; tTree Type; } yFormal;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tType Type; ADDRESS TypeTree; BOOLEAN IsVAR; tType TypesIn; tTypes TypesOut; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX Level; } yParIds;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tType Type; ADDRESS TypeTree; BOOLEAN IsVAR; tType TypesIn; tTypes TypesOut; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX Level; } yNoParId;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tType Type; ADDRESS TypeTree; BOOLEAN IsVAR; tType TypesIn; tTypes TypesOut; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX Level; tTree Next; tIdent Ident; tPosition Pos; tObject Object; tIdent CIdent; BOOLEAN IsRedeclared; } yParId;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tObject TypeObj; tType Type1; tType Type2; tEnv Env1; tVoid Env2; tEnv Env3; BOOLEAN IsInArray; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; BOOLEAN HasVariableSize; BOOLEAN ContainsVector; } yType;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tObject TypeObj; tType Type1; tType Type2; tEnv Env1; tVoid Env2; tEnv Env3; BOOLEAN IsInArray; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; BOOLEAN HasVariableSize; BOOLEAN ContainsVector; BOOLEAN IsOpen; tTree Config; tTree Scalar; } yVector;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tObject TypeObj; tType Type1; tType Type2; tEnv Env1; tVoid Env2; tEnv Env3; BOOLEAN IsInArray; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; BOOLEAN HasVariableSize; BOOLEAN ContainsVector; BOOLEAN IsOpen; tTree Index; tTree ElemType; } yArray;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tObject TypeObj; tType Type1; tType Type2; tEnv Env1; tVoid Env2; tEnv Env3; BOOLEAN IsInArray; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; BOOLEAN HasVariableSize; BOOLEAN ContainsVector; tTree Fields; } yRecord;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tObject TypeObj; tType Type1; tType Type2; tEnv Env1; tVoid Env2; tEnv Env3; BOOLEAN IsInArray; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; BOOLEAN HasVariableSize; BOOLEAN ContainsVector; tTree BaseType; } ySetType;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tObject TypeObj; tType Type1; tType Type2; tEnv Env1; tVoid Env2; tEnv Env3; BOOLEAN IsInArray; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; BOOLEAN HasVariableSize; BOOLEAN ContainsVector; tTree TargetType; INDEX TypePos; } yPointer;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tObject TypeObj; tType Type1; tType Type2; tEnv Env1; tVoid Env2; tEnv Env3; BOOLEAN IsInArray; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; BOOLEAN HasVariableSize; BOOLEAN ContainsVector; tTree FormalTypes; tTree ResultType; } yProcType;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tObject TypeObj; tType Type1; tType Type2; tEnv Env1; tVoid Env2; tEnv Env3; BOOLEAN IsInArray; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; BOOLEAN HasVariableSize; BOOLEAN ContainsVector; } ySimpleType;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tObject TypeObj; tType Type1; tType Type2; tEnv Env1; tVoid Env2; tEnv Env3; BOOLEAN IsInArray; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; BOOLEAN HasVariableSize; BOOLEAN ContainsVector; tTree EnumIds; tType Type0; } yEnumeration;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tObject TypeObj; tType Type1; tType Type2; tEnv Env1; tVoid Env2; tEnv Env3; BOOLEAN IsInArray; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; BOOLEAN HasVariableSize; BOOLEAN ContainsVector; tTree BaseType; tTree Lwb; tTree Upb; tType Type3; } ySubrange;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tObject TypeObj; tType Type1; tType Type2; tEnv Env1; tVoid Env2; tEnv Env3; BOOLEAN IsInArray; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; BOOLEAN HasVariableSize; BOOLEAN ContainsVector; } yPrimaryType;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tObject TypeObj; tType Type1; tType Type2; tEnv Env1; tVoid Env2; tEnv Env3; BOOLEAN IsInArray; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; BOOLEAN HasVariableSize; BOOLEAN ContainsVector; } yVoid;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tObject TypeObj; tType Type1; tType Type2; tEnv Env1; tVoid Env2; tEnv Env3; BOOLEAN IsInArray; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; BOOLEAN HasVariableSize; BOOLEAN ContainsVector; tIdent Ident; tPosition Pos; tObject Object; } yTypeId;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tObject TypeObj; tType Type1; tType Type2; tEnv Env1; tVoid Env2; tEnv Env3; BOOLEAN IsInArray; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; BOOLEAN HasVariableSize; BOOLEAN ContainsVector; tIdent Ident; tPosition Pos; tObject Object; } yTypeId0;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tObject TypeObj; tType Type1; tType Type2; tEnv Env1; tVoid Env2; tEnv Env3; BOOLEAN IsInArray; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; BOOLEAN HasVariableSize; BOOLEAN ContainsVector; tIdent Ident; tPosition Pos; tObject Object; tTree TypeId; } yTypeId1;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tObjects FieldsIn; tObjects FieldsOut; tEnv Env1; tVoid Env2; tEnv Env3; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; INDEX nUnion; tSelectors Select; BOOLEAN ContainsVector; } yFields;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tObjects FieldsIn; tObjects FieldsOut; tEnv Env1; tVoid Env2; tEnv Env3; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; INDEX nUnion; tSelectors Select; BOOLEAN ContainsVector; } yNoField;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tObjects FieldsIn; tObjects FieldsOut; tEnv Env1; tVoid Env2; tEnv Env3; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; INDEX nUnion; tSelectors Select; BOOLEAN ContainsVector; tTree Next; } yField;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tObjects FieldsIn; tObjects FieldsOut; tEnv Env1; tVoid Env2; tEnv Env3; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; INDEX nUnion; tSelectors Select; BOOLEAN ContainsVector; tTree Next; tTree FieldIds; tTree Type; } yRecordSect;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tObjects FieldsIn; tObjects FieldsOut; tEnv Env1; tVoid Env2; tEnv Env3; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; INDEX nUnion; tSelectors Select; BOOLEAN ContainsVector; tTree Next; tTree TagField; tTree Variants; tTree Else; tIdent UnionId; tIdent ElseId; } yVariantSect;
typedef struct { Tree_tNodeHead yyHead; tType Type; tObjects FieldsIn; tObjects FieldsOut; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; tSelectors Select; } yFieldIds;
typedef struct { Tree_tNodeHead yyHead; tType Type; tObjects FieldsIn; tObjects FieldsOut; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; tSelectors Select; } yNoFieldId;
typedef struct { Tree_tNodeHead yyHead; tType Type; tObjects FieldsIn; tObjects FieldsOut; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; tSelectors Select; tTree Next; tIdent Ident; tPosition Pos; tObject Object; tIdent CIdent; BOOLEAN IsRedeclared; } yFieldId;
typedef struct { Tree_tNodeHead yyHead; tTree Type; tObjects FieldsIn; tObjects FieldsOut; tEnv Env1; tVoid Env2; tEnv Env3; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; tSelectors Select; } yTagField;
typedef struct { Tree_tNodeHead yyHead; tTree Type; tObjects FieldsIn; tObjects FieldsOut; tEnv Env1; tVoid Env2; tEnv Env3; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; tSelectors Select; } yTagField1;
typedef struct { Tree_tNodeHead yyHead; tTree Type; tObjects FieldsIn; tObjects FieldsOut; tEnv Env1; tVoid Env2; tEnv Env3; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; tSelectors Select; tIdent Ident; tObject Object; tIdent CIdent; BOOLEAN IsRedeclared; } yTagField2;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tObjects FieldsIn; tObjects FieldsOut; tEnv Env1; tVoid Env2; tEnv Env3; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; INDEX nStruct; tSelectors Select; } yVariants;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tObjects FieldsIn; tObjects FieldsOut; tEnv Env1; tVoid Env2; tEnv Env3; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; INDEX nStruct; tSelectors Select; } yNoVariant;
typedef struct { Tree_tNodeHead yyHead; tObjects Objects3; tObjects FieldsIn; tObjects FieldsOut; tEnv Env1; tVoid Env2; tEnv Env3; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; INDEX CntIn; INDEX CntOut; INDEX nStruct; tSelectors Select; tTree Next; tTree Labels; tTree Variant; tIdent StructId; } yVariant;
typedef struct { Tree_tNodeHead yyHead; tTypes Types; tEnv Env1; tVoid Env2; tEnv Env3; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; } yFormalTypes;
typedef struct { Tree_tNodeHead yyHead; tTypes Types; tEnv Env1; tVoid Env2; tEnv Env3; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; } yNoFormalType;
typedef struct { Tree_tNodeHead yyHead; tTypes Types; tEnv Env1; tVoid Env2; tEnv Env3; INDEX PosIn; INDEX PosOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; tTree Next; BOOLEAN IsVAR; tTree Type; } yFormalType;
typedef struct { Tree_tNodeHead yyHead; tType Type; tObjects Objects; INDEX IndexIn; INDEX IndexOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; } yEnumIds;
typedef struct { Tree_tNodeHead yyHead; tType Type; tObjects Objects; INDEX IndexIn; INDEX IndexOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; } yNoEnumId;
typedef struct { Tree_tNodeHead yyHead; tType Type; tObjects Objects; INDEX IndexIn; INDEX IndexOut; INDEX Kind; tIdent Module; tIdents IdsIn; tIdents IdsOut; tLocalIds LocalIdsIn; tLocalIds LocalIdsOut; tTree Next; tIdent Ident; tPosition Pos; tObject Object; tIdent CIdent; BOOLEAN IsRedeclared; } yEnumId;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; BOOLEAN IsLval; tType Type; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN THelpVar; BOOLEAN TakeHelpVar; tIdent HelpVar; BOOLEAN IsFirstDesignator; BOOLEAN HasProcOrDimSucc; BOOLEAN WriteVectorIndex; tTree ProcOrDimSpec; BOOLEAN WriteProcOrDimIndex; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; } yExpr;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; BOOLEAN IsLval; tType Type; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN THelpVar; BOOLEAN TakeHelpVar; tIdent HelpVar; BOOLEAN IsFirstDesignator; BOOLEAN HasProcOrDimSucc; BOOLEAN WriteVectorIndex; tTree ProcOrDimSpec; BOOLEAN WriteProcOrDimIndex; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; } yNoExpr;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; BOOLEAN IsLval; tType Type; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN THelpVar; BOOLEAN TakeHelpVar; tIdent HelpVar; BOOLEAN IsFirstDesignator; BOOLEAN HasProcOrDimSucc; BOOLEAN WriteVectorIndex; tTree ProcOrDimSpec; BOOLEAN WriteProcOrDimIndex; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tTree Mop; tType MultiType; } yMultiples;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; BOOLEAN IsLval; tType Type; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN THelpVar; BOOLEAN TakeHelpVar; tIdent HelpVar; BOOLEAN IsFirstDesignator; BOOLEAN HasProcOrDimSucc; BOOLEAN WriteVectorIndex; tTree ProcOrDimSpec; BOOLEAN WriteProcOrDimIndex; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tTree Mop; tType MultiType; } yLastMultiple;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; BOOLEAN IsLval; tType Type; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN THelpVar; BOOLEAN TakeHelpVar; tIdent HelpVar; BOOLEAN IsFirstDesignator; BOOLEAN HasProcOrDimSucc; BOOLEAN WriteVectorIndex; tTree ProcOrDimSpec; BOOLEAN WriteProcOrDimIndex; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tTree Mop; tType MultiType; tPosition Pos; INDEX Operator; tTree Multiples; INDEX COperator; } yMultiple;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; BOOLEAN IsLval; tType Type; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN THelpVar; BOOLEAN TakeHelpVar; tIdent HelpVar; BOOLEAN IsFirstDesignator; BOOLEAN HasProcOrDimSucc; BOOLEAN WriteVectorIndex; tTree ProcOrDimSpec; BOOLEAN WriteProcOrDimIndex; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tPosition Pos; INDEX Operator; tTree Lop; tTree Rop; INDEX COperator; } yBinary;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; BOOLEAN IsLval; tType Type; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN THelpVar; BOOLEAN TakeHelpVar; tIdent HelpVar; BOOLEAN IsFirstDesignator; BOOLEAN HasProcOrDimSucc; BOOLEAN WriteVectorIndex; tTree ProcOrDimSpec; BOOLEAN WriteProcOrDimIndex; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tPosition Pos; INDEX Operator; tTree Mop; INDEX COperator; } yUnary;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; BOOLEAN IsLval; tType Type; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN THelpVar; BOOLEAN TakeHelpVar; tIdent HelpVar; BOOLEAN IsFirstDesignator; BOOLEAN HasProcOrDimSucc; BOOLEAN WriteVectorIndex; tTree ProcOrDimSpec; BOOLEAN WriteProcOrDimIndex; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tPosition Pos; INDEX Kind; ULONG IntVal; } yIntConst;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; BOOLEAN IsLval; tType Type; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN THelpVar; BOOLEAN TakeHelpVar; tIdent HelpVar; BOOLEAN IsFirstDesignator; BOOLEAN HasProcOrDimSucc; BOOLEAN WriteVectorIndex; tTree ProcOrDimSpec; BOOLEAN WriteProcOrDimIndex; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tPosition Pos; tStringRef RealVal; } yRealConst;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; BOOLEAN IsLval; tType Type; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN THelpVar; BOOLEAN TakeHelpVar; tIdent HelpVar; BOOLEAN IsFirstDesignator; BOOLEAN HasProcOrDimSucc; BOOLEAN WriteVectorIndex; tTree ProcOrDimSpec; BOOLEAN WriteProcOrDimIndex; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tPosition Pos; tStringRef StringVal; } yStringConst;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; BOOLEAN IsLval; tType Type; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN THelpVar; BOOLEAN TakeHelpVar; tIdent HelpVar; BOOLEAN IsFirstDesignator; BOOLEAN HasProcOrDimSucc; BOOLEAN WriteVectorIndex; tTree ProcOrDimSpec; BOOLEAN WriteProcOrDimIndex; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tPosition Pos; UCHAR CharVal; } yCharConst;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; BOOLEAN IsLval; tType Type; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN THelpVar; BOOLEAN TakeHelpVar; tIdent HelpVar; BOOLEAN IsFirstDesignator; BOOLEAN HasProcOrDimSucc; BOOLEAN WriteVectorIndex; tTree ProcOrDimSpec; BOOLEAN WriteProcOrDimIndex; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tTree Designator; tTree Actuals; } yFuncCall;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; BOOLEAN IsLval; tType Type; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN THelpVar; BOOLEAN TakeHelpVar; tIdent HelpVar; BOOLEAN IsFirstDesignator; BOOLEAN HasProcOrDimSucc; BOOLEAN WriteVectorIndex; tTree ProcOrDimSpec; BOOLEAN WriteProcOrDimIndex; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tTree DirSpec; tTree Expr; } yMove;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; BOOLEAN IsLval; tType Type; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN THelpVar; BOOLEAN TakeHelpVar; tIdent HelpVar; BOOLEAN IsFirstDesignator; BOOLEAN HasProcOrDimSucc; BOOLEAN WriteVectorIndex; tTree ProcOrDimSpec; BOOLEAN WriteProcOrDimIndex; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tTree DirSpec; tTree Expr; } yReceive;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; BOOLEAN IsLval; tType Type; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN THelpVar; BOOLEAN TakeHelpVar; tIdent HelpVar; BOOLEAN IsFirstDesignator; BOOLEAN HasProcOrDimSucc; BOOLEAN WriteVectorIndex; tTree ProcOrDimSpec; BOOLEAN WriteProcOrDimIndex; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tTree Reduce; tTree Expr; } yReduce;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; BOOLEAN IsLval; tType Type; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN THelpVar; BOOLEAN TakeHelpVar; tIdent HelpVar; BOOLEAN IsFirstDesignator; BOOLEAN HasProcOrDimSucc; BOOLEAN WriteVectorIndex; tTree ProcOrDimSpec; BOOLEAN WriteProcOrDimIndex; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tTree BaseType; tTree Elems; } ySet;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; BOOLEAN IsLval; tType Type; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN THelpVar; BOOLEAN TakeHelpVar; tIdent HelpVar; BOOLEAN IsFirstDesignator; BOOLEAN HasProcOrDimSucc; BOOLEAN WriteVectorIndex; tTree ProcOrDimSpec; BOOLEAN WriteProcOrDimIndex; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tTree Elems; } yBitSet;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; BOOLEAN IsLval; tType Type; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN THelpVar; BOOLEAN TakeHelpVar; tIdent HelpVar; BOOLEAN IsFirstDesignator; BOOLEAN HasProcOrDimSucc; BOOLEAN WriteVectorIndex; tTree ProcOrDimSpec; BOOLEAN WriteProcOrDimIndex; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; } yDesignator;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; BOOLEAN IsLval; tType Type; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN THelpVar; BOOLEAN TakeHelpVar; tIdent HelpVar; BOOLEAN IsFirstDesignator; BOOLEAN HasProcOrDimSucc; BOOLEAN WriteVectorIndex; tTree ProcOrDimSpec; BOOLEAN WriteProcOrDimIndex; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tIdent Ident; tPosition Pos; tObject Object; BOOLEAN IsGlobalPtr; } yQualid;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; BOOLEAN IsLval; tType Type; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN THelpVar; BOOLEAN TakeHelpVar; tIdent HelpVar; BOOLEAN IsFirstDesignator; BOOLEAN HasProcOrDimSucc; BOOLEAN WriteVectorIndex; tTree ProcOrDimSpec; BOOLEAN WriteProcOrDimIndex; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tIdent Ident; tPosition Pos; tObject Object; BOOLEAN IsGlobalPtr; } yQualid0;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; BOOLEAN IsLval; tType Type; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN THelpVar; BOOLEAN TakeHelpVar; tIdent HelpVar; BOOLEAN IsFirstDesignator; BOOLEAN HasProcOrDimSucc; BOOLEAN WriteVectorIndex; tTree ProcOrDimSpec; BOOLEAN WriteProcOrDimIndex; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tIdent Ident; tPosition Pos; tObject Object; BOOLEAN IsGlobalPtr; tTree Qualid; } yQualid1;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; BOOLEAN IsLval; tType Type; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN THelpVar; BOOLEAN TakeHelpVar; tIdent HelpVar; BOOLEAN IsFirstDesignator; BOOLEAN HasProcOrDimSucc; BOOLEAN WriteVectorIndex; tTree ProcOrDimSpec; BOOLEAN WriteProcOrDimIndex; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tTree Designator; tPosition Pos; tTree Proc; } yProcessor;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; BOOLEAN IsLval; tType Type; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN THelpVar; BOOLEAN TakeHelpVar; tIdent HelpVar; BOOLEAN IsFirstDesignator; BOOLEAN HasProcOrDimSucc; BOOLEAN WriteVectorIndex; tTree ProcOrDimSpec; BOOLEAN WriteProcOrDimIndex; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tTree Designator; tPosition Pos; tTree Actuals; tIdent SecondHelpVar; } yDimensions;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; BOOLEAN IsLval; tType Type; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN THelpVar; BOOLEAN TakeHelpVar; tIdent HelpVar; BOOLEAN IsFirstDesignator; BOOLEAN HasProcOrDimSucc; BOOLEAN WriteVectorIndex; tTree ProcOrDimSpec; BOOLEAN WriteProcOrDimIndex; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tTree Designator; tPosition Pos; tIdent Field; tObject Object; } ySelect;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; BOOLEAN IsLval; tType Type; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN THelpVar; BOOLEAN TakeHelpVar; tIdent HelpVar; BOOLEAN IsFirstDesignator; BOOLEAN HasProcOrDimSucc; BOOLEAN WriteVectorIndex; tTree ProcOrDimSpec; BOOLEAN WriteProcOrDimIndex; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tTree Designator; tPosition Pos; tTree Index; } ySubscript;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; BOOLEAN IsLval; tType Type; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN THelpVar; BOOLEAN TakeHelpVar; tIdent HelpVar; BOOLEAN IsFirstDesignator; BOOLEAN HasProcOrDimSucc; BOOLEAN WriteVectorIndex; tTree ProcOrDimSpec; BOOLEAN WriteProcOrDimIndex; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tTree Designator; tPosition Pos; } yDeref;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; tObject ConnectObj; INDEX Level; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; } yDirSpec;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; tObject ConnectObj; INDEX Level; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tTree DirOut; tTree DirOutIndex; tTree Step; tTree Reduce; } yFuncSpec;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; tObject ConnectObj; INDEX Level; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tTree Expr; tTree Reduce; } yProcSpec;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; tObject ConnectObj; INDEX Level; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tTree Actuals; tTree Reduce; tIdent HelpVar; tIdent SecondHelpVar; } yDimSpec;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; } yElems;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; } yNoElem;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tTree Next; } yElem;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tTree Next; tTree Elem; } yElemExpr;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tTree Next; tTree Lwb; tTree Upb; } yElemRange;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; ULONG ReduceNumber; ULONG ActualsNumber; tTypes Types; tTypes Formals; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; } yActuals;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; ULONG ReduceNumber; ULONG ActualsNumber; tTypes Types; tTypes Formals; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; } yNoActual;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; ULONG ReduceNumber; ULONG ActualsNumber; tTypes Types; tTypes Formals; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tTree Next; BOOLEAN IsVAR; tType Formal; } yActual;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; ULONG ReduceNumber; ULONG ActualsNumber; tTypes Types; tTypes Formals; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tTree Next; BOOLEAN IsVAR; tType Formal; tTree Expr; tIdent HelpVar; tIdent String; } yActualExpr;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; ULONG ReduceNumber; ULONG ActualsNumber; tTypes Types; tTypes Formals; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tTree Next; BOOLEAN IsVAR; tType Formal; tTree Lwb; tTree Upb; } yActualRange;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; ULONG ReduceNumber; ULONG ActualsNumber; tTypes Types; tTypes Formals; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tTree Next; BOOLEAN IsVAR; tType Formal; tTree Qualid; tIdent HelpVar; } yActualReduce;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; ULONG ReduceNumber; ULONG ActualsNumber; tTypes Types; tTypes Formals; INDEX Level; BOOLEAN UseHelpVar; BOOLEAN IsCConst; BOOLEAN IsP3Const; BOOLEAN OpenAccessOrCall; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tTree Next; BOOLEAN IsVAR; tType Formal; tIdent HelpVar; } yActualStar;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN IsVectorExit; tConfigs ExitConfigsIn; tConfigs ExitConfigsOut; tConfigs ReturnConfigsIn; tConfigs ReturnConfigsOut; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tType Type; } yStmts;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN IsVectorExit; tConfigs ExitConfigsIn; tConfigs ExitConfigsOut; tConfigs ReturnConfigsIn; tConfigs ReturnConfigsOut; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tType Type; } yNoStmt;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN IsVectorExit; tConfigs ExitConfigsIn; tConfigs ExitConfigsOut; tConfigs ReturnConfigsIn; tConfigs ReturnConfigsOut; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tType Type; tTree Next; tPosition Pos; } yStmt;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN IsVectorExit; tConfigs ExitConfigsIn; tConfigs ExitConfigsOut; tConfigs ReturnConfigsIn; tConfigs ReturnConfigsOut; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tType Type; tTree Next; tPosition Pos; tTree Designator; tTree Expr; } yAssign;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN IsVectorExit; tConfigs ExitConfigsIn; tConfigs ExitConfigsOut; tConfigs ReturnConfigsIn; tConfigs ReturnConfigsOut; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tType Type; tTree Next; tPosition Pos; tTree Designator; tTree Actuals; tType CheckProcs; tObject AllocOrDealloc; } yCall;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN IsVectorExit; tConfigs ExitConfigsIn; tConfigs ExitConfigsOut; tConfigs ReturnConfigsIn; tConfigs ReturnConfigsOut; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tType Type; tTree Next; tPosition Pos; tTree Cond; tTree Then; tTree Elsifs; tTree Else; } yIf;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN IsVectorExit; tConfigs ExitConfigsIn; tConfigs ExitConfigsOut; tConfigs ReturnConfigsIn; tConfigs ReturnConfigsOut; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tType Type; tTree Next; tPosition Pos; BOOLEAN Default; tTree Expr; tTree Cases; tTree Else; } yCase;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN IsVectorExit; tConfigs ExitConfigsIn; tConfigs ExitConfigsOut; tConfigs ReturnConfigsIn; tConfigs ReturnConfigsOut; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tType Type; tTree Next; tPosition Pos; tTree Cond; tTree Stmts; } yWhile;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN IsVectorExit; tConfigs ExitConfigsIn; tConfigs ExitConfigsOut; tConfigs ReturnConfigsIn; tConfigs ReturnConfigsOut; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tType Type; tTree Next; tPosition Pos; tTree Stmts; tTree Cond; } yRepeat;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN IsVectorExit; tConfigs ExitConfigsIn; tConfigs ExitConfigsOut; tConfigs ReturnConfigsIn; tConfigs ReturnConfigsOut; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tType Type; tTree Next; tPosition Pos; tTree Stmts; tConfigs ExitConfigs; } yLoop;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN IsVectorExit; tConfigs ExitConfigsIn; tConfigs ExitConfigsOut; tConfigs ReturnConfigsIn; tConfigs ReturnConfigsOut; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tType Type; tTree Next; tPosition Pos; tTree Qualid; tTree Stmts; tConfigs ExitConfigs; } yLooppar;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN IsVectorExit; tConfigs ExitConfigsIn; tConfigs ExitConfigsOut; tConfigs ReturnConfigsIn; tConfigs ReturnConfigsOut; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tType Type; tTree Next; tPosition Pos; tTree Qualid; tTree From; tTree To; tTree By; tTree Stmts; tValue ToVal; tValue ByVal; } yFor;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN IsVectorExit; tConfigs ExitConfigsIn; tConfigs ExitConfigsOut; tConfigs ReturnConfigsIn; tConfigs ReturnConfigsOut; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tType Type; tTree Next; tPosition Pos; tTree Designator; tTree Stmts; } yWith;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN IsVectorExit; tConfigs ExitConfigsIn; tConfigs ExitConfigsOut; tConfigs ReturnConfigsIn; tConfigs ReturnConfigsOut; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tType Type; tTree Next; tPosition Pos; tTree Qualid; tTree Stmts; } yAll;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN IsVectorExit; tConfigs ExitConfigsIn; tConfigs ExitConfigsOut; tConfigs ReturnConfigsIn; tConfigs ReturnConfigsOut; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tType Type; tTree Next; tPosition Pos; tTree DirSpec; tTree From; tTree To; } ySend;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN IsVectorExit; tConfigs ExitConfigsIn; tConfigs ExitConfigsOut; tConfigs ReturnConfigsIn; tConfigs ReturnConfigsOut; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tType Type; tTree Next; tPosition Pos; BOOLEAN SizeDef; tTree What; tTree From; tTree Size; } yLoad;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN IsVectorExit; tConfigs ExitConfigsIn; tConfigs ExitConfigsOut; tConfigs ReturnConfigsIn; tConfigs ReturnConfigsOut; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tType Type; tTree Next; tPosition Pos; BOOLEAN SizeDef; tTree What; tTree To; tTree Size; } yStore;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN IsVectorExit; tConfigs ExitConfigsIn; tConfigs ExitConfigsOut; tConfigs ReturnConfigsIn; tConfigs ReturnConfigsOut; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tType Type; tTree Next; tPosition Pos; } yExit;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN IsVectorExit; tConfigs ExitConfigsIn; tConfigs ExitConfigsOut; tConfigs ReturnConfigsIn; tConfigs ReturnConfigsOut; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tType Type; tTree Next; tPosition Pos; tType ResultType; } yReturn0;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN IsVectorExit; tConfigs ExitConfigsIn; tConfigs ExitConfigsOut; tConfigs ReturnConfigsIn; tConfigs ReturnConfigsOut; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tType Type; tTree Next; tPosition Pos; tTree Result; BOOLEAN OpenAccessOrCall; tType ResultType; } yReturn1;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN IsVectorExit; tConfigs ExitConfigsIn; tConfigs ExitConfigsOut; tConfigs ReturnConfigsIn; tConfigs ReturnConfigsOut; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tType Type; } yElsifs;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN IsVectorExit; tConfigs ExitConfigsIn; tConfigs ExitConfigsOut; tConfigs ReturnConfigsIn; tConfigs ReturnConfigsOut; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tType Type; } yNoElsif;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN IsVectorExit; tConfigs ExitConfigsIn; tConfigs ExitConfigsOut; tConfigs ReturnConfigsIn; tConfigs ReturnConfigsOut; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tType Type; tTree Next; tTree Cond; tTree Stmts; } yElsif;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN IsVectorExit; tConfigs ExitConfigsIn; tConfigs ExitConfigsOut; tConfigs ReturnConfigsIn; tConfigs ReturnConfigsOut; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tType Type; } yCases;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN IsVectorExit; tConfigs ExitConfigsIn; tConfigs ExitConfigsOut; tConfigs ReturnConfigsIn; tConfigs ReturnConfigsOut; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tType Type; } yNoCase;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; INDEX Level; BOOLEAN IsVectorExit; tConfigs ExitConfigsIn; tConfigs ExitConfigsOut; tConfigs ReturnConfigsIn; tConfigs ReturnConfigsOut; BOOLEAN GlobalPtrs; tStrings StrsIn; tStrings StrsOut; tType Type; tTree Next; tTree Labels; tTree Stmts; } yCases1;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; } yLabels;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; } yNoLabel;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; tTree Next; } yLabel;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; tTree Next; tTree Expr; tValue LabelVal; } yLabelExpr;
typedef struct { Tree_tNodeHead yyHead; tEnv Env; tTree Next; tTree Lwb; tTree Upb; tValue LwbVal; tValue UpbVal; } yLabelRange;

union Tree_Node {
 Tree_tKind Kind;
 Tree_tNodeHead yyHead;
 yROOT ROOT;
 yCompUnits CompUnits;
 yNoCompUnit NoCompUnit;
 yCompUnit CompUnit;
 yDefMod DefMod;
 yImplMod ImplMod;
 yImports Imports;
 yNoImport NoImport;
 yImport Import;
 yFrom From;
 yObjects Objects;
 yImpIds ImpIds;
 yNoImpId NoImpId;
 yImpId ImpId;
 yExports Exports;
 yNoExport NoExport;
 yExport Export;
 yExpIds ExpIds;
 yNoExpId NoExpId;
 yExpId ExpId;
 yDecls Decls;
 yNoDecl NoDecl;
 yDecl Decl;
 yVar Var;
 yObject Object;
 yConnectFrom ConnectFrom;
 yConnectDecls ConnectDecls;
 yConfig Config;
 yConst Const;
 yTypeDecl TypeDecl;
 yProc Proc;
 yProcHead ProcHead;
 yOpaque Opaque;
 yConnectDests ConnectDests;
 yNoConnectDest NoConnectDest;
 yConnectDest ConnectDest;
 yConnectDestUni ConnectDestUni;
 yConnectDestBi ConnectDestBi;
 yVarIds VarIds;
 yNoVarId NoVarId;
 yVarId VarId;
 yFormals Formals;
 yNoFormal NoFormal;
 yFormal Formal;
 yParIds ParIds;
 yNoParId NoParId;
 yParId ParId;
 yType Type;
 yVector Vector;
 yArray Array;
 yRecord Record;
 ySetType SetType;
 yPointer Pointer;
 yProcType ProcType;
 ySimpleType SimpleType;
 yEnumeration Enumeration;
 ySubrange Subrange;
 yPrimaryType PrimaryType;
 yVoid Void;
 yTypeId TypeId;
 yTypeId0 TypeId0;
 yTypeId1 TypeId1;
 yFields Fields;
 yNoField NoField;
 yField Field;
 yRecordSect RecordSect;
 yVariantSect VariantSect;
 yFieldIds FieldIds;
 yNoFieldId NoFieldId;
 yFieldId FieldId;
 yTagField TagField;
 yTagField1 TagField1;
 yTagField2 TagField2;
 yVariants Variants;
 yNoVariant NoVariant;
 yVariant Variant;
 yFormalTypes FormalTypes;
 yNoFormalType NoFormalType;
 yFormalType FormalType;
 yEnumIds EnumIds;
 yNoEnumId NoEnumId;
 yEnumId EnumId;
 yExpr Expr;
 yNoExpr NoExpr;
 yMultiples Multiples;
 yLastMultiple LastMultiple;
 yMultiple Multiple;
 yBinary Binary;
 yUnary Unary;
 yIntConst IntConst;
 yRealConst RealConst;
 yStringConst StringConst;
 yCharConst CharConst;
 yFuncCall FuncCall;
 yMove Move;
 yReceive Receive;
 yReduce Reduce;
 ySet Set;
 yBitSet BitSet;
 yDesignator Designator;
 yQualid Qualid;
 yQualid0 Qualid0;
 yQualid1 Qualid1;
 yProcessor Processor;
 yDimensions Dimensions;
 ySelect Select;
 ySubscript Subscript;
 yDeref Deref;
 yDirSpec DirSpec;
 yFuncSpec FuncSpec;
 yProcSpec ProcSpec;
 yDimSpec DimSpec;
 yElems Elems;
 yNoElem NoElem;
 yElem Elem;
 yElemExpr ElemExpr;
 yElemRange ElemRange;
 yActuals Actuals;
 yNoActual NoActual;
 yActual Actual;
 yActualExpr ActualExpr;
 yActualRange ActualRange;
 yActualReduce ActualReduce;
 yActualStar ActualStar;
 yStmts Stmts;
 yNoStmt NoStmt;
 yStmt Stmt;
 yAssign Assign;
 yCall Call;
 yIf If;
 yCase Case;
 yWhile While;
 yRepeat Repeat;
 yLoop Loop;
 yLooppar Looppar;
 yFor For;
 yWith With;
 yAll All;
 ySend Send;
 yLoad Load;
 yStore Store;
 yExit Exit;
 yReturn0 Return0;
 yReturn1 Return1;
 yElsifs Elsifs;
 yNoElsif NoElsif;
 yElsif Elsif;
 yCases Cases;
 yNoCase NoCase;
 yCases1 Cases1;
 yLabels Labels;
 yNoLabel NoLabel;
 yLabel Label;
 yLabelExpr LabelExpr;
 yLabelRange LabelRange;
};

extern tTree TreeRoot;
extern unsigned long Tree_HeapUsed;
extern char * Tree_PoolFreePtr, * Tree_PoolMaxPtr;
extern unsigned short Tree_NodeSize [155 + 1];
extern char * Tree_NodeName [155 + 1];

extern void (* Tree_Exit) ();
extern tTree Tree_Alloc ();
extern tTree MakeTree ARGS((Tree_tKind yyKind));
extern bool Tree_IsType ARGS((register tTree yyt, register Tree_tKind yyKind));

extern tTree mROOT ARGS((tTree pCompUnits));
extern tTree mCompUnits ARGS(());
extern tTree mNoCompUnit ARGS(());
extern tTree mCompUnit ARGS((tTree pNext, INDEX pKind, tIdent pIdent, tPosition pPos));
extern tTree mDefMod ARGS((tTree pNext, INDEX pKind, tIdent pIdent, tPosition pPos, tTree pImports, tTree pExports, tTree pDecls));
extern tTree mImplMod ARGS((tTree pNext, INDEX pKind, tIdent pIdent, tPosition pPos, tTree pImports, tTree pDecls, tTree pStmts, tPosition pBeginPos));
extern tTree mImports ARGS(());
extern tTree mNoImport ARGS(());
extern tTree mImport ARGS((tTree pNext));
extern tTree mFrom ARGS((tTree pNext, tIdent pIdent, tPosition pPos, tTree pImpIds));
extern tTree mObjects ARGS((tTree pNext, tTree pImpIds));
extern tTree mImpIds ARGS(());
extern tTree mNoImpId ARGS(());
extern tTree mImpId ARGS((tTree pNext, tIdent pIdent, tPosition pPos));
extern tTree mExports ARGS(());
extern tTree mNoExport ARGS(());
extern tTree mExport ARGS((BOOLEAN pQualified, tTree pExpIds));
extern tTree mExpIds ARGS(());
extern tTree mNoExpId ARGS(());
extern tTree mExpId ARGS((tTree pNext, tIdent pIdent, tPosition pPos));
extern tTree mDecls ARGS(());
extern tTree mNoDecl ARGS(());
extern tTree mDecl ARGS((tTree pNext));
extern tTree mVar ARGS((tTree pNext, tTree pVarIds, tTree pType));
extern tTree mObject ARGS((tTree pNext, tIdent pIdent, tPosition pPos));
extern tTree mConnectFrom ARGS((tTree pNext, tIdent pIdent, tPosition pPos, tTree pFrom, tTree pTo, tTree pConnectDecls));
extern tTree mConnectDecls ARGS((tTree pNext, tIdent pIdent, tPosition pPos, tTree pIndex, BOOLEAN pBiDirectional, tTree pConfig, tTree pActuals, tTree pDirIn));
extern tTree mConfig ARGS((tTree pNext, tIdent pIdent, tPosition pPos, tTree pActuals, BOOLEAN pRespecified, tTree pQualid));
extern tTree mConst ARGS((tTree pNext, tIdent pIdent, tPosition pPos, tTree pExpr));
extern tTree mTypeDecl ARGS((tTree pNext, tIdent pIdent, tPosition pPos, tTree pType));
extern tTree mProc ARGS((tTree pNext, tIdent pIdent, tPosition pPos, tTree pFormals, tTree pResultType, tTree pDecls, tTree pStmts, tPosition pBeginPos));
extern tTree mProcHead ARGS((tTree pNext, tIdent pIdent, tPosition pPos, tTree pFormals, tTree pResultType));
extern tTree mOpaque ARGS((tTree pNext, tIdent pIdent, tPosition pPos));
extern tTree mConnectDests ARGS(());
extern tTree mNoConnectDest ARGS(());
extern tTree mConnectDest ARGS((tTree pNext, tTree pExpr, tTree pConfig, tTree pActuals));
extern tTree mConnectDestUni ARGS((tTree pNext, tTree pExpr, tTree pConfig, tTree pActuals));
extern tTree mConnectDestBi ARGS((tTree pNext, tTree pExpr, tTree pConfig, tTree pActuals, tIdent pIdent, tPosition pPos, tTree pIndex));
extern tTree mVarIds ARGS(());
extern tTree mNoVarId ARGS(());
extern tTree mVarId ARGS((tTree pNext, tIdent pIdent, tPosition pPos));
extern tTree mFormals ARGS(());
extern tTree mNoFormal ARGS(());
extern tTree mFormal ARGS((tTree pNext, BOOLEAN pIsVAR, tTree pParIds, tTree pType));
extern tTree mParIds ARGS(());
extern tTree mNoParId ARGS(());
extern tTree mParId ARGS((tTree pNext, tIdent pIdent, tPosition pPos));
extern tTree mType ARGS(());
extern tTree mVector ARGS((BOOLEAN pIsOpen, tTree pConfig, tTree pScalar));
extern tTree mArray ARGS((BOOLEAN pIsOpen, tTree pIndex, tTree pElemType));
extern tTree mRecord ARGS((tTree pFields));
extern tTree mSetType ARGS((tTree pBaseType));
extern tTree mPointer ARGS((tTree pTargetType));
extern tTree mProcType ARGS((tTree pFormalTypes, tTree pResultType));
extern tTree mSimpleType ARGS(());
extern tTree mEnumeration ARGS((tTree pEnumIds));
extern tTree mSubrange ARGS((tTree pBaseType, tTree pLwb, tTree pUpb));
extern tTree mPrimaryType ARGS(());
extern tTree mVoid ARGS(());
extern tTree mTypeId ARGS((tIdent pIdent, tPosition pPos));
extern tTree mTypeId0 ARGS((tIdent pIdent, tPosition pPos));
extern tTree mTypeId1 ARGS((tIdent pIdent, tPosition pPos, tTree pTypeId));
extern tTree mFields ARGS(());
extern tTree mNoField ARGS(());
extern tTree mField ARGS((tTree pNext));
extern tTree mRecordSect ARGS((tTree pNext, tTree pFieldIds, tTree pType));
extern tTree mVariantSect ARGS((tTree pNext, tTree pTagField, tTree pVariants, tTree pElse));
extern tTree mFieldIds ARGS(());
extern tTree mNoFieldId ARGS(());
extern tTree mFieldId ARGS((tTree pNext, tIdent pIdent, tPosition pPos));
extern tTree mTagField ARGS((tTree pType));
extern tTree mTagField1 ARGS((tTree pType));
extern tTree mTagField2 ARGS((tTree pType, tIdent pIdent));
extern tTree mVariants ARGS(());
extern tTree mNoVariant ARGS(());
extern tTree mVariant ARGS((tTree pNext, tTree pLabels, tTree pVariant));
extern tTree mFormalTypes ARGS(());
extern tTree mNoFormalType ARGS(());
extern tTree mFormalType ARGS((tTree pNext, BOOLEAN pIsVAR, tTree pType));
extern tTree mEnumIds ARGS(());
extern tTree mNoEnumId ARGS(());
extern tTree mEnumId ARGS((tTree pNext, tIdent pIdent, tPosition pPos));
extern tTree mExpr ARGS(());
extern tTree mNoExpr ARGS(());
extern tTree mMultiples ARGS((tTree pMop));
extern tTree mLastMultiple ARGS((tTree pMop));
extern tTree mMultiple ARGS((tTree pMop, tPosition pPos, INDEX pOperator, tTree pMultiples));
extern tTree mBinary ARGS((tPosition pPos, INDEX pOperator, tTree pLop, tTree pRop));
extern tTree mUnary ARGS((tPosition pPos, INDEX pOperator, tTree pMop));
extern tTree mIntConst ARGS((tPosition pPos, INDEX pKind, ULONG pIntVal));
extern tTree mRealConst ARGS((tPosition pPos, tStringRef pRealVal));
extern tTree mStringConst ARGS((tPosition pPos, tStringRef pStringVal));
extern tTree mCharConst ARGS((tPosition pPos, UCHAR pCharVal));
extern tTree mFuncCall ARGS((tTree pDesignator, tTree pActuals));
extern tTree mMove ARGS((tTree pDirSpec, tTree pExpr));
extern tTree mReceive ARGS((tTree pDirSpec, tTree pExpr));
extern tTree mReduce ARGS((tTree pReduce, tTree pExpr));
extern tTree mSet ARGS((tTree pBaseType, tTree pElems));
extern tTree mBitSet ARGS((tTree pElems));
extern tTree mDesignator ARGS(());
extern tTree mQualid ARGS((tIdent pIdent, tPosition pPos));
extern tTree mQualid0 ARGS((tIdent pIdent, tPosition pPos));
extern tTree mQualid1 ARGS((tIdent pIdent, tPosition pPos, tTree pQualid));
extern tTree mProcessor ARGS((tTree pDesignator, tPosition pPos, tTree pProc));
extern tTree mDimensions ARGS((tTree pDesignator, tPosition pPos, tTree pActuals));
extern tTree mSelect ARGS((tTree pDesignator, tPosition pPos, tIdent pField));
extern tTree mSubscript ARGS((tTree pDesignator, tPosition pPos, tTree pIndex));
extern tTree mDeref ARGS((tTree pDesignator, tPosition pPos));
extern tTree mDirSpec ARGS(());
extern tTree mFuncSpec ARGS((tTree pDirOut, tTree pDirOutIndex, tTree pStep, tTree pReduce));
extern tTree mProcSpec ARGS((tTree pExpr, tTree pReduce));
extern tTree mDimSpec ARGS((tTree pActuals, tTree pReduce));
extern tTree mElems ARGS(());
extern tTree mNoElem ARGS(());
extern tTree mElem ARGS((tTree pNext));
extern tTree mElemExpr ARGS((tTree pNext, tTree pElem));
extern tTree mElemRange ARGS((tTree pNext, tTree pLwb, tTree pUpb));
extern tTree mActuals ARGS(());
extern tTree mNoActual ARGS(());
extern tTree mActual ARGS((tTree pNext));
extern tTree mActualExpr ARGS((tTree pNext, tTree pExpr));
extern tTree mActualRange ARGS((tTree pNext, tTree pLwb, tTree pUpb));
extern tTree mActualReduce ARGS((tTree pNext, tTree pQualid));
extern tTree mActualStar ARGS((tTree pNext));
extern tTree mStmts ARGS(());
extern tTree mNoStmt ARGS(());
extern tTree mStmt ARGS((tTree pNext, tPosition pPos));
extern tTree mAssign ARGS((tTree pNext, tPosition pPos, tTree pDesignator, tTree pExpr));
extern tTree mCall ARGS((tTree pNext, tPosition pPos, tTree pDesignator, tTree pActuals));
extern tTree mIf ARGS((tTree pNext, tPosition pPos, tTree pCond, tTree pThen, tTree pElsifs, tTree pElse));
extern tTree mCase ARGS((tTree pNext, tPosition pPos, BOOLEAN pDefault, tTree pExpr, tTree pCases, tTree pElse));
extern tTree mWhile ARGS((tTree pNext, tPosition pPos, tTree pCond, tTree pStmts));
extern tTree mRepeat ARGS((tTree pNext, tPosition pPos, tTree pStmts, tTree pCond));
extern tTree mLoop ARGS((tTree pNext, tPosition pPos, tTree pStmts));
extern tTree mLooppar ARGS((tTree pNext, tPosition pPos, tTree pQualid, tTree pStmts));
extern tTree mFor ARGS((tTree pNext, tPosition pPos, tTree pQualid, tTree pFrom, tTree pTo, tTree pBy, tTree pStmts));
extern tTree mWith ARGS((tTree pNext, tPosition pPos, tTree pDesignator, tTree pStmts));
extern tTree mAll ARGS((tTree pNext, tPosition pPos, tTree pQualid, tTree pStmts));
extern tTree mSend ARGS((tTree pNext, tPosition pPos, tTree pDirSpec, tTree pFrom, tTree pTo));
extern tTree mLoad ARGS((tTree pNext, tPosition pPos, BOOLEAN pSizeDef, tTree pWhat, tTree pFrom, tTree pSize));
extern tTree mStore ARGS((tTree pNext, tPosition pPos, BOOLEAN pSizeDef, tTree pWhat, tTree pTo, tTree pSize));
extern tTree mExit ARGS((tTree pNext, tPosition pPos));
extern tTree mReturn0 ARGS((tTree pNext, tPosition pPos));
extern tTree mReturn1 ARGS((tTree pNext, tPosition pPos, tTree pResult));
extern tTree mElsifs ARGS(());
extern tTree mNoElsif ARGS(());
extern tTree mElsif ARGS((tTree pNext, tTree pCond, tTree pStmts));
extern tTree mCases ARGS(());
extern tTree mNoCase ARGS(());
extern tTree mCases1 ARGS((tTree pNext, tTree pLabels, tTree pStmts));
extern tTree mLabels ARGS(());
extern tTree mNoLabel ARGS(());
extern tTree mLabel ARGS((tTree pNext));
extern tTree mLabelExpr ARGS((tTree pNext, tTree pExpr));
extern tTree mLabelRange ARGS((tTree pNext, tTree pLwb, tTree pUpb));

extern void WriteTreeNode ARGS((FILE * yyyf, tTree yyt));
extern void WriteTree ARGS((FILE * yyyf, tTree yyt));
extern tTree ReverseTree ARGS((tTree yyOld));
extern tTree CopyTree ARGS((tTree yyt));
extern bool CheckTree ARGS((tTree yyt));
extern void QueryTree ARGS((tTree yyt));
extern void BeginTree ();
extern void CloseTree ();

# endif
