#include <stdlib.h>
#include <stdio.h>

extern int mpl_bildbearbeiten(char *feld, int *breite, int *hoehe, int *maxgrey);

char c;
FILE *fp;
int breite, hoehe, maxgrey;

char feld[100][100];			  /* tut nur fuer 100x100 Bilder */

/*----------------------------------------------------------------------*/

/*********************************************************
 *  Bildroutinen zum Bearbeiten des Bildes in feld[][].  *
 *********************************************************/

void bildbearbeiten()
{
     callRequest(mpl_bildbearbeiten, sizeof(char *)+3*sizeof(int *), feld, &breite, &hoehe, &maxgrey);
}




/*----------------------------------------------------------------------*/

/*************************************************
 *  Bildroutinen zum Einladen eines .pgm-Files.  *
 *************************************************/

void skipwhitespace()
{
     while ((c=='\n') || (c=='#') || (c=='\t') || (c==' ') || (c=='\r'))
     {
	  if (c=='#')
	  {
	       do
	       {
		    c = fgetc(fp);
	       } while (c!='\n');
	  };
	  c = fgetc(fp);
     }
}

int getnum()
{
     int wert;
     
     wert = 0;
     do
     {
	  wert = 10*wert + c -'0';
	  c = fgetc(fp);
     } while ((c>='0') && (c<='9'));

     return wert;
}

void bildladen()
{
     char m1, m2;
     int x,y;

     fp = fopen("surf1.pgm", "r");
     m1 = fgetc(fp);
     m2 = fgetc(fp);

     printf("Zeichen: %c%c\n",m1,m2);
     
     if ((m1!='P') && (m2!='5'))
     {
	  fprintf(stderr, "Bad file format, no P5-pgm-file\n");
	  exit(-1);
     }
     c = fgetc(fp);
     skipwhitespace();
     breite = getnum();
     skipwhitespace();
     hoehe = getnum();
     skipwhitespace();
     maxgrey = getnum();

     printf("Breite: %d,  Hoehe: %d,  Maxgrey: %d\n",breite, hoehe, maxgrey);
     if ((breite>128) || (hoehe>128))
     {
	  fprintf(stderr, "Sorry, Bild zu gross! Maximal 128x128. \n");
	  exit(-1);
     }
     
     for (y=0; y<hoehe; y++)
     {
	  for (x=0; x<breite; x++)
	  {
	       c = fgetc(fp);
	       feld[y][x] = c;
	  }
     }

     fclose(fp);
}


/*----------------------------------------------------------------------*/

/**************************************************
 *  Bildroutinen zum Speichern eines .pgm-Files.  *
 **************************************************/

void bildspeichern()
{
     int x,y;

     fp = fopen("ziel.pgm","w");

     fprintf(fp, "P5\n");
     fprintf(fp, "#Claudi's und Hartmut's geniales MPL-Programm\n");
     fprintf(fp, "%d %d\n", breite, hoehe);
     fprintf(fp, "%d\n", maxgrey);
     
     for (y=0; y<hoehe; y++)
     {
	  for (x=0; x<breite; x++)
	  {
	       fprintf(fp, "%c", feld[y][x]);
	  }
     }
     fclose(fp);
}

/*----------------------------------------------------------------------*/

/*******************
 *  Hauptprogramm  *
 *******************/


void main()
{
     bildladen();
     printf("Bild geladen.\n");
     bildbearbeiten();
     printf("Bild bearbeitet.\n");
     bildspeichern();
}
