#include <mpl.h>
#include <mpddl.h>
#include <stdio.h>

MPDDLId  fid;
MPDDLVirtualization virt;
MPDDLImage image;
MPDDLParam param;
int nbits=7;
plural unsigned char pixel[1];


/*************************************************
 *  Bildroutinen zum Einladen eines .pgm-Files.  *
 *************************************************/

char c;
FILE *fp;
int breite, hoehe, maxgrey;

char feld[128][128];

void skipwhitespace()
{
     while ((c=='\n') || (c=='#') || (c=='\t') || (c==' ') || (c=='\r'))
     {
	  if (c=='#')
	  {
	       do
	       {
		    c = fgetc(fp);
	       } while (c!='\n');
	  };
	  c = fgetc(fp);
     }
}

int getnum()
{
     int wert;
     
     wert = 0;
     do
     {
	  wert = 10*wert + c -'0';
	  c = fgetc(fp);
     } while ((c>='0') && (c<='9'));

     return wert;
}

void bildladen(char *filename)
{
     char m1, m2;
     int x,y;

     fp = fopen(filename, "r");
     m1 = fgetc(fp);
     m2 = fgetc(fp);

     printf("Zeichen: %c%c\n",m1,m2);
     
     if ((m1!='P') && (m2!='5'))
     {
	  fprintf(stderr, "Bad file format, no P5-pgm-file\n");
	  exit(-1);
     }
     c = fgetc(fp);
     skipwhitespace();
     breite = getnum();
     skipwhitespace();
     hoehe = getnum();
     skipwhitespace();
     maxgrey = getnum();

     printf("Breite: %d,  Hoehe: %d,  Maxgrey: %d\n",breite, hoehe, maxgrey);
     if ((breite>128) || (hoehe>128))
     {
	  fprintf(stderr, "Sorry, Bild zu gross! Maximal 128x128. \n");
	  exit(-1);
     }
     
     for (y=0; y<hoehe; y++)
     {
	  for (x=0; x<breite; x++)
	  {
	       c = fgetc(fp);
	       feld[y][x] = c;
	  }
     }

     fclose(fp);

     pixel[0] = feld[iyproc][ixproc];
}

void fensteroeffnen(void)
{
     param.x_approx.width = nxproc;
     param.x_approx.height = nyproc;
     param.x_approx.nbits = &nbits;

     fid = MPDDLopen(8, MPDDL_DEVICE_X_APPROX, &param);

     virt = MPDDLcreateVirt(MPDDL_VIRT_2DH_8, nxproc, nyproc);

     image = MPDDLcreateImage(virt, pixel);     
}

void bildanzeigen(void)
{
     MPDDLputImage(fid, image);

     getchar();     
}

void fensterschliessen(void)
{
     MPDDLclose(fid);
}


/*----------------------------------------------------------------------*/




void main(int argc, char *argv[])
{
     plural char n,s,w,e;

     bildladen(argv[1]);
     fensteroeffnen();
     bildanzeigen();

     pixel[0] = pixel[0]-40;

     bildanzeigen();

     if (pixel[0]<128)
	  pixel[0]=0;
     else
	  pixel[0]=255;

     bildanzeigen();

     n=xnetN[1].pixel[0];
     s=xnetS[1].pixel[0];
     w=xnetW[1].pixel[0];
     e=xnetE[1].pixel[0];

     if ((pixel[0]==0) && (n==0) && (s==0) && (w==0) && (e==0))
	  pixel[0]=128;

     bildanzeigen();

     fensterschliessen();
}
