/* Dieses kleine Programm testet die 3 moeglichen Endlosschleifen in C durch */
/* und misst die benoetigten Zeiten. Es zeigt sich, dass die for-Schleife am */
/* laengsten braucht, while und do-while sind praktisch gleich schnell. */

#include <mpl.h>
#include <stdio.h>
#include <time.h>
#include <mp_time.h>

#define MAX 1000000
#define LOOPS 10

void main()
{
     int i,j;

     for (j=0; j<LOOPS; j++)
     {
	  i = MAX;
	  mpTimerStart();
	  for (;;) { if (i--==0) break; }
	  printf("for(;;): %d\n", mpTimerElapsed());
	  
	  i = MAX;
	  mpTimerStart();
	  while (1) { if (i--==0) break; }
	  printf("while(1): %d\n", mpTimerElapsed());
	  
	  i = MAX;
	  mpTimerStart();
	  do { if (i--==0) break; } while (1);
	  printf("do while(1): %d\n", mpTimerElapsed());

	  printf("\n");
     }
}
