MODULE fsdither;

FROM ImageIO IMPORT read_g_image, write_b_image, gray, binary;

CONST m=128;

CONFIGURATION bild[0..m-1],[0..m-1];

CONNECTION e:  bild[i,j] -> bild[i,j+1];
           sw: bild[i,j] -> bild[i+1,j-1];
	   s:  bild[i,j] -> bild[i+1,j];
	   se: bild[i,j] -> bild[i+1,j+1];

VAR gbild: bild OF gray;
    bbild: bild OF binary;
    obild,ibild: bild OF INTEGER;
    fehler: bild OF INTEGER;
    w, h: CARDINAL;
    done: bild OF BOOLEAN;
    fe, fsw, fs, fse: bild OF INTEGER;
    i: INTEGER;

BEGIN
  
  read_g_image(gbild, "fstestin.pgm", w, h);

  ibild := gbild;

  i := 0;
  REPEAT
    INC(i);
    WriteInt(i, 5);
    WriteLn;
    fe := 0;
    fsw := 0;
    fs := 0;
    fse := 0;
    IF ibild<127 THEN
      fehler := -ibild;
    ELSE
      fehler := 255-ibild;
    END; (*IF*)
    
    SEND.e(fehler*7 DIV 16, fe);
    SEND.sw(fehler*3 DIV 16, fsw);
    SEND.s(fehler*5 DIV 16, fs);
    SEND.se(fehler DIV 16, fse);

    ibild := gbild+fe+fsw+fs+fse;
    done := (fe+fsw+fs+fse = 0);
  UNTIL done OR (i>=m);

  bbild := ibild<127;
  write_b_image(bbild, "fstestout.pbm", w, h);

END fsdither.
