MODULE saywhat;

(* This module's purpose is to represent a more relistic image processing *)
(* program, where the number of processors available is finite.           *)
(* Images are loaded, and are then, with user prompting, have thier grey  *)
(* scales reduced.                                                        *)


CONST

  max_width     = 10;   (* maximum image width, arbitrary *)
  max_height    = 10;   (* maximum image height, arbitrary *)
  offset        = 2;    (* offset from ends of sections. *)
  pex           = 2;
  pey           = pex;  (* number of processors square rooted *)



CONFIGURATION grid [*],[*];

CONNECTION    up : grid[i,j] <-> grid[i-1,j] : down;
            left : grid[i,j] <-> grid[i,j+1] : right;

CONFIGURATION p_list = grid[1..pey],[1..pex];


TYPE image = ARRAY[1..max_height],[1..max_width] OF INTEGER;


VAR

    x,y         : INTEGER; (* The current top x,y of square *)
    num         : INTEGER;
    take2,take3       : p_list OF image;
    i,j         : INTEGER;



BEGIN
  (* This is just initialising the things *)
  num:=1;
  FOR i:=1 TO max_height DO
    FOR j:=1 TO max_width DO
      FOR x:=1 TO pex DO
      	FOR y:=1 TO pey DO
          take2<:y,x:>[i,j]:=num*(x+y*pex);
          INC(num);
        END;
      END;
    END;
  END;

  FOR x:=1 TO pex DO
    FOR y:=1 TO pey DO
      FOR i:=1 TO max_height DO
      	FOR j:=1 TO max_width DO
       	  WriteInt(take2<:y,x:>[i,j],4);WriteString(" ");
      	END;
      	WriteLn;
      END;
      WriteLn;
    END;
  END;



  (* Heres where the problem is..they all get the same answer *)

  FOR i:=2 TO max_height-1 DO
    FOR j:=2 TO max_width-1 DO
      take3[i,j]:=take2[i,j];
    END;
  END;



  (* Showing that same answer for all internal elements of indivis PE's *)

  FOR x:=1 TO pex DO
    FOR y:=1 TO pey DO
      FOR i:=1 TO max_height DO
      	FOR j:=1 TO max_width DO
      	  WriteInt(take3<:y,x:>[i,j],5);
      	END;
      	WriteLn;
      END;
      WriteLn;
    END;
  END;

  WriteInt(x,1);
  WriteInt(y,1);

END saywhat.
