(************************************************************************)
(*  Filename:    testWrite.pm						*)
(*  Author:	 Hartmut Keller						*)
(*  Last Change: Mon Sep  4 00:31:49 1995				*)
(*									*)
(*  Description:							*)
(*  ------------							*)
(*  This file contains commands which execute each possible Write com-  *)
(*  mand. Thats WriteLn, WriteInt, WriteCard, WriteReal, WriteFixPt,	*)
(*  WriteBool, Write. Each of this in scalar and parallel version.	*)
(*  One or more dimensional configurations.				*)
(*									*)
(*  REMARK:								*)
(*  This file should be written without using any other functions and 	*)
(*  procedures than the assignment. Then it can be used to check the    *)
(*  Write-routines first. When this works, the standard functions can   *)
(*  be tested using these Write-routines.				*)
(************************************************************************)

MODULE testWrite;

CONFIGURATION list[1..9];
              grid[1..3],['a'..'e'];

VAR a: INTEGER;		al: list OF INTEGER;   		ag: grid OF INTEGER;
    b: BOOLEAN;		bl: list OF BOOLEAN;		bg: grid OF BOOLEAN;
    c: CHAR;		cl: list OF CHAR;		cg: grid OF CHAR;
    d: CARDINAL;	dl: list OF CARDINAL;		dg: grid OF CARDINAL;
    e: REAL;		el: list OF REAL;		eg: grid OF REAL;
    
BEGIN
  a  := 0;
  al := -ID(list);
  ag := ID(grid);
  
  b  := FALSE;
  bl := ODD(ID(list));
  bg := (4<ID(grid)) AND (ID(grid)<12);
  
  c  := '*';
  cl := CHR(ID(list)+48);
  cg := CHR(ID(grid)+64);
  
  d  := 0;
  dl := 100+ID(list);
  dg := 200+ID(grid);

  e  := -123.4567;
  el := FLOAT(ID(list)) + FLOAT(ID(list))/100.0 + 0.1;
  eg := FLOAT(ID(grid)) + FLOAT(ID(grid))/100.0 + 0.2;

  WriteString("WriteInt:"); WriteLn;
  WriteInt(a, 5); WriteLn;
  WriteInt(al, 5); WriteLn;
  WriteInt(ag, 5); WriteLn;
  
  WriteString("WriteBool:"); WriteLn;
  WriteBool(b, 6); WriteLn;
  WriteBool(bl, 6); WriteLn;
  WriteBool(bg, 6); WriteLn;
  
  WriteString("Write:"); WriteLn;
  Write(c); WriteLn;
  Write(cl); WriteLn;
  Write(cg); WriteLn;

  WriteString("WriteCard:"); WriteLn;
  WriteCard(d, 5); WriteLn;
  WriteCard(dl, 5); WriteLn;
  WriteCard(dg, 5); WriteLn;

  WriteString("WriteReal:"); WriteLn;
  WriteReal(e, 13); WriteLn;
  WriteReal(el, 13); WriteLn;
  WriteReal(eg, 13); WriteLn;
  
  WriteString("WriteFixPt:"); WriteLn;
  WriteFixPt(e, 13, 4); WriteLn;
  WriteFixPt(el, 13, 4); WriteLn;
  WriteFixPt(eg, 13, 4); WriteLn;

END testWrite.
