(* The problem of a LOOP is the missing connection between the LOOP and the *)
(* EXIT. There are probably several nesting levels between an EXIT and the *)
(* surrounding LOOP. A goto in C/MPL does correct the stack properly, but it *)
(* does not reset the active-sets of all open nesting levels inbetween. *)
(* Ex.:	  LOOP
    	    IF <grid>
    	      WHILE <list>
		REPEAT
		   EXIT;
		UNTIL <cube>;
	      END;
    	    END;
    	  END; 
   here, EXIT has to reset the active-sets of cube, list and grid when
leaving the LOOP. Moreover it has to change the active-set of any nested
levels of the same configuration as LOOP itsef. *)

MODULE testloop;

CONFIGURATION list[0..8];

VAR x: INTEGER;
    xg: list OF INTEGER;

BEGIN
  (* scalar LOOP *)
  x := 5;
  LOOP
    x := x-2;
    IF x<1 THEN EXIT; END; (*IF*)
    x := x+1;
  END; (*LOOP*)
  
  (* parallel LOOP with all PEs active at start *)
  xg := ID(list);
  LOOP OF list DO
    xg := xg-2;
    IF xg<5 THEN EXIT; END; (*IF*)
    xg := xg+1;
  END; (*LOOP*)

  (* parallel LOOP with some PEs inactive at start *)
  xg := ID(list);
  IF (xg<4) OR (xg>6) THEN
    LOOP OF list DO
      xg := xg-2;
      IF xg<5 THEN EXIT; END; (*IF*)
      xg := xg+1;
    END; (*LOOP*)
  END; (*IF*)

END testloop.
