#ifndef _Graphics_h
#define _Graphics_h

#include "ImageIO.h"
#define Graphics_GrOK 0
#define Graphics_GrWrongWindowSize 1
#define Graphics_GrMemoryTrouble 2
#define Graphics_GrWindowCreationFailure 3
#define Graphics_GrNotExistingWindow 4
#define Graphics_GrNoWindowSelected 5
#define Graphics_GrWrongCoordinates 6
#define Graphics_GrWrongColors 7
typedef CARDINAL Graphics_window;
extern CARDINAL Graphics_GraphicsError;
extern Graphics_window Graphics_OpenWindow ARGS((CHAR title[], CARDINAL , CARDINAL width, CARDINAL height));
extern Graphics_window Graphics_OpenWindowP ARGS((CHAR title[], CARDINAL , CARDINAL width, CARDINAL height));
extern void Graphics_CloseWindow ARGS((Graphics_window window_num));
extern void Graphics_SelectWindow ARGS((Graphics_window window_num));
extern void Graphics_GetScreenSize ARGS((CARDINAL *width, CARDINAL *height));
extern void Graphics_GetWindowSize ARGS((CARDINAL *width, CARDINAL *height));
extern void Graphics_SetArea ARGS((ImageIO_color c[], CONFIGURATION OPEN_VECTOR));
extern void Graphics_SetgArea ARGS((ImageIO_gray c[], CONFIGURATION OPEN_VECTOR));
extern void Graphics_SetbArea ARGS((ImageIO_binary c[], CONFIGURATION OPEN_VECTOR));
extern void Graphics_SetAreaXYZ ARGS((ImageIO_color c[], INTEGER x, INTEGER y, INTEGER zoom, CONFIGURATION OPEN_VECTOR));
extern void Graphics_SetgAreaXYZ ARGS((ImageIO_gray c[], INTEGER x, INTEGER y, INTEGER zoom, CONFIGURATION OPEN_VECTOR));
extern void Graphics_SetbAreaXYZ ARGS((ImageIO_binary c[], INTEGER x, INTEGER y, INTEGER zoom, CONFIGURATION OPEN_VECTOR));
extern void Graphics_SetLine ARGS((ImageIO_color c[], CARDINAL C_9_line, CONFIGURATION OPEN_VECTOR));
extern void Graphics_SetgLine ARGS((ImageIO_gray c[], CARDINAL C_10_line, CONFIGURATION OPEN_VECTOR));
extern void Graphics_SetbLine ARGS((ImageIO_binary c[], CARDINAL C_11_line, CONFIGURATION OPEN_VECTOR));
extern void Graphics_SetLineZ ARGS((ImageIO_color c[], CARDINAL C_12_line, INTEGER offset, INTEGER zoom, CONFIGURATION OPEN_VECTOR));
extern void Graphics_SetgLineZ ARGS((ImageIO_gray c[], CARDINAL C_13_line, INTEGER offset, INTEGER zoom, CONFIGURATION OPEN_VECTOR));
extern void Graphics_SetbLineZ ARGS((ImageIO_binary c[], CARDINAL C_14_line, INTEGER offset, INTEGER zoom, CONFIGURATION OPEN_VECTOR));
extern void Graphics_SetColumn ARGS((ImageIO_color c[], CARDINAL col, CONFIGURATION OPEN_VECTOR));
extern void Graphics_SetgColumn ARGS((ImageIO_gray c[], CARDINAL col, CONFIGURATION OPEN_VECTOR));
extern void Graphics_SetbColumn ARGS((ImageIO_binary c[], CARDINAL col, CONFIGURATION OPEN_VECTOR));
extern void Graphics_SetColumnZ ARGS((ImageIO_color c[], CARDINAL col, INTEGER offset, INTEGER zoom, CONFIGURATION OPEN_VECTOR));
extern void Graphics_SetgColumnZ ARGS((ImageIO_gray c[], CARDINAL col, INTEGER offset, INTEGER zoom, CONFIGURATION OPEN_VECTOR));
extern void Graphics_SetbColumnZ ARGS((ImageIO_binary c[], CARDINAL col, INTEGER offset, INTEGER zoom, CONFIGURATION OPEN_VECTOR));
extern void Graphics_SetColor ARGS((ImageIO_color c));
extern void Graphics_SetgColor ARGS((ImageIO_gray c));
extern void Graphics_SetbColor ARGS((ImageIO_binary c));
extern void Graphics_SetPixel ARGS((CARDINAL x, CARDINAL y));
extern ImageIO_color Graphics_GetPixel ARGS((CARDINAL x, CARDINAL y));
extern void Graphics_Line ARGS((CARDINAL x1, CARDINAL y1, CARDINAL x2, CARDINAL y2));
extern void Graphics_DrawAt ARGS((CARDINAL x, CARDINAL y));
extern void Graphics_Draw ARGS((CHAR c));
extern void Graphics_DrawString ARGS((CHAR s[], CARDINAL ));
extern void Graphics_DrawInt ARGS((INTEGER i, INTEGER l));
extern void Graphics_DrawCard ARGS((CARDINAL c, CARDINAL l));
extern void Graphics_DrawReal ARGS((REAL r, CARDINAL l));
extern void Graphics_DrawFixPt ARGS((REAL r, CARDINAL l, CARDINAL m));
extern void Graphics_DrawBool ARGS((BOOLEAN b, CARDINAL l));
extern void Graphics_DrawLn ARGS(());
extern void BEGIN_Graphics();

#endif
