/* $Id: Scanner.c,v 2.16 1992/08/18 09:05:32 grosch rel $ */

# define bool		char
# define true		1
# define false		0
# define StdIn		0
 
# include "Scanner.h"
# include "Source.h"
# include "System.h"
# include "General.h"
# include "DynArray.h"
# include "Positions.h"
# include <stdio.h>
 
# if defined __STDC__ | defined __cplusplus
#  include <stdlib.h>
# else
/* extern char * malloc ();
   extern void free (); */
# endif

# define yyTabSpace	8

# define yyStart(State)	{ yyPreviousStart = yyStartState; yyStartState = State; }
# define yyPrevious	{ yyStateRange s = yyStartState; \
	 		yyStartState = yyPreviousStart; yyPreviousStart = s; }
# define yyEcho		{ char * yyEnd = TokenPtr + TokenLength; \
			char yyCh = * yyEnd; * yyEnd = '\0'; \
	 		(void) fputs (TokenPtr, stdout); * yyEnd = yyCh; }
# define yyLess(n)	{ yyChBufferIndex -= TokenLength - n; TokenLength = n; }
# define yyTab		yyLineStart -= yyTabSpace - 1 - ((unsigned char *) TokenPtr - yyLineStart - 1) % yyTabSpace
# define yyTab1(a)	yyLineStart -= yyTabSpace - 1 - ((unsigned char *) TokenPtr - yyLineStart + a - 1) % yyTabSpace
# define yyTab2(a,b)	yyLineStart -= yyTabSpace - 1 - ((unsigned char *) TokenPtr - yyLineStart + a - 1) % yyTabSpace
# define yyEol(Column)	{ yyLineCount ++; yyLineStart = yyChBufferIndex - 1 - Column; }
# define output(c)	(void) putchar ((int) c)
# define unput(c)	* (-- yyChBufferIndex) = c

# define yyDNoState		0
# define yyFileStackSize	16
# define yyInitBufferSize	1024 * 8 + 256
# define yyFirstCh	(unsigned char) '\0'
# define yyLastCh	(unsigned char) '\177'
# define yyEolCh	(unsigned char) '\12'
# define yyEobCh	(unsigned char) '\177'
# define yyDStateCount	37
# define yyTableSize	317
# define yyEobState	33
# define yyDefaultState	34
# define STD	1
 
static void yyExit () { Exit (1); }

typedef unsigned short	yyStateRange;
typedef struct { yyStateRange yyCheck, yyNext; } yyCombType;
 
	char *		TokenPtr	;
	short		TokenLength	;
	tScanAttribute	Attribute	;
	void		(* Scanner_Exit) () = yyExit;
 
static	yyCombType	yyComb		[yyTableSize   + 1] = {{1, 0},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 36},
{1, 35},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 37},
{1, 9},
{1, 9},
{1, 3},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{1, 9},
{3, 14},
{4, 8},
{11, 20},
{11, 20},
{11, 20},
{11, 20},
{11, 20},
{11, 20},
{11, 20},
{11, 20},
{11, 20},
{11, 20},
{12, 5},
{13, 30},
{14, 24},
{15, 7},
{16, 6},
{14, 27},
{17, 10},
{18, 5},
{19, 15},
{20, 4},
{21, 26},
{22, 29},
{23, 13},
{24, 25},
{25, 21},
{26, 11},
{27, 22},
{28, 23},
{31, 28},
{32, 33},
{0, 0},
{0, 0},
{12, 12},
{0, 0},
{12, 17},
{0, 0},
{16, 16},
{0, 0},
{0, 0},
{18, 12},
{29, 19},
{29, 19},
{29, 19},
{29, 19},
{29, 19},
{29, 19},
{29, 19},
{29, 19},
{29, 19},
{29, 19},
{30, 18},
{30, 18},
{30, 18},
{30, 18},
{30, 18},
{30, 18},
{30, 18},
{30, 18},
{30, 18},
{30, 18},
{0, 0},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{3, 31},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 16},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{10, 10},
{0, 0},
};
static	yyCombType *	yyBasePtr	[yyDStateCount + 1] = {& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [92],
& yyComb [93],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [190],
& yyComb [81],
& yyComb [129],
& yyComb [108],
& yyComb [43],
& yyComb [107],
& yyComb [133],
& yyComb [111],
& yyComb [136],
& yyComb [112],
& yyComb [113],
& yyComb [44],
& yyComb [50],
& yyComb [50],
& yyComb [51],
& yyComb [50],
& yyComb [44],
& yyComb [45],
& yyComb [46],
& yyComb [121],
& yyComb [131],
& yyComb [52],
& yyComb [31],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
& yyComb [0],
};
static	yyStateRange	yyDefault	[yyDStateCount + 1] = {0,
32,
1,
32,
32,
0,
0,
0,
0,
32,
32,
32,
32,
32,
32,
32,
10,
10,
30,
29,
11,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
0,
0,
0,
9,
9,
9,
};
static	yyStateRange	yyEobTrans	[yyDStateCount + 1] = {0,
9,
9,
0,
0,
0,
0,
0,
0,
0,
10,
0,
0,
0,
0,
0,
10,
10,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
};

static	yyStateRange	yyInitStateStack [yyInitBufferSize] = {0};
static	yyStateRange *	yyStateStack	= yyInitStateStack;
static	unsigned long	yyStateStackSize= yyInitBufferSize;
static	yyStateRange	yyStartState	= 0;
static	yyStateRange	yyPreviousStart	= 1;

static  short		yySourceFile	;
static	bool		yyEof		;
static	unsigned char *	yyChBufferPtr	;
static	unsigned char *	yyChBufferStart	;
static	unsigned long	yyChBufferSize	;
static	unsigned char *	yyChBufferIndex	= ((unsigned char *) yyComb) + 2; /* dirty trick */
static	int		yyBytesRead	;
static	int		yyLineCount	;
static	unsigned char *	yyLineStart	;

static	struct {
	short		yySourceFile	;
	bool		yyEof		;
	unsigned char *	yyChBufferPtr	;
	unsigned char *	yyChBufferStart	;
	unsigned long	yyChBufferSize	;
	unsigned char *	yyChBufferIndex	;
	int		yyBytesRead	;
	int		yyLineCount	;
	unsigned char *	yyLineStart	;
	} yyFileStack [yyFileStackSize + 1], * yyFileStackPtr = yyFileStack;

static	unsigned char	yyToLower	[] = {
'\0', '\1', '\2', '\3', '\4', '\5', '\6', '\7',
'\10', '\11', '\12', '\13', '\14', '\15', '\16', '\17',
'\20', '\21', '\22', '\23', '\24', '\25', '\26', '\27',
'\30', '\31', '\32', '\33', '\34', '\35', '\36', '\37',
' ', '!', '"', '#', '$', '%', '&', '\'', '(', ')', '*', '+', ',', '-', '.', '/',
'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '<', '=', '>', '?',
'@', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o',
'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '[', '\\', ']', '^', '_',
'`', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o',
'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~', '\177',
'\200', '\201', '\202', '\203', '\204', '\205', '\206', '\207',
'\210', '\211', '\212', '\213', '\214', '\215', '\216', '\217',
'\220', '\221', '\222', '\223', '\224', '\225', '\226', '\227',
'\230', '\231', '\232', '\233', '\234', '\235', '\236', '\237',
'\240', '\241', '\242', '\243', '\244', '\245', '\246', '\247',
'\250', '\251', '\252', '\253', '\254', '\255', '\256', '\257',
'\260', '\261', '\262', '\263', '\264', '\265', '\266', '\267',
'\270', '\271', '\272', '\273', '\274', '\275', '\276', '\277',
'\300', '\301', '\302', '\303', '\304', '\305', '\306', '\307',
'\310', '\311', '\312', '\313', '\314', '\315', '\316', '\317',
'\320', '\321', '\322', '\323', '\324', '\325', '\326', '\327',
'\330', '\331', '\332', '\333', '\334', '\335', '\336', '\337',
'\340', '\341', '\342', '\343', '\344', '\345', '\346', '\347',
'\350', '\351', '\352', '\353', '\354', '\355', '\356', '\357',
'\360', '\361', '\362', '\363', '\364', '\365', '\366', '\367',
'\370', '\371', '\372', '\373', '\374', '\375', '\376', '\377',
};

static	unsigned char	yyToUpper	[] = {
'\0', '\1', '\2', '\3', '\4', '\5', '\6', '\7',
'\10', '\11', '\12', '\13', '\14', '\15', '\16', '\17',
'\20', '\21', '\22', '\23', '\24', '\25', '\26', '\27',
'\30', '\31', '\32', '\33', '\34', '\35', '\36', '\37',
' ', '!', '"', '#', '$', '%', '&', '\'', '(', ')', '*', '+', ',', '-', '.', '/',
'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '<', '=', '>', '?',
'@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', '\\', ']', '^', '_',
'`', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '{', '|', '}', '~', '\177',
'\200', '\201', '\202', '\203', '\204', '\205', '\206', '\207',
'\210', '\211', '\212', '\213', '\214', '\215', '\216', '\217',
'\220', '\221', '\222', '\223', '\224', '\225', '\226', '\227',
'\230', '\231', '\232', '\233', '\234', '\235', '\236', '\237',
'\240', '\241', '\242', '\243', '\244', '\245', '\246', '\247',
'\250', '\251', '\252', '\253', '\254', '\255', '\256', '\257',
'\260', '\261', '\262', '\263', '\264', '\265', '\266', '\267',
'\270', '\271', '\272', '\273', '\274', '\275', '\276', '\277',
'\300', '\301', '\302', '\303', '\304', '\305', '\306', '\307',
'\310', '\311', '\312', '\313', '\314', '\315', '\316', '\317',
'\320', '\321', '\322', '\323', '\324', '\325', '\326', '\327',
'\330', '\331', '\332', '\333', '\334', '\335', '\336', '\337',
'\340', '\341', '\342', '\343', '\344', '\345', '\346', '\347',
'\350', '\351', '\352', '\353', '\354', '\355', '\356', '\357',
'\360', '\361', '\362', '\363', '\364', '\365', '\366', '\367',
'\370', '\371', '\372', '\373', '\374', '\375', '\376', '\377',
};
 
static	void	yyInitialize	();
static	void	yyErrorMessage	ARGS((int yyErrorCode));
static	char	input		();
/* line 26 "Scanner.rex" */

#include <math.h>
#include "Memory.h"
#include "StringMem.h"
#include "Idents.h"
#include "Errors.h"
void ErrorAttribute
# if defined __STDC__ | defined __cplusplus
 (int Token, tScanAttribute * pAttribute)
# else
 (Token, pAttribute) int Token; tScanAttribute * pAttribute;
# endif
{
 pAttribute->Position = Attribute.Position;
 switch (Token) {
 case /* BEGIN */ 1: 
 pAttribute->BEGIN.number = 0;
 break;
 case /* END */ 2: 
 pAttribute->END.number = 0;
 break;
 case /* OTHER */ 3: 
 pAttribute->OTHER.character= '\0';
 ;
 break;
 case /* LINE */ 4: 
 pAttribute->LINE.number = 0;
 ;
 break;
 }
}


 
int GetToken ()
{
   register	yyStateRange	yyState;
   register	yyStateRange *	yyStatePtr;
   register	unsigned char * yyChBufferIndexReg;
   register	yyCombType * *	yyBasePtrReg = yyBasePtr;
/* line 59 "Scanner.rex" */

char Word[256];
int length;

   
yyBegin:
   yyState		= yyStartState;		/* initialize */
   yyStatePtr		= & yyStateStack [1];
   yyChBufferIndexReg 	= yyChBufferIndex;
   TokenPtr	 	= (char *) yyChBufferIndexReg;
 
   /* ASSERT yyChBuffer [yyChBufferIndex] == first character */
 
yyContinue:		/* continue after sentinel or skipping blanks */
   for (;;) {		/* execute as many state transitions as possible */
					/* determine next state and get next character */
      register yyCombType * yyTablePtr = (yyBasePtrReg [yyState] + * yyChBufferIndexReg ++);
      if (yyTablePtr->yyCheck == yyState) {
	 yyState = yyTablePtr->yyNext;
	 * yyStatePtr ++ = yyState;		/* push state */
	 goto yyContinue;
      }
      yyChBufferIndexReg --;			/* reconsider character */
      if ((yyState = yyDefault [yyState]) == yyDNoState) break;
   }
 
   for (;;) {					/* search for last final state */
      TokenLength = yyChBufferIndexReg - (unsigned char *) TokenPtr;
      yyChBufferIndex = yyChBufferIndexReg;
switch (* -- yyStatePtr) {
case 8:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 73 "Scanner.rex" */
{ length = GetWord(Word); Word[length]='\0';
				  sscanf(Word+7, "%d", &Attribute.BEGIN.number); return 1;
} yy1: goto yyBegin;
case 7:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 75 "Scanner.rex" */
{ length = GetWord(Word); Word[length]='\0';
				  sscanf(Word+5, "%d", &Attribute.END.number); return 2;
} yy2: goto yyBegin;
case 6:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 77 "Scanner.rex" */
{ length = GetWord(Word); Word[length]='\0';
                                          sscanf(Word+6, "%d", &Attribute.LINE.number); return 4; 
} yy3: goto yyBegin;
case 5:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 79 "Scanner.rex" */
{ length = GetWord(Word); Word[length]='\0';
                                          sscanf(Word+6, "%d", &Attribute.LINE.number); return 4; 
} yy4: goto yyBegin;
case 3:;
case 9:;
case 35:;
case 36:;
case 37:;
Attribute.Position.Line   = yyLineCount;
Attribute.Position.Column = (unsigned char *) TokenPtr - yyLineStart;
/* line 82 "Scanner.rex" */
{ length = GetWord(Word);  Attribute.OTHER.character = *Word;return 3; 
} yy5: goto yyBegin;
case 1:;
case 2:;
case 4:;
case 10:;
case 11:;
case 12:;
case 13:;
case 14:;
case 15:;
case 16:;
case 17:;
case 18:;
case 19:;
case 20:;
case 21:;
case 22:;
case 23:;
case 24:;
case 25:;
case 26:;
case 27:;
case 28:;
case 29:;
case 30:;
case 31:;
case 32:;
	 /* non final states */
	 yyChBufferIndexReg --;			/* return character */
	 break;
 
case 34:
	 Attribute.Position.Line   = yyLineCount;
	 Attribute.Position.Column = yyChBufferIndexReg - yyLineStart;
      /* TokenLength   = 1; */
	 yyChBufferIndex = ++ yyChBufferIndexReg;
	 {
/* line 63 "Scanner.rex" */

MessageI("illegal character", xxError, Attribute.Position, xxCharacter, TokenPtr);

	 }
	 goto yyBegin;
 
      case yyDNoState:				/* automatic initialization */
	 yyInitialize ();
	 yySourceFile = StdIn;
	 goto yyBegin;

case 33:
	 yyChBufferIndex = -- yyChBufferIndexReg; /* undo last state transition */
	 if (-- TokenLength == 0) {		/* get previous state */
	    yyState = yyStartState;
	 } else {
	    yyState = * (yyStatePtr - 1);
	 }

	 if (yyChBufferIndex != & yyChBufferStart [yyBytesRead]) {
						/* end of buffer sentinel in buffer */
	    if ((yyState = yyEobTrans [yyState]) == yyDNoState) continue;
	    yyChBufferIndexReg ++;
	    * yyStatePtr ++ = yyState;		/* push state */
	    goto yyContinue;
	 }
						/* end of buffer reached */
	 {  /* copy initial part of token in front of the input buffer */
	    register char * yySource = TokenPtr;
	    register char * yyTarget = TokenPtr = (char *) & yyChBufferPtr [yyMaxAlign - TokenLength % yyMaxAlign];
	    if (yySource != yyTarget) {
	       while (yySource < (char *) yyChBufferIndexReg) * yyTarget ++ = * yySource ++;
	       yyLineStart += (unsigned char *) yyTarget - yyChBufferStart - yyBytesRead;
	       yyChBufferStart = (unsigned char *) yyTarget;
	    } else {
	       yyChBufferStart = yyChBufferIndexReg;
	    }
	 }

	 if (! yyEof) {				/* read buffer and restart */
	    int yyChBufferFree = (int) Exp2 (Log2 (yyChBufferSize - 4 - yyMaxAlign - TokenLength));
	    if (yyChBufferFree < yyChBufferSize / 8) {
	       register int yyDelta;
	       register unsigned char * yyOldChBufferPtr = yyChBufferPtr;
	       ExtendArray ((char * *) & yyChBufferPtr, & yyChBufferSize, sizeof (char));
	       if (yyChBufferPtr == NULL) yyErrorMessage (1);
	       yyDelta = yyChBufferPtr - yyOldChBufferPtr;
	       yyChBufferStart	+= yyDelta;
	       yyLineStart	+= yyDelta;
	       TokenPtr	+= yyDelta;
	       yyChBufferFree = (int) Exp2 (Log2 (yyChBufferSize - 4 - yyMaxAlign - TokenLength));
	       if (yyStateStackSize < yyChBufferSize) {
		  yyStateRange * yyOldStateStack = yyStateStack;
		  ExtendArray ((char * *) & yyStateStack, & yyStateStackSize, sizeof (yyStateRange));
		  if (yyStateStack == NULL) yyErrorMessage (1);
		  yyStatePtr	+= yyStateStack - yyOldStateStack;
	       }
	    }
	    yyChBufferIndex = yyChBufferIndexReg = yyChBufferStart;
	    yyBytesRead = GetLine (yySourceFile, (char *) yyChBufferIndex, yyChBufferFree);
	    if (yyBytesRead <= 0) { yyBytesRead = 0; yyEof = true; }
	    yyChBufferStart [yyBytesRead    ] = yyEobCh;
	    yyChBufferStart [yyBytesRead + 1] = '\0';
	    goto yyContinue;
	 }

	 if (TokenLength == 0) {		/* end of file reached */
	    Attribute.Position.Line   = yyLineCount;
	    Attribute.Position.Column = yyChBufferIndexReg - yyLineStart;
	    CloseFile ();
	    if (yyFileStackPtr == yyFileStack) {
	    }
	    if (yyFileStackPtr == yyFileStack) return EofToken;
	    goto yyBegin;
	 }
	 break;
 
      default:
	 yyErrorMessage (0);
      }
   }
}
 
void BeginFile
# if defined __STDC__ | defined __cplusplus
   (char * yyFileName)
# else
   (yyFileName) char * yyFileName;
# endif
   {
      yyInitialize ();
      yySourceFile = BeginSource (yyFileName);
   }

static void yyInitialize ()
   {
      if (yyFileStackPtr >= yyFileStack + yyFileStackSize) yyErrorMessage (2);
      yyFileStackPtr ++;			/* push file */
      yyFileStackPtr->yySourceFile	= yySourceFile		;
      yyFileStackPtr->yyEof		= yyEof			;
      yyFileStackPtr->yyChBufferPtr	= yyChBufferPtr		;
      yyFileStackPtr->yyChBufferStart	= yyChBufferStart	;
      yyFileStackPtr->yyChBufferSize	= yyChBufferSize	;
      yyFileStackPtr->yyChBufferIndex	= yyChBufferIndex	;
      yyFileStackPtr->yyBytesRead	= yyBytesRead		;
      yyFileStackPtr->yyLineCount	= yyLineCount		;
      yyFileStackPtr->yyLineStart	= yyLineStart		;
						/* initialize file state */
      yyChBufferSize	   = yyInitBufferSize;
      MakeArray ((char * *) & yyChBufferPtr, & yyChBufferSize, sizeof (char));
      if (yyChBufferPtr == NULL) yyErrorMessage (1);
      yyChBufferStart	   = & yyChBufferPtr [yyMaxAlign];
      yyChBufferStart [-1] = yyEolCh;		/* begin of line indicator */
      yyChBufferStart [ 0] = yyEobCh;		/* end of buffer sentinel */
      yyChBufferStart [ 1] = '\0';
      yyChBufferIndex	   = yyChBufferStart;
      yyEof		   = false;
      yyBytesRead	   = 0;
      yyLineCount	   = 1;
      yyLineStart	   = & yyChBufferStart [-1];
      if (yyStartState == 0) {
	 yyStartState	   = STD;
	 yyStateStack [0]  = yyDefaultState;	/* stack underflow sentinel */
      }
   }

void CloseFile ()
   {
      if (yyFileStackPtr == yyFileStack) yyErrorMessage (3);
      CloseSource (yySourceFile);
      ReleaseArray ((char * *) & yyChBufferPtr, & yyChBufferSize, sizeof (char));
						/* pop file */
      yySourceFile	= yyFileStackPtr->yySourceFile		;
      yyEof		= yyFileStackPtr->yyEof			;
      yyChBufferPtr	= yyFileStackPtr->yyChBufferPtr		;
      yyChBufferStart	= yyFileStackPtr->yyChBufferStart	;
      yyChBufferSize	= yyFileStackPtr->yyChBufferSize	;
      yyChBufferIndex	= yyFileStackPtr->yyChBufferIndex	;
      yyBytesRead	= yyFileStackPtr->yyBytesRead		;
      yyLineCount	= yyFileStackPtr->yyLineCount		;
      yyLineStart	= yyFileStackPtr->yyLineStart		;
      yyFileStackPtr --;		
   }
 
int GetWord
# if defined __STDC__ | defined __cplusplus
   (char * yyWord)
# else
   (yyWord) char * yyWord;
# endif
   {
      register char * yySource			= TokenPtr;
      register char * yyTarget			= yyWord;
      register char * yyChBufferIndexReg	= (char *) yyChBufferIndex;
   
      do {				/* ASSERT word is not empty */
	 * yyTarget ++ = * yySource ++;
      } while (yySource < yyChBufferIndexReg);
      * yyTarget = '\0';
      return yyChBufferIndexReg - TokenPtr;
   }
 
int GetLower
# if defined __STDC__ | defined __cplusplus
   (char * yyWord)
# else
   (yyWord) char * yyWord;
# endif
   {
      register char * yySource			= TokenPtr;
      register char * yyTarget			= yyWord;
      register char * yyChBufferIndexReg	= (char *) yyChBufferIndex;
   
      do {				/* ASSERT word is not empty */
	 * yyTarget ++ = yyToLower [* yySource ++];
      } while (yySource < yyChBufferIndexReg);
      * yyTarget = '\0';
      return yyChBufferIndexReg - TokenPtr;
   }
 
int GetUpper
# if defined __STDC__ | defined __cplusplus
   (char * yyWord)
# else
   (yyWord) char * yyWord;
# endif
   {
      register char * yySource			= TokenPtr;
      register char * yyTarget			= yyWord;
      register char * yyChBufferIndexReg	= (char *) yyChBufferIndex;
   
      do {				/* ASSERT word is not empty */
	 * yyTarget ++ = yyToUpper [* yySource ++];
      } while (yySource < yyChBufferIndexReg);
      * yyTarget = '\0';
      return yyChBufferIndexReg - TokenPtr;
   }
 
static char input ()
   {
      if (yyChBufferIndex == & yyChBufferStart [yyBytesRead]) {
	 if (! yyEof) {
	    yyLineStart -= yyBytesRead;
	    yyChBufferIndex = yyChBufferStart = yyChBufferPtr;
	    yyBytesRead = GetLine (yySourceFile, (char *) yyChBufferIndex,
	       (int) Exp2 (Log2 (yyChBufferSize)));
	    if (yyBytesRead <= 0) { yyBytesRead = 0; yyEof = true; }
	    yyChBufferStart [yyBytesRead    ] = yyEobCh;
	    yyChBufferStart [yyBytesRead + 1] = '\0';
	 }
      }
      if (yyChBufferIndex == & yyChBufferStart [yyBytesRead]) return '\0';
      else return * yyChBufferIndex ++;
   }

void BeginScanner ()
   {
   }
 
void CloseScanner ()
   {
   }
 
static void yyErrorMessage
# if defined __STDC__ | defined __cplusplus
   (int yyErrorCode)
# else
   (yyErrorCode) int yyErrorCode;
# endif
   {
      WritePosition (stderr, Attribute.Position);
      switch (yyErrorCode) {
      case 0: (void) fprintf (stderr, ": Scanner: internal error\n"); break;
      case 1: (void) fprintf (stderr, ": Scanner: out of memory\n"); break;
      case 2: (void) fprintf (stderr, ": Scanner: too many nested include files\n"); break;
      case 3: (void) fprintf (stderr, ": Scanner: file stack underflow (too many calls of CloseFile)\n"); break;
      }
      Scanner_Exit ();
   }
