EXPORT {
#include "Idents.h"
#include "Positions.h"
# if defined __STDC__ | defined __cplusplus
# define ARGS(parameters)	parameters
# else
# define ARGS(parameters)	()
# endif

typedef struct { tPosition yyPos; int number; } yyBEGIN;
typedef struct { tPosition yyPos; int number; } yyEND;
typedef struct { tPosition yyPos; char character; } yyOTHER;
typedef struct { tPosition yyPos; int number; } yyLINE;

typedef union {
 tPosition Position;
 yyBEGIN BEGIN;
 yyEND END;
 yyOTHER OTHER;
 yyLINE LINE;
} tScanAttribute;

extern void ErrorAttribute ARGS((int Token, tScanAttribute * pAttribute));

}
GLOBAL {
#include <math.h>
#include "Memory.h"
#include "StringMem.h"
#include "Idents.h"
#include "Errors.h"
void ErrorAttribute
# if defined __STDC__ | defined __cplusplus
 (int Token, tScanAttribute * pAttribute)
# else
 (Token, pAttribute) int Token; tScanAttribute * pAttribute;
# endif
{
 pAttribute->Position = Attribute.Position;
 switch (Token) {
 case /* BEGIN */ 1: 
 pAttribute->BEGIN.number = 0;
 break;
 case /* END */ 2: 
 pAttribute->END.number = 0;
 break;
 case /* OTHER */ 3: 
 pAttribute->OTHER.character= '\0';
 ;
 break;
 case /* LINE */ 4: 
 pAttribute->LINE.number = 0;
 ;
 break;
 }
}

}
LOCAL {
char Word[256];
int length;
}
DEFAULT {
MessageI("illegal character", xxError, Attribute.Position, xxCharacter, TokenPtr);
}


DEFINE digit = {0-9}	.
       other = ANY | \n .
RULE


"##begin" digit + "##"	:	{ length = GetWord(Word); Word[length]='\0';
				  sscanf(Word+7, "%d", &Attribute.BEGIN.number); return 1;}
"##end"   digit + "##"	:	{ length = GetWord(Word); Word[length]='\0';
				  sscanf(Word+5, "%d", &Attribute.END.number); return 2;}
"#line " digit + " " + \" ANY + \" " "* \n : { length = GetWord(Word); Word[length]='\0';
                                          sscanf(Word+6, "%d", &Attribute.LINE.number); return 4; }
"#line " digit +  " "* \n : { length = GetWord(Word); Word[length]='\0';
                                          sscanf(Word+6, "%d", &Attribute.LINE.number); return 4; }

other			:	{ length = GetWord(Word);  Attribute.OTHER.character = *Word;return 3; }

