/*************************************************************************
 *
 * Parallaxis Compiler Projects
 * ----------------------------
 *
 * name   :  parallaxis.h
 * desc   :  general type definition
 * author :  lampke
 *
 ************************************************************************/
#ifndef parallaxis_H
#define parallaxis_H

/*
 * definition CHAR & UCHAR
 */

typedef          char  CHAR;
typedef unsigned char  UCHAR;

#ifndef MAXUCHAR
#define MAXUCHAR     255
#endif

#ifndef MINUCHAR
#define MINUCHAR     0
#endif

/*
 * definition SHORT & USHORT
 */

typedef          short SHORT;
typedef unsigned short USHORT;

/*
 * definition LONG & ULONG
 */

typedef          long  LONG;
typedef unsigned long  ULONG;

#define BITSPERLONG  32

#ifndef MAXLONG
#define MAXLONG    0x7FFFFFFFL    /* 2147483647 */
#endif

#ifndef MINLONG
#define MINLONG    0x80000000L    /* -2147483648 */
#endif

#ifndef MAXULONG
#define MAXULONG   0xFFFFFFFFUL   /* 4294967295 */
#endif

#ifndef MINULONG
#define MINULONG   0
#endif

/*
 * definition REAL
 */

typedef double REAL;

#ifndef MAXREAL
#define MAXREAL       1.79769313486231470E+308
#endif

#ifndef MINREAL
#define MINREAL       4.94065645841246544E-324
#endif

/*
 * definition BOOLEAN
 */

typedef UCHAR  BOOLEAN;

#ifndef FALSE
#define FALSE   0
#endif

#ifndef TRUE
#define TRUE    1
#endif

typedef void  *ADDRESS;

#ifndef NULL
#define NULL ((ADDRESS)0)
#endif

/*
 * definition indextype
 */

typedef unsigned long INDEX;

#ifndef min
#define min(a,b)     ((a)<(b)?(a):(b))
#endif

#ifndef max
#define max(a,b)     ((a)>(b)?(a):(b))
#endif

#define ARRAYSIZE(a) (sizeof(a)/sizeof(a[0]))

#endif /* parallaxis_H */
