# include "Code.h"
# include "yyCode.w"
# include "System.h"
# include <stdio.h>
# include "Tree.h"

# define yyInline
# ifndef NULL
# define NULL 0L
# endif
# ifndef false
# define false 0
# endif
# ifndef true
# define true 1
# endif

# ifdef yyInline
# define yyALLOC(tree, free, max, alloc, nodesize, make, ptr, kind) \
  if ((ptr = (tree) free) >= (tree) max) ptr = alloc (); \
  free += nodesize [kind]; \
  ptr->yyHead.yyMark = 0; \
  ptr->Kind = kind;
# else
# define yyALLOC(tree, free, max, alloc, nodesize, make, ptr, kind) ptr = make (kind);
# endif

# define yyWrite(s) (void) fputs (s, yyf)
# define yyWriteNl (void) fputc ('\n', yyf)

/* line 57 "new_C.puma" */

/*************************************************************************
 *
 * Parallaxis Compiler Projects
 * ----------------------------
 *
 * name :  Code.c
 * desc :  generated by parallaxis.puma
 *
 ************************************************************************/
#define END_RULE
END_RULE;
#define ruturn return
#include <string.h>
#include "StringMem.h"			  /* Reuse-Library */
#include "Idents.h"			  /* Reuse-Library */
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include "Options.h"
#include "GeneralIO.h"
#include "FileIO.h"
#include "Tree.h"
#include "Symbols.h"
#include "Values.h"
#include "Types.h"
#include "AssocTab.h"
#include "GenIdents.h"
#include "Errors.h"
#include "With.h"
#include "LoopStack.h"
#include "Pointer.h"
#include "Parameter.h"

#include "parallaxis.h"

#define  MAXPREC_PREC         1
#define  CALL_PREC            1
#define  SUBSCRIPT_PREC       1
#define  SELECT_PREC          1
#define  CAST_PREC            2
#define  DEREF_PREC           3
#define  ADR_PREC             3
#define  NOT_PREC             3
#define  TIMES_PREC           4
#define  DIVIDE_PREC          4
#define  MOD_PREC             4
#define  PLUS_PREC            5
#define  MINUS_PREC           5
#define  COMPARISON_PREC      7
#define  LESS_PREC            7
#define  LESSEQUAL_PREC       7
#define  GREATER_PREC         7
#define  GREATEREQUAL_PREC    7
#define  EQUAL_PREC           8
#define  NOTEQUAL_PREC        8
#define  INTERSECTION_PREC    9
#define  SYMDIFF_PREC        10
#define  UNION_PREC          11
#define  AND_PREC            12
#define  OR_PREC             13
#define  IN_PREC             14
#define  DIFFERENCE_PREC     14
#define  ISSUBSET1_PREC      14
#define  ISSUBSET2_PREC      14
#define  ASSIGN_PREC         14
#define  PASSVALUE_PREC      14
#define  PASSADDRESS_PREC    14
#define  MINPREC_PREC        14

#define  STORAGE_AUTO                  1
#define  STORAGE_STATIC                2

#define  FULL                  TRUE
#define  NONFULL               !( FULL )
#define  BEFORE                TRUE
#define  AFTER                 !( BEFORE )
#define  STRNCPY               TRUE

FILE      *fileHandle;
unsigned short precedence[Code_PassAddress + 1];

/* indent
 *   used by WRITEBLANKS(), contains the actual number of spaces for the
 *   indent of new lines
 * indentTab
 *   used by TAB() and DETAB(), number of spaces to add or sub from the indent
 * VectorLoopCalls
 *   Number of calls to the CodeVectorLoopBegin-function. Used to make sure
 *   that Loops are not nested.
 * AssignCalls
 *   Number of calls to the CodeHelpVarAssign-function. Used to make sure that
 *   a designator list is assigned to only one temporary variable.
 * NotInActualsWrite
 *   Used to skip the processor index [PE] of variables if they are passed as
 *   parameter to a function call
 * TreeRoot
 *   This is the root of the whole tree with all compilation units. It is
 *   used to traverse all compilation units to find all generic connections
 *   for a respecified configuration.
 */
long      indent, indentTab, VectorLoopCalls, AssignCalls;
BOOLEAN   NotInActualsWrite;
tTree     TreeRoot;
tPosition debugpos;
BOOLEAN   debuglinefull;

/*
 *  Modules for special handlings
 */

/*
 *  routines for construction of designator strings
 *  used to allocate memory for open vector and generic configuration variables
 */

static char DesignatorString[2][1024];
static char DesignatorBuffer[1024];

void InitDesignatorString(unsigned long Number)
{
  DesignatorString[Number][0] = '\0';
}

void AddDesignatorString(unsigned long Number, char *Str)
{
  (void) strcat(DesignatorString[Number], Str);
}

void AddPrefixDesignatorString(unsigned long Number, char *Str)
{
  (void) strcpy(DesignatorBuffer, DesignatorString[Number]);
  (void) strcpy(DesignatorString[Number], Str);
  (void) strcat(DesignatorString[Number], DesignatorBuffer);
}

void SubDesignatorString(unsigned long Number, unsigned long Sub)
{
  DesignatorString[Number][strlen(DesignatorString[Number]) - Sub] = '\0';
}

void SubPrefixDesignatorString(unsigned long Number, unsigned long Sub)
{
  (void) strcpy(DesignatorBuffer, &(DesignatorString[Number][Sub]));
  (void) strcpy(DesignatorString[Number], DesignatorBuffer);
}

char *GetDesignatorString(unsigned long Number)
{
END_RULE;
  return DesignatorString[Number];
}


/*
 *  stack for parallel loops
 *  contains the active stack pointer and the else stack pointer of the
 *  actual parallel loop
 *  used by the EXIT statement to disactivate PEs
 */

typedef struct S_1 {
  struct S_1 *Previous;
  tTree Expr;
  tIdent ActivePtr;
  tIdent ElsePtr;
} tLoopparStack;

tLoopparStack *LoopparStack = NULL;

void LoopparStackPush(tTree Expr, tIdent ActivePtr, tIdent ElsePtr)
{
  tLoopparStack *Temp;

  Temp = (tLoopparStack *) malloc(sizeof(tLoopparStack));
  Temp->Expr = Expr;
  Temp->ActivePtr = ActivePtr;
  Temp->ElsePtr = ElsePtr;
  Temp->Previous = LoopparStack;
  LoopparStack = Temp;
}

void LoopparStackTop(tTree *Expr, tIdent *ActivePtr, tIdent *ElsePtr)
{
  *Expr = LoopparStack->Expr;
  *ActivePtr = LoopparStack->ActivePtr;
  *ElsePtr = LoopparStack->ElsePtr;
}

void LoopparStackPop()
{
  tLoopparStack *Temp;

  Temp = LoopparStack;
  LoopparStack = LoopparStack->Previous;
  free(Temp);
}

/*
 *  stack for procedures
 *  contains the list with the configurations which are involved in
 *  parallel statements in the procedure
 *  used by the RETURN statement to reset the active stack and else stack
 */

typedef struct S_2 {
  struct S_2 *Previous;
  tConfigs Configs;
} tReturnStack;

tReturnStack *ReturnStack = NULL;

void ReturnStackPush(tConfigs Configs)
{
  tReturnStack *Temp;

  Temp = (tReturnStack *) malloc(sizeof(tReturnStack));
  Temp->Configs = Configs;
  Temp->Previous = ReturnStack;
  ReturnStack = Temp;
}

void ReturnStackTop(tConfigs *Configs)
{
  *Configs = ReturnStack->Configs;
}

void ReturnStackPop()
{
  tReturnStack *Temp;

  Temp = ReturnStack;
  ReturnStack = ReturnStack->Previous;
  free(Temp);
}

/*  stack for procedures
 *  contains the local declarations
 *  it is used to store and reset the local declared configurations and
 *  connections in case of recursive calls of the procedure
 */

typedef struct S_3 {
  struct S_3 *Previous;
  tTree Declarations;
} tDeclarationStack;

tDeclarationStack *DeclarationStack = NULL;

void DeclarationStackPush(tTree Declarations)
{
  tDeclarationStack *Temp;

  Temp = (tDeclarationStack *) malloc(sizeof(tDeclarationStack));
  Temp->Declarations = Declarations;
  Temp->Previous = DeclarationStack;
  DeclarationStack = Temp;
}

void DeclarationStackTop(tTree *Declarations)
{
  *Declarations = DeclarationStack->Declarations;
}

void DeclarationStackPop()
{
  tDeclarationStack *Temp;

  Temp = DeclarationStack;
  DeclarationStack = DeclarationStack->Previous;
  free(Temp);
}

/*
 *  stack for actuals
 *  contains the reduce actuals from unstructered data exchange operations
 */

typedef struct S_4 {
  struct S_4 *Previous;
  tTree Actual;
  unsigned long ActualDimension;
} tActualStack;

tActualStack *ActualStack = NULL;

void ActualStackPush(tTree Actual, unsigned long ActualDimension)
{
  tActualStack *Temp;

  Temp = (tActualStack *) malloc(sizeof(tActualStack));
  Temp->Actual = Actual;
  Temp->ActualDimension = ActualDimension;
  Temp->Previous = ActualStack;
  ActualStack = Temp;
}

void ActualStackTop(tTree *Actual, unsigned long *ActualDimension)
{
  *Actual = ActualStack->Actual;
  *ActualDimension = ActualStack->ActualDimension;
}

void ActualStackPop()
{
  tActualStack *Temp;

  Temp = ActualStack;
  ActualStack = ActualStack->Previous;
  free(Temp);
}

/*
 *  stack for idents
 *  contains the idents for the indizes of the array(s) of LOAD and STORE
 *  and their type
 */

typedef struct S_5 {
  struct S_5 *Previous;
  tIdent Ident;
  tType Type;
} tArrayStack;

tArrayStack *ArrayStack = NULL;

void ArrayStackPush(tIdent Ident, tType Type)
{
  tArrayStack *Temp;

  Temp = (tArrayStack *) malloc(sizeof(tArrayStack));
  Temp->Ident = Ident;
  Temp->Type = Type;
  Temp->Previous = ArrayStack;
  ArrayStack = Temp;
}

tIdent ArrayStackTop(tType *Type)
{
  *Type = ArrayStack->Type;
END_RULE;
  return ArrayStack->Ident;
}

void ArrayStackPop()
{
  tArrayStack *Temp;

  Temp = ArrayStack;
  ArrayStack = ArrayStack->Previous;
  free(Temp);
}

/* Check if the translation of the Parallaxis FOR-statement
 *	FOR v := a TO b BY c DO ... END;	(b = const)
 * into the C for-statement
 *	for (v = a; v <= b; v += c) { ... }	(v >= b if c < 0)
 * would result in a over resp. underflow of the control variable v.
 * 'CtrlType' is the type of v, 'ToValue' is the value of b, and
 * 'ByValue' is the value of c.
 */
BOOLEAN OverOrUnderFlow(tType CtrlType, tValue ToValue, tValue ByValue)
{
  tValue MinCValue, MaxCValue;

  if (ToValue.Kind == eNoValue) {
    /* error illegal limit value */
END_RULE;
    return TRUE;
  } else {
    if (CtrlType->Kind == kSymSubrange) {
      CtrlType = CtrlType->SymSubrange.Type;
    } /* endif */

    switch (CtrlType->Kind) {
    case kSymCardinal    :
    case kSymInteger     :
    case kSymChar        :
      Types_GetLwb(CtrlType, &MinCValue);
      Types_GetUpb(CtrlType, &MaxCValue);
      break;
    case kSymBoolean     :
    case kSymEnumeration :
      if (Types_TypeSize(CtrlType) == 1) {
        MinCValue = Values_MinChar;
        MaxCValue = Values_MaxChar;
      } else {
        MinCValue = Values_Zero;
        MaxCValue = Values_MaxCardinal;
      } /* endif */
      break;
    default              :
END_RULE;
      return TRUE;
    } /* endswitch */

    if (Values_ValueToInt(&ByValue) >= 0) {
      if (CtrlType == TypeCARDINAL) {
        /* MAXULONG is not representet by LONG !! */
END_RULE;
        return FALSE;
      } /* endif */
END_RULE;
      return Values_ValueToInt(&ToValue) >
             (Values_ValueToInt(&MaxCValue) - Values_ValueToInt(&ByValue));
    } else {
END_RULE;
      return Values_ValueToInt(&ToValue) <
             (Values_ValueToInt(&MinCValue) - Values_ValueToInt(&ByValue));
    } /* endif */
  } /* endif */
}

BOOLEAN IsVector(tTree Expr)
{
END_RULE;
  return Symbols_IsVectorType(Expr->Expr.Type);
}

/*  checks, if the tree is a 'vector OF type' or a typedeclaration of
 *  vector type
 */
BOOLEAN Code_IsVectorType(tTree Type)
{
END_RULE;
  return Type->Kind == kVector ||
         (Tree_IsType(Type, kTypeId) &&
          Type->TypeId.Object->SymTypeDecl.Type->Kind == kSymVector);
}

BOOLEAN IsNotAFunctionCall(tTree Expr)
{
  /* a. expression is not a function call (see parallaxis.cg) OR
   * b. expression is a function call AND NOT a user defined function,
   *    a record initialization or the DIM-function (see symbols.cg)
   */
END_RULE;
  return
    (Expr->Kind != kFuncCall && Expr->Kind != kMove &&
     Expr->Kind != kReceive  && Expr->Kind != kReduce ) ||
    (Expr->Kind == kFuncCall &&
     !Symbols_IsFunctioncall(Expr->FuncCall.Designator->Designator.Type));
}


/* determine type of reduce function for easy selections */

typedef enum {REDUCEUSERDEF, REDUCESUM, REDUCEPRODUCT, REDUCEAND, REDUCEOR,
		   REDUCEMAX, REDUCEMIN, REDUCEFIRST, REDUCELAST} reducetype;

reducetype GetReduceType(tIdent reduceident)
{
     char ReduceFunction[1024];
     GetString(reduceident, ReduceFunction);
END_RULE;
     if (strcmp(ReduceFunction, "SUM") == 0)     return REDUCESUM;
END_RULE;
     if (strcmp(ReduceFunction, "PRODUCT") == 0) return REDUCEPRODUCT;
END_RULE;
     if (strcmp(ReduceFunction, "AND") == 0)     return REDUCEAND;
END_RULE;
     if (strcmp(ReduceFunction, "OR") == 0)      return REDUCEOR;
END_RULE;
     if (strcmp(ReduceFunction, "MAX") == 0)     return REDUCEMAX;
END_RULE;
     if (strcmp(ReduceFunction, "MIN") == 0)     return REDUCEMIN;
END_RULE;
     if (strcmp(ReduceFunction, "FIRST") == 0)   return REDUCEFIRST;
END_RULE;
     if (strcmp(ReduceFunction, "LAST") == 0)    return REDUCELAST;
END_RULE;
     return REDUCEUSERDEF;
}

/* used to avoid vector loops for the previous designator which certainly
 * is of vector type after a 'Dimension' or 'Processor' access
 */
static void IncVectorLoopCalls()
{
  VectorLoopCalls++;
}

static void DecVectorLoopCalls()
{
  VectorLoopCalls--;
}

static void WriteFileBlanks( FILE *f, long counter )
{
  long i;

  for (i = 0; i < counter; i++) {
    fprintf(f," ");
  } /* endfor */
}

/*
 *      generate code for compilation units
 */

/****************************************************************************
 *
 * functions to generate some substancial code
 *
 ****************************************************************************/

static void PrintDebugLine(void);
static void CodeDefMod (tTree t);
static void CodeDefProg (tTree t);
static void CodeImports (tTree t);
static void CodeInitModules (tTree t);
static void CodeInitConfigs (tTree t);
static void CodeInitConfigBounds (tTree t, tIdent i, ULONG d);
static void CodeInitConnections (tTree t);
static void CodeInitDimensions (tTree t, tIdent Config, BOOLEAN Before, ULONG Rank);
static void CodeComputeConnections (tTree t, tIdent SourceIdent, tTree SourceIndex);
static void CodeComputeConnectionUni(tTree t, tIdent SourceIdent, tTree SourceIndex, tTree DestinationConfig, ULONG Rank);
static void CodeComputeConnectionBi(tTree t, tIdent SourceIdent, tTree SourceIndex, tIdent DestinationIdent, tTree DestinationIndex, tTree DestinationConfig, ULONG Rank);
static void CodeInitVectorVariables (tTree t);
static void CodeInitVectors (tTree t, tTree v);
static void CodeInitRecordVectors (tTree f, tTree t, tTree v);
static void CodeFreeConfigs (tTree t);
static void CodeFreeVectorVariables (tTree t);
static void CodeFreeVectors (tTree t, tTree v);
static void CodeFreeRecordVectors (tTree f, tTree t, tTree v);
static void CodeArrayUpperbound(tTree t);
static void CodeDecls1 (tTree t);
static void CodeType (tTree t, BOOLEAN Full);
static void CodeDecla (tTree t, BOOLEAN Before);
static void CodeDeclaFormals (tTree t, BOOLEAN Before);
static void CodeStruct (tTree t);
static void CodeEnums (tTree t);
static void CodeIds (tTree t, tTree Type);
static void CodeProcs (tTree t);
static void CodeFormals1 (tTree t);
static void CodeFormals2 (tTree t, tTree u, tIdent ElemTypeId);
static void CodeFormals3 (tTree t, tTree u, tIdent typeIdent);
static void CodeFormals4 (tTree t);
static void CodeFormalsOpenVector (tTree t, ULONG ParamKind);
static void CodeFormalsGenericConfig (tTree t, ULONG ParamKind);
static void CodeDecls2 (tTree t, BOOLEAN *NewLine);
static void CodeExpr (tTree t, ULONG Prec);
static void CodeExprCompute (tTree t);
static void CodeAdr (tTree t);
static void CodeString2 (tTree t, BOOLEAN Strncpy);
static void CodeStmts (tTree t);
static void CodeStmtsElse (tTree t, tTree e, BOOLEAN WasVector, tTree cond, tIdent expression);
static void CodeStmtsCases (tTree t, tTree e, tIdent Expression);
static void CodeStmtsSend(tTree t, tTree From, tTree To);
static void CodeStmtsReceive(tTree t, tTree From, tIdent To, tType ToType);
static void CodeStmtsMove(tTree t, tTree From, tIdent To, tType ToType);
static void CodeStdProc (tTree a1, ULONG StdProc, tObject AllocOrDealloc);
static void CodeActuals (tTree t);
static void CodeActualsCompute (tTree t);
static void CodeActualsRestoreVars (tTree t);
static void CodeActualsHelpVar (tTree t);
static void CodeActualsOpenVector (tTree t);
static void CodeActualsGenericConfig (tTree t);
static void CodeExprHelpVarBegin (tTree t);
static void CodeDesignatorHelpVarBegin (tTree t);
static void CodeExprHelpVarClose (tTree t);
static void CodeDesignatorHelpVarClose (tTree t);
static void CodeSepa (tTree t);

static void Crossreference (tTree t);

static void CodeDeclaratorBegin( tType Type );
static void CodeDeclaratorEnd( tType Type );
static void CodeExprWrite(tTree Expr, unsigned long Prec);


#ifdef ARGS
#undef ARGS()
#define ARGS(x)            x
#endif
#define WRITESTRING(x)     fprintf( fileHandle, x )
#define WRITELN()          fprintf( fileHandle, "\n" )/*; PrintDebugLine()*/
#define WRITEIDENT(x)      WriteIdent( fileHandle, x )
#define WRITEINT(x)        fprintf( fileHandle, "%ld", (long) x )
#define WRITECARD(x)       fprintf( fileHandle, "%lu", (unsigned long) x )
#define WRITECHAR(x)       fprintf( fileHandle, "%c", x )
#define WRITECHAROCT(x)	   fprintf( fileHandle, "%o", x )
#define WRITEHEX(x)        fprintf( fileHandle, "%lx", x )
#define WRITEOCT(x)        fprintf( fileHandle, "%lo", x )
#define WRITEREAL(x)       fprintf( fileHandle, "%.18e", x )
#define WRITEBLANKS()      PrintDebugLine(); WriteFileBlanks( fileHandle, indent )
#define TAB(x)             indent += x * indentTab
#define DETAB(x)           indent -= x * indentTab

/****************************************************************************
 *
 * functions to generate some substancial code
 *
 ****************************************************************************/

/*
 * code generation for constant strings
 */

static void CodeConstString( tStringRef s )
{
  LONG  i;
  CHAR  ch;
  CHAR  string[1024];
  LONG  length;

  StGetString( s, string );
  length = strlen( string );

  WRITESTRING("\"");
  for ( i = 0; i < length; i++ ) {
    ch = string[i];
    if (( ch == '\"' ) || ( ch == '\\' )) {
      WRITESTRING("\\");
    }
    WRITECHAR( ch );
  }
  WRITESTRING("\"");
}

/*
 * code generation for constant reals
 */

static void CodeConstReal( tStringRef s )
{
  CHAR  string[1024];

  StGetString( s, string );
  WRITESTRING( string );
}

/*
 * code generation for constant char
 */

static void CodeConstChar( CHAR ch )
{
  WRITESTRING("\"");
  if ( ( ch < ' ' ) || ( ch > '~' ) ) {
    WRITESTRING("\\");
    WRITECHAROCT( ch );
  } else if (( ch == '\"' ) || ( ch == '\\' )) {
    WRITESTRING("\\");
    WRITECHAR( ch );
  } else {
    WRITECHAR( ch );
  } /* endif */
  WRITESTRING("\"");
}

/*
 * code generation for char
 */

static void CodeChar( CHAR ch )
{
  switch ( ch ) {
  case '\'' : WRITESTRING("'\\''");  break;
  case '\\' : WRITESTRING("'\\\\'"); break;
  case '\0' : WRITESTRING("'\\0'");  break;
  case '\b' : WRITESTRING("'\\b'");  break;
  case '\t' : WRITESTRING("'\\t'");  break;
  case '\n' : WRITESTRING("'\\n'");  break;
  case '\f' : WRITESTRING("'\\f'");  break;
  case '\r' : WRITESTRING("'\\r'");  break;
  default   :
    if ( ( ( ch >= ' ' ) && ( ch <= '&' ) ) ||
         ( ( ch >= '(' ) && ( ch <= '[' ) ) ||
         ( ( ch >= ']' ) && ( ch <= '~' ) ) ) {
      WRITESTRING("'");
      WRITECHAR( ch );
      WRITESTRING("'");
    } else {
      WRITESTRING("((CHAR)'\\");
      WRITECHAROCT( ch );
      WRITESTRING("')");
    } /* endif */
  } /* endswitch */
}

/*
 * code generation for constant strings with a length of 1
 */

static void CodeConstStringChar( tStringRef s )
{
  CHAR  string[1024];

  StGetString( s, string );
  CodeChar( string[0] );
}

/*
 * code generation for strings resp. arrays of char in comparisons
 */

static void CodeString3(tTree Expr)
{
  tType Type;

  if (Expr->Expr.Type->Kind == kSymVector) {
    Type = Expr->Expr.Type->SymVector.Type;
  } else {
    Type = Expr->Expr.Type;
  }
  if (Type == TypeString || Type == TypeStringChar) {
    if (Expr->Kind == kStringConst) {
      /* string constant in the program text */
      CodeConstString(Expr->StringConst.StringVal);
    } else {
      /* string constant defined with CONST */
      if (Type == TypeStringChar) {
        /* string constant of length 1 */
        CodeConstChar(Expr->Qualid.Object->SymConst.Value.value.charValue);
      } else {
        CodeExpr(Expr, PASSVALUE_PREC);
      }
     }
  } else {
    CodeExpr(Expr, PASSVALUE_PREC);
    WRITESTRING(".A");
  }
}

/*
 * generate code for value
 */

static void CodeValue( tValue Value )
{
  tObject Object;

  switch (Value.Kind) {
  case eCardinal  : WRITECARD(Value.value.cardinalValue);     break;
  case eInteger   : WRITEINT(Value.value.integerValue);       break;
  case eReal      : WRITEREAL(Value.value.realValue);         break;
  case eBoolean   :
    if (Value.value.booleanValue) {
      WRITESTRING("TRUE");
    } else {
      WRITESTRING("FALSE");
    };
    break;
  case eChar      :
  case eStringChar: CodeChar(Value.value.charValue);          break;
  case eString    : CodeConstString(Value.value.stringValue); break;
  case eBitset    :
    WRITESTRING("0X");
    WRITEHEX( Value.value.bitsetValue );
    WRITESTRING("L ");
    break;
  case eEnum      :
    Object = (tObject) Value.value.enumValue;
    WRITEIDENT(Object->SymEnumLiteral.CIdent);
    break;
  case eNilType   : WRITESTRING("NIL "); break;
  default         :
    /*
     * error there cannot be precalculated value
     */
  } /* endswitch */
}

/*
 * code typename
 */

static void CodeTypeName( tType Type )
{
  tObject Object;

  if (Type->Kind == kSymVector) {
    Type = Type->SymVector.Type;
  }

  switch (Type->Kind) {
  case kSymArray        :
  case kSymEnumeration  :
  case kSymPointer      :
  case kSymProcType     :
  case kSymRecord       :
  case kSymSet          :
  case kSymSubrange     :
  case kSymOpaqueType   :
    Object = Type->SymConstructor.TypeObj;
    if (Object != NoObject) {
      WRITEIDENT(Object->SymObject.CIdent);
END_RULE;
      return;
    };
    break;
  } /* endswitch */

  if (Type->Kind == kSymSubrange) {
    Type = Type->SymSubrange.Type;
  }

  switch (Type->Kind) {
  case kSymInteger     : WRITESTRING("INTEGER"); break;
  case kSymCardinal    : WRITESTRING("CARDINAL"); break;
  case kSymReal        : WRITESTRING("REAL"); break;
  case kSymBoolean     : WRITESTRING("BOOLEAN"); break;
  case kSymChar        : WRITESTRING("CHAR"); break;
  case kSymBitset      : WRITESTRING("BITSET"); break;
  case kSymProc        : WRITESTRING("PROC"); break;
  case kSymWord        : WRITESTRING("WORD"); break;
  case kSymAddress     : WRITESTRING("ADDRESS"); break;
  case kSymIntCard     : WRITESTRING("INTEGER"); break;
  case kSymNil         : WRITESTRING("ADDRESS"); break;
  case kSymString      : WRITESTRING("CHAR *"); break;
  case kSymStringChar  : WRITESTRING("CHAR"); break;
  case kSymOpaqueType  : WRITESTRING("OPAQUE"); break;
  case kSymArray       :
    WRITESTRING("struct ");
    WRITEIDENT(Type->SymArray.StructId);
    break;
  case kSymEnumeration :
    if (Types_TypeSize(Type) <= MAXUCHAR) {
      WRITESTRING("unsigned char");
    } else {
      WRITESTRING("unsigned short ");
    } /* endif */
    break;
  case kSymPointer     : CodeTypeName(Type->SymPointer.Type); break;
  case kSymProcType    : CodeTypeName(Type->SymProcType.Type); break;
  case kSymRecord      :
    WRITESTRING("struct ");
    WRITEIDENT(Type->SymRecord.StructId);
    break;
  case kSymSet         : WRITESTRING("unsigned long"); break;
  }
}

/*
 * code declaration before ident
 */

static void CodeDeclaratorBegin( tType Type )
{
  if (Type->Kind == kSymVector) {
    Type = Type->SymVector.Type;
  }
  if (Type->Kind == kSymPointer && Type->SymPointer.TypeObj == NoObject) {
    CodeDeclaratorBegin(Type->SymPointer.Type);
    WRITESTRING(" *");
  } else if (Type->Kind == kSymProcType &&
             Type->SymProcType.TypeObj == NoObject) {
    WRITESTRING(" (*");
  }
}

/*
 * code declaration before after
 */

static void CodeDeclaratorEnd( tType Type )
{
  if (Type->Kind == kSymVector) {
    Type = Type->SymVector.Type;
  }
  if (Type->Kind == kSymPointer && Type->SymPointer.TypeObj == NoObject) {
    CodeDeclaratorEnd(Type->SymPointer.Type);
  } else if (Type->Kind == kSymProcType &&
             Type->SymProcType.TypeObj == NoObject) {
    WRITESTRING(")()");
  }
}

/*
 * code pointer
 */

static void CodePointers( unsigned short StorageClass, tCObjects Pointers )
{
  tTree Type;

  while ( Pointers != NoCObjects ) {
    Type = (tTree) Pointers->SymCObjects.M2Object->SymVar.TypeTree;
    if ( !(Symbols_IsOpenArray(Pointers->SymCObjects.M2Object))) {
      WRITEBLANKS();
      if ( StorageClass == STORAGE_STATIC ) {
        WRITESTRING("static ");
      }
      /* because vector data is always a pointer (address), the address
       * is saved instead of the address of the pointer
       */
      if (Type->Kind == kVector) {
        CodeType(Type, NONFULL);
        WRITESTRING(" *");
        WRITEIDENT(Pointers->SymCObjects.CObject);
        WRITESTRING(";");
	WRITELN();
      } else {
        CodeType( Type, NONFULL );
        CodeDecla( Type, BEFORE );
        WRITESTRING(" *");
        WRITEIDENT( Pointers->SymCObjects.CObject );
        CodeDecla( Type, AFTER );
        WRITESTRING(";");
	WRITELN();
      }
    } else {
      WRITEBLANKS();
      if ( StorageClass == STORAGE_STATIC ) {
        WRITESTRING("static ");
      }
      CodeType( Type->Array.ElemType, NONFULL );
      WRITESTRING(" *");
      WRITEIDENT( Pointers->SymCObjects.CObject );
      WRITESTRING(";");
      WRITELN();
      WRITEBLANKS();
      if ( StorageClass == STORAGE_STATIC ) {
        WRITESTRING("static ");
      }
      WRITESTRING("CARDINAL ");
      WRITEIDENT( Pointers->SymCObjects.CObject );
      WRITESTRING("_O;");
      WRITELN();
    } /* endif */
  Pointers = Pointers->SymCObjects.Next;
  } /* endwhile */
}

/*
 * code to initialize and save global pointer variables
 */

static void CodePushVarPointer ( tCObjects LocalPtrs )
{
  tIdent GlobalPtr;

  while ( LocalPtrs != NoCObjects ) {
    GlobalPtr = Pointer_GetGlobalPtr( LocalPtrs->SymCObjects.M2Object );
    WRITEBLANKS();
    WRITEIDENT( LocalPtrs->SymCObjects.CObject );
    WRITESTRING(" = ");
    WRITEIDENT( GlobalPtr );
    WRITESTRING(";");
    WRITELN();
    if ( Symbols_IsOpenArray( LocalPtrs->SymCObjects.M2Object )) {
      WRITEBLANKS();
      WRITEIDENT( GlobalPtr );
      WRITESTRING(" = ");
      WRITEIDENT( LocalPtrs->SymCObjects.M2Object->SymVar.CIdent );
      WRITESTRING(";");
      WRITELN();
      WRITEBLANKS();
      WRITEIDENT( LocalPtrs->SymCObjects.CObject );
      WRITESTRING("_O = ");
      WRITEIDENT( GlobalPtr );
      WRITESTRING("_O;");
      WRITELN();
      WRITEBLANKS();
      WRITEIDENT( GlobalPtr );
      WRITESTRING("_O = ");
      WRITEIDENT( Parameter_GetParam ( LocalPtrs->SymCObjects.M2Object ) );
      WRITESTRING(";");
      WRITELN();
    } else if ( Symbols_IsVAR( LocalPtrs->SymCObjects.M2Object ) ) {
      WRITEBLANKS();
      WRITEIDENT( GlobalPtr );
      WRITESTRING(" = ");
      WRITEIDENT( LocalPtrs->SymCObjects.M2Object->SymVar.CIdent );
      WRITESTRING(";");
      WRITELN();
    } else {
      WRITEBLANKS();
      WRITEIDENT( GlobalPtr );
      /* because vector data is always a pointer (address), the address
       * is saved instead of the address of the pointer
       */
      if (LocalPtrs->SymCObjects.M2Object->SymVar.Type->Kind == kSymVector) {
        WRITESTRING(" = ");
      } else {
        WRITESTRING(" = &");
      }
      WRITEIDENT( LocalPtrs->SymCObjects.M2Object->SymVar.CIdent );
      WRITESTRING(";");
      WRITELN();
    } /* endif */
    LocalPtrs = LocalPtrs->SymCObjects.Next;
  } /* endwhile */
}


/*
 * code to restore global Pointer variables
 */

static void CodePopVarPointer ( tCObjects LocalPtrs )
{
  tIdent GlobalPtr;

  while ( LocalPtrs != NoCObjects ) {
    GlobalPtr = Pointer_GetGlobalPtr( LocalPtrs->SymCObjects.M2Object );
    WRITEBLANKS();
    WRITEIDENT( GlobalPtr );
    WRITESTRING(" = ");
    WRITEIDENT( LocalPtrs->SymCObjects.CObject );
    WRITESTRING(";");
    WRITELN();
    if ( Symbols_IsOpenArray( LocalPtrs->SymCObjects.M2Object )) {
      WRITEBLANKS();
      WRITEIDENT( GlobalPtr );
      WRITESTRING("_O = ");
      WRITEIDENT( LocalPtrs->SymCObjects.CObject );
      WRITESTRING("_O;");
      WRITELN();
    };
    LocalPtrs = LocalPtrs->SymCObjects.Next;
  } /* endwhile */
}

/*
 * CodeLabelRange
 */

static void CodeLabelRange( tValue Label1, tValue Label2 )
{
  long     IntLabel;
  unsigned long CardLabel;
  BOOLEAN  BoolLabel;
  UCHAR    CharLabel;
  tObjects EnumLiterals;
  unsigned short EnumIndex1, EnumIndex2;
  tType    Type;

  switch( Label1.Kind ) {
    case eInteger  :
      for ( IntLabel = Label1.value.integerValue;
            IntLabel <= Label2.value.integerValue;
            IntLabel++ ) {
        WRITEBLANKS();
        WRITESTRING("case ");
        WRITEINT( IntLabel );
        WRITESTRING(":");
	WRITELN();
      } /* endfor */
      break;
    case eCardinal :
      for ( CardLabel = Label1.value.cardinalValue;
            CardLabel <= Label2.value.cardinalValue;
            CardLabel++ ) {
        WRITEBLANKS();
        WRITESTRING("case ");
        WRITECARD( CardLabel );
        WRITESTRING(":");
	WRITELN();
      }
      break;
    case eBoolean  :
      for ( BoolLabel = Label1.value.booleanValue;
            BoolLabel <= Label2.value.booleanValue;
            BoolLabel++ ) {
        WRITEBLANKS();
        if (BoolLabel) {
          WRITESTRING("case TRUE:");
        } else {
          WRITESTRING("case FALSE:");
	  WRITELN();
        } /* endif */
        WRITELN();
      } /* endfor */
      break;
    case eChar       :
    case eStringChar :
      for ( CharLabel = Label1.value.charValue;
            CharLabel <= Label2.value.charValue;
            CharLabel++ ) {
        WRITEBLANKS();
        WRITESTRING("case ");
        CodeChar( CharLabel );
        WRITESTRING(":");
	WRITELN();
      } /* endfor */
      break;
    case eEnum  :
      Type = Symbols_GetType( (tObject) Label1.value.enumValue );
      EnumLiterals = Type->SymEnumeration.Objects;
      EnumIndex1 = Values_ValueToInt( &Label1 );
      EnumIndex2 = Values_ValueToInt( &Label2 );
      while (EnumLiterals != NoObjects ) {
        if ( ( EnumLiterals->SymElem.Object->SymEnumLiteral.Index >=
                 EnumIndex1 ) &&
             ( EnumLiterals->SymElem.Object->SymEnumLiteral.Index <=
                 EnumIndex2 ) ) {
          WRITEBLANKS();
          WRITESTRING("case ");
          WRITEIDENT( EnumLiterals->SymElem.Object->SymEnumLiteral.CIdent );
          WRITESTRING(":");
	  WRITELN();
        } /* endif */
        EnumLiterals = EnumLiterals->SymElem.Next;
      } /* endwhile */
      break;
    default     : break;
  } /* endswitch */
}

/*
 * generate code to allocate memory for open array value
 */

static void CodeAllocOpenArray( tCObjects ValueOpens )
{
  ULONG     ArrayCnt;
  BOOLEAN   cont = TRUE;

  if ( ValueOpens != NoCObjects ) {
    ArrayCnt = 0;
    WRITEBLANKS();
    WRITESTRING("ALLOC_OPEN_ARRAYS(");
    while ( cont ) {
      ArrayCnt++;
      WRITEIDENT( ValueOpens->SymCObjects.CObject );
      WRITESTRING(" * sizeof(");
      CodeTypeName( Symbols_GetElemType(
        Symbols_GetType( ValueOpens->SymCObjects.M2Object )));
      WRITESTRING(")");
      ValueOpens = ValueOpens->SymCObjects.Next;
      if ( ValueOpens == NoObjects ) {
        cont = FALSE;
      } else {
        WRITESTRING(" + ");
      };
    } /* endwhile */
    WRITESTRING(", ");
    WRITEINT( ArrayCnt );
    WRITESTRING(")");
    WRITELN();
  } /* endif */
}

/*
 * generate code copy open array values
 */

static void CodeCopyOpenArray( tCObjects ValueOpens )
{
  while (ValueOpens != NoCObjects ) {
    WRITEBLANKS();
    WRITESTRING("COPY_OPEN_ARRAY(");
    WRITEIDENT( ValueOpens->SymCObjects.M2Object->SymVar.CIdent );
    WRITESTRING(", ");
    WRITEIDENT( ValueOpens->SymCObjects.CObject );
    WRITESTRING(", ");
    CodeTypeName( Symbols_GetElemType(
      Symbols_GetType( ValueOpens->SymCObjects.M2Object )));
    WRITESTRING(")");
    WRITELN();
    ValueOpens = ValueOpens->SymCObjects.Next;
  } /* endwhile */
}

/*
 * generate code free open array values
 */

static void CodeFreeOpenArray( tCObjects ValueOpens )
{
  if ( ValueOpens != NoCObjects ) {
    WRITEBLANKS();
    WRITESTRING("FREE_OPEN_ARRAYS");
    WRITELN();
  } /* endif */
}

/*
 * generate code strings
 */

static void CodeStrings( tStrings Strings )
{
  while ( Strings != NoStrings ) {
    WRITEBLANKS();
    CodeTypeName( Strings->SymStringPar.FormalType);
    WRITESTRING(" ");
    WRITEIDENT( Strings->SymStringPar.CString );
    WRITESTRING(";");
    WRITELN();
    Strings = Strings->SymStringPar.Next;
  } /* endwhile */
}

/*
 * generate code strings copy
 */

static void CodeStrncpy( tStrings Strings )
{
  while ( Strings != NoStrings ) {
    WRITEBLANKS();
    WRITESTRING("(void) strncpy(");
    if ( Options_IsOptionSet(Options_eCasts) ) {
      WRITESTRING("(CHAR *)");
    } /* endif */
    WRITEIDENT( Strings->SymStringPar.CString );
    WRITESTRING(".A, ");
    CodeString2( Strings->SymStringPar.M2String, STRNCPY );
    WRITESTRING(", ");
    WRITESTRING("sizeof(");
    WRITEIDENT( Strings->SymStringPar.CString );
    WRITESTRING(".A)");
    WRITESTRING(");");
    WRITELN();
    Strings = Strings->SymStringPar.Next;
  } /* endwhile */
}

/*
 * generate code selector
 */

static void CodeSelectors ( tSelectors Selectors )
{
  if ( Selectors != NoSelectors ) {
    CodeSelectors( Selectors->SymSelectors.Next );
    WRITEIDENT( Selectors->SymSelectors.Selector );
    WRITESTRING(".");
  } /* endif */
}

/*
 * generate code cast
 */

static void CodeCast(tType Type)
{
  WRITESTRING("(");
  CodeTypeName(Type);
  CodeDeclaratorBegin(Type);
  CodeDeclaratorEnd(Type);
  WRITESTRING(")");
}

static void CodeCastVAR( tType Type )
{
  WRITESTRING("(");
  CodeTypeName( Type );
  CodeDeclaratorBegin( Type );
  WRITESTRING(" *");
  CodeDeclaratorEnd( Type );
  WRITESTRING(")");
}

/*
 *  code minium or maximum of a datatype
 */

static void CodeMinimum( tType Type )
{
  tObject Object;

  if (Type->Kind == kSymVector) {
    Type = Type->SymVector.Type;
  }
  switch ( Type->Kind ) {
  case kSymInteger     : WRITESTRING("MIN_INTEGER"); break;
  case kSymCardinal    : WRITESTRING("MIN_CARDINAL"); break;
  case kSymReal        : WRITESTRING("MIN_REAL"); break;
  case kSymBoolean     : WRITESTRING("MIN_BOOLEAN"); break;
  case kSymChar        : WRITESTRING("MIN_CHAR"); break;
  case kSymEnumeration :
    Object = Symbols_GetLiteral( Type->SymEnumeration.Objects, 0 );
    WRITEIDENT( Object->SymEnumLiteral.CIdent );
    break;
  case kSymSubrange    :
    CodeValue( Type->SymSubrange.Lwb );
    if ( Symbols_IsIntType( Type ) &&
         Types_Cast( Code_PassValue, Type, TypeIntCard ) ) {
      WRITESTRING("L");
    } /* endif */
    break;
  } /* endswitch */
}

static void CodeMaximum( tType Type )
{
  tObject Object;

  if (Type->Kind == kSymVector) {
    Type = Type->SymVector.Type;
  }
  switch ( Type->Kind ) {
  case kSymInteger     : WRITESTRING("MAX_INTEGER"); break;
  case kSymCardinal    : WRITESTRING("MAX_CARDINAL"); break;
  case kSymReal        : WRITESTRING("MAX_REAL"); break;
  case kSymBoolean     : WRITESTRING("MAX_BOOLEAN"); break;
  case kSymChar        : WRITESTRING("MAX_CHAR"); break;
  case kSymEnumeration :
    Object = Symbols_GetLiteral( Type->SymEnumeration.Objects,
      Type->SymEnumeration.MaxValue );
    WRITEIDENT( Object->SymEnumLiteral.CIdent );
    break;
  case kSymSubrange    :
     CodeValue( Type->SymSubrange.Upb );
     if ( Symbols_IsIntType( Type ) &&
          Types_Cast( Code_PassValue, Type, TypeIntCard ) ) {
       WRITESTRING("L");
     } /* endif */
     break;
  } /* endswitch */
}

/*
 *  generate code for the configurationname of a type
 */

static void CodeWriteConfigName2(tType Type)
{
  if (Type->Kind == kSymVector) {
    if (Type->SymVector.IsOpen) {
      WRITESTRING("OPEN_VECTOR");
    } else if (Type->SymVector.Config->SymConfig.IsGeneric) {
      WRITESTRING("GENERIC_CONFIGURATION");
    } else {
      WRITEIDENT(Type->SymVector.Config->SymConfig.CIdent);
    }
  } else if (Type->Kind == kSymConfiguration) {
    if (Type->SymConfiguration.Config->SymConfig.IsGeneric) {
      WRITESTRING("GENERIC_CONFIGURATION");
    } else {
      WRITEIDENT(Type->SymConfiguration.Config->SymConfig.CIdent);
    }
  }
}

/*
 *  generate code for the configurationname of a vector expression
 */

static void CodeWriteConfigName(tTree Expr)
{
  CodeWriteConfigName2(Expr->Expr.Type);
}

/*
 * generate code for the size of variable sized configs
 */

/*
void CodeConfigLen(tTypes Types)
{
  while (Types != NoTypes) {
    WRITESTRING("(");
    CodeExpr(Types->SymTypes.Type->SymSubrange.UpbExpr, PASSVALUE_PREC);
    WRITESTRING(" - ");
    CodeExpr(Types->SymTypes.Type->SymSubrange.LwbExpr, PASSVALUE_PREC);
    WRITESTRING(" + 1)");
    Types = Types->SymTypes.Next;
    if (Types != NoTypes) {
      WRITESTRING(" * ");
    }
  }
}
*/

/*
 *  generate code for the initialization and freeing of temporary variables
 *  of an expression
 */

static void CodeHelpVarInit(tTree Expr)
{
  WRITEBLANKS();
  CodeTypeName(Expr->Expr.Type);
  WRITESTRING(" ");
  if (Expr->Expr.Type->Kind == kSymVector) {
    WRITESTRING("*");
    WRITEIDENT(Expr->Expr.HelpVar);
    if (IsNotAFunctionCall(Expr) ||
        Expr->Kind == kMove || Expr->Kind == kReceive) {
END_RULE;
      /* not a real function call which returns a pointer to a vector or
       * the MOVE function or the RECEIVE function
       */
      WRITESTRING(" = (void *) malloc(sizeof(*(");
      WRITEIDENT(Expr->Expr.HelpVar);
      WRITESTRING(")) * LEN(");
      CodeWriteConfigName(Expr);
      WRITESTRING("))");
    }
  } else {
    WRITEIDENT(Expr->Expr.HelpVar);
  }
  WRITESTRING(";");
  WRITELN();
}

static void CodeHelpVarFree(tTree Expr)
{
  if (Expr->Expr.Type->Kind == kSymVector) {
    WRITEBLANKS();
    WRITESTRING("free(");
    WRITEIDENT(Expr->Expr.HelpVar);
    WRITESTRING(");");
    WRITELN();
  }
}

/*
 *  generate code for the vector index of designators
 */

static void CodeVectorIndex(tTree Expr)
{
  if (Expr->Expr.WriteVectorIndex &&
      IsNotAFunctionCall(Expr) &&
      NotInActualsWrite) {
    /* is a vector type, but not a function call, in actuals write or the
     * index was written in a previous designator
     */
    WRITESTRING("[PE]");
  } else if (Expr->Expr.WriteProcOrDimIndex) {
    if (Expr->Expr.ProcOrDimSpec->Kind == kProcessor) {
      WRITESTRING("[");
      if (Options_IsOptionSet(Options_eChecks)) {
        WRITESTRING("CHECK_PE_NUMBER(");
        CodeWriteConfigName(Expr);
        WRITESTRING(", ");
      }
      CodeExprWrite(Expr->Expr.ProcOrDimSpec->Processor.Proc, MINPREC_PREC);
      WRITESTRING(" - 1");
      if (Options_IsOptionSet(Options_eChecks)) {
        WRITESTRING(", __FILE__, __LINE__)");
      }
      WRITESTRING("]");
    } else {
      WRITESTRING("[");
      if (Options_IsOptionSet(Options_eChecks)) {
        WRITESTRING("CHECK_PE_NUMBER(");
        CodeWriteConfigName(Expr);
        WRITESTRING(", ");
      }
      WRITESTRING("DIM2ID(");
      CodeWriteConfigName(Expr->Expr.ProcOrDimSpec->Dimensions.Designator);
      WRITESTRING(", ");
      WRITEIDENT(Expr->Expr.ProcOrDimSpec->Dimensions.Actuals->ActualExpr/*.Expr->Expr*/.HelpVar);
      WRITESTRING(") - 1");  /* ##### probably -1 is wrong */
      if (Options_IsOptionSet(Options_eChecks)) {
        WRITESTRING(", __FILE__, __LINE__)");
      }
      WRITESTRING("]");
    }
  }
}

/*
 *  generate code for the assignment of an expression to its temporary
 *  variable
 */

static void CodeHelpVarWrite(tTree Expr)
{
  WRITEIDENT(Expr->Expr.HelpVar);
  if (Expr->Expr.Type->Kind == kSymVector && NotInActualsWrite) {
    /* is a vector type, but not a parameter of a procedure call */
    WRITESTRING("[PE]");
  }  
}

static void CodeHelpVarAssignBegin(tTree Expr)
{
  if (AssignCalls == 0) {
    WRITEBLANKS();
    WRITEIDENT(Expr->Expr.HelpVar);
    if (Expr->Expr.Type->Kind == kSymVector && IsNotAFunctionCall(Expr)) {
      /* is of vector type , but not an assignement of a function result */
      WRITESTRING("[PE]");
    }
    WRITESTRING(" = ");
  }
  AssignCalls++;
}

static void CodeHelpVarAssignClose(tTree Expr)
{
  AssignCalls--;
  if (AssignCalls == 0) {
    WRITESTRING(";");
    WRITELN();
  }
}

/*
 *  generate code for the initialization, writing and freeing of actuals
 */

static void CodeActualsBegin(tTree Actuals)
{
  if (Actuals->Actuals.UseHelpVar) {
    WRITEBLANKS();
    WRITESTRING("{");
    WRITELN();
    TAB(1);
    CodeExprHelpVarBegin(Actuals);
    CodeActualsCompute(Actuals);
  }
}

static void CodeActualsWrite(tTree Actuals)
{
  BOOLEAN Old_NotInActualsWrite;

  Old_NotInActualsWrite = NotInActualsWrite;
  NotInActualsWrite = FALSE;
  if (Actuals->Actuals.UseHelpVar) {
    CodeActualsHelpVar(Actuals);
  } else {
    CodeActuals(Actuals);
  }
  CodeActualsOpenVector(Actuals);
  CodeActualsGenericConfig(Actuals);
  NotInActualsWrite = Old_NotInActualsWrite;
}

static void CodeActualsHelpVarNext(tTree Next)
{
  if (Next->Actuals.UseHelpVar) {
    CodeActualsHelpVar(Next);
  } else {
    CodeActuals(Next);
  }
}

static void CodeActualsClose(tTree Actuals)
{
  if (Actuals->Actuals.UseHelpVar) {
    CodeExprHelpVarClose(Actuals);
    DETAB(1);
    WRITEBLANKS();
    WRITESTRING("}");
    WRITELN();
  }
}

static void CodeStdActualWrite(tTree Actual, ULONG Prec)
{
  /* writes an actual of a standard procedure which is implemented as
   * a real procedure call
   */
  BOOLEAN Old_NotInActualsWrite;

  Old_NotInActualsWrite = NotInActualsWrite;
  NotInActualsWrite = FALSE;
  if (Actual->ActualExpr.UseHelpVar) {
    WRITEIDENT(Actual->ActualExpr.Expr->Expr.HelpVar);
  } else {
    CodeExpr(Actual->ActualExpr.Expr, Prec);
  };
  NotInActualsWrite = Old_NotInActualsWrite;
}

/*
 *  generate code for the initialization, writing and freeing of expressions
 */

static void CodeExprBegin(tTree Expr)
{
  if (Expr->Expr.UseHelpVar) {
    WRITEBLANKS();
    WRITESTRING("{");
    WRITELN();
    TAB(1);
    CodeExprHelpVarBegin(Expr);
    CodeExprCompute(Expr);
  }
}

static void CodeExprBegin2(tTree Expr)
{
  /* allocation of the help variable computation of the expression for while */
  /*  and repeat whichs expressions are not computed directly after the      */
  /* allocation of the help variable                                         */
  if (Expr->Expr.UseHelpVar) {
    WRITEBLANKS();
    WRITESTRING("{");
    WRITELN();
    TAB(1);
    CodeExprHelpVarBegin(Expr);
  }
}

static void CodeExprCompute2(tTree Expr)
{
  /* computation of the expression for while and repeat whichs expressions */
  /* are not computed directly after the allocation of the help variable   */
  if (Expr->Expr.UseHelpVar) {
    CodeExprCompute(Expr);
  }
}

static void CodeExprCompute3(tTree Expr)
{
  /* computation of the source expression of a RECEIVE statement which */
  /* needs an surrounding ALL statement                                */
  if (Expr->Expr.UseHelpVar) {
    WRITEBLANKS();
    WRITESTRING("PUSH_ACTIVE_ALL(");
    CodeWriteConfigName(Expr);
    WRITESTRING(");");
    WRITELN();
    TAB(1);
    CodeExprCompute(Expr);
    DETAB(1);
    WRITEBLANKS();
    WRITESTRING("POP_ACTIVE(");
    CodeWriteConfigName(Expr);
    WRITESTRING(");");
    WRITELN();
  }
}

static void CodeExprWrite(tTree Expr, unsigned long Prec)
{
  if (Expr->Expr.UseHelpVar) {
    WRITEIDENT(Expr->Expr.HelpVar);
    if (Expr->Expr.Type->Kind == kSymVector) {
      WRITESTRING("[PE]");
    }
  } else {
    CodeExpr(Expr, Prec);
  }
}

static void CodeExprClose(tTree Expr)
{
  if (Expr->Expr.UseHelpVar) {
    CodeExprHelpVarClose(Expr);
    DETAB(1);
    WRITEBLANKS();
    WRITESTRING("}");
    WRITELN();
  }
}

/*
 *  generate code for the computation of indizes and actuals of designators
 *  this routine is called from every designator but must only
 *  be executed for the first designator of a designator list
 *  otherwise this would cause conflicts with the writing and computation
 *  of designator lists
 */

static void CodeDesignatorBegin(tTree Designator)
{
  if (Designator->Designator.UseHelpVar) {
    WRITEBLANKS();
    WRITESTRING("{");
    WRITELN();
    TAB(1);
    CodeDesignatorHelpVarBegin(Designator);
  }
}

static void CodeDesignatorCompute(tTree Designator)
{
  unsigned long Dim;
  tTree Actuals;

  if ((Designator->Kind == kProcessor ||
       Designator->Kind == kDimensions ||
       Designator->Kind == kSelect ||
       Designator->Kind == kSubscript ||
       Designator->Kind == kDeref) &&
      Designator->Designator.IsFirstDesignator &&
      Designator->Designator.UseHelpVar) {
    /*  start only if it is really a designator, if it is the first
     *  designator in a designator list and at least one member uses
     *  the HelpVar
     */
    while (Designator->Kind != kQualid0 && Designator->Kind != kQualid1) {
      switch(Designator->Kind) {
      case kProcessor:
        if (Designator->Processor.Proc->Expr.UseHelpVar) {
          CodeExprCompute(Designator->Processor.Proc);
        }
        Designator = Designator->Processor.Designator;
        break;
      case kDimensions:
        if (Designator->Dimensions.Actuals->Actuals.UseHelpVar) {
          CodeActualsCompute(Designator->Dimensions.Actuals);
        }
        /* generation of the HelpVar for Array of DIM2ID */
        Dim = 0;
        Actuals = Designator->Dimensions.Actuals;
        while (Actuals->Kind != kNoActual) {
          Dim++;
          Actuals = Actuals->Actual.Next;
        }
        Actuals = Designator->Dimensions.Actuals;
        while (Actuals->Kind != kNoActual) {
          Dim--;
          WRITEBLANKS();
          WRITEIDENT(Designator->Dimensions.Actuals->ActualExpr/*.Expr->Expr*/.HelpVar);
          WRITESTRING("[");
          WRITECARD(Dim);
          WRITESTRING("] = ");
          CodeExprWrite(Actuals->ActualExpr.Expr, ASSIGN_PREC);
          WRITESTRING(";");
	  WRITELN();
          Actuals = Actuals->Actual.Next;
        }
        Designator = Designator->Dimensions.Designator;
        break;
      case kSelect:
        Designator = Designator->Select.Designator;
        break;
      case kSubscript:
        if (Designator->Subscript.Index->Expr.UseHelpVar) {
          CodeExprCompute(Designator->Subscript.Index);
        }
        Designator = Designator->Subscript.Designator;
        break;
      case kDeref:
        Designator = Designator->Deref.Designator;
        break;
      }
    }
  }
}

static void CodeDesignatorClose(tTree Designator)
{
  if (Designator->Designator.UseHelpVar) {
    CodeDesignatorHelpVarClose(Designator);
    DETAB(1);
    WRITEBLANKS();
    WRITESTRING("}");
    WRITELN();
  }
}

/*
 *  generate code for the computation of set expressions
 */

static void CodeElemsCompute(tTree Elems)
{
  switch (Elems->Kind) {
  case kElemExpr:
    if (Elems->ElemExpr.Elem->Expr.UseHelpVar) {
      CodeExprCompute(Elems->ElemExpr.Elem);
    }
    CodeElemsCompute(Elems->ElemExpr.Next);
    break;
  case kElemRange:
    if (Elems->ElemRange.Lwb->Expr.UseHelpVar) {
      CodeExprCompute(Elems->ElemRange.Lwb);
    }
    if (Elems->ElemRange.Upb->Expr.UseHelpVar) {
      CodeExprCompute(Elems->ElemRange.Upb);
    }
    CodeElemsCompute(Elems->ElemRange.Next);
    break;
  }
}

/*
 *  generate code for the loop for vector expressions
 */

static void CodeVectorLoopBegin(tTree Expr)
{
  if (Expr->Expr.Type->Kind == kSymVector && IsNotAFunctionCall(Expr)) {
    /* vector expression which is not a function call */
    if (VectorLoopCalls == 0) {
      /* first call of this function */
      WRITEBLANKS();
      WRITESTRING("FOR_ALL_ACTIVES(");
      CodeWriteConfigName(Expr);
      WRITESTRING(") {");
      WRITELN();
      TAB(1);
    }
    VectorLoopCalls++;
  }
}

static void CodeVectorLoopClose(tTree Expr)
{
  if (Expr->Expr.Type->Kind == kSymVector && IsNotAFunctionCall(Expr)) {
    /* vector expression which is not a function call */
    VectorLoopCalls--;
    if (VectorLoopCalls == 0) {
      /* corresponds to the first call of this function */
      DETAB(1);
      WRITEBLANKS();
      WRITESTRING("}");
      WRITELN();
    }
  }
}

/*
 *  generate code for the loop for vector statements
 */

static void CodeStmtsVectorLoopBegin(tTree Expr)
{
  if (Expr->Expr.Type->Kind == kSymVector) {
    WRITEBLANKS();
    WRITESTRING("FOR_ALL_ACTIVES(");
    CodeWriteConfigName(Expr);
    WRITESTRING(") {");
    WRITELN();
    TAB(1);
  }
}

static void CodeStmtsVectorLoopClose(tTree Expr)
{
  if (Expr->Expr.Type->Kind == kSymVector) {
    DETAB(1);
    WRITEBLANKS();
    WRITESTRING("}");
    WRITELN();
  }
}

/*
 *  generate code for the loops for LOAD and STORE statements
 */

static void CodeArrayLength(tType Type)
{
  tValue Lwb, Upb;

  switch (Type->Kind) {
  case kSymEnumeration:
    WRITEINT(Type->SymEnumeration.MaxValue + 1);
    break;
  case kSymSubrange   :
    WRITEINT(Values_ValueToInt(&(Type->SymSubrange.Upb)) -
      Values_ValueToInt(&(Type->SymSubrange.Lwb)) + 1);
    break;
  default             :
    Types_GetLwb(Type, &Lwb);
    Types_GetUpb(Type, &Upb);
    WRITEINT(Values_ValueToInt(&Upb) - Values_ValueToInt(&Lwb) + 1);
    break;
  }
}

static void CodeLoadStoreLoopBegin(tTree Expr, tLocalIds Count, tTree Array)
{
  tType Type;

  if (Expr->Expr.Type->Kind == kSymVector) {
    WRITEBLANKS();
    WRITESTRING("for (PE = 0;  PE < LEN(");
    CodeWriteConfigName(Expr);
    WRITESTRING(") && ");
    if (Array->Designator.Type->SymArray.IsOpen) { /* open array */
      WRITEIDENT(Count->SymLocalIds.Ident);
      WRITESTRING(" < ");
      if (Array->Qualid0.IsGlobalPtr) {
        WRITEIDENT(Pointer_GetGlobalPtr(Array->Qualid0.Object));
        WRITESTRING("_O");
      } else {
        WRITEIDENT(Parameter_GetParam(Array->Qualid0.Object) );
      }
    } else { /* no open array */
      Type = Array->Designator.Type->SymArray.ElemType;
      while (Type->Kind == kSymArray) {
        WRITESTRING("(");
        Type = Type->SymArray.ElemType;
      }
      Type = Array->Designator.Type;
      while (Type->Kind == kSymArray) {
        WRITEIDENT(Count->SymLocalIds.Ident);
        Type = Type->SymArray.ElemType;
        if (Type->Kind == kSymArray) {
          WRITESTRING(") * ");
          CodeArrayLength(Type->SymArray.IndexType);
          WRITESTRING(" + ");
        }
        Count = Count->SymLocalIds.Next;
      }
      WRITESTRING(" < ");
      Type = Array->Designator.Type;
      while (Type->Kind == kSymArray) {
        CodeArrayLength(Type->SymArray.IndexType);
        Type = Type->SymArray.ElemType;
        if (Type->Kind == kSymArray) {
          WRITESTRING(" * ");
        }
      }
    }
    WRITESTRING("; PE++) {");
    WRITELN();
    TAB(1);
      WRITEBLANKS();
      WRITESTRING("if (IS_ACTIVE(");
      CodeWriteConfigName(Expr);
      WRITESTRING(", PE)) {");
      WRITELN();
      TAB(1);
  }   
}

static void CodeLoadStoreLoopClose(tTree Expr, tIdent ReturnSize, tTree Size)
{
  if (Expr->Expr.Type->Kind == kSymVector) {
      DETAB(1);
      WRITEBLANKS();
      WRITESTRING("}");
      WRITELN();
    DETAB(1);
    WRITEBLANKS();
    WRITESTRING("}");
    WRITELN();
    if (Size != NoQualid) {
      WRITEBLANKS();
      CodeExpr(Size, MINPREC_PREC);
      WRITESTRING(" = ");
      WRITEIDENT(ReturnSize);
      WRITESTRING(";");
      WRITELN();
    }
  }
}

/*
 *  generate code for the push and pop operations
 */

static void CodePushActive(tTree Expr)
{
  WRITEBLANKS();
  WRITESTRING("PUSH_ACTIVE(");
  CodeWriteConfigName(Expr);
  WRITESTRING(");");
  WRITELN();
}

static void CodePopActive(tTree Expr)
{
  WRITEBLANKS();
  WRITESTRING("POP_ACTIVE(");
  CodeWriteConfigName(Expr);
  WRITESTRING(");");
  WRITELN();
}

static void CodePushElse(tTree Expr)
{
  WRITEBLANKS();
  WRITESTRING("PUSH_ELSE(");
  CodeWriteConfigName(Expr);
  WRITESTRING(");");
  WRITELN();
}

static void CodePopElse(tTree Expr)
{
  WRITEBLANKS();
  WRITESTRING("POP_ELSE(");
  CodeWriteConfigName(Expr);
  WRITESTRING(");");
  WRITELN();
}

static void CodeCopyElse(tTree Expr)
{
  WRITEBLANKS();
  WRITESTRING("COPY_ELSE_TO_ACTIVE(");
  CodeWriteConfigName(Expr);
  WRITESTRING(");");
  WRITELN();
}

/*
 *  generate code for the evaluation of the IF-expression
 */

static void CodeIfExpr(tTree Expr, tIdent Ident)
{
  CodeExprBegin(Expr);
  CodeStmtsVectorLoopBegin(Expr);
  WRITEBLANKS();
  WRITEIDENT(Ident);
  WRITESTRING("[PE] = ");
  CodeExprWrite(Expr, ASSIGN_PREC);
  WRITESTRING(";");
  WRITELN();
  CodeStmtsVectorLoopClose(Expr);
  CodeExprClose(Expr);
}


/*
 *  generate code for the activation of all PEs which do not satisfy resp.
 *  do satisfy the IF-condition
 */

static void CodeIf(tTree Expr, tIdent Ident)
{
  CodeStmtsVectorLoopBegin(Expr);
  WRITEBLANKS();
  WRITESTRING("if (!");
  WRITEIDENT(Ident);
  WRITESTRING("[PE]) { SET_INACTIVE(");
  CodeWriteConfigName(Expr);
  WRITESTRING(", PE); }");
  WRITELN();
  CodeStmtsVectorLoopClose(Expr);
}

static void CodeElse(tTree Expr, tIdent Ident)
{
  CodeStmtsVectorLoopBegin(Expr);
  WRITEBLANKS();
  WRITESTRING("if (");
  WRITEIDENT(Ident);
  WRITESTRING("[PE]) { SET_INACTIVE(");
  CodeWriteConfigName(Expr);
  WRITESTRING(", PE); }");
  WRITELN();
  CodeStmtsVectorLoopClose(Expr);
}

/*
 *  stores the state of the active stack and else stack for EXIT
 *  respectively RETURN statement
 */

static void CodeStoreStacksReturnDecl(tConfigs Configs)
{
  while (Configs != NoConfigs) {
    Configs->SymConfigs.ActiveIdent = GenIdents_HelpVar();
    Configs->SymConfigs.ElseIdent = GenIdents_HelpVar();
    WRITEBLANKS();
    WRITESTRING("BOOLEAN_ELEM_PTR ");
    WRITEIDENT(Configs->SymConfigs.ActiveIdent);
    WRITESTRING(", ");
    WRITEIDENT(Configs->SymConfigs.ElseIdent);
    WRITESTRING(";");
    WRITELN();
    Configs = Configs->SymConfigs.Next;
  }
}

static void CodeStoreStacksReturnDoit(tConfigs Configs)
{
  while (Configs != NoConfigs) {
    WRITEBLANKS();
    WRITEIDENT(Configs->SymConfigs.ActiveIdent);
    WRITESTRING(" = READ_ACTIVE(");
    if (Configs->SymConfigs.Object == NoObject) {
      WRITESTRING("OPEN_VECTOR");
    } else if (Configs->SymConfigs.Object->SymConfig.IsGeneric) {
      WRITESTRING("GENERIC_CONFIGURATION");
    } else {
      WRITEIDENT(Configs->SymConfigs.Object->SymConfig.CIdent);
    }
    WRITESTRING(");");
    WRITELN();

    WRITEBLANKS();
    WRITEIDENT(Configs->SymConfigs.ElseIdent);
    WRITESTRING(" = READ_ELSE(");
    if (Configs->SymConfigs.Object == NoObject) {
      WRITESTRING("OPEN_VECTOR");
    } else if (Configs->SymConfigs.Object->SymConfig.IsGeneric) {
      WRITESTRING("GENERIC_CONFIGURATION");
    } else {
      WRITEIDENT(Configs->SymConfigs.Object->SymConfig.CIdent);
    }
    WRITESTRING(");");
    WRITELN();
    Configs = Configs->SymConfigs.Next;
  }
  WRITELN();
}

static void CodeStoreStacksExit(tConfigs Configs)
{
  if (Configs != NoConfigs) {
    WRITEBLANKS();
    WRITESTRING("{");
    WRITELN();
    TAB(1);
    CodeStoreStacksReturnDecl(Configs);
    CodeStoreStacksReturnDoit(Configs);
  }
}

/*
 *  stores at the beginning of a procedure the global variable PE and
 *  restores it at the end or before a RETURN statement
 *  it is used to avoid conflicts when this procedure is called as a
 *  reduce function, because this is the only case where a function call
 *  can be enclosed in the FOR_ALL_ACTIVES loop
 *  also local defined configurations and connections are stored because in
 *  case of a recursive call the reinitalisation of the configurations and
 *  the recomputation of the connections would cause conflicts
 *  the initialization and computation can not be done in every case at the
 *  start of the program because it is possible that the configuration has
 *  variable size, is the respecification of a generic configuration or the
 *  connections belong to such a configuration
 */

static void CodeStoreConfigsConnects(tTree Decls)
{
  switch (Decls->Kind) {
  case kConnectFrom:
    CodeStoreConfigsConnects(Decls->ConnectFrom.ConnectDecls);
    CodeStoreConfigsConnects(Decls->ConnectFrom.Next);
    break;
  case kConnectDecls:
    if (Decls->ConnectDecls.FirstDeclaration) {
      WRITEBLANKS();
      if (Decls->ConnectDecls.Object->SymConnect.IndexUsed) {
        WRITESTRING("PARAMETER_CONNECTION L_");
      } else {
        WRITESTRING("CONNECTION L_");
      }
      WRITEIDENT(Decls->ConnectDecls.Object->SymConnect.CIdent);
      WRITESTRING(" = ");
      WRITEIDENT(Decls->ConnectDecls.Object->SymConnect.CIdent);
      WRITESTRING(";");
      WRITELN();
    }
    CodeStoreConfigsConnects(Decls->ConnectDecls.DirIn);
    CodeStoreConfigsConnects(Decls->ConnectDecls.Next);
    break;
  case kConfig:
    WRITEBLANKS();
    WRITESTRING("CONFIGURATION L_");
    WRITEIDENT(Decls->Config.Object->SymConfig.CIdent);
    WRITESTRING(" = ");
    WRITEIDENT(Decls->Config.Object->SymConfig.CIdent);
    WRITESTRING(";");
    WRITELN();
    CodeStoreConfigsConnects(Decls->Config.Next);
    break;
  case kConnectDestUni:
    CodeStoreConfigsConnects(Decls->ConnectDestUni.Next);
    break;
  case kConnectDestBi:
    if (Decls->ConnectDestBi.FirstDeclaration) {
      WRITEBLANKS();
      if (Decls->ConnectDestBi.Object->SymConnect.IndexUsed) {
        WRITESTRING("PARAMETER_CONNECTION L_");
      } else {
        WRITESTRING("CONNECTION L_");
      }
      WRITEIDENT(Decls->ConnectDestBi.Object->SymConnect.CIdent);
      WRITESTRING(" = ");
      WRITEIDENT(Decls->ConnectDestBi.Object->SymConnect.CIdent);
      WRITESTRING(";");
      WRITELN();
    }
    CodeStoreConfigsConnects(Decls->ConnectDestBi.Next);
    break;
  case kNoDecl:
  case kNoConnectDest:
    break;
  default:
    CodeStoreConfigsConnects(Decls->Decl.Next);
    break;
  }
}

static void CodeStoreConfigsConnectsPE(tTree Declarations)
{
  WRITEBLANKS();
  WRITESTRING("CARDINAL L_PE = PE;");
  WRITELN();
  CodeStoreConfigsConnects(Declarations);
}

static void CodeRestoreConfigsConnects(tTree Decls)
{
  switch (Decls->Kind) {
  case kConnectFrom:
    CodeRestoreConfigsConnects(Decls->ConnectFrom.ConnectDecls);
    CodeRestoreConfigsConnects(Decls->ConnectFrom.Next);
    break;
  case kConnectDecls:
    if (Decls->ConnectDecls.FirstDeclaration) {
      WRITEBLANKS();
      WRITEIDENT(Decls->ConnectDecls.Object->SymConnect.CIdent);
      WRITESTRING(" = L_");
      WRITEIDENT(Decls->ConnectDecls.Object->SymConnect.CIdent);
      WRITESTRING(";");
      WRITELN();
    }
    CodeRestoreConfigsConnects(Decls->ConnectDecls.DirIn);
    CodeRestoreConfigsConnects(Decls->ConnectDecls.Next);
    break;
  case kConfig:
    WRITEBLANKS();
    WRITEIDENT(Decls->Config.Object->SymConfig.CIdent);
    WRITESTRING(" = L_");
    WRITEIDENT(Decls->Config.Object->SymConfig.CIdent);
    WRITESTRING(";");
    WRITELN();
    CodeRestoreConfigsConnects(Decls->Config.Next);
    break;
  case kConnectDestUni:
    CodeRestoreConfigsConnects(Decls->ConnectDestUni.Next);
    break;
  case kConnectDestBi:
    if (Decls->ConnectDestBi.FirstDeclaration) {
      WRITEBLANKS();
      WRITEIDENT(Decls->ConnectDestBi.Object->SymConnect.CIdent);
      WRITESTRING(" = L_");
      WRITEIDENT(Decls->ConnectDestBi.Object->SymConnect.CIdent);
      WRITESTRING(";");
      WRITELN();
    }
    CodeRestoreConfigsConnects(Decls->ConnectDestBi.Next);
    break;
  case kNoDecl:
  case kNoConnectDest:
    break;
  default:
    CodeRestoreConfigsConnects(Decls->Decl.Next);
    break;
  }
}

static void CodeRestoreConfigsConnectsPE(tTree Declarations)
{
  CodeFreeVectorVariables(Declarations);
  CodeRestoreConfigsConnects(Declarations);
  WRITEBLANKS();
  WRITESTRING("PE = L_PE;");
  WRITELN();
}

/*
 *  resets the active stack and else stack after an EXIT respectively
 *  before a RETURN statement
 */

static void CodeResetStacksReturn(tConfigs Configs)
{
  while (Configs != NoConfigs) {
    WRITEBLANKS();
    WRITESTRING("RESET_ACTIVE(");
    if (Configs->SymConfigs.Object == NoObject) {
      WRITESTRING("OPEN_VECTOR");
    } else if (Configs->SymConfigs.Object->SymConfig.IsGeneric) {
      WRITESTRING("GENERIC_CONFIGURATION");
    } else {
      WRITEIDENT(Configs->SymConfigs.Object->SymConfig.CIdent);
    }
    WRITESTRING(", ");
    WRITEIDENT(Configs->SymConfigs.ActiveIdent);
    WRITESTRING("); RESET_ELSE(");
    if (Configs->SymConfigs.Object == NoObject) {
      WRITESTRING("OPEN_VECTOR");
    } else if (Configs->SymConfigs.Object->SymConfig.IsGeneric) {
      WRITESTRING("GENERIC_CONFIGURATION");
    } else {
      WRITEIDENT(Configs->SymConfigs.Object->SymConfig.CIdent);
    }
    WRITESTRING(", ");
    WRITEIDENT(Configs->SymConfigs.ElseIdent);
    WRITESTRING(");");
    WRITELN();
    Configs = Configs->SymConfigs.Next;
  }
}

static void CodeResetStacksExit(tConfigs Configs)
{
  if (Configs != NoConfigs) {
    CodeResetStacksReturn(Configs);
    DETAB(1);
    WRITEBLANKS();
    WRITESTRING("}");
    WRITELN();
  }
}

/*
 *  generate informations for the debugging tool
 */


#if 1
#define SetDebugLineFull() debuglinefull = TRUE
#else
static void SetDebugLineFull(void);
{
  debuglinefull = TRUE;
}
#endif

static void SetDebugLine(tPosition Position)
{
  if (debugpos.File != Position.File) SetDebugLineFull();
  debugpos = Position;                /* remember the line and file */
}

static void CodeDebugLine(tPosition Position)
{
  SetDebugLine(Position);
  PrintDebugLine();
}

static void PrintDebugLine(void)
{
  if (Options_IsOptionSet(Options_eDebug)) {
    WRITESTRING("#line ");            /* generate a #line from the saved */
    WRITEINT(debugpos.Line);          /* position */
    if (debuglinefull) {
      WRITESTRING(" \"");
      WRITEIDENT(debugpos.File);
      WRITESTRING("\"");
      debuglinefull = FALSE;
    }
    WRITELN();
  }
}


/*
 *  writes a line into the crossreference file
 *  format: Parallaxis-identifier C-identifier configurationname
 *  the configurationname is optional and only set if the identifier
 *  is a variable of a vector type
 */

static void CrossreferenceLine(tIdent PIdent, tIdent CIdent, tIdent Config)
{
  WRITEIDENT(PIdent);
  WRITESTRING(" ");
  WRITEIDENT(CIdent);
  if (Config != 0) {
    WRITESTRING(" ");
    WRITEIDENT(Config);
  }
  WRITESTRING("\n");
}

#ifdef DEVELOP
#define BEGIN_RULE(rulenumber)\
{\
  if (Options_IsOptionSet(Options_eDebugPuma)){\
    if(fileHandle){\
      WRITESTRING("##begin");\
      WRITEINT(rulenumber);\
      WRITESTRING("##");\
      rulestack [rulessp++]=rulenumber;\
    } else printf("%d\n", rulenumber);\
  }\
}
#else
#define BEGIN_RULE(rulenumber)
#endif
#undef END_RULE
#ifdef DEVELOP
#define END_RULE \
{\
  if (Options_IsOptionSet(Options_eDebugPuma)){\
    if(fileHandle){\
        while(rulessp!=0){\
         WRITESTRING("##end");\
         WRITEINT(rulestack[--rulessp]);\
         WRITESTRING("##");\
        }\
    }\
  }\
}
#else
#define END_RULE
#endif
typedef char CHARBUF[1024];
/* end global */


static void yyExit () { Exit (1); }

void (* Code_Exit) () = yyExit;

/*static FILE * yyf = stdout;*/

static void yyAbort
# ifdef __cplusplus
 (char * yyFunction)
# else
 (yyFunction) char * yyFunction;
# endif
{
 (void) fprintf (stderr, "Error: module Code, routine %s failed\n", yyFunction);
 Code_Exit ();
}

void CodeCompUnits ARGS((tTree yyP1));
static void CodeImports ARGS((tTree yyP2));
static void CodeInitModules ARGS((tTree t));
static void CodeInitConfigs ARGS((tTree t));
static void CodeInitConfigBounds ARGS((tTree t, tIdent i, ULONG d));
static void CodeInitConnections ARGS((tTree t));
static void CodeInitDimensions ARGS((tTree t, tIdent Config, BOOLEAN Before, ULONG Rank));
static void CodeComputeConnections ARGS((tTree t, tIdent SourceIdent, tTree SourceIndex));
static void CodeComputeConnectionUni ARGS((tTree t, tIdent SourceIdent, tTree SourceIndex, tTree DestinationConfig, ULONG Rank));
static void CodeComputeConnectionBi ARGS((tTree t, tIdent SourceIdent, tTree SourceIndex, tIdent DestinationIdent, tTree DestinationIndex, tTree DestinationConfig, ULONG Rank));
static void CodeInitGenericConnections ARGS((tTree t, tObject Generic, tIdent ConfigIdent));
static void CodeComputeGenericConnections ARGS((tTree t, tIdent SourceIdent, tTree SourceIndex, tIdent ConfigIdent, ULONG Rank));
static void CodeComputeGenericConnectionUni ARGS((tTree t, tIdent SourceIdent, tTree SourceIndex, tIdent ConfigIdent, ULONG Rank));
static void CodeComputeGenericConnectionBi ARGS((tTree t, tIdent SourceIdent, tTree SourceIndex, tIdent DestinationIdent, tTree DestinationIndex, tIdent ConfigIdent, ULONG Rank));
static void CodeFreeGenericConnections ARGS((tTree t, tObject Generic, tIdent ConfigIdent));
static void CodeInitVectorVariables ARGS((tTree t));
static void CodeInitVectors ARGS((tTree t, tTree v));
static void CodeInitRecordVectors ARGS((tTree f, tTree t, tTree v));
static void CodeFreeConfigs ARGS((tTree t));
static void CodeFreeVectorVariables ARGS((tTree t));
static void CodeFreeVectors ARGS((tTree t, tTree v));
static void CodeFreeRecordVectors ARGS((tTree f, tTree t, tTree v));
static void CodeArrayUpperbound ARGS((tTree t));
static void CodeDefMod ARGS((tTree t));
static void CodeDefModConst ARGS((tTree t));
static void CodeDefModConfig ARGS((tTree t));
static void CodeDefModConnect ARGS((tTree t));
static void CodeDefModOpaque ARGS((tTree t));
static void CodeDefModType ARGS((tTree t));
static void CodeDefModConstInit ARGS((tTree t));
static void CodeDefModVar ARGS((tTree t));
static void CodeDefModProc ARGS((tTree t));
static void CodeDefProg ARGS((tTree t));
static void CodeDecls1 ARGS((tTree t));
static void CodeDeclsConst ARGS((tTree t));
static void CodeDeclsConfig ARGS((tTree t));
static void CodeDeclsConnect ARGS((tTree t));
static void CodeDeclsType ARGS((tTree t));
static void CodeDeclsConstInit ARGS((tTree t));
static void CodeDeclsVar ARGS((tTree t));
static void CodeDeclsProc ARGS((tTree t));
static void CodeType ARGS((tTree t, BOOLEAN Full));
static void CodeDecla ARGS((tTree t, BOOLEAN Before));
static void CodeDeclaFormals ARGS((tTree t, BOOLEAN Before));
static void CodeStruct ARGS((tTree t));
static void CodeEnums ARGS((tTree t));
static void CodeIds ARGS((tTree t, tTree ttype));
static void CodeProcs ARGS((tTree t));
static void CodeFormals1 ARGS((tTree t));
static void CodeFormals2 ARGS((tTree t, tTree u, tIdent ElemTypeId));
static void CodeFormals3 ARGS((tTree t, tTree u, tIdent typeIdent));
static void CodeFormals4 ARGS((tTree yyP3));
static void CodeFormalsOpenVector ARGS((tTree yyP4, ULONG ParamKind));
static void CodeFormalsGenericConfig ARGS((tTree yyP5, ULONG ParamKind));
static void CodeDecls2 ARGS((tTree yyP6, BOOLEAN * NewLine));
static void CodeExpr ARGS((tTree t, ULONG Prec));
static void CodeExprCompute ARGS((tTree t));
static void CodeAdr ARGS((tTree t));
static void CodeString2 ARGS((tTree t, BOOLEAN Strncpy));
static void CodeStmts ARGS((tTree t));
static void CodeStmtsElse ARGS((tTree t, tTree e, BOOLEAN WasVector, tTree cond, tIdent expression));
static void CodeStmtsCases ARGS((tTree t, tTree e, tIdent expression));
static void CodeStmtsSend ARGS((tTree t, tTree From, tTree To));
static void CodeStmtsReceive ARGS((tTree t, tTree From, tIdent To, tType ToType));
static void CodeStmtsMove ARGS((tTree t, tTree From, tIdent To, tType ToType));
static void CodeStdProc ARGS((tTree a1, INDEX StdProc, tObject AllocOrDealloc));
static void CodeActuals ARGS((tTree t));
static void CodeActualsCompute ARGS((tTree t));
static void CodeActualsRestoreVars ARGS((tTree t));
static void CodeActualsHelpVar ARGS((tTree t));
static void CodeActualsOpenVector ARGS((tTree t));
static void CodeActualsGenericConfig ARGS((tTree t));
static void CodeExprHelpVarBegin ARGS((tTree t));
static void CodeDesignatorHelpVarBegin ARGS((tTree t));
static void CodeExprHelpVarClose ARGS((tTree t));
static void CodeReturnHelpVarClose ARGS((tTree t));
static void CodeDesignatorHelpVarClose ARGS((tTree t));
static void CodeSepa ARGS((tTree yyP7));
static void Crossreference ARGS((tTree t));

void CodeCompUnits
# if defined __STDC__ | defined __cplusplus
(register tTree yyP1)
# else
(yyP1)
 register tTree yyP1;
# endif
{
/* line 2469 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (yyP1->Kind == kROOT) {
/* line 2476 "new_C.puma" */
  {
/* line 2477 "new_C.puma" */
BEGIN_RULE(1);
/* line 2479 "new_C.puma" */

                TreeRoot = yyP1->ROOT.CompUnits;
                CodeCompUnits(yyP1->ROOT.CompUnits);
                if (Options_IsOptionSet(Options_eDebug)) {
                  Crossreference(yyP1->ROOT.CompUnits);
                }

  }
END_RULE;
   return;

  }
  if (yyP1->Kind == kDefMod) {
  if (yyP1->DefMod.Next->Kind == kNoCompUnit) {
/* line 2487 "new_C.puma" */
  {
/* line 2488 "new_C.puma" */
BEGIN_RULE(2);
/* line 2490 "new_C.puma" */

                AssocTab_PutAssoc(yyP1->DefMod.Ident, yyP1);
                if (yyP1->DefMod.Ident != yyP1->DefMod.RealName) {
                  ErrorMessage(xxInvalidFilename, xxWarning, yyP1->DefMod.Pos);
                }
                fileHandle = GeneralIO_OpenCHeader(yyP1->DefMod.RealName);
		SetDebugLineFull();
		CodeDebugLine(yyP1->DefMod.Pos);
                WRITESTRING("#ifndef _");
                WRITEIDENT(yyP1->DefMod.RealName);
                WRITESTRING("_h\n#define _");
                WRITEIDENT(yyP1->DefMod.RealName);
                WRITESTRING("_h\n");
		WRITELN();
                CodeImports(yyP1->DefMod.Imports);
                CodeDefMod(yyP1->DefMod.Decls);
                WRITESTRING("extern void BEGIN_");
                WRITEIDENT(yyP1->DefMod.RealName);
                WRITESTRING("();\n\n#endif\n");
                FileIO_Close( fileHandle );
                 


  }
END_RULE;
   return;

  }
  if (Tree_IsType (yyP1->DefMod.Next, kCompUnit)) {
/* line 2520 "new_C.puma" */
  {
/* line 2521 "new_C.puma" */
BEGIN_RULE(3);
/* line 2523 "new_C.puma" */

                AssocTab_PutAssoc(yyP1->DefMod.Ident, yyP1 );
                if (yyP1->DefMod.Ident != yyP1->DefMod.RealName) {
                  ErrorMessage(xxInvalidFilename, xxWarning, yyP1->DefMod.Pos);
                }
                if ( Options_IsOptionSet( Options_eInclude ) ) {
                  fileHandle = GeneralIO_OpenCHeader(yyP1->DefMod.RealName);
		  SetDebugLineFull();
		  CodeDebugLine(yyP1->DefMod.Pos);
                  WRITESTRING("#ifndef _");
                  WRITEIDENT(yyP1->DefMod.RealName);
                  WRITESTRING("_h\n");
                  WRITESTRING("#define _");
                  WRITEIDENT(yyP1->DefMod.RealName);
                  WRITESTRING("_h\n");
		  WRITELN();
                  CodeImports( yyP1->DefMod.Imports);
                  CodeDefMod( yyP1->DefMod.Decls );
                  WRITESTRING("extern void BEGIN_");
                  WRITEIDENT(yyP1->DefMod.RealName);
                  WRITESTRING("();\n\n#endif\n");
                  FileIO_Close( fileHandle );
                  

                };
                CodeCompUnits( yyP1->DefMod.Next );

  }
END_RULE;
   return;

  }
  }
  if (yyP1->Kind == kImplMod) {
  if (yyP1->ImplMod.Next->Kind == kNoCompUnit) {
/* line 2558 "new_C.puma" */
 {
  tTree DefMod;
  {
/* line 2559 "new_C.puma" */
BEGIN_RULE(4);
/* line 2561 "new_C.puma" */
   if (! (yyP1->ImplMod.Kind == ModTypeImp)) goto yyL4;
  {
/* line 2562 "new_C.puma" */

/* line 2563 "new_C.puma" */

                if (yyP1->ImplMod.Ident != yyP1->ImplMod.RealName) {
                  ErrorMessage(xxInvalidFilename, xxWarning, yyP1->ImplMod.Pos);
                }
                fileHandle = GeneralIO_OpenCModule(yyP1->ImplMod.RealName);
                AssocTab_GetAssoc(yyP1->ImplMod.Ident, (void **) &DefMod);
                if (DefMod == NoTree) {
                  fprintf(stderr, "Code.CodeCompUnits: assertion violation\n");
                  (void) FileIO_CloseAll();
                  exit(1);
                };
		SetDebugLineFull();
		CodeDebugLine(yyP1->ImplMod.Pos);
                WRITESTRING("#include \"SYSTEM_C.h\"\n#include \"");
                WRITEIDENT(yyP1->ImplMod.RealName);
                WRITESTRING(".h\"");
		WRITELN();
		SetDebugLineFull();
                CodeImports(yyP1->ImplMod.Imports);
                CodeDefProg(DefMod->DefMod.Decls);
                WRITELN();
                CodeDecls1(yyP1->ImplMod.Decls);
                WRITELN();
                Pointer_GenGlobalPtrs(yyP1->ImplMod.GlobalPtrs);
                Pointer_GlobalPtrs = yyP1->ImplMod.GlobalPtrs;
                CodePointers(STORAGE_STATIC, yyP1->ImplMod.GlobalPtrs);
                WRITELN();
                CodeProcs(yyP1->ImplMod.Decls);
                
		CodeDebugLine(yyP1->ImplMod.BeginPos);
                WRITESTRING("void BEGIN_");
                WRITEIDENT(yyP1->ImplMod.RealName);
                WRITESTRING("()\n");
		PrintDebugLine();
                WRITESTRING("{");
		WRITELN();
                TAB(1);
		WRITEBLANKS();
		WRITESTRING("static BOOLEAN IsInitialized = FALSE;\n" );
		WRITELN();
                  CodeStrings (yyP1->ImplMod.Strings);
                  if (yyP1->ImplMod.Strings != NoStrings) {
                    WRITELN();
                  }
                  WRITESTRING("  if (!IsInitialized) {");
		  WRITELN();
                  WRITESTRING("    IsInitialized = TRUE;\n");
		  WRITELN();
                  TAB(1);
                    CodeInitModules(DefMod->DefMod.Imports);
                    CodeInitModules(yyP1->ImplMod.Imports);
                    CodeStrncpy(yyP1->ImplMod.Strings);
                    CodeInitConfigs(DefMod->DefMod.Decls);
                    CodeInitConfigs(yyP1->ImplMod.Decls);
                    CodeInitConnections(DefMod->DefMod.Decls);
                    CodeInitConnections(yyP1->ImplMod.Decls);
                    CodeInitVectorVariables(DefMod->DefMod.Decls);
                    CodeInitVectorVariables(yyP1->ImplMod.Decls);
                    CodeInitModules(yyP1->ImplMod.Decls);
                    WRITELN();
                    CodeStmts(yyP1->ImplMod.Stmts);
                DETAB(2);
                WRITESTRING("  }\n");
                WRITESTRING("}\n");
                FileIO_Close(fileHandle);

  }
  }
END_RULE;
   return;
 }
yyL4:;

/* line 2632 "new_C.puma" */
  {
/* line 2633 "new_C.puma" */
BEGIN_RULE(5);
/* line 2635 "new_C.puma" */
   if (! (yyP1->ImplMod.Kind == ModTypeProg)) goto yyL5;
  {
/* line 2636 "new_C.puma" */

                if (yyP1->ImplMod.Ident != yyP1->ImplMod.RealName) {
                  ErrorMessage(xxInvalidFilename, xxWarning, yyP1->ImplMod.Pos);
                }
                fileHandle = GeneralIO_OpenCModule(yyP1->ImplMod.RealName);
		SetDebugLineFull();
		CodeDebugLine(yyP1->ImplMod.Pos);
                WRITESTRING("#include \"SYSTEM_C.h\"");
		WRITELN();
		SetDebugLineFull();
                CodeImports(yyP1->ImplMod.Imports);
                CodeDecls1(yyP1->ImplMod.Decls);
                WRITELN();
                Pointer_GenGlobalPtrs(yyP1->ImplMod.GlobalPtrs);
                Pointer_GlobalPtrs = yyP1->ImplMod.GlobalPtrs;
                CodePointers (STORAGE_STATIC, yyP1->ImplMod.GlobalPtrs);
                WRITELN();
                CodeProcs (yyP1->ImplMod.Decls);
		CodeDebugLine(yyP1->ImplMod.BeginPos);
		WRITESTRING("int main\n");
		WRITESTRING("#ifdef __STDC__\n");
		WRITESTRING("(int _argc, char *_argv[], char *_envp[])\n");
		WRITESTRING("#else\n");
		WRITESTRING("(_argc, _argv, _envp)\n");
		WRITESTRING("int _argc;\n");
		WRITESTRING("char *_argv[], *_envp[];\n");
		WRITESTRING("#endif\n");

		PrintDebugLine();
                WRITESTRING("{");
		WRITELN();
                TAB(1);
		  WRITEBLANKS();
		  WRITESTRING("INIT_MODULE(_argc, _argv, _envp);");
		  WRITELN();
                  CodeStrings(yyP1->ImplMod.Strings);
                  if (yyP1->ImplMod.Strings != NoStrings) {
                    WRITELN();
                  };
                  CodeInitModules(yyP1->ImplMod.Imports);
                  CodeStrncpy(yyP1->ImplMod.Strings);
                  CodeInitConfigs(yyP1->ImplMod.Decls);
                  CodeInitConnections(yyP1->ImplMod.Decls);
                  CodeInitVectorVariables(yyP1->ImplMod.Decls);
                  CodeInitModules(yyP1->ImplMod.Decls);
                  WRITELN();
                  CodeStmts(yyP1->ImplMod.Stmts);


		  WRITEBLANKS();
		  WRITESTRING("EXIT_MODULE();");
		  WRITELN();
		  WRITESTRING("return 0;");
		  WRITELN();
                DETAB(1);
                WRITESTRING("}\n");
                FileIO_Close(fileHandle);

  }
  }
END_RULE;
   return;
yyL5:;

  }
  }
/* line 2700 "new_C.puma" */
  {
/* line 2701 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeImports
# if defined __STDC__ | defined __cplusplus
(register tTree yyP2)
# else
(yyP2)
 register tTree yyP2;
# endif
{
/* line 2707 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (yyP2->Kind == kFrom) {
/* line 2714 "new_C.puma" */
  {
/* line 2715 "new_C.puma" */
BEGIN_RULE(6);
/* line 2717 "new_C.puma" */
   if (! (yyP2->From.Ident != IdentSYSTEM)) goto yyL1;
  {
/* line 2718 "new_C.puma" */
   CodeDebugLine (yyP2->From.Pos);
/* line 2719 "new_C.puma" */
   WRITESTRING ("#include \"");
/* line 2720 "new_C.puma" */
   WRITEIDENT (yyP2->From.Ident);
/* line 2721 "new_C.puma" */
   WRITESTRING (".h\"");
/* line 2722 "new_C.puma" */
   WRITELN ();
/* line 2723 "new_C.puma" */
   SetDebugLineFull ();
/* line 2724 "new_C.puma" */
   CodeImports (yyP2->From.Next);
  }
  }
END_RULE;
   return;
yyL1:;

/* line 2726 "new_C.puma" */
  {
/* line 2727 "new_C.puma" */
BEGIN_RULE(7);
/* line 2729 "new_C.puma" */
   CodeImports (yyP2->From.Next);
  }
END_RULE;
   return;

  }
  if (yyP2->Kind == kObjects) {
/* line 2731 "new_C.puma" */
  {
/* line 2732 "new_C.puma" */
BEGIN_RULE(8);
/* line 2734 "new_C.puma" */
   CodeImports (yyP2->Objects.ImpIds);
/* line 2735 "new_C.puma" */
   CodeImports (yyP2->Objects.Next);
  }
END_RULE;
   return;

  }
  if (yyP2->Kind == kImpId) {
/* line 2737 "new_C.puma" */
  {
/* line 2738 "new_C.puma" */
BEGIN_RULE(9);
/* line 2740 "new_C.puma" */
   CodeDebugLine (yyP2->ImpId.Pos);
/* line 2741 "new_C.puma" */
   if (! (yyP2->ImpId.Ident != IdentSYSTEM)) goto yyL4;
  {
/* line 2742 "new_C.puma" */
   WRITESTRING ("#include \"");
/* line 2743 "new_C.puma" */
   WRITEIDENT (yyP2->ImpId.Ident);
/* line 2744 "new_C.puma" */
   WRITESTRING (".h\"");
/* line 2745 "new_C.puma" */
   WRITELN ();
/* line 2746 "new_C.puma" */
   SetDebugLineFull ();
/* line 2747 "new_C.puma" */
   CodeImports (yyP2->ImpId.Next);
  }
  }
END_RULE;
   return;
yyL4:;

/* line 2749 "new_C.puma" */
  {
/* line 2750 "new_C.puma" */
BEGIN_RULE(10);
/* line 2752 "new_C.puma" */
   CodeImports (yyP2->ImpId.Next);
  }
END_RULE;
   return;

  }
/* line 2754 "new_C.puma" */
  {
/* line 2755 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeInitModules
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 2761 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kFrom) {
/* line 2768 "new_C.puma" */
  {
/* line 2769 "new_C.puma" */
BEGIN_RULE(11);
/* line 2771 "new_C.puma" */
   if (! (t->From.Ident != IdentSYSTEM)) goto yyL1;
  {
/* line 2772 "new_C.puma" */
   WRITEBLANKS ();
/* line 2773 "new_C.puma" */
   WRITESTRING ("BEGIN_");
/* line 2774 "new_C.puma" */
   WRITEIDENT (t->From.Ident);
/* line 2775 "new_C.puma" */
   WRITESTRING ("();\n");
/* line 2776 "new_C.puma" */
   CodeInitModules (t->From.Next);
  }
  }
END_RULE;
   return;
yyL1:;

/* line 2778 "new_C.puma" */
  {
/* line 2779 "new_C.puma" */
BEGIN_RULE(12);
/* line 2781 "new_C.puma" */
   CodeInitModules (t->From.Next);
  }
END_RULE;
   return;

  }
  if (t->Kind == kObjects) {
/* line 2783 "new_C.puma" */
  {
/* line 2784 "new_C.puma" */
BEGIN_RULE(13);
/* line 2786 "new_C.puma" */
   CodeInitModules (t->Objects.ImpIds);
/* line 2787 "new_C.puma" */
   CodeInitModules (t->Objects.Next);
  }
END_RULE;
   return;

  }
  if (t->Kind == kImpId) {
/* line 2789 "new_C.puma" */
  {
/* line 2790 "new_C.puma" */
BEGIN_RULE(14);
/* line 2792 "new_C.puma" */
   if (! (t->ImpId.Ident != IdentSYSTEM)) goto yyL4;
  {
/* line 2793 "new_C.puma" */
   WRITEBLANKS ();
/* line 2794 "new_C.puma" */
   WRITESTRING ("BEGIN_");
/* line 2795 "new_C.puma" */
   WRITEIDENT (t->ImpId.Ident);
/* line 2796 "new_C.puma" */
   WRITESTRING ("();\n");
/* line 2797 "new_C.puma" */
   CodeInitModules (t->ImpId.Next);
  }
  }
END_RULE;
   return;
yyL4:;

/* line 2799 "new_C.puma" */
  {
/* line 2800 "new_C.puma" */
BEGIN_RULE(15);
/* line 2802 "new_C.puma" */
   CodeInitModules (t->ImpId.Next);
  }
END_RULE;
   return;

  }
  if (Tree_IsType (t, kDecl)) {
/* line 2804 "new_C.puma" */
  {
/* line 2805 "new_C.puma" */
BEGIN_RULE(16);
/* line 2807 "new_C.puma" */
   CodeInitModules (t->Decl.Next);
  }
END_RULE;
   return;

  }
/* line 2809 "new_C.puma" */
  {
/* line 2810 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeInitConfigs
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 2815 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kConfig) {
/* line 2821 "new_C.puma" */
  {
/* line 2822 "new_C.puma" */
BEGIN_RULE(17);
/* line 2824 "new_C.puma" */
   if (! (! t -> Config . Object -> SymConfig . IsGeneric)) goto yyL1;
  {
/* line 2825 "new_C.puma" */

	        if (t->Config.View != NoObject) {
		  
		  CodeInitConfigs(t->Config.Next);
		}
                WRITEBLANKS();
                WRITESTRING("INIT_CONFIGURATION(\"");
                WRITEIDENT(t->Config.CIdent);
                WRITESTRING("\", &");
                WRITEIDENT(t->Config.CIdent);
                WRITESTRING(", ");
                WRITEINT(t->Config.Object->SymConfig.Rank);
                WRITESTRING(");");
		WRITELN();
                CodeInitConfigBounds( t->Config.Actuals, t->Config.CIdent, 0 );

                WRITEBLANKS();
                if (t->Config.View == NoObject) {
                  WRITESTRING("INIT_STACKS(&");
                  WRITEIDENT(t->Config.CIdent);
		} else {
                  WRITESTRING("COPY_STACKS(&");
                  WRITEIDENT(t->Config.CIdent);
                  WRITESTRING(", &");
                  WRITEIDENT(t->Config.Object->SymConfig.View->SymConfig.CIdent);
		}
                WRITESTRING(");\n");
		WRITELN();
                if (t->Config.Respecified) {
                  CodeInitGenericConnections(TreeRoot, t->Config.Qualid->Qualid.Object,
                    t->Config.CIdent);
                }
	        if (t->Config.View == NoObject) {
		  CodeInitConfigs(t->Config.Next);
		}

  }
  }
END_RULE;
   return;
yyL1:;

  }
  if (Tree_IsType (t, kDecl)) {
/* line 2863 "new_C.puma" */
  {
/* line 2864 "new_C.puma" */
BEGIN_RULE(18);
/* line 2866 "new_C.puma" */
   CodeInitConfigs (t->Decl.Next);
  }
END_RULE;
   return;

  }
/* line 2868 "new_C.puma" */
  {
/* line 2869 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeInitConfigBounds
# if defined __STDC__ | defined __cplusplus
(register tTree t, register tIdent i, ULONG d)
# else
(t, i, d)
 register tTree t;
 register tIdent i;
 ULONG d;
# endif
{
/* line 2871 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kActualRange) {
/* line 2877 "new_C.puma" */
  {
/* line 2878 "new_C.puma" */
BEGIN_RULE(19);
/* line 2880 "new_C.puma" */
   WRITEBLANKS ();
/* line 2881 "new_C.puma" */
   WRITESTRING ("SET_BOUNDS(&");
/* line 2882 "new_C.puma" */
   WRITEIDENT (i);
/* line 2883 "new_C.puma" */
   WRITESTRING (", ");
/* line 2884 "new_C.puma" */
   WRITEINT (d);
/* line 2885 "new_C.puma" */
   WRITESTRING (", ");
/* line 2886 "new_C.puma" */
   CodeExpr (t->ActualRange.Lwb, PASSVALUE_PREC);
/* line 2887 "new_C.puma" */
   WRITESTRING (", ");
/* line 2888 "new_C.puma" */
   CodeExpr (t->ActualRange.Upb, PASSVALUE_PREC);
/* line 2889 "new_C.puma" */
   WRITESTRING (");");
/* line 2890 "new_C.puma" */
   WRITELN ();
/* line 2891 "new_C.puma" */
   CodeInitConfigBounds (t->ActualRange.Next, i, d + 1);
  }
END_RULE;
   return;

  }
/* line 2893 "new_C.puma" */
  {
/* line 2894 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeInitConnections
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 2899 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kConnectFrom) {
/* line 2905 "new_C.puma" */
  {
/* line 2906 "new_C.puma" */
BEGIN_RULE(20);
/* line 2908 "new_C.puma" */
   if (! (! t->ConnectFrom.ConnectDecls -> ConnectDecls . Config -> Qualid . Object -> SymConfig . IsGeneric)) goto yyL1;
  {
/* line 2909 "new_C.puma" */
   WRITEBLANKS ();
/* line 2910 "new_C.puma" */
   WRITESTRING ("{ INTEGER ");
/* line 2911 "new_C.puma" */
   WRITEIDENT (t -> ConnectFrom . CIdent);
/* line 2912 "new_C.puma" */
   WRITESTRING ("; for (");
/* line 2913 "new_C.puma" */
   WRITEIDENT (t -> ConnectFrom . CIdent);
/* line 2914 "new_C.puma" */
   WRITESTRING (" = ");
/* line 2915 "new_C.puma" */
   CodeExpr (t->ConnectFrom.From, ASSIGN_PREC);
/* line 2916 "new_C.puma" */
   WRITESTRING ("; ");
/* line 2917 "new_C.puma" */
   WRITEIDENT (t -> ConnectFrom . CIdent);
/* line 2918 "new_C.puma" */
   WRITESTRING (" <= ");
/* line 2919 "new_C.puma" */
   CodeExpr (t->ConnectFrom.To, LESSEQUAL_PREC);
/* line 2920 "new_C.puma" */
   WRITESTRING ("; ");
/* line 2921 "new_C.puma" */
   WRITEIDENT (t -> ConnectFrom . CIdent);
/* line 2922 "new_C.puma" */
   WRITESTRING ("++) {");
/* line 2923 "new_C.puma" */
   WRITELN ();
/* line 2924 "new_C.puma" */
   TAB (1);
/* line 2925 "new_C.puma" */
   CodeInitConnections (t->ConnectFrom.ConnectDecls);
/* line 2926 "new_C.puma" */
   DETAB (1);
/* line 2927 "new_C.puma" */
   WRITEBLANKS ();
/* line 2928 "new_C.puma" */
   WRITESTRING ("} }\n");
/* line 2929 "new_C.puma" */
   WRITELN ();
/* line 2930 "new_C.puma" */
   CodeInitConnections (t->ConnectFrom.Next);
  }
  }
END_RULE;
   return;
yyL1:;

  }
  if (t->Kind == kConnectDecls) {
/* line 2932 "new_C.puma" */
  {
/* line 2933 "new_C.puma" */
BEGIN_RULE(21);
/* line 2935 "new_C.puma" */
   if (! (! t->ConnectDecls.Config -> Qualid . Object -> SymConfig . IsGeneric)) goto yyL2;
  {
/* line 2936 "new_C.puma" */

      tIdent ConfigIdent;
                ConfigIdent = t->ConnectDecls.Config->Qualid.Object->SymConfig.CIdent;
                if (t->ConnectDecls.FirstDeclaration) {
                  WRITEBLANKS();
                  if (t->ConnectDecls.Index == NoExpr) {
                    WRITESTRING("INIT_CONNECTION(&");
                  } else {
                    WRITESTRING("INIT_PARAMETER_CONNECTION(&");
                  }
                  WRITEIDENT(t->ConnectDecls.CIdent);
                  WRITESTRING(", &");
                  WRITEIDENT(t->ConnectDecls.Object->SymConnect.SourceConfig->SymConfig.CIdent);
                  WRITESTRING(", &");
                  WRITEIDENT(t->ConnectDecls.Object->SymConnect.DestConfig->SymConfig.CIdent);
                  WRITESTRING(");");
		  WRITELN();
                }
                CodeInitConnections(t->ConnectDecls.DirIn);
                WRITEBLANKS();
                WRITESTRING("SOURCE_ARRAY = (INTEGER *) malloc(sizeof(INTEGER) * RANK(");
                WRITEIDENT(ConfigIdent);
                WRITESTRING("));");
                WRITELN();
                CodeInitDimensions(t->ConnectDecls.Actuals, ConfigIdent, BEFORE,
                  t->ConnectDecls.Config->Qualid.Object->SymConfig.Rank);
                CodeComputeConnections(t->ConnectDecls.DirIn, t->ConnectDecls.CIdent,
                  t->ConnectDecls.Index);
                CodeInitDimensions(t->ConnectDecls.Actuals, NoIdent, AFTER, 0);
                WRITEBLANKS();
                WRITESTRING("free(SOURCE_ARRAY);\n");
                WRITELN();
                CodeInitConnections(t->ConnectDecls.Next);

  }
  }
END_RULE;
   return;
yyL2:;

  }
  if (Tree_IsType (t, kDecl)) {
/* line 2971 "new_C.puma" */
  {
/* line 2972 "new_C.puma" */
BEGIN_RULE(22);
/* line 2974 "new_C.puma" */
   CodeInitConnections (t->Decl.Next);
  }
END_RULE;
   return;

  }
  if (t->Kind == kConnectDestBi) {
/* line 2977 "new_C.puma" */
  {
/* line 2978 "new_C.puma" */
BEGIN_RULE(23);
/* line 2980 "new_C.puma" */

                if (t->ConnectDestBi.FirstDeclaration) {
                  WRITEBLANKS();
                  if (t->ConnectDestBi.Index == NoExpr) {
                    WRITESTRING("INIT_CONNECTION(&");
                  } else {
                    WRITESTRING("INIT_PARAMETER_CONNECTION(&");
                  }
                  WRITEIDENT(t->ConnectDestBi.CIdent);
                  WRITESTRING(", &");
                  WRITEIDENT(t->ConnectDestBi.Object->SymConnect.SourceConfig->SymConfig.CIdent);
                  WRITESTRING(", &");
                  WRITEIDENT(t->ConnectDestBi.Object->SymConnect.DestConfig->SymConfig.CIdent);
                  WRITESTRING(");");
		  WRITELN();
                }

/* line 2997 "new_C.puma" */
   CodeInitConnections (t->ConnectDestBi.Next);
  }
END_RULE;
   return;

  }
/* line 2999 "new_C.puma" */
  {
/* line 3000 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeInitDimensions
# if defined __STDC__ | defined __cplusplus
(register tTree t, register tIdent Config, BOOLEAN Before, ULONG Rank)
# else
(t, Config, Before, Rank)
 register tTree t;
 register tIdent Config;
 BOOLEAN Before;
 ULONG Rank;
# endif
{
/* line 3005 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kActualExpr) {
/* line 3011 "new_C.puma" */
  {
/* line 3012 "new_C.puma" */
BEGIN_RULE(24);
/* line 3014 "new_C.puma" */
   if (! ((t->ActualExpr.Expr -> Kind == kQualid0 && t->ActualExpr.Expr -> Qualid0 . Object -> Kind == kSymVar && t->ActualExpr.Expr -> Qualid0 . Object -> SymVar . IsDimIndex))) goto yyL1;
  {
/* line 3017 "new_C.puma" */

        tIdent DimIdent;
                if (Before) {
                  DimIdent = t->ActualExpr.Expr->Qualid0.Object->SymObject.Ident;
                  WRITEBLANKS();
                  WRITESTRING("{ INTEGER ");
                  WRITEIDENT(DimIdent);
                  WRITESTRING("; for (");
                  WRITEIDENT(DimIdent);
                  WRITESTRING(" = LOWER(");
                  WRITEIDENT(Config);
                  WRITESTRING(", ");
                  WRITEINT(Rank);
                  WRITESTRING("); ");
                  WRITEIDENT(DimIdent);
                  WRITESTRING(" <= UPPER(");
                  WRITEIDENT(Config);
                  WRITESTRING(", ");
                  WRITEINT(Rank);
                  WRITESTRING("); ");
                  WRITEIDENT(DimIdent);
                  WRITESTRING("++) {");
		  WRITELN();
                  TAB(1);
                    WRITEBLANKS();
                    WRITESTRING("SOURCE_ARRAY[");
                    WRITEINT(Rank - 1);
                    WRITESTRING("] = ");
                    WRITEIDENT(DimIdent);
                    WRITESTRING(";");
		    WRITELN();
                } else {
                  DETAB(1);
                  WRITEBLANKS();
                  WRITESTRING("} }");
		  WRITELN();
                }
                CodeInitDimensions(t->ActualExpr.Next, Config, Before, Rank - 1);

  }
  }
END_RULE;
   return;
yyL1:;

/* line 3057 "new_C.puma" */
  {
/* line 3058 "new_C.puma" */
BEGIN_RULE(25);
/* line 3060 "new_C.puma" */
   if (! ((t->ActualExpr.Expr -> Kind == kQualid0))) goto yyL2;
  {
/* line 3061 "new_C.puma" */

		if (Before) {
                  WRITEBLANKS();
                  WRITESTRING("SOURCE_ARRAY[");
                  WRITEINT(Rank - 1);
                  WRITESTRING("] = ");
                  WRITEIDENT(t->ActualExpr.Expr->Qualid0.Object->SymObject.Ident);
                  WRITESTRING(";");
                  WRITELN();
                }
                CodeInitDimensions(t->ActualExpr.Next, Config, Before, Rank - 1);

  }
  }
END_RULE;
   return;
yyL2:;

/* line 3074 "new_C.puma" */
  {
/* line 3075 "new_C.puma" */
BEGIN_RULE(26);
/* line 3077 "new_C.puma" */
   if (! ((t->ActualExpr.Expr -> Kind == kIntConst || t->ActualExpr.Expr -> Kind == kStringConst))) goto yyL3;
  {
/* line 3078 "new_C.puma" */

                if (Before) {
                  WRITEBLANKS();
                  WRITESTRING("SOURCE_ARRAY[");
                  WRITEINT(Rank - 1);
                  WRITESTRING("] = ");
                  CodeExpr(t->ActualExpr.Expr, ASSIGN_PREC);
                  WRITESTRING(";");
		  WRITELN();
                }
                CodeInitDimensions(t->ActualExpr.Next, Config, Before, Rank - 1);

  }
  }
END_RULE;
   return;
yyL3:;

  }
  if (t->Kind == kActualStar) {
/* line 3091 "new_C.puma" */
 {
  tIdent DimIdent;
  {
/* line 3092 "new_C.puma" */
BEGIN_RULE(27);
/* line 3094 "new_C.puma" */

/* line 3095 "new_C.puma" */

                if (Before) {
                  DimIdent = GenIdents_HelpVar();
                  WRITEBLANKS();
                  WRITESTRING("{ INTEGER ");
                  WRITEIDENT(DimIdent);
                  WRITESTRING("; for (");
                  WRITEIDENT(DimIdent);
                  WRITESTRING(" = LOWER(");
                  WRITEIDENT(Config);
                  WRITESTRING(", ");
                  WRITEINT(Rank);
                  WRITESTRING("); ");
                  WRITEIDENT(DimIdent);
                  WRITESTRING(" <= UPPER(");
                  WRITEIDENT(Config);
                  WRITESTRING(", ");
                  WRITEINT(Rank);
                  WRITESTRING("); ");
                  WRITEIDENT(DimIdent);
                  WRITESTRING("++) {");
		  WRITELN();
                  TAB(1);
                    WRITEBLANKS();
                    WRITESTRING("SOURCE_ARRAY[");
                    WRITEINT(Rank - 1);
                    WRITESTRING("] = ");
                    WRITEIDENT(DimIdent);
                    WRITESTRING(";");
		    WRITELN();
                } else {
                  DETAB(1);
                  WRITEBLANKS();
                  WRITESTRING("} }");
		  WRITELN();
                }
                CodeInitDimensions(t->ActualStar.Next, Config, Before, Rank - 1);

  }
END_RULE;
   return;
 }

  }
/* line 3134 "new_C.puma" */
  {
/* line 3135 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeComputeConnections
# if defined __STDC__ | defined __cplusplus
(register tTree t, register tIdent SourceIdent, register tTree SourceIndex)
# else
(t, SourceIdent, SourceIndex)
 register tTree t;
 register tIdent SourceIdent;
 register tTree SourceIndex;
# endif
{
/* line 3140 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kConnectDestUni) {
/* line 3146 "new_C.puma" */
  {
/* line 3147 "new_C.puma" */
BEGIN_RULE(28);
/* line 3149 "new_C.puma" */

                WRITEBLANKS();
                WRITESTRING("DESTINATION_ARRAY = (INTEGER *) malloc(sizeof(INTEGER) * RANK(");
                WRITEIDENT(t->ConnectDestUni.Config->Qualid.Object->SymConfig.CIdent);
                WRITESTRING("));");
		WRITELN();
                if (t->ConnectDestUni.Expr != NoExpr) {
                  CodeExprBegin(t->ConnectDestUni.Expr);
                  WRITEBLANKS();
                  WRITESTRING("if (");
                  CodeExprWrite(t->ConnectDestUni.Expr, MINPREC_PREC);
                  WRITESTRING(") {");
		  WRITELN();
                  TAB(1);
                }
                CodeComputeConnectionUni(t->ConnectDestUni.Actuals, SourceIdent, SourceIndex,
                  t->ConnectDestUni.Config,
                  t->ConnectDestUni.Config->Qualid.Object->SymConfig.Rank);
                if (t->ConnectDestUni.Expr != NoExpr) {
                  DETAB(1);
                  WRITEBLANKS();
                  WRITESTRING("}");
		  WRITELN();
                  CodeExprClose(t->ConnectDestUni.Expr);
                }
                WRITEBLANKS();
                WRITESTRING("free(DESTINATION_ARRAY);");
		WRITELN();
                CodeComputeConnections(t->ConnectDestUni.Next, SourceIdent, SourceIndex);

  }
END_RULE;
   return;

  }
  if (t->Kind == kConnectDestBi) {
/* line 3180 "new_C.puma" */
  {
/* line 3181 "new_C.puma" */
BEGIN_RULE(29);
/* line 3183 "new_C.puma" */

                WRITEBLANKS();
                WRITESTRING("DESTINATION_ARRAY = (INTEGER *) malloc(sizeof(INTEGER) * RANK(");
                WRITEIDENT(t->ConnectDestBi.Config->Qualid.Object->SymConfig.CIdent);
                WRITESTRING("));");
		WRITELN();
                if (t->ConnectDestBi.Expr != NoExpr) {
                  WRITEBLANKS();
                  WRITESTRING("if (");
                  CodeExpr(t->ConnectDestBi.Expr, MINPREC_PREC);
                  WRITESTRING(") {");
		  WRITELN();
                  TAB(1);
                }
                CodeComputeConnectionBi(t->ConnectDestBi.Actuals, SourceIdent, SourceIndex,
                  t->ConnectDestBi.Object->SymConnect.CIdent, t->ConnectDestBi.Index,
                  t->ConnectDestBi.Config,
                  t->ConnectDestBi.Config->Qualid.Object->SymConfig.Rank);
                if (t->ConnectDestBi.Expr != NoExpr) {
                  DETAB(1);
                  WRITEBLANKS();
                  WRITESTRING("}");
		  WRITELN();
                }                
                WRITEBLANKS();
                WRITESTRING("free(DESTINATION_ARRAY);");
		WRITELN();
                CodeComputeConnections(t->ConnectDestBi.Next, SourceIdent, SourceIndex);

  }
END_RULE;
   return;

  }
/* line 3213 "new_C.puma" */
  {
/* line 3214 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeComputeConnectionUni
# if defined __STDC__ | defined __cplusplus
(register tTree t, register tIdent SourceIdent, register tTree SourceIndex, register tTree DestinationConfig, ULONG Rank)
# else
(t, SourceIdent, SourceIndex, DestinationConfig, Rank)
 register tTree t;
 register tIdent SourceIdent;
 register tTree SourceIndex;
 register tTree DestinationConfig;
 ULONG Rank;
# endif
{
/* line 3219 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kNoActual) {
/* line 3225 "new_C.puma" */
  {
/* line 3226 "new_C.puma" */
BEGIN_RULE(30);
/* line 3228 "new_C.puma" */

                WRITEBLANKS();
                if (SourceIndex == NoExpr) {
                  WRITESTRING("REGISTER_LINK");
                } else {
                  WRITESTRING("REGISTER_PARAMETER_LINK");
                }
                WRITESTRING("(&");
                WRITEIDENT(SourceIdent);
                if (SourceIndex != NoExpr) {
                  WRITESTRING(", ");
                  CodeExpr(SourceIndex, PASSVALUE_PREC);
                }
                WRITESTRING(", SOURCE_ARRAY, DESTINATION_ARRAY);");
		WRITELN();

  }
END_RULE;
   return;

  }
  if (t->Kind == kActualExpr) {
/* line 3245 "new_C.puma" */
  {
/* line 3246 "new_C.puma" */
BEGIN_RULE(31);
/* line 3248 "new_C.puma" */
   WRITEBLANKS ();
/* line 3249 "new_C.puma" */
   WRITESTRING ("DESTINATION_ARRAY[");
/* line 3250 "new_C.puma" */
   WRITEINT (Rank - 1);
/* line 3251 "new_C.puma" */
   WRITESTRING ("] = ");
/* line 3252 "new_C.puma" */
   CodeExpr (t->ActualExpr.Expr, ASSIGN_PREC);
/* line 3253 "new_C.puma" */
   WRITESTRING (";");
/* line 3254 "new_C.puma" */
   WRITELN ();
/* line 3255 "new_C.puma" */
   CodeComputeConnectionUni (t->ActualExpr.Next, SourceIdent, SourceIndex, DestinationConfig, Rank - 1);
  }
END_RULE;
   return;

  }
  if (t->Kind == kActualRange) {
/* line 3258 "new_C.puma" */
 {
  tIdent ForIdent;
  {
/* line 3259 "new_C.puma" */
BEGIN_RULE(32);
/* line 3261 "new_C.puma" */

/* line 3262 "new_C.puma" */

                ForIdent = GenIdents_HelpVar();
                WRITEBLANKS();
                WRITESTRING("{ INTEGER ");
                WRITEIDENT(ForIdent);
                WRITESTRING("; for (");
                WRITEIDENT(ForIdent);
                WRITESTRING(" = ");
                CodeExpr(t->ActualRange.Lwb, ASSIGN_PREC);
                WRITESTRING("; ");
                WRITEIDENT(ForIdent);
                WRITESTRING(" <= ");
                CodeExpr(t->ActualRange.Upb, LESSEQUAL_PREC);
                WRITESTRING("; ");
                WRITEIDENT(ForIdent);
                WRITESTRING("++) {");
	        WRITELN();
                TAB(1);
                  WRITEBLANKS();
                  WRITESTRING("DESTINATION_ARRAY[");
                  WRITEINT(Rank - 1);
                  WRITESTRING("] = ");
                  WRITEIDENT(ForIdent);
                  WRITESTRING(";");
	          WRITELN();
                  CodeComputeConnectionUni(t->ActualRange.Next, SourceIdent, SourceIndex,
                    DestinationConfig, Rank - 1);
                DETAB(1);
                WRITEBLANKS();
                WRITESTRING("} }");
	        WRITELN();

  }
END_RULE;
   return;
 }

  }
  if (t->Kind == kActualStar) {
/* line 3295 "new_C.puma" */
 {
  tIdent ForIdent;
  {
/* line 3296 "new_C.puma" */
BEGIN_RULE(33);
/* line 3298 "new_C.puma" */

/* line 3299 "new_C.puma" */

                ForIdent = GenIdents_HelpVar();
                WRITEBLANKS();
                WRITESTRING("{ INTEGER ");
                WRITEIDENT(ForIdent);
                WRITESTRING("; for (");
                WRITEIDENT(ForIdent);
                WRITESTRING(" = LOWER(");
                WRITEIDENT(DestinationConfig->Qualid.Object->SymConfig.CIdent);
                WRITESTRING(", ");
                WRITEINT(Rank);
                WRITESTRING("); ");
                WRITEIDENT(ForIdent);
                WRITESTRING(" <= UPPER(");
                WRITEIDENT(DestinationConfig->Qualid.Object->SymConfig.CIdent);
                WRITESTRING(", ");
                WRITEINT(Rank);
                WRITESTRING("); ");
                WRITEIDENT(ForIdent);
                WRITESTRING("++) {");
	        WRITELN();
                TAB(1);
                  WRITEBLANKS();
                  WRITESTRING("DESTINATION_ARRAY[");
                  WRITEINT(Rank - 1);
                  WRITESTRING("] = ");
                  WRITEIDENT(ForIdent);
                  WRITESTRING(";");
	          WRITELN();
                  CodeComputeConnectionUni(t->ActualStar.Next, SourceIdent, SourceIndex,
                    DestinationConfig, Rank - 1);
                DETAB(1);
                WRITEBLANKS();
                WRITESTRING("} }");
	        WRITELN();

  }
END_RULE;
   return;
 }

  }
/* line 3336 "new_C.puma" */
  {
/* line 3337 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeComputeConnectionBi
# if defined __STDC__ | defined __cplusplus
(register tTree t, register tIdent SourceIdent, register tTree SourceIndex, register tIdent DestinationIdent, register tTree DestinationIndex, register tTree DestinationConfig, ULONG Rank)
# else
(t, SourceIdent, SourceIndex, DestinationIdent, DestinationIndex, DestinationConfig, Rank)
 register tTree t;
 register tIdent SourceIdent;
 register tTree SourceIndex;
 register tIdent DestinationIdent;
 register tTree DestinationIndex;
 register tTree DestinationConfig;
 ULONG Rank;
# endif
{
/* line 3342 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kNoActual) {
/* line 3348 "new_C.puma" */
  {
/* line 3349 "new_C.puma" */
BEGIN_RULE(34);
/* line 3351 "new_C.puma" */

                WRITEBLANKS();
                if (SourceIndex == NoExpr) {
                  WRITESTRING("REGISTER_LINK");
                } else {
                  WRITESTRING("REGISTER_PARAMETER_LINK");
                }
                WRITESTRING("(&");
                WRITEIDENT(SourceIdent);
                if (SourceIndex != NoExpr) {
                  WRITESTRING(", ");
                  CodeExpr(SourceIndex, PASSVALUE_PREC);
                }
                WRITESTRING(", SOURCE_ARRAY, DESTINATION_ARRAY);");
		WRITELN();
                WRITEBLANKS();
                if (DestinationIndex == NoExpr) {
                  WRITESTRING("REGISTER_LINK");
                } else {
                  WRITESTRING("REGISTER_PARAMETER_LINK");
                }
                WRITESTRING("(&");
                WRITEIDENT(DestinationIdent);
                if (DestinationIndex != NoExpr) {
                  WRITESTRING(", ");
                  CodeExpr(DestinationIndex, PASSVALUE_PREC);
                }
                WRITESTRING(", DESTINATION_ARRAY, SOURCE_ARRAY);");
		WRITELN();

  }
END_RULE;
   return;

  }
  if (t->Kind == kActualExpr) {
/* line 3382 "new_C.puma" */
  {
/* line 3383 "new_C.puma" */
BEGIN_RULE(35);
/* line 3385 "new_C.puma" */
   WRITEBLANKS ();
/* line 3386 "new_C.puma" */
   WRITESTRING ("DESTINATION_ARRAY[");
/* line 3387 "new_C.puma" */
   WRITEINT (Rank - 1);
/* line 3388 "new_C.puma" */
   WRITESTRING ("] = ");
/* line 3389 "new_C.puma" */
   CodeExpr (t->ActualExpr.Expr, ASSIGN_PREC);
/* line 3390 "new_C.puma" */
   WRITESTRING (";");
/* line 3391 "new_C.puma" */
   WRITELN ();
/* line 3392 "new_C.puma" */
   CodeComputeConnectionBi (t->ActualExpr.Next, SourceIdent, SourceIndex, DestinationIdent, DestinationIndex, DestinationConfig, Rank - 1);
  }
END_RULE;
   return;

  }
  if (t->Kind == kActualRange) {
/* line 3394 "new_C.puma" */
 {
  tIdent ForIdent;
  {
/* line 3395 "new_C.puma" */
BEGIN_RULE(36);
/* line 3397 "new_C.puma" */

/* line 3398 "new_C.puma" */

                ForIdent = GenIdents_HelpVar();
                WRITEBLANKS();
                WRITESTRING("{ INTEGER ");
                WRITEIDENT(ForIdent);
                WRITESTRING("; for (");
                WRITEIDENT(ForIdent);
                WRITESTRING(" = ");
                CodeExpr(t->ActualRange.Lwb, ASSIGN_PREC);
                WRITESTRING("; ");
                WRITEIDENT(ForIdent);
                WRITESTRING(" <= ");
                CodeExpr(t->ActualRange.Upb, LESSEQUAL_PREC);
                WRITESTRING("; ");
                WRITEIDENT(ForIdent);
                WRITESTRING("++) {");
	        WRITELN();
                TAB(1);
                  WRITEBLANKS();
                  WRITESTRING("DESTINATION_ARRAY[");
                  WRITEINT(Rank - 1);
                  WRITESTRING("] = ");
                  WRITEIDENT(ForIdent);
                  WRITESTRING(";");
	          WRITELN();
                  CodeComputeConnectionBi(t->ActualRange.Next, SourceIdent, SourceIndex,
                    DestinationIdent, DestinationIndex, DestinationConfig,
                    Rank - 1);
                DETAB(1);
                WRITEBLANKS();
                WRITESTRING("} }");
	        WRITELN();

  }
END_RULE;
   return;
 }

  }
  if (t->Kind == kActualStar) {
/* line 3432 "new_C.puma" */
 {
  tIdent ForIdent;
  {
/* line 3433 "new_C.puma" */
BEGIN_RULE(37);
/* line 3435 "new_C.puma" */

/* line 3436 "new_C.puma" */

                ForIdent = GenIdents_HelpVar();
                WRITEBLANKS();
                WRITESTRING("{ INTEGER ");
                WRITEIDENT(ForIdent);
                WRITESTRING("; for (");
                WRITEIDENT(ForIdent);
                WRITESTRING(" = LOWER(");
                WRITEIDENT(DestinationConfig->Qualid.Object->SymConfig.CIdent);
                WRITESTRING(", ");
                WRITEINT(Rank);
                WRITESTRING("); ");
                WRITEIDENT(ForIdent);
                WRITESTRING(" <= UPPER(");
                WRITEIDENT(DestinationConfig->Qualid.Object->SymConfig.CIdent);
                WRITESTRING(", ");
                WRITEINT(Rank);
                WRITESTRING("); ");
                WRITEIDENT(ForIdent);
                WRITESTRING("++) {");
	        WRITELN();
                TAB(1);
                  WRITEBLANKS();
                  WRITESTRING("DESTINATION_ARRAY[");
                  WRITEINT(Rank - 1);
                  WRITESTRING("] = ");
                  WRITEIDENT(ForIdent);
                  WRITESTRING(";");
	          WRITELN();
                  CodeComputeConnectionBi(t->ActualStar.Next, SourceIdent, SourceIndex,
                    DestinationIdent, DestinationIndex, DestinationConfig,
                    Rank - 1);
                DETAB(1);
                WRITEBLANKS();
                WRITESTRING("} }");
	        WRITELN();

  }
END_RULE;
   return;
 }

  }
/* line 3474 "new_C.puma" */
  {
/* line 3475 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeInitGenericConnections
# if defined __STDC__ | defined __cplusplus
(register tTree t, tObject Generic, register tIdent ConfigIdent)
# else
(t, Generic, ConfigIdent)
 register tTree t;
 tObject Generic;
 register tIdent ConfigIdent;
# endif
{
/* line 3481 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kDefMod) {
/* line 3487 "new_C.puma" */
  {
/* line 3488 "new_C.puma" */
BEGIN_RULE(38);
/* line 3490 "new_C.puma" */
   CodeInitGenericConnections (t->DefMod.Decls, Generic, ConfigIdent);
/* line 3491 "new_C.puma" */
   CodeInitGenericConnections (t->DefMod.Next, Generic, ConfigIdent);
  }
END_RULE;
   return;

  }
  if (t->Kind == kImplMod) {
/* line 3493 "new_C.puma" */
  {
/* line 3494 "new_C.puma" */
BEGIN_RULE(39);
/* line 3496 "new_C.puma" */
   CodeInitGenericConnections (t->ImplMod.Decls, Generic, ConfigIdent);
/* line 3497 "new_C.puma" */
   CodeInitGenericConnections (t->ImplMod.Next, Generic, ConfigIdent);
  }
END_RULE;
   return;

  }
  if (t->Kind == kConnectFrom) {
/* line 3499 "new_C.puma" */
  {
/* line 3500 "new_C.puma" */
BEGIN_RULE(40);
/* line 3502 "new_C.puma" */
   if (! (t->ConnectFrom.ConnectDecls -> ConnectDecls . Config -> Qualid . Object == Generic)) goto yyL3;
  {
/* line 3503 "new_C.puma" */
   WRITEBLANKS ();
/* line 3504 "new_C.puma" */
   WRITESTRING ("{ INTEGER ");
/* line 3505 "new_C.puma" */
   WRITEIDENT (t -> ConnectFrom . CIdent);
/* line 3506 "new_C.puma" */
   WRITESTRING ("; for (");
/* line 3507 "new_C.puma" */
   WRITEIDENT (t -> ConnectFrom . CIdent);
/* line 3508 "new_C.puma" */
   WRITESTRING (" = ");
/* line 3509 "new_C.puma" */
   CodeExpr (t->ConnectFrom.From, ASSIGN_PREC);
/* line 3510 "new_C.puma" */
   WRITESTRING ("; ");
/* line 3511 "new_C.puma" */
   WRITEIDENT (t -> ConnectFrom . CIdent);
/* line 3512 "new_C.puma" */
   WRITESTRING (" <= ");
/* line 3513 "new_C.puma" */
   CodeExpr (t->ConnectFrom.To, LESSEQUAL_PREC);
/* line 3514 "new_C.puma" */
   WRITESTRING ("; ");
/* line 3515 "new_C.puma" */
   WRITEIDENT (t -> ConnectFrom . CIdent);
/* line 3516 "new_C.puma" */
   WRITESTRING ("++) {");
/* line 3517 "new_C.puma" */
   WRITELN ();
/* line 3518 "new_C.puma" */
   TAB (1);
/* line 3519 "new_C.puma" */
   CodeInitGenericConnections (t->ConnectFrom.ConnectDecls, Generic, ConfigIdent);
/* line 3520 "new_C.puma" */
   DETAB (1);
/* line 3521 "new_C.puma" */
   WRITEBLANKS ();
/* line 3522 "new_C.puma" */
   WRITESTRING ("} }\n");
/* line 3523 "new_C.puma" */
   WRITELN ();
/* line 3524 "new_C.puma" */
   CodeInitGenericConnections (t->ConnectFrom.Next, Generic, ConfigIdent);
  }
  }
END_RULE;
   return;
yyL3:;

  }
  if (t->Kind == kConnectDecls) {
/* line 3526 "new_C.puma" */
  {
/* line 3527 "new_C.puma" */
BEGIN_RULE(41);
/* line 3529 "new_C.puma" */
   if (! (t->ConnectDecls.Config -> Qualid . Object == Generic)) goto yyL4;
  {
/* line 3530 "new_C.puma" */

                if (t->ConnectDecls.FirstDeclaration) {
                  if (t->ConnectDecls.Index == NoExpr) {
                    WRITEBLANKS();
                    WRITESTRING("INIT_GENERIC_CONNECTION(\"");
                  } else {
                    WRITEBLANKS();
                    WRITESTRING("INIT_GENERIC_PARAMETER_CONNECTION(\"");
                  }
                  WRITEIDENT(t->ConnectDecls.CIdent);
                  WRITESTRING("\", &");
                  WRITEIDENT(ConfigIdent);
                  WRITESTRING(");");
		  WRITELN();
                }
                CodeInitGenericConnections(t->ConnectDecls.DirIn, Generic, ConfigIdent);
                WRITEBLANKS();
                WRITESTRING("SOURCE_ARRAY = (INTEGER *) malloc(sizeof(INTEGER) * RANK(");
                WRITEIDENT(ConfigIdent);
                WRITESTRING("));");
		WRITELN();
                CodeInitDimensions(t->ConnectDecls.Actuals, ConfigIdent, BEFORE,
                  t->ConnectDecls.Config->Qualid.Object->SymConfig.Rank);
                CodeComputeGenericConnections(t->ConnectDecls.DirIn, t->ConnectDecls.CIdent,
                  t->ConnectDecls.Index, ConfigIdent, t->ConnectDecls.Config->Qualid.Object->SymConfig.Rank);
                CodeInitDimensions(t->ConnectDecls.Actuals, NoIdent, AFTER, 0);
                WRITEBLANKS();
                WRITESTRING("free(SOURCE_ARRAY);\n");
		WRITELN();
                CodeInitGenericConnections(t->ConnectDecls.Next, Generic, ConfigIdent);

  }
  }
END_RULE;
   return;
yyL4:;

  }
  if (Tree_IsType (t, kDecl)) {
/* line 3562 "new_C.puma" */
  {
/* line 3563 "new_C.puma" */
BEGIN_RULE(42);
/* line 3565 "new_C.puma" */
   CodeInitGenericConnections (t->Decl.Next, Generic, ConfigIdent);
  }
END_RULE;
   return;

  }
  if (t->Kind == kConnectDestBi) {
/* line 3567 "new_C.puma" */
  {
/* line 3568 "new_C.puma" */
BEGIN_RULE(43);
/* line 3570 "new_C.puma" */

                if (t->ConnectDestBi.FirstDeclaration) {
                  if (t->ConnectDestBi.Index == NoExpr) {
                    WRITEBLANKS();
                    WRITESTRING("INIT_GENERIC_CONNECTION(\"");
                  } else {
                    WRITEBLANKS();
                    WRITESTRING("INIT_GENERIC_PARAMETER_CONNECTION(\"");
                  }
                  WRITEIDENT(t->ConnectDestBi.CIdent);
                  WRITESTRING("\", &");
                  WRITEIDENT(ConfigIdent);
                  WRITESTRING(");");
		  WRITELN();
                }

/* line 3586 "new_C.puma" */
   CodeInitGenericConnections (t->ConnectDestBi.Next, Generic, ConfigIdent);
  }
END_RULE;
   return;

  }
/* line 3588 "new_C.puma" */
  {
/* line 3589 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeComputeGenericConnections
# if defined __STDC__ | defined __cplusplus
(register tTree t, register tIdent SourceIdent, register tTree SourceIndex, register tIdent ConfigIdent, ULONG Rank)
# else
(t, SourceIdent, SourceIndex, ConfigIdent, Rank)
 register tTree t;
 register tIdent SourceIdent;
 register tTree SourceIndex;
 register tIdent ConfigIdent;
 ULONG Rank;
# endif
{
/* line 3591 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kConnectDestUni) {
/* line 3597 "new_C.puma" */
  {
/* line 3598 "new_C.puma" */
BEGIN_RULE(44);
/* line 3600 "new_C.puma" */

                WRITEBLANKS();
                WRITESTRING("DESTINATION_ARRAY = (INTEGER *) malloc(sizeof(INTEGER) * RANK(");
                WRITEIDENT(ConfigIdent);
                WRITESTRING("));");
		WRITELN();
                if (t->ConnectDestUni.Expr != NoExpr) {
                  WRITEBLANKS();
                  WRITESTRING("if (");
                  CodeExpr(t->ConnectDestUni.Expr, MINPREC_PREC);
                  WRITESTRING(") {");
		  WRITELN();
                  TAB(1);
                }
                CodeComputeGenericConnectionUni(t->ConnectDestUni.Actuals, SourceIdent,
                  SourceIndex, ConfigIdent, Rank);
                if (t->ConnectDestUni.Expr != NoExpr) {
                  DETAB(1);
                  WRITEBLANKS();
                  WRITESTRING("}");
		  WRITELN();
                }
                WRITEBLANKS();
                WRITESTRING("free(DESTINATION_ARRAY);");
		WRITELN();
                CodeComputeGenericConnections(t->ConnectDestUni.Next, SourceIdent, SourceIndex,
                  ConfigIdent, Rank);

  }
END_RULE;
   return;

  }
  if (t->Kind == kConnectDestBi) {
/* line 3629 "new_C.puma" */
  {
/* line 3630 "new_C.puma" */
BEGIN_RULE(45);
/* line 3632 "new_C.puma" */

                WRITEBLANKS();
                WRITESTRING("DESTINATION_ARRAY = (INTEGER *) malloc(sizeof(INTEGER) * RANK(");
                WRITEIDENT(ConfigIdent);
                WRITESTRING("));");
		WRITELN();
                if (t->ConnectDestBi.Expr != NoExpr) {
                  WRITEBLANKS();
                  WRITESTRING("if (");
                  CodeExpr(t->ConnectDestBi.Expr, MINPREC_PREC);
                  WRITESTRING(") {");
		  WRITELN();
                  TAB(1);
                }
                CodeComputeGenericConnectionBi(t->ConnectDestBi.Actuals, SourceIdent,
                  SourceIndex, t->ConnectDestBi.CIdent, t->ConnectDestBi.Index,
                  ConfigIdent, Rank);
                if (t->ConnectDestBi.Expr != NoExpr) {
                  DETAB(1);
                  WRITEBLANKS();
                  WRITESTRING("}");
		  WRITELN();
                }                
                WRITEBLANKS();
                WRITESTRING("free(DESTINATION_ARRAY);");
		WRITELN();
                CodeComputeGenericConnections(t->ConnectDestBi.Next, SourceIdent, SourceIndex,
                  ConfigIdent, Rank);

  }
END_RULE;
   return;

  }
/* line 3662 "new_C.puma" */
  {
/* line 3663 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeComputeGenericConnectionUni
# if defined __STDC__ | defined __cplusplus
(register tTree t, register tIdent SourceIdent, register tTree SourceIndex, register tIdent ConfigIdent, ULONG Rank)
# else
(t, SourceIdent, SourceIndex, ConfigIdent, Rank)
 register tTree t;
 register tIdent SourceIdent;
 register tTree SourceIndex;
 register tIdent ConfigIdent;
 ULONG Rank;
# endif
{
/* line 3665 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kNoActual) {
/* line 3671 "new_C.puma" */
  {
/* line 3672 "new_C.puma" */
BEGIN_RULE(46);
/* line 3674 "new_C.puma" */

                WRITEBLANKS();
                if (SourceIndex == NoExpr) {
                  WRITESTRING("REGISTER_GENERIC_LINK");
                } else {
                  WRITESTRING("REGISTER_GENERIC_PARAMETER_LINK");
                }
                WRITESTRING("(\"");
                WRITEIDENT(SourceIdent);
                WRITESTRING("\", &");
                WRITEIDENT(ConfigIdent);
                if (SourceIndex != NoExpr) {
                  WRITESTRING(", ");
                  CodeExpr(SourceIndex, PASSVALUE_PREC);
                }
                WRITESTRING(", SOURCE_ARRAY, DESTINATION_ARRAY);");
		WRITELN();

  }
END_RULE;
   return;

  }
  if (t->Kind == kActualExpr) {
/* line 3693 "new_C.puma" */
  {
/* line 3694 "new_C.puma" */
BEGIN_RULE(47);
/* line 3696 "new_C.puma" */
   WRITEBLANKS ();
/* line 3697 "new_C.puma" */
   WRITESTRING ("DESTINATION_ARRAY[");
/* line 3698 "new_C.puma" */
   WRITEINT (Rank - 1);
/* line 3699 "new_C.puma" */
   WRITESTRING ("] = ");
/* line 3700 "new_C.puma" */
   CodeExpr (t->ActualExpr.Expr, ASSIGN_PREC);
/* line 3701 "new_C.puma" */
   WRITESTRING (";");
/* line 3702 "new_C.puma" */
   WRITELN ();
/* line 3703 "new_C.puma" */
   CodeComputeGenericConnectionUni (t->ActualExpr.Next, SourceIdent, SourceIndex, ConfigIdent, Rank - 1);
  }
END_RULE;
   return;

  }
  if (t->Kind == kActualRange) {
/* line 3706 "new_C.puma" */
 {
  tIdent ForIdent;
  {
/* line 3707 "new_C.puma" */
BEGIN_RULE(48);
/* line 3709 "new_C.puma" */

/* line 3710 "new_C.puma" */

                ForIdent = GenIdents_HelpVar();
                WRITEBLANKS();
                WRITESTRING("{ INTEGER ");
                WRITEIDENT(ForIdent);
                WRITESTRING("; for (");
                WRITEIDENT(ForIdent);
                WRITESTRING(" = ");
                CodeExpr(t->ActualRange.Lwb, ASSIGN_PREC);
                WRITESTRING("; ");
                WRITEIDENT(ForIdent);
                WRITESTRING(" <= ");
                CodeExpr(t->ActualRange.Upb, LESSEQUAL_PREC);
                WRITESTRING("; ");
                WRITEIDENT(ForIdent);
                WRITESTRING("++) {");
	        WRITELN();
                TAB(1);
                  WRITEBLANKS();
                  WRITESTRING("DESTINATION_ARRAY[");
                  WRITEINT(Rank - 1);
                  WRITESTRING("] = ");
                  WRITEIDENT(ForIdent);
                  WRITESTRING(";");
	          WRITELN();
                  CodeComputeGenericConnectionUni(t->ActualRange.Next, SourceIdent,
                    SourceIndex, ConfigIdent, Rank - 1);
                DETAB(1);
                WRITEBLANKS();
                WRITESTRING("} }");
	        WRITELN();

  }
END_RULE;
   return;
 }

  }
  if (t->Kind == kActualStar) {
/* line 3743 "new_C.puma" */
 {
  tIdent ForIdent;
  {
/* line 3744 "new_C.puma" */
BEGIN_RULE(49);
/* line 3746 "new_C.puma" */

/* line 3747 "new_C.puma" */

                ForIdent = GenIdents_HelpVar();
                WRITEBLANKS();
                WRITESTRING("{ INTEGER ");
                WRITEIDENT(ForIdent);
                WRITESTRING("; for (");
                WRITEIDENT(ForIdent);
                WRITESTRING(" = LOWER(");
                WRITEIDENT(ConfigIdent);
                WRITESTRING(", ");
                WRITEINT(Rank);
                WRITESTRING("); ");
                WRITEIDENT(ForIdent);
                WRITESTRING(" <= UPPER(");
                WRITEIDENT(ConfigIdent);
                WRITESTRING(", ");
                WRITEINT(Rank);
                WRITESTRING("); ");
                WRITEIDENT(ForIdent);
                WRITESTRING("++) {");
	        WRITELN();
                TAB(1);
                  WRITEBLANKS();
                  WRITESTRING("DESTINATION_ARRAY[");
                  WRITEINT(Rank - 1);
                  WRITESTRING("] = ");
                  WRITEIDENT(ForIdent);
                  WRITESTRING(";");
	          WRITELN();
                  CodeComputeGenericConnectionUni(t->ActualStar.Next, SourceIdent,
                    SourceIndex, ConfigIdent, Rank - 1);
                DETAB(1);
                WRITEBLANKS();
                WRITESTRING("} }");
	        WRITELN();

  }
END_RULE;
   return;
 }

  }
/* line 3784 "new_C.puma" */
  {
/* line 3785 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeComputeGenericConnectionBi
# if defined __STDC__ | defined __cplusplus
(register tTree t, register tIdent SourceIdent, register tTree SourceIndex, register tIdent DestinationIdent, register tTree DestinationIndex, register tIdent ConfigIdent, ULONG Rank)
# else
(t, SourceIdent, SourceIndex, DestinationIdent, DestinationIndex, ConfigIdent, Rank)
 register tTree t;
 register tIdent SourceIdent;
 register tTree SourceIndex;
 register tIdent DestinationIdent;
 register tTree DestinationIndex;
 register tIdent ConfigIdent;
 ULONG Rank;
# endif
{
/* line 3787 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kNoActual) {
/* line 3793 "new_C.puma" */
  {
/* line 3794 "new_C.puma" */
BEGIN_RULE(50);
/* line 3796 "new_C.puma" */

                WRITEBLANKS();
                if (SourceIndex == NoExpr) {
                  WRITESTRING("REGISTER_GENERIC_LINK");
                } else {
                  WRITESTRING("REGISTER_GENERIC_PARAMETER_LINK");
                }
                WRITESTRING("(\"");
                WRITEIDENT(SourceIdent);
                WRITESTRING("\", &");
                WRITEIDENT(ConfigIdent);
                if (SourceIndex != NoExpr) {
                  WRITESTRING(", ");
                  CodeExpr(SourceIndex, PASSVALUE_PREC);
                }
                WRITESTRING(", SOURCE_ARRAY, DESTINATION_ARRAY);");
		WRITELN();
                WRITEBLANKS();
                if (DestinationIndex == NoExpr) {
                  WRITESTRING("REGISTER_GENERIC_LINK");
                } else {
                  WRITESTRING("REGISTER_GENERIC_PARAMETER_LINK");
                }
                WRITESTRING("(\"");
                WRITEIDENT(DestinationIdent);
                WRITESTRING("\", &");
                WRITEIDENT(ConfigIdent);
                if (DestinationIndex != NoExpr) {
                  WRITESTRING(", ");
                  CodeExpr(DestinationIndex, PASSVALUE_PREC);
                }
                WRITESTRING(", DESTINATION_ARRAY, SOURCE_ARRAY);");
		WRITELN();

  }
END_RULE;
   return;

  }
  if (t->Kind == kActualExpr) {
/* line 3831 "new_C.puma" */
  {
/* line 3832 "new_C.puma" */
BEGIN_RULE(51);
/* line 3834 "new_C.puma" */
   WRITEBLANKS ();
/* line 3835 "new_C.puma" */
   WRITESTRING ("DESTINATION_ARRAY[");
/* line 3836 "new_C.puma" */
   WRITEINT (Rank - 1);
/* line 3837 "new_C.puma" */
   WRITESTRING ("] = ");
/* line 3838 "new_C.puma" */
   CodeExpr (t->ActualExpr.Expr, ASSIGN_PREC);
/* line 3839 "new_C.puma" */
   WRITESTRING (";");
/* line 3840 "new_C.puma" */
   WRITELN ();
/* line 3841 "new_C.puma" */
   CodeComputeGenericConnectionBi (t->ActualExpr.Next, SourceIdent, SourceIndex, DestinationIdent, DestinationIndex, ConfigIdent, Rank - 1);
  }
END_RULE;
   return;

  }
  if (t->Kind == kActualRange) {
/* line 3844 "new_C.puma" */
 {
  tIdent ForIdent;
  {
/* line 3845 "new_C.puma" */
BEGIN_RULE(52);
/* line 3847 "new_C.puma" */

/* line 3848 "new_C.puma" */

                ForIdent = GenIdents_HelpVar();
                WRITEBLANKS();
                WRITESTRING("{ INTEGER ");
                WRITEIDENT(ForIdent);
                WRITESTRING("; for (");
                WRITEIDENT(ForIdent);
                WRITESTRING(" = ");
                CodeExpr(t->ActualRange.Lwb, ASSIGN_PREC);
                WRITESTRING("; ");
                WRITEIDENT(ForIdent);
                WRITESTRING(" <= ");
                CodeExpr(t->ActualRange.Upb, LESSEQUAL_PREC);
                WRITESTRING("; ");
                WRITEIDENT(ForIdent);
                WRITESTRING("++) {");
	        WRITELN();
                TAB(1);
                  WRITEBLANKS();
                  WRITESTRING("DESTINATION_ARRAY[");
                  WRITEINT(Rank - 1);
                  WRITESTRING("] = ");
                  WRITEIDENT(ForIdent);
                  WRITESTRING(";");
	          WRITELN();
                  CodeComputeGenericConnectionBi(t->ActualRange.Next, SourceIdent,
                    SourceIndex, DestinationIdent, DestinationIndex,
                    ConfigIdent, Rank - 1);
                DETAB(1);
                WRITEBLANKS();
                WRITESTRING("} }");
	        WRITELN();

  }
END_RULE;
   return;
 }

  }
  if (t->Kind == kActualStar) {
/* line 3882 "new_C.puma" */
 {
  tIdent ForIdent;
  {
/* line 3883 "new_C.puma" */
BEGIN_RULE(53);
/* line 3885 "new_C.puma" */

/* line 3886 "new_C.puma" */

                ForIdent = GenIdents_HelpVar();
                WRITEBLANKS();
                WRITESTRING("{ INTEGER ");
                WRITEIDENT(ForIdent);
                WRITESTRING("; for (");
                WRITEIDENT(ForIdent);
                WRITESTRING(" = LOWER(");
                WRITEIDENT(ConfigIdent);
                WRITESTRING(", ");
                WRITEINT(Rank);
                WRITESTRING("); ");
                WRITEIDENT(ForIdent);
                WRITESTRING(" <= UPPER(");
                WRITEIDENT(ConfigIdent);
                WRITESTRING(", ");
                WRITEINT(Rank);
                WRITESTRING("); ");
                WRITEIDENT(ForIdent);
                WRITESTRING("++) {");
	        WRITELN();
                TAB(1);
                  WRITEBLANKS();
                  WRITESTRING("DESTINATION_ARRAY[");
                  WRITEINT(Rank - 1);
                  WRITESTRING("] = ");
                  WRITEIDENT(ForIdent);
                  WRITESTRING(";");
	          WRITELN();
                  CodeComputeGenericConnectionBi(t->ActualStar.Next, SourceIdent,
                    SourceIndex, DestinationIdent, DestinationIndex,
                    ConfigIdent, Rank - 1);
                DETAB(1);
                WRITEBLANKS();
                WRITESTRING("} }");
	        WRITELN();

  }
END_RULE;
   return;
 }

  }
/* line 3924 "new_C.puma" */
  {
/* line 3925 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeFreeGenericConnections
# if defined __STDC__ | defined __cplusplus
(register tTree t, tObject Generic, register tIdent ConfigIdent)
# else
(t, Generic, ConfigIdent)
 register tTree t;
 tObject Generic;
 register tIdent ConfigIdent;
# endif
{
/* line 3927 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kDefMod) {
/* line 3933 "new_C.puma" */
  {
/* line 3934 "new_C.puma" */
BEGIN_RULE(54);
/* line 3936 "new_C.puma" */
   CodeFreeGenericConnections (t->DefMod.Decls, Generic, ConfigIdent);
/* line 3937 "new_C.puma" */
   CodeFreeGenericConnections (t->DefMod.Next, Generic, ConfigIdent);
  }
END_RULE;
   return;

  }
  if (t->Kind == kImplMod) {
/* line 3939 "new_C.puma" */
  {
/* line 3940 "new_C.puma" */
BEGIN_RULE(55);
/* line 3942 "new_C.puma" */
   CodeFreeGenericConnections (t->ImplMod.Decls, Generic, ConfigIdent);
/* line 3943 "new_C.puma" */
   CodeFreeGenericConnections (t->ImplMod.Next, Generic, ConfigIdent);
  }
END_RULE;
   return;

  }
  if (t->Kind == kConnectFrom) {
/* line 3945 "new_C.puma" */
  {
/* line 3946 "new_C.puma" */
BEGIN_RULE(56);
/* line 3948 "new_C.puma" */
   if (! (t->ConnectFrom.ConnectDecls -> ConnectDecls . Config -> Qualid . Object == Generic)) goto yyL3;
  {
/* line 3949 "new_C.puma" */
   WRITEBLANKS ();
/* line 3950 "new_C.puma" */
   WRITESTRING ("{ INTEGER ");
/* line 3951 "new_C.puma" */
   WRITEIDENT (t -> ConnectFrom . CIdent);
/* line 3952 "new_C.puma" */
   WRITESTRING ("; for (");
/* line 3953 "new_C.puma" */
   WRITEIDENT (t -> ConnectFrom . CIdent);
/* line 3954 "new_C.puma" */
   WRITESTRING (" = ");
/* line 3955 "new_C.puma" */
   CodeExpr (t->ConnectFrom.From, ASSIGN_PREC);
/* line 3956 "new_C.puma" */
   WRITESTRING ("; ");
/* line 3957 "new_C.puma" */
   WRITEIDENT (t -> ConnectFrom . CIdent);
/* line 3958 "new_C.puma" */
   WRITESTRING (" <= ");
/* line 3959 "new_C.puma" */
   CodeExpr (t->ConnectFrom.To, LESSEQUAL_PREC);
/* line 3960 "new_C.puma" */
   WRITESTRING ("; ");
/* line 3961 "new_C.puma" */
   WRITEIDENT (t -> ConnectFrom . CIdent);
/* line 3962 "new_C.puma" */
   WRITESTRING ("++) {");
/* line 3963 "new_C.puma" */
   WRITELN ();
/* line 3964 "new_C.puma" */
   TAB (1);
/* line 3965 "new_C.puma" */
   CodeFreeGenericConnections (t->ConnectFrom.ConnectDecls, Generic, ConfigIdent);
/* line 3966 "new_C.puma" */
   DETAB (1);
/* line 3967 "new_C.puma" */
   WRITEBLANKS ();
/* line 3968 "new_C.puma" */
   WRITESTRING ("} }\n");
/* line 3969 "new_C.puma" */
   WRITELN ();
/* line 3970 "new_C.puma" */
   CodeFreeGenericConnections (t->ConnectFrom.Next, Generic, ConfigIdent);
  }
  }
END_RULE;
   return;
yyL3:;

  }
  if (t->Kind == kConnectDecls) {
/* line 3972 "new_C.puma" */
  {
/* line 3973 "new_C.puma" */
BEGIN_RULE(57);
/* line 3975 "new_C.puma" */
   if (! (t->ConnectDecls.Config -> Qualid . Object == Generic)) goto yyL4;
  {
/* line 3976 "new_C.puma" */

                if (t->ConnectDecls.FirstDeclaration) {
                  if (t->ConnectDecls.Index == NoExpr) {
                    WRITEBLANKS();
                    WRITESTRING("FREE_GENERIC_CONNECTION(\"");
                  } else {
                    WRITEBLANKS();
                    WRITESTRING("FREE_GENERIC_PARAMETER_CONNECTION(\"");
                  }
                  WRITEIDENT(t->ConnectDecls.CIdent);
                  WRITESTRING("\", &");
                  WRITEIDENT(ConfigIdent);
                  WRITESTRING(");");
		  WRITELN();
                }
                CodeFreeGenericConnections(t->ConnectDecls.DirIn, Generic, ConfigIdent);
                CodeFreeGenericConnections(t->ConnectDecls.Next, Generic, ConfigIdent);

  }
  }
END_RULE;
   return;
yyL4:;

  }
  if (Tree_IsType (t, kDecl)) {
/* line 3995 "new_C.puma" */
  {
/* line 3996 "new_C.puma" */
BEGIN_RULE(58);
/* line 3998 "new_C.puma" */
   CodeFreeGenericConnections (t->Decl.Next, Generic, ConfigIdent);
  }
END_RULE;
   return;

  }
  if (t->Kind == kConnectDestBi) {
/* line 4000 "new_C.puma" */
  {
/* line 4001 "new_C.puma" */
BEGIN_RULE(59);
/* line 4003 "new_C.puma" */

                if (t->ConnectDestBi.FirstDeclaration) {
                  if (t->ConnectDestBi.Index == NoExpr) {
                    WRITEBLANKS();
                    WRITESTRING("FREE_GENERIC_CONNECTION(\"");
                  } else {
                    WRITEBLANKS();
                    WRITESTRING("FREE_GENERIC_PARAMETER_CONNECTION(\"");
                  }
                  WRITEIDENT(t->ConnectDestBi.CIdent);
                  WRITESTRING("\", &");
                  WRITEIDENT(ConfigIdent);
                  WRITESTRING(");");
		  WRITELN();
                }

/* line 4019 "new_C.puma" */
   CodeFreeGenericConnections (t->ConnectDestBi.Next, Generic, ConfigIdent);
  }
END_RULE;
   return;

  }
/* line 4021 "new_C.puma" */
  {
/* line 4022 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeInitVectorVariables
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 4027 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kVar) {
/* line 4033 "new_C.puma" */
  {
/* line 4034 "new_C.puma" */
BEGIN_RULE(60);
/* line 4036 "new_C.puma" */
   InitDesignatorString (0);
/* line 4037 "new_C.puma" */
   InitDesignatorString (1);
/* line 4038 "new_C.puma" */
   CodeInitVectors (t->Var.Type, t->Var.VarIds);
/* line 4039 "new_C.puma" */
   CodeInitVectorVariables (t->Var.Next);
  }
END_RULE;
   return;

  }
  if (Tree_IsType (t, kDecl)) {
/* line 4041 "new_C.puma" */
  {
/* line 4042 "new_C.puma" */
BEGIN_RULE(61);
/* line 4044 "new_C.puma" */
   CodeInitVectorVariables (t->Decl.Next);
  }
END_RULE;
   return;

  }
/* line 4046 "new_C.puma" */
  {
/* line 4047 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeInitVectors
# if defined __STDC__ | defined __cplusplus
(register tTree t, register tTree v)
# else
(t, v)
 register tTree t;
 register tTree v;
# endif
{
/* line 4052 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kVector) {
/* line 4059 "new_C.puma" */
 {
  CHARBUF StringVar;
  {
/* line 4060 "new_C.puma" */
BEGIN_RULE(62);
/* line 4062 "new_C.puma" */
   if (! (t->Vector.IsOpen && v -> Kind == kVarId)) goto yyL1;
  {
/* line 4063 "new_C.puma" */

/* line 4064 "new_C.puma" */

                GetString( v->VarId.CIdent, StringVar );
                AddPrefixDesignatorString(0, StringVar);
                AddPrefixDesignatorString(1, StringVar);
                WRITEBLANKS();
                WRITESTRING(GetDesignatorString(0));
                WRITESTRING(" = (void *) malloc(sizeof(*(");
                WRITESTRING(GetDesignatorString(1));
                WRITESTRING(")) * LEN(OPEN_VECTOR));");
	        WRITELN();
                SubPrefixDesignatorString(0, strlen(StringVar));
                SubPrefixDesignatorString(1, strlen(StringVar));
                CodeInitVectors( t, v->VarId.Next );

  }
  }
END_RULE;
   return;
 }
yyL1:;

/* line 4079 "new_C.puma" */
 {
  CHARBUF StringVar;
  {
/* line 4080 "new_C.puma" */
BEGIN_RULE(63);
/* line 4082 "new_C.puma" */
   if (! (t->Vector.Config -> Qualid . Object -> SymConfig . IsGeneric && v -> Kind == kVarId)) goto yyL2;
  {
/* line 4083 "new_C.puma" */

/* line 4084 "new_C.puma" */

                GetString( v->VarId.CIdent, StringVar );
                AddPrefixDesignatorString(0, StringVar);
                AddPrefixDesignatorString(1, StringVar);
                WRITEBLANKS();
                WRITESTRING(GetDesignatorString(0));
                WRITESTRING(" = (void *) malloc(sizeof(*(");
                WRITESTRING(GetDesignatorString(1));
                WRITESTRING(")) * LEN(GENERIC_CONFIGURATION));");
	        WRITELN();
                SubPrefixDesignatorString(0, strlen(StringVar));
                SubPrefixDesignatorString(1, strlen(StringVar));
                CodeInitVectors( t, v->VarId.Next );

  }
  }
END_RULE;
   return;
 }
yyL2:;

/* line 4099 "new_C.puma" */
 {
  CHARBUF StringVar;
  {
/* line 4100 "new_C.puma" */
BEGIN_RULE(64);
/* line 4102 "new_C.puma" */
   if (! ((t->Vector.Config -> Qualid . Object -> SymConfig . Len == 0) && v -> Kind == kVarId)) goto yyL3;
  {
/* line 4103 "new_C.puma" */

/* line 4104 "new_C.puma" */

                GetString( v->VarId.CIdent, StringVar );
                AddPrefixDesignatorString(0, StringVar);
                AddPrefixDesignatorString(1, StringVar);
                WRITEBLANKS();
                WRITESTRING(GetDesignatorString(0));
                WRITESTRING(" = (void *) malloc(sizeof(*(");
                WRITESTRING(GetDesignatorString(1));
                WRITESTRING(")) * LEN(");

		WRITEIDENT(t->Vector.Config->Qualid.Object->SymConfig.CIdent);
		WRITESTRING("));");
	        WRITELN();
                SubPrefixDesignatorString(0, strlen(StringVar));
                SubPrefixDesignatorString(1, strlen(StringVar));
                CodeInitVectors( t, v->VarId.Next );

  }
  }
END_RULE;
   return;
 }
yyL3:;

  }
  if (t->Kind == kArray) {
/* line 4122 "new_C.puma" */
 {
  tIdent IndexVar;
  CHARBUF StringIndex;
  {
/* line 4123 "new_C.puma" */
BEGIN_RULE(65);
/* line 4125 "new_C.puma" */

/* line 4126 "new_C.puma" */

/* line 4127 "new_C.puma" */
   if (! (t -> Array . ContainsVector)) goto yyL4;
  {
/* line 4128 "new_C.puma" */

                IndexVar = GenIdents_HelpVar();
                GetString( IndexVar, StringIndex );
                AddDesignatorString( 0, ".A[" );
                AddDesignatorString( 0, StringIndex );
                AddDesignatorString( 0, "]" );
                AddDesignatorString( 1, ".A[0]");
                WRITEBLANKS();
                WRITESTRING("{ CARDINAL ");
                WRITEIDENT( IndexVar );
                WRITESTRING("; for (");
                WRITEIDENT( IndexVar );
                WRITESTRING(" = 0; ");
                WRITEIDENT( IndexVar );
                WRITESTRING(" <= ");
                CodeArrayUpperbound( t->Array.Index );
                WRITESTRING("; ");
                WRITEIDENT( IndexVar );
                WRITESTRING("++ ) {");
	        WRITELN();
                TAB(1);
                  CodeInitVectors( t->Array.ElemType, v );
                  SubDesignatorString( 0, strlen( StringIndex) + 4 );
                  SubDesignatorString( 1, 5 );
                DETAB(1);
                WRITEBLANKS();
                WRITESTRING("} }");
	        WRITELN();

  }
  }
END_RULE;
   return;
 }
yyL4:;

  }
  if (t->Kind == kRecord) {
/* line 4158 "new_C.puma" */
  {
/* line 4159 "new_C.puma" */
BEGIN_RULE(66);
/* line 4161 "new_C.puma" */
   CodeInitVectors (t->Record.Fields, v);
  }
END_RULE;
   return;

  }
  if (t->Kind == kTypeId0) {
/* line 4163 "new_C.puma" */
 {
  CHARBUF StringVar;
  {
/* line 4164 "new_C.puma" */
BEGIN_RULE(67);
/* line 4166 "new_C.puma" */

/* line 4169 "new_C.puma" */
   if (! (t -> TypeId0 . Object -> SymTypeDecl . Type -> Kind == kSymVector && t -> TypeId0 . Object -> SymTypeDecl . Type -> SymVector . IsOpen && v -> Kind == kVarId)) goto yyL6;
  {
/* line 4170 "new_C.puma" */

                GetString( v->VarId.CIdent, StringVar );
                AddPrefixDesignatorString(0, StringVar);
                AddPrefixDesignatorString(1, StringVar);
                WRITEBLANKS();
                WRITESTRING(GetDesignatorString(0));
                WRITESTRING(" = (void *) malloc(sizeof(*(");
                WRITESTRING(GetDesignatorString(1));
                WRITESTRING(")) * LEN(OPEN_VECTOR));");
	        WRITELN();
                SubPrefixDesignatorString(0, strlen(StringVar));
                SubPrefixDesignatorString(1, strlen(StringVar));
                CodeInitVectors( t, v->VarId.Next );

  }
  }
END_RULE;
   return;
 }
yyL6:;

/* line 4185 "new_C.puma" */
 {
  CHARBUF StringVar;
  {
/* line 4186 "new_C.puma" */
BEGIN_RULE(68);
/* line 4188 "new_C.puma" */

/* line 4191 "new_C.puma" */
   if (! (t -> TypeId0 . Object -> SymTypeDecl . Type -> Kind == kSymVector && t -> TypeId0 . Object -> SymTypeDecl . Type -> SymVector . Config -> SymConfig . IsGeneric && v -> Kind == kVarId)) goto yyL7;
  {
/* line 4192 "new_C.puma" */

                GetString( v->VarId.CIdent, StringVar );
                AddPrefixDesignatorString(0, StringVar);
                AddPrefixDesignatorString(1, StringVar);
                WRITEBLANKS();
                WRITESTRING(GetDesignatorString(0));
                WRITESTRING(" = (void *) malloc(sizeof(*(");
                WRITESTRING(GetDesignatorString(1));
                WRITESTRING(")) * LEN(GENERIC_CONFIGURATION));");
	        WRITELN();
                SubPrefixDesignatorString(0, strlen(StringVar));
                SubPrefixDesignatorString(1, strlen(StringVar));
                CodeInitVectors( t, v->VarId.Next );

  }
  }
END_RULE;
   return;
 }
yyL7:;

  }
  if (t->Kind == kTypeId1) {
/* line 4207 "new_C.puma" */
  {
/* line 4208 "new_C.puma" */
BEGIN_RULE(69);
/* line 4210 "new_C.puma" */
   CodeInitVectors (t->TypeId1.TypeId, v);
  }
END_RULE;
   return;

  }
  if (t->Kind == kRecordSect) {
/* line 4212 "new_C.puma" */
  {
/* line 4213 "new_C.puma" */
BEGIN_RULE(70);
/* line 4215 "new_C.puma" */
   CodeInitRecordVectors (t->RecordSect.FieldIds, t->RecordSect.Type, v);
/* line 4216 "new_C.puma" */
   CodeInitVectors (t->RecordSect.Next, v);
  }
END_RULE;
   return;

  }
/* line 4218 "new_C.puma" */
  {
/* line 4219 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeInitRecordVectors
# if defined __STDC__ | defined __cplusplus
(register tTree f, register tTree t, register tTree v)
# else
(f, t, v)
 register tTree f;
 register tTree t;
 register tTree v;
# endif
{
/* line 4224 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (f->Kind == kFieldId) {
/* line 4231 "new_C.puma" */
 {
  CHARBUF StringField;
  {
/* line 4232 "new_C.puma" */
BEGIN_RULE(71);
/* line 4234 "new_C.puma" */

/* line 4235 "new_C.puma" */

                GetString( f->FieldId.CIdent, StringField );
                AddDesignatorString( 0, "." );
                AddDesignatorString( 0, StringField );
                AddDesignatorString( 1, "." );
                AddDesignatorString( 1, StringField );
                CodeInitVectors( t, v );
                SubDesignatorString( 0, strlen( StringField) + 1 );
                SubDesignatorString( 1, strlen( StringField) + 1 );
                CodeInitRecordVectors( f->FieldId.Next, t, v );

  }
END_RULE;
   return;
 }

  }
/* line 4247 "new_C.puma" */
  {
/* line 4248 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeFreeConfigs
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 4253 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kConfig) {
/* line 4259 "new_C.puma" */
 {
  tIdent ConfigIdent;
  {
/* line 4260 "new_C.puma" */
BEGIN_RULE(72);
/* line 4262 "new_C.puma" */

/* line 4263 "new_C.puma" */
   if (! (! t -> Config . Object -> SymConfig . IsGeneric)) goto yyL1;
  {
/* line 4264 "new_C.puma" */

	        if (t->Config.View == NoObject) {
		  
		  CodeFreeConfigs(t->Config.Next);
		}

                ConfigIdent = t->Config.Object->SymConfig.CIdent;
                WRITEBLANKS();
                WRITESTRING("FREE_CONFIGURATION(&");
                WRITEIDENT(t->Config.Object->SymConfig.CIdent);

		
                if (t->Config.View == NoObject) {
                  WRITESTRING(", TRUE);");
		} else {
                  WRITESTRING(", FALSE);");
		}
		WRITELN();
                if (t->Config.Respecified) {
                  CodeFreeGenericConnections(TreeRoot, t->Config.Qualid->Qualid.Object,
                    t->Config.CIdent);
                }
	        if (t->Config.View != NoObject) {
                  CodeFreeConfigs( t->Config.Next );
		}

  }
  }
END_RULE;
   return;
 }
yyL1:;

  }
  if (Tree_IsType (t, kDecl)) {
/* line 4293 "new_C.puma" */
  {
/* line 4294 "new_C.puma" */
BEGIN_RULE(73);
/* line 4296 "new_C.puma" */
   CodeFreeConfigs (t->Decl.Next);
  }
END_RULE;
   return;

  }
/* line 4298 "new_C.puma" */
  {
/* line 4299 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeFreeVectorVariables
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 4304 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kVar) {
/* line 4310 "new_C.puma" */
  {
/* line 4311 "new_C.puma" */
BEGIN_RULE(74);
/* line 4313 "new_C.puma" */
   InitDesignatorString (0);
/* line 4314 "new_C.puma" */
   CodeFreeVectors (t->Var.Type, t->Var.VarIds);
/* line 4315 "new_C.puma" */
   CodeFreeVectorVariables (t->Var.Next);
  }
END_RULE;
   return;

  }
  if (Tree_IsType (t, kDecl)) {
/* line 4317 "new_C.puma" */
  {
/* line 4318 "new_C.puma" */
BEGIN_RULE(75);
/* line 4320 "new_C.puma" */
   CodeFreeVectorVariables (t->Decl.Next);
  }
END_RULE;
   return;

  }
/* line 4322 "new_C.puma" */
  {
/* line 4323 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeFreeVectors
# if defined __STDC__ | defined __cplusplus
(register tTree t, register tTree v)
# else
(t, v)
 register tTree t;
 register tTree v;
# endif
{
/* line 4328 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kVector) {
/* line 4335 "new_C.puma" */
 {
  CHARBUF StringVar;
  {
/* line 4336 "new_C.puma" */
BEGIN_RULE(76);
/* line 4338 "new_C.puma" */

/* line 4341 "new_C.puma" */
   if (! ((t->Vector.IsOpen || t->Vector.Config -> Qualid . Object -> SymConfig . IsGeneric || t->Vector.Config -> Qualid . Object -> SymConfig . Len == 0) && v -> Kind == kVarId)) goto yyL1;
  {
/* line 4342 "new_C.puma" */

                GetString( v->VarId.CIdent, StringVar );
                AddPrefixDesignatorString(0, StringVar);
                WRITEBLANKS();
                WRITESTRING("free(");
                WRITESTRING(GetDesignatorString(0));
                WRITESTRING(");");
	        WRITELN();
                SubPrefixDesignatorString(0, strlen(StringVar));
                CodeFreeVectors( t, v->VarId.Next );

  }
  }
END_RULE;
   return;
 }
yyL1:;

  }
  if (t->Kind == kArray) {
/* line 4354 "new_C.puma" */
 {
  tIdent IndexVar;
  CHARBUF StringIndex;
  {
/* line 4355 "new_C.puma" */
BEGIN_RULE(77);
/* line 4357 "new_C.puma" */

/* line 4358 "new_C.puma" */

/* line 4359 "new_C.puma" */
   if (! (t -> Array . ContainsVector)) goto yyL2;
  {
/* line 4360 "new_C.puma" */

                IndexVar = GenIdents_HelpVar();
                GetString( IndexVar, StringIndex );
                AddDesignatorString( 0, ".A[" );
                AddDesignatorString( 0, StringIndex );
                AddDesignatorString( 0, "]" );
                WRITEBLANKS();
                WRITESTRING("{ CARDINAL ");
                WRITEIDENT( IndexVar );
                WRITESTRING("; for (");
                WRITEIDENT( IndexVar );
                WRITESTRING(" = 0; ");
                WRITEIDENT( IndexVar );
                WRITESTRING(" <= ");
                CodeArrayUpperbound( t->Array.Index );
                WRITESTRING("; ");
                WRITEIDENT( IndexVar );
                WRITESTRING("++ ) {");
	        WRITELN();
                TAB(1);
                  CodeFreeVectors( t->Array.ElemType, v );
                  SubDesignatorString( 0, strlen( StringIndex) + 4 );
                DETAB(1);
                WRITEBLANKS();
                WRITESTRING("} }");
	        WRITELN();

  }
  }
END_RULE;
   return;
 }
yyL2:;

  }
  if (t->Kind == kRecord) {
/* line 4388 "new_C.puma" */
  {
/* line 4389 "new_C.puma" */
BEGIN_RULE(78);
/* line 4391 "new_C.puma" */
   CodeFreeVectors (t->Record.Fields, v);
  }
END_RULE;
   return;

  }
  if (t->Kind == kTypeId0) {
/* line 4393 "new_C.puma" */
 {
  CHARBUF StringVar;
  {
/* line 4394 "new_C.puma" */
BEGIN_RULE(79);
/* line 4396 "new_C.puma" */

/* line 4400 "new_C.puma" */
   if (! (t -> TypeId0 . Object -> SymTypeDecl . Type -> Kind == kSymVector && (t -> TypeId0 . Object -> SymTypeDecl . Type -> SymVector . IsOpen || t -> TypeId0 . Object -> SymTypeDecl . Type -> SymVector . Config -> SymConfig . IsGeneric) && v -> Kind == kVarId)) goto yyL4;
  {
/* line 4401 "new_C.puma" */

                GetString( v->VarId.CIdent, StringVar );
                AddPrefixDesignatorString(0, StringVar);
                WRITEBLANKS();
                WRITESTRING("free(");
                WRITESTRING(GetDesignatorString(0));
                WRITESTRING(");");
	        WRITELN();
                SubPrefixDesignatorString(0, strlen(StringVar));
                CodeFreeVectors( t, v->VarId.Next );

  }
  }
END_RULE;
   return;
 }
yyL4:;

  }
  if (t->Kind == kTypeId1) {
/* line 4413 "new_C.puma" */
  {
/* line 4414 "new_C.puma" */
BEGIN_RULE(80);
/* line 4416 "new_C.puma" */
   CodeFreeVectors (t->TypeId1.TypeId, v);
  }
END_RULE;
   return;

  }
  if (t->Kind == kRecordSect) {
/* line 4418 "new_C.puma" */
  {
/* line 4419 "new_C.puma" */
BEGIN_RULE(81);
/* line 4421 "new_C.puma" */
   CodeFreeRecordVectors (t->RecordSect.FieldIds, t->RecordSect.Type, v);
/* line 4422 "new_C.puma" */
   CodeFreeVectors (t->RecordSect.Next, v);
  }
END_RULE;
   return;

  }
/* line 4424 "new_C.puma" */
  {
/* line 4425 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeFreeRecordVectors
# if defined __STDC__ | defined __cplusplus
(register tTree f, register tTree t, register tTree v)
# else
(f, t, v)
 register tTree f;
 register tTree t;
 register tTree v;
# endif
{
/* line 4430 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (f->Kind == kFieldId) {
/* line 4437 "new_C.puma" */
 {
  CHARBUF StringField;
  {
/* line 4438 "new_C.puma" */
BEGIN_RULE(82);
/* line 4440 "new_C.puma" */

/* line 4441 "new_C.puma" */

                GetString( f->FieldId.CIdent, StringField );
                AddDesignatorString( 0, "." );
                AddDesignatorString( 0, StringField );
                CodeFreeVectors( t, v );
                SubDesignatorString( 0, strlen( StringField) + 1 );
                CodeFreeRecordVectors( f->FieldId.Next, t, v );

  }
END_RULE;
   return;
 }

  }
/* line 4450 "new_C.puma" */
  {
/* line 4451 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeArrayUpperbound
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 4456 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kEnumeration) {
/* line 4463 "new_C.puma" */
 {
  tValue Upb;
  {
/* line 4464 "new_C.puma" */
BEGIN_RULE(83);
/* line 4466 "new_C.puma" */

/* line 4467 "new_C.puma" */
   Types_GetUpb (t -> Enumeration . Type2, & Upb);
/* line 4468 "new_C.puma" */
   CodeValue (Upb);
  }
END_RULE;
   return;
 }

  }
  if (t->Kind == kSubrange) {
/* line 4470 "new_C.puma" */
 {
  tValue Lwb;
  tTree LwbExpr;
  tTree UpbExpr;
  {
/* line 4471 "new_C.puma" */
BEGIN_RULE(84);
/* line 4473 "new_C.puma" */

/* line 4473 "new_C.puma" */

/* line 4473 "new_C.puma" */

/* line 4474 "new_C.puma" */

                Types_GetLwb (t->Subrange.Type2, &Lwb);
                LwbExpr = t->Subrange.Type2->SymSubrange.LwbExpr;
                UpbExpr = t->Subrange.Type2->SymSubrange.UpbExpr;
                if ( UpbExpr->Expr.IsCConst ) {
                  if ( Values_ValueToInt( &Lwb ) != 0 ) {
                    CodeExpr( UpbExpr, MINUS_PREC + 1);
                  } else {
                    CodeExpr( UpbExpr, PLUS_PREC + 1);
                  };
                } else {
                  CodeValue (t->Subrange.Type2->SymSubrange.Upb);
                };
                if ( Values_ValueToInt( &Lwb ) != 0 ) {
                  WRITESTRING(" - ");
                  if ( LwbExpr->Expr.IsCConst ) {
                    CodeExpr( LwbExpr, MINUS_PREC );
                  } else {
                    CodeValue( Lwb );
                  };
                };

  }
END_RULE;
   return;
 }

  }
/* line 4497 "new_C.puma" */
 {
  tValue Lwb;
  tValue Upb;
  {
/* line 4498 "new_C.puma" */
BEGIN_RULE(85);
/* line 4500 "new_C.puma" */

/* line 4500 "new_C.puma" */

/* line 4501 "new_C.puma" */
   Types_GetLwb (t -> SimpleType . Type2, & Lwb);
/* line 4502 "new_C.puma" */
   Types_GetUpb (t -> SimpleType . Type2, & Upb);
/* line 4503 "new_C.puma" */
   WRITEINT (Values_ValueToInt (& Upb) - Values_ValueToInt (& Lwb));
  }
END_RULE;
   return;
 }

;
}

static void CodeDefMod
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 4512 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

/* line 4518 "new_C.puma" */
  {
/* line 4519 "new_C.puma" */
BEGIN_RULE(86);
/* line 4521 "new_C.puma" */
   CodeDefModConst (t);
/* line 4522 "new_C.puma" */
   CodeDefModConfig (t);
/* line 4523 "new_C.puma" */
   CodeDefModConnect (t);
/* line 4524 "new_C.puma" */
   CodeDefModOpaque (t);
/* line 4525 "new_C.puma" */
   CodeDefModType (t);
/* line 4526 "new_C.puma" */
   CodeDefModConstInit (t);
/* line 4527 "new_C.puma" */
   CodeDefModVar (t);
/* line 4528 "new_C.puma" */
   CodeDefModProc (t);
  }
END_RULE;
   return;

;
}

static void CodeDefModConst
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 4534 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kConst) {
  if (t->Const.Expr->Kind == kFuncCall) {
  if (Tree_IsType (t->Const.Expr->FuncCall.Designator, kQualid)) {
/* line 4540 "new_C.puma" */
  {
/* line 4541 "new_C.puma" */
BEGIN_RULE(87);
/* line 4544 "new_C.puma" */
   if (! (t->Const.Expr->FuncCall.Designator -> Qualid . Type -> Kind == kSymRecord || t->Const.Expr->FuncCall.Designator -> Qualid . Type -> Kind == kSymArray)) goto yyL1;
  {
/* line 4545 "new_C.puma" */
   CodeDefModConst (t->Const.Next);
  }
  }
END_RULE;
   return;
yyL1:;

  }
  }
  if (t->Const.Expr->Kind == kStringConst) {
/* line 4547 "new_C.puma" */
  {
/* line 4548 "new_C.puma" */
BEGIN_RULE(88);
/* line 4550 "new_C.puma" */
   if (! (LengthSt (t->Const.Expr->StringConst.StringVal) > 1)) goto yyL2;
  {
/* line 4551 "new_C.puma" */
   CodeDebugLine (t->Const.Pos);
/* line 4552 "new_C.puma" */
   WRITESTRING ("extern CHAR ");
/* line 4553 "new_C.puma" */
   WRITEIDENT (t -> Const . CIdent);
/* line 4554 "new_C.puma" */
   WRITESTRING ("[];");
/* line 4555 "new_C.puma" */
   WRITELN ();
/* line 4556 "new_C.puma" */
   CodeDefModConst (t->Const.Next);
  }
  }
END_RULE;
   return;
yyL2:;

  }
/* line 4558 "new_C.puma" */
  {
/* line 4559 "new_C.puma" */
BEGIN_RULE(89);
/* line 4561 "new_C.puma" */
   if (! (t->Const.Expr -> Expr . IsCConst)) goto yyL3;
  {
/* line 4562 "new_C.puma" */
   CodeDebugLine (t->Const.Pos);
/* line 4563 "new_C.puma" */
   WRITESTRING ("#define ");
/* line 4564 "new_C.puma" */
   WRITEIDENT (t -> Const . CIdent);
/* line 4565 "new_C.puma" */
   WRITESTRING (" ");
/* line 4566 "new_C.puma" */
   CodeExpr (t->Const.Expr, MAXPREC_PREC);
/* line 4567 "new_C.puma" */
   WRITELN ();
/* line 4568 "new_C.puma" */
   CodeDefModConst (t->Const.Next);
  }
  }
END_RULE;
   return;
yyL3:;

/* line 4570 "new_C.puma" */
  {
/* line 4571 "new_C.puma" */
BEGIN_RULE(90);
/* line 4573 "new_C.puma" */
   CodeDebugLine (t->Const.Pos);
/* line 4574 "new_C.puma" */
   WRITESTRING ("#define ");
/* line 4575 "new_C.puma" */
   WRITEIDENT (t -> Const . CIdent);
/* line 4576 "new_C.puma" */
   WRITESTRING (" ");
/* line 4577 "new_C.puma" */
   CodeValue (t -> Const . Object -> SymConst . Value);
/* line 4578 "new_C.puma" */
   WRITELN ();
/* line 4579 "new_C.puma" */
   CodeDefModConst (t->Const.Next);
  }
END_RULE;
   return;

  }
  if (Tree_IsType (t, kDecl)) {
/* line 4581 "new_C.puma" */
  {
/* line 4582 "new_C.puma" */
BEGIN_RULE(91);
/* line 4584 "new_C.puma" */
   CodeDefModConst (t->Decl.Next);
  }
END_RULE;
   return;

  }
/* line 4586 "new_C.puma" */
  {
/* line 4587 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeDefModConfig
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 4590 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kConfig) {
/* line 4596 "new_C.puma" */
  {
/* line 4597 "new_C.puma" */
BEGIN_RULE(92);
/* line 4599 "new_C.puma" */
   if (! (t -> Config . Object -> SymConfig . IsGeneric)) goto yyL1;
  {
/* line 4607 "new_C.puma" */
   CodeDefModConfig (t->Config.Next);
  }
  }
END_RULE;
   return;
yyL1:;

/* line 4609 "new_C.puma" */
  {
/* line 4610 "new_C.puma" */
BEGIN_RULE(93);
/* line 4612 "new_C.puma" */
   CodeDebugLine (t->Config.Pos);
/* line 4613 "new_C.puma" */
   WRITESTRING ("extern CONFIGURATION ");
/* line 4614 "new_C.puma" */
   WRITEIDENT (t -> Config . CIdent);
/* line 4615 "new_C.puma" */
   WRITESTRING (";");
/* line 4616 "new_C.puma" */
   WRITELN ();
/* line 4617 "new_C.puma" */
   CodeDefModConfig (t->Config.Next);
  }
END_RULE;
   return;

  }
  if (Tree_IsType (t, kDecl)) {
/* line 4619 "new_C.puma" */
  {
/* line 4620 "new_C.puma" */
BEGIN_RULE(94);
/* line 4622 "new_C.puma" */
   CodeDefModConfig (t->Decl.Next);
  }
END_RULE;
   return;

  }
/* line 4624 "new_C.puma" */
  {
/* line 4625 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeDefModConnect
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 4628 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kConnectFrom) {
/* line 4634 "new_C.puma" */
  {
/* line 4635 "new_C.puma" */
BEGIN_RULE(95);
/* line 4637 "new_C.puma" */
   CodeDefModConnect (t->ConnectFrom.ConnectDecls);
/* line 4638 "new_C.puma" */
   CodeDefModConnect (t->ConnectFrom.Next);
  }
END_RULE;
   return;

  }
  if (t->Kind == kConnectDecls) {
/* line 4640 "new_C.puma" */
  {
/* line 4641 "new_C.puma" */
BEGIN_RULE(96);
/* line 4643 "new_C.puma" */
   if (! (! t->ConnectDecls.Config -> Qualid . Object -> SymConfig . IsGeneric)) goto yyL2;
  {
/* line 4644 "new_C.puma" */

                if (t->ConnectDecls.FirstDeclaration) {
		  CodeDebugLine(t->ConnectDecls.Pos);
                  if (t->ConnectDecls.Index == NoExpr) {
                    WRITESTRING("extern CONNECTION ");
                  } else {
                    WRITESTRING("extern PARAMETER_CONNECTION ");
                  }
                  WRITEIDENT(t->ConnectDecls.CIdent);
                  WRITESTRING(";");
		  WRITELN();
                }
                CodeDefModConnect(t->ConnectDecls.DirIn);

/* line 4658 "new_C.puma" */
   CodeDefModConnect (t->ConnectDecls.Next);
  }
  }
END_RULE;
   return;
yyL2:;

  }
  if (Tree_IsType (t, kDecl)) {
/* line 4660 "new_C.puma" */
  {
/* line 4661 "new_C.puma" */
BEGIN_RULE(97);
/* line 4663 "new_C.puma" */
   CodeDefModConnect (t->Decl.Next);
  }
END_RULE;
   return;

  }
  if (t->Kind == kConnectDestBi) {
/* line 4665 "new_C.puma" */
  {
/* line 4666 "new_C.puma" */
BEGIN_RULE(98);
/* line 4668 "new_C.puma" */

                if (t->ConnectDestBi.FirstDeclaration) {
		  CodeDebugLine(t->ConnectDestBi.Pos);
                  if (t->ConnectDestBi.Index == NoExpr) {
                    WRITESTRING("extern CONNECTION ");
                  } else {
                    WRITESTRING("extern PARAMETER_CONNECTION ");
                  }
                  WRITEIDENT(t->ConnectDestBi.CIdent);
                  WRITESTRING(";");
		  WRITELN();
                }
                CodeDefModConnect(t->ConnectDestBi.Next);

  }
END_RULE;
   return;

  }
/* line 4683 "new_C.puma" */
  {
/* line 4684 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeDefModOpaque
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 4687 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kOpaque) {
/* line 4693 "new_C.puma" */
  {
/* line 4694 "new_C.puma" */
BEGIN_RULE(99);
/* line 4696 "new_C.puma" */
   CodeDebugLine (t->Opaque.Pos);
/* line 4697 "new_C.puma" */
   WRITESTRING ("typedef OPAQUE ");
/* line 4698 "new_C.puma" */
   WRITEIDENT (t -> Opaque . CIdent);
/* line 4699 "new_C.puma" */
   WRITESTRING ("; ");
/* line 4700 "new_C.puma" */
   WRITELN ();
/* line 4701 "new_C.puma" */
   CodeDefModOpaque (t->Opaque.Next);
  }
END_RULE;
   return;

  }
  if (Tree_IsType (t, kDecl)) {
/* line 4703 "new_C.puma" */
  {
/* line 4704 "new_C.puma" */
BEGIN_RULE(100);
/* line 4706 "new_C.puma" */
   CodeDefModOpaque (t->Decl.Next);
  }
END_RULE;
   return;

  }
/* line 4708 "new_C.puma" */
  {
/* line 4709 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeDefModType
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 4712 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kTypeDecl) {
/* line 4718 "new_C.puma" */
  {
/* line 4719 "new_C.puma" */
BEGIN_RULE(101);
/* line 4721 "new_C.puma" */
   CodeEnums (t->TypeDecl.Type);
/* line 4722 "new_C.puma" */
   CodeDebugLine (t->TypeDecl.Pos);
/* line 4723 "new_C.puma" */
   WRITESTRING ("typedef ");
/* line 4724 "new_C.puma" */
   CodeType (t->TypeDecl.Type, FULL);
/* line 4725 "new_C.puma" */
   WRITESTRING (" ");
/* line 4726 "new_C.puma" */
   CodeDecla (t->TypeDecl.Type, BEFORE);
/* line 4727 "new_C.puma" */
   WRITEIDENT (t -> TypeDecl . CIdent);
/* line 4728 "new_C.puma" */
   CodeDecla (t->TypeDecl.Type, AFTER);
/* line 4729 "new_C.puma" */
   WRITESTRING (";");
/* line 4730 "new_C.puma" */
   WRITELN ();
/* line 4731 "new_C.puma" */
   CodeDefModType (t->TypeDecl.Next);
  }
END_RULE;
   return;

  }
  if (Tree_IsType (t, kDecl)) {
/* line 4733 "new_C.puma" */
  {
/* line 4734 "new_C.puma" */
BEGIN_RULE(102);
/* line 4736 "new_C.puma" */
   CodeDefModType (t->Decl.Next);
  }
END_RULE;
   return;

  }
/* line 4738 "new_C.puma" */
  {
/* line 4739 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeDefModConstInit
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 4742 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kConst) {
  if (t->Const.Expr->Kind == kFuncCall) {
  if (Tree_IsType (t->Const.Expr->FuncCall.Designator, kQualid)) {
/* line 4748 "new_C.puma" */
  {
/* line 4749 "new_C.puma" */
BEGIN_RULE(103);
/* line 4752 "new_C.puma" */
   if (! (t->Const.Expr->FuncCall.Designator -> Qualid . Type -> Kind == kSymRecord || t->Const.Expr->FuncCall.Designator -> Qualid . Type -> Kind == kSymArray)) goto yyL1;
  {
/* line 4753 "new_C.puma" */
   CodeDebugLine (t->Const.Pos);
/* line 4754 "new_C.puma" */
   WRITESTRING ("extern ");
/* line 4755 "new_C.puma" */
   WRITEIDENT (t->Const.Expr->FuncCall.Designator -> Qualid . Object -> SymObject . CIdent);
/* line 4756 "new_C.puma" */
   WRITESTRING (" ");
/* line 4757 "new_C.puma" */
   WRITEIDENT (t -> Const . CIdent);
/* line 4758 "new_C.puma" */
   WRITESTRING (";");
/* line 4759 "new_C.puma" */
   WRITELN ();
/* line 4760 "new_C.puma" */
   CodeDefModConstInit (t->Const.Next);
  }
  }
END_RULE;
   return;
yyL1:;

  }
  }
  }
  if (Tree_IsType (t, kDecl)) {
/* line 4762 "new_C.puma" */
  {
/* line 4763 "new_C.puma" */
BEGIN_RULE(104);
/* line 4765 "new_C.puma" */
   CodeDefModConstInit (t->Decl.Next);
  }
END_RULE;
   return;

  }
/* line 4767 "new_C.puma" */
  {
/* line 4768 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeDefModVar
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 4771 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kVar) {
/* line 4777 "new_C.puma" */
  {
/* line 4778 "new_C.puma" */
BEGIN_RULE(105);
/* line 4780 "new_C.puma" */
   CodeEnums (t->Var.Type);
/* line 4781 "new_C.puma" */
   CodeDebugLine (t->Var.VarIds -> VarId . Pos);
/* line 4782 "new_C.puma" */
   WRITESTRING ("extern ");
/* line 4783 "new_C.puma" */
   CodeType (t->Var.Type, FULL);
/* line 4784 "new_C.puma" */
   WRITESTRING (" ");
/* line 4785 "new_C.puma" */
   CodeIds (t->Var.VarIds, t->Var.Type);
/* line 4786 "new_C.puma" */
   WRITESTRING (";");
/* line 4787 "new_C.puma" */
   WRITELN ();
/* line 4788 "new_C.puma" */
   CodeDefModVar (t->Var.Next);
  }
END_RULE;
   return;

  }
  if (Tree_IsType (t, kDecl)) {
/* line 4790 "new_C.puma" */
  {
/* line 4791 "new_C.puma" */
BEGIN_RULE(106);
/* line 4793 "new_C.puma" */
   CodeDefModVar (t->Decl.Next);
  }
END_RULE;
   return;

  }
/* line 4795 "new_C.puma" */
  {
/* line 4796 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeDefModProc
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 4799 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kProcHead) {
/* line 4805 "new_C.puma" */
  {
/* line 4806 "new_C.puma" */
BEGIN_RULE(107);
/* line 4808 "new_C.puma" */
   CodeDebugLine (t->ProcHead.Pos);
/* line 4809 "new_C.puma" */
   WRITESTRING ("extern ");
/* line 4810 "new_C.puma" */
   CodeType (t->ProcHead.ResultType, FULL);
/* line 4811 "new_C.puma" */
   WRITESTRING (" ");
/* line 4812 "new_C.puma" */
 if (t->ProcHead.ResultType->Kind == kVector) { WRITESTRING("*"); } 
/* line 4813 "new_C.puma" */
   WRITEIDENT (t -> ProcHead . CIdent);
/* line 4814 "new_C.puma" */
   WRITESTRING (" ARGS((");
/* line 4815 "new_C.puma" */
   CodeFormals3 (t->ProcHead.Formals, mVoid (), NoIdent);
/* line 4816 "new_C.puma" */
   CodeFormalsOpenVector (t->ProcHead.Formals, 3);
/* line 4817 "new_C.puma" */
   CodeFormalsGenericConfig (t->ProcHead.Formals, 3);
/* line 4818 "new_C.puma" */
   WRITESTRING ("));");
/* line 4819 "new_C.puma" */
   WRITELN ();
/* line 4820 "new_C.puma" */
   CodeDefModProc (t->ProcHead.Next);
  }
END_RULE;
   return;

  }
  if (Tree_IsType (t, kDecl)) {
/* line 4822 "new_C.puma" */
  {
/* line 4823 "new_C.puma" */
BEGIN_RULE(108);
/* line 4825 "new_C.puma" */
   CodeDefModProc (t->Decl.Next);
  }
END_RULE;
   return;

  }
/* line 4827 "new_C.puma" */
  {
/* line 4828 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeDefProg
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 4836 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kVar) {
/* line 4843 "new_C.puma" */
  {
/* line 4844 "new_C.puma" */
BEGIN_RULE(109);
/* line 4846 "new_C.puma" */
   CodeDebugLine (t->Var.VarIds -> VarId . Pos);
/* line 4847 "new_C.puma" */
   CodeType (t->Var.Type, NONFULL);
/* line 4848 "new_C.puma" */
   WRITESTRING (" ");
/* line 4849 "new_C.puma" */
   CodeIds (t->Var.VarIds, t->Var.Type);
/* line 4850 "new_C.puma" */
   WRITESTRING (";");
/* line 4851 "new_C.puma" */
   WRITELN ();
/* line 4852 "new_C.puma" */
   CodeDefProg (t->Var.Next);
  }
END_RULE;
   return;

  }
  if (t->Kind == kConnectFrom) {
/* line 4854 "new_C.puma" */
  {
/* line 4855 "new_C.puma" */
BEGIN_RULE(110);
/* line 4857 "new_C.puma" */
   CodeDefProg (t->ConnectFrom.ConnectDecls);
/* line 4858 "new_C.puma" */
   CodeDefProg (t->ConnectFrom.Next);
  }
END_RULE;
   return;

  }
  if (t->Kind == kConnectDecls) {
/* line 4860 "new_C.puma" */
  {
/* line 4861 "new_C.puma" */
BEGIN_RULE(111);
/* line 4863 "new_C.puma" */
   if (! (! t->ConnectDecls.Config -> Qualid . Object -> SymConfig . IsGeneric)) goto yyL3;
  {
/* line 4864 "new_C.puma" */

                if (t->ConnectDecls.FirstDeclaration) {
		  CodeDebugLine(t->ConnectDecls.Pos);
                  if (t->ConnectDecls.Index == NoExpr) {
                    WRITESTRING("CONNECTION ");
                  } else {
                    WRITESTRING("PARAMETER_CONNECTION ");
                  }
                  WRITEIDENT(t->ConnectDecls.CIdent);
                  WRITESTRING(" = { NULL, NULL, NULL };");
		  WRITELN();
                }
                CodeDefProg(t->ConnectDecls.DirIn);

/* line 4878 "new_C.puma" */
   CodeDefProg (t->ConnectDecls.Next);
  }
  }
END_RULE;
   return;
yyL3:;

  }
  if (t->Kind == kConfig) {
/* line 4880 "new_C.puma" */
  {
/* line 4881 "new_C.puma" */
BEGIN_RULE(112);
/* line 4883 "new_C.puma" */
   if (! (! t -> Config . Object -> SymConfig . IsGeneric)) goto yyL4;
  {
/* line 4884 "new_C.puma" */
   CodeDebugLine (t->Config.Pos);
/* line 4885 "new_C.puma" */
   WRITESTRING ("CONFIGURATION ");
/* line 4886 "new_C.puma" */
   WRITEIDENT (t -> Config . CIdent);
/* line 4887 "new_C.puma" */
   WRITESTRING (";");
/* line 4888 "new_C.puma" */
   WRITELN ();
/* line 4889 "new_C.puma" */
   CodeDefProg (t->Config.Next);
  }
  }
END_RULE;
   return;
yyL4:;

  }
  if (t->Kind == kConst) {
  if (t->Const.Expr->Kind == kFuncCall) {
  if (Tree_IsType (t->Const.Expr->FuncCall.Designator, kQualid)) {
/* line 4891 "new_C.puma" */
  {
/* line 4892 "new_C.puma" */
BEGIN_RULE(113);
/* line 4895 "new_C.puma" */
   if (! (t->Const.Expr->FuncCall.Designator -> Qualid . Type -> Kind == kSymRecord || t->Const.Expr->FuncCall.Designator -> Qualid . Type -> Kind == kSymArray)) goto yyL5;
  {
/* line 4896 "new_C.puma" */
   CodeDebugLine (t->Const.Pos);
/* line 4897 "new_C.puma" */
   WRITEIDENT (t->Const.Expr->FuncCall.Designator -> Qualid . Object -> SymObject . CIdent);
/* line 4898 "new_C.puma" */
   WRITESTRING (" ");
/* line 4899 "new_C.puma" */
   WRITEIDENT (t -> Const . CIdent);
/* line 4900 "new_C.puma" */
   WRITESTRING (" = {");
/* line 4901 "new_C.puma" */
   CodeActuals (t->Const.Expr->FuncCall.Actuals);
/* line 4902 "new_C.puma" */
   WRITESTRING ("};");
/* line 4903 "new_C.puma" */
   WRITELN ();
/* line 4904 "new_C.puma" */
   CodeDefProg (t->Const.Next);
  }
  }
END_RULE;
   return;
yyL5:;

  }
  }
  if (t->Const.Expr->Kind == kStringConst) {
/* line 4906 "new_C.puma" */
  {
/* line 4907 "new_C.puma" */
BEGIN_RULE(114);
/* line 4909 "new_C.puma" */
   if (! (LengthSt (t->Const.Expr->StringConst.StringVal) > 1)) goto yyL6;
  {
/* line 4910 "new_C.puma" */
   CodeDebugLine (t->Const.Pos);
/* line 4911 "new_C.puma" */
   WRITESTRING ("CHAR ");
/* line 4912 "new_C.puma" */
   WRITEIDENT (t -> Const . CIdent);
/* line 4913 "new_C.puma" */
   WRITESTRING (" [] = ");
/* line 4914 "new_C.puma" */
   CodeConstString (t->Const.Expr->StringConst.StringVal);
/* line 4915 "new_C.puma" */
   WRITESTRING (";");
/* line 4916 "new_C.puma" */
   WRITELN ();
/* line 4917 "new_C.puma" */
   CodeDefProg (t->Const.Next);
  }
  }
END_RULE;
   return;
yyL6:;

  }
  }
  if (Tree_IsType (t, kDecl)) {
/* line 4919 "new_C.puma" */
  {
/* line 4920 "new_C.puma" */
BEGIN_RULE(115);
/* line 4922 "new_C.puma" */
   CodeDefProg (t->Decl.Next);
  }
END_RULE;
   return;

  }
  if (t->Kind == kConnectDestBi) {
/* line 4924 "new_C.puma" */
  {
/* line 4925 "new_C.puma" */
BEGIN_RULE(116);
/* line 4927 "new_C.puma" */

                if (t->ConnectDestBi.FirstDeclaration) {
		  CodeDebugLine(t->ConnectDestBi.Pos);
                  if (t->ConnectDestBi.Index == NoExpr) {
                    WRITESTRING("CONNECTION ");
                  } else {
                    WRITESTRING("PARAMETER_CONNECTION ");
                  }
                  WRITEIDENT(t->ConnectDestBi.CIdent);
                  WRITESTRING(" = { NULL, NULL, NULL };");
		  WRITELN();
                }
                CodeDefProg(t->ConnectDestBi.Next);

  }
END_RULE;
   return;

  }
/* line 4942 "new_C.puma" */
  {
/* line 4943 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeDecls1
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 4954 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

/* line 4961 "new_C.puma" */
  {
/* line 4962 "new_C.puma" */
BEGIN_RULE(117);
/* line 4964 "new_C.puma" */
   CodeDeclsConst (t);
/* line 4965 "new_C.puma" */
   CodeDeclsConfig (t);
/* line 4966 "new_C.puma" */
   CodeDeclsConnect (t);
/* line 4967 "new_C.puma" */
   CodeDeclsType (t);
/* line 4968 "new_C.puma" */
   CodeDeclsConstInit (t);
/* line 4969 "new_C.puma" */
   CodeDeclsVar (t);
/* line 4970 "new_C.puma" */
   CodeDeclsProc (t);
  }
END_RULE;
   return;

;
}

static void CodeDeclsConst
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 4976 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kConst) {
  if (t->Const.Expr->Kind == kFuncCall) {
  if (Tree_IsType (t->Const.Expr->FuncCall.Designator, kQualid)) {
/* line 4982 "new_C.puma" */
  {
/* line 4983 "new_C.puma" */
BEGIN_RULE(118);
/* line 4986 "new_C.puma" */
   if (! (t->Const.Expr->FuncCall.Designator -> Qualid . Type -> Kind == kSymRecord || t->Const.Expr->FuncCall.Designator -> Qualid . Type -> Kind == kSymArray)) goto yyL1;
  {
/* line 4987 "new_C.puma" */
   CodeDeclsConst (t->Const.Next);
  }
  }
END_RULE;
   return;
yyL1:;

  }
  }
  if (t->Const.Expr->Kind == kStringConst) {
/* line 4989 "new_C.puma" */
  {
/* line 4990 "new_C.puma" */
BEGIN_RULE(119);
/* line 4992 "new_C.puma" */
   if (! (LengthSt (t->Const.Expr->StringConst.StringVal) > 1)) goto yyL2;
  {
/* line 4993 "new_C.puma" */
   CodeDebugLine (t->Const.Pos);
/* line 4994 "new_C.puma" */
   WRITESTRING ("static CHAR ");
/* line 4995 "new_C.puma" */
   WRITEIDENT (t -> Const . CIdent);
/* line 4996 "new_C.puma" */
   WRITESTRING (" [] = ");
/* line 4997 "new_C.puma" */
   CodeConstString (t->Const.Expr->StringConst.StringVal);
/* line 4998 "new_C.puma" */
   WRITESTRING (";");
/* line 4999 "new_C.puma" */
   WRITELN ();
/* line 5000 "new_C.puma" */
   CodeDeclsConst (t->Const.Next);
  }
  }
END_RULE;
   return;
yyL2:;

  }
/* line 5002 "new_C.puma" */
  {
/* line 5003 "new_C.puma" */
BEGIN_RULE(120);
/* line 5005 "new_C.puma" */
   if (! (t->Const.Expr -> Expr . IsCConst)) goto yyL3;
  {
/* line 5006 "new_C.puma" */
   CodeDebugLine (t->Const.Pos);
/* line 5007 "new_C.puma" */
   WRITESTRING ("#define ");
/* line 5008 "new_C.puma" */
   WRITEIDENT (t -> Const . CIdent);
/* line 5009 "new_C.puma" */
   WRITESTRING (" ");
/* line 5010 "new_C.puma" */
   CodeExpr (t->Const.Expr, MAXPREC_PREC);
/* line 5011 "new_C.puma" */
   WRITELN ();
/* line 5012 "new_C.puma" */
   CodeDeclsConst (t->Const.Next);
  }
  }
END_RULE;
   return;
yyL3:;

/* line 5014 "new_C.puma" */
  {
/* line 5015 "new_C.puma" */
BEGIN_RULE(121);
/* line 5017 "new_C.puma" */
   CodeDebugLine (t->Const.Pos);
/* line 5018 "new_C.puma" */
   WRITESTRING ("#define ");
/* line 5019 "new_C.puma" */
   WRITEIDENT (t -> Const . CIdent);
/* line 5020 "new_C.puma" */
   WRITESTRING (" ");
/* line 5021 "new_C.puma" */
   CodeValue (t -> Const . Object -> SymConst . Value);
/* line 5022 "new_C.puma" */
   WRITELN ();
/* line 5023 "new_C.puma" */
   CodeDeclsConst (t->Const.Next);
  }
END_RULE;
   return;

  }
  if (Tree_IsType (t, kDecl)) {
/* line 5025 "new_C.puma" */
  {
/* line 5026 "new_C.puma" */
BEGIN_RULE(122);
/* line 5028 "new_C.puma" */
   CodeDeclsConst (t->Decl.Next);
  }
END_RULE;
   return;

  }
/* line 5030 "new_C.puma" */
  {
/* line 5031 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeDeclsConfig
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 5034 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kConfig) {
/* line 5040 "new_C.puma" */
  {
/* line 5041 "new_C.puma" */
BEGIN_RULE(123);
/* line 5043 "new_C.puma" */
   if (! (t -> Config . Object -> SymConfig . IsGeneric)) goto yyL1;
  {
/* line 5057 "new_C.puma" */
   CodeDeclsConfig (t->Config.Next);
  }
  }
END_RULE;
   return;
yyL1:;

/* line 5059 "new_C.puma" */
  {
/* line 5060 "new_C.puma" */
BEGIN_RULE(124);
/* line 5062 "new_C.puma" */
   CodeDebugLine (t->Config.Pos);
/* line 5063 "new_C.puma" */
   WRITESTRING ("static CONFIGURATION ");
/* line 5064 "new_C.puma" */
   WRITEIDENT (t -> Config . CIdent);
/* line 5065 "new_C.puma" */
   WRITESTRING (";");
/* line 5066 "new_C.puma" */
   WRITELN ();
/* line 5067 "new_C.puma" */
   CodeDeclsConfig (t->Config.Next);
  }
END_RULE;
   return;

  }
  if (Tree_IsType (t, kDecl)) {
/* line 5069 "new_C.puma" */
  {
/* line 5070 "new_C.puma" */
BEGIN_RULE(125);
/* line 5072 "new_C.puma" */
   CodeDeclsConfig (t->Decl.Next);
  }
END_RULE;
   return;

  }
/* line 5074 "new_C.puma" */
  {
/* line 5075 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeDeclsConnect
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 5078 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kConnectFrom) {
/* line 5084 "new_C.puma" */
  {
/* line 5085 "new_C.puma" */
BEGIN_RULE(126);
/* line 5087 "new_C.puma" */
   CodeDeclsConnect (t->ConnectFrom.ConnectDecls);
/* line 5088 "new_C.puma" */
   CodeDeclsConnect (t->ConnectFrom.Next);
  }
END_RULE;
   return;

  }
  if (t->Kind == kConnectDecls) {
/* line 5090 "new_C.puma" */
  {
/* line 5091 "new_C.puma" */
BEGIN_RULE(127);
/* line 5093 "new_C.puma" */
   if (! (! t->ConnectDecls.Config -> Qualid . Object -> SymConfig . IsGeneric)) goto yyL2;
  {
/* line 5094 "new_C.puma" */

                if (t->ConnectDecls.FirstDeclaration) {
		  CodeDebugLine(t->ConnectDecls.Pos);
                  if (t->ConnectDecls.Index == NoExpr) {
                    WRITESTRING("static CONNECTION ");
                  } else {
                    WRITESTRING("static PARAMETER_CONNECTION ");
                  }
                  WRITEIDENT(t->ConnectDecls.CIdent);
                  WRITESTRING(" = { NULL, NULL, NULL};");
		  WRITELN();
                }
                CodeDeclsConnect(t->ConnectDecls.DirIn);
                CodeDeclsConnect(t->ConnectDecls.Next);

  }
  }
END_RULE;
   return;
yyL2:;

  }
  if (Tree_IsType (t, kDecl)) {
/* line 5110 "new_C.puma" */
  {
/* line 5111 "new_C.puma" */
BEGIN_RULE(128);
/* line 5113 "new_C.puma" */
   CodeDeclsConnect (t->Decl.Next);
  }
END_RULE;
   return;

  }
  if (t->Kind == kConnectDestBi) {
/* line 5115 "new_C.puma" */
  {
/* line 5116 "new_C.puma" */
BEGIN_RULE(129);
/* line 5118 "new_C.puma" */

                if (t->ConnectDestBi.FirstDeclaration) {
		  CodeDebugLine(t->ConnectDestBi.Pos);
                  if (t->ConnectDestBi.Index == NoExpr) {
                    WRITESTRING("static CONNECTION ");
                  } else {
                    WRITESTRING("static PARAMETER_CONNECTION ");
                  }
                  WRITEIDENT(t->ConnectDestBi.CIdent);
                  WRITESTRING(" = { NULL, NULL, NULL};");
		  WRITELN();
                }
                CodeDeclsConnect( t->ConnectDestBi.Next );

  }
END_RULE;
   return;

  }
/* line 5133 "new_C.puma" */
  {
/* line 5134 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeDeclsType
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 5137 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kTypeDecl) {
/* line 5143 "new_C.puma" */
  {
/* line 5144 "new_C.puma" */
BEGIN_RULE(130);
/* line 5146 "new_C.puma" */
   CodeEnums (t->TypeDecl.Type);
/* line 5147 "new_C.puma" */
   CodeDebugLine (t->TypeDecl.Pos);
/* line 5148 "new_C.puma" */
   WRITESTRING ("typedef ");
/* line 5149 "new_C.puma" */
   CodeType (t->TypeDecl.Type, FULL);
/* line 5150 "new_C.puma" */
   WRITESTRING (" ");
/* line 5151 "new_C.puma" */
   CodeDecla (t->TypeDecl.Type, BEFORE);
/* line 5152 "new_C.puma" */
   WRITEIDENT (t -> TypeDecl . CIdent);
/* line 5153 "new_C.puma" */
   CodeDecla (t->TypeDecl.Type, AFTER);
/* line 5154 "new_C.puma" */
   WRITESTRING (";");
/* line 5155 "new_C.puma" */
   WRITELN ();
/* line 5156 "new_C.puma" */
   CodeDeclsType (t->TypeDecl.Next);
  }
END_RULE;
   return;

  }
  if (Tree_IsType (t, kDecl)) {
/* line 5158 "new_C.puma" */
  {
/* line 5159 "new_C.puma" */
BEGIN_RULE(131);
/* line 5161 "new_C.puma" */
   CodeDeclsType (t->Decl.Next);
  }
END_RULE;
   return;

  }
/* line 5163 "new_C.puma" */
  {
/* line 5164 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeDeclsConstInit
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 5167 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kConst) {
  if (t->Const.Expr->Kind == kFuncCall) {
  if (Tree_IsType (t->Const.Expr->FuncCall.Designator, kQualid)) {
/* line 5173 "new_C.puma" */
  {
/* line 5174 "new_C.puma" */
BEGIN_RULE(132);
/* line 5177 "new_C.puma" */
   if (! (t->Const.Expr->FuncCall.Designator -> Qualid . Type -> Kind == kSymRecord || t->Const.Expr->FuncCall.Designator -> Qualid . Type -> Kind == kSymArray)) goto yyL1;
  {
/* line 5178 "new_C.puma" */
   CodeDebugLine (t->Const.Pos);
/* line 5179 "new_C.puma" */
   WRITESTRING ("static ");
/* line 5180 "new_C.puma" */
   WRITEIDENT (t->Const.Expr->FuncCall.Designator -> Qualid . Object -> SymObject . CIdent);
/* line 5181 "new_C.puma" */
   WRITESTRING (" ");
/* line 5182 "new_C.puma" */
   WRITEIDENT (t -> Const . CIdent);
/* line 5183 "new_C.puma" */
   WRITESTRING (" = {");
/* line 5184 "new_C.puma" */
   CodeActuals (t->Const.Expr->FuncCall.Actuals);
/* line 5185 "new_C.puma" */
   WRITESTRING ("};");
/* line 5186 "new_C.puma" */
   WRITELN ();
/* line 5187 "new_C.puma" */
   CodeDeclsConstInit (t->Const.Next);
  }
  }
END_RULE;
   return;
yyL1:;

  }
  }
  }
  if (Tree_IsType (t, kDecl)) {
/* line 5189 "new_C.puma" */
  {
/* line 5190 "new_C.puma" */
BEGIN_RULE(133);
/* line 5192 "new_C.puma" */
   CodeDeclsConstInit (t->Decl.Next);
  }
END_RULE;
   return;

  }
/* line 5194 "new_C.puma" */
  {
/* line 5195 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeDeclsVar
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 5198 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kVar) {
/* line 5204 "new_C.puma" */
  {
/* line 5205 "new_C.puma" */
BEGIN_RULE(134);
/* line 5207 "new_C.puma" */
   if (! (t -> Var . IsGlobal)) goto yyL1;
  {
/* line 5208 "new_C.puma" */
   CodeEnums (t->Var.Type);
/* line 5209 "new_C.puma" */
   CodeDebugLine (t->Var.VarIds -> VarId . Pos);
/* line 5210 "new_C.puma" */
   WRITESTRING ("static ");
/* line 5211 "new_C.puma" */
   CodeType (t->Var.Type, FULL);
/* line 5212 "new_C.puma" */
   WRITESTRING (" ");
/* line 5213 "new_C.puma" */
   CodeIds (t->Var.VarIds, t->Var.Type);
/* line 5214 "new_C.puma" */
   WRITESTRING (";");
/* line 5215 "new_C.puma" */
   WRITELN ();
/* line 5216 "new_C.puma" */
   CodeDeclsVar (t->Var.Next);
  }
  }
END_RULE;
   return;
yyL1:;

/* line 5218 "new_C.puma" */
  {
/* line 5219 "new_C.puma" */
BEGIN_RULE(135);
/* line 5221 "new_C.puma" */
   if (! (! (t -> Var . IsGlobal))) goto yyL2;
  {
/* line 5222 "new_C.puma" */
   CodeEnums (t->Var.Type);
/* line 5223 "new_C.puma" */
   CodeStruct (t->Var.Type);
/* line 5224 "new_C.puma" */
   CodeDeclsVar (t->Var.Next);
  }
  }
END_RULE;
   return;
yyL2:;

  }
  if (Tree_IsType (t, kDecl)) {
/* line 5226 "new_C.puma" */
  {
/* line 5227 "new_C.puma" */
BEGIN_RULE(136);
/* line 5229 "new_C.puma" */
   CodeDeclsVar (t->Decl.Next);
  }
END_RULE;
   return;

  }
/* line 5231 "new_C.puma" */
  {
/* line 5232 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeDeclsProc
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 5235 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kProc) {
/* line 5241 "new_C.puma" */
  {
/* line 5242 "new_C.puma" */
BEGIN_RULE(137);
/* line 5244 "new_C.puma" */
   if (! (! (Symbols_IsExported (t -> Proc . Object)))) goto yyL1;
  {
/* line 5245 "new_C.puma" */
   CodeDebugLine (t->Proc.Pos);
/* line 5246 "new_C.puma" */
   WRITESTRING ("static ");
/* line 5247 "new_C.puma" */
   CodeType (t->Proc.ResultType, FULL);
/* line 5248 "new_C.puma" */
   WRITESTRING (" ");
/* line 5249 "new_C.puma" */
 if (t->Proc.ResultType->Kind == kVector) { WRITESTRING("*"); } 
/* line 5250 "new_C.puma" */
   WRITEIDENT (t -> Proc . CIdent);
/* line 5251 "new_C.puma" */
   WRITESTRING (" ARGS((");
/* line 5252 "new_C.puma" */
   CodeFormals3 (t->Proc.Formals, mVoid (), NoIdent);
/* line 5253 "new_C.puma" */
   CodeFormalsOpenVector (t->Proc.Formals, 3);
/* line 5254 "new_C.puma" */
   CodeFormalsGenericConfig (t->Proc.Formals, 3);
/* line 5255 "new_C.puma" */
   WRITESTRING ("));");
/* line 5256 "new_C.puma" */
   WRITELN ();
/* line 5257 "new_C.puma" */
   CodeDecls1 (t->Proc.Decls);
/* line 5258 "new_C.puma" */
   CodeDeclsProc (t->Proc.Next);
  }
  }
END_RULE;
   return;
yyL1:;

/* line 5260 "new_C.puma" */
  {
/* line 5261 "new_C.puma" */
BEGIN_RULE(138);
/* line 5263 "new_C.puma" */
   CodeDecls1 (t->Proc.Decls);
/* line 5264 "new_C.puma" */
   CodeDeclsProc (t->Proc.Next);
  }
END_RULE;
   return;

  }
  if (Tree_IsType (t, kDecl)) {
/* line 5266 "new_C.puma" */
  {
/* line 5267 "new_C.puma" */
BEGIN_RULE(139);
/* line 5269 "new_C.puma" */
   CodeDeclsProc (t->Decl.Next);
  }
END_RULE;
   return;

  }
/* line 5271 "new_C.puma" */
  {
/* line 5272 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeType
# if defined __STDC__ | defined __cplusplus
(register tTree t, BOOLEAN Full)
# else
(t, Full)
 register tTree t;
 BOOLEAN Full;
# endif
{
/* line 5279 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif


  switch (t->Kind) {
  case kVector:
/* line 5290 "new_C.puma" */
  {
/* line 5291 "new_C.puma" */
BEGIN_RULE(140);
/* line 5293 "new_C.puma" */
   CodeType (t->Vector.Scalar, Full);
  }
END_RULE;
   return;

  case kArray:
/* line 5295 "new_C.puma" */
 {
  tValue Lwb;
  tTree LwbExpr;
  tTree UpbExpr;
  {
/* line 5296 "new_C.puma" */
BEGIN_RULE(141);
/* line 5298 "new_C.puma" */
   if (! (t->Array.Index -> SimpleType . Type2 -> Kind == kSymSubrange)) goto yyL2;
  {
/* line 5299 "new_C.puma" */

/* line 5299 "new_C.puma" */

/* line 5299 "new_C.puma" */

/* line 5300 "new_C.puma" */

                if ( Full ) {
                  Types_GetLwb (t->Array.Index->SimpleType.Type2, &Lwb);
                  LwbExpr = t->Array.Index->SimpleType.Type2->SymSubrange.LwbExpr;
                  UpbExpr = t->Array.Index->SimpleType.Type2->SymSubrange.UpbExpr;

                  WRITESTRING("struct ");
                  WRITEIDENT( t->Array.Type2->SymArray.StructId );
                  WRITESTRING(" {");
		  WRITELN();
                  TAB(2);
                      WRITEBLANKS();
                      CodeType (t->Array.ElemType, Full);
                      WRITESTRING(" ");
                      CodeDecla (t->Array.ElemType, BEFORE);
                      WRITESTRING("A[");
                      if ( UpbExpr->Expr.IsCConst ) {
                        if ( Values_ValueToInt( &Lwb ) != 0 ) {
                          CodeExpr( UpbExpr, MINUS_PREC + 1);
                        } else {
                          CodeExpr( UpbExpr, PLUS_PREC + 1);
                        };
                      } else {
                        CodeValue (t->Array.Index->SimpleType.Type2->SymSubrange.Upb);
                      };
                      if ( Values_ValueToInt( &Lwb ) != 0 ) {
                        WRITESTRING(" - ");
                        if  ( LwbExpr->Expr.IsCConst ) {
                          CodeExpr( LwbExpr, MINUS_PREC );
                        } else {
                          CodeValue( Lwb );
                        };
                      };
                      WRITESTRING(" + 1]");
                      CodeDecla( t->Array.ElemType, AFTER );
                      WRITESTRING(";");
		  WRITELN();
                  DETAB(2);
                  WRITEBLANKS();
                  WRITESTRING("}");
                } else {
                  WRITESTRING("struct ");
                  WRITEIDENT( t->Array.Type2->SymArray.StructId );
                };

  }
  }
END_RULE;
   return;
 }
yyL2:;

/* line 5346 "new_C.puma" */
 {
  tValue Upb;
  {
/* line 5347 "new_C.puma" */
BEGIN_RULE(142);
/* line 5349 "new_C.puma" */
   if (! (t->Array.Index -> SimpleType . Type2 -> Kind == kSymEnumeration)) goto yyL3;
  {
/* line 5350 "new_C.puma" */

/* line 5351 "new_C.puma" */

                if ( Full ) {
                  Types_GetUpb( t->Array.Index->SimpleType.Type2, &Upb );
                  WRITESTRING("struct ");
                  WRITEIDENT( t->Array.Type2->SymArray.StructId );
                  WRITESTRING(" {");
		  WRITELN();
                  TAB(2);
                      WRITEBLANKS();
                      CodeType (t->Array.ElemType, Full);
                      WRITESTRING(" ");
                      CodeDecla (t->Array.ElemType, BEFORE);
                      WRITESTRING("A[");
                      CodeValue (Upb);
                      WRITESTRING(" + 1]");
                      CodeDecla( t->Array.ElemType, AFTER);
                      WRITESTRING(";");
		  WRITELN();
                  DETAB(2);
                  WRITEBLANKS();
                  WRITESTRING("}");
                } else {
                  WRITESTRING("struct ");
                  WRITEIDENT( t->Array.Type2->SymArray.StructId );
                };

  }
  }
END_RULE;
   return;
 }
yyL3:;

/* line 5378 "new_C.puma" */
 {
  tValue Lwb;
  tValue Upb;
  {
/* line 5379 "new_C.puma" */
BEGIN_RULE(143);
/* line 5381 "new_C.puma" */

/* line 5381 "new_C.puma" */

/* line 5382 "new_C.puma" */

                if ( Full ) {
                  Types_GetLwb( t->Array.Index->SimpleType.Type2 , &Lwb);
                  Types_GetUpb( t->Array.Index->SimpleType.Type2 , &Upb);

                  WRITESTRING("struct ");
                  WRITEIDENT( t->Array.Type2->SymArray.StructId );
                  WRITESTRING(" {");
		  WRITELN();
                  TAB(2);
                      WRITEBLANKS();
                      CodeType (t->Array.ElemType, Full);
                      WRITESTRING(" ");
                      CodeDecla (t->Array.ElemType, BEFORE);
                      WRITESTRING("A[");
                      WRITEINT( Values_ValueToInt (&Upb) - Values_ValueToInt (&Lwb) + 1 );
                      WRITESTRING("]");
                      CodeDecla (t->Array.ElemType, AFTER);
                      WRITESTRING(";");
		  WRITELN();
                  DETAB(2);
                  WRITEBLANKS();
                  WRITESTRING("}");
                } else {
                  WRITESTRING("struct ");
                  WRITEIDENT( t->Array.Type2->SymArray.StructId );
                };

  }
END_RULE;
   return;
 }

  case kRecord:
  if (t->Record.Fields->Kind == kNoField) {
/* line 5411 "new_C.puma" */
  {
/* line 5412 "new_C.puma" */
BEGIN_RULE(144);
/* line 5418 "new_C.puma" */

                if ( Full ) {
                  WRITESTRING("struct ");
                  WRITEIDENT( t->Record.Type2->SymRecord.StructId );
                  WRITESTRING(" {");
		  WRITELN();
                  TAB(2);
                      WRITEBLANKS();
                      WRITESTRING("char dummy;");
		  WRITELN();
                  DETAB(2);
                  WRITEBLANKS();
                  WRITESTRING("}");
                } else {
                  WRITESTRING("struct ");
                  WRITEIDENT( t->Record.Type2->SymRecord.StructId );
                };

  }
END_RULE;
   return;

  }
  if (Tree_IsType (t->Record.Fields, kField)) {
/* line 5437 "new_C.puma" */
  {
/* line 5438 "new_C.puma" */
BEGIN_RULE(145);
/* line 5440 "new_C.puma" */

                if ( Full ) {
                  WRITESTRING("struct ");
                  WRITEIDENT( t->Record.Type2->SymRecord.StructId );
                  WRITESTRING(" {");
		  WRITELN();
                  TAB(2);
                      CodeType (t->Record.Fields, Full);
                  DETAB(2);
                  WRITEBLANKS();
                  WRITESTRING("}");
                } else {
                  WRITESTRING("struct ");
                  WRITEIDENT( t->Record.Type2->SymRecord.StructId );
                };

  }
END_RULE;
   return;

  }
  break;
  case kSetType:
/* line 5457 "new_C.puma" */
  {
/* line 5458 "new_C.puma" */
BEGIN_RULE(146);
/* line 5460 "new_C.puma" */
   WRITESTRING ("unsigned long");
  }
END_RULE;
   return;

  case kPointer:
  if (t->Pointer.TargetType->Kind == kTypeId0) {
/* line 5462 "new_C.puma" */
  {
/* line 5463 "new_C.puma" */
BEGIN_RULE(147);
/* line 5465 "new_C.puma" */
   if (! ((Symbols_IsForward (t -> Pointer . TypePos, t->Pointer.TargetType -> TypeId0 . Object)))) goto yyL8;
  {
/* line 5466 "new_C.puma" */

                switch( t->Pointer.TargetType->TypeId0.Type2->Kind ) {
                case kSymRecord :
                  WRITESTRING("struct ");
                  WRITEIDENT( t->Pointer.TargetType->TypeId0.Type2->SymRecord.StructId );
                  break;
                case kSymArray  :
                  WRITESTRING("struct ");
                  WRITEIDENT( t->Pointer.TargetType->TypeId0.Type2->SymArray.StructId );
                  break;
                default         :
                  WRITEIDENT( t->Pointer.TargetType->TypeId0.Object->SymObject.CIdent );
                  ErrorMessage( xxStructTypeReq, xxRestriction, t->Pointer.TargetType->TypeId0.Pos );
                }; 

  }
  }
END_RULE;
   return;
yyL8:;

  }
/* line 5482 "new_C.puma" */
  {
/* line 5483 "new_C.puma" */
BEGIN_RULE(148);
/* line 5485 "new_C.puma" */
   CodeType (t->Pointer.TargetType, Full);
  }
END_RULE;
   return;

  case kProcType:
/* line 5487 "new_C.puma" */
  {
/* line 5488 "new_C.puma" */
BEGIN_RULE(149);
/* line 5490 "new_C.puma" */
   CodeType (t->ProcType.ResultType, Full);
  }
END_RULE;
   return;

  case kEnumeration:
/* line 5492 "new_C.puma" */
  {
/* line 5493 "new_C.puma" */
BEGIN_RULE(150);
/* line 5495 "new_C.puma" */

                if (Types_TypeSize (t->Enumeration.Type2) == 1) {
                  WRITESTRING("unsigned char");
                } else {
                  WRITESTRING("unsigned short");
                };

  }
END_RULE;
   return;

  case kSubrange:
  if (t->Subrange.BaseType->Kind == kVoid) {
/* line 5503 "new_C.puma" */
  {
/* line 5504 "new_C.puma" */
BEGIN_RULE(151);
/* line 5506 "new_C.puma" */
   CodeTypeName (t -> Subrange . Type2 -> SymSubrange . Type);
  }
END_RULE;
   return;

  }
  if (Tree_IsType (t->Subrange.BaseType, kTypeId)) {
/* line 5508 "new_C.puma" */
  {
/* line 5509 "new_C.puma" */
BEGIN_RULE(152);
/* line 5511 "new_C.puma" */
   WRITEIDENT (t->Subrange.BaseType -> TypeId . Object -> SymObject . CIdent);
  }
END_RULE;
   return;

  }
  break;
  case kVoid:
/* line 5513 "new_C.puma" */
  {
/* line 5514 "new_C.puma" */
BEGIN_RULE(153);
/* line 5516 "new_C.puma" */
   WRITESTRING ("void");
  }
END_RULE;
   return;

  case kTypeId:
  case kTypeId0:
  case kTypeId1:
/* line 5518 "new_C.puma" */
  {
/* line 5519 "new_C.puma" */
BEGIN_RULE(154);
/* line 5521 "new_C.puma" */
   WRITEIDENT (t -> TypeId . Object -> SymObject . CIdent);
  }
END_RULE;
   return;

  case kRecordSect:
/* line 5523 "new_C.puma" */
  {
/* line 5524 "new_C.puma" */
BEGIN_RULE(155);
/* line 5526 "new_C.puma" */
   WRITEBLANKS ();
/* line 5527 "new_C.puma" */
   CodeType (t->RecordSect.Type, Full);
/* line 5528 "new_C.puma" */
   WRITESTRING (" ");
/* line 5529 "new_C.puma" */
   CodeIds (t->RecordSect.FieldIds, t->RecordSect.Type);
/* line 5530 "new_C.puma" */
   WRITESTRING (";");
/* line 5531 "new_C.puma" */
   WRITELN ();
/* line 5532 "new_C.puma" */
   CodeType (t->RecordSect.Next, Full);
  }
END_RULE;
   return;

  case kVariantSect:
  if (t->VariantSect.Variants->Kind == kNoVariant) {
  if (t->VariantSect.Else->Kind == kNoField) {
/* line 5534 "new_C.puma" */
  {
/* line 5535 "new_C.puma" */
BEGIN_RULE(156);
/* line 5539 "new_C.puma" */
   CodeType (t->VariantSect.TagField, Full);
/* line 5540 "new_C.puma" */
   WRITEBLANKS ();
/* line 5541 "new_C.puma" */
   WRITESTRING ("union {");
/* line 5542 "new_C.puma" */
   TAB (2);
/* line 5543 "new_C.puma" */
   WRITEBLANKS ();
/* line 5544 "new_C.puma" */
   WRITESTRING ("char dummy;\n");
/* line 5545 "new_C.puma" */
   DETAB (2);
/* line 5546 "new_C.puma" */
   WRITEBLANKS ();
/* line 5547 "new_C.puma" */
   WRITESTRING ("} ");
/* line 5548 "new_C.puma" */
   WRITEIDENT (t -> VariantSect . UnionId);
/* line 5549 "new_C.puma" */
   WRITESTRING (";");
/* line 5550 "new_C.puma" */
   WRITELN ();
/* line 5551 "new_C.puma" */
   CodeType (t->VariantSect.Next, Full);
  }
END_RULE;
   return;

  }
  }
  if (t->VariantSect.Else->Kind == kNoField) {
/* line 5553 "new_C.puma" */
  {
/* line 5554 "new_C.puma" */
BEGIN_RULE(157);
/* line 5556 "new_C.puma" */
   CodeType (t->VariantSect.TagField, Full);
/* line 5557 "new_C.puma" */
   WRITEBLANKS ();
/* line 5558 "new_C.puma" */
   WRITESTRING ("union {\n");
/* line 5559 "new_C.puma" */
   TAB (2);
/* line 5560 "new_C.puma" */
   CodeType (t->VariantSect.Variants, Full);
/* line 5561 "new_C.puma" */
   DETAB (2);
/* line 5562 "new_C.puma" */
   WRITEBLANKS ();
/* line 5563 "new_C.puma" */
   WRITESTRING ("} ");
/* line 5564 "new_C.puma" */
   WRITEIDENT (t -> VariantSect . UnionId);
/* line 5565 "new_C.puma" */
   WRITESTRING (";");
/* line 5566 "new_C.puma" */
   WRITELN ();
/* line 5567 "new_C.puma" */
   CodeType (t->VariantSect.Next, Full);
  }
END_RULE;
   return;

  }
/* line 5569 "new_C.puma" */
  {
/* line 5570 "new_C.puma" */
BEGIN_RULE(158);
/* line 5572 "new_C.puma" */
   CodeType (t->VariantSect.TagField, Full);
/* line 5573 "new_C.puma" */
   WRITEBLANKS ();
/* line 5574 "new_C.puma" */
   WRITESTRING ("union {\n");
/* line 5575 "new_C.puma" */
   TAB (2);
/* line 5576 "new_C.puma" */
   CodeType (t->VariantSect.Variants, Full);
/* line 5577 "new_C.puma" */
   WRITEBLANKS ();
/* line 5578 "new_C.puma" */
   WRITESTRING ("struct {\n");
/* line 5579 "new_C.puma" */
   TAB (2);
/* line 5580 "new_C.puma" */
   CodeType (t->VariantSect.Else, Full);
/* line 5581 "new_C.puma" */
   DETAB (2);
/* line 5582 "new_C.puma" */
   WRITEBLANKS ();
/* line 5583 "new_C.puma" */
   WRITESTRING ("} ");
/* line 5584 "new_C.puma" */
   WRITEIDENT (t -> VariantSect . ElseId);
/* line 5585 "new_C.puma" */
   WRITESTRING (";\n");
/* line 5586 "new_C.puma" */
   DETAB (2);
/* line 5587 "new_C.puma" */
   WRITEBLANKS ();
/* line 5588 "new_C.puma" */
   WRITESTRING ("} ");
/* line 5589 "new_C.puma" */
   WRITEIDENT (t -> VariantSect . UnionId);
/* line 5590 "new_C.puma" */
   WRITESTRING (";\n");
/* line 5591 "new_C.puma" */
   CodeType (t->VariantSect.Next, Full);
  }
END_RULE;
   return;

  case kTagField2:
/* line 5593 "new_C.puma" */
  {
/* line 5594 "new_C.puma" */
BEGIN_RULE(159);
/* line 5596 "new_C.puma" */
   WRITEBLANKS ();
/* line 5597 "new_C.puma" */
   WRITEIDENT (t->TagField2.Type -> TypeId . Object -> SymObject . CIdent);
/* line 5598 "new_C.puma" */
   WRITESTRING (" ");
/* line 5599 "new_C.puma" */
   WRITEIDENT (t -> TagField2 . CIdent);
/* line 5600 "new_C.puma" */
   WRITESTRING (";");
/* line 5601 "new_C.puma" */
   WRITELN ();
  }
END_RULE;
   return;

  case kVariant:
  if (t->Variant.Variant->Kind == kNoField) {
/* line 5603 "new_C.puma" */
  {
/* line 5604 "new_C.puma" */
BEGIN_RULE(160);
/* line 5608 "new_C.puma" */
   WRITEBLANKS ();
/* line 5609 "new_C.puma" */
   WRITESTRING ("struct {\n");
/* line 5610 "new_C.puma" */
   TAB (2);
/* line 5611 "new_C.puma" */
   WRITEBLANKS ();
/* line 5612 "new_C.puma" */
   WRITESTRING ("char dummy;\n");
/* line 5613 "new_C.puma" */
   DETAB (2);
/* line 5614 "new_C.puma" */
   WRITEBLANKS ();
/* line 5615 "new_C.puma" */
   WRITESTRING ("} ");
/* line 5616 "new_C.puma" */
   WRITEIDENT (t -> Variant . StructId);
/* line 5617 "new_C.puma" */
   WRITESTRING (";");
/* line 5618 "new_C.puma" */
   WRITELN ();
/* line 5619 "new_C.puma" */
   CodeType (t->Variant.Next, Full);
  }
END_RULE;
   return;

  }
  if (Tree_IsType (t->Variant.Variant, kField)) {
/* line 5621 "new_C.puma" */
  {
/* line 5622 "new_C.puma" */
BEGIN_RULE(161);
/* line 5624 "new_C.puma" */
   WRITEBLANKS ();
/* line 5625 "new_C.puma" */
   WRITESTRING ("struct {\n");
/* line 5626 "new_C.puma" */
   TAB (2);
/* line 5627 "new_C.puma" */
   CodeType (t->Variant.Variant, Full);
/* line 5628 "new_C.puma" */
   DETAB (2);
/* line 5629 "new_C.puma" */
   WRITEBLANKS ();
/* line 5630 "new_C.puma" */
   WRITESTRING ("} ");
/* line 5631 "new_C.puma" */
   WRITEIDENT (t -> Variant . StructId);
/* line 5632 "new_C.puma" */
   WRITESTRING (";");
/* line 5633 "new_C.puma" */
   WRITELN ();
/* line 5634 "new_C.puma" */
   CodeType (t->Variant.Next, Full);
  }
END_RULE;
   return;

  }
  break;
  }

/* line 5636 "new_C.puma" */
  {
/* line 5637 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeDecla
# if defined __STDC__ | defined __cplusplus
(register tTree t, BOOLEAN Before)
# else
(t, Before)
 register tTree t;
 BOOLEAN Before;
# endif
{
/* line 5644 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kVector) {
/* line 5655 "new_C.puma" */
  {
/* line 5656 "new_C.puma" */
BEGIN_RULE(162);
/* line 5658 "new_C.puma" */
   if (! (Before && (t -> Vector . IsOpen || t->Vector.Config -> Qualid . Object -> SymConfig . IsGeneric || t->Vector.Config -> Qualid . Object -> SymConfig . Len == 0))) goto yyL1;
  {
/* line 5661 "new_C.puma" */
   WRITESTRING ("*");
  }
  }
END_RULE;
   return;
yyL1:;

/* line 5663 "new_C.puma" */
  {
/* line 5664 "new_C.puma" */
BEGIN_RULE(163);
/* line 5666 "new_C.puma" */
   if (! (Before)) goto yyL2;
  }
END_RULE;
   return;
yyL2:;

/* line 5678 "new_C.puma" */
  {
/* line 5679 "new_C.puma" */
BEGIN_RULE(164);
/* line 5681 "new_C.puma" */
   if (! ((t -> Vector . IsOpen || t->Vector.Config -> Qualid . Object -> SymConfig . IsGeneric || (t->Vector.Config -> Qualid . Object -> SymConfig . Len == 0)))) goto yyL3;
  }
END_RULE;
   return;
yyL3:;

/* line 5686 "new_C.puma" */
  {
/* line 5687 "new_C.puma" */
BEGIN_RULE(165);
/* line 5689 "new_C.puma" */
   if (! (! (t -> Vector . IsOpen || t->Vector.Config -> Qualid . Object -> SymConfig . IsGeneric))) goto yyL4;
  {
/* line 5691 "new_C.puma" */
   WRITESTRING ("[");
/* line 5692 "new_C.puma" */
   WRITEINT (t->Vector.Config -> Qualid . Object -> SymConfig . Len);
/* line 5693 "new_C.puma" */
   WRITESTRING ("]");
  }
  }
END_RULE;
   return;
yyL4:;

  }
  if (t->Kind == kPointer) {
/* line 5695 "new_C.puma" */
  {
/* line 5696 "new_C.puma" */
BEGIN_RULE(166);
/* line 5698 "new_C.puma" */
   CodeDecla (t->Pointer.TargetType, Before);
/* line 5699 "new_C.puma" */

                if (Before) {
                  WRITESTRING("*");  ;
                };

  }
END_RULE;
   return;

  }
  if (t->Kind == kProcType) {
/* line 5705 "new_C.puma" */
  {
/* line 5706 "new_C.puma" */
BEGIN_RULE(167);
/* line 5708 "new_C.puma" */

                if (Before) {
		  if (t->ProcType.ResultType->Kind == kVector) WRITESTRING("*");
                  WRITESTRING("(*");
                } else {
                  WRITESTRING(") ARGS((");
                  CodeFormals4 (t->ProcType.FormalTypes);
                  CodeFormalsOpenVector(t->ProcType.FormalTypes, 4);
                  CodeFormalsGenericConfig(t->ProcType.FormalTypes, 4);
                  WRITESTRING("))");
                };

  }
END_RULE;
   return;

  }
/* line 5721 "new_C.puma" */
  {
/* line 5722 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeDeclaFormals
# if defined __STDC__ | defined __cplusplus
(register tTree t, BOOLEAN Before)
# else
(t, Before)
 register tTree t;
 BOOLEAN Before;
# endif
{
/* line 5729 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kVector) {
/* line 5736 "new_C.puma" */
  {
/* line 5737 "new_C.puma" */
BEGIN_RULE(168);
/* line 5739 "new_C.puma" */
   if (! (! Before && (t -> Vector . IsOpen || t->Vector.Config -> Qualid . Object -> SymConfig . IsGeneric))) goto yyL1;
  {
/* line 5741 "new_C.puma" */
   WRITESTRING ("[]");
  }
  }
END_RULE;
   return;
yyL1:;

/* line 5743 "new_C.puma" */
  {
/* line 5744 "new_C.puma" */
BEGIN_RULE(169);
/* line 5746 "new_C.puma" */
   if (! (! Before && ! (t -> Vector . IsOpen || t->Vector.Config -> Qualid . Object -> SymConfig . IsGeneric))) goto yyL2;
  {
/* line 5748 "new_C.puma" */
   WRITESTRING ("[");
/* line 5749 "new_C.puma" */
   WRITEINT (t->Vector.Config -> Qualid . Object -> SymConfig . Len);
/* line 5750 "new_C.puma" */
   WRITESTRING ("]");
  }
  }
END_RULE;
   return;
yyL2:;

  }
/* line 5752 "new_C.puma" */
  {
/* line 5753 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeStruct
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 5760 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kVector) {
/* line 5767 "new_C.puma" */
  {
/* line 5768 "new_C.puma" */
BEGIN_RULE(170);
/* line 5770 "new_C.puma" */
   CodeStruct (t->Vector.Scalar);
  }
END_RULE;
   return;

  }
  if (t->Kind == kArray) {
/* line 5772 "new_C.puma" */
  {
/* line 5773 "new_C.puma" */
BEGIN_RULE(171);
/* line 5775 "new_C.puma" */
   CodeType (t, FULL);
/* line 5776 "new_C.puma" */
   WRITESTRING (";");
/* line 5777 "new_C.puma" */
   WRITELN ();
  }
END_RULE;
   return;

  }
  if (t->Kind == kRecord) {
/* line 5779 "new_C.puma" */
  {
/* line 5780 "new_C.puma" */
BEGIN_RULE(172);
/* line 5782 "new_C.puma" */
   CodeType (t, FULL);
/* line 5783 "new_C.puma" */
   WRITESTRING (";");
/* line 5784 "new_C.puma" */
   WRITELN ();
  }
END_RULE;
   return;

  }
  if (t->Kind == kPointer) {
/* line 5786 "new_C.puma" */
  {
/* line 5787 "new_C.puma" */
BEGIN_RULE(173);
/* line 5789 "new_C.puma" */
   CodeStruct (t->Pointer.TargetType);
  }
END_RULE;
   return;

  }
/* line 5791 "new_C.puma" */
  {
/* line 5792 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeEnums
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 5798 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif


  switch (t->Kind) {
  case kVector:
/* line 5805 "new_C.puma" */
  {
/* line 5806 "new_C.puma" */
BEGIN_RULE(174);
/* line 5808 "new_C.puma" */
   CodeEnums (t->Vector.Scalar);
  }
END_RULE;
   return;

  case kArray:
/* line 5810 "new_C.puma" */
  {
/* line 5811 "new_C.puma" */
BEGIN_RULE(175);
/* line 5813 "new_C.puma" */
   CodeEnums (t->Array.Index);
/* line 5814 "new_C.puma" */
   CodeEnums (t->Array.ElemType);
  }
END_RULE;
   return;

  case kRecord:
/* line 5816 "new_C.puma" */
  {
/* line 5817 "new_C.puma" */
BEGIN_RULE(176);
/* line 5819 "new_C.puma" */
   CodeEnums (t->Record.Fields);
  }
END_RULE;
   return;

  case kSetType:
/* line 5821 "new_C.puma" */
  {
/* line 5822 "new_C.puma" */
BEGIN_RULE(177);
/* line 5824 "new_C.puma" */
   CodeEnums (t->SetType.BaseType);
  }
END_RULE;
   return;

  case kPointer:
/* line 5826 "new_C.puma" */
  {
/* line 5827 "new_C.puma" */
BEGIN_RULE(178);
/* line 5829 "new_C.puma" */
   CodeEnums (t->Pointer.TargetType);
  }
END_RULE;
   return;

  case kEnumeration:
/* line 5831 "new_C.puma" */
  {
/* line 5832 "new_C.puma" */
BEGIN_RULE(179);
/* line 5834 "new_C.puma" */
   CodeEnums (t->Enumeration.EnumIds);
  }
END_RULE;
   return;

  case kRecordSect:
/* line 5836 "new_C.puma" */
  {
/* line 5837 "new_C.puma" */
BEGIN_RULE(180);
/* line 5839 "new_C.puma" */
   CodeEnums (t->RecordSect.Type);
  }
END_RULE;
   return;

  case kVariantSect:
/* line 5841 "new_C.puma" */
  {
/* line 5842 "new_C.puma" */
BEGIN_RULE(181);
/* line 5844 "new_C.puma" */
   CodeEnums (t->VariantSect.Variants);
/* line 5845 "new_C.puma" */
   CodeEnums (t->VariantSect.Else);
/* line 5846 "new_C.puma" */
   CodeEnums (t->VariantSect.Next);
  }
END_RULE;
   return;

  case kVariant:
/* line 5848 "new_C.puma" */
  {
/* line 5849 "new_C.puma" */
BEGIN_RULE(182);
/* line 5851 "new_C.puma" */
   CodeEnums (t->Variant.Variant);
/* line 5852 "new_C.puma" */
   CodeEnums (t->Variant.Next);
  }
END_RULE;
   return;

  case kEnumId:
/* line 5854 "new_C.puma" */
  {
/* line 5855 "new_C.puma" */
BEGIN_RULE(183);
/* line 5857 "new_C.puma" */
   CodeDebugLine (t->EnumId.Pos);
/* line 5858 "new_C.puma" */
   WRITESTRING ("#define ");
/* line 5859 "new_C.puma" */
   WRITEIDENT (t -> EnumId . CIdent);
/* line 5860 "new_C.puma" */
   WRITESTRING (" ");
/* line 5861 "new_C.puma" */
   WRITEINT (t -> EnumId . Object -> SymEnumLiteral . Index);
/* line 5862 "new_C.puma" */
   WRITELN ();
/* line 5863 "new_C.puma" */
   CodeEnums (t->EnumId.Next);
  }
END_RULE;
   return;

  }

/* line 5865 "new_C.puma" */
  {
/* line 5866 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeIds
# if defined __STDC__ | defined __cplusplus
(register tTree t, register tTree ttype)
# else
(t, ttype)
 register tTree t;
 register tTree ttype;
# endif
{
/* line 5872 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kVarId) {
/* line 5884 "new_C.puma" */
  {
/* line 5885 "new_C.puma" */
BEGIN_RULE(184);
/* line 5887 "new_C.puma" */
   CodeDecla (ttype, BEFORE);
/* line 5888 "new_C.puma" */
   WRITEIDENT (t -> VarId . CIdent);
/* line 5889 "new_C.puma" */
   CodeDecla (ttype, AFTER);
/* line 5890 "new_C.puma" */
   CodeSepa (t->VarId.Next);
/* line 5891 "new_C.puma" */
   CodeIds (t->VarId.Next, ttype);
  }
END_RULE;
   return;

  }
  if (t->Kind == kFieldId) {
/* line 5894 "new_C.puma" */
  {
/* line 5895 "new_C.puma" */
BEGIN_RULE(185);
/* line 5897 "new_C.puma" */
   CodeDecla (ttype, BEFORE);
/* line 5898 "new_C.puma" */
   WRITEIDENT (t -> FieldId . CIdent);
/* line 5899 "new_C.puma" */
   CodeDecla (ttype, AFTER);
/* line 5900 "new_C.puma" */
   CodeSepa (t->FieldId.Next);
/* line 5901 "new_C.puma" */
   CodeIds (t->FieldId.Next, ttype);
  }
END_RULE;
   return;

  }
/* line 5903 "new_C.puma" */
  {
/* line 5904 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeProcs
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 5912 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kProc) {
/* line 5919 "new_C.puma" */
 {
  BOOLEAN NewLine;
  {
/* line 5921 "new_C.puma" */
BEGIN_RULE(186);
/* line 5923 "new_C.puma" */

/* line 5924 "new_C.puma" */

                CodeProcs (t->Proc.Decls);

		CodeDebugLine(t->Proc.Pos);
                Parameter_GenParams (t->Proc.VAROpens);
                Parameter_GenParams (t->Proc.ValueOpens);
                Pointer_GenLocalPtrs (t->Proc.LocalPtrs);

                Parameter_VAROpens   = t->Proc.VAROpens;
                Parameter_ValueOpens = t->Proc.ValueOpens;
                Pointer_LocalPtrs    = t->Proc.LocalPtrs;

                if ( !Symbols_IsExported (t->Proc.Object) ) {
                   WRITESTRING("static ");
                };
                CodeType (t->Proc.ResultType, FULL);
                WRITESTRING(" ");
                { if (t->Proc.ResultType->Kind == kVector) { WRITESTRING("*"); } };
                WRITEIDENT( t->Proc.CIdent );
                WRITESTRING("\n#ifdef __STDC__\n(");
                CodeFormals3 (t->Proc.Formals, mVoid(), NoIdent);
                CodeFormalsOpenVector(t->Proc.Formals, 3);
                CodeFormalsGenericConfig(t->Proc.Formals, 3);
                WRITESTRING(")\n#else\n(");
                CodeFormals1 (t->Proc.Formals);
                CodeFormalsOpenVector(t->Proc.Formals, 1);
                CodeFormalsGenericConfig(t->Proc.Formals, 1);
                WRITESTRING(")");
		WRITELN();
                CodeFormals2 (t->Proc.Formals, mVoid(), NoIdent);
                CodeFormalsOpenVector(t->Proc.Formals, 2);
                CodeFormalsGenericConfig(t->Proc.Formals, 2);
                WRITESTRING("#endif\n");
		CodeDebugLine(t->Proc.BeginPos);
		WRITESTRING("{");
		WRITELN();
                TAB(1);
                  ReturnStackPush(t->Proc.Stmts->Stmts.ReturnConfigsOut);
                  DeclarationStackPush(t->Proc.Decls);
                  NewLine =
                    t->Proc.ValueOpens != NoCObjects ||
                    t->Proc.LocalPtrs!= NoCObjects ||
                    t->Proc.Strings != NoStrings  ||
                    t->Proc.Stmts->Stmts.ReturnConfigsOut != NoConfigs;
                  CodeDecls2(t->Proc.Decls, &NewLine);
                  CodeStoreConfigsConnectsPE(t->Proc.Decls);
                  CodeStoreStacksReturnDecl(t->Proc.Stmts->Stmts.ReturnConfigsOut);
                  if (t->Proc.ValueOpens != NoCObjects) {
                     WRITEBLANKS();
                     WRITESTRING("OPEN_ARRAY_LOCALS");
		     WRITELN();
                  };
                  CodePointers (STORAGE_AUTO, t->Proc.LocalPtrs);
                  CodeStrings (t->Proc.Strings);
                  if (NewLine) {
                    WRITELN();
                  };

                  CodeAllocOpenArray(t->Proc.ValueOpens);
                  CodeCopyOpenArray (t->Proc.ValueOpens);

                  CodeStrncpy       (t->Proc.Strings);
                  CodeInitConfigs(t->Proc.Decls);
                  CodeInitConnections(t->Proc.Decls);
                  CodeInitVectorVariables(t->Proc.Decls);
                  CodeInitModules(t->Proc.Decls);
                  CodePushVarPointer(t->Proc.LocalPtrs);  
		  CodeStoreStacksReturnDoit(t->Proc.Stmts->Stmts.ReturnConfigsOut);

                  CodeStmts(t->Proc.Stmts);

                  if (Symbols_GetResultType(Symbols_GetType(t->Proc.Object)) == TypeVoid) {
                    CodePopVarPointer (t->Proc.LocalPtrs);
                    CodeFreeOpenArray (t->Proc.ValueOpens);
                    CodeFreeVectorVariables(t->Proc.Decls);
                    CodeFreeConfigs(t->Proc.Decls);
                    CodeRestoreConfigsConnectsPE(t->Proc.Decls);
                    DeclarationStackPop();
                    ReturnStackPop();
                  } else {
                    
                    if (Options_IsOptionSet(Options_eChecks)) {
                      WRITEBLANKS();
                      WRITESTRING("ReturnError(__FILE__, __LINE__);");
		      WRITELN();
                    };
                  };
                DETAB(1);
                WRITESTRING("}\n");
                WRITELN();

                Parameter_VAROpens   = NoCObjects;
                Parameter_ValueOpens = NoCObjects;
                Pointer_LocalPtrs    = NoCObjects;

/* line 6025 "new_C.puma" */
   CodeProcs (t->Proc.Next);
  }
END_RULE;
   return;
 }

  }
  if (Tree_IsType (t, kDecl)) {
/* line 6027 "new_C.puma" */
  {
/* line 6028 "new_C.puma" */
BEGIN_RULE(187);
/* line 6030 "new_C.puma" */
   CodeProcs (t->Decl.Next);
  }
END_RULE;
   return;

  }
/* line 6032 "new_C.puma" */
  {
/* line 6033 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeFormals1
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 6040 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kFormal) {
/* line 6047 "new_C.puma" */
  {
/* line 6048 "new_C.puma" */
BEGIN_RULE(188);
/* line 6050 "new_C.puma" */
   CodeFormals1 (t->Formal.ParIds);
/* line 6051 "new_C.puma" */
   CodeSepa (t->Formal.Next);
/* line 6052 "new_C.puma" */
   CodeFormals1 (t->Formal.Next);
  }
END_RULE;
   return;

  }
  if (t->Kind == kParId) {
/* line 6054 "new_C.puma" */
  {
/* line 6055 "new_C.puma" */
BEGIN_RULE(189);
/* line 6057 "new_C.puma" */
   if (! ((Symbols_IsOpenArray (t -> ParId . Object)))) goto yyL2;
  {
/* line 6058 "new_C.puma" */
   WRITEIDENT (t -> ParId . CIdent);
/* line 6059 "new_C.puma" */
   WRITESTRING (", ");
/* line 6060 "new_C.puma" */
   WRITEIDENT (Parameter_GetParam (t -> ParId . Object));
/* line 6061 "new_C.puma" */
   CodeSepa (t->ParId.Next);
/* line 6062 "new_C.puma" */
   CodeFormals1 (t->ParId.Next);
  }
  }
END_RULE;
   return;
yyL2:;

/* line 6064 "new_C.puma" */
  {
/* line 6065 "new_C.puma" */
BEGIN_RULE(190);
/* line 6067 "new_C.puma" */
   WRITEIDENT (t -> ParId . CIdent);
/* line 6068 "new_C.puma" */
   CodeSepa (t->ParId.Next);
/* line 6069 "new_C.puma" */
   CodeFormals1 (t->ParId.Next);
  }
END_RULE;
   return;

  }
/* line 6071 "new_C.puma" */
  {
/* line 6072 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeFormals2
# if defined __STDC__ | defined __cplusplus
(register tTree t, register tTree u, register tIdent ElemTypeId)
# else
(t, u, ElemTypeId)
 register tTree t;
 register tTree u;
 register tIdent ElemTypeId;
# endif
{
/* line 6079 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kFormal) {
  if (Tree_IsType (t->Formal.Type, kTypeId)) {
/* line 6089 "new_C.puma" */
  {
/* line 6090 "new_C.puma" */
BEGIN_RULE(191);
/* line 6092 "new_C.puma" */
   if (! ((Code_IsVectorType (t->Formal.Type)))) goto yyL1;
  {
/* line 6093 "new_C.puma" */
   WRITEIDENT (t->Formal.Type -> TypeId . Object -> SymObject . CIdent);
/* line 6094 "new_C.puma" */
   WRITESTRING (" ");
/* line 6095 "new_C.puma" */
   CodeFormals2 (t->Formal.ParIds, t->Formal.Type, NoIdent);
/* line 6096 "new_C.puma" */
   WRITESTRING (";");
/* line 6097 "new_C.puma" */
   WRITELN ();
/* line 6098 "new_C.puma" */
   CodeFormals2 (t->Formal.Next, mVoid (), NoIdent);
  }
  }
END_RULE;
   return;
yyL1:;

/* line 6100 "new_C.puma" */
  {
/* line 6101 "new_C.puma" */
BEGIN_RULE(192);
/* line 6103 "new_C.puma" */
   WRITEIDENT (t->Formal.Type -> TypeId . Object -> SymObject . CIdent);
/* line 6104 "new_C.puma" */
   WRITESTRING (" ");
/* line 6105 "new_C.puma" */
   CodeFormals2 (t->Formal.ParIds, mVoid (), NoIdent);
/* line 6106 "new_C.puma" */
   WRITESTRING (";");
/* line 6107 "new_C.puma" */
   WRITELN ();
/* line 6108 "new_C.puma" */
   CodeFormals2 (t->Formal.Next, mVoid (), NoIdent);
  }
END_RULE;
   return;

  }
  if (t->Formal.Type->Kind == kVector) {
  if (Tree_IsType (t->Formal.Type->Vector.Scalar, kTypeId)) {
/* line 6110 "new_C.puma" */
  {
/* line 6111 "new_C.puma" */
BEGIN_RULE(193);
/* line 6113 "new_C.puma" */
   WRITEIDENT (t->Formal.Type->Vector.Scalar -> TypeId . Object -> SymObject . CIdent);
/* line 6114 "new_C.puma" */
   WRITESTRING (" ");
/* line 6115 "new_C.puma" */
   CodeFormals2 (t->Formal.ParIds, t->Formal.Type, NoIdent);
/* line 6116 "new_C.puma" */
   WRITESTRING (";");
/* line 6117 "new_C.puma" */
   WRITELN ();
/* line 6118 "new_C.puma" */
   CodeFormals2 (t->Formal.Next, mVoid (), NoIdent);
  }
END_RULE;
   return;

  }
  if (t->Formal.Type->Vector.Scalar->Kind == kArray) {
  {BOOLEAN yyT; yyT = TRUE;
  if (equalBOOLEAN (t->Formal.Type->Vector.Scalar->Array.IsOpen, yyT)) {
  if (Tree_IsType (t->Formal.Type->Vector.Scalar->Array.ElemType, kTypeId)) {
/* line 6126 "new_C.puma" */
  {
/* line 6127 "new_C.puma" */
BEGIN_RULE(195);
/* line 6129 "new_C.puma" */
   CodeFormals2 (t->Formal.ParIds, t->Formal.Type, t->Formal.Type->Vector.Scalar->Array.ElemType -> TypeId . Object -> SymObject . CIdent);
/* line 6130 "new_C.puma" */
   CodeFormals2 (t->Formal.Next, mVoid (), NoIdent);
  }
END_RULE;
   return;

  }
  }
  }
  }
  }
  if (t->Formal.Type->Kind == kArray) {
  {BOOLEAN yyT; yyT = TRUE;
  if (equalBOOLEAN (t->Formal.Type->Array.IsOpen, yyT)) {
  if (Tree_IsType (t->Formal.Type->Array.ElemType, kTypeId)) {
/* line 6120 "new_C.puma" */
  {
/* line 6121 "new_C.puma" */
BEGIN_RULE(194);
/* line 6123 "new_C.puma" */
   CodeFormals2 (t->Formal.ParIds, mVoid (), t->Formal.Type->Array.ElemType -> TypeId . Object -> SymObject . CIdent);
/* line 6124 "new_C.puma" */
   CodeFormals2 (t->Formal.Next, mVoid (), NoIdent);
  }
END_RULE;
   return;

  }
  }
  }
  }
  }
  if (t->Kind == kParId) {
/* line 6132 "new_C.puma" */
  {
/* line 6133 "new_C.puma" */
BEGIN_RULE(196);
/* line 6135 "new_C.puma" */
   if (! ((Symbols_IsOpenArray (t -> ParId . Object)))) goto yyL6;
  {
/* line 6136 "new_C.puma" */
   WRITEIDENT (ElemTypeId);
/* line 6137 "new_C.puma" */
   WRITESTRING (" ");
/* line 6138 "new_C.puma" */
   CodeDeclaFormals (u, BEFORE);
/* line 6139 "new_C.puma" */
   WRITEIDENT (t -> ParId . CIdent);
/* line 6140 "new_C.puma" */
   WRITESTRING ("[]");
/* line 6141 "new_C.puma" */
   CodeDeclaFormals (u, AFTER);
/* line 6142 "new_C.puma" */
   WRITESTRING (";");
/* line 6143 "new_C.puma" */
   WRITELN ();
/* line 6144 "new_C.puma" */
   WRITESTRING ("CARDINAL ");
/* line 6145 "new_C.puma" */
   WRITEIDENT (Parameter_GetParam (t -> ParId . Object));
/* line 6146 "new_C.puma" */
   WRITESTRING (";");
/* line 6147 "new_C.puma" */
   WRITELN ();
/* line 6148 "new_C.puma" */
   CodeFormals2 (t->ParId.Next, u, ElemTypeId);
  }
  }
END_RULE;
   return;
yyL6:;

/* line 6150 "new_C.puma" */
  {
/* line 6151 "new_C.puma" */
BEGIN_RULE(197);
/* line 6153 "new_C.puma" */
               if (Symbols_IsVAR(t->ParId.Object) && !Code_IsVectorType(u)) {
                  
                  WRITESTRING("*");
                }

/* line 6158 "new_C.puma" */
   CodeDeclaFormals (u, BEFORE);
/* line 6159 "new_C.puma" */
   WRITEIDENT (t -> ParId . CIdent);
/* line 6160 "new_C.puma" */
   CodeDeclaFormals (u, AFTER);
/* line 6161 "new_C.puma" */
   CodeSepa (t->ParId.Next);
/* line 6162 "new_C.puma" */
   CodeFormals2 (t->ParId.Next, u, ElemTypeId);
  }
END_RULE;
   return;

  }
/* line 6164 "new_C.puma" */
  {
/* line 6165 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeFormals3
# if defined __STDC__ | defined __cplusplus
(register tTree t, register tTree u, register tIdent typeIdent)
# else
(t, u, typeIdent)
 register tTree t;
 register tTree u;
 register tIdent typeIdent;
# endif
{
/* line 6172 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kFormal) {
  if (Tree_IsType (t->Formal.Type, kTypeId)) {
/* line 6182 "new_C.puma" */
  {
/* line 6183 "new_C.puma" */
BEGIN_RULE(198);
/* line 6185 "new_C.puma" */
   if (! (t->Formal.Type -> TypeId . Object -> SymTypeDecl . Type -> Kind == kSymVector)) goto yyL1;
  {
/* line 6186 "new_C.puma" */
   CodeFormals3 (t->Formal.ParIds, t->Formal.Type, t->Formal.Type -> TypeId . Object -> SymObject . CIdent);
/* line 6187 "new_C.puma" */
   CodeSepa (t->Formal.Next);
/* line 6188 "new_C.puma" */
   CodeFormals3 (t->Formal.Next, mVoid (), NoIdent);
  }
  }
END_RULE;
   return;
yyL1:;

/* line 6190 "new_C.puma" */
  {
/* line 6192 "new_C.puma" */
BEGIN_RULE(199);
/* line 6194 "new_C.puma" */
   CodeFormals3 (t->Formal.ParIds, mVoid (), t->Formal.Type -> TypeId . Object -> SymObject . CIdent);
/* line 6195 "new_C.puma" */
   CodeSepa (t->Formal.Next);
/* line 6196 "new_C.puma" */
   CodeFormals3 (t->Formal.Next, mVoid (), NoIdent);
  }
END_RULE;
   return;

  }
  if (t->Formal.Type->Kind == kArray) {
  {BOOLEAN yyT; yyT = TRUE;
  if (equalBOOLEAN (t->Formal.Type->Array.IsOpen, yyT)) {
  if (Tree_IsType (t->Formal.Type->Array.ElemType, kTypeId)) {
/* line 6190 "new_C.puma" */
  {
/* line 6192 "new_C.puma" */
BEGIN_RULE(199);
/* line 6194 "new_C.puma" */
   CodeFormals3 (t->Formal.ParIds, mVoid (), t->Formal.Type->Array.ElemType -> TypeId . Object -> SymObject . CIdent);
/* line 6195 "new_C.puma" */
   CodeSepa (t->Formal.Next);
/* line 6196 "new_C.puma" */
   CodeFormals3 (t->Formal.Next, mVoid (), NoIdent);
  }
END_RULE;
   return;

  }
  }
  }
  }
  if (t->Formal.Type->Kind == kVector) {
  if (Tree_IsType (t->Formal.Type->Vector.Scalar, kTypeId)) {
/* line 6198 "new_C.puma" */
  {
/* line 6200 "new_C.puma" */
BEGIN_RULE(200);
/* line 6202 "new_C.puma" */
   CodeFormals3 (t->Formal.ParIds, t->Formal.Type, t->Formal.Type->Vector.Scalar -> TypeId . Object -> SymObject . CIdent);
/* line 6203 "new_C.puma" */
   CodeSepa (t->Formal.Next);
/* line 6204 "new_C.puma" */
   CodeFormals3 (t->Formal.Next, mVoid (), NoIdent);
  }
END_RULE;
   return;

  }
  if (t->Formal.Type->Vector.Scalar->Kind == kArray) {
  {BOOLEAN yyT; yyT = TRUE;
  if (equalBOOLEAN (t->Formal.Type->Vector.Scalar->Array.IsOpen, yyT)) {
  if (Tree_IsType (t->Formal.Type->Vector.Scalar->Array.ElemType, kTypeId)) {
/* line 6198 "new_C.puma" */
  {
/* line 6200 "new_C.puma" */
BEGIN_RULE(200);
/* line 6202 "new_C.puma" */
   CodeFormals3 (t->Formal.ParIds, t->Formal.Type, t->Formal.Type->Vector.Scalar->Array.ElemType -> TypeId . Object -> SymObject . CIdent);
/* line 6203 "new_C.puma" */
   CodeSepa (t->Formal.Next);
/* line 6204 "new_C.puma" */
   CodeFormals3 (t->Formal.Next, mVoid (), NoIdent);
  }
END_RULE;
   return;

  }
  }
  }
  }
  }
  }
  if (t->Kind == kParId) {
/* line 6206 "new_C.puma" */
  {
/* line 6207 "new_C.puma" */
BEGIN_RULE(201);
/* line 6209 "new_C.puma" */
   if (! ((Symbols_IsOpenArray (t -> ParId . Object)))) goto yyL6;
  {
/* line 6210 "new_C.puma" */
   WRITEIDENT (typeIdent);
/* line 6211 "new_C.puma" */
   WRITESTRING (" ");
/* line 6212 "new_C.puma" */
   CodeDeclaFormals (u, BEFORE);
/* line 6213 "new_C.puma" */
   WRITEIDENT (t -> ParId . CIdent);
/* line 6214 "new_C.puma" */
   WRITESTRING ("[]");
/* line 6215 "new_C.puma" */
   CodeDeclaFormals (u, AFTER);
/* line 6216 "new_C.puma" */
   WRITESTRING (", ");
/* line 6217 "new_C.puma" */
   WRITESTRING ("CARDINAL ");
/* line 6218 "new_C.puma" */
   WRITEIDENT (Parameter_GetParam (t -> ParId . Object));
/* line 6219 "new_C.puma" */
   CodeSepa (t->ParId.Next);
/* line 6220 "new_C.puma" */
   CodeFormals3 (t->ParId.Next, u, typeIdent);
  }
  }
END_RULE;
   return;
yyL6:;

/* line 6222 "new_C.puma" */
  {
/* line 6223 "new_C.puma" */
BEGIN_RULE(202);
/* line 6225 "new_C.puma" */
   WRITEIDENT (typeIdent);
/* line 6226 "new_C.puma" */
               if (Symbols_IsVAR(t->ParId.Object) && !Code_IsVectorType(u)) {
                  
                  WRITESTRING(" *");
                } else {
                  WRITESTRING(" ");
                };

/* line 6233 "new_C.puma" */
   CodeDeclaFormals (u, BEFORE);
/* line 6234 "new_C.puma" */
   WRITEIDENT (t -> ParId . CIdent);
/* line 6235 "new_C.puma" */
   CodeDeclaFormals (u, AFTER);
/* line 6236 "new_C.puma" */
   CodeSepa (t->ParId.Next);
/* line 6237 "new_C.puma" */
   CodeFormals3 (t->ParId.Next, u, typeIdent);
  }
END_RULE;
   return;

  }
/* line 6239 "new_C.puma" */
  {
/* line 6240 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeFormals4
# if defined __STDC__ | defined __cplusplus
(register tTree yyP3)
# else
(yyP3)
 register tTree yyP3;
# endif
{
/* line 6246 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (yyP3->Kind == kFormalType) {
/* line 6253 "new_C.puma" */
  {
/* line 6254 "new_C.puma" */
BEGIN_RULE(203);
/* line 6256 "new_C.puma" */
   CodeType (yyP3->FormalType.Type, FULL);
/* line 6257 "new_C.puma" */

                if (yyP3->FormalType.IsVAR && !Code_IsVectorType(yyP3->FormalType.Type)) {
                  
                  WRITESTRING(" *");
                }
                if (yyP3->FormalType.Type->Kind == kVector) {
                  WRITESTRING(" *");
                }

/* line 6266 "new_C.puma" */
   CodeSepa (yyP3->FormalType.Next);
/* line 6267 "new_C.puma" */
   CodeFormals4 (yyP3->FormalType.Next);
  }
END_RULE;
   return;

  }
/* line 6269 "new_C.puma" */
  {
/* line 6270 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeFormalsOpenVector
# if defined __STDC__ | defined __cplusplus
(register tTree yyP4, ULONG ParamKind)
# else
(yyP4, ParamKind)
 register tTree yyP4;
 ULONG ParamKind;
# endif
{
/* line 6276 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (yyP4->Kind == kFormal) {
/* line 6283 "new_C.puma" */
  {
/* line 6284 "new_C.puma" */
BEGIN_RULE(204);
/* line 6286 "new_C.puma" */
   if (! ((yyP4->Formal.Type -> Kind == kVector && yyP4->Formal.Type -> Vector . IsOpen) || (Tree_IsType (yyP4->Formal.Type, kTypeId) && yyP4->Formal.Type -> TypeId . Object -> SymTypeDecl . Type -> Kind == kSymVector && yyP4->Formal.Type -> TypeId . Object -> SymTypeDecl . Type -> SymVector . IsOpen))) goto yyL1;
  {
/* line 6290 "new_C.puma" */

                switch (ParamKind) {
                case 1: WRITESTRING(", OPEN_VECTOR");                break;
                case 2: WRITESTRING("CONFIGURATION OPEN_VECTOR;\n"); break;
                case 3: WRITESTRING(", CONFIGURATION OPEN_VECTOR");  break;
                case 4: WRITESTRING(", CONFIGURATION");              break;
                }

  }
  }
END_RULE;
   return;
yyL1:;

/* line 6299 "new_C.puma" */
  {
/* line 6300 "new_C.puma" */
BEGIN_RULE(205);
/* line 6302 "new_C.puma" */
   CodeFormalsOpenVector (yyP4->Formal.Next, ParamKind);
  }
END_RULE;
   return;

  }
/* line 6304 "new_C.puma" */
  {
/* line 6305 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeFormalsGenericConfig
# if defined __STDC__ | defined __cplusplus
(register tTree yyP5, ULONG ParamKind)
# else
(yyP5, ParamKind)
 register tTree yyP5;
 ULONG ParamKind;
# endif
{
/* line 6311 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (yyP5->Kind == kFormalType) {
/* line 6318 "new_C.puma" */
  {
/* line 6320 "new_C.puma" */
BEGIN_RULE(206);
/* line 6326 "new_C.puma" */
   if (! ((yyP5->FormalType.Type -> Kind == kVector && yyP5->FormalType.Type -> Vector . Config -> Qualid . Object -> Kind == kSymConfig && (yyP5->FormalType.Type -> Vector . Config -> Qualid . Object -> SymConfig . IsGeneric || yyP5->FormalType.Type -> Vector . Config -> Qualid . Object -> SymConfig . IsRespecified)) || (Tree_IsType (yyP5->FormalType.Type, kTypeId) && yyP5->FormalType.Type -> TypeId . Object -> SymTypeDecl . Type -> Kind == kSymVector && (yyP5->FormalType.Type -> TypeId . Object -> SymTypeDecl . Type -> SymVector . Config -> SymConfig . IsGeneric || yyP5->FormalType.Type -> TypeId . Object -> SymTypeDecl . Type -> SymVector . Config -> SymConfig . IsRespecified)))) goto yyL1;
  {
/* line 6331 "new_C.puma" */

                switch (ParamKind) {
                case 1:
                  WRITESTRING(", GENERIC_CONFIGURATION");                break;
                case 2:
                  WRITESTRING("CONFIGURATION GENERIC_CONFIGURATION;\n"); break;
                case 3:
                  WRITESTRING(", CONFIGURATION GENERIC_CONFIGURATION");  break;
                case 4:
                  WRITESTRING(", CONFIGURATION");                        break;
                }

  }
  }
END_RULE;
   return;
yyL1:;

/* line 6344 "new_C.puma" */
  {
/* line 6346 "new_C.puma" */
BEGIN_RULE(207);
/* line 6348 "new_C.puma" */
   CodeFormalsGenericConfig (yyP5->FormalType.Next, ParamKind);
  }
END_RULE;
   return;

  }
  if (yyP5->Kind == kFormal) {
/* line 6318 "new_C.puma" */
  {
/* line 6320 "new_C.puma" */
BEGIN_RULE(206);
/* line 6326 "new_C.puma" */
   if (! ((yyP5->Formal.Type -> Kind == kVector && yyP5->Formal.Type -> Vector . Config -> Qualid . Object -> Kind == kSymConfig && (yyP5->Formal.Type -> Vector . Config -> Qualid . Object -> SymConfig . IsGeneric || yyP5->Formal.Type -> Vector . Config -> Qualid . Object -> SymConfig . IsRespecified)) || (Tree_IsType (yyP5->Formal.Type, kTypeId) && yyP5->Formal.Type -> TypeId . Object -> SymTypeDecl . Type -> Kind == kSymVector && (yyP5->Formal.Type -> TypeId . Object -> SymTypeDecl . Type -> SymVector . Config -> SymConfig . IsGeneric || yyP5->Formal.Type -> TypeId . Object -> SymTypeDecl . Type -> SymVector . Config -> SymConfig . IsRespecified)))) goto yyL2;
  {
/* line 6331 "new_C.puma" */

                switch (ParamKind) {
                case 1:
                  WRITESTRING(", GENERIC_CONFIGURATION");                break;
                case 2:
                  WRITESTRING("CONFIGURATION GENERIC_CONFIGURATION;\n"); break;
                case 3:
                  WRITESTRING(", CONFIGURATION GENERIC_CONFIGURATION");  break;
                case 4:
                  WRITESTRING(", CONFIGURATION");                        break;
                }

  }
  }
END_RULE;
   return;
yyL2:;

/* line 6344 "new_C.puma" */
  {
/* line 6346 "new_C.puma" */
BEGIN_RULE(207);
/* line 6348 "new_C.puma" */
   CodeFormalsGenericConfig (yyP5->Formal.Next, ParamKind);
  }
END_RULE;
   return;

  }
/* line 6350 "new_C.puma" */
  {
/* line 6351 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeDecls2
# if defined __STDC__ | defined __cplusplus
(register tTree yyP6, BOOLEAN * NewLine)
# else
(yyP6, NewLine)
 register tTree yyP6;
 BOOLEAN * NewLine;
# endif
{
/* line 6359 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (yyP6->Kind == kVar) {
/* line 6369 "new_C.puma" */
  {
/* line 6370 "new_C.puma" */
BEGIN_RULE(208);
/* line 6372 "new_C.puma" */
   WRITEBLANKS ();
/* line 6373 "new_C.puma" */
   CodeType (yyP6->Var.Type, NONFULL);
/* line 6374 "new_C.puma" */
   WRITESTRING (" ");
/* line 6375 "new_C.puma" */
   CodeIds (yyP6->Var.VarIds, yyP6->Var.Type);
/* line 6376 "new_C.puma" */
   WRITESTRING (";");
/* line 6377 "new_C.puma" */
   WRITELN ();
/* line 6378 "new_C.puma" */
   if (! ((* NewLine) = TRUE)) goto yyL1;
  {
/* line 6379 "new_C.puma" */
 CodeDecls2 (yyP6->Var.Next, &(* NewLine)); 
  }
  }
    beginBOOLEAN (* NewLine)
END_RULE;
   return;
yyL1:;

  }
  if (Tree_IsType (yyP6, kDecl)) {
/* line 6381 "new_C.puma" */
  {
/* line 6382 "new_C.puma" */
BEGIN_RULE(209);
/* line 6384 "new_C.puma" */
 CodeDecls2 (yyP6->Decl.Next, &(* NewLine)); 
  }
    beginBOOLEAN (* NewLine)
END_RULE;
   return;

  }
/* line 6386 "new_C.puma" */
  {
/* line 6387 "new_C.puma" */

END_RULE;
return;
  }
    beginBOOLEAN (* NewLine)
END_RULE;
   return;

;
}

static void CodeExpr
# if defined __STDC__ | defined __cplusplus
(register tTree t, ULONG Prec)
# else
(t, Prec)
 register tTree t;
 ULONG Prec;
# endif
{
/* line 6394 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif


  switch (t->Kind) {
  case kBinary:
/* line 6407 "new_C.puma" */
  {
/* line 6408 "new_C.puma" */
BEGIN_RULE(210);
/* line 6412 "new_C.puma" */
   if (! (Symbols_IsStringType (t->Binary.Lop -> Expr . Type) && Symbols_IsStringType (t->Binary.Rop -> Expr . Type) && (t -> Binary . COperator == Code_NotEqual || t -> Binary . COperator == Code_Less || t -> Binary . COperator == Code_LessEqual || t -> Binary . COperator == Code_Equal || t -> Binary . COperator == Code_Greater || t -> Binary . COperator == Code_GreaterEqual || t -> Binary . COperator == Code_In))) goto yyL1;
  {
/* line 6420 "new_C.puma" */

                if (t->Binary.COperator == Code_In) {
                  WRITESTRING("(strstr(");
                  CodeString3(t->Binary.Rop);
                  WRITESTRING(", ");
                  CodeString3(t->Binary.Lop);
                  WRITESTRING(") != NULL)");
                } else {
                  WRITESTRING("(strcmp(");
                  CodeString3(t->Binary.Lop);
                  WRITESTRING(", ");
                  CodeString3(t->Binary.Rop);
                  WRITESTRING(")");
                  switch (t->Binary.COperator) {
                  case Code_NotEqual     : WRITESTRING(" != "); break;
                  case Code_Less         : WRITESTRING(" < ");  break;
                  case Code_LessEqual    : WRITESTRING(" <= "); break;
                  case Code_Equal        : WRITESTRING(" == "); break;
                  case Code_Greater      : WRITESTRING(" > ");  break;
                  case Code_GreaterEqual : WRITESTRING(" >= "); break;
                  };
                  WRITESTRING("0)");
                }

  }
  }
END_RULE;
   return;
yyL1:;

/* line 6447 "new_C.puma" */
  {
/* line 6448 "new_C.puma" */
BEGIN_RULE(211);
/* line 6452 "new_C.puma" */
   if (! ((t -> Binary . COperator == Code_Equal || t -> Binary . COperator == Code_NotEqual) && (t->Binary.Lop -> Expr . Type -> Kind == kSymRecord || t->Binary.Lop -> Expr . Type -> Kind == kSymArray || ((t->Binary.Lop -> Expr . Type -> Kind == kSymVector) && (t->Binary.Lop -> Expr . Type -> SymVector . Type -> Kind == kSymRecord || t->Binary.Lop -> Expr . Type -> SymVector . Type -> Kind == kSymArray))))) goto yyL2;
  {
/* line 6458 "new_C.puma" */
   WRITESTRING ("(memcmp(&(");
/* line 6459 "new_C.puma" */
   CodeExprWrite (t->Binary.Lop, PASSVALUE_PREC);
/* line 6460 "new_C.puma" */
   WRITESTRING ("), &(");
/* line 6461 "new_C.puma" */
   CodeExprWrite (t->Binary.Rop, PASSVALUE_PREC);
/* line 6462 "new_C.puma" */
   WRITESTRING ("), sizeof(");
/* line 6463 "new_C.puma" */
   CodeExprWrite (t->Binary.Lop, PASSVALUE_PREC);
/* line 6464 "new_C.puma" */
   WRITESTRING ("))");
/* line 6465 "new_C.puma" */

                if (t->Binary.COperator == Code_Equal) {
                  WRITESTRING(" == ");
                } else {
                  WRITESTRING(" != ");
                }

/* line 6472 "new_C.puma" */
   WRITESTRING (" 0)");
  }
  }
END_RULE;
   return;
yyL2:;

/* line 6474 "new_C.puma" */
  {
/* line 6475 "new_C.puma" */
BEGIN_RULE(212);
/* line 6478 "new_C.puma" */
   if (! (t -> Binary . COperator == Code_Mod && t->Binary.Lop -> Expr . IsCConst && t->Binary.Rop -> Expr . IsCConst)) goto yyL3;
  {
/* line 6479 "new_C.puma" */
   WRITESTRING ("MOD(");
/* line 6480 "new_C.puma" */
   CodeExprWrite (t->Binary.Lop, PASSVALUE_PREC);
/* line 6481 "new_C.puma" */
   WRITESTRING (", ");
/* line 6482 "new_C.puma" */
   CodeExprWrite (t->Binary.Rop, PASSVALUE_PREC);
/* line 6483 "new_C.puma" */
   WRITESTRING (")");
  }
  }
END_RULE;
   return;
yyL3:;

/* line 6485 "new_C.puma" */
  {
/* line 6486 "new_C.puma" */
BEGIN_RULE(213);
/* line 6488 "new_C.puma" */
   if (! (t -> Binary . COperator == Code_Mod)) goto yyL4;
  {
/* line 6489 "new_C.puma" */
   WRITESTRING ("MOD1(");
/* line 6490 "new_C.puma" */
   CodeExprWrite (t->Binary.Lop, PASSVALUE_PREC);
/* line 6491 "new_C.puma" */
   WRITESTRING (", ");
/* line 6492 "new_C.puma" */
   CodeExprWrite (t->Binary.Rop, PASSVALUE_PREC);
/* line 6493 "new_C.puma" */
   WRITESTRING (")");
  }
  }
END_RULE;
   return;
yyL4:;

/* line 6495 "new_C.puma" */
  {
/* line 6496 "new_C.puma" */
BEGIN_RULE(214);
/* line 6499 "new_C.puma" */
   if (! (((t -> Binary . COperator == Code_In) || (t -> Binary . COperator == Code_Difference) || (t -> Binary . COperator == Code_IsSubset1) || (t -> Binary . COperator == Code_IsSubset2)))) goto yyL5;
  {
/* line 6503 "new_C.puma" */

                switch ( t->Binary.COperator ) {
                case Code_In        : WRITESTRING("IN");             break;
                case Code_Difference: WRITESTRING("SET_DIFF");       break;
                case Code_IsSubset1 : WRITESTRING("SET_IS_SUBSET1"); break;
                case Code_IsSubset2 : WRITESTRING("SET_IS_SUBSET2"); break;
                };

/* line 6511 "new_C.puma" */
   WRITESTRING ("(");
/* line 6512 "new_C.puma" */
   CodeExprWrite (t->Binary.Lop, PASSVALUE_PREC);
/* line 6513 "new_C.puma" */
   WRITESTRING (", ");
/* line 6514 "new_C.puma" */
   CodeExprWrite (t->Binary.Rop, PASSVALUE_PREC);
/* line 6515 "new_C.puma" */
   WRITESTRING (")");
  }
  }
END_RULE;
   return;
yyL5:;

/* line 6517 "new_C.puma" */
  {
/* line 6518 "new_C.puma" */
BEGIN_RULE(215);
/* line 6522 "new_C.puma" */
   if (! (t -> Binary . COperator == Code_Power && Symbols_IsIntType (t->Binary.Lop -> Expr . Type) && Symbols_IsIntType (t->Binary.Rop -> Expr . Type))) goto yyL6;
  {
/* line 6524 "new_C.puma" */
   WRITESTRING ("((INTEGER) pow((double) ");
/* line 6525 "new_C.puma" */
   CodeExprWrite (t->Binary.Lop, CAST_PREC);
/* line 6526 "new_C.puma" */
   WRITESTRING (", (double) ");
/* line 6527 "new_C.puma" */
   CodeExprWrite (t->Binary.Rop, CAST_PREC);
/* line 6528 "new_C.puma" */
   WRITESTRING ("))");
  }
  }
END_RULE;
   return;
yyL6:;

/* line 6530 "new_C.puma" */
  {
/* line 6531 "new_C.puma" */
BEGIN_RULE(216);
/* line 6534 "new_C.puma" */
   if (! ((t -> Binary . COperator == Code_Power))) goto yyL7;
  {
/* line 6535 "new_C.puma" */
   WRITESTRING ("pow((double) ");
/* line 6536 "new_C.puma" */
   CodeExprWrite (t->Binary.Lop, CAST_PREC);
/* line 6537 "new_C.puma" */
   WRITESTRING (", (double) ");
/* line 6538 "new_C.puma" */
   CodeExprWrite (t->Binary.Rop, CAST_PREC);
/* line 6539 "new_C.puma" */
   WRITESTRING (")");
  }
  }
END_RULE;
   return;
yyL7:;

/* line 6541 "new_C.puma" */
  {
/* line 6542 "new_C.puma" */
BEGIN_RULE(217);
/* line 6545 "new_C.puma" */
   if (! ((((t -> Binary . COperator == Code_Plus) || (t -> Binary . COperator == Code_Minus)) && (t->Binary.Lop -> Expr . Type == TypeADDRESS) && (t->Binary.Rop -> Expr . Type == TypeADDRESS)))) goto yyL8;
  {
/* line 6549 "new_C.puma" */

                if ( Prec <= precedence [t->Binary.COperator] ) {
                  WRITESTRING("(");
                };
                CodeExprWrite(t->Binary.Lop, precedence [t->Binary.COperator] + 1);
                if ( t->Binary.COperator == Code_Plus ) {
                  WRITESTRING(" + ");
                } else {
                  WRITESTRING(" - ");
                };
                WRITESTRING("(CARDINAL)");
                CodeExprWrite( t->Binary.Rop, CAST_PREC );
                if ( Prec <= precedence [t->Binary.COperator] ) {
                  WRITESTRING(")");
                };

  }
  }
END_RULE;
   return;
yyL8:;

/* line 6566 "new_C.puma" */
  {
/* line 6567 "new_C.puma" */
BEGIN_RULE(218);
/* line 6570 "new_C.puma" */
   if (! (((t -> Binary . COperator == Code_Minus) && ! (t->Binary.Lop -> Expr . Type == TypeADDRESS) && (t->Binary.Rop -> Expr . Type == TypeADDRESS)))) goto yyL9;
  {
/* line 6573 "new_C.puma" */

                if ( Prec < CAST_PREC ) {
                   WRITESTRING("(");
                };
                WRITESTRING("(ADDRESS)(");
                CodeExprWrite(t->Binary.Lop, MINUS_PREC + 1);
                WRITESTRING(" - (CARDINAL)");
                CodeExprWrite(t->Binary.Rop, CAST_PREC);
                WRITESTRING(")");
                if ( Prec < CAST_PREC ) {
                   WRITESTRING(")");
                };

  }
  }
END_RULE;
   return;
yyL9:;

/* line 6587 "new_C.puma" */
  {
/* line 6588 "new_C.puma" */
BEGIN_RULE(219);
/* line 6591 "new_C.puma" */
   if (! ((((t -> Binary . COperator == Code_Times) || (t -> Binary . COperator == Code_Divide)) && ((t->Binary.Lop -> Expr . Type == TypeADDRESS) || (t->Binary.Rop -> Expr . Type == TypeADDRESS))))) goto yyL10;
  {
/* line 6595 "new_C.puma" */

                if ( Prec < CAST_PREC ) {
                   WRITESTRING("(");
                };
                WRITESTRING("(ADDRESS)(");
                if ( t->Binary.Lop->Expr.Type == TypeADDRESS ) {
                  WRITESTRING("(CARDINAL)");
                  CodeExprWrite(t->Binary.Lop, CAST_PREC );
                } else {
                  CodeExprWrite(t->Binary.Lop, precedence [t->Binary.COperator] + 1);
                };
                if ( t->Binary.COperator == Code_Times ) {
                  WRITESTRING(" * ");
                } else {
                  WRITESTRING(" / ");
                };
                if ( t->Binary.Rop->Expr.Type == TypeADDRESS ) {
                  WRITESTRING("(CARDINAL)");
                  CodeExprWrite(t->Binary.Rop, CAST_PREC);
                } else {
                  CodeExprWrite(t->Binary.Rop, precedence [t->Binary.COperator]);
                };
                WRITESTRING(")");
                if ( Prec < CAST_PREC ) {
                  WRITESTRING(")");
                };

  }
  }
END_RULE;
   return;
yyL10:;

/* line 6623 "new_C.puma" */
  {
/* line 6624 "new_C.puma" */
BEGIN_RULE(220);
/* line 6628 "new_C.puma" */
   if (! ((((Symbols_IsINTEGER (t->Binary.Lop -> Expr . Type) && Symbols_IsCARDINAL (t->Binary.Rop -> Expr . Type)) || (Symbols_IsCARDINAL (t->Binary.Lop -> Expr . Type) && Symbols_IsINTEGER (t->Binary.Rop -> Expr . Type))) && (t -> Binary . COperator == Code_Less || t -> Binary . COperator == Code_LessEqual || t -> Binary . COperator == Code_Greater || t -> Binary . COperator == Code_GreaterEqual)))) goto yyL11;
  {
/* line 6636 "new_C.puma" */

                if (Prec <= precedence[t->Binary.COperator]) {
                  WRITESTRING("(");
                };
                if (Symbols_IsCARDINAL(t->Binary.Lop->Expr.Type)) {
                  WRITESTRING("((INTEGER) ");
                  CodeExprWrite(t->Binary.Lop, CAST_PREC);
                  WRITESTRING(")");
                } else {
                  CodeExprWrite(t->Binary.Lop, precedence [t->Binary.COperator] + 1);
                }
                
                switch (t->Binary.COperator) {
                   case Code_Less         : WRITESTRING(" < ");  break;
                   case Code_LessEqual    : WRITESTRING(" <= "); break;
                   case Code_Greater      : WRITESTRING(" > ");  break;
                   case Code_GreaterEqual : WRITESTRING(" >= "); break;
                };
                if (Symbols_IsCARDINAL(t->Binary.Rop->Expr.Type)) {
                  WRITESTRING("((INTEGER) ");
                  CodeExprWrite(t->Binary.Rop, CAST_PREC);
                  WRITESTRING(")");
                } else {
                  CodeExprWrite(t->Binary.Rop, precedence [t->Binary.COperator]);
                }
                if (Prec <= precedence[t->Binary.COperator]) {
                  WRITESTRING(")");
                };

  }
  }
END_RULE;
   return;
yyL11:;

/* line 6670 "new_C.puma" */
  {
/* line 6671 "new_C.puma" */
BEGIN_RULE(221);
/* line 6673 "new_C.puma" */

                if  ( Prec <= precedence [t->Binary.COperator] ) {
                  WRITESTRING("(");
                };
                CodeExprWrite(t->Binary.Lop, precedence [t->Binary.COperator] + 1);
                
                switch (t->Binary.COperator) {
                   case Code_NotEqual     : WRITESTRING(" != "); break;
                   case Code_Times        : WRITESTRING(" * ");  break;
                   case Code_Plus         : WRITESTRING(" + ");  break;
                   case Code_Minus        : WRITESTRING(" - ");  break;
                   case Code_Divide       : WRITESTRING(" / ");  break;
                   case Code_Less         : WRITESTRING(" < ");  break;
                   case Code_LessEqual    : WRITESTRING(" <= "); break;
                   case Code_Equal        : WRITESTRING(" == "); break;
                   case Code_Greater      : WRITESTRING(" > ");  break;
                   case Code_GreaterEqual : WRITESTRING(" >= "); break;
                   case Code_And          : WRITESTRING(" && "); break;
                   case Code_Mod          : WRITESTRING(" %% "); break;
                   case Code_Or           : WRITESTRING(" || "); break;
                   case Code_Union        : WRITESTRING(" | ");  break;
                   case Code_Intersection : WRITESTRING(" & ");  break;
                   case Code_SymDiff      : WRITESTRING(" ^ ");  break;
                };
                CodeExprWrite(t->Binary.Rop, precedence [t->Binary.COperator]);
                if ( Prec <= precedence [t->Binary.COperator] ) {
                  WRITESTRING(")");
                };

  }
END_RULE;
   return;

  case kUnary:
  if (t->Unary.Mop->Kind == kIntConst) {
/* line 6707 "new_C.puma" */
  {
/* line 6708 "new_C.puma" */
BEGIN_RULE(222);
/* line 6710 "new_C.puma" */
   if (! (t -> Unary . COperator == Code_Minus)) goto yyL13;
  {
/* line 6711 "new_C.puma" */

                switch (t->Unary.Mop->IntConst.Kind) {
                case IntDecimal    :
                  WRITESTRING("-");
                  WRITECARD(t->Unary.Mop->IntConst.IntVal);
                  break;
                case IntOctal      :
                  WRITESTRING("-0");
                  WRITEOCT(t->Unary.Mop->IntConst.IntVal);
                  break;
                case IntHexadecimal:
                  WRITESTRING("-0X");
                  WRITEHEX(t->Unary.Mop->IntConst.IntVal);
                  break;
                };

  }
  }
END_RULE;
   return;
yyL13:;

  }
/* line 6728 "new_C.puma" */
  {
/* line 6729 "new_C.puma" */
BEGIN_RULE(223);
/* line 6731 "new_C.puma" */

                if ( Prec < precedence [t->Unary.COperator] ) {
                   WRITESTRING("(");
                };
                switch (t->Unary.COperator) {
                case Code_Minus: WRITESTRING("-"); break;
                case Code_Not  : WRITESTRING("!"); break;
                };
                CodeExprWrite( t->Unary.Mop, precedence [t->Unary.COperator] );
                if ( Prec < precedence [t->Unary.COperator] ) {
                  WRITESTRING(")");
                };

  }
END_RULE;
   return;

  case kIntConst:
/* line 6745 "new_C.puma" */
  {
/* line 6746 "new_C.puma" */
BEGIN_RULE(224);
/* line 6748 "new_C.puma" */

                if (t->IntConst.IntVal > MAXLONG) {
                  WRITESTRING("(CARDINAL)");
                  ErrorMessage(xxOutOfLongRange, xxWarning, t->IntConst.Pos);
                };
                switch (t->IntConst.Kind) {
                case IntDecimal    :
                  WRITECARD(t->IntConst.IntVal);
                  break;
                case IntOctal      :
                  WRITESTRING("0");
                  WRITEOCT(t->IntConst.IntVal);
                  break;
                case IntHexadecimal:
                  WRITESTRING("0X");
                  WRITEHEX( t->IntConst.IntVal );
                  break;
                };

  }
END_RULE;
   return;

  case kRealConst:
/* line 6768 "new_C.puma" */
  {
/* line 6769 "new_C.puma" */
BEGIN_RULE(225);
/* line 6771 "new_C.puma" */
   CodeConstReal (t->RealConst.RealVal);
  }
END_RULE;
   return;

  case kStringConst:
/* line 6773 "new_C.puma" */
  {
/* line 6774 "new_C.puma" */
BEGIN_RULE(226);
/* line 6776 "new_C.puma" */
   if (! (LengthSt (t->StringConst.StringVal) == 1)) goto yyL17;
  {
/* line 6777 "new_C.puma" */
   CodeConstStringChar (t->StringConst.StringVal);
  }
  }
END_RULE;
   return;
yyL17:;

/* line 6779 "new_C.puma" */
  {
/* line 6780 "new_C.puma" */
BEGIN_RULE(227);
/* line 6782 "new_C.puma" */
   CodeConstString (t->StringConst.StringVal);
  }
END_RULE;
   return;

  case kCharConst:
/* line 6784 "new_C.puma" */
  {
/* line 6785 "new_C.puma" */
BEGIN_RULE(228);
/* line 6787 "new_C.puma" */
   CodeChar (t->CharConst.CharVal);
  }
END_RULE;
   return;

  case kFuncCall:
/* line 6789 "new_C.puma" */
  {
/* line 6790 "new_C.puma" */
BEGIN_RULE(229);
/* line 6792 "new_C.puma" */
   if (! (t->FuncCall.Designator -> Designator . Type -> Kind == kSymStdProcType)) goto yyL20;
  {
/* line 6793 "new_C.puma" */
   CodeStdProc (t->FuncCall.Actuals, t->FuncCall.Designator -> Designator . Type -> SymStdProcType . StdProc, NoObject);
  }
  }
END_RULE;
   return;
yyL20:;

  if (Tree_IsType (t->FuncCall.Designator, kQualid)) {
/* line 6795 "new_C.puma" */
  {
/* line 6796 "new_C.puma" */
BEGIN_RULE(230);
/* line 6798 "new_C.puma" */
   if (! ((Symbols_IsProcedure (t->FuncCall.Designator -> Qualid . Object)))) goto yyL21;
  {
/* line 6799 "new_C.puma" */
   WRITEIDENT (t->FuncCall.Designator -> Qualid . Object -> SymObject . CIdent);
/* line 6800 "new_C.puma" */
   WRITESTRING ("(");
/* line 6801 "new_C.puma" */
   CodeActualsWrite (t->FuncCall.Actuals);
/* line 6802 "new_C.puma" */
   WRITESTRING (")");
  }
  }
END_RULE;
   return;
yyL21:;

  if (t->FuncCall.Actuals->Kind == kActualExpr) {
  if (t->FuncCall.Actuals->ActualExpr.Next->Kind == kNoActual) {
/* line 6804 "new_C.puma" */
  {
/* line 6805 "new_C.puma" */
BEGIN_RULE(231);
/* line 6807 "new_C.puma" */
   if (! ((Symbols_IsOfType (t->FuncCall.Designator -> Qualid . Object)))) goto yyL22;
  {
/* line 6808 "new_C.puma" */

                if ( Prec < CAST_PREC ) {
                  WRITESTRING("((");
                  WRITEIDENT( t->FuncCall.Designator->Qualid.Object->SymObject.CIdent );
                  WRITESTRING(")");
                  CodeExprWrite(t->FuncCall.Actuals->ActualExpr.Expr, CAST_PREC);
                  WRITESTRING(")");
                } else {
                  WRITESTRING("(");
                  WRITEIDENT( t->FuncCall.Designator->Qualid.Object->SymObject.CIdent );
                  WRITESTRING(")");
                  CodeExprWrite(t->FuncCall.Actuals->ActualExpr.Expr, CAST_PREC);
                };

  }
  }
END_RULE;
   return;
yyL22:;

  }
  }
  }
/* line 6823 "new_C.puma" */
  {
/* line 6824 "new_C.puma" */
BEGIN_RULE(232);
/* line 6826 "new_C.puma" */
   WRITESTRING ("(*");
/* line 6827 "new_C.puma" */
   CodeExprWrite (t->FuncCall.Designator, DEREF_PREC);
/* line 6828 "new_C.puma" */
   WRITESTRING (")(");
/* line 6829 "new_C.puma" */
   CodeActualsWrite (t->FuncCall.Actuals);
/* line 6830 "new_C.puma" */
   WRITESTRING (")");
  }
END_RULE;
   return;

  case kSet:
  if (t->Set.Elems->Kind == kNoElem) {
/* line 6832 "new_C.puma" */
  {
/* line 6833 "new_C.puma" */
BEGIN_RULE(233);
/* line 6835 "new_C.puma" */
   WRITESTRING ("0X0L");
  }
END_RULE;
   return;

  }
  if (Tree_IsType (t->Set.Elems, kElem)) {
/* line 6837 "new_C.puma" */
  {
/* line 6838 "new_C.puma" */
BEGIN_RULE(234);
/* line 6840 "new_C.puma" */

                if ( Prec <= UNION_PREC ) {
                  WRITESTRING("(");
                  CodeExprWrite(t->Set.Elems, MINPREC_PREC);
                  WRITESTRING(")");
                } else {
                  CodeExprWrite(t->Set.Elems, Prec);
                };

  }
END_RULE;
   return;

  }
  break;
  case kBitSet:
  if (t->BitSet.Elems->Kind == kNoElem) {
/* line 6850 "new_C.puma" */
  {
/* line 6851 "new_C.puma" */
BEGIN_RULE(235);
/* line 6853 "new_C.puma" */
   WRITESTRING ("0X0L");
  }
END_RULE;
   return;

  }
  if (Tree_IsType (t->BitSet.Elems, kElem)) {
/* line 6855 "new_C.puma" */
  {
/* line 6856 "new_C.puma" */
BEGIN_RULE(236);
/* line 6858 "new_C.puma" */

                if ( Prec <= UNION_PREC ) {
                  WRITESTRING("(");
                  CodeExprWrite(t->BitSet.Elems, MINPREC_PREC );
                  WRITESTRING(")");
                } else {
                  CodeExprWrite(t->BitSet.Elems, Prec);
                };

  }
END_RULE;
   return;

  }
  break;
  case kQualid0:
/* line 6868 "new_C.puma" */
  {
/* line 6869 "new_C.puma" */
BEGIN_RULE(237);
/* line 6871 "new_C.puma" */
   if (! ((t -> Qualid0 . IsGlobalPtr && Symbols_IsOpen (t -> Qualid0 . Type)))) goto yyL28;
  {
/* line 6872 "new_C.puma" */
   WRITEIDENT (Pointer_GetGlobalPtr (t -> Qualid0 . Object));
/* line 6873 "new_C.puma" */
   CodeVectorIndex (t);
  }
  }
END_RULE;
   return;
yyL28:;

/* line 6875 "new_C.puma" */
  {
/* line 6876 "new_C.puma" */
BEGIN_RULE(238);
/* line 6878 "new_C.puma" */
   if (! (t -> Qualid0 . Object -> Kind == kSymField)) goto yyL29;
  {
/* line 6879 "new_C.puma" */
   WRITEIDENT (With_GetField (t->Qualid0.Ident));
/* line 6880 "new_C.puma" */
   WRITESTRING ("->");
/* line 6881 "new_C.puma" */
   CodeSelectors (t -> Qualid0 . Object -> SymField . Selectors);
/* line 6882 "new_C.puma" */
   WRITEIDENT (t -> Qualid0 . Object -> SymField . CIdent);
/* line 6883 "new_C.puma" */
   CodeVectorIndex (t);
  }
  }
END_RULE;
   return;
yyL29:;

  break;
  case kQualid1:
/* line 6885 "new_C.puma" */
  {
/* line 6886 "new_C.puma" */
BEGIN_RULE(239);
/* line 6889 "new_C.puma" */
   if (! (t->Qualid1.Qualid -> Qualid . IsGlobalPtr && t->Qualid1.Qualid -> Qualid . Type -> Kind == kSymVector)) goto yyL30;
  {
/* line 6890 "new_C.puma" */
   WRITEIDENT (Pointer_GetGlobalPtr (t->Qualid1.Qualid -> Qualid . Object));
/* line 6891 "new_C.puma" */
   CodeVectorIndex (t->Qualid1.Qualid);
/* line 6892 "new_C.puma" */
   WRITESTRING (".");
/* line 6893 "new_C.puma" */
   CodeSelectors (Symbols_GetSelectors (t -> Qualid1 . Object));
/* line 6894 "new_C.puma" */
   WRITEIDENT (t -> Qualid1 . Object -> SymObject . CIdent);
/* line 6895 "new_C.puma" */
   CodeVectorIndex (t);
  }
  }
END_RULE;
   return;
yyL30:;

/* line 6897 "new_C.puma" */
  {
/* line 6898 "new_C.puma" */
BEGIN_RULE(240);
/* line 6900 "new_C.puma" */
   if (! (t->Qualid1.Qualid -> Qualid . IsGlobalPtr)) goto yyL31;
  {
/* line 6901 "new_C.puma" */
   WRITEIDENT (Pointer_GetGlobalPtr (t->Qualid1.Qualid -> Qualid . Object));
/* line 6902 "new_C.puma" */
   CodeVectorIndex (t->Qualid1.Qualid);
/* line 6903 "new_C.puma" */
   WRITESTRING ("->");
/* line 6904 "new_C.puma" */
   CodeSelectors (Symbols_GetSelectors (t -> Qualid1 . Object));
/* line 6905 "new_C.puma" */
   WRITEIDENT (t -> Qualid1 . Object -> SymObject . CIdent);
/* line 6906 "new_C.puma" */
   CodeVectorIndex (t);
  }
  }
END_RULE;
   return;
yyL31:;

/* line 6908 "new_C.puma" */
  {
/* line 6909 "new_C.puma" */
BEGIN_RULE(241);
/* line 6912 "new_C.puma" */
   if (! (Symbols_IsVAR (t->Qualid1.Qualid -> Qualid . Object) && t->Qualid1.Qualid -> Qualid . Type -> Kind == kSymVector)) goto yyL32;
  {
/* line 6913 "new_C.puma" */
   WRITEIDENT (t->Qualid1.Qualid -> Qualid . Object -> SymVar . CIdent);
/* line 6914 "new_C.puma" */
   CodeVectorIndex (t->Qualid1.Qualid);
/* line 6915 "new_C.puma" */
   WRITESTRING (".");
/* line 6916 "new_C.puma" */
   CodeSelectors (Symbols_GetSelectors (t -> Qualid1 . Object));
/* line 6917 "new_C.puma" */
   WRITEIDENT (t -> Qualid1 . Object -> SymObject . CIdent);
/* line 6918 "new_C.puma" */
   CodeVectorIndex (t);
  }
  }
END_RULE;
   return;
yyL32:;

/* line 6920 "new_C.puma" */
  {
/* line 6921 "new_C.puma" */
BEGIN_RULE(242);
/* line 6923 "new_C.puma" */
   if (! ((Symbols_IsVAR (t->Qualid1.Qualid -> Qualid . Object)))) goto yyL33;
  {
/* line 6924 "new_C.puma" */
   WRITEIDENT (t->Qualid1.Qualid -> Qualid . Object -> SymVar . CIdent);
/* line 6925 "new_C.puma" */
   CodeVectorIndex (t->Qualid1.Qualid);
/* line 6926 "new_C.puma" */
   WRITESTRING ("->");
/* line 6927 "new_C.puma" */
   CodeSelectors (Symbols_GetSelectors (t -> Qualid1 . Object));
/* line 6928 "new_C.puma" */
   WRITEIDENT (t -> Qualid1 . Object -> SymObject . CIdent);
/* line 6929 "new_C.puma" */
   CodeVectorIndex (t);
  }
  }
END_RULE;
   return;
yyL33:;

/* line 6931 "new_C.puma" */
  {
/* line 6932 "new_C.puma" */
BEGIN_RULE(243);
/* line 6934 "new_C.puma" */
   if (! (t -> Qualid1 . Object -> Kind == kSymField)) goto yyL34;
  {
/* line 6935 "new_C.puma" */
   CodeExpr (t->Qualid1.Qualid, SELECT_PREC);
/* line 6936 "new_C.puma" */
   WRITESTRING (".");
/* line 6937 "new_C.puma" */
   CodeSelectors (t -> Qualid1 . Object -> SymField . Selectors);
/* line 6938 "new_C.puma" */
   WRITEIDENT (t -> Qualid1 . Object -> SymField . CIdent);
/* line 6939 "new_C.puma" */
   CodeVectorIndex (t);
  }
  }
END_RULE;
   return;
yyL34:;

  break;
  }


  switch (t->Kind) {
  case kQualid:
  case kQualid0:
  case kQualid1:
/* line 6941 "new_C.puma" */
  {
/* line 6942 "new_C.puma" */
BEGIN_RULE(244);
/* line 6944 "new_C.puma" */
   if (! (t -> Qualid . IsGlobalPtr && t -> Qualid . Type -> Kind == kSymVector)) goto yyL35;
  {
/* line 6945 "new_C.puma" */
   WRITEIDENT (Pointer_GetGlobalPtr (t -> Qualid . Object));
/* line 6946 "new_C.puma" */
   CodeVectorIndex (t);
  }
  }
END_RULE;
   return;
yyL35:;

/* line 6948 "new_C.puma" */
  {
/* line 6949 "new_C.puma" */
BEGIN_RULE(245);
/* line 6951 "new_C.puma" */
   if (! (t -> Qualid . IsGlobalPtr)) goto yyL36;
  {
/* line 6952 "new_C.puma" */

                if ( Prec < DEREF_PREC ) {
                  WRITESTRING("(*");
                  WRITEIDENT( Pointer_GetGlobalPtr (t->Qualid.Object) );
                  CodeVectorIndex(t);
                  WRITESTRING(")");
                } else {
                  WRITESTRING("*");
                  WRITEIDENT( Pointer_GetGlobalPtr (t->Qualid.Object) );
                  CodeVectorIndex(t);
                };

  }
  }
END_RULE;
   return;
yyL36:;

/* line 6965 "new_C.puma" */
  {
/* line 6966 "new_C.puma" */
BEGIN_RULE(246);
/* line 6970 "new_C.puma" */
   if (! (Symbols_IsVAR (t -> Qualid . Object) && ! (Symbols_IsOpen (t -> Qualid . Type)) && t -> Qualid . Type -> Kind == kSymVector)) goto yyL37;
  {
/* line 6971 "new_C.puma" */
   WRITEIDENT (t -> Qualid . Object -> SymVar . CIdent);
/* line 6972 "new_C.puma" */
   CodeVectorIndex (t);
  }
  }
END_RULE;
   return;
yyL37:;

/* line 6974 "new_C.puma" */
  {
/* line 6975 "new_C.puma" */
BEGIN_RULE(247);
/* line 6977 "new_C.puma" */
   if (! (Symbols_IsVAR (t -> Qualid . Object) && ! (Symbols_IsOpen (t -> Qualid . Type)))) goto yyL38;
  {
/* line 6979 "new_C.puma" */

                if ( Prec < DEREF_PREC ) {
                  WRITESTRING("(*");
                  WRITEIDENT( t->Qualid.Object->SymVar.CIdent );
                  CodeVectorIndex(t);
                  WRITESTRING(")");
                } else {
                  WRITESTRING("*");
                  WRITEIDENT( t->Qualid.Object->SymVar.CIdent );
                  CodeVectorIndex(t);
                };

  }
  }
END_RULE;
   return;
yyL38:;

/* line 6992 "new_C.puma" */
  {
/* line 6993 "new_C.puma" */
BEGIN_RULE(248);
/* line 6995 "new_C.puma" */
   WRITEIDENT (t -> Qualid . Object -> SymObject . CIdent);
/* line 6996 "new_C.puma" */
   CodeVectorIndex (t);
  }
END_RULE;
   return;

  case kProcessor:
/* line 6998 "new_C.puma" */
  {
/* line 6999 "new_C.puma" */
BEGIN_RULE(249);
/* line 7001 "new_C.puma" */
   IncVectorLoopCalls ();
/* line 7003 "new_C.puma" */
   CodeExpr (t->Processor.Designator, SUBSCRIPT_PREC);
/* line 7007 "new_C.puma" */
   DecVectorLoopCalls ();
  }
END_RULE;
   return;

  case kDimensions:
/* line 7009 "new_C.puma" */
  {
/* line 7010 "new_C.puma" */
BEGIN_RULE(250);
/* line 7012 "new_C.puma" */
   IncVectorLoopCalls ();
/* line 7014 "new_C.puma" */
   CodeExpr (t->Dimensions.Designator, SUBSCRIPT_PREC);
/* line 7018 "new_C.puma" */
   DecVectorLoopCalls ();
  }
END_RULE;
   return;

  case kSubscript:
  if (t->Subscript.Designator->Kind == kQualid0) {
/* line 7020 "new_C.puma" */
  {
/* line 7021 "new_C.puma" */
BEGIN_RULE(251);
/* line 7023 "new_C.puma" */
   if (! ((Symbols_IsOpenArray (t->Subscript.Designator -> Qualid0 . Object)))) goto yyL42;
  {
/* line 7024 "new_C.puma" */
   CodeExpr (t->Subscript.Designator, SUBSCRIPT_PREC);
/* line 7025 "new_C.puma" */
   WRITESTRING ("[");
/* line 7026 "new_C.puma" */
   CodeExprWrite (t->Subscript.Index, MINPREC_PREC);
/* line 7027 "new_C.puma" */
   WRITESTRING ("]");
/* line 7028 "new_C.puma" */
   CodeVectorIndex (t);
  }
  }
END_RULE;
   return;
yyL42:;

  }
  if (t->Subscript.Designator->Kind == kDeref) {
/* line 7030 "new_C.puma" */
 {
  tValue Lwb;
  {
/* line 7031 "new_C.puma" */
BEGIN_RULE(252);
/* line 7033 "new_C.puma" */
   if (! (! (t->Subscript.Designator->Deref.Designator -> Designator . Type -> Kind == kSymOpaqueType))) goto yyL43;
  {
/* line 7034 "new_C.puma" */

/* line 7035 "new_C.puma" */
   Types_GetLwb (Symbols_GetIndexType (t->Subscript.Designator -> Deref . Type), & Lwb);
/* line 7036 "new_C.puma" */
   CodeExpr (t->Subscript.Designator->Deref.Designator, SELECT_PREC);
/* line 7037 "new_C.puma" */
   CodeVectorIndex (t->Subscript.Designator);
/* line 7038 "new_C.puma" */
   WRITESTRING ("->A[");
/* line 7039 "new_C.puma" */

                if (Values_ValueToInt(&Lwb) != Values_Zero.value.cardinalValue) {
                  CodeExprWrite(t->Subscript.Index, MINUS_PREC + 1);
                  WRITESTRING(" - ");
                  CodeValue (Lwb);
                } else {
                  CodeExprWrite(t->Subscript.Index, MINPREC_PREC);
                };

/* line 7048 "new_C.puma" */
   WRITESTRING ("]");
/* line 7049 "new_C.puma" */
   CodeVectorIndex (t);
  }
  }
END_RULE;
   return;
 }
yyL43:;

  }
  if (Tree_IsType (t->Subscript.Designator, kQualid)) {
/* line 7051 "new_C.puma" */
 {
  tValue Lwb;
  {
/* line 7052 "new_C.puma" */
BEGIN_RULE(253);
/* line 7056 "new_C.puma" */
   if (! (t->Subscript.Designator -> Qualid . IsGlobalPtr && ! (Symbols_IsOpen (t->Subscript.Designator -> Qualid . Type)) && t->Subscript.Designator -> Qualid . Type -> Kind == kSymVector)) goto yyL44;
  {
/* line 7057 "new_C.puma" */

/* line 7058 "new_C.puma" */
   Types_GetLwb (Symbols_GetIndexType (t->Subscript.Designator -> Qualid . Type), & Lwb);
/* line 7059 "new_C.puma" */
   WRITEIDENT (Pointer_GetGlobalPtr (t->Subscript.Designator -> Qualid . Object));
/* line 7060 "new_C.puma" */
   CodeVectorIndex (t->Subscript.Designator);
/* line 7061 "new_C.puma" */
   WRITESTRING (".A[");
/* line 7062 "new_C.puma" */

                if (Values_ValueToInt(&Lwb) != Values_Zero.value.cardinalValue) {
                  CodeExprWrite(t->Subscript.Index, MINUS_PREC + 1);
                  WRITESTRING(" - ");
                  CodeValue (Lwb);
                } else {
                  CodeExprWrite(t->Subscript.Index, MINPREC_PREC);
                };

/* line 7071 "new_C.puma" */
   WRITESTRING ("]");
/* line 7072 "new_C.puma" */
   CodeVectorIndex (t);
  }
  }
END_RULE;
   return;
 }
yyL44:;

/* line 7074 "new_C.puma" */
 {
  tValue Lwb;
  {
/* line 7075 "new_C.puma" */
BEGIN_RULE(254);
/* line 7077 "new_C.puma" */
   if (! (t->Subscript.Designator -> Qualid . IsGlobalPtr && ! (Symbols_IsOpen (t->Subscript.Designator -> Qualid . Type)))) goto yyL45;
  {
/* line 7079 "new_C.puma" */

/* line 7080 "new_C.puma" */
   Types_GetLwb (Symbols_GetIndexType (t->Subscript.Designator -> Qualid . Type), & Lwb);
/* line 7081 "new_C.puma" */
   WRITEIDENT (Pointer_GetGlobalPtr (t->Subscript.Designator -> Qualid . Object));
/* line 7082 "new_C.puma" */
   CodeVectorIndex (t->Subscript.Designator);
/* line 7083 "new_C.puma" */
   WRITESTRING ("->A[");
/* line 7084 "new_C.puma" */

                if ( Values_ValueToInt( &Lwb ) != Values_Zero.value.cardinalValue ) {
                  CodeExprWrite(t->Subscript.Index, MINUS_PREC + 1);
                  WRITESTRING(" - ");
                  CodeValue (Lwb);
                } else {
                  CodeExprWrite(t->Subscript.Index, MINPREC_PREC);
                };

/* line 7093 "new_C.puma" */
   WRITESTRING ("]");
/* line 7094 "new_C.puma" */
   CodeVectorIndex (t);
  }
  }
END_RULE;
   return;
 }
yyL45:;

/* line 7096 "new_C.puma" */
 {
  tValue Lwb;
  {
/* line 7097 "new_C.puma" */
BEGIN_RULE(255);
/* line 7101 "new_C.puma" */
   if (! (Symbols_IsVAR (t->Subscript.Designator -> Qualid . Object) && ! (Symbols_IsOpen (t->Subscript.Designator -> Qualid . Type)) && t->Subscript.Designator -> Qualid . Type -> Kind == kSymVector)) goto yyL46;
  {
/* line 7102 "new_C.puma" */

/* line 7103 "new_C.puma" */
   Types_GetLwb (Symbols_GetIndexType (t->Subscript.Designator -> Qualid . Type), & Lwb);
/* line 7104 "new_C.puma" */
   WRITEIDENT (t->Subscript.Designator -> Qualid . Object -> SymVar . CIdent);
/* line 7105 "new_C.puma" */
   CodeVectorIndex (t->Subscript.Designator);
/* line 7106 "new_C.puma" */
   WRITESTRING (".A[");
/* line 7107 "new_C.puma" */

                if (Values_ValueToInt(&Lwb) != Values_Zero.value.cardinalValue) {
                  CodeExprWrite(t->Subscript.Index, MINUS_PREC + 1);
                  WRITESTRING(" - ");
                  CodeValue (Lwb);
                } else {
                  CodeExprWrite(t->Subscript.Index, MINPREC_PREC);
                };

/* line 7116 "new_C.puma" */
   WRITESTRING ("]");
/* line 7117 "new_C.puma" */
   CodeVectorIndex (t);
  }
  }
END_RULE;
   return;
 }
yyL46:;

/* line 7119 "new_C.puma" */
 {
  tValue Lwb;
  {
/* line 7120 "new_C.puma" */
BEGIN_RULE(256);
/* line 7122 "new_C.puma" */
   if (! (Symbols_IsVAR (t->Subscript.Designator -> Qualid . Object) && ! (Symbols_IsOpen (t->Subscript.Designator -> Qualid . Type)))) goto yyL47;
  {
/* line 7124 "new_C.puma" */

/* line 7125 "new_C.puma" */
   Types_GetLwb (Symbols_GetIndexType (t->Subscript.Designator -> Qualid . Type), & Lwb);
/* line 7126 "new_C.puma" */
   WRITEIDENT (t->Subscript.Designator -> Qualid . Object -> SymVar . CIdent);
/* line 7127 "new_C.puma" */
   CodeVectorIndex (t->Subscript.Designator);
/* line 7128 "new_C.puma" */
   WRITESTRING ("->A[");
/* line 7129 "new_C.puma" */

                if ( Values_ValueToInt( &Lwb ) != Values_Zero.value.cardinalValue ) {
                  CodeExprWrite(t->Subscript.Index, MINUS_PREC + 1);
                  WRITESTRING(" - ");
                  CodeValue (Lwb);
                } else {
                  CodeExprWrite(t->Subscript.Index, MINPREC_PREC);
                };

/* line 7138 "new_C.puma" */
   WRITESTRING ("]");
/* line 7139 "new_C.puma" */
   CodeVectorIndex (t);
  }
  }
END_RULE;
   return;
 }
yyL47:;

  }
/* line 7141 "new_C.puma" */
 {
  tValue Lwb;
  {
/* line 7142 "new_C.puma" */
BEGIN_RULE(257);
/* line 7144 "new_C.puma" */

/* line 7145 "new_C.puma" */
   Types_GetLwb (Symbols_GetIndexType (t->Subscript.Designator -> Designator . Type), & Lwb);
/* line 7146 "new_C.puma" */
   CodeExpr (t->Subscript.Designator, SELECT_PREC);
/* line 7147 "new_C.puma" */
   WRITESTRING (".A[");
/* line 7148 "new_C.puma" */

                if ( Values_ValueToInt( &Lwb ) != Values_Zero.value.cardinalValue ) {
                  CodeExprWrite(t->Subscript.Index, MINUS_PREC + 1);
                  WRITESTRING(" - ");
                  CodeValue ( Lwb );
                } else {
                  CodeExprWrite( t->Subscript.Index, MINPREC_PREC );
                };

/* line 7157 "new_C.puma" */
   WRITESTRING ("]");
/* line 7158 "new_C.puma" */
   CodeVectorIndex (t);
  }
END_RULE;
   return;
 }

  case kSelect:
  if (t->Select.Designator->Kind == kDeref) {
/* line 7160 "new_C.puma" */
 {
  tObject Object;
  {
/* line 7161 "new_C.puma" */
BEGIN_RULE(258);
/* line 7163 "new_C.puma" */
   if (! (t->Select.Designator->Deref.Designator -> Designator . Type -> Kind == kSymOpaqueType)) goto yyL49;
  {
/* line 7164 "new_C.puma" */

/* line 7165 "new_C.puma" */
   if (! (Object = t->Select.Designator->Deref.Designator -> Designator . Type -> SymConstructor . TypeObj)) goto yyL49;
  {
/* line 7166 "new_C.puma" */
   WRITESTRING ("((");
/* line 7167 "new_C.puma" */
   WRITEIDENT (GenIdents_Opaque (Object -> SymObject . CIdent));
/* line 7168 "new_C.puma" */
   WRITESTRING (")");
/* line 7169 "new_C.puma" */
   CodeExpr (t->Select.Designator->Deref.Designator, CAST_PREC);
/* line 7170 "new_C.puma" */
   WRITESTRING (")");
/* line 7171 "new_C.puma" */
   CodeVectorIndex (t->Select.Designator);
/* line 7172 "new_C.puma" */
   WRITESTRING ("->");
/* line 7173 "new_C.puma" */
   CodeSelectors (Symbols_GetSelectors (t -> Select . Object));
/* line 7174 "new_C.puma" */
   WRITEIDENT (t -> Select . Object -> SymObject . CIdent);
/* line 7175 "new_C.puma" */
   CodeVectorIndex (t);
  }
  }
  }
END_RULE;
   return;
 }
yyL49:;

/* line 7177 "new_C.puma" */
  {
/* line 7178 "new_C.puma" */
BEGIN_RULE(259);
/* line 7180 "new_C.puma" */
   CodeExpr (t->Select.Designator->Deref.Designator, SELECT_PREC);
/* line 7181 "new_C.puma" */
   CodeVectorIndex (t->Select.Designator);
/* line 7182 "new_C.puma" */
   WRITESTRING ("->");
/* line 7183 "new_C.puma" */
   CodeSelectors (Symbols_GetSelectors (t -> Select . Object));
/* line 7184 "new_C.puma" */
   WRITEIDENT (t -> Select . Object -> SymObject . CIdent);
/* line 7185 "new_C.puma" */
   CodeVectorIndex (t);
  }
END_RULE;
   return;

  }
/* line 7187 "new_C.puma" */
  {
/* line 7188 "new_C.puma" */
BEGIN_RULE(260);
/* line 7190 "new_C.puma" */
   CodeExpr (t->Select.Designator, SELECT_PREC);
/* line 7191 "new_C.puma" */
   WRITESTRING (".");
/* line 7192 "new_C.puma" */
   CodeSelectors (Symbols_GetSelectors (t -> Select . Object));
/* line 7193 "new_C.puma" */
   WRITEIDENT (t -> Select . Object -> SymObject . CIdent);
/* line 7194 "new_C.puma" */
   CodeVectorIndex (t);
  }
END_RULE;
   return;

  case kDeref:
/* line 7196 "new_C.puma" */
 {
  tObject Object;
  {
/* line 7197 "new_C.puma" */
BEGIN_RULE(261);
/* line 7199 "new_C.puma" */
   if (! (t->Deref.Designator -> Designator . Type -> Kind == kSymOpaqueType)) goto yyL52;
  {
/* line 7200 "new_C.puma" */

/* line 7201 "new_C.puma" */
   if (! (Object = t->Deref.Designator -> Designator . Type -> SymConstructor . TypeObj)) goto yyL52;
  {
/* line 7202 "new_C.puma" */

                if ( Prec < DEREF_PREC ) {
                  WRITESTRING("(*(");
                  WRITEIDENT( GenIdents_Opaque (Object->SymObject.CIdent) );
                  WRITESTRING(")");
                  CodeExpr(t->Deref.Designator, CAST_PREC );
                  CodeVectorIndex(t);
                  WRITESTRING(")");
                } else {
                  WRITESTRING("*(");
                  WRITEIDENT( GenIdents_Opaque (Object->SymObject.CIdent) );
                  WRITESTRING(")");
                  CodeExpr( t->Deref.Designator, CAST_PREC );
                  CodeVectorIndex(t);
                };

  }
  }
  }
END_RULE;
   return;
 }
yyL52:;

/* line 7219 "new_C.puma" */
  {
/* line 7220 "new_C.puma" */
BEGIN_RULE(262);
/* line 7222 "new_C.puma" */

                if ( Prec < DEREF_PREC ) {
                  WRITESTRING("(*");
                  CodeExpr( t->Deref.Designator, DEREF_PREC );
                  CodeVectorIndex(t);
                  WRITESTRING(")");
                } else {
                  WRITESTRING("*");
                  CodeExpr( t->Deref.Designator, DEREF_PREC );
                  CodeVectorIndex(t);
                };

  }
END_RULE;
   return;

  case kElemExpr:
/* line 7235 "new_C.puma" */
  {
/* line 7236 "new_C.puma" */
BEGIN_RULE(263);
/* line 7238 "new_C.puma" */
   WRITESTRING ("SET_ELEM(");
/* line 7239 "new_C.puma" */
   CodeExprWrite (t->ElemExpr.Elem, PASSVALUE_PREC);
/* line 7240 "new_C.puma" */
   WRITESTRING (")");
/* line 7241 "new_C.puma" */
   CodeSepa (t->ElemExpr.Next);
/* line 7242 "new_C.puma" */
   CodeExprWrite (t->ElemExpr.Next, UNION_PREC);
  }
END_RULE;
   return;

  case kElemRange:
/* line 7244 "new_C.puma" */
  {
/* line 7245 "new_C.puma" */
BEGIN_RULE(264);
/* line 7247 "new_C.puma" */
   if (! (t->ElemRange.Lwb -> Expr . IsCConst && t->ElemRange.Upb -> Expr . IsCConst)) goto yyL55;
  {
/* line 7248 "new_C.puma" */
   WRITESTRING ("SET_cRNG(");
/* line 7249 "new_C.puma" */
   CodeExprWrite (t->ElemRange.Lwb, PASSVALUE_PREC);
/* line 7250 "new_C.puma" */
   WRITESTRING (", ");
/* line 7251 "new_C.puma" */
   CodeExprWrite (t->ElemRange.Upb, PASSVALUE_PREC);
/* line 7252 "new_C.puma" */
   WRITESTRING (")");
/* line 7253 "new_C.puma" */
   CodeSepa (t->ElemRange.Next);
/* line 7254 "new_C.puma" */
   CodeExprWrite (t->ElemRange.Next, UNION_PREC);
  }
  }
END_RULE;
   return;
yyL55:;

/* line 7256 "new_C.puma" */
  {
/* line 7257 "new_C.puma" */
BEGIN_RULE(265);
/* line 7259 "new_C.puma" */
   WRITESTRING ("SET_RANGE(");
/* line 7260 "new_C.puma" */
   CodeExprWrite (t->ElemRange.Lwb, PASSVALUE_PREC);
/* line 7261 "new_C.puma" */
   WRITESTRING (", ");
/* line 7262 "new_C.puma" */
   CodeExprWrite (t->ElemRange.Upb, PASSVALUE_PREC);
/* line 7263 "new_C.puma" */
   WRITESTRING (")");
/* line 7264 "new_C.puma" */
   CodeSepa (t->ElemRange.Next);
/* line 7265 "new_C.puma" */
   CodeExprWrite (t->ElemRange.Next, UNION_PREC);
  }
END_RULE;
   return;

  }

/* line 7267 "new_C.puma" */
  {
/* line 7268 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeExprCompute
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 7275 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif


  switch (t->Kind) {
  case kLastMultiple:
/* line 7282 "new_C.puma" */
  {
/* line 7283 "new_C.puma" */
BEGIN_RULE(266);
/* line 7285 "new_C.puma" */
   CodeExprCompute (t->LastMultiple.Mop);
  }
END_RULE;
   return;

  case kMultiple:
/* line 7287 "new_C.puma" */
  {
/* line 7288 "new_C.puma" */
BEGIN_RULE(267);
/* line 7290 "new_C.puma" */

                CodeExprCompute(t->Multiple.Mop);
                CodeExprCompute(t->Multiple.Multiples);
                CodeVectorLoopBegin(t);
                CodeHelpVarAssignBegin(t);
                CodeHelpVarWrite(t->Multiple.Mop);
                switch (t->Multiple.COperator) {
                case Code_NotEqual     : WRITESTRING(" != "); break;
                case Code_Less         : WRITESTRING(" < ");  break;
                case Code_LessEqual    : WRITESTRING(" <= "); break;
                case Code_Equal        : WRITESTRING(" == "); break;
                case Code_Greater      : WRITESTRING(" > ");  break;
                case Code_GreaterEqual : WRITESTRING(" >= "); break;
                }
                CodeHelpVarWrite(t->Multiple.Multiples->Multiples.Mop);
                if (t->Multiple.Multiples->Kind == kMultiple) {
                  WRITESTRING(" && ");
                  CodeHelpVarWrite(t->Multiple.Multiples);
                }
                CodeHelpVarAssignClose(t);
                CodeVectorLoopClose(t);

  }
END_RULE;
   return;

  case kBinary:
/* line 7314 "new_C.puma" */
  {
/* line 7315 "new_C.puma" */
BEGIN_RULE(268);
/* line 7319 "new_C.puma" */
   if (! (Symbols_IsStringType (t->Binary.Lop -> Expr . Type) && Symbols_IsStringType (t->Binary.Rop -> Expr . Type) && (t -> Binary . COperator == Code_NotEqual || t -> Binary . COperator == Code_Less || t -> Binary . COperator == Code_LessEqual || t -> Binary . COperator == Code_Equal || t -> Binary . COperator == Code_Greater || t -> Binary . COperator == Code_GreaterEqual || t -> Binary . COperator == Code_In))) goto yyL3;
  {
/* line 7327 "new_C.puma" */
   CodeExprCompute (t->Binary.Lop);
/* line 7328 "new_C.puma" */
   CodeExprCompute (t->Binary.Rop);
/* line 7329 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 7330 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 7331 "new_C.puma" */

                if (t->Binary.COperator == Code_In) {
                  WRITESTRING("(strstr(");
                  CodeHelpVarWrite(t->Binary.Rop);
                  WRITESTRING(", ");
                  CodeHelpVarWrite(t->Binary.Lop);
                  WRITESTRING(") != NULL)");
                } else {
                  WRITESTRING("(strcmp(");
                  CodeHelpVarWrite(t->Binary.Lop);
                  WRITESTRING(", ");
                  CodeHelpVarWrite(t->Binary.Rop);
                  WRITESTRING(")");
                  switch (t->Binary.COperator) {
                  case Code_NotEqual     : WRITESTRING(" != "); break;
                  case Code_Less         : WRITESTRING(" < ");  break;
                  case Code_LessEqual    : WRITESTRING(" <= "); break;
                  case Code_Equal        : WRITESTRING(" == "); break;
                  case Code_Greater      : WRITESTRING(" > ");  break;
                  case Code_GreaterEqual : WRITESTRING(" >= "); break;
                  };
                  WRITESTRING("0)");
                }

/* line 7355 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 7356 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
END_RULE;
   return;
yyL3:;

/* line 7359 "new_C.puma" */
  {
/* line 7360 "new_C.puma" */
BEGIN_RULE(269);
/* line 7364 "new_C.puma" */
   if (! ((t -> Binary . COperator == Code_Equal || t -> Binary . COperator == Code_NotEqual) && (t->Binary.Lop -> Expr . Type -> Kind == kSymRecord || t->Binary.Lop -> Expr . Type -> Kind == kSymArray || ((t->Binary.Lop -> Expr . Type -> Kind == kSymVector) && (t->Binary.Lop -> Expr . Type -> SymVector . Type -> Kind == kSymRecord || t->Binary.Lop -> Expr . Type -> SymVector . Type -> Kind == kSymArray))))) goto yyL4;
  {
/* line 7371 "new_C.puma" */
   CodeExprCompute (t->Binary.Lop);
/* line 7372 "new_C.puma" */
   CodeExprCompute (t->Binary.Rop);
/* line 7373 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 7374 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 7375 "new_C.puma" */
   WRITESTRING ("(memcmp(&(");
/* line 7376 "new_C.puma" */
   CodeExprWrite (t->Binary.Lop, PASSVALUE_PREC);
/* line 7377 "new_C.puma" */
   WRITESTRING ("), &(");
/* line 7378 "new_C.puma" */
   CodeExprWrite (t->Binary.Rop, PASSVALUE_PREC);
/* line 7379 "new_C.puma" */
   WRITESTRING ("), sizeof(");
/* line 7380 "new_C.puma" */
   CodeExprWrite (t->Binary.Lop, PASSVALUE_PREC);
/* line 7381 "new_C.puma" */
   WRITESTRING ("))");
/* line 7382 "new_C.puma" */

                if (t->Binary.COperator == Code_Equal) {
                  WRITESTRING(" == ");
                } else {
                  WRITESTRING(" != ");
                }

/* line 7389 "new_C.puma" */
   WRITESTRING (" 0)");
/* line 7390 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 7391 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
END_RULE;
   return;
yyL4:;

/* line 7393 "new_C.puma" */
  {
/* line 7394 "new_C.puma" */
BEGIN_RULE(270);
/* line 7396 "new_C.puma" */
   if (! (t -> Binary . COperator == Code_Mod)) goto yyL5;
  {
/* line 7397 "new_C.puma" */
   CodeExprCompute (t->Binary.Lop);
/* line 7398 "new_C.puma" */
   CodeExprCompute (t->Binary.Rop);
/* line 7399 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 7400 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 7401 "new_C.puma" */
   WRITESTRING ("MOD(");
/* line 7402 "new_C.puma" */
   CodeHelpVarWrite (t->Binary.Lop);
/* line 7403 "new_C.puma" */
   WRITESTRING (", ");
/* line 7404 "new_C.puma" */
   CodeHelpVarWrite (t->Binary.Rop);
/* line 7405 "new_C.puma" */
   WRITESTRING (")");
/* line 7406 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 7407 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
END_RULE;
   return;
yyL5:;

/* line 7409 "new_C.puma" */
  {
/* line 7410 "new_C.puma" */
BEGIN_RULE(271);
/* line 7412 "new_C.puma" */
   if (! (((t -> Binary . COperator == Code_In) || (t -> Binary . COperator == Code_Difference) || (t -> Binary . COperator == Code_IsSubset1) || (t -> Binary . COperator == Code_IsSubset2)))) goto yyL6;
  {
/* line 7416 "new_C.puma" */
   CodeExprCompute (t->Binary.Lop);
/* line 7417 "new_C.puma" */
   CodeExprCompute (t->Binary.Rop);
/* line 7418 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 7419 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 7420 "new_C.puma" */

                switch ( t->Binary.COperator ) {
                case Code_In        : WRITESTRING("IN");             break;
                case Code_Difference: WRITESTRING("SET_DIFF");       break;
                case Code_IsSubset1 : WRITESTRING("SET_IS_SUBSET1"); break;
                case Code_IsSubset2 : WRITESTRING("SET_IS_SUBSET2"); break;
                };

/* line 7428 "new_C.puma" */
   WRITESTRING ("(");
/* line 7429 "new_C.puma" */
   CodeHelpVarWrite (t->Binary.Lop);
/* line 7430 "new_C.puma" */
   WRITESTRING (", ");
/* line 7431 "new_C.puma" */
   CodeHelpVarWrite (t->Binary.Rop);
/* line 7432 "new_C.puma" */
   WRITESTRING (")");
/* line 7433 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 7434 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
END_RULE;
   return;
yyL6:;

/* line 7436 "new_C.puma" */
  {
/* line 7437 "new_C.puma" */
BEGIN_RULE(272);
/* line 7439 "new_C.puma" */
   if (! ((t -> Binary . COperator == Code_Power && (t->Binary.Lop -> Expr . Type == TypeCARDINAL || t->Binary.Lop -> Expr . Type == TypeINTEGER || t->Binary.Lop -> Expr . Type == TypeIntCard) && (t->Binary.Rop -> Expr . Type == TypeCARDINAL || t->Binary.Rop -> Expr . Type == TypeINTEGER || t->Binary.Rop -> Expr . Type == TypeIntCard)))) goto yyL7;
  {
/* line 7446 "new_C.puma" */
   CodeExprCompute (t->Binary.Lop);
/* line 7447 "new_C.puma" */
   CodeExprCompute (t->Binary.Rop);
/* line 7448 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 7449 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 7450 "new_C.puma" */
   WRITESTRING ("((INTEGER) pow((double) ");
/* line 7451 "new_C.puma" */
   CodeHelpVarWrite (t->Binary.Lop);
/* line 7452 "new_C.puma" */
   WRITESTRING (", (double) ");
/* line 7453 "new_C.puma" */
   CodeHelpVarWrite (t->Binary.Rop);
/* line 7454 "new_C.puma" */
   WRITESTRING ("))");
/* line 7455 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 7456 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
END_RULE;
   return;
yyL7:;

/* line 7458 "new_C.puma" */
  {
/* line 7459 "new_C.puma" */
BEGIN_RULE(273);
/* line 7461 "new_C.puma" */
   if (! ((t -> Binary . COperator == Code_Power))) goto yyL8;
  {
/* line 7462 "new_C.puma" */
   CodeExprCompute (t->Binary.Lop);
/* line 7463 "new_C.puma" */
   CodeExprCompute (t->Binary.Rop);
/* line 7464 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 7465 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 7466 "new_C.puma" */
   WRITESTRING ("pow((double) ");
/* line 7467 "new_C.puma" */
   CodeHelpVarWrite (t->Binary.Lop);
/* line 7468 "new_C.puma" */
   WRITESTRING (", (double) ");
/* line 7469 "new_C.puma" */
   CodeHelpVarWrite (t->Binary.Rop);
/* line 7470 "new_C.puma" */
   WRITESTRING (")");
/* line 7471 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 7472 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
END_RULE;
   return;
yyL8:;

/* line 7474 "new_C.puma" */
  {
/* line 7475 "new_C.puma" */
BEGIN_RULE(274);
/* line 7477 "new_C.puma" */
   if (! ((((t -> Binary . COperator == Code_Plus) || (t -> Binary . COperator == Code_Minus)) && (t->Binary.Lop -> Expr . Type == TypeADDRESS) && (t->Binary.Rop -> Expr . Type == TypeADDRESS)))) goto yyL9;
  {
/* line 7481 "new_C.puma" */
   CodeExprCompute (t->Binary.Lop);
/* line 7482 "new_C.puma" */
   CodeExprCompute (t->Binary.Rop);
/* line 7483 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 7484 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 7485 "new_C.puma" */
   CodeHelpVarWrite (t->Binary.Lop);
/* line 7486 "new_C.puma" */

                if ( t->Binary.COperator == Code_Plus ) {
                  WRITESTRING(" + ");
                } else {
                  WRITESTRING(" - ");
                };

/* line 7493 "new_C.puma" */
   WRITESTRING ("(CARDINAL)");
/* line 7494 "new_C.puma" */
   CodeHelpVarWrite (t->Binary.Rop);
/* line 7495 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 7496 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
END_RULE;
   return;
yyL9:;

/* line 7498 "new_C.puma" */
  {
/* line 7499 "new_C.puma" */
BEGIN_RULE(275);
/* line 7501 "new_C.puma" */
   if (! (((t -> Binary . COperator == Code_Minus) && ! (t->Binary.Lop -> Expr . Type == TypeADDRESS) && (t->Binary.Rop -> Expr . Type == TypeADDRESS)))) goto yyL10;
  {
/* line 7504 "new_C.puma" */
   CodeExprCompute (t->Binary.Lop);
/* line 7505 "new_C.puma" */
   CodeExprCompute (t->Binary.Rop);
/* line 7506 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 7507 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 7508 "new_C.puma" */
   WRITESTRING ("(ADDRESS)(");
/* line 7509 "new_C.puma" */
   CodeHelpVarWrite (t->Binary.Lop);
/* line 7510 "new_C.puma" */
   WRITESTRING (" - (CARDINAL)");
/* line 7511 "new_C.puma" */
   CodeHelpVarWrite (t->Binary.Rop);
/* line 7512 "new_C.puma" */
   WRITESTRING (")");
/* line 7513 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 7514 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
END_RULE;
   return;
yyL10:;

/* line 7516 "new_C.puma" */
  {
/* line 7517 "new_C.puma" */
BEGIN_RULE(276);
/* line 7519 "new_C.puma" */
   if (! ((((t -> Binary . COperator == Code_Times) || (t -> Binary . COperator == Code_Divide)) && ((t->Binary.Lop -> Expr . Type == TypeADDRESS) || (t->Binary.Rop -> Expr . Type == TypeADDRESS))))) goto yyL11;
  {
/* line 7523 "new_C.puma" */
   CodeExprCompute (t->Binary.Lop);
/* line 7524 "new_C.puma" */
   CodeExprCompute (t->Binary.Rop);
/* line 7525 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 7526 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 7527 "new_C.puma" */
   WRITESTRING ("(ADDRESS)(");
/* line 7528 "new_C.puma" */

                if ( t->Binary.Lop->Expr.Type == TypeADDRESS ) {
                  WRITESTRING("(CARDINAL)");
                };
                CodeHelpVarWrite(t->Binary.Lop);
                if ( t->Binary.COperator == Code_Times ) {
                  WRITESTRING(" * ");
                } else {
                  WRITESTRING(" / ");
                };
                if ( t->Binary.Rop->Expr.Type == TypeADDRESS ) {
                  WRITESTRING("(CARDINAL)");
                };

/* line 7542 "new_C.puma" */
   CodeHelpVarWrite (t->Binary.Rop);
/* line 7543 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 7544 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
END_RULE;
   return;
yyL11:;

/* line 7546 "new_C.puma" */
  {
/* line 7547 "new_C.puma" */
BEGIN_RULE(277);
/* line 7551 "new_C.puma" */
   if (! ((((Symbols_IsINTEGER (t->Binary.Lop -> Expr . Type) && Symbols_IsCARDINAL (t->Binary.Rop -> Expr . Type)) || (Symbols_IsCARDINAL (t->Binary.Lop -> Expr . Type) && Symbols_IsINTEGER (t->Binary.Rop -> Expr . Type))) && (t -> Binary . COperator == Code_Less || t -> Binary . COperator == Code_LessEqual || t -> Binary . COperator == Code_Greater || t -> Binary . COperator == Code_GreaterEqual)))) goto yyL12;
  {
/* line 7559 "new_C.puma" */
   CodeExprCompute (t->Binary.Lop);
/* line 7560 "new_C.puma" */
   CodeExprCompute (t->Binary.Rop);
/* line 7561 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 7562 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 7563 "new_C.puma" */

                if (Symbols_IsCARDINAL(t->Binary.Lop->Expr.Type)) {
                  WRITESTRING("((INTEGER) ");
                  CodeHelpVarWrite(t->Binary.Lop);
                  WRITESTRING(")");
                } else {
                  CodeHelpVarWrite(t->Binary.Lop);
                }
                switch (t->Binary.COperator) {
                   case Code_Less         : WRITESTRING(" < ");  break;
                   case Code_LessEqual    : WRITESTRING(" <= "); break;
                   case Code_Greater      : WRITESTRING(" > ");  break;
                   case Code_GreaterEqual : WRITESTRING(" >= "); break;
                };
                if (Symbols_IsCARDINAL(t->Binary.Rop->Expr.Type)) {
                  WRITESTRING("((INTEGER) ");
                  CodeHelpVarWrite(t->Binary.Rop);
                  WRITESTRING(")");
                } else {
                  CodeHelpVarWrite(t->Binary.Rop);
                }

/* line 7585 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 7586 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
END_RULE;
   return;
yyL12:;

/* line 7588 "new_C.puma" */
  {
/* line 7589 "new_C.puma" */
BEGIN_RULE(278);
/* line 7591 "new_C.puma" */
   CodeExprCompute (t->Binary.Lop);
/* line 7592 "new_C.puma" */
   CodeExprCompute (t->Binary.Rop);
/* line 7593 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 7594 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 7595 "new_C.puma" */
   CodeHelpVarWrite (t->Binary.Lop);
/* line 7596 "new_C.puma" */

                switch (t->Binary.COperator) {
                  case Code_NotEqual     : WRITESTRING(" != "); break;
                  case Code_Times        : WRITESTRING(" * ");  break;
                  case Code_Plus         : WRITESTRING(" + ");  break;
                  case Code_Minus        : WRITESTRING(" - ");  break;
                  case Code_Divide       : WRITESTRING(" / ");  break;
                  case Code_Less         : WRITESTRING(" < ");  break;
                  case Code_LessEqual    : WRITESTRING(" <= "); break;
                  case Code_Equal        : WRITESTRING(" == "); break;
                  case Code_Greater      : WRITESTRING(" > ");  break;
                  case Code_GreaterEqual : WRITESTRING(" >= "); break;
                  case Code_And          : WRITESTRING(" && "); break;
                  case Code_Mod          : WRITESTRING(" %% "); break;
                  case Code_Or           : WRITESTRING(" || "); break;
                  case Code_Union        : WRITESTRING(" | ");  break;
                  case Code_Intersection : WRITESTRING(" & ");  break;
                  case Code_SymDiff      : WRITESTRING(" ^ ");  break;
                };

/* line 7616 "new_C.puma" */
   CodeHelpVarWrite (t->Binary.Rop);
/* line 7617 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 7618 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
END_RULE;
   return;

  case kUnary:
  if (t->Unary.Mop->Kind == kIntConst) {
/* line 7620 "new_C.puma" */
  {
/* line 7621 "new_C.puma" */
BEGIN_RULE(279);
/* line 7623 "new_C.puma" */
   if (! (t -> Unary . COperator == Code_Minus)) goto yyL14;
  {
/* line 7624 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 7625 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 7626 "new_C.puma" */

                switch (t->Unary.Mop->IntConst.Kind) {
                case IntDecimal    :
                  WRITESTRING("-");
                  WRITECARD(t->Unary.Mop->IntConst.IntVal);
                  break;
                case IntOctal      :
                  WRITESTRING("-0");
                  WRITEOCT(t->Unary.Mop->IntConst.IntVal);
                  break;
                case IntHexadecimal:
                  WRITESTRING("-0X");
                  WRITEHEX(t->Unary.Mop->IntConst.IntVal);
                  break;
                };

/* line 7642 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 7643 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
END_RULE;
   return;
yyL14:;

  }
/* line 7645 "new_C.puma" */
  {
/* line 7646 "new_C.puma" */
BEGIN_RULE(280);
/* line 7648 "new_C.puma" */
   CodeExprCompute (t->Unary.Mop);
/* line 7649 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 7650 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 7651 "new_C.puma" */

                switch (t->Unary.COperator) {
                case Code_Minus: WRITESTRING("-"); break;
                case Code_Not  : WRITESTRING("!"); break;
                };

/* line 7657 "new_C.puma" */
   CodeHelpVarWrite (t->Unary.Mop);
/* line 7658 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 7659 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
END_RULE;
   return;

  case kIntConst:
/* line 7661 "new_C.puma" */
  {
/* line 7662 "new_C.puma" */
BEGIN_RULE(281);
/* line 7664 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 7665 "new_C.puma" */

                if (t->IntConst.IntVal > MAXLONG) {
                  WRITESTRING("(CARDINAL)");
                  ErrorMessage(xxOutOfLongRange, xxWarning, t->IntConst.Pos);
                };
                switch (t->IntConst.Kind) {
                case IntDecimal    :
                  WRITECARD(t->IntConst.IntVal);
                  break;
                case IntOctal      :
                  WRITESTRING("0");
                  WRITEOCT(t->IntConst.IntVal);
                  break;
                case IntHexadecimal:
                  WRITESTRING("0X");
                  WRITEHEX( t->IntConst.IntVal );
                  break;
                };

/* line 7684 "new_C.puma" */
   CodeHelpVarAssignClose (t);
  }
END_RULE;
   return;

  case kRealConst:
/* line 7686 "new_C.puma" */
  {
/* line 7687 "new_C.puma" */
BEGIN_RULE(282);
/* line 7689 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 7690 "new_C.puma" */
   CodeConstReal (t->RealConst.RealVal);
/* line 7691 "new_C.puma" */
   CodeHelpVarAssignClose (t);
  }
END_RULE;
   return;

  case kStringConst:
/* line 7693 "new_C.puma" */
  {
/* line 7694 "new_C.puma" */
BEGIN_RULE(283);
/* line 7696 "new_C.puma" */
   if (! (LengthSt (t->StringConst.StringVal) == 1)) goto yyL18;
  {
/* line 7697 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 7698 "new_C.puma" */
   CodeConstStringChar (t->StringConst.StringVal);
/* line 7699 "new_C.puma" */
   CodeHelpVarAssignClose (t);
  }
  }
END_RULE;
   return;
yyL18:;

/* line 7701 "new_C.puma" */
  {
/* line 7702 "new_C.puma" */
BEGIN_RULE(284);
/* line 7704 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 7705 "new_C.puma" */
   CodeConstString (t->StringConst.StringVal);
/* line 7706 "new_C.puma" */
   CodeHelpVarAssignClose (t);
  }
END_RULE;
   return;

  case kCharConst:
/* line 7708 "new_C.puma" */
  {
/* line 7709 "new_C.puma" */
BEGIN_RULE(285);
/* line 7711 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 7712 "new_C.puma" */
   CodeChar (t->CharConst.CharVal);
/* line 7713 "new_C.puma" */
   CodeHelpVarAssignClose (t);
  }
END_RULE;
   return;

  case kFuncCall:
/* line 7715 "new_C.puma" */
  {
/* line 7716 "new_C.puma" */
BEGIN_RULE(286);
/* line 7718 "new_C.puma" */
   if (! (t->FuncCall.Designator -> Designator . Type -> Kind == kSymStdProcType)) goto yyL21;
  {
/* line 7719 "new_C.puma" */

                if (t->FuncCall.Actuals->Actuals.UseHelpVar) {
                  CodeActualsCompute(t->FuncCall.Actuals);
                }
                CodeVectorLoopBegin(t);
                CodeHelpVarAssignBegin(t);
                CodeStdProc(t->FuncCall.Actuals, t->FuncCall.Designator->Designator.Type->SymStdProcType.StdProc, NoObject);
                CodeHelpVarAssignClose(t);
                CodeVectorLoopClose(t);
                
                

  }
  }
END_RULE;
   return;
yyL21:;

  if (Tree_IsType (t->FuncCall.Designator, kQualid)) {
/* line 7732 "new_C.puma" */
  {
/* line 7733 "new_C.puma" */
BEGIN_RULE(287);
/* line 7735 "new_C.puma" */
   if (! ((Symbols_IsProcedure (t->FuncCall.Designator -> Qualid . Object)))) goto yyL22;
  {
/* line 7736 "new_C.puma" */

                if (t->FuncCall.Actuals->Actuals.UseHelpVar) {
                  CodeActualsCompute(t->FuncCall.Actuals);
                }
                CodeVectorLoopBegin(t);
                CodeHelpVarAssignBegin(t);
                WRITEIDENT( t->FuncCall.Designator->Qualid.Object->SymObject.CIdent );
                WRITESTRING("(");
                CodeActualsWrite(t->FuncCall.Actuals);
                WRITESTRING(")");
                CodeHelpVarAssignClose(t);
                CodeVectorLoopClose(t);
                if (t->FuncCall.Actuals->Actuals.UseHelpVar) {
                  CodeActualsRestoreVars(t->FuncCall.Actuals);
                }

  }
  }
END_RULE;
   return;
yyL22:;

/* line 7753 "new_C.puma" */
  {
/* line 7754 "new_C.puma" */
BEGIN_RULE(288);
/* line 7756 "new_C.puma" */
   if (! (t -> FuncCall . Type -> Kind == kSymArray)) goto yyL23;
  {
/* line 7757 "new_C.puma" */

        ULONG Dim;
        tTree actual;
                if (t->FuncCall.Actuals->Actuals.UseHelpVar) {
                  CodeActualsCompute(t->FuncCall.Actuals);
                }
                Dim = 0;
                actual = t->FuncCall.Actuals;
                while (actual->Kind != kNoActual) {
                  WRITEBLANKS();
                  WRITEIDENT(t->FuncCall.HelpVar);
                  WRITESTRING(".A[");
                  WRITECARD(Dim);
                  WRITESTRING("] = ");
                  CodeExprWrite(actual->ActualExpr.Expr, ASSIGN_PREC);
                  WRITESTRING(";");
		  WRITELN();
                  Dim++;
                  actual = actual->Actual.Next;
                }                
                

  }
  }
END_RULE;
   return;
yyL23:;

/* line 7780 "new_C.puma" */
 {
  tObjects field;
  tTree actual;
  {
/* line 7781 "new_C.puma" */
BEGIN_RULE(289);
/* line 7783 "new_C.puma" */
   if (! (t -> FuncCall . Type -> Kind == kSymRecord)) goto yyL24;
  {
/* line 7784 "new_C.puma" */

/* line 7785 "new_C.puma" */

/* line 7786 "new_C.puma" */

                if (t->FuncCall.Actuals->Actuals.UseHelpVar) {
                  CodeActualsCompute(t->FuncCall.Actuals);
                }
                field = t->FuncCall.Designator->Qualid.Object->SymTypeDecl.Type->SymRecord.Objects;
                actual = t->FuncCall.Actuals;
                while (actual->Kind != kNoActual && field != NoObjects) {
                  WRITEBLANKS();
                  WRITEIDENT(t->FuncCall.HelpVar);
                  WRITESTRING(".");
                  WRITEIDENT(field->SymElem.Object->SymField.CIdent);
                  WRITESTRING(" = ");
                  CodeExprWrite(actual->ActualExpr.Expr, ASSIGN_PREC);
                  WRITESTRING(";");
		  WRITELN();
                  field = field->SymElem.Next;
                  actual = actual->Actual.Next;
                }                
                

  }
  }
END_RULE;
   return;
 }
yyL24:;

  if (t->FuncCall.Actuals->Kind == kActualExpr) {
  if (t->FuncCall.Actuals->ActualExpr.Next->Kind == kNoActual) {
/* line 7807 "new_C.puma" */
  {
/* line 7808 "new_C.puma" */
BEGIN_RULE(290);
/* line 7810 "new_C.puma" */
   if (! ((Symbols_IsOfType (t->FuncCall.Designator -> Qualid . Object)))) goto yyL25;
  {
/* line 7811 "new_C.puma" */

                if (t->FuncCall.Actuals->ActualExpr.Expr->Expr.UseHelpVar) {
                  CodeExprCompute(t->FuncCall.Actuals->ActualExpr.Expr);
                }

/* line 7816 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 7817 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 7818 "new_C.puma" */
   WRITESTRING ("(");
/* line 7819 "new_C.puma" */
   WRITEIDENT (t->FuncCall.Designator -> Qualid . Object -> SymObject . CIdent);
/* line 7820 "new_C.puma" */
   WRITESTRING (")");
/* line 7821 "new_C.puma" */
   CodeExprWrite (t->FuncCall.Actuals->ActualExpr.Expr, CAST_PREC);
/* line 7822 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 7823 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
END_RULE;
   return;
yyL25:;

/* line 7826 "new_C.puma" */
  {
/* line 7827 "new_C.puma" */
BEGIN_RULE(291);
/* line 7829 "new_C.puma" */
   if (! ((IsVector (t->FuncCall.Designator)))) goto yyL26;
  {
/* line 7830 "new_C.puma" */

                if (t->FuncCall.Actuals->ActualExpr.Expr->Expr.UseHelpVar) {
                  CodeExprCompute(t->FuncCall.Actuals->ActualExpr.Expr);
                }

/* line 7835 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 7836 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 7837 "new_C.puma" */
   CodeExprWrite (t->FuncCall.Actuals->ActualExpr.Expr, ASSIGN_PREC);
/* line 7838 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 7839 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
END_RULE;
   return;
yyL26:;

  }
  }
  }
/* line 7842 "new_C.puma" */
  {
/* line 7843 "new_C.puma" */
BEGIN_RULE(292);
/* line 7845 "new_C.puma" */
   CodeDesignatorCompute (t->FuncCall.Designator);
/* line 7846 "new_C.puma" */

                if (t->FuncCall.Actuals->Actuals.UseHelpVar) {
                  CodeActualsCompute(t->FuncCall.Actuals);
                }
                CodeVectorLoopBegin(t);
                CodeHelpVarAssignBegin(t);
                WRITESTRING("(*");
                CodeExprWrite(t->FuncCall.Designator, DEREF_PREC);
                WRITESTRING(")(");
                CodeActualsWrite(t->FuncCall.Actuals);
                WRITESTRING(")");
                CodeHelpVarAssignClose(t);
                CodeVectorLoopClose(t);
                if (t->FuncCall.Actuals->Actuals.UseHelpVar) {
                  CodeActualsRestoreVars(t->FuncCall.Actuals);
                }

  }
END_RULE;
   return;

  case kMove:
/* line 7864 "new_C.puma" */
  {
/* line 7865 "new_C.puma" */
BEGIN_RULE(293);
/* line 7867 "new_C.puma" */
   CodeStmtsMove (t->Move.DirSpec, t->Move.Expr, t -> Move . HelpVar, t -> Move . Type);
  }
END_RULE;
   return;

  case kReceive:
/* line 7869 "new_C.puma" */
  {
/* line 7870 "new_C.puma" */
BEGIN_RULE(294);
/* line 7872 "new_C.puma" */
   CodeStmtsReceive (t->Receive.DirSpec, t->Receive.Expr, t -> Receive . HelpVar, t -> Receive . Type);
  }
END_RULE;
   return;

  case kReduce:
/* line 7874 "new_C.puma" */
 {
  tIdent BoolId;
  CHARBUF ReduceFunction;
  {
/* line 7875 "new_C.puma" */
BEGIN_RULE(295);
/* line 7877 "new_C.puma" */

/* line 7878 "new_C.puma" */

/* line 7879 "new_C.puma" */

                BoolId = GenIdents_HelpVar();
                if (t->Reduce.Expr->Expr.UseHelpVar) {
                  CodeExprCompute(t->Reduce.Expr);
                }
                WRITEBLANKS();
                WRITESTRING("{ BOOLEAN ");
                WRITEIDENT(BoolId);
                WRITESTRING(" = FALSE;");
	        WRITELN();
                TAB(1);
                  CodeStmtsVectorLoopBegin(t->Reduce.Expr);
                  WRITEBLANKS();
                  WRITESTRING("if (");
                  WRITEIDENT(BoolId);
                  WRITESTRING(") {");
	          WRITELN();
                  TAB(1);
                    CodeHelpVarAssignBegin(t);
                    GetString(t->Reduce.Reduce->Qualid.Ident, ReduceFunction);
                    if (strcmp(ReduceFunction, "SUM") == 0) {
                      WRITEIDENT(t->Qualid.HelpVar);
                      WRITESTRING(" + ");
                      CodeExprWrite(t->Reduce.Expr, PLUS_PREC);
                    } else if (strcmp(ReduceFunction, "PRODUCT") == 0) {
                      WRITEIDENT(t->Qualid.HelpVar);
                      WRITESTRING(" * ");
                      CodeExprWrite(t->Reduce.Expr, TIMES_PREC);
                    } else if (strcmp(ReduceFunction, "AND") == 0) {
                      WRITEIDENT(t->Qualid.HelpVar);
                      WRITESTRING(" && ");
                      CodeExprWrite(t->Reduce.Expr, AND_PREC);
                    } else if (strcmp(ReduceFunction, "OR") == 0) {
                      WRITEIDENT(t->Qualid.HelpVar);
                      WRITESTRING(" || ");
                      CodeExprWrite(t->Reduce.Expr, OR_PREC);
                    } else if (strcmp(ReduceFunction, "MAX") == 0) {
                      WRITESTRING("MAX(");
                      WRITEIDENT(t->Qualid.HelpVar);
                      WRITESTRING(", ");
                      CodeExprWrite(t->Reduce.Expr, PASSVALUE_PREC);
                      WRITESTRING(")");
                    } else if (strcmp(ReduceFunction, "MIN") == 0) {
                      WRITESTRING("MIN(");
                      WRITEIDENT(t->Qualid.HelpVar);
                      WRITESTRING(", ");
                      CodeExprWrite(t->Reduce.Expr, PASSVALUE_PREC);
                      WRITESTRING(")");
                    } else if (strcmp(ReduceFunction, "FIRST") == 0) {
                      WRITEIDENT(t->Qualid.HelpVar);
                    } else if (strcmp(ReduceFunction, "LAST") == 0) {
                      CodeExprWrite(t->Reduce.Expr, ASSIGN_PREC);
                    } else { 
                      WRITESTRING("*");
                      WRITEIDENT(t->Reduce.Reduce->Qualid.Object->SymObject.CIdent);
                      WRITESTRING("(&");
                      WRITEIDENT(t->Qualid.HelpVar);
                      WRITESTRING(", &");
                      CodeExprWrite(t->Reduce.Expr, PASSADDRESS_PREC);
                      WRITESTRING(", CONFIG_1)");
                    }
                    CodeHelpVarAssignClose(t);
                  DETAB(1);
                  WRITEBLANKS();
                  WRITESTRING("} else {");
	          WRITELN();
                  TAB(1);
                    WRITEBLANKS();
                    WRITEIDENT(BoolId);
                    WRITESTRING(" = TRUE;");
	            WRITELN();
                    WRITEBLANKS();
                    WRITEIDENT(t->Qualid.HelpVar);
                    WRITESTRING(" = ");
                    CodeExprWrite(t->Reduce.Expr, ASSIGN_PREC);
                    WRITESTRING(";");
	            WRITELN();
                  DETAB(1);
                  WRITEBLANKS();
                  WRITESTRING("}");
	          WRITELN();
                  CodeStmtsVectorLoopClose(t->Reduce.Expr);
                DETAB(1);
                WRITEBLANKS();
                WRITESTRING("}");
	        WRITELN();

  }
END_RULE;
   return;
 }

  case kSet:
  if (t->Set.Elems->Kind == kNoElem) {
/* line 7967 "new_C.puma" */
  {
/* line 7968 "new_C.puma" */
BEGIN_RULE(296);
/* line 7970 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 7971 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 7972 "new_C.puma" */
   WRITESTRING ("0X0L");
/* line 7973 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 7974 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
END_RULE;
   return;

  }
  if (Tree_IsType (t->Set.Elems, kElem)) {
/* line 7976 "new_C.puma" */
  {
/* line 7977 "new_C.puma" */
BEGIN_RULE(297);
/* line 7979 "new_C.puma" */
   CodeElemsCompute (t->Set.Elems);
/* line 7980 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 7981 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 7982 "new_C.puma" */
   CodeExprCompute (t->Set.Elems);
/* line 7983 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 7984 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
END_RULE;
   return;

  }
  break;
  case kBitSet:
  if (t->BitSet.Elems->Kind == kNoElem) {
/* line 7986 "new_C.puma" */
  {
/* line 7987 "new_C.puma" */
BEGIN_RULE(298);
/* line 7989 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 7990 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 7991 "new_C.puma" */
   WRITESTRING ("0X0L");
/* line 7992 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 7993 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
END_RULE;
   return;

  }
  if (Tree_IsType (t->BitSet.Elems, kElem)) {
/* line 7995 "new_C.puma" */
  {
/* line 7996 "new_C.puma" */
BEGIN_RULE(299);
/* line 7998 "new_C.puma" */
   CodeElemsCompute (t->BitSet.Elems);
/* line 7999 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 8000 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 8001 "new_C.puma" */
   CodeExprCompute (t->BitSet.Elems);
/* line 8002 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 8003 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
END_RULE;
   return;

  }
  break;
  case kQualid0:
/* line 8005 "new_C.puma" */
  {
/* line 8006 "new_C.puma" */
BEGIN_RULE(300);
/* line 8008 "new_C.puma" */
   if (! (t -> Qualid0 . IsGlobalPtr && Symbols_IsOpen (t -> Qualid0 . Type))) goto yyL35;
  {
/* line 8009 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 8010 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 8011 "new_C.puma" */
   WRITEIDENT (Pointer_GetGlobalPtr (t -> Qualid0 . Object));
/* line 8012 "new_C.puma" */
   CodeVectorIndex (t);
/* line 8013 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 8014 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
END_RULE;
   return;
yyL35:;

/* line 8016 "new_C.puma" */
  {
/* line 8017 "new_C.puma" */
BEGIN_RULE(301);
/* line 8019 "new_C.puma" */
   if (! (t -> Qualid0 . Object -> Kind == kSymField)) goto yyL36;
  {
/* line 8020 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 8021 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 8022 "new_C.puma" */
   WRITEIDENT (With_GetField (t->Qualid0.Ident));
/* line 8023 "new_C.puma" */
   WRITESTRING ("->");
/* line 8024 "new_C.puma" */
   CodeSelectors (t -> Qualid0 . Object -> SymField . Selectors);
/* line 8025 "new_C.puma" */
   WRITEIDENT (t -> Qualid0 . Object -> SymField . CIdent);
/* line 8026 "new_C.puma" */
   CodeVectorIndex (t);
/* line 8027 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 8028 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
END_RULE;
   return;
yyL36:;

  break;
  case kQualid1:
/* line 8030 "new_C.puma" */
  {
/* line 8031 "new_C.puma" */
BEGIN_RULE(302);
/* line 8034 "new_C.puma" */
   if (! (t->Qualid1.Qualid -> Qualid . IsGlobalPtr && t->Qualid1.Qualid -> Qualid . Type -> Kind == kSymVector)) goto yyL37;
  {
/* line 8035 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 8036 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 8037 "new_C.puma" */
   WRITEIDENT (Pointer_GetGlobalPtr (t->Qualid1.Qualid -> Qualid . Object));
/* line 8038 "new_C.puma" */
   CodeVectorIndex (t->Qualid1.Qualid);
/* line 8039 "new_C.puma" */
   WRITESTRING (".");
/* line 8040 "new_C.puma" */
   CodeSelectors (Symbols_GetSelectors (t -> Qualid1 . Object));
/* line 8041 "new_C.puma" */
   WRITEIDENT (t -> Qualid1 . Object -> SymObject . CIdent);
/* line 8042 "new_C.puma" */
   CodeVectorIndex (t);
/* line 8043 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 8044 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
END_RULE;
   return;
yyL37:;

/* line 8046 "new_C.puma" */
  {
/* line 8047 "new_C.puma" */
BEGIN_RULE(303);
/* line 8049 "new_C.puma" */
   if (! (t->Qualid1.Qualid -> Qualid . IsGlobalPtr)) goto yyL38;
  {
/* line 8050 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 8051 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 8052 "new_C.puma" */
   WRITEIDENT (Pointer_GetGlobalPtr (t->Qualid1.Qualid -> Qualid . Object));
/* line 8053 "new_C.puma" */
   CodeVectorIndex (t->Qualid1.Qualid);
/* line 8054 "new_C.puma" */
   WRITESTRING ("->");
/* line 8055 "new_C.puma" */
   CodeSelectors (Symbols_GetSelectors (t -> Qualid1 . Object));
/* line 8056 "new_C.puma" */
   WRITEIDENT (t -> Qualid1 . Object -> SymObject . CIdent);
/* line 8057 "new_C.puma" */
   CodeVectorIndex (t);
/* line 8058 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 8059 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
END_RULE;
   return;
yyL38:;

/* line 8061 "new_C.puma" */
  {
/* line 8062 "new_C.puma" */
BEGIN_RULE(304);
/* line 8065 "new_C.puma" */
   if (! (Symbols_IsVAR (t->Qualid1.Qualid -> Qualid . Object) && t->Qualid1.Qualid -> Qualid . Type -> Kind == kSymVector)) goto yyL39;
  {
/* line 8066 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 8067 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 8068 "new_C.puma" */
   WRITEIDENT (t->Qualid1.Qualid -> Qualid . Object -> SymVar . CIdent);
/* line 8069 "new_C.puma" */
   CodeVectorIndex (t->Qualid1.Qualid);
/* line 8070 "new_C.puma" */
   WRITESTRING (".");
/* line 8071 "new_C.puma" */
   CodeSelectors (Symbols_GetSelectors (t -> Qualid1 . Object));
/* line 8072 "new_C.puma" */
   WRITEIDENT (t -> Qualid1 . Object -> SymObject . CIdent);
/* line 8073 "new_C.puma" */
   CodeVectorIndex (t);
/* line 8074 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 8075 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
END_RULE;
   return;
yyL39:;

/* line 8077 "new_C.puma" */
  {
/* line 8078 "new_C.puma" */
BEGIN_RULE(305);
/* line 8080 "new_C.puma" */
   if (! ((Symbols_IsVAR (t->Qualid1.Qualid -> Qualid . Object)))) goto yyL40;
  {
/* line 8081 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 8082 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 8083 "new_C.puma" */
   WRITEIDENT (t->Qualid1.Qualid -> Qualid . Object -> SymVar . CIdent);
/* line 8084 "new_C.puma" */
   CodeVectorIndex (t->Qualid1.Qualid);
/* line 8085 "new_C.puma" */
   WRITESTRING ("->");
/* line 8086 "new_C.puma" */
   CodeSelectors (Symbols_GetSelectors (t -> Qualid1 . Object));
/* line 8087 "new_C.puma" */
   WRITEIDENT (t -> Qualid1 . Object -> SymObject . CIdent);
/* line 8088 "new_C.puma" */
   CodeVectorIndex (t);
/* line 8089 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 8090 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
END_RULE;
   return;
yyL40:;

/* line 8092 "new_C.puma" */
  {
/* line 8093 "new_C.puma" */
BEGIN_RULE(306);
/* line 8095 "new_C.puma" */
   if (! (t -> Qualid1 . Object -> Kind == kSymField)) goto yyL41;
  {
/* line 8096 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 8097 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 8098 "new_C.puma" */
   CodeExprCompute (t->Qualid1.Qualid);
/* line 8099 "new_C.puma" */
   WRITESTRING (".");
/* line 8100 "new_C.puma" */
   CodeSelectors (t -> Qualid1 . Object -> SymField . Selectors);
/* line 8101 "new_C.puma" */
   WRITEIDENT (t -> Qualid1 . Object -> SymField . CIdent);
/* line 8102 "new_C.puma" */
   CodeVectorIndex (t);
/* line 8103 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 8104 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
END_RULE;
   return;
yyL41:;

  break;
  }


  switch (t->Kind) {
  case kQualid:
  case kQualid0:
  case kQualid1:
/* line 8106 "new_C.puma" */
  {
/* line 8107 "new_C.puma" */
BEGIN_RULE(307);
/* line 8110 "new_C.puma" */
   if (! (t -> Qualid . IsGlobalPtr && t -> Qualid . Type -> Kind == kSymVector)) goto yyL42;
  {
/* line 8111 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 8112 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 8113 "new_C.puma" */
   WRITEIDENT (Pointer_GetGlobalPtr (t -> Qualid . Object));
/* line 8114 "new_C.puma" */
   CodeVectorIndex (t);
/* line 8115 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 8116 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
END_RULE;
   return;
yyL42:;

/* line 8118 "new_C.puma" */
  {
/* line 8119 "new_C.puma" */
BEGIN_RULE(308);
/* line 8121 "new_C.puma" */
   if (! (t -> Qualid . IsGlobalPtr)) goto yyL43;
  {
/* line 8122 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 8123 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 8124 "new_C.puma" */
   WRITESTRING ("*");
/* line 8125 "new_C.puma" */
   WRITEIDENT (Pointer_GetGlobalPtr (t -> Qualid . Object));
/* line 8126 "new_C.puma" */
   CodeVectorIndex (t);
/* line 8127 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 8128 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
END_RULE;
   return;
yyL43:;

/* line 8130 "new_C.puma" */
  {
/* line 8131 "new_C.puma" */
BEGIN_RULE(309);
/* line 8133 "new_C.puma" */
   if (! (Symbols_IsVAR (t -> Qualid . Object) && ! (Symbols_IsOpen (t -> Qualid . Type)) && t -> Qualid . Type -> Kind == kSymVector)) goto yyL44;
  {
/* line 8134 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 8135 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 8136 "new_C.puma" */
   WRITEIDENT (t -> Qualid . Object -> SymVar . CIdent);
/* line 8137 "new_C.puma" */
   CodeVectorIndex (t);
/* line 8138 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 8139 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
END_RULE;
   return;
yyL44:;

/* line 8141 "new_C.puma" */
  {
/* line 8142 "new_C.puma" */
BEGIN_RULE(310);
/* line 8144 "new_C.puma" */
   if (! (Symbols_IsVAR (t -> Qualid . Object) && ! (Symbols_IsOpen (t -> Qualid . Type)))) goto yyL45;
  {
/* line 8145 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 8146 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 8147 "new_C.puma" */
   WRITESTRING ("*");
/* line 8148 "new_C.puma" */
   WRITEIDENT (t -> Qualid . Object -> SymVar . CIdent);
/* line 8149 "new_C.puma" */
   CodeVectorIndex (t);
/* line 8150 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 8151 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
END_RULE;
   return;
yyL45:;

/* line 8153 "new_C.puma" */
  {
/* line 8154 "new_C.puma" */
BEGIN_RULE(311);
/* line 8156 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 8157 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 8158 "new_C.puma" */
   WRITEIDENT (t -> Qualid . Object -> SymObject . CIdent);
/* line 8159 "new_C.puma" */
   CodeVectorIndex (t);
/* line 8160 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 8161 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
END_RULE;
   return;

  case kProcessor:
/* line 8163 "new_C.puma" */
  {
/* line 8164 "new_C.puma" */
BEGIN_RULE(312);
/* line 8166 "new_C.puma" */
   CodeDesignatorCompute (t);
/* line 8167 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 8168 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 8169 "new_C.puma" */
   IncVectorLoopCalls ();
/* line 8171 "new_C.puma" */
   CodeExprCompute (t->Processor.Designator);
/* line 8175 "new_C.puma" */
   DecVectorLoopCalls ();
/* line 8176 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 8177 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
END_RULE;
   return;

  case kDimensions:
/* line 8179 "new_C.puma" */
  {
/* line 8180 "new_C.puma" */
BEGIN_RULE(313);
/* line 8182 "new_C.puma" */
   CodeDesignatorCompute (t);
/* line 8183 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 8184 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 8185 "new_C.puma" */
   IncVectorLoopCalls ();
/* line 8187 "new_C.puma" */
   CodeExprCompute (t->Dimensions.Designator);
/* line 8191 "new_C.puma" */
   DecVectorLoopCalls ();
/* line 8192 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 8193 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
END_RULE;
   return;

  case kSubscript:
  if (t->Subscript.Designator->Kind == kQualid0) {
/* line 8195 "new_C.puma" */
  {
/* line 8196 "new_C.puma" */
BEGIN_RULE(314);
/* line 8198 "new_C.puma" */
   if (! ((Symbols_IsOpenArray (t->Subscript.Designator -> Qualid0 . Object)))) goto yyL49;
  {
/* line 8199 "new_C.puma" */
   CodeDesignatorCompute (t);
/* line 8200 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 8201 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 8202 "new_C.puma" */
   CodeExprCompute (t->Subscript.Designator);
/* line 8203 "new_C.puma" */
   WRITESTRING ("[");
/* line 8204 "new_C.puma" */
   CodeExprWrite (t->Subscript.Index, MINPREC_PREC);
/* line 8205 "new_C.puma" */
   WRITESTRING ("]");
/* line 8206 "new_C.puma" */
   CodeVectorIndex (t);
/* line 8207 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 8208 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
END_RULE;
   return;
yyL49:;

  }
  if (t->Subscript.Designator->Kind == kDeref) {
/* line 8210 "new_C.puma" */
 {
  tValue Lwb;
  {
/* line 8211 "new_C.puma" */
BEGIN_RULE(315);
/* line 8213 "new_C.puma" */
   if (! (! (t->Subscript.Designator->Deref.Designator -> Designator . Type -> Kind == kSymOpaqueType))) goto yyL50;
  {
/* line 8214 "new_C.puma" */

/* line 8215 "new_C.puma" */
   CodeDesignatorCompute (t);
/* line 8216 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 8217 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 8218 "new_C.puma" */
   Types_GetLwb (Symbols_GetIndexType (t->Subscript.Designator -> Deref . Type), & Lwb);
/* line 8219 "new_C.puma" */
   CodeExprCompute (t->Subscript.Designator->Deref.Designator);
/* line 8220 "new_C.puma" */
   CodeVectorIndex (t->Subscript.Designator);
/* line 8221 "new_C.puma" */
   WRITESTRING ("->A[");
/* line 8222 "new_C.puma" */

                if (Values_ValueToInt(&Lwb) != Values_Zero.value.cardinalValue) {
                  CodeExprWrite(t->Subscript.Index, MINUS_PREC + 1);
                  WRITESTRING(" - ");
                  CodeValue (Lwb);
                } else {
                  CodeExprWrite(t->Subscript.Index, MINPREC_PREC);
                };

/* line 8231 "new_C.puma" */
   WRITESTRING ("]");
/* line 8232 "new_C.puma" */
   CodeVectorIndex (t);
/* line 8233 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 8234 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
END_RULE;
   return;
 }
yyL50:;

  }
  if (Tree_IsType (t->Subscript.Designator, kQualid)) {
/* line 8236 "new_C.puma" */
 {
  tValue Lwb;
  {
/* line 8237 "new_C.puma" */
BEGIN_RULE(316);
/* line 8241 "new_C.puma" */
   if (! (t->Subscript.Designator -> Qualid . IsGlobalPtr && ! (Symbols_IsOpen (t->Subscript.Designator -> Qualid . Type)) && t->Subscript.Designator -> Qualid . Type -> Kind == kSymVector)) goto yyL51;
  {
/* line 8242 "new_C.puma" */

/* line 8243 "new_C.puma" */
   CodeDesignatorCompute (t);
/* line 8244 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 8245 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 8246 "new_C.puma" */

                Types_GetLwb(Symbols_GetIndexType(t->Subscript.Designator->Qualid.Type), &Lwb);
                WRITEIDENT(Pointer_GetGlobalPtr(t->Subscript.Designator->Qualid.Object));
                CodeVectorIndex(t->Subscript.Designator);
                WRITESTRING(".A[");
                if (Values_ValueToInt(&Lwb) != Values_Zero.value.cardinalValue) {
                  CodeExprWrite(t->Subscript.Index, MINUS_PREC + 1);
                  WRITESTRING(" - ");
                  CodeValue(Lwb);
                } else {
                  CodeExprWrite(t->Subscript.Index, MINPREC_PREC);
                };
                WRITESTRING("]");

/* line 8260 "new_C.puma" */
   CodeVectorIndex (t);
/* line 8261 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 8262 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
END_RULE;
   return;
 }
yyL51:;

/* line 8264 "new_C.puma" */
 {
  tValue Lwb;
  {
/* line 8265 "new_C.puma" */
BEGIN_RULE(317);
/* line 8267 "new_C.puma" */
   if (! ((t->Subscript.Designator -> Qualid . IsGlobalPtr && ! (Symbols_IsOpen (t->Subscript.Designator -> Qualid . Type))))) goto yyL52;
  {
/* line 8269 "new_C.puma" */

/* line 8270 "new_C.puma" */
   CodeDesignatorCompute (t);
/* line 8271 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 8272 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 8273 "new_C.puma" */

                Types_GetLwb(Symbols_GetIndexType(t->Subscript.Designator->Qualid.Type), &Lwb);
                WRITEIDENT(Pointer_GetGlobalPtr(t->Subscript.Designator->Qualid.Object));
                CodeVectorIndex(t->Subscript.Designator);
                WRITESTRING("->A[");
                if (Values_ValueToInt(&Lwb) != Values_Zero.value.cardinalValue) {
                  CodeExprWrite(t->Subscript.Index, MINUS_PREC + 1);
                  WRITESTRING(" - ");
                  CodeValue(Lwb);
                } else {
                  CodeExprWrite(t->Subscript.Index, MINPREC_PREC);
                };
                WRITESTRING("]");

/* line 8287 "new_C.puma" */
   CodeVectorIndex (t);
/* line 8288 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 8289 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
END_RULE;
   return;
 }
yyL52:;

/* line 8291 "new_C.puma" */
 {
  tValue Lwb;
  {
/* line 8292 "new_C.puma" */
BEGIN_RULE(318);
/* line 8296 "new_C.puma" */
   if (! (Symbols_IsVAR (t->Subscript.Designator -> Qualid . Object) && ! (Symbols_IsOpen (t->Subscript.Designator -> Qualid . Type)) && t->Subscript.Designator -> Qualid . Type -> Kind == kSymVector)) goto yyL53;
  {
/* line 8297 "new_C.puma" */

/* line 8298 "new_C.puma" */
   CodeDesignatorCompute (t);
/* line 8299 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 8300 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 8301 "new_C.puma" */

                Types_GetLwb(Symbols_GetIndexType(t->Subscript.Designator->Qualid.Type), &Lwb);
                WRITEIDENT(t->Subscript.Designator->Qualid.Object->SymVar.CIdent);
                CodeVectorIndex(t->Subscript.Designator);
                WRITESTRING(".A[");
                if (Values_ValueToInt(&Lwb) != Values_Zero.value.cardinalValue) {
                  CodeExprWrite(t->Subscript.Index, MINUS_PREC + 1);
                  WRITESTRING(" - ");
                  CodeValue (Lwb);
                } else {
                  CodeExprWrite(t->Subscript.Index, MINPREC_PREC);
                };
                WRITESTRING("]");

/* line 8315 "new_C.puma" */
   CodeVectorIndex (t);
/* line 8316 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 8317 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
END_RULE;
   return;
 }
yyL53:;

/* line 8319 "new_C.puma" */
 {
  tValue Lwb;
  {
/* line 8320 "new_C.puma" */
BEGIN_RULE(319);
/* line 8322 "new_C.puma" */
   if (! (Symbols_IsVAR (t->Subscript.Designator -> Qualid . Object) && ! (Symbols_IsOpen (t->Subscript.Designator -> Qualid . Type)))) goto yyL54;
  {
/* line 8324 "new_C.puma" */

/* line 8325 "new_C.puma" */
   CodeDesignatorCompute (t);
/* line 8326 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 8327 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 8328 "new_C.puma" */

                Types_GetLwb(Symbols_GetIndexType(t->Subscript.Designator->Qualid.Type), &Lwb);
                WRITEIDENT(t->Subscript.Designator->Qualid.Object->SymVar.CIdent);
                CodeVectorIndex(t->Subscript.Designator);
                WRITESTRING("->A[");
                if (Values_ValueToInt(&Lwb) != Values_Zero.value.cardinalValue) {
                  CodeExprWrite(t->Subscript.Index, MINUS_PREC + 1);
                  WRITESTRING(" - ");
                  CodeValue (Lwb);
                } else {
                  CodeExprWrite(t->Subscript.Index, MINPREC_PREC);
                };
                WRITESTRING("]");

/* line 8342 "new_C.puma" */
   CodeVectorIndex (t);
/* line 8343 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 8344 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
END_RULE;
   return;
 }
yyL54:;

  }
/* line 8346 "new_C.puma" */
 {
  tValue Lwb;
  {
/* line 8347 "new_C.puma" */
BEGIN_RULE(320);
/* line 8349 "new_C.puma" */

/* line 8350 "new_C.puma" */
   CodeDesignatorCompute (t);
/* line 8351 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 8352 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 8353 "new_C.puma" */

                Types_GetLwb(Symbols_GetIndexType(t->Subscript.Designator->Designator.Type), &Lwb);
                CodeExprCompute(t->Subscript.Designator);
                WRITESTRING(".A[");
                if ( Values_ValueToInt( &Lwb ) != Values_Zero.value.cardinalValue ) {
                  CodeExprWrite(t->Subscript.Index, MINUS_PREC + 1);
                  WRITESTRING(" - ");
                  CodeValue ( Lwb );
                } else {
                  CodeExprWrite( t->Subscript.Index, MINPREC_PREC );
                };
                WRITESTRING("]");

/* line 8366 "new_C.puma" */
   CodeVectorIndex (t);
/* line 8367 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 8368 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
END_RULE;
   return;
 }

  case kSelect:
  if (t->Select.Designator->Kind == kDeref) {
/* line 8370 "new_C.puma" */
 {
  tObject Object;
  {
/* line 8371 "new_C.puma" */
BEGIN_RULE(321);
/* line 8373 "new_C.puma" */
   if (! (t->Select.Designator->Deref.Designator -> Designator . Type -> Kind == kSymOpaqueType)) goto yyL56;
  {
/* line 8374 "new_C.puma" */

/* line 8375 "new_C.puma" */
   if (! (Object = t->Select.Designator->Deref.Designator -> Designator . Type -> SymConstructor . TypeObj)) goto yyL56;
  {
/* line 8376 "new_C.puma" */
   CodeDesignatorCompute (t);
/* line 8377 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 8378 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 8379 "new_C.puma" */
   WRITESTRING ("((");
/* line 8380 "new_C.puma" */
   WRITEIDENT (GenIdents_Opaque (Object -> SymObject . CIdent));
/* line 8381 "new_C.puma" */
   WRITESTRING (")");
/* line 8382 "new_C.puma" */
   CodeExprWrite (t->Select.Designator->Deref.Designator, CAST_PREC);
/* line 8383 "new_C.puma" */
   WRITESTRING (")");
/* line 8384 "new_C.puma" */
   CodeVectorIndex (t->Select.Designator);
/* line 8385 "new_C.puma" */
   WRITESTRING ("->");
/* line 8386 "new_C.puma" */
   CodeSelectors (Symbols_GetSelectors (t -> Select . Object));
/* line 8387 "new_C.puma" */
   WRITEIDENT (t -> Select . Object -> SymObject . CIdent);
/* line 8388 "new_C.puma" */
   CodeVectorIndex (t);
/* line 8389 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 8390 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
  }
END_RULE;
   return;
 }
yyL56:;

/* line 8392 "new_C.puma" */
  {
/* line 8393 "new_C.puma" */
BEGIN_RULE(322);
/* line 8395 "new_C.puma" */
   CodeDesignatorCompute (t);
/* line 8396 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 8397 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 8398 "new_C.puma" */
   CodeExprCompute (t->Select.Designator->Deref.Designator);
/* line 8399 "new_C.puma" */
   CodeVectorIndex (t->Select.Designator);
/* line 8400 "new_C.puma" */
   WRITESTRING ("->");
/* line 8401 "new_C.puma" */
   CodeSelectors (Symbols_GetSelectors (t -> Select . Object));
/* line 8402 "new_C.puma" */
   WRITEIDENT (t -> Select . Object -> SymObject . CIdent);
/* line 8403 "new_C.puma" */
   CodeVectorIndex (t);
/* line 8404 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 8405 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
END_RULE;
   return;

  }
/* line 8407 "new_C.puma" */
  {
/* line 8408 "new_C.puma" */
BEGIN_RULE(323);
/* line 8410 "new_C.puma" */
   CodeDesignatorCompute (t);
/* line 8411 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 8412 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 8413 "new_C.puma" */
   CodeExprCompute (t->Select.Designator);
/* line 8414 "new_C.puma" */
   WRITESTRING (".");
/* line 8415 "new_C.puma" */
   CodeSelectors (Symbols_GetSelectors (t -> Select . Object));
/* line 8416 "new_C.puma" */
   WRITEIDENT (t -> Select . Object -> SymObject . CIdent);
/* line 8417 "new_C.puma" */
   CodeVectorIndex (t);
/* line 8418 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 8419 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
END_RULE;
   return;

  case kDeref:
/* line 8421 "new_C.puma" */
 {
  tObject Object;
  {
/* line 8422 "new_C.puma" */
BEGIN_RULE(324);
/* line 8424 "new_C.puma" */
   if (! (t->Deref.Designator -> Designator . Type -> Kind == kSymOpaqueType)) goto yyL59;
  {
/* line 8425 "new_C.puma" */

/* line 8426 "new_C.puma" */
   CodeDesignatorCompute (t);
/* line 8427 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 8428 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 8429 "new_C.puma" */
   if (! (Object = t->Deref.Designator -> Designator . Type -> SymConstructor . TypeObj)) goto yyL59;
  {
/* line 8430 "new_C.puma" */
   WRITESTRING ("*(");
/* line 8431 "new_C.puma" */
   WRITEIDENT (GenIdents_Opaque (Object -> SymObject . CIdent));
/* line 8432 "new_C.puma" */
   WRITESTRING (")");
/* line 8433 "new_C.puma" */
   CodeExprCompute (t->Deref.Designator);
/* line 8434 "new_C.puma" */
   CodeVectorIndex (t);
/* line 8435 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 8436 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
  }
  }
END_RULE;
   return;
 }
yyL59:;

/* line 8438 "new_C.puma" */
  {
/* line 8439 "new_C.puma" */
BEGIN_RULE(325);
/* line 8441 "new_C.puma" */
   CodeDesignatorCompute (t);
/* line 8442 "new_C.puma" */
   CodeVectorLoopBegin (t);
/* line 8443 "new_C.puma" */
   CodeHelpVarAssignBegin (t);
/* line 8444 "new_C.puma" */
   WRITESTRING ("*");
/* line 8445 "new_C.puma" */
   CodeExprCompute (t->Deref.Designator);
/* line 8446 "new_C.puma" */
   CodeVectorIndex (t);
/* line 8447 "new_C.puma" */
   CodeHelpVarAssignClose (t);
/* line 8448 "new_C.puma" */
   CodeVectorLoopClose (t);
  }
END_RULE;
   return;

  case kElemExpr:
/* line 8453 "new_C.puma" */
  {
/* line 8454 "new_C.puma" */
BEGIN_RULE(326);
/* line 8456 "new_C.puma" */
   WRITESTRING ("SET_ELEM(");
/* line 8457 "new_C.puma" */
   CodeExprWrite (t->ElemExpr.Elem, PASSVALUE_PREC);
/* line 8458 "new_C.puma" */
   WRITESTRING (")");
/* line 8459 "new_C.puma" */
   CodeSepa (t->ElemExpr.Next);
/* line 8460 "new_C.puma" */
   CodeExprCompute (t->ElemExpr.Next);
  }
END_RULE;
   return;

  case kElemRange:
/* line 8462 "new_C.puma" */
  {
/* line 8463 "new_C.puma" */
BEGIN_RULE(327);
/* line 8465 "new_C.puma" */
   if (! (t->ElemRange.Lwb -> Expr . IsCConst && t->ElemRange.Upb -> Expr . IsCConst)) goto yyL62;
  {
/* line 8466 "new_C.puma" */
   WRITESTRING ("SET_cRNG(");
/* line 8467 "new_C.puma" */
   CodeExprWrite (t->ElemRange.Lwb, PASSVALUE_PREC);
/* line 8468 "new_C.puma" */
   WRITESTRING (", ");
/* line 8469 "new_C.puma" */
   CodeExprWrite (t->ElemRange.Upb, PASSVALUE_PREC);
/* line 8470 "new_C.puma" */
   WRITESTRING (")");
/* line 8471 "new_C.puma" */
   CodeSepa (t->ElemRange.Next);
/* line 8472 "new_C.puma" */
   CodeExprCompute (t->ElemRange.Next);
  }
  }
END_RULE;
   return;
yyL62:;

/* line 8474 "new_C.puma" */
  {
/* line 8475 "new_C.puma" */
BEGIN_RULE(328);
/* line 8477 "new_C.puma" */
   WRITESTRING ("SET_RANGE(");
/* line 8478 "new_C.puma" */
   CodeExprWrite (t->ElemRange.Lwb, PASSVALUE_PREC);
/* line 8479 "new_C.puma" */
   WRITESTRING (", ");
/* line 8480 "new_C.puma" */
   CodeExprWrite (t->ElemRange.Upb, PASSVALUE_PREC);
/* line 8481 "new_C.puma" */
   WRITESTRING (")");
/* line 8482 "new_C.puma" */
   CodeSepa (t->ElemRange.Next);
/* line 8483 "new_C.puma" */
   CodeExprCompute (t->ElemRange.Next);
  }
END_RULE;
   return;

  }

/* line 8485 "new_C.puma" */
  {
/* line 8486 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeAdr
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 8492 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kDeref) {
/* line 8499 "new_C.puma" */
  {
/* line 8500 "new_C.puma" */
BEGIN_RULE(329);
/* line 8502 "new_C.puma" */
   CodeExpr (t->Deref.Designator, MINPREC_PREC);
  }
END_RULE;
   return;

  }
  if (Tree_IsType (t, kQualid)) {
/* line 8504 "new_C.puma" */
  {
/* line 8505 "new_C.puma" */
BEGIN_RULE(330);
/* line 8507 "new_C.puma" */
   if (! (t -> Qualid . IsGlobalPtr)) goto yyL2;
  {
/* line 8508 "new_C.puma" */
   WRITEIDENT (Pointer_GetGlobalPtr (t -> Qualid . Object));
  }
  }
END_RULE;
   return;
yyL2:;

  }
  if (t->Kind == kQualid0) {
/* line 8510 "new_C.puma" */
  {
/* line 8511 "new_C.puma" */
BEGIN_RULE(331);
/* line 8513 "new_C.puma" */
   if (! ((Symbols_IsVAR (t -> Qualid0 . Object) && t -> Qualid0 . Type -> Kind != kSymVector))) goto yyL3;
  {
/* line 8514 "new_C.puma" */
   WRITEIDENT (t -> Qualid0 . Object -> SymVar . CIdent);
  }
  }
END_RULE;
   return;
yyL3:;

  }
/* line 8516 "new_C.puma" */
  {
/* line 8517 "new_C.puma" */
BEGIN_RULE(332);
/* line 8519 "new_C.puma" */
   WRITESTRING ("&");
/* line 8520 "new_C.puma" */
   CodeExpr (t, ADR_PREC);
  }
END_RULE;
   return;

;
}

static void CodeString2
# if defined __STDC__ | defined __cplusplus
(register tTree t, BOOLEAN Strncpy)
# else
(t, Strncpy)
 register tTree t;
 BOOLEAN Strncpy;
# endif
{
/* line 8529 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kStringConst) {
/* line 8539 "new_C.puma" */
  {
/* line 8540 "new_C.puma" */
BEGIN_RULE(333);
/* line 8542 "new_C.puma" */
               if ( Options_IsOptionSet (Options_eCasts) && !Strncpy ) {
                   WRITESTRING("(STRING)");
                };

/* line 8546 "new_C.puma" */
   CodeConstString (t->StringConst.StringVal);
  }
END_RULE;
   return;

  }
  if (t->Kind == kCharConst) {
/* line 8548 "new_C.puma" */
  {
/* line 8549 "new_C.puma" */
BEGIN_RULE(334);
/* line 8551 "new_C.puma" */
               if ( Options_IsOptionSet (Options_eCasts) && !Strncpy ) {
                   WRITESTRING("(STRING)");
                };

/* line 8555 "new_C.puma" */
   CodeConstChar (t->CharConst.CharVal);
  }
END_RULE;
   return;

  }
  if (Tree_IsType (t, kQualid)) {
/* line 8557 "new_C.puma" */
  {
/* line 8558 "new_C.puma" */
BEGIN_RULE(335);
/* line 8560 "new_C.puma" */
   if (! (t -> Qualid . Type == TypeString)) goto yyL3;
  {
/* line 8561 "new_C.puma" */
               if (Options_IsOptionSet (Options_eCasts) && !Strncpy ) {
                   WRITESTRING("(char *)");
                };

/* line 8565 "new_C.puma" */
   WRITEIDENT (t -> Qualid . Object -> SymObject . CIdent);
  }
  }
END_RULE;
   return;
yyL3:;

/* line 8567 "new_C.puma" */
  {
/* line 8568 "new_C.puma" */
BEGIN_RULE(336);
/* line 8570 "new_C.puma" */
   if (! (t -> Qualid . Type == TypeStringChar)) goto yyL4;
  {
/* line 8571 "new_C.puma" */
               if (Options_IsOptionSet (Options_eCasts) && !Strncpy ) {
                   WRITESTRING("(STRING)");
                };

/* line 8575 "new_C.puma" */
   CodeConstChar (t -> Qualid . Object -> SymConst . Value . value . charValue);
  }
  }
END_RULE;
   return;
yyL4:;

/* line 8577 "new_C.puma" */
  {
/* line 8578 "new_C.puma" */
BEGIN_RULE(337);
/* line 8580 "new_C.puma" */
   if (! (t -> Qualid . Type == TypeCHAR)) goto yyL5;
  {
/* line 8581 "new_C.puma" */
               if (Options_IsOptionSet (Options_eCasts) && !Strncpy ) {
                   WRITESTRING("(STRING)");
                };

/* line 8585 "new_C.puma" */
   CodeConstChar (t -> Qualid . Object -> SymConst . Value . value . charValue);
  }
  }
END_RULE;
   return;
yyL5:;

  }
/* line 8587 "new_C.puma" */
  {
/* line 8588 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeStmts
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 8594 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif


  switch (t->Kind) {
  case kAssign:
/* line 8601 "new_C.puma" */
  {
/* line 8602 "new_C.puma" */
BEGIN_RULE(338);
/* line 8604 "new_C.puma" */
   if (! ((t->Assign.Designator -> Designator . Type -> Kind == kSymArray) && ((t->Assign.Expr -> Expr . Type == TypeStringChar) || (t->Assign.Expr -> Expr . Type == TypeString)))) goto yyL1;
  {
/* line 8607 "new_C.puma" */
   SetDebugLine (t->Assign.Pos);
/* line 8608 "new_C.puma" */
   WRITEBLANKS ();
/* line 8609 "new_C.puma" */
   WRITESTRING ("(void) strncpy(");
/* line 8610 "new_C.puma" */

                if (Options_IsOptionSet(Options_eCasts)) {
                  WRITESTRING("(char *)");
                };

/* line 8615 "new_C.puma" */
   CodeExprBegin (t->Assign.Expr);
/* line 8616 "new_C.puma" */
   CodeDesignatorBegin (t->Assign.Designator);
/* line 8617 "new_C.puma" */
   CodeDesignatorCompute (t->Assign.Designator);
/* line 8618 "new_C.puma" */
   CodeExpr (t->Assign.Designator, SELECT_PREC);
/* line 8619 "new_C.puma" */
   WRITESTRING (".A, ");
/* line 8620 "new_C.puma" */
   CodeString2 (t->Assign.Expr, STRNCPY);
/* line 8621 "new_C.puma" */
   WRITESTRING (", sizeof(");
/* line 8622 "new_C.puma" */
   CodeExpr (t->Assign.Designator, SELECT_PREC);
/* line 8623 "new_C.puma" */
   WRITESTRING (".A));");
/* line 8624 "new_C.puma" */
   WRITELN ();
/* line 8625 "new_C.puma" */
   CodeDesignatorClose (t->Assign.Designator);
/* line 8626 "new_C.puma" */
   CodeExprClose (t->Assign.Expr);
/* line 8627 "new_C.puma" */
   CodeStmts (t->Assign.Next);
  }
  }
END_RULE;
   return;
yyL1:;

/* line 8629 "new_C.puma" */
  {
/* line 8630 "new_C.puma" */
BEGIN_RULE(339);
/* line 8633 "new_C.puma" */
   if (! ((t->Assign.Designator -> Designator . Type -> Kind == kSymVector) && (t->Assign.Designator -> Designator . Type -> SymVector . Type -> Kind == kSymArray) && ((t->Assign.Expr -> Expr . Type == TypeStringChar) || (t->Assign.Expr -> Expr . Type == TypeString)))) goto yyL2;
  {
/* line 8636 "new_C.puma" */
   SetDebugLine (t->Assign.Pos);
/* line 8637 "new_C.puma" */
   CodeExprBegin (t->Assign.Expr);
/* line 8638 "new_C.puma" */
   CodeDesignatorBegin (t->Assign.Designator);
/* line 8639 "new_C.puma" */
   CodeDesignatorCompute (t->Assign.Designator);
/* line 8640 "new_C.puma" */
   CodeStmtsVectorLoopBegin (t->Assign.Designator);
/* line 8641 "new_C.puma" */
   WRITEBLANKS ();
/* line 8642 "new_C.puma" */
   WRITESTRING ("(void) strncpy(");
/* line 8643 "new_C.puma" */

                if (Options_IsOptionSet(Options_eCasts)) {
                  WRITESTRING("(char *)");
                };

/* line 8648 "new_C.puma" */
   CodeExpr (t->Assign.Designator, SELECT_PREC);
/* line 8649 "new_C.puma" */
   WRITESTRING (".A, ");
/* line 8650 "new_C.puma" */
   CodeString2 (t->Assign.Expr, STRNCPY);
/* line 8651 "new_C.puma" */
   WRITESTRING (", sizeof(");
/* line 8652 "new_C.puma" */
   CodeExpr (t->Assign.Designator, SELECT_PREC);
/* line 8653 "new_C.puma" */
   WRITESTRING (".A));");
/* line 8654 "new_C.puma" */
   WRITELN ();
/* line 8655 "new_C.puma" */
   CodeStmtsVectorLoopClose (t->Assign.Designator);
/* line 8656 "new_C.puma" */
   CodeDesignatorClose (t->Assign.Designator);
/* line 8657 "new_C.puma" */
   CodeExprClose (t->Assign.Expr);
/* line 8658 "new_C.puma" */
   CodeStmts (t->Assign.Next);
  }
  }
END_RULE;
   return;
yyL2:;

/* line 8660 "new_C.puma" */
  {
/* line 8661 "new_C.puma" */
BEGIN_RULE(340);
/* line 8663 "new_C.puma" */
   SetDebugLine (t->Assign.Pos);
/* line 8664 "new_C.puma" */
   CodeExprBegin (t->Assign.Expr);
/* line 8665 "new_C.puma" */
   CodeDesignatorBegin (t->Assign.Designator);
/* line 8666 "new_C.puma" */
   CodeDesignatorCompute (t->Assign.Designator);
/* line 8667 "new_C.puma" */
   CodeVectorLoopBegin (t->Assign.Designator);
/* line 8668 "new_C.puma" */
   WRITEBLANKS ();
/* line 8669 "new_C.puma" */
   CodeExpr (t->Assign.Designator, ASSIGN_PREC);
/* line 8670 "new_C.puma" */
   WRITESTRING (" = ");
/* line 8671 "new_C.puma" */

                if (Types_Cast(Code_Assign, t->Assign.Designator->Designator.Type, t->Assign.Expr->Expr.Type)) {
                  CodeCast(t->Assign.Designator->Designator.Type);
                }

/* line 8676 "new_C.puma" */
   CodeExprWrite (t->Assign.Expr, ASSIGN_PREC);
/* line 8677 "new_C.puma" */
   WRITESTRING (";");
/* line 8678 "new_C.puma" */
   WRITELN ();
/* line 8679 "new_C.puma" */
   CodeVectorLoopClose (t->Assign.Designator);
/* line 8680 "new_C.puma" */
   CodeDesignatorClose (t->Assign.Designator);
/* line 8681 "new_C.puma" */
   CodeExprClose (t->Assign.Expr);
/* line 8682 "new_C.puma" */
   CodeStmts (t->Assign.Next);
  }
END_RULE;
   return;

  case kCall:
/* line 8684 "new_C.puma" */
 {
  ULONG StdProc;
  {
/* line 8685 "new_C.puma" */
BEGIN_RULE(341);
/* line 8687 "new_C.puma" */
   if (! (t->Call.Designator -> Designator . Type -> Kind == kSymStdProcType)) goto yyL4;
  {
/* line 8688 "new_C.puma" */

/* line 8689 "new_C.puma" */
   SetDebugLine (t->Call.Pos);
/* line 8690 "new_C.puma" */
   CodeActualsBegin (t->Call.Actuals);
/* line 8691 "new_C.puma" */

                StdProc = t->Call.Designator->Designator.Type->SymStdProcType.StdProc;
                switch( StdProc ) {
                case eSystemNew    :
                case eSystemDispose:
                  WRITEBLANKS();
                  CodeStdProc(t->Call.Actuals, StdProc, t->Call.AllocOrDealloc);
                  WRITESTRING(";");
		  WRITELN();
                  break;
                case eSystemInc        :
                case eSystemDec        :
                case eSystemExcl       :
                case eSystemIncl       :
                  CodeVectorLoopBegin(t->Call.Actuals->ActualExpr.Expr);
                  WRITEBLANKS();
                  CodeStdProc(t->Call.Actuals, StdProc, NoObject);
                  WRITESTRING(";");
		  WRITELN();
                  CodeVectorLoopClose(t->Call.Actuals->ActualExpr.Expr);
                  if (t->Call.Actuals->ActualExpr.Expr->Expr.UseHelpVar) {
                    CodeVectorLoopBegin(t->Call.Actuals->ActualExpr.Expr);
                    WRITEBLANKS();
                    CodeExpr(t->Call.Actuals->ActualExpr.Expr, MINPREC_PREC);
                    WRITESTRING(" = ");
                    CodeHelpVarWrite(t->Call.Actuals->ActualExpr.Expr);
                    WRITESTRING(";");
		    WRITELN();
                    CodeVectorLoopClose(t->Call.Actuals->ActualExpr.Expr);
                  }
                  break;
                case eSystemRead       :
                case eSystemReadString :
                case eSystemReadInt    :
                case eSystemReadCard   :
                case eSystemReadReal   :
                case eSystemReadBoolean:
                  WRITEBLANKS();
                  CodeStdProc(t->Call.Actuals, StdProc, NoObject);
                  WRITESTRING(";");
		  WRITELN();
                  if (t->Call.Actuals->ActualExpr.UseHelpVar) {
                    CodeVectorLoopBegin(t->Call.Actuals->ActualExpr.Expr);
                    WRITEBLANKS();
                    CodeExpr(t->Call.Actuals->ActualExpr.Expr, MINPREC_PREC);
                    WRITESTRING(" = ");
                    CodeHelpVarWrite(t->Call.Actuals->ActualExpr.Expr);
                    WRITESTRING(";");
		    WRITELN();
                    CodeVectorLoopClose(t->Call.Actuals->ActualExpr.Expr);
                  }
                  break;
                default:
                  WRITEBLANKS();
                  CodeStdProc(t->Call.Actuals, StdProc, NoObject);
                  WRITESTRING(";");
		  WRITELN();
                };  

/* line 8750 "new_C.puma" */
   CodeActualsClose (t->Call.Actuals);
/* line 8751 "new_C.puma" */
   CodeStmts (t->Call.Next);
  }
  }
END_RULE;
   return;
 }
yyL4:;

  if (Tree_IsType (t->Call.Designator, kQualid)) {
/* line 8753 "new_C.puma" */
  {
/* line 8754 "new_C.puma" */
BEGIN_RULE(342);
/* line 8756 "new_C.puma" */
   if (! ((Symbols_IsProcedure (t->Call.Designator -> Qualid . Object)))) goto yyL5;
  {
/* line 8757 "new_C.puma" */

                SetDebugLine(t->Call.Pos);
                CodeActualsBegin(t->Call.Actuals);
                WRITEBLANKS();
                WRITEIDENT(t->Call.Designator->Qualid.Object->SymObject.CIdent);
                WRITESTRING("(");
                CodeActualsWrite(t->Call.Actuals);
                WRITESTRING(");");
		WRITELN();
                if (t->Call.Actuals->Actuals.UseHelpVar) {
                  CodeActualsRestoreVars(t->Call.Actuals);
                }
                CodeActualsClose(t->Call.Actuals);
                CodeStmts(t->Call.Next);

  }
  }
END_RULE;
   return;
yyL5:;

  }
/* line 8773 "new_C.puma" */
  {
/* line 8774 "new_C.puma" */
BEGIN_RULE(343);
/* line 8776 "new_C.puma" */

                SetDebugLine(t->Call.Pos);
                CodeDesignatorBegin(t->Call.Designator);
                CodeDesignatorCompute(t->Call.Designator);
                CodeActualsBegin(t->Call.Actuals);
                WRITEBLANKS();
                WRITESTRING("(*");
                CodeExpr(t->Call.Designator, DEREF_PREC);
                WRITESTRING(")(");
                CodeActualsWrite(t->Call.Actuals);
                WRITESTRING(");");
		WRITELN();
                if (t->Call.Actuals->Actuals.UseHelpVar) {
                  CodeActualsRestoreVars(t->Call.Actuals);
                }
                CodeActualsClose(t->Call.Actuals);
                CodeDesignatorClose(t->Call.Designator);
                CodeStmts (t->Call.Next);

  }
END_RULE;
   return;

  case kIf:
/* line 8796 "new_C.puma" */
 {
  tIdent Expression;
  {
/* line 8797 "new_C.puma" */
BEGIN_RULE(344);
/* line 8799 "new_C.puma" */
   if (! (t->If.Cond -> Expr . Type -> Kind == kSymVector)) goto yyL7;
  {
/* line 8800 "new_C.puma" */

/* line 8801 "new_C.puma" */
   if (! (Expression = GenIdents_HelpVar ())) goto yyL7;
  {
/* line 8802 "new_C.puma" */
   SetDebugLine (t->If.Pos);
/* line 8803 "new_C.puma" */
   CodePushActive (t->If.Cond);
/* line 8804 "new_C.puma" */
   WRITEBLANKS ();
/* line 8805 "new_C.puma" */
   WRITESTRING ("{ BOOLEAN *");
/* line 8806 "new_C.puma" */
   WRITEIDENT (Expression);
/* line 8807 "new_C.puma" */
   WRITESTRING (" = (BOOLEAN *) malloc(sizeof(BOOLEAN) * LEN(");
/* line 8808 "new_C.puma" */
   CodeWriteConfigName (t->If.Cond);
/* line 8809 "new_C.puma" */
   WRITESTRING ("));");
/* line 8810 "new_C.puma" */
   WRITELN ();
/* line 8811 "new_C.puma" */
   TAB (1);
/* line 8812 "new_C.puma" */
   CodeIfExpr (t->If.Cond, Expression);
/* line 8813 "new_C.puma" */
   CodeIf (t->If.Cond, Expression);
/* line 8815 "new_C.puma" */
   WRITEBLANKS ();
/* line 8816 "new_C.puma" */
   WRITESTRING ("if (IS_ANY_ACTIVE(");
/* line 8817 "new_C.puma" */
   CodeWriteConfigName (t->If.Cond);
/* line 8818 "new_C.puma" */
   WRITESTRING (")) {\n");
/* line 8819 "new_C.puma" */
   TAB (1);
/* line 8820 "new_C.puma" */
   CodeStmts (t->If.Then);
/* line 8821 "new_C.puma" */
   DETAB (1);
/* line 8822 "new_C.puma" */
   WRITEBLANKS ();
/* line 8823 "new_C.puma" */
   WRITESTRING ("}");
/* line 8825 "new_C.puma" */
   CodeStmtsElse (t->If.Elsifs, t->If.Else, TRUE, t->If.Cond, Expression);
/* line 8827 "new_C.puma" */
   WRITELN ();
/* line 8828 "new_C.puma" */
   WRITEBLANKS ();
/* line 8829 "new_C.puma" */
   WRITESTRING ("free(");
/* line 8830 "new_C.puma" */
   WRITEIDENT (Expression);
/* line 8831 "new_C.puma" */
   WRITESTRING (");");
/* line 8832 "new_C.puma" */
   WRITELN ();
/* line 8833 "new_C.puma" */
   DETAB (1);
/* line 8834 "new_C.puma" */
   WRITEBLANKS ();
/* line 8835 "new_C.puma" */
   WRITESTRING ("}");
/* line 8836 "new_C.puma" */
   WRITELN ();
/* line 8837 "new_C.puma" */
   CodePopActive (t->If.Cond);
/* line 8838 "new_C.puma" */
   CodeStmts (t->If.Next);
  }
  }
  }
END_RULE;
   return;
 }
yyL7:;

/* line 8840 "new_C.puma" */
  {
/* line 8841 "new_C.puma" */
BEGIN_RULE(345);
/* line 8843 "new_C.puma" */
   SetDebugLine (t->If.Pos);
/* line 8844 "new_C.puma" */
   CodeExprBegin (t->If.Cond);
/* line 8845 "new_C.puma" */
   WRITEBLANKS ();
/* line 8846 "new_C.puma" */
   WRITESTRING ("if (");
/* line 8847 "new_C.puma" */
   CodeExprWrite (t->If.Cond, MINPREC_PREC);
/* line 8848 "new_C.puma" */
   WRITESTRING (") {\n");
/* line 8849 "new_C.puma" */
   TAB (1);
/* line 8850 "new_C.puma" */
   CodeStmts (t->If.Then);
/* line 8851 "new_C.puma" */
   DETAB (1);
/* line 8852 "new_C.puma" */
   WRITEBLANKS ();
/* line 8853 "new_C.puma" */
   WRITESTRING ("}");
/* line 8854 "new_C.puma" */
   CodeStmtsElse (t->If.Elsifs, t->If.Else, FALSE, NoExpr, NoIdent);
/* line 8855 "new_C.puma" */
   WRITELN ();
/* line 8856 "new_C.puma" */
   CodeExprClose (t->If.Cond);
/* line 8857 "new_C.puma" */
   CodeStmts (t->If.Next);
  }
END_RULE;
   return;

  case kCase:
/* line 8859 "new_C.puma" */
 {
  tIdent Expression;
  {
/* line 8860 "new_C.puma" */
BEGIN_RULE(346);
/* line 8862 "new_C.puma" */
   if (! (t->Case.Expr -> Expr . Type -> Kind == kSymVector)) goto yyL9;
  {
/* line 8863 "new_C.puma" */

/* line 8864 "new_C.puma" */
   if (! (Expression = GenIdents_HelpVar ())) goto yyL9;
  {
/* line 8865 "new_C.puma" */
   SetDebugLine (t->Case.Pos);
/* line 8866 "new_C.puma" */
   CodePushActive (t->Case.Expr);
/* line 8867 "new_C.puma" */
   CodePushElse (t->Case.Expr);
/* line 8868 "new_C.puma" */
   WRITEBLANKS ();
/* line 8869 "new_C.puma" */
   WRITESTRING ("{ ");
/* line 8870 "new_C.puma" */
   CodeTypeName (t->Case.Expr -> Expr . Type);
/* line 8871 "new_C.puma" */
   WRITESTRING (" *");
/* line 8872 "new_C.puma" */
   WRITEIDENT (Expression);
/* line 8873 "new_C.puma" */
   WRITESTRING (" = (");
/* line 8874 "new_C.puma" */
   CodeTypeName (t->Case.Expr -> Expr . Type);
/* line 8875 "new_C.puma" */
   WRITESTRING (" *) malloc(sizeof(");
/* line 8876 "new_C.puma" */
   CodeTypeName (t->Case.Expr -> Expr . Type);
/* line 8877 "new_C.puma" */
   WRITESTRING (") * LEN(");
/* line 8878 "new_C.puma" */
   CodeWriteConfigName (t->Case.Expr);
/* line 8879 "new_C.puma" */
   WRITESTRING ("));");
/* line 8880 "new_C.puma" */
   WRITELN ();
/* line 8881 "new_C.puma" */
   TAB (1);
/* line 8882 "new_C.puma" */
   CodeExprBegin (t->Case.Expr);
/* line 8883 "new_C.puma" */
   CodeStmtsVectorLoopBegin (t->Case.Expr);
/* line 8884 "new_C.puma" */
   WRITEBLANKS ();
/* line 8885 "new_C.puma" */
   WRITEIDENT (Expression);
/* line 8886 "new_C.puma" */
   WRITESTRING ("[PE] = ");
/* line 8887 "new_C.puma" */
   CodeExprWrite (t->Case.Expr, ASSIGN_PREC);
/* line 8888 "new_C.puma" */
   WRITESTRING (";");
/* line 8889 "new_C.puma" */
   WRITELN ();
/* line 8890 "new_C.puma" */
   CodeStmtsVectorLoopClose (t->Case.Expr);
/* line 8891 "new_C.puma" */
   CodeExprClose (t->Case.Expr);
/* line 8892 "new_C.puma" */
   CodeStmtsCases (t->Case.Cases, t->Case.Expr, Expression);
/* line 8893 "new_C.puma" */

                  if (t->Case.Default) {
                    CodeCopyElse(t->Case.Expr);
                    WRITEBLANKS();
                    WRITESTRING("if (IS_ANY_ACTIVE(");
                    CodeWriteConfigName(t->Case.Expr);
                    WRITESTRING(")) {\n");
                    TAB(1);
                      CodeStmts(t->Case.Else);
                    DETAB(1);
                    WRITEBLANKS();
                    WRITESTRING("}");
		    WRITELN();
                  } else if (Options_IsOptionSet(Options_eChecks)) {
                    CodeCopyElse(t->Case.Expr);
                    WRITEBLANKS();
                    WRITESTRING("if (IS_ANY_ACTIVE(");
                    CodeWriteConfigName(t->Case.Expr);
                    WRITESTRING(")) {");
		    WRITELN();
                    TAB(1);
		      WRITEBLANKS();
                      WRITESTRING("CaseError(__FILE__, __LINE__); ");
		    WRITELN();
                    DETAB(1);
                    WRITEBLANKS();
                    WRITESTRING("}");
		    WRITELN();
                  }

/* line 8923 "new_C.puma" */
   WRITEBLANKS ();
/* line 8924 "new_C.puma" */
   WRITESTRING ("free(");
/* line 8925 "new_C.puma" */
   WRITEIDENT (Expression);
/* line 8926 "new_C.puma" */
   WRITESTRING (");");
/* line 8927 "new_C.puma" */
   WRITELN ();
/* line 8928 "new_C.puma" */
   DETAB (1);
/* line 8929 "new_C.puma" */
   WRITEBLANKS ();
/* line 8930 "new_C.puma" */
   WRITESTRING ("}");
/* line 8931 "new_C.puma" */
   WRITELN ();
/* line 8932 "new_C.puma" */
   CodePopElse (t->Case.Expr);
/* line 8933 "new_C.puma" */
   CodePopActive (t->Case.Expr);
/* line 8934 "new_C.puma" */
   CodeStmts (t->Case.Next);
  }
  }
  }
END_RULE;
   return;
 }
yyL9:;

  {BOOLEAN yyT; yyT = TRUE;
  if (equalBOOLEAN (t->Case.Default, yyT)) {
/* line 8936 "new_C.puma" */
  {
/* line 8937 "new_C.puma" */
BEGIN_RULE(347);
/* line 8939 "new_C.puma" */
   SetDebugLine (t->Case.Pos);
/* line 8940 "new_C.puma" */
   CodeExprBegin (t->Case.Expr);
/* line 8941 "new_C.puma" */
   WRITEBLANKS ();
/* line 8942 "new_C.puma" */
   WRITESTRING ("switch (");
/* line 8943 "new_C.puma" */
   CodeExprWrite (t->Case.Expr, MINPREC_PREC);
/* line 8944 "new_C.puma" */
   WRITESTRING (") {\n");
/* line 8945 "new_C.puma" */
   CodeStmts (t->Case.Cases);
/* line 8946 "new_C.puma" */
   WRITEBLANKS ();
/* line 8947 "new_C.puma" */
   WRITESTRING ("default:\n");
/* line 8948 "new_C.puma" */
   TAB (1);
/* line 8949 "new_C.puma" */
   CodeStmts (t->Case.Else);
/* line 8950 "new_C.puma" */
   WRITEBLANKS ();
/* line 8951 "new_C.puma" */
   WRITESTRING ("break;");
/* line 8952 "new_C.puma" */
   WRITELN ();
/* line 8953 "new_C.puma" */
   DETAB (1);
/* line 8954 "new_C.puma" */
   WRITEBLANKS ();
/* line 8955 "new_C.puma" */
   WRITESTRING ("}");
/* line 8956 "new_C.puma" */
   WRITELN ();
/* line 8957 "new_C.puma" */
   CodeExprClose (t->Case.Expr);
/* line 8958 "new_C.puma" */
   CodeStmts (t->Case.Next);
  }
END_RULE;
   return;

  }
  }
/* line 8960 "new_C.puma" */
  {
/* line 8961 "new_C.puma" */
BEGIN_RULE(348);
/* line 8963 "new_C.puma" */
   SetDebugLine (t->Case.Pos);
/* line 8964 "new_C.puma" */
   CodeExprBegin (t->Case.Expr);
/* line 8965 "new_C.puma" */
   WRITEBLANKS ();
/* line 8966 "new_C.puma" */
   WRITESTRING ("switch (");
/* line 8967 "new_C.puma" */
   CodeExprWrite (t->Case.Expr, MINPREC_PREC);
/* line 8968 "new_C.puma" */
   WRITESTRING (") {\n");
/* line 8969 "new_C.puma" */
   CodeStmts (t->Case.Cases);
/* line 8970 "new_C.puma" */

                if (Options_IsOptionSet(Options_eChecks)) {
                  WRITEBLANKS();
                  WRITESTRING("default:");
		  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("  CaseError(__FILE__, __LINE__); break;");
		  WRITELN();
                };

/* line 8980 "new_C.puma" */
   WRITEBLANKS ();
/* line 8981 "new_C.puma" */
   WRITESTRING ("}");
/* line 8982 "new_C.puma" */
   WRITELN ();
/* line 8983 "new_C.puma" */
   CodeExprClose (t->Case.Expr);
/* line 8984 "new_C.puma" */
   CodeStmts (t->Case.Next);
  }
END_RULE;
   return;

  case kWhile:
/* line 8986 "new_C.puma" */
  {
/* line 8987 "new_C.puma" */
BEGIN_RULE(349);
/* line 8989 "new_C.puma" */
   if (! (t->While.Cond -> Expr . Type -> Kind == kSymVector)) goto yyL12;
  {
/* line 8990 "new_C.puma" */
   SetDebugLine (t->While.Pos);
/* line 8991 "new_C.puma" */
   CodeExprBegin2 (t->While.Cond);
/* line 8992 "new_C.puma" */
   CodePushActive (t->While.Cond);
/* line 8993 "new_C.puma" */
   WRITEBLANKS ();
/* line 8994 "new_C.puma" */
   WRITESTRING ("while (IS_ANY_ACTIVE(");
/* line 8995 "new_C.puma" */
   CodeWriteConfigName (t->While.Cond);
/* line 8996 "new_C.puma" */
   WRITESTRING (")) {");
/* line 8997 "new_C.puma" */
   WRITELN ();
/* line 8998 "new_C.puma" */
   TAB (1);
/* line 8999 "new_C.puma" */
   CodeExprCompute2 (t->While.Cond);
/* line 9000 "new_C.puma" */
   CodeStmtsVectorLoopBegin (t->While.Cond);
/* line 9001 "new_C.puma" */
   WRITEBLANKS ();
/* line 9002 "new_C.puma" */
   WRITESTRING ("if (!(");
/* line 9003 "new_C.puma" */
   CodeExprWrite (t->While.Cond, MINPREC_PREC);
/* line 9004 "new_C.puma" */
   WRITESTRING (")) { SET_INACTIVE(");
/* line 9005 "new_C.puma" */
   CodeWriteConfigName (t->While.Cond);
/* line 9006 "new_C.puma" */
   WRITESTRING (", PE); }");
/* line 9007 "new_C.puma" */
   WRITELN ();
/* line 9008 "new_C.puma" */
   CodeStmtsVectorLoopClose (t->While.Cond);
/* line 9009 "new_C.puma" */
   WRITEBLANKS ();
/* line 9010 "new_C.puma" */
   WRITESTRING ("if (IS_ANY_ACTIVE(");
/* line 9011 "new_C.puma" */
   CodeWriteConfigName (t->While.Cond);
/* line 9012 "new_C.puma" */
   WRITESTRING (")) {\n");
/* line 9013 "new_C.puma" */
   TAB (1);
/* line 9014 "new_C.puma" */
   CodeStmts (t->While.Stmts);
/* line 9015 "new_C.puma" */
   DETAB (1);
/* line 9016 "new_C.puma" */
   WRITEBLANKS ();
/* line 9017 "new_C.puma" */
   WRITESTRING ("}");
/* line 9018 "new_C.puma" */
   WRITELN ();
/* line 9019 "new_C.puma" */
   DETAB (1);
/* line 9020 "new_C.puma" */
   WRITEBLANKS ();
/* line 9021 "new_C.puma" */
   WRITESTRING ("}");
/* line 9022 "new_C.puma" */
   WRITELN ();
/* line 9023 "new_C.puma" */
   CodePopActive (t->While.Cond);
/* line 9024 "new_C.puma" */
   CodeExprClose (t->While.Cond);
/* line 9025 "new_C.puma" */
   CodeStmts (t->While.Next);
  }
  }
END_RULE;
   return;
yyL12:;

/* line 9027 "new_C.puma" */
  {
/* line 9028 "new_C.puma" */
BEGIN_RULE(350);
/* line 9030 "new_C.puma" */
   SetDebugLine (t->While.Pos);
/* line 9031 "new_C.puma" */
   CodeExprBegin (t->While.Cond);
/* line 9032 "new_C.puma" */
   WRITEBLANKS ();
/* line 9033 "new_C.puma" */
   WRITESTRING ("while (");
/* line 9034 "new_C.puma" */
   CodeExprWrite (t->While.Cond, MINPREC_PREC);
/* line 9035 "new_C.puma" */
   WRITESTRING (") {\n");
/* line 9036 "new_C.puma" */
   TAB (1);
/* line 9037 "new_C.puma" */
   CodeStmts (t->While.Stmts);
/* line 9038 "new_C.puma" */
   CodeExprCompute2 (t->While.Cond);
/* line 9039 "new_C.puma" */
   DETAB (1);
/* line 9040 "new_C.puma" */
   WRITEBLANKS ();
/* line 9041 "new_C.puma" */
   WRITESTRING ("}");
/* line 9042 "new_C.puma" */
   WRITELN ();
/* line 9043 "new_C.puma" */
   CodeExprClose (t->While.Cond);
/* line 9044 "new_C.puma" */
   CodeStmts (t->While.Next);
  }
END_RULE;
   return;

  case kRepeat:
/* line 9046 "new_C.puma" */
  {
/* line 9047 "new_C.puma" */
BEGIN_RULE(351);
/* line 9049 "new_C.puma" */
   if (! (t->Repeat.Cond -> Expr . Type -> Kind == kSymVector)) goto yyL14;
  {
/* line 9050 "new_C.puma" */
   SetDebugLine (t->Repeat.Pos);
/* line 9051 "new_C.puma" */
   CodePushActive (t->Repeat.Cond);
/* line 9052 "new_C.puma" */
   WRITEBLANKS ();
/* line 9053 "new_C.puma" */
   WRITESTRING ("do {\n");
/* line 9054 "new_C.puma" */
   TAB (1);
/* line 9055 "new_C.puma" */
   CodeStmts (t->Repeat.Stmts);
/* line 9056 "new_C.puma" */
   CodeExprBegin (t->Repeat.Cond);
/* line 9057 "new_C.puma" */
   CodeStmtsVectorLoopBegin (t->Repeat.Cond);
/* line 9058 "new_C.puma" */
   WRITEBLANKS ();
/* line 9059 "new_C.puma" */
   WRITESTRING ("if (");
/* line 9060 "new_C.puma" */
   CodeExprWrite (t->Repeat.Cond, MINPREC_PREC);
/* line 9061 "new_C.puma" */
   WRITESTRING (") { SET_INACTIVE(");
/* line 9062 "new_C.puma" */
   CodeWriteConfigName (t->Repeat.Cond);
/* line 9063 "new_C.puma" */
   WRITESTRING (", PE); }");
/* line 9064 "new_C.puma" */
   WRITELN ();
/* line 9065 "new_C.puma" */
   CodeStmtsVectorLoopClose (t->Repeat.Cond);
/* line 9066 "new_C.puma" */
   CodeExprClose (t->Repeat.Cond);
/* line 9067 "new_C.puma" */
   DETAB (1);
/* line 9068 "new_C.puma" */
   WRITEBLANKS ();
/* line 9069 "new_C.puma" */
   WRITESTRING ("} while (IS_ANY_ACTIVE(");
/* line 9070 "new_C.puma" */
   CodeWriteConfigName (t->Repeat.Cond);
/* line 9071 "new_C.puma" */
   WRITESTRING ("));");
/* line 9072 "new_C.puma" */
   WRITELN ();
/* line 9074 "new_C.puma" */
   CodePopActive (t->Repeat.Cond);
/* line 9075 "new_C.puma" */
   CodeStmts (t->Repeat.Next);
  }
  }
END_RULE;
   return;
yyL14:;

/* line 9077 "new_C.puma" */
  {
/* line 9078 "new_C.puma" */
BEGIN_RULE(352);
/* line 9080 "new_C.puma" */
   SetDebugLine (t->Repeat.Pos);
/* line 9081 "new_C.puma" */
   CodeExprBegin2 (t->Repeat.Cond);
/* line 9082 "new_C.puma" */
   WRITEBLANKS ();
/* line 9083 "new_C.puma" */
   WRITESTRING ("do {\n");
/* line 9084 "new_C.puma" */
   TAB (1);
/* line 9085 "new_C.puma" */
   CodeStmts (t->Repeat.Stmts);
/* line 9086 "new_C.puma" */
   CodeExprCompute2 (t->Repeat.Cond);
/* line 9087 "new_C.puma" */
   DETAB (1);
/* line 9088 "new_C.puma" */
   WRITEBLANKS ();
/* line 9089 "new_C.puma" */
   WRITESTRING ("} while (!");
/* line 9090 "new_C.puma" */
   CodeExprWrite (t->Repeat.Cond, NOT_PREC);
/* line 9091 "new_C.puma" */
   WRITESTRING (");");
/* line 9092 "new_C.puma" */
   WRITELN ();
/* line 9093 "new_C.puma" */
   CodeExprClose (t->Repeat.Cond);
/* line 9094 "new_C.puma" */
   CodeStmts (t->Repeat.Next);
  }
END_RULE;
   return;

  case kLooppar:
/* line 9096 "new_C.puma" */
 {
  tIdent ActivePtr;
  tIdent ElsePtr;
  {
/* line 9097 "new_C.puma" */
BEGIN_RULE(353);
/* line 9099 "new_C.puma" */

/* line 9100 "new_C.puma" */

/* line 9101 "new_C.puma" */
   SetDebugLine (t->Looppar.Pos);
/* line 9102 "new_C.puma" */
   if (! (ActivePtr = GenIdents_HelpVar ())) goto yyL16;
  {
/* line 9103 "new_C.puma" */
   if (! (ElsePtr = GenIdents_HelpVar ())) goto yyL16;
  {
/* line 9104 "new_C.puma" */
   LoopparStackPush (t->Looppar.Qualid, ActivePtr, ElsePtr);
/* line 9105 "new_C.puma" */
   WRITEBLANKS ();
/* line 9106 "new_C.puma" */
   WRITESTRING ("{ BOOLEAN_ELEM_PTR ");
/* line 9107 "new_C.puma" */
   WRITEIDENT (ActivePtr);
/* line 9108 "new_C.puma" */
   WRITESTRING (" = READ_ACTIVE(");
/* line 9109 "new_C.puma" */
   CodeWriteConfigName (t->Looppar.Qualid);
/* line 9110 "new_C.puma" */
   WRITESTRING ("), ");
/* line 9111 "new_C.puma" */
   WRITEIDENT (ElsePtr);
/* line 9112 "new_C.puma" */
   WRITESTRING (" = READ_ELSE(");
/* line 9113 "new_C.puma" */
   CodeWriteConfigName (t->Looppar.Qualid);
/* line 9114 "new_C.puma" */
   WRITESTRING (");");
/* line 9115 "new_C.puma" */
   WRITELN ();
/* line 9116 "new_C.puma" */
   TAB (1);
/* line 9117 "new_C.puma" */
   CodePushActive (t->Looppar.Qualid);
/* line 9118 "new_C.puma" */
   CodePushElse (t->Looppar.Qualid);
/* line 9119 "new_C.puma" */
   WRITEBLANKS ();
/* line 9120 "new_C.puma" */
   WRITESTRING ("while (IS_ANY_ACTIVE(");
/* line 9121 "new_C.puma" */
   CodeWriteConfigName (t->Looppar.Qualid);
/* line 9122 "new_C.puma" */
   WRITESTRING (")) {\n");
/* line 9123 "new_C.puma" */
   TAB (1);
/* line 9124 "new_C.puma" */
   CodeStmts (t->Looppar.Stmts);
/* line 9125 "new_C.puma" */
   DETAB (1);
/* line 9126 "new_C.puma" */
   WRITEBLANKS ();
/* line 9127 "new_C.puma" */
   WRITESTRING ("}");
/* line 9128 "new_C.puma" */
   WRITELN ();
/* line 9129 "new_C.puma" */
   CodePopActive (t->Looppar.Qualid);
/* line 9130 "new_C.puma" */
   CodePopElse (t->Looppar.Qualid);
/* line 9131 "new_C.puma" */
   DETAB (1);
/* line 9132 "new_C.puma" */
   WRITEBLANKS ();
/* line 9133 "new_C.puma" */
   WRITESTRING ("}");
/* line 9134 "new_C.puma" */
   WRITELN ();
/* line 9135 "new_C.puma" */
   LoopparStackPop ();
/* line 9136 "new_C.puma" */
   CodeStmts (t->Looppar.Next);
  }
  }
  }
END_RULE;
   return;
 }
yyL16:;

  break;
  case kLoop:
/* line 9138 "new_C.puma" */
  {
/* line 9139 "new_C.puma" */
BEGIN_RULE(354);
/* line 9141 "new_C.puma" */
   SetDebugLine (t->Loop.Pos);
/* line 9142 "new_C.puma" */
   LoopStack_Push (GenIdents_Label (), NoIdent);
/* line 9143 "new_C.puma" */
   CodeStoreStacksExit (t -> Loop . ExitConfigs);
/* line 9144 "new_C.puma" */
   WRITEBLANKS ();
/* line 9145 "new_C.puma" */
   WRITESTRING ("for (;;) {\n");
/* line 9146 "new_C.puma" */
   TAB (1);
/* line 9147 "new_C.puma" */
   CodeStmts (t->Loop.Stmts);
/* line 9148 "new_C.puma" */
   DETAB (1);
/* line 9149 "new_C.puma" */
   WRITEBLANKS ();
/* line 9150 "new_C.puma" */
   WRITESTRING ("} ");
/* line 9151 "new_C.puma" */
   WRITEIDENT (LoopStack_GetTopLabel ());
/* line 9152 "new_C.puma" */
   WRITESTRING (":;");
/* line 9153 "new_C.puma" */
   WRITELN ();
/* line 9154 "new_C.puma" */
   CodeResetStacksExit (t -> Loop . ExitConfigs);
/* line 9155 "new_C.puma" */
   LoopStack_Pop ();
/* line 9156 "new_C.puma" */
   CodeStmts (t->Loop.Next);
  }
END_RULE;
   return;

  case kFor:
/* line 9158 "new_C.puma" */
 {
  tIdent UpperBound;
  {
/* line 9159 "new_C.puma" */
BEGIN_RULE(355);
/* line 9161 "new_C.puma" */
   if (! (t->For.Qualid -> Expr . Type -> Kind == kSymVector)) goto yyL18;
  {
/* line 9162 "new_C.puma" */

/* line 9163 "new_C.puma" */
   if (! (UpperBound = GenIdents_Bound ())) goto yyL18;
  {
/* line 9164 "new_C.puma" */
   SetDebugLine (t->For.Pos);
/* line 9165 "new_C.puma" */
   CodePushActive (t->For.Qualid);
/* line 9166 "new_C.puma" */
   CodeExprBegin (t->For.From);
/* line 9167 "new_C.puma" */
   CodeStmtsVectorLoopBegin (t->For.Qualid);
/* line 9168 "new_C.puma" */
   WRITEBLANKS ();
/* line 9169 "new_C.puma" */
   CodeExprWrite (t->For.Qualid, ASSIGN_PREC);
/* line 9170 "new_C.puma" */
   WRITESTRING (" = ");
/* line 9171 "new_C.puma" */
   CodeExprWrite (t->For.From, ASSIGN_PREC);
/* line 9172 "new_C.puma" */
   WRITESTRING (";");
/* line 9173 "new_C.puma" */
   WRITELN ();
/* line 9174 "new_C.puma" */
   CodeStmtsVectorLoopClose (t->For.Qualid);
/* line 9175 "new_C.puma" */
   CodeExprClose (t->For.From);
/* line 9176 "new_C.puma" */
   WRITEBLANKS ();
/* line 9177 "new_C.puma" */
   WRITESTRING ("{ ");
/* line 9178 "new_C.puma" */
   CodeTypeName (t->For.To -> Expr . Type);
/* line 9179 "new_C.puma" */
   WRITESTRING (" ");
/* line 9180 "new_C.puma" */


                if (t->For.To->Expr.Type->Kind == kSymVector) {
                  WRITESTRING("*");
                  WRITEIDENT(UpperBound);
                  WRITESTRING(" = (");
                  CodeTypeName(t->For.To->Expr.Type);
                  WRITESTRING(" *) malloc(sizeof(");
                  CodeTypeName(t->For.To->Expr.Type);
                  WRITESTRING(") * LEN(");
                  CodeWriteConfigName(t->For.To);
                  WRITESTRING("));");
		  WRITELN();
                } else {
                  WRITEIDENT(UpperBound);
                  WRITESTRING(";");
		  WRITELN();
                }
                TAB(1);
                  CodeExprBegin(t->For.To);
                  CodeVectorLoopBegin(t->For.To);
                  WRITEBLANKS();
                  WRITEIDENT(UpperBound);
                  if (t->For.To->Expr.Type->Kind == kSymVector) {
                    WRITESTRING("[PE]");
                  }
                  WRITESTRING(" = ");
                  CodeExprWrite(t->For.To, ASSIGN_PREC);
                  WRITESTRING(";");
		  WRITELN();
                  CodeVectorLoopClose(t->For.To);
                  CodeExprClose(t->For.To);
                  WRITEBLANKS();
                  WRITESTRING("while (IS_ANY_ACTIVE(");
                  CodeWriteConfigName(t->For.Qualid);
                  WRITESTRING(")) {");
		  WRITELN();
                  TAB(1);
                    CodeStmtsVectorLoopBegin(t->For.Qualid);
                    WRITEBLANKS();

                    WRITESTRING("if (");
                    CodeExprWrite(t->For.Qualid, ASSIGN_PREC);
                    if (Values_ValueToInt(&(t->For.ByVal)) >= 0) {
                      WRITESTRING(" > ");
                    } else {
                      WRITESTRING(" < ");
                    }
                    WRITEIDENT(UpperBound);
                    if (t->For.To->Expr.Type->Kind == kSymVector) {
                      WRITESTRING("[PE]");
                    }
                    WRITESTRING(") { SET_INACTIVE(");
                    CodeWriteConfigName(t->For.Qualid);
                    WRITESTRING(", PE); }");
		    WRITELN();
                    CodeStmtsVectorLoopClose(t->For.Qualid);
                    WRITEBLANKS();
                    WRITESTRING("if (IS_ANY_ACTIVE(");
                    CodeWriteConfigName(t->For.Qualid);
                    WRITESTRING(")) {\n");
                    TAB(1);
                      CodeStmts(t->For.Stmts);
                      CodeStmtsVectorLoopBegin(t->For.Qualid);
                      WRITEBLANKS();
                      CodeExprWrite(t->For.Qualid, MINPREC_PREC);
                      WRITESTRING(" += ");
                      CodeExprWrite(t->For.By, ASSIGN_PREC);
                      WRITESTRING(";");
		      WRITELN();
                      CodeStmtsVectorLoopClose(t->For.Qualid);
                    DETAB(1);
                    WRITEBLANKS();
                    WRITESTRING("}");
		    WRITELN();
                  DETAB(1);
                  WRITEBLANKS();
                  WRITESTRING("}");
		  WRITELN();
                  if (t->For.To->Expr.Type->Kind == kSymVector) {
                    WRITEBLANKS();
                    WRITESTRING("free(");
                    WRITEIDENT(UpperBound);
                    WRITESTRING(");");
		    WRITELN();
                  }

/* line 9267 "new_C.puma" */
   DETAB (1);
/* line 9268 "new_C.puma" */
   WRITEBLANKS ();
/* line 9269 "new_C.puma" */
   WRITESTRING ("}");
/* line 9270 "new_C.puma" */
   WRITELN ();
/* line 9271 "new_C.puma" */
   CodePopActive (t->For.Qualid);
/* line 9272 "new_C.puma" */
   CodeStmts (t->For.Next);
  }
  }
  }
END_RULE;
   return;
 }
yyL18:;

/* line 9274 "new_C.puma" */
  {
/* line 9275 "new_C.puma" */
BEGIN_RULE(356);
/* line 9277 "new_C.puma" */
   if (! (t->For.To -> Expr . IsCConst && ! (OverOrUnderFlow (t->For.Qualid -> Qualid . Type, t -> For . ToVal, t -> For . ByVal)))) goto yyL19;
  {
/* line 9278 "new_C.puma" */
   SetDebugLine (t->For.Pos);
/* line 9279 "new_C.puma" */
   CodeExprBegin (t->For.From);
/* line 9280 "new_C.puma" */
   WRITEBLANKS ();
/* line 9281 "new_C.puma" */
   WRITESTRING ("for (");
/* line 9282 "new_C.puma" */
   CodeExprWrite (t->For.Qualid, ASSIGN_PREC);
/* line 9283 "new_C.puma" */
   WRITESTRING (" = ");
/* line 9284 "new_C.puma" */
   CodeExprWrite (t->For.From, ASSIGN_PREC);
/* line 9285 "new_C.puma" */
   WRITESTRING ("; ");
/* line 9286 "new_C.puma" */
   CodeExprWrite (t->For.Qualid, COMPARISON_PREC);
/* line 9287 "new_C.puma" */

                if (Values_ValueToInt(&(t->For.ByVal)) >= 0) {
                  WRITESTRING(" <= ");
                } else {
                  WRITESTRING(" >= ");
                };

/* line 9294 "new_C.puma" */
   CodeExprWrite (t->For.To, COMPARISON_PREC);
/* line 9295 "new_C.puma" */
   WRITESTRING ("; ");
/* line 9296 "new_C.puma" */
   CodeExprWrite (t->For.Qualid, ASSIGN_PREC);
/* line 9297 "new_C.puma" */
   WRITESTRING (" += ");
/* line 9298 "new_C.puma" */
   CodeExprWrite (t->For.By, ASSIGN_PREC);
/* line 9299 "new_C.puma" */
   WRITESTRING (") {\n");
/* line 9300 "new_C.puma" */
   TAB (1);
/* line 9301 "new_C.puma" */
   CodeStmts (t->For.Stmts);
/* line 9302 "new_C.puma" */
   DETAB (1);
/* line 9303 "new_C.puma" */
   WRITEBLANKS ();
/* line 9304 "new_C.puma" */
   WRITESTRING ("}");
/* line 9305 "new_C.puma" */
   WRITELN ();
/* line 9306 "new_C.puma" */
   CodeExprClose (t->For.From);
/* line 9307 "new_C.puma" */
   CodeStmts (t->For.Next);
  }
  }
END_RULE;
   return;
yyL19:;

/* line 9309 "new_C.puma" */
 {
  tIdent BoundId1;
  tIdent BoundId2;
  LONG ByValue;
  {
/* line 9310 "new_C.puma" */
BEGIN_RULE(357);
/* line 9312 "new_C.puma" */

/* line 9313 "new_C.puma" */

/* line 9314 "new_C.puma" */

/* line 9315 "new_C.puma" */

                BoundId1 = GenIdents_Bound ();
                BoundId2 = GenIdents_Bound ();
                ByValue  = Values_ValueToInt ( &(t->For.ByVal) );

                SetDebugLine(t->For.Pos);
                CodeExprBegin(t->For.From);
                CodeExprBegin(t->For.To);
                WRITEBLANKS();
                WRITESTRING("{");
		WRITELN();
                TAB(1);
                  WRITEBLANKS();
                  CodeTypeName (t->For.Qualid->Qualid.Type);
                  WRITESTRING(" ");
                  WRITEIDENT( BoundId1 );
                  WRITESTRING(" = ");
                  CodeExprWrite(t->For.From, ASSIGN_PREC);
                  WRITESTRING(", ");
                  WRITEIDENT( BoundId2 );
                  WRITESTRING(" = ");
                  CodeExprWrite(t->For.To, ASSIGN_PREC);
                  WRITESTRING(";\n");
		  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("if (");
                  WRITEIDENT( BoundId1 );
                  if (ByValue >= 0) {
                    WRITESTRING(" <= ");
                  } else {
                    WRITESTRING(" >= ");
                  };
                  WRITEIDENT( BoundId2 );
                  WRITESTRING(")");
		  WRITELN();
                  TAB(1);
                    WRITEBLANKS();
                    WRITESTRING("for (");
                    CodeExprWrite(t->For.Qualid, ASSIGN_PREC);
                    WRITESTRING(" = ");
                    WRITEIDENT( BoundId1 );
                    if (ByValue >= 2) {
                      WRITESTRING(", ");
                      WRITEIDENT( BoundId2 );
                      WRITESTRING(" = ");
                      WRITESTRING("FOR_LIMIT_UP(");
                      WRITEIDENT( BoundId2 );
                      WRITESTRING(", ");
                      CodeExprWrite( t->For.By, PASSVALUE_PREC);
                      WRITESTRING(", ");
                      CodeMinimum (t->For.Qualid->Qualid.Type);
                      WRITESTRING(")");
                    } else if (ByValue <= -2) {
                      WRITESTRING(", ");
                      WRITEIDENT( BoundId2 );
                      WRITESTRING(" = ");
                      WRITESTRING("FOR_LIMIT_DOWN(");
                      WRITEIDENT( BoundId2 );
                      WRITESTRING(", ");
                      CodeExprWrite( t->For.By, PASSVALUE_PREC);
                      WRITESTRING(", ");
                      CodeMaximum (t->For.Qualid->Qualid.Type);
                      WRITESTRING(")");
                    };
                    WRITESTRING(";; ");
                    CodeExprWrite(t->For.Qualid, ASSIGN_PREC);
                    WRITESTRING(" += ");
                    CodeExprWrite(t->For.By , ASSIGN_PREC);
                    WRITESTRING(") {\n");
                    TAB(1);
                      CodeStmts (t->For.Stmts);
                      WRITEBLANKS();
                      WRITESTRING("if (");
                      CodeExprWrite(t->For.Qualid, COMPARISON_PREC);
                      if (ByValue >= 0) {
                        WRITESTRING(" >= ");
                      } else {
                        WRITESTRING(" <= ");
                      };
                      WRITEIDENT( BoundId2 );
                      WRITESTRING(") break;");
		      WRITELN();
                    DETAB(1);
                    WRITEBLANKS();
                    WRITESTRING("}");
		    WRITELN();
                DETAB(2);
                WRITEBLANKS();
                WRITESTRING("}");
		WRITELN();

/* line 9406 "new_C.puma" */
   CodeExprClose (t->For.To);
/* line 9407 "new_C.puma" */
   CodeExprClose (t->For.From);
/* line 9408 "new_C.puma" */
   CodeStmts (t->For.Next);
  }
END_RULE;
   return;
 }

  case kWith:
  if (t->With.Designator->Kind == kDeref) {
/* line 9410 "new_C.puma" */
 {
  tIdent WithId;
  tObject Object;
  {
/* line 9411 "new_C.puma" */
BEGIN_RULE(358);
/* line 9413 "new_C.puma" */
   if (! (t->With.Designator->Deref.Designator -> Designator . Type -> Kind == kSymOpaqueType)) goto yyL21;
  {
/* line 9414 "new_C.puma" */

/* line 9415 "new_C.puma" */

/* line 9416 "new_C.puma" */
   if (! (WithId = GenIdents_With ())) goto yyL21;
  {
/* line 9417 "new_C.puma" */
   if (! (Object = t->With.Designator->Deref.Designator -> Designator . Type -> SymConstructor . TypeObj)) goto yyL21;
  {
/* line 9418 "new_C.puma" */
   SetDebugLine (t->With.Pos);
/* line 9419 "new_C.puma" */
   WRITEBLANKS ();
/* line 9420 "new_C.puma" */
   WRITESTRING ("{");
/* line 9421 "new_C.puma" */
   WRITELN ();
/* line 9422 "new_C.puma" */
   TAB (1);
/* line 9423 "new_C.puma" */
   CodeDesignatorBegin (t->With.Designator->Deref.Designator);
/* line 9424 "new_C.puma" */
   CodeDesignatorCompute (t->With.Designator->Deref.Designator);
/* line 9425 "new_C.puma" */
   WRITEBLANKS ();
/* line 9426 "new_C.puma" */
   WRITESTRING ("register ");
/* line 9427 "new_C.puma" */
   CodeTypeName (t->With.Designator -> Deref . Type);
/* line 9428 "new_C.puma" */
   WRITESTRING (" *");
/* line 9429 "new_C.puma" */
   WRITEIDENT (WithId);
/* line 9430 "new_C.puma" */
   WRITESTRING (" = ");
/* line 9431 "new_C.puma" */
   WRITESTRING ("(");
/* line 9432 "new_C.puma" */
   WRITEIDENT (GenIdents_Opaque (Object -> SymObject . CIdent));
/* line 9433 "new_C.puma" */
   WRITESTRING (")");
/* line 9434 "new_C.puma" */
   CodeExpr (t->With.Designator->Deref.Designator, CAST_PREC);
/* line 9435 "new_C.puma" */
   WRITESTRING (";\n");
/* line 9436 "new_C.puma" */
   WRITELN ();
/* line 9437 "new_C.puma" */
   With_Push (WithId, Symbols_GetFields (t->With.Designator -> Deref . Type));
/* line 9438 "new_C.puma" */
   CodeStmts (t->With.Stmts);
/* line 9439 "new_C.puma" */
   With_Pop ();
/* line 9440 "new_C.puma" */
   CodeDesignatorClose (t->With.Designator->Deref.Designator);
/* line 9441 "new_C.puma" */
   DETAB (1);
/* line 9442 "new_C.puma" */
   WRITEBLANKS ();
/* line 9443 "new_C.puma" */
   WRITESTRING ("}\n");
/* line 9444 "new_C.puma" */
   CodeStmts (t->With.Next);
  }
  }
  }
  }
END_RULE;
   return;
 }
yyL21:;

  }
/* line 9446 "new_C.puma" */
 {
  tIdent WithId;
  {
/* line 9447 "new_C.puma" */
BEGIN_RULE(359);
/* line 9449 "new_C.puma" */

/* line 9450 "new_C.puma" */
   if (! (WithId = GenIdents_With ())) goto yyL22;
  {
/* line 9451 "new_C.puma" */
   SetDebugLine (t->With.Pos);
/* line 9452 "new_C.puma" */
   WRITEBLANKS ();
/* line 9453 "new_C.puma" */
   WRITESTRING ("{");
/* line 9454 "new_C.puma" */
   WRITELN ();
/* line 9455 "new_C.puma" */
   TAB (1);
/* line 9456 "new_C.puma" */
   CodeDesignatorBegin (t->With.Designator);
/* line 9457 "new_C.puma" */
   CodeDesignatorCompute (t->With.Designator);
/* line 9458 "new_C.puma" */
   WRITEBLANKS ();
/* line 9459 "new_C.puma" */
   WRITESTRING ("register ");
/* line 9460 "new_C.puma" */
   CodeTypeName (t->With.Designator -> Designator . Type);
/* line 9461 "new_C.puma" */
   WRITESTRING (" *");
/* line 9462 "new_C.puma" */
   WRITEIDENT (WithId);
/* line 9463 "new_C.puma" */
   WRITESTRING (" = ");
/* line 9464 "new_C.puma" */
   CodeAdr (t->With.Designator);
/* line 9465 "new_C.puma" */
   WRITESTRING (";\n");
/* line 9466 "new_C.puma" */
   WRITELN ();
/* line 9467 "new_C.puma" */
   With_Push (WithId, Symbols_GetFields (t->With.Designator -> Designator . Type));
/* line 9468 "new_C.puma" */
   CodeStmts (t->With.Stmts);
/* line 9469 "new_C.puma" */
   With_Pop ();
/* line 9470 "new_C.puma" */
   CodeDesignatorClose (t->With.Designator);
/* line 9471 "new_C.puma" */
   DETAB (1);
/* line 9472 "new_C.puma" */
   WRITEBLANKS ();
/* line 9473 "new_C.puma" */
   WRITESTRING ("}\n");
/* line 9474 "new_C.puma" */
   CodeStmts (t->With.Next);
  }
  }
END_RULE;
   return;
 }
yyL22:;

  break;
  case kAll:
/* line 9476 "new_C.puma" */
  {
/* line 9477 "new_C.puma" */
BEGIN_RULE(360);
/* line 9479 "new_C.puma" */
   SetDebugLine (t->All.Pos);
/* line 9480 "new_C.puma" */
   WRITEBLANKS ();
/* line 9481 "new_C.puma" */
   WRITESTRING ("PUSH_ACTIVE_ALL(");
/* line 9482 "new_C.puma" */
   CodeWriteConfigName (t->All.Qualid);
/* line 9483 "new_C.puma" */
   WRITESTRING (");\n");
/* line 9484 "new_C.puma" */
   TAB (1);
/* line 9485 "new_C.puma" */
   CodeStmts (t->All.Stmts);
/* line 9486 "new_C.puma" */
   DETAB (1);
/* line 9487 "new_C.puma" */
   WRITEBLANKS ();
/* line 9488 "new_C.puma" */
   WRITESTRING ("POP_ACTIVE(");
/* line 9489 "new_C.puma" */
   CodeWriteConfigName (t->All.Qualid);
/* line 9490 "new_C.puma" */
   WRITESTRING (");\n");
/* line 9491 "new_C.puma" */
   CodeStmts (t->All.Next);
  }
END_RULE;
   return;

  case kSend:
/* line 9493 "new_C.puma" */
  {
/* line 9494 "new_C.puma" */
BEGIN_RULE(361);
/* line 9496 "new_C.puma" */
   SetDebugLine (t->Send.Pos);
/* line 9497 "new_C.puma" */
   CodeStmtsSend (t->Send.DirSpec, t->Send.From, t->Send.To);
/* line 9498 "new_C.puma" */
   CodeStmts (t->Send.Next);
  }
END_RULE;
   return;

  case kLoad:
/* line 9500 "new_C.puma" */
 {
  ULONG ReturnSize;
  tLocalIds Count;
  tLocalIds CountPtr;
  tType FromType;
  BOOLEAN IsFirstIndex;
  {
/* line 9501 "new_C.puma" */
BEGIN_RULE(362);
/* line 9503 "new_C.puma" */

/* line 9504 "new_C.puma" */

/* line 9505 "new_C.puma" */

/* line 9506 "new_C.puma" */

/* line 9507 "new_C.puma" */

/* line 9508 "new_C.puma" */

                SetDebugLine(t->Load.Pos);
                ReturnSize = GenIdents_HelpVar();
                WRITEBLANKS();
                WRITESTRING("{ CARDINAL ");
                WRITEIDENT(ReturnSize);
                WRITESTRING(" = 0;");
		WRITELN();
                TAB(1);
                  Count = NoLocalIds;
                  FromType = t->Load.From->Expr.Type;
                  while (FromType->Kind == kSymArray) {
                    Count = mSymLocalIds(GenIdents_HelpVar(), Count);
                    WRITEBLANKS();
                    WRITESTRING("CARDINAL ");
                    WRITEIDENT(Count->SymLocalIds.Ident);
                    WRITESTRING(" = 0;");
		    WRITELN();
                    FromType = FromType->SymArray.ElemType;
                  }
                  CodeDesignatorBegin(t->Load.What);
                  CodeDesignatorCompute(t->Load.What);
                  CodeDesignatorBegin(t->Load.From);
                  CodeDesignatorCompute(t->Load.From);
                  if (t->Load.Size != NoQualid) {
                    CodeDesignatorBegin(t->Load.Size);
                    CodeDesignatorCompute(t->Load.Size);
                  }
                  CodeLoadStoreLoopBegin(t->Load.What, Count, t->Load.From);
                  WRITEBLANKS();
                  CodeExpr(t->Load.What, MINPREC_PREC);
                  WRITESTRING(" = ");
                  if (t->Load.From->Kind == kQualid0 &&
                      Symbols_IsVAR(t->Load.From->Qualid0.Object) &&
                      !t->Load.From->Expr.Type->SymArray.IsOpen) {
                    
                    WRITEIDENT(t->Load.From->Qualid0.Object->SymVar.CIdent);
                    WRITESTRING("->");
                  } else {
                    CodeExpr(t->Load.From, ASSIGN_PREC);
                    if (!t->Load.From->Expr.Type->SymArray.IsOpen) {
                      WRITESTRING(".");
                    }
                  }
                  CountPtr = Count;
                  FromType = t->Load.From->Expr.Type;
                  IsFirstIndex = TRUE;
                  while (CountPtr != NoLocalIds) {
                    if (!t->Load.From->Expr.Type->SymArray.IsOpen) {
                      if (IsFirstIndex) {
                        WRITESTRING("A");
                        IsFirstIndex = FALSE;
                      } else {
                        WRITESTRING(".A");
                      }
                    }
                    WRITESTRING("[");
                    WRITEIDENT(CountPtr->SymLocalIds.Ident);
                    WRITESTRING("]");
                    ArrayStackPush(CountPtr->SymLocalIds.Ident, FromType);
                    FromType = FromType->SymArray.ElemType;
                    CountPtr = CountPtr->SymLocalIds.Next;
                  }
                  WRITESTRING(";");
		  WRITELN();
                  while (ArrayStack != NULL) {
                    WRITEBLANKS();
                    WRITEIDENT(ArrayStackTop(&FromType));
                    WRITESTRING("++;");
		    WRITELN();
                    if (ArrayStack->Previous != NULL) {
                      WRITEBLANKS();
                      WRITESTRING("if (");
                      WRITEIDENT(ArrayStackTop(&FromType));
                      WRITESTRING(" == ");
                      CodeArrayLength(FromType->SymArray.IndexType);
                      WRITESTRING(") {");
		      WRITELN();
                      TAB(1);
                        WRITEBLANKS();
                        WRITEIDENT(ArrayStackTop(&FromType));
                        WRITESTRING(" = 0;");
		        WRITELN();
                    }
                    ArrayStackPop();
                   }
                  CountPtr = Count;
                  while (CountPtr != NoLocalIds) {
                    if (CountPtr->SymLocalIds.Next != NULL) {
                      DETAB(1);
                      WRITEBLANKS();
                      WRITESTRING("}");
		      WRITELN();
                    }
                    CountPtr = CountPtr->SymLocalIds.Next;
                  }
                  WRITEBLANKS();
                  WRITEIDENT(ReturnSize);
                  WRITESTRING("++;");
		  WRITELN();
                  CodeLoadStoreLoopClose(t->Load.What, ReturnSize, t->Load.Size);
                  if (t->Load.Size != NoQualid) {
                    CodeDesignatorClose(t->Load.Size);
                  }
                  CodeDesignatorClose(t->Load.From);
                  CodeDesignatorClose(t->Load.What);
                DETAB(1);
                WRITEBLANKS();
                WRITESTRING("}\n");
                CodeStmts(t->Load.Next);

  }
END_RULE;
   return;
 }

  case kStore:
/* line 9623 "new_C.puma" */
 {
  tIdent ReturnSize;
  tLocalIds Count;
  tLocalIds CountPtr;
  tType ToType;
  BOOLEAN IsFirstIndex;
  {
/* line 9624 "new_C.puma" */
BEGIN_RULE(363);
/* line 9626 "new_C.puma" */

/* line 9627 "new_C.puma" */

/* line 9628 "new_C.puma" */

/* line 9629 "new_C.puma" */

/* line 9630 "new_C.puma" */

/* line 9631 "new_C.puma" */

                SetDebugLine(t->Store.Pos);
                ReturnSize = GenIdents_HelpVar();
                WRITEBLANKS();
                WRITESTRING("{ CARDINAL ");
                WRITEIDENT(ReturnSize);
                WRITESTRING(" = 0;");
		WRITELN();
                TAB(1);
                  Count = NoLocalIds;
                  ToType = t->Store.To->Expr.Type;
                  while (ToType->Kind == kSymArray) {
                    Count = mSymLocalIds(GenIdents_HelpVar(), Count);
                    WRITEBLANKS();
                    WRITESTRING("CARDINAL ");
                    WRITEIDENT(Count->SymLocalIds.Ident);
                    WRITESTRING(" = 0;");
		    WRITELN();
                    ToType = ToType->SymArray.ElemType;
                  }
                  CodeDesignatorBegin(t->Store.What);
                  CodeDesignatorCompute(t->Store.What);
                  CodeDesignatorBegin(t->Store.To);
                  CodeDesignatorCompute(t->Store.To);
                  if (t->Store.Size != NoQualid) {
                    CodeDesignatorBegin(t->Store.Size);
                    CodeDesignatorCompute(t->Store.Size);
                  }
                  CodeLoadStoreLoopBegin(t->Store.What, Count, t->Store.To);
                  WRITEBLANKS();
                  if (t->Store.To->Kind == kQualid0 &&
                      Symbols_IsVAR(t->Store.To->Qualid0.Object) &&
                      !t->Store.To->Expr.Type->SymArray.IsOpen) {
                    
                    WRITEIDENT(t->Store.To->Qualid0.Object->SymVar.CIdent);
                    WRITESTRING("->");
                  } else {
                    CodeExpr(t->Store.To, MINPREC_PREC);
                    if (!t->Store.To->Expr.Type->SymArray.IsOpen) {                   
                      WRITESTRING(".");
                    }
                  }
                  CountPtr = Count;
                  ToType = t->Store.To->Expr.Type;
                  IsFirstIndex = TRUE;
                  while (CountPtr != NoLocalIds) {
                    if (!t->Store.To->Expr.Type->SymArray.IsOpen) {
                      if (IsFirstIndex) {
                        WRITESTRING("A");
                        IsFirstIndex = FALSE;
                      } else {
                        WRITESTRING(".A");
                      }
                    }
                    WRITESTRING("[");
                    WRITEIDENT(CountPtr->SymLocalIds.Ident);
                    WRITESTRING("]");
                    ArrayStackPush(CountPtr->SymLocalIds.Ident, ToType);
                    ToType = ToType->SymArray.ElemType;
                    CountPtr = CountPtr->SymLocalIds.Next;
                  }
                  WRITESTRING(" = ");
                  CodeExpr(t->Store.What, MINPREC_PREC);
                  WRITESTRING(";");
		  WRITELN();
                  while (ArrayStack != NULL) {
                    WRITEBLANKS();
                    WRITEIDENT(ArrayStackTop(&ToType));
                    WRITESTRING("++;");
		    WRITELN();
                    if (ArrayStack->Previous != NULL) {
                      WRITEBLANKS();
                      WRITESTRING("if (");
                      WRITEIDENT(ArrayStackTop(&ToType));
                      WRITESTRING(" == ");
                      CodeArrayLength(ToType->SymArray.IndexType);
                      WRITESTRING(") {");
		      WRITELN();
                      TAB(1);
                        WRITEBLANKS();
                        WRITEIDENT(ArrayStackTop(&ToType));
                        WRITESTRING(" = 0;");
		        WRITELN();
                    }
                    ArrayStackPop();
                   }
                  CountPtr = Count;
                  while (CountPtr != NoLocalIds) {
                    if (CountPtr->SymLocalIds.Next != NULL) {
                      DETAB(1);
                      WRITEBLANKS();
                      WRITESTRING("}");
		      WRITELN();
                    }
                    CountPtr = CountPtr->SymLocalIds.Next;
                  }
                  WRITEBLANKS();
                  WRITEIDENT(ReturnSize);
                  WRITESTRING("++;");
		  WRITELN();
                  CodeLoadStoreLoopClose(t->Store.What, ReturnSize, t->Store.Size);
                  if (t->Store.Size != NoQualid) {
                    CodeDesignatorClose(t->Store.Size);
                  }
                  CodeDesignatorClose(t->Store.To);
                  CodeDesignatorClose(t->Store.What);
                DETAB(1);
                WRITEBLANKS();
                WRITESTRING("}\n");
                CodeStmts(t->Store.Next);

  }
END_RULE;
   return;
 }

  case kExit:
/* line 9746 "new_C.puma" */
 {
  tTree Config;
  tIdent ActivePtr;
  tIdent ElsePtr;
  {
/* line 9747 "new_C.puma" */
BEGIN_RULE(364);
/* line 9749 "new_C.puma" */
   if (! (t -> Exit . IsVectorExit)) goto yyL27;
  {
/* line 9750 "new_C.puma" */

/* line 9751 "new_C.puma" */

/* line 9752 "new_C.puma" */

/* line 9753 "new_C.puma" */
   LoopparStackTop (& Config, & ActivePtr, & ElsePtr);
/* line 9754 "new_C.puma" */
   SetDebugLine (t->Exit.Pos);
/* line 9755 "new_C.puma" */
   WRITEBLANKS ();
/* line 9756 "new_C.puma" */
   WRITESTRING ("EXIT_ALL_ACTIVES(");
/* line 9757 "new_C.puma" */
   CodeWriteConfigName (Config);
/* line 9758 "new_C.puma" */
   WRITESTRING (", ");
/* line 9759 "new_C.puma" */
   WRITEIDENT (ActivePtr);
/* line 9760 "new_C.puma" */
   WRITESTRING (", ");
/* line 9761 "new_C.puma" */
   WRITEIDENT (ElsePtr);
/* line 9762 "new_C.puma" */
   WRITESTRING (");\n");
/* line 9763 "new_C.puma" */
   CodeStmts (t->Exit.Next);
  }
  }
END_RULE;
   return;
 }
yyL27:;

/* line 9765 "new_C.puma" */
  {
/* line 9766 "new_C.puma" */
BEGIN_RULE(365);
/* line 9768 "new_C.puma" */
   SetDebugLine (t->Exit.Pos);
/* line 9769 "new_C.puma" */
   WRITEBLANKS ();
/* line 9770 "new_C.puma" */
   WRITESTRING ("goto ");
/* line 9771 "new_C.puma" */
   WRITEIDENT (LoopStack_GetTopLabel ());
/* line 9772 "new_C.puma" */
   WRITESTRING (";\n");
/* line 9773 "new_C.puma" */
   CodeStmts (t->Exit.Next);
  }
END_RULE;
   return;

  case kReturn0:
/* line 9775 "new_C.puma" */
 {
  tConfigs Configs;
  tTree Declarations;
  {
/* line 9776 "new_C.puma" */
BEGIN_RULE(366);
/* line 9778 "new_C.puma" */

/* line 9779 "new_C.puma" */

/* line 9780 "new_C.puma" */
   SetDebugLine (t->Return0.Pos);
/* line 9781 "new_C.puma" */
   CodePopVarPointer (Pointer_LocalPtrs);
/* line 9782 "new_C.puma" */
   CodeFreeOpenArray (Parameter_ValueOpens);
/* line 9783 "new_C.puma" */
   ReturnStackTop (& Configs);
/* line 9784 "new_C.puma" */
   CodeResetStacksReturn (Configs);
/* line 9785 "new_C.puma" */
   DeclarationStackTop (& Declarations);
/* line 9786 "new_C.puma" */
   CodeRestoreConfigsConnectsPE (Declarations);
/* line 9787 "new_C.puma" */
   WRITEBLANKS ();
/* line 9788 "new_C.puma" */
   WRITESTRING ("return;\n");
/* line 9789 "new_C.puma" */
   CodeStmts (t->Return0.Next);
  }
END_RULE;
   return;
 }

  case kReturn1:
/* line 9791 "new_C.puma" */
 {
  tConfigs Configs;
  tTree Declarations;
  {
/* line 9792 "new_C.puma" */
BEGIN_RULE(367);
/* line 9794 "new_C.puma" */

/* line 9795 "new_C.puma" */

/* line 9796 "new_C.puma" */
   SetDebugLine (t->Return1.Pos);
/* line 9797 "new_C.puma" */
   WRITEBLANKS ();
/* line 9798 "new_C.puma" */
   WRITESTRING ("{");
/* line 9799 "new_C.puma" */
   WRITELN ();
/* line 9800 "new_C.puma" */
   TAB (1);
/* line 9801 "new_C.puma" */
   CodeExprHelpVarBegin (t->Return1.Result);
/* line 9802 "new_C.puma" */
   CodeExprCompute (t->Return1.Result);
/* line 9803 "new_C.puma" */
   CodePopVarPointer (Pointer_LocalPtrs);
/* line 9804 "new_C.puma" */
   CodeFreeOpenArray (Parameter_ValueOpens);
/* line 9805 "new_C.puma" */
   ReturnStackTop (& Configs);
/* line 9806 "new_C.puma" */
   CodeResetStacksReturn (Configs);
/* line 9807 "new_C.puma" */
   DeclarationStackTop (& Declarations);
/* line 9808 "new_C.puma" */
   CodeRestoreConfigsConnectsPE (Declarations);
/* line 9810 "new_C.puma" */
   CodeReturnHelpVarClose (t->Return1.Result);
/* line 9811 "new_C.puma" */
   WRITEBLANKS ();
/* line 9812 "new_C.puma" */
   WRITESTRING ("return ");
/* line 9813 "new_C.puma" */
   WRITEIDENT (t->Return1.Result -> Expr . HelpVar);
/* line 9814 "new_C.puma" */
   WRITESTRING (";");
/* line 9815 "new_C.puma" */
   WRITELN ();
/* line 9816 "new_C.puma" */
   DETAB (1);
/* line 9817 "new_C.puma" */
   WRITEBLANKS ();
/* line 9818 "new_C.puma" */
   WRITESTRING ("}\n");
/* line 9819 "new_C.puma" */
   CodeStmts (t->Return1.Next);
  }
END_RULE;
   return;
 }

  case kCases1:
/* line 9821 "new_C.puma" */
  {
/* line 9822 "new_C.puma" */
BEGIN_RULE(368);
/* line 9824 "new_C.puma" */
   CodeStmts (t->Cases1.Labels);
/* line 9825 "new_C.puma" */
   TAB (1);
/* line 9826 "new_C.puma" */
   CodeStmts (t->Cases1.Stmts);
/* line 9827 "new_C.puma" */
   WRITEBLANKS ();
/* line 9828 "new_C.puma" */
   WRITESTRING ("break;\n");
/* line 9829 "new_C.puma" */
   DETAB (1);
/* line 9830 "new_C.puma" */
   CodeStmts (t->Cases1.Next);
  }
END_RULE;
   return;

  case kLabelExpr:
/* line 9832 "new_C.puma" */
  {
/* line 9833 "new_C.puma" */
BEGIN_RULE(369);
/* line 9835 "new_C.puma" */
   if (! (t->LabelExpr.Expr -> Expr . IsCConst)) goto yyL32;
  {
/* line 9836 "new_C.puma" */
   WRITEBLANKS ();
/* line 9837 "new_C.puma" */
   WRITESTRING ("case ");
/* line 9838 "new_C.puma" */
   CodeExpr (t->LabelExpr.Expr, MINPREC_PREC);
/* line 9839 "new_C.puma" */
   WRITESTRING (":\n");
/* line 9840 "new_C.puma" */
   CodeStmts (t->LabelExpr.Next);
  }
  }
END_RULE;
   return;
yyL32:;

/* line 9842 "new_C.puma" */
  {
/* line 9843 "new_C.puma" */
BEGIN_RULE(370);
/* line 9845 "new_C.puma" */
   WRITEBLANKS ();
/* line 9846 "new_C.puma" */
   WRITESTRING ("case ");
/* line 9847 "new_C.puma" */
   CodeValue (t -> LabelExpr . LabelVal);
/* line 9848 "new_C.puma" */
   WRITESTRING (":\n");
/* line 9849 "new_C.puma" */
   CodeStmts (t->LabelExpr.Next);
  }
END_RULE;
   return;

  case kLabelRange:
/* line 9851 "new_C.puma" */
  {
/* line 9852 "new_C.puma" */
BEGIN_RULE(371);
/* line 9854 "new_C.puma" */
   CodeLabelRange (t -> LabelRange . LwbVal, t -> LabelRange . UpbVal);
/* line 9855 "new_C.puma" */
   CodeStmts (t->LabelRange.Next);
  }
END_RULE;
   return;

  }

/* line 9857 "new_C.puma" */
  {
/* line 9858 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeStmtsElse
# if defined __STDC__ | defined __cplusplus
(register tTree t, register tTree e, BOOLEAN WasVector, register tTree cond, register tIdent expression)
# else
(t, e, WasVector, cond, expression)
 register tTree t;
 register tTree e;
 BOOLEAN WasVector;
 register tTree cond;
 register tIdent expression;
# endif
{
/* line 9863 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kNoElsif) {
/* line 9870 "new_C.puma" */
  {
/* line 9871 "new_C.puma" */
BEGIN_RULE(372);
/* line 9873 "new_C.puma" */
   if (! (e -> Kind != kNoStmt && WasVector)) goto yyL1;
  {
/* line 9874 "new_C.puma" */
   WRITELN ();
/* line 9875 "new_C.puma" */
   CodePopActive (cond);
/* line 9876 "new_C.puma" */
   CodePushActive (cond);
/* line 9877 "new_C.puma" */
   CodeElse (cond, expression);
/* line 9879 "new_C.puma" */
   WRITEBLANKS ();
/* line 9880 "new_C.puma" */
   WRITESTRING ("if (IS_ANY_ACTIVE(");
/* line 9881 "new_C.puma" */
   CodeWriteConfigName (cond);
/* line 9882 "new_C.puma" */
   WRITESTRING (")) {\n");
/* line 9883 "new_C.puma" */
   TAB (1);
/* line 9884 "new_C.puma" */
   CodeStmts (e);
/* line 9885 "new_C.puma" */
   DETAB (1);
/* line 9886 "new_C.puma" */
   WRITEBLANKS ();
/* line 9887 "new_C.puma" */
   WRITESTRING ("}");
  }
  }
END_RULE;
   return;
yyL1:;

/* line 9889 "new_C.puma" */
  {
/* line 9890 "new_C.puma" */
BEGIN_RULE(373);
/* line 9892 "new_C.puma" */
   if (! (e -> Kind != kNoStmt)) goto yyL2;
  {
/* line 9893 "new_C.puma" */
   WRITESTRING (" else {\n");
/* line 9894 "new_C.puma" */
   TAB (1);
/* line 9895 "new_C.puma" */
   CodeStmts (e);
/* line 9896 "new_C.puma" */
   DETAB (1);
/* line 9897 "new_C.puma" */
   WRITEBLANKS ();
/* line 9898 "new_C.puma" */
   WRITESTRING ("}");
  }
  }
END_RULE;
   return;
yyL2:;

  }
  if (t->Kind == kElsif) {
/* line 9900 "new_C.puma" */
 {
  tIdent Expression;
  {
/* line 9901 "new_C.puma" */
BEGIN_RULE(374);
/* line 9903 "new_C.puma" */
   if (! (t->Elsif.Cond -> Expr . Type -> Kind == kSymVector && WasVector)) goto yyL3;
  {
/* line 9904 "new_C.puma" */

/* line 9905 "new_C.puma" */
   if (! (Expression = GenIdents_HelpVar ())) goto yyL3;
  {
/* line 9906 "new_C.puma" */
   WRITELN ();
/* line 9907 "new_C.puma" */
   CodePopActive (cond);
/* line 9908 "new_C.puma" */
   CodePushActive (cond);
/* line 9909 "new_C.puma" */
   CodeElse (cond, expression);
/* line 9911 "new_C.puma" */
   WRITEBLANKS ();
/* line 9912 "new_C.puma" */
   WRITESTRING ("if (IS_ANY_ACTIVE(");
/* line 9913 "new_C.puma" */
   CodeWriteConfigName (cond);
/* line 9914 "new_C.puma" */
   WRITESTRING (")) {");
/* line 9915 "new_C.puma" */
   WRITELN ();
/* line 9916 "new_C.puma" */
   TAB (1);
/* line 9917 "new_C.puma" */
   CodePushActive (t->Elsif.Cond);
/* line 9918 "new_C.puma" */
   WRITEBLANKS ();
/* line 9919 "new_C.puma" */
   WRITESTRING ("{ BOOLEAN *");
/* line 9920 "new_C.puma" */
   WRITEIDENT (Expression);
/* line 9921 "new_C.puma" */
   WRITESTRING (" = (BOOLEAN *) malloc(sizeof(BOOLEAN) * LEN(");
/* line 9922 "new_C.puma" */
   CodeWriteConfigName (t->Elsif.Cond);
/* line 9923 "new_C.puma" */
   WRITESTRING ("));");
/* line 9924 "new_C.puma" */
   WRITELN ();
/* line 9925 "new_C.puma" */
   TAB (1);
/* line 9926 "new_C.puma" */
   CodeIfExpr (t->Elsif.Cond, Expression);
/* line 9927 "new_C.puma" */
   CodeIf (t->Elsif.Cond, Expression);
/* line 9929 "new_C.puma" */
   WRITEBLANKS ();
/* line 9930 "new_C.puma" */
   WRITESTRING ("if (IS_ANY_ACTIVE(");
/* line 9931 "new_C.puma" */
   CodeWriteConfigName (t->Elsif.Cond);
/* line 9932 "new_C.puma" */
   WRITESTRING (")) {\n");
/* line 9933 "new_C.puma" */
   TAB (1);
/* line 9934 "new_C.puma" */
   CodeStmts (t->Elsif.Stmts);
/* line 9935 "new_C.puma" */
   DETAB (1);
/* line 9936 "new_C.puma" */
   WRITEBLANKS ();
/* line 9937 "new_C.puma" */
   WRITESTRING ("}");
/* line 9939 "new_C.puma" */
   CodeStmtsElse (t->Elsif.Next, e, TRUE, t->Elsif.Cond, Expression);
/* line 9941 "new_C.puma" */
   WRITELN ();
/* line 9942 "new_C.puma" */
   WRITEBLANKS ();
/* line 9943 "new_C.puma" */
   WRITESTRING ("free(");
/* line 9944 "new_C.puma" */
   WRITEIDENT (Expression);
/* line 9945 "new_C.puma" */
   WRITESTRING (");");
/* line 9946 "new_C.puma" */
   WRITELN ();
/* line 9947 "new_C.puma" */
   DETAB (1);
/* line 9948 "new_C.puma" */
   WRITEBLANKS ();
/* line 9949 "new_C.puma" */
   WRITESTRING ("}");
/* line 9950 "new_C.puma" */
   WRITELN ();
/* line 9951 "new_C.puma" */
   CodePopActive (t->Elsif.Cond);
/* line 9952 "new_C.puma" */
   DETAB (1);
/* line 9953 "new_C.puma" */
   WRITEBLANKS ();
/* line 9954 "new_C.puma" */
   WRITESTRING ("}");
  }
  }
  }
END_RULE;
   return;
 }
yyL3:;

/* line 9956 "new_C.puma" */
 {
  tIdent Expression;
  {
/* line 9957 "new_C.puma" */
BEGIN_RULE(375);
/* line 9959 "new_C.puma" */
   if (! (t->Elsif.Cond -> Expr . Type -> Kind == kSymVector)) goto yyL4;
  {
/* line 9960 "new_C.puma" */

/* line 9961 "new_C.puma" */
   if (! (Expression = GenIdents_HelpVar ())) goto yyL4;
  {
/* line 9962 "new_C.puma" */
   WRITESTRING (" else {");
/* line 9963 "new_C.puma" */
   WRITELN ();
/* line 9964 "new_C.puma" */
   TAB (1);
/* line 9965 "new_C.puma" */
   CodePushActive (t->Elsif.Cond);
/* line 9966 "new_C.puma" */
   WRITEBLANKS ();
/* line 9967 "new_C.puma" */
   WRITESTRING ("{ BOOLEAN *");
/* line 9968 "new_C.puma" */
   WRITEIDENT (Expression);
/* line 9969 "new_C.puma" */
   WRITESTRING (" = (BOOLEAN *) malloc(sizeof(BOOLEAN) * LEN(");
/* line 9970 "new_C.puma" */
   CodeWriteConfigName (t->Elsif.Cond);
/* line 9971 "new_C.puma" */
   WRITESTRING ("));");
/* line 9972 "new_C.puma" */
   WRITELN ();
/* line 9973 "new_C.puma" */
   TAB (1);
/* line 9974 "new_C.puma" */
   CodeIfExpr (t->Elsif.Cond, Expression);
/* line 9975 "new_C.puma" */
   CodeIf (t->Elsif.Cond, Expression);
/* line 9977 "new_C.puma" */
   WRITEBLANKS ();
/* line 9978 "new_C.puma" */
   WRITESTRING ("if (IS_ANY_ACTIVE(");
/* line 9979 "new_C.puma" */
   CodeWriteConfigName (t->Elsif.Cond);
/* line 9980 "new_C.puma" */
   WRITESTRING (")) {\n");
/* line 9981 "new_C.puma" */
   TAB (1);
/* line 9982 "new_C.puma" */
   CodeStmts (t->Elsif.Stmts);
/* line 9983 "new_C.puma" */
   DETAB (1);
/* line 9984 "new_C.puma" */
   WRITEBLANKS ();
/* line 9985 "new_C.puma" */
   WRITESTRING ("}");
/* line 9987 "new_C.puma" */
   CodeStmtsElse (t->Elsif.Next, e, TRUE, t->Elsif.Cond, Expression);
/* line 9989 "new_C.puma" */
   WRITELN ();
/* line 9990 "new_C.puma" */
   WRITEBLANKS ();
/* line 9991 "new_C.puma" */
   WRITESTRING ("free(");
/* line 9992 "new_C.puma" */
   WRITEIDENT (Expression);
/* line 9993 "new_C.puma" */
   WRITESTRING (");");
/* line 9994 "new_C.puma" */
   WRITELN ();
/* line 9995 "new_C.puma" */
   DETAB (1);
/* line 9996 "new_C.puma" */
   WRITEBLANKS ();
/* line 9997 "new_C.puma" */
   WRITESTRING ("}");
/* line 9998 "new_C.puma" */
   WRITELN ();
/* line 9999 "new_C.puma" */
   CodePopActive (t->Elsif.Cond);
/* line 10001 "new_C.puma" */
   DETAB (1);
/* line 10002 "new_C.puma" */
   WRITEBLANKS ();
/* line 10003 "new_C.puma" */
   WRITESTRING ("}");
  }
  }
  }
END_RULE;
   return;
 }
yyL4:;

/* line 10005 "new_C.puma" */
  {
/* line 10006 "new_C.puma" */
BEGIN_RULE(376);
/* line 10008 "new_C.puma" */
   if (! (WasVector)) goto yyL5;
  {
/* line 10009 "new_C.puma" */
   WRITELN ();
/* line 10010 "new_C.puma" */
   CodePopActive (cond);
/* line 10011 "new_C.puma" */
   CodePushActive (cond);
/* line 10012 "new_C.puma" */
   CodeElse (cond, expression);
/* line 10014 "new_C.puma" */
   WRITEBLANKS ();
/* line 10015 "new_C.puma" */
   WRITESTRING ("if (IS_ANY_ACTIVE(");
/* line 10016 "new_C.puma" */
   CodeWriteConfigName (cond);
/* line 10017 "new_C.puma" */
   WRITESTRING (")) {");
/* line 10018 "new_C.puma" */
   WRITELN ();
/* line 10019 "new_C.puma" */
   TAB (1);
/* line 10020 "new_C.puma" */
   CodeExprBegin (t->Elsif.Cond);
/* line 10021 "new_C.puma" */
   WRITEBLANKS ();
/* line 10022 "new_C.puma" */
   WRITESTRING ("if (");
/* line 10023 "new_C.puma" */
   CodeExprWrite (t->Elsif.Cond, MINPREC_PREC);
/* line 10024 "new_C.puma" */
   WRITESTRING (") {\n");
/* line 10025 "new_C.puma" */
   TAB (1);
/* line 10026 "new_C.puma" */
   CodeStmts (t->Elsif.Stmts);
/* line 10027 "new_C.puma" */
   DETAB (1);
/* line 10028 "new_C.puma" */
   WRITEBLANKS ();
/* line 10029 "new_C.puma" */
   WRITESTRING ("}");
/* line 10030 "new_C.puma" */
   CodeStmtsElse (t->Elsif.Next, e, FALSE, NoExpr, NoIdent);
/* line 10031 "new_C.puma" */
   WRITELN ();
/* line 10032 "new_C.puma" */
   CodeExprClose (t->Elsif.Cond);
/* line 10033 "new_C.puma" */
   DETAB (1);
/* line 10034 "new_C.puma" */
   WRITEBLANKS ();
/* line 10035 "new_C.puma" */
   WRITESTRING ("}");
  }
  }
END_RULE;
   return;
yyL5:;

/* line 10037 "new_C.puma" */
  {
/* line 10038 "new_C.puma" */
BEGIN_RULE(377);
/* line 10040 "new_C.puma" */
   WRITESTRING (" else {");
/* line 10041 "new_C.puma" */
   WRITELN ();
/* line 10042 "new_C.puma" */
   TAB (1);
/* line 10043 "new_C.puma" */
   CodeExprBegin (t->Elsif.Cond);
/* line 10044 "new_C.puma" */
   WRITEBLANKS ();
/* line 10045 "new_C.puma" */
   WRITESTRING ("if (");
/* line 10046 "new_C.puma" */
   CodeExprWrite (t->Elsif.Cond, MINPREC_PREC);
/* line 10047 "new_C.puma" */
   WRITESTRING (") {\n");
/* line 10048 "new_C.puma" */
   TAB (1);
/* line 10049 "new_C.puma" */
   CodeStmts (t->Elsif.Stmts);
/* line 10050 "new_C.puma" */
   DETAB (1);
/* line 10051 "new_C.puma" */
   WRITEBLANKS ();
/* line 10052 "new_C.puma" */
   WRITESTRING ("}");
/* line 10053 "new_C.puma" */
   CodeStmtsElse (t->Elsif.Next, e, FALSE, NoExpr, NoIdent);
/* line 10054 "new_C.puma" */
   WRITELN ();
/* line 10055 "new_C.puma" */
   CodeExprClose (t->Elsif.Cond);
/* line 10056 "new_C.puma" */
   DETAB (1);
/* line 10057 "new_C.puma" */
   WRITEBLANKS ();
/* line 10058 "new_C.puma" */
   WRITESTRING ("}");
  }
END_RULE;
   return;

  }
/* line 10060 "new_C.puma" */
  {
/* line 10061 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeStmtsCases
# if defined __STDC__ | defined __cplusplus
(register tTree t, register tTree e, register tIdent expression)
# else
(t, e, expression)
 register tTree t;
 register tTree e;
 register tIdent expression;
# endif
{
/* line 10067 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kCases1) {
/* line 10074 "new_C.puma" */
  {
/* line 10075 "new_C.puma" */
BEGIN_RULE(378);
/* line 10077 "new_C.puma" */
   CodePopActive (e);
/* line 10078 "new_C.puma" */
   CodePushActive (e);
/* line 10079 "new_C.puma" */
   CodeStmtsVectorLoopBegin (e);
/* line 10080 "new_C.puma" */
   WRITEBLANKS ();
/* line 10081 "new_C.puma" */
   WRITESTRING ("switch (");
/* line 10082 "new_C.puma" */
   WRITEIDENT (expression);
/* line 10083 "new_C.puma" */
   WRITESTRING ("[PE]) {");
/* line 10084 "new_C.puma" */
   WRITELN ();
/* line 10085 "new_C.puma" */
   CodeStmts (t->Cases1.Labels);
/* line 10086 "new_C.puma" */
   WRITEBLANKS ();
/* line 10087 "new_C.puma" */
   WRITESTRING ("  UNSET_ELSE(");
/* line 10088 "new_C.puma" */
   CodeWriteConfigName (e);
/* line 10089 "new_C.puma" */
   WRITESTRING (", PE); break;");
/* line 10090 "new_C.puma" */
   WRITELN ();
/* line 10091 "new_C.puma" */
   WRITEBLANKS ();
/* line 10092 "new_C.puma" */
   WRITESTRING ("default:");
/* line 10093 "new_C.puma" */
   WRITELN ();
/* line 10094 "new_C.puma" */
   WRITEBLANKS ();
/* line 10095 "new_C.puma" */
   WRITESTRING ("  SET_INACTIVE(");
/* line 10096 "new_C.puma" */
   CodeWriteConfigName (e);
/* line 10097 "new_C.puma" */
   WRITESTRING (", PE); break;");
/* line 10098 "new_C.puma" */
   WRITELN ();
/* line 10099 "new_C.puma" */
   WRITEBLANKS ();
/* line 10100 "new_C.puma" */
   WRITESTRING ("}");
/* line 10101 "new_C.puma" */
   WRITELN ();
/* line 10102 "new_C.puma" */
   CodeStmtsVectorLoopClose (e);
/* line 10103 "new_C.puma" */
   WRITEBLANKS ();
/* line 10104 "new_C.puma" */
   WRITESTRING ("if (IS_ANY_ACTIVE(");
/* line 10105 "new_C.puma" */
   CodeWriteConfigName (e);
/* line 10106 "new_C.puma" */
   WRITESTRING (")) {\n");
/* line 10107 "new_C.puma" */
   TAB (1);
/* line 10108 "new_C.puma" */
   CodeStmts (t->Cases1.Stmts);
/* line 10109 "new_C.puma" */
   DETAB (1);
/* line 10110 "new_C.puma" */
   WRITEBLANKS ();
/* line 10111 "new_C.puma" */
   WRITESTRING ("}");
/* line 10112 "new_C.puma" */
   WRITELN ();
/* line 10113 "new_C.puma" */
   CodeStmtsCases (t->Cases1.Next, e, expression);
  }
END_RULE;
   return;

  }
/* line 10115 "new_C.puma" */
  {
/* line 10116 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeStmtsSend
# if defined __STDC__ | defined __cplusplus
(register tTree t, register tTree From, register tTree To)
# else
(t, From, To)
 register tTree t;
 register tTree From;
 register tTree To;
# endif
{
/* line 10122 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kFuncSpec) {
/* line 10129 "new_C.puma" */
 {
  tIdent FromId;
  tIdent ToId;
  tIdent HitId;
  tIdent StepId;
  tIdent LinkId;
  tIdent ActiveId;
  CHARBUF ReduceFunction;
  {
/* line 10130 "new_C.puma" */
BEGIN_RULE(379);
/* line 10132 "new_C.puma" */

/* line 10133 "new_C.puma" */

/* line 10134 "new_C.puma" */

/* line 10135 "new_C.puma" */

/* line 10136 "new_C.puma" */

/* line 10137 "new_C.puma" */

/* line 10138 "new_C.puma" */

/* line 10139 "new_C.puma" */

                FromId = GenIdents_HelpVar();
                ToId = GenIdents_HelpVar();
                HitId = GenIdents_HelpVar();
                StepId = GenIdents_HelpVar();
                LinkId = GenIdents_HelpVar();
                ActiveId = GenIdents_HelpVar();
                WRITEBLANKS();
                WRITESTRING("{");
	        WRITELN();
                TAB(1);
                  WRITEBLANKS();
                  CodeTypeName(From->Expr.Type);
                  WRITESTRING(" *");
                  WRITEIDENT(FromId);
                  WRITESTRING(" = (void *) malloc(sizeof(");
                  CodeTypeName(From->Expr.Type);
                  WRITESTRING(") * LEN(");
                  CodeWriteConfigName(From);
                  WRITESTRING("));");
	          WRITELN();
                  WRITEBLANKS();
                  CodeTypeName(To->Expr.Type);
                  WRITESTRING(" *");
                  WRITEIDENT(ToId);
                  WRITESTRING(" = (void *) malloc(sizeof(");
                  CodeTypeName(To->Expr.Type);
                  WRITESTRING(") * LEN(");
                  CodeWriteConfigName(To);
                  WRITESTRING("));");
	          WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("BOOLEAN *");
                  WRITEIDENT(ActiveId);
                  WRITESTRING(" = (void *) malloc(sizeof(BOOLEAN) * LEN(");
                  CodeWriteConfigName(From);
                  WRITESTRING("));");
	          WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("BOOLEAN *");
                  WRITEIDENT(HitId);
                  WRITESTRING(" = (void *) malloc(sizeof(BOOLEAN) * LEN(");
                  CodeWriteConfigName(To);
                  WRITESTRING("));");
	          WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("CARDINAL ");
                  WRITEIDENT(StepId);
                  WRITESTRING(";");
	          WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("LINK *");
                  WRITEIDENT(LinkId);
                  WRITESTRING(";");
	          WRITELN();
                  CodeExprBegin(t->FuncSpec.DirOutIndex);
                  CodeExprBegin(t->FuncSpec.Step);
                  CodeExprBegin(From);
                  WRITEBLANKS();
                  WRITESTRING("for (PE = 0; PE < LEN(");
                  CodeWriteConfigName(From);
                  WRITESTRING("); PE++) {");
	          WRITELN();
                  TAB(1);
                    WRITEBLANKS();
                    WRITEIDENT(FromId);
                    WRITESTRING("[PE] = ");
                    CodeExprWrite(From, ASSIGN_PREC);
                    WRITESTRING(";");
	            WRITELN();
                    WRITEBLANKS();
                    WRITEIDENT(ActiveId);
                    WRITESTRING("[PE] = IS_ACTIVE(");
                    CodeWriteConfigName(From);
                    WRITESTRING(", PE);");
	            WRITELN();
                    if (Types_VectorsCompatible(From->Expr.Type, To->Designator.Type)) {
                      WRITEBLANKS();
                      WRITEIDENT(ToId);
                      WRITESTRING("[PE] = ");
                      WRITEIDENT(FromId);
                      WRITESTRING("[PE];");
		      WRITELN();
                    }
                  DETAB(1);
                  WRITEBLANKS();
                  WRITESTRING("}");
	          WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("for (");
                  WRITEIDENT(StepId);
                  WRITESTRING(" = 1; ");
                  WRITEIDENT(StepId);
                  WRITESTRING(" <= ");
                  CodeExprWrite(t->FuncSpec.Step, LESSEQUAL_PREC);
                  WRITESTRING("; ");
                  WRITEIDENT(StepId);
                  WRITESTRING("++) {");
	          WRITELN();
                  TAB(1);
                    WRITEBLANKS();
                    WRITESTRING("for (PE = 0; PE < LEN(");
                    CodeWriteConfigName(To);
                    WRITESTRING("); PE++) {");
	            WRITELN();
                    TAB(1);
                      WRITEBLANKS();
                      WRITEIDENT(HitId);
                      WRITESTRING("[PE] = FALSE;");
	              WRITELN();
                    DETAB(1);
                    WRITEBLANKS();
                    WRITESTRING("}");
	            WRITELN();
                    WRITEBLANKS();
                    WRITEIDENT(LinkId);
                    if (t->FuncSpec.DirOutIndex == NoExpr) {
                      if (t->FuncSpec.DirOut->Qualid.Object->SymConnect.SourceConfig->SymConfig.IsGeneric) {
                        WRITESTRING(" = GET_GENERIC_LINKS(\"");
                        WRITEIDENT(t->FuncSpec.DirOut->Qualid.Object->SymObject.CIdent);
                        WRITESTRING("\", &");
                        CodeWriteConfigName(From);
                        WRITESTRING(");");
			WRITELN();
                      } else {
                        WRITESTRING(" = GET_LINKS(");
                        WRITEIDENT(t->FuncSpec.DirOut->Qualid.Object->SymObject.CIdent);
                        WRITESTRING(");");
			WRITELN();
                      }
                    } else {
                      if (t->FuncSpec.DirOut->Qualid.Object->SymConnect.SourceConfig->SymConfig.IsGeneric) {
                        WRITESTRING(" = GET_GENERIC_PARAMETER_LINKS(\"");
                        WRITEIDENT(t->FuncSpec.DirOut->Qualid.Object->SymObject.CIdent);
                        WRITESTRING("\", &");
                        CodeWriteConfigName(From);
                        WRITESTRING(", ");
                        CodeExprWrite(t->FuncSpec.DirOutIndex, PASSVALUE_PREC);
                        WRITESTRING(");");
			WRITELN();
                      } else {
                        WRITESTRING(" = GET_PARAMETER_LINKS(");
                        WRITEIDENT(t->FuncSpec.DirOut->Qualid.Object->SymObject.CIdent);
                        WRITESTRING(", ");
                        CodeExprWrite(t->FuncSpec.DirOutIndex, PASSVALUE_PREC);
                        WRITESTRING(");");
			WRITELN();
                      }
                    }
                    WRITEBLANKS();
                    WRITESTRING("while (");
                    WRITEIDENT(LinkId);
                    WRITESTRING(" != NULL) {");
	            WRITELN();
                    TAB(1);
                      WRITEBLANKS();
                      WRITESTRING("if (");
                      WRITEIDENT(ActiveId);
                      WRITESTRING("[");
                      WRITEIDENT(LinkId);
                      WRITESTRING("->SourceID]) {");
	              WRITELN();
                      TAB(1);
                        WRITEBLANKS();
                        WRITESTRING("if (");
                        WRITEIDENT(HitId);
                        WRITESTRING("[");
                        WRITEIDENT(LinkId);
                        WRITESTRING("->DestinationID]) {");
	                WRITELN();
                        TAB(1);
                          if (t->FuncSpec.Reduce != NoQualid) {
                            GetString(t->FuncSpec.Reduce->Qualid.Ident, ReduceFunction);
                            WRITEBLANKS();
                            WRITEIDENT(ToId);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->DestinationID] = ");
                            if (strcmp(ReduceFunction, "SUM") == 0) {
                              WRITEIDENT(ToId);
                              WRITESTRING("[");
                              WRITEIDENT(LinkId);
                              WRITESTRING("->DestinationID] + ");
                              WRITEIDENT(FromId);
                              WRITESTRING("[");
                              WRITEIDENT(LinkId);
                              WRITESTRING("->SourceID]");
                            } else if (strcmp(ReduceFunction, "PRODUCT") == 0) {
                              WRITEIDENT(ToId);
                              WRITESTRING("[");
                              WRITEIDENT(LinkId);
                              WRITESTRING("->DestinationID] * ");
                              WRITEIDENT(FromId);
                              WRITESTRING("[");
                              WRITEIDENT(LinkId);
                              WRITESTRING("->SourceID]");
                            } else if (strcmp(ReduceFunction, "AND") == 0) {
                              WRITEIDENT(ToId);
                              WRITESTRING("[");
                              WRITEIDENT(LinkId);
                              WRITESTRING("->DestinationID] && ");
                              WRITEIDENT(FromId);
                              WRITESTRING("[");
                              WRITEIDENT(LinkId);
                              WRITESTRING("->SourceID]");
                            } else if (strcmp(ReduceFunction, "OR") == 0) {
                              WRITEIDENT(ToId);
                              WRITESTRING("[");
                              WRITEIDENT(LinkId);
                              WRITESTRING("->DestinationID] || ");
                              WRITEIDENT(FromId);
                              WRITESTRING("[");
                              WRITEIDENT(LinkId);
                              WRITESTRING("->SourceID]");
                            } else if (strcmp(ReduceFunction, "MAX") == 0) {
                              WRITESTRING("MAX(");
                              WRITEIDENT(ToId);
                              WRITESTRING("[");
                              WRITEIDENT(LinkId);
                              WRITESTRING("->DestinationID], ");
                              WRITEIDENT(FromId);
                              WRITESTRING("[");
                              WRITEIDENT(LinkId);
                              WRITESTRING("->SourceID])");
                            } else if (strcmp(ReduceFunction, "MIN") == 0) {
                              WRITESTRING("MIN(");
                              WRITEIDENT(ToId);
                              WRITESTRING("[");
                              WRITEIDENT(LinkId);
                              WRITESTRING("->DestinationID], ");
                              WRITEIDENT(FromId);
                              WRITESTRING("[");
                              WRITEIDENT(LinkId);
                              WRITESTRING("->SourceID])");
                            } else if (strcmp(ReduceFunction, "FIRST") == 0) {
                              WRITEIDENT(ToId);
                              WRITESTRING("[");
                              WRITEIDENT(LinkId);
                              WRITESTRING("->DestinationID]");
                            } else if (strcmp(ReduceFunction, "LAST") == 0) {
                              WRITEIDENT(FromId);
                              WRITESTRING("[");
                              WRITEIDENT(LinkId);
                              WRITESTRING("->SourceID]");
                            } else { 
                              WRITESTRING("*");
                              WRITEIDENT(t->FuncSpec.Reduce->Qualid.Object->SymObject.CIdent);
                              WRITESTRING("(&(");
                              WRITEIDENT(ToId);
                              WRITESTRING("[");
                              WRITEIDENT(LinkId);
                              WRITESTRING("->DestinationID]), &(");
                              WRITEIDENT(FromId);
                              WRITESTRING("[");
                              WRITEIDENT(LinkId);
                              WRITESTRING("->SourceID]), CONFIG_1)");
                            }
                            WRITESTRING(";");
			    WRITELN();
                          }
                        DETAB(1);
                        WRITEBLANKS();
                        WRITESTRING("} else {");
	                WRITELN();
                        TAB(1);
                          WRITEBLANKS();
                          WRITEIDENT(HitId);
                          WRITESTRING("[");
                          WRITEIDENT(LinkId);
                          WRITESTRING("->DestinationID] = TRUE;");
	                  WRITELN();
                          WRITEBLANKS();
                          WRITEIDENT(ToId);
                          WRITESTRING("[");
                          WRITEIDENT(LinkId);
                          WRITESTRING("->DestinationID] = ");
                          WRITEIDENT(FromId);
                          WRITESTRING("[");
                          WRITEIDENT(LinkId);
                          WRITESTRING("->SourceID];");
	                  WRITELN();
                        DETAB(1);
                        WRITEBLANKS();
                        WRITESTRING("}");
	                WRITELN();
                      DETAB(1);
                      WRITEBLANKS();
                      WRITESTRING("}");
	              WRITELN();
                      WRITEBLANKS();
                      WRITEIDENT(LinkId);
                      WRITESTRING(" = ");
                      WRITEIDENT(LinkId);
                      WRITESTRING("->Next;");
	              WRITELN();
                    DETAB(1);
                    WRITEBLANKS();
                    WRITESTRING("}");
	            WRITELN();
                    WRITEBLANKS();
                    WRITESTRING("if (");
                    WRITEIDENT(StepId);
                    WRITESTRING(" == ");
                    CodeExprWrite(t->FuncSpec.Step, EQUAL_PREC);
                    WRITESTRING(") {");
	            WRITELN();
                    TAB(1);
                      WRITEBLANKS();
                      WRITESTRING("for (PE = 0; PE < LEN(");
                      CodeWriteConfigName(To);
                      WRITESTRING("); PE++) {");
	              WRITELN();
                      TAB(1);
                        WRITEBLANKS();
                        WRITESTRING("if (");
                        WRITEIDENT(HitId);
                        WRITESTRING("[PE]) {");
	                WRITELN();
                        TAB(1);
                          WRITEBLANKS();
                          CodeExpr(To, MINPREC_PREC);
                          WRITESTRING(" = ");
                          WRITEIDENT(ToId);
                          WRITESTRING("[PE];");
	                  WRITELN();
                        DETAB(1);
                        WRITEBLANKS();
                        WRITESTRING("}");
	                WRITELN();
                      DETAB(1);
                      WRITEBLANKS();
                      WRITESTRING("}");
	              WRITELN();
                    DETAB(1);
                    WRITEBLANKS();
                    WRITESTRING("} else {");
	            WRITELN();
                    TAB(1);
                      WRITEBLANKS();
                      WRITESTRING("for (PE = 0; PE < LEN(");
                      CodeWriteConfigName(To);
                      WRITESTRING("); PE++) {");
	              WRITELN();
                      TAB(1);
                        WRITEBLANKS();
                        WRITEIDENT(ActiveId);
                        WRITESTRING("[PE] = ");
                        WRITEIDENT(HitId);
                        WRITESTRING("[PE];");
	                WRITELN();
                        WRITEBLANKS();
                        WRITEIDENT(FromId);
                        WRITESTRING("[PE] = ");
                        WRITEIDENT(ToId);
                        WRITESTRING("[PE];");
	                WRITELN();
                      DETAB(1);
                      WRITEBLANKS();
                      WRITESTRING("}");
	              WRITELN();
                    DETAB(1);
                    WRITEBLANKS();
                    WRITESTRING("}");
	            WRITELN();
                  DETAB(1);
                  WRITEBLANKS();
                  WRITESTRING("}");
	          WRITELN();
                  CodeExprClose(From);
                  CodeExprClose(t->FuncSpec.Step);
                  CodeExprClose(t->FuncSpec.DirOutIndex);
                  WRITEBLANKS();
                  WRITESTRING("free(");
                  WRITEIDENT(HitId);
                  WRITESTRING(");");
	          WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("free(");
                  WRITEIDENT(ActiveId);
                  WRITESTRING(");");
	          WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("free(");
                  WRITEIDENT(ToId);
                  WRITESTRING(");");
	          WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("free(");
                  WRITEIDENT(FromId);
                  WRITESTRING(");");
	          WRITELN();
                DETAB(1);
                WRITEBLANKS();
                WRITESTRING("}");
	        WRITELN();

  }
END_RULE;
   return;
 }

  }
  if (t->Kind == kProcSpec) {
/* line 10536 "new_C.puma" */
 {
  tIdent FromId;
  tIdent ToId;
  tIdent HitId;
  CHARBUF ReduceFunction;
  {
/* line 10537 "new_C.puma" */
BEGIN_RULE(380);
/* line 10539 "new_C.puma" */

/* line 10540 "new_C.puma" */

/* line 10541 "new_C.puma" */

/* line 10542 "new_C.puma" */

/* line 10543 "new_C.puma" */

                FromId = GenIdents_HelpVar();
                ToId = GenIdents_HelpVar();
                HitId = GenIdents_HelpVar();
                WRITEBLANKS();
                WRITESTRING("{");
                WRITELN();
                TAB(1);
                  WRITEBLANKS();
                  CodeTypeName(From->Expr.Type);
                  WRITESTRING(" *");
                  WRITEIDENT(FromId);
                  WRITESTRING(" = (void *) malloc(sizeof(");
                  CodeTypeName(From->Expr.Type);
                  WRITESTRING(") * LEN(");
                  CodeWriteConfigName(From);
                  WRITESTRING("));");
                  WRITELN();
                  WRITEBLANKS();
                  CodeTypeName(To->Expr.Type);
                  WRITESTRING(" *");
                  WRITEIDENT(ToId);
                  WRITESTRING(" = (void *) malloc(sizeof(");
                  CodeTypeName(To->Expr.Type);
                  WRITESTRING(") * LEN(");
                  CodeWriteConfigName(To);
                  WRITESTRING("));");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("BOOLEAN *");
                  WRITEIDENT(HitId);
                  WRITESTRING(" = (void *) malloc(sizeof(BOOLEAN) * LEN(");
                  CodeWriteConfigName(To);
                  WRITESTRING("));");
                  WRITELN();
                  CodeExprBegin(t->ProcSpec.Expr);
                  CodeExprBegin(From);
                  WRITEBLANKS();
                  WRITESTRING("for (PE = 0; PE < LEN(");
                  CodeWriteConfigName(From);
                  WRITESTRING("); PE++) {");
                  WRITELN();
                  TAB(1);
                    WRITEBLANKS();
                    WRITEIDENT(FromId);
                    WRITESTRING("[PE] = ");
                    CodeExprWrite(From, ASSIGN_PREC);
                    WRITESTRING(";");
                    WRITELN();
                    WRITEBLANKS();
                    WRITEIDENT(HitId);
                    WRITESTRING("[PE] = FALSE;");
                    WRITELN();
                  DETAB(1);
                  WRITEBLANKS();
                  WRITESTRING("}");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("for (PE = 0; PE < LEN(");
                  CodeWriteConfigName(From);
                  WRITESTRING("); PE++) {");
                  WRITELN();
                  TAB(1);
                    WRITEBLANKS();
                    WRITESTRING("if (IS_ACTIVE(");
                    CodeWriteConfigName(From);
                    WRITESTRING(", PE)) {");
                    WRITELN();
                    TAB(1);
                      WRITEBLANKS();
                      WRITESTRING("if (");
                      WRITEIDENT(HitId);
                      WRITESTRING("[");
                      if (Options_IsOptionSet(Options_eChecks)) {
                        WRITESTRING("CHECK_PE_NUMBER(");
                        CodeWriteConfigName(To);
                        WRITESTRING(", ");
                      }
                      CodeExprWrite(t->ProcSpec.Expr, MINPREC_PREC);
                      WRITESTRING(" - 1");
                      if (Options_IsOptionSet(Options_eChecks)) {
                        WRITESTRING(", __FILE__, __LINE__)");
                      }
                      WRITESTRING("]) {");
                      WRITELN();
                      TAB(1);
                        if (t->ProcSpec.Reduce != NoQualid) {
                          GetString(t->ProcSpec.Reduce->Qualid.Ident, ReduceFunction);
                          WRITEBLANKS();
                          WRITEIDENT(ToId);
                          WRITESTRING("[");
                          CodeExprWrite(t->ProcSpec.Expr, MINPREC_PREC);
                          WRITESTRING(" - 1] = ");
                          if (strcmp(ReduceFunction, "SUM") == 0) {
                            WRITEIDENT(ToId);
                            WRITESTRING("[");
                            CodeExprWrite(t->ProcSpec.Expr, MINPREC_PREC);
                            WRITESTRING(" - 1] + ");
                            WRITEIDENT(FromId);
                            WRITESTRING("[PE]");
                          } else if (strcmp(ReduceFunction, "PRODUCT") == 0) {
                            WRITEIDENT(ToId);
                            WRITESTRING("[");
                            CodeExprWrite(t->ProcSpec.Expr, MINPREC_PREC);
                            WRITESTRING(" - 1] * ");
                            WRITEIDENT(FromId);
                            WRITESTRING("[PE]");
                          } else if (strcmp(ReduceFunction, "AND") == 0) {
                            WRITEIDENT(ToId);
                            WRITESTRING("[");
                            CodeExprWrite(t->ProcSpec.Expr, MINPREC_PREC);
                            WRITESTRING(" - 1] && ");
                            WRITEIDENT(FromId);
                            WRITESTRING("[PE]");
                          } else if (strcmp(ReduceFunction, "OR") == 0) {
                            WRITEIDENT(ToId);
                            WRITESTRING("[");
                            CodeExprWrite(t->ProcSpec.Expr, MINPREC_PREC);
                            WRITESTRING(" - 1] || ");
                            WRITEIDENT(FromId);
                            WRITESTRING("[PE]");
                          } else if (strcmp(ReduceFunction, "MAX") == 0) {
                            WRITESTRING("MAX(");
                            WRITEIDENT(ToId);
                            WRITESTRING("[");
                            CodeExprWrite(t->ProcSpec.Expr, MINPREC_PREC);
                            WRITESTRING(" - 1], ");
                            WRITEIDENT(FromId);
                            WRITESTRING("[PE])");
                          } else if (strcmp(ReduceFunction, "MIN") == 0) {
                            WRITESTRING("MIN(");
                            WRITEIDENT(ToId);
                            WRITESTRING("[");
                            CodeExprWrite(t->ProcSpec.Expr, MINPREC_PREC);
                            WRITESTRING(" - 1], ");
                            WRITEIDENT(FromId);
                            WRITESTRING("[PE])");
                          } else if (strcmp(ReduceFunction, "FIRST") == 0) {
                            WRITEIDENT(ToId);
                            WRITESTRING("[");
                            CodeExprWrite(t->ProcSpec.Expr, MINPREC_PREC);
                            WRITESTRING(" - 1]");
                          } else if (strcmp(ReduceFunction, "LAST") == 0) {
                            WRITEIDENT(FromId);
                            WRITESTRING("[PE]");
                          } else { 
                            WRITESTRING("*");
                            WRITEIDENT(t->ProcSpec.Reduce->Qualid.Object->SymObject.CIdent);
                            WRITESTRING("(&(");
                            WRITEIDENT(ToId);
                            WRITESTRING("[");
                            CodeExprWrite(t->ProcSpec.Expr, MINPREC_PREC);
                            WRITESTRING(" - 1]), &(");
                            WRITEIDENT(FromId);
                            WRITESTRING("[PE]), CONFIG_1)");
                          }
                          WRITESTRING(";");
			  WRITELN();
                        }
                      DETAB(1);
                      WRITEBLANKS();
                      WRITESTRING("} else {");
                      WRITELN();
                      TAB(1);
                        WRITEBLANKS();
                        WRITEIDENT(HitId);
                        WRITESTRING("[");
                        CodeExprWrite(t->ProcSpec.Expr, MINPREC_PREC);
                        WRITESTRING(" - 1] = TRUE;");
                        WRITELN();
                        WRITEBLANKS();
                        WRITEIDENT(ToId);
                        WRITESTRING("[");
                        CodeExprWrite(t->ProcSpec.Expr, MINPREC_PREC);
                        WRITESTRING(" - 1] = ");
                        WRITEIDENT(FromId);
                        WRITESTRING("[PE];");
                        WRITELN();
                      DETAB(1);
                      WRITEBLANKS();
                      WRITESTRING("}");
                      WRITELN();
                    DETAB(1);
                    WRITEBLANKS();
                    WRITESTRING("}");
                    WRITELN();
                  DETAB(1);
                  WRITEBLANKS();
                  WRITESTRING("}");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("for (PE = 0; PE < LEN(");
                  CodeWriteConfigName(To);
                  WRITESTRING("); PE++) {");
                  WRITELN();
                  TAB(1);
                    WRITEBLANKS();
                    WRITESTRING("if (");
                    WRITEIDENT(HitId);
                    WRITESTRING("[PE]) {");
                    WRITELN();
                    TAB(1);
                      WRITEBLANKS();
                      CodeExpr(To, MINPREC_PREC);
                      WRITESTRING(" = ");
                      WRITEIDENT(ToId);
                      WRITESTRING("[PE];");
                      WRITELN();
                     DETAB(1);
                     WRITEBLANKS();
                     WRITESTRING("}");
                     WRITELN();
                  DETAB(1);
                  WRITEBLANKS();
                  WRITESTRING("}");
                  WRITELN();
                  CodeExprClose(From);
                  CodeExprClose(t->ProcSpec.Expr);
                  WRITEBLANKS();
                  WRITESTRING("free(");
                  WRITEIDENT(HitId);
                  WRITESTRING(");");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("free(");
                  WRITEIDENT(ToId);
                  WRITESTRING(");");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("free(");
                  WRITEIDENT(FromId);
                  WRITESTRING(");");
                  WRITELN();
                DETAB(1);
                WRITEBLANKS();
                WRITESTRING("}");
                WRITELN();

  }
END_RULE;
   return;
 }

  }
  if (t->Kind == kDimSpec) {
/* line 10782 "new_C.puma" */
 {
  tIdent HelpId;
  tIdent ToId;
  tIdent HitId;
  tIdent SourcePE;
  tIdent DestPE;
  ULONG Rank;
  tTree Act;
  ULONG ActDim;
  ULONG ActualDimension;
  reducetype reducef;
  {
/* line 10783 "new_C.puma" */
BEGIN_RULE(381);
/* line 10785 "new_C.puma" */

/* line 10786 "new_C.puma" */

/* line 10787 "new_C.puma" */

/* line 10788 "new_C.puma" */

/* line 10789 "new_C.puma" */

/* line 10790 "new_C.puma" */

/* line 10791 "new_C.puma" */

/* line 10792 "new_C.puma" */

/* line 10793 "new_C.puma" */

/* line 10794 "new_C.puma" */

/* line 10795 "new_C.puma" */

                ToId = GenIdents_HelpVar();
                HitId = GenIdents_HelpVar();
                SourcePE = GenIdents_HelpVar();
                DestPE = GenIdents_HelpVar();
		HelpId = GenIdents_HelpVar();
                Rank = To->Expr.Type->SymVector.Config->SymConfig.Rank;
                WRITEBLANKS();
                WRITESTRING("{");
                WRITELN();
                TAB(1);

                  WRITEBLANKS();
                  CodeTypeName(To->Expr.Type);
                  WRITESTRING(" *");
                  WRITEIDENT(ToId);
                  WRITESTRING(" = (void *) malloc(sizeof(");
                  CodeTypeName(To->Expr.Type);
                  WRITESTRING(") * LEN(");
                  CodeWriteConfigName(To);
                  WRITESTRING("));");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("BOOLEAN *");
                  WRITEIDENT(HitId);
                  WRITESTRING(" = (void *) malloc(sizeof(BOOLEAN) * LEN(");
                  CodeWriteConfigName(To);
                  WRITESTRING("));");
                  WRITELN();
                  WRITEBLANKS();
		  CodeTypeName(To->Expr.Type);
		  WRITESTRING(" ");
		  WRITEIDENT(HelpId);
		  WRITESTRING(";");
		  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("CARDINAL ");
                  WRITEIDENT(SourcePE);
                  WRITESTRING(", ");
                  WRITEIDENT(DestPE);
                  WRITESTRING(";");
                  WRITELN();
                  Act = t->DimSpec.Actuals; ActDim = Rank;
                  while (Act->Kind != kNoActual) {
                    if (Act->Kind == kActualStar) {
                      WRITEBLANKS();
                      WRITESTRING("INTEGER *");
                      WRITEIDENT(Act->ActualStar.HelpVar);
                      WRITESTRING(" = DIM(");
                      CodeWriteConfigName(From);
                      WRITESTRING(", ");
                      WRITECARD(ActDim);
                      WRITESTRING(");");
		      WRITELN();
                    }
                    Act = Act->Actual.Next;
                    ActDim--;
                  }
                  CodeActualsBegin(t->DimSpec.Actuals);
                  CodeExprBegin(From);
                  WRITEBLANKS();
                  WRITESTRING("SOURCE_ARRAY = (INTEGER *) malloc(sizeof(INTEGER) * RANK(");
                  CodeWriteConfigName(From);
                  WRITESTRING("));");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("DESTINATION_ARRAY = (INTEGER *) malloc(sizeof(INTEGER) * RANK(");
                  CodeWriteConfigName(To);
                  WRITESTRING("));");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("for (PE = 0; PE < LEN(");
                  CodeWriteConfigName(To);
                  WRITESTRING("); PE++) {");
                  WRITELN();
                  TAB(1);
		    WRITEBLANKS();
		    WRITEIDENT(ToId);
		    WRITESTRING("[PE] = ");
		    CodeExprWrite(To, ASSIGN_PREC);
		    WRITESTRING(";");
		    WRITELN();
                    WRITEBLANKS();
                    WRITEIDENT(HitId);
                    WRITESTRING("[PE] = FALSE;");
                    WRITELN();
                  DETAB(1);
                  WRITEBLANKS();
                  WRITESTRING("}");
                  WRITELN();
                  if (t->DimSpec.Reduce != NoQualid) {
                    reducef = GetReduceType(t->DimSpec.Reduce->Qualid.Ident);
                  } else if (t->DimSpec.Actuals->Actuals.ReduceNumber == 1) {
                    Act = t->DimSpec.Actuals; ActualDimension = Rank;
                    while (Act->Kind != kActualReduce) {
                      Act = Act->Actual.Next;
                      ActualDimension--;
                    }
                    reducef = GetReduceType(Act->ActualReduce.Qualid->Qualid.Ident);
                  }
		  CodeExprBegin(From);
                  WRITEBLANKS();
                  WRITESTRING("for (PE = 0; PE < LEN(");
                  CodeWriteConfigName(From);
                  WRITESTRING("); PE ++) {");
                  WRITELN();
                  TAB(1);
                    WRITEBLANKS();
                    WRITESTRING("if (IS_ACTIVE(");
                    CodeWriteConfigName(From);
                    WRITESTRING(", PE)) {");
                    WRITELN();
                    TAB(1);
                      Act = t->DimSpec.Actuals; ActDim = Rank;
                      while (Act->Kind != kNoActual) {
                        WRITEBLANKS();
                        WRITESTRING("DESTINATION_ARRAY[");
                        WRITECARD(ActDim-1);
                        WRITESTRING("] = ");
                        if (Act->Kind == kActualExpr) {
                          CodeExprWrite(Act->ActualExpr.Expr, ASSIGN_PREC);
                        } else if (Act->Kind == kActualStar) {
                          WRITEIDENT(Act->ActualStar.HelpVar);
                          WRITESTRING("[PE]");
                        } else if (Act->Kind == kActualReduce) {
                          WRITESTRING("LOWER(");
                          CodeWriteConfigName(From);
                          WRITESTRING(", ");
                          WRITECARD(ActualDimension);
                          WRITESTRING(")");
                        }
                        WRITESTRING(";");
			WRITELN();
                        Act = Act->Actual.Next;
                        ActDim--;
                      }
                      WRITEBLANKS();
                      WRITEIDENT(DestPE);
                      WRITESTRING(" = DIM2ID(");
                      CodeWriteConfigName(To);
                      WRITESTRING(", DESTINATION_ARRAY) - 1;");
                      WRITELN();
                      WRITEBLANKS();
                      WRITESTRING("if (");
                      WRITEIDENT(HitId);
                      WRITESTRING("[");
                      if (Options_IsOptionSet(Options_eChecks)) {
                        WRITESTRING("CHECK_PE_NUMBER(");
                        CodeWriteConfigName(To);
                        WRITESTRING(", ");
                      }
                      WRITEIDENT(DestPE);
                      if (Options_IsOptionSet(Options_eChecks)) {
                        WRITESTRING(", __FILE__, __LINE__)");
                      }
                      WRITESTRING("]) {");
                      WRITELN();
                      TAB(1);
                        if (t->DimSpec.Reduce != NoQualid || t->DimSpec.Actuals->Actuals.ReduceNumber == 1) {
			  if (reducef == REDUCEUSERDEF) {
			     WRITEBLANKS();
			     WRITEIDENT(HelpId);
			     WRITESTRING(" = ");
			     CodeExprWrite(From, PASSVALUE_PREC);
			     WRITESTRING(";");
			     WRITELN();
			  }
			  
			  if (reducef != REDUCEFIRST) {
			       WRITEBLANKS();
			       WRITEIDENT(ToId);
			       WRITESTRING("[");
			       WRITEIDENT(DestPE);
			       WRITESTRING("]");
			  }
			  switch (reducef) {
			    case REDUCESUM:
			       WRITESTRING(" += ");
			       CodeExprWrite(From, ASSIGN_PREC);
			       break;
			    case REDUCEPRODUCT:
			       WRITESTRING(" *= ");
			       CodeExprWrite(From, ASSIGN_PREC);
			       break;
			    case REDUCEAND:
			       WRITESTRING(" = ");
			       WRITEIDENT(ToId);
			       WRITESTRING("[");
			       WRITEIDENT(DestPE);
			       WRITESTRING("] && ");
			       CodeExprWrite(From, ASSIGN_PREC);
			       break;
			    case REDUCEOR:
			       WRITESTRING(" = ");
			       WRITEIDENT(ToId);
			       WRITESTRING("[");
			       WRITEIDENT(DestPE);
			       WRITESTRING("] || ");
			       CodeExprWrite(From, ASSIGN_PREC);
			       break;
			    case REDUCEMAX:
			       WRITESTRING(" = ");
			       WRITESTRING("MAX(");
			       WRITEIDENT(ToId);
			       WRITESTRING("[");
			       WRITEIDENT(DestPE);
			       WRITESTRING("], ");
			       CodeExprWrite(From, PASSVALUE_PREC);
			       break;
			    case REDUCEMIN:
			       WRITESTRING(" = ");
			       WRITESTRING("MIN(");
			       WRITEIDENT(ToId);
			       WRITESTRING("[");
			       WRITEIDENT(DestPE);
			       WRITESTRING("], ");
			       CodeExprWrite(From, PASSVALUE_PREC);
			       break;
			    case REDUCEFIRST:
			       break;
			    case REDUCELAST:
			       WRITESTRING(" = ");
			       CodeExprWrite(From, ASSIGN_PREC);
			       break;
			    case REDUCEUSERDEF:
			       WRITESTRING(" = *");
			       WRITEIDENT(t->DimSpec.Reduce->Qualid.Object->SymObject.CIdent);
			       WRITESTRING("(&(");
			       WRITEIDENT(ToId);
			       WRITESTRING("[");
			       WRITEIDENT(DestPE);
			       WRITESTRING("]), &(");
			       WRITEIDENT(HelpId);

			       WRITESTRING("))");
			       break;
			    default:
			       WRITESTRING("/* unkonwn reduce function */");
			       break;
                          }
                          WRITESTRING(";");
			  WRITELN();
                        }
                      DETAB(1);
                      WRITEBLANKS();
                      WRITESTRING("} else {");
                      WRITELN();
                      TAB(1);
                        WRITEBLANKS();
                        WRITEIDENT(HitId);
                        WRITESTRING("[");
                        WRITEIDENT(DestPE);
                        WRITESTRING("] = TRUE;");
                        WRITELN();
                        WRITEBLANKS();
                        WRITEIDENT(ToId);
                        WRITESTRING("[");
                        WRITEIDENT(DestPE);
                        WRITESTRING("] = ");
                        CodeExprWrite(From, ASSIGN_PREC);
                        WRITESTRING(";");
                        WRITELN();
                      DETAB(1);
                      WRITEBLANKS();
                      WRITESTRING("}");
                      WRITELN();
                    DETAB(1);
                    WRITEBLANKS();
                    WRITESTRING("}");
                    WRITELN();
                  DETAB(1);
                  WRITEBLANKS();
                  WRITESTRING("}");
                  WRITELN();
		  CodeExprClose(From);
                  WRITEBLANKS();
                  WRITESTRING("for (PE = 0; PE < LEN(");
                  CodeWriteConfigName(To);
                  WRITESTRING("); PE++) {");
                  WRITELN();
                  TAB(1);
                    WRITEBLANKS();
                    WRITESTRING("if (");
                    WRITEIDENT(HitId);
                    WRITESTRING("[PE]) {");
                    WRITELN();
                    TAB(1);
                      WRITEBLANKS();
                      CodeExpr(To, MINPREC_PREC);
                      WRITESTRING(" = ");
                      WRITEIDENT(ToId);
                      WRITESTRING("[PE];");
                      WRITELN();
                     DETAB(1);
                     WRITEBLANKS();
                     WRITESTRING("}");
                     WRITELN();
                  DETAB(1);
                  WRITEBLANKS();
                  WRITESTRING("}");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("free(SOURCE_ARRAY);");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("free(DESTINATION_ARRAY);");
                  WRITELN();
                  CodeExprClose(From);
                  CodeActualsClose(t->DimSpec.Actuals);
                  Act = t->DimSpec.Actuals;
                  while (Act->Kind != kNoActual) {
                    if (Act->Kind == kActualStar) {
                      WRITEBLANKS();
                      WRITESTRING("free(");
                      WRITEIDENT(Act->ActualStar.HelpVar);
                      WRITESTRING(");");
		      WRITELN();
                    }
                    Act = Act->Actual.Next;
                  }
                  WRITEBLANKS();
                  WRITESTRING("free(");
                  WRITEIDENT(HitId);
                  WRITESTRING(");");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("free(");
                  WRITEIDENT(ToId);
                  WRITESTRING(");");
                  WRITELN();

                DETAB(1);
                WRITEBLANKS();
                WRITESTRING("}");
                WRITELN();

  }
END_RULE;
   return;
 }

  }
/* line 11149 "new_C.puma" */
  {
/* line 11150 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeStmtsReceive
# if defined __STDC__ | defined __cplusplus
(register tTree t, register tTree From, register tIdent To, tType ToType)
# else
(t, From, To, ToType)
 register tTree t;
 register tTree From;
 register tIdent To;
 tType ToType;
# endif
{
/* line 11156 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kFuncSpec) {
/* line 11163 "new_C.puma" */
 {
  tIdent FromId;
  tIdent HitId;
  tIdent LinkId;
  CHARBUF ReduceFunction;
  {
/* line 11164 "new_C.puma" */
BEGIN_RULE(382);
/* line 11166 "new_C.puma" */

/* line 11167 "new_C.puma" */

/* line 11168 "new_C.puma" */

/* line 11169 "new_C.puma" */

/* line 11170 "new_C.puma" */

                FromId = GenIdents_HelpVar();
                HitId = GenIdents_HelpVar();
                LinkId = GenIdents_HelpVar();
                WRITEBLANKS();
                WRITESTRING("{");
                WRITELN();
                TAB(1);
                  WRITEBLANKS();
                  CodeTypeName(From->Expr.Type);
                  WRITESTRING(" *");
                  WRITEIDENT(FromId);
                  WRITESTRING(" = (void *) malloc(sizeof(");
                  CodeTypeName(From->Expr.Type);
                  WRITESTRING(") * LEN(");
                  CodeWriteConfigName(From);
                  WRITESTRING("));");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("BOOLEAN *");
                  WRITEIDENT(HitId);
                  WRITESTRING(" = (void *) malloc(sizeof(BOOLEAN) * LEN(");
                  CodeWriteConfigName2(ToType);
                  WRITESTRING("));");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("LINK *");
                  WRITEIDENT(LinkId);
                  WRITESTRING(";");
                  WRITELN();
                  CodeExprBegin(t->FuncSpec.DirOutIndex);
                  CodeExprBegin2(From);
                  CodeExprCompute3(From);
                  WRITEBLANKS();
                  WRITESTRING("for (PE = 0; PE < LEN(");
                  CodeWriteConfigName(From);
                  WRITESTRING("); PE++) {");
                  WRITELN();
                  TAB(1);
                    WRITEBLANKS();
                    WRITEIDENT(FromId);
                    WRITESTRING("[PE] = ");
                    CodeExprWrite(From, ASSIGN_PREC);
                    WRITESTRING(";");
                    WRITELN();
                    if (Types_VectorsCompatible(From->Expr.Type, ToType)) {
                      WRITEBLANKS();
                      WRITEIDENT(To);
                      WRITESTRING("[PE] = ");
                      WRITEIDENT(FromId);
                      WRITESTRING("[PE];");
		      WRITELN();
                    }
                  DETAB(1);
                  WRITEBLANKS();
                  WRITESTRING("}");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("for (PE = 0; PE < LEN(");
                  CodeWriteConfigName2(ToType);
                  WRITESTRING("); PE++) {");
                  WRITELN();
                  TAB(1);
                    WRITEBLANKS();
                    WRITEIDENT(HitId);
                    WRITESTRING("[PE] = FALSE;");
                    WRITELN();
                  DETAB(1);
                  WRITEBLANKS();
                  WRITESTRING("}");
                  WRITELN();
                  WRITEBLANKS();
                  WRITEIDENT(LinkId);
                  if (t->FuncSpec.DirOutIndex == NoExpr) {
                    if (t->FuncSpec.DirOut->Qualid.Object->SymConnect.SourceConfig->SymConfig.IsGeneric) {
                      WRITESTRING(" = GET_GENERIC_LINKS(\"");
                      WRITEIDENT(t->FuncSpec.DirOut->Qualid.Object->SymObject.CIdent);
                      WRITESTRING("\", &");
                      CodeWriteConfigName(From);
                      WRITESTRING(");");
		      WRITELN();
                    } else {
                      WRITESTRING(" = GET_LINKS(");
                      WRITEIDENT(t->FuncSpec.DirOut->Qualid.Object->SymObject.CIdent);
                      WRITESTRING(");");
		      WRITELN();
                    }
                  } else {
                    if (t->FuncSpec.DirOut->Qualid.Object->SymConnect.SourceConfig->SymConfig.IsGeneric) {
                      WRITESTRING(" = GET_GENERIC_PARAMETER_LINKS(\"");
                      WRITEIDENT(t->FuncSpec.DirOut->Qualid.Object->SymObject.CIdent);
                      WRITESTRING("\", &");
                      CodeWriteConfigName(From);
                      WRITESTRING(", ");
                      CodeExprWrite(t->FuncSpec.DirOutIndex, PASSVALUE_PREC);
                      WRITESTRING(");");
		      WRITELN();
                    } else {
                      WRITESTRING(" = GET_PARAMETER_LINKS(");
                      WRITEIDENT(t->FuncSpec.DirOut->Qualid.Object->SymObject.CIdent);
                      WRITESTRING(", ");
                      CodeExprWrite(t->FuncSpec.DirOutIndex, PASSVALUE_PREC);
                      WRITESTRING(");");
		      WRITELN();
                    }
                  }
                  WRITEBLANKS();
                  WRITESTRING("while (");
                  WRITEIDENT(LinkId);
                  WRITESTRING(" != NULL) {");
                  WRITELN();
                  TAB(1);
                    WRITEBLANKS();
                    WRITESTRING("if (IS_ACTIVE(");
                    CodeWriteConfigName2(ToType);
                    WRITESTRING(", ");
                    WRITEIDENT(LinkId);
                    WRITESTRING("->DestinationID)) {");
                    WRITELN();
                    TAB(1);
                      WRITEBLANKS();
                      WRITESTRING("if (");
                      WRITEIDENT(HitId);
                      WRITESTRING("[");
                      WRITEIDENT(LinkId);
                      WRITESTRING("->DestinationID]) {");
                      WRITELN();
                      TAB(1);
                        if (t->FuncSpec.Reduce != NoQualid) {
                          GetString(t->FuncSpec.Reduce->Qualid.Ident, ReduceFunction);
                          WRITEBLANKS();
                          WRITEIDENT(To);
                          WRITESTRING("[");
                          WRITEIDENT(LinkId);
                          WRITESTRING("->DestinationID] = ");
                          if (strcmp(ReduceFunction, "SUM") == 0) {
                            WRITEIDENT(To);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->DestinationID] + ");
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->SourceID]");
                          } else if (strcmp(ReduceFunction, "PRODUCT") == 0) {
                            WRITEIDENT(To);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->DestinationID] * ");
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->SourceID]");
                          } else if (strcmp(ReduceFunction, "AND") == 0) {
                            WRITEIDENT(To);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->DestinationID] && ");
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->SourceID]");
                          } else if (strcmp(ReduceFunction, "OR") == 0) {
                            WRITEIDENT(To);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->DestinationID] || ");
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->SourceID]");
                          } else if (strcmp(ReduceFunction, "MAX") == 0) {
                            WRITESTRING("MAX(");
                            WRITEIDENT(To);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->DestinationID], ");
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->SourceID])");
                          } else if (strcmp(ReduceFunction, "MIN") == 0) {
                            WRITESTRING("MIN(");
                            WRITEIDENT(To);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->DestinationID], ");
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->SourceID])");
                          } else if (strcmp(ReduceFunction, "FIRST") == 0) {
                            WRITEIDENT(To);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->DestinationID]");
                          } else if (strcmp(ReduceFunction, "LAST") == 0) {
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->SourceID]");
                          } else { 
                            WRITESTRING("*");
                            WRITEIDENT(t->FuncSpec.Reduce->Qualid.Object->SymObject.CIdent);
                            WRITESTRING("(&(");
                            WRITEIDENT(To);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->DestinationID]), &(");
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->SourceID]), CONFIG_1)");
                          }
                          WRITESTRING(";");
			  WRITELN();
                        }
                      DETAB(1);
                      WRITEBLANKS();
                      WRITESTRING("} else {");
                      WRITELN();
                      TAB(1);
                        WRITEBLANKS();
                        WRITEIDENT(HitId);
                        WRITESTRING("[");
                        WRITEIDENT(LinkId);
                        WRITESTRING("->DestinationID] = TRUE;");
                        WRITELN();
                        WRITEBLANKS();
                        WRITEIDENT(To);
                        WRITESTRING("[");
                        WRITEIDENT(LinkId);
                        WRITESTRING("->DestinationID] = ");
                        WRITEIDENT(FromId);
                        WRITESTRING("[");
                        WRITEIDENT(LinkId);
                        WRITESTRING("->SourceID];");
                        WRITELN();
                      DETAB(1);
                      WRITEBLANKS();
                      WRITESTRING("}");
                      WRITELN();
                    DETAB(1);
                    WRITEBLANKS();
                    WRITESTRING("}");
                    WRITELN();
                    WRITEBLANKS();
                    WRITEIDENT(LinkId);
                    WRITESTRING(" = ");
                    WRITEIDENT(LinkId);
                    WRITESTRING("->Next;");
                    WRITELN();
                  DETAB(1);
                  WRITEBLANKS();
                  WRITESTRING("}");
                  WRITELN();
                  CodeExprClose(From);
                  CodeExprClose(t->FuncSpec.DirOutIndex);
                  WRITEBLANKS();
                  WRITESTRING("free(");
                  WRITEIDENT(HitId);
                  WRITESTRING(");");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("free(");
                  WRITEIDENT(FromId);
                  WRITESTRING(");");
                  WRITELN();
                DETAB(1);
                WRITEBLANKS();
                WRITESTRING("}");
                WRITELN();

  }
END_RULE;
   return;
 }

  }
  if (t->Kind == kProcSpec) {
/* line 11444 "new_C.puma" */
 {
  tIdent FromId;
  tIdent HitId;
  CHARBUF ReduceFunction;
  {
/* line 11445 "new_C.puma" */
BEGIN_RULE(383);
/* line 11447 "new_C.puma" */

/* line 11448 "new_C.puma" */

/* line 11449 "new_C.puma" */

/* line 11450 "new_C.puma" */

                FromId = GenIdents_HelpVar();
                HitId = GenIdents_HelpVar();
                WRITEBLANKS();
                WRITESTRING("{");
                WRITELN();
                TAB(1);
                  WRITEBLANKS();
                  CodeTypeName(From->Expr.Type);
                  WRITESTRING(" *");
                  WRITEIDENT(FromId);
                  WRITESTRING(" = (void *) malloc(sizeof(");
                  CodeTypeName(From->Expr.Type);
                  WRITESTRING(") * LEN(");
                  CodeWriteConfigName(From);
                  WRITESTRING("));");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("BOOLEAN *");
                  WRITEIDENT(HitId);
                  WRITESTRING(" = (void *) malloc(sizeof(BOOLEAN) * LEN(");
                  CodeWriteConfigName(From);
                  WRITESTRING("));");
                  WRITELN();
                  CodeExprBegin(t->ProcSpec.Expr);
                  CodeExprBegin2(From);
                  CodeExprCompute3(From);
                  WRITEBLANKS();
                  WRITESTRING("for (PE = 0; PE < LEN(");
                  CodeWriteConfigName(From);
                  WRITESTRING("); PE++) {");
                  WRITELN();
                  TAB(1);
                    WRITEBLANKS();
                    WRITEIDENT(FromId);
                    WRITESTRING("[PE] = ");
                    CodeExprWrite(From, ASSIGN_PREC);
                    WRITESTRING(";");
                    WRITELN();
                    WRITEBLANKS();
                    WRITEIDENT(HitId);
                    WRITESTRING("[PE] = FALSE;");
                    WRITELN();
                  DETAB(1);
                  WRITEBLANKS();
                  WRITESTRING("}");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("for (PE = 0; PE < LEN(");
                  CodeWriteConfigName(From);
                  WRITESTRING("); PE++) {");
                  WRITELN();
                  TAB(1);
                    WRITEBLANKS();
                    WRITESTRING("if (IS_ACTIVE(");
                    CodeWriteConfigName(From);
                    WRITESTRING(", PE)) {");
                    WRITELN();
                    TAB(1);
                      if (Options_IsOptionSet(Options_eChecks)) {
                        WRITEBLANKS();
                        WRITESTRING("(void) CHECK_PE_NUMBER(");
                        CodeWriteConfigName(From);
                        WRITESTRING(", ");
                        CodeExprWrite(t->ProcSpec.Expr, MINPREC_PREC);
                        WRITESTRING(" - 1");
                        WRITESTRING(", __FILE__, __LINE__);");
			WRITELN();
                      }
                      WRITEBLANKS();
                      WRITESTRING("if (");
                      WRITEIDENT(HitId);
                      WRITESTRING("[PE]) {");
                      WRITELN();
                      TAB(1);
                        if (t->ProcSpec.Reduce != NoQualid) {
                          GetString(t->ProcSpec.Reduce->Qualid.Ident, ReduceFunction);
                          WRITEBLANKS();
                          WRITEIDENT(To);
                          WRITESTRING("[PE] = ");
                          if (strcmp(ReduceFunction, "SUM") == 0) {
                            WRITEIDENT(To);
                            WRITESTRING("[PE] + ");
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            CodeExprWrite(t->ProcSpec.Expr, MINPREC_PREC);
                            WRITESTRING(" - 1]");
                          } else if (strcmp(ReduceFunction, "PRODUCT") == 0) {
                            WRITEIDENT(To);
                            WRITESTRING("[PE] * ");
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            CodeExprWrite(t->ProcSpec.Expr, MINPREC_PREC);
                            WRITESTRING(" - 1]");
                          } else if (strcmp(ReduceFunction, "AND") == 0) {
                            WRITEIDENT(To);
                            WRITESTRING("[PE] && ");
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            CodeExprWrite(t->ProcSpec.Expr, MINPREC_PREC);
                            WRITESTRING(" - 1]");
                          } else if (strcmp(ReduceFunction, "OR") == 0) {
                            WRITEIDENT(To);
                            WRITESTRING("[PE] || ");
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            CodeExprWrite(t->ProcSpec.Expr, MINPREC_PREC);
                            WRITESTRING(" - 1]");
                          } else if (strcmp(ReduceFunction, "MAX") == 0) {
                            WRITESTRING("MAX(");
                            WRITEIDENT(To);
                            WRITESTRING("[PE], ");
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            CodeExprWrite(t->ProcSpec.Expr, MINPREC_PREC);
                            WRITESTRING(" - 1])");
                          } else if (strcmp(ReduceFunction, "MIN") == 0) {
                            WRITESTRING("MIN(");
                            WRITEIDENT(To);
                            WRITESTRING("[PE], ");
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            CodeExprWrite(t->ProcSpec.Expr, MINPREC_PREC);
                            WRITESTRING(" - 1])");
                          } else if (strcmp(ReduceFunction, "FIRST") == 0) {
                            WRITEIDENT(To);
                            WRITESTRING("[PE]");
                          } else if (strcmp(ReduceFunction, "LAST") == 0) {
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            CodeExprWrite(t->ProcSpec.Expr, MINPREC_PREC);
                            WRITESTRING(" - 1]");
                          } else { 
                            WRITESTRING("*");
                            WRITEIDENT(t->ProcSpec.Reduce->Qualid.Object->SymObject.CIdent);
                            WRITESTRING("(&(");
                            WRITEIDENT(To);
                            WRITESTRING("[PE]), &(");
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            CodeExprWrite(t->ProcSpec.Expr, MINPREC_PREC);
                            WRITESTRING(" - 1]), CONFIG_1)");
                          }
                          WRITESTRING(";");
			  WRITELN();
                        }
                      DETAB(1);
                      WRITEBLANKS();
                      WRITESTRING("} else {");
                      WRITELN();
                      TAB(1);
                        WRITEBLANKS();
                        WRITEIDENT(HitId);
                        WRITESTRING("[PE] = TRUE;");
                        WRITELN();
                        WRITEBLANKS();
                        WRITEIDENT(To);
                        WRITESTRING("[PE] = ");
                        WRITEIDENT(FromId);
                        WRITESTRING("[");
                        CodeExprWrite(t->ProcSpec.Expr, MINPREC_PREC);
                        WRITESTRING(" - 1");
                        WRITESTRING("];");
                        WRITELN();
                      DETAB(1);
                      WRITEBLANKS();
                      WRITESTRING("}");
                      WRITELN();
                    DETAB(1);
                    WRITEBLANKS();
                    WRITESTRING("}");
                    WRITELN();
                  DETAB(1);
                  WRITEBLANKS();
                  WRITESTRING("}");
                  WRITELN();
                  CodeExprClose(From);
                  CodeExprClose(t->ProcSpec.Expr);
                  WRITEBLANKS();
                  WRITESTRING("free(");
                  WRITEIDENT(HitId);
                  WRITESTRING(");");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("free(");
                  WRITEIDENT(FromId);
                  WRITESTRING(");");
                  WRITELN();
                DETAB(1);
                WRITEBLANKS();
                WRITESTRING("}");
                WRITELN();

  }
END_RULE;
   return;
 }

  }
  if (t->Kind == kDimSpec) {
/* line 11644 "new_C.puma" */
 {
  tIdent FromId;
  tIdent ToId;
  tIdent HitId;
  tIdent SourcePE;
  tIdent DestPE;
  ULONG Rank;
  tTree Act;
  ULONG ActDim;
  ULONG ActualDimension;
  CHARBUF ReduceFunction;
  {
/* line 11645 "new_C.puma" */
BEGIN_RULE(384);
/* line 11647 "new_C.puma" */

/* line 11648 "new_C.puma" */

/* line 11649 "new_C.puma" */

/* line 11650 "new_C.puma" */

/* line 11651 "new_C.puma" */

/* line 11652 "new_C.puma" */

/* line 11653 "new_C.puma" */

/* line 11654 "new_C.puma" */

/* line 11655 "new_C.puma" */

/* line 11656 "new_C.puma" */

/* line 11657 "new_C.puma" */

                FromId = GenIdents_HelpVar();
                ToId = GenIdents_HelpVar();
                HitId = GenIdents_HelpVar();
                SourcePE = GenIdents_HelpVar();
                DestPE = GenIdents_HelpVar();
                Rank = From->Expr.Type->SymVector.Config->SymConfig.Rank;
                WRITEBLANKS();
                WRITESTRING("{");
                WRITELN();
                TAB(1);
                  WRITEBLANKS();
                  CodeTypeName(From->Expr.Type);
                  WRITESTRING(" *");
                  WRITEIDENT(FromId);
                  WRITESTRING(" = (void *) malloc(sizeof(");
                  CodeTypeName(From->Expr.Type);
                  WRITESTRING(") * LEN(");
                  CodeWriteConfigName(From);
                  WRITESTRING("));");
                  WRITELN();
                  WRITEBLANKS();
                  CodeTypeName(ToType);
                  WRITESTRING(" *");
                  WRITEIDENT(ToId);
                  WRITESTRING(" = (void *) malloc(sizeof(");
                  CodeTypeName(ToType);
                  WRITESTRING(") * LEN(");
                  CodeWriteConfigName2(ToType);
                  WRITESTRING("));");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("BOOLEAN *");
                  WRITEIDENT(HitId);
                  WRITESTRING(" = (void *) malloc(sizeof(BOOLEAN) * LEN(");
                  CodeWriteConfigName2(ToType);
                  WRITESTRING("));");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("CARDINAL ");
                  WRITEIDENT(SourcePE);
                  WRITESTRING(", ");
                  WRITEIDENT(DestPE);
                  WRITESTRING(";");
                  WRITELN();
                  Act = t->DimSpec.Actuals; ActDim = Rank;
                  while (Act->Kind != kNoActual) {
                    if (Act->Kind == kActualStar) {
                      WRITEBLANKS();
                      WRITESTRING("INTEGER *");
                      WRITEIDENT(Act->ActualStar.HelpVar);
                      WRITESTRING(" = DIM(");
                      CodeWriteConfigName(From);
                      WRITESTRING(", ");
                      WRITECARD(ActDim);
                      WRITESTRING(");");
		      WRITELN();
                    }
                    Act = Act->Actual.Next;
                    ActDim--;
                  }
                  CodeActualsBegin(t->DimSpec.Actuals);
                  CodeExprBegin2(From);
                  CodeExprCompute3(From);
                  WRITEBLANKS();
                  WRITESTRING("SOURCE_ARRAY = (INTEGER *) malloc(sizeof(INTEGER) * RANK(");
                  CodeWriteConfigName(From);
                  WRITESTRING("));");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("DESTINATION_ARRAY = (INTEGER *) malloc(sizeof(INTEGER) * RANK(");
                  CodeWriteConfigName(From);
                  WRITESTRING("));");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("for (PE = 0; PE < LEN(");
                  CodeWriteConfigName(From);
                  WRITESTRING("); PE++) {");
                  WRITELN();
                  TAB(1);
                    WRITEBLANKS();
                    WRITEIDENT(FromId);
                    WRITESTRING("[PE] = ");
                    CodeExprWrite(From, ASSIGN_PREC);
                    WRITESTRING(";");
                    WRITELN();
                    WRITEBLANKS();
                    WRITEIDENT(ToId);
                    WRITESTRING("[PE] = ");
                    WRITEIDENT(FromId);
                    WRITESTRING("[PE]");
                    WRITESTRING(";");
                    WRITELN();
                    WRITEBLANKS();
                    WRITEIDENT(HitId);
                    WRITESTRING("[PE] = FALSE;");
                    WRITELN();
                  DETAB(1);
                  WRITEBLANKS();
                  WRITESTRING("}");
                  WRITELN();
                  if (t->DimSpec.Reduce != NoQualid) {
                    GetString(t->DimSpec.Reduce->Qualid.Ident, ReduceFunction);
                  } else if (t->DimSpec.Actuals->Actuals.ReduceNumber == 1) {
                    Act = t->DimSpec.Actuals; ActualDimension = Rank;
                    while (Act->Kind != kActualReduce) {
                      Act = Act->Actual.Next;
                      ActualDimension--;
                    }
                    GetString(Act->ActualReduce.Qualid->Qualid.Ident, ReduceFunction);
                  }
                  WRITEBLANKS();
                  WRITESTRING("for (PE = 0; PE < LEN(");
                  CodeWriteConfigName(From);
                  WRITESTRING("); PE ++) {");
                  WRITELN();
                  TAB(1);
                    WRITEBLANKS();
                    WRITESTRING("if (IS_ACTIVE(");
                    CodeWriteConfigName(From);
                    WRITESTRING(", PE)) {");
                    WRITELN();
                    TAB(1);
                      Act = t->DimSpec.Actuals; ActDim = Rank;
                      while (Act->Kind != kNoActual) {
                        WRITEBLANKS();
                        WRITESTRING("SOURCE_ARRAY[");
                        WRITECARD(ActDim-1);
                        WRITESTRING("] = ");
                        if (Act->Kind == kActualExpr) {
                          CodeExprWrite(Act->ActualExpr.Expr, ASSIGN_PREC);
                        } else if (Act->Kind == kActualStar) {
                          WRITEIDENT(Act->ActualStar.HelpVar);
                          WRITESTRING("[PE]");
                        } else if (Act->Kind == kActualReduce) {
                          WRITESTRING("LOWER(");
                          CodeWriteConfigName(From);
                          WRITESTRING(", ");
                          WRITECARD(ActualDimension);
                          WRITESTRING(")");
                        }
                        WRITESTRING(";");
			WRITELN();
                        Act = Act->Actual.Next;
                        ActDim--;
                      }
                      WRITEBLANKS();
                      WRITEIDENT(SourcePE);
                      WRITESTRING(" = DIM2ID(");
                      CodeWriteConfigName(From);
                      WRITESTRING(", SOURCE_ARRAY) - 1;");
                      WRITELN();
                      if (Options_IsOptionSet(Options_eChecks)) {
                        WRITEBLANKS();
                        WRITESTRING("(void) CHECK_PE_NUMBER(");
                        CodeWriteConfigName(From);
                        WRITESTRING(", ");
                        WRITEIDENT(SourcePE);
                    
                        WRITESTRING(", __FILE__, __LINE__);");
			WRITELN();
                      }
                      WRITEBLANKS();
                      WRITESTRING("if (");
                      WRITEIDENT(HitId);
                      WRITESTRING("[PE]) {");
                      WRITELN();
                      TAB(1);
                        if (t->DimSpec.Reduce != NoQualid || t->DimSpec.Actuals->Actuals.ReduceNumber == 1) {
                          WRITEBLANKS();
                          WRITEIDENT(ToId);
                          WRITESTRING("[PE] = ");
                          if (strcmp(ReduceFunction, "SUM") == 0) {
                            WRITEIDENT(ToId);
                            WRITESTRING("[PE] + ");
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            WRITEIDENT(SourcePE);
                            WRITESTRING("]");
                          } else if (strcmp(ReduceFunction, "PRODUCT") == 0) {
                            WRITEIDENT(ToId);
                            WRITESTRING("[PE] * ");
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            WRITEIDENT(SourcePE);
                            WRITESTRING("]");
                          } else if (strcmp(ReduceFunction, "AND") == 0) {
                            WRITEIDENT(ToId);
                            WRITESTRING("[PE] && ");
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            WRITEIDENT(SourcePE);
                            WRITESTRING("]");
                          } else if (strcmp(ReduceFunction, "OR") == 0) {
                            WRITEIDENT(ToId);
                            WRITESTRING("[PE] || ");
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            WRITEIDENT(SourcePE);
                            WRITESTRING("]");
                          } else if (strcmp(ReduceFunction, "MAX") == 0) {
                            WRITESTRING("MAX(");
                            WRITEIDENT(ToId);
                            WRITESTRING("[PE], ");
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            WRITEIDENT(SourcePE);
                            WRITESTRING("])");
                          } else if (strcmp(ReduceFunction, "MIN") == 0) {
                            WRITESTRING("MIN(");
                            WRITEIDENT(ToId);
                            WRITESTRING("[PE], ");
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            WRITEIDENT(SourcePE);
                            WRITESTRING("])");
                          } else if (strcmp(ReduceFunction, "FIRST") == 0) {
                            WRITEIDENT(ToId);
                            WRITESTRING("[PE];");
                          } else if (strcmp(ReduceFunction, "LAST") == 0) {
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            WRITEIDENT(SourcePE);
                            WRITESTRING("])");
                          } else { 
                            WRITESTRING("*");
                            WRITEIDENT(t->DimSpec.Reduce->Qualid.Object->SymObject.CIdent);
                            WRITESTRING("(&(");
                            WRITEIDENT(ToId);
                            WRITESTRING("[PE]), &(");
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            WRITEIDENT(SourcePE);
                            WRITESTRING("]), CONFIG_1)");
                          }
                          WRITESTRING(";");
			  WRITELN();
                        }
                      DETAB(1);
                      WRITEBLANKS();
                      WRITESTRING("} else {");
                      WRITELN();
                      TAB(1);
                        WRITEBLANKS();
                        WRITEIDENT(HitId);
                        WRITESTRING("[PE] = TRUE;");
                        WRITELN();
                        WRITEBLANKS();
                        WRITEIDENT(ToId);
                        WRITESTRING("[PE] = ");
                        WRITEIDENT(FromId);
                        WRITESTRING("[");
                        WRITEIDENT(SourcePE);
                        WRITESTRING("];");
                        WRITELN();
                      DETAB(1);
                      WRITEBLANKS();
                      WRITESTRING("}");
                      WRITELN();
                    DETAB(1);
                    WRITEBLANKS();
                    WRITESTRING("}");
                    WRITELN();
                  DETAB(1);
                  WRITEBLANKS();
                  WRITESTRING("}");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("for (PE = 0; PE < LEN(");
                  CodeWriteConfigName2(ToType);
                  WRITESTRING("); PE++) {");
                  WRITELN();
                  TAB(1);
                    WRITEBLANKS();
                    WRITESTRING("if (");
                    WRITEIDENT(HitId);
                    WRITESTRING("[PE]) {");
                    WRITELN();
                    TAB(1);
                      WRITEBLANKS();
                      WRITEIDENT(To);
                      WRITESTRING("[PE] = ");
                      WRITEIDENT(ToId);
                      WRITESTRING("[PE];");
                      WRITELN();
                    DETAB(1);
                    WRITEBLANKS();
                    WRITESTRING("}");
                    WRITELN();
                  DETAB(1);
                  WRITEBLANKS();
                  WRITESTRING("}");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("free(SOURCE_ARRAY);");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("free(DESTINATION_ARRAY);");
                  WRITELN();
                  CodeExprClose(From);
                  CodeActualsClose(t->DimSpec.Actuals);
                  Act = t->DimSpec.Actuals;
                  while (Act->Kind != kNoActual) {
                    if (Act->Kind == kActualStar) {
                      WRITEBLANKS();
                      WRITESTRING("free(");
                      WRITEIDENT(Act->ActualStar.HelpVar);
                      WRITESTRING(");");
		      WRITELN();
                    }
                    Act = Act->Actual.Next;
                  }
                  WRITEBLANKS();
                  WRITESTRING("free(");
                  WRITEIDENT(HitId);
                  WRITESTRING(");");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("free(");
                  WRITEIDENT(ToId);
                  WRITESTRING(");");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("free(");
                  WRITEIDENT(FromId);
                  WRITESTRING(");");
                  WRITELN();
                DETAB(1);
                WRITEBLANKS();
                WRITESTRING("}");
                WRITELN();

  }
END_RULE;
   return;
 }

  }
/* line 11990 "new_C.puma" */
  {
/* line 11991 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeStmtsMove
# if defined __STDC__ | defined __cplusplus
(register tTree t, register tTree From, register tIdent To, tType ToType)
# else
(t, From, To, ToType)
 register tTree t;
 register tTree From;
 register tIdent To;
 tType ToType;
# endif
{
/* line 11997 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kFuncSpec) {
/* line 12004 "new_C.puma" */
 {
  tIdent FromId;
  tIdent HitId;
  tIdent LinkId;
  CHARBUF ReduceFunction;
  {
/* line 12005 "new_C.puma" */
BEGIN_RULE(385);
/* line 12007 "new_C.puma" */

/* line 12008 "new_C.puma" */

/* line 12009 "new_C.puma" */

/* line 12010 "new_C.puma" */

/* line 12011 "new_C.puma" */

                FromId = GenIdents_HelpVar();
                HitId = GenIdents_HelpVar();
                LinkId = GenIdents_HelpVar();
                WRITEBLANKS();
                WRITESTRING("{");
                WRITELN();
                TAB(1);
                  WRITEBLANKS();
                  CodeTypeName(From->Expr.Type);
                  WRITESTRING(" *");
                  WRITEIDENT(FromId);
                  WRITESTRING(" = (void *) malloc(sizeof(");
                  CodeTypeName(From->Expr.Type);
                  WRITESTRING(") * LEN(");
                  CodeWriteConfigName(From);
                  WRITESTRING("));");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("BOOLEAN *");
                  WRITEIDENT(HitId);
                  WRITESTRING(" = (void *) malloc(sizeof(BOOLEAN) * LEN(");
                  CodeWriteConfigName2(ToType);
                  WRITESTRING("));");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("LINK *");
                  WRITEIDENT(LinkId);
                  WRITESTRING(";");
                  WRITELN();
                  CodeExprBegin(t->FuncSpec.DirOutIndex);
                  CodeExprBegin(From);
                  WRITEBLANKS();
                  WRITESTRING("for (PE = 0; PE < LEN(");
                  CodeWriteConfigName(From);
                  WRITESTRING("); PE++) {");
                  WRITELN();
                  TAB(1);
                    WRITEBLANKS();
                    WRITEIDENT(FromId);
                    WRITESTRING("[PE] = ");
                    CodeExprWrite(From, ASSIGN_PREC);
                    WRITESTRING(";");
                    WRITELN();
                    if (Types_VectorsCompatible(From->Expr.Type, ToType)) {
                      WRITEBLANKS();
                      WRITEIDENT(To);
                      WRITESTRING("[PE] = ");
                      WRITEIDENT(FromId);
                      WRITESTRING("[PE];");
		      WRITELN();
                    }
                  DETAB(1);
                  WRITEBLANKS();
                  WRITESTRING("}");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("for (PE = 0; PE < LEN(");
                  CodeWriteConfigName2(ToType);
                  WRITESTRING("); PE++) {");
                  WRITELN();
                  TAB(1);
                    WRITEBLANKS();
                    WRITEIDENT(HitId);
                    WRITESTRING("[PE] = FALSE;");
                    WRITELN();
                  DETAB(1);
                  WRITEBLANKS();
                  WRITESTRING("}");
                  WRITELN();
                  WRITEBLANKS();
                  WRITEIDENT(LinkId);
                  if (t->FuncSpec.DirOutIndex == NoExpr) {
                    if (t->FuncSpec.DirOut->Qualid.Object->SymConnect.SourceConfig->SymConfig.IsGeneric) {
                      WRITESTRING(" = GET_GENERIC_LINKS(\"");
                      WRITEIDENT(t->FuncSpec.DirOut->Qualid.Object->SymObject.CIdent);
                      WRITESTRING("\", &");
                      CodeWriteConfigName(From);
                      WRITESTRING(");");
		      WRITELN();
                    } else {
                      WRITESTRING(" = GET_LINKS(");
                      WRITEIDENT(t->FuncSpec.DirOut->Qualid.Object->SymObject.CIdent);
                      WRITESTRING(");");
		      WRITELN();
                    }
                  } else {
                    if (t->FuncSpec.DirOut->Qualid.Object->SymConnect.SourceConfig->SymConfig.IsGeneric) {
                      WRITESTRING(" = GET_GENERIC_PARAMETER_LINKS(\"");
                      WRITEIDENT(t->FuncSpec.DirOut->Qualid.Object->SymObject.CIdent);
                      WRITESTRING("\", &");
                      CodeWriteConfigName(From);
                      WRITESTRING(", ");
                      CodeExprWrite(t->FuncSpec.DirOutIndex, PASSVALUE_PREC);
                      WRITESTRING(");");
		      WRITELN();
                    } else {
                      WRITESTRING(" = GET_PARAMETER_LINKS(");
                      WRITEIDENT(t->FuncSpec.DirOut->Qualid.Object->SymObject.CIdent);
                      WRITESTRING(", ");
                      CodeExprWrite(t->FuncSpec.DirOutIndex, PASSVALUE_PREC);
                      WRITESTRING(");");
		      WRITELN();
                    }
                  }
                  WRITEBLANKS();
                  WRITESTRING("while (");
                  WRITEIDENT(LinkId);
                  WRITESTRING(" != NULL) {");
                  WRITELN();
                  TAB(1);
                    WRITEBLANKS();
                    WRITESTRING("if (IS_ACTIVE(");
                    CodeWriteConfigName(From);
                    WRITESTRING(", ");
                    WRITEIDENT(LinkId);
                    WRITESTRING("->SourceID) && IS_ACTIVE(");
                    CodeWriteConfigName2(ToType);
                    WRITESTRING(", ");
                    WRITEIDENT(LinkId);
                    WRITESTRING("->DestinationID)) {");
                    WRITELN();
                    TAB(1);
                      WRITEBLANKS();
                      WRITESTRING("if (");
                      WRITEIDENT(HitId);
                      WRITESTRING("[");
                      WRITEIDENT(LinkId);
                      WRITESTRING("->DestinationID]) {");
                      WRITELN();
                      TAB(1);
                        if (t->FuncSpec.Reduce != NoQualid) {
                          GetString(t->FuncSpec.Reduce->Qualid.Ident, ReduceFunction);
                          WRITEBLANKS();
                          WRITEIDENT(To);
                          WRITESTRING("[");
                          WRITEIDENT(LinkId);
                          WRITESTRING("->DestinationID] = ");
                          if (strcmp(ReduceFunction, "SUM") == 0) {
                            WRITEIDENT(To);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->DestinationID] + ");
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->SourceID]");
                          } else if (strcmp(ReduceFunction, "PRODUCT") == 0) {
                            WRITEIDENT(To);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->DestinationID] * ");
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->SourceID]");
                          } else if (strcmp(ReduceFunction, "AND") == 0) {
                            WRITEIDENT(To);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->DestinationID] && ");
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->SourceID]");
                          } else if (strcmp(ReduceFunction, "OR") == 0) {
                            WRITEIDENT(To);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->DestinationID] || ");
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->SourceID]");
                          } else if (strcmp(ReduceFunction, "MAX") == 0) {
                            WRITESTRING("MAX(");
                            WRITEIDENT(To);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->DestinationID], ");
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->SourceID])");
                          } else if (strcmp(ReduceFunction, "MIN") == 0) {
                            WRITESTRING("MIN(");
                            WRITEIDENT(To);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->DestinationID], ");
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->SourceID])");
                          } else if (strcmp(ReduceFunction, "FIRST") == 0) {
                            WRITEIDENT(To);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->DestinationID]");
                          } else if (strcmp(ReduceFunction, "LAST") == 0) {
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->SourceID]");
                          } else { 
                            WRITESTRING("*");
                            WRITEIDENT(t->FuncSpec.Reduce->Qualid.Object->SymObject.CIdent);
                            WRITESTRING("(&(");
                            WRITEIDENT(To);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->DestinationID]), &(");
                            WRITEIDENT(FromId);
                            WRITESTRING("[");
                            WRITEIDENT(LinkId);
                            WRITESTRING("->SourceID]), CONFIG_1)");
                          }
                          WRITESTRING(";");
			  WRITELN();
                        }
                      DETAB(1);
                      WRITEBLANKS();
                      WRITESTRING("} else {");
                      WRITELN();
                      TAB(1);
                        WRITEBLANKS();
                        WRITEIDENT(HitId);
                        WRITESTRING("[");
                        WRITEIDENT(LinkId);
                        WRITESTRING("->DestinationID] = TRUE;");
                        WRITELN();
                        WRITEBLANKS();
                        WRITEIDENT(To);
                        WRITESTRING("[");
                        WRITEIDENT(LinkId);
                        WRITESTRING("->DestinationID] = ");
                        WRITEIDENT(FromId);
                        WRITESTRING("[");
                        WRITEIDENT(LinkId);
                        WRITESTRING("->SourceID];");
                        WRITELN();
                      DETAB(1);
                      WRITEBLANKS();
                      WRITESTRING("}");
                      WRITELN();
                    DETAB(1);
                    WRITEBLANKS();
                    WRITESTRING("}");
                    WRITELN();
                    WRITEBLANKS();
                    WRITEIDENT(LinkId);
                    WRITESTRING(" = ");
                    WRITEIDENT(LinkId);
                    WRITESTRING("->Next;");
                    WRITELN();
                  DETAB(1);
                  WRITEBLANKS();
                  WRITESTRING("}");
                  WRITELN();
                  CodeExprClose(From);
                  CodeExprClose(t->FuncSpec.DirOutIndex);
                  WRITEBLANKS();
                  WRITESTRING("free(");
                  WRITEIDENT(HitId);
                  WRITESTRING(");");
                  WRITELN();
                  WRITEBLANKS();
                  WRITESTRING("free(");
                  WRITEIDENT(FromId);
                  WRITESTRING(");");
                  WRITELN();
                DETAB(1);
                WRITEBLANKS();
                WRITESTRING("}");
                WRITELN();

  }
END_RULE;
   return;
 }

  }
/* line 12288 "new_C.puma" */
  {
/* line 12289 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeStdProc
# if defined __STDC__ | defined __cplusplus
(register tTree a1, INDEX StdProc, tObject AllocOrDealloc)
# else
(a1, StdProc, AllocOrDealloc)
 register tTree a1;
 INDEX StdProc;
 tObject AllocOrDealloc;
# endif
{
/* line 12295 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (a1->Kind == kNoActual) {
/* line 12307 "new_C.puma" */
  {
/* line 12308 "new_C.puma" */
BEGIN_RULE(386);
/* line 12310 "new_C.puma" */

                switch (StdProc) {
                case eSystemHalt       : WRITESTRING("exit(1)");       break;
                case eSystemArgc       : WRITESTRING("argc()");        break;
                case eSystemCardRandom : WRITESTRING("RandomCard");  break;
                case eSystemIntRandom  : WRITESTRING("RandomInt");   break;
                case eSystemRealRandom : WRITESTRING("RandomReal");  break;
                case eSystemBoolRandom : WRITESTRING("RandomBool");  break;
                case eSystemCharRandom : WRITESTRING("RandomChar");  break;
                case eSystemWriteLn    : WRITESTRING("WriteLn()");     break;
                case eSystemCloseOutput: WRITESTRING("CloseOutput()"); break;
                case eSystemCloseInput : WRITESTRING("CloseInput()");  break;
                }

  }
END_RULE;
   return;

  }
  if (a1->Kind == kActualExpr) {
  if (a1->ActualExpr.Next->Kind == kNoActual) {
  if (a1->ActualExpr.Expr->Kind == kQualid0) {
/* line 12325 "new_C.puma" */
  {
/* line 12326 "new_C.puma" */
BEGIN_RULE(387);
/* line 12328 "new_C.puma" */
   if (! ((Symbols_IsOpenArray (a1->ActualExpr.Expr -> Qualid0 . Object)))) goto yyL2;
  {
/* line 12329 "new_C.puma" */

                switch (StdProc) {
                case eSystemHigh:
                  WRITESTRING("(");
                  if (a1->ActualExpr.Expr->Qualid0.IsGlobalPtr) {
                    WRITEIDENT(Pointer_GetGlobalPtr(a1->ActualExpr.Expr->Qualid0.Object));
                    WRITESTRING("_O");
                  } else {
                    WRITEIDENT( Parameter_GetParam (a1->ActualExpr.Expr->Qualid0.Object) );
                  }
                  WRITESTRING(" - 1)");
                  break;
                case eSystemAdr:
                  WRITESTRING("ADR1(");
                  CodeExpr(a1->ActualExpr.Expr, PASSVALUE_PREC);
                  WRITESTRING(")");
                  break;
                case eSystemSize:
                  WRITESTRING("(sizeof(");
                  if (a1->ActualExpr.Expr->Qualid0.Type->Kind == kSymVector) {
                    CodeTypeName(a1->ActualExpr.Expr->Qualid0.Type->SymVector.Type->SymArray.ElemType);
                  } else {
                    CodeTypeName(a1->ActualExpr.Expr->Qualid0.Type->SymArray.ElemType);
                  }
                  WRITESTRING(") * ");
                  if (a1->ActualExpr.Expr->Qualid0.IsGlobalPtr) {
                    WRITEIDENT(Pointer_GetGlobalPtr(a1->ActualExpr.Expr->Qualid0.Object));
                    WRITESTRING("_O");
                  } else {
                    WRITEIDENT(Parameter_GetParam(a1->ActualExpr.Expr->Qualid0.Object));
                  }
                  WRITESTRING(")");
                  break;
                case eSystemWriteString:
                case eSystemReadString :
                case eSystemOpenInput  :
                case eSystemOpenOutput :
                  switch (StdProc) {
                  case eSystemWriteString: WRITESTRING("WriteString"); break;
                  case eSystemReadString : WRITESTRING("ReadString");  break;
                  case eSystemOpenInput  : WRITESTRING("OpenInput");   break;
                  case eSystemOpenOutput : WRITESTRING("OpenOutput");  break;
                  }
                  WRITESTRING("(");
                  CodeStdActualWrite(a1, PASSVALUE_PREC);
                  WRITESTRING(")");
                  break;
                }

  }
  }
END_RULE;
   return;
yyL2:;

  }
/* line 12379 "new_C.puma" */
 {
  tValue Upb;
  tType Type;
  {
/* line 12380 "new_C.puma" */
BEGIN_RULE(388);
/* line 12382 "new_C.puma" */

/* line 12383 "new_C.puma" */

/* line 12384 "new_C.puma" */

                switch (StdProc) {
                case eSystemHigh:
                  Type = Symbols_GetIndexType(a1->ActualExpr.Expr->Expr.Type);
                  Types_GetUpb(Type, &Upb);
                  CodeValue(Upb);
                  if (Symbols_IsIntType(Type) &&
                      Types_Cast(Code_PassValue, Type, TypeIntCard)) {
                    WRITESTRING("L");
                  };
                  break;
                case eSystemMin:
                  CodeMinimum(a1->ActualExpr.Expr->Expr.Type);
                  break;
                case eSystemMax:
                  CodeMaximum(a1->ActualExpr.Expr->Expr.Type);
                  break;
                case eSystemAdr:
                  if (a1->ActualExpr.Expr->Expr.Type->Kind == kSymVector) {
                    WRITESTRING("ADR1(");
                  } else {
                    WRITESTRING("ADR(");
                  }
                  CodeExpr(a1->ActualExpr.Expr, PASSVALUE_PREC);
                  WRITESTRING(")");
                  break;
                case eSystemSize :
                case eSystemTSize:
                  WRITESTRING("sizeof(");
                  CodeExprWrite(a1->ActualExpr.Expr, PASSVALUE_PREC);
                  WRITESTRING(")");
                  break;
                case eSystemAbs:
                  if (a1->ActualExpr.Expr->Expr.IsCConst) {
                    WRITESTRING("ABS");
                  } else {
                    Type = a1->ActualExpr.Expr->Expr.Type;
                    if (Type->Kind == kSymVector) {
                      Type = Type->SymVector.Type;
                    }
                    if (Type->Kind == kSymSubrange) {
                      Type = Type->SymSubrange.Type;
                    }
                    switch (Type->Kind) {
                    case kSymIntCard :
                    case kSymInteger : WRITESTRING("ABSI"); break;
                    case kSymCardinal: WRITESTRING("ABSC"); break;
                    case kSymReal    : WRITESTRING("ABSR"); break;
                    };  
                  }; 
                  WRITESTRING("(");
                  CodeExprWrite(a1->ActualExpr.Expr, PASSVALUE_PREC);
                  WRITESTRING(")");
                  break;
                case eSystemNew    :
                case eSystemDispose:
                  WRITEIDENT(AllocOrDealloc->SymObject.CIdent);
                  WRITESTRING("(");
                  WRITESTRING("(ADDRESS *)");
                  CodeAdr(a1->ActualExpr.Expr);
                  WRITESTRING(", ");
                  if (Options_IsOptionSet(Options_eCasts))  {
                     WRITESTRING("(CARDINAL)");
                  };
                  WRITESTRING("sizeof(");
                  CodeTypeName(Symbols_GetTargetType(a1->ActualExpr.Expr->Expr.Type));
                  WRITESTRING(")");
                  if (IsVector(a1->ActualExpr.Expr)) {
                    WRITESTRING(" * LEN(");
                    CodeWriteConfigName(a1->ActualExpr.Expr);
                    WRITESTRING(")");
                  }
                  WRITESTRING(")");
                  break;
                case eSystemOpenInput:
                case eSystemOpenOutput:
                  switch (StdProc) {
                  case eSystemOpenInput : WRITESTRING("OpenInput");  break;
                  case eSystemOpenOutput: WRITESTRING("OpenOutput"); break;
                  }
                  WRITESTRING("(");
                  CodeString3(a1->ActualExpr.Expr);
                  WRITESTRING(")");
                  break;
                case eSystemWrite:
                  if (IsVector(a1->ActualExpr.Expr)) {
                    WRITESTRING("Write1");
                    WRITESTRING("(");
                    CodeWriteConfigName(a1->ActualExpr.Expr);
                    WRITESTRING(", ");
                  } else {
                    WRITESTRING("Write");
                    WRITESTRING("(");
                  }
                  CodeStdActualWrite(a1, PASSVALUE_PREC);
                  WRITESTRING(")");
                  break;
                case eSystemWriteString:
                  if (IsVector(a1->ActualExpr.Expr)) {
                    if (a1->ActualExpr.Expr->Expr.Type->SymVector.Type == TypeStringChar) {
                      WRITESTRING("WriteStringChar1(");
                      CodeWriteConfigName(a1->ActualExpr.Expr);
                      WRITESTRING(", ");
                      CodeStdActualWrite(a1, PASSVALUE_PREC );
                      WRITESTRING(")");
                    } else {
                      WRITESTRING("{");
		      WRITELN();
                      TAB(1);
                      	WRITEBLANKS();
                      	WRITESTRING("CHAR **A;");
		        WRITELN();
                      	WRITEBLANKS();
                      	WRITESTRING("A = (CHAR **) malloc(sizeof(CHAR *) * LEN(");
                      	CodeWriteConfigName(a1->ActualExpr.Expr);
                      	WRITESTRING("));");
		        WRITELN();
                      	WRITEBLANKS();
                      	WRITESTRING("for (PE = 0; PE < LEN(");
                      	CodeWriteConfigName(a1->ActualExpr.Expr);
                      	WRITESTRING("); PE++) {");
		        WRITELN();
                      	
                      	TAB(1);
                        	WRITEBLANKS();
                        	WRITESTRING("A[PE] = (CHAR *) &(");
                        	CodeStdActualWrite(a1, PASSVALUE_PREC);
                        	WRITESTRING("[PE]);");
		                WRITELN();
                      	DETAB(1);
                      	WRITEBLANKS();
                      	WRITESTRING("}");
		        WRITELN();
                      	WRITEBLANKS();
                      	WRITESTRING("WriteString1(");
                      	CodeWriteConfigName(a1->ActualExpr.Expr);
                      	WRITESTRING(", A);");
		        WRITELN();
                      	WRITEBLANKS();
                      	WRITESTRING("free(A);");
		        WRITELN();
                      	WRITEBLANKS();
                      DETAB(1);
                      WRITEBLANKS();
                      WRITESTRING("}");
		    }
                  } else {
                    if (a1->ActualExpr.Expr->Expr.Type == TypeStringChar) {
                      WRITESTRING("Write(");
                      CodeStdActualWrite(a1, PASSVALUE_PREC );
                      WRITESTRING(")");
                    } else {
                      WRITESTRING("WriteString(");
                      CodeStdActualWrite(a1, PASSVALUE_PREC );
                      if (a1->ActualExpr.Expr->Kind != kStringConst) {
                        WRITESTRING(".A");
                      }
                      WRITESTRING(")");
                    }
                  }
                  break;
                case eSystemRead       :
                case eSystemReadInt    :
                case eSystemReadCard   :
                case eSystemReadReal   :
                case eSystemReadBoolean:
                  if (IsVector(a1->ActualExpr.Expr)) {
                    switch (StdProc) {
                    case eSystemRead       : WRITESTRING("Read1");     break;
                    case eSystemReadInt    : WRITESTRING("ReadInt1");  break;
                    case eSystemReadCard   : WRITESTRING("ReadCard1"); break;
                    case eSystemReadReal   : WRITESTRING("ReadReal1"); break;
                    case eSystemReadBoolean: WRITESTRING("ReadBool1"); break;
                    }
                    WRITESTRING("(");
                    CodeWriteConfigName(a1->ActualExpr.Expr);
                    WRITESTRING(", ");
                    CodeStdActualWrite(a1, PASSVALUE_PREC );
                    WRITESTRING(")");
                  } else {
                    switch (StdProc) {
                    case eSystemRead       : WRITESTRING("Read");     break;
                    case eSystemReadInt    : WRITESTRING("ReadInt");  break;
                    case eSystemReadCard   : WRITESTRING("ReadCard"); break;
                    case eSystemReadReal   : WRITESTRING("ReadReal"); break;
                    case eSystemReadBoolean: WRITESTRING("ReadBool"); break;
                    }
                    WRITESTRING("(");
		    if (a1->ActualExpr.Expr->Expr.UseHelpVar) {
		      WRITESTRING("&");
		      CodeHelpVarWrite(a1->ActualExpr.Expr);
		    } else {
                      CodeAdr(a1->ActualExpr.Expr);
		    }
                    WRITESTRING(")");
                  }
                  break;
                case eSystemReadString:
                  if (IsVector(a1->ActualExpr.Expr)) {
                      WRITESTRING("{");
		      WRITELN();
                      TAB(1);
                      	WRITEBLANKS();
                      	WRITESTRING("CHAR **A;");
		        WRITELN();
                      	WRITEBLANKS();
                      	WRITESTRING("A = (CHAR **) malloc(sizeof(CHAR *) * LEN(");
                      	CodeWriteConfigName(a1->ActualExpr.Expr);
                      	WRITESTRING("));");
		        WRITELN();
                      	WRITEBLANKS();
                      	WRITESTRING("for (PE = 0; PE < LEN(");
                      	CodeWriteConfigName(a1->ActualExpr.Expr);
                      	WRITESTRING("); PE++) {");
		        WRITELN();
                      	
                      	TAB(1);
                          WRITEBLANKS();
                          WRITESTRING("A[PE] = (CHAR *) &(");
                          CodeStdActualWrite(a1, PASSVALUE_PREC);
                          WRITESTRING("[PE]);");
		          WRITELN();
                      	DETAB(1);
                      	WRITEBLANKS();
                      	WRITESTRING("}");
		        WRITELN();
                      	WRITEBLANKS();
                      	WRITESTRING("ReadString1(");
                      	CodeWriteConfigName(a1->ActualExpr.Expr);
                     	 WRITESTRING(", A);");
		        WRITELN();
                        WRITEBLANKS();
                        WRITESTRING("free(A);");
		        WRITELN();
                        WRITEBLANKS();
                      DETAB(1);
                      WRITEBLANKS();
                      WRITESTRING("}");
                  } else {
                    WRITESTRING("ReadString(");
                    CodeExpr(a1->ActualExpr.Expr, PASSVALUE_PREC);
                    WRITESTRING(".A)");
                  }
                  break;
                case eSystemId:
                case eSystemLen :
                case eSystemRank:
                  switch (StdProc) {
                  case eSystemId  : WRITESTRING("ID");  break;
                  case eSystemLen : WRITESTRING("LEN");  break;
                  case eSystemRank: WRITESTRING("RANK"); break;
                  }
                  WRITESTRING("(");
                  CodeWriteConfigName(a1->ActualExpr.Expr);
                  WRITESTRING(")");
                  break;
                case eSystemCardRandom:
                case eSystemIntRandom :
                case eSystemRealRandom:
                case eSystemBoolRandom:
                case eSystemCharRandom:
                  switch (StdProc) {
                  case eSystemCardRandom: WRITESTRING("RandomCard"); break;
                  case eSystemIntRandom : WRITESTRING("RandomInt");  break;
                  case eSystemRealRandom: WRITESTRING("RandomReal"); break;
                  case eSystemBoolRandom: WRITESTRING("RandomBool"); break;
                  case eSystemCharRandom: WRITESTRING("RandomChar"); break;
                  };
                  break;
                default: 
                  switch (StdProc) {
                  case eSystemCap       : WRITESTRING("CAP");        break;
                  case eSystemChr       : WRITESTRING("CHR");        break;
                  case eSystemDec       : WRITESTRING("DEC");        break;
                  case eSystemEven      : WRITESTRING("EVEN");       break;
                  case eSystemFloat     : WRITESTRING("FLOAT");      break;
                  case eSystemInc       : WRITESTRING("INC");        break;
                  case eSystemOdd       : WRITESTRING("ODD");        break;
                  case eSystemOrd       : WRITESTRING("ORD");        break;
                  case eSystemTrunc     : WRITESTRING("TRUNC");      break;
                  case eSystemSqrt      : WRITESTRING("sqrt");       break;
                  case eSystemExponent  : WRITESTRING("exp");        break;
                  case eSystemLn        : WRITESTRING("log");        break;
                  case eSystemSin       : WRITESTRING("sin");        break;
                  case eSystemArcSin    : WRITESTRING("asin");       break;
                  case eSystemCos       : WRITESTRING("cos");        break;
                  case eSystemArcCos    : WRITESTRING("acos");       break;
                  case eSystemTan       : WRITESTRING("tan");        break;
                  case eSystemArcTan    : WRITESTRING("atan");       break;
                  case eSystemCeiling   : WRITESTRING("ceil");       break;
                  case eSystemFloor     : WRITESTRING("floor");      break;
                  case eSystemRound     : WRITESTRING("round");      break;
                  };
                  WRITESTRING("(");
                  CodeExprWrite( a1->ActualExpr.Expr, PASSVALUE_PREC );
                  WRITESTRING(")");
                }

  }
END_RULE;
   return;
 }

  }
  if (a1->ActualExpr.Next->Kind == kActualExpr) {
  if (a1->ActualExpr.Next->ActualExpr.Next->Kind == kNoActual) {
/* line 12683 "new_C.puma" */
  {
/* line 12684 "new_C.puma" */
BEGIN_RULE(389);
/* line 12686 "new_C.puma" */

                switch (StdProc) {
                case eSystemDec:
                case eSystemInc:
                  switch (StdProc) {
                  case eSystemDec: WRITESTRING("DEC1"); break;
                  case eSystemInc: WRITESTRING("INC1"); break;
                  };
                  WRITESTRING("(");
                  CodeExprWrite(a1->ActualExpr.Expr, PASSVALUE_PREC);
                  WRITESTRING(", ");
                  if (a1->ActualExpr.Next->ActualExpr.Expr->Expr.Type == TypeADDRESS) {
                    WRITESTRING("(CARDINAL)");
                    CodeExprWrite(a1->ActualExpr.Next->ActualExpr.Expr, CAST_PREC);
                  } else {
                    CodeExprWrite(a1->ActualExpr.Next->ActualExpr.Expr, PASSVALUE_PREC);
                  };
                  WRITESTRING(")");
                  break;
                case eSystemArgv:
                  WRITESTRING("argv");
                  WRITESTRING("(");
                  CodeStdActualWrite(a1, PASSVALUE_PREC);
                  WRITESTRING(", ");
                  CodeStdActualWrite(a1->ActualExpr.Next, PASSVALUE_PREC);
                  WRITESTRING(".A)");
                  break;
                case eSystemArcTan2:
                  WRITESTRING("ArcTan2(");
                  CodeExprWrite(a1->ActualExpr.Expr, PASSVALUE_PREC);
                  WRITESTRING(", ");
                  CodeExprWrite(a1->ActualExpr.Next->ActualExpr.Expr, PASSVALUE_PREC);
                  WRITESTRING(")");
                  break;
                case eSystemWriteInt :
                case eSystemWriteCard:
                case eSystemWriteReal:
                case eSystemWriteBoolean:
                  if (IsVector(a1->ActualExpr.Expr)) {
                    switch (StdProc) {
                    case eSystemWriteInt    :WRITESTRING("WriteInt1(");  break;
                    case eSystemWriteCard   :WRITESTRING("WriteCard1("); break;
                    case eSystemWriteReal   :WRITESTRING("WriteReal1("); break;
                    case eSystemWriteBoolean:WRITESTRING("WriteBool1("); break;
                    }
                    CodeWriteConfigName(a1->ActualExpr.Expr);
                    WRITESTRING(", ");
                  } else {
                    switch (StdProc) {
                    case eSystemWriteInt    : WRITESTRING("WriteInt(");  break;
                    case eSystemWriteCard   : WRITESTRING("WriteCard("); break;
                    case eSystemWriteReal   : WRITESTRING("WriteReal("); break;
                    case eSystemWriteBoolean: WRITESTRING("WriteBool("); break;
                    }
                  }
                  CodeStdActualWrite(a1, PASSVALUE_PREC);
                  WRITESTRING(", ");
                  CodeStdActualWrite(a1->ActualExpr.Next, PASSVALUE_PREC);
                  WRITESTRING(")");
                  break;
                case eSystemDim  :
                case eSystemLen  :
                case eSystemUpper:
                case eSystemLower:
                  switch (StdProc) {
                  case eSystemDim  : WRITESTRING("DIM");   break;
                  case eSystemLen  : WRITESTRING("LEN1");  break;
                  case eSystemUpper: WRITESTRING("UPPER"); break;
                  case eSystemLower: WRITESTRING("LOWER"); break;
                  }
                  WRITESTRING("(");
                  CodeWriteConfigName(a1->ActualExpr.Expr);
                  WRITESTRING(", ");
                  CodeStdActualWrite(a1->ActualExpr.Next, PASSVALUE_PREC);
                  WRITESTRING(")");
                  break;
                case eSystemDim2Id:
                  WRITESTRING("DIM2ID(");
                  CodeWriteConfigName(a1->ActualExpr.Expr);
                  WRITESTRING(", ");
                  CodeStdActualWrite(a1->ActualExpr.Next, PASSVALUE_PREC);
                  WRITESTRING(".A)");
                  break;
                default:
                  switch (StdProc) {
                  case eSystemArgv: WRITESTRING("argv"); break;
                  case eSystemExcl: WRITESTRING("EXCL"); break;
                  case eSystemIncl: WRITESTRING("INCL"); break;
                  case eSystemVal : WRITESTRING("VAL");  break;
                  };
                  WRITESTRING("(");
                  CodeExpr(a1->ActualExpr.Expr, PASSVALUE_PREC);
                  WRITESTRING(", ");
                  CodeExpr(a1->ActualExpr.Next->ActualExpr.Expr, PASSVALUE_PREC);
                  WRITESTRING(")");
                }

  }
END_RULE;
   return;

  }
  if (a1->ActualExpr.Next->ActualExpr.Next->Kind == kActualExpr) {
  if (a1->ActualExpr.Next->ActualExpr.Next->ActualExpr.Next->Kind == kNoActual) {
/* line 12784 "new_C.puma" */
  {
/* line 12785 "new_C.puma" */
BEGIN_RULE(390);
/* line 12787 "new_C.puma" */

                switch (StdProc) {
                case eSystemWriteFixPt:
                  if (IsVector(a1->ActualExpr.Expr)) {
                    WRITESTRING("WriteFixPt1(");
                    CodeWriteConfigName(a1->ActualExpr.Expr);
                    WRITESTRING(", ");
                  } else {
                    WRITESTRING("WriteFixPt(");
                  }
                  CodeStdActualWrite(a1, PASSVALUE_PREC );
                  WRITESTRING(", ");
                  CodeStdActualWrite(a1->ActualExpr.Next, PASSVALUE_PREC );
                  WRITESTRING(", ");
                  CodeStdActualWrite(a1->ActualExpr.Next->ActualExpr.Next, PASSVALUE_PREC );
                  WRITESTRING(")");
                  break;
                case eSystemId2Dim:
                  (void) IsVector(a1->ActualExpr.Expr);
                  WRITESTRING("ID2DIM(");
                  CodeWriteConfigName(a1->ActualExpr.Expr);
                  WRITESTRING(", ");
                  CodeStdActualWrite(a1->ActualExpr.Next, PASSVALUE_PREC );
                  WRITESTRING(", ");
                  CodeStdActualWrite(a1->ActualExpr.Next->ActualExpr.Next, PASSVALUE_PREC );
                  WRITESTRING(")");
                  break;
                }

  }
END_RULE;
   return;

  }
  }
  }
  }
/* line 12817 "new_C.puma" */
  {
/* line 12818 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeActuals
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 12824 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kActualExpr) {
/* line 12837 "new_C.puma" */
  {
/* line 12838 "new_C.puma" */
BEGIN_RULE(391);
/* line 12842 "new_C.puma" */
   if (! (((t->ActualExpr.Expr -> Expr . Type == TypeString) || (t->ActualExpr.Expr -> Expr . Type == TypeStringChar)) && (t -> ActualExpr . Formal -> Kind == kSymArray) && ! Symbols_IsOpen (t -> ActualExpr . Formal))) goto yyL1;
  {
/* line 12844 "new_C.puma" */
   WRITEIDENT (t -> ActualExpr . String);
/* line 12845 "new_C.puma" */
   CodeSepa (t->ActualExpr.Next);
/* line 12846 "new_C.puma" */
   CodeActuals (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL1:;

  if (t->ActualExpr.Expr->Kind == kQualid0) {
/* line 12848 "new_C.puma" */
  {
/* line 12849 "new_C.puma" */
BEGIN_RULE(392);
/* line 12851 "new_C.puma" */
   if (! (Symbols_IsOpen (t -> ActualExpr . Formal) && Symbols_IsOpenArray (t->ActualExpr.Expr -> Qualid0 . Object))) goto yyL2;
  {
/* line 12852 "new_C.puma" */

                CodeExpr(t->ActualExpr.Expr, PASSVALUE_PREC);
                WRITESTRING(", ");
                if ( t->ActualExpr.Expr->Qualid0.IsGlobalPtr ) {
                  WRITEIDENT( Pointer_GetGlobalPtr (t->ActualExpr.Expr->Qualid0.Object) );
                  WRITESTRING("_O");
                } else {
                  WRITEIDENT( Parameter_GetParam(t->ActualExpr.Expr->Qualid0.Object) );
                };
                if ( t->Actual.Formal->SymArray.ElemType == TypeWORD ) {
                  WRITESTRING(" * sizeof(");
                  CodeTypeName (t->ActualExpr.Expr->Qualid0.Type->SymArray.ElemType);
                  WRITESTRING(")");
                }
                CodeSepa (t->ActualExpr.Next);

/* line 12868 "new_C.puma" */
   CodeActuals (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL2:;

  }
  if (t->ActualExpr.Expr->Kind == kStringConst) {
/* line 12870 "new_C.puma" */
 {
  ULONG length;
  {
/* line 12871 "new_C.puma" */
BEGIN_RULE(393);
/* line 12873 "new_C.puma" */
   if (! ((Symbols_IsOpen (t -> ActualExpr . Formal)))) goto yyL3;
  {
/* line 12874 "new_C.puma" */
   CodeString2 (t->ActualExpr.Expr, ! STRNCPY);
/* line 12875 "new_C.puma" */
   WRITESTRING (", ");
/* line 12876 "new_C.puma" */

/* line 12877 "new_C.puma" */
   if (! (length = LengthSt (t->ActualExpr.Expr->StringConst.StringVal) + 1)) goto yyL3;
  {
/* line 12878 "new_C.puma" */
   WRITECARD (length);
/* line 12879 "new_C.puma" */
   WRITESTRING ("L");
/* line 12880 "new_C.puma" */
   CodeSepa (t->ActualExpr.Next);
/* line 12881 "new_C.puma" */
   CodeActuals (t->ActualExpr.Next);
  }
  }
  }
END_RULE;
   return;
 }
yyL3:;

  }
  if (t->ActualExpr.Expr->Kind == kCharConst) {
/* line 12883 "new_C.puma" */
  {
/* line 12884 "new_C.puma" */
BEGIN_RULE(394);
/* line 12886 "new_C.puma" */
   if (! ((Symbols_IsOpen (t -> ActualExpr . Formal)))) goto yyL4;
  {
/* line 12887 "new_C.puma" */
   CodeString2 (t->ActualExpr.Expr, ! STRNCPY);
/* line 12888 "new_C.puma" */
   WRITESTRING (", 1L");
/* line 12889 "new_C.puma" */
   CodeSepa (t->ActualExpr.Next);
/* line 12890 "new_C.puma" */
   CodeActuals (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL4:;

  }
  if (Tree_IsType (t->ActualExpr.Expr, kQualid)) {
/* line 12892 "new_C.puma" */
 {
  ULONG length;
  {
/* line 12893 "new_C.puma" */
BEGIN_RULE(395);
/* line 12895 "new_C.puma" */
   if (! (Symbols_IsOpen (t -> ActualExpr . Formal) && (t->ActualExpr.Expr -> Qualid . Type == TypeString))) goto yyL5;
  {
/* line 12897 "new_C.puma" */
   CodeString2 (t->ActualExpr.Expr, ! STRNCPY);
/* line 12898 "new_C.puma" */
   WRITESTRING (", ");
/* line 12899 "new_C.puma" */

/* line 12900 "new_C.puma" */
   if (! (length = LengthSt (t->ActualExpr.Expr -> Qualid . Object -> SymConst . Value . value . stringValue))) goto yyL5;
  {
/* line 12901 "new_C.puma" */
 if (length == 0) { length = 1; }; 
/* line 12902 "new_C.puma" */
   WRITEINT (length);
/* line 12903 "new_C.puma" */
   WRITESTRING ("L");
/* line 12904 "new_C.puma" */
   CodeSepa (t->ActualExpr.Next);
/* line 12905 "new_C.puma" */
   CodeActuals (t->ActualExpr.Next);
  }
  }
  }
END_RULE;
   return;
 }
yyL5:;

/* line 12907 "new_C.puma" */
  {
/* line 12908 "new_C.puma" */
BEGIN_RULE(396);
/* line 12910 "new_C.puma" */
   if (! (Symbols_IsOpen (t -> ActualExpr . Formal) && (t->ActualExpr.Expr -> Qualid . Type == TypeStringChar))) goto yyL6;
  {
/* line 12912 "new_C.puma" */
   CodeString2 (t->ActualExpr.Expr, ! STRNCPY);
/* line 12913 "new_C.puma" */
   WRITESTRING (", 2L");
/* line 12914 "new_C.puma" */
   CodeSepa (t->ActualExpr.Next);
/* line 12915 "new_C.puma" */
   CodeActuals (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL6:;

/* line 12917 "new_C.puma" */
  {
/* line 12918 "new_C.puma" */
BEGIN_RULE(397);
/* line 12920 "new_C.puma" */
   if (! (Symbols_IsOpen (t -> ActualExpr . Formal) && (t->ActualExpr.Expr -> Qualid . Type == TypeCHAR))) goto yyL7;
  {
/* line 12922 "new_C.puma" */
   CodeString2 (t->ActualExpr.Expr, ! STRNCPY);
/* line 12923 "new_C.puma" */
   WRITESTRING (", 2L");
/* line 12924 "new_C.puma" */
   CodeSepa (t->ActualExpr.Next);
/* line 12925 "new_C.puma" */
   CodeActuals (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL7:;

  }
/* line 12927 "new_C.puma" */
  {
/* line 12928 "new_C.puma" */
BEGIN_RULE(398);
/* line 12930 "new_C.puma" */
   if (! (Symbols_IsOpen (t -> ActualExpr . Formal) && (t -> Actual . Formal -> SymArray . ElemType == TypeWORD))) goto yyL8;
  {
/* line 12932 "new_C.puma" */

                if ( Options_IsOptionSet (Options_eCasts)) {
                   WRITESTRING("(WORD *)");
                };
                CodeAdr(t->ActualExpr.Expr);
                WRITESTRING(", ");
                if (Options_IsOptionSet(Options_eCasts)) {
                  WRITESTRING("(CARDINAL)");
                };
                WRITESTRING("sizeof(");
                CodeExpr(t->ActualExpr.Expr, PASSVALUE_PREC);
                WRITESTRING(")");
                CodeSepa (t->ActualExpr.Next);

/* line 12946 "new_C.puma" */
   CodeActuals (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL8:;

/* line 12948 "new_C.puma" */
 {
  tValue Upb;
  tValue Lwb;
  tType IndexType;
  {
/* line 12949 "new_C.puma" */
BEGIN_RULE(399);
/* line 12951 "new_C.puma" */
   if (! (Symbols_IsOpen (t -> ActualExpr . Formal) && (t->ActualExpr.Expr -> Designator . Type -> Kind == kSymArray))) goto yyL9;
  {
/* line 12953 "new_C.puma" */

/* line 12954 "new_C.puma" */

/* line 12955 "new_C.puma" */

/* line 12956 "new_C.puma" */

                IndexType = t->ActualExpr.Expr->Designator.Type->SymArray.IndexType;
                Types_GetLwb( IndexType, &Lwb);
                Types_GetUpb( IndexType, &Upb);
                CodeExpr( t->ActualExpr.Expr, SELECT_PREC);
                WRITESTRING(".A, ");
                WRITEINT(Values_ValueToInt(&Upb) - Values_ValueToInt (&Lwb) + 1);
                WRITESTRING("L");
                CodeSepa (t->ActualExpr.Next);

/* line 12966 "new_C.puma" */
   CodeActuals (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
 }
yyL9:;

/* line 12968 "new_C.puma" */
  {
/* line 12969 "new_C.puma" */
BEGIN_RULE(400);
/* line 12972 "new_C.puma" */
   if (! (t -> ActualExpr . IsVAR && t->ActualExpr.Expr -> Expr . Type -> Kind == kSymVector && t->ActualExpr.Expr -> Kind == kQualid0)) goto yyL10;
  {
/* line 12975 "new_C.puma" */
   CodeExpr (t->ActualExpr.Expr, PASSVALUE_PREC);
/* line 12976 "new_C.puma" */
   CodeSepa (t->ActualExpr.Next);
/* line 12977 "new_C.puma" */
   CodeActuals (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL10:;

/* line 12979 "new_C.puma" */
  {
/* line 12980 "new_C.puma" */
BEGIN_RULE(401);
/* line 12982 "new_C.puma" */
   if (! (t -> ActualExpr . IsVAR && t->ActualExpr.Expr -> Expr . Type -> Kind == kSymVector)) goto yyL11;
  {
/* line 12985 "new_C.puma" */
   CodeCast (t -> ActualExpr . Formal);
/* line 12986 "new_C.puma" */
   CodeExpr (t->ActualExpr.Expr, PASSVALUE_PREC);
/* line 12987 "new_C.puma" */
   CodeSepa (t->ActualExpr.Next);
/* line 12988 "new_C.puma" */
   CodeActuals (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL11:;

/* line 12990 "new_C.puma" */
  {
/* line 12991 "new_C.puma" */
BEGIN_RULE(402);
/* line 12993 "new_C.puma" */
   if (! (t -> ActualExpr . IsVAR)) goto yyL12;
  {
/* line 12995 "new_C.puma" */

                if (Types_Cast(Code_PassAddress, t->Actual.Formal, t->ActualExpr.Expr->Expr.Type)) {
                  CodeCastVAR(t->ActualExpr.Formal);
                };
                CodeAdr(t->ActualExpr.Expr);
                CodeSepa(t->ActualExpr.Next);

/* line 13002 "new_C.puma" */
   CodeActuals (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL12:;

  if (t->ActualExpr.Expr->Kind == kIntConst) {
/* line 13004 "new_C.puma" */
  {
/* line 13005 "new_C.puma" */
BEGIN_RULE(403);
/* line 13007 "new_C.puma" */

                CodeExpr(t->ActualExpr.Expr, PASSVALUE_PREC);
                if (Types_Cast(Code_PassValue, t->ActualExpr.Formal, TypeIntCard)) {
                   WRITESTRING("L");
                };
                CodeSepa(t->ActualExpr.Next);

/* line 13014 "new_C.puma" */
   CodeActuals (t->ActualExpr.Next);
  }
END_RULE;
   return;

  }
  if (t->ActualExpr.Expr->Kind == kUnary) {
  if (t->ActualExpr.Expr->Unary.Mop->Kind == kIntConst) {
/* line 13016 "new_C.puma" */
  {
/* line 13017 "new_C.puma" */
BEGIN_RULE(404);
/* line 13019 "new_C.puma" */
   if (! (t->ActualExpr.Expr -> Unary . COperator == Code_Minus)) goto yyL14;
  {
/* line 13020 "new_C.puma" */

                CodeExpr( t->ActualExpr.Expr, PASSVALUE_PREC );
                if (Types_Cast(Code_PassValue, t->Actual.Formal, TypeIntCard)) {
                   WRITESTRING("L");
                };
                CodeSepa(t->ActualExpr.Next);

/* line 13027 "new_C.puma" */
   CodeActuals (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL14:;

  }
  }
/* line 13029 "new_C.puma" */
  {
/* line 13030 "new_C.puma" */
BEGIN_RULE(405);
/* line 13032 "new_C.puma" */

                if (Types_Cast(Code_PassValue, t->Actual.Formal, t->ActualExpr.Expr->Expr.Type)) {
                  CodeCast(t->ActualExpr.Formal);
                  CodeExpr(t->ActualExpr.Expr, CAST_PREC);
                } else {
                  CodeExpr(t->ActualExpr.Expr, PASSVALUE_PREC);
                };
                CodeSepa (t->ActualExpr.Next);

/* line 13041 "new_C.puma" */
   CodeActuals (t->ActualExpr.Next);
  }
END_RULE;
   return;

  }
/* line 13043 "new_C.puma" */
  {
/* line 13044 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeActualsCompute
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 13051 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kActualExpr) {
/* line 13064 "new_C.puma" */
  {
/* line 13065 "new_C.puma" */
BEGIN_RULE(406);
/* line 13070 "new_C.puma" */
   if (! (t -> ActualExpr . UseHelpVar && ((t->ActualExpr.Expr -> Expr . Type == TypeString) || (t->ActualExpr.Expr -> Expr . Type == TypeStringChar)) && (t -> ActualExpr . Formal -> Kind == kSymArray) && ! Symbols_IsOpen (t -> ActualExpr . Formal))) goto yyL1;
  {
/* line 13072 "new_C.puma" */
   CodeHelpVarAssignBegin (t->ActualExpr.Expr);
/* line 13073 "new_C.puma" */
   WRITEIDENT (t -> ActualExpr . String);
/* line 13074 "new_C.puma" */
   CodeHelpVarAssignClose (t->ActualExpr.Expr);
/* line 13075 "new_C.puma" */
   CodeActualsCompute (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL1:;

  if (t->ActualExpr.Expr->Kind == kQualid0) {
/* line 13077 "new_C.puma" */
  {
/* line 13078 "new_C.puma" */
BEGIN_RULE(407);
/* line 13081 "new_C.puma" */
   if (! (t -> ActualExpr . UseHelpVar && Symbols_IsOpen (t -> ActualExpr . Formal) && Symbols_IsOpenArray (t->ActualExpr.Expr -> Qualid0 . Object))) goto yyL2;
  {
/* line 13083 "new_C.puma" */
   CodeExprCompute (t->ActualExpr.Expr);
/* line 13084 "new_C.puma" */
   CodeActualsCompute (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL2:;

  }
  if (t->ActualExpr.Expr->Kind == kStringConst) {
/* line 13086 "new_C.puma" */
  {
/* line 13087 "new_C.puma" */
BEGIN_RULE(408);
/* line 13089 "new_C.puma" */
   if (! (t -> ActualExpr . UseHelpVar && Symbols_IsOpen (t -> ActualExpr . Formal))) goto yyL3;
  {
/* line 13091 "new_C.puma" */
   CodeHelpVarAssignBegin (t->ActualExpr.Expr);
/* line 13092 "new_C.puma" */
   CodeString2 (t->ActualExpr.Expr, ! STRNCPY);
/* line 13093 "new_C.puma" */
   CodeHelpVarAssignClose (t->ActualExpr.Expr);
/* line 13094 "new_C.puma" */
   CodeActualsCompute (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL3:;

  }
  if (t->ActualExpr.Expr->Kind == kCharConst) {
/* line 13096 "new_C.puma" */
  {
/* line 13097 "new_C.puma" */
BEGIN_RULE(409);
/* line 13099 "new_C.puma" */
   if (! (t -> ActualExpr . UseHelpVar && Symbols_IsOpen (t -> ActualExpr . Formal))) goto yyL4;
  {
/* line 13101 "new_C.puma" */
   CodeHelpVarAssignBegin (t->ActualExpr.Expr);
/* line 13102 "new_C.puma" */
   CodeString2 (t->ActualExpr.Expr, ! STRNCPY);
/* line 13103 "new_C.puma" */
   CodeHelpVarAssignClose (t->ActualExpr.Expr);
/* line 13104 "new_C.puma" */
   CodeActualsCompute (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL4:;

  }
  if (Tree_IsType (t->ActualExpr.Expr, kQualid)) {
/* line 13106 "new_C.puma" */
  {
/* line 13107 "new_C.puma" */
BEGIN_RULE(410);
/* line 13110 "new_C.puma" */
   if (! (t -> ActualExpr . UseHelpVar && Symbols_IsOpen (t -> ActualExpr . Formal) && (t->ActualExpr.Expr -> Qualid . Type == TypeString))) goto yyL5;
  {
/* line 13112 "new_C.puma" */
   CodeHelpVarAssignBegin (t->ActualExpr.Expr);
/* line 13113 "new_C.puma" */
   CodeString2 (t->ActualExpr.Expr, ! STRNCPY);
/* line 13114 "new_C.puma" */
   CodeHelpVarAssignClose (t->ActualExpr.Expr);
/* line 13115 "new_C.puma" */
   CodeActualsCompute (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL5:;

/* line 13117 "new_C.puma" */
  {
/* line 13118 "new_C.puma" */
BEGIN_RULE(411);
/* line 13121 "new_C.puma" */
   if (! (t -> ActualExpr . UseHelpVar && Symbols_IsOpen (t -> ActualExpr . Formal) && (t->ActualExpr.Expr -> Qualid . Type == TypeStringChar))) goto yyL6;
  {
/* line 13123 "new_C.puma" */
   CodeHelpVarAssignBegin (t->ActualExpr.Expr);
/* line 13124 "new_C.puma" */
   CodeString2 (t->ActualExpr.Expr, ! STRNCPY);
/* line 13125 "new_C.puma" */
   CodeHelpVarAssignClose (t->ActualExpr.Expr);
/* line 13126 "new_C.puma" */
   CodeActualsCompute (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL6:;

/* line 13128 "new_C.puma" */
  {
/* line 13129 "new_C.puma" */
BEGIN_RULE(412);
/* line 13132 "new_C.puma" */
   if (! (t -> ActualExpr . UseHelpVar && Symbols_IsOpen (t -> ActualExpr . Formal) && (t->ActualExpr.Expr -> Qualid . Type == TypeCHAR))) goto yyL7;
  {
/* line 13134 "new_C.puma" */
   CodeHelpVarAssignBegin (t->ActualExpr.Expr);
/* line 13135 "new_C.puma" */
   CodeString2 (t->ActualExpr.Expr, ! STRNCPY);
/* line 13136 "new_C.puma" */
   CodeHelpVarAssignClose (t->ActualExpr.Expr);
/* line 13137 "new_C.puma" */
   CodeActualsCompute (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL7:;

  }
/* line 13139 "new_C.puma" */
  {
/* line 13140 "new_C.puma" */
BEGIN_RULE(413);
/* line 13142 "new_C.puma" */
   if (! (t -> ActualExpr . UseHelpVar && t->ActualExpr.Expr -> Expr . Type -> Kind == kSymConfiguration)) goto yyL8;
  {
/* line 13143 "new_C.puma" */
   CodeActualsCompute (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL8:;

/* line 13145 "new_C.puma" */
  {
/* line 13146 "new_C.puma" */
BEGIN_RULE(414);
/* line 13148 "new_C.puma" */
   if (! (t -> ActualExpr . UseHelpVar)) goto yyL9;
  {
/* line 13149 "new_C.puma" */
   CodeExprCompute (t->ActualExpr.Expr);
/* line 13150 "new_C.puma" */
   CodeActualsCompute (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL9:;

  }
  if (t->Kind == kActualReduce) {
/* line 13152 "new_C.puma" */
  {
/* line 13153 "new_C.puma" */
BEGIN_RULE(415);
/* line 13155 "new_C.puma" */
   if (! (t -> ActualReduce . UseHelpVar)) goto yyL10;
  {
/* line 13156 "new_C.puma" */
   CodeActualsCompute (t->ActualReduce.Next);
  }
  }
END_RULE;
   return;
yyL10:;

  }
  if (t->Kind == kActualStar) {
/* line 13158 "new_C.puma" */
  {
/* line 13159 "new_C.puma" */
BEGIN_RULE(416);
/* line 13161 "new_C.puma" */
   if (! (t -> ActualStar . UseHelpVar)) goto yyL11;
  {
/* line 13162 "new_C.puma" */
   CodeActualsCompute (t->ActualStar.Next);
  }
  }
END_RULE;
   return;
yyL11:;

  }
/* line 13164 "new_C.puma" */
  {
/* line 13165 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeActualsRestoreVars
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 13172 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kActualExpr) {
  if (Tree_IsType (t->ActualExpr.Expr, kDesignator)) {
/* line 13178 "new_C.puma" */
  {
/* line 13179 "new_C.puma" */
BEGIN_RULE(417);
/* line 13181 "new_C.puma" */
   if (! (t -> ActualExpr . UseHelpVar && t -> ActualExpr . IsVAR)) goto yyL1;
  {
/* line 13185 "new_C.puma" */
   CodeVectorLoopBegin (t->ActualExpr.Expr);
/* line 13186 "new_C.puma" */
   WRITEBLANKS ();
/* line 13187 "new_C.puma" */
   CodeExpr (t->ActualExpr.Expr, MINPREC_PREC);
/* line 13188 "new_C.puma" */
   WRITESTRING (" = ");
/* line 13189 "new_C.puma" */
   CodeHelpVarWrite (t->ActualExpr.Expr);
/* line 13190 "new_C.puma" */
   WRITESTRING (";");
/* line 13191 "new_C.puma" */
   WRITELN ();
/* line 13192 "new_C.puma" */
   CodeVectorLoopClose (t->ActualExpr.Expr);
/* line 13193 "new_C.puma" */
   CodeActualsRestoreVars (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL1:;

  }
/* line 13195 "new_C.puma" */
  {
/* line 13196 "new_C.puma" */
BEGIN_RULE(418);
/* line 13198 "new_C.puma" */
   if (! (t -> ActualExpr . UseHelpVar)) goto yyL2;
  {
/* line 13199 "new_C.puma" */
   CodeActualsRestoreVars (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL2:;

  }
/* line 13201 "new_C.puma" */
  {
/* line 13202 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeActualsHelpVar
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 13207 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kActualExpr) {
/* line 13214 "new_C.puma" */
  {
/* line 13215 "new_C.puma" */
BEGIN_RULE(419);
/* line 13219 "new_C.puma" */
   if (! (((t->ActualExpr.Expr -> Expr . Type == TypeString) || (t->ActualExpr.Expr -> Expr . Type == TypeStringChar)) && (t -> ActualExpr . Formal -> Kind == kSymArray) && ! Symbols_IsOpen (t -> ActualExpr . Formal))) goto yyL1;
  {
/* line 13221 "new_C.puma" */
   CodeHelpVarWrite (t->ActualExpr.Expr);
/* line 13222 "new_C.puma" */
   CodeSepa (t->ActualExpr.Next);
/* line 13223 "new_C.puma" */
   CodeActualsHelpVarNext (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL1:;

  if (t->ActualExpr.Expr->Kind == kQualid0) {
/* line 13225 "new_C.puma" */
  {
/* line 13226 "new_C.puma" */
BEGIN_RULE(420);
/* line 13228 "new_C.puma" */
   if (! (Symbols_IsOpen (t -> ActualExpr . Formal) && Symbols_IsOpenArray (t->ActualExpr.Expr -> Qualid0 . Object))) goto yyL2;
  {
/* line 13229 "new_C.puma" */

                CodeHelpVarWrite(t->ActualExpr.Expr);
                WRITESTRING(", ");
                if (t->ActualExpr.Expr->Qualid0.IsGlobalPtr) {
                  WRITEIDENT(Pointer_GetGlobalPtr(t->ActualExpr.Expr->Qualid0.Object));
                  WRITESTRING("_O");
                } else {
                  WRITEIDENT(Parameter_GetParam(t->ActualExpr.Expr->Qualid0.Object));
                };
                if (t->Actual.Formal->Kind == kSymArray &&
                    t->Actual.Formal->SymArray.ElemType == TypeWORD ) {
                  WRITESTRING(" * sizeof(");
                  CodeTypeName(t->ActualExpr.Expr->Qualid0.Type->SymArray.ElemType);
                  WRITESTRING(")");
                } else if (t->Actual.Formal->Kind == kSymVector &&
                    t->Actual.Formal->SymVector.Type->Kind == kSymArray &&
                    t->Actual.Formal->SymVector.Type->SymArray.ElemType == TypeWORD) {
                  WRITESTRING(" * sizeof(");
                  CodeTypeName(t->ActualExpr.Expr->Qualid0.Type->SymVector.Type->SymArray.ElemType);
                  WRITESTRING(")");
                }
                CodeSepa (t->ActualExpr.Next);

/* line 13252 "new_C.puma" */
   CodeActualsHelpVarNext (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL2:;

  }
  if (t->ActualExpr.Expr->Kind == kStringConst) {
/* line 13254 "new_C.puma" */
 {
  ULONG length;
  {
/* line 13255 "new_C.puma" */
BEGIN_RULE(421);
/* line 13257 "new_C.puma" */
   if (! ((Symbols_IsOpen (t -> ActualExpr . Formal)))) goto yyL3;
  {
/* line 13258 "new_C.puma" */
   CodeHelpVarWrite (t->ActualExpr.Expr);
/* line 13259 "new_C.puma" */
   WRITESTRING (", ");
/* line 13260 "new_C.puma" */

/* line 13261 "new_C.puma" */
   if (! (length = LengthSt (t->ActualExpr.Expr->StringConst.StringVal))) goto yyL3;
  {
/* line 13262 "new_C.puma" */
 if ( length == 0 ) { length = 1; }; 
/* line 13263 "new_C.puma" */
   WRITEINT (length);
/* line 13264 "new_C.puma" */
   WRITESTRING ("L");
/* line 13265 "new_C.puma" */
   CodeSepa (t->ActualExpr.Next);
/* line 13266 "new_C.puma" */
   CodeActualsHelpVarNext (t->ActualExpr.Next);
  }
  }
  }
END_RULE;
   return;
 }
yyL3:;

  }
  if (t->ActualExpr.Expr->Kind == kCharConst) {
/* line 13268 "new_C.puma" */
  {
/* line 13269 "new_C.puma" */
BEGIN_RULE(422);
/* line 13271 "new_C.puma" */
   if (! ((Symbols_IsOpen (t -> ActualExpr . Formal)))) goto yyL4;
  {
/* line 13272 "new_C.puma" */
   CodeHelpVarWrite (t->ActualExpr.Expr);
/* line 13273 "new_C.puma" */
   WRITESTRING (", 1L");
/* line 13274 "new_C.puma" */
   CodeSepa (t->ActualExpr.Next);
/* line 13275 "new_C.puma" */
   CodeActualsHelpVarNext (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL4:;

  }
  if (Tree_IsType (t->ActualExpr.Expr, kQualid)) {
/* line 13277 "new_C.puma" */
 {
  ULONG length;
  {
/* line 13278 "new_C.puma" */
BEGIN_RULE(423);
/* line 13280 "new_C.puma" */
   if (! (Symbols_IsOpen (t -> ActualExpr . Formal) && (t->ActualExpr.Expr -> Qualid . Type == TypeString))) goto yyL5;
  {
/* line 13282 "new_C.puma" */
   CodeHelpVarWrite (t->ActualExpr.Expr);
/* line 13283 "new_C.puma" */
   WRITESTRING (", ");
/* line 13284 "new_C.puma" */

/* line 13285 "new_C.puma" */
   if (! (length = LengthSt (t->ActualExpr.Expr -> Qualid . Object -> SymConst . Value . value . stringValue))) goto yyL5;
  {
/* line 13286 "new_C.puma" */
 if (length == 0) { length = 1; }; 
/* line 13287 "new_C.puma" */
   WRITEINT (length);
/* line 13288 "new_C.puma" */
   WRITESTRING ("L");
/* line 13289 "new_C.puma" */
   CodeSepa (t->ActualExpr.Next);
/* line 13290 "new_C.puma" */
   CodeActualsHelpVarNext (t->ActualExpr.Next);
  }
  }
  }
END_RULE;
   return;
 }
yyL5:;

/* line 13292 "new_C.puma" */
  {
/* line 13293 "new_C.puma" */
BEGIN_RULE(424);
/* line 13295 "new_C.puma" */
   if (! (Symbols_IsOpen (t -> ActualExpr . Formal) && (t->ActualExpr.Expr -> Qualid . Type == TypeStringChar))) goto yyL6;
  {
/* line 13297 "new_C.puma" */
   CodeHelpVarWrite (t->ActualExpr.Expr);
/* line 13298 "new_C.puma" */
   WRITESTRING (", 1L");
/* line 13299 "new_C.puma" */
   CodeSepa (t->ActualExpr.Next);
/* line 13300 "new_C.puma" */
   CodeActualsHelpVarNext (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL6:;

/* line 13302 "new_C.puma" */
  {
/* line 13303 "new_C.puma" */
BEGIN_RULE(425);
/* line 13305 "new_C.puma" */
   if (! (Symbols_IsOpen (t -> ActualExpr . Formal) && (t->ActualExpr.Expr -> Qualid . Type == TypeCHAR))) goto yyL7;
  {
/* line 13307 "new_C.puma" */
   CodeHelpVarWrite (t->ActualExpr.Expr);
/* line 13308 "new_C.puma" */
   WRITESTRING (", 1L");
/* line 13309 "new_C.puma" */
   CodeSepa (t->ActualExpr.Next);
/* line 13310 "new_C.puma" */
   CodeActualsHelpVarNext (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL7:;

  }
/* line 13312 "new_C.puma" */
  {
/* line 13313 "new_C.puma" */
BEGIN_RULE(426);
/* line 13315 "new_C.puma" */
   if (! (Symbols_IsOpen (t -> ActualExpr . Formal) && (t -> Actual . Formal -> SymArray . ElemType == TypeWORD))) goto yyL8;
  {
/* line 13317 "new_C.puma" */

                if (Options_IsOptionSet(Options_eCasts)) {
                   WRITESTRING("(WORD *)");
                };
                WRITESTRING("&");
                CodeHelpVarWrite(t->ActualExpr.Expr);
                WRITESTRING(", ");
                if (Options_IsOptionSet(Options_eCasts)) {
                   WRITESTRING("(CARDINAL)");
                };
                WRITESTRING("sizeof(");
                CodeHelpVarWrite(t->ActualExpr.Expr);
                WRITESTRING(")");
                CodeSepa (t->ActualExpr.Next);

/* line 13332 "new_C.puma" */
   CodeActualsHelpVarNext (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL8:;

/* line 13334 "new_C.puma" */
 {
  tValue Upb;
  tValue Lwb;
  tType IndexType;
  {
/* line 13335 "new_C.puma" */
BEGIN_RULE(427);
/* line 13337 "new_C.puma" */
   if (! (Symbols_IsOpen (t -> ActualExpr . Formal) && (t->ActualExpr.Expr -> Designator . Type -> Kind == kSymArray || (t->ActualExpr.Expr -> Designator . Type -> Kind == kSymVector && t->ActualExpr.Expr -> Designator . Type -> SymVector . Type -> Kind == kSymArray)))) goto yyL9;
  {
/* line 13341 "new_C.puma" */

/* line 13342 "new_C.puma" */

/* line 13343 "new_C.puma" */

/* line 13344 "new_C.puma" */

                if (t->ActualExpr.Expr->Designator.Type->Kind == kSymArray) {
                  IndexType = t->ActualExpr.Expr->Designator.Type->SymArray.IndexType;
                } else {
                  IndexType = t->ActualExpr.Expr->Designator.Type->SymVector.Type->SymArray.IndexType;
                }
                Types_GetLwb( IndexType, &Lwb);
                Types_GetUpb( IndexType, &Upb);
                CodeHelpVarWrite(t->ActualExpr.Expr);
                WRITESTRING(".A, ");
                WRITEINT(Values_ValueToInt(&Upb) - Values_ValueToInt(&Lwb) + 1);
                WRITESTRING("L");
                CodeSepa (t->ActualExpr.Next);

/* line 13358 "new_C.puma" */
   CodeActualsHelpVarNext (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
 }
yyL9:;

/* line 13360 "new_C.puma" */
  {
/* line 13361 "new_C.puma" */
BEGIN_RULE(428);
/* line 13363 "new_C.puma" */
   if (! (t -> ActualExpr . IsVAR && t->ActualExpr.Expr -> Expr . Type -> Kind == kSymVector && ! t -> ActualExpr . UseHelpVar)) goto yyL10;
  {
/* line 13366 "new_C.puma" */
   CodeExpr (t->ActualExpr.Expr, PASSVALUE_PREC);
/* line 13367 "new_C.puma" */
   CodeSepa (t->ActualExpr.Next);
/* line 13368 "new_C.puma" */
   CodeActualsHelpVarNext (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL10:;

/* line 13370 "new_C.puma" */
  {
/* line 13371 "new_C.puma" */
BEGIN_RULE(429);
/* line 13373 "new_C.puma" */
   if (! (t -> ActualExpr . IsVAR && t->ActualExpr.Expr -> Expr . Type -> Kind == kSymVector && t -> ActualExpr . UseHelpVar)) goto yyL11;
  {
/* line 13375 "new_C.puma" */
   CodeHelpVarWrite (t->ActualExpr.Expr);
/* line 13376 "new_C.puma" */
   CodeSepa (t->ActualExpr.Next);
/* line 13377 "new_C.puma" */
   CodeActualsHelpVarNext (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL11:;

/* line 13379 "new_C.puma" */
  {
/* line 13380 "new_C.puma" */
BEGIN_RULE(430);
/* line 13382 "new_C.puma" */
   if (! (t -> ActualExpr . IsVAR)) goto yyL12;
  {
/* line 13383 "new_C.puma" */

                if (Types_Cast(Code_PassAddress, t->Actual.Formal, t->ActualExpr.Expr->Expr.Type)) {
                  CodeCastVAR(t->ActualExpr.Formal);
                };
                WRITESTRING("&");
                CodeHelpVarWrite(t->ActualExpr.Expr);
                CodeSepa (t->ActualExpr.Next);

/* line 13391 "new_C.puma" */
   CodeActualsHelpVarNext (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL12:;

/* line 13393 "new_C.puma" */
  {
/* line 13394 "new_C.puma" */
BEGIN_RULE(431);
/* line 13396 "new_C.puma" */

                if (Types_Cast(Code_PassValue, t->Actual.Formal, t->ActualExpr.Expr->Expr.Type)) {
                   CodeCast(t->ActualExpr.Formal);
                }

/* line 13401 "new_C.puma" */
   CodeHelpVarWrite (t->ActualExpr.Expr);
/* line 13402 "new_C.puma" */
   CodeSepa (t->ActualExpr.Next);
/* line 13403 "new_C.puma" */
   CodeActualsHelpVarNext (t->ActualExpr.Next);
  }
END_RULE;
   return;

  }
/* line 13405 "new_C.puma" */
  {
/* line 13406 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeActualsOpenVector
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 13413 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kActualExpr) {
/* line 13420 "new_C.puma" */
  {
/* line 13421 "new_C.puma" */
BEGIN_RULE(432);
/* line 13423 "new_C.puma" */
   if (! (t -> ActualExpr . Formal -> Kind == kSymVector && t -> ActualExpr . Formal -> SymVector . IsOpen)) goto yyL1;
  {
/* line 13425 "new_C.puma" */
   WRITESTRING (", ");
/* line 13426 "new_C.puma" */
   CodeWriteConfigName (t -> ActualExpr . Expr);
  }
  }
END_RULE;
   return;
yyL1:;

/* line 13428 "new_C.puma" */
  {
/* line 13429 "new_C.puma" */
BEGIN_RULE(433);
/* line 13431 "new_C.puma" */
   CodeActualsOpenVector (t->ActualExpr.Next);
  }
END_RULE;
   return;

  }
/* line 13433 "new_C.puma" */
  {
/* line 13434 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeActualsGenericConfig
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 13442 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kActualExpr) {
/* line 13449 "new_C.puma" */
  {
/* line 13450 "new_C.puma" */
BEGIN_RULE(434);
/* line 13452 "new_C.puma" */
   if (! (t -> ActualExpr . Formal -> Kind == kSymVector && (t -> ActualExpr . Formal -> SymVector . Config -> SymConfig . IsRespecified || t -> ActualExpr . Formal -> SymVector . Config -> SymConfig . IsGeneric))) goto yyL1;
  {
/* line 13455 "new_C.puma" */
   WRITESTRING (", ");
/* line 13456 "new_C.puma" */
   CodeWriteConfigName (t -> ActualExpr . Expr);
  }
  }
END_RULE;
   return;
yyL1:;

/* line 13458 "new_C.puma" */
  {
/* line 13459 "new_C.puma" */
BEGIN_RULE(435);
/* line 13461 "new_C.puma" */
   CodeActualsGenericConfig (t->ActualExpr.Next);
  }
END_RULE;
   return;

  }
/* line 13463 "new_C.puma" */
  {
/* line 13464 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeExprHelpVarBegin
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 13470 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif


  switch (t->Kind) {
  case kLastMultiple:
/* line 13477 "new_C.puma" */
  {
/* line 13478 "new_C.puma" */
BEGIN_RULE(436);
/* line 13480 "new_C.puma" */
   CodeExprHelpVarBegin (t->LastMultiple.Mop);
  }
END_RULE;
   return;

  case kMultiple:
/* line 13482 "new_C.puma" */
  {
/* line 13483 "new_C.puma" */
BEGIN_RULE(437);
/* line 13485 "new_C.puma" */
   CodeExprHelpVarBegin (t->Multiple.Mop);
/* line 13486 "new_C.puma" */
   CodeExprHelpVarBegin (t->Multiple.Multiples);
/* line 13487 "new_C.puma" */
   CodeHelpVarInit (t);
  }
END_RULE;
   return;

  case kBinary:
/* line 13489 "new_C.puma" */
  {
/* line 13490 "new_C.puma" */
BEGIN_RULE(438);
/* line 13492 "new_C.puma" */
   CodeExprHelpVarBegin (t->Binary.Lop);
/* line 13493 "new_C.puma" */
   CodeExprHelpVarBegin (t->Binary.Rop);
/* line 13494 "new_C.puma" */
   CodeHelpVarInit (t);
  }
END_RULE;
   return;

  case kUnary:
/* line 13496 "new_C.puma" */
  {
/* line 13497 "new_C.puma" */
BEGIN_RULE(439);
/* line 13499 "new_C.puma" */
   CodeExprHelpVarBegin (t->Unary.Mop);
/* line 13500 "new_C.puma" */
   CodeHelpVarInit (t);
  }
END_RULE;
   return;

  case kIntConst:
/* line 13502 "new_C.puma" */
  {
/* line 13503 "new_C.puma" */
BEGIN_RULE(440);
/* line 13505 "new_C.puma" */
   CodeHelpVarInit (t);
  }
END_RULE;
   return;

  case kRealConst:
/* line 13507 "new_C.puma" */
  {
/* line 13508 "new_C.puma" */
BEGIN_RULE(441);
/* line 13510 "new_C.puma" */
   CodeHelpVarInit (t);
  }
END_RULE;
   return;

  case kStringConst:
/* line 13512 "new_C.puma" */
  {
/* line 13513 "new_C.puma" */
BEGIN_RULE(442);
/* line 13515 "new_C.puma" */
   CodeHelpVarInit (t);
  }
END_RULE;
   return;

  case kCharConst:
/* line 13517 "new_C.puma" */
  {
/* line 13518 "new_C.puma" */
BEGIN_RULE(443);
/* line 13520 "new_C.puma" */
   CodeHelpVarInit (t);
  }
END_RULE;
   return;

  case kFuncCall:
/* line 13522 "new_C.puma" */
  {
/* line 13523 "new_C.puma" */
BEGIN_RULE(444);
/* line 13525 "new_C.puma" */
   CodeExprHelpVarBegin (t->FuncCall.Actuals);
/* line 13526 "new_C.puma" */
   CodeHelpVarInit (t);
  }
END_RULE;
   return;

  case kMove:
/* line 13528 "new_C.puma" */
  {
/* line 13529 "new_C.puma" */
BEGIN_RULE(445);
/* line 13531 "new_C.puma" */
   CodeHelpVarInit (t);
  }
END_RULE;
   return;

  case kReceive:
/* line 13533 "new_C.puma" */
  {
/* line 13534 "new_C.puma" */
BEGIN_RULE(446);
/* line 13536 "new_C.puma" */
   CodeHelpVarInit (t);
  }
END_RULE;
   return;

  case kReduce:
/* line 13538 "new_C.puma" */
  {
/* line 13539 "new_C.puma" */
BEGIN_RULE(447);
/* line 13541 "new_C.puma" */
   CodeExprHelpVarBegin (t->Reduce.Expr);
/* line 13542 "new_C.puma" */
   CodeHelpVarInit (t);
  }
END_RULE;
   return;

  case kSet:
/* line 13544 "new_C.puma" */
  {
/* line 13545 "new_C.puma" */
BEGIN_RULE(448);
/* line 13547 "new_C.puma" */
   CodeExprHelpVarBegin (t->Set.Elems);
/* line 13548 "new_C.puma" */
   CodeHelpVarInit (t);
  }
END_RULE;
   return;

  case kBitSet:
/* line 13550 "new_C.puma" */
  {
/* line 13551 "new_C.puma" */
BEGIN_RULE(449);
/* line 13553 "new_C.puma" */
   CodeExprHelpVarBegin (t->BitSet.Elems);
/* line 13554 "new_C.puma" */
   CodeHelpVarInit (t);
  }
END_RULE;
   return;

  case kQualid0:
/* line 13556 "new_C.puma" */
  {
/* line 13557 "new_C.puma" */
BEGIN_RULE(450);
/* line 13559 "new_C.puma" */
   CodeHelpVarInit (t);
  }
END_RULE;
   return;

  case kQualid1:
/* line 13561 "new_C.puma" */
  {
/* line 13562 "new_C.puma" */
BEGIN_RULE(451);
/* line 13564 "new_C.puma" */
   CodeHelpVarInit (t);
  }
END_RULE;
   return;

  case kProcessor:
/* line 13566 "new_C.puma" */
  {
/* line 13567 "new_C.puma" */
BEGIN_RULE(452);
/* line 13569 "new_C.puma" */
   CodeDesignatorHelpVarBegin (t);
/* line 13570 "new_C.puma" */
   CodeHelpVarInit (t);
  }
END_RULE;
   return;

  case kDimensions:
/* line 13572 "new_C.puma" */
  {
/* line 13573 "new_C.puma" */
BEGIN_RULE(453);
/* line 13575 "new_C.puma" */
   CodeDesignatorHelpVarBegin (t);
/* line 13576 "new_C.puma" */
   CodeHelpVarInit (t);
  }
END_RULE;
   return;

  case kSelect:
/* line 13578 "new_C.puma" */
  {
/* line 13579 "new_C.puma" */
BEGIN_RULE(454);
/* line 13581 "new_C.puma" */
   CodeDesignatorHelpVarBegin (t);
/* line 13582 "new_C.puma" */
   CodeHelpVarInit (t);
  }
END_RULE;
   return;

  case kSubscript:
/* line 13584 "new_C.puma" */
  {
/* line 13585 "new_C.puma" */
BEGIN_RULE(455);
/* line 13587 "new_C.puma" */
   CodeDesignatorHelpVarBegin (t);
/* line 13588 "new_C.puma" */
   CodeHelpVarInit (t);
  }
END_RULE;
   return;

  case kDeref:
/* line 13590 "new_C.puma" */
  {
/* line 13591 "new_C.puma" */
BEGIN_RULE(456);
/* line 13593 "new_C.puma" */
   CodeDesignatorHelpVarBegin (t);
/* line 13594 "new_C.puma" */
   CodeHelpVarInit (t);
  }
END_RULE;
   return;

  case kActualExpr:
/* line 13597 "new_C.puma" */
  {
/* line 13598 "new_C.puma" */
BEGIN_RULE(457);
/* line 13600 "new_C.puma" */
   if (! (t -> ActualExpr . UseHelpVar && t->ActualExpr.Expr -> Expr . Type -> Kind == kSymConfiguration)) goto yyL22;
  {
/* line 13601 "new_C.puma" */
   CodeExprHelpVarBegin (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL22:;

/* line 13603 "new_C.puma" */
  {
/* line 13604 "new_C.puma" */
BEGIN_RULE(458);
/* line 13606 "new_C.puma" */
   if (! (t -> ActualExpr . UseHelpVar)) goto yyL23;
  {
/* line 13607 "new_C.puma" */
   CodeExprHelpVarBegin (t->ActualExpr.Expr);
/* line 13608 "new_C.puma" */
   CodeExprHelpVarBegin (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL23:;

  break;
  case kActualReduce:
/* line 13610 "new_C.puma" */
  {
/* line 13611 "new_C.puma" */
BEGIN_RULE(459);
/* line 13613 "new_C.puma" */
   if (! (t -> ActualReduce . UseHelpVar)) goto yyL24;
  {
/* line 13614 "new_C.puma" */
   CodeExprHelpVarBegin (t->ActualReduce.Next);
  }
  }
END_RULE;
   return;
yyL24:;

  break;
  case kActualStar:
/* line 13616 "new_C.puma" */
  {
/* line 13617 "new_C.puma" */
BEGIN_RULE(460);
/* line 13619 "new_C.puma" */
   if (! (t -> ActualStar . UseHelpVar)) goto yyL25;
  {
/* line 13620 "new_C.puma" */
   CodeExprHelpVarBegin (t->ActualStar.Next);
  }
  }
END_RULE;
   return;
yyL25:;

  break;
  case kElemExpr:
/* line 13623 "new_C.puma" */
  {
/* line 13624 "new_C.puma" */
BEGIN_RULE(461);
/* line 13626 "new_C.puma" */
   CodeExprHelpVarBegin (t->ElemExpr.Elem);
/* line 13627 "new_C.puma" */
   CodeExprHelpVarBegin (t->ElemExpr.Next);
  }
END_RULE;
   return;

  case kElemRange:
/* line 13629 "new_C.puma" */
  {
/* line 13630 "new_C.puma" */
BEGIN_RULE(462);
/* line 13632 "new_C.puma" */
   CodeExprHelpVarBegin (t->ElemRange.Lwb);
/* line 13633 "new_C.puma" */
   CodeExprHelpVarBegin (t->ElemRange.Upb);
/* line 13634 "new_C.puma" */
   CodeExprHelpVarBegin (t->ElemRange.Next);
  }
END_RULE;
   return;

  }

/* line 13636 "new_C.puma" */
  {
/* line 13637 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeDesignatorHelpVarBegin
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 13640 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kProcessor) {
/* line 13648 "new_C.puma" */
  {
/* line 13649 "new_C.puma" */
BEGIN_RULE(463);
/* line 13651 "new_C.puma" */
   if (! (t->Processor.Proc -> Expr . UseHelpVar)) goto yyL1;
  {
/* line 13652 "new_C.puma" */
   CodeExprHelpVarBegin (t->Processor.Proc);
/* line 13653 "new_C.puma" */
   CodeDesignatorHelpVarBegin (t->Processor.Designator);
  }
  }
END_RULE;
   return;
yyL1:;

/* line 13655 "new_C.puma" */
  {
/* line 13656 "new_C.puma" */
BEGIN_RULE(464);
/* line 13658 "new_C.puma" */
   CodeDesignatorHelpVarBegin (t->Processor.Designator);
  }
END_RULE;
   return;

  }
  if (t->Kind == kDimensions) {
/* line 13660 "new_C.puma" */
  {
/* line 13661 "new_C.puma" */
BEGIN_RULE(465);
/* line 13663 "new_C.puma" */
   if (! (t->Dimensions.Actuals -> Actuals . UseHelpVar)) goto yyL3;
  {
/* line 13664 "new_C.puma" */
   CodeExprHelpVarBegin (t->Dimensions.Actuals);
/* line 13665 "new_C.puma" */
   WRITEBLANKS ();
/* line 13666 "new_C.puma" */
   WRITESTRING ("CARDINAL *");
/* line 13667 "new_C.puma" */
   WRITEIDENT (t->Dimensions.Actuals -> ActualExpr . HelpVar);
/* line 13668 "new_C.puma" */
   WRITESTRING (" = (CARDINAL *) malloc(sizeof(CARDINAL) * RANK(");
/* line 13669 "new_C.puma" */
   CodeWriteConfigName (t->Dimensions.Designator);
/* line 13670 "new_C.puma" */
   WRITESTRING ("));");
/* line 13671 "new_C.puma" */
   WRITELN ();
/* line 13672 "new_C.puma" */
   CodeDesignatorHelpVarBegin (t->Dimensions.Designator);
  }
  }
END_RULE;
   return;
yyL3:;

/* line 13674 "new_C.puma" */
  {
/* line 13675 "new_C.puma" */
BEGIN_RULE(466);
/* line 13677 "new_C.puma" */
   WRITEBLANKS ();
/* line 13678 "new_C.puma" */
   WRITESTRING ("CARDINAL *");
/* line 13679 "new_C.puma" */
   WRITEIDENT (t->Dimensions.Actuals -> ActualExpr . HelpVar);
/* line 13680 "new_C.puma" */
   WRITESTRING (" = (CARDINAL *) malloc(sizeof(CARDINAL) * RANK(");
/* line 13681 "new_C.puma" */
   CodeWriteConfigName (t->Dimensions.Designator);
/* line 13682 "new_C.puma" */
   WRITESTRING ("));");
/* line 13683 "new_C.puma" */
   WRITELN ();
/* line 13684 "new_C.puma" */
   CodeDesignatorHelpVarBegin (t->Dimensions.Designator);
  }
END_RULE;
   return;

  }
  if (t->Kind == kSubscript) {
/* line 13686 "new_C.puma" */
  {
/* line 13687 "new_C.puma" */
BEGIN_RULE(467);
/* line 13689 "new_C.puma" */
   if (! (t->Subscript.Index -> Expr . UseHelpVar)) goto yyL5;
  {
/* line 13690 "new_C.puma" */
   CodeExprHelpVarBegin (t->Subscript.Index);
/* line 13691 "new_C.puma" */
   CodeDesignatorHelpVarBegin (t->Subscript.Designator);
  }
  }
END_RULE;
   return;
yyL5:;

/* line 13693 "new_C.puma" */
  {
/* line 13694 "new_C.puma" */
BEGIN_RULE(468);
/* line 13696 "new_C.puma" */
   CodeDesignatorHelpVarBegin (t->Subscript.Designator);
  }
END_RULE;
   return;

  }
  if (t->Kind == kSelect) {
/* line 13698 "new_C.puma" */
  {
/* line 13699 "new_C.puma" */
BEGIN_RULE(469);
/* line 13701 "new_C.puma" */
   CodeDesignatorHelpVarBegin (t->Select.Designator);
  }
END_RULE;
   return;

  }
  if (t->Kind == kDeref) {
/* line 13703 "new_C.puma" */
  {
/* line 13704 "new_C.puma" */
BEGIN_RULE(470);
/* line 13706 "new_C.puma" */
   CodeDesignatorHelpVarBegin (t->Deref.Designator);
  }
END_RULE;
   return;

  }
/* line 13708 "new_C.puma" */
  {
/* line 13709 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeExprHelpVarClose
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 13712 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif


  switch (t->Kind) {
  case kLastMultiple:
/* line 13719 "new_C.puma" */
  {
/* line 13720 "new_C.puma" */
BEGIN_RULE(471);
/* line 13722 "new_C.puma" */
   CodeExprHelpVarClose (t->LastMultiple.Mop);
  }
END_RULE;
   return;

  case kMultiple:
/* line 13724 "new_C.puma" */
  {
/* line 13725 "new_C.puma" */
BEGIN_RULE(472);
/* line 13727 "new_C.puma" */
   CodeExprHelpVarClose (t->Multiple.Mop);
/* line 13728 "new_C.puma" */
   CodeExprHelpVarClose (t->Multiple.Multiples);
/* line 13729 "new_C.puma" */
   CodeHelpVarFree (t);
  }
END_RULE;
   return;

  case kBinary:
/* line 13731 "new_C.puma" */
  {
/* line 13732 "new_C.puma" */
BEGIN_RULE(473);
/* line 13734 "new_C.puma" */
   CodeExprHelpVarClose (t->Binary.Lop);
/* line 13735 "new_C.puma" */
   CodeExprHelpVarClose (t->Binary.Rop);
/* line 13736 "new_C.puma" */
   CodeHelpVarFree (t);
  }
END_RULE;
   return;

  case kUnary:
/* line 13738 "new_C.puma" */
  {
/* line 13739 "new_C.puma" */
BEGIN_RULE(474);
/* line 13741 "new_C.puma" */
   CodeExprHelpVarClose (t->Unary.Mop);
/* line 13742 "new_C.puma" */
   CodeHelpVarFree (t);
  }
END_RULE;
   return;

  case kIntConst:
/* line 13744 "new_C.puma" */
  {
/* line 13745 "new_C.puma" */
BEGIN_RULE(475);
/* line 13747 "new_C.puma" */
   CodeHelpVarFree (t);
  }
END_RULE;
   return;

  case kRealConst:
/* line 13749 "new_C.puma" */
  {
/* line 13750 "new_C.puma" */
BEGIN_RULE(476);
/* line 13752 "new_C.puma" */
   CodeHelpVarFree (t);
  }
END_RULE;
   return;

  case kStringConst:
/* line 13754 "new_C.puma" */
  {
/* line 13755 "new_C.puma" */
BEGIN_RULE(477);
/* line 13757 "new_C.puma" */
   CodeHelpVarFree (t);
  }
END_RULE;
   return;

  case kCharConst:
/* line 13759 "new_C.puma" */
  {
/* line 13760 "new_C.puma" */
BEGIN_RULE(478);
/* line 13762 "new_C.puma" */
   CodeHelpVarFree (t);
  }
END_RULE;
   return;

  case kFuncCall:
/* line 13764 "new_C.puma" */
  {
/* line 13765 "new_C.puma" */
BEGIN_RULE(479);
/* line 13767 "new_C.puma" */
   CodeExprHelpVarClose (t->FuncCall.Actuals);
/* line 13768 "new_C.puma" */
   CodeHelpVarFree (t);
  }
END_RULE;
   return;

  case kMove:
/* line 13770 "new_C.puma" */
  {
/* line 13771 "new_C.puma" */
BEGIN_RULE(480);
/* line 13773 "new_C.puma" */
   CodeHelpVarFree (t);
  }
END_RULE;
   return;

  case kReceive:
/* line 13775 "new_C.puma" */
  {
/* line 13776 "new_C.puma" */
BEGIN_RULE(481);
/* line 13778 "new_C.puma" */
   CodeHelpVarFree (t);
  }
END_RULE;
   return;

  case kReduce:
/* line 13780 "new_C.puma" */
  {
/* line 13781 "new_C.puma" */
BEGIN_RULE(482);
/* line 13783 "new_C.puma" */
   CodeExprHelpVarClose (t->Reduce.Expr);
/* line 13784 "new_C.puma" */
   CodeHelpVarFree (t);
  }
END_RULE;
   return;

  case kSet:
/* line 13786 "new_C.puma" */
  {
/* line 13787 "new_C.puma" */
BEGIN_RULE(483);
/* line 13789 "new_C.puma" */
   CodeExprHelpVarClose (t->Set.Elems);
/* line 13790 "new_C.puma" */
   CodeHelpVarFree (t);
  }
END_RULE;
   return;

  case kBitSet:
/* line 13792 "new_C.puma" */
  {
/* line 13793 "new_C.puma" */
BEGIN_RULE(484);
/* line 13795 "new_C.puma" */
   CodeExprHelpVarClose (t->BitSet.Elems);
/* line 13796 "new_C.puma" */
   CodeHelpVarFree (t);
  }
END_RULE;
   return;

  case kQualid0:
/* line 13798 "new_C.puma" */
  {
/* line 13799 "new_C.puma" */
BEGIN_RULE(485);
/* line 13801 "new_C.puma" */
   CodeHelpVarFree (t);
  }
END_RULE;
   return;

  case kQualid1:
/* line 13803 "new_C.puma" */
  {
/* line 13804 "new_C.puma" */
BEGIN_RULE(486);
/* line 13806 "new_C.puma" */
   CodeHelpVarFree (t);
  }
END_RULE;
   return;

  case kProcessor:
/* line 13808 "new_C.puma" */
  {
/* line 13809 "new_C.puma" */
BEGIN_RULE(487);
/* line 13811 "new_C.puma" */
   CodeDesignatorHelpVarClose (t);
/* line 13812 "new_C.puma" */
   CodeHelpVarFree (t);
  }
END_RULE;
   return;

  case kDimensions:
/* line 13814 "new_C.puma" */
  {
/* line 13815 "new_C.puma" */
BEGIN_RULE(488);
/* line 13817 "new_C.puma" */
   CodeDesignatorHelpVarClose (t);
/* line 13818 "new_C.puma" */
   CodeHelpVarFree (t);
  }
END_RULE;
   return;

  case kSelect:
/* line 13820 "new_C.puma" */
  {
/* line 13821 "new_C.puma" */
BEGIN_RULE(489);
/* line 13823 "new_C.puma" */
   CodeDesignatorHelpVarClose (t);
/* line 13824 "new_C.puma" */
   CodeHelpVarFree (t);
  }
END_RULE;
   return;

  case kSubscript:
/* line 13826 "new_C.puma" */
  {
/* line 13827 "new_C.puma" */
BEGIN_RULE(490);
/* line 13829 "new_C.puma" */
   CodeDesignatorHelpVarClose (t);
/* line 13830 "new_C.puma" */
   CodeHelpVarFree (t);
  }
END_RULE;
   return;

  case kDeref:
/* line 13832 "new_C.puma" */
  {
/* line 13833 "new_C.puma" */
BEGIN_RULE(491);
/* line 13835 "new_C.puma" */
   CodeDesignatorHelpVarClose (t);
/* line 13836 "new_C.puma" */
   CodeHelpVarFree (t);
  }
END_RULE;
   return;

  case kActualExpr:
/* line 13839 "new_C.puma" */
  {
/* line 13840 "new_C.puma" */
BEGIN_RULE(492);
/* line 13842 "new_C.puma" */
   if (! (t -> ActualExpr . UseHelpVar && t->ActualExpr.Expr -> Expr . Type -> Kind == kSymConfiguration)) goto yyL22;
  {
/* line 13843 "new_C.puma" */
   CodeExprHelpVarClose (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL22:;

/* line 13845 "new_C.puma" */
  {
/* line 13846 "new_C.puma" */
BEGIN_RULE(493);
/* line 13848 "new_C.puma" */
   if (! (t -> ActualExpr . UseHelpVar)) goto yyL23;
  {
/* line 13849 "new_C.puma" */
   CodeExprHelpVarClose (t->ActualExpr.Expr);
/* line 13850 "new_C.puma" */
   CodeExprHelpVarClose (t->ActualExpr.Next);
  }
  }
END_RULE;
   return;
yyL23:;

  break;
  case kActualReduce:
/* line 13852 "new_C.puma" */
  {
/* line 13853 "new_C.puma" */
BEGIN_RULE(494);
/* line 13855 "new_C.puma" */
   if (! (t -> ActualReduce . UseHelpVar)) goto yyL24;
  {
/* line 13856 "new_C.puma" */
   CodeExprHelpVarClose (t->ActualReduce.Next);
  }
  }
END_RULE;
   return;
yyL24:;

  break;
  case kActualStar:
/* line 13858 "new_C.puma" */
  {
/* line 13859 "new_C.puma" */
BEGIN_RULE(495);
/* line 13861 "new_C.puma" */
   if (! (t -> ActualStar . UseHelpVar)) goto yyL25;
  {
/* line 13862 "new_C.puma" */
   CodeExprHelpVarClose (t->ActualStar.Next);
  }
  }
END_RULE;
   return;
yyL25:;

  break;
  case kElemExpr:
/* line 13865 "new_C.puma" */
  {
/* line 13866 "new_C.puma" */
BEGIN_RULE(496);
/* line 13868 "new_C.puma" */
   CodeExprHelpVarClose (t->ElemExpr.Elem);
/* line 13869 "new_C.puma" */
   CodeExprHelpVarClose (t->ElemExpr.Next);
  }
END_RULE;
   return;

  case kElemRange:
/* line 13871 "new_C.puma" */
  {
/* line 13872 "new_C.puma" */
BEGIN_RULE(497);
/* line 13874 "new_C.puma" */
   CodeExprHelpVarClose (t->ElemRange.Lwb);
/* line 13875 "new_C.puma" */
   CodeExprHelpVarClose (t->ElemRange.Upb);
/* line 13876 "new_C.puma" */
   CodeExprHelpVarClose (t->ElemRange.Next);
  }
END_RULE;
   return;

  }

/* line 13878 "new_C.puma" */
  {
/* line 13879 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeReturnHelpVarClose
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 13882 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif


  switch (t->Kind) {
  case kLastMultiple:
/* line 13892 "new_C.puma" */
  {
/* line 13893 "new_C.puma" */
BEGIN_RULE(498);
/* line 13895 "new_C.puma" */
   CodeReturnHelpVarClose (t->LastMultiple.Mop);
  }
END_RULE;
   return;

  case kMultiple:
/* line 13897 "new_C.puma" */
  {
/* line 13898 "new_C.puma" */
BEGIN_RULE(499);
/* line 13900 "new_C.puma" */
   CodeExprHelpVarClose (t->Multiple.Mop);
/* line 13901 "new_C.puma" */
   CodeExprHelpVarClose (t->Multiple.Multiples);
  }
END_RULE;
   return;

  case kBinary:
/* line 13903 "new_C.puma" */
  {
/* line 13904 "new_C.puma" */
BEGIN_RULE(500);
/* line 13906 "new_C.puma" */
   CodeExprHelpVarClose (t->Binary.Lop);
/* line 13907 "new_C.puma" */
   CodeExprHelpVarClose (t->Binary.Rop);
  }
END_RULE;
   return;

  case kUnary:
/* line 13909 "new_C.puma" */
  {
/* line 13910 "new_C.puma" */
BEGIN_RULE(501);
/* line 13912 "new_C.puma" */
   CodeExprHelpVarClose (t->Unary.Mop);
  }
END_RULE;
   return;

  case kFuncCall:
/* line 13914 "new_C.puma" */
  {
/* line 13915 "new_C.puma" */
BEGIN_RULE(502);
/* line 13917 "new_C.puma" */
   CodeExprHelpVarClose (t->FuncCall.Actuals);
  }
END_RULE;
   return;

  case kReduce:
/* line 13919 "new_C.puma" */
  {
/* line 13920 "new_C.puma" */
BEGIN_RULE(503);
/* line 13922 "new_C.puma" */
   CodeExprHelpVarClose (t->Reduce.Expr);
  }
END_RULE;
   return;

  case kSet:
/* line 13924 "new_C.puma" */
  {
/* line 13925 "new_C.puma" */
BEGIN_RULE(504);
/* line 13927 "new_C.puma" */
   CodeExprHelpVarClose (t->Set.Elems);
  }
END_RULE;
   return;

  case kBitSet:
/* line 13929 "new_C.puma" */
  {
/* line 13930 "new_C.puma" */
BEGIN_RULE(505);
/* line 13932 "new_C.puma" */
   CodeExprHelpVarClose (t->BitSet.Elems);
  }
END_RULE;
   return;

  case kProcessor:
/* line 13934 "new_C.puma" */
  {
/* line 13935 "new_C.puma" */
BEGIN_RULE(506);
/* line 13937 "new_C.puma" */
   CodeDesignatorHelpVarClose (t);
  }
END_RULE;
   return;

  case kDimensions:
/* line 13939 "new_C.puma" */
  {
/* line 13940 "new_C.puma" */
BEGIN_RULE(507);
/* line 13942 "new_C.puma" */
   CodeDesignatorHelpVarClose (t);
  }
END_RULE;
   return;

  case kSelect:
/* line 13944 "new_C.puma" */
  {
/* line 13945 "new_C.puma" */
BEGIN_RULE(508);
/* line 13947 "new_C.puma" */
   CodeDesignatorHelpVarClose (t);
  }
END_RULE;
   return;

  case kSubscript:
/* line 13949 "new_C.puma" */
  {
/* line 13950 "new_C.puma" */
BEGIN_RULE(509);
/* line 13952 "new_C.puma" */
   CodeDesignatorHelpVarClose (t);
  }
END_RULE;
   return;

  case kDeref:
/* line 13954 "new_C.puma" */
  {
/* line 13955 "new_C.puma" */
BEGIN_RULE(510);
/* line 13957 "new_C.puma" */
   CodeDesignatorHelpVarClose (t);
  }
END_RULE;
   return;

  }

/* line 13959 "new_C.puma" */
  {
/* line 13960 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeDesignatorHelpVarClose
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 13963 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif

  if (t->Kind == kProcessor) {
/* line 13970 "new_C.puma" */
  {
/* line 13971 "new_C.puma" */
BEGIN_RULE(511);
/* line 13973 "new_C.puma" */
   if (! (t->Processor.Proc -> Expr . UseHelpVar)) goto yyL1;
  {
/* line 13974 "new_C.puma" */
   CodeExprHelpVarClose (t->Processor.Proc);
/* line 13975 "new_C.puma" */
   CodeDesignatorHelpVarClose (t->Processor.Designator);
  }
  }
END_RULE;
   return;
yyL1:;

/* line 13977 "new_C.puma" */
  {
/* line 13978 "new_C.puma" */
BEGIN_RULE(512);
/* line 13980 "new_C.puma" */
   CodeDesignatorHelpVarClose (t->Processor.Designator);
  }
END_RULE;
   return;

  }
  if (t->Kind == kDimensions) {
/* line 13982 "new_C.puma" */
  {
/* line 13983 "new_C.puma" */
BEGIN_RULE(513);
/* line 13985 "new_C.puma" */
   if (! (t->Dimensions.Actuals -> Actuals . UseHelpVar)) goto yyL3;
  {
/* line 13986 "new_C.puma" */
   CodeExprHelpVarClose (t->Dimensions.Actuals);
/* line 13987 "new_C.puma" */
   WRITEBLANKS ();
/* line 13988 "new_C.puma" */
   WRITESTRING ("free(");
/* line 13989 "new_C.puma" */
   WRITEIDENT (t->Dimensions.Actuals -> ActualExpr . HelpVar);
/* line 13990 "new_C.puma" */
   WRITESTRING (");");
/* line 13991 "new_C.puma" */
   WRITELN ();
/* line 13992 "new_C.puma" */
   CodeDesignatorHelpVarClose (t->Dimensions.Designator);
  }
  }
END_RULE;
   return;
yyL3:;

/* line 13994 "new_C.puma" */
  {
/* line 13995 "new_C.puma" */
BEGIN_RULE(514);
/* line 13997 "new_C.puma" */
   WRITEBLANKS ();
/* line 13998 "new_C.puma" */
   WRITESTRING ("free(");
/* line 13999 "new_C.puma" */
   WRITEIDENT (t->Dimensions.Actuals -> ActualExpr . HelpVar);
/* line 14000 "new_C.puma" */
   WRITESTRING (");");
/* line 14001 "new_C.puma" */
   WRITELN ();
/* line 14002 "new_C.puma" */
   CodeDesignatorHelpVarClose (t->Dimensions.Designator);
  }
END_RULE;
   return;

  }
  if (t->Kind == kSubscript) {
/* line 14004 "new_C.puma" */
  {
/* line 14005 "new_C.puma" */
BEGIN_RULE(515);
/* line 14007 "new_C.puma" */
   if (! (t->Subscript.Index -> Expr . UseHelpVar)) goto yyL5;
  {
/* line 14008 "new_C.puma" */
   CodeExprHelpVarClose (t->Subscript.Index);
/* line 14009 "new_C.puma" */
   CodeDesignatorHelpVarClose (t->Subscript.Designator);
  }
  }
END_RULE;
   return;
yyL5:;

/* line 14011 "new_C.puma" */
  {
/* line 14012 "new_C.puma" */
BEGIN_RULE(516);
/* line 14014 "new_C.puma" */
   CodeDesignatorHelpVarClose (t->Subscript.Designator);
  }
END_RULE;
   return;

  }
  if (t->Kind == kSelect) {
/* line 14016 "new_C.puma" */
  {
/* line 14017 "new_C.puma" */
BEGIN_RULE(517);
/* line 14019 "new_C.puma" */
   CodeDesignatorHelpVarClose (t->Select.Designator);
  }
END_RULE;
   return;

  }
  if (t->Kind == kDeref) {
/* line 14021 "new_C.puma" */
  {
/* line 14022 "new_C.puma" */
BEGIN_RULE(518);
/* line 14024 "new_C.puma" */
   CodeDesignatorHelpVarClose (t->Deref.Designator);
  }
END_RULE;
   return;

  }
/* line 14026 "new_C.puma" */
  {
/* line 14027 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void CodeSepa
# if defined __STDC__ | defined __cplusplus
(register tTree yyP7)
# else
(yyP7)
 register tTree yyP7;
# endif
{
/* line 14034 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif


  switch (yyP7->Kind) {
  case kVarId:
/* line 14041 "new_C.puma" */
  {
/* line 14047 "new_C.puma" */
BEGIN_RULE(519);
/* line 14049 "new_C.puma" */
   WRITESTRING (", ");
  }
END_RULE;
   return;

  case kParId:
/* line 14041 "new_C.puma" */
  {
/* line 14047 "new_C.puma" */
BEGIN_RULE(519);
/* line 14049 "new_C.puma" */
   WRITESTRING (", ");
  }
END_RULE;
   return;

  case kFieldId:
/* line 14041 "new_C.puma" */
  {
/* line 14047 "new_C.puma" */
BEGIN_RULE(519);
/* line 14049 "new_C.puma" */
   WRITESTRING (", ");
  }
END_RULE;
   return;

  case kFormal:
/* line 14041 "new_C.puma" */
  {
/* line 14047 "new_C.puma" */
BEGIN_RULE(519);
/* line 14049 "new_C.puma" */
   WRITESTRING (", ");
  }
END_RULE;
   return;

  case kFormalType:
/* line 14041 "new_C.puma" */
  {
/* line 14047 "new_C.puma" */
BEGIN_RULE(519);
/* line 14049 "new_C.puma" */
   WRITESTRING (", ");
  }
END_RULE;
   return;

  case kActual:
  case kActualExpr:
  case kActualRange:
  case kActualReduce:
  case kActualStar:
/* line 14041 "new_C.puma" */
  {
/* line 14047 "new_C.puma" */
BEGIN_RULE(519);
/* line 14049 "new_C.puma" */
   WRITESTRING (", ");
  }
END_RULE;
   return;

  case kElem:
  case kElemExpr:
  case kElemRange:
/* line 14050 "new_C.puma" */
  {
/* line 14051 "new_C.puma" */
BEGIN_RULE(520);
/* line 14053 "new_C.puma" */
   WRITESTRING (" | ");
  }
END_RULE;
   return;

  }

/* line 14054 "new_C.puma" */
  {
/* line 14055 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

static void Crossreference
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{
/* line 14064 "new_C.puma" */
 
#ifdef DEVELOP
unsigned rulestack[1024];unsigned rulessp=0;
#endif


  switch (t->Kind) {
  case kDefMod:
  if (t->DefMod.Next->Kind == kImplMod) {
  if (t->DefMod.Next->ImplMod.Next->Kind == kNoCompUnit) {
/* line 14071 "new_C.puma" */
  {
/* line 14072 "new_C.puma" */
BEGIN_RULE(521);
/* line 14074 "new_C.puma" */

               fileHandle = GeneralIO_OpenCrossreferenceFile(t->DefMod.RealName);
               WRITESTRING("# Parallaxis 3.0 crossreference file for module ");
               WRITEIDENT(t->DefMod.Ident);
               WRITELN();
               WRITESTRING("#line 1 \"");
               WRITEIDENT(t->DefMod.Pos.File);
               WRITESTRING("\"\n");
               Crossreference(t->DefMod.Decls);
               Crossreference(t->DefMod.Next);
               WRITESTRING("# end of crossreference file\n");
               FileIO_Close(fileHandle);

  }
END_RULE;
   return;

  }
  }
  if (Tree_IsType (t->DefMod.Next, kCompUnit)) {
/* line 14088 "new_C.puma" */
  {
/* line 14089 "new_C.puma" */
BEGIN_RULE(522);
/* line 14091 "new_C.puma" */
   Crossreference (t->DefMod.Next);
  }
END_RULE;
   return;

  }
  break;
  case kImplMod:
  if (t->ImplMod.Next->Kind == kNoCompUnit) {
/* line 14093 "new_C.puma" */
  {
/* line 14094 "new_C.puma" */
BEGIN_RULE(523);
/* line 14096 "new_C.puma" */
   if (! (t->ImplMod.Kind == ModTypeProg)) goto yyL3;
  {
/* line 14097 "new_C.puma" */

               fileHandle = GeneralIO_OpenCrossreferenceFile(t->ImplMod.RealName);
               WRITESTRING("# Parallaxis 3.0 crossreference file for module ");
               WRITEIDENT(t->ImplMod.Ident);
               WRITELN();
               WRITESTRING("#line 1 \"");
               WRITEIDENT(t->ImplMod.Pos.File);
               WRITESTRING("\"\n");
               Crossreference(t->ImplMod.Decls);
               WRITESTRING("# end of crossreference file\n");
               FileIO_Close(fileHandle);

  }
  }
END_RULE;
   return;
yyL3:;

/* line 14110 "new_C.puma" */
  {
/* line 14111 "new_C.puma" */
BEGIN_RULE(524);
/* line 14113 "new_C.puma" */
   if (! (t->ImplMod.Kind == ModTypeImp)) goto yyL4;
  {
/* line 14114 "new_C.puma" */
   Crossreference (t->ImplMod.Decls);
  }
  }
END_RULE;
   return;
yyL4:;

  }
  break;
  case kVar:
/* line 14117 "new_C.puma" */
  {
/* line 14118 "new_C.puma" */
BEGIN_RULE(525);
/* line 14120 "new_C.puma" */
   Crossreference (t->Var.VarIds);
/* line 14121 "new_C.puma" */
   Crossreference (t->Var.Next);
  }
END_RULE;
   return;

  case kConfig:
/* line 14123 "new_C.puma" */
  {
/* line 14124 "new_C.puma" */
BEGIN_RULE(526);
/* line 14126 "new_C.puma" */
   CrossreferenceLine (t->Config.Ident, t -> Config . CIdent, 0);
/* line 14127 "new_C.puma" */
   Crossreference (t->Config.Next);
  }
END_RULE;
   return;

  case kConst:
/* line 14129 "new_C.puma" */
  {
/* line 14130 "new_C.puma" */
BEGIN_RULE(527);
/* line 14132 "new_C.puma" */
   CrossreferenceLine (t->Const.Ident, t -> Const . CIdent, 0);
/* line 14133 "new_C.puma" */
   Crossreference (t->Const.Next);
  }
END_RULE;
   return;

  case kTypeDecl:
/* line 14135 "new_C.puma" */
  {
/* line 14136 "new_C.puma" */
BEGIN_RULE(528);
/* line 14138 "new_C.puma" */
   CrossreferenceLine (t->TypeDecl.Ident, t -> TypeDecl . CIdent, 0);
/* line 14139 "new_C.puma" */
   Crossreference (t->TypeDecl.Next);
  }
END_RULE;
   return;

  case kProc:
/* line 14141 "new_C.puma" */
  {
/* line 14142 "new_C.puma" */
BEGIN_RULE(529);
/* line 14144 "new_C.puma" */
   CrossreferenceLine (t->Proc.Ident, t -> Proc . CIdent, 0);
/* line 14145 "new_C.puma" */
   Crossreference (t->Proc.Formals);
/* line 14146 "new_C.puma" */
   Crossreference (t->Proc.Decls);
/* line 14147 "new_C.puma" */
   Crossreference (t->Proc.Next);
  }
END_RULE;
   return;

  case kProcHead:
/* line 14149 "new_C.puma" */
  {
/* line 14150 "new_C.puma" */
BEGIN_RULE(530);
/* line 14152 "new_C.puma" */
   CrossreferenceLine (t->ProcHead.Ident, t -> ProcHead . CIdent, 0);
/* line 14153 "new_C.puma" */
   Crossreference (t->ProcHead.Next);
  }
END_RULE;
   return;

  case kOpaque:
/* line 14155 "new_C.puma" */
  {
/* line 14156 "new_C.puma" */
BEGIN_RULE(531);
/* line 14158 "new_C.puma" */
   CrossreferenceLine (t->Opaque.Ident, t -> Opaque . CIdent, 0);
/* line 14159 "new_C.puma" */
   Crossreference (t->Opaque.Next);
  }
END_RULE;
   return;

  case kDecl:
  case kObject:
  case kConnectFrom:
  case kConnectDecls:
/* line 14161 "new_C.puma" */
  {
/* line 14162 "new_C.puma" */
BEGIN_RULE(532);
/* line 14164 "new_C.puma" */
   Crossreference (t->Decl.Next);
  }
END_RULE;
   return;

  case kVarId:
/* line 14167 "new_C.puma" */
  {
/* line 14168 "new_C.puma" */
BEGIN_RULE(533);
/* line 14170 "new_C.puma" */
   if (! (t -> VarId . Object -> SymVar . Type -> Kind == kSymVector)) goto yyL13;
  {
/* line 14171 "new_C.puma" */
   CrossreferenceLine (t->VarId.Ident, t -> VarId . CIdent, t -> VarId . Object -> SymVar . Type -> SymVector . Config -> SymConfig . CIdent);
/* line 14172 "new_C.puma" */
   Crossreference (t->VarId.Next);
  }
  }
END_RULE;
   return;
yyL13:;

/* line 14174 "new_C.puma" */
  {
/* line 14175 "new_C.puma" */
BEGIN_RULE(534);
/* line 14177 "new_C.puma" */
   CrossreferenceLine (t->VarId.Ident, t -> VarId . CIdent, 0);
/* line 14178 "new_C.puma" */
   Crossreference (t->VarId.Next);
  }
END_RULE;
   return;

  case kFormal:
/* line 14181 "new_C.puma" */
  {
/* line 14182 "new_C.puma" */
BEGIN_RULE(535);
/* line 14184 "new_C.puma" */
   Crossreference (t->Formal.ParIds);
/* line 14185 "new_C.puma" */
   Crossreference (t->Formal.Next);
  }
END_RULE;
   return;

  case kParId:
/* line 14189 "new_C.puma" */
  {
/* line 14190 "new_C.puma" */
BEGIN_RULE(536);
/* line 14192 "new_C.puma" */
   if (! (t -> ParId . Object -> SymVar . Type -> Kind == kSymVector)) goto yyL16;
  {
/* line 14193 "new_C.puma" */
   CrossreferenceLine (t->ParId.Ident, t -> ParId . CIdent, t -> ParId . Object -> SymVar . Type -> SymVector . Config -> SymConfig . CIdent);
/* line 14194 "new_C.puma" */
   Crossreference (t->ParId.Next);
  }
  }
END_RULE;
   return;
yyL16:;

/* line 14196 "new_C.puma" */
  {
/* line 14197 "new_C.puma" */
BEGIN_RULE(537);
/* line 14199 "new_C.puma" */
   CrossreferenceLine (t->ParId.Ident, t -> ParId . CIdent, 0);
/* line 14200 "new_C.puma" */
   Crossreference (t->ParId.Next);
  }
END_RULE;
   return;

  }

/* line 14203 "new_C.puma" */
  {
/* line 14204 "new_C.puma" */
END_RULE;
return;
  }
END_RULE;
   return;

;
}

void BeginCode ()
{
/* line 2413 "new_C.puma" */

  indent = 0;
  indentTab = Options_GetSourceIndent();
  NotInActualsWrite = TRUE;
  VectorLoopCalls = 0;
  AssignCalls = 0;

  precedence [ Code_NoOp          ] = MINPREC_PREC;
  precedence [ Code_NotEqual      ] = NOTEQUAL_PREC;
  precedence [ Code_Times         ] = TIMES_PREC;
  precedence [ Code_Plus          ] = PLUS_PREC;
  precedence [ Code_Minus         ] = MINUS_PREC;
  precedence [ Code_Divide        ] = DIVIDE_PREC;
  precedence [ Code_Less          ] = LESS_PREC;
  precedence [ Code_LessEqual     ] = LESSEQUAL_PREC;
  precedence [ Code_Equal         ] = EQUAL_PREC;
  precedence [ Code_Greater       ] = GREATER_PREC;
  precedence [ Code_GreaterEqual  ] = GREATEREQUAL_PREC;
  precedence [ Code_And           ] = AND_PREC;
  precedence [ Code_In            ] = IN_PREC;
  precedence [ Code_Mod           ] = MOD_PREC;
  precedence [ Code_Not           ] = NOT_PREC;
  precedence [ Code_Or            ] = OR_PREC;
  precedence [ Code_Union         ] = UNION_PREC;
  precedence [ Code_Difference    ] = DIFFERENCE_PREC;
  precedence [ Code_Intersection  ] = INTERSECTION_PREC;
  precedence [ Code_SymDiff       ] = SYMDIFF_PREC;
  precedence [ Code_IsSubset1     ] = ISSUBSET1_PREC;
  precedence [ Code_IsSubset2     ] = ISSUBSET2_PREC;
  precedence [ Code_Assign        ] = ASSIGN_PREC;
  precedence [ Code_PassValue     ] = PASSVALUE_PREC;
  precedence [ Code_PassAddress   ] = PASSADDRESS_PREC;

  AssocTab_Begin();
  LoopStack_Init();
  With_Init();

}

void CloseCode ()
{
/* line 2452 "new_C.puma" */

  AssocTab_Close();
  LoopStack_Free();
  With_Free();

}
