# include "Tree.h"
# define yyALLOC(ptr, size)	if ((ptr = (tTree) Tree_PoolFreePtr) >= (tTree) Tree_PoolMaxPtr) \
  ptr = Tree_Alloc (); \
  Tree_PoolFreePtr += size;
# define yyFREE(ptr, size)	
# ifdef __cplusplus
extern "C" {
# include <stdio.h>
# include "yyTree.w"
# include "System.h"
# include "General.h"
# include "Memory.h"
# include "DynArray.h"
# include "StringMem.h"
# include "Idents.h"
# include "Sets.h"
# include "Positions.h"
}
# else
# include <stdio.h>
# include "yyTree.w"
# include "System.h"
# include "General.h"
# include "Memory.h"
# include "DynArray.h"
# include "StringMem.h"
# include "Idents.h"
# include "Sets.h"
# include "Positions.h"
# endif

/* line 76 "parallaxis.cg" */

# include "Values.h"

/* use this if you want to free memory for single tree nodes
 */
/*
#define yyALLOC(ptr,size) ptr = Alloc(size);
#define yyFREE(ptr,size)  Free(size,ptr);
 */
#include "Tree.h"
#include "parallaxis.w"
#include "browser.w"
tTree NoExpr;
tTree NoQualid;
tTree Tree_Integer;
tTree Tree_Boolean;
tTree Tree_Char;

tPosition Tree_LeftmostPos( tTree expr )
{
  switch ( expr->Kind ) {
  case kMultiple    : return Tree_LeftmostPos(expr->Multiple.Mop);
  case kLastMultiple: return Tree_LeftmostPos(expr->LastMultiple.Mop);
  case kBinary      : return Tree_LeftmostPos(expr->Binary.Lop);
  case kUnary       : return expr->Unary.Pos;
  case kIntConst    : return expr->IntConst.Pos;
  case kRealConst   : return expr->RealConst.Pos;
  case kStringConst : return expr->StringConst.Pos;
  case kCharConst   : return expr->CharConst.Pos;
  case kFuncCall    : return Tree_LeftmostPos(expr->FuncCall.Designator);
  case kMove        : return Tree_LeftmostPos(expr->Move.DirSpec);
  case kReceive     : return Tree_LeftmostPos(expr->Receive.DirSpec);
  case kReduce      : return Tree_LeftmostPos(expr->Reduce.Reduce);
  case kSet         : return Tree_LeftmostPos(expr->Set.BaseType);
  case kBitSet      : return Tree_LeftmostPos(expr->BitSet.Elems);
  case kQualid0     : return expr->Qualid0.Pos;
  case kQualid1     : return Tree_LeftmostPos(expr->Qualid1.Qualid);
  case kProcessor   : return Tree_LeftmostPos(expr->Processor.Proc);
  case kDimensions  : return Tree_LeftmostPos(expr->Dimensions.Actuals);
  case kSelect      : return Tree_LeftmostPos(expr->Select.Designator);
  case kSubscript   : return Tree_LeftmostPos(expr->Subscript.Designator);
  case kDeref       : return Tree_LeftmostPos(expr->Deref.Designator);
  case kFuncSpec    : return Tree_LeftmostPos(expr->FuncSpec.DirOut);
  case kProcSpec    : return Tree_LeftmostPos(expr->ProcSpec.Expr);
  case kDimSpec     : return Tree_LeftmostPos(expr->DimSpec.Actuals);
  case kElemExpr    : return Tree_LeftmostPos(expr->ElemExpr.Elem);
  case kElemRange   : return Tree_LeftmostPos(expr->ElemRange.Lwb);
  case kActualExpr  : return Tree_LeftmostPos(expr->ActualExpr.Expr);
  case kActualRange : return Tree_LeftmostPos(expr->ActualRange.Lwb);
  case kActualReduce: return Tree_LeftmostPos(expr->ActualReduce.Qualid);
  case kActualStar  : return Tree_LeftmostPos(expr->ActualStar.Next);
  default           : return NoPosition;
  } /* endswitch */
}

char *Tree_DesignatorName( tTree designator, char *buffer )
{
  switch ( designator->Kind ) {
  case kQualid0:
    GetString( designator->Qualid0.Ident, buffer );
    break;
  case kQualid1:
    Tree_DesignatorName( designator->Qualid1.Qualid, buffer );
    strcat( buffer, "." );
    GetString( designator->Qualid1.Ident, buffer+strlen(buffer) );
    break;
  case kProcessor:
    Tree_DesignatorName( designator->Select.Designator, buffer );
    strcat( buffer, "<< >>" );
    break;
  case kDimensions:
    Tree_DesignatorName( designator->Select.Designator, buffer );
    strcat( buffer, "<: :>" );
    break;
  case kSubscript:
    Tree_DesignatorName( designator->Subscript.Designator, buffer );
    strcat( buffer, "[]" );
    break;
  case kSelect:
    Tree_DesignatorName( designator->Select.Designator, buffer );
    strcat( buffer, "." );
    GetString( designator->Select.Field, buffer+strlen(buffer) );
    break;
  case kDeref:
    Tree_DesignatorName( designator->Deref.Designator, buffer );
    strcat( buffer, "^" );
    break;
  default:
    strcpy( buffer, "Unknown Designator" );
    break;
  } /* endswitch */
  return buffer;
}



static void yyExit () { Exit (1); }

void (* Tree_Exit) () = yyExit;

# define yyBlockSize 20480

typedef struct yysBlock {
 char yyBlock [yyBlockSize];
 struct yysBlock * yySuccessor;
} yytBlock, * yytBlockPtr;

tTree TreeRoot;
unsigned long Tree_HeapUsed = 0;

static yytBlockPtr yyBlockList	= (yytBlockPtr) NoTree;
char * Tree_PoolFreePtr	= (char *) NoTree;
char * Tree_PoolMaxPtr	= (char *) NoTree;
static unsigned short yyMaxSize	= 0;
unsigned short Tree_NodeSize [155 + 1] = { 0,
 sizeof (yROOT),
 sizeof (yCompUnits),
 sizeof (yNoCompUnit),
 sizeof (yCompUnit),
 sizeof (yDefMod),
 sizeof (yImplMod),
 sizeof (yImports),
 sizeof (yNoImport),
 sizeof (yImport),
 sizeof (yFrom),
 sizeof (yObjects),
 sizeof (yImpIds),
 sizeof (yNoImpId),
 sizeof (yImpId),
 sizeof (yExports),
 sizeof (yNoExport),
 sizeof (yExport),
 sizeof (yExpIds),
 sizeof (yNoExpId),
 sizeof (yExpId),
 sizeof (yDecls),
 sizeof (yNoDecl),
 sizeof (yDecl),
 sizeof (yVar),
 sizeof (yObject),
 sizeof (yConnectFrom),
 sizeof (yConnectDecls),
 sizeof (yConfig),
 sizeof (yConst),
 sizeof (yTypeDecl),
 sizeof (yProc),
 sizeof (yProcHead),
 sizeof (yOpaque),
 sizeof (yConnectDests),
 sizeof (yNoConnectDest),
 sizeof (yConnectDest),
 sizeof (yConnectDestUni),
 sizeof (yConnectDestBi),
 sizeof (yVarIds),
 sizeof (yNoVarId),
 sizeof (yVarId),
 sizeof (yFormals),
 sizeof (yNoFormal),
 sizeof (yFormal),
 sizeof (yParIds),
 sizeof (yNoParId),
 sizeof (yParId),
 sizeof (yType),
 sizeof (yVector),
 sizeof (yArray),
 sizeof (yRecord),
 sizeof (ySetType),
 sizeof (yPointer),
 sizeof (yProcType),
 sizeof (ySimpleType),
 sizeof (yEnumeration),
 sizeof (ySubrange),
 sizeof (yPrimaryType),
 sizeof (yVoid),
 sizeof (yTypeId),
 sizeof (yTypeId0),
 sizeof (yTypeId1),
 sizeof (yFields),
 sizeof (yNoField),
 sizeof (yField),
 sizeof (yRecordSect),
 sizeof (yVariantSect),
 sizeof (yFieldIds),
 sizeof (yNoFieldId),
 sizeof (yFieldId),
 sizeof (yTagField),
 sizeof (yTagField1),
 sizeof (yTagField2),
 sizeof (yVariants),
 sizeof (yNoVariant),
 sizeof (yVariant),
 sizeof (yFormalTypes),
 sizeof (yNoFormalType),
 sizeof (yFormalType),
 sizeof (yEnumIds),
 sizeof (yNoEnumId),
 sizeof (yEnumId),
 sizeof (yExpr),
 sizeof (yNoExpr),
 sizeof (yMultiples),
 sizeof (yLastMultiple),
 sizeof (yMultiple),
 sizeof (yBinary),
 sizeof (yUnary),
 sizeof (yIntConst),
 sizeof (yRealConst),
 sizeof (yStringConst),
 sizeof (yCharConst),
 sizeof (yFuncCall),
 sizeof (yMove),
 sizeof (yReceive),
 sizeof (yReduce),
 sizeof (ySet),
 sizeof (yBitSet),
 sizeof (yDesignator),
 sizeof (yQualid),
 sizeof (yQualid0),
 sizeof (yQualid1),
 sizeof (yProcessor),
 sizeof (yDimensions),
 sizeof (ySelect),
 sizeof (ySubscript),
 sizeof (yDeref),
 sizeof (yDirSpec),
 sizeof (yFuncSpec),
 sizeof (yProcSpec),
 sizeof (yDimSpec),
 sizeof (yElems),
 sizeof (yNoElem),
 sizeof (yElem),
 sizeof (yElemExpr),
 sizeof (yElemRange),
 sizeof (yActuals),
 sizeof (yNoActual),
 sizeof (yActual),
 sizeof (yActualExpr),
 sizeof (yActualRange),
 sizeof (yActualReduce),
 sizeof (yActualStar),
 sizeof (yStmts),
 sizeof (yNoStmt),
 sizeof (yStmt),
 sizeof (yAssign),
 sizeof (yCall),
 sizeof (yIf),
 sizeof (yCase),
 sizeof (yWhile),
 sizeof (yRepeat),
 sizeof (yLoop),
 sizeof (yLooppar),
 sizeof (yFor),
 sizeof (yWith),
 sizeof (yAll),
 sizeof (ySend),
 sizeof (yLoad),
 sizeof (yStore),
 sizeof (yExit),
 sizeof (yReturn0),
 sizeof (yReturn1),
 sizeof (yElsifs),
 sizeof (yNoElsif),
 sizeof (yElsif),
 sizeof (yCases),
 sizeof (yNoCase),
 sizeof (yCases1),
 sizeof (yLabels),
 sizeof (yNoLabel),
 sizeof (yLabel),
 sizeof (yLabelExpr),
 sizeof (yLabelRange),
};
char * Tree_NodeName [155 + 1] = {
 "NoTree",
 "ROOT",
 "CompUnits",
 "NoCompUnit",
 "CompUnit",
 "DefMod",
 "ImplMod",
 "Imports",
 "NoImport",
 "Import",
 "From",
 "Objects",
 "ImpIds",
 "NoImpId",
 "ImpId",
 "Exports",
 "NoExport",
 "Export",
 "ExpIds",
 "NoExpId",
 "ExpId",
 "Decls",
 "NoDecl",
 "Decl",
 "Var",
 "Object",
 "ConnectFrom",
 "ConnectDecls",
 "Config",
 "Const",
 "TypeDecl",
 "Proc",
 "ProcHead",
 "Opaque",
 "ConnectDests",
 "NoConnectDest",
 "ConnectDest",
 "ConnectDestUni",
 "ConnectDestBi",
 "VarIds",
 "NoVarId",
 "VarId",
 "Formals",
 "NoFormal",
 "Formal",
 "ParIds",
 "NoParId",
 "ParId",
 "Type",
 "Vector",
 "Array",
 "Record",
 "SetType",
 "Pointer",
 "ProcType",
 "SimpleType",
 "Enumeration",
 "Subrange",
 "PrimaryType",
 "Void",
 "TypeId",
 "TypeId0",
 "TypeId1",
 "Fields",
 "NoField",
 "Field",
 "RecordSect",
 "VariantSect",
 "FieldIds",
 "NoFieldId",
 "FieldId",
 "TagField",
 "TagField1",
 "TagField2",
 "Variants",
 "NoVariant",
 "Variant",
 "FormalTypes",
 "NoFormalType",
 "FormalType",
 "EnumIds",
 "NoEnumId",
 "EnumId",
 "Expr",
 "NoExpr",
 "Multiples",
 "LastMultiple",
 "Multiple",
 "Binary",
 "Unary",
 "IntConst",
 "RealConst",
 "StringConst",
 "CharConst",
 "FuncCall",
 "Move",
 "Receive",
 "Reduce",
 "Set",
 "BitSet",
 "Designator",
 "Qualid",
 "Qualid0",
 "Qualid1",
 "Processor",
 "Dimensions",
 "Select",
 "Subscript",
 "Deref",
 "DirSpec",
 "FuncSpec",
 "ProcSpec",
 "DimSpec",
 "Elems",
 "NoElem",
 "Elem",
 "ElemExpr",
 "ElemRange",
 "Actuals",
 "NoActual",
 "Actual",
 "ActualExpr",
 "ActualRange",
 "ActualReduce",
 "ActualStar",
 "Stmts",
 "NoStmt",
 "Stmt",
 "Assign",
 "Call",
 "If",
 "Case",
 "While",
 "Repeat",
 "Loop",
 "Looppar",
 "For",
 "With",
 "All",
 "Send",
 "Load",
 "Store",
 "Exit",
 "Return0",
 "Return1",
 "Elsifs",
 "NoElsif",
 "Elsif",
 "Cases",
 "NoCase",
 "Cases1",
 "Labels",
 "NoLabel",
 "Label",
 "LabelExpr",
 "LabelRange",
};
static Tree_tKind yyTypeRange [155 + 1] = { 0,
 kROOT,
 kImplMod,
 kNoCompUnit,
 kImplMod,
 kDefMod,
 kImplMod,
 kObjects,
 kNoImport,
 kObjects,
 kFrom,
 kObjects,
 kImpId,
 kNoImpId,
 kImpId,
 kExport,
 kNoExport,
 kExport,
 kExpId,
 kNoExpId,
 kExpId,
 kOpaque,
 kNoDecl,
 kOpaque,
 kVar,
 kOpaque,
 kConnectFrom,
 kConnectDecls,
 kConfig,
 kConst,
 kTypeDecl,
 kProc,
 kProcHead,
 kOpaque,
 kConnectDestBi,
 kNoConnectDest,
 kConnectDestBi,
 kConnectDestUni,
 kConnectDestBi,
 kVarId,
 kNoVarId,
 kVarId,
 kFormal,
 kNoFormal,
 kFormal,
 kParId,
 kNoParId,
 kParId,
 kTypeId1,
 kVector,
 kArray,
 kRecord,
 kSetType,
 kPointer,
 kProcType,
 kTypeId1,
 kEnumeration,
 kSubrange,
 kTypeId1,
 kVoid,
 kTypeId1,
 kTypeId0,
 kTypeId1,
 kVariantSect,
 kNoField,
 kVariantSect,
 kRecordSect,
 kVariantSect,
 kFieldId,
 kNoFieldId,
 kFieldId,
 kTagField2,
 kTagField1,
 kTagField2,
 kVariant,
 kNoVariant,
 kVariant,
 kFormalType,
 kNoFormalType,
 kFormalType,
 kEnumId,
 kNoEnumId,
 kEnumId,
 kDeref,
 kNoExpr,
 kMultiple,
 kLastMultiple,
 kMultiple,
 kBinary,
 kUnary,
 kIntConst,
 kRealConst,
 kStringConst,
 kCharConst,
 kFuncCall,
 kMove,
 kReceive,
 kReduce,
 kSet,
 kBitSet,
 kDeref,
 kQualid1,
 kQualid0,
 kQualid1,
 kProcessor,
 kDimensions,
 kSelect,
 kSubscript,
 kDeref,
 kDimSpec,
 kFuncSpec,
 kProcSpec,
 kDimSpec,
 kElemRange,
 kNoElem,
 kElemRange,
 kElemExpr,
 kElemRange,
 kActualStar,
 kNoActual,
 kActualStar,
 kActualExpr,
 kActualRange,
 kActualReduce,
 kActualStar,
 kReturn1,
 kNoStmt,
 kReturn1,
 kAssign,
 kCall,
 kIf,
 kCase,
 kWhile,
 kRepeat,
 kLoop,
 kLooppar,
 kFor,
 kWith,
 kAll,
 kSend,
 kLoad,
 kStore,
 kExit,
 kReturn0,
 kReturn1,
 kElsif,
 kNoElsif,
 kElsif,
 kCases1,
 kNoCase,
 kCases1,
 kLabelRange,
 kNoLabel,
 kLabelRange,
 kLabelExpr,
 kLabelRange,
};

tTree Tree_Alloc ()
{
 register yytBlockPtr yyBlockPtr = yyBlockList;
 register int i;

 if (yyMaxSize == 0)
  for (i = 1; i <= 155; i ++) {
   Tree_NodeSize [i] = (Tree_NodeSize [i] + yyMaxAlign - 1) & yyAlignMasks [yyMaxAlign];
   yyMaxSize = Max (Tree_NodeSize [i], yyMaxSize);
  }
 yyBlockList = (yytBlockPtr) Alloc (sizeof (yytBlock));
 yyBlockList->yySuccessor = yyBlockPtr;
 Tree_PoolFreePtr = yyBlockList->yyBlock;
 Tree_PoolMaxPtr = Tree_PoolFreePtr + yyBlockSize - yyMaxSize + 1;
 Tree_HeapUsed += yyBlockSize;
 return (tTree) Tree_PoolFreePtr;
}

tTree MakeTree
# if defined __STDC__ | defined __cplusplus
 (Tree_tKind yyKind)
# else
 (yyKind) Tree_tKind yyKind;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [yyKind])
 yyt->Kind = yyKind;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

bool Tree_IsType
# if defined __STDC__ | defined __cplusplus
 (register tTree yyt, register Tree_tKind yyKind)
# else
 (yyt, yyKind) register tTree yyt; register Tree_tKind yyKind;
# endif
{
 return yyt != NoTree && yyKind <= yyt->Kind && yyt->Kind <= yyTypeRange [yyKind];
}


tTree mROOT
# if defined __STDC__ | defined __cplusplus
(tTree pCompUnits)
# else
(pCompUnits)
tTree pCompUnits;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kROOT])
 yyt->Kind = kROOT;
 yyt->yyHead.yyMark = 0;
 yyt->ROOT.CompUnits = pCompUnits;
 return yyt;
}

tTree mCompUnits
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kCompUnits])
 yyt->Kind = kCompUnits;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->CompUnits.Objects1)
 begintVoid(yyt->CompUnits.Objects2)
 begintObjects(yyt->CompUnits.Objects3)
 begintVoid(yyt->CompUnits.Objects4In)
 begintVoid(yyt->CompUnits.Objects4Out)
 begintEnv(yyt->CompUnits.Env1)
 begintVoid(yyt->CompUnits.Env2)
 begintEnv(yyt->CompUnits.Env3)
 beginINDEX(yyt->CompUnits.ConfigGroupIn)
 begintIdent(yyt->CompUnits.ImplIdent)
 begintObjects(yyt->CompUnits.ImplTypes)
 beginINDEX(yyt->CompUnits.PosIn)
 beginINDEX(yyt->CompUnits.PosOut)
 begintIdents(yyt->CompUnits.IdsIn)
 begintIdents(yyt->CompUnits.IdsOut)
 return yyt;
}

tTree mNoCompUnit
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoCompUnit])
 yyt->Kind = kNoCompUnit;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->NoCompUnit.Objects1)
 begintVoid(yyt->NoCompUnit.Objects2)
 begintObjects(yyt->NoCompUnit.Objects3)
 begintVoid(yyt->NoCompUnit.Objects4In)
 begintVoid(yyt->NoCompUnit.Objects4Out)
 begintEnv(yyt->NoCompUnit.Env1)
 begintVoid(yyt->NoCompUnit.Env2)
 begintEnv(yyt->NoCompUnit.Env3)
 beginINDEX(yyt->NoCompUnit.ConfigGroupIn)
 begintIdent(yyt->NoCompUnit.ImplIdent)
 begintObjects(yyt->NoCompUnit.ImplTypes)
 beginINDEX(yyt->NoCompUnit.PosIn)
 beginINDEX(yyt->NoCompUnit.PosOut)
 begintIdents(yyt->NoCompUnit.IdsIn)
 begintIdents(yyt->NoCompUnit.IdsOut)
 return yyt;
}

tTree mCompUnit
# if defined __STDC__ | defined __cplusplus
(tTree pNext, INDEX pKind, tIdent pIdent, tPosition pPos)
# else
(pNext, pKind, pIdent, pPos)
tTree pNext;
INDEX pKind;
tIdent pIdent;
tPosition pPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kCompUnit])
 yyt->Kind = kCompUnit;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->CompUnit.Objects1)
 begintVoid(yyt->CompUnit.Objects2)
 begintObjects(yyt->CompUnit.Objects3)
 begintVoid(yyt->CompUnit.Objects4In)
 begintVoid(yyt->CompUnit.Objects4Out)
 begintEnv(yyt->CompUnit.Env1)
 begintVoid(yyt->CompUnit.Env2)
 begintEnv(yyt->CompUnit.Env3)
 beginINDEX(yyt->CompUnit.ConfigGroupIn)
 begintIdent(yyt->CompUnit.ImplIdent)
 begintObjects(yyt->CompUnit.ImplTypes)
 beginINDEX(yyt->CompUnit.PosIn)
 beginINDEX(yyt->CompUnit.PosOut)
 begintIdents(yyt->CompUnit.IdsIn)
 begintIdents(yyt->CompUnit.IdsOut)
 yyt->CompUnit.Next = pNext;
 yyt->CompUnit.Kind = pKind;
 yyt->CompUnit.Ident = pIdent;
 yyt->CompUnit.Pos = pPos;
 begintObject(yyt->CompUnit.Object)
 begintIdent(yyt->CompUnit.RealName)
 return yyt;
}

tTree mDefMod
# if defined __STDC__ | defined __cplusplus
(tTree pNext, INDEX pKind, tIdent pIdent, tPosition pPos, tTree pImports, tTree pExports, tTree pDecls)
# else
(pNext, pKind, pIdent, pPos, pImports, pExports, pDecls)
tTree pNext;
INDEX pKind;
tIdent pIdent;
tPosition pPos;
tTree pImports;
tTree pExports;
tTree pDecls;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kDefMod])
 yyt->Kind = kDefMod;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->DefMod.Objects1)
 begintVoid(yyt->DefMod.Objects2)
 begintObjects(yyt->DefMod.Objects3)
 begintVoid(yyt->DefMod.Objects4In)
 begintVoid(yyt->DefMod.Objects4Out)
 begintEnv(yyt->DefMod.Env1)
 begintVoid(yyt->DefMod.Env2)
 begintEnv(yyt->DefMod.Env3)
 beginINDEX(yyt->DefMod.ConfigGroupIn)
 begintIdent(yyt->DefMod.ImplIdent)
 begintObjects(yyt->DefMod.ImplTypes)
 beginINDEX(yyt->DefMod.PosIn)
 beginINDEX(yyt->DefMod.PosOut)
 begintIdents(yyt->DefMod.IdsIn)
 begintIdents(yyt->DefMod.IdsOut)
 yyt->DefMod.Next = pNext;
 yyt->DefMod.Kind = pKind;
 yyt->DefMod.Ident = pIdent;
 yyt->DefMod.Pos = pPos;
 begintObject(yyt->DefMod.Object)
 begintIdent(yyt->DefMod.RealName)
 yyt->DefMod.Imports = pImports;
 yyt->DefMod.Exports = pExports;
 yyt->DefMod.Decls = pDecls;
 return yyt;
}

tTree mImplMod
# if defined __STDC__ | defined __cplusplus
(tTree pNext, INDEX pKind, tIdent pIdent, tPosition pPos, tTree pImports, tTree pDecls, tTree pStmts, tPosition pBeginPos)
# else
(pNext, pKind, pIdent, pPos, pImports, pDecls, pStmts, pBeginPos)
tTree pNext;
INDEX pKind;
tIdent pIdent;
tPosition pPos;
tTree pImports;
tTree pDecls;
tTree pStmts;
tPosition pBeginPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kImplMod])
 yyt->Kind = kImplMod;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->ImplMod.Objects1)
 begintVoid(yyt->ImplMod.Objects2)
 begintObjects(yyt->ImplMod.Objects3)
 begintVoid(yyt->ImplMod.Objects4In)
 begintVoid(yyt->ImplMod.Objects4Out)
 begintEnv(yyt->ImplMod.Env1)
 begintVoid(yyt->ImplMod.Env2)
 begintEnv(yyt->ImplMod.Env3)
 beginINDEX(yyt->ImplMod.ConfigGroupIn)
 begintIdent(yyt->ImplMod.ImplIdent)
 begintObjects(yyt->ImplMod.ImplTypes)
 beginINDEX(yyt->ImplMod.PosIn)
 beginINDEX(yyt->ImplMod.PosOut)
 begintIdents(yyt->ImplMod.IdsIn)
 begintIdents(yyt->ImplMod.IdsOut)
 yyt->ImplMod.Next = pNext;
 yyt->ImplMod.Kind = pKind;
 yyt->ImplMod.Ident = pIdent;
 yyt->ImplMod.Pos = pPos;
 begintObject(yyt->ImplMod.Object)
 begintIdent(yyt->ImplMod.RealName)
 yyt->ImplMod.Imports = pImports;
 yyt->ImplMod.Decls = pDecls;
 yyt->ImplMod.Stmts = pStmts;
 yyt->ImplMod.BeginPos = pBeginPos;
 begintObjects(yyt->ImplMod.DefObjects1)
 begintObjects(yyt->ImplMod.DefObjects3)
 begintCObjects(yyt->ImplMod.GlobalPtrs)
 begintStrings(yyt->ImplMod.Strings)
 return yyt;
}

tTree mImports
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kImports])
 yyt->Kind = kImports;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->Imports.Objects1)
 begintObjects(yyt->Imports.Objects2)
 begintEnv(yyt->Imports.Env1)
 begintEnv(yyt->Imports.Env2)
 begintLocalIds(yyt->Imports.LocalIdsIn)
 begintLocalIds(yyt->Imports.LocalIdsOut)
 return yyt;
}

tTree mNoImport
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoImport])
 yyt->Kind = kNoImport;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->NoImport.Objects1)
 begintObjects(yyt->NoImport.Objects2)
 begintEnv(yyt->NoImport.Env1)
 begintEnv(yyt->NoImport.Env2)
 begintLocalIds(yyt->NoImport.LocalIdsIn)
 begintLocalIds(yyt->NoImport.LocalIdsOut)
 return yyt;
}

tTree mImport
# if defined __STDC__ | defined __cplusplus
(tTree pNext)
# else
(pNext)
tTree pNext;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kImport])
 yyt->Kind = kImport;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->Import.Objects1)
 begintObjects(yyt->Import.Objects2)
 begintEnv(yyt->Import.Env1)
 begintEnv(yyt->Import.Env2)
 begintLocalIds(yyt->Import.LocalIdsIn)
 begintLocalIds(yyt->Import.LocalIdsOut)
 yyt->Import.Next = pNext;
 return yyt;
}

tTree mFrom
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tIdent pIdent, tPosition pPos, tTree pImpIds)
# else
(pNext, pIdent, pPos, pImpIds)
tTree pNext;
tIdent pIdent;
tPosition pPos;
tTree pImpIds;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kFrom])
 yyt->Kind = kFrom;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->From.Objects1)
 begintObjects(yyt->From.Objects2)
 begintEnv(yyt->From.Env1)
 begintEnv(yyt->From.Env2)
 begintLocalIds(yyt->From.LocalIdsIn)
 begintLocalIds(yyt->From.LocalIdsOut)
 yyt->From.Next = pNext;
 yyt->From.Ident = pIdent;
 yyt->From.Pos = pPos;
 yyt->From.ImpIds = pImpIds;
 begintObject(yyt->From.Object1)
 begintObject(yyt->From.Object2)
 return yyt;
}

tTree mObjects
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tTree pImpIds)
# else
(pNext, pImpIds)
tTree pNext;
tTree pImpIds;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kObjects])
 yyt->Kind = kObjects;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->Objects.Objects1)
 begintObjects(yyt->Objects.Objects2)
 begintEnv(yyt->Objects.Env1)
 begintEnv(yyt->Objects.Env2)
 begintLocalIds(yyt->Objects.LocalIdsIn)
 begintLocalIds(yyt->Objects.LocalIdsOut)
 yyt->Objects.Next = pNext;
 yyt->Objects.ImpIds = pImpIds;
 return yyt;
}

tTree mImpIds
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kImpIds])
 yyt->Kind = kImpIds;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->ImpIds.Objects1)
 begintObjects(yyt->ImpIds.Objects2)
 begintEnv(yyt->ImpIds.Env1)
 begintEnv(yyt->ImpIds.Env2)
 begintLocalIds(yyt->ImpIds.LocalIdsIn)
 begintLocalIds(yyt->ImpIds.LocalIdsOut)
 return yyt;
}

tTree mNoImpId
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoImpId])
 yyt->Kind = kNoImpId;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->NoImpId.Objects1)
 begintObjects(yyt->NoImpId.Objects2)
 begintEnv(yyt->NoImpId.Env1)
 begintEnv(yyt->NoImpId.Env2)
 begintLocalIds(yyt->NoImpId.LocalIdsIn)
 begintLocalIds(yyt->NoImpId.LocalIdsOut)
 return yyt;
}

tTree mImpId
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tIdent pIdent, tPosition pPos)
# else
(pNext, pIdent, pPos)
tTree pNext;
tIdent pIdent;
tPosition pPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kImpId])
 yyt->Kind = kImpId;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->ImpId.Objects1)
 begintObjects(yyt->ImpId.Objects2)
 begintEnv(yyt->ImpId.Env1)
 begintEnv(yyt->ImpId.Env2)
 begintLocalIds(yyt->ImpId.LocalIdsIn)
 begintLocalIds(yyt->ImpId.LocalIdsOut)
 yyt->ImpId.Next = pNext;
 yyt->ImpId.Ident = pIdent;
 yyt->ImpId.Pos = pPos;
 begintType(yyt->ImpId.Type)
 begintObject(yyt->ImpId.Object1)
 begintObject(yyt->ImpId.Object2)
 beginBOOLEAN(yyt->ImpId.IsRedeclared)
 return yyt;
}

tTree mExports
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kExports])
 yyt->Kind = kExports;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mNoExport
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoExport])
 yyt->Kind = kNoExport;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mExport
# if defined __STDC__ | defined __cplusplus
(BOOLEAN pQualified, tTree pExpIds)
# else
(pQualified, pExpIds)
BOOLEAN pQualified;
tTree pExpIds;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kExport])
 yyt->Kind = kExport;
 yyt->yyHead.yyMark = 0;
 yyt->Export.Qualified = pQualified;
 yyt->Export.ExpIds = pExpIds;
 return yyt;
}

tTree mExpIds
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kExpIds])
 yyt->Kind = kExpIds;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mNoExpId
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoExpId])
 yyt->Kind = kNoExpId;
 yyt->yyHead.yyMark = 0;
 return yyt;
}

tTree mExpId
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tIdent pIdent, tPosition pPos)
# else
(pNext, pIdent, pPos)
tTree pNext;
tIdent pIdent;
tPosition pPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kExpId])
 yyt->Kind = kExpId;
 yyt->yyHead.yyMark = 0;
 yyt->ExpId.Next = pNext;
 yyt->ExpId.Ident = pIdent;
 yyt->ExpId.Pos = pPos;
 return yyt;
}

tTree mDecls
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kDecls])
 yyt->Kind = kDecls;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->Decls.Objects1)
 begintVoid(yyt->Decls.Objects2)
 begintObjects(yyt->Decls.Objects3)
 begintObjects(yyt->Decls.Objects4In)
 begintObjects(yyt->Decls.Objects4Out)
 begintEnv(yyt->Decls.Env1)
 begintVoid(yyt->Decls.Env2)
 begintEnv(yyt->Decls.Env3)
 begintEnv(yyt->Decls.Env4)
 beginINDEX(yyt->Decls.ConfigGroupIn)
 beginINDEX(yyt->Decls.ConfigGroupOut)
 begintObjects(yyt->Decls.DefTypes)
 begintObjects(yyt->Decls.DefObjects)
 begintObjects(yyt->Decls.ImplTypes)
 beginINDEX(yyt->Decls.PosIn)
 beginINDEX(yyt->Decls.PosOut)
 beginINDEX(yyt->Decls.Kind)
 begintIdent(yyt->Decls.Module)
 begintIdents(yyt->Decls.IdsIn)
 begintIdents(yyt->Decls.IdsOut)
 begintConnects(yyt->Decls.ConnectsIn)
 begintConnects(yyt->Decls.ConnectsOut)
 begintLocalIds(yyt->Decls.LocalIdsIn)
 begintLocalIds(yyt->Decls.LocalIdsOut)
 beginINDEX(yyt->Decls.CntIn)
 beginINDEX(yyt->Decls.CntOut)
 beginINDEX(yyt->Decls.Level)
 beginBOOLEAN(yyt->Decls.GlobalPtrs)
 return yyt;
}

tTree mNoDecl
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoDecl])
 yyt->Kind = kNoDecl;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->NoDecl.Objects1)
 begintVoid(yyt->NoDecl.Objects2)
 begintObjects(yyt->NoDecl.Objects3)
 begintObjects(yyt->NoDecl.Objects4In)
 begintObjects(yyt->NoDecl.Objects4Out)
 begintEnv(yyt->NoDecl.Env1)
 begintVoid(yyt->NoDecl.Env2)
 begintEnv(yyt->NoDecl.Env3)
 begintEnv(yyt->NoDecl.Env4)
 beginINDEX(yyt->NoDecl.ConfigGroupIn)
 beginINDEX(yyt->NoDecl.ConfigGroupOut)
 begintObjects(yyt->NoDecl.DefTypes)
 begintObjects(yyt->NoDecl.DefObjects)
 begintObjects(yyt->NoDecl.ImplTypes)
 beginINDEX(yyt->NoDecl.PosIn)
 beginINDEX(yyt->NoDecl.PosOut)
 beginINDEX(yyt->NoDecl.Kind)
 begintIdent(yyt->NoDecl.Module)
 begintIdents(yyt->NoDecl.IdsIn)
 begintIdents(yyt->NoDecl.IdsOut)
 begintConnects(yyt->NoDecl.ConnectsIn)
 begintConnects(yyt->NoDecl.ConnectsOut)
 begintLocalIds(yyt->NoDecl.LocalIdsIn)
 begintLocalIds(yyt->NoDecl.LocalIdsOut)
 beginINDEX(yyt->NoDecl.CntIn)
 beginINDEX(yyt->NoDecl.CntOut)
 beginINDEX(yyt->NoDecl.Level)
 beginBOOLEAN(yyt->NoDecl.GlobalPtrs)
 return yyt;
}

tTree mDecl
# if defined __STDC__ | defined __cplusplus
(tTree pNext)
# else
(pNext)
tTree pNext;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kDecl])
 yyt->Kind = kDecl;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->Decl.Objects1)
 begintVoid(yyt->Decl.Objects2)
 begintObjects(yyt->Decl.Objects3)
 begintObjects(yyt->Decl.Objects4In)
 begintObjects(yyt->Decl.Objects4Out)
 begintEnv(yyt->Decl.Env1)
 begintVoid(yyt->Decl.Env2)
 begintEnv(yyt->Decl.Env3)
 begintEnv(yyt->Decl.Env4)
 beginINDEX(yyt->Decl.ConfigGroupIn)
 beginINDEX(yyt->Decl.ConfigGroupOut)
 begintObjects(yyt->Decl.DefTypes)
 begintObjects(yyt->Decl.DefObjects)
 begintObjects(yyt->Decl.ImplTypes)
 beginINDEX(yyt->Decl.PosIn)
 beginINDEX(yyt->Decl.PosOut)
 beginINDEX(yyt->Decl.Kind)
 begintIdent(yyt->Decl.Module)
 begintIdents(yyt->Decl.IdsIn)
 begintIdents(yyt->Decl.IdsOut)
 begintConnects(yyt->Decl.ConnectsIn)
 begintConnects(yyt->Decl.ConnectsOut)
 begintLocalIds(yyt->Decl.LocalIdsIn)
 begintLocalIds(yyt->Decl.LocalIdsOut)
 beginINDEX(yyt->Decl.CntIn)
 beginINDEX(yyt->Decl.CntOut)
 beginINDEX(yyt->Decl.Level)
 beginBOOLEAN(yyt->Decl.GlobalPtrs)
 yyt->Decl.Next = pNext;
 return yyt;
}

tTree mVar
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tTree pVarIds, tTree pType)
# else
(pNext, pVarIds, pType)
tTree pNext;
tTree pVarIds;
tTree pType;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kVar])
 yyt->Kind = kVar;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->Var.Objects1)
 begintVoid(yyt->Var.Objects2)
 begintObjects(yyt->Var.Objects3)
 begintObjects(yyt->Var.Objects4In)
 begintObjects(yyt->Var.Objects4Out)
 begintEnv(yyt->Var.Env1)
 begintVoid(yyt->Var.Env2)
 begintEnv(yyt->Var.Env3)
 begintEnv(yyt->Var.Env4)
 beginINDEX(yyt->Var.ConfigGroupIn)
 beginINDEX(yyt->Var.ConfigGroupOut)
 begintObjects(yyt->Var.DefTypes)
 begintObjects(yyt->Var.DefObjects)
 begintObjects(yyt->Var.ImplTypes)
 beginINDEX(yyt->Var.PosIn)
 beginINDEX(yyt->Var.PosOut)
 beginINDEX(yyt->Var.Kind)
 begintIdent(yyt->Var.Module)
 begintIdents(yyt->Var.IdsIn)
 begintIdents(yyt->Var.IdsOut)
 begintConnects(yyt->Var.ConnectsIn)
 begintConnects(yyt->Var.ConnectsOut)
 begintLocalIds(yyt->Var.LocalIdsIn)
 begintLocalIds(yyt->Var.LocalIdsOut)
 beginINDEX(yyt->Var.CntIn)
 beginINDEX(yyt->Var.CntOut)
 beginINDEX(yyt->Var.Level)
 beginBOOLEAN(yyt->Var.GlobalPtrs)
 yyt->Var.Next = pNext;
 yyt->Var.VarIds = pVarIds;
 yyt->Var.Type = pType;
 beginBOOLEAN(yyt->Var.IsGlobal)
 return yyt;
}

tTree mObject
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tIdent pIdent, tPosition pPos)
# else
(pNext, pIdent, pPos)
tTree pNext;
tIdent pIdent;
tPosition pPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kObject])
 yyt->Kind = kObject;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->Object.Objects1)
 begintVoid(yyt->Object.Objects2)
 begintObjects(yyt->Object.Objects3)
 begintObjects(yyt->Object.Objects4In)
 begintObjects(yyt->Object.Objects4Out)
 begintEnv(yyt->Object.Env1)
 begintVoid(yyt->Object.Env2)
 begintEnv(yyt->Object.Env3)
 begintEnv(yyt->Object.Env4)
 beginINDEX(yyt->Object.ConfigGroupIn)
 beginINDEX(yyt->Object.ConfigGroupOut)
 begintObjects(yyt->Object.DefTypes)
 begintObjects(yyt->Object.DefObjects)
 begintObjects(yyt->Object.ImplTypes)
 beginINDEX(yyt->Object.PosIn)
 beginINDEX(yyt->Object.PosOut)
 beginINDEX(yyt->Object.Kind)
 begintIdent(yyt->Object.Module)
 begintIdents(yyt->Object.IdsIn)
 begintIdents(yyt->Object.IdsOut)
 begintConnects(yyt->Object.ConnectsIn)
 begintConnects(yyt->Object.ConnectsOut)
 begintLocalIds(yyt->Object.LocalIdsIn)
 begintLocalIds(yyt->Object.LocalIdsOut)
 beginINDEX(yyt->Object.CntIn)
 beginINDEX(yyt->Object.CntOut)
 beginINDEX(yyt->Object.Level)
 beginBOOLEAN(yyt->Object.GlobalPtrs)
 yyt->Object.Next = pNext;
 yyt->Object.Ident = pIdent;
 yyt->Object.Pos = pPos;
 begintIdent(yyt->Object.CIdent)
 beginBOOLEAN(yyt->Object.IsRedeclared)
 return yyt;
}

tTree mConnectFrom
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tIdent pIdent, tPosition pPos, tTree pFrom, tTree pTo, tTree pConnectDecls)
# else
(pNext, pIdent, pPos, pFrom, pTo, pConnectDecls)
tTree pNext;
tIdent pIdent;
tPosition pPos;
tTree pFrom;
tTree pTo;
tTree pConnectDecls;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kConnectFrom])
 yyt->Kind = kConnectFrom;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->ConnectFrom.Objects1)
 begintVoid(yyt->ConnectFrom.Objects2)
 begintObjects(yyt->ConnectFrom.Objects3)
 begintObjects(yyt->ConnectFrom.Objects4In)
 begintObjects(yyt->ConnectFrom.Objects4Out)
 begintEnv(yyt->ConnectFrom.Env1)
 begintVoid(yyt->ConnectFrom.Env2)
 begintEnv(yyt->ConnectFrom.Env3)
 begintEnv(yyt->ConnectFrom.Env4)
 beginINDEX(yyt->ConnectFrom.ConfigGroupIn)
 beginINDEX(yyt->ConnectFrom.ConfigGroupOut)
 begintObjects(yyt->ConnectFrom.DefTypes)
 begintObjects(yyt->ConnectFrom.DefObjects)
 begintObjects(yyt->ConnectFrom.ImplTypes)
 beginINDEX(yyt->ConnectFrom.PosIn)
 beginINDEX(yyt->ConnectFrom.PosOut)
 beginINDEX(yyt->ConnectFrom.Kind)
 begintIdent(yyt->ConnectFrom.Module)
 begintIdents(yyt->ConnectFrom.IdsIn)
 begintIdents(yyt->ConnectFrom.IdsOut)
 begintConnects(yyt->ConnectFrom.ConnectsIn)
 begintConnects(yyt->ConnectFrom.ConnectsOut)
 begintLocalIds(yyt->ConnectFrom.LocalIdsIn)
 begintLocalIds(yyt->ConnectFrom.LocalIdsOut)
 beginINDEX(yyt->ConnectFrom.CntIn)
 beginINDEX(yyt->ConnectFrom.CntOut)
 beginINDEX(yyt->ConnectFrom.Level)
 beginBOOLEAN(yyt->ConnectFrom.GlobalPtrs)
 yyt->ConnectFrom.Next = pNext;
 yyt->ConnectFrom.Ident = pIdent;
 yyt->ConnectFrom.Pos = pPos;
 begintIdent(yyt->ConnectFrom.CIdent)
 beginBOOLEAN(yyt->ConnectFrom.IsRedeclared)
 yyt->ConnectFrom.From = pFrom;
 yyt->ConnectFrom.To = pTo;
 yyt->ConnectFrom.ConnectDecls = pConnectDecls;
 begintObject(yyt->ConnectFrom.Object)
 return yyt;
}

tTree mConnectDecls
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tIdent pIdent, tPosition pPos, tTree pIndex, BOOLEAN pBiDirectional, tTree pConfig, tTree pActuals, tTree pDirIn)
# else
(pNext, pIdent, pPos, pIndex, pBiDirectional, pConfig, pActuals, pDirIn)
tTree pNext;
tIdent pIdent;
tPosition pPos;
tTree pIndex;
BOOLEAN pBiDirectional;
tTree pConfig;
tTree pActuals;
tTree pDirIn;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kConnectDecls])
 yyt->Kind = kConnectDecls;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->ConnectDecls.Objects1)
 begintVoid(yyt->ConnectDecls.Objects2)
 begintObjects(yyt->ConnectDecls.Objects3)
 begintObjects(yyt->ConnectDecls.Objects4In)
 begintObjects(yyt->ConnectDecls.Objects4Out)
 begintEnv(yyt->ConnectDecls.Env1)
 begintVoid(yyt->ConnectDecls.Env2)
 begintEnv(yyt->ConnectDecls.Env3)
 begintEnv(yyt->ConnectDecls.Env4)
 beginINDEX(yyt->ConnectDecls.ConfigGroupIn)
 beginINDEX(yyt->ConnectDecls.ConfigGroupOut)
 begintObjects(yyt->ConnectDecls.DefTypes)
 begintObjects(yyt->ConnectDecls.DefObjects)
 begintObjects(yyt->ConnectDecls.ImplTypes)
 beginINDEX(yyt->ConnectDecls.PosIn)
 beginINDEX(yyt->ConnectDecls.PosOut)
 beginINDEX(yyt->ConnectDecls.Kind)
 begintIdent(yyt->ConnectDecls.Module)
 begintIdents(yyt->ConnectDecls.IdsIn)
 begintIdents(yyt->ConnectDecls.IdsOut)
 begintConnects(yyt->ConnectDecls.ConnectsIn)
 begintConnects(yyt->ConnectDecls.ConnectsOut)
 begintLocalIds(yyt->ConnectDecls.LocalIdsIn)
 begintLocalIds(yyt->ConnectDecls.LocalIdsOut)
 beginINDEX(yyt->ConnectDecls.CntIn)
 beginINDEX(yyt->ConnectDecls.CntOut)
 beginINDEX(yyt->ConnectDecls.Level)
 beginBOOLEAN(yyt->ConnectDecls.GlobalPtrs)
 yyt->ConnectDecls.Next = pNext;
 yyt->ConnectDecls.Ident = pIdent;
 yyt->ConnectDecls.Pos = pPos;
 begintIdent(yyt->ConnectDecls.CIdent)
 beginBOOLEAN(yyt->ConnectDecls.IsRedeclared)
 yyt->ConnectDecls.Index = pIndex;
 yyt->ConnectDecls.BiDirectional = pBiDirectional;
 yyt->ConnectDecls.Config = pConfig;
 yyt->ConnectDecls.Actuals = pActuals;
 yyt->ConnectDecls.DirIn = pDirIn;
 begintObject(yyt->ConnectDecls.Object)
 begintObjects(yyt->ConnectDecls.IndexObjects)
 begintObject(yyt->ConnectDecls.LeftConfigObj)
 begintObject(yyt->ConnectDecls.RightConfigObj)
 begintValue(yyt->ConnectDecls.IndexVal)
 beginBOOLEAN(yyt->ConnectDecls.FirstDeclaration)
 begintIdent(yyt->ConnectDecls.PrevCIdent)
 return yyt;
}

tTree mConfig
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tIdent pIdent, tPosition pPos, tTree pActuals, BOOLEAN pRespecified, tTree pQualid)
# else
(pNext, pIdent, pPos, pActuals, pRespecified, pQualid)
tTree pNext;
tIdent pIdent;
tPosition pPos;
tTree pActuals;
BOOLEAN pRespecified;
tTree pQualid;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kConfig])
 yyt->Kind = kConfig;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->Config.Objects1)
 begintVoid(yyt->Config.Objects2)
 begintObjects(yyt->Config.Objects3)
 begintObjects(yyt->Config.Objects4In)
 begintObjects(yyt->Config.Objects4Out)
 begintEnv(yyt->Config.Env1)
 begintVoid(yyt->Config.Env2)
 begintEnv(yyt->Config.Env3)
 begintEnv(yyt->Config.Env4)
 beginINDEX(yyt->Config.ConfigGroupIn)
 beginINDEX(yyt->Config.ConfigGroupOut)
 begintObjects(yyt->Config.DefTypes)
 begintObjects(yyt->Config.DefObjects)
 begintObjects(yyt->Config.ImplTypes)
 beginINDEX(yyt->Config.PosIn)
 beginINDEX(yyt->Config.PosOut)
 beginINDEX(yyt->Config.Kind)
 begintIdent(yyt->Config.Module)
 begintIdents(yyt->Config.IdsIn)
 begintIdents(yyt->Config.IdsOut)
 begintConnects(yyt->Config.ConnectsIn)
 begintConnects(yyt->Config.ConnectsOut)
 begintLocalIds(yyt->Config.LocalIdsIn)
 begintLocalIds(yyt->Config.LocalIdsOut)
 beginINDEX(yyt->Config.CntIn)
 beginINDEX(yyt->Config.CntOut)
 beginINDEX(yyt->Config.Level)
 beginBOOLEAN(yyt->Config.GlobalPtrs)
 yyt->Config.Next = pNext;
 yyt->Config.Ident = pIdent;
 yyt->Config.Pos = pPos;
 begintIdent(yyt->Config.CIdent)
 beginBOOLEAN(yyt->Config.IsRedeclared)
 yyt->Config.Actuals = pActuals;
 yyt->Config.Respecified = pRespecified;
 yyt->Config.Qualid = pQualid;
 begintObject(yyt->Config.Object)
 begintType(yyt->Config.Type)
 beginINDEX(yyt->Config.NewConfigGroup)
 begintObject(yyt->Config.View)
 beginBOOLEAN(yyt->Config.HasVariableSize)
 return yyt;
}

tTree mConst
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tIdent pIdent, tPosition pPos, tTree pExpr)
# else
(pNext, pIdent, pPos, pExpr)
tTree pNext;
tIdent pIdent;
tPosition pPos;
tTree pExpr;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kConst])
 yyt->Kind = kConst;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->Const.Objects1)
 begintVoid(yyt->Const.Objects2)
 begintObjects(yyt->Const.Objects3)
 begintObjects(yyt->Const.Objects4In)
 begintObjects(yyt->Const.Objects4Out)
 begintEnv(yyt->Const.Env1)
 begintVoid(yyt->Const.Env2)
 begintEnv(yyt->Const.Env3)
 begintEnv(yyt->Const.Env4)
 beginINDEX(yyt->Const.ConfigGroupIn)
 beginINDEX(yyt->Const.ConfigGroupOut)
 begintObjects(yyt->Const.DefTypes)
 begintObjects(yyt->Const.DefObjects)
 begintObjects(yyt->Const.ImplTypes)
 beginINDEX(yyt->Const.PosIn)
 beginINDEX(yyt->Const.PosOut)
 beginINDEX(yyt->Const.Kind)
 begintIdent(yyt->Const.Module)
 begintIdents(yyt->Const.IdsIn)
 begintIdents(yyt->Const.IdsOut)
 begintConnects(yyt->Const.ConnectsIn)
 begintConnects(yyt->Const.ConnectsOut)
 begintLocalIds(yyt->Const.LocalIdsIn)
 begintLocalIds(yyt->Const.LocalIdsOut)
 beginINDEX(yyt->Const.CntIn)
 beginINDEX(yyt->Const.CntOut)
 beginINDEX(yyt->Const.Level)
 beginBOOLEAN(yyt->Const.GlobalPtrs)
 yyt->Const.Next = pNext;
 yyt->Const.Ident = pIdent;
 yyt->Const.Pos = pPos;
 begintIdent(yyt->Const.CIdent)
 beginBOOLEAN(yyt->Const.IsRedeclared)
 yyt->Const.Expr = pExpr;
 begintObject(yyt->Const.Object)
 return yyt;
}

tTree mTypeDecl
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tIdent pIdent, tPosition pPos, tTree pType)
# else
(pNext, pIdent, pPos, pType)
tTree pNext;
tIdent pIdent;
tPosition pPos;
tTree pType;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kTypeDecl])
 yyt->Kind = kTypeDecl;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->TypeDecl.Objects1)
 begintVoid(yyt->TypeDecl.Objects2)
 begintObjects(yyt->TypeDecl.Objects3)
 begintObjects(yyt->TypeDecl.Objects4In)
 begintObjects(yyt->TypeDecl.Objects4Out)
 begintEnv(yyt->TypeDecl.Env1)
 begintVoid(yyt->TypeDecl.Env2)
 begintEnv(yyt->TypeDecl.Env3)
 begintEnv(yyt->TypeDecl.Env4)
 beginINDEX(yyt->TypeDecl.ConfigGroupIn)
 beginINDEX(yyt->TypeDecl.ConfigGroupOut)
 begintObjects(yyt->TypeDecl.DefTypes)
 begintObjects(yyt->TypeDecl.DefObjects)
 begintObjects(yyt->TypeDecl.ImplTypes)
 beginINDEX(yyt->TypeDecl.PosIn)
 beginINDEX(yyt->TypeDecl.PosOut)
 beginINDEX(yyt->TypeDecl.Kind)
 begintIdent(yyt->TypeDecl.Module)
 begintIdents(yyt->TypeDecl.IdsIn)
 begintIdents(yyt->TypeDecl.IdsOut)
 begintConnects(yyt->TypeDecl.ConnectsIn)
 begintConnects(yyt->TypeDecl.ConnectsOut)
 begintLocalIds(yyt->TypeDecl.LocalIdsIn)
 begintLocalIds(yyt->TypeDecl.LocalIdsOut)
 beginINDEX(yyt->TypeDecl.CntIn)
 beginINDEX(yyt->TypeDecl.CntOut)
 beginINDEX(yyt->TypeDecl.Level)
 beginBOOLEAN(yyt->TypeDecl.GlobalPtrs)
 yyt->TypeDecl.Next = pNext;
 yyt->TypeDecl.Ident = pIdent;
 yyt->TypeDecl.Pos = pPos;
 begintIdent(yyt->TypeDecl.CIdent)
 beginBOOLEAN(yyt->TypeDecl.IsRedeclared)
 yyt->TypeDecl.Type = pType;
 begintObject(yyt->TypeDecl.Object)
 begintType(yyt->TypeDecl.Type1)
 begintType(yyt->TypeDecl.Type2)
 return yyt;
}

tTree mProc
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tIdent pIdent, tPosition pPos, tTree pFormals, tTree pResultType, tTree pDecls, tTree pStmts, tPosition pBeginPos)
# else
(pNext, pIdent, pPos, pFormals, pResultType, pDecls, pStmts, pBeginPos)
tTree pNext;
tIdent pIdent;
tPosition pPos;
tTree pFormals;
tTree pResultType;
tTree pDecls;
tTree pStmts;
tPosition pBeginPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kProc])
 yyt->Kind = kProc;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->Proc.Objects1)
 begintVoid(yyt->Proc.Objects2)
 begintObjects(yyt->Proc.Objects3)
 begintObjects(yyt->Proc.Objects4In)
 begintObjects(yyt->Proc.Objects4Out)
 begintEnv(yyt->Proc.Env1)
 begintVoid(yyt->Proc.Env2)
 begintEnv(yyt->Proc.Env3)
 begintEnv(yyt->Proc.Env4)
 beginINDEX(yyt->Proc.ConfigGroupIn)
 beginINDEX(yyt->Proc.ConfigGroupOut)
 begintObjects(yyt->Proc.DefTypes)
 begintObjects(yyt->Proc.DefObjects)
 begintObjects(yyt->Proc.ImplTypes)
 beginINDEX(yyt->Proc.PosIn)
 beginINDEX(yyt->Proc.PosOut)
 beginINDEX(yyt->Proc.Kind)
 begintIdent(yyt->Proc.Module)
 begintIdents(yyt->Proc.IdsIn)
 begintIdents(yyt->Proc.IdsOut)
 begintConnects(yyt->Proc.ConnectsIn)
 begintConnects(yyt->Proc.ConnectsOut)
 begintLocalIds(yyt->Proc.LocalIdsIn)
 begintLocalIds(yyt->Proc.LocalIdsOut)
 beginINDEX(yyt->Proc.CntIn)
 beginINDEX(yyt->Proc.CntOut)
 beginINDEX(yyt->Proc.Level)
 beginBOOLEAN(yyt->Proc.GlobalPtrs)
 yyt->Proc.Next = pNext;
 yyt->Proc.Ident = pIdent;
 yyt->Proc.Pos = pPos;
 begintIdent(yyt->Proc.CIdent)
 beginBOOLEAN(yyt->Proc.IsRedeclared)
 yyt->Proc.Formals = pFormals;
 yyt->Proc.ResultType = pResultType;
 yyt->Proc.Decls = pDecls;
 yyt->Proc.Stmts = pStmts;
 yyt->Proc.BeginPos = pBeginPos;
 begintObject(yyt->Proc.Object)
 begintType(yyt->Proc.Type)
 beginBOOLEAN(yyt->Proc.HasOpenVector)
 begintCObjects(yyt->Proc.ValueOpens)
 begintCObjects(yyt->Proc.VAROpens)
 begintCObjects(yyt->Proc.LocalPtrs)
 begintStrings(yyt->Proc.Strings)
 return yyt;
}

tTree mProcHead
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tIdent pIdent, tPosition pPos, tTree pFormals, tTree pResultType)
# else
(pNext, pIdent, pPos, pFormals, pResultType)
tTree pNext;
tIdent pIdent;
tPosition pPos;
tTree pFormals;
tTree pResultType;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kProcHead])
 yyt->Kind = kProcHead;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->ProcHead.Objects1)
 begintVoid(yyt->ProcHead.Objects2)
 begintObjects(yyt->ProcHead.Objects3)
 begintObjects(yyt->ProcHead.Objects4In)
 begintObjects(yyt->ProcHead.Objects4Out)
 begintEnv(yyt->ProcHead.Env1)
 begintVoid(yyt->ProcHead.Env2)
 begintEnv(yyt->ProcHead.Env3)
 begintEnv(yyt->ProcHead.Env4)
 beginINDEX(yyt->ProcHead.ConfigGroupIn)
 beginINDEX(yyt->ProcHead.ConfigGroupOut)
 begintObjects(yyt->ProcHead.DefTypes)
 begintObjects(yyt->ProcHead.DefObjects)
 begintObjects(yyt->ProcHead.ImplTypes)
 beginINDEX(yyt->ProcHead.PosIn)
 beginINDEX(yyt->ProcHead.PosOut)
 beginINDEX(yyt->ProcHead.Kind)
 begintIdent(yyt->ProcHead.Module)
 begintIdents(yyt->ProcHead.IdsIn)
 begintIdents(yyt->ProcHead.IdsOut)
 begintConnects(yyt->ProcHead.ConnectsIn)
 begintConnects(yyt->ProcHead.ConnectsOut)
 begintLocalIds(yyt->ProcHead.LocalIdsIn)
 begintLocalIds(yyt->ProcHead.LocalIdsOut)
 beginINDEX(yyt->ProcHead.CntIn)
 beginINDEX(yyt->ProcHead.CntOut)
 beginINDEX(yyt->ProcHead.Level)
 beginBOOLEAN(yyt->ProcHead.GlobalPtrs)
 yyt->ProcHead.Next = pNext;
 yyt->ProcHead.Ident = pIdent;
 yyt->ProcHead.Pos = pPos;
 begintIdent(yyt->ProcHead.CIdent)
 beginBOOLEAN(yyt->ProcHead.IsRedeclared)
 yyt->ProcHead.Formals = pFormals;
 yyt->ProcHead.ResultType = pResultType;
 begintObject(yyt->ProcHead.Object)
 begintType(yyt->ProcHead.Type)
 beginBOOLEAN(yyt->ProcHead.HasOpenVector)
 return yyt;
}

tTree mOpaque
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tIdent pIdent, tPosition pPos)
# else
(pNext, pIdent, pPos)
tTree pNext;
tIdent pIdent;
tPosition pPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kOpaque])
 yyt->Kind = kOpaque;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->Opaque.Objects1)
 begintVoid(yyt->Opaque.Objects2)
 begintObjects(yyt->Opaque.Objects3)
 begintObjects(yyt->Opaque.Objects4In)
 begintObjects(yyt->Opaque.Objects4Out)
 begintEnv(yyt->Opaque.Env1)
 begintVoid(yyt->Opaque.Env2)
 begintEnv(yyt->Opaque.Env3)
 begintEnv(yyt->Opaque.Env4)
 beginINDEX(yyt->Opaque.ConfigGroupIn)
 beginINDEX(yyt->Opaque.ConfigGroupOut)
 begintObjects(yyt->Opaque.DefTypes)
 begintObjects(yyt->Opaque.DefObjects)
 begintObjects(yyt->Opaque.ImplTypes)
 beginINDEX(yyt->Opaque.PosIn)
 beginINDEX(yyt->Opaque.PosOut)
 beginINDEX(yyt->Opaque.Kind)
 begintIdent(yyt->Opaque.Module)
 begintIdents(yyt->Opaque.IdsIn)
 begintIdents(yyt->Opaque.IdsOut)
 begintConnects(yyt->Opaque.ConnectsIn)
 begintConnects(yyt->Opaque.ConnectsOut)
 begintLocalIds(yyt->Opaque.LocalIdsIn)
 begintLocalIds(yyt->Opaque.LocalIdsOut)
 beginINDEX(yyt->Opaque.CntIn)
 beginINDEX(yyt->Opaque.CntOut)
 beginINDEX(yyt->Opaque.Level)
 beginBOOLEAN(yyt->Opaque.GlobalPtrs)
 yyt->Opaque.Next = pNext;
 yyt->Opaque.Ident = pIdent;
 yyt->Opaque.Pos = pPos;
 begintIdent(yyt->Opaque.CIdent)
 beginBOOLEAN(yyt->Opaque.IsRedeclared)
 begintObject(yyt->Opaque.Object)
 begintType(yyt->Opaque.Type1)
 begintType(yyt->Opaque.FullType)
 begintType(yyt->Opaque.Type2)
 return yyt;
}

tTree mConnectDests
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kConnectDests])
 yyt->Kind = kConnectDests;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->ConnectDests.Objects1)
 begintVoid(yyt->ConnectDests.Objects2)
 begintObjects(yyt->ConnectDests.Objects3)
 begintObjects(yyt->ConnectDests.Objects4In)
 begintObjects(yyt->ConnectDests.Objects4Out)
 begintObject(yyt->ConnectDests.LeftConfigObj)
 begintObject(yyt->ConnectDests.RightConfigObj)
 begintEnv(yyt->ConnectDests.Env1)
 begintVoid(yyt->ConnectDests.Env2)
 begintEnv(yyt->ConnectDests.Env3)
 begintEnv(yyt->ConnectDests.Env4)
 beginINDEX(yyt->ConnectDests.Kind)
 begintIdent(yyt->ConnectDests.Module)
 begintIdents(yyt->ConnectDests.IdsIn)
 begintIdents(yyt->ConnectDests.IdsOut)
 begintConnects(yyt->ConnectDests.ConnectsIn)
 begintConnects(yyt->ConnectDests.ConnectsOut)
 begintLocalIds(yyt->ConnectDests.LocalIdsIn)
 begintLocalIds(yyt->ConnectDests.LocalIdsOut)
 beginINDEX(yyt->ConnectDests.Level)
 return yyt;
}

tTree mNoConnectDest
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoConnectDest])
 yyt->Kind = kNoConnectDest;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->NoConnectDest.Objects1)
 begintVoid(yyt->NoConnectDest.Objects2)
 begintObjects(yyt->NoConnectDest.Objects3)
 begintObjects(yyt->NoConnectDest.Objects4In)
 begintObjects(yyt->NoConnectDest.Objects4Out)
 begintObject(yyt->NoConnectDest.LeftConfigObj)
 begintObject(yyt->NoConnectDest.RightConfigObj)
 begintEnv(yyt->NoConnectDest.Env1)
 begintVoid(yyt->NoConnectDest.Env2)
 begintEnv(yyt->NoConnectDest.Env3)
 begintEnv(yyt->NoConnectDest.Env4)
 beginINDEX(yyt->NoConnectDest.Kind)
 begintIdent(yyt->NoConnectDest.Module)
 begintIdents(yyt->NoConnectDest.IdsIn)
 begintIdents(yyt->NoConnectDest.IdsOut)
 begintConnects(yyt->NoConnectDest.ConnectsIn)
 begintConnects(yyt->NoConnectDest.ConnectsOut)
 begintLocalIds(yyt->NoConnectDest.LocalIdsIn)
 begintLocalIds(yyt->NoConnectDest.LocalIdsOut)
 beginINDEX(yyt->NoConnectDest.Level)
 return yyt;
}

tTree mConnectDest
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tTree pExpr, tTree pConfig, tTree pActuals)
# else
(pNext, pExpr, pConfig, pActuals)
tTree pNext;
tTree pExpr;
tTree pConfig;
tTree pActuals;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kConnectDest])
 yyt->Kind = kConnectDest;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->ConnectDest.Objects1)
 begintVoid(yyt->ConnectDest.Objects2)
 begintObjects(yyt->ConnectDest.Objects3)
 begintObjects(yyt->ConnectDest.Objects4In)
 begintObjects(yyt->ConnectDest.Objects4Out)
 begintObject(yyt->ConnectDest.LeftConfigObj)
 begintObject(yyt->ConnectDest.RightConfigObj)
 begintEnv(yyt->ConnectDest.Env1)
 begintVoid(yyt->ConnectDest.Env2)
 begintEnv(yyt->ConnectDest.Env3)
 begintEnv(yyt->ConnectDest.Env4)
 beginINDEX(yyt->ConnectDest.Kind)
 begintIdent(yyt->ConnectDest.Module)
 begintIdents(yyt->ConnectDest.IdsIn)
 begintIdents(yyt->ConnectDest.IdsOut)
 begintConnects(yyt->ConnectDest.ConnectsIn)
 begintConnects(yyt->ConnectDest.ConnectsOut)
 begintLocalIds(yyt->ConnectDest.LocalIdsIn)
 begintLocalIds(yyt->ConnectDest.LocalIdsOut)
 beginINDEX(yyt->ConnectDest.Level)
 yyt->ConnectDest.Next = pNext;
 yyt->ConnectDest.Expr = pExpr;
 yyt->ConnectDest.Config = pConfig;
 yyt->ConnectDest.Actuals = pActuals;
 begintIdent(yyt->ConnectDest.DestDimId)
 begintIdent(yyt->ConnectDest.DestIdsId)
 return yyt;
}

tTree mConnectDestUni
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tTree pExpr, tTree pConfig, tTree pActuals)
# else
(pNext, pExpr, pConfig, pActuals)
tTree pNext;
tTree pExpr;
tTree pConfig;
tTree pActuals;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kConnectDestUni])
 yyt->Kind = kConnectDestUni;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->ConnectDestUni.Objects1)
 begintVoid(yyt->ConnectDestUni.Objects2)
 begintObjects(yyt->ConnectDestUni.Objects3)
 begintObjects(yyt->ConnectDestUni.Objects4In)
 begintObjects(yyt->ConnectDestUni.Objects4Out)
 begintObject(yyt->ConnectDestUni.LeftConfigObj)
 begintObject(yyt->ConnectDestUni.RightConfigObj)
 begintEnv(yyt->ConnectDestUni.Env1)
 begintVoid(yyt->ConnectDestUni.Env2)
 begintEnv(yyt->ConnectDestUni.Env3)
 begintEnv(yyt->ConnectDestUni.Env4)
 beginINDEX(yyt->ConnectDestUni.Kind)
 begintIdent(yyt->ConnectDestUni.Module)
 begintIdents(yyt->ConnectDestUni.IdsIn)
 begintIdents(yyt->ConnectDestUni.IdsOut)
 begintConnects(yyt->ConnectDestUni.ConnectsIn)
 begintConnects(yyt->ConnectDestUni.ConnectsOut)
 begintLocalIds(yyt->ConnectDestUni.LocalIdsIn)
 begintLocalIds(yyt->ConnectDestUni.LocalIdsOut)
 beginINDEX(yyt->ConnectDestUni.Level)
 yyt->ConnectDestUni.Next = pNext;
 yyt->ConnectDestUni.Expr = pExpr;
 yyt->ConnectDestUni.Config = pConfig;
 yyt->ConnectDestUni.Actuals = pActuals;
 begintIdent(yyt->ConnectDestUni.DestDimId)
 begintIdent(yyt->ConnectDestUni.DestIdsId)
 return yyt;
}

tTree mConnectDestBi
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tTree pExpr, tTree pConfig, tTree pActuals, tIdent pIdent, tPosition pPos, tTree pIndex)
# else
(pNext, pExpr, pConfig, pActuals, pIdent, pPos, pIndex)
tTree pNext;
tTree pExpr;
tTree pConfig;
tTree pActuals;
tIdent pIdent;
tPosition pPos;
tTree pIndex;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kConnectDestBi])
 yyt->Kind = kConnectDestBi;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->ConnectDestBi.Objects1)
 begintVoid(yyt->ConnectDestBi.Objects2)
 begintObjects(yyt->ConnectDestBi.Objects3)
 begintObjects(yyt->ConnectDestBi.Objects4In)
 begintObjects(yyt->ConnectDestBi.Objects4Out)
 begintObject(yyt->ConnectDestBi.LeftConfigObj)
 begintObject(yyt->ConnectDestBi.RightConfigObj)
 begintEnv(yyt->ConnectDestBi.Env1)
 begintVoid(yyt->ConnectDestBi.Env2)
 begintEnv(yyt->ConnectDestBi.Env3)
 begintEnv(yyt->ConnectDestBi.Env4)
 beginINDEX(yyt->ConnectDestBi.Kind)
 begintIdent(yyt->ConnectDestBi.Module)
 begintIdents(yyt->ConnectDestBi.IdsIn)
 begintIdents(yyt->ConnectDestBi.IdsOut)
 begintConnects(yyt->ConnectDestBi.ConnectsIn)
 begintConnects(yyt->ConnectDestBi.ConnectsOut)
 begintLocalIds(yyt->ConnectDestBi.LocalIdsIn)
 begintLocalIds(yyt->ConnectDestBi.LocalIdsOut)
 beginINDEX(yyt->ConnectDestBi.Level)
 yyt->ConnectDestBi.Next = pNext;
 yyt->ConnectDestBi.Expr = pExpr;
 yyt->ConnectDestBi.Config = pConfig;
 yyt->ConnectDestBi.Actuals = pActuals;
 begintIdent(yyt->ConnectDestBi.DestDimId)
 begintIdent(yyt->ConnectDestBi.DestIdsId)
 yyt->ConnectDestBi.Ident = pIdent;
 yyt->ConnectDestBi.Pos = pPos;
 yyt->ConnectDestBi.Index = pIndex;
 begintObject(yyt->ConnectDestBi.Object)
 begintValue(yyt->ConnectDestBi.IndexVal)
 begintIdent(yyt->ConnectDestBi.CIdent)
 beginBOOLEAN(yyt->ConnectDestBi.FirstDeclaration)
 begintIdent(yyt->ConnectDestBi.PrevCIdent)
 begintIdent(yyt->ConnectDestBi.BiDirIdsId)
 begintIdent(yyt->ConnectDestBi.IsinBiDirConnId)
 return yyt;
}

tTree mVarIds
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kVarIds])
 yyt->Kind = kVarIds;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->VarIds.Objects3)
 begintType(yyt->VarIds.Type)
 beginADDRESS(yyt->VarIds.TypeTree)
 beginINDEX(yyt->VarIds.Kind)
 begintIdent(yyt->VarIds.Module)
 begintIdents(yyt->VarIds.IdsIn)
 begintIdents(yyt->VarIds.IdsOut)
 begintLocalIds(yyt->VarIds.LocalIdsIn)
 begintLocalIds(yyt->VarIds.LocalIdsOut)
 beginINDEX(yyt->VarIds.Level)
 return yyt;
}

tTree mNoVarId
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoVarId])
 yyt->Kind = kNoVarId;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->NoVarId.Objects3)
 begintType(yyt->NoVarId.Type)
 beginADDRESS(yyt->NoVarId.TypeTree)
 beginINDEX(yyt->NoVarId.Kind)
 begintIdent(yyt->NoVarId.Module)
 begintIdents(yyt->NoVarId.IdsIn)
 begintIdents(yyt->NoVarId.IdsOut)
 begintLocalIds(yyt->NoVarId.LocalIdsIn)
 begintLocalIds(yyt->NoVarId.LocalIdsOut)
 beginINDEX(yyt->NoVarId.Level)
 return yyt;
}

tTree mVarId
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tIdent pIdent, tPosition pPos)
# else
(pNext, pIdent, pPos)
tTree pNext;
tIdent pIdent;
tPosition pPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kVarId])
 yyt->Kind = kVarId;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->VarId.Objects3)
 begintType(yyt->VarId.Type)
 beginADDRESS(yyt->VarId.TypeTree)
 beginINDEX(yyt->VarId.Kind)
 begintIdent(yyt->VarId.Module)
 begintIdents(yyt->VarId.IdsIn)
 begintIdents(yyt->VarId.IdsOut)
 begintLocalIds(yyt->VarId.LocalIdsIn)
 begintLocalIds(yyt->VarId.LocalIdsOut)
 beginINDEX(yyt->VarId.Level)
 yyt->VarId.Next = pNext;
 yyt->VarId.Ident = pIdent;
 yyt->VarId.Pos = pPos;
 begintObject(yyt->VarId.Object)
 begintIdent(yyt->VarId.CIdent)
 beginBOOLEAN(yyt->VarId.IsRedeclared)
 return yyt;
}

tTree mFormals
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kFormals])
 yyt->Kind = kFormals;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->Formals.Objects3)
 begintTypes(yyt->Formals.Types)
 begintEnv(yyt->Formals.Env1)
 begintVoid(yyt->Formals.Env2)
 begintEnv(yyt->Formals.Env3)
 beginBOOLEAN(yyt->Formals.HasOpenVector)
 beginINDEX(yyt->Formals.PosIn)
 beginINDEX(yyt->Formals.PosOut)
 beginINDEX(yyt->Formals.Kind)
 begintIdent(yyt->Formals.Module)
 begintIdents(yyt->Formals.IdsIn)
 begintIdents(yyt->Formals.IdsOut)
 begintLocalIds(yyt->Formals.LocalIdsIn)
 begintLocalIds(yyt->Formals.LocalIdsOut)
 beginINDEX(yyt->Formals.Level)
 return yyt;
}

tTree mNoFormal
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoFormal])
 yyt->Kind = kNoFormal;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->NoFormal.Objects3)
 begintTypes(yyt->NoFormal.Types)
 begintEnv(yyt->NoFormal.Env1)
 begintVoid(yyt->NoFormal.Env2)
 begintEnv(yyt->NoFormal.Env3)
 beginBOOLEAN(yyt->NoFormal.HasOpenVector)
 beginINDEX(yyt->NoFormal.PosIn)
 beginINDEX(yyt->NoFormal.PosOut)
 beginINDEX(yyt->NoFormal.Kind)
 begintIdent(yyt->NoFormal.Module)
 begintIdents(yyt->NoFormal.IdsIn)
 begintIdents(yyt->NoFormal.IdsOut)
 begintLocalIds(yyt->NoFormal.LocalIdsIn)
 begintLocalIds(yyt->NoFormal.LocalIdsOut)
 beginINDEX(yyt->NoFormal.Level)
 return yyt;
}

tTree mFormal
# if defined __STDC__ | defined __cplusplus
(tTree pNext, BOOLEAN pIsVAR, tTree pParIds, tTree pType)
# else
(pNext, pIsVAR, pParIds, pType)
tTree pNext;
BOOLEAN pIsVAR;
tTree pParIds;
tTree pType;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kFormal])
 yyt->Kind = kFormal;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->Formal.Objects3)
 begintTypes(yyt->Formal.Types)
 begintEnv(yyt->Formal.Env1)
 begintVoid(yyt->Formal.Env2)
 begintEnv(yyt->Formal.Env3)
 beginBOOLEAN(yyt->Formal.HasOpenVector)
 beginINDEX(yyt->Formal.PosIn)
 beginINDEX(yyt->Formal.PosOut)
 beginINDEX(yyt->Formal.Kind)
 begintIdent(yyt->Formal.Module)
 begintIdents(yyt->Formal.IdsIn)
 begintIdents(yyt->Formal.IdsOut)
 begintLocalIds(yyt->Formal.LocalIdsIn)
 begintLocalIds(yyt->Formal.LocalIdsOut)
 beginINDEX(yyt->Formal.Level)
 yyt->Formal.Next = pNext;
 yyt->Formal.IsVAR = pIsVAR;
 yyt->Formal.ParIds = pParIds;
 yyt->Formal.Type = pType;
 return yyt;
}

tTree mParIds
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kParIds])
 yyt->Kind = kParIds;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->ParIds.Objects3)
 begintType(yyt->ParIds.Type)
 beginADDRESS(yyt->ParIds.TypeTree)
 beginBOOLEAN(yyt->ParIds.IsVAR)
 begintType(yyt->ParIds.TypesIn)
 begintTypes(yyt->ParIds.TypesOut)
 begintIdents(yyt->ParIds.IdsIn)
 begintIdents(yyt->ParIds.IdsOut)
 begintLocalIds(yyt->ParIds.LocalIdsIn)
 begintLocalIds(yyt->ParIds.LocalIdsOut)
 beginINDEX(yyt->ParIds.Level)
 return yyt;
}

tTree mNoParId
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoParId])
 yyt->Kind = kNoParId;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->NoParId.Objects3)
 begintType(yyt->NoParId.Type)
 beginADDRESS(yyt->NoParId.TypeTree)
 beginBOOLEAN(yyt->NoParId.IsVAR)
 begintType(yyt->NoParId.TypesIn)
 begintTypes(yyt->NoParId.TypesOut)
 begintIdents(yyt->NoParId.IdsIn)
 begintIdents(yyt->NoParId.IdsOut)
 begintLocalIds(yyt->NoParId.LocalIdsIn)
 begintLocalIds(yyt->NoParId.LocalIdsOut)
 beginINDEX(yyt->NoParId.Level)
 return yyt;
}

tTree mParId
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tIdent pIdent, tPosition pPos)
# else
(pNext, pIdent, pPos)
tTree pNext;
tIdent pIdent;
tPosition pPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kParId])
 yyt->Kind = kParId;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->ParId.Objects3)
 begintType(yyt->ParId.Type)
 beginADDRESS(yyt->ParId.TypeTree)
 beginBOOLEAN(yyt->ParId.IsVAR)
 begintType(yyt->ParId.TypesIn)
 begintTypes(yyt->ParId.TypesOut)
 begintIdents(yyt->ParId.IdsIn)
 begintIdents(yyt->ParId.IdsOut)
 begintLocalIds(yyt->ParId.LocalIdsIn)
 begintLocalIds(yyt->ParId.LocalIdsOut)
 beginINDEX(yyt->ParId.Level)
 yyt->ParId.Next = pNext;
 yyt->ParId.Ident = pIdent;
 yyt->ParId.Pos = pPos;
 begintObject(yyt->ParId.Object)
 begintIdent(yyt->ParId.CIdent)
 beginBOOLEAN(yyt->ParId.IsRedeclared)
 return yyt;
}

tTree mType
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kType])
 yyt->Kind = kType;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->Type.Objects3)
 begintObject(yyt->Type.TypeObj)
 begintType(yyt->Type.Type1)
 begintType(yyt->Type.Type2)
 begintEnv(yyt->Type.Env1)
 begintVoid(yyt->Type.Env2)
 begintEnv(yyt->Type.Env3)
 beginBOOLEAN(yyt->Type.IsInArray)
 beginINDEX(yyt->Type.PosIn)
 beginINDEX(yyt->Type.PosOut)
 beginINDEX(yyt->Type.Kind)
 begintIdent(yyt->Type.Module)
 begintIdents(yyt->Type.IdsIn)
 begintIdents(yyt->Type.IdsOut)
 begintLocalIds(yyt->Type.LocalIdsIn)
 begintLocalIds(yyt->Type.LocalIdsOut)
 beginINDEX(yyt->Type.CntIn)
 beginINDEX(yyt->Type.CntOut)
 beginBOOLEAN(yyt->Type.HasVariableSize)
 beginBOOLEAN(yyt->Type.ContainsVector)
 return yyt;
}

tTree mVector
# if defined __STDC__ | defined __cplusplus
(BOOLEAN pIsOpen, tTree pConfig, tTree pScalar)
# else
(pIsOpen, pConfig, pScalar)
BOOLEAN pIsOpen;
tTree pConfig;
tTree pScalar;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kVector])
 yyt->Kind = kVector;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->Vector.Objects3)
 begintObject(yyt->Vector.TypeObj)
 begintType(yyt->Vector.Type1)
 begintType(yyt->Vector.Type2)
 begintEnv(yyt->Vector.Env1)
 begintVoid(yyt->Vector.Env2)
 begintEnv(yyt->Vector.Env3)
 beginBOOLEAN(yyt->Vector.IsInArray)
 beginINDEX(yyt->Vector.PosIn)
 beginINDEX(yyt->Vector.PosOut)
 beginINDEX(yyt->Vector.Kind)
 begintIdent(yyt->Vector.Module)
 begintIdents(yyt->Vector.IdsIn)
 begintIdents(yyt->Vector.IdsOut)
 begintLocalIds(yyt->Vector.LocalIdsIn)
 begintLocalIds(yyt->Vector.LocalIdsOut)
 beginINDEX(yyt->Vector.CntIn)
 beginINDEX(yyt->Vector.CntOut)
 beginBOOLEAN(yyt->Vector.HasVariableSize)
 beginBOOLEAN(yyt->Vector.ContainsVector)
 yyt->Vector.IsOpen = pIsOpen;
 yyt->Vector.Config = pConfig;
 yyt->Vector.Scalar = pScalar;
 return yyt;
}

tTree mArray
# if defined __STDC__ | defined __cplusplus
(BOOLEAN pIsOpen, tTree pIndex, tTree pElemType)
# else
(pIsOpen, pIndex, pElemType)
BOOLEAN pIsOpen;
tTree pIndex;
tTree pElemType;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kArray])
 yyt->Kind = kArray;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->Array.Objects3)
 begintObject(yyt->Array.TypeObj)
 begintType(yyt->Array.Type1)
 begintType(yyt->Array.Type2)
 begintEnv(yyt->Array.Env1)
 begintVoid(yyt->Array.Env2)
 begintEnv(yyt->Array.Env3)
 beginBOOLEAN(yyt->Array.IsInArray)
 beginINDEX(yyt->Array.PosIn)
 beginINDEX(yyt->Array.PosOut)
 beginINDEX(yyt->Array.Kind)
 begintIdent(yyt->Array.Module)
 begintIdents(yyt->Array.IdsIn)
 begintIdents(yyt->Array.IdsOut)
 begintLocalIds(yyt->Array.LocalIdsIn)
 begintLocalIds(yyt->Array.LocalIdsOut)
 beginINDEX(yyt->Array.CntIn)
 beginINDEX(yyt->Array.CntOut)
 beginBOOLEAN(yyt->Array.HasVariableSize)
 beginBOOLEAN(yyt->Array.ContainsVector)
 yyt->Array.IsOpen = pIsOpen;
 yyt->Array.Index = pIndex;
 yyt->Array.ElemType = pElemType;
 return yyt;
}

tTree mRecord
# if defined __STDC__ | defined __cplusplus
(tTree pFields)
# else
(pFields)
tTree pFields;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kRecord])
 yyt->Kind = kRecord;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->Record.Objects3)
 begintObject(yyt->Record.TypeObj)
 begintType(yyt->Record.Type1)
 begintType(yyt->Record.Type2)
 begintEnv(yyt->Record.Env1)
 begintVoid(yyt->Record.Env2)
 begintEnv(yyt->Record.Env3)
 beginBOOLEAN(yyt->Record.IsInArray)
 beginINDEX(yyt->Record.PosIn)
 beginINDEX(yyt->Record.PosOut)
 beginINDEX(yyt->Record.Kind)
 begintIdent(yyt->Record.Module)
 begintIdents(yyt->Record.IdsIn)
 begintIdents(yyt->Record.IdsOut)
 begintLocalIds(yyt->Record.LocalIdsIn)
 begintLocalIds(yyt->Record.LocalIdsOut)
 beginINDEX(yyt->Record.CntIn)
 beginINDEX(yyt->Record.CntOut)
 beginBOOLEAN(yyt->Record.HasVariableSize)
 beginBOOLEAN(yyt->Record.ContainsVector)
 yyt->Record.Fields = pFields;
 return yyt;
}

tTree mSetType
# if defined __STDC__ | defined __cplusplus
(tTree pBaseType)
# else
(pBaseType)
tTree pBaseType;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kSetType])
 yyt->Kind = kSetType;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->SetType.Objects3)
 begintObject(yyt->SetType.TypeObj)
 begintType(yyt->SetType.Type1)
 begintType(yyt->SetType.Type2)
 begintEnv(yyt->SetType.Env1)
 begintVoid(yyt->SetType.Env2)
 begintEnv(yyt->SetType.Env3)
 beginBOOLEAN(yyt->SetType.IsInArray)
 beginINDEX(yyt->SetType.PosIn)
 beginINDEX(yyt->SetType.PosOut)
 beginINDEX(yyt->SetType.Kind)
 begintIdent(yyt->SetType.Module)
 begintIdents(yyt->SetType.IdsIn)
 begintIdents(yyt->SetType.IdsOut)
 begintLocalIds(yyt->SetType.LocalIdsIn)
 begintLocalIds(yyt->SetType.LocalIdsOut)
 beginINDEX(yyt->SetType.CntIn)
 beginINDEX(yyt->SetType.CntOut)
 beginBOOLEAN(yyt->SetType.HasVariableSize)
 beginBOOLEAN(yyt->SetType.ContainsVector)
 yyt->SetType.BaseType = pBaseType;
 return yyt;
}

tTree mPointer
# if defined __STDC__ | defined __cplusplus
(tTree pTargetType)
# else
(pTargetType)
tTree pTargetType;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kPointer])
 yyt->Kind = kPointer;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->Pointer.Objects3)
 begintObject(yyt->Pointer.TypeObj)
 begintType(yyt->Pointer.Type1)
 begintType(yyt->Pointer.Type2)
 begintEnv(yyt->Pointer.Env1)
 begintVoid(yyt->Pointer.Env2)
 begintEnv(yyt->Pointer.Env3)
 beginBOOLEAN(yyt->Pointer.IsInArray)
 beginINDEX(yyt->Pointer.PosIn)
 beginINDEX(yyt->Pointer.PosOut)
 beginINDEX(yyt->Pointer.Kind)
 begintIdent(yyt->Pointer.Module)
 begintIdents(yyt->Pointer.IdsIn)
 begintIdents(yyt->Pointer.IdsOut)
 begintLocalIds(yyt->Pointer.LocalIdsIn)
 begintLocalIds(yyt->Pointer.LocalIdsOut)
 beginINDEX(yyt->Pointer.CntIn)
 beginINDEX(yyt->Pointer.CntOut)
 beginBOOLEAN(yyt->Pointer.HasVariableSize)
 beginBOOLEAN(yyt->Pointer.ContainsVector)
 yyt->Pointer.TargetType = pTargetType;
 beginINDEX(yyt->Pointer.TypePos)
 return yyt;
}

tTree mProcType
# if defined __STDC__ | defined __cplusplus
(tTree pFormalTypes, tTree pResultType)
# else
(pFormalTypes, pResultType)
tTree pFormalTypes;
tTree pResultType;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kProcType])
 yyt->Kind = kProcType;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->ProcType.Objects3)
 begintObject(yyt->ProcType.TypeObj)
 begintType(yyt->ProcType.Type1)
 begintType(yyt->ProcType.Type2)
 begintEnv(yyt->ProcType.Env1)
 begintVoid(yyt->ProcType.Env2)
 begintEnv(yyt->ProcType.Env3)
 beginBOOLEAN(yyt->ProcType.IsInArray)
 beginINDEX(yyt->ProcType.PosIn)
 beginINDEX(yyt->ProcType.PosOut)
 beginINDEX(yyt->ProcType.Kind)
 begintIdent(yyt->ProcType.Module)
 begintIdents(yyt->ProcType.IdsIn)
 begintIdents(yyt->ProcType.IdsOut)
 begintLocalIds(yyt->ProcType.LocalIdsIn)
 begintLocalIds(yyt->ProcType.LocalIdsOut)
 beginINDEX(yyt->ProcType.CntIn)
 beginINDEX(yyt->ProcType.CntOut)
 beginBOOLEAN(yyt->ProcType.HasVariableSize)
 beginBOOLEAN(yyt->ProcType.ContainsVector)
 yyt->ProcType.FormalTypes = pFormalTypes;
 yyt->ProcType.ResultType = pResultType;
 return yyt;
}

tTree mSimpleType
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kSimpleType])
 yyt->Kind = kSimpleType;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->SimpleType.Objects3)
 begintObject(yyt->SimpleType.TypeObj)
 begintType(yyt->SimpleType.Type1)
 begintType(yyt->SimpleType.Type2)
 begintEnv(yyt->SimpleType.Env1)
 begintVoid(yyt->SimpleType.Env2)
 begintEnv(yyt->SimpleType.Env3)
 beginBOOLEAN(yyt->SimpleType.IsInArray)
 beginINDEX(yyt->SimpleType.PosIn)
 beginINDEX(yyt->SimpleType.PosOut)
 beginINDEX(yyt->SimpleType.Kind)
 begintIdent(yyt->SimpleType.Module)
 begintIdents(yyt->SimpleType.IdsIn)
 begintIdents(yyt->SimpleType.IdsOut)
 begintLocalIds(yyt->SimpleType.LocalIdsIn)
 begintLocalIds(yyt->SimpleType.LocalIdsOut)
 beginINDEX(yyt->SimpleType.CntIn)
 beginINDEX(yyt->SimpleType.CntOut)
 beginBOOLEAN(yyt->SimpleType.HasVariableSize)
 beginBOOLEAN(yyt->SimpleType.ContainsVector)
 return yyt;
}

tTree mEnumeration
# if defined __STDC__ | defined __cplusplus
(tTree pEnumIds)
# else
(pEnumIds)
tTree pEnumIds;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kEnumeration])
 yyt->Kind = kEnumeration;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->Enumeration.Objects3)
 begintObject(yyt->Enumeration.TypeObj)
 begintType(yyt->Enumeration.Type1)
 begintType(yyt->Enumeration.Type2)
 begintEnv(yyt->Enumeration.Env1)
 begintVoid(yyt->Enumeration.Env2)
 begintEnv(yyt->Enumeration.Env3)
 beginBOOLEAN(yyt->Enumeration.IsInArray)
 beginINDEX(yyt->Enumeration.PosIn)
 beginINDEX(yyt->Enumeration.PosOut)
 beginINDEX(yyt->Enumeration.Kind)
 begintIdent(yyt->Enumeration.Module)
 begintIdents(yyt->Enumeration.IdsIn)
 begintIdents(yyt->Enumeration.IdsOut)
 begintLocalIds(yyt->Enumeration.LocalIdsIn)
 begintLocalIds(yyt->Enumeration.LocalIdsOut)
 beginINDEX(yyt->Enumeration.CntIn)
 beginINDEX(yyt->Enumeration.CntOut)
 beginBOOLEAN(yyt->Enumeration.HasVariableSize)
 beginBOOLEAN(yyt->Enumeration.ContainsVector)
 yyt->Enumeration.EnumIds = pEnumIds;
 begintType(yyt->Enumeration.Type0)
 return yyt;
}

tTree mSubrange
# if defined __STDC__ | defined __cplusplus
(tTree pBaseType, tTree pLwb, tTree pUpb)
# else
(pBaseType, pLwb, pUpb)
tTree pBaseType;
tTree pLwb;
tTree pUpb;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kSubrange])
 yyt->Kind = kSubrange;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->Subrange.Objects3)
 begintObject(yyt->Subrange.TypeObj)
 begintType(yyt->Subrange.Type1)
 begintType(yyt->Subrange.Type2)
 begintEnv(yyt->Subrange.Env1)
 begintVoid(yyt->Subrange.Env2)
 begintEnv(yyt->Subrange.Env3)
 beginBOOLEAN(yyt->Subrange.IsInArray)
 beginINDEX(yyt->Subrange.PosIn)
 beginINDEX(yyt->Subrange.PosOut)
 beginINDEX(yyt->Subrange.Kind)
 begintIdent(yyt->Subrange.Module)
 begintIdents(yyt->Subrange.IdsIn)
 begintIdents(yyt->Subrange.IdsOut)
 begintLocalIds(yyt->Subrange.LocalIdsIn)
 begintLocalIds(yyt->Subrange.LocalIdsOut)
 beginINDEX(yyt->Subrange.CntIn)
 beginINDEX(yyt->Subrange.CntOut)
 beginBOOLEAN(yyt->Subrange.HasVariableSize)
 beginBOOLEAN(yyt->Subrange.ContainsVector)
 yyt->Subrange.BaseType = pBaseType;
 yyt->Subrange.Lwb = pLwb;
 yyt->Subrange.Upb = pUpb;
 begintType(yyt->Subrange.Type3)
 return yyt;
}

tTree mPrimaryType
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kPrimaryType])
 yyt->Kind = kPrimaryType;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->PrimaryType.Objects3)
 begintObject(yyt->PrimaryType.TypeObj)
 begintType(yyt->PrimaryType.Type1)
 begintType(yyt->PrimaryType.Type2)
 begintEnv(yyt->PrimaryType.Env1)
 begintVoid(yyt->PrimaryType.Env2)
 begintEnv(yyt->PrimaryType.Env3)
 beginBOOLEAN(yyt->PrimaryType.IsInArray)
 beginINDEX(yyt->PrimaryType.PosIn)
 beginINDEX(yyt->PrimaryType.PosOut)
 beginINDEX(yyt->PrimaryType.Kind)
 begintIdent(yyt->PrimaryType.Module)
 begintIdents(yyt->PrimaryType.IdsIn)
 begintIdents(yyt->PrimaryType.IdsOut)
 begintLocalIds(yyt->PrimaryType.LocalIdsIn)
 begintLocalIds(yyt->PrimaryType.LocalIdsOut)
 beginINDEX(yyt->PrimaryType.CntIn)
 beginINDEX(yyt->PrimaryType.CntOut)
 beginBOOLEAN(yyt->PrimaryType.HasVariableSize)
 beginBOOLEAN(yyt->PrimaryType.ContainsVector)
 return yyt;
}

tTree mVoid
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kVoid])
 yyt->Kind = kVoid;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->Void.Objects3)
 begintObject(yyt->Void.TypeObj)
 begintType(yyt->Void.Type1)
 begintType(yyt->Void.Type2)
 begintEnv(yyt->Void.Env1)
 begintVoid(yyt->Void.Env2)
 begintEnv(yyt->Void.Env3)
 beginBOOLEAN(yyt->Void.IsInArray)
 beginINDEX(yyt->Void.PosIn)
 beginINDEX(yyt->Void.PosOut)
 beginINDEX(yyt->Void.Kind)
 begintIdent(yyt->Void.Module)
 begintIdents(yyt->Void.IdsIn)
 begintIdents(yyt->Void.IdsOut)
 begintLocalIds(yyt->Void.LocalIdsIn)
 begintLocalIds(yyt->Void.LocalIdsOut)
 beginINDEX(yyt->Void.CntIn)
 beginINDEX(yyt->Void.CntOut)
 beginBOOLEAN(yyt->Void.HasVariableSize)
 beginBOOLEAN(yyt->Void.ContainsVector)
 return yyt;
}

tTree mTypeId
# if defined __STDC__ | defined __cplusplus
(tIdent pIdent, tPosition pPos)
# else
(pIdent, pPos)
tIdent pIdent;
tPosition pPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kTypeId])
 yyt->Kind = kTypeId;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->TypeId.Objects3)
 begintObject(yyt->TypeId.TypeObj)
 begintType(yyt->TypeId.Type1)
 begintType(yyt->TypeId.Type2)
 begintEnv(yyt->TypeId.Env1)
 begintVoid(yyt->TypeId.Env2)
 begintEnv(yyt->TypeId.Env3)
 beginBOOLEAN(yyt->TypeId.IsInArray)
 beginINDEX(yyt->TypeId.PosIn)
 beginINDEX(yyt->TypeId.PosOut)
 beginINDEX(yyt->TypeId.Kind)
 begintIdent(yyt->TypeId.Module)
 begintIdents(yyt->TypeId.IdsIn)
 begintIdents(yyt->TypeId.IdsOut)
 begintLocalIds(yyt->TypeId.LocalIdsIn)
 begintLocalIds(yyt->TypeId.LocalIdsOut)
 beginINDEX(yyt->TypeId.CntIn)
 beginINDEX(yyt->TypeId.CntOut)
 beginBOOLEAN(yyt->TypeId.HasVariableSize)
 beginBOOLEAN(yyt->TypeId.ContainsVector)
 yyt->TypeId.Ident = pIdent;
 yyt->TypeId.Pos = pPos;
 begintObject(yyt->TypeId.Object)
 return yyt;
}

tTree mTypeId0
# if defined __STDC__ | defined __cplusplus
(tIdent pIdent, tPosition pPos)
# else
(pIdent, pPos)
tIdent pIdent;
tPosition pPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kTypeId0])
 yyt->Kind = kTypeId0;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->TypeId0.Objects3)
 begintObject(yyt->TypeId0.TypeObj)
 begintType(yyt->TypeId0.Type1)
 begintType(yyt->TypeId0.Type2)
 begintEnv(yyt->TypeId0.Env1)
 begintVoid(yyt->TypeId0.Env2)
 begintEnv(yyt->TypeId0.Env3)
 beginBOOLEAN(yyt->TypeId0.IsInArray)
 beginINDEX(yyt->TypeId0.PosIn)
 beginINDEX(yyt->TypeId0.PosOut)
 beginINDEX(yyt->TypeId0.Kind)
 begintIdent(yyt->TypeId0.Module)
 begintIdents(yyt->TypeId0.IdsIn)
 begintIdents(yyt->TypeId0.IdsOut)
 begintLocalIds(yyt->TypeId0.LocalIdsIn)
 begintLocalIds(yyt->TypeId0.LocalIdsOut)
 beginINDEX(yyt->TypeId0.CntIn)
 beginINDEX(yyt->TypeId0.CntOut)
 beginBOOLEAN(yyt->TypeId0.HasVariableSize)
 beginBOOLEAN(yyt->TypeId0.ContainsVector)
 yyt->TypeId0.Ident = pIdent;
 yyt->TypeId0.Pos = pPos;
 begintObject(yyt->TypeId0.Object)
 return yyt;
}

tTree mTypeId1
# if defined __STDC__ | defined __cplusplus
(tIdent pIdent, tPosition pPos, tTree pTypeId)
# else
(pIdent, pPos, pTypeId)
tIdent pIdent;
tPosition pPos;
tTree pTypeId;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kTypeId1])
 yyt->Kind = kTypeId1;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->TypeId1.Objects3)
 begintObject(yyt->TypeId1.TypeObj)
 begintType(yyt->TypeId1.Type1)
 begintType(yyt->TypeId1.Type2)
 begintEnv(yyt->TypeId1.Env1)
 begintVoid(yyt->TypeId1.Env2)
 begintEnv(yyt->TypeId1.Env3)
 beginBOOLEAN(yyt->TypeId1.IsInArray)
 beginINDEX(yyt->TypeId1.PosIn)
 beginINDEX(yyt->TypeId1.PosOut)
 beginINDEX(yyt->TypeId1.Kind)
 begintIdent(yyt->TypeId1.Module)
 begintIdents(yyt->TypeId1.IdsIn)
 begintIdents(yyt->TypeId1.IdsOut)
 begintLocalIds(yyt->TypeId1.LocalIdsIn)
 begintLocalIds(yyt->TypeId1.LocalIdsOut)
 beginINDEX(yyt->TypeId1.CntIn)
 beginINDEX(yyt->TypeId1.CntOut)
 beginBOOLEAN(yyt->TypeId1.HasVariableSize)
 beginBOOLEAN(yyt->TypeId1.ContainsVector)
 yyt->TypeId1.Ident = pIdent;
 yyt->TypeId1.Pos = pPos;
 begintObject(yyt->TypeId1.Object)
 yyt->TypeId1.TypeId = pTypeId;
 return yyt;
}

tTree mFields
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kFields])
 yyt->Kind = kFields;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->Fields.Objects3)
 begintObjects(yyt->Fields.FieldsIn)
 begintObjects(yyt->Fields.FieldsOut)
 begintEnv(yyt->Fields.Env1)
 begintVoid(yyt->Fields.Env2)
 begintEnv(yyt->Fields.Env3)
 beginINDEX(yyt->Fields.PosIn)
 beginINDEX(yyt->Fields.PosOut)
 beginINDEX(yyt->Fields.Kind)
 begintIdent(yyt->Fields.Module)
 begintIdents(yyt->Fields.IdsIn)
 begintIdents(yyt->Fields.IdsOut)
 begintLocalIds(yyt->Fields.LocalIdsIn)
 begintLocalIds(yyt->Fields.LocalIdsOut)
 beginINDEX(yyt->Fields.CntIn)
 beginINDEX(yyt->Fields.CntOut)
 beginINDEX(yyt->Fields.nUnion)
 begintSelectors(yyt->Fields.Select)
 beginBOOLEAN(yyt->Fields.ContainsVector)
 return yyt;
}

tTree mNoField
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoField])
 yyt->Kind = kNoField;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->NoField.Objects3)
 begintObjects(yyt->NoField.FieldsIn)
 begintObjects(yyt->NoField.FieldsOut)
 begintEnv(yyt->NoField.Env1)
 begintVoid(yyt->NoField.Env2)
 begintEnv(yyt->NoField.Env3)
 beginINDEX(yyt->NoField.PosIn)
 beginINDEX(yyt->NoField.PosOut)
 beginINDEX(yyt->NoField.Kind)
 begintIdent(yyt->NoField.Module)
 begintIdents(yyt->NoField.IdsIn)
 begintIdents(yyt->NoField.IdsOut)
 begintLocalIds(yyt->NoField.LocalIdsIn)
 begintLocalIds(yyt->NoField.LocalIdsOut)
 beginINDEX(yyt->NoField.CntIn)
 beginINDEX(yyt->NoField.CntOut)
 beginINDEX(yyt->NoField.nUnion)
 begintSelectors(yyt->NoField.Select)
 beginBOOLEAN(yyt->NoField.ContainsVector)
 return yyt;
}

tTree mField
# if defined __STDC__ | defined __cplusplus
(tTree pNext)
# else
(pNext)
tTree pNext;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kField])
 yyt->Kind = kField;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->Field.Objects3)
 begintObjects(yyt->Field.FieldsIn)
 begintObjects(yyt->Field.FieldsOut)
 begintEnv(yyt->Field.Env1)
 begintVoid(yyt->Field.Env2)
 begintEnv(yyt->Field.Env3)
 beginINDEX(yyt->Field.PosIn)
 beginINDEX(yyt->Field.PosOut)
 beginINDEX(yyt->Field.Kind)
 begintIdent(yyt->Field.Module)
 begintIdents(yyt->Field.IdsIn)
 begintIdents(yyt->Field.IdsOut)
 begintLocalIds(yyt->Field.LocalIdsIn)
 begintLocalIds(yyt->Field.LocalIdsOut)
 beginINDEX(yyt->Field.CntIn)
 beginINDEX(yyt->Field.CntOut)
 beginINDEX(yyt->Field.nUnion)
 begintSelectors(yyt->Field.Select)
 beginBOOLEAN(yyt->Field.ContainsVector)
 yyt->Field.Next = pNext;
 return yyt;
}

tTree mRecordSect
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tTree pFieldIds, tTree pType)
# else
(pNext, pFieldIds, pType)
tTree pNext;
tTree pFieldIds;
tTree pType;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kRecordSect])
 yyt->Kind = kRecordSect;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->RecordSect.Objects3)
 begintObjects(yyt->RecordSect.FieldsIn)
 begintObjects(yyt->RecordSect.FieldsOut)
 begintEnv(yyt->RecordSect.Env1)
 begintVoid(yyt->RecordSect.Env2)
 begintEnv(yyt->RecordSect.Env3)
 beginINDEX(yyt->RecordSect.PosIn)
 beginINDEX(yyt->RecordSect.PosOut)
 beginINDEX(yyt->RecordSect.Kind)
 begintIdent(yyt->RecordSect.Module)
 begintIdents(yyt->RecordSect.IdsIn)
 begintIdents(yyt->RecordSect.IdsOut)
 begintLocalIds(yyt->RecordSect.LocalIdsIn)
 begintLocalIds(yyt->RecordSect.LocalIdsOut)
 beginINDEX(yyt->RecordSect.CntIn)
 beginINDEX(yyt->RecordSect.CntOut)
 beginINDEX(yyt->RecordSect.nUnion)
 begintSelectors(yyt->RecordSect.Select)
 beginBOOLEAN(yyt->RecordSect.ContainsVector)
 yyt->RecordSect.Next = pNext;
 yyt->RecordSect.FieldIds = pFieldIds;
 yyt->RecordSect.Type = pType;
 return yyt;
}

tTree mVariantSect
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tTree pTagField, tTree pVariants, tTree pElse)
# else
(pNext, pTagField, pVariants, pElse)
tTree pNext;
tTree pTagField;
tTree pVariants;
tTree pElse;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kVariantSect])
 yyt->Kind = kVariantSect;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->VariantSect.Objects3)
 begintObjects(yyt->VariantSect.FieldsIn)
 begintObjects(yyt->VariantSect.FieldsOut)
 begintEnv(yyt->VariantSect.Env1)
 begintVoid(yyt->VariantSect.Env2)
 begintEnv(yyt->VariantSect.Env3)
 beginINDEX(yyt->VariantSect.PosIn)
 beginINDEX(yyt->VariantSect.PosOut)
 beginINDEX(yyt->VariantSect.Kind)
 begintIdent(yyt->VariantSect.Module)
 begintIdents(yyt->VariantSect.IdsIn)
 begintIdents(yyt->VariantSect.IdsOut)
 begintLocalIds(yyt->VariantSect.LocalIdsIn)
 begintLocalIds(yyt->VariantSect.LocalIdsOut)
 beginINDEX(yyt->VariantSect.CntIn)
 beginINDEX(yyt->VariantSect.CntOut)
 beginINDEX(yyt->VariantSect.nUnion)
 begintSelectors(yyt->VariantSect.Select)
 beginBOOLEAN(yyt->VariantSect.ContainsVector)
 yyt->VariantSect.Next = pNext;
 yyt->VariantSect.TagField = pTagField;
 yyt->VariantSect.Variants = pVariants;
 yyt->VariantSect.Else = pElse;
 begintIdent(yyt->VariantSect.UnionId)
 begintIdent(yyt->VariantSect.ElseId)
 return yyt;
}

tTree mFieldIds
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kFieldIds])
 yyt->Kind = kFieldIds;
 yyt->yyHead.yyMark = 0;
 begintType(yyt->FieldIds.Type)
 begintObjects(yyt->FieldIds.FieldsIn)
 begintObjects(yyt->FieldIds.FieldsOut)
 begintIdents(yyt->FieldIds.IdsIn)
 begintIdents(yyt->FieldIds.IdsOut)
 begintLocalIds(yyt->FieldIds.LocalIdsIn)
 begintLocalIds(yyt->FieldIds.LocalIdsOut)
 begintSelectors(yyt->FieldIds.Select)
 return yyt;
}

tTree mNoFieldId
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoFieldId])
 yyt->Kind = kNoFieldId;
 yyt->yyHead.yyMark = 0;
 begintType(yyt->NoFieldId.Type)
 begintObjects(yyt->NoFieldId.FieldsIn)
 begintObjects(yyt->NoFieldId.FieldsOut)
 begintIdents(yyt->NoFieldId.IdsIn)
 begintIdents(yyt->NoFieldId.IdsOut)
 begintLocalIds(yyt->NoFieldId.LocalIdsIn)
 begintLocalIds(yyt->NoFieldId.LocalIdsOut)
 begintSelectors(yyt->NoFieldId.Select)
 return yyt;
}

tTree mFieldId
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tIdent pIdent, tPosition pPos)
# else
(pNext, pIdent, pPos)
tTree pNext;
tIdent pIdent;
tPosition pPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kFieldId])
 yyt->Kind = kFieldId;
 yyt->yyHead.yyMark = 0;
 begintType(yyt->FieldId.Type)
 begintObjects(yyt->FieldId.FieldsIn)
 begintObjects(yyt->FieldId.FieldsOut)
 begintIdents(yyt->FieldId.IdsIn)
 begintIdents(yyt->FieldId.IdsOut)
 begintLocalIds(yyt->FieldId.LocalIdsIn)
 begintLocalIds(yyt->FieldId.LocalIdsOut)
 begintSelectors(yyt->FieldId.Select)
 yyt->FieldId.Next = pNext;
 yyt->FieldId.Ident = pIdent;
 yyt->FieldId.Pos = pPos;
 begintObject(yyt->FieldId.Object)
 begintIdent(yyt->FieldId.CIdent)
 beginBOOLEAN(yyt->FieldId.IsRedeclared)
 return yyt;
}

tTree mTagField
# if defined __STDC__ | defined __cplusplus
(tTree pType)
# else
(pType)
tTree pType;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kTagField])
 yyt->Kind = kTagField;
 yyt->yyHead.yyMark = 0;
 yyt->TagField.Type = pType;
 begintObjects(yyt->TagField.FieldsIn)
 begintObjects(yyt->TagField.FieldsOut)
 begintEnv(yyt->TagField.Env1)
 begintVoid(yyt->TagField.Env2)
 begintEnv(yyt->TagField.Env3)
 beginINDEX(yyt->TagField.PosIn)
 beginINDEX(yyt->TagField.PosOut)
 beginINDEX(yyt->TagField.Kind)
 begintIdent(yyt->TagField.Module)
 begintIdents(yyt->TagField.IdsIn)
 begintIdents(yyt->TagField.IdsOut)
 begintLocalIds(yyt->TagField.LocalIdsIn)
 begintLocalIds(yyt->TagField.LocalIdsOut)
 begintSelectors(yyt->TagField.Select)
 return yyt;
}

tTree mTagField1
# if defined __STDC__ | defined __cplusplus
(tTree pType)
# else
(pType)
tTree pType;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kTagField1])
 yyt->Kind = kTagField1;
 yyt->yyHead.yyMark = 0;
 yyt->TagField1.Type = pType;
 begintObjects(yyt->TagField1.FieldsIn)
 begintObjects(yyt->TagField1.FieldsOut)
 begintEnv(yyt->TagField1.Env1)
 begintVoid(yyt->TagField1.Env2)
 begintEnv(yyt->TagField1.Env3)
 beginINDEX(yyt->TagField1.PosIn)
 beginINDEX(yyt->TagField1.PosOut)
 beginINDEX(yyt->TagField1.Kind)
 begintIdent(yyt->TagField1.Module)
 begintIdents(yyt->TagField1.IdsIn)
 begintIdents(yyt->TagField1.IdsOut)
 begintLocalIds(yyt->TagField1.LocalIdsIn)
 begintLocalIds(yyt->TagField1.LocalIdsOut)
 begintSelectors(yyt->TagField1.Select)
 return yyt;
}

tTree mTagField2
# if defined __STDC__ | defined __cplusplus
(tTree pType, tIdent pIdent)
# else
(pType, pIdent)
tTree pType;
tIdent pIdent;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kTagField2])
 yyt->Kind = kTagField2;
 yyt->yyHead.yyMark = 0;
 yyt->TagField2.Type = pType;
 begintObjects(yyt->TagField2.FieldsIn)
 begintObjects(yyt->TagField2.FieldsOut)
 begintEnv(yyt->TagField2.Env1)
 begintVoid(yyt->TagField2.Env2)
 begintEnv(yyt->TagField2.Env3)
 beginINDEX(yyt->TagField2.PosIn)
 beginINDEX(yyt->TagField2.PosOut)
 beginINDEX(yyt->TagField2.Kind)
 begintIdent(yyt->TagField2.Module)
 begintIdents(yyt->TagField2.IdsIn)
 begintIdents(yyt->TagField2.IdsOut)
 begintLocalIds(yyt->TagField2.LocalIdsIn)
 begintLocalIds(yyt->TagField2.LocalIdsOut)
 begintSelectors(yyt->TagField2.Select)
 yyt->TagField2.Ident = pIdent;
 begintObject(yyt->TagField2.Object)
 begintIdent(yyt->TagField2.CIdent)
 beginBOOLEAN(yyt->TagField2.IsRedeclared)
 return yyt;
}

tTree mVariants
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kVariants])
 yyt->Kind = kVariants;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->Variants.Objects3)
 begintObjects(yyt->Variants.FieldsIn)
 begintObjects(yyt->Variants.FieldsOut)
 begintEnv(yyt->Variants.Env1)
 begintVoid(yyt->Variants.Env2)
 begintEnv(yyt->Variants.Env3)
 beginINDEX(yyt->Variants.PosIn)
 beginINDEX(yyt->Variants.PosOut)
 beginINDEX(yyt->Variants.Kind)
 begintIdent(yyt->Variants.Module)
 begintIdents(yyt->Variants.IdsIn)
 begintIdents(yyt->Variants.IdsOut)
 begintLocalIds(yyt->Variants.LocalIdsIn)
 begintLocalIds(yyt->Variants.LocalIdsOut)
 beginINDEX(yyt->Variants.CntIn)
 beginINDEX(yyt->Variants.CntOut)
 beginINDEX(yyt->Variants.nStruct)
 begintSelectors(yyt->Variants.Select)
 return yyt;
}

tTree mNoVariant
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoVariant])
 yyt->Kind = kNoVariant;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->NoVariant.Objects3)
 begintObjects(yyt->NoVariant.FieldsIn)
 begintObjects(yyt->NoVariant.FieldsOut)
 begintEnv(yyt->NoVariant.Env1)
 begintVoid(yyt->NoVariant.Env2)
 begintEnv(yyt->NoVariant.Env3)
 beginINDEX(yyt->NoVariant.PosIn)
 beginINDEX(yyt->NoVariant.PosOut)
 beginINDEX(yyt->NoVariant.Kind)
 begintIdent(yyt->NoVariant.Module)
 begintIdents(yyt->NoVariant.IdsIn)
 begintIdents(yyt->NoVariant.IdsOut)
 begintLocalIds(yyt->NoVariant.LocalIdsIn)
 begintLocalIds(yyt->NoVariant.LocalIdsOut)
 beginINDEX(yyt->NoVariant.CntIn)
 beginINDEX(yyt->NoVariant.CntOut)
 beginINDEX(yyt->NoVariant.nStruct)
 begintSelectors(yyt->NoVariant.Select)
 return yyt;
}

tTree mVariant
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tTree pLabels, tTree pVariant)
# else
(pNext, pLabels, pVariant)
tTree pNext;
tTree pLabels;
tTree pVariant;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kVariant])
 yyt->Kind = kVariant;
 yyt->yyHead.yyMark = 0;
 begintObjects(yyt->Variant.Objects3)
 begintObjects(yyt->Variant.FieldsIn)
 begintObjects(yyt->Variant.FieldsOut)
 begintEnv(yyt->Variant.Env1)
 begintVoid(yyt->Variant.Env2)
 begintEnv(yyt->Variant.Env3)
 beginINDEX(yyt->Variant.PosIn)
 beginINDEX(yyt->Variant.PosOut)
 beginINDEX(yyt->Variant.Kind)
 begintIdent(yyt->Variant.Module)
 begintIdents(yyt->Variant.IdsIn)
 begintIdents(yyt->Variant.IdsOut)
 begintLocalIds(yyt->Variant.LocalIdsIn)
 begintLocalIds(yyt->Variant.LocalIdsOut)
 beginINDEX(yyt->Variant.CntIn)
 beginINDEX(yyt->Variant.CntOut)
 beginINDEX(yyt->Variant.nStruct)
 begintSelectors(yyt->Variant.Select)
 yyt->Variant.Next = pNext;
 yyt->Variant.Labels = pLabels;
 yyt->Variant.Variant = pVariant;
 begintIdent(yyt->Variant.StructId)
 return yyt;
}

tTree mFormalTypes
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kFormalTypes])
 yyt->Kind = kFormalTypes;
 yyt->yyHead.yyMark = 0;
 begintTypes(yyt->FormalTypes.Types)
 begintEnv(yyt->FormalTypes.Env1)
 begintVoid(yyt->FormalTypes.Env2)
 begintEnv(yyt->FormalTypes.Env3)
 beginINDEX(yyt->FormalTypes.PosIn)
 beginINDEX(yyt->FormalTypes.PosOut)
 beginINDEX(yyt->FormalTypes.Kind)
 begintIdent(yyt->FormalTypes.Module)
 begintIdents(yyt->FormalTypes.IdsIn)
 begintIdents(yyt->FormalTypes.IdsOut)
 begintLocalIds(yyt->FormalTypes.LocalIdsIn)
 begintLocalIds(yyt->FormalTypes.LocalIdsOut)
 return yyt;
}

tTree mNoFormalType
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoFormalType])
 yyt->Kind = kNoFormalType;
 yyt->yyHead.yyMark = 0;
 begintTypes(yyt->NoFormalType.Types)
 begintEnv(yyt->NoFormalType.Env1)
 begintVoid(yyt->NoFormalType.Env2)
 begintEnv(yyt->NoFormalType.Env3)
 beginINDEX(yyt->NoFormalType.PosIn)
 beginINDEX(yyt->NoFormalType.PosOut)
 beginINDEX(yyt->NoFormalType.Kind)
 begintIdent(yyt->NoFormalType.Module)
 begintIdents(yyt->NoFormalType.IdsIn)
 begintIdents(yyt->NoFormalType.IdsOut)
 begintLocalIds(yyt->NoFormalType.LocalIdsIn)
 begintLocalIds(yyt->NoFormalType.LocalIdsOut)
 return yyt;
}

tTree mFormalType
# if defined __STDC__ | defined __cplusplus
(tTree pNext, BOOLEAN pIsVAR, tTree pType)
# else
(pNext, pIsVAR, pType)
tTree pNext;
BOOLEAN pIsVAR;
tTree pType;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kFormalType])
 yyt->Kind = kFormalType;
 yyt->yyHead.yyMark = 0;
 begintTypes(yyt->FormalType.Types)
 begintEnv(yyt->FormalType.Env1)
 begintVoid(yyt->FormalType.Env2)
 begintEnv(yyt->FormalType.Env3)
 beginINDEX(yyt->FormalType.PosIn)
 beginINDEX(yyt->FormalType.PosOut)
 beginINDEX(yyt->FormalType.Kind)
 begintIdent(yyt->FormalType.Module)
 begintIdents(yyt->FormalType.IdsIn)
 begintIdents(yyt->FormalType.IdsOut)
 begintLocalIds(yyt->FormalType.LocalIdsIn)
 begintLocalIds(yyt->FormalType.LocalIdsOut)
 yyt->FormalType.Next = pNext;
 yyt->FormalType.IsVAR = pIsVAR;
 yyt->FormalType.Type = pType;
 return yyt;
}

tTree mEnumIds
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kEnumIds])
 yyt->Kind = kEnumIds;
 yyt->yyHead.yyMark = 0;
 begintType(yyt->EnumIds.Type)
 begintObjects(yyt->EnumIds.Objects)
 beginINDEX(yyt->EnumIds.IndexIn)
 beginINDEX(yyt->EnumIds.IndexOut)
 beginINDEX(yyt->EnumIds.Kind)
 begintIdent(yyt->EnumIds.Module)
 begintIdents(yyt->EnumIds.IdsIn)
 begintIdents(yyt->EnumIds.IdsOut)
 begintLocalIds(yyt->EnumIds.LocalIdsIn)
 begintLocalIds(yyt->EnumIds.LocalIdsOut)
 return yyt;
}

tTree mNoEnumId
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoEnumId])
 yyt->Kind = kNoEnumId;
 yyt->yyHead.yyMark = 0;
 begintType(yyt->NoEnumId.Type)
 begintObjects(yyt->NoEnumId.Objects)
 beginINDEX(yyt->NoEnumId.IndexIn)
 beginINDEX(yyt->NoEnumId.IndexOut)
 beginINDEX(yyt->NoEnumId.Kind)
 begintIdent(yyt->NoEnumId.Module)
 begintIdents(yyt->NoEnumId.IdsIn)
 begintIdents(yyt->NoEnumId.IdsOut)
 begintLocalIds(yyt->NoEnumId.LocalIdsIn)
 begintLocalIds(yyt->NoEnumId.LocalIdsOut)
 return yyt;
}

tTree mEnumId
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tIdent pIdent, tPosition pPos)
# else
(pNext, pIdent, pPos)
tTree pNext;
tIdent pIdent;
tPosition pPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kEnumId])
 yyt->Kind = kEnumId;
 yyt->yyHead.yyMark = 0;
 begintType(yyt->EnumId.Type)
 begintObjects(yyt->EnumId.Objects)
 beginINDEX(yyt->EnumId.IndexIn)
 beginINDEX(yyt->EnumId.IndexOut)
 beginINDEX(yyt->EnumId.Kind)
 begintIdent(yyt->EnumId.Module)
 begintIdents(yyt->EnumId.IdsIn)
 begintIdents(yyt->EnumId.IdsOut)
 begintLocalIds(yyt->EnumId.LocalIdsIn)
 begintLocalIds(yyt->EnumId.LocalIdsOut)
 yyt->EnumId.Next = pNext;
 yyt->EnumId.Ident = pIdent;
 yyt->EnumId.Pos = pPos;
 begintObject(yyt->EnumId.Object)
 begintIdent(yyt->EnumId.CIdent)
 beginBOOLEAN(yyt->EnumId.IsRedeclared)
 return yyt;
}

tTree mExpr
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kExpr])
 yyt->Kind = kExpr;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Expr.Env)
 beginBOOLEAN(yyt->Expr.IsLval)
 begintType(yyt->Expr.Type)
 beginINDEX(yyt->Expr.Level)
 beginBOOLEAN(yyt->Expr.UseHelpVar)
 beginBOOLEAN(yyt->Expr.THelpVar)
 beginBOOLEAN(yyt->Expr.TakeHelpVar)
 begintIdent(yyt->Expr.HelpVar)
 beginBOOLEAN(yyt->Expr.IsFirstDesignator)
 beginBOOLEAN(yyt->Expr.HasProcOrDimSucc)
 beginBOOLEAN(yyt->Expr.WriteVectorIndex)
 begintTree(yyt->Expr.ProcOrDimSpec)
 beginBOOLEAN(yyt->Expr.WriteProcOrDimIndex)
 beginBOOLEAN(yyt->Expr.IsCConst)
 beginBOOLEAN(yyt->Expr.IsP3Const)
 beginBOOLEAN(yyt->Expr.OpenAccessOrCall)
 beginBOOLEAN(yyt->Expr.GlobalPtrs)
 begintStrings(yyt->Expr.StrsIn)
 begintStrings(yyt->Expr.StrsOut)
 return yyt;
}

tTree mNoExpr
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoExpr])
 yyt->Kind = kNoExpr;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->NoExpr.Env)
 beginBOOLEAN(yyt->NoExpr.IsLval)
 begintType(yyt->NoExpr.Type)
 beginINDEX(yyt->NoExpr.Level)
 beginBOOLEAN(yyt->NoExpr.UseHelpVar)
 beginBOOLEAN(yyt->NoExpr.THelpVar)
 beginBOOLEAN(yyt->NoExpr.TakeHelpVar)
 begintIdent(yyt->NoExpr.HelpVar)
 beginBOOLEAN(yyt->NoExpr.IsFirstDesignator)
 beginBOOLEAN(yyt->NoExpr.HasProcOrDimSucc)
 beginBOOLEAN(yyt->NoExpr.WriteVectorIndex)
 begintTree(yyt->NoExpr.ProcOrDimSpec)
 beginBOOLEAN(yyt->NoExpr.WriteProcOrDimIndex)
 beginBOOLEAN(yyt->NoExpr.IsCConst)
 beginBOOLEAN(yyt->NoExpr.IsP3Const)
 beginBOOLEAN(yyt->NoExpr.OpenAccessOrCall)
 beginBOOLEAN(yyt->NoExpr.GlobalPtrs)
 begintStrings(yyt->NoExpr.StrsIn)
 begintStrings(yyt->NoExpr.StrsOut)
 return yyt;
}

tTree mMultiples
# if defined __STDC__ | defined __cplusplus
(tTree pMop)
# else
(pMop)
tTree pMop;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kMultiples])
 yyt->Kind = kMultiples;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Multiples.Env)
 beginBOOLEAN(yyt->Multiples.IsLval)
 begintType(yyt->Multiples.Type)
 beginINDEX(yyt->Multiples.Level)
 beginBOOLEAN(yyt->Multiples.UseHelpVar)
 beginBOOLEAN(yyt->Multiples.THelpVar)
 beginBOOLEAN(yyt->Multiples.TakeHelpVar)
 begintIdent(yyt->Multiples.HelpVar)
 beginBOOLEAN(yyt->Multiples.IsFirstDesignator)
 beginBOOLEAN(yyt->Multiples.HasProcOrDimSucc)
 beginBOOLEAN(yyt->Multiples.WriteVectorIndex)
 begintTree(yyt->Multiples.ProcOrDimSpec)
 beginBOOLEAN(yyt->Multiples.WriteProcOrDimIndex)
 beginBOOLEAN(yyt->Multiples.IsCConst)
 beginBOOLEAN(yyt->Multiples.IsP3Const)
 beginBOOLEAN(yyt->Multiples.OpenAccessOrCall)
 beginBOOLEAN(yyt->Multiples.GlobalPtrs)
 begintStrings(yyt->Multiples.StrsIn)
 begintStrings(yyt->Multiples.StrsOut)
 yyt->Multiples.Mop = pMop;
 begintType(yyt->Multiples.MultiType)
 return yyt;
}

tTree mLastMultiple
# if defined __STDC__ | defined __cplusplus
(tTree pMop)
# else
(pMop)
tTree pMop;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kLastMultiple])
 yyt->Kind = kLastMultiple;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->LastMultiple.Env)
 beginBOOLEAN(yyt->LastMultiple.IsLval)
 begintType(yyt->LastMultiple.Type)
 beginINDEX(yyt->LastMultiple.Level)
 beginBOOLEAN(yyt->LastMultiple.UseHelpVar)
 beginBOOLEAN(yyt->LastMultiple.THelpVar)
 beginBOOLEAN(yyt->LastMultiple.TakeHelpVar)
 begintIdent(yyt->LastMultiple.HelpVar)
 beginBOOLEAN(yyt->LastMultiple.IsFirstDesignator)
 beginBOOLEAN(yyt->LastMultiple.HasProcOrDimSucc)
 beginBOOLEAN(yyt->LastMultiple.WriteVectorIndex)
 begintTree(yyt->LastMultiple.ProcOrDimSpec)
 beginBOOLEAN(yyt->LastMultiple.WriteProcOrDimIndex)
 beginBOOLEAN(yyt->LastMultiple.IsCConst)
 beginBOOLEAN(yyt->LastMultiple.IsP3Const)
 beginBOOLEAN(yyt->LastMultiple.OpenAccessOrCall)
 beginBOOLEAN(yyt->LastMultiple.GlobalPtrs)
 begintStrings(yyt->LastMultiple.StrsIn)
 begintStrings(yyt->LastMultiple.StrsOut)
 yyt->LastMultiple.Mop = pMop;
 begintType(yyt->LastMultiple.MultiType)
 return yyt;
}

tTree mMultiple
# if defined __STDC__ | defined __cplusplus
(tTree pMop, tPosition pPos, INDEX pOperator, tTree pMultiples)
# else
(pMop, pPos, pOperator, pMultiples)
tTree pMop;
tPosition pPos;
INDEX pOperator;
tTree pMultiples;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kMultiple])
 yyt->Kind = kMultiple;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Multiple.Env)
 beginBOOLEAN(yyt->Multiple.IsLval)
 begintType(yyt->Multiple.Type)
 beginINDEX(yyt->Multiple.Level)
 beginBOOLEAN(yyt->Multiple.UseHelpVar)
 beginBOOLEAN(yyt->Multiple.THelpVar)
 beginBOOLEAN(yyt->Multiple.TakeHelpVar)
 begintIdent(yyt->Multiple.HelpVar)
 beginBOOLEAN(yyt->Multiple.IsFirstDesignator)
 beginBOOLEAN(yyt->Multiple.HasProcOrDimSucc)
 beginBOOLEAN(yyt->Multiple.WriteVectorIndex)
 begintTree(yyt->Multiple.ProcOrDimSpec)
 beginBOOLEAN(yyt->Multiple.WriteProcOrDimIndex)
 beginBOOLEAN(yyt->Multiple.IsCConst)
 beginBOOLEAN(yyt->Multiple.IsP3Const)
 beginBOOLEAN(yyt->Multiple.OpenAccessOrCall)
 beginBOOLEAN(yyt->Multiple.GlobalPtrs)
 begintStrings(yyt->Multiple.StrsIn)
 begintStrings(yyt->Multiple.StrsOut)
 yyt->Multiple.Mop = pMop;
 begintType(yyt->Multiple.MultiType)
 yyt->Multiple.Pos = pPos;
 yyt->Multiple.Operator = pOperator;
 yyt->Multiple.Multiples = pMultiples;
 beginINDEX(yyt->Multiple.COperator)
 return yyt;
}

tTree mBinary
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, INDEX pOperator, tTree pLop, tTree pRop)
# else
(pPos, pOperator, pLop, pRop)
tPosition pPos;
INDEX pOperator;
tTree pLop;
tTree pRop;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kBinary])
 yyt->Kind = kBinary;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Binary.Env)
 beginBOOLEAN(yyt->Binary.IsLval)
 begintType(yyt->Binary.Type)
 beginINDEX(yyt->Binary.Level)
 beginBOOLEAN(yyt->Binary.UseHelpVar)
 beginBOOLEAN(yyt->Binary.THelpVar)
 beginBOOLEAN(yyt->Binary.TakeHelpVar)
 begintIdent(yyt->Binary.HelpVar)
 beginBOOLEAN(yyt->Binary.IsFirstDesignator)
 beginBOOLEAN(yyt->Binary.HasProcOrDimSucc)
 beginBOOLEAN(yyt->Binary.WriteVectorIndex)
 begintTree(yyt->Binary.ProcOrDimSpec)
 beginBOOLEAN(yyt->Binary.WriteProcOrDimIndex)
 beginBOOLEAN(yyt->Binary.IsCConst)
 beginBOOLEAN(yyt->Binary.IsP3Const)
 beginBOOLEAN(yyt->Binary.OpenAccessOrCall)
 beginBOOLEAN(yyt->Binary.GlobalPtrs)
 begintStrings(yyt->Binary.StrsIn)
 begintStrings(yyt->Binary.StrsOut)
 yyt->Binary.Pos = pPos;
 yyt->Binary.Operator = pOperator;
 yyt->Binary.Lop = pLop;
 yyt->Binary.Rop = pRop;
 beginINDEX(yyt->Binary.COperator)
 return yyt;
}

tTree mUnary
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, INDEX pOperator, tTree pMop)
# else
(pPos, pOperator, pMop)
tPosition pPos;
INDEX pOperator;
tTree pMop;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kUnary])
 yyt->Kind = kUnary;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Unary.Env)
 beginBOOLEAN(yyt->Unary.IsLval)
 begintType(yyt->Unary.Type)
 beginINDEX(yyt->Unary.Level)
 beginBOOLEAN(yyt->Unary.UseHelpVar)
 beginBOOLEAN(yyt->Unary.THelpVar)
 beginBOOLEAN(yyt->Unary.TakeHelpVar)
 begintIdent(yyt->Unary.HelpVar)
 beginBOOLEAN(yyt->Unary.IsFirstDesignator)
 beginBOOLEAN(yyt->Unary.HasProcOrDimSucc)
 beginBOOLEAN(yyt->Unary.WriteVectorIndex)
 begintTree(yyt->Unary.ProcOrDimSpec)
 beginBOOLEAN(yyt->Unary.WriteProcOrDimIndex)
 beginBOOLEAN(yyt->Unary.IsCConst)
 beginBOOLEAN(yyt->Unary.IsP3Const)
 beginBOOLEAN(yyt->Unary.OpenAccessOrCall)
 beginBOOLEAN(yyt->Unary.GlobalPtrs)
 begintStrings(yyt->Unary.StrsIn)
 begintStrings(yyt->Unary.StrsOut)
 yyt->Unary.Pos = pPos;
 yyt->Unary.Operator = pOperator;
 yyt->Unary.Mop = pMop;
 beginINDEX(yyt->Unary.COperator)
 return yyt;
}

tTree mIntConst
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, INDEX pKind, ULONG pIntVal)
# else
(pPos, pKind, pIntVal)
tPosition pPos;
INDEX pKind;
ULONG pIntVal;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kIntConst])
 yyt->Kind = kIntConst;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->IntConst.Env)
 beginBOOLEAN(yyt->IntConst.IsLval)
 begintType(yyt->IntConst.Type)
 beginINDEX(yyt->IntConst.Level)
 beginBOOLEAN(yyt->IntConst.UseHelpVar)
 beginBOOLEAN(yyt->IntConst.THelpVar)
 beginBOOLEAN(yyt->IntConst.TakeHelpVar)
 begintIdent(yyt->IntConst.HelpVar)
 beginBOOLEAN(yyt->IntConst.IsFirstDesignator)
 beginBOOLEAN(yyt->IntConst.HasProcOrDimSucc)
 beginBOOLEAN(yyt->IntConst.WriteVectorIndex)
 begintTree(yyt->IntConst.ProcOrDimSpec)
 beginBOOLEAN(yyt->IntConst.WriteProcOrDimIndex)
 beginBOOLEAN(yyt->IntConst.IsCConst)
 beginBOOLEAN(yyt->IntConst.IsP3Const)
 beginBOOLEAN(yyt->IntConst.OpenAccessOrCall)
 beginBOOLEAN(yyt->IntConst.GlobalPtrs)
 begintStrings(yyt->IntConst.StrsIn)
 begintStrings(yyt->IntConst.StrsOut)
 yyt->IntConst.Pos = pPos;
 yyt->IntConst.Kind = pKind;
 yyt->IntConst.IntVal = pIntVal;
 return yyt;
}

tTree mRealConst
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tStringRef pRealVal)
# else
(pPos, pRealVal)
tPosition pPos;
tStringRef pRealVal;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kRealConst])
 yyt->Kind = kRealConst;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->RealConst.Env)
 beginBOOLEAN(yyt->RealConst.IsLval)
 begintType(yyt->RealConst.Type)
 beginINDEX(yyt->RealConst.Level)
 beginBOOLEAN(yyt->RealConst.UseHelpVar)
 beginBOOLEAN(yyt->RealConst.THelpVar)
 beginBOOLEAN(yyt->RealConst.TakeHelpVar)
 begintIdent(yyt->RealConst.HelpVar)
 beginBOOLEAN(yyt->RealConst.IsFirstDesignator)
 beginBOOLEAN(yyt->RealConst.HasProcOrDimSucc)
 beginBOOLEAN(yyt->RealConst.WriteVectorIndex)
 begintTree(yyt->RealConst.ProcOrDimSpec)
 beginBOOLEAN(yyt->RealConst.WriteProcOrDimIndex)
 beginBOOLEAN(yyt->RealConst.IsCConst)
 beginBOOLEAN(yyt->RealConst.IsP3Const)
 beginBOOLEAN(yyt->RealConst.OpenAccessOrCall)
 beginBOOLEAN(yyt->RealConst.GlobalPtrs)
 begintStrings(yyt->RealConst.StrsIn)
 begintStrings(yyt->RealConst.StrsOut)
 yyt->RealConst.Pos = pPos;
 yyt->RealConst.RealVal = pRealVal;
 return yyt;
}

tTree mStringConst
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, tStringRef pStringVal)
# else
(pPos, pStringVal)
tPosition pPos;
tStringRef pStringVal;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kStringConst])
 yyt->Kind = kStringConst;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->StringConst.Env)
 beginBOOLEAN(yyt->StringConst.IsLval)
 begintType(yyt->StringConst.Type)
 beginINDEX(yyt->StringConst.Level)
 beginBOOLEAN(yyt->StringConst.UseHelpVar)
 beginBOOLEAN(yyt->StringConst.THelpVar)
 beginBOOLEAN(yyt->StringConst.TakeHelpVar)
 begintIdent(yyt->StringConst.HelpVar)
 beginBOOLEAN(yyt->StringConst.IsFirstDesignator)
 beginBOOLEAN(yyt->StringConst.HasProcOrDimSucc)
 beginBOOLEAN(yyt->StringConst.WriteVectorIndex)
 begintTree(yyt->StringConst.ProcOrDimSpec)
 beginBOOLEAN(yyt->StringConst.WriteProcOrDimIndex)
 beginBOOLEAN(yyt->StringConst.IsCConst)
 beginBOOLEAN(yyt->StringConst.IsP3Const)
 beginBOOLEAN(yyt->StringConst.OpenAccessOrCall)
 beginBOOLEAN(yyt->StringConst.GlobalPtrs)
 begintStrings(yyt->StringConst.StrsIn)
 begintStrings(yyt->StringConst.StrsOut)
 yyt->StringConst.Pos = pPos;
 yyt->StringConst.StringVal = pStringVal;
 return yyt;
}

tTree mCharConst
# if defined __STDC__ | defined __cplusplus
(tPosition pPos, UCHAR pCharVal)
# else
(pPos, pCharVal)
tPosition pPos;
UCHAR pCharVal;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kCharConst])
 yyt->Kind = kCharConst;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->CharConst.Env)
 beginBOOLEAN(yyt->CharConst.IsLval)
 begintType(yyt->CharConst.Type)
 beginINDEX(yyt->CharConst.Level)
 beginBOOLEAN(yyt->CharConst.UseHelpVar)
 beginBOOLEAN(yyt->CharConst.THelpVar)
 beginBOOLEAN(yyt->CharConst.TakeHelpVar)
 begintIdent(yyt->CharConst.HelpVar)
 beginBOOLEAN(yyt->CharConst.IsFirstDesignator)
 beginBOOLEAN(yyt->CharConst.HasProcOrDimSucc)
 beginBOOLEAN(yyt->CharConst.WriteVectorIndex)
 begintTree(yyt->CharConst.ProcOrDimSpec)
 beginBOOLEAN(yyt->CharConst.WriteProcOrDimIndex)
 beginBOOLEAN(yyt->CharConst.IsCConst)
 beginBOOLEAN(yyt->CharConst.IsP3Const)
 beginBOOLEAN(yyt->CharConst.OpenAccessOrCall)
 beginBOOLEAN(yyt->CharConst.GlobalPtrs)
 begintStrings(yyt->CharConst.StrsIn)
 begintStrings(yyt->CharConst.StrsOut)
 yyt->CharConst.Pos = pPos;
 yyt->CharConst.CharVal = pCharVal;
 return yyt;
}

tTree mFuncCall
# if defined __STDC__ | defined __cplusplus
(tTree pDesignator, tTree pActuals)
# else
(pDesignator, pActuals)
tTree pDesignator;
tTree pActuals;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kFuncCall])
 yyt->Kind = kFuncCall;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->FuncCall.Env)
 beginBOOLEAN(yyt->FuncCall.IsLval)
 begintType(yyt->FuncCall.Type)
 beginINDEX(yyt->FuncCall.Level)
 beginBOOLEAN(yyt->FuncCall.UseHelpVar)
 beginBOOLEAN(yyt->FuncCall.THelpVar)
 beginBOOLEAN(yyt->FuncCall.TakeHelpVar)
 begintIdent(yyt->FuncCall.HelpVar)
 beginBOOLEAN(yyt->FuncCall.IsFirstDesignator)
 beginBOOLEAN(yyt->FuncCall.HasProcOrDimSucc)
 beginBOOLEAN(yyt->FuncCall.WriteVectorIndex)
 begintTree(yyt->FuncCall.ProcOrDimSpec)
 beginBOOLEAN(yyt->FuncCall.WriteProcOrDimIndex)
 beginBOOLEAN(yyt->FuncCall.IsCConst)
 beginBOOLEAN(yyt->FuncCall.IsP3Const)
 beginBOOLEAN(yyt->FuncCall.OpenAccessOrCall)
 beginBOOLEAN(yyt->FuncCall.GlobalPtrs)
 begintStrings(yyt->FuncCall.StrsIn)
 begintStrings(yyt->FuncCall.StrsOut)
 yyt->FuncCall.Designator = pDesignator;
 yyt->FuncCall.Actuals = pActuals;
 return yyt;
}

tTree mMove
# if defined __STDC__ | defined __cplusplus
(tTree pDirSpec, tTree pExpr)
# else
(pDirSpec, pExpr)
tTree pDirSpec;
tTree pExpr;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kMove])
 yyt->Kind = kMove;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Move.Env)
 beginBOOLEAN(yyt->Move.IsLval)
 begintType(yyt->Move.Type)
 beginINDEX(yyt->Move.Level)
 beginBOOLEAN(yyt->Move.UseHelpVar)
 beginBOOLEAN(yyt->Move.THelpVar)
 beginBOOLEAN(yyt->Move.TakeHelpVar)
 begintIdent(yyt->Move.HelpVar)
 beginBOOLEAN(yyt->Move.IsFirstDesignator)
 beginBOOLEAN(yyt->Move.HasProcOrDimSucc)
 beginBOOLEAN(yyt->Move.WriteVectorIndex)
 begintTree(yyt->Move.ProcOrDimSpec)
 beginBOOLEAN(yyt->Move.WriteProcOrDimIndex)
 beginBOOLEAN(yyt->Move.IsCConst)
 beginBOOLEAN(yyt->Move.IsP3Const)
 beginBOOLEAN(yyt->Move.OpenAccessOrCall)
 beginBOOLEAN(yyt->Move.GlobalPtrs)
 begintStrings(yyt->Move.StrsIn)
 begintStrings(yyt->Move.StrsOut)
 yyt->Move.DirSpec = pDirSpec;
 yyt->Move.Expr = pExpr;
 return yyt;
}

tTree mReceive
# if defined __STDC__ | defined __cplusplus
(tTree pDirSpec, tTree pExpr)
# else
(pDirSpec, pExpr)
tTree pDirSpec;
tTree pExpr;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kReceive])
 yyt->Kind = kReceive;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Receive.Env)
 beginBOOLEAN(yyt->Receive.IsLval)
 begintType(yyt->Receive.Type)
 beginINDEX(yyt->Receive.Level)
 beginBOOLEAN(yyt->Receive.UseHelpVar)
 beginBOOLEAN(yyt->Receive.THelpVar)
 beginBOOLEAN(yyt->Receive.TakeHelpVar)
 begintIdent(yyt->Receive.HelpVar)
 beginBOOLEAN(yyt->Receive.IsFirstDesignator)
 beginBOOLEAN(yyt->Receive.HasProcOrDimSucc)
 beginBOOLEAN(yyt->Receive.WriteVectorIndex)
 begintTree(yyt->Receive.ProcOrDimSpec)
 beginBOOLEAN(yyt->Receive.WriteProcOrDimIndex)
 beginBOOLEAN(yyt->Receive.IsCConst)
 beginBOOLEAN(yyt->Receive.IsP3Const)
 beginBOOLEAN(yyt->Receive.OpenAccessOrCall)
 beginBOOLEAN(yyt->Receive.GlobalPtrs)
 begintStrings(yyt->Receive.StrsIn)
 begintStrings(yyt->Receive.StrsOut)
 yyt->Receive.DirSpec = pDirSpec;
 yyt->Receive.Expr = pExpr;
 return yyt;
}

tTree mReduce
# if defined __STDC__ | defined __cplusplus
(tTree pReduce, tTree pExpr)
# else
(pReduce, pExpr)
tTree pReduce;
tTree pExpr;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kReduce])
 yyt->Kind = kReduce;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Reduce.Env)
 beginBOOLEAN(yyt->Reduce.IsLval)
 begintType(yyt->Reduce.Type)
 beginINDEX(yyt->Reduce.Level)
 beginBOOLEAN(yyt->Reduce.UseHelpVar)
 beginBOOLEAN(yyt->Reduce.THelpVar)
 beginBOOLEAN(yyt->Reduce.TakeHelpVar)
 begintIdent(yyt->Reduce.HelpVar)
 beginBOOLEAN(yyt->Reduce.IsFirstDesignator)
 beginBOOLEAN(yyt->Reduce.HasProcOrDimSucc)
 beginBOOLEAN(yyt->Reduce.WriteVectorIndex)
 begintTree(yyt->Reduce.ProcOrDimSpec)
 beginBOOLEAN(yyt->Reduce.WriteProcOrDimIndex)
 beginBOOLEAN(yyt->Reduce.IsCConst)
 beginBOOLEAN(yyt->Reduce.IsP3Const)
 beginBOOLEAN(yyt->Reduce.OpenAccessOrCall)
 beginBOOLEAN(yyt->Reduce.GlobalPtrs)
 begintStrings(yyt->Reduce.StrsIn)
 begintStrings(yyt->Reduce.StrsOut)
 yyt->Reduce.Reduce = pReduce;
 yyt->Reduce.Expr = pExpr;
 return yyt;
}

tTree mSet
# if defined __STDC__ | defined __cplusplus
(tTree pBaseType, tTree pElems)
# else
(pBaseType, pElems)
tTree pBaseType;
tTree pElems;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kSet])
 yyt->Kind = kSet;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Set.Env)
 beginBOOLEAN(yyt->Set.IsLval)
 begintType(yyt->Set.Type)
 beginINDEX(yyt->Set.Level)
 beginBOOLEAN(yyt->Set.UseHelpVar)
 beginBOOLEAN(yyt->Set.THelpVar)
 beginBOOLEAN(yyt->Set.TakeHelpVar)
 begintIdent(yyt->Set.HelpVar)
 beginBOOLEAN(yyt->Set.IsFirstDesignator)
 beginBOOLEAN(yyt->Set.HasProcOrDimSucc)
 beginBOOLEAN(yyt->Set.WriteVectorIndex)
 begintTree(yyt->Set.ProcOrDimSpec)
 beginBOOLEAN(yyt->Set.WriteProcOrDimIndex)
 beginBOOLEAN(yyt->Set.IsCConst)
 beginBOOLEAN(yyt->Set.IsP3Const)
 beginBOOLEAN(yyt->Set.OpenAccessOrCall)
 beginBOOLEAN(yyt->Set.GlobalPtrs)
 begintStrings(yyt->Set.StrsIn)
 begintStrings(yyt->Set.StrsOut)
 yyt->Set.BaseType = pBaseType;
 yyt->Set.Elems = pElems;
 return yyt;
}

tTree mBitSet
# if defined __STDC__ | defined __cplusplus
(tTree pElems)
# else
(pElems)
tTree pElems;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kBitSet])
 yyt->Kind = kBitSet;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->BitSet.Env)
 beginBOOLEAN(yyt->BitSet.IsLval)
 begintType(yyt->BitSet.Type)
 beginINDEX(yyt->BitSet.Level)
 beginBOOLEAN(yyt->BitSet.UseHelpVar)
 beginBOOLEAN(yyt->BitSet.THelpVar)
 beginBOOLEAN(yyt->BitSet.TakeHelpVar)
 begintIdent(yyt->BitSet.HelpVar)
 beginBOOLEAN(yyt->BitSet.IsFirstDesignator)
 beginBOOLEAN(yyt->BitSet.HasProcOrDimSucc)
 beginBOOLEAN(yyt->BitSet.WriteVectorIndex)
 begintTree(yyt->BitSet.ProcOrDimSpec)
 beginBOOLEAN(yyt->BitSet.WriteProcOrDimIndex)
 beginBOOLEAN(yyt->BitSet.IsCConst)
 beginBOOLEAN(yyt->BitSet.IsP3Const)
 beginBOOLEAN(yyt->BitSet.OpenAccessOrCall)
 beginBOOLEAN(yyt->BitSet.GlobalPtrs)
 begintStrings(yyt->BitSet.StrsIn)
 begintStrings(yyt->BitSet.StrsOut)
 yyt->BitSet.Elems = pElems;
 return yyt;
}

tTree mDesignator
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kDesignator])
 yyt->Kind = kDesignator;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Designator.Env)
 beginBOOLEAN(yyt->Designator.IsLval)
 begintType(yyt->Designator.Type)
 beginINDEX(yyt->Designator.Level)
 beginBOOLEAN(yyt->Designator.UseHelpVar)
 beginBOOLEAN(yyt->Designator.THelpVar)
 beginBOOLEAN(yyt->Designator.TakeHelpVar)
 begintIdent(yyt->Designator.HelpVar)
 beginBOOLEAN(yyt->Designator.IsFirstDesignator)
 beginBOOLEAN(yyt->Designator.HasProcOrDimSucc)
 beginBOOLEAN(yyt->Designator.WriteVectorIndex)
 begintTree(yyt->Designator.ProcOrDimSpec)
 beginBOOLEAN(yyt->Designator.WriteProcOrDimIndex)
 beginBOOLEAN(yyt->Designator.IsCConst)
 beginBOOLEAN(yyt->Designator.IsP3Const)
 beginBOOLEAN(yyt->Designator.OpenAccessOrCall)
 beginBOOLEAN(yyt->Designator.GlobalPtrs)
 begintStrings(yyt->Designator.StrsIn)
 begintStrings(yyt->Designator.StrsOut)
 return yyt;
}

tTree mQualid
# if defined __STDC__ | defined __cplusplus
(tIdent pIdent, tPosition pPos)
# else
(pIdent, pPos)
tIdent pIdent;
tPosition pPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kQualid])
 yyt->Kind = kQualid;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Qualid.Env)
 beginBOOLEAN(yyt->Qualid.IsLval)
 begintType(yyt->Qualid.Type)
 beginINDEX(yyt->Qualid.Level)
 beginBOOLEAN(yyt->Qualid.UseHelpVar)
 beginBOOLEAN(yyt->Qualid.THelpVar)
 beginBOOLEAN(yyt->Qualid.TakeHelpVar)
 begintIdent(yyt->Qualid.HelpVar)
 beginBOOLEAN(yyt->Qualid.IsFirstDesignator)
 beginBOOLEAN(yyt->Qualid.HasProcOrDimSucc)
 beginBOOLEAN(yyt->Qualid.WriteVectorIndex)
 begintTree(yyt->Qualid.ProcOrDimSpec)
 beginBOOLEAN(yyt->Qualid.WriteProcOrDimIndex)
 beginBOOLEAN(yyt->Qualid.IsCConst)
 beginBOOLEAN(yyt->Qualid.IsP3Const)
 beginBOOLEAN(yyt->Qualid.OpenAccessOrCall)
 beginBOOLEAN(yyt->Qualid.GlobalPtrs)
 begintStrings(yyt->Qualid.StrsIn)
 begintStrings(yyt->Qualid.StrsOut)
 yyt->Qualid.Ident = pIdent;
 yyt->Qualid.Pos = pPos;
 begintObject(yyt->Qualid.Object)
 beginBOOLEAN(yyt->Qualid.IsGlobalPtr)
 return yyt;
}

tTree mQualid0
# if defined __STDC__ | defined __cplusplus
(tIdent pIdent, tPosition pPos)
# else
(pIdent, pPos)
tIdent pIdent;
tPosition pPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kQualid0])
 yyt->Kind = kQualid0;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Qualid0.Env)
 beginBOOLEAN(yyt->Qualid0.IsLval)
 begintType(yyt->Qualid0.Type)
 beginINDEX(yyt->Qualid0.Level)
 beginBOOLEAN(yyt->Qualid0.UseHelpVar)
 beginBOOLEAN(yyt->Qualid0.THelpVar)
 beginBOOLEAN(yyt->Qualid0.TakeHelpVar)
 begintIdent(yyt->Qualid0.HelpVar)
 beginBOOLEAN(yyt->Qualid0.IsFirstDesignator)
 beginBOOLEAN(yyt->Qualid0.HasProcOrDimSucc)
 beginBOOLEAN(yyt->Qualid0.WriteVectorIndex)
 begintTree(yyt->Qualid0.ProcOrDimSpec)
 beginBOOLEAN(yyt->Qualid0.WriteProcOrDimIndex)
 beginBOOLEAN(yyt->Qualid0.IsCConst)
 beginBOOLEAN(yyt->Qualid0.IsP3Const)
 beginBOOLEAN(yyt->Qualid0.OpenAccessOrCall)
 beginBOOLEAN(yyt->Qualid0.GlobalPtrs)
 begintStrings(yyt->Qualid0.StrsIn)
 begintStrings(yyt->Qualid0.StrsOut)
 yyt->Qualid0.Ident = pIdent;
 yyt->Qualid0.Pos = pPos;
 begintObject(yyt->Qualid0.Object)
 beginBOOLEAN(yyt->Qualid0.IsGlobalPtr)
 return yyt;
}

tTree mQualid1
# if defined __STDC__ | defined __cplusplus
(tIdent pIdent, tPosition pPos, tTree pQualid)
# else
(pIdent, pPos, pQualid)
tIdent pIdent;
tPosition pPos;
tTree pQualid;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kQualid1])
 yyt->Kind = kQualid1;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Qualid1.Env)
 beginBOOLEAN(yyt->Qualid1.IsLval)
 begintType(yyt->Qualid1.Type)
 beginINDEX(yyt->Qualid1.Level)
 beginBOOLEAN(yyt->Qualid1.UseHelpVar)
 beginBOOLEAN(yyt->Qualid1.THelpVar)
 beginBOOLEAN(yyt->Qualid1.TakeHelpVar)
 begintIdent(yyt->Qualid1.HelpVar)
 beginBOOLEAN(yyt->Qualid1.IsFirstDesignator)
 beginBOOLEAN(yyt->Qualid1.HasProcOrDimSucc)
 beginBOOLEAN(yyt->Qualid1.WriteVectorIndex)
 begintTree(yyt->Qualid1.ProcOrDimSpec)
 beginBOOLEAN(yyt->Qualid1.WriteProcOrDimIndex)
 beginBOOLEAN(yyt->Qualid1.IsCConst)
 beginBOOLEAN(yyt->Qualid1.IsP3Const)
 beginBOOLEAN(yyt->Qualid1.OpenAccessOrCall)
 beginBOOLEAN(yyt->Qualid1.GlobalPtrs)
 begintStrings(yyt->Qualid1.StrsIn)
 begintStrings(yyt->Qualid1.StrsOut)
 yyt->Qualid1.Ident = pIdent;
 yyt->Qualid1.Pos = pPos;
 begintObject(yyt->Qualid1.Object)
 beginBOOLEAN(yyt->Qualid1.IsGlobalPtr)
 yyt->Qualid1.Qualid = pQualid;
 return yyt;
}

tTree mProcessor
# if defined __STDC__ | defined __cplusplus
(tTree pDesignator, tPosition pPos, tTree pProc)
# else
(pDesignator, pPos, pProc)
tTree pDesignator;
tPosition pPos;
tTree pProc;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kProcessor])
 yyt->Kind = kProcessor;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Processor.Env)
 beginBOOLEAN(yyt->Processor.IsLval)
 begintType(yyt->Processor.Type)
 beginINDEX(yyt->Processor.Level)
 beginBOOLEAN(yyt->Processor.UseHelpVar)
 beginBOOLEAN(yyt->Processor.THelpVar)
 beginBOOLEAN(yyt->Processor.TakeHelpVar)
 begintIdent(yyt->Processor.HelpVar)
 beginBOOLEAN(yyt->Processor.IsFirstDesignator)
 beginBOOLEAN(yyt->Processor.HasProcOrDimSucc)
 beginBOOLEAN(yyt->Processor.WriteVectorIndex)
 begintTree(yyt->Processor.ProcOrDimSpec)
 beginBOOLEAN(yyt->Processor.WriteProcOrDimIndex)
 beginBOOLEAN(yyt->Processor.IsCConst)
 beginBOOLEAN(yyt->Processor.IsP3Const)
 beginBOOLEAN(yyt->Processor.OpenAccessOrCall)
 beginBOOLEAN(yyt->Processor.GlobalPtrs)
 begintStrings(yyt->Processor.StrsIn)
 begintStrings(yyt->Processor.StrsOut)
 yyt->Processor.Designator = pDesignator;
 yyt->Processor.Pos = pPos;
 yyt->Processor.Proc = pProc;
 return yyt;
}

tTree mDimensions
# if defined __STDC__ | defined __cplusplus
(tTree pDesignator, tPosition pPos, tTree pActuals)
# else
(pDesignator, pPos, pActuals)
tTree pDesignator;
tPosition pPos;
tTree pActuals;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kDimensions])
 yyt->Kind = kDimensions;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Dimensions.Env)
 beginBOOLEAN(yyt->Dimensions.IsLval)
 begintType(yyt->Dimensions.Type)
 beginINDEX(yyt->Dimensions.Level)
 beginBOOLEAN(yyt->Dimensions.UseHelpVar)
 beginBOOLEAN(yyt->Dimensions.THelpVar)
 beginBOOLEAN(yyt->Dimensions.TakeHelpVar)
 begintIdent(yyt->Dimensions.HelpVar)
 beginBOOLEAN(yyt->Dimensions.IsFirstDesignator)
 beginBOOLEAN(yyt->Dimensions.HasProcOrDimSucc)
 beginBOOLEAN(yyt->Dimensions.WriteVectorIndex)
 begintTree(yyt->Dimensions.ProcOrDimSpec)
 beginBOOLEAN(yyt->Dimensions.WriteProcOrDimIndex)
 beginBOOLEAN(yyt->Dimensions.IsCConst)
 beginBOOLEAN(yyt->Dimensions.IsP3Const)
 beginBOOLEAN(yyt->Dimensions.OpenAccessOrCall)
 beginBOOLEAN(yyt->Dimensions.GlobalPtrs)
 begintStrings(yyt->Dimensions.StrsIn)
 begintStrings(yyt->Dimensions.StrsOut)
 yyt->Dimensions.Designator = pDesignator;
 yyt->Dimensions.Pos = pPos;
 yyt->Dimensions.Actuals = pActuals;
 begintIdent(yyt->Dimensions.SecondHelpVar)
 return yyt;
}

tTree mSelect
# if defined __STDC__ | defined __cplusplus
(tTree pDesignator, tPosition pPos, tIdent pField)
# else
(pDesignator, pPos, pField)
tTree pDesignator;
tPosition pPos;
tIdent pField;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kSelect])
 yyt->Kind = kSelect;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Select.Env)
 beginBOOLEAN(yyt->Select.IsLval)
 begintType(yyt->Select.Type)
 beginINDEX(yyt->Select.Level)
 beginBOOLEAN(yyt->Select.UseHelpVar)
 beginBOOLEAN(yyt->Select.THelpVar)
 beginBOOLEAN(yyt->Select.TakeHelpVar)
 begintIdent(yyt->Select.HelpVar)
 beginBOOLEAN(yyt->Select.IsFirstDesignator)
 beginBOOLEAN(yyt->Select.HasProcOrDimSucc)
 beginBOOLEAN(yyt->Select.WriteVectorIndex)
 begintTree(yyt->Select.ProcOrDimSpec)
 beginBOOLEAN(yyt->Select.WriteProcOrDimIndex)
 beginBOOLEAN(yyt->Select.IsCConst)
 beginBOOLEAN(yyt->Select.IsP3Const)
 beginBOOLEAN(yyt->Select.OpenAccessOrCall)
 beginBOOLEAN(yyt->Select.GlobalPtrs)
 begintStrings(yyt->Select.StrsIn)
 begintStrings(yyt->Select.StrsOut)
 yyt->Select.Designator = pDesignator;
 yyt->Select.Pos = pPos;
 yyt->Select.Field = pField;
 begintObject(yyt->Select.Object)
 return yyt;
}

tTree mSubscript
# if defined __STDC__ | defined __cplusplus
(tTree pDesignator, tPosition pPos, tTree pIndex)
# else
(pDesignator, pPos, pIndex)
tTree pDesignator;
tPosition pPos;
tTree pIndex;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kSubscript])
 yyt->Kind = kSubscript;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Subscript.Env)
 beginBOOLEAN(yyt->Subscript.IsLval)
 begintType(yyt->Subscript.Type)
 beginINDEX(yyt->Subscript.Level)
 beginBOOLEAN(yyt->Subscript.UseHelpVar)
 beginBOOLEAN(yyt->Subscript.THelpVar)
 beginBOOLEAN(yyt->Subscript.TakeHelpVar)
 begintIdent(yyt->Subscript.HelpVar)
 beginBOOLEAN(yyt->Subscript.IsFirstDesignator)
 beginBOOLEAN(yyt->Subscript.HasProcOrDimSucc)
 beginBOOLEAN(yyt->Subscript.WriteVectorIndex)
 begintTree(yyt->Subscript.ProcOrDimSpec)
 beginBOOLEAN(yyt->Subscript.WriteProcOrDimIndex)
 beginBOOLEAN(yyt->Subscript.IsCConst)
 beginBOOLEAN(yyt->Subscript.IsP3Const)
 beginBOOLEAN(yyt->Subscript.OpenAccessOrCall)
 beginBOOLEAN(yyt->Subscript.GlobalPtrs)
 begintStrings(yyt->Subscript.StrsIn)
 begintStrings(yyt->Subscript.StrsOut)
 yyt->Subscript.Designator = pDesignator;
 yyt->Subscript.Pos = pPos;
 yyt->Subscript.Index = pIndex;
 return yyt;
}

tTree mDeref
# if defined __STDC__ | defined __cplusplus
(tTree pDesignator, tPosition pPos)
# else
(pDesignator, pPos)
tTree pDesignator;
tPosition pPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kDeref])
 yyt->Kind = kDeref;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Deref.Env)
 beginBOOLEAN(yyt->Deref.IsLval)
 begintType(yyt->Deref.Type)
 beginINDEX(yyt->Deref.Level)
 beginBOOLEAN(yyt->Deref.UseHelpVar)
 beginBOOLEAN(yyt->Deref.THelpVar)
 beginBOOLEAN(yyt->Deref.TakeHelpVar)
 begintIdent(yyt->Deref.HelpVar)
 beginBOOLEAN(yyt->Deref.IsFirstDesignator)
 beginBOOLEAN(yyt->Deref.HasProcOrDimSucc)
 beginBOOLEAN(yyt->Deref.WriteVectorIndex)
 begintTree(yyt->Deref.ProcOrDimSpec)
 beginBOOLEAN(yyt->Deref.WriteProcOrDimIndex)
 beginBOOLEAN(yyt->Deref.IsCConst)
 beginBOOLEAN(yyt->Deref.IsP3Const)
 beginBOOLEAN(yyt->Deref.OpenAccessOrCall)
 beginBOOLEAN(yyt->Deref.GlobalPtrs)
 begintStrings(yyt->Deref.StrsIn)
 begintStrings(yyt->Deref.StrsOut)
 yyt->Deref.Designator = pDesignator;
 yyt->Deref.Pos = pPos;
 return yyt;
}

tTree mDirSpec
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kDirSpec])
 yyt->Kind = kDirSpec;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->DirSpec.Env)
 begintObject(yyt->DirSpec.ConnectObj)
 beginINDEX(yyt->DirSpec.Level)
 beginBOOLEAN(yyt->DirSpec.OpenAccessOrCall)
 beginBOOLEAN(yyt->DirSpec.GlobalPtrs)
 begintStrings(yyt->DirSpec.StrsIn)
 begintStrings(yyt->DirSpec.StrsOut)
 return yyt;
}

tTree mFuncSpec
# if defined __STDC__ | defined __cplusplus
(tTree pDirOut, tTree pDirOutIndex, tTree pStep, tTree pReduce)
# else
(pDirOut, pDirOutIndex, pStep, pReduce)
tTree pDirOut;
tTree pDirOutIndex;
tTree pStep;
tTree pReduce;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kFuncSpec])
 yyt->Kind = kFuncSpec;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->FuncSpec.Env)
 begintObject(yyt->FuncSpec.ConnectObj)
 beginINDEX(yyt->FuncSpec.Level)
 beginBOOLEAN(yyt->FuncSpec.OpenAccessOrCall)
 beginBOOLEAN(yyt->FuncSpec.GlobalPtrs)
 begintStrings(yyt->FuncSpec.StrsIn)
 begintStrings(yyt->FuncSpec.StrsOut)
 yyt->FuncSpec.DirOut = pDirOut;
 yyt->FuncSpec.DirOutIndex = pDirOutIndex;
 yyt->FuncSpec.Step = pStep;
 yyt->FuncSpec.Reduce = pReduce;
 return yyt;
}

tTree mProcSpec
# if defined __STDC__ | defined __cplusplus
(tTree pExpr, tTree pReduce)
# else
(pExpr, pReduce)
tTree pExpr;
tTree pReduce;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kProcSpec])
 yyt->Kind = kProcSpec;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->ProcSpec.Env)
 begintObject(yyt->ProcSpec.ConnectObj)
 beginINDEX(yyt->ProcSpec.Level)
 beginBOOLEAN(yyt->ProcSpec.OpenAccessOrCall)
 beginBOOLEAN(yyt->ProcSpec.GlobalPtrs)
 begintStrings(yyt->ProcSpec.StrsIn)
 begintStrings(yyt->ProcSpec.StrsOut)
 yyt->ProcSpec.Expr = pExpr;
 yyt->ProcSpec.Reduce = pReduce;
 return yyt;
}

tTree mDimSpec
# if defined __STDC__ | defined __cplusplus
(tTree pActuals, tTree pReduce)
# else
(pActuals, pReduce)
tTree pActuals;
tTree pReduce;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kDimSpec])
 yyt->Kind = kDimSpec;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->DimSpec.Env)
 begintObject(yyt->DimSpec.ConnectObj)
 beginINDEX(yyt->DimSpec.Level)
 beginBOOLEAN(yyt->DimSpec.OpenAccessOrCall)
 beginBOOLEAN(yyt->DimSpec.GlobalPtrs)
 begintStrings(yyt->DimSpec.StrsIn)
 begintStrings(yyt->DimSpec.StrsOut)
 yyt->DimSpec.Actuals = pActuals;
 yyt->DimSpec.Reduce = pReduce;
 begintIdent(yyt->DimSpec.HelpVar)
 begintIdent(yyt->DimSpec.SecondHelpVar)
 return yyt;
}

tTree mElems
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kElems])
 yyt->Kind = kElems;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Elems.Env)
 beginINDEX(yyt->Elems.Level)
 beginBOOLEAN(yyt->Elems.UseHelpVar)
 beginBOOLEAN(yyt->Elems.IsCConst)
 beginBOOLEAN(yyt->Elems.IsP3Const)
 beginBOOLEAN(yyt->Elems.OpenAccessOrCall)
 beginBOOLEAN(yyt->Elems.GlobalPtrs)
 begintStrings(yyt->Elems.StrsIn)
 begintStrings(yyt->Elems.StrsOut)
 return yyt;
}

tTree mNoElem
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoElem])
 yyt->Kind = kNoElem;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->NoElem.Env)
 beginINDEX(yyt->NoElem.Level)
 beginBOOLEAN(yyt->NoElem.UseHelpVar)
 beginBOOLEAN(yyt->NoElem.IsCConst)
 beginBOOLEAN(yyt->NoElem.IsP3Const)
 beginBOOLEAN(yyt->NoElem.OpenAccessOrCall)
 beginBOOLEAN(yyt->NoElem.GlobalPtrs)
 begintStrings(yyt->NoElem.StrsIn)
 begintStrings(yyt->NoElem.StrsOut)
 return yyt;
}

tTree mElem
# if defined __STDC__ | defined __cplusplus
(tTree pNext)
# else
(pNext)
tTree pNext;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kElem])
 yyt->Kind = kElem;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Elem.Env)
 beginINDEX(yyt->Elem.Level)
 beginBOOLEAN(yyt->Elem.UseHelpVar)
 beginBOOLEAN(yyt->Elem.IsCConst)
 beginBOOLEAN(yyt->Elem.IsP3Const)
 beginBOOLEAN(yyt->Elem.OpenAccessOrCall)
 beginBOOLEAN(yyt->Elem.GlobalPtrs)
 begintStrings(yyt->Elem.StrsIn)
 begintStrings(yyt->Elem.StrsOut)
 yyt->Elem.Next = pNext;
 return yyt;
}

tTree mElemExpr
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tTree pElem)
# else
(pNext, pElem)
tTree pNext;
tTree pElem;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kElemExpr])
 yyt->Kind = kElemExpr;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->ElemExpr.Env)
 beginINDEX(yyt->ElemExpr.Level)
 beginBOOLEAN(yyt->ElemExpr.UseHelpVar)
 beginBOOLEAN(yyt->ElemExpr.IsCConst)
 beginBOOLEAN(yyt->ElemExpr.IsP3Const)
 beginBOOLEAN(yyt->ElemExpr.OpenAccessOrCall)
 beginBOOLEAN(yyt->ElemExpr.GlobalPtrs)
 begintStrings(yyt->ElemExpr.StrsIn)
 begintStrings(yyt->ElemExpr.StrsOut)
 yyt->ElemExpr.Next = pNext;
 yyt->ElemExpr.Elem = pElem;
 return yyt;
}

tTree mElemRange
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tTree pLwb, tTree pUpb)
# else
(pNext, pLwb, pUpb)
tTree pNext;
tTree pLwb;
tTree pUpb;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kElemRange])
 yyt->Kind = kElemRange;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->ElemRange.Env)
 beginINDEX(yyt->ElemRange.Level)
 beginBOOLEAN(yyt->ElemRange.UseHelpVar)
 beginBOOLEAN(yyt->ElemRange.IsCConst)
 beginBOOLEAN(yyt->ElemRange.IsP3Const)
 beginBOOLEAN(yyt->ElemRange.OpenAccessOrCall)
 beginBOOLEAN(yyt->ElemRange.GlobalPtrs)
 begintStrings(yyt->ElemRange.StrsIn)
 begintStrings(yyt->ElemRange.StrsOut)
 yyt->ElemRange.Next = pNext;
 yyt->ElemRange.Lwb = pLwb;
 yyt->ElemRange.Upb = pUpb;
 return yyt;
}

tTree mActuals
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kActuals])
 yyt->Kind = kActuals;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Actuals.Env)
 beginULONG(yyt->Actuals.ReduceNumber)
 beginULONG(yyt->Actuals.ActualsNumber)
 begintTypes(yyt->Actuals.Types)
 begintTypes(yyt->Actuals.Formals)
 beginINDEX(yyt->Actuals.Level)
 beginBOOLEAN(yyt->Actuals.UseHelpVar)
 beginBOOLEAN(yyt->Actuals.IsCConst)
 beginBOOLEAN(yyt->Actuals.IsP3Const)
 beginBOOLEAN(yyt->Actuals.OpenAccessOrCall)
 beginBOOLEAN(yyt->Actuals.GlobalPtrs)
 begintStrings(yyt->Actuals.StrsIn)
 begintStrings(yyt->Actuals.StrsOut)
 return yyt;
}

tTree mNoActual
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoActual])
 yyt->Kind = kNoActual;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->NoActual.Env)
 beginULONG(yyt->NoActual.ReduceNumber)
 beginULONG(yyt->NoActual.ActualsNumber)
 begintTypes(yyt->NoActual.Types)
 begintTypes(yyt->NoActual.Formals)
 beginINDEX(yyt->NoActual.Level)
 beginBOOLEAN(yyt->NoActual.UseHelpVar)
 beginBOOLEAN(yyt->NoActual.IsCConst)
 beginBOOLEAN(yyt->NoActual.IsP3Const)
 beginBOOLEAN(yyt->NoActual.OpenAccessOrCall)
 beginBOOLEAN(yyt->NoActual.GlobalPtrs)
 begintStrings(yyt->NoActual.StrsIn)
 begintStrings(yyt->NoActual.StrsOut)
 return yyt;
}

tTree mActual
# if defined __STDC__ | defined __cplusplus
(tTree pNext)
# else
(pNext)
tTree pNext;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kActual])
 yyt->Kind = kActual;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Actual.Env)
 beginULONG(yyt->Actual.ReduceNumber)
 beginULONG(yyt->Actual.ActualsNumber)
 begintTypes(yyt->Actual.Types)
 begintTypes(yyt->Actual.Formals)
 beginINDEX(yyt->Actual.Level)
 beginBOOLEAN(yyt->Actual.UseHelpVar)
 beginBOOLEAN(yyt->Actual.IsCConst)
 beginBOOLEAN(yyt->Actual.IsP3Const)
 beginBOOLEAN(yyt->Actual.OpenAccessOrCall)
 beginBOOLEAN(yyt->Actual.GlobalPtrs)
 begintStrings(yyt->Actual.StrsIn)
 begintStrings(yyt->Actual.StrsOut)
 yyt->Actual.Next = pNext;
 beginBOOLEAN(yyt->Actual.IsVAR)
 begintType(yyt->Actual.Formal)
 return yyt;
}

tTree mActualExpr
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tTree pExpr)
# else
(pNext, pExpr)
tTree pNext;
tTree pExpr;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kActualExpr])
 yyt->Kind = kActualExpr;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->ActualExpr.Env)
 beginULONG(yyt->ActualExpr.ReduceNumber)
 beginULONG(yyt->ActualExpr.ActualsNumber)
 begintTypes(yyt->ActualExpr.Types)
 begintTypes(yyt->ActualExpr.Formals)
 beginINDEX(yyt->ActualExpr.Level)
 beginBOOLEAN(yyt->ActualExpr.UseHelpVar)
 beginBOOLEAN(yyt->ActualExpr.IsCConst)
 beginBOOLEAN(yyt->ActualExpr.IsP3Const)
 beginBOOLEAN(yyt->ActualExpr.OpenAccessOrCall)
 beginBOOLEAN(yyt->ActualExpr.GlobalPtrs)
 begintStrings(yyt->ActualExpr.StrsIn)
 begintStrings(yyt->ActualExpr.StrsOut)
 yyt->ActualExpr.Next = pNext;
 beginBOOLEAN(yyt->ActualExpr.IsVAR)
 begintType(yyt->ActualExpr.Formal)
 yyt->ActualExpr.Expr = pExpr;
 begintIdent(yyt->ActualExpr.HelpVar)
 begintIdent(yyt->ActualExpr.String)
 return yyt;
}

tTree mActualRange
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tTree pLwb, tTree pUpb)
# else
(pNext, pLwb, pUpb)
tTree pNext;
tTree pLwb;
tTree pUpb;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kActualRange])
 yyt->Kind = kActualRange;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->ActualRange.Env)
 beginULONG(yyt->ActualRange.ReduceNumber)
 beginULONG(yyt->ActualRange.ActualsNumber)
 begintTypes(yyt->ActualRange.Types)
 begintTypes(yyt->ActualRange.Formals)
 beginINDEX(yyt->ActualRange.Level)
 beginBOOLEAN(yyt->ActualRange.UseHelpVar)
 beginBOOLEAN(yyt->ActualRange.IsCConst)
 beginBOOLEAN(yyt->ActualRange.IsP3Const)
 beginBOOLEAN(yyt->ActualRange.OpenAccessOrCall)
 beginBOOLEAN(yyt->ActualRange.GlobalPtrs)
 begintStrings(yyt->ActualRange.StrsIn)
 begintStrings(yyt->ActualRange.StrsOut)
 yyt->ActualRange.Next = pNext;
 beginBOOLEAN(yyt->ActualRange.IsVAR)
 begintType(yyt->ActualRange.Formal)
 yyt->ActualRange.Lwb = pLwb;
 yyt->ActualRange.Upb = pUpb;
 return yyt;
}

tTree mActualReduce
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tTree pQualid)
# else
(pNext, pQualid)
tTree pNext;
tTree pQualid;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kActualReduce])
 yyt->Kind = kActualReduce;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->ActualReduce.Env)
 beginULONG(yyt->ActualReduce.ReduceNumber)
 beginULONG(yyt->ActualReduce.ActualsNumber)
 begintTypes(yyt->ActualReduce.Types)
 begintTypes(yyt->ActualReduce.Formals)
 beginINDEX(yyt->ActualReduce.Level)
 beginBOOLEAN(yyt->ActualReduce.UseHelpVar)
 beginBOOLEAN(yyt->ActualReduce.IsCConst)
 beginBOOLEAN(yyt->ActualReduce.IsP3Const)
 beginBOOLEAN(yyt->ActualReduce.OpenAccessOrCall)
 beginBOOLEAN(yyt->ActualReduce.GlobalPtrs)
 begintStrings(yyt->ActualReduce.StrsIn)
 begintStrings(yyt->ActualReduce.StrsOut)
 yyt->ActualReduce.Next = pNext;
 beginBOOLEAN(yyt->ActualReduce.IsVAR)
 begintType(yyt->ActualReduce.Formal)
 yyt->ActualReduce.Qualid = pQualid;
 begintIdent(yyt->ActualReduce.HelpVar)
 return yyt;
}

tTree mActualStar
# if defined __STDC__ | defined __cplusplus
(tTree pNext)
# else
(pNext)
tTree pNext;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kActualStar])
 yyt->Kind = kActualStar;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->ActualStar.Env)
 beginULONG(yyt->ActualStar.ReduceNumber)
 beginULONG(yyt->ActualStar.ActualsNumber)
 begintTypes(yyt->ActualStar.Types)
 begintTypes(yyt->ActualStar.Formals)
 beginINDEX(yyt->ActualStar.Level)
 beginBOOLEAN(yyt->ActualStar.UseHelpVar)
 beginBOOLEAN(yyt->ActualStar.IsCConst)
 beginBOOLEAN(yyt->ActualStar.IsP3Const)
 beginBOOLEAN(yyt->ActualStar.OpenAccessOrCall)
 beginBOOLEAN(yyt->ActualStar.GlobalPtrs)
 begintStrings(yyt->ActualStar.StrsIn)
 begintStrings(yyt->ActualStar.StrsOut)
 yyt->ActualStar.Next = pNext;
 beginBOOLEAN(yyt->ActualStar.IsVAR)
 begintType(yyt->ActualStar.Formal)
 begintIdent(yyt->ActualStar.HelpVar)
 return yyt;
}

tTree mStmts
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kStmts])
 yyt->Kind = kStmts;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Stmts.Env)
 beginINDEX(yyt->Stmts.Level)
 beginBOOLEAN(yyt->Stmts.IsVectorExit)
 begintConfigs(yyt->Stmts.ExitConfigsIn)
 begintConfigs(yyt->Stmts.ExitConfigsOut)
 begintConfigs(yyt->Stmts.ReturnConfigsIn)
 begintConfigs(yyt->Stmts.ReturnConfigsOut)
 beginBOOLEAN(yyt->Stmts.GlobalPtrs)
 begintStrings(yyt->Stmts.StrsIn)
 begintStrings(yyt->Stmts.StrsOut)
 begintType(yyt->Stmts.Type)
 return yyt;
}

tTree mNoStmt
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoStmt])
 yyt->Kind = kNoStmt;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->NoStmt.Env)
 beginINDEX(yyt->NoStmt.Level)
 beginBOOLEAN(yyt->NoStmt.IsVectorExit)
 begintConfigs(yyt->NoStmt.ExitConfigsIn)
 begintConfigs(yyt->NoStmt.ExitConfigsOut)
 begintConfigs(yyt->NoStmt.ReturnConfigsIn)
 begintConfigs(yyt->NoStmt.ReturnConfigsOut)
 beginBOOLEAN(yyt->NoStmt.GlobalPtrs)
 begintStrings(yyt->NoStmt.StrsIn)
 begintStrings(yyt->NoStmt.StrsOut)
 begintType(yyt->NoStmt.Type)
 return yyt;
}

tTree mStmt
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tPosition pPos)
# else
(pNext, pPos)
tTree pNext;
tPosition pPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kStmt])
 yyt->Kind = kStmt;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Stmt.Env)
 beginINDEX(yyt->Stmt.Level)
 beginBOOLEAN(yyt->Stmt.IsVectorExit)
 begintConfigs(yyt->Stmt.ExitConfigsIn)
 begintConfigs(yyt->Stmt.ExitConfigsOut)
 begintConfigs(yyt->Stmt.ReturnConfigsIn)
 begintConfigs(yyt->Stmt.ReturnConfigsOut)
 beginBOOLEAN(yyt->Stmt.GlobalPtrs)
 begintStrings(yyt->Stmt.StrsIn)
 begintStrings(yyt->Stmt.StrsOut)
 begintType(yyt->Stmt.Type)
 yyt->Stmt.Next = pNext;
 yyt->Stmt.Pos = pPos;
 return yyt;
}

tTree mAssign
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tPosition pPos, tTree pDesignator, tTree pExpr)
# else
(pNext, pPos, pDesignator, pExpr)
tTree pNext;
tPosition pPos;
tTree pDesignator;
tTree pExpr;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kAssign])
 yyt->Kind = kAssign;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Assign.Env)
 beginINDEX(yyt->Assign.Level)
 beginBOOLEAN(yyt->Assign.IsVectorExit)
 begintConfigs(yyt->Assign.ExitConfigsIn)
 begintConfigs(yyt->Assign.ExitConfigsOut)
 begintConfigs(yyt->Assign.ReturnConfigsIn)
 begintConfigs(yyt->Assign.ReturnConfigsOut)
 beginBOOLEAN(yyt->Assign.GlobalPtrs)
 begintStrings(yyt->Assign.StrsIn)
 begintStrings(yyt->Assign.StrsOut)
 begintType(yyt->Assign.Type)
 yyt->Assign.Next = pNext;
 yyt->Assign.Pos = pPos;
 yyt->Assign.Designator = pDesignator;
 yyt->Assign.Expr = pExpr;
 return yyt;
}

tTree mCall
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tPosition pPos, tTree pDesignator, tTree pActuals)
# else
(pNext, pPos, pDesignator, pActuals)
tTree pNext;
tPosition pPos;
tTree pDesignator;
tTree pActuals;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kCall])
 yyt->Kind = kCall;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Call.Env)
 beginINDEX(yyt->Call.Level)
 beginBOOLEAN(yyt->Call.IsVectorExit)
 begintConfigs(yyt->Call.ExitConfigsIn)
 begintConfigs(yyt->Call.ExitConfigsOut)
 begintConfigs(yyt->Call.ReturnConfigsIn)
 begintConfigs(yyt->Call.ReturnConfigsOut)
 beginBOOLEAN(yyt->Call.GlobalPtrs)
 begintStrings(yyt->Call.StrsIn)
 begintStrings(yyt->Call.StrsOut)
 begintType(yyt->Call.Type)
 yyt->Call.Next = pNext;
 yyt->Call.Pos = pPos;
 yyt->Call.Designator = pDesignator;
 yyt->Call.Actuals = pActuals;
 begintType(yyt->Call.CheckProcs)
 begintObject(yyt->Call.AllocOrDealloc)
 return yyt;
}

tTree mIf
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tPosition pPos, tTree pCond, tTree pThen, tTree pElsifs, tTree pElse)
# else
(pNext, pPos, pCond, pThen, pElsifs, pElse)
tTree pNext;
tPosition pPos;
tTree pCond;
tTree pThen;
tTree pElsifs;
tTree pElse;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kIf])
 yyt->Kind = kIf;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->If.Env)
 beginINDEX(yyt->If.Level)
 beginBOOLEAN(yyt->If.IsVectorExit)
 begintConfigs(yyt->If.ExitConfigsIn)
 begintConfigs(yyt->If.ExitConfigsOut)
 begintConfigs(yyt->If.ReturnConfigsIn)
 begintConfigs(yyt->If.ReturnConfigsOut)
 beginBOOLEAN(yyt->If.GlobalPtrs)
 begintStrings(yyt->If.StrsIn)
 begintStrings(yyt->If.StrsOut)
 begintType(yyt->If.Type)
 yyt->If.Next = pNext;
 yyt->If.Pos = pPos;
 yyt->If.Cond = pCond;
 yyt->If.Then = pThen;
 yyt->If.Elsifs = pElsifs;
 yyt->If.Else = pElse;
 return yyt;
}

tTree mCase
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tPosition pPos, BOOLEAN pDefault, tTree pExpr, tTree pCases, tTree pElse)
# else
(pNext, pPos, pDefault, pExpr, pCases, pElse)
tTree pNext;
tPosition pPos;
BOOLEAN pDefault;
tTree pExpr;
tTree pCases;
tTree pElse;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kCase])
 yyt->Kind = kCase;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Case.Env)
 beginINDEX(yyt->Case.Level)
 beginBOOLEAN(yyt->Case.IsVectorExit)
 begintConfigs(yyt->Case.ExitConfigsIn)
 begintConfigs(yyt->Case.ExitConfigsOut)
 begintConfigs(yyt->Case.ReturnConfigsIn)
 begintConfigs(yyt->Case.ReturnConfigsOut)
 beginBOOLEAN(yyt->Case.GlobalPtrs)
 begintStrings(yyt->Case.StrsIn)
 begintStrings(yyt->Case.StrsOut)
 begintType(yyt->Case.Type)
 yyt->Case.Next = pNext;
 yyt->Case.Pos = pPos;
 yyt->Case.Default = pDefault;
 yyt->Case.Expr = pExpr;
 yyt->Case.Cases = pCases;
 yyt->Case.Else = pElse;
 return yyt;
}

tTree mWhile
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tPosition pPos, tTree pCond, tTree pStmts)
# else
(pNext, pPos, pCond, pStmts)
tTree pNext;
tPosition pPos;
tTree pCond;
tTree pStmts;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kWhile])
 yyt->Kind = kWhile;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->While.Env)
 beginINDEX(yyt->While.Level)
 beginBOOLEAN(yyt->While.IsVectorExit)
 begintConfigs(yyt->While.ExitConfigsIn)
 begintConfigs(yyt->While.ExitConfigsOut)
 begintConfigs(yyt->While.ReturnConfigsIn)
 begintConfigs(yyt->While.ReturnConfigsOut)
 beginBOOLEAN(yyt->While.GlobalPtrs)
 begintStrings(yyt->While.StrsIn)
 begintStrings(yyt->While.StrsOut)
 begintType(yyt->While.Type)
 yyt->While.Next = pNext;
 yyt->While.Pos = pPos;
 yyt->While.Cond = pCond;
 yyt->While.Stmts = pStmts;
 return yyt;
}

tTree mRepeat
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tPosition pPos, tTree pStmts, tTree pCond)
# else
(pNext, pPos, pStmts, pCond)
tTree pNext;
tPosition pPos;
tTree pStmts;
tTree pCond;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kRepeat])
 yyt->Kind = kRepeat;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Repeat.Env)
 beginINDEX(yyt->Repeat.Level)
 beginBOOLEAN(yyt->Repeat.IsVectorExit)
 begintConfigs(yyt->Repeat.ExitConfigsIn)
 begintConfigs(yyt->Repeat.ExitConfigsOut)
 begintConfigs(yyt->Repeat.ReturnConfigsIn)
 begintConfigs(yyt->Repeat.ReturnConfigsOut)
 beginBOOLEAN(yyt->Repeat.GlobalPtrs)
 begintStrings(yyt->Repeat.StrsIn)
 begintStrings(yyt->Repeat.StrsOut)
 begintType(yyt->Repeat.Type)
 yyt->Repeat.Next = pNext;
 yyt->Repeat.Pos = pPos;
 yyt->Repeat.Stmts = pStmts;
 yyt->Repeat.Cond = pCond;
 return yyt;
}

tTree mLoop
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tPosition pPos, tTree pStmts)
# else
(pNext, pPos, pStmts)
tTree pNext;
tPosition pPos;
tTree pStmts;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kLoop])
 yyt->Kind = kLoop;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Loop.Env)
 beginINDEX(yyt->Loop.Level)
 beginBOOLEAN(yyt->Loop.IsVectorExit)
 begintConfigs(yyt->Loop.ExitConfigsIn)
 begintConfigs(yyt->Loop.ExitConfigsOut)
 begintConfigs(yyt->Loop.ReturnConfigsIn)
 begintConfigs(yyt->Loop.ReturnConfigsOut)
 beginBOOLEAN(yyt->Loop.GlobalPtrs)
 begintStrings(yyt->Loop.StrsIn)
 begintStrings(yyt->Loop.StrsOut)
 begintType(yyt->Loop.Type)
 yyt->Loop.Next = pNext;
 yyt->Loop.Pos = pPos;
 yyt->Loop.Stmts = pStmts;
 begintConfigs(yyt->Loop.ExitConfigs)
 return yyt;
}

tTree mLooppar
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tPosition pPos, tTree pQualid, tTree pStmts)
# else
(pNext, pPos, pQualid, pStmts)
tTree pNext;
tPosition pPos;
tTree pQualid;
tTree pStmts;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kLooppar])
 yyt->Kind = kLooppar;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Looppar.Env)
 beginINDEX(yyt->Looppar.Level)
 beginBOOLEAN(yyt->Looppar.IsVectorExit)
 begintConfigs(yyt->Looppar.ExitConfigsIn)
 begintConfigs(yyt->Looppar.ExitConfigsOut)
 begintConfigs(yyt->Looppar.ReturnConfigsIn)
 begintConfigs(yyt->Looppar.ReturnConfigsOut)
 beginBOOLEAN(yyt->Looppar.GlobalPtrs)
 begintStrings(yyt->Looppar.StrsIn)
 begintStrings(yyt->Looppar.StrsOut)
 begintType(yyt->Looppar.Type)
 yyt->Looppar.Next = pNext;
 yyt->Looppar.Pos = pPos;
 yyt->Looppar.Qualid = pQualid;
 yyt->Looppar.Stmts = pStmts;
 begintConfigs(yyt->Looppar.ExitConfigs)
 return yyt;
}

tTree mFor
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tPosition pPos, tTree pQualid, tTree pFrom, tTree pTo, tTree pBy, tTree pStmts)
# else
(pNext, pPos, pQualid, pFrom, pTo, pBy, pStmts)
tTree pNext;
tPosition pPos;
tTree pQualid;
tTree pFrom;
tTree pTo;
tTree pBy;
tTree pStmts;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kFor])
 yyt->Kind = kFor;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->For.Env)
 beginINDEX(yyt->For.Level)
 beginBOOLEAN(yyt->For.IsVectorExit)
 begintConfigs(yyt->For.ExitConfigsIn)
 begintConfigs(yyt->For.ExitConfigsOut)
 begintConfigs(yyt->For.ReturnConfigsIn)
 begintConfigs(yyt->For.ReturnConfigsOut)
 beginBOOLEAN(yyt->For.GlobalPtrs)
 begintStrings(yyt->For.StrsIn)
 begintStrings(yyt->For.StrsOut)
 begintType(yyt->For.Type)
 yyt->For.Next = pNext;
 yyt->For.Pos = pPos;
 yyt->For.Qualid = pQualid;
 yyt->For.From = pFrom;
 yyt->For.To = pTo;
 yyt->For.By = pBy;
 yyt->For.Stmts = pStmts;
 begintValue(yyt->For.ToVal)
 begintValue(yyt->For.ByVal)
 return yyt;
}

tTree mWith
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tPosition pPos, tTree pDesignator, tTree pStmts)
# else
(pNext, pPos, pDesignator, pStmts)
tTree pNext;
tPosition pPos;
tTree pDesignator;
tTree pStmts;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kWith])
 yyt->Kind = kWith;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->With.Env)
 beginINDEX(yyt->With.Level)
 beginBOOLEAN(yyt->With.IsVectorExit)
 begintConfigs(yyt->With.ExitConfigsIn)
 begintConfigs(yyt->With.ExitConfigsOut)
 begintConfigs(yyt->With.ReturnConfigsIn)
 begintConfigs(yyt->With.ReturnConfigsOut)
 beginBOOLEAN(yyt->With.GlobalPtrs)
 begintStrings(yyt->With.StrsIn)
 begintStrings(yyt->With.StrsOut)
 begintType(yyt->With.Type)
 yyt->With.Next = pNext;
 yyt->With.Pos = pPos;
 yyt->With.Designator = pDesignator;
 yyt->With.Stmts = pStmts;
 return yyt;
}

tTree mAll
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tPosition pPos, tTree pQualid, tTree pStmts)
# else
(pNext, pPos, pQualid, pStmts)
tTree pNext;
tPosition pPos;
tTree pQualid;
tTree pStmts;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kAll])
 yyt->Kind = kAll;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->All.Env)
 beginINDEX(yyt->All.Level)
 beginBOOLEAN(yyt->All.IsVectorExit)
 begintConfigs(yyt->All.ExitConfigsIn)
 begintConfigs(yyt->All.ExitConfigsOut)
 begintConfigs(yyt->All.ReturnConfigsIn)
 begintConfigs(yyt->All.ReturnConfigsOut)
 beginBOOLEAN(yyt->All.GlobalPtrs)
 begintStrings(yyt->All.StrsIn)
 begintStrings(yyt->All.StrsOut)
 begintType(yyt->All.Type)
 yyt->All.Next = pNext;
 yyt->All.Pos = pPos;
 yyt->All.Qualid = pQualid;
 yyt->All.Stmts = pStmts;
 return yyt;
}

tTree mSend
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tPosition pPos, tTree pDirSpec, tTree pFrom, tTree pTo)
# else
(pNext, pPos, pDirSpec, pFrom, pTo)
tTree pNext;
tPosition pPos;
tTree pDirSpec;
tTree pFrom;
tTree pTo;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kSend])
 yyt->Kind = kSend;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Send.Env)
 beginINDEX(yyt->Send.Level)
 beginBOOLEAN(yyt->Send.IsVectorExit)
 begintConfigs(yyt->Send.ExitConfigsIn)
 begintConfigs(yyt->Send.ExitConfigsOut)
 begintConfigs(yyt->Send.ReturnConfigsIn)
 begintConfigs(yyt->Send.ReturnConfigsOut)
 beginBOOLEAN(yyt->Send.GlobalPtrs)
 begintStrings(yyt->Send.StrsIn)
 begintStrings(yyt->Send.StrsOut)
 begintType(yyt->Send.Type)
 yyt->Send.Next = pNext;
 yyt->Send.Pos = pPos;
 yyt->Send.DirSpec = pDirSpec;
 yyt->Send.From = pFrom;
 yyt->Send.To = pTo;
 return yyt;
}

tTree mLoad
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tPosition pPos, BOOLEAN pSizeDef, tTree pWhat, tTree pFrom, tTree pSize)
# else
(pNext, pPos, pSizeDef, pWhat, pFrom, pSize)
tTree pNext;
tPosition pPos;
BOOLEAN pSizeDef;
tTree pWhat;
tTree pFrom;
tTree pSize;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kLoad])
 yyt->Kind = kLoad;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Load.Env)
 beginINDEX(yyt->Load.Level)
 beginBOOLEAN(yyt->Load.IsVectorExit)
 begintConfigs(yyt->Load.ExitConfigsIn)
 begintConfigs(yyt->Load.ExitConfigsOut)
 begintConfigs(yyt->Load.ReturnConfigsIn)
 begintConfigs(yyt->Load.ReturnConfigsOut)
 beginBOOLEAN(yyt->Load.GlobalPtrs)
 begintStrings(yyt->Load.StrsIn)
 begintStrings(yyt->Load.StrsOut)
 begintType(yyt->Load.Type)
 yyt->Load.Next = pNext;
 yyt->Load.Pos = pPos;
 yyt->Load.SizeDef = pSizeDef;
 yyt->Load.What = pWhat;
 yyt->Load.From = pFrom;
 yyt->Load.Size = pSize;
 return yyt;
}

tTree mStore
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tPosition pPos, BOOLEAN pSizeDef, tTree pWhat, tTree pTo, tTree pSize)
# else
(pNext, pPos, pSizeDef, pWhat, pTo, pSize)
tTree pNext;
tPosition pPos;
BOOLEAN pSizeDef;
tTree pWhat;
tTree pTo;
tTree pSize;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kStore])
 yyt->Kind = kStore;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Store.Env)
 beginINDEX(yyt->Store.Level)
 beginBOOLEAN(yyt->Store.IsVectorExit)
 begintConfigs(yyt->Store.ExitConfigsIn)
 begintConfigs(yyt->Store.ExitConfigsOut)
 begintConfigs(yyt->Store.ReturnConfigsIn)
 begintConfigs(yyt->Store.ReturnConfigsOut)
 beginBOOLEAN(yyt->Store.GlobalPtrs)
 begintStrings(yyt->Store.StrsIn)
 begintStrings(yyt->Store.StrsOut)
 begintType(yyt->Store.Type)
 yyt->Store.Next = pNext;
 yyt->Store.Pos = pPos;
 yyt->Store.SizeDef = pSizeDef;
 yyt->Store.What = pWhat;
 yyt->Store.To = pTo;
 yyt->Store.Size = pSize;
 return yyt;
}

tTree mExit
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tPosition pPos)
# else
(pNext, pPos)
tTree pNext;
tPosition pPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kExit])
 yyt->Kind = kExit;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Exit.Env)
 beginINDEX(yyt->Exit.Level)
 beginBOOLEAN(yyt->Exit.IsVectorExit)
 begintConfigs(yyt->Exit.ExitConfigsIn)
 begintConfigs(yyt->Exit.ExitConfigsOut)
 begintConfigs(yyt->Exit.ReturnConfigsIn)
 begintConfigs(yyt->Exit.ReturnConfigsOut)
 beginBOOLEAN(yyt->Exit.GlobalPtrs)
 begintStrings(yyt->Exit.StrsIn)
 begintStrings(yyt->Exit.StrsOut)
 begintType(yyt->Exit.Type)
 yyt->Exit.Next = pNext;
 yyt->Exit.Pos = pPos;
 return yyt;
}

tTree mReturn0
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tPosition pPos)
# else
(pNext, pPos)
tTree pNext;
tPosition pPos;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kReturn0])
 yyt->Kind = kReturn0;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Return0.Env)
 beginINDEX(yyt->Return0.Level)
 beginBOOLEAN(yyt->Return0.IsVectorExit)
 begintConfigs(yyt->Return0.ExitConfigsIn)
 begintConfigs(yyt->Return0.ExitConfigsOut)
 begintConfigs(yyt->Return0.ReturnConfigsIn)
 begintConfigs(yyt->Return0.ReturnConfigsOut)
 beginBOOLEAN(yyt->Return0.GlobalPtrs)
 begintStrings(yyt->Return0.StrsIn)
 begintStrings(yyt->Return0.StrsOut)
 begintType(yyt->Return0.Type)
 yyt->Return0.Next = pNext;
 yyt->Return0.Pos = pPos;
 begintType(yyt->Return0.ResultType)
 return yyt;
}

tTree mReturn1
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tPosition pPos, tTree pResult)
# else
(pNext, pPos, pResult)
tTree pNext;
tPosition pPos;
tTree pResult;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kReturn1])
 yyt->Kind = kReturn1;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Return1.Env)
 beginINDEX(yyt->Return1.Level)
 beginBOOLEAN(yyt->Return1.IsVectorExit)
 begintConfigs(yyt->Return1.ExitConfigsIn)
 begintConfigs(yyt->Return1.ExitConfigsOut)
 begintConfigs(yyt->Return1.ReturnConfigsIn)
 begintConfigs(yyt->Return1.ReturnConfigsOut)
 beginBOOLEAN(yyt->Return1.GlobalPtrs)
 begintStrings(yyt->Return1.StrsIn)
 begintStrings(yyt->Return1.StrsOut)
 begintType(yyt->Return1.Type)
 yyt->Return1.Next = pNext;
 yyt->Return1.Pos = pPos;
 yyt->Return1.Result = pResult;
 beginBOOLEAN(yyt->Return1.OpenAccessOrCall)
 begintType(yyt->Return1.ResultType)
 return yyt;
}

tTree mElsifs
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kElsifs])
 yyt->Kind = kElsifs;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Elsifs.Env)
 beginINDEX(yyt->Elsifs.Level)
 beginBOOLEAN(yyt->Elsifs.IsVectorExit)
 begintConfigs(yyt->Elsifs.ExitConfigsIn)
 begintConfigs(yyt->Elsifs.ExitConfigsOut)
 begintConfigs(yyt->Elsifs.ReturnConfigsIn)
 begintConfigs(yyt->Elsifs.ReturnConfigsOut)
 beginBOOLEAN(yyt->Elsifs.GlobalPtrs)
 begintStrings(yyt->Elsifs.StrsIn)
 begintStrings(yyt->Elsifs.StrsOut)
 begintType(yyt->Elsifs.Type)
 return yyt;
}

tTree mNoElsif
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoElsif])
 yyt->Kind = kNoElsif;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->NoElsif.Env)
 beginINDEX(yyt->NoElsif.Level)
 beginBOOLEAN(yyt->NoElsif.IsVectorExit)
 begintConfigs(yyt->NoElsif.ExitConfigsIn)
 begintConfigs(yyt->NoElsif.ExitConfigsOut)
 begintConfigs(yyt->NoElsif.ReturnConfigsIn)
 begintConfigs(yyt->NoElsif.ReturnConfigsOut)
 beginBOOLEAN(yyt->NoElsif.GlobalPtrs)
 begintStrings(yyt->NoElsif.StrsIn)
 begintStrings(yyt->NoElsif.StrsOut)
 begintType(yyt->NoElsif.Type)
 return yyt;
}

tTree mElsif
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tTree pCond, tTree pStmts)
# else
(pNext, pCond, pStmts)
tTree pNext;
tTree pCond;
tTree pStmts;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kElsif])
 yyt->Kind = kElsif;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Elsif.Env)
 beginINDEX(yyt->Elsif.Level)
 beginBOOLEAN(yyt->Elsif.IsVectorExit)
 begintConfigs(yyt->Elsif.ExitConfigsIn)
 begintConfigs(yyt->Elsif.ExitConfigsOut)
 begintConfigs(yyt->Elsif.ReturnConfigsIn)
 begintConfigs(yyt->Elsif.ReturnConfigsOut)
 beginBOOLEAN(yyt->Elsif.GlobalPtrs)
 begintStrings(yyt->Elsif.StrsIn)
 begintStrings(yyt->Elsif.StrsOut)
 begintType(yyt->Elsif.Type)
 yyt->Elsif.Next = pNext;
 yyt->Elsif.Cond = pCond;
 yyt->Elsif.Stmts = pStmts;
 return yyt;
}

tTree mCases
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kCases])
 yyt->Kind = kCases;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Cases.Env)
 beginINDEX(yyt->Cases.Level)
 beginBOOLEAN(yyt->Cases.IsVectorExit)
 begintConfigs(yyt->Cases.ExitConfigsIn)
 begintConfigs(yyt->Cases.ExitConfigsOut)
 begintConfigs(yyt->Cases.ReturnConfigsIn)
 begintConfigs(yyt->Cases.ReturnConfigsOut)
 beginBOOLEAN(yyt->Cases.GlobalPtrs)
 begintStrings(yyt->Cases.StrsIn)
 begintStrings(yyt->Cases.StrsOut)
 begintType(yyt->Cases.Type)
 return yyt;
}

tTree mNoCase
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoCase])
 yyt->Kind = kNoCase;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->NoCase.Env)
 beginINDEX(yyt->NoCase.Level)
 beginBOOLEAN(yyt->NoCase.IsVectorExit)
 begintConfigs(yyt->NoCase.ExitConfigsIn)
 begintConfigs(yyt->NoCase.ExitConfigsOut)
 begintConfigs(yyt->NoCase.ReturnConfigsIn)
 begintConfigs(yyt->NoCase.ReturnConfigsOut)
 beginBOOLEAN(yyt->NoCase.GlobalPtrs)
 begintStrings(yyt->NoCase.StrsIn)
 begintStrings(yyt->NoCase.StrsOut)
 begintType(yyt->NoCase.Type)
 return yyt;
}

tTree mCases1
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tTree pLabels, tTree pStmts)
# else
(pNext, pLabels, pStmts)
tTree pNext;
tTree pLabels;
tTree pStmts;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kCases1])
 yyt->Kind = kCases1;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Cases1.Env)
 beginINDEX(yyt->Cases1.Level)
 beginBOOLEAN(yyt->Cases1.IsVectorExit)
 begintConfigs(yyt->Cases1.ExitConfigsIn)
 begintConfigs(yyt->Cases1.ExitConfigsOut)
 begintConfigs(yyt->Cases1.ReturnConfigsIn)
 begintConfigs(yyt->Cases1.ReturnConfigsOut)
 beginBOOLEAN(yyt->Cases1.GlobalPtrs)
 begintStrings(yyt->Cases1.StrsIn)
 begintStrings(yyt->Cases1.StrsOut)
 begintType(yyt->Cases1.Type)
 yyt->Cases1.Next = pNext;
 yyt->Cases1.Labels = pLabels;
 yyt->Cases1.Stmts = pStmts;
 return yyt;
}

tTree mLabels
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kLabels])
 yyt->Kind = kLabels;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Labels.Env)
 return yyt;
}

tTree mNoLabel
# if defined __STDC__ | defined __cplusplus
()
# else
()
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kNoLabel])
 yyt->Kind = kNoLabel;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->NoLabel.Env)
 return yyt;
}

tTree mLabel
# if defined __STDC__ | defined __cplusplus
(tTree pNext)
# else
(pNext)
tTree pNext;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kLabel])
 yyt->Kind = kLabel;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->Label.Env)
 yyt->Label.Next = pNext;
 return yyt;
}

tTree mLabelExpr
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tTree pExpr)
# else
(pNext, pExpr)
tTree pNext;
tTree pExpr;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kLabelExpr])
 yyt->Kind = kLabelExpr;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->LabelExpr.Env)
 yyt->LabelExpr.Next = pNext;
 yyt->LabelExpr.Expr = pExpr;
 begintValue(yyt->LabelExpr.LabelVal)
 return yyt;
}

tTree mLabelRange
# if defined __STDC__ | defined __cplusplus
(tTree pNext, tTree pLwb, tTree pUpb)
# else
(pNext, pLwb, pUpb)
tTree pNext;
tTree pLwb;
tTree pUpb;
# endif
{
 register tTree yyt;
 yyALLOC (yyt, Tree_NodeSize [kLabelRange])
 yyt->Kind = kLabelRange;
 yyt->yyHead.yyMark = 0;
 begintEnv(yyt->LabelRange.Env)
 yyt->LabelRange.Next = pNext;
 yyt->LabelRange.Lwb = pLwb;
 yyt->LabelRange.Upb = pUpb;
 begintValue(yyt->LabelRange.LwbVal)
 begintValue(yyt->LabelRange.UpbVal)
 return yyt;
}

typedef tTree * yyPtrtTree;

static FILE * yyf;

static void yyMark
# if defined __STDC__ | defined __cplusplus
 (register tTree yyt)
# else
 (yyt) register tTree yyt;
# endif
{
 for (;;) {
  if (yyt == NoTree || ++ yyt->yyHead.yyMark > 1) return;

  switch (yyt->Kind) {
case kROOT:
yyt = yyt->ROOT.CompUnits; break;
case kCompUnit:
yyt = yyt->CompUnit.Next; break;
case kDefMod:
yyMark (yyt->DefMod.Imports);
yyMark (yyt->DefMod.Exports);
yyMark (yyt->DefMod.Decls);
yyt = yyt->DefMod.Next; break;
case kImplMod:
yyMark (yyt->ImplMod.Imports);
yyMark (yyt->ImplMod.Decls);
yyMark (yyt->ImplMod.Stmts);
yyt = yyt->ImplMod.Next; break;
case kImport:
yyt = yyt->Import.Next; break;
case kFrom:
yyMark (yyt->From.ImpIds);
yyt = yyt->From.Next; break;
case kObjects:
yyMark (yyt->Objects.ImpIds);
yyt = yyt->Objects.Next; break;
case kImpId:
yyt = yyt->ImpId.Next; break;
case kExport:
yyt = yyt->Export.ExpIds; break;
case kExpId:
yyt = yyt->ExpId.Next; break;
case kDecl:
yyt = yyt->Decl.Next; break;
case kVar:
yyMark (yyt->Var.VarIds);
yyMark (yyt->Var.Type);
yyt = yyt->Var.Next; break;
case kObject:
yyt = yyt->Object.Next; break;
case kConnectFrom:
yyMark (yyt->ConnectFrom.From);
yyMark (yyt->ConnectFrom.To);
yyMark (yyt->ConnectFrom.ConnectDecls);
yyt = yyt->ConnectFrom.Next; break;
case kConnectDecls:
yyMark (yyt->ConnectDecls.Index);
yyMark (yyt->ConnectDecls.Config);
yyMark (yyt->ConnectDecls.Actuals);
yyMark (yyt->ConnectDecls.DirIn);
yyt = yyt->ConnectDecls.Next; break;
case kConfig:
yyMark (yyt->Config.Actuals);
yyMark (yyt->Config.Qualid);
yyt = yyt->Config.Next; break;
case kConst:
yyMark (yyt->Const.Expr);
yyt = yyt->Const.Next; break;
case kTypeDecl:
yyMark (yyt->TypeDecl.Type);
yyt = yyt->TypeDecl.Next; break;
case kProc:
yyMark (yyt->Proc.Formals);
yyMark (yyt->Proc.ResultType);
yyMark (yyt->Proc.Decls);
yyMark (yyt->Proc.Stmts);
yyt = yyt->Proc.Next; break;
case kProcHead:
yyMark (yyt->ProcHead.Formals);
yyMark (yyt->ProcHead.ResultType);
yyt = yyt->ProcHead.Next; break;
case kOpaque:
yyt = yyt->Opaque.Next; break;
case kConnectDest:
yyMark (yyt->ConnectDest.Expr);
yyMark (yyt->ConnectDest.Config);
yyMark (yyt->ConnectDest.Actuals);
yyt = yyt->ConnectDest.Next; break;
case kConnectDestUni:
yyMark (yyt->ConnectDestUni.Expr);
yyMark (yyt->ConnectDestUni.Config);
yyMark (yyt->ConnectDestUni.Actuals);
yyt = yyt->ConnectDestUni.Next; break;
case kConnectDestBi:
yyMark (yyt->ConnectDestBi.Expr);
yyMark (yyt->ConnectDestBi.Config);
yyMark (yyt->ConnectDestBi.Actuals);
yyMark (yyt->ConnectDestBi.Index);
yyt = yyt->ConnectDestBi.Next; break;
case kVarId:
yyt = yyt->VarId.Next; break;
case kFormal:
yyMark (yyt->Formal.ParIds);
yyMark (yyt->Formal.Type);
yyt = yyt->Formal.Next; break;
case kParId:
yyt = yyt->ParId.Next; break;
case kVector:
yyMark (yyt->Vector.Config);
yyt = yyt->Vector.Scalar; break;
case kArray:
yyMark (yyt->Array.Index);
yyt = yyt->Array.ElemType; break;
case kRecord:
yyt = yyt->Record.Fields; break;
case kSetType:
yyt = yyt->SetType.BaseType; break;
case kPointer:
yyt = yyt->Pointer.TargetType; break;
case kProcType:
yyMark (yyt->ProcType.FormalTypes);
yyt = yyt->ProcType.ResultType; break;
case kEnumeration:
yyt = yyt->Enumeration.EnumIds; break;
case kSubrange:
yyMark (yyt->Subrange.BaseType);
yyMark (yyt->Subrange.Lwb);
yyt = yyt->Subrange.Upb; break;
case kTypeId1:
yyt = yyt->TypeId1.TypeId; break;
case kField:
yyt = yyt->Field.Next; break;
case kRecordSect:
yyMark (yyt->RecordSect.FieldIds);
yyMark (yyt->RecordSect.Type);
yyt = yyt->RecordSect.Next; break;
case kVariantSect:
yyMark (yyt->VariantSect.TagField);
yyMark (yyt->VariantSect.Variants);
yyMark (yyt->VariantSect.Else);
yyt = yyt->VariantSect.Next; break;
case kFieldId:
yyt = yyt->FieldId.Next; break;
case kTagField:
yyt = yyt->TagField.Type; break;
case kTagField1:
yyt = yyt->TagField1.Type; break;
case kTagField2:
yyt = yyt->TagField2.Type; break;
case kVariant:
yyMark (yyt->Variant.Labels);
yyMark (yyt->Variant.Variant);
yyt = yyt->Variant.Next; break;
case kFormalType:
yyMark (yyt->FormalType.Type);
yyt = yyt->FormalType.Next; break;
case kEnumId:
yyt = yyt->EnumId.Next; break;
case kMultiples:
yyt = yyt->Multiples.Mop; break;
case kLastMultiple:
yyt = yyt->LastMultiple.Mop; break;
case kMultiple:
yyMark (yyt->Multiple.Mop);
yyt = yyt->Multiple.Multiples; break;
case kBinary:
yyMark (yyt->Binary.Lop);
yyt = yyt->Binary.Rop; break;
case kUnary:
yyt = yyt->Unary.Mop; break;
case kFuncCall:
yyMark (yyt->FuncCall.Designator);
yyt = yyt->FuncCall.Actuals; break;
case kMove:
yyMark (yyt->Move.DirSpec);
yyt = yyt->Move.Expr; break;
case kReceive:
yyMark (yyt->Receive.DirSpec);
yyt = yyt->Receive.Expr; break;
case kReduce:
yyMark (yyt->Reduce.Reduce);
yyt = yyt->Reduce.Expr; break;
case kSet:
yyMark (yyt->Set.BaseType);
yyt = yyt->Set.Elems; break;
case kBitSet:
yyt = yyt->BitSet.Elems; break;
case kQualid1:
yyt = yyt->Qualid1.Qualid; break;
case kProcessor:
yyMark (yyt->Processor.Designator);
yyt = yyt->Processor.Proc; break;
case kDimensions:
yyMark (yyt->Dimensions.Designator);
yyt = yyt->Dimensions.Actuals; break;
case kSelect:
yyt = yyt->Select.Designator; break;
case kSubscript:
yyMark (yyt->Subscript.Designator);
yyt = yyt->Subscript.Index; break;
case kDeref:
yyt = yyt->Deref.Designator; break;
case kFuncSpec:
yyMark (yyt->FuncSpec.DirOut);
yyMark (yyt->FuncSpec.DirOutIndex);
yyMark (yyt->FuncSpec.Step);
yyt = yyt->FuncSpec.Reduce; break;
case kProcSpec:
yyMark (yyt->ProcSpec.Expr);
yyt = yyt->ProcSpec.Reduce; break;
case kDimSpec:
yyMark (yyt->DimSpec.Actuals);
yyt = yyt->DimSpec.Reduce; break;
case kElem:
yyt = yyt->Elem.Next; break;
case kElemExpr:
yyMark (yyt->ElemExpr.Elem);
yyt = yyt->ElemExpr.Next; break;
case kElemRange:
yyMark (yyt->ElemRange.Lwb);
yyMark (yyt->ElemRange.Upb);
yyt = yyt->ElemRange.Next; break;
case kActual:
yyt = yyt->Actual.Next; break;
case kActualExpr:
yyMark (yyt->ActualExpr.Expr);
yyt = yyt->ActualExpr.Next; break;
case kActualRange:
yyMark (yyt->ActualRange.Lwb);
yyMark (yyt->ActualRange.Upb);
yyt = yyt->ActualRange.Next; break;
case kActualReduce:
yyMark (yyt->ActualReduce.Qualid);
yyt = yyt->ActualReduce.Next; break;
case kActualStar:
yyt = yyt->ActualStar.Next; break;
case kStmt:
yyt = yyt->Stmt.Next; break;
case kAssign:
yyMark (yyt->Assign.Designator);
yyMark (yyt->Assign.Expr);
yyt = yyt->Assign.Next; break;
case kCall:
yyMark (yyt->Call.Designator);
yyMark (yyt->Call.Actuals);
yyt = yyt->Call.Next; break;
case kIf:
yyMark (yyt->If.Cond);
yyMark (yyt->If.Then);
yyMark (yyt->If.Elsifs);
yyMark (yyt->If.Else);
yyt = yyt->If.Next; break;
case kCase:
yyMark (yyt->Case.Expr);
yyMark (yyt->Case.Cases);
yyMark (yyt->Case.Else);
yyt = yyt->Case.Next; break;
case kWhile:
yyMark (yyt->While.Cond);
yyMark (yyt->While.Stmts);
yyt = yyt->While.Next; break;
case kRepeat:
yyMark (yyt->Repeat.Stmts);
yyMark (yyt->Repeat.Cond);
yyt = yyt->Repeat.Next; break;
case kLoop:
yyMark (yyt->Loop.Stmts);
yyt = yyt->Loop.Next; break;
case kLooppar:
yyMark (yyt->Looppar.Qualid);
yyMark (yyt->Looppar.Stmts);
yyt = yyt->Looppar.Next; break;
case kFor:
yyMark (yyt->For.Qualid);
yyMark (yyt->For.From);
yyMark (yyt->For.To);
yyMark (yyt->For.By);
yyMark (yyt->For.Stmts);
yyt = yyt->For.Next; break;
case kWith:
yyMark (yyt->With.Designator);
yyMark (yyt->With.Stmts);
yyt = yyt->With.Next; break;
case kAll:
yyMark (yyt->All.Qualid);
yyMark (yyt->All.Stmts);
yyt = yyt->All.Next; break;
case kSend:
yyMark (yyt->Send.DirSpec);
yyMark (yyt->Send.From);
yyMark (yyt->Send.To);
yyt = yyt->Send.Next; break;
case kLoad:
yyMark (yyt->Load.What);
yyMark (yyt->Load.From);
yyMark (yyt->Load.Size);
yyt = yyt->Load.Next; break;
case kStore:
yyMark (yyt->Store.What);
yyMark (yyt->Store.To);
yyMark (yyt->Store.Size);
yyt = yyt->Store.Next; break;
case kExit:
yyt = yyt->Exit.Next; break;
case kReturn0:
yyt = yyt->Return0.Next; break;
case kReturn1:
yyMark (yyt->Return1.Result);
yyt = yyt->Return1.Next; break;
case kElsif:
yyMark (yyt->Elsif.Cond);
yyMark (yyt->Elsif.Stmts);
yyt = yyt->Elsif.Next; break;
case kCases1:
yyMark (yyt->Cases1.Labels);
yyMark (yyt->Cases1.Stmts);
yyt = yyt->Cases1.Next; break;
case kLabel:
yyt = yyt->Label.Next; break;
case kLabelExpr:
yyMark (yyt->LabelExpr.Expr);
yyt = yyt->LabelExpr.Next; break;
case kLabelRange:
yyMark (yyt->LabelRange.Lwb);
yyMark (yyt->LabelRange.Upb);
yyt = yyt->LabelRange.Next; break;
  default: return;
  }
 }
}

# define yyInitTreeStoreSize 32
# define yyMapToTree(yyLabel) yyTreeStorePtr [yyLabel]

static unsigned long yyTreeStoreSize = yyInitTreeStoreSize;
static tTree yyTreeStore [yyInitTreeStoreSize];
static tTree * yyTreeStorePtr = yyTreeStore;
static int yyLabelCount;
static short yyRecursionLevel = 0;

static Tree_tLabel yyMapToLabel
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 register int yyi;
 for (yyi = 1; yyi <= yyLabelCount; yyi ++) if (yyTreeStorePtr [yyi] == yyt) return yyi;
 if (++ yyLabelCount == yyTreeStoreSize)
  ExtendArray ((char * *) & yyTreeStorePtr, & yyTreeStoreSize, sizeof (tTree));
 yyTreeStorePtr [yyLabelCount] = yyt;
 return yyLabelCount;
}

static void yyWriteTree ();

static void yyWriteNl () { (void) putc ('\n', yyf); }

static void yyWriteSelector
# if defined __STDC__ | defined __cplusplus
 (char * yys)
# else
 (yys) char * yys;
# endif
{
 register int yyi = 16 - strlen (yys);
 (void) fputs (yys, yyf);
 while (yyi -- > 0) (void) putc (' ', yyf);
 (void) fputs (" = ", yyf);
}

static void yyWriteHex
# if defined __STDC__ | defined __cplusplus
 (unsigned char * yyx, int yysize)
# else
 (yyx, yysize) unsigned char * yyx; int yysize;
# endif
{ register int yyi; for (yyi = 0; yyi < yysize; yyi ++) (void) fprintf (yyf, "%02x ", yyx [yyi]); }

static void yyWriteAdr
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 if (yyt == NoTree) (void) fputs ("NoTree", yyf);
 else yyWriteHex ((unsigned char *) & yyt, sizeof (yyt));
 yyWriteNl ();
}

static void yWriteNodeROOT
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("CompUnits"); yyWriteAdr (yyt->ROOT.CompUnits);
}

static void yWriteNodeCompUnits
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Objects1"); writetObjects (yyt->CompUnits.Objects1) yyWriteNl ();
 yyWriteSelector ("Objects2"); writetVoid (yyt->CompUnits.Objects2) yyWriteNl ();
 yyWriteSelector ("Objects3"); writetObjects (yyt->CompUnits.Objects3) yyWriteNl ();
 yyWriteSelector ("Objects4In"); writetVoid (yyt->CompUnits.Objects4In) yyWriteNl ();
 yyWriteSelector ("Objects4Out"); writetVoid (yyt->CompUnits.Objects4Out) yyWriteNl ();
 yyWriteSelector ("Env1"); writetEnv (yyt->CompUnits.Env1) yyWriteNl ();
 yyWriteSelector ("Env2"); writetVoid (yyt->CompUnits.Env2) yyWriteNl ();
 yyWriteSelector ("Env3"); writetEnv (yyt->CompUnits.Env3) yyWriteNl ();
 yyWriteSelector ("ConfigGroupIn"); writeINDEX (yyt->CompUnits.ConfigGroupIn) yyWriteNl ();
 yyWriteSelector ("ImplIdent"); writetIdent (yyt->CompUnits.ImplIdent) yyWriteNl ();
 yyWriteSelector ("ImplTypes"); writetObjects (yyt->CompUnits.ImplTypes) yyWriteNl ();
 yyWriteSelector ("PosIn"); writeINDEX (yyt->CompUnits.PosIn) yyWriteNl ();
 yyWriteSelector ("PosOut"); writeINDEX (yyt->CompUnits.PosOut) yyWriteNl ();
 yyWriteSelector ("IdsIn"); writetIdents (yyt->CompUnits.IdsIn) yyWriteNl ();
 yyWriteSelector ("IdsOut"); writetIdents (yyt->CompUnits.IdsOut) yyWriteNl ();
}

static void yWriteNodeNoCompUnit
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeCompUnits (yyt); 
}

static void yWriteNodeCompUnit
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeCompUnits (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->CompUnit.Next);
 yyWriteSelector ("Kind"); writeINDEX (yyt->CompUnit.Kind) yyWriteNl ();
 yyWriteSelector ("Ident"); writetIdent (yyt->CompUnit.Ident) yyWriteNl ();
 yyWriteSelector ("Pos"); writetPosition (yyt->CompUnit.Pos) yyWriteNl ();
 yyWriteSelector ("Object"); writetObject (yyt->CompUnit.Object) yyWriteNl ();
 yyWriteSelector ("RealName"); writetIdent (yyt->CompUnit.RealName) yyWriteNl ();
}

static void yWriteNodeDefMod
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeCompUnit (yyt); 
 yyWriteSelector ("Imports"); yyWriteAdr (yyt->DefMod.Imports);
 yyWriteSelector ("Exports"); yyWriteAdr (yyt->DefMod.Exports);
 yyWriteSelector ("Decls"); yyWriteAdr (yyt->DefMod.Decls);
}

static void yWriteNodeImplMod
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeCompUnit (yyt); 
 yyWriteSelector ("Imports"); yyWriteAdr (yyt->ImplMod.Imports);
 yyWriteSelector ("Decls"); yyWriteAdr (yyt->ImplMod.Decls);
 yyWriteSelector ("Stmts"); yyWriteAdr (yyt->ImplMod.Stmts);
 yyWriteSelector ("BeginPos"); writetPosition (yyt->ImplMod.BeginPos) yyWriteNl ();
 yyWriteSelector ("DefObjects1"); writetObjects (yyt->ImplMod.DefObjects1) yyWriteNl ();
 yyWriteSelector ("DefObjects3"); writetObjects (yyt->ImplMod.DefObjects3) yyWriteNl ();
 yyWriteSelector ("GlobalPtrs"); writetCObjects (yyt->ImplMod.GlobalPtrs) yyWriteNl ();
 yyWriteSelector ("Strings"); writetStrings (yyt->ImplMod.Strings) yyWriteNl ();
}

static void yWriteNodeImports
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Objects1"); writetObjects (yyt->Imports.Objects1) yyWriteNl ();
 yyWriteSelector ("Objects2"); writetObjects (yyt->Imports.Objects2) yyWriteNl ();
 yyWriteSelector ("Env1"); writetEnv (yyt->Imports.Env1) yyWriteNl ();
 yyWriteSelector ("Env2"); writetEnv (yyt->Imports.Env2) yyWriteNl ();
 yyWriteSelector ("LocalIdsIn"); writetLocalIds (yyt->Imports.LocalIdsIn) yyWriteNl ();
 yyWriteSelector ("LocalIdsOut"); writetLocalIds (yyt->Imports.LocalIdsOut) yyWriteNl ();
}

static void yWriteNodeNoImport
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeImports (yyt); 
}

static void yWriteNodeImport
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeImports (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->Import.Next);
}

static void yWriteNodeFrom
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeImport (yyt); 
 yyWriteSelector ("Ident"); writetIdent (yyt->From.Ident) yyWriteNl ();
 yyWriteSelector ("Pos"); writetPosition (yyt->From.Pos) yyWriteNl ();
 yyWriteSelector ("ImpIds"); yyWriteAdr (yyt->From.ImpIds);
 yyWriteSelector ("Object1"); writetObject (yyt->From.Object1) yyWriteNl ();
 yyWriteSelector ("Object2"); writetObject (yyt->From.Object2) yyWriteNl ();
}

static void yWriteNodeObjects
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeImport (yyt); 
 yyWriteSelector ("ImpIds"); yyWriteAdr (yyt->Objects.ImpIds);
}

static void yWriteNodeImpIds
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Objects1"); writetObjects (yyt->ImpIds.Objects1) yyWriteNl ();
 yyWriteSelector ("Objects2"); writetObjects (yyt->ImpIds.Objects2) yyWriteNl ();
 yyWriteSelector ("Env1"); writetEnv (yyt->ImpIds.Env1) yyWriteNl ();
 yyWriteSelector ("Env2"); writetEnv (yyt->ImpIds.Env2) yyWriteNl ();
 yyWriteSelector ("LocalIdsIn"); writetLocalIds (yyt->ImpIds.LocalIdsIn) yyWriteNl ();
 yyWriteSelector ("LocalIdsOut"); writetLocalIds (yyt->ImpIds.LocalIdsOut) yyWriteNl ();
}

static void yWriteNodeNoImpId
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeImpIds (yyt); 
}

static void yWriteNodeImpId
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeImpIds (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->ImpId.Next);
 yyWriteSelector ("Ident"); writetIdent (yyt->ImpId.Ident) yyWriteNl ();
 yyWriteSelector ("Pos"); writetPosition (yyt->ImpId.Pos) yyWriteNl ();
 yyWriteSelector ("Type"); writetType (yyt->ImpId.Type) yyWriteNl ();
 yyWriteSelector ("Object1"); writetObject (yyt->ImpId.Object1) yyWriteNl ();
 yyWriteSelector ("Object2"); writetObject (yyt->ImpId.Object2) yyWriteNl ();
 yyWriteSelector ("IsRedeclared"); writeBOOLEAN (yyt->ImpId.IsRedeclared) yyWriteNl ();
}

static void yWriteNodeExport
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Qualified"); writeBOOLEAN (yyt->Export.Qualified) yyWriteNl ();
 yyWriteSelector ("ExpIds"); yyWriteAdr (yyt->Export.ExpIds);
}

static void yWriteNodeExpId
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Next"); yyWriteAdr (yyt->ExpId.Next);
 yyWriteSelector ("Ident"); writetIdent (yyt->ExpId.Ident) yyWriteNl ();
 yyWriteSelector ("Pos"); writetPosition (yyt->ExpId.Pos) yyWriteNl ();
}

static void yWriteNodeDecls
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Objects1"); writetObjects (yyt->Decls.Objects1) yyWriteNl ();
 yyWriteSelector ("Objects2"); writetVoid (yyt->Decls.Objects2) yyWriteNl ();
 yyWriteSelector ("Objects3"); writetObjects (yyt->Decls.Objects3) yyWriteNl ();
 yyWriteSelector ("Objects4In"); writetObjects (yyt->Decls.Objects4In) yyWriteNl ();
 yyWriteSelector ("Objects4Out"); writetObjects (yyt->Decls.Objects4Out) yyWriteNl ();
 yyWriteSelector ("Env1"); writetEnv (yyt->Decls.Env1) yyWriteNl ();
 yyWriteSelector ("Env2"); writetVoid (yyt->Decls.Env2) yyWriteNl ();
 yyWriteSelector ("Env3"); writetEnv (yyt->Decls.Env3) yyWriteNl ();
 yyWriteSelector ("Env4"); writetEnv (yyt->Decls.Env4) yyWriteNl ();
 yyWriteSelector ("ConfigGroupIn"); writeINDEX (yyt->Decls.ConfigGroupIn) yyWriteNl ();
 yyWriteSelector ("ConfigGroupOut"); writeINDEX (yyt->Decls.ConfigGroupOut) yyWriteNl ();
 yyWriteSelector ("DefTypes"); writetObjects (yyt->Decls.DefTypes) yyWriteNl ();
 yyWriteSelector ("DefObjects"); writetObjects (yyt->Decls.DefObjects) yyWriteNl ();
 yyWriteSelector ("ImplTypes"); writetObjects (yyt->Decls.ImplTypes) yyWriteNl ();
 yyWriteSelector ("PosIn"); writeINDEX (yyt->Decls.PosIn) yyWriteNl ();
 yyWriteSelector ("PosOut"); writeINDEX (yyt->Decls.PosOut) yyWriteNl ();
 yyWriteSelector ("Kind"); writeINDEX (yyt->Decls.Kind) yyWriteNl ();
 yyWriteSelector ("Module"); writetIdent (yyt->Decls.Module) yyWriteNl ();
 yyWriteSelector ("IdsIn"); writetIdents (yyt->Decls.IdsIn) yyWriteNl ();
 yyWriteSelector ("IdsOut"); writetIdents (yyt->Decls.IdsOut) yyWriteNl ();
 yyWriteSelector ("ConnectsIn"); writetConnects (yyt->Decls.ConnectsIn) yyWriteNl ();
 yyWriteSelector ("ConnectsOut"); writetConnects (yyt->Decls.ConnectsOut) yyWriteNl ();
 yyWriteSelector ("LocalIdsIn"); writetLocalIds (yyt->Decls.LocalIdsIn) yyWriteNl ();
 yyWriteSelector ("LocalIdsOut"); writetLocalIds (yyt->Decls.LocalIdsOut) yyWriteNl ();
 yyWriteSelector ("CntIn"); writeINDEX (yyt->Decls.CntIn) yyWriteNl ();
 yyWriteSelector ("CntOut"); writeINDEX (yyt->Decls.CntOut) yyWriteNl ();
 yyWriteSelector ("Level"); writeINDEX (yyt->Decls.Level) yyWriteNl ();
 yyWriteSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Decls.GlobalPtrs) yyWriteNl ();
}

static void yWriteNodeNoDecl
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeDecls (yyt); 
}

static void yWriteNodeDecl
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeDecls (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->Decl.Next);
}

static void yWriteNodeVar
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeDecl (yyt); 
 yyWriteSelector ("VarIds"); yyWriteAdr (yyt->Var.VarIds);
 yyWriteSelector ("Type"); yyWriteAdr (yyt->Var.Type);
 yyWriteSelector ("IsGlobal"); writeBOOLEAN (yyt->Var.IsGlobal) yyWriteNl ();
}

static void yWriteNodeObject
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeDecl (yyt); 
 yyWriteSelector ("Ident"); writetIdent (yyt->Object.Ident) yyWriteNl ();
 yyWriteSelector ("Pos"); writetPosition (yyt->Object.Pos) yyWriteNl ();
 yyWriteSelector ("CIdent"); writetIdent (yyt->Object.CIdent) yyWriteNl ();
 yyWriteSelector ("IsRedeclared"); writeBOOLEAN (yyt->Object.IsRedeclared) yyWriteNl ();
}

static void yWriteNodeConnectFrom
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeObject (yyt); 
 yyWriteSelector ("From"); yyWriteAdr (yyt->ConnectFrom.From);
 yyWriteSelector ("To"); yyWriteAdr (yyt->ConnectFrom.To);
 yyWriteSelector ("ConnectDecls"); yyWriteAdr (yyt->ConnectFrom.ConnectDecls);
 yyWriteSelector ("Object"); writetObject (yyt->ConnectFrom.Object) yyWriteNl ();
}

static void yWriteNodeConnectDecls
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeObject (yyt); 
 yyWriteSelector ("Index"); yyWriteAdr (yyt->ConnectDecls.Index);
 yyWriteSelector ("BiDirectional"); writeBOOLEAN (yyt->ConnectDecls.BiDirectional) yyWriteNl ();
 yyWriteSelector ("Config"); yyWriteAdr (yyt->ConnectDecls.Config);
 yyWriteSelector ("Actuals"); yyWriteAdr (yyt->ConnectDecls.Actuals);
 yyWriteSelector ("DirIn"); yyWriteAdr (yyt->ConnectDecls.DirIn);
 yyWriteSelector ("Object"); writetObject (yyt->ConnectDecls.Object) yyWriteNl ();
 yyWriteSelector ("IndexObjects"); writetObjects (yyt->ConnectDecls.IndexObjects) yyWriteNl ();
 yyWriteSelector ("LeftConfigObj"); writetObject (yyt->ConnectDecls.LeftConfigObj) yyWriteNl ();
 yyWriteSelector ("RightConfigObj"); writetObject (yyt->ConnectDecls.RightConfigObj) yyWriteNl ();
 yyWriteSelector ("IndexVal"); writetValue (yyt->ConnectDecls.IndexVal) yyWriteNl ();
 yyWriteSelector ("FirstDeclaration"); writeBOOLEAN (yyt->ConnectDecls.FirstDeclaration) yyWriteNl ();
 yyWriteSelector ("PrevCIdent"); writetIdent (yyt->ConnectDecls.PrevCIdent) yyWriteNl ();
}

static void yWriteNodeConfig
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeObject (yyt); 
 yyWriteSelector ("Actuals"); yyWriteAdr (yyt->Config.Actuals);
 yyWriteSelector ("Respecified"); writeBOOLEAN (yyt->Config.Respecified) yyWriteNl ();
 yyWriteSelector ("Qualid"); yyWriteAdr (yyt->Config.Qualid);
 yyWriteSelector ("Object"); writetObject (yyt->Config.Object) yyWriteNl ();
 yyWriteSelector ("Type"); writetType (yyt->Config.Type) yyWriteNl ();
 yyWriteSelector ("NewConfigGroup"); writeINDEX (yyt->Config.NewConfigGroup) yyWriteNl ();
 yyWriteSelector ("View"); writetObject (yyt->Config.View) yyWriteNl ();
 yyWriteSelector ("HasVariableSize"); writeBOOLEAN (yyt->Config.HasVariableSize) yyWriteNl ();
}

static void yWriteNodeConst
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeObject (yyt); 
 yyWriteSelector ("Expr"); yyWriteAdr (yyt->Const.Expr);
 yyWriteSelector ("Object"); writetObject (yyt->Const.Object) yyWriteNl ();
}

static void yWriteNodeTypeDecl
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeObject (yyt); 
 yyWriteSelector ("Type"); yyWriteAdr (yyt->TypeDecl.Type);
 yyWriteSelector ("Object"); writetObject (yyt->TypeDecl.Object) yyWriteNl ();
 yyWriteSelector ("Type1"); writetType (yyt->TypeDecl.Type1) yyWriteNl ();
 yyWriteSelector ("Type2"); writetType (yyt->TypeDecl.Type2) yyWriteNl ();
}

static void yWriteNodeProc
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeObject (yyt); 
 yyWriteSelector ("Formals"); yyWriteAdr (yyt->Proc.Formals);
 yyWriteSelector ("ResultType"); yyWriteAdr (yyt->Proc.ResultType);
 yyWriteSelector ("Decls"); yyWriteAdr (yyt->Proc.Decls);
 yyWriteSelector ("Stmts"); yyWriteAdr (yyt->Proc.Stmts);
 yyWriteSelector ("BeginPos"); writetPosition (yyt->Proc.BeginPos) yyWriteNl ();
 yyWriteSelector ("Object"); writetObject (yyt->Proc.Object) yyWriteNl ();
 yyWriteSelector ("Type"); writetType (yyt->Proc.Type) yyWriteNl ();
 yyWriteSelector ("HasOpenVector"); writeBOOLEAN (yyt->Proc.HasOpenVector) yyWriteNl ();
 yyWriteSelector ("ValueOpens"); writetCObjects (yyt->Proc.ValueOpens) yyWriteNl ();
 yyWriteSelector ("VAROpens"); writetCObjects (yyt->Proc.VAROpens) yyWriteNl ();
 yyWriteSelector ("LocalPtrs"); writetCObjects (yyt->Proc.LocalPtrs) yyWriteNl ();
 yyWriteSelector ("Strings"); writetStrings (yyt->Proc.Strings) yyWriteNl ();
}

static void yWriteNodeProcHead
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeObject (yyt); 
 yyWriteSelector ("Formals"); yyWriteAdr (yyt->ProcHead.Formals);
 yyWriteSelector ("ResultType"); yyWriteAdr (yyt->ProcHead.ResultType);
 yyWriteSelector ("Object"); writetObject (yyt->ProcHead.Object) yyWriteNl ();
 yyWriteSelector ("Type"); writetType (yyt->ProcHead.Type) yyWriteNl ();
 yyWriteSelector ("HasOpenVector"); writeBOOLEAN (yyt->ProcHead.HasOpenVector) yyWriteNl ();
}

static void yWriteNodeOpaque
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeObject (yyt); 
 yyWriteSelector ("Object"); writetObject (yyt->Opaque.Object) yyWriteNl ();
 yyWriteSelector ("Type1"); writetType (yyt->Opaque.Type1) yyWriteNl ();
 yyWriteSelector ("FullType"); writetType (yyt->Opaque.FullType) yyWriteNl ();
 yyWriteSelector ("Type2"); writetType (yyt->Opaque.Type2) yyWriteNl ();
}

static void yWriteNodeConnectDests
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Objects1"); writetObjects (yyt->ConnectDests.Objects1) yyWriteNl ();
 yyWriteSelector ("Objects2"); writetVoid (yyt->ConnectDests.Objects2) yyWriteNl ();
 yyWriteSelector ("Objects3"); writetObjects (yyt->ConnectDests.Objects3) yyWriteNl ();
 yyWriteSelector ("Objects4In"); writetObjects (yyt->ConnectDests.Objects4In) yyWriteNl ();
 yyWriteSelector ("Objects4Out"); writetObjects (yyt->ConnectDests.Objects4Out) yyWriteNl ();
 yyWriteSelector ("LeftConfigObj"); writetObject (yyt->ConnectDests.LeftConfigObj) yyWriteNl ();
 yyWriteSelector ("RightConfigObj"); writetObject (yyt->ConnectDests.RightConfigObj) yyWriteNl ();
 yyWriteSelector ("Env1"); writetEnv (yyt->ConnectDests.Env1) yyWriteNl ();
 yyWriteSelector ("Env2"); writetVoid (yyt->ConnectDests.Env2) yyWriteNl ();
 yyWriteSelector ("Env3"); writetEnv (yyt->ConnectDests.Env3) yyWriteNl ();
 yyWriteSelector ("Env4"); writetEnv (yyt->ConnectDests.Env4) yyWriteNl ();
 yyWriteSelector ("Kind"); writeINDEX (yyt->ConnectDests.Kind) yyWriteNl ();
 yyWriteSelector ("Module"); writetIdent (yyt->ConnectDests.Module) yyWriteNl ();
 yyWriteSelector ("IdsIn"); writetIdents (yyt->ConnectDests.IdsIn) yyWriteNl ();
 yyWriteSelector ("IdsOut"); writetIdents (yyt->ConnectDests.IdsOut) yyWriteNl ();
 yyWriteSelector ("ConnectsIn"); writetConnects (yyt->ConnectDests.ConnectsIn) yyWriteNl ();
 yyWriteSelector ("ConnectsOut"); writetConnects (yyt->ConnectDests.ConnectsOut) yyWriteNl ();
 yyWriteSelector ("LocalIdsIn"); writetLocalIds (yyt->ConnectDests.LocalIdsIn) yyWriteNl ();
 yyWriteSelector ("LocalIdsOut"); writetLocalIds (yyt->ConnectDests.LocalIdsOut) yyWriteNl ();
 yyWriteSelector ("Level"); writeINDEX (yyt->ConnectDests.Level) yyWriteNl ();
}

static void yWriteNodeNoConnectDest
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeConnectDests (yyt); 
}

static void yWriteNodeConnectDest
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeConnectDests (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->ConnectDest.Next);
 yyWriteSelector ("Expr"); yyWriteAdr (yyt->ConnectDest.Expr);
 yyWriteSelector ("Config"); yyWriteAdr (yyt->ConnectDest.Config);
 yyWriteSelector ("Actuals"); yyWriteAdr (yyt->ConnectDest.Actuals);
 yyWriteSelector ("DestDimId"); writetIdent (yyt->ConnectDest.DestDimId) yyWriteNl ();
 yyWriteSelector ("DestIdsId"); writetIdent (yyt->ConnectDest.DestIdsId) yyWriteNl ();
}

static void yWriteNodeConnectDestUni
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeConnectDest (yyt); 
}

static void yWriteNodeConnectDestBi
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeConnectDest (yyt); 
 yyWriteSelector ("Ident"); writetIdent (yyt->ConnectDestBi.Ident) yyWriteNl ();
 yyWriteSelector ("Pos"); writetPosition (yyt->ConnectDestBi.Pos) yyWriteNl ();
 yyWriteSelector ("Index"); yyWriteAdr (yyt->ConnectDestBi.Index);
 yyWriteSelector ("Object"); writetObject (yyt->ConnectDestBi.Object) yyWriteNl ();
 yyWriteSelector ("IndexVal"); writetValue (yyt->ConnectDestBi.IndexVal) yyWriteNl ();
 yyWriteSelector ("CIdent"); writetIdent (yyt->ConnectDestBi.CIdent) yyWriteNl ();
 yyWriteSelector ("FirstDeclaration"); writeBOOLEAN (yyt->ConnectDestBi.FirstDeclaration) yyWriteNl ();
 yyWriteSelector ("PrevCIdent"); writetIdent (yyt->ConnectDestBi.PrevCIdent) yyWriteNl ();
 yyWriteSelector ("BiDirIdsId"); writetIdent (yyt->ConnectDestBi.BiDirIdsId) yyWriteNl ();
 yyWriteSelector ("IsinBiDirConnId"); writetIdent (yyt->ConnectDestBi.IsinBiDirConnId) yyWriteNl ();
}

static void yWriteNodeVarIds
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Objects3"); writetObjects (yyt->VarIds.Objects3) yyWriteNl ();
 yyWriteSelector ("Type"); writetType (yyt->VarIds.Type) yyWriteNl ();
 yyWriteSelector ("TypeTree"); writeADDRESS (yyt->VarIds.TypeTree) yyWriteNl ();
 yyWriteSelector ("Kind"); writeINDEX (yyt->VarIds.Kind) yyWriteNl ();
 yyWriteSelector ("Module"); writetIdent (yyt->VarIds.Module) yyWriteNl ();
 yyWriteSelector ("IdsIn"); writetIdents (yyt->VarIds.IdsIn) yyWriteNl ();
 yyWriteSelector ("IdsOut"); writetIdents (yyt->VarIds.IdsOut) yyWriteNl ();
 yyWriteSelector ("LocalIdsIn"); writetLocalIds (yyt->VarIds.LocalIdsIn) yyWriteNl ();
 yyWriteSelector ("LocalIdsOut"); writetLocalIds (yyt->VarIds.LocalIdsOut) yyWriteNl ();
 yyWriteSelector ("Level"); writeINDEX (yyt->VarIds.Level) yyWriteNl ();
}

static void yWriteNodeNoVarId
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeVarIds (yyt); 
}

static void yWriteNodeVarId
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeVarIds (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->VarId.Next);
 yyWriteSelector ("Ident"); writetIdent (yyt->VarId.Ident) yyWriteNl ();
 yyWriteSelector ("Pos"); writetPosition (yyt->VarId.Pos) yyWriteNl ();
 yyWriteSelector ("Object"); writetObject (yyt->VarId.Object) yyWriteNl ();
 yyWriteSelector ("CIdent"); writetIdent (yyt->VarId.CIdent) yyWriteNl ();
 yyWriteSelector ("IsRedeclared"); writeBOOLEAN (yyt->VarId.IsRedeclared) yyWriteNl ();
}

static void yWriteNodeFormals
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Objects3"); writetObjects (yyt->Formals.Objects3) yyWriteNl ();
 yyWriteSelector ("Types"); writetTypes (yyt->Formals.Types) yyWriteNl ();
 yyWriteSelector ("Env1"); writetEnv (yyt->Formals.Env1) yyWriteNl ();
 yyWriteSelector ("Env2"); writetVoid (yyt->Formals.Env2) yyWriteNl ();
 yyWriteSelector ("Env3"); writetEnv (yyt->Formals.Env3) yyWriteNl ();
 yyWriteSelector ("HasOpenVector"); writeBOOLEAN (yyt->Formals.HasOpenVector) yyWriteNl ();
 yyWriteSelector ("PosIn"); writeINDEX (yyt->Formals.PosIn) yyWriteNl ();
 yyWriteSelector ("PosOut"); writeINDEX (yyt->Formals.PosOut) yyWriteNl ();
 yyWriteSelector ("Kind"); writeINDEX (yyt->Formals.Kind) yyWriteNl ();
 yyWriteSelector ("Module"); writetIdent (yyt->Formals.Module) yyWriteNl ();
 yyWriteSelector ("IdsIn"); writetIdents (yyt->Formals.IdsIn) yyWriteNl ();
 yyWriteSelector ("IdsOut"); writetIdents (yyt->Formals.IdsOut) yyWriteNl ();
 yyWriteSelector ("LocalIdsIn"); writetLocalIds (yyt->Formals.LocalIdsIn) yyWriteNl ();
 yyWriteSelector ("LocalIdsOut"); writetLocalIds (yyt->Formals.LocalIdsOut) yyWriteNl ();
 yyWriteSelector ("Level"); writeINDEX (yyt->Formals.Level) yyWriteNl ();
}

static void yWriteNodeNoFormal
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeFormals (yyt); 
}

static void yWriteNodeFormal
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeFormals (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->Formal.Next);
 yyWriteSelector ("IsVAR"); writeBOOLEAN (yyt->Formal.IsVAR) yyWriteNl ();
 yyWriteSelector ("ParIds"); yyWriteAdr (yyt->Formal.ParIds);
 yyWriteSelector ("Type"); yyWriteAdr (yyt->Formal.Type);
}

static void yWriteNodeParIds
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Objects3"); writetObjects (yyt->ParIds.Objects3) yyWriteNl ();
 yyWriteSelector ("Type"); writetType (yyt->ParIds.Type) yyWriteNl ();
 yyWriteSelector ("TypeTree"); writeADDRESS (yyt->ParIds.TypeTree) yyWriteNl ();
 yyWriteSelector ("IsVAR"); writeBOOLEAN (yyt->ParIds.IsVAR) yyWriteNl ();
 yyWriteSelector ("TypesIn"); writetType (yyt->ParIds.TypesIn) yyWriteNl ();
 yyWriteSelector ("TypesOut"); writetTypes (yyt->ParIds.TypesOut) yyWriteNl ();
 yyWriteSelector ("IdsIn"); writetIdents (yyt->ParIds.IdsIn) yyWriteNl ();
 yyWriteSelector ("IdsOut"); writetIdents (yyt->ParIds.IdsOut) yyWriteNl ();
 yyWriteSelector ("LocalIdsIn"); writetLocalIds (yyt->ParIds.LocalIdsIn) yyWriteNl ();
 yyWriteSelector ("LocalIdsOut"); writetLocalIds (yyt->ParIds.LocalIdsOut) yyWriteNl ();
 yyWriteSelector ("Level"); writeINDEX (yyt->ParIds.Level) yyWriteNl ();
}

static void yWriteNodeNoParId
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeParIds (yyt); 
}

static void yWriteNodeParId
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeParIds (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->ParId.Next);
 yyWriteSelector ("Ident"); writetIdent (yyt->ParId.Ident) yyWriteNl ();
 yyWriteSelector ("Pos"); writetPosition (yyt->ParId.Pos) yyWriteNl ();
 yyWriteSelector ("Object"); writetObject (yyt->ParId.Object) yyWriteNl ();
 yyWriteSelector ("CIdent"); writetIdent (yyt->ParId.CIdent) yyWriteNl ();
 yyWriteSelector ("IsRedeclared"); writeBOOLEAN (yyt->ParId.IsRedeclared) yyWriteNl ();
}

static void yWriteNodeType
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Objects3"); writetObjects (yyt->Type.Objects3) yyWriteNl ();
 yyWriteSelector ("TypeObj"); writetObject (yyt->Type.TypeObj) yyWriteNl ();
 yyWriteSelector ("Type1"); writetType (yyt->Type.Type1) yyWriteNl ();
 yyWriteSelector ("Type2"); writetType (yyt->Type.Type2) yyWriteNl ();
 yyWriteSelector ("Env1"); writetEnv (yyt->Type.Env1) yyWriteNl ();
 yyWriteSelector ("Env2"); writetVoid (yyt->Type.Env2) yyWriteNl ();
 yyWriteSelector ("Env3"); writetEnv (yyt->Type.Env3) yyWriteNl ();
 yyWriteSelector ("IsInArray"); writeBOOLEAN (yyt->Type.IsInArray) yyWriteNl ();
 yyWriteSelector ("PosIn"); writeINDEX (yyt->Type.PosIn) yyWriteNl ();
 yyWriteSelector ("PosOut"); writeINDEX (yyt->Type.PosOut) yyWriteNl ();
 yyWriteSelector ("Kind"); writeINDEX (yyt->Type.Kind) yyWriteNl ();
 yyWriteSelector ("Module"); writetIdent (yyt->Type.Module) yyWriteNl ();
 yyWriteSelector ("IdsIn"); writetIdents (yyt->Type.IdsIn) yyWriteNl ();
 yyWriteSelector ("IdsOut"); writetIdents (yyt->Type.IdsOut) yyWriteNl ();
 yyWriteSelector ("LocalIdsIn"); writetLocalIds (yyt->Type.LocalIdsIn) yyWriteNl ();
 yyWriteSelector ("LocalIdsOut"); writetLocalIds (yyt->Type.LocalIdsOut) yyWriteNl ();
 yyWriteSelector ("CntIn"); writeINDEX (yyt->Type.CntIn) yyWriteNl ();
 yyWriteSelector ("CntOut"); writeINDEX (yyt->Type.CntOut) yyWriteNl ();
 yyWriteSelector ("HasVariableSize"); writeBOOLEAN (yyt->Type.HasVariableSize) yyWriteNl ();
 yyWriteSelector ("ContainsVector"); writeBOOLEAN (yyt->Type.ContainsVector) yyWriteNl ();
}

static void yWriteNodeVector
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeType (yyt); 
 yyWriteSelector ("IsOpen"); writeBOOLEAN (yyt->Vector.IsOpen) yyWriteNl ();
 yyWriteSelector ("Config"); yyWriteAdr (yyt->Vector.Config);
 yyWriteSelector ("Scalar"); yyWriteAdr (yyt->Vector.Scalar);
}

static void yWriteNodeArray
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeType (yyt); 
 yyWriteSelector ("IsOpen"); writeBOOLEAN (yyt->Array.IsOpen) yyWriteNl ();
 yyWriteSelector ("Index"); yyWriteAdr (yyt->Array.Index);
 yyWriteSelector ("ElemType"); yyWriteAdr (yyt->Array.ElemType);
}

static void yWriteNodeRecord
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeType (yyt); 
 yyWriteSelector ("Fields"); yyWriteAdr (yyt->Record.Fields);
}

static void yWriteNodeSetType
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeType (yyt); 
 yyWriteSelector ("BaseType"); yyWriteAdr (yyt->SetType.BaseType);
}

static void yWriteNodePointer
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeType (yyt); 
 yyWriteSelector ("TargetType"); yyWriteAdr (yyt->Pointer.TargetType);
 yyWriteSelector ("TypePos"); writeINDEX (yyt->Pointer.TypePos) yyWriteNl ();
}

static void yWriteNodeProcType
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeType (yyt); 
 yyWriteSelector ("FormalTypes"); yyWriteAdr (yyt->ProcType.FormalTypes);
 yyWriteSelector ("ResultType"); yyWriteAdr (yyt->ProcType.ResultType);
}

static void yWriteNodeSimpleType
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeType (yyt); 
}

static void yWriteNodeEnumeration
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeSimpleType (yyt); 
 yyWriteSelector ("EnumIds"); yyWriteAdr (yyt->Enumeration.EnumIds);
 yyWriteSelector ("Type0"); writetType (yyt->Enumeration.Type0) yyWriteNl ();
}

static void yWriteNodeSubrange
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeSimpleType (yyt); 
 yyWriteSelector ("BaseType"); yyWriteAdr (yyt->Subrange.BaseType);
 yyWriteSelector ("Lwb"); yyWriteAdr (yyt->Subrange.Lwb);
 yyWriteSelector ("Upb"); yyWriteAdr (yyt->Subrange.Upb);
 yyWriteSelector ("Type3"); writetType (yyt->Subrange.Type3) yyWriteNl ();
}

static void yWriteNodePrimaryType
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeSimpleType (yyt); 
}

static void yWriteNodeVoid
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodePrimaryType (yyt); 
}

static void yWriteNodeTypeId
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodePrimaryType (yyt); 
 yyWriteSelector ("Ident"); writetIdent (yyt->TypeId.Ident) yyWriteNl ();
 yyWriteSelector ("Pos"); writetPosition (yyt->TypeId.Pos) yyWriteNl ();
 yyWriteSelector ("Object"); writetObject (yyt->TypeId.Object) yyWriteNl ();
}

static void yWriteNodeTypeId0
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeTypeId (yyt); 
}

static void yWriteNodeTypeId1
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeTypeId (yyt); 
 yyWriteSelector ("TypeId"); yyWriteAdr (yyt->TypeId1.TypeId);
}

static void yWriteNodeFields
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Objects3"); writetObjects (yyt->Fields.Objects3) yyWriteNl ();
 yyWriteSelector ("FieldsIn"); writetObjects (yyt->Fields.FieldsIn) yyWriteNl ();
 yyWriteSelector ("FieldsOut"); writetObjects (yyt->Fields.FieldsOut) yyWriteNl ();
 yyWriteSelector ("Env1"); writetEnv (yyt->Fields.Env1) yyWriteNl ();
 yyWriteSelector ("Env2"); writetVoid (yyt->Fields.Env2) yyWriteNl ();
 yyWriteSelector ("Env3"); writetEnv (yyt->Fields.Env3) yyWriteNl ();
 yyWriteSelector ("PosIn"); writeINDEX (yyt->Fields.PosIn) yyWriteNl ();
 yyWriteSelector ("PosOut"); writeINDEX (yyt->Fields.PosOut) yyWriteNl ();
 yyWriteSelector ("Kind"); writeINDEX (yyt->Fields.Kind) yyWriteNl ();
 yyWriteSelector ("Module"); writetIdent (yyt->Fields.Module) yyWriteNl ();
 yyWriteSelector ("IdsIn"); writetIdents (yyt->Fields.IdsIn) yyWriteNl ();
 yyWriteSelector ("IdsOut"); writetIdents (yyt->Fields.IdsOut) yyWriteNl ();
 yyWriteSelector ("LocalIdsIn"); writetLocalIds (yyt->Fields.LocalIdsIn) yyWriteNl ();
 yyWriteSelector ("LocalIdsOut"); writetLocalIds (yyt->Fields.LocalIdsOut) yyWriteNl ();
 yyWriteSelector ("CntIn"); writeINDEX (yyt->Fields.CntIn) yyWriteNl ();
 yyWriteSelector ("CntOut"); writeINDEX (yyt->Fields.CntOut) yyWriteNl ();
 yyWriteSelector ("nUnion"); writeINDEX (yyt->Fields.nUnion) yyWriteNl ();
 yyWriteSelector ("Select"); writetSelectors (yyt->Fields.Select) yyWriteNl ();
 yyWriteSelector ("ContainsVector"); writeBOOLEAN (yyt->Fields.ContainsVector) yyWriteNl ();
}

static void yWriteNodeNoField
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeFields (yyt); 
}

static void yWriteNodeField
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeFields (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->Field.Next);
}

static void yWriteNodeRecordSect
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeField (yyt); 
 yyWriteSelector ("FieldIds"); yyWriteAdr (yyt->RecordSect.FieldIds);
 yyWriteSelector ("Type"); yyWriteAdr (yyt->RecordSect.Type);
}

static void yWriteNodeVariantSect
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeField (yyt); 
 yyWriteSelector ("TagField"); yyWriteAdr (yyt->VariantSect.TagField);
 yyWriteSelector ("Variants"); yyWriteAdr (yyt->VariantSect.Variants);
 yyWriteSelector ("Else"); yyWriteAdr (yyt->VariantSect.Else);
 yyWriteSelector ("UnionId"); writetIdent (yyt->VariantSect.UnionId) yyWriteNl ();
 yyWriteSelector ("ElseId"); writetIdent (yyt->VariantSect.ElseId) yyWriteNl ();
}

static void yWriteNodeFieldIds
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Type"); writetType (yyt->FieldIds.Type) yyWriteNl ();
 yyWriteSelector ("FieldsIn"); writetObjects (yyt->FieldIds.FieldsIn) yyWriteNl ();
 yyWriteSelector ("FieldsOut"); writetObjects (yyt->FieldIds.FieldsOut) yyWriteNl ();
 yyWriteSelector ("IdsIn"); writetIdents (yyt->FieldIds.IdsIn) yyWriteNl ();
 yyWriteSelector ("IdsOut"); writetIdents (yyt->FieldIds.IdsOut) yyWriteNl ();
 yyWriteSelector ("LocalIdsIn"); writetLocalIds (yyt->FieldIds.LocalIdsIn) yyWriteNl ();
 yyWriteSelector ("LocalIdsOut"); writetLocalIds (yyt->FieldIds.LocalIdsOut) yyWriteNl ();
 yyWriteSelector ("Select"); writetSelectors (yyt->FieldIds.Select) yyWriteNl ();
}

static void yWriteNodeNoFieldId
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeFieldIds (yyt); 
}

static void yWriteNodeFieldId
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeFieldIds (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->FieldId.Next);
 yyWriteSelector ("Ident"); writetIdent (yyt->FieldId.Ident) yyWriteNl ();
 yyWriteSelector ("Pos"); writetPosition (yyt->FieldId.Pos) yyWriteNl ();
 yyWriteSelector ("Object"); writetObject (yyt->FieldId.Object) yyWriteNl ();
 yyWriteSelector ("CIdent"); writetIdent (yyt->FieldId.CIdent) yyWriteNl ();
 yyWriteSelector ("IsRedeclared"); writeBOOLEAN (yyt->FieldId.IsRedeclared) yyWriteNl ();
}

static void yWriteNodeTagField
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Type"); yyWriteAdr (yyt->TagField.Type);
 yyWriteSelector ("FieldsIn"); writetObjects (yyt->TagField.FieldsIn) yyWriteNl ();
 yyWriteSelector ("FieldsOut"); writetObjects (yyt->TagField.FieldsOut) yyWriteNl ();
 yyWriteSelector ("Env1"); writetEnv (yyt->TagField.Env1) yyWriteNl ();
 yyWriteSelector ("Env2"); writetVoid (yyt->TagField.Env2) yyWriteNl ();
 yyWriteSelector ("Env3"); writetEnv (yyt->TagField.Env3) yyWriteNl ();
 yyWriteSelector ("PosIn"); writeINDEX (yyt->TagField.PosIn) yyWriteNl ();
 yyWriteSelector ("PosOut"); writeINDEX (yyt->TagField.PosOut) yyWriteNl ();
 yyWriteSelector ("Kind"); writeINDEX (yyt->TagField.Kind) yyWriteNl ();
 yyWriteSelector ("Module"); writetIdent (yyt->TagField.Module) yyWriteNl ();
 yyWriteSelector ("IdsIn"); writetIdents (yyt->TagField.IdsIn) yyWriteNl ();
 yyWriteSelector ("IdsOut"); writetIdents (yyt->TagField.IdsOut) yyWriteNl ();
 yyWriteSelector ("LocalIdsIn"); writetLocalIds (yyt->TagField.LocalIdsIn) yyWriteNl ();
 yyWriteSelector ("LocalIdsOut"); writetLocalIds (yyt->TagField.LocalIdsOut) yyWriteNl ();
 yyWriteSelector ("Select"); writetSelectors (yyt->TagField.Select) yyWriteNl ();
}

static void yWriteNodeTagField1
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeTagField (yyt); 
}

static void yWriteNodeTagField2
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeTagField (yyt); 
 yyWriteSelector ("Ident"); writetIdent (yyt->TagField2.Ident) yyWriteNl ();
 yyWriteSelector ("Object"); writetObject (yyt->TagField2.Object) yyWriteNl ();
 yyWriteSelector ("CIdent"); writetIdent (yyt->TagField2.CIdent) yyWriteNl ();
 yyWriteSelector ("IsRedeclared"); writeBOOLEAN (yyt->TagField2.IsRedeclared) yyWriteNl ();
}

static void yWriteNodeVariants
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Objects3"); writetObjects (yyt->Variants.Objects3) yyWriteNl ();
 yyWriteSelector ("FieldsIn"); writetObjects (yyt->Variants.FieldsIn) yyWriteNl ();
 yyWriteSelector ("FieldsOut"); writetObjects (yyt->Variants.FieldsOut) yyWriteNl ();
 yyWriteSelector ("Env1"); writetEnv (yyt->Variants.Env1) yyWriteNl ();
 yyWriteSelector ("Env2"); writetVoid (yyt->Variants.Env2) yyWriteNl ();
 yyWriteSelector ("Env3"); writetEnv (yyt->Variants.Env3) yyWriteNl ();
 yyWriteSelector ("PosIn"); writeINDEX (yyt->Variants.PosIn) yyWriteNl ();
 yyWriteSelector ("PosOut"); writeINDEX (yyt->Variants.PosOut) yyWriteNl ();
 yyWriteSelector ("Kind"); writeINDEX (yyt->Variants.Kind) yyWriteNl ();
 yyWriteSelector ("Module"); writetIdent (yyt->Variants.Module) yyWriteNl ();
 yyWriteSelector ("IdsIn"); writetIdents (yyt->Variants.IdsIn) yyWriteNl ();
 yyWriteSelector ("IdsOut"); writetIdents (yyt->Variants.IdsOut) yyWriteNl ();
 yyWriteSelector ("LocalIdsIn"); writetLocalIds (yyt->Variants.LocalIdsIn) yyWriteNl ();
 yyWriteSelector ("LocalIdsOut"); writetLocalIds (yyt->Variants.LocalIdsOut) yyWriteNl ();
 yyWriteSelector ("CntIn"); writeINDEX (yyt->Variants.CntIn) yyWriteNl ();
 yyWriteSelector ("CntOut"); writeINDEX (yyt->Variants.CntOut) yyWriteNl ();
 yyWriteSelector ("nStruct"); writeINDEX (yyt->Variants.nStruct) yyWriteNl ();
 yyWriteSelector ("Select"); writetSelectors (yyt->Variants.Select) yyWriteNl ();
}

static void yWriteNodeNoVariant
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeVariants (yyt); 
}

static void yWriteNodeVariant
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeVariants (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->Variant.Next);
 yyWriteSelector ("Labels"); yyWriteAdr (yyt->Variant.Labels);
 yyWriteSelector ("Variant"); yyWriteAdr (yyt->Variant.Variant);
 yyWriteSelector ("StructId"); writetIdent (yyt->Variant.StructId) yyWriteNl ();
}

static void yWriteNodeFormalTypes
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Types"); writetTypes (yyt->FormalTypes.Types) yyWriteNl ();
 yyWriteSelector ("Env1"); writetEnv (yyt->FormalTypes.Env1) yyWriteNl ();
 yyWriteSelector ("Env2"); writetVoid (yyt->FormalTypes.Env2) yyWriteNl ();
 yyWriteSelector ("Env3"); writetEnv (yyt->FormalTypes.Env3) yyWriteNl ();
 yyWriteSelector ("PosIn"); writeINDEX (yyt->FormalTypes.PosIn) yyWriteNl ();
 yyWriteSelector ("PosOut"); writeINDEX (yyt->FormalTypes.PosOut) yyWriteNl ();
 yyWriteSelector ("Kind"); writeINDEX (yyt->FormalTypes.Kind) yyWriteNl ();
 yyWriteSelector ("Module"); writetIdent (yyt->FormalTypes.Module) yyWriteNl ();
 yyWriteSelector ("IdsIn"); writetIdents (yyt->FormalTypes.IdsIn) yyWriteNl ();
 yyWriteSelector ("IdsOut"); writetIdents (yyt->FormalTypes.IdsOut) yyWriteNl ();
 yyWriteSelector ("LocalIdsIn"); writetLocalIds (yyt->FormalTypes.LocalIdsIn) yyWriteNl ();
 yyWriteSelector ("LocalIdsOut"); writetLocalIds (yyt->FormalTypes.LocalIdsOut) yyWriteNl ();
}

static void yWriteNodeNoFormalType
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeFormalTypes (yyt); 
}

static void yWriteNodeFormalType
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeFormalTypes (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->FormalType.Next);
 yyWriteSelector ("IsVAR"); writeBOOLEAN (yyt->FormalType.IsVAR) yyWriteNl ();
 yyWriteSelector ("Type"); yyWriteAdr (yyt->FormalType.Type);
}

static void yWriteNodeEnumIds
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Type"); writetType (yyt->EnumIds.Type) yyWriteNl ();
 yyWriteSelector ("Objects"); writetObjects (yyt->EnumIds.Objects) yyWriteNl ();
 yyWriteSelector ("IndexIn"); writeINDEX (yyt->EnumIds.IndexIn) yyWriteNl ();
 yyWriteSelector ("IndexOut"); writeINDEX (yyt->EnumIds.IndexOut) yyWriteNl ();
 yyWriteSelector ("Kind"); writeINDEX (yyt->EnumIds.Kind) yyWriteNl ();
 yyWriteSelector ("Module"); writetIdent (yyt->EnumIds.Module) yyWriteNl ();
 yyWriteSelector ("IdsIn"); writetIdents (yyt->EnumIds.IdsIn) yyWriteNl ();
 yyWriteSelector ("IdsOut"); writetIdents (yyt->EnumIds.IdsOut) yyWriteNl ();
 yyWriteSelector ("LocalIdsIn"); writetLocalIds (yyt->EnumIds.LocalIdsIn) yyWriteNl ();
 yyWriteSelector ("LocalIdsOut"); writetLocalIds (yyt->EnumIds.LocalIdsOut) yyWriteNl ();
}

static void yWriteNodeNoEnumId
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeEnumIds (yyt); 
}

static void yWriteNodeEnumId
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeEnumIds (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->EnumId.Next);
 yyWriteSelector ("Ident"); writetIdent (yyt->EnumId.Ident) yyWriteNl ();
 yyWriteSelector ("Pos"); writetPosition (yyt->EnumId.Pos) yyWriteNl ();
 yyWriteSelector ("Object"); writetObject (yyt->EnumId.Object) yyWriteNl ();
 yyWriteSelector ("CIdent"); writetIdent (yyt->EnumId.CIdent) yyWriteNl ();
 yyWriteSelector ("IsRedeclared"); writeBOOLEAN (yyt->EnumId.IsRedeclared) yyWriteNl ();
}

static void yWriteNodeExpr
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Env"); writetEnv (yyt->Expr.Env) yyWriteNl ();
 yyWriteSelector ("IsLval"); writeBOOLEAN (yyt->Expr.IsLval) yyWriteNl ();
 yyWriteSelector ("Type"); writetType (yyt->Expr.Type) yyWriteNl ();
 yyWriteSelector ("Level"); writeINDEX (yyt->Expr.Level) yyWriteNl ();
 yyWriteSelector ("UseHelpVar"); writeBOOLEAN (yyt->Expr.UseHelpVar) yyWriteNl ();
 yyWriteSelector ("THelpVar"); writeBOOLEAN (yyt->Expr.THelpVar) yyWriteNl ();
 yyWriteSelector ("TakeHelpVar"); writeBOOLEAN (yyt->Expr.TakeHelpVar) yyWriteNl ();
 yyWriteSelector ("HelpVar"); writetIdent (yyt->Expr.HelpVar) yyWriteNl ();
 yyWriteSelector ("IsFirstDesignator"); writeBOOLEAN (yyt->Expr.IsFirstDesignator) yyWriteNl ();
 yyWriteSelector ("HasProcOrDimSucc"); writeBOOLEAN (yyt->Expr.HasProcOrDimSucc) yyWriteNl ();
 yyWriteSelector ("WriteVectorIndex"); writeBOOLEAN (yyt->Expr.WriteVectorIndex) yyWriteNl ();
 yyWriteSelector ("ProcOrDimSpec"); writetTree (yyt->Expr.ProcOrDimSpec) yyWriteNl ();
 yyWriteSelector ("WriteProcOrDimIndex"); writeBOOLEAN (yyt->Expr.WriteProcOrDimIndex) yyWriteNl ();
 yyWriteSelector ("IsCConst"); writeBOOLEAN (yyt->Expr.IsCConst) yyWriteNl ();
 yyWriteSelector ("IsP3Const"); writeBOOLEAN (yyt->Expr.IsP3Const) yyWriteNl ();
 yyWriteSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->Expr.OpenAccessOrCall) yyWriteNl ();
 yyWriteSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Expr.GlobalPtrs) yyWriteNl ();
 yyWriteSelector ("StrsIn"); writetStrings (yyt->Expr.StrsIn) yyWriteNl ();
 yyWriteSelector ("StrsOut"); writetStrings (yyt->Expr.StrsOut) yyWriteNl ();
}

static void yWriteNodeNoExpr
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExpr (yyt); 
}

static void yWriteNodeMultiples
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExpr (yyt); 
 yyWriteSelector ("Mop"); yyWriteAdr (yyt->Multiples.Mop);
 yyWriteSelector ("MultiType"); writetType (yyt->Multiples.MultiType) yyWriteNl ();
}

static void yWriteNodeLastMultiple
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeMultiples (yyt); 
}

static void yWriteNodeMultiple
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeMultiples (yyt); 
 yyWriteSelector ("Pos"); writetPosition (yyt->Multiple.Pos) yyWriteNl ();
 yyWriteSelector ("Operator"); writeINDEX (yyt->Multiple.Operator) yyWriteNl ();
 yyWriteSelector ("Multiples"); yyWriteAdr (yyt->Multiple.Multiples);
 yyWriteSelector ("COperator"); writeINDEX (yyt->Multiple.COperator) yyWriteNl ();
}

static void yWriteNodeBinary
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExpr (yyt); 
 yyWriteSelector ("Pos"); writetPosition (yyt->Binary.Pos) yyWriteNl ();
 yyWriteSelector ("Operator"); writeINDEX (yyt->Binary.Operator) yyWriteNl ();
 yyWriteSelector ("Lop"); yyWriteAdr (yyt->Binary.Lop);
 yyWriteSelector ("Rop"); yyWriteAdr (yyt->Binary.Rop);
 yyWriteSelector ("COperator"); writeINDEX (yyt->Binary.COperator) yyWriteNl ();
}

static void yWriteNodeUnary
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExpr (yyt); 
 yyWriteSelector ("Pos"); writetPosition (yyt->Unary.Pos) yyWriteNl ();
 yyWriteSelector ("Operator"); writeINDEX (yyt->Unary.Operator) yyWriteNl ();
 yyWriteSelector ("Mop"); yyWriteAdr (yyt->Unary.Mop);
 yyWriteSelector ("COperator"); writeINDEX (yyt->Unary.COperator) yyWriteNl ();
}

static void yWriteNodeIntConst
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExpr (yyt); 
 yyWriteSelector ("Pos"); writetPosition (yyt->IntConst.Pos) yyWriteNl ();
 yyWriteSelector ("Kind"); writeINDEX (yyt->IntConst.Kind) yyWriteNl ();
 yyWriteSelector ("IntVal"); writeULONG (yyt->IntConst.IntVal) yyWriteNl ();
}

static void yWriteNodeRealConst
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExpr (yyt); 
 yyWriteSelector ("Pos"); writetPosition (yyt->RealConst.Pos) yyWriteNl ();
 yyWriteSelector ("RealVal"); writetStringRef (yyt->RealConst.RealVal) yyWriteNl ();
}

static void yWriteNodeStringConst
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExpr (yyt); 
 yyWriteSelector ("Pos"); writetPosition (yyt->StringConst.Pos) yyWriteNl ();
 yyWriteSelector ("StringVal"); writetStringRef (yyt->StringConst.StringVal) yyWriteNl ();
}

static void yWriteNodeCharConst
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExpr (yyt); 
 yyWriteSelector ("Pos"); writetPosition (yyt->CharConst.Pos) yyWriteNl ();
 yyWriteSelector ("CharVal"); writeUCHAR (yyt->CharConst.CharVal) yyWriteNl ();
}

static void yWriteNodeFuncCall
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExpr (yyt); 
 yyWriteSelector ("Designator"); yyWriteAdr (yyt->FuncCall.Designator);
 yyWriteSelector ("Actuals"); yyWriteAdr (yyt->FuncCall.Actuals);
}

static void yWriteNodeMove
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExpr (yyt); 
 yyWriteSelector ("DirSpec"); yyWriteAdr (yyt->Move.DirSpec);
 yyWriteSelector ("Expr"); yyWriteAdr (yyt->Move.Expr);
}

static void yWriteNodeReceive
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExpr (yyt); 
 yyWriteSelector ("DirSpec"); yyWriteAdr (yyt->Receive.DirSpec);
 yyWriteSelector ("Expr"); yyWriteAdr (yyt->Receive.Expr);
}

static void yWriteNodeReduce
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExpr (yyt); 
 yyWriteSelector ("Reduce"); yyWriteAdr (yyt->Reduce.Reduce);
 yyWriteSelector ("Expr"); yyWriteAdr (yyt->Reduce.Expr);
}

static void yWriteNodeSet
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExpr (yyt); 
 yyWriteSelector ("BaseType"); yyWriteAdr (yyt->Set.BaseType);
 yyWriteSelector ("Elems"); yyWriteAdr (yyt->Set.Elems);
}

static void yWriteNodeBitSet
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExpr (yyt); 
 yyWriteSelector ("Elems"); yyWriteAdr (yyt->BitSet.Elems);
}

static void yWriteNodeDesignator
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeExpr (yyt); 
}

static void yWriteNodeQualid
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeDesignator (yyt); 
 yyWriteSelector ("Ident"); writetIdent (yyt->Qualid.Ident) yyWriteNl ();
 yyWriteSelector ("Pos"); writetPosition (yyt->Qualid.Pos) yyWriteNl ();
 yyWriteSelector ("Object"); writetObject (yyt->Qualid.Object) yyWriteNl ();
 yyWriteSelector ("IsGlobalPtr"); writeBOOLEAN (yyt->Qualid.IsGlobalPtr) yyWriteNl ();
}

static void yWriteNodeQualid0
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeQualid (yyt); 
}

static void yWriteNodeQualid1
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeQualid (yyt); 
 yyWriteSelector ("Qualid"); yyWriteAdr (yyt->Qualid1.Qualid);
}

static void yWriteNodeProcessor
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeDesignator (yyt); 
 yyWriteSelector ("Designator"); yyWriteAdr (yyt->Processor.Designator);
 yyWriteSelector ("Pos"); writetPosition (yyt->Processor.Pos) yyWriteNl ();
 yyWriteSelector ("Proc"); yyWriteAdr (yyt->Processor.Proc);
}

static void yWriteNodeDimensions
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeDesignator (yyt); 
 yyWriteSelector ("Designator"); yyWriteAdr (yyt->Dimensions.Designator);
 yyWriteSelector ("Pos"); writetPosition (yyt->Dimensions.Pos) yyWriteNl ();
 yyWriteSelector ("Actuals"); yyWriteAdr (yyt->Dimensions.Actuals);
 yyWriteSelector ("SecondHelpVar"); writetIdent (yyt->Dimensions.SecondHelpVar) yyWriteNl ();
}

static void yWriteNodeSelect
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeDesignator (yyt); 
 yyWriteSelector ("Designator"); yyWriteAdr (yyt->Select.Designator);
 yyWriteSelector ("Pos"); writetPosition (yyt->Select.Pos) yyWriteNl ();
 yyWriteSelector ("Field"); writetIdent (yyt->Select.Field) yyWriteNl ();
 yyWriteSelector ("Object"); writetObject (yyt->Select.Object) yyWriteNl ();
}

static void yWriteNodeSubscript
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeDesignator (yyt); 
 yyWriteSelector ("Designator"); yyWriteAdr (yyt->Subscript.Designator);
 yyWriteSelector ("Pos"); writetPosition (yyt->Subscript.Pos) yyWriteNl ();
 yyWriteSelector ("Index"); yyWriteAdr (yyt->Subscript.Index);
}

static void yWriteNodeDeref
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeDesignator (yyt); 
 yyWriteSelector ("Designator"); yyWriteAdr (yyt->Deref.Designator);
 yyWriteSelector ("Pos"); writetPosition (yyt->Deref.Pos) yyWriteNl ();
}

static void yWriteNodeDirSpec
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Env"); writetEnv (yyt->DirSpec.Env) yyWriteNl ();
 yyWriteSelector ("ConnectObj"); writetObject (yyt->DirSpec.ConnectObj) yyWriteNl ();
 yyWriteSelector ("Level"); writeINDEX (yyt->DirSpec.Level) yyWriteNl ();
 yyWriteSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->DirSpec.OpenAccessOrCall) yyWriteNl ();
 yyWriteSelector ("GlobalPtrs"); writeBOOLEAN (yyt->DirSpec.GlobalPtrs) yyWriteNl ();
 yyWriteSelector ("StrsIn"); writetStrings (yyt->DirSpec.StrsIn) yyWriteNl ();
 yyWriteSelector ("StrsOut"); writetStrings (yyt->DirSpec.StrsOut) yyWriteNl ();
}

static void yWriteNodeFuncSpec
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeDirSpec (yyt); 
 yyWriteSelector ("DirOut"); yyWriteAdr (yyt->FuncSpec.DirOut);
 yyWriteSelector ("DirOutIndex"); yyWriteAdr (yyt->FuncSpec.DirOutIndex);
 yyWriteSelector ("Step"); yyWriteAdr (yyt->FuncSpec.Step);
 yyWriteSelector ("Reduce"); yyWriteAdr (yyt->FuncSpec.Reduce);
}

static void yWriteNodeProcSpec
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeDirSpec (yyt); 
 yyWriteSelector ("Expr"); yyWriteAdr (yyt->ProcSpec.Expr);
 yyWriteSelector ("Reduce"); yyWriteAdr (yyt->ProcSpec.Reduce);
}

static void yWriteNodeDimSpec
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeDirSpec (yyt); 
 yyWriteSelector ("Actuals"); yyWriteAdr (yyt->DimSpec.Actuals);
 yyWriteSelector ("Reduce"); yyWriteAdr (yyt->DimSpec.Reduce);
 yyWriteSelector ("HelpVar"); writetIdent (yyt->DimSpec.HelpVar) yyWriteNl ();
 yyWriteSelector ("SecondHelpVar"); writetIdent (yyt->DimSpec.SecondHelpVar) yyWriteNl ();
}

static void yWriteNodeElems
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Env"); writetEnv (yyt->Elems.Env) yyWriteNl ();
 yyWriteSelector ("Level"); writeINDEX (yyt->Elems.Level) yyWriteNl ();
 yyWriteSelector ("UseHelpVar"); writeBOOLEAN (yyt->Elems.UseHelpVar) yyWriteNl ();
 yyWriteSelector ("IsCConst"); writeBOOLEAN (yyt->Elems.IsCConst) yyWriteNl ();
 yyWriteSelector ("IsP3Const"); writeBOOLEAN (yyt->Elems.IsP3Const) yyWriteNl ();
 yyWriteSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->Elems.OpenAccessOrCall) yyWriteNl ();
 yyWriteSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Elems.GlobalPtrs) yyWriteNl ();
 yyWriteSelector ("StrsIn"); writetStrings (yyt->Elems.StrsIn) yyWriteNl ();
 yyWriteSelector ("StrsOut"); writetStrings (yyt->Elems.StrsOut) yyWriteNl ();
}

static void yWriteNodeNoElem
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeElems (yyt); 
}

static void yWriteNodeElem
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeElems (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->Elem.Next);
}

static void yWriteNodeElemExpr
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeElem (yyt); 
 yyWriteSelector ("Elem"); yyWriteAdr (yyt->ElemExpr.Elem);
}

static void yWriteNodeElemRange
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeElem (yyt); 
 yyWriteSelector ("Lwb"); yyWriteAdr (yyt->ElemRange.Lwb);
 yyWriteSelector ("Upb"); yyWriteAdr (yyt->ElemRange.Upb);
}

static void yWriteNodeActuals
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Env"); writetEnv (yyt->Actuals.Env) yyWriteNl ();
 yyWriteSelector ("ReduceNumber"); writeULONG (yyt->Actuals.ReduceNumber) yyWriteNl ();
 yyWriteSelector ("ActualsNumber"); writeULONG (yyt->Actuals.ActualsNumber) yyWriteNl ();
 yyWriteSelector ("Types"); writetTypes (yyt->Actuals.Types) yyWriteNl ();
 yyWriteSelector ("Formals"); writetTypes (yyt->Actuals.Formals) yyWriteNl ();
 yyWriteSelector ("Level"); writeINDEX (yyt->Actuals.Level) yyWriteNl ();
 yyWriteSelector ("UseHelpVar"); writeBOOLEAN (yyt->Actuals.UseHelpVar) yyWriteNl ();
 yyWriteSelector ("IsCConst"); writeBOOLEAN (yyt->Actuals.IsCConst) yyWriteNl ();
 yyWriteSelector ("IsP3Const"); writeBOOLEAN (yyt->Actuals.IsP3Const) yyWriteNl ();
 yyWriteSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->Actuals.OpenAccessOrCall) yyWriteNl ();
 yyWriteSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Actuals.GlobalPtrs) yyWriteNl ();
 yyWriteSelector ("StrsIn"); writetStrings (yyt->Actuals.StrsIn) yyWriteNl ();
 yyWriteSelector ("StrsOut"); writetStrings (yyt->Actuals.StrsOut) yyWriteNl ();
}

static void yWriteNodeNoActual
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeActuals (yyt); 
}

static void yWriteNodeActual
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeActuals (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->Actual.Next);
 yyWriteSelector ("IsVAR"); writeBOOLEAN (yyt->Actual.IsVAR) yyWriteNl ();
 yyWriteSelector ("Formal"); writetType (yyt->Actual.Formal) yyWriteNl ();
}

static void yWriteNodeActualExpr
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeActual (yyt); 
 yyWriteSelector ("Expr"); yyWriteAdr (yyt->ActualExpr.Expr);
 yyWriteSelector ("HelpVar"); writetIdent (yyt->ActualExpr.HelpVar) yyWriteNl ();
 yyWriteSelector ("String"); writetIdent (yyt->ActualExpr.String) yyWriteNl ();
}

static void yWriteNodeActualRange
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeActual (yyt); 
 yyWriteSelector ("Lwb"); yyWriteAdr (yyt->ActualRange.Lwb);
 yyWriteSelector ("Upb"); yyWriteAdr (yyt->ActualRange.Upb);
}

static void yWriteNodeActualReduce
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeActual (yyt); 
 yyWriteSelector ("Qualid"); yyWriteAdr (yyt->ActualReduce.Qualid);
 yyWriteSelector ("HelpVar"); writetIdent (yyt->ActualReduce.HelpVar) yyWriteNl ();
}

static void yWriteNodeActualStar
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeActual (yyt); 
 yyWriteSelector ("HelpVar"); writetIdent (yyt->ActualStar.HelpVar) yyWriteNl ();
}

static void yWriteNodeStmts
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Env"); writetEnv (yyt->Stmts.Env) yyWriteNl ();
 yyWriteSelector ("Level"); writeINDEX (yyt->Stmts.Level) yyWriteNl ();
 yyWriteSelector ("IsVectorExit"); writeBOOLEAN (yyt->Stmts.IsVectorExit) yyWriteNl ();
 yyWriteSelector ("ExitConfigsIn"); writetConfigs (yyt->Stmts.ExitConfigsIn) yyWriteNl ();
 yyWriteSelector ("ExitConfigsOut"); writetConfigs (yyt->Stmts.ExitConfigsOut) yyWriteNl ();
 yyWriteSelector ("ReturnConfigsIn"); writetConfigs (yyt->Stmts.ReturnConfigsIn) yyWriteNl ();
 yyWriteSelector ("ReturnConfigsOut"); writetConfigs (yyt->Stmts.ReturnConfigsOut) yyWriteNl ();
 yyWriteSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Stmts.GlobalPtrs) yyWriteNl ();
 yyWriteSelector ("StrsIn"); writetStrings (yyt->Stmts.StrsIn) yyWriteNl ();
 yyWriteSelector ("StrsOut"); writetStrings (yyt->Stmts.StrsOut) yyWriteNl ();
 yyWriteSelector ("Type"); writetType (yyt->Stmts.Type) yyWriteNl ();
}

static void yWriteNodeNoStmt
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeStmts (yyt); 
}

static void yWriteNodeStmt
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeStmts (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->Stmt.Next);
 yyWriteSelector ("Pos"); writetPosition (yyt->Stmt.Pos) yyWriteNl ();
}

static void yWriteNodeAssign
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeStmt (yyt); 
 yyWriteSelector ("Designator"); yyWriteAdr (yyt->Assign.Designator);
 yyWriteSelector ("Expr"); yyWriteAdr (yyt->Assign.Expr);
}

static void yWriteNodeCall
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeStmt (yyt); 
 yyWriteSelector ("Designator"); yyWriteAdr (yyt->Call.Designator);
 yyWriteSelector ("Actuals"); yyWriteAdr (yyt->Call.Actuals);
 yyWriteSelector ("CheckProcs"); writetType (yyt->Call.CheckProcs) yyWriteNl ();
 yyWriteSelector ("AllocOrDealloc"); writetObject (yyt->Call.AllocOrDealloc) yyWriteNl ();
}

static void yWriteNodeIf
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeStmt (yyt); 
 yyWriteSelector ("Cond"); yyWriteAdr (yyt->If.Cond);
 yyWriteSelector ("Then"); yyWriteAdr (yyt->If.Then);
 yyWriteSelector ("Elsifs"); yyWriteAdr (yyt->If.Elsifs);
 yyWriteSelector ("Else"); yyWriteAdr (yyt->If.Else);
}

static void yWriteNodeCase
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeStmt (yyt); 
 yyWriteSelector ("Default"); writeBOOLEAN (yyt->Case.Default) yyWriteNl ();
 yyWriteSelector ("Expr"); yyWriteAdr (yyt->Case.Expr);
 yyWriteSelector ("Cases"); yyWriteAdr (yyt->Case.Cases);
 yyWriteSelector ("Else"); yyWriteAdr (yyt->Case.Else);
}

static void yWriteNodeWhile
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeStmt (yyt); 
 yyWriteSelector ("Cond"); yyWriteAdr (yyt->While.Cond);
 yyWriteSelector ("Stmts"); yyWriteAdr (yyt->While.Stmts);
}

static void yWriteNodeRepeat
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeStmt (yyt); 
 yyWriteSelector ("Stmts"); yyWriteAdr (yyt->Repeat.Stmts);
 yyWriteSelector ("Cond"); yyWriteAdr (yyt->Repeat.Cond);
}

static void yWriteNodeLoop
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeStmt (yyt); 
 yyWriteSelector ("Stmts"); yyWriteAdr (yyt->Loop.Stmts);
 yyWriteSelector ("ExitConfigs"); writetConfigs (yyt->Loop.ExitConfigs) yyWriteNl ();
}

static void yWriteNodeLooppar
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeStmt (yyt); 
 yyWriteSelector ("Qualid"); yyWriteAdr (yyt->Looppar.Qualid);
 yyWriteSelector ("Stmts"); yyWriteAdr (yyt->Looppar.Stmts);
 yyWriteSelector ("ExitConfigs"); writetConfigs (yyt->Looppar.ExitConfigs) yyWriteNl ();
}

static void yWriteNodeFor
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeStmt (yyt); 
 yyWriteSelector ("Qualid"); yyWriteAdr (yyt->For.Qualid);
 yyWriteSelector ("From"); yyWriteAdr (yyt->For.From);
 yyWriteSelector ("To"); yyWriteAdr (yyt->For.To);
 yyWriteSelector ("By"); yyWriteAdr (yyt->For.By);
 yyWriteSelector ("Stmts"); yyWriteAdr (yyt->For.Stmts);
 yyWriteSelector ("ToVal"); writetValue (yyt->For.ToVal) yyWriteNl ();
 yyWriteSelector ("ByVal"); writetValue (yyt->For.ByVal) yyWriteNl ();
}

static void yWriteNodeWith
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeStmt (yyt); 
 yyWriteSelector ("Designator"); yyWriteAdr (yyt->With.Designator);
 yyWriteSelector ("Stmts"); yyWriteAdr (yyt->With.Stmts);
}

static void yWriteNodeAll
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeStmt (yyt); 
 yyWriteSelector ("Qualid"); yyWriteAdr (yyt->All.Qualid);
 yyWriteSelector ("Stmts"); yyWriteAdr (yyt->All.Stmts);
}

static void yWriteNodeSend
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeStmt (yyt); 
 yyWriteSelector ("DirSpec"); yyWriteAdr (yyt->Send.DirSpec);
 yyWriteSelector ("From"); yyWriteAdr (yyt->Send.From);
 yyWriteSelector ("To"); yyWriteAdr (yyt->Send.To);
}

static void yWriteNodeLoad
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeStmt (yyt); 
 yyWriteSelector ("SizeDef"); writeBOOLEAN (yyt->Load.SizeDef) yyWriteNl ();
 yyWriteSelector ("What"); yyWriteAdr (yyt->Load.What);
 yyWriteSelector ("From"); yyWriteAdr (yyt->Load.From);
 yyWriteSelector ("Size"); yyWriteAdr (yyt->Load.Size);
}

static void yWriteNodeStore
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeStmt (yyt); 
 yyWriteSelector ("SizeDef"); writeBOOLEAN (yyt->Store.SizeDef) yyWriteNl ();
 yyWriteSelector ("What"); yyWriteAdr (yyt->Store.What);
 yyWriteSelector ("To"); yyWriteAdr (yyt->Store.To);
 yyWriteSelector ("Size"); yyWriteAdr (yyt->Store.Size);
}

static void yWriteNodeExit
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeStmt (yyt); 
}

static void yWriteNodeReturn0
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeStmt (yyt); 
 yyWriteSelector ("ResultType"); writetType (yyt->Return0.ResultType) yyWriteNl ();
}

static void yWriteNodeReturn1
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeStmt (yyt); 
 yyWriteSelector ("Result"); yyWriteAdr (yyt->Return1.Result);
 yyWriteSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->Return1.OpenAccessOrCall) yyWriteNl ();
 yyWriteSelector ("ResultType"); writetType (yyt->Return1.ResultType) yyWriteNl ();
}

static void yWriteNodeElsifs
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Env"); writetEnv (yyt->Elsifs.Env) yyWriteNl ();
 yyWriteSelector ("Level"); writeINDEX (yyt->Elsifs.Level) yyWriteNl ();
 yyWriteSelector ("IsVectorExit"); writeBOOLEAN (yyt->Elsifs.IsVectorExit) yyWriteNl ();
 yyWriteSelector ("ExitConfigsIn"); writetConfigs (yyt->Elsifs.ExitConfigsIn) yyWriteNl ();
 yyWriteSelector ("ExitConfigsOut"); writetConfigs (yyt->Elsifs.ExitConfigsOut) yyWriteNl ();
 yyWriteSelector ("ReturnConfigsIn"); writetConfigs (yyt->Elsifs.ReturnConfigsIn) yyWriteNl ();
 yyWriteSelector ("ReturnConfigsOut"); writetConfigs (yyt->Elsifs.ReturnConfigsOut) yyWriteNl ();
 yyWriteSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Elsifs.GlobalPtrs) yyWriteNl ();
 yyWriteSelector ("StrsIn"); writetStrings (yyt->Elsifs.StrsIn) yyWriteNl ();
 yyWriteSelector ("StrsOut"); writetStrings (yyt->Elsifs.StrsOut) yyWriteNl ();
 yyWriteSelector ("Type"); writetType (yyt->Elsifs.Type) yyWriteNl ();
}

static void yWriteNodeNoElsif
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeElsifs (yyt); 
}

static void yWriteNodeElsif
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeElsifs (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->Elsif.Next);
 yyWriteSelector ("Cond"); yyWriteAdr (yyt->Elsif.Cond);
 yyWriteSelector ("Stmts"); yyWriteAdr (yyt->Elsif.Stmts);
}

static void yWriteNodeCases
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Env"); writetEnv (yyt->Cases.Env) yyWriteNl ();
 yyWriteSelector ("Level"); writeINDEX (yyt->Cases.Level) yyWriteNl ();
 yyWriteSelector ("IsVectorExit"); writeBOOLEAN (yyt->Cases.IsVectorExit) yyWriteNl ();
 yyWriteSelector ("ExitConfigsIn"); writetConfigs (yyt->Cases.ExitConfigsIn) yyWriteNl ();
 yyWriteSelector ("ExitConfigsOut"); writetConfigs (yyt->Cases.ExitConfigsOut) yyWriteNl ();
 yyWriteSelector ("ReturnConfigsIn"); writetConfigs (yyt->Cases.ReturnConfigsIn) yyWriteNl ();
 yyWriteSelector ("ReturnConfigsOut"); writetConfigs (yyt->Cases.ReturnConfigsOut) yyWriteNl ();
 yyWriteSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Cases.GlobalPtrs) yyWriteNl ();
 yyWriteSelector ("StrsIn"); writetStrings (yyt->Cases.StrsIn) yyWriteNl ();
 yyWriteSelector ("StrsOut"); writetStrings (yyt->Cases.StrsOut) yyWriteNl ();
 yyWriteSelector ("Type"); writetType (yyt->Cases.Type) yyWriteNl ();
}

static void yWriteNodeNoCase
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeCases (yyt); 
}

static void yWriteNodeCases1
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeCases (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->Cases1.Next);
 yyWriteSelector ("Labels"); yyWriteAdr (yyt->Cases1.Labels);
 yyWriteSelector ("Stmts"); yyWriteAdr (yyt->Cases1.Stmts);
}

static void yWriteNodeLabels
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyWriteSelector ("Env"); writetEnv (yyt->Labels.Env) yyWriteNl ();
}

static void yWriteNodeNoLabel
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeLabels (yyt); 
}

static void yWriteNodeLabel
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeLabels (yyt); 
 yyWriteSelector ("Next"); yyWriteAdr (yyt->Label.Next);
}

static void yWriteNodeLabelExpr
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeLabel (yyt); 
 yyWriteSelector ("Expr"); yyWriteAdr (yyt->LabelExpr.Expr);
 yyWriteSelector ("LabelVal"); writetValue (yyt->LabelExpr.LabelVal) yyWriteNl ();
}

static void yWriteNodeLabelRange
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yWriteNodeLabel (yyt); 
 yyWriteSelector ("Lwb"); yyWriteAdr (yyt->LabelRange.Lwb);
 yyWriteSelector ("Upb"); yyWriteAdr (yyt->LabelRange.Upb);
 yyWriteSelector ("LwbVal"); writetValue (yyt->LabelRange.LwbVal) yyWriteNl ();
 yyWriteSelector ("UpbVal"); writetValue (yyt->LabelRange.UpbVal) yyWriteNl ();
}

void WriteTreeNode
# if defined __STDC__ | defined __cplusplus
 (FILE * yyyf, tTree yyt)
# else
 (yyyf, yyt) FILE * yyyf; tTree yyt;
# endif
{
 yyf = yyyf;
 if (yyt == NoTree) { (void) fputs ("NoTree\n", yyf); return; }

 switch (yyt->Kind) {
case kROOT: (void) fputs (Tree_NodeName [kROOT], yyf); (void) fputc ('\n', yyf);
 yWriteNodeROOT (yyt); break;
case kCompUnits: (void) fputs (Tree_NodeName [kCompUnits], yyf); (void) fputc ('\n', yyf);
 yWriteNodeCompUnits (yyt); break;
case kNoCompUnit: (void) fputs (Tree_NodeName [kNoCompUnit], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoCompUnit (yyt); break;
case kCompUnit: (void) fputs (Tree_NodeName [kCompUnit], yyf); (void) fputc ('\n', yyf);
 yWriteNodeCompUnit (yyt); break;
case kDefMod: (void) fputs (Tree_NodeName [kDefMod], yyf); (void) fputc ('\n', yyf);
 yWriteNodeDefMod (yyt); break;
case kImplMod: (void) fputs (Tree_NodeName [kImplMod], yyf); (void) fputc ('\n', yyf);
 yWriteNodeImplMod (yyt); break;
case kImports: (void) fputs (Tree_NodeName [kImports], yyf); (void) fputc ('\n', yyf);
 yWriteNodeImports (yyt); break;
case kNoImport: (void) fputs (Tree_NodeName [kNoImport], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoImport (yyt); break;
case kImport: (void) fputs (Tree_NodeName [kImport], yyf); (void) fputc ('\n', yyf);
 yWriteNodeImport (yyt); break;
case kFrom: (void) fputs (Tree_NodeName [kFrom], yyf); (void) fputc ('\n', yyf);
 yWriteNodeFrom (yyt); break;
case kObjects: (void) fputs (Tree_NodeName [kObjects], yyf); (void) fputc ('\n', yyf);
 yWriteNodeObjects (yyt); break;
case kImpIds: (void) fputs (Tree_NodeName [kImpIds], yyf); (void) fputc ('\n', yyf);
 yWriteNodeImpIds (yyt); break;
case kNoImpId: (void) fputs (Tree_NodeName [kNoImpId], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoImpId (yyt); break;
case kImpId: (void) fputs (Tree_NodeName [kImpId], yyf); (void) fputc ('\n', yyf);
 yWriteNodeImpId (yyt); break;
case kExports: (void) fputs (Tree_NodeName [kExports], yyf); (void) fputc ('\n', yyf);
 break;
case kNoExport: (void) fputs (Tree_NodeName [kNoExport], yyf); (void) fputc ('\n', yyf);
 break;
case kExport: (void) fputs (Tree_NodeName [kExport], yyf); (void) fputc ('\n', yyf);
 yWriteNodeExport (yyt); break;
case kExpIds: (void) fputs (Tree_NodeName [kExpIds], yyf); (void) fputc ('\n', yyf);
 break;
case kNoExpId: (void) fputs (Tree_NodeName [kNoExpId], yyf); (void) fputc ('\n', yyf);
 break;
case kExpId: (void) fputs (Tree_NodeName [kExpId], yyf); (void) fputc ('\n', yyf);
 yWriteNodeExpId (yyt); break;
case kDecls: (void) fputs (Tree_NodeName [kDecls], yyf); (void) fputc ('\n', yyf);
 yWriteNodeDecls (yyt); break;
case kNoDecl: (void) fputs (Tree_NodeName [kNoDecl], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoDecl (yyt); break;
case kDecl: (void) fputs (Tree_NodeName [kDecl], yyf); (void) fputc ('\n', yyf);
 yWriteNodeDecl (yyt); break;
case kVar: (void) fputs (Tree_NodeName [kVar], yyf); (void) fputc ('\n', yyf);
 yWriteNodeVar (yyt); break;
case kObject: (void) fputs (Tree_NodeName [kObject], yyf); (void) fputc ('\n', yyf);
 yWriteNodeObject (yyt); break;
case kConnectFrom: (void) fputs (Tree_NodeName [kConnectFrom], yyf); (void) fputc ('\n', yyf);
 yWriteNodeConnectFrom (yyt); break;
case kConnectDecls: (void) fputs (Tree_NodeName [kConnectDecls], yyf); (void) fputc ('\n', yyf);
 yWriteNodeConnectDecls (yyt); break;
case kConfig: (void) fputs (Tree_NodeName [kConfig], yyf); (void) fputc ('\n', yyf);
 yWriteNodeConfig (yyt); break;
case kConst: (void) fputs (Tree_NodeName [kConst], yyf); (void) fputc ('\n', yyf);
 yWriteNodeConst (yyt); break;
case kTypeDecl: (void) fputs (Tree_NodeName [kTypeDecl], yyf); (void) fputc ('\n', yyf);
 yWriteNodeTypeDecl (yyt); break;
case kProc: (void) fputs (Tree_NodeName [kProc], yyf); (void) fputc ('\n', yyf);
 yWriteNodeProc (yyt); break;
case kProcHead: (void) fputs (Tree_NodeName [kProcHead], yyf); (void) fputc ('\n', yyf);
 yWriteNodeProcHead (yyt); break;
case kOpaque: (void) fputs (Tree_NodeName [kOpaque], yyf); (void) fputc ('\n', yyf);
 yWriteNodeOpaque (yyt); break;
case kConnectDests: (void) fputs (Tree_NodeName [kConnectDests], yyf); (void) fputc ('\n', yyf);
 yWriteNodeConnectDests (yyt); break;
case kNoConnectDest: (void) fputs (Tree_NodeName [kNoConnectDest], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoConnectDest (yyt); break;
case kConnectDest: (void) fputs (Tree_NodeName [kConnectDest], yyf); (void) fputc ('\n', yyf);
 yWriteNodeConnectDest (yyt); break;
case kConnectDestUni: (void) fputs (Tree_NodeName [kConnectDestUni], yyf); (void) fputc ('\n', yyf);
 yWriteNodeConnectDestUni (yyt); break;
case kConnectDestBi: (void) fputs (Tree_NodeName [kConnectDestBi], yyf); (void) fputc ('\n', yyf);
 yWriteNodeConnectDestBi (yyt); break;
case kVarIds: (void) fputs (Tree_NodeName [kVarIds], yyf); (void) fputc ('\n', yyf);
 yWriteNodeVarIds (yyt); break;
case kNoVarId: (void) fputs (Tree_NodeName [kNoVarId], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoVarId (yyt); break;
case kVarId: (void) fputs (Tree_NodeName [kVarId], yyf); (void) fputc ('\n', yyf);
 yWriteNodeVarId (yyt); break;
case kFormals: (void) fputs (Tree_NodeName [kFormals], yyf); (void) fputc ('\n', yyf);
 yWriteNodeFormals (yyt); break;
case kNoFormal: (void) fputs (Tree_NodeName [kNoFormal], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoFormal (yyt); break;
case kFormal: (void) fputs (Tree_NodeName [kFormal], yyf); (void) fputc ('\n', yyf);
 yWriteNodeFormal (yyt); break;
case kParIds: (void) fputs (Tree_NodeName [kParIds], yyf); (void) fputc ('\n', yyf);
 yWriteNodeParIds (yyt); break;
case kNoParId: (void) fputs (Tree_NodeName [kNoParId], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoParId (yyt); break;
case kParId: (void) fputs (Tree_NodeName [kParId], yyf); (void) fputc ('\n', yyf);
 yWriteNodeParId (yyt); break;
case kType: (void) fputs (Tree_NodeName [kType], yyf); (void) fputc ('\n', yyf);
 yWriteNodeType (yyt); break;
case kVector: (void) fputs (Tree_NodeName [kVector], yyf); (void) fputc ('\n', yyf);
 yWriteNodeVector (yyt); break;
case kArray: (void) fputs (Tree_NodeName [kArray], yyf); (void) fputc ('\n', yyf);
 yWriteNodeArray (yyt); break;
case kRecord: (void) fputs (Tree_NodeName [kRecord], yyf); (void) fputc ('\n', yyf);
 yWriteNodeRecord (yyt); break;
case kSetType: (void) fputs (Tree_NodeName [kSetType], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSetType (yyt); break;
case kPointer: (void) fputs (Tree_NodeName [kPointer], yyf); (void) fputc ('\n', yyf);
 yWriteNodePointer (yyt); break;
case kProcType: (void) fputs (Tree_NodeName [kProcType], yyf); (void) fputc ('\n', yyf);
 yWriteNodeProcType (yyt); break;
case kSimpleType: (void) fputs (Tree_NodeName [kSimpleType], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSimpleType (yyt); break;
case kEnumeration: (void) fputs (Tree_NodeName [kEnumeration], yyf); (void) fputc ('\n', yyf);
 yWriteNodeEnumeration (yyt); break;
case kSubrange: (void) fputs (Tree_NodeName [kSubrange], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSubrange (yyt); break;
case kPrimaryType: (void) fputs (Tree_NodeName [kPrimaryType], yyf); (void) fputc ('\n', yyf);
 yWriteNodePrimaryType (yyt); break;
case kVoid: (void) fputs (Tree_NodeName [kVoid], yyf); (void) fputc ('\n', yyf);
 yWriteNodeVoid (yyt); break;
case kTypeId: (void) fputs (Tree_NodeName [kTypeId], yyf); (void) fputc ('\n', yyf);
 yWriteNodeTypeId (yyt); break;
case kTypeId0: (void) fputs (Tree_NodeName [kTypeId0], yyf); (void) fputc ('\n', yyf);
 yWriteNodeTypeId0 (yyt); break;
case kTypeId1: (void) fputs (Tree_NodeName [kTypeId1], yyf); (void) fputc ('\n', yyf);
 yWriteNodeTypeId1 (yyt); break;
case kFields: (void) fputs (Tree_NodeName [kFields], yyf); (void) fputc ('\n', yyf);
 yWriteNodeFields (yyt); break;
case kNoField: (void) fputs (Tree_NodeName [kNoField], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoField (yyt); break;
case kField: (void) fputs (Tree_NodeName [kField], yyf); (void) fputc ('\n', yyf);
 yWriteNodeField (yyt); break;
case kRecordSect: (void) fputs (Tree_NodeName [kRecordSect], yyf); (void) fputc ('\n', yyf);
 yWriteNodeRecordSect (yyt); break;
case kVariantSect: (void) fputs (Tree_NodeName [kVariantSect], yyf); (void) fputc ('\n', yyf);
 yWriteNodeVariantSect (yyt); break;
case kFieldIds: (void) fputs (Tree_NodeName [kFieldIds], yyf); (void) fputc ('\n', yyf);
 yWriteNodeFieldIds (yyt); break;
case kNoFieldId: (void) fputs (Tree_NodeName [kNoFieldId], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoFieldId (yyt); break;
case kFieldId: (void) fputs (Tree_NodeName [kFieldId], yyf); (void) fputc ('\n', yyf);
 yWriteNodeFieldId (yyt); break;
case kTagField: (void) fputs (Tree_NodeName [kTagField], yyf); (void) fputc ('\n', yyf);
 yWriteNodeTagField (yyt); break;
case kTagField1: (void) fputs (Tree_NodeName [kTagField1], yyf); (void) fputc ('\n', yyf);
 yWriteNodeTagField1 (yyt); break;
case kTagField2: (void) fputs (Tree_NodeName [kTagField2], yyf); (void) fputc ('\n', yyf);
 yWriteNodeTagField2 (yyt); break;
case kVariants: (void) fputs (Tree_NodeName [kVariants], yyf); (void) fputc ('\n', yyf);
 yWriteNodeVariants (yyt); break;
case kNoVariant: (void) fputs (Tree_NodeName [kNoVariant], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoVariant (yyt); break;
case kVariant: (void) fputs (Tree_NodeName [kVariant], yyf); (void) fputc ('\n', yyf);
 yWriteNodeVariant (yyt); break;
case kFormalTypes: (void) fputs (Tree_NodeName [kFormalTypes], yyf); (void) fputc ('\n', yyf);
 yWriteNodeFormalTypes (yyt); break;
case kNoFormalType: (void) fputs (Tree_NodeName [kNoFormalType], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoFormalType (yyt); break;
case kFormalType: (void) fputs (Tree_NodeName [kFormalType], yyf); (void) fputc ('\n', yyf);
 yWriteNodeFormalType (yyt); break;
case kEnumIds: (void) fputs (Tree_NodeName [kEnumIds], yyf); (void) fputc ('\n', yyf);
 yWriteNodeEnumIds (yyt); break;
case kNoEnumId: (void) fputs (Tree_NodeName [kNoEnumId], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoEnumId (yyt); break;
case kEnumId: (void) fputs (Tree_NodeName [kEnumId], yyf); (void) fputc ('\n', yyf);
 yWriteNodeEnumId (yyt); break;
case kExpr: (void) fputs (Tree_NodeName [kExpr], yyf); (void) fputc ('\n', yyf);
 yWriteNodeExpr (yyt); break;
case kNoExpr: (void) fputs (Tree_NodeName [kNoExpr], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoExpr (yyt); break;
case kMultiples: (void) fputs (Tree_NodeName [kMultiples], yyf); (void) fputc ('\n', yyf);
 yWriteNodeMultiples (yyt); break;
case kLastMultiple: (void) fputs (Tree_NodeName [kLastMultiple], yyf); (void) fputc ('\n', yyf);
 yWriteNodeLastMultiple (yyt); break;
case kMultiple: (void) fputs (Tree_NodeName [kMultiple], yyf); (void) fputc ('\n', yyf);
 yWriteNodeMultiple (yyt); break;
case kBinary: (void) fputs (Tree_NodeName [kBinary], yyf); (void) fputc ('\n', yyf);
 yWriteNodeBinary (yyt); break;
case kUnary: (void) fputs (Tree_NodeName [kUnary], yyf); (void) fputc ('\n', yyf);
 yWriteNodeUnary (yyt); break;
case kIntConst: (void) fputs (Tree_NodeName [kIntConst], yyf); (void) fputc ('\n', yyf);
 yWriteNodeIntConst (yyt); break;
case kRealConst: (void) fputs (Tree_NodeName [kRealConst], yyf); (void) fputc ('\n', yyf);
 yWriteNodeRealConst (yyt); break;
case kStringConst: (void) fputs (Tree_NodeName [kStringConst], yyf); (void) fputc ('\n', yyf);
 yWriteNodeStringConst (yyt); break;
case kCharConst: (void) fputs (Tree_NodeName [kCharConst], yyf); (void) fputc ('\n', yyf);
 yWriteNodeCharConst (yyt); break;
case kFuncCall: (void) fputs (Tree_NodeName [kFuncCall], yyf); (void) fputc ('\n', yyf);
 yWriteNodeFuncCall (yyt); break;
case kMove: (void) fputs (Tree_NodeName [kMove], yyf); (void) fputc ('\n', yyf);
 yWriteNodeMove (yyt); break;
case kReceive: (void) fputs (Tree_NodeName [kReceive], yyf); (void) fputc ('\n', yyf);
 yWriteNodeReceive (yyt); break;
case kReduce: (void) fputs (Tree_NodeName [kReduce], yyf); (void) fputc ('\n', yyf);
 yWriteNodeReduce (yyt); break;
case kSet: (void) fputs (Tree_NodeName [kSet], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSet (yyt); break;
case kBitSet: (void) fputs (Tree_NodeName [kBitSet], yyf); (void) fputc ('\n', yyf);
 yWriteNodeBitSet (yyt); break;
case kDesignator: (void) fputs (Tree_NodeName [kDesignator], yyf); (void) fputc ('\n', yyf);
 yWriteNodeDesignator (yyt); break;
case kQualid: (void) fputs (Tree_NodeName [kQualid], yyf); (void) fputc ('\n', yyf);
 yWriteNodeQualid (yyt); break;
case kQualid0: (void) fputs (Tree_NodeName [kQualid0], yyf); (void) fputc ('\n', yyf);
 yWriteNodeQualid0 (yyt); break;
case kQualid1: (void) fputs (Tree_NodeName [kQualid1], yyf); (void) fputc ('\n', yyf);
 yWriteNodeQualid1 (yyt); break;
case kProcessor: (void) fputs (Tree_NodeName [kProcessor], yyf); (void) fputc ('\n', yyf);
 yWriteNodeProcessor (yyt); break;
case kDimensions: (void) fputs (Tree_NodeName [kDimensions], yyf); (void) fputc ('\n', yyf);
 yWriteNodeDimensions (yyt); break;
case kSelect: (void) fputs (Tree_NodeName [kSelect], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSelect (yyt); break;
case kSubscript: (void) fputs (Tree_NodeName [kSubscript], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSubscript (yyt); break;
case kDeref: (void) fputs (Tree_NodeName [kDeref], yyf); (void) fputc ('\n', yyf);
 yWriteNodeDeref (yyt); break;
case kDirSpec: (void) fputs (Tree_NodeName [kDirSpec], yyf); (void) fputc ('\n', yyf);
 yWriteNodeDirSpec (yyt); break;
case kFuncSpec: (void) fputs (Tree_NodeName [kFuncSpec], yyf); (void) fputc ('\n', yyf);
 yWriteNodeFuncSpec (yyt); break;
case kProcSpec: (void) fputs (Tree_NodeName [kProcSpec], yyf); (void) fputc ('\n', yyf);
 yWriteNodeProcSpec (yyt); break;
case kDimSpec: (void) fputs (Tree_NodeName [kDimSpec], yyf); (void) fputc ('\n', yyf);
 yWriteNodeDimSpec (yyt); break;
case kElems: (void) fputs (Tree_NodeName [kElems], yyf); (void) fputc ('\n', yyf);
 yWriteNodeElems (yyt); break;
case kNoElem: (void) fputs (Tree_NodeName [kNoElem], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoElem (yyt); break;
case kElem: (void) fputs (Tree_NodeName [kElem], yyf); (void) fputc ('\n', yyf);
 yWriteNodeElem (yyt); break;
case kElemExpr: (void) fputs (Tree_NodeName [kElemExpr], yyf); (void) fputc ('\n', yyf);
 yWriteNodeElemExpr (yyt); break;
case kElemRange: (void) fputs (Tree_NodeName [kElemRange], yyf); (void) fputc ('\n', yyf);
 yWriteNodeElemRange (yyt); break;
case kActuals: (void) fputs (Tree_NodeName [kActuals], yyf); (void) fputc ('\n', yyf);
 yWriteNodeActuals (yyt); break;
case kNoActual: (void) fputs (Tree_NodeName [kNoActual], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoActual (yyt); break;
case kActual: (void) fputs (Tree_NodeName [kActual], yyf); (void) fputc ('\n', yyf);
 yWriteNodeActual (yyt); break;
case kActualExpr: (void) fputs (Tree_NodeName [kActualExpr], yyf); (void) fputc ('\n', yyf);
 yWriteNodeActualExpr (yyt); break;
case kActualRange: (void) fputs (Tree_NodeName [kActualRange], yyf); (void) fputc ('\n', yyf);
 yWriteNodeActualRange (yyt); break;
case kActualReduce: (void) fputs (Tree_NodeName [kActualReduce], yyf); (void) fputc ('\n', yyf);
 yWriteNodeActualReduce (yyt); break;
case kActualStar: (void) fputs (Tree_NodeName [kActualStar], yyf); (void) fputc ('\n', yyf);
 yWriteNodeActualStar (yyt); break;
case kStmts: (void) fputs (Tree_NodeName [kStmts], yyf); (void) fputc ('\n', yyf);
 yWriteNodeStmts (yyt); break;
case kNoStmt: (void) fputs (Tree_NodeName [kNoStmt], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoStmt (yyt); break;
case kStmt: (void) fputs (Tree_NodeName [kStmt], yyf); (void) fputc ('\n', yyf);
 yWriteNodeStmt (yyt); break;
case kAssign: (void) fputs (Tree_NodeName [kAssign], yyf); (void) fputc ('\n', yyf);
 yWriteNodeAssign (yyt); break;
case kCall: (void) fputs (Tree_NodeName [kCall], yyf); (void) fputc ('\n', yyf);
 yWriteNodeCall (yyt); break;
case kIf: (void) fputs (Tree_NodeName [kIf], yyf); (void) fputc ('\n', yyf);
 yWriteNodeIf (yyt); break;
case kCase: (void) fputs (Tree_NodeName [kCase], yyf); (void) fputc ('\n', yyf);
 yWriteNodeCase (yyt); break;
case kWhile: (void) fputs (Tree_NodeName [kWhile], yyf); (void) fputc ('\n', yyf);
 yWriteNodeWhile (yyt); break;
case kRepeat: (void) fputs (Tree_NodeName [kRepeat], yyf); (void) fputc ('\n', yyf);
 yWriteNodeRepeat (yyt); break;
case kLoop: (void) fputs (Tree_NodeName [kLoop], yyf); (void) fputc ('\n', yyf);
 yWriteNodeLoop (yyt); break;
case kLooppar: (void) fputs (Tree_NodeName [kLooppar], yyf); (void) fputc ('\n', yyf);
 yWriteNodeLooppar (yyt); break;
case kFor: (void) fputs (Tree_NodeName [kFor], yyf); (void) fputc ('\n', yyf);
 yWriteNodeFor (yyt); break;
case kWith: (void) fputs (Tree_NodeName [kWith], yyf); (void) fputc ('\n', yyf);
 yWriteNodeWith (yyt); break;
case kAll: (void) fputs (Tree_NodeName [kAll], yyf); (void) fputc ('\n', yyf);
 yWriteNodeAll (yyt); break;
case kSend: (void) fputs (Tree_NodeName [kSend], yyf); (void) fputc ('\n', yyf);
 yWriteNodeSend (yyt); break;
case kLoad: (void) fputs (Tree_NodeName [kLoad], yyf); (void) fputc ('\n', yyf);
 yWriteNodeLoad (yyt); break;
case kStore: (void) fputs (Tree_NodeName [kStore], yyf); (void) fputc ('\n', yyf);
 yWriteNodeStore (yyt); break;
case kExit: (void) fputs (Tree_NodeName [kExit], yyf); (void) fputc ('\n', yyf);
 yWriteNodeExit (yyt); break;
case kReturn0: (void) fputs (Tree_NodeName [kReturn0], yyf); (void) fputc ('\n', yyf);
 yWriteNodeReturn0 (yyt); break;
case kReturn1: (void) fputs (Tree_NodeName [kReturn1], yyf); (void) fputc ('\n', yyf);
 yWriteNodeReturn1 (yyt); break;
case kElsifs: (void) fputs (Tree_NodeName [kElsifs], yyf); (void) fputc ('\n', yyf);
 yWriteNodeElsifs (yyt); break;
case kNoElsif: (void) fputs (Tree_NodeName [kNoElsif], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoElsif (yyt); break;
case kElsif: (void) fputs (Tree_NodeName [kElsif], yyf); (void) fputc ('\n', yyf);
 yWriteNodeElsif (yyt); break;
case kCases: (void) fputs (Tree_NodeName [kCases], yyf); (void) fputc ('\n', yyf);
 yWriteNodeCases (yyt); break;
case kNoCase: (void) fputs (Tree_NodeName [kNoCase], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoCase (yyt); break;
case kCases1: (void) fputs (Tree_NodeName [kCases1], yyf); (void) fputc ('\n', yyf);
 yWriteNodeCases1 (yyt); break;
case kLabels: (void) fputs (Tree_NodeName [kLabels], yyf); (void) fputc ('\n', yyf);
 yWriteNodeLabels (yyt); break;
case kNoLabel: (void) fputs (Tree_NodeName [kNoLabel], yyf); (void) fputc ('\n', yyf);
 yWriteNodeNoLabel (yyt); break;
case kLabel: (void) fputs (Tree_NodeName [kLabel], yyf); (void) fputc ('\n', yyf);
 yWriteNodeLabel (yyt); break;
case kLabelExpr: (void) fputs (Tree_NodeName [kLabelExpr], yyf); (void) fputc ('\n', yyf);
 yWriteNodeLabelExpr (yyt); break;
case kLabelRange: (void) fputs (Tree_NodeName [kLabelRange], yyf); (void) fputc ('\n', yyf);
 yWriteNodeLabelRange (yyt); break;
 default: ;
 }
}

static short yyIndentLevel;

void WriteTree
# if defined __STDC__ | defined __cplusplus
 (FILE * yyyf, tTree yyt)
# else
 (yyyf, yyt) FILE * yyyf; tTree yyt;
# endif
{
 short yySaveLevel = yyIndentLevel;
 yyf = yyyf;
 if (yyRecursionLevel ++ == 0) yyLabelCount = 0;
 yyMark (yyt);
 yyIndentLevel = 0;
 yyWriteTree (yyt);
 yyIndentLevel = yySaveLevel;
 yyRecursionLevel --;
}

static void yyIndentSelector
# if defined __STDC__ | defined __cplusplus
 (char * yys)
# else
 (yys) char * yys;
# endif
{
 register int yyi;
 for (yyi = 1; yyi <= yyIndentLevel; yyi ++) (void) putc (' ', yyf);
 yyWriteSelector (yys);
}

static void yyIndentSelectorTree
# if defined __STDC__ | defined __cplusplus
 (char * yys, tTree yyt)
# else
 (yys, yyt) char * yys; tTree yyt;
# endif
{ yyIndentSelector (yys); writetTree (yyt) }

static void yWriteROOT
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kROOT], yyf); (void) fputc ('\n', yyf);
}

static void yWriteCompUnits
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kCompUnits], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->CompUnits.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetVoid (yyt->CompUnits.Objects2) yyWriteNl ();
 yyIndentSelector ("Objects3"); writetObjects (yyt->CompUnits.Objects3) yyWriteNl ();
 yyIndentSelector ("Objects4In"); writetVoid (yyt->CompUnits.Objects4In) yyWriteNl ();
 yyIndentSelector ("Objects4Out"); writetVoid (yyt->CompUnits.Objects4Out) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->CompUnits.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->CompUnits.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->CompUnits.Env3) yyWriteNl ();
 yyIndentSelector ("ConfigGroupIn"); writeINDEX (yyt->CompUnits.ConfigGroupIn) yyWriteNl ();
 yyIndentSelector ("ImplIdent"); writetIdent (yyt->CompUnits.ImplIdent) yyWriteNl ();
 yyIndentSelector ("ImplTypes"); writetObjects (yyt->CompUnits.ImplTypes) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->CompUnits.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->CompUnits.PosOut) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->CompUnits.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->CompUnits.IdsOut) yyWriteNl ();
}

static void yWriteNoCompUnit
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoCompUnit], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->NoCompUnit.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetVoid (yyt->NoCompUnit.Objects2) yyWriteNl ();
 yyIndentSelector ("Objects3"); writetObjects (yyt->NoCompUnit.Objects3) yyWriteNl ();
 yyIndentSelector ("Objects4In"); writetVoid (yyt->NoCompUnit.Objects4In) yyWriteNl ();
 yyIndentSelector ("Objects4Out"); writetVoid (yyt->NoCompUnit.Objects4Out) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->NoCompUnit.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->NoCompUnit.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->NoCompUnit.Env3) yyWriteNl ();
 yyIndentSelector ("ConfigGroupIn"); writeINDEX (yyt->NoCompUnit.ConfigGroupIn) yyWriteNl ();
 yyIndentSelector ("ImplIdent"); writetIdent (yyt->NoCompUnit.ImplIdent) yyWriteNl ();
 yyIndentSelector ("ImplTypes"); writetObjects (yyt->NoCompUnit.ImplTypes) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->NoCompUnit.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->NoCompUnit.PosOut) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->NoCompUnit.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->NoCompUnit.IdsOut) yyWriteNl ();
}

static void yWriteCompUnit
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kCompUnit], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->CompUnit.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetVoid (yyt->CompUnit.Objects2) yyWriteNl ();
 yyIndentSelector ("Objects3"); writetObjects (yyt->CompUnit.Objects3) yyWriteNl ();
 yyIndentSelector ("Objects4In"); writetVoid (yyt->CompUnit.Objects4In) yyWriteNl ();
 yyIndentSelector ("Objects4Out"); writetVoid (yyt->CompUnit.Objects4Out) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->CompUnit.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->CompUnit.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->CompUnit.Env3) yyWriteNl ();
 yyIndentSelector ("ConfigGroupIn"); writeINDEX (yyt->CompUnit.ConfigGroupIn) yyWriteNl ();
 yyIndentSelector ("ImplIdent"); writetIdent (yyt->CompUnit.ImplIdent) yyWriteNl ();
 yyIndentSelector ("ImplTypes"); writetObjects (yyt->CompUnit.ImplTypes) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->CompUnit.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->CompUnit.PosOut) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->CompUnit.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->CompUnit.IdsOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->CompUnit.Kind) yyWriteNl ();
 yyIndentSelector ("Ident"); writetIdent (yyt->CompUnit.Ident) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->CompUnit.Pos) yyWriteNl ();
 yyIndentSelector ("Object"); writetObject (yyt->CompUnit.Object) yyWriteNl ();
 yyIndentSelector ("RealName"); writetIdent (yyt->CompUnit.RealName) yyWriteNl ();
}

static void yWriteDefMod
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kDefMod], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->DefMod.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetVoid (yyt->DefMod.Objects2) yyWriteNl ();
 yyIndentSelector ("Objects3"); writetObjects (yyt->DefMod.Objects3) yyWriteNl ();
 yyIndentSelector ("Objects4In"); writetVoid (yyt->DefMod.Objects4In) yyWriteNl ();
 yyIndentSelector ("Objects4Out"); writetVoid (yyt->DefMod.Objects4Out) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->DefMod.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->DefMod.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->DefMod.Env3) yyWriteNl ();
 yyIndentSelector ("ConfigGroupIn"); writeINDEX (yyt->DefMod.ConfigGroupIn) yyWriteNl ();
 yyIndentSelector ("ImplIdent"); writetIdent (yyt->DefMod.ImplIdent) yyWriteNl ();
 yyIndentSelector ("ImplTypes"); writetObjects (yyt->DefMod.ImplTypes) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->DefMod.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->DefMod.PosOut) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->DefMod.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->DefMod.IdsOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->DefMod.Kind) yyWriteNl ();
 yyIndentSelector ("Ident"); writetIdent (yyt->DefMod.Ident) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->DefMod.Pos) yyWriteNl ();
 yyIndentSelector ("Object"); writetObject (yyt->DefMod.Object) yyWriteNl ();
 yyIndentSelector ("RealName"); writetIdent (yyt->DefMod.RealName) yyWriteNl ();
 yyIndentSelectorTree ("Imports", yyt->DefMod.Imports);
 yyIndentSelectorTree ("Exports", yyt->DefMod.Exports);
 yyIndentSelectorTree ("Decls", yyt->DefMod.Decls);
}

static void yWriteImplMod
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kImplMod], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->ImplMod.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetVoid (yyt->ImplMod.Objects2) yyWriteNl ();
 yyIndentSelector ("Objects3"); writetObjects (yyt->ImplMod.Objects3) yyWriteNl ();
 yyIndentSelector ("Objects4In"); writetVoid (yyt->ImplMod.Objects4In) yyWriteNl ();
 yyIndentSelector ("Objects4Out"); writetVoid (yyt->ImplMod.Objects4Out) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->ImplMod.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->ImplMod.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->ImplMod.Env3) yyWriteNl ();
 yyIndentSelector ("ConfigGroupIn"); writeINDEX (yyt->ImplMod.ConfigGroupIn) yyWriteNl ();
 yyIndentSelector ("ImplIdent"); writetIdent (yyt->ImplMod.ImplIdent) yyWriteNl ();
 yyIndentSelector ("ImplTypes"); writetObjects (yyt->ImplMod.ImplTypes) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->ImplMod.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->ImplMod.PosOut) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->ImplMod.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->ImplMod.IdsOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->ImplMod.Kind) yyWriteNl ();
 yyIndentSelector ("Ident"); writetIdent (yyt->ImplMod.Ident) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->ImplMod.Pos) yyWriteNl ();
 yyIndentSelector ("Object"); writetObject (yyt->ImplMod.Object) yyWriteNl ();
 yyIndentSelector ("RealName"); writetIdent (yyt->ImplMod.RealName) yyWriteNl ();
 yyIndentSelectorTree ("Imports", yyt->ImplMod.Imports);
 yyIndentSelectorTree ("Decls", yyt->ImplMod.Decls);
 yyIndentSelectorTree ("Stmts", yyt->ImplMod.Stmts);
 yyIndentSelector ("BeginPos"); writetPosition (yyt->ImplMod.BeginPos) yyWriteNl ();
 yyIndentSelector ("DefObjects1"); writetObjects (yyt->ImplMod.DefObjects1) yyWriteNl ();
 yyIndentSelector ("DefObjects3"); writetObjects (yyt->ImplMod.DefObjects3) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writetCObjects (yyt->ImplMod.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("Strings"); writetStrings (yyt->ImplMod.Strings) yyWriteNl ();
}

static void yWriteImports
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kImports], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->Imports.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetObjects (yyt->Imports.Objects2) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->Imports.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetEnv (yyt->Imports.Env2) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->Imports.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->Imports.LocalIdsOut) yyWriteNl ();
}

static void yWriteNoImport
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoImport], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->NoImport.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetObjects (yyt->NoImport.Objects2) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->NoImport.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetEnv (yyt->NoImport.Env2) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->NoImport.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->NoImport.LocalIdsOut) yyWriteNl ();
}

static void yWriteImport
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kImport], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->Import.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetObjects (yyt->Import.Objects2) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->Import.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetEnv (yyt->Import.Env2) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->Import.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->Import.LocalIdsOut) yyWriteNl ();
}

static void yWriteFrom
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kFrom], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->From.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetObjects (yyt->From.Objects2) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->From.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetEnv (yyt->From.Env2) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->From.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->From.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("Ident"); writetIdent (yyt->From.Ident) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->From.Pos) yyWriteNl ();
 yyIndentSelectorTree ("ImpIds", yyt->From.ImpIds);
 yyIndentSelector ("Object1"); writetObject (yyt->From.Object1) yyWriteNl ();
 yyIndentSelector ("Object2"); writetObject (yyt->From.Object2) yyWriteNl ();
}

static void yWriteObjects
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kObjects], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->Objects.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetObjects (yyt->Objects.Objects2) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->Objects.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetEnv (yyt->Objects.Env2) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->Objects.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->Objects.LocalIdsOut) yyWriteNl ();
 yyIndentSelectorTree ("ImpIds", yyt->Objects.ImpIds);
}

static void yWriteImpIds
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kImpIds], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->ImpIds.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetObjects (yyt->ImpIds.Objects2) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->ImpIds.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetEnv (yyt->ImpIds.Env2) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->ImpIds.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->ImpIds.LocalIdsOut) yyWriteNl ();
}

static void yWriteNoImpId
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoImpId], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->NoImpId.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetObjects (yyt->NoImpId.Objects2) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->NoImpId.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetEnv (yyt->NoImpId.Env2) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->NoImpId.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->NoImpId.LocalIdsOut) yyWriteNl ();
}

static void yWriteImpId
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kImpId], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->ImpId.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetObjects (yyt->ImpId.Objects2) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->ImpId.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetEnv (yyt->ImpId.Env2) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->ImpId.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->ImpId.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("Ident"); writetIdent (yyt->ImpId.Ident) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->ImpId.Pos) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->ImpId.Type) yyWriteNl ();
 yyIndentSelector ("Object1"); writetObject (yyt->ImpId.Object1) yyWriteNl ();
 yyIndentSelector ("Object2"); writetObject (yyt->ImpId.Object2) yyWriteNl ();
 yyIndentSelector ("IsRedeclared"); writeBOOLEAN (yyt->ImpId.IsRedeclared) yyWriteNl ();
}

static void yWriteExport
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kExport], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Qualified"); writeBOOLEAN (yyt->Export.Qualified) yyWriteNl ();
}

static void yWriteExpId
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kExpId], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Ident"); writetIdent (yyt->ExpId.Ident) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->ExpId.Pos) yyWriteNl ();
}

static void yWriteDecls
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kDecls], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->Decls.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetVoid (yyt->Decls.Objects2) yyWriteNl ();
 yyIndentSelector ("Objects3"); writetObjects (yyt->Decls.Objects3) yyWriteNl ();
 yyIndentSelector ("Objects4In"); writetObjects (yyt->Decls.Objects4In) yyWriteNl ();
 yyIndentSelector ("Objects4Out"); writetObjects (yyt->Decls.Objects4Out) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->Decls.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->Decls.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->Decls.Env3) yyWriteNl ();
 yyIndentSelector ("Env4"); writetEnv (yyt->Decls.Env4) yyWriteNl ();
 yyIndentSelector ("ConfigGroupIn"); writeINDEX (yyt->Decls.ConfigGroupIn) yyWriteNl ();
 yyIndentSelector ("ConfigGroupOut"); writeINDEX (yyt->Decls.ConfigGroupOut) yyWriteNl ();
 yyIndentSelector ("DefTypes"); writetObjects (yyt->Decls.DefTypes) yyWriteNl ();
 yyIndentSelector ("DefObjects"); writetObjects (yyt->Decls.DefObjects) yyWriteNl ();
 yyIndentSelector ("ImplTypes"); writetObjects (yyt->Decls.ImplTypes) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->Decls.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->Decls.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->Decls.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->Decls.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->Decls.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->Decls.IdsOut) yyWriteNl ();
 yyIndentSelector ("ConnectsIn"); writetConnects (yyt->Decls.ConnectsIn) yyWriteNl ();
 yyIndentSelector ("ConnectsOut"); writetConnects (yyt->Decls.ConnectsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->Decls.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->Decls.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->Decls.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->Decls.CntOut) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Decls.Level) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Decls.GlobalPtrs) yyWriteNl ();
}

static void yWriteNoDecl
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoDecl], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->NoDecl.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetVoid (yyt->NoDecl.Objects2) yyWriteNl ();
 yyIndentSelector ("Objects3"); writetObjects (yyt->NoDecl.Objects3) yyWriteNl ();
 yyIndentSelector ("Objects4In"); writetObjects (yyt->NoDecl.Objects4In) yyWriteNl ();
 yyIndentSelector ("Objects4Out"); writetObjects (yyt->NoDecl.Objects4Out) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->NoDecl.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->NoDecl.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->NoDecl.Env3) yyWriteNl ();
 yyIndentSelector ("Env4"); writetEnv (yyt->NoDecl.Env4) yyWriteNl ();
 yyIndentSelector ("ConfigGroupIn"); writeINDEX (yyt->NoDecl.ConfigGroupIn) yyWriteNl ();
 yyIndentSelector ("ConfigGroupOut"); writeINDEX (yyt->NoDecl.ConfigGroupOut) yyWriteNl ();
 yyIndentSelector ("DefTypes"); writetObjects (yyt->NoDecl.DefTypes) yyWriteNl ();
 yyIndentSelector ("DefObjects"); writetObjects (yyt->NoDecl.DefObjects) yyWriteNl ();
 yyIndentSelector ("ImplTypes"); writetObjects (yyt->NoDecl.ImplTypes) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->NoDecl.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->NoDecl.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->NoDecl.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->NoDecl.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->NoDecl.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->NoDecl.IdsOut) yyWriteNl ();
 yyIndentSelector ("ConnectsIn"); writetConnects (yyt->NoDecl.ConnectsIn) yyWriteNl ();
 yyIndentSelector ("ConnectsOut"); writetConnects (yyt->NoDecl.ConnectsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->NoDecl.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->NoDecl.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->NoDecl.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->NoDecl.CntOut) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->NoDecl.Level) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->NoDecl.GlobalPtrs) yyWriteNl ();
}

static void yWriteDecl
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kDecl], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->Decl.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetVoid (yyt->Decl.Objects2) yyWriteNl ();
 yyIndentSelector ("Objects3"); writetObjects (yyt->Decl.Objects3) yyWriteNl ();
 yyIndentSelector ("Objects4In"); writetObjects (yyt->Decl.Objects4In) yyWriteNl ();
 yyIndentSelector ("Objects4Out"); writetObjects (yyt->Decl.Objects4Out) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->Decl.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->Decl.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->Decl.Env3) yyWriteNl ();
 yyIndentSelector ("Env4"); writetEnv (yyt->Decl.Env4) yyWriteNl ();
 yyIndentSelector ("ConfigGroupIn"); writeINDEX (yyt->Decl.ConfigGroupIn) yyWriteNl ();
 yyIndentSelector ("ConfigGroupOut"); writeINDEX (yyt->Decl.ConfigGroupOut) yyWriteNl ();
 yyIndentSelector ("DefTypes"); writetObjects (yyt->Decl.DefTypes) yyWriteNl ();
 yyIndentSelector ("DefObjects"); writetObjects (yyt->Decl.DefObjects) yyWriteNl ();
 yyIndentSelector ("ImplTypes"); writetObjects (yyt->Decl.ImplTypes) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->Decl.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->Decl.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->Decl.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->Decl.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->Decl.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->Decl.IdsOut) yyWriteNl ();
 yyIndentSelector ("ConnectsIn"); writetConnects (yyt->Decl.ConnectsIn) yyWriteNl ();
 yyIndentSelector ("ConnectsOut"); writetConnects (yyt->Decl.ConnectsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->Decl.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->Decl.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->Decl.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->Decl.CntOut) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Decl.Level) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Decl.GlobalPtrs) yyWriteNl ();
}

static void yWriteVar
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kVar], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->Var.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetVoid (yyt->Var.Objects2) yyWriteNl ();
 yyIndentSelector ("Objects3"); writetObjects (yyt->Var.Objects3) yyWriteNl ();
 yyIndentSelector ("Objects4In"); writetObjects (yyt->Var.Objects4In) yyWriteNl ();
 yyIndentSelector ("Objects4Out"); writetObjects (yyt->Var.Objects4Out) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->Var.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->Var.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->Var.Env3) yyWriteNl ();
 yyIndentSelector ("Env4"); writetEnv (yyt->Var.Env4) yyWriteNl ();
 yyIndentSelector ("ConfigGroupIn"); writeINDEX (yyt->Var.ConfigGroupIn) yyWriteNl ();
 yyIndentSelector ("ConfigGroupOut"); writeINDEX (yyt->Var.ConfigGroupOut) yyWriteNl ();
 yyIndentSelector ("DefTypes"); writetObjects (yyt->Var.DefTypes) yyWriteNl ();
 yyIndentSelector ("DefObjects"); writetObjects (yyt->Var.DefObjects) yyWriteNl ();
 yyIndentSelector ("ImplTypes"); writetObjects (yyt->Var.ImplTypes) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->Var.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->Var.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->Var.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->Var.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->Var.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->Var.IdsOut) yyWriteNl ();
 yyIndentSelector ("ConnectsIn"); writetConnects (yyt->Var.ConnectsIn) yyWriteNl ();
 yyIndentSelector ("ConnectsOut"); writetConnects (yyt->Var.ConnectsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->Var.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->Var.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->Var.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->Var.CntOut) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Var.Level) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Var.GlobalPtrs) yyWriteNl ();
 yyIndentSelectorTree ("VarIds", yyt->Var.VarIds);
 yyIndentSelectorTree ("Type", yyt->Var.Type);
 yyIndentSelector ("IsGlobal"); writeBOOLEAN (yyt->Var.IsGlobal) yyWriteNl ();
}

static void yWriteObject
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kObject], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->Object.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetVoid (yyt->Object.Objects2) yyWriteNl ();
 yyIndentSelector ("Objects3"); writetObjects (yyt->Object.Objects3) yyWriteNl ();
 yyIndentSelector ("Objects4In"); writetObjects (yyt->Object.Objects4In) yyWriteNl ();
 yyIndentSelector ("Objects4Out"); writetObjects (yyt->Object.Objects4Out) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->Object.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->Object.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->Object.Env3) yyWriteNl ();
 yyIndentSelector ("Env4"); writetEnv (yyt->Object.Env4) yyWriteNl ();
 yyIndentSelector ("ConfigGroupIn"); writeINDEX (yyt->Object.ConfigGroupIn) yyWriteNl ();
 yyIndentSelector ("ConfigGroupOut"); writeINDEX (yyt->Object.ConfigGroupOut) yyWriteNl ();
 yyIndentSelector ("DefTypes"); writetObjects (yyt->Object.DefTypes) yyWriteNl ();
 yyIndentSelector ("DefObjects"); writetObjects (yyt->Object.DefObjects) yyWriteNl ();
 yyIndentSelector ("ImplTypes"); writetObjects (yyt->Object.ImplTypes) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->Object.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->Object.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->Object.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->Object.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->Object.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->Object.IdsOut) yyWriteNl ();
 yyIndentSelector ("ConnectsIn"); writetConnects (yyt->Object.ConnectsIn) yyWriteNl ();
 yyIndentSelector ("ConnectsOut"); writetConnects (yyt->Object.ConnectsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->Object.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->Object.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->Object.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->Object.CntOut) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Object.Level) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Object.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("Ident"); writetIdent (yyt->Object.Ident) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->Object.Pos) yyWriteNl ();
 yyIndentSelector ("CIdent"); writetIdent (yyt->Object.CIdent) yyWriteNl ();
 yyIndentSelector ("IsRedeclared"); writeBOOLEAN (yyt->Object.IsRedeclared) yyWriteNl ();
}

static void yWriteConnectFrom
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kConnectFrom], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->ConnectFrom.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetVoid (yyt->ConnectFrom.Objects2) yyWriteNl ();
 yyIndentSelector ("Objects3"); writetObjects (yyt->ConnectFrom.Objects3) yyWriteNl ();
 yyIndentSelector ("Objects4In"); writetObjects (yyt->ConnectFrom.Objects4In) yyWriteNl ();
 yyIndentSelector ("Objects4Out"); writetObjects (yyt->ConnectFrom.Objects4Out) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->ConnectFrom.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->ConnectFrom.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->ConnectFrom.Env3) yyWriteNl ();
 yyIndentSelector ("Env4"); writetEnv (yyt->ConnectFrom.Env4) yyWriteNl ();
 yyIndentSelector ("ConfigGroupIn"); writeINDEX (yyt->ConnectFrom.ConfigGroupIn) yyWriteNl ();
 yyIndentSelector ("ConfigGroupOut"); writeINDEX (yyt->ConnectFrom.ConfigGroupOut) yyWriteNl ();
 yyIndentSelector ("DefTypes"); writetObjects (yyt->ConnectFrom.DefTypes) yyWriteNl ();
 yyIndentSelector ("DefObjects"); writetObjects (yyt->ConnectFrom.DefObjects) yyWriteNl ();
 yyIndentSelector ("ImplTypes"); writetObjects (yyt->ConnectFrom.ImplTypes) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->ConnectFrom.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->ConnectFrom.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->ConnectFrom.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->ConnectFrom.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->ConnectFrom.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->ConnectFrom.IdsOut) yyWriteNl ();
 yyIndentSelector ("ConnectsIn"); writetConnects (yyt->ConnectFrom.ConnectsIn) yyWriteNl ();
 yyIndentSelector ("ConnectsOut"); writetConnects (yyt->ConnectFrom.ConnectsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->ConnectFrom.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->ConnectFrom.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->ConnectFrom.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->ConnectFrom.CntOut) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->ConnectFrom.Level) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->ConnectFrom.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("Ident"); writetIdent (yyt->ConnectFrom.Ident) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->ConnectFrom.Pos) yyWriteNl ();
 yyIndentSelector ("CIdent"); writetIdent (yyt->ConnectFrom.CIdent) yyWriteNl ();
 yyIndentSelector ("IsRedeclared"); writeBOOLEAN (yyt->ConnectFrom.IsRedeclared) yyWriteNl ();
 yyIndentSelectorTree ("From", yyt->ConnectFrom.From);
 yyIndentSelectorTree ("To", yyt->ConnectFrom.To);
 yyIndentSelectorTree ("ConnectDecls", yyt->ConnectFrom.ConnectDecls);
 yyIndentSelector ("Object"); writetObject (yyt->ConnectFrom.Object) yyWriteNl ();
}

static void yWriteConnectDecls
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kConnectDecls], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->ConnectDecls.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetVoid (yyt->ConnectDecls.Objects2) yyWriteNl ();
 yyIndentSelector ("Objects3"); writetObjects (yyt->ConnectDecls.Objects3) yyWriteNl ();
 yyIndentSelector ("Objects4In"); writetObjects (yyt->ConnectDecls.Objects4In) yyWriteNl ();
 yyIndentSelector ("Objects4Out"); writetObjects (yyt->ConnectDecls.Objects4Out) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->ConnectDecls.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->ConnectDecls.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->ConnectDecls.Env3) yyWriteNl ();
 yyIndentSelector ("Env4"); writetEnv (yyt->ConnectDecls.Env4) yyWriteNl ();
 yyIndentSelector ("ConfigGroupIn"); writeINDEX (yyt->ConnectDecls.ConfigGroupIn) yyWriteNl ();
 yyIndentSelector ("ConfigGroupOut"); writeINDEX (yyt->ConnectDecls.ConfigGroupOut) yyWriteNl ();
 yyIndentSelector ("DefTypes"); writetObjects (yyt->ConnectDecls.DefTypes) yyWriteNl ();
 yyIndentSelector ("DefObjects"); writetObjects (yyt->ConnectDecls.DefObjects) yyWriteNl ();
 yyIndentSelector ("ImplTypes"); writetObjects (yyt->ConnectDecls.ImplTypes) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->ConnectDecls.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->ConnectDecls.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->ConnectDecls.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->ConnectDecls.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->ConnectDecls.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->ConnectDecls.IdsOut) yyWriteNl ();
 yyIndentSelector ("ConnectsIn"); writetConnects (yyt->ConnectDecls.ConnectsIn) yyWriteNl ();
 yyIndentSelector ("ConnectsOut"); writetConnects (yyt->ConnectDecls.ConnectsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->ConnectDecls.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->ConnectDecls.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->ConnectDecls.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->ConnectDecls.CntOut) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->ConnectDecls.Level) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->ConnectDecls.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("Ident"); writetIdent (yyt->ConnectDecls.Ident) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->ConnectDecls.Pos) yyWriteNl ();
 yyIndentSelector ("CIdent"); writetIdent (yyt->ConnectDecls.CIdent) yyWriteNl ();
 yyIndentSelector ("IsRedeclared"); writeBOOLEAN (yyt->ConnectDecls.IsRedeclared) yyWriteNl ();
 yyIndentSelectorTree ("Index", yyt->ConnectDecls.Index);
 yyIndentSelector ("BiDirectional"); writeBOOLEAN (yyt->ConnectDecls.BiDirectional) yyWriteNl ();
 yyIndentSelectorTree ("Config", yyt->ConnectDecls.Config);
 yyIndentSelectorTree ("Actuals", yyt->ConnectDecls.Actuals);
 yyIndentSelectorTree ("DirIn", yyt->ConnectDecls.DirIn);
 yyIndentSelector ("Object"); writetObject (yyt->ConnectDecls.Object) yyWriteNl ();
 yyIndentSelector ("IndexObjects"); writetObjects (yyt->ConnectDecls.IndexObjects) yyWriteNl ();
 yyIndentSelector ("LeftConfigObj"); writetObject (yyt->ConnectDecls.LeftConfigObj) yyWriteNl ();
 yyIndentSelector ("RightConfigObj"); writetObject (yyt->ConnectDecls.RightConfigObj) yyWriteNl ();
 yyIndentSelector ("IndexVal"); writetValue (yyt->ConnectDecls.IndexVal) yyWriteNl ();
 yyIndentSelector ("FirstDeclaration"); writeBOOLEAN (yyt->ConnectDecls.FirstDeclaration) yyWriteNl ();
 yyIndentSelector ("PrevCIdent"); writetIdent (yyt->ConnectDecls.PrevCIdent) yyWriteNl ();
}

static void yWriteConfig
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kConfig], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->Config.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetVoid (yyt->Config.Objects2) yyWriteNl ();
 yyIndentSelector ("Objects3"); writetObjects (yyt->Config.Objects3) yyWriteNl ();
 yyIndentSelector ("Objects4In"); writetObjects (yyt->Config.Objects4In) yyWriteNl ();
 yyIndentSelector ("Objects4Out"); writetObjects (yyt->Config.Objects4Out) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->Config.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->Config.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->Config.Env3) yyWriteNl ();
 yyIndentSelector ("Env4"); writetEnv (yyt->Config.Env4) yyWriteNl ();
 yyIndentSelector ("ConfigGroupIn"); writeINDEX (yyt->Config.ConfigGroupIn) yyWriteNl ();
 yyIndentSelector ("ConfigGroupOut"); writeINDEX (yyt->Config.ConfigGroupOut) yyWriteNl ();
 yyIndentSelector ("DefTypes"); writetObjects (yyt->Config.DefTypes) yyWriteNl ();
 yyIndentSelector ("DefObjects"); writetObjects (yyt->Config.DefObjects) yyWriteNl ();
 yyIndentSelector ("ImplTypes"); writetObjects (yyt->Config.ImplTypes) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->Config.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->Config.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->Config.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->Config.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->Config.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->Config.IdsOut) yyWriteNl ();
 yyIndentSelector ("ConnectsIn"); writetConnects (yyt->Config.ConnectsIn) yyWriteNl ();
 yyIndentSelector ("ConnectsOut"); writetConnects (yyt->Config.ConnectsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->Config.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->Config.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->Config.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->Config.CntOut) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Config.Level) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Config.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("Ident"); writetIdent (yyt->Config.Ident) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->Config.Pos) yyWriteNl ();
 yyIndentSelector ("CIdent"); writetIdent (yyt->Config.CIdent) yyWriteNl ();
 yyIndentSelector ("IsRedeclared"); writeBOOLEAN (yyt->Config.IsRedeclared) yyWriteNl ();
 yyIndentSelectorTree ("Actuals", yyt->Config.Actuals);
 yyIndentSelector ("Respecified"); writeBOOLEAN (yyt->Config.Respecified) yyWriteNl ();
 yyIndentSelectorTree ("Qualid", yyt->Config.Qualid);
 yyIndentSelector ("Object"); writetObject (yyt->Config.Object) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Config.Type) yyWriteNl ();
 yyIndentSelector ("NewConfigGroup"); writeINDEX (yyt->Config.NewConfigGroup) yyWriteNl ();
 yyIndentSelector ("View"); writetObject (yyt->Config.View) yyWriteNl ();
 yyIndentSelector ("HasVariableSize"); writeBOOLEAN (yyt->Config.HasVariableSize) yyWriteNl ();
}

static void yWriteConst
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kConst], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->Const.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetVoid (yyt->Const.Objects2) yyWriteNl ();
 yyIndentSelector ("Objects3"); writetObjects (yyt->Const.Objects3) yyWriteNl ();
 yyIndentSelector ("Objects4In"); writetObjects (yyt->Const.Objects4In) yyWriteNl ();
 yyIndentSelector ("Objects4Out"); writetObjects (yyt->Const.Objects4Out) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->Const.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->Const.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->Const.Env3) yyWriteNl ();
 yyIndentSelector ("Env4"); writetEnv (yyt->Const.Env4) yyWriteNl ();
 yyIndentSelector ("ConfigGroupIn"); writeINDEX (yyt->Const.ConfigGroupIn) yyWriteNl ();
 yyIndentSelector ("ConfigGroupOut"); writeINDEX (yyt->Const.ConfigGroupOut) yyWriteNl ();
 yyIndentSelector ("DefTypes"); writetObjects (yyt->Const.DefTypes) yyWriteNl ();
 yyIndentSelector ("DefObjects"); writetObjects (yyt->Const.DefObjects) yyWriteNl ();
 yyIndentSelector ("ImplTypes"); writetObjects (yyt->Const.ImplTypes) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->Const.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->Const.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->Const.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->Const.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->Const.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->Const.IdsOut) yyWriteNl ();
 yyIndentSelector ("ConnectsIn"); writetConnects (yyt->Const.ConnectsIn) yyWriteNl ();
 yyIndentSelector ("ConnectsOut"); writetConnects (yyt->Const.ConnectsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->Const.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->Const.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->Const.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->Const.CntOut) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Const.Level) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Const.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("Ident"); writetIdent (yyt->Const.Ident) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->Const.Pos) yyWriteNl ();
 yyIndentSelector ("CIdent"); writetIdent (yyt->Const.CIdent) yyWriteNl ();
 yyIndentSelector ("IsRedeclared"); writeBOOLEAN (yyt->Const.IsRedeclared) yyWriteNl ();
 yyIndentSelectorTree ("Expr", yyt->Const.Expr);
 yyIndentSelector ("Object"); writetObject (yyt->Const.Object) yyWriteNl ();
}

static void yWriteTypeDecl
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kTypeDecl], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->TypeDecl.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetVoid (yyt->TypeDecl.Objects2) yyWriteNl ();
 yyIndentSelector ("Objects3"); writetObjects (yyt->TypeDecl.Objects3) yyWriteNl ();
 yyIndentSelector ("Objects4In"); writetObjects (yyt->TypeDecl.Objects4In) yyWriteNl ();
 yyIndentSelector ("Objects4Out"); writetObjects (yyt->TypeDecl.Objects4Out) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->TypeDecl.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->TypeDecl.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->TypeDecl.Env3) yyWriteNl ();
 yyIndentSelector ("Env4"); writetEnv (yyt->TypeDecl.Env4) yyWriteNl ();
 yyIndentSelector ("ConfigGroupIn"); writeINDEX (yyt->TypeDecl.ConfigGroupIn) yyWriteNl ();
 yyIndentSelector ("ConfigGroupOut"); writeINDEX (yyt->TypeDecl.ConfigGroupOut) yyWriteNl ();
 yyIndentSelector ("DefTypes"); writetObjects (yyt->TypeDecl.DefTypes) yyWriteNl ();
 yyIndentSelector ("DefObjects"); writetObjects (yyt->TypeDecl.DefObjects) yyWriteNl ();
 yyIndentSelector ("ImplTypes"); writetObjects (yyt->TypeDecl.ImplTypes) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->TypeDecl.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->TypeDecl.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->TypeDecl.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->TypeDecl.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->TypeDecl.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->TypeDecl.IdsOut) yyWriteNl ();
 yyIndentSelector ("ConnectsIn"); writetConnects (yyt->TypeDecl.ConnectsIn) yyWriteNl ();
 yyIndentSelector ("ConnectsOut"); writetConnects (yyt->TypeDecl.ConnectsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->TypeDecl.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->TypeDecl.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->TypeDecl.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->TypeDecl.CntOut) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->TypeDecl.Level) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->TypeDecl.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("Ident"); writetIdent (yyt->TypeDecl.Ident) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->TypeDecl.Pos) yyWriteNl ();
 yyIndentSelector ("CIdent"); writetIdent (yyt->TypeDecl.CIdent) yyWriteNl ();
 yyIndentSelector ("IsRedeclared"); writeBOOLEAN (yyt->TypeDecl.IsRedeclared) yyWriteNl ();
 yyIndentSelectorTree ("Type", yyt->TypeDecl.Type);
 yyIndentSelector ("Object"); writetObject (yyt->TypeDecl.Object) yyWriteNl ();
 yyIndentSelector ("Type1"); writetType (yyt->TypeDecl.Type1) yyWriteNl ();
 yyIndentSelector ("Type2"); writetType (yyt->TypeDecl.Type2) yyWriteNl ();
}

static void yWriteProc
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kProc], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->Proc.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetVoid (yyt->Proc.Objects2) yyWriteNl ();
 yyIndentSelector ("Objects3"); writetObjects (yyt->Proc.Objects3) yyWriteNl ();
 yyIndentSelector ("Objects4In"); writetObjects (yyt->Proc.Objects4In) yyWriteNl ();
 yyIndentSelector ("Objects4Out"); writetObjects (yyt->Proc.Objects4Out) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->Proc.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->Proc.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->Proc.Env3) yyWriteNl ();
 yyIndentSelector ("Env4"); writetEnv (yyt->Proc.Env4) yyWriteNl ();
 yyIndentSelector ("ConfigGroupIn"); writeINDEX (yyt->Proc.ConfigGroupIn) yyWriteNl ();
 yyIndentSelector ("ConfigGroupOut"); writeINDEX (yyt->Proc.ConfigGroupOut) yyWriteNl ();
 yyIndentSelector ("DefTypes"); writetObjects (yyt->Proc.DefTypes) yyWriteNl ();
 yyIndentSelector ("DefObjects"); writetObjects (yyt->Proc.DefObjects) yyWriteNl ();
 yyIndentSelector ("ImplTypes"); writetObjects (yyt->Proc.ImplTypes) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->Proc.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->Proc.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->Proc.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->Proc.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->Proc.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->Proc.IdsOut) yyWriteNl ();
 yyIndentSelector ("ConnectsIn"); writetConnects (yyt->Proc.ConnectsIn) yyWriteNl ();
 yyIndentSelector ("ConnectsOut"); writetConnects (yyt->Proc.ConnectsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->Proc.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->Proc.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->Proc.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->Proc.CntOut) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Proc.Level) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Proc.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("Ident"); writetIdent (yyt->Proc.Ident) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->Proc.Pos) yyWriteNl ();
 yyIndentSelector ("CIdent"); writetIdent (yyt->Proc.CIdent) yyWriteNl ();
 yyIndentSelector ("IsRedeclared"); writeBOOLEAN (yyt->Proc.IsRedeclared) yyWriteNl ();
 yyIndentSelectorTree ("Formals", yyt->Proc.Formals);
 yyIndentSelectorTree ("ResultType", yyt->Proc.ResultType);
 yyIndentSelectorTree ("Decls", yyt->Proc.Decls);
 yyIndentSelectorTree ("Stmts", yyt->Proc.Stmts);
 yyIndentSelector ("BeginPos"); writetPosition (yyt->Proc.BeginPos) yyWriteNl ();
 yyIndentSelector ("Object"); writetObject (yyt->Proc.Object) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Proc.Type) yyWriteNl ();
 yyIndentSelector ("HasOpenVector"); writeBOOLEAN (yyt->Proc.HasOpenVector) yyWriteNl ();
 yyIndentSelector ("ValueOpens"); writetCObjects (yyt->Proc.ValueOpens) yyWriteNl ();
 yyIndentSelector ("VAROpens"); writetCObjects (yyt->Proc.VAROpens) yyWriteNl ();
 yyIndentSelector ("LocalPtrs"); writetCObjects (yyt->Proc.LocalPtrs) yyWriteNl ();
 yyIndentSelector ("Strings"); writetStrings (yyt->Proc.Strings) yyWriteNl ();
}

static void yWriteProcHead
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kProcHead], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->ProcHead.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetVoid (yyt->ProcHead.Objects2) yyWriteNl ();
 yyIndentSelector ("Objects3"); writetObjects (yyt->ProcHead.Objects3) yyWriteNl ();
 yyIndentSelector ("Objects4In"); writetObjects (yyt->ProcHead.Objects4In) yyWriteNl ();
 yyIndentSelector ("Objects4Out"); writetObjects (yyt->ProcHead.Objects4Out) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->ProcHead.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->ProcHead.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->ProcHead.Env3) yyWriteNl ();
 yyIndentSelector ("Env4"); writetEnv (yyt->ProcHead.Env4) yyWriteNl ();
 yyIndentSelector ("ConfigGroupIn"); writeINDEX (yyt->ProcHead.ConfigGroupIn) yyWriteNl ();
 yyIndentSelector ("ConfigGroupOut"); writeINDEX (yyt->ProcHead.ConfigGroupOut) yyWriteNl ();
 yyIndentSelector ("DefTypes"); writetObjects (yyt->ProcHead.DefTypes) yyWriteNl ();
 yyIndentSelector ("DefObjects"); writetObjects (yyt->ProcHead.DefObjects) yyWriteNl ();
 yyIndentSelector ("ImplTypes"); writetObjects (yyt->ProcHead.ImplTypes) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->ProcHead.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->ProcHead.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->ProcHead.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->ProcHead.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->ProcHead.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->ProcHead.IdsOut) yyWriteNl ();
 yyIndentSelector ("ConnectsIn"); writetConnects (yyt->ProcHead.ConnectsIn) yyWriteNl ();
 yyIndentSelector ("ConnectsOut"); writetConnects (yyt->ProcHead.ConnectsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->ProcHead.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->ProcHead.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->ProcHead.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->ProcHead.CntOut) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->ProcHead.Level) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->ProcHead.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("Ident"); writetIdent (yyt->ProcHead.Ident) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->ProcHead.Pos) yyWriteNl ();
 yyIndentSelector ("CIdent"); writetIdent (yyt->ProcHead.CIdent) yyWriteNl ();
 yyIndentSelector ("IsRedeclared"); writeBOOLEAN (yyt->ProcHead.IsRedeclared) yyWriteNl ();
 yyIndentSelectorTree ("Formals", yyt->ProcHead.Formals);
 yyIndentSelectorTree ("ResultType", yyt->ProcHead.ResultType);
 yyIndentSelector ("Object"); writetObject (yyt->ProcHead.Object) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->ProcHead.Type) yyWriteNl ();
 yyIndentSelector ("HasOpenVector"); writeBOOLEAN (yyt->ProcHead.HasOpenVector) yyWriteNl ();
}

static void yWriteOpaque
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kOpaque], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->Opaque.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetVoid (yyt->Opaque.Objects2) yyWriteNl ();
 yyIndentSelector ("Objects3"); writetObjects (yyt->Opaque.Objects3) yyWriteNl ();
 yyIndentSelector ("Objects4In"); writetObjects (yyt->Opaque.Objects4In) yyWriteNl ();
 yyIndentSelector ("Objects4Out"); writetObjects (yyt->Opaque.Objects4Out) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->Opaque.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->Opaque.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->Opaque.Env3) yyWriteNl ();
 yyIndentSelector ("Env4"); writetEnv (yyt->Opaque.Env4) yyWriteNl ();
 yyIndentSelector ("ConfigGroupIn"); writeINDEX (yyt->Opaque.ConfigGroupIn) yyWriteNl ();
 yyIndentSelector ("ConfigGroupOut"); writeINDEX (yyt->Opaque.ConfigGroupOut) yyWriteNl ();
 yyIndentSelector ("DefTypes"); writetObjects (yyt->Opaque.DefTypes) yyWriteNl ();
 yyIndentSelector ("DefObjects"); writetObjects (yyt->Opaque.DefObjects) yyWriteNl ();
 yyIndentSelector ("ImplTypes"); writetObjects (yyt->Opaque.ImplTypes) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->Opaque.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->Opaque.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->Opaque.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->Opaque.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->Opaque.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->Opaque.IdsOut) yyWriteNl ();
 yyIndentSelector ("ConnectsIn"); writetConnects (yyt->Opaque.ConnectsIn) yyWriteNl ();
 yyIndentSelector ("ConnectsOut"); writetConnects (yyt->Opaque.ConnectsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->Opaque.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->Opaque.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->Opaque.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->Opaque.CntOut) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Opaque.Level) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Opaque.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("Ident"); writetIdent (yyt->Opaque.Ident) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->Opaque.Pos) yyWriteNl ();
 yyIndentSelector ("CIdent"); writetIdent (yyt->Opaque.CIdent) yyWriteNl ();
 yyIndentSelector ("IsRedeclared"); writeBOOLEAN (yyt->Opaque.IsRedeclared) yyWriteNl ();
 yyIndentSelector ("Object"); writetObject (yyt->Opaque.Object) yyWriteNl ();
 yyIndentSelector ("Type1"); writetType (yyt->Opaque.Type1) yyWriteNl ();
 yyIndentSelector ("FullType"); writetType (yyt->Opaque.FullType) yyWriteNl ();
 yyIndentSelector ("Type2"); writetType (yyt->Opaque.Type2) yyWriteNl ();
}

static void yWriteConnectDests
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kConnectDests], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->ConnectDests.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetVoid (yyt->ConnectDests.Objects2) yyWriteNl ();
 yyIndentSelector ("Objects3"); writetObjects (yyt->ConnectDests.Objects3) yyWriteNl ();
 yyIndentSelector ("Objects4In"); writetObjects (yyt->ConnectDests.Objects4In) yyWriteNl ();
 yyIndentSelector ("Objects4Out"); writetObjects (yyt->ConnectDests.Objects4Out) yyWriteNl ();
 yyIndentSelector ("LeftConfigObj"); writetObject (yyt->ConnectDests.LeftConfigObj) yyWriteNl ();
 yyIndentSelector ("RightConfigObj"); writetObject (yyt->ConnectDests.RightConfigObj) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->ConnectDests.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->ConnectDests.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->ConnectDests.Env3) yyWriteNl ();
 yyIndentSelector ("Env4"); writetEnv (yyt->ConnectDests.Env4) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->ConnectDests.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->ConnectDests.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->ConnectDests.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->ConnectDests.IdsOut) yyWriteNl ();
 yyIndentSelector ("ConnectsIn"); writetConnects (yyt->ConnectDests.ConnectsIn) yyWriteNl ();
 yyIndentSelector ("ConnectsOut"); writetConnects (yyt->ConnectDests.ConnectsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->ConnectDests.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->ConnectDests.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->ConnectDests.Level) yyWriteNl ();
}

static void yWriteNoConnectDest
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoConnectDest], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->NoConnectDest.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetVoid (yyt->NoConnectDest.Objects2) yyWriteNl ();
 yyIndentSelector ("Objects3"); writetObjects (yyt->NoConnectDest.Objects3) yyWriteNl ();
 yyIndentSelector ("Objects4In"); writetObjects (yyt->NoConnectDest.Objects4In) yyWriteNl ();
 yyIndentSelector ("Objects4Out"); writetObjects (yyt->NoConnectDest.Objects4Out) yyWriteNl ();
 yyIndentSelector ("LeftConfigObj"); writetObject (yyt->NoConnectDest.LeftConfigObj) yyWriteNl ();
 yyIndentSelector ("RightConfigObj"); writetObject (yyt->NoConnectDest.RightConfigObj) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->NoConnectDest.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->NoConnectDest.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->NoConnectDest.Env3) yyWriteNl ();
 yyIndentSelector ("Env4"); writetEnv (yyt->NoConnectDest.Env4) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->NoConnectDest.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->NoConnectDest.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->NoConnectDest.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->NoConnectDest.IdsOut) yyWriteNl ();
 yyIndentSelector ("ConnectsIn"); writetConnects (yyt->NoConnectDest.ConnectsIn) yyWriteNl ();
 yyIndentSelector ("ConnectsOut"); writetConnects (yyt->NoConnectDest.ConnectsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->NoConnectDest.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->NoConnectDest.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->NoConnectDest.Level) yyWriteNl ();
}

static void yWriteConnectDest
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kConnectDest], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->ConnectDest.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetVoid (yyt->ConnectDest.Objects2) yyWriteNl ();
 yyIndentSelector ("Objects3"); writetObjects (yyt->ConnectDest.Objects3) yyWriteNl ();
 yyIndentSelector ("Objects4In"); writetObjects (yyt->ConnectDest.Objects4In) yyWriteNl ();
 yyIndentSelector ("Objects4Out"); writetObjects (yyt->ConnectDest.Objects4Out) yyWriteNl ();
 yyIndentSelector ("LeftConfigObj"); writetObject (yyt->ConnectDest.LeftConfigObj) yyWriteNl ();
 yyIndentSelector ("RightConfigObj"); writetObject (yyt->ConnectDest.RightConfigObj) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->ConnectDest.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->ConnectDest.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->ConnectDest.Env3) yyWriteNl ();
 yyIndentSelector ("Env4"); writetEnv (yyt->ConnectDest.Env4) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->ConnectDest.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->ConnectDest.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->ConnectDest.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->ConnectDest.IdsOut) yyWriteNl ();
 yyIndentSelector ("ConnectsIn"); writetConnects (yyt->ConnectDest.ConnectsIn) yyWriteNl ();
 yyIndentSelector ("ConnectsOut"); writetConnects (yyt->ConnectDest.ConnectsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->ConnectDest.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->ConnectDest.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->ConnectDest.Level) yyWriteNl ();
 yyIndentSelectorTree ("Expr", yyt->ConnectDest.Expr);
 yyIndentSelectorTree ("Config", yyt->ConnectDest.Config);
 yyIndentSelectorTree ("Actuals", yyt->ConnectDest.Actuals);
 yyIndentSelector ("DestDimId"); writetIdent (yyt->ConnectDest.DestDimId) yyWriteNl ();
 yyIndentSelector ("DestIdsId"); writetIdent (yyt->ConnectDest.DestIdsId) yyWriteNl ();
}

static void yWriteConnectDestUni
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kConnectDestUni], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->ConnectDestUni.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetVoid (yyt->ConnectDestUni.Objects2) yyWriteNl ();
 yyIndentSelector ("Objects3"); writetObjects (yyt->ConnectDestUni.Objects3) yyWriteNl ();
 yyIndentSelector ("Objects4In"); writetObjects (yyt->ConnectDestUni.Objects4In) yyWriteNl ();
 yyIndentSelector ("Objects4Out"); writetObjects (yyt->ConnectDestUni.Objects4Out) yyWriteNl ();
 yyIndentSelector ("LeftConfigObj"); writetObject (yyt->ConnectDestUni.LeftConfigObj) yyWriteNl ();
 yyIndentSelector ("RightConfigObj"); writetObject (yyt->ConnectDestUni.RightConfigObj) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->ConnectDestUni.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->ConnectDestUni.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->ConnectDestUni.Env3) yyWriteNl ();
 yyIndentSelector ("Env4"); writetEnv (yyt->ConnectDestUni.Env4) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->ConnectDestUni.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->ConnectDestUni.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->ConnectDestUni.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->ConnectDestUni.IdsOut) yyWriteNl ();
 yyIndentSelector ("ConnectsIn"); writetConnects (yyt->ConnectDestUni.ConnectsIn) yyWriteNl ();
 yyIndentSelector ("ConnectsOut"); writetConnects (yyt->ConnectDestUni.ConnectsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->ConnectDestUni.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->ConnectDestUni.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->ConnectDestUni.Level) yyWriteNl ();
 yyIndentSelectorTree ("Expr", yyt->ConnectDestUni.Expr);
 yyIndentSelectorTree ("Config", yyt->ConnectDestUni.Config);
 yyIndentSelectorTree ("Actuals", yyt->ConnectDestUni.Actuals);
 yyIndentSelector ("DestDimId"); writetIdent (yyt->ConnectDestUni.DestDimId) yyWriteNl ();
 yyIndentSelector ("DestIdsId"); writetIdent (yyt->ConnectDestUni.DestIdsId) yyWriteNl ();
}

static void yWriteConnectDestBi
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kConnectDestBi], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects1"); writetObjects (yyt->ConnectDestBi.Objects1) yyWriteNl ();
 yyIndentSelector ("Objects2"); writetVoid (yyt->ConnectDestBi.Objects2) yyWriteNl ();
 yyIndentSelector ("Objects3"); writetObjects (yyt->ConnectDestBi.Objects3) yyWriteNl ();
 yyIndentSelector ("Objects4In"); writetObjects (yyt->ConnectDestBi.Objects4In) yyWriteNl ();
 yyIndentSelector ("Objects4Out"); writetObjects (yyt->ConnectDestBi.Objects4Out) yyWriteNl ();
 yyIndentSelector ("LeftConfigObj"); writetObject (yyt->ConnectDestBi.LeftConfigObj) yyWriteNl ();
 yyIndentSelector ("RightConfigObj"); writetObject (yyt->ConnectDestBi.RightConfigObj) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->ConnectDestBi.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->ConnectDestBi.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->ConnectDestBi.Env3) yyWriteNl ();
 yyIndentSelector ("Env4"); writetEnv (yyt->ConnectDestBi.Env4) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->ConnectDestBi.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->ConnectDestBi.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->ConnectDestBi.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->ConnectDestBi.IdsOut) yyWriteNl ();
 yyIndentSelector ("ConnectsIn"); writetConnects (yyt->ConnectDestBi.ConnectsIn) yyWriteNl ();
 yyIndentSelector ("ConnectsOut"); writetConnects (yyt->ConnectDestBi.ConnectsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->ConnectDestBi.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->ConnectDestBi.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->ConnectDestBi.Level) yyWriteNl ();
 yyIndentSelectorTree ("Expr", yyt->ConnectDestBi.Expr);
 yyIndentSelectorTree ("Config", yyt->ConnectDestBi.Config);
 yyIndentSelectorTree ("Actuals", yyt->ConnectDestBi.Actuals);
 yyIndentSelector ("DestDimId"); writetIdent (yyt->ConnectDestBi.DestDimId) yyWriteNl ();
 yyIndentSelector ("DestIdsId"); writetIdent (yyt->ConnectDestBi.DestIdsId) yyWriteNl ();
 yyIndentSelector ("Ident"); writetIdent (yyt->ConnectDestBi.Ident) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->ConnectDestBi.Pos) yyWriteNl ();
 yyIndentSelectorTree ("Index", yyt->ConnectDestBi.Index);
 yyIndentSelector ("Object"); writetObject (yyt->ConnectDestBi.Object) yyWriteNl ();
 yyIndentSelector ("IndexVal"); writetValue (yyt->ConnectDestBi.IndexVal) yyWriteNl ();
 yyIndentSelector ("CIdent"); writetIdent (yyt->ConnectDestBi.CIdent) yyWriteNl ();
 yyIndentSelector ("FirstDeclaration"); writeBOOLEAN (yyt->ConnectDestBi.FirstDeclaration) yyWriteNl ();
 yyIndentSelector ("PrevCIdent"); writetIdent (yyt->ConnectDestBi.PrevCIdent) yyWriteNl ();
 yyIndentSelector ("BiDirIdsId"); writetIdent (yyt->ConnectDestBi.BiDirIdsId) yyWriteNl ();
 yyIndentSelector ("IsinBiDirConnId"); writetIdent (yyt->ConnectDestBi.IsinBiDirConnId) yyWriteNl ();
}

static void yWriteVarIds
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kVarIds], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->VarIds.Objects3) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->VarIds.Type) yyWriteNl ();
 yyIndentSelector ("TypeTree"); writeADDRESS (yyt->VarIds.TypeTree) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->VarIds.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->VarIds.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->VarIds.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->VarIds.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->VarIds.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->VarIds.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->VarIds.Level) yyWriteNl ();
}

static void yWriteNoVarId
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoVarId], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->NoVarId.Objects3) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->NoVarId.Type) yyWriteNl ();
 yyIndentSelector ("TypeTree"); writeADDRESS (yyt->NoVarId.TypeTree) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->NoVarId.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->NoVarId.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->NoVarId.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->NoVarId.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->NoVarId.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->NoVarId.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->NoVarId.Level) yyWriteNl ();
}

static void yWriteVarId
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kVarId], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->VarId.Objects3) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->VarId.Type) yyWriteNl ();
 yyIndentSelector ("TypeTree"); writeADDRESS (yyt->VarId.TypeTree) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->VarId.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->VarId.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->VarId.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->VarId.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->VarId.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->VarId.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->VarId.Level) yyWriteNl ();
 yyIndentSelector ("Ident"); writetIdent (yyt->VarId.Ident) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->VarId.Pos) yyWriteNl ();
 yyIndentSelector ("Object"); writetObject (yyt->VarId.Object) yyWriteNl ();
 yyIndentSelector ("CIdent"); writetIdent (yyt->VarId.CIdent) yyWriteNl ();
 yyIndentSelector ("IsRedeclared"); writeBOOLEAN (yyt->VarId.IsRedeclared) yyWriteNl ();
}

static void yWriteFormals
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kFormals], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->Formals.Objects3) yyWriteNl ();
 yyIndentSelector ("Types"); writetTypes (yyt->Formals.Types) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->Formals.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->Formals.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->Formals.Env3) yyWriteNl ();
 yyIndentSelector ("HasOpenVector"); writeBOOLEAN (yyt->Formals.HasOpenVector) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->Formals.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->Formals.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->Formals.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->Formals.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->Formals.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->Formals.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->Formals.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->Formals.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Formals.Level) yyWriteNl ();
}

static void yWriteNoFormal
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoFormal], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->NoFormal.Objects3) yyWriteNl ();
 yyIndentSelector ("Types"); writetTypes (yyt->NoFormal.Types) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->NoFormal.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->NoFormal.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->NoFormal.Env3) yyWriteNl ();
 yyIndentSelector ("HasOpenVector"); writeBOOLEAN (yyt->NoFormal.HasOpenVector) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->NoFormal.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->NoFormal.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->NoFormal.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->NoFormal.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->NoFormal.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->NoFormal.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->NoFormal.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->NoFormal.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->NoFormal.Level) yyWriteNl ();
}

static void yWriteFormal
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kFormal], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->Formal.Objects3) yyWriteNl ();
 yyIndentSelector ("Types"); writetTypes (yyt->Formal.Types) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->Formal.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->Formal.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->Formal.Env3) yyWriteNl ();
 yyIndentSelector ("HasOpenVector"); writeBOOLEAN (yyt->Formal.HasOpenVector) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->Formal.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->Formal.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->Formal.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->Formal.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->Formal.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->Formal.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->Formal.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->Formal.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Formal.Level) yyWriteNl ();
 yyIndentSelector ("IsVAR"); writeBOOLEAN (yyt->Formal.IsVAR) yyWriteNl ();
 yyIndentSelectorTree ("ParIds", yyt->Formal.ParIds);
 yyIndentSelectorTree ("Type", yyt->Formal.Type);
}

static void yWriteParIds
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kParIds], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->ParIds.Objects3) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->ParIds.Type) yyWriteNl ();
 yyIndentSelector ("TypeTree"); writeADDRESS (yyt->ParIds.TypeTree) yyWriteNl ();
 yyIndentSelector ("IsVAR"); writeBOOLEAN (yyt->ParIds.IsVAR) yyWriteNl ();
 yyIndentSelector ("TypesIn"); writetType (yyt->ParIds.TypesIn) yyWriteNl ();
 yyIndentSelector ("TypesOut"); writetTypes (yyt->ParIds.TypesOut) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->ParIds.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->ParIds.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->ParIds.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->ParIds.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->ParIds.Level) yyWriteNl ();
}

static void yWriteNoParId
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoParId], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->NoParId.Objects3) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->NoParId.Type) yyWriteNl ();
 yyIndentSelector ("TypeTree"); writeADDRESS (yyt->NoParId.TypeTree) yyWriteNl ();
 yyIndentSelector ("IsVAR"); writeBOOLEAN (yyt->NoParId.IsVAR) yyWriteNl ();
 yyIndentSelector ("TypesIn"); writetType (yyt->NoParId.TypesIn) yyWriteNl ();
 yyIndentSelector ("TypesOut"); writetTypes (yyt->NoParId.TypesOut) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->NoParId.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->NoParId.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->NoParId.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->NoParId.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->NoParId.Level) yyWriteNl ();
}

static void yWriteParId
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kParId], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->ParId.Objects3) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->ParId.Type) yyWriteNl ();
 yyIndentSelector ("TypeTree"); writeADDRESS (yyt->ParId.TypeTree) yyWriteNl ();
 yyIndentSelector ("IsVAR"); writeBOOLEAN (yyt->ParId.IsVAR) yyWriteNl ();
 yyIndentSelector ("TypesIn"); writetType (yyt->ParId.TypesIn) yyWriteNl ();
 yyIndentSelector ("TypesOut"); writetTypes (yyt->ParId.TypesOut) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->ParId.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->ParId.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->ParId.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->ParId.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->ParId.Level) yyWriteNl ();
 yyIndentSelector ("Ident"); writetIdent (yyt->ParId.Ident) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->ParId.Pos) yyWriteNl ();
 yyIndentSelector ("Object"); writetObject (yyt->ParId.Object) yyWriteNl ();
 yyIndentSelector ("CIdent"); writetIdent (yyt->ParId.CIdent) yyWriteNl ();
 yyIndentSelector ("IsRedeclared"); writeBOOLEAN (yyt->ParId.IsRedeclared) yyWriteNl ();
}

static void yWriteType
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kType], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->Type.Objects3) yyWriteNl ();
 yyIndentSelector ("TypeObj"); writetObject (yyt->Type.TypeObj) yyWriteNl ();
 yyIndentSelector ("Type1"); writetType (yyt->Type.Type1) yyWriteNl ();
 yyIndentSelector ("Type2"); writetType (yyt->Type.Type2) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->Type.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->Type.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->Type.Env3) yyWriteNl ();
 yyIndentSelector ("IsInArray"); writeBOOLEAN (yyt->Type.IsInArray) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->Type.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->Type.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->Type.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->Type.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->Type.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->Type.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->Type.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->Type.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->Type.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->Type.CntOut) yyWriteNl ();
 yyIndentSelector ("HasVariableSize"); writeBOOLEAN (yyt->Type.HasVariableSize) yyWriteNl ();
 yyIndentSelector ("ContainsVector"); writeBOOLEAN (yyt->Type.ContainsVector) yyWriteNl ();
}

static void yWriteVector
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kVector], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->Vector.Objects3) yyWriteNl ();
 yyIndentSelector ("TypeObj"); writetObject (yyt->Vector.TypeObj) yyWriteNl ();
 yyIndentSelector ("Type1"); writetType (yyt->Vector.Type1) yyWriteNl ();
 yyIndentSelector ("Type2"); writetType (yyt->Vector.Type2) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->Vector.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->Vector.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->Vector.Env3) yyWriteNl ();
 yyIndentSelector ("IsInArray"); writeBOOLEAN (yyt->Vector.IsInArray) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->Vector.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->Vector.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->Vector.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->Vector.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->Vector.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->Vector.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->Vector.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->Vector.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->Vector.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->Vector.CntOut) yyWriteNl ();
 yyIndentSelector ("HasVariableSize"); writeBOOLEAN (yyt->Vector.HasVariableSize) yyWriteNl ();
 yyIndentSelector ("ContainsVector"); writeBOOLEAN (yyt->Vector.ContainsVector) yyWriteNl ();
 yyIndentSelector ("IsOpen"); writeBOOLEAN (yyt->Vector.IsOpen) yyWriteNl ();
 yyIndentSelectorTree ("Config", yyt->Vector.Config);
}

static void yWriteArray
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kArray], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->Array.Objects3) yyWriteNl ();
 yyIndentSelector ("TypeObj"); writetObject (yyt->Array.TypeObj) yyWriteNl ();
 yyIndentSelector ("Type1"); writetType (yyt->Array.Type1) yyWriteNl ();
 yyIndentSelector ("Type2"); writetType (yyt->Array.Type2) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->Array.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->Array.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->Array.Env3) yyWriteNl ();
 yyIndentSelector ("IsInArray"); writeBOOLEAN (yyt->Array.IsInArray) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->Array.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->Array.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->Array.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->Array.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->Array.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->Array.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->Array.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->Array.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->Array.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->Array.CntOut) yyWriteNl ();
 yyIndentSelector ("HasVariableSize"); writeBOOLEAN (yyt->Array.HasVariableSize) yyWriteNl ();
 yyIndentSelector ("ContainsVector"); writeBOOLEAN (yyt->Array.ContainsVector) yyWriteNl ();
 yyIndentSelector ("IsOpen"); writeBOOLEAN (yyt->Array.IsOpen) yyWriteNl ();
 yyIndentSelectorTree ("Index", yyt->Array.Index);
}

static void yWriteRecord
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kRecord], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->Record.Objects3) yyWriteNl ();
 yyIndentSelector ("TypeObj"); writetObject (yyt->Record.TypeObj) yyWriteNl ();
 yyIndentSelector ("Type1"); writetType (yyt->Record.Type1) yyWriteNl ();
 yyIndentSelector ("Type2"); writetType (yyt->Record.Type2) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->Record.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->Record.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->Record.Env3) yyWriteNl ();
 yyIndentSelector ("IsInArray"); writeBOOLEAN (yyt->Record.IsInArray) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->Record.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->Record.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->Record.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->Record.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->Record.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->Record.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->Record.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->Record.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->Record.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->Record.CntOut) yyWriteNl ();
 yyIndentSelector ("HasVariableSize"); writeBOOLEAN (yyt->Record.HasVariableSize) yyWriteNl ();
 yyIndentSelector ("ContainsVector"); writeBOOLEAN (yyt->Record.ContainsVector) yyWriteNl ();
}

static void yWriteSetType
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kSetType], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->SetType.Objects3) yyWriteNl ();
 yyIndentSelector ("TypeObj"); writetObject (yyt->SetType.TypeObj) yyWriteNl ();
 yyIndentSelector ("Type1"); writetType (yyt->SetType.Type1) yyWriteNl ();
 yyIndentSelector ("Type2"); writetType (yyt->SetType.Type2) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->SetType.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->SetType.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->SetType.Env3) yyWriteNl ();
 yyIndentSelector ("IsInArray"); writeBOOLEAN (yyt->SetType.IsInArray) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->SetType.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->SetType.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->SetType.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->SetType.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->SetType.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->SetType.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->SetType.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->SetType.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->SetType.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->SetType.CntOut) yyWriteNl ();
 yyIndentSelector ("HasVariableSize"); writeBOOLEAN (yyt->SetType.HasVariableSize) yyWriteNl ();
 yyIndentSelector ("ContainsVector"); writeBOOLEAN (yyt->SetType.ContainsVector) yyWriteNl ();
}

static void yWritePointer
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kPointer], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->Pointer.Objects3) yyWriteNl ();
 yyIndentSelector ("TypeObj"); writetObject (yyt->Pointer.TypeObj) yyWriteNl ();
 yyIndentSelector ("Type1"); writetType (yyt->Pointer.Type1) yyWriteNl ();
 yyIndentSelector ("Type2"); writetType (yyt->Pointer.Type2) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->Pointer.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->Pointer.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->Pointer.Env3) yyWriteNl ();
 yyIndentSelector ("IsInArray"); writeBOOLEAN (yyt->Pointer.IsInArray) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->Pointer.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->Pointer.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->Pointer.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->Pointer.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->Pointer.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->Pointer.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->Pointer.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->Pointer.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->Pointer.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->Pointer.CntOut) yyWriteNl ();
 yyIndentSelector ("HasVariableSize"); writeBOOLEAN (yyt->Pointer.HasVariableSize) yyWriteNl ();
 yyIndentSelector ("ContainsVector"); writeBOOLEAN (yyt->Pointer.ContainsVector) yyWriteNl ();
 yyIndentSelector ("TypePos"); writeINDEX (yyt->Pointer.TypePos) yyWriteNl ();
}

static void yWriteProcType
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kProcType], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->ProcType.Objects3) yyWriteNl ();
 yyIndentSelector ("TypeObj"); writetObject (yyt->ProcType.TypeObj) yyWriteNl ();
 yyIndentSelector ("Type1"); writetType (yyt->ProcType.Type1) yyWriteNl ();
 yyIndentSelector ("Type2"); writetType (yyt->ProcType.Type2) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->ProcType.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->ProcType.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->ProcType.Env3) yyWriteNl ();
 yyIndentSelector ("IsInArray"); writeBOOLEAN (yyt->ProcType.IsInArray) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->ProcType.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->ProcType.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->ProcType.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->ProcType.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->ProcType.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->ProcType.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->ProcType.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->ProcType.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->ProcType.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->ProcType.CntOut) yyWriteNl ();
 yyIndentSelector ("HasVariableSize"); writeBOOLEAN (yyt->ProcType.HasVariableSize) yyWriteNl ();
 yyIndentSelector ("ContainsVector"); writeBOOLEAN (yyt->ProcType.ContainsVector) yyWriteNl ();
 yyIndentSelectorTree ("FormalTypes", yyt->ProcType.FormalTypes);
}

static void yWriteSimpleType
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kSimpleType], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->SimpleType.Objects3) yyWriteNl ();
 yyIndentSelector ("TypeObj"); writetObject (yyt->SimpleType.TypeObj) yyWriteNl ();
 yyIndentSelector ("Type1"); writetType (yyt->SimpleType.Type1) yyWriteNl ();
 yyIndentSelector ("Type2"); writetType (yyt->SimpleType.Type2) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->SimpleType.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->SimpleType.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->SimpleType.Env3) yyWriteNl ();
 yyIndentSelector ("IsInArray"); writeBOOLEAN (yyt->SimpleType.IsInArray) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->SimpleType.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->SimpleType.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->SimpleType.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->SimpleType.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->SimpleType.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->SimpleType.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->SimpleType.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->SimpleType.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->SimpleType.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->SimpleType.CntOut) yyWriteNl ();
 yyIndentSelector ("HasVariableSize"); writeBOOLEAN (yyt->SimpleType.HasVariableSize) yyWriteNl ();
 yyIndentSelector ("ContainsVector"); writeBOOLEAN (yyt->SimpleType.ContainsVector) yyWriteNl ();
}

static void yWriteEnumeration
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kEnumeration], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->Enumeration.Objects3) yyWriteNl ();
 yyIndentSelector ("TypeObj"); writetObject (yyt->Enumeration.TypeObj) yyWriteNl ();
 yyIndentSelector ("Type1"); writetType (yyt->Enumeration.Type1) yyWriteNl ();
 yyIndentSelector ("Type2"); writetType (yyt->Enumeration.Type2) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->Enumeration.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->Enumeration.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->Enumeration.Env3) yyWriteNl ();
 yyIndentSelector ("IsInArray"); writeBOOLEAN (yyt->Enumeration.IsInArray) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->Enumeration.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->Enumeration.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->Enumeration.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->Enumeration.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->Enumeration.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->Enumeration.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->Enumeration.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->Enumeration.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->Enumeration.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->Enumeration.CntOut) yyWriteNl ();
 yyIndentSelector ("HasVariableSize"); writeBOOLEAN (yyt->Enumeration.HasVariableSize) yyWriteNl ();
 yyIndentSelector ("ContainsVector"); writeBOOLEAN (yyt->Enumeration.ContainsVector) yyWriteNl ();
 yyIndentSelector ("Type0"); writetType (yyt->Enumeration.Type0) yyWriteNl ();
}

static void yWriteSubrange
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kSubrange], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->Subrange.Objects3) yyWriteNl ();
 yyIndentSelector ("TypeObj"); writetObject (yyt->Subrange.TypeObj) yyWriteNl ();
 yyIndentSelector ("Type1"); writetType (yyt->Subrange.Type1) yyWriteNl ();
 yyIndentSelector ("Type2"); writetType (yyt->Subrange.Type2) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->Subrange.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->Subrange.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->Subrange.Env3) yyWriteNl ();
 yyIndentSelector ("IsInArray"); writeBOOLEAN (yyt->Subrange.IsInArray) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->Subrange.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->Subrange.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->Subrange.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->Subrange.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->Subrange.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->Subrange.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->Subrange.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->Subrange.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->Subrange.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->Subrange.CntOut) yyWriteNl ();
 yyIndentSelector ("HasVariableSize"); writeBOOLEAN (yyt->Subrange.HasVariableSize) yyWriteNl ();
 yyIndentSelector ("ContainsVector"); writeBOOLEAN (yyt->Subrange.ContainsVector) yyWriteNl ();
 yyIndentSelectorTree ("BaseType", yyt->Subrange.BaseType);
 yyIndentSelectorTree ("Lwb", yyt->Subrange.Lwb);
 yyIndentSelector ("Type3"); writetType (yyt->Subrange.Type3) yyWriteNl ();
}

static void yWritePrimaryType
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kPrimaryType], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->PrimaryType.Objects3) yyWriteNl ();
 yyIndentSelector ("TypeObj"); writetObject (yyt->PrimaryType.TypeObj) yyWriteNl ();
 yyIndentSelector ("Type1"); writetType (yyt->PrimaryType.Type1) yyWriteNl ();
 yyIndentSelector ("Type2"); writetType (yyt->PrimaryType.Type2) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->PrimaryType.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->PrimaryType.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->PrimaryType.Env3) yyWriteNl ();
 yyIndentSelector ("IsInArray"); writeBOOLEAN (yyt->PrimaryType.IsInArray) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->PrimaryType.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->PrimaryType.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->PrimaryType.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->PrimaryType.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->PrimaryType.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->PrimaryType.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->PrimaryType.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->PrimaryType.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->PrimaryType.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->PrimaryType.CntOut) yyWriteNl ();
 yyIndentSelector ("HasVariableSize"); writeBOOLEAN (yyt->PrimaryType.HasVariableSize) yyWriteNl ();
 yyIndentSelector ("ContainsVector"); writeBOOLEAN (yyt->PrimaryType.ContainsVector) yyWriteNl ();
}

static void yWriteVoid
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kVoid], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->Void.Objects3) yyWriteNl ();
 yyIndentSelector ("TypeObj"); writetObject (yyt->Void.TypeObj) yyWriteNl ();
 yyIndentSelector ("Type1"); writetType (yyt->Void.Type1) yyWriteNl ();
 yyIndentSelector ("Type2"); writetType (yyt->Void.Type2) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->Void.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->Void.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->Void.Env3) yyWriteNl ();
 yyIndentSelector ("IsInArray"); writeBOOLEAN (yyt->Void.IsInArray) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->Void.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->Void.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->Void.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->Void.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->Void.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->Void.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->Void.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->Void.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->Void.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->Void.CntOut) yyWriteNl ();
 yyIndentSelector ("HasVariableSize"); writeBOOLEAN (yyt->Void.HasVariableSize) yyWriteNl ();
 yyIndentSelector ("ContainsVector"); writeBOOLEAN (yyt->Void.ContainsVector) yyWriteNl ();
}

static void yWriteTypeId
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kTypeId], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->TypeId.Objects3) yyWriteNl ();
 yyIndentSelector ("TypeObj"); writetObject (yyt->TypeId.TypeObj) yyWriteNl ();
 yyIndentSelector ("Type1"); writetType (yyt->TypeId.Type1) yyWriteNl ();
 yyIndentSelector ("Type2"); writetType (yyt->TypeId.Type2) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->TypeId.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->TypeId.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->TypeId.Env3) yyWriteNl ();
 yyIndentSelector ("IsInArray"); writeBOOLEAN (yyt->TypeId.IsInArray) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->TypeId.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->TypeId.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->TypeId.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->TypeId.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->TypeId.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->TypeId.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->TypeId.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->TypeId.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->TypeId.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->TypeId.CntOut) yyWriteNl ();
 yyIndentSelector ("HasVariableSize"); writeBOOLEAN (yyt->TypeId.HasVariableSize) yyWriteNl ();
 yyIndentSelector ("ContainsVector"); writeBOOLEAN (yyt->TypeId.ContainsVector) yyWriteNl ();
 yyIndentSelector ("Ident"); writetIdent (yyt->TypeId.Ident) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->TypeId.Pos) yyWriteNl ();
 yyIndentSelector ("Object"); writetObject (yyt->TypeId.Object) yyWriteNl ();
}

static void yWriteTypeId0
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kTypeId0], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->TypeId0.Objects3) yyWriteNl ();
 yyIndentSelector ("TypeObj"); writetObject (yyt->TypeId0.TypeObj) yyWriteNl ();
 yyIndentSelector ("Type1"); writetType (yyt->TypeId0.Type1) yyWriteNl ();
 yyIndentSelector ("Type2"); writetType (yyt->TypeId0.Type2) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->TypeId0.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->TypeId0.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->TypeId0.Env3) yyWriteNl ();
 yyIndentSelector ("IsInArray"); writeBOOLEAN (yyt->TypeId0.IsInArray) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->TypeId0.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->TypeId0.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->TypeId0.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->TypeId0.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->TypeId0.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->TypeId0.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->TypeId0.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->TypeId0.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->TypeId0.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->TypeId0.CntOut) yyWriteNl ();
 yyIndentSelector ("HasVariableSize"); writeBOOLEAN (yyt->TypeId0.HasVariableSize) yyWriteNl ();
 yyIndentSelector ("ContainsVector"); writeBOOLEAN (yyt->TypeId0.ContainsVector) yyWriteNl ();
 yyIndentSelector ("Ident"); writetIdent (yyt->TypeId0.Ident) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->TypeId0.Pos) yyWriteNl ();
 yyIndentSelector ("Object"); writetObject (yyt->TypeId0.Object) yyWriteNl ();
}

static void yWriteTypeId1
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kTypeId1], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->TypeId1.Objects3) yyWriteNl ();
 yyIndentSelector ("TypeObj"); writetObject (yyt->TypeId1.TypeObj) yyWriteNl ();
 yyIndentSelector ("Type1"); writetType (yyt->TypeId1.Type1) yyWriteNl ();
 yyIndentSelector ("Type2"); writetType (yyt->TypeId1.Type2) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->TypeId1.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->TypeId1.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->TypeId1.Env3) yyWriteNl ();
 yyIndentSelector ("IsInArray"); writeBOOLEAN (yyt->TypeId1.IsInArray) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->TypeId1.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->TypeId1.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->TypeId1.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->TypeId1.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->TypeId1.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->TypeId1.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->TypeId1.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->TypeId1.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->TypeId1.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->TypeId1.CntOut) yyWriteNl ();
 yyIndentSelector ("HasVariableSize"); writeBOOLEAN (yyt->TypeId1.HasVariableSize) yyWriteNl ();
 yyIndentSelector ("ContainsVector"); writeBOOLEAN (yyt->TypeId1.ContainsVector) yyWriteNl ();
 yyIndentSelector ("Ident"); writetIdent (yyt->TypeId1.Ident) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->TypeId1.Pos) yyWriteNl ();
 yyIndentSelector ("Object"); writetObject (yyt->TypeId1.Object) yyWriteNl ();
}

static void yWriteFields
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kFields], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->Fields.Objects3) yyWriteNl ();
 yyIndentSelector ("FieldsIn"); writetObjects (yyt->Fields.FieldsIn) yyWriteNl ();
 yyIndentSelector ("FieldsOut"); writetObjects (yyt->Fields.FieldsOut) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->Fields.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->Fields.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->Fields.Env3) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->Fields.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->Fields.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->Fields.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->Fields.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->Fields.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->Fields.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->Fields.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->Fields.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->Fields.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->Fields.CntOut) yyWriteNl ();
 yyIndentSelector ("nUnion"); writeINDEX (yyt->Fields.nUnion) yyWriteNl ();
 yyIndentSelector ("Select"); writetSelectors (yyt->Fields.Select) yyWriteNl ();
 yyIndentSelector ("ContainsVector"); writeBOOLEAN (yyt->Fields.ContainsVector) yyWriteNl ();
}

static void yWriteNoField
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoField], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->NoField.Objects3) yyWriteNl ();
 yyIndentSelector ("FieldsIn"); writetObjects (yyt->NoField.FieldsIn) yyWriteNl ();
 yyIndentSelector ("FieldsOut"); writetObjects (yyt->NoField.FieldsOut) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->NoField.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->NoField.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->NoField.Env3) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->NoField.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->NoField.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->NoField.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->NoField.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->NoField.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->NoField.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->NoField.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->NoField.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->NoField.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->NoField.CntOut) yyWriteNl ();
 yyIndentSelector ("nUnion"); writeINDEX (yyt->NoField.nUnion) yyWriteNl ();
 yyIndentSelector ("Select"); writetSelectors (yyt->NoField.Select) yyWriteNl ();
 yyIndentSelector ("ContainsVector"); writeBOOLEAN (yyt->NoField.ContainsVector) yyWriteNl ();
}

static void yWriteField
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kField], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->Field.Objects3) yyWriteNl ();
 yyIndentSelector ("FieldsIn"); writetObjects (yyt->Field.FieldsIn) yyWriteNl ();
 yyIndentSelector ("FieldsOut"); writetObjects (yyt->Field.FieldsOut) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->Field.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->Field.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->Field.Env3) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->Field.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->Field.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->Field.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->Field.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->Field.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->Field.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->Field.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->Field.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->Field.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->Field.CntOut) yyWriteNl ();
 yyIndentSelector ("nUnion"); writeINDEX (yyt->Field.nUnion) yyWriteNl ();
 yyIndentSelector ("Select"); writetSelectors (yyt->Field.Select) yyWriteNl ();
 yyIndentSelector ("ContainsVector"); writeBOOLEAN (yyt->Field.ContainsVector) yyWriteNl ();
}

static void yWriteRecordSect
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kRecordSect], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->RecordSect.Objects3) yyWriteNl ();
 yyIndentSelector ("FieldsIn"); writetObjects (yyt->RecordSect.FieldsIn) yyWriteNl ();
 yyIndentSelector ("FieldsOut"); writetObjects (yyt->RecordSect.FieldsOut) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->RecordSect.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->RecordSect.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->RecordSect.Env3) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->RecordSect.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->RecordSect.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->RecordSect.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->RecordSect.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->RecordSect.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->RecordSect.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->RecordSect.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->RecordSect.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->RecordSect.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->RecordSect.CntOut) yyWriteNl ();
 yyIndentSelector ("nUnion"); writeINDEX (yyt->RecordSect.nUnion) yyWriteNl ();
 yyIndentSelector ("Select"); writetSelectors (yyt->RecordSect.Select) yyWriteNl ();
 yyIndentSelector ("ContainsVector"); writeBOOLEAN (yyt->RecordSect.ContainsVector) yyWriteNl ();
 yyIndentSelectorTree ("FieldIds", yyt->RecordSect.FieldIds);
 yyIndentSelectorTree ("Type", yyt->RecordSect.Type);
}

static void yWriteVariantSect
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kVariantSect], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->VariantSect.Objects3) yyWriteNl ();
 yyIndentSelector ("FieldsIn"); writetObjects (yyt->VariantSect.FieldsIn) yyWriteNl ();
 yyIndentSelector ("FieldsOut"); writetObjects (yyt->VariantSect.FieldsOut) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->VariantSect.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->VariantSect.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->VariantSect.Env3) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->VariantSect.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->VariantSect.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->VariantSect.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->VariantSect.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->VariantSect.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->VariantSect.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->VariantSect.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->VariantSect.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->VariantSect.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->VariantSect.CntOut) yyWriteNl ();
 yyIndentSelector ("nUnion"); writeINDEX (yyt->VariantSect.nUnion) yyWriteNl ();
 yyIndentSelector ("Select"); writetSelectors (yyt->VariantSect.Select) yyWriteNl ();
 yyIndentSelector ("ContainsVector"); writeBOOLEAN (yyt->VariantSect.ContainsVector) yyWriteNl ();
 yyIndentSelectorTree ("TagField", yyt->VariantSect.TagField);
 yyIndentSelectorTree ("Variants", yyt->VariantSect.Variants);
 yyIndentSelectorTree ("Else", yyt->VariantSect.Else);
 yyIndentSelector ("UnionId"); writetIdent (yyt->VariantSect.UnionId) yyWriteNl ();
 yyIndentSelector ("ElseId"); writetIdent (yyt->VariantSect.ElseId) yyWriteNl ();
}

static void yWriteFieldIds
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kFieldIds], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Type"); writetType (yyt->FieldIds.Type) yyWriteNl ();
 yyIndentSelector ("FieldsIn"); writetObjects (yyt->FieldIds.FieldsIn) yyWriteNl ();
 yyIndentSelector ("FieldsOut"); writetObjects (yyt->FieldIds.FieldsOut) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->FieldIds.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->FieldIds.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->FieldIds.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->FieldIds.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("Select"); writetSelectors (yyt->FieldIds.Select) yyWriteNl ();
}

static void yWriteNoFieldId
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoFieldId], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Type"); writetType (yyt->NoFieldId.Type) yyWriteNl ();
 yyIndentSelector ("FieldsIn"); writetObjects (yyt->NoFieldId.FieldsIn) yyWriteNl ();
 yyIndentSelector ("FieldsOut"); writetObjects (yyt->NoFieldId.FieldsOut) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->NoFieldId.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->NoFieldId.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->NoFieldId.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->NoFieldId.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("Select"); writetSelectors (yyt->NoFieldId.Select) yyWriteNl ();
}

static void yWriteFieldId
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kFieldId], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Type"); writetType (yyt->FieldId.Type) yyWriteNl ();
 yyIndentSelector ("FieldsIn"); writetObjects (yyt->FieldId.FieldsIn) yyWriteNl ();
 yyIndentSelector ("FieldsOut"); writetObjects (yyt->FieldId.FieldsOut) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->FieldId.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->FieldId.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->FieldId.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->FieldId.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("Select"); writetSelectors (yyt->FieldId.Select) yyWriteNl ();
 yyIndentSelector ("Ident"); writetIdent (yyt->FieldId.Ident) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->FieldId.Pos) yyWriteNl ();
 yyIndentSelector ("Object"); writetObject (yyt->FieldId.Object) yyWriteNl ();
 yyIndentSelector ("CIdent"); writetIdent (yyt->FieldId.CIdent) yyWriteNl ();
 yyIndentSelector ("IsRedeclared"); writeBOOLEAN (yyt->FieldId.IsRedeclared) yyWriteNl ();
}

static void yWriteTagField
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kTagField], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("FieldsIn"); writetObjects (yyt->TagField.FieldsIn) yyWriteNl ();
 yyIndentSelector ("FieldsOut"); writetObjects (yyt->TagField.FieldsOut) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->TagField.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->TagField.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->TagField.Env3) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->TagField.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->TagField.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->TagField.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->TagField.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->TagField.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->TagField.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->TagField.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->TagField.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("Select"); writetSelectors (yyt->TagField.Select) yyWriteNl ();
}

static void yWriteTagField1
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kTagField1], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("FieldsIn"); writetObjects (yyt->TagField1.FieldsIn) yyWriteNl ();
 yyIndentSelector ("FieldsOut"); writetObjects (yyt->TagField1.FieldsOut) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->TagField1.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->TagField1.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->TagField1.Env3) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->TagField1.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->TagField1.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->TagField1.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->TagField1.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->TagField1.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->TagField1.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->TagField1.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->TagField1.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("Select"); writetSelectors (yyt->TagField1.Select) yyWriteNl ();
}

static void yWriteTagField2
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kTagField2], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("FieldsIn"); writetObjects (yyt->TagField2.FieldsIn) yyWriteNl ();
 yyIndentSelector ("FieldsOut"); writetObjects (yyt->TagField2.FieldsOut) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->TagField2.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->TagField2.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->TagField2.Env3) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->TagField2.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->TagField2.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->TagField2.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->TagField2.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->TagField2.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->TagField2.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->TagField2.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->TagField2.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("Select"); writetSelectors (yyt->TagField2.Select) yyWriteNl ();
 yyIndentSelector ("Ident"); writetIdent (yyt->TagField2.Ident) yyWriteNl ();
 yyIndentSelector ("Object"); writetObject (yyt->TagField2.Object) yyWriteNl ();
 yyIndentSelector ("CIdent"); writetIdent (yyt->TagField2.CIdent) yyWriteNl ();
 yyIndentSelector ("IsRedeclared"); writeBOOLEAN (yyt->TagField2.IsRedeclared) yyWriteNl ();
}

static void yWriteVariants
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kVariants], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->Variants.Objects3) yyWriteNl ();
 yyIndentSelector ("FieldsIn"); writetObjects (yyt->Variants.FieldsIn) yyWriteNl ();
 yyIndentSelector ("FieldsOut"); writetObjects (yyt->Variants.FieldsOut) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->Variants.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->Variants.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->Variants.Env3) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->Variants.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->Variants.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->Variants.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->Variants.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->Variants.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->Variants.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->Variants.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->Variants.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->Variants.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->Variants.CntOut) yyWriteNl ();
 yyIndentSelector ("nStruct"); writeINDEX (yyt->Variants.nStruct) yyWriteNl ();
 yyIndentSelector ("Select"); writetSelectors (yyt->Variants.Select) yyWriteNl ();
}

static void yWriteNoVariant
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoVariant], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->NoVariant.Objects3) yyWriteNl ();
 yyIndentSelector ("FieldsIn"); writetObjects (yyt->NoVariant.FieldsIn) yyWriteNl ();
 yyIndentSelector ("FieldsOut"); writetObjects (yyt->NoVariant.FieldsOut) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->NoVariant.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->NoVariant.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->NoVariant.Env3) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->NoVariant.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->NoVariant.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->NoVariant.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->NoVariant.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->NoVariant.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->NoVariant.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->NoVariant.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->NoVariant.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->NoVariant.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->NoVariant.CntOut) yyWriteNl ();
 yyIndentSelector ("nStruct"); writeINDEX (yyt->NoVariant.nStruct) yyWriteNl ();
 yyIndentSelector ("Select"); writetSelectors (yyt->NoVariant.Select) yyWriteNl ();
}

static void yWriteVariant
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kVariant], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Objects3"); writetObjects (yyt->Variant.Objects3) yyWriteNl ();
 yyIndentSelector ("FieldsIn"); writetObjects (yyt->Variant.FieldsIn) yyWriteNl ();
 yyIndentSelector ("FieldsOut"); writetObjects (yyt->Variant.FieldsOut) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->Variant.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->Variant.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->Variant.Env3) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->Variant.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->Variant.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->Variant.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->Variant.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->Variant.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->Variant.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->Variant.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->Variant.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("CntIn"); writeINDEX (yyt->Variant.CntIn) yyWriteNl ();
 yyIndentSelector ("CntOut"); writeINDEX (yyt->Variant.CntOut) yyWriteNl ();
 yyIndentSelector ("nStruct"); writeINDEX (yyt->Variant.nStruct) yyWriteNl ();
 yyIndentSelector ("Select"); writetSelectors (yyt->Variant.Select) yyWriteNl ();
 yyIndentSelectorTree ("Labels", yyt->Variant.Labels);
 yyIndentSelectorTree ("Variant", yyt->Variant.Variant);
 yyIndentSelector ("StructId"); writetIdent (yyt->Variant.StructId) yyWriteNl ();
}

static void yWriteFormalTypes
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kFormalTypes], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Types"); writetTypes (yyt->FormalTypes.Types) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->FormalTypes.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->FormalTypes.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->FormalTypes.Env3) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->FormalTypes.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->FormalTypes.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->FormalTypes.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->FormalTypes.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->FormalTypes.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->FormalTypes.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->FormalTypes.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->FormalTypes.LocalIdsOut) yyWriteNl ();
}

static void yWriteNoFormalType
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoFormalType], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Types"); writetTypes (yyt->NoFormalType.Types) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->NoFormalType.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->NoFormalType.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->NoFormalType.Env3) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->NoFormalType.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->NoFormalType.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->NoFormalType.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->NoFormalType.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->NoFormalType.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->NoFormalType.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->NoFormalType.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->NoFormalType.LocalIdsOut) yyWriteNl ();
}

static void yWriteFormalType
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kFormalType], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Types"); writetTypes (yyt->FormalType.Types) yyWriteNl ();
 yyIndentSelector ("Env1"); writetEnv (yyt->FormalType.Env1) yyWriteNl ();
 yyIndentSelector ("Env2"); writetVoid (yyt->FormalType.Env2) yyWriteNl ();
 yyIndentSelector ("Env3"); writetEnv (yyt->FormalType.Env3) yyWriteNl ();
 yyIndentSelector ("PosIn"); writeINDEX (yyt->FormalType.PosIn) yyWriteNl ();
 yyIndentSelector ("PosOut"); writeINDEX (yyt->FormalType.PosOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->FormalType.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->FormalType.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->FormalType.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->FormalType.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->FormalType.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->FormalType.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("IsVAR"); writeBOOLEAN (yyt->FormalType.IsVAR) yyWriteNl ();
 yyIndentSelectorTree ("Type", yyt->FormalType.Type);
}

static void yWriteEnumIds
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kEnumIds], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Type"); writetType (yyt->EnumIds.Type) yyWriteNl ();
 yyIndentSelector ("Objects"); writetObjects (yyt->EnumIds.Objects) yyWriteNl ();
 yyIndentSelector ("IndexIn"); writeINDEX (yyt->EnumIds.IndexIn) yyWriteNl ();
 yyIndentSelector ("IndexOut"); writeINDEX (yyt->EnumIds.IndexOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->EnumIds.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->EnumIds.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->EnumIds.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->EnumIds.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->EnumIds.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->EnumIds.LocalIdsOut) yyWriteNl ();
}

static void yWriteNoEnumId
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoEnumId], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Type"); writetType (yyt->NoEnumId.Type) yyWriteNl ();
 yyIndentSelector ("Objects"); writetObjects (yyt->NoEnumId.Objects) yyWriteNl ();
 yyIndentSelector ("IndexIn"); writeINDEX (yyt->NoEnumId.IndexIn) yyWriteNl ();
 yyIndentSelector ("IndexOut"); writeINDEX (yyt->NoEnumId.IndexOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->NoEnumId.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->NoEnumId.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->NoEnumId.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->NoEnumId.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->NoEnumId.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->NoEnumId.LocalIdsOut) yyWriteNl ();
}

static void yWriteEnumId
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kEnumId], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Type"); writetType (yyt->EnumId.Type) yyWriteNl ();
 yyIndentSelector ("Objects"); writetObjects (yyt->EnumId.Objects) yyWriteNl ();
 yyIndentSelector ("IndexIn"); writeINDEX (yyt->EnumId.IndexIn) yyWriteNl ();
 yyIndentSelector ("IndexOut"); writeINDEX (yyt->EnumId.IndexOut) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->EnumId.Kind) yyWriteNl ();
 yyIndentSelector ("Module"); writetIdent (yyt->EnumId.Module) yyWriteNl ();
 yyIndentSelector ("IdsIn"); writetIdents (yyt->EnumId.IdsIn) yyWriteNl ();
 yyIndentSelector ("IdsOut"); writetIdents (yyt->EnumId.IdsOut) yyWriteNl ();
 yyIndentSelector ("LocalIdsIn"); writetLocalIds (yyt->EnumId.LocalIdsIn) yyWriteNl ();
 yyIndentSelector ("LocalIdsOut"); writetLocalIds (yyt->EnumId.LocalIdsOut) yyWriteNl ();
 yyIndentSelector ("Ident"); writetIdent (yyt->EnumId.Ident) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->EnumId.Pos) yyWriteNl ();
 yyIndentSelector ("Object"); writetObject (yyt->EnumId.Object) yyWriteNl ();
 yyIndentSelector ("CIdent"); writetIdent (yyt->EnumId.CIdent) yyWriteNl ();
 yyIndentSelector ("IsRedeclared"); writeBOOLEAN (yyt->EnumId.IsRedeclared) yyWriteNl ();
}

static void yWriteExpr
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kExpr], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Expr.Env) yyWriteNl ();
 yyIndentSelector ("IsLval"); writeBOOLEAN (yyt->Expr.IsLval) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Expr.Type) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Expr.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->Expr.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("THelpVar"); writeBOOLEAN (yyt->Expr.THelpVar) yyWriteNl ();
 yyIndentSelector ("TakeHelpVar"); writeBOOLEAN (yyt->Expr.TakeHelpVar) yyWriteNl ();
 yyIndentSelector ("HelpVar"); writetIdent (yyt->Expr.HelpVar) yyWriteNl ();
 yyIndentSelector ("IsFirstDesignator"); writeBOOLEAN (yyt->Expr.IsFirstDesignator) yyWriteNl ();
 yyIndentSelector ("HasProcOrDimSucc"); writeBOOLEAN (yyt->Expr.HasProcOrDimSucc) yyWriteNl ();
 yyIndentSelector ("WriteVectorIndex"); writeBOOLEAN (yyt->Expr.WriteVectorIndex) yyWriteNl ();
 yyIndentSelector ("ProcOrDimSpec"); writetTree (yyt->Expr.ProcOrDimSpec) yyWriteNl ();
 yyIndentSelector ("WriteProcOrDimIndex"); writeBOOLEAN (yyt->Expr.WriteProcOrDimIndex) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->Expr.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->Expr.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->Expr.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Expr.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Expr.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Expr.StrsOut) yyWriteNl ();
}

static void yWriteNoExpr
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoExpr], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->NoExpr.Env) yyWriteNl ();
 yyIndentSelector ("IsLval"); writeBOOLEAN (yyt->NoExpr.IsLval) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->NoExpr.Type) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->NoExpr.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->NoExpr.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("THelpVar"); writeBOOLEAN (yyt->NoExpr.THelpVar) yyWriteNl ();
 yyIndentSelector ("TakeHelpVar"); writeBOOLEAN (yyt->NoExpr.TakeHelpVar) yyWriteNl ();
 yyIndentSelector ("HelpVar"); writetIdent (yyt->NoExpr.HelpVar) yyWriteNl ();
 yyIndentSelector ("IsFirstDesignator"); writeBOOLEAN (yyt->NoExpr.IsFirstDesignator) yyWriteNl ();
 yyIndentSelector ("HasProcOrDimSucc"); writeBOOLEAN (yyt->NoExpr.HasProcOrDimSucc) yyWriteNl ();
 yyIndentSelector ("WriteVectorIndex"); writeBOOLEAN (yyt->NoExpr.WriteVectorIndex) yyWriteNl ();
 yyIndentSelector ("ProcOrDimSpec"); writetTree (yyt->NoExpr.ProcOrDimSpec) yyWriteNl ();
 yyIndentSelector ("WriteProcOrDimIndex"); writeBOOLEAN (yyt->NoExpr.WriteProcOrDimIndex) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->NoExpr.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->NoExpr.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->NoExpr.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->NoExpr.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->NoExpr.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->NoExpr.StrsOut) yyWriteNl ();
}

static void yWriteMultiples
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kMultiples], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Multiples.Env) yyWriteNl ();
 yyIndentSelector ("IsLval"); writeBOOLEAN (yyt->Multiples.IsLval) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Multiples.Type) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Multiples.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->Multiples.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("THelpVar"); writeBOOLEAN (yyt->Multiples.THelpVar) yyWriteNl ();
 yyIndentSelector ("TakeHelpVar"); writeBOOLEAN (yyt->Multiples.TakeHelpVar) yyWriteNl ();
 yyIndentSelector ("HelpVar"); writetIdent (yyt->Multiples.HelpVar) yyWriteNl ();
 yyIndentSelector ("IsFirstDesignator"); writeBOOLEAN (yyt->Multiples.IsFirstDesignator) yyWriteNl ();
 yyIndentSelector ("HasProcOrDimSucc"); writeBOOLEAN (yyt->Multiples.HasProcOrDimSucc) yyWriteNl ();
 yyIndentSelector ("WriteVectorIndex"); writeBOOLEAN (yyt->Multiples.WriteVectorIndex) yyWriteNl ();
 yyIndentSelector ("ProcOrDimSpec"); writetTree (yyt->Multiples.ProcOrDimSpec) yyWriteNl ();
 yyIndentSelector ("WriteProcOrDimIndex"); writeBOOLEAN (yyt->Multiples.WriteProcOrDimIndex) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->Multiples.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->Multiples.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->Multiples.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Multiples.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Multiples.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Multiples.StrsOut) yyWriteNl ();
 yyIndentSelector ("MultiType"); writetType (yyt->Multiples.MultiType) yyWriteNl ();
}

static void yWriteLastMultiple
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kLastMultiple], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->LastMultiple.Env) yyWriteNl ();
 yyIndentSelector ("IsLval"); writeBOOLEAN (yyt->LastMultiple.IsLval) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->LastMultiple.Type) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->LastMultiple.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->LastMultiple.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("THelpVar"); writeBOOLEAN (yyt->LastMultiple.THelpVar) yyWriteNl ();
 yyIndentSelector ("TakeHelpVar"); writeBOOLEAN (yyt->LastMultiple.TakeHelpVar) yyWriteNl ();
 yyIndentSelector ("HelpVar"); writetIdent (yyt->LastMultiple.HelpVar) yyWriteNl ();
 yyIndentSelector ("IsFirstDesignator"); writeBOOLEAN (yyt->LastMultiple.IsFirstDesignator) yyWriteNl ();
 yyIndentSelector ("HasProcOrDimSucc"); writeBOOLEAN (yyt->LastMultiple.HasProcOrDimSucc) yyWriteNl ();
 yyIndentSelector ("WriteVectorIndex"); writeBOOLEAN (yyt->LastMultiple.WriteVectorIndex) yyWriteNl ();
 yyIndentSelector ("ProcOrDimSpec"); writetTree (yyt->LastMultiple.ProcOrDimSpec) yyWriteNl ();
 yyIndentSelector ("WriteProcOrDimIndex"); writeBOOLEAN (yyt->LastMultiple.WriteProcOrDimIndex) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->LastMultiple.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->LastMultiple.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->LastMultiple.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->LastMultiple.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->LastMultiple.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->LastMultiple.StrsOut) yyWriteNl ();
 yyIndentSelector ("MultiType"); writetType (yyt->LastMultiple.MultiType) yyWriteNl ();
}

static void yWriteMultiple
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kMultiple], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Multiple.Env) yyWriteNl ();
 yyIndentSelector ("IsLval"); writeBOOLEAN (yyt->Multiple.IsLval) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Multiple.Type) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Multiple.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->Multiple.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("THelpVar"); writeBOOLEAN (yyt->Multiple.THelpVar) yyWriteNl ();
 yyIndentSelector ("TakeHelpVar"); writeBOOLEAN (yyt->Multiple.TakeHelpVar) yyWriteNl ();
 yyIndentSelector ("HelpVar"); writetIdent (yyt->Multiple.HelpVar) yyWriteNl ();
 yyIndentSelector ("IsFirstDesignator"); writeBOOLEAN (yyt->Multiple.IsFirstDesignator) yyWriteNl ();
 yyIndentSelector ("HasProcOrDimSucc"); writeBOOLEAN (yyt->Multiple.HasProcOrDimSucc) yyWriteNl ();
 yyIndentSelector ("WriteVectorIndex"); writeBOOLEAN (yyt->Multiple.WriteVectorIndex) yyWriteNl ();
 yyIndentSelector ("ProcOrDimSpec"); writetTree (yyt->Multiple.ProcOrDimSpec) yyWriteNl ();
 yyIndentSelector ("WriteProcOrDimIndex"); writeBOOLEAN (yyt->Multiple.WriteProcOrDimIndex) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->Multiple.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->Multiple.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->Multiple.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Multiple.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Multiple.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Multiple.StrsOut) yyWriteNl ();
 yyIndentSelectorTree ("Mop", yyt->Multiple.Mop);
 yyIndentSelector ("MultiType"); writetType (yyt->Multiple.MultiType) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->Multiple.Pos) yyWriteNl ();
 yyIndentSelector ("Operator"); writeINDEX (yyt->Multiple.Operator) yyWriteNl ();
 yyIndentSelector ("COperator"); writeINDEX (yyt->Multiple.COperator) yyWriteNl ();
}

static void yWriteBinary
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kBinary], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Binary.Env) yyWriteNl ();
 yyIndentSelector ("IsLval"); writeBOOLEAN (yyt->Binary.IsLval) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Binary.Type) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Binary.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->Binary.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("THelpVar"); writeBOOLEAN (yyt->Binary.THelpVar) yyWriteNl ();
 yyIndentSelector ("TakeHelpVar"); writeBOOLEAN (yyt->Binary.TakeHelpVar) yyWriteNl ();
 yyIndentSelector ("HelpVar"); writetIdent (yyt->Binary.HelpVar) yyWriteNl ();
 yyIndentSelector ("IsFirstDesignator"); writeBOOLEAN (yyt->Binary.IsFirstDesignator) yyWriteNl ();
 yyIndentSelector ("HasProcOrDimSucc"); writeBOOLEAN (yyt->Binary.HasProcOrDimSucc) yyWriteNl ();
 yyIndentSelector ("WriteVectorIndex"); writeBOOLEAN (yyt->Binary.WriteVectorIndex) yyWriteNl ();
 yyIndentSelector ("ProcOrDimSpec"); writetTree (yyt->Binary.ProcOrDimSpec) yyWriteNl ();
 yyIndentSelector ("WriteProcOrDimIndex"); writeBOOLEAN (yyt->Binary.WriteProcOrDimIndex) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->Binary.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->Binary.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->Binary.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Binary.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Binary.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Binary.StrsOut) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->Binary.Pos) yyWriteNl ();
 yyIndentSelector ("Operator"); writeINDEX (yyt->Binary.Operator) yyWriteNl ();
 yyIndentSelectorTree ("Lop", yyt->Binary.Lop);
 yyIndentSelector ("COperator"); writeINDEX (yyt->Binary.COperator) yyWriteNl ();
}

static void yWriteUnary
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kUnary], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Unary.Env) yyWriteNl ();
 yyIndentSelector ("IsLval"); writeBOOLEAN (yyt->Unary.IsLval) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Unary.Type) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Unary.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->Unary.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("THelpVar"); writeBOOLEAN (yyt->Unary.THelpVar) yyWriteNl ();
 yyIndentSelector ("TakeHelpVar"); writeBOOLEAN (yyt->Unary.TakeHelpVar) yyWriteNl ();
 yyIndentSelector ("HelpVar"); writetIdent (yyt->Unary.HelpVar) yyWriteNl ();
 yyIndentSelector ("IsFirstDesignator"); writeBOOLEAN (yyt->Unary.IsFirstDesignator) yyWriteNl ();
 yyIndentSelector ("HasProcOrDimSucc"); writeBOOLEAN (yyt->Unary.HasProcOrDimSucc) yyWriteNl ();
 yyIndentSelector ("WriteVectorIndex"); writeBOOLEAN (yyt->Unary.WriteVectorIndex) yyWriteNl ();
 yyIndentSelector ("ProcOrDimSpec"); writetTree (yyt->Unary.ProcOrDimSpec) yyWriteNl ();
 yyIndentSelector ("WriteProcOrDimIndex"); writeBOOLEAN (yyt->Unary.WriteProcOrDimIndex) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->Unary.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->Unary.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->Unary.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Unary.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Unary.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Unary.StrsOut) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->Unary.Pos) yyWriteNl ();
 yyIndentSelector ("Operator"); writeINDEX (yyt->Unary.Operator) yyWriteNl ();
 yyIndentSelector ("COperator"); writeINDEX (yyt->Unary.COperator) yyWriteNl ();
}

static void yWriteIntConst
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kIntConst], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->IntConst.Env) yyWriteNl ();
 yyIndentSelector ("IsLval"); writeBOOLEAN (yyt->IntConst.IsLval) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->IntConst.Type) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->IntConst.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->IntConst.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("THelpVar"); writeBOOLEAN (yyt->IntConst.THelpVar) yyWriteNl ();
 yyIndentSelector ("TakeHelpVar"); writeBOOLEAN (yyt->IntConst.TakeHelpVar) yyWriteNl ();
 yyIndentSelector ("HelpVar"); writetIdent (yyt->IntConst.HelpVar) yyWriteNl ();
 yyIndentSelector ("IsFirstDesignator"); writeBOOLEAN (yyt->IntConst.IsFirstDesignator) yyWriteNl ();
 yyIndentSelector ("HasProcOrDimSucc"); writeBOOLEAN (yyt->IntConst.HasProcOrDimSucc) yyWriteNl ();
 yyIndentSelector ("WriteVectorIndex"); writeBOOLEAN (yyt->IntConst.WriteVectorIndex) yyWriteNl ();
 yyIndentSelector ("ProcOrDimSpec"); writetTree (yyt->IntConst.ProcOrDimSpec) yyWriteNl ();
 yyIndentSelector ("WriteProcOrDimIndex"); writeBOOLEAN (yyt->IntConst.WriteProcOrDimIndex) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->IntConst.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->IntConst.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->IntConst.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->IntConst.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->IntConst.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->IntConst.StrsOut) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->IntConst.Pos) yyWriteNl ();
 yyIndentSelector ("Kind"); writeINDEX (yyt->IntConst.Kind) yyWriteNl ();
 yyIndentSelector ("IntVal"); writeULONG (yyt->IntConst.IntVal) yyWriteNl ();
}

static void yWriteRealConst
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kRealConst], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->RealConst.Env) yyWriteNl ();
 yyIndentSelector ("IsLval"); writeBOOLEAN (yyt->RealConst.IsLval) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->RealConst.Type) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->RealConst.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->RealConst.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("THelpVar"); writeBOOLEAN (yyt->RealConst.THelpVar) yyWriteNl ();
 yyIndentSelector ("TakeHelpVar"); writeBOOLEAN (yyt->RealConst.TakeHelpVar) yyWriteNl ();
 yyIndentSelector ("HelpVar"); writetIdent (yyt->RealConst.HelpVar) yyWriteNl ();
 yyIndentSelector ("IsFirstDesignator"); writeBOOLEAN (yyt->RealConst.IsFirstDesignator) yyWriteNl ();
 yyIndentSelector ("HasProcOrDimSucc"); writeBOOLEAN (yyt->RealConst.HasProcOrDimSucc) yyWriteNl ();
 yyIndentSelector ("WriteVectorIndex"); writeBOOLEAN (yyt->RealConst.WriteVectorIndex) yyWriteNl ();
 yyIndentSelector ("ProcOrDimSpec"); writetTree (yyt->RealConst.ProcOrDimSpec) yyWriteNl ();
 yyIndentSelector ("WriteProcOrDimIndex"); writeBOOLEAN (yyt->RealConst.WriteProcOrDimIndex) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->RealConst.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->RealConst.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->RealConst.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->RealConst.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->RealConst.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->RealConst.StrsOut) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->RealConst.Pos) yyWriteNl ();
 yyIndentSelector ("RealVal"); writetStringRef (yyt->RealConst.RealVal) yyWriteNl ();
}

static void yWriteStringConst
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kStringConst], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->StringConst.Env) yyWriteNl ();
 yyIndentSelector ("IsLval"); writeBOOLEAN (yyt->StringConst.IsLval) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->StringConst.Type) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->StringConst.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->StringConst.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("THelpVar"); writeBOOLEAN (yyt->StringConst.THelpVar) yyWriteNl ();
 yyIndentSelector ("TakeHelpVar"); writeBOOLEAN (yyt->StringConst.TakeHelpVar) yyWriteNl ();
 yyIndentSelector ("HelpVar"); writetIdent (yyt->StringConst.HelpVar) yyWriteNl ();
 yyIndentSelector ("IsFirstDesignator"); writeBOOLEAN (yyt->StringConst.IsFirstDesignator) yyWriteNl ();
 yyIndentSelector ("HasProcOrDimSucc"); writeBOOLEAN (yyt->StringConst.HasProcOrDimSucc) yyWriteNl ();
 yyIndentSelector ("WriteVectorIndex"); writeBOOLEAN (yyt->StringConst.WriteVectorIndex) yyWriteNl ();
 yyIndentSelector ("ProcOrDimSpec"); writetTree (yyt->StringConst.ProcOrDimSpec) yyWriteNl ();
 yyIndentSelector ("WriteProcOrDimIndex"); writeBOOLEAN (yyt->StringConst.WriteProcOrDimIndex) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->StringConst.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->StringConst.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->StringConst.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->StringConst.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->StringConst.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->StringConst.StrsOut) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->StringConst.Pos) yyWriteNl ();
 yyIndentSelector ("StringVal"); writetStringRef (yyt->StringConst.StringVal) yyWriteNl ();
}

static void yWriteCharConst
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kCharConst], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->CharConst.Env) yyWriteNl ();
 yyIndentSelector ("IsLval"); writeBOOLEAN (yyt->CharConst.IsLval) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->CharConst.Type) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->CharConst.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->CharConst.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("THelpVar"); writeBOOLEAN (yyt->CharConst.THelpVar) yyWriteNl ();
 yyIndentSelector ("TakeHelpVar"); writeBOOLEAN (yyt->CharConst.TakeHelpVar) yyWriteNl ();
 yyIndentSelector ("HelpVar"); writetIdent (yyt->CharConst.HelpVar) yyWriteNl ();
 yyIndentSelector ("IsFirstDesignator"); writeBOOLEAN (yyt->CharConst.IsFirstDesignator) yyWriteNl ();
 yyIndentSelector ("HasProcOrDimSucc"); writeBOOLEAN (yyt->CharConst.HasProcOrDimSucc) yyWriteNl ();
 yyIndentSelector ("WriteVectorIndex"); writeBOOLEAN (yyt->CharConst.WriteVectorIndex) yyWriteNl ();
 yyIndentSelector ("ProcOrDimSpec"); writetTree (yyt->CharConst.ProcOrDimSpec) yyWriteNl ();
 yyIndentSelector ("WriteProcOrDimIndex"); writeBOOLEAN (yyt->CharConst.WriteProcOrDimIndex) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->CharConst.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->CharConst.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->CharConst.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->CharConst.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->CharConst.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->CharConst.StrsOut) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->CharConst.Pos) yyWriteNl ();
 yyIndentSelector ("CharVal"); writeUCHAR (yyt->CharConst.CharVal) yyWriteNl ();
}

static void yWriteFuncCall
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kFuncCall], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->FuncCall.Env) yyWriteNl ();
 yyIndentSelector ("IsLval"); writeBOOLEAN (yyt->FuncCall.IsLval) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->FuncCall.Type) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->FuncCall.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->FuncCall.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("THelpVar"); writeBOOLEAN (yyt->FuncCall.THelpVar) yyWriteNl ();
 yyIndentSelector ("TakeHelpVar"); writeBOOLEAN (yyt->FuncCall.TakeHelpVar) yyWriteNl ();
 yyIndentSelector ("HelpVar"); writetIdent (yyt->FuncCall.HelpVar) yyWriteNl ();
 yyIndentSelector ("IsFirstDesignator"); writeBOOLEAN (yyt->FuncCall.IsFirstDesignator) yyWriteNl ();
 yyIndentSelector ("HasProcOrDimSucc"); writeBOOLEAN (yyt->FuncCall.HasProcOrDimSucc) yyWriteNl ();
 yyIndentSelector ("WriteVectorIndex"); writeBOOLEAN (yyt->FuncCall.WriteVectorIndex) yyWriteNl ();
 yyIndentSelector ("ProcOrDimSpec"); writetTree (yyt->FuncCall.ProcOrDimSpec) yyWriteNl ();
 yyIndentSelector ("WriteProcOrDimIndex"); writeBOOLEAN (yyt->FuncCall.WriteProcOrDimIndex) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->FuncCall.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->FuncCall.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->FuncCall.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->FuncCall.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->FuncCall.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->FuncCall.StrsOut) yyWriteNl ();
 yyIndentSelectorTree ("Designator", yyt->FuncCall.Designator);
}

static void yWriteMove
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kMove], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Move.Env) yyWriteNl ();
 yyIndentSelector ("IsLval"); writeBOOLEAN (yyt->Move.IsLval) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Move.Type) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Move.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->Move.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("THelpVar"); writeBOOLEAN (yyt->Move.THelpVar) yyWriteNl ();
 yyIndentSelector ("TakeHelpVar"); writeBOOLEAN (yyt->Move.TakeHelpVar) yyWriteNl ();
 yyIndentSelector ("HelpVar"); writetIdent (yyt->Move.HelpVar) yyWriteNl ();
 yyIndentSelector ("IsFirstDesignator"); writeBOOLEAN (yyt->Move.IsFirstDesignator) yyWriteNl ();
 yyIndentSelector ("HasProcOrDimSucc"); writeBOOLEAN (yyt->Move.HasProcOrDimSucc) yyWriteNl ();
 yyIndentSelector ("WriteVectorIndex"); writeBOOLEAN (yyt->Move.WriteVectorIndex) yyWriteNl ();
 yyIndentSelector ("ProcOrDimSpec"); writetTree (yyt->Move.ProcOrDimSpec) yyWriteNl ();
 yyIndentSelector ("WriteProcOrDimIndex"); writeBOOLEAN (yyt->Move.WriteProcOrDimIndex) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->Move.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->Move.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->Move.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Move.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Move.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Move.StrsOut) yyWriteNl ();
 yyIndentSelectorTree ("DirSpec", yyt->Move.DirSpec);
}

static void yWriteReceive
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kReceive], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Receive.Env) yyWriteNl ();
 yyIndentSelector ("IsLval"); writeBOOLEAN (yyt->Receive.IsLval) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Receive.Type) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Receive.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->Receive.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("THelpVar"); writeBOOLEAN (yyt->Receive.THelpVar) yyWriteNl ();
 yyIndentSelector ("TakeHelpVar"); writeBOOLEAN (yyt->Receive.TakeHelpVar) yyWriteNl ();
 yyIndentSelector ("HelpVar"); writetIdent (yyt->Receive.HelpVar) yyWriteNl ();
 yyIndentSelector ("IsFirstDesignator"); writeBOOLEAN (yyt->Receive.IsFirstDesignator) yyWriteNl ();
 yyIndentSelector ("HasProcOrDimSucc"); writeBOOLEAN (yyt->Receive.HasProcOrDimSucc) yyWriteNl ();
 yyIndentSelector ("WriteVectorIndex"); writeBOOLEAN (yyt->Receive.WriteVectorIndex) yyWriteNl ();
 yyIndentSelector ("ProcOrDimSpec"); writetTree (yyt->Receive.ProcOrDimSpec) yyWriteNl ();
 yyIndentSelector ("WriteProcOrDimIndex"); writeBOOLEAN (yyt->Receive.WriteProcOrDimIndex) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->Receive.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->Receive.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->Receive.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Receive.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Receive.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Receive.StrsOut) yyWriteNl ();
 yyIndentSelectorTree ("DirSpec", yyt->Receive.DirSpec);
}

static void yWriteReduce
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kReduce], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Reduce.Env) yyWriteNl ();
 yyIndentSelector ("IsLval"); writeBOOLEAN (yyt->Reduce.IsLval) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Reduce.Type) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Reduce.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->Reduce.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("THelpVar"); writeBOOLEAN (yyt->Reduce.THelpVar) yyWriteNl ();
 yyIndentSelector ("TakeHelpVar"); writeBOOLEAN (yyt->Reduce.TakeHelpVar) yyWriteNl ();
 yyIndentSelector ("HelpVar"); writetIdent (yyt->Reduce.HelpVar) yyWriteNl ();
 yyIndentSelector ("IsFirstDesignator"); writeBOOLEAN (yyt->Reduce.IsFirstDesignator) yyWriteNl ();
 yyIndentSelector ("HasProcOrDimSucc"); writeBOOLEAN (yyt->Reduce.HasProcOrDimSucc) yyWriteNl ();
 yyIndentSelector ("WriteVectorIndex"); writeBOOLEAN (yyt->Reduce.WriteVectorIndex) yyWriteNl ();
 yyIndentSelector ("ProcOrDimSpec"); writetTree (yyt->Reduce.ProcOrDimSpec) yyWriteNl ();
 yyIndentSelector ("WriteProcOrDimIndex"); writeBOOLEAN (yyt->Reduce.WriteProcOrDimIndex) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->Reduce.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->Reduce.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->Reduce.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Reduce.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Reduce.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Reduce.StrsOut) yyWriteNl ();
 yyIndentSelectorTree ("Reduce", yyt->Reduce.Reduce);
}

static void yWriteSet
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kSet], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Set.Env) yyWriteNl ();
 yyIndentSelector ("IsLval"); writeBOOLEAN (yyt->Set.IsLval) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Set.Type) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Set.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->Set.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("THelpVar"); writeBOOLEAN (yyt->Set.THelpVar) yyWriteNl ();
 yyIndentSelector ("TakeHelpVar"); writeBOOLEAN (yyt->Set.TakeHelpVar) yyWriteNl ();
 yyIndentSelector ("HelpVar"); writetIdent (yyt->Set.HelpVar) yyWriteNl ();
 yyIndentSelector ("IsFirstDesignator"); writeBOOLEAN (yyt->Set.IsFirstDesignator) yyWriteNl ();
 yyIndentSelector ("HasProcOrDimSucc"); writeBOOLEAN (yyt->Set.HasProcOrDimSucc) yyWriteNl ();
 yyIndentSelector ("WriteVectorIndex"); writeBOOLEAN (yyt->Set.WriteVectorIndex) yyWriteNl ();
 yyIndentSelector ("ProcOrDimSpec"); writetTree (yyt->Set.ProcOrDimSpec) yyWriteNl ();
 yyIndentSelector ("WriteProcOrDimIndex"); writeBOOLEAN (yyt->Set.WriteProcOrDimIndex) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->Set.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->Set.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->Set.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Set.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Set.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Set.StrsOut) yyWriteNl ();
 yyIndentSelectorTree ("BaseType", yyt->Set.BaseType);
}

static void yWriteBitSet
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kBitSet], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->BitSet.Env) yyWriteNl ();
 yyIndentSelector ("IsLval"); writeBOOLEAN (yyt->BitSet.IsLval) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->BitSet.Type) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->BitSet.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->BitSet.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("THelpVar"); writeBOOLEAN (yyt->BitSet.THelpVar) yyWriteNl ();
 yyIndentSelector ("TakeHelpVar"); writeBOOLEAN (yyt->BitSet.TakeHelpVar) yyWriteNl ();
 yyIndentSelector ("HelpVar"); writetIdent (yyt->BitSet.HelpVar) yyWriteNl ();
 yyIndentSelector ("IsFirstDesignator"); writeBOOLEAN (yyt->BitSet.IsFirstDesignator) yyWriteNl ();
 yyIndentSelector ("HasProcOrDimSucc"); writeBOOLEAN (yyt->BitSet.HasProcOrDimSucc) yyWriteNl ();
 yyIndentSelector ("WriteVectorIndex"); writeBOOLEAN (yyt->BitSet.WriteVectorIndex) yyWriteNl ();
 yyIndentSelector ("ProcOrDimSpec"); writetTree (yyt->BitSet.ProcOrDimSpec) yyWriteNl ();
 yyIndentSelector ("WriteProcOrDimIndex"); writeBOOLEAN (yyt->BitSet.WriteProcOrDimIndex) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->BitSet.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->BitSet.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->BitSet.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->BitSet.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->BitSet.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->BitSet.StrsOut) yyWriteNl ();
}

static void yWriteDesignator
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kDesignator], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Designator.Env) yyWriteNl ();
 yyIndentSelector ("IsLval"); writeBOOLEAN (yyt->Designator.IsLval) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Designator.Type) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Designator.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->Designator.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("THelpVar"); writeBOOLEAN (yyt->Designator.THelpVar) yyWriteNl ();
 yyIndentSelector ("TakeHelpVar"); writeBOOLEAN (yyt->Designator.TakeHelpVar) yyWriteNl ();
 yyIndentSelector ("HelpVar"); writetIdent (yyt->Designator.HelpVar) yyWriteNl ();
 yyIndentSelector ("IsFirstDesignator"); writeBOOLEAN (yyt->Designator.IsFirstDesignator) yyWriteNl ();
 yyIndentSelector ("HasProcOrDimSucc"); writeBOOLEAN (yyt->Designator.HasProcOrDimSucc) yyWriteNl ();
 yyIndentSelector ("WriteVectorIndex"); writeBOOLEAN (yyt->Designator.WriteVectorIndex) yyWriteNl ();
 yyIndentSelector ("ProcOrDimSpec"); writetTree (yyt->Designator.ProcOrDimSpec) yyWriteNl ();
 yyIndentSelector ("WriteProcOrDimIndex"); writeBOOLEAN (yyt->Designator.WriteProcOrDimIndex) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->Designator.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->Designator.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->Designator.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Designator.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Designator.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Designator.StrsOut) yyWriteNl ();
}

static void yWriteQualid
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kQualid], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Qualid.Env) yyWriteNl ();
 yyIndentSelector ("IsLval"); writeBOOLEAN (yyt->Qualid.IsLval) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Qualid.Type) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Qualid.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->Qualid.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("THelpVar"); writeBOOLEAN (yyt->Qualid.THelpVar) yyWriteNl ();
 yyIndentSelector ("TakeHelpVar"); writeBOOLEAN (yyt->Qualid.TakeHelpVar) yyWriteNl ();
 yyIndentSelector ("HelpVar"); writetIdent (yyt->Qualid.HelpVar) yyWriteNl ();
 yyIndentSelector ("IsFirstDesignator"); writeBOOLEAN (yyt->Qualid.IsFirstDesignator) yyWriteNl ();
 yyIndentSelector ("HasProcOrDimSucc"); writeBOOLEAN (yyt->Qualid.HasProcOrDimSucc) yyWriteNl ();
 yyIndentSelector ("WriteVectorIndex"); writeBOOLEAN (yyt->Qualid.WriteVectorIndex) yyWriteNl ();
 yyIndentSelector ("ProcOrDimSpec"); writetTree (yyt->Qualid.ProcOrDimSpec) yyWriteNl ();
 yyIndentSelector ("WriteProcOrDimIndex"); writeBOOLEAN (yyt->Qualid.WriteProcOrDimIndex) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->Qualid.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->Qualid.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->Qualid.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Qualid.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Qualid.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Qualid.StrsOut) yyWriteNl ();
 yyIndentSelector ("Ident"); writetIdent (yyt->Qualid.Ident) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->Qualid.Pos) yyWriteNl ();
 yyIndentSelector ("Object"); writetObject (yyt->Qualid.Object) yyWriteNl ();
 yyIndentSelector ("IsGlobalPtr"); writeBOOLEAN (yyt->Qualid.IsGlobalPtr) yyWriteNl ();
}

static void yWriteQualid0
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kQualid0], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Qualid0.Env) yyWriteNl ();
 yyIndentSelector ("IsLval"); writeBOOLEAN (yyt->Qualid0.IsLval) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Qualid0.Type) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Qualid0.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->Qualid0.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("THelpVar"); writeBOOLEAN (yyt->Qualid0.THelpVar) yyWriteNl ();
 yyIndentSelector ("TakeHelpVar"); writeBOOLEAN (yyt->Qualid0.TakeHelpVar) yyWriteNl ();
 yyIndentSelector ("HelpVar"); writetIdent (yyt->Qualid0.HelpVar) yyWriteNl ();
 yyIndentSelector ("IsFirstDesignator"); writeBOOLEAN (yyt->Qualid0.IsFirstDesignator) yyWriteNl ();
 yyIndentSelector ("HasProcOrDimSucc"); writeBOOLEAN (yyt->Qualid0.HasProcOrDimSucc) yyWriteNl ();
 yyIndentSelector ("WriteVectorIndex"); writeBOOLEAN (yyt->Qualid0.WriteVectorIndex) yyWriteNl ();
 yyIndentSelector ("ProcOrDimSpec"); writetTree (yyt->Qualid0.ProcOrDimSpec) yyWriteNl ();
 yyIndentSelector ("WriteProcOrDimIndex"); writeBOOLEAN (yyt->Qualid0.WriteProcOrDimIndex) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->Qualid0.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->Qualid0.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->Qualid0.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Qualid0.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Qualid0.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Qualid0.StrsOut) yyWriteNl ();
 yyIndentSelector ("Ident"); writetIdent (yyt->Qualid0.Ident) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->Qualid0.Pos) yyWriteNl ();
 yyIndentSelector ("Object"); writetObject (yyt->Qualid0.Object) yyWriteNl ();
 yyIndentSelector ("IsGlobalPtr"); writeBOOLEAN (yyt->Qualid0.IsGlobalPtr) yyWriteNl ();
}

static void yWriteQualid1
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kQualid1], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Qualid1.Env) yyWriteNl ();
 yyIndentSelector ("IsLval"); writeBOOLEAN (yyt->Qualid1.IsLval) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Qualid1.Type) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Qualid1.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->Qualid1.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("THelpVar"); writeBOOLEAN (yyt->Qualid1.THelpVar) yyWriteNl ();
 yyIndentSelector ("TakeHelpVar"); writeBOOLEAN (yyt->Qualid1.TakeHelpVar) yyWriteNl ();
 yyIndentSelector ("HelpVar"); writetIdent (yyt->Qualid1.HelpVar) yyWriteNl ();
 yyIndentSelector ("IsFirstDesignator"); writeBOOLEAN (yyt->Qualid1.IsFirstDesignator) yyWriteNl ();
 yyIndentSelector ("HasProcOrDimSucc"); writeBOOLEAN (yyt->Qualid1.HasProcOrDimSucc) yyWriteNl ();
 yyIndentSelector ("WriteVectorIndex"); writeBOOLEAN (yyt->Qualid1.WriteVectorIndex) yyWriteNl ();
 yyIndentSelector ("ProcOrDimSpec"); writetTree (yyt->Qualid1.ProcOrDimSpec) yyWriteNl ();
 yyIndentSelector ("WriteProcOrDimIndex"); writeBOOLEAN (yyt->Qualid1.WriteProcOrDimIndex) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->Qualid1.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->Qualid1.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->Qualid1.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Qualid1.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Qualid1.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Qualid1.StrsOut) yyWriteNl ();
 yyIndentSelector ("Ident"); writetIdent (yyt->Qualid1.Ident) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->Qualid1.Pos) yyWriteNl ();
 yyIndentSelector ("Object"); writetObject (yyt->Qualid1.Object) yyWriteNl ();
 yyIndentSelector ("IsGlobalPtr"); writeBOOLEAN (yyt->Qualid1.IsGlobalPtr) yyWriteNl ();
}

static void yWriteProcessor
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kProcessor], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Processor.Env) yyWriteNl ();
 yyIndentSelector ("IsLval"); writeBOOLEAN (yyt->Processor.IsLval) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Processor.Type) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Processor.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->Processor.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("THelpVar"); writeBOOLEAN (yyt->Processor.THelpVar) yyWriteNl ();
 yyIndentSelector ("TakeHelpVar"); writeBOOLEAN (yyt->Processor.TakeHelpVar) yyWriteNl ();
 yyIndentSelector ("HelpVar"); writetIdent (yyt->Processor.HelpVar) yyWriteNl ();
 yyIndentSelector ("IsFirstDesignator"); writeBOOLEAN (yyt->Processor.IsFirstDesignator) yyWriteNl ();
 yyIndentSelector ("HasProcOrDimSucc"); writeBOOLEAN (yyt->Processor.HasProcOrDimSucc) yyWriteNl ();
 yyIndentSelector ("WriteVectorIndex"); writeBOOLEAN (yyt->Processor.WriteVectorIndex) yyWriteNl ();
 yyIndentSelector ("ProcOrDimSpec"); writetTree (yyt->Processor.ProcOrDimSpec) yyWriteNl ();
 yyIndentSelector ("WriteProcOrDimIndex"); writeBOOLEAN (yyt->Processor.WriteProcOrDimIndex) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->Processor.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->Processor.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->Processor.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Processor.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Processor.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Processor.StrsOut) yyWriteNl ();
 yyIndentSelectorTree ("Designator", yyt->Processor.Designator);
 yyIndentSelector ("Pos"); writetPosition (yyt->Processor.Pos) yyWriteNl ();
}

static void yWriteDimensions
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kDimensions], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Dimensions.Env) yyWriteNl ();
 yyIndentSelector ("IsLval"); writeBOOLEAN (yyt->Dimensions.IsLval) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Dimensions.Type) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Dimensions.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->Dimensions.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("THelpVar"); writeBOOLEAN (yyt->Dimensions.THelpVar) yyWriteNl ();
 yyIndentSelector ("TakeHelpVar"); writeBOOLEAN (yyt->Dimensions.TakeHelpVar) yyWriteNl ();
 yyIndentSelector ("HelpVar"); writetIdent (yyt->Dimensions.HelpVar) yyWriteNl ();
 yyIndentSelector ("IsFirstDesignator"); writeBOOLEAN (yyt->Dimensions.IsFirstDesignator) yyWriteNl ();
 yyIndentSelector ("HasProcOrDimSucc"); writeBOOLEAN (yyt->Dimensions.HasProcOrDimSucc) yyWriteNl ();
 yyIndentSelector ("WriteVectorIndex"); writeBOOLEAN (yyt->Dimensions.WriteVectorIndex) yyWriteNl ();
 yyIndentSelector ("ProcOrDimSpec"); writetTree (yyt->Dimensions.ProcOrDimSpec) yyWriteNl ();
 yyIndentSelector ("WriteProcOrDimIndex"); writeBOOLEAN (yyt->Dimensions.WriteProcOrDimIndex) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->Dimensions.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->Dimensions.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->Dimensions.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Dimensions.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Dimensions.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Dimensions.StrsOut) yyWriteNl ();
 yyIndentSelectorTree ("Designator", yyt->Dimensions.Designator);
 yyIndentSelector ("Pos"); writetPosition (yyt->Dimensions.Pos) yyWriteNl ();
 yyIndentSelector ("SecondHelpVar"); writetIdent (yyt->Dimensions.SecondHelpVar) yyWriteNl ();
}

static void yWriteSelect
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kSelect], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Select.Env) yyWriteNl ();
 yyIndentSelector ("IsLval"); writeBOOLEAN (yyt->Select.IsLval) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Select.Type) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Select.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->Select.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("THelpVar"); writeBOOLEAN (yyt->Select.THelpVar) yyWriteNl ();
 yyIndentSelector ("TakeHelpVar"); writeBOOLEAN (yyt->Select.TakeHelpVar) yyWriteNl ();
 yyIndentSelector ("HelpVar"); writetIdent (yyt->Select.HelpVar) yyWriteNl ();
 yyIndentSelector ("IsFirstDesignator"); writeBOOLEAN (yyt->Select.IsFirstDesignator) yyWriteNl ();
 yyIndentSelector ("HasProcOrDimSucc"); writeBOOLEAN (yyt->Select.HasProcOrDimSucc) yyWriteNl ();
 yyIndentSelector ("WriteVectorIndex"); writeBOOLEAN (yyt->Select.WriteVectorIndex) yyWriteNl ();
 yyIndentSelector ("ProcOrDimSpec"); writetTree (yyt->Select.ProcOrDimSpec) yyWriteNl ();
 yyIndentSelector ("WriteProcOrDimIndex"); writeBOOLEAN (yyt->Select.WriteProcOrDimIndex) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->Select.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->Select.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->Select.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Select.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Select.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Select.StrsOut) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->Select.Pos) yyWriteNl ();
 yyIndentSelector ("Field"); writetIdent (yyt->Select.Field) yyWriteNl ();
 yyIndentSelector ("Object"); writetObject (yyt->Select.Object) yyWriteNl ();
}

static void yWriteSubscript
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kSubscript], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Subscript.Env) yyWriteNl ();
 yyIndentSelector ("IsLval"); writeBOOLEAN (yyt->Subscript.IsLval) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Subscript.Type) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Subscript.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->Subscript.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("THelpVar"); writeBOOLEAN (yyt->Subscript.THelpVar) yyWriteNl ();
 yyIndentSelector ("TakeHelpVar"); writeBOOLEAN (yyt->Subscript.TakeHelpVar) yyWriteNl ();
 yyIndentSelector ("HelpVar"); writetIdent (yyt->Subscript.HelpVar) yyWriteNl ();
 yyIndentSelector ("IsFirstDesignator"); writeBOOLEAN (yyt->Subscript.IsFirstDesignator) yyWriteNl ();
 yyIndentSelector ("HasProcOrDimSucc"); writeBOOLEAN (yyt->Subscript.HasProcOrDimSucc) yyWriteNl ();
 yyIndentSelector ("WriteVectorIndex"); writeBOOLEAN (yyt->Subscript.WriteVectorIndex) yyWriteNl ();
 yyIndentSelector ("ProcOrDimSpec"); writetTree (yyt->Subscript.ProcOrDimSpec) yyWriteNl ();
 yyIndentSelector ("WriteProcOrDimIndex"); writeBOOLEAN (yyt->Subscript.WriteProcOrDimIndex) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->Subscript.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->Subscript.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->Subscript.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Subscript.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Subscript.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Subscript.StrsOut) yyWriteNl ();
 yyIndentSelectorTree ("Designator", yyt->Subscript.Designator);
 yyIndentSelector ("Pos"); writetPosition (yyt->Subscript.Pos) yyWriteNl ();
}

static void yWriteDeref
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kDeref], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Deref.Env) yyWriteNl ();
 yyIndentSelector ("IsLval"); writeBOOLEAN (yyt->Deref.IsLval) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Deref.Type) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Deref.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->Deref.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("THelpVar"); writeBOOLEAN (yyt->Deref.THelpVar) yyWriteNl ();
 yyIndentSelector ("TakeHelpVar"); writeBOOLEAN (yyt->Deref.TakeHelpVar) yyWriteNl ();
 yyIndentSelector ("HelpVar"); writetIdent (yyt->Deref.HelpVar) yyWriteNl ();
 yyIndentSelector ("IsFirstDesignator"); writeBOOLEAN (yyt->Deref.IsFirstDesignator) yyWriteNl ();
 yyIndentSelector ("HasProcOrDimSucc"); writeBOOLEAN (yyt->Deref.HasProcOrDimSucc) yyWriteNl ();
 yyIndentSelector ("WriteVectorIndex"); writeBOOLEAN (yyt->Deref.WriteVectorIndex) yyWriteNl ();
 yyIndentSelector ("ProcOrDimSpec"); writetTree (yyt->Deref.ProcOrDimSpec) yyWriteNl ();
 yyIndentSelector ("WriteProcOrDimIndex"); writeBOOLEAN (yyt->Deref.WriteProcOrDimIndex) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->Deref.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->Deref.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->Deref.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Deref.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Deref.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Deref.StrsOut) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->Deref.Pos) yyWriteNl ();
}

static void yWriteDirSpec
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kDirSpec], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->DirSpec.Env) yyWriteNl ();
 yyIndentSelector ("ConnectObj"); writetObject (yyt->DirSpec.ConnectObj) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->DirSpec.Level) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->DirSpec.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->DirSpec.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->DirSpec.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->DirSpec.StrsOut) yyWriteNl ();
}

static void yWriteFuncSpec
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kFuncSpec], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->FuncSpec.Env) yyWriteNl ();
 yyIndentSelector ("ConnectObj"); writetObject (yyt->FuncSpec.ConnectObj) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->FuncSpec.Level) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->FuncSpec.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->FuncSpec.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->FuncSpec.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->FuncSpec.StrsOut) yyWriteNl ();
 yyIndentSelectorTree ("DirOut", yyt->FuncSpec.DirOut);
 yyIndentSelectorTree ("DirOutIndex", yyt->FuncSpec.DirOutIndex);
 yyIndentSelectorTree ("Step", yyt->FuncSpec.Step);
}

static void yWriteProcSpec
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kProcSpec], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->ProcSpec.Env) yyWriteNl ();
 yyIndentSelector ("ConnectObj"); writetObject (yyt->ProcSpec.ConnectObj) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->ProcSpec.Level) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->ProcSpec.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->ProcSpec.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->ProcSpec.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->ProcSpec.StrsOut) yyWriteNl ();
 yyIndentSelectorTree ("Expr", yyt->ProcSpec.Expr);
}

static void yWriteDimSpec
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kDimSpec], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->DimSpec.Env) yyWriteNl ();
 yyIndentSelector ("ConnectObj"); writetObject (yyt->DimSpec.ConnectObj) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->DimSpec.Level) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->DimSpec.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->DimSpec.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->DimSpec.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->DimSpec.StrsOut) yyWriteNl ();
 yyIndentSelectorTree ("Actuals", yyt->DimSpec.Actuals);
 yyIndentSelector ("HelpVar"); writetIdent (yyt->DimSpec.HelpVar) yyWriteNl ();
 yyIndentSelector ("SecondHelpVar"); writetIdent (yyt->DimSpec.SecondHelpVar) yyWriteNl ();
}

static void yWriteElems
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kElems], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Elems.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Elems.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->Elems.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->Elems.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->Elems.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->Elems.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Elems.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Elems.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Elems.StrsOut) yyWriteNl ();
}

static void yWriteNoElem
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoElem], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->NoElem.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->NoElem.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->NoElem.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->NoElem.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->NoElem.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->NoElem.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->NoElem.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->NoElem.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->NoElem.StrsOut) yyWriteNl ();
}

static void yWriteElem
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kElem], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Elem.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Elem.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->Elem.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->Elem.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->Elem.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->Elem.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Elem.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Elem.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Elem.StrsOut) yyWriteNl ();
}

static void yWriteElemExpr
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kElemExpr], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->ElemExpr.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->ElemExpr.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->ElemExpr.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->ElemExpr.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->ElemExpr.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->ElemExpr.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->ElemExpr.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->ElemExpr.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->ElemExpr.StrsOut) yyWriteNl ();
 yyIndentSelectorTree ("Elem", yyt->ElemExpr.Elem);
}

static void yWriteElemRange
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kElemRange], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->ElemRange.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->ElemRange.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->ElemRange.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->ElemRange.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->ElemRange.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->ElemRange.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->ElemRange.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->ElemRange.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->ElemRange.StrsOut) yyWriteNl ();
 yyIndentSelectorTree ("Lwb", yyt->ElemRange.Lwb);
 yyIndentSelectorTree ("Upb", yyt->ElemRange.Upb);
}

static void yWriteActuals
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kActuals], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Actuals.Env) yyWriteNl ();
 yyIndentSelector ("ReduceNumber"); writeULONG (yyt->Actuals.ReduceNumber) yyWriteNl ();
 yyIndentSelector ("ActualsNumber"); writeULONG (yyt->Actuals.ActualsNumber) yyWriteNl ();
 yyIndentSelector ("Types"); writetTypes (yyt->Actuals.Types) yyWriteNl ();
 yyIndentSelector ("Formals"); writetTypes (yyt->Actuals.Formals) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Actuals.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->Actuals.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->Actuals.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->Actuals.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->Actuals.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Actuals.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Actuals.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Actuals.StrsOut) yyWriteNl ();
}

static void yWriteNoActual
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoActual], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->NoActual.Env) yyWriteNl ();
 yyIndentSelector ("ReduceNumber"); writeULONG (yyt->NoActual.ReduceNumber) yyWriteNl ();
 yyIndentSelector ("ActualsNumber"); writeULONG (yyt->NoActual.ActualsNumber) yyWriteNl ();
 yyIndentSelector ("Types"); writetTypes (yyt->NoActual.Types) yyWriteNl ();
 yyIndentSelector ("Formals"); writetTypes (yyt->NoActual.Formals) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->NoActual.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->NoActual.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->NoActual.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->NoActual.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->NoActual.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->NoActual.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->NoActual.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->NoActual.StrsOut) yyWriteNl ();
}

static void yWriteActual
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kActual], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Actual.Env) yyWriteNl ();
 yyIndentSelector ("ReduceNumber"); writeULONG (yyt->Actual.ReduceNumber) yyWriteNl ();
 yyIndentSelector ("ActualsNumber"); writeULONG (yyt->Actual.ActualsNumber) yyWriteNl ();
 yyIndentSelector ("Types"); writetTypes (yyt->Actual.Types) yyWriteNl ();
 yyIndentSelector ("Formals"); writetTypes (yyt->Actual.Formals) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Actual.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->Actual.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->Actual.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->Actual.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->Actual.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Actual.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Actual.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Actual.StrsOut) yyWriteNl ();
 yyIndentSelector ("IsVAR"); writeBOOLEAN (yyt->Actual.IsVAR) yyWriteNl ();
 yyIndentSelector ("Formal"); writetType (yyt->Actual.Formal) yyWriteNl ();
}

static void yWriteActualExpr
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kActualExpr], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->ActualExpr.Env) yyWriteNl ();
 yyIndentSelector ("ReduceNumber"); writeULONG (yyt->ActualExpr.ReduceNumber) yyWriteNl ();
 yyIndentSelector ("ActualsNumber"); writeULONG (yyt->ActualExpr.ActualsNumber) yyWriteNl ();
 yyIndentSelector ("Types"); writetTypes (yyt->ActualExpr.Types) yyWriteNl ();
 yyIndentSelector ("Formals"); writetTypes (yyt->ActualExpr.Formals) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->ActualExpr.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->ActualExpr.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->ActualExpr.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->ActualExpr.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->ActualExpr.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->ActualExpr.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->ActualExpr.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->ActualExpr.StrsOut) yyWriteNl ();
 yyIndentSelector ("IsVAR"); writeBOOLEAN (yyt->ActualExpr.IsVAR) yyWriteNl ();
 yyIndentSelector ("Formal"); writetType (yyt->ActualExpr.Formal) yyWriteNl ();
 yyIndentSelectorTree ("Expr", yyt->ActualExpr.Expr);
 yyIndentSelector ("HelpVar"); writetIdent (yyt->ActualExpr.HelpVar) yyWriteNl ();
 yyIndentSelector ("String"); writetIdent (yyt->ActualExpr.String) yyWriteNl ();
}

static void yWriteActualRange
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kActualRange], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->ActualRange.Env) yyWriteNl ();
 yyIndentSelector ("ReduceNumber"); writeULONG (yyt->ActualRange.ReduceNumber) yyWriteNl ();
 yyIndentSelector ("ActualsNumber"); writeULONG (yyt->ActualRange.ActualsNumber) yyWriteNl ();
 yyIndentSelector ("Types"); writetTypes (yyt->ActualRange.Types) yyWriteNl ();
 yyIndentSelector ("Formals"); writetTypes (yyt->ActualRange.Formals) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->ActualRange.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->ActualRange.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->ActualRange.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->ActualRange.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->ActualRange.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->ActualRange.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->ActualRange.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->ActualRange.StrsOut) yyWriteNl ();
 yyIndentSelector ("IsVAR"); writeBOOLEAN (yyt->ActualRange.IsVAR) yyWriteNl ();
 yyIndentSelector ("Formal"); writetType (yyt->ActualRange.Formal) yyWriteNl ();
 yyIndentSelectorTree ("Lwb", yyt->ActualRange.Lwb);
 yyIndentSelectorTree ("Upb", yyt->ActualRange.Upb);
}

static void yWriteActualReduce
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kActualReduce], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->ActualReduce.Env) yyWriteNl ();
 yyIndentSelector ("ReduceNumber"); writeULONG (yyt->ActualReduce.ReduceNumber) yyWriteNl ();
 yyIndentSelector ("ActualsNumber"); writeULONG (yyt->ActualReduce.ActualsNumber) yyWriteNl ();
 yyIndentSelector ("Types"); writetTypes (yyt->ActualReduce.Types) yyWriteNl ();
 yyIndentSelector ("Formals"); writetTypes (yyt->ActualReduce.Formals) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->ActualReduce.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->ActualReduce.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->ActualReduce.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->ActualReduce.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->ActualReduce.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->ActualReduce.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->ActualReduce.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->ActualReduce.StrsOut) yyWriteNl ();
 yyIndentSelector ("IsVAR"); writeBOOLEAN (yyt->ActualReduce.IsVAR) yyWriteNl ();
 yyIndentSelector ("Formal"); writetType (yyt->ActualReduce.Formal) yyWriteNl ();
 yyIndentSelectorTree ("Qualid", yyt->ActualReduce.Qualid);
 yyIndentSelector ("HelpVar"); writetIdent (yyt->ActualReduce.HelpVar) yyWriteNl ();
}

static void yWriteActualStar
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kActualStar], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->ActualStar.Env) yyWriteNl ();
 yyIndentSelector ("ReduceNumber"); writeULONG (yyt->ActualStar.ReduceNumber) yyWriteNl ();
 yyIndentSelector ("ActualsNumber"); writeULONG (yyt->ActualStar.ActualsNumber) yyWriteNl ();
 yyIndentSelector ("Types"); writetTypes (yyt->ActualStar.Types) yyWriteNl ();
 yyIndentSelector ("Formals"); writetTypes (yyt->ActualStar.Formals) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->ActualStar.Level) yyWriteNl ();
 yyIndentSelector ("UseHelpVar"); writeBOOLEAN (yyt->ActualStar.UseHelpVar) yyWriteNl ();
 yyIndentSelector ("IsCConst"); writeBOOLEAN (yyt->ActualStar.IsCConst) yyWriteNl ();
 yyIndentSelector ("IsP3Const"); writeBOOLEAN (yyt->ActualStar.IsP3Const) yyWriteNl ();
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->ActualStar.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->ActualStar.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->ActualStar.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->ActualStar.StrsOut) yyWriteNl ();
 yyIndentSelector ("IsVAR"); writeBOOLEAN (yyt->ActualStar.IsVAR) yyWriteNl ();
 yyIndentSelector ("Formal"); writetType (yyt->ActualStar.Formal) yyWriteNl ();
 yyIndentSelector ("HelpVar"); writetIdent (yyt->ActualStar.HelpVar) yyWriteNl ();
}

static void yWriteStmts
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kStmts], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Stmts.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Stmts.Level) yyWriteNl ();
 yyIndentSelector ("IsVectorExit"); writeBOOLEAN (yyt->Stmts.IsVectorExit) yyWriteNl ();
 yyIndentSelector ("ExitConfigsIn"); writetConfigs (yyt->Stmts.ExitConfigsIn) yyWriteNl ();
 yyIndentSelector ("ExitConfigsOut"); writetConfigs (yyt->Stmts.ExitConfigsOut) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsIn"); writetConfigs (yyt->Stmts.ReturnConfigsIn) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsOut"); writetConfigs (yyt->Stmts.ReturnConfigsOut) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Stmts.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Stmts.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Stmts.StrsOut) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Stmts.Type) yyWriteNl ();
}

static void yWriteNoStmt
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoStmt], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->NoStmt.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->NoStmt.Level) yyWriteNl ();
 yyIndentSelector ("IsVectorExit"); writeBOOLEAN (yyt->NoStmt.IsVectorExit) yyWriteNl ();
 yyIndentSelector ("ExitConfigsIn"); writetConfigs (yyt->NoStmt.ExitConfigsIn) yyWriteNl ();
 yyIndentSelector ("ExitConfigsOut"); writetConfigs (yyt->NoStmt.ExitConfigsOut) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsIn"); writetConfigs (yyt->NoStmt.ReturnConfigsIn) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsOut"); writetConfigs (yyt->NoStmt.ReturnConfigsOut) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->NoStmt.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->NoStmt.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->NoStmt.StrsOut) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->NoStmt.Type) yyWriteNl ();
}

static void yWriteStmt
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kStmt], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Stmt.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Stmt.Level) yyWriteNl ();
 yyIndentSelector ("IsVectorExit"); writeBOOLEAN (yyt->Stmt.IsVectorExit) yyWriteNl ();
 yyIndentSelector ("ExitConfigsIn"); writetConfigs (yyt->Stmt.ExitConfigsIn) yyWriteNl ();
 yyIndentSelector ("ExitConfigsOut"); writetConfigs (yyt->Stmt.ExitConfigsOut) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsIn"); writetConfigs (yyt->Stmt.ReturnConfigsIn) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsOut"); writetConfigs (yyt->Stmt.ReturnConfigsOut) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Stmt.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Stmt.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Stmt.StrsOut) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Stmt.Type) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->Stmt.Pos) yyWriteNl ();
}

static void yWriteAssign
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kAssign], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Assign.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Assign.Level) yyWriteNl ();
 yyIndentSelector ("IsVectorExit"); writeBOOLEAN (yyt->Assign.IsVectorExit) yyWriteNl ();
 yyIndentSelector ("ExitConfigsIn"); writetConfigs (yyt->Assign.ExitConfigsIn) yyWriteNl ();
 yyIndentSelector ("ExitConfigsOut"); writetConfigs (yyt->Assign.ExitConfigsOut) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsIn"); writetConfigs (yyt->Assign.ReturnConfigsIn) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsOut"); writetConfigs (yyt->Assign.ReturnConfigsOut) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Assign.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Assign.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Assign.StrsOut) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Assign.Type) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->Assign.Pos) yyWriteNl ();
 yyIndentSelectorTree ("Designator", yyt->Assign.Designator);
 yyIndentSelectorTree ("Expr", yyt->Assign.Expr);
}

static void yWriteCall
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kCall], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Call.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Call.Level) yyWriteNl ();
 yyIndentSelector ("IsVectorExit"); writeBOOLEAN (yyt->Call.IsVectorExit) yyWriteNl ();
 yyIndentSelector ("ExitConfigsIn"); writetConfigs (yyt->Call.ExitConfigsIn) yyWriteNl ();
 yyIndentSelector ("ExitConfigsOut"); writetConfigs (yyt->Call.ExitConfigsOut) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsIn"); writetConfigs (yyt->Call.ReturnConfigsIn) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsOut"); writetConfigs (yyt->Call.ReturnConfigsOut) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Call.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Call.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Call.StrsOut) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Call.Type) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->Call.Pos) yyWriteNl ();
 yyIndentSelectorTree ("Designator", yyt->Call.Designator);
 yyIndentSelectorTree ("Actuals", yyt->Call.Actuals);
 yyIndentSelector ("CheckProcs"); writetType (yyt->Call.CheckProcs) yyWriteNl ();
 yyIndentSelector ("AllocOrDealloc"); writetObject (yyt->Call.AllocOrDealloc) yyWriteNl ();
}

static void yWriteIf
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kIf], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->If.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->If.Level) yyWriteNl ();
 yyIndentSelector ("IsVectorExit"); writeBOOLEAN (yyt->If.IsVectorExit) yyWriteNl ();
 yyIndentSelector ("ExitConfigsIn"); writetConfigs (yyt->If.ExitConfigsIn) yyWriteNl ();
 yyIndentSelector ("ExitConfigsOut"); writetConfigs (yyt->If.ExitConfigsOut) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsIn"); writetConfigs (yyt->If.ReturnConfigsIn) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsOut"); writetConfigs (yyt->If.ReturnConfigsOut) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->If.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->If.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->If.StrsOut) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->If.Type) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->If.Pos) yyWriteNl ();
 yyIndentSelectorTree ("Cond", yyt->If.Cond);
 yyIndentSelectorTree ("Then", yyt->If.Then);
 yyIndentSelectorTree ("Elsifs", yyt->If.Elsifs);
 yyIndentSelectorTree ("Else", yyt->If.Else);
}

static void yWriteCase
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kCase], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Case.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Case.Level) yyWriteNl ();
 yyIndentSelector ("IsVectorExit"); writeBOOLEAN (yyt->Case.IsVectorExit) yyWriteNl ();
 yyIndentSelector ("ExitConfigsIn"); writetConfigs (yyt->Case.ExitConfigsIn) yyWriteNl ();
 yyIndentSelector ("ExitConfigsOut"); writetConfigs (yyt->Case.ExitConfigsOut) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsIn"); writetConfigs (yyt->Case.ReturnConfigsIn) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsOut"); writetConfigs (yyt->Case.ReturnConfigsOut) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Case.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Case.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Case.StrsOut) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Case.Type) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->Case.Pos) yyWriteNl ();
 yyIndentSelector ("Default"); writeBOOLEAN (yyt->Case.Default) yyWriteNl ();
 yyIndentSelectorTree ("Expr", yyt->Case.Expr);
 yyIndentSelectorTree ("Cases", yyt->Case.Cases);
 yyIndentSelectorTree ("Else", yyt->Case.Else);
}

static void yWriteWhile
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kWhile], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->While.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->While.Level) yyWriteNl ();
 yyIndentSelector ("IsVectorExit"); writeBOOLEAN (yyt->While.IsVectorExit) yyWriteNl ();
 yyIndentSelector ("ExitConfigsIn"); writetConfigs (yyt->While.ExitConfigsIn) yyWriteNl ();
 yyIndentSelector ("ExitConfigsOut"); writetConfigs (yyt->While.ExitConfigsOut) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsIn"); writetConfigs (yyt->While.ReturnConfigsIn) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsOut"); writetConfigs (yyt->While.ReturnConfigsOut) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->While.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->While.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->While.StrsOut) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->While.Type) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->While.Pos) yyWriteNl ();
 yyIndentSelectorTree ("Cond", yyt->While.Cond);
 yyIndentSelectorTree ("Stmts", yyt->While.Stmts);
}

static void yWriteRepeat
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kRepeat], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Repeat.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Repeat.Level) yyWriteNl ();
 yyIndentSelector ("IsVectorExit"); writeBOOLEAN (yyt->Repeat.IsVectorExit) yyWriteNl ();
 yyIndentSelector ("ExitConfigsIn"); writetConfigs (yyt->Repeat.ExitConfigsIn) yyWriteNl ();
 yyIndentSelector ("ExitConfigsOut"); writetConfigs (yyt->Repeat.ExitConfigsOut) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsIn"); writetConfigs (yyt->Repeat.ReturnConfigsIn) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsOut"); writetConfigs (yyt->Repeat.ReturnConfigsOut) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Repeat.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Repeat.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Repeat.StrsOut) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Repeat.Type) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->Repeat.Pos) yyWriteNl ();
 yyIndentSelectorTree ("Stmts", yyt->Repeat.Stmts);
 yyIndentSelectorTree ("Cond", yyt->Repeat.Cond);
}

static void yWriteLoop
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kLoop], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Loop.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Loop.Level) yyWriteNl ();
 yyIndentSelector ("IsVectorExit"); writeBOOLEAN (yyt->Loop.IsVectorExit) yyWriteNl ();
 yyIndentSelector ("ExitConfigsIn"); writetConfigs (yyt->Loop.ExitConfigsIn) yyWriteNl ();
 yyIndentSelector ("ExitConfigsOut"); writetConfigs (yyt->Loop.ExitConfigsOut) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsIn"); writetConfigs (yyt->Loop.ReturnConfigsIn) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsOut"); writetConfigs (yyt->Loop.ReturnConfigsOut) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Loop.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Loop.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Loop.StrsOut) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Loop.Type) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->Loop.Pos) yyWriteNl ();
 yyIndentSelectorTree ("Stmts", yyt->Loop.Stmts);
 yyIndentSelector ("ExitConfigs"); writetConfigs (yyt->Loop.ExitConfigs) yyWriteNl ();
}

static void yWriteLooppar
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kLooppar], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Looppar.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Looppar.Level) yyWriteNl ();
 yyIndentSelector ("IsVectorExit"); writeBOOLEAN (yyt->Looppar.IsVectorExit) yyWriteNl ();
 yyIndentSelector ("ExitConfigsIn"); writetConfigs (yyt->Looppar.ExitConfigsIn) yyWriteNl ();
 yyIndentSelector ("ExitConfigsOut"); writetConfigs (yyt->Looppar.ExitConfigsOut) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsIn"); writetConfigs (yyt->Looppar.ReturnConfigsIn) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsOut"); writetConfigs (yyt->Looppar.ReturnConfigsOut) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Looppar.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Looppar.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Looppar.StrsOut) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Looppar.Type) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->Looppar.Pos) yyWriteNl ();
 yyIndentSelectorTree ("Qualid", yyt->Looppar.Qualid);
 yyIndentSelectorTree ("Stmts", yyt->Looppar.Stmts);
 yyIndentSelector ("ExitConfigs"); writetConfigs (yyt->Looppar.ExitConfigs) yyWriteNl ();
}

static void yWriteFor
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kFor], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->For.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->For.Level) yyWriteNl ();
 yyIndentSelector ("IsVectorExit"); writeBOOLEAN (yyt->For.IsVectorExit) yyWriteNl ();
 yyIndentSelector ("ExitConfigsIn"); writetConfigs (yyt->For.ExitConfigsIn) yyWriteNl ();
 yyIndentSelector ("ExitConfigsOut"); writetConfigs (yyt->For.ExitConfigsOut) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsIn"); writetConfigs (yyt->For.ReturnConfigsIn) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsOut"); writetConfigs (yyt->For.ReturnConfigsOut) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->For.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->For.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->For.StrsOut) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->For.Type) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->For.Pos) yyWriteNl ();
 yyIndentSelectorTree ("Qualid", yyt->For.Qualid);
 yyIndentSelectorTree ("From", yyt->For.From);
 yyIndentSelectorTree ("To", yyt->For.To);
 yyIndentSelectorTree ("By", yyt->For.By);
 yyIndentSelectorTree ("Stmts", yyt->For.Stmts);
 yyIndentSelector ("ToVal"); writetValue (yyt->For.ToVal) yyWriteNl ();
 yyIndentSelector ("ByVal"); writetValue (yyt->For.ByVal) yyWriteNl ();
}

static void yWriteWith
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kWith], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->With.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->With.Level) yyWriteNl ();
 yyIndentSelector ("IsVectorExit"); writeBOOLEAN (yyt->With.IsVectorExit) yyWriteNl ();
 yyIndentSelector ("ExitConfigsIn"); writetConfigs (yyt->With.ExitConfigsIn) yyWriteNl ();
 yyIndentSelector ("ExitConfigsOut"); writetConfigs (yyt->With.ExitConfigsOut) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsIn"); writetConfigs (yyt->With.ReturnConfigsIn) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsOut"); writetConfigs (yyt->With.ReturnConfigsOut) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->With.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->With.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->With.StrsOut) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->With.Type) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->With.Pos) yyWriteNl ();
 yyIndentSelectorTree ("Designator", yyt->With.Designator);
 yyIndentSelectorTree ("Stmts", yyt->With.Stmts);
}

static void yWriteAll
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kAll], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->All.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->All.Level) yyWriteNl ();
 yyIndentSelector ("IsVectorExit"); writeBOOLEAN (yyt->All.IsVectorExit) yyWriteNl ();
 yyIndentSelector ("ExitConfigsIn"); writetConfigs (yyt->All.ExitConfigsIn) yyWriteNl ();
 yyIndentSelector ("ExitConfigsOut"); writetConfigs (yyt->All.ExitConfigsOut) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsIn"); writetConfigs (yyt->All.ReturnConfigsIn) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsOut"); writetConfigs (yyt->All.ReturnConfigsOut) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->All.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->All.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->All.StrsOut) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->All.Type) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->All.Pos) yyWriteNl ();
 yyIndentSelectorTree ("Qualid", yyt->All.Qualid);
 yyIndentSelectorTree ("Stmts", yyt->All.Stmts);
}

static void yWriteSend
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kSend], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Send.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Send.Level) yyWriteNl ();
 yyIndentSelector ("IsVectorExit"); writeBOOLEAN (yyt->Send.IsVectorExit) yyWriteNl ();
 yyIndentSelector ("ExitConfigsIn"); writetConfigs (yyt->Send.ExitConfigsIn) yyWriteNl ();
 yyIndentSelector ("ExitConfigsOut"); writetConfigs (yyt->Send.ExitConfigsOut) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsIn"); writetConfigs (yyt->Send.ReturnConfigsIn) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsOut"); writetConfigs (yyt->Send.ReturnConfigsOut) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Send.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Send.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Send.StrsOut) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Send.Type) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->Send.Pos) yyWriteNl ();
 yyIndentSelectorTree ("DirSpec", yyt->Send.DirSpec);
 yyIndentSelectorTree ("From", yyt->Send.From);
 yyIndentSelectorTree ("To", yyt->Send.To);
}

static void yWriteLoad
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kLoad], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Load.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Load.Level) yyWriteNl ();
 yyIndentSelector ("IsVectorExit"); writeBOOLEAN (yyt->Load.IsVectorExit) yyWriteNl ();
 yyIndentSelector ("ExitConfigsIn"); writetConfigs (yyt->Load.ExitConfigsIn) yyWriteNl ();
 yyIndentSelector ("ExitConfigsOut"); writetConfigs (yyt->Load.ExitConfigsOut) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsIn"); writetConfigs (yyt->Load.ReturnConfigsIn) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsOut"); writetConfigs (yyt->Load.ReturnConfigsOut) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Load.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Load.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Load.StrsOut) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Load.Type) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->Load.Pos) yyWriteNl ();
 yyIndentSelector ("SizeDef"); writeBOOLEAN (yyt->Load.SizeDef) yyWriteNl ();
 yyIndentSelectorTree ("What", yyt->Load.What);
 yyIndentSelectorTree ("From", yyt->Load.From);
 yyIndentSelectorTree ("Size", yyt->Load.Size);
}

static void yWriteStore
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kStore], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Store.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Store.Level) yyWriteNl ();
 yyIndentSelector ("IsVectorExit"); writeBOOLEAN (yyt->Store.IsVectorExit) yyWriteNl ();
 yyIndentSelector ("ExitConfigsIn"); writetConfigs (yyt->Store.ExitConfigsIn) yyWriteNl ();
 yyIndentSelector ("ExitConfigsOut"); writetConfigs (yyt->Store.ExitConfigsOut) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsIn"); writetConfigs (yyt->Store.ReturnConfigsIn) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsOut"); writetConfigs (yyt->Store.ReturnConfigsOut) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Store.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Store.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Store.StrsOut) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Store.Type) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->Store.Pos) yyWriteNl ();
 yyIndentSelector ("SizeDef"); writeBOOLEAN (yyt->Store.SizeDef) yyWriteNl ();
 yyIndentSelectorTree ("What", yyt->Store.What);
 yyIndentSelectorTree ("To", yyt->Store.To);
 yyIndentSelectorTree ("Size", yyt->Store.Size);
}

static void yWriteExit
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kExit], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Exit.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Exit.Level) yyWriteNl ();
 yyIndentSelector ("IsVectorExit"); writeBOOLEAN (yyt->Exit.IsVectorExit) yyWriteNl ();
 yyIndentSelector ("ExitConfigsIn"); writetConfigs (yyt->Exit.ExitConfigsIn) yyWriteNl ();
 yyIndentSelector ("ExitConfigsOut"); writetConfigs (yyt->Exit.ExitConfigsOut) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsIn"); writetConfigs (yyt->Exit.ReturnConfigsIn) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsOut"); writetConfigs (yyt->Exit.ReturnConfigsOut) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Exit.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Exit.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Exit.StrsOut) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Exit.Type) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->Exit.Pos) yyWriteNl ();
}

static void yWriteReturn0
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kReturn0], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Return0.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Return0.Level) yyWriteNl ();
 yyIndentSelector ("IsVectorExit"); writeBOOLEAN (yyt->Return0.IsVectorExit) yyWriteNl ();
 yyIndentSelector ("ExitConfigsIn"); writetConfigs (yyt->Return0.ExitConfigsIn) yyWriteNl ();
 yyIndentSelector ("ExitConfigsOut"); writetConfigs (yyt->Return0.ExitConfigsOut) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsIn"); writetConfigs (yyt->Return0.ReturnConfigsIn) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsOut"); writetConfigs (yyt->Return0.ReturnConfigsOut) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Return0.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Return0.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Return0.StrsOut) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Return0.Type) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->Return0.Pos) yyWriteNl ();
 yyIndentSelector ("ResultType"); writetType (yyt->Return0.ResultType) yyWriteNl ();
}

static void yWriteReturn1
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kReturn1], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Return1.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Return1.Level) yyWriteNl ();
 yyIndentSelector ("IsVectorExit"); writeBOOLEAN (yyt->Return1.IsVectorExit) yyWriteNl ();
 yyIndentSelector ("ExitConfigsIn"); writetConfigs (yyt->Return1.ExitConfigsIn) yyWriteNl ();
 yyIndentSelector ("ExitConfigsOut"); writetConfigs (yyt->Return1.ExitConfigsOut) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsIn"); writetConfigs (yyt->Return1.ReturnConfigsIn) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsOut"); writetConfigs (yyt->Return1.ReturnConfigsOut) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Return1.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Return1.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Return1.StrsOut) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Return1.Type) yyWriteNl ();
 yyIndentSelector ("Pos"); writetPosition (yyt->Return1.Pos) yyWriteNl ();
 yyIndentSelectorTree ("Result", yyt->Return1.Result);
 yyIndentSelector ("OpenAccessOrCall"); writeBOOLEAN (yyt->Return1.OpenAccessOrCall) yyWriteNl ();
 yyIndentSelector ("ResultType"); writetType (yyt->Return1.ResultType) yyWriteNl ();
}

static void yWriteElsifs
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kElsifs], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Elsifs.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Elsifs.Level) yyWriteNl ();
 yyIndentSelector ("IsVectorExit"); writeBOOLEAN (yyt->Elsifs.IsVectorExit) yyWriteNl ();
 yyIndentSelector ("ExitConfigsIn"); writetConfigs (yyt->Elsifs.ExitConfigsIn) yyWriteNl ();
 yyIndentSelector ("ExitConfigsOut"); writetConfigs (yyt->Elsifs.ExitConfigsOut) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsIn"); writetConfigs (yyt->Elsifs.ReturnConfigsIn) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsOut"); writetConfigs (yyt->Elsifs.ReturnConfigsOut) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Elsifs.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Elsifs.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Elsifs.StrsOut) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Elsifs.Type) yyWriteNl ();
}

static void yWriteNoElsif
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoElsif], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->NoElsif.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->NoElsif.Level) yyWriteNl ();
 yyIndentSelector ("IsVectorExit"); writeBOOLEAN (yyt->NoElsif.IsVectorExit) yyWriteNl ();
 yyIndentSelector ("ExitConfigsIn"); writetConfigs (yyt->NoElsif.ExitConfigsIn) yyWriteNl ();
 yyIndentSelector ("ExitConfigsOut"); writetConfigs (yyt->NoElsif.ExitConfigsOut) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsIn"); writetConfigs (yyt->NoElsif.ReturnConfigsIn) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsOut"); writetConfigs (yyt->NoElsif.ReturnConfigsOut) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->NoElsif.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->NoElsif.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->NoElsif.StrsOut) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->NoElsif.Type) yyWriteNl ();
}

static void yWriteElsif
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kElsif], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Elsif.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Elsif.Level) yyWriteNl ();
 yyIndentSelector ("IsVectorExit"); writeBOOLEAN (yyt->Elsif.IsVectorExit) yyWriteNl ();
 yyIndentSelector ("ExitConfigsIn"); writetConfigs (yyt->Elsif.ExitConfigsIn) yyWriteNl ();
 yyIndentSelector ("ExitConfigsOut"); writetConfigs (yyt->Elsif.ExitConfigsOut) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsIn"); writetConfigs (yyt->Elsif.ReturnConfigsIn) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsOut"); writetConfigs (yyt->Elsif.ReturnConfigsOut) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Elsif.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Elsif.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Elsif.StrsOut) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Elsif.Type) yyWriteNl ();
 yyIndentSelectorTree ("Cond", yyt->Elsif.Cond);
 yyIndentSelectorTree ("Stmts", yyt->Elsif.Stmts);
}

static void yWriteCases
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kCases], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Cases.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Cases.Level) yyWriteNl ();
 yyIndentSelector ("IsVectorExit"); writeBOOLEAN (yyt->Cases.IsVectorExit) yyWriteNl ();
 yyIndentSelector ("ExitConfigsIn"); writetConfigs (yyt->Cases.ExitConfigsIn) yyWriteNl ();
 yyIndentSelector ("ExitConfigsOut"); writetConfigs (yyt->Cases.ExitConfigsOut) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsIn"); writetConfigs (yyt->Cases.ReturnConfigsIn) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsOut"); writetConfigs (yyt->Cases.ReturnConfigsOut) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Cases.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Cases.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Cases.StrsOut) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Cases.Type) yyWriteNl ();
}

static void yWriteNoCase
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoCase], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->NoCase.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->NoCase.Level) yyWriteNl ();
 yyIndentSelector ("IsVectorExit"); writeBOOLEAN (yyt->NoCase.IsVectorExit) yyWriteNl ();
 yyIndentSelector ("ExitConfigsIn"); writetConfigs (yyt->NoCase.ExitConfigsIn) yyWriteNl ();
 yyIndentSelector ("ExitConfigsOut"); writetConfigs (yyt->NoCase.ExitConfigsOut) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsIn"); writetConfigs (yyt->NoCase.ReturnConfigsIn) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsOut"); writetConfigs (yyt->NoCase.ReturnConfigsOut) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->NoCase.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->NoCase.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->NoCase.StrsOut) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->NoCase.Type) yyWriteNl ();
}

static void yWriteCases1
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kCases1], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Cases1.Env) yyWriteNl ();
 yyIndentSelector ("Level"); writeINDEX (yyt->Cases1.Level) yyWriteNl ();
 yyIndentSelector ("IsVectorExit"); writeBOOLEAN (yyt->Cases1.IsVectorExit) yyWriteNl ();
 yyIndentSelector ("ExitConfigsIn"); writetConfigs (yyt->Cases1.ExitConfigsIn) yyWriteNl ();
 yyIndentSelector ("ExitConfigsOut"); writetConfigs (yyt->Cases1.ExitConfigsOut) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsIn"); writetConfigs (yyt->Cases1.ReturnConfigsIn) yyWriteNl ();
 yyIndentSelector ("ReturnConfigsOut"); writetConfigs (yyt->Cases1.ReturnConfigsOut) yyWriteNl ();
 yyIndentSelector ("GlobalPtrs"); writeBOOLEAN (yyt->Cases1.GlobalPtrs) yyWriteNl ();
 yyIndentSelector ("StrsIn"); writetStrings (yyt->Cases1.StrsIn) yyWriteNl ();
 yyIndentSelector ("StrsOut"); writetStrings (yyt->Cases1.StrsOut) yyWriteNl ();
 yyIndentSelector ("Type"); writetType (yyt->Cases1.Type) yyWriteNl ();
 yyIndentSelectorTree ("Labels", yyt->Cases1.Labels);
 yyIndentSelectorTree ("Stmts", yyt->Cases1.Stmts);
}

static void yWriteLabels
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kLabels], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Labels.Env) yyWriteNl ();
}

static void yWriteNoLabel
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kNoLabel], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->NoLabel.Env) yyWriteNl ();
}

static void yWriteLabel
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kLabel], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->Label.Env) yyWriteNl ();
}

static void yWriteLabelExpr
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kLabelExpr], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->LabelExpr.Env) yyWriteNl ();
 yyIndentSelectorTree ("Expr", yyt->LabelExpr.Expr);
 yyIndentSelector ("LabelVal"); writetValue (yyt->LabelExpr.LabelVal) yyWriteNl ();
}

static void yWriteLabelRange
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 (void) fputs (Tree_NodeName [kLabelRange], yyf); (void) fputc ('\n', yyf);
 yyIndentSelector ("Env"); writetEnv (yyt->LabelRange.Env) yyWriteNl ();
 yyIndentSelectorTree ("Lwb", yyt->LabelRange.Lwb);
 yyIndentSelectorTree ("Upb", yyt->LabelRange.Upb);
 yyIndentSelector ("LwbVal"); writetValue (yyt->LabelRange.LwbVal) yyWriteNl ();
 yyIndentSelector ("UpbVal"); writetValue (yyt->LabelRange.UpbVal) yyWriteNl ();
}

static void yyWriteTree
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{ unsigned short yyLevel = yyIndentLevel;
 for (;;) {
  if (yyt == NoTree) { (void) fputs (" NoTree\n", yyf); goto yyExit;
  } else if (yyt->yyHead.yyMark == 0) { (void) fprintf (yyf, "^%d\n", yyMapToLabel (yyt)); goto yyExit;
  } else if (yyt->yyHead.yyMark > 1) {
   register int yyi;
   (void) fprintf (yyf, "\n%06d:", yyMapToLabel (yyt));
   for (yyi = 8; yyi <= yyIndentLevel; yyi ++) (void) putc (' ', yyf);
  } else (void) putc (' ', yyf);
  yyt->yyHead.yyMark = 0;
  yyIndentLevel += 2;

  switch (yyt->Kind) {
case kROOT: yWriteROOT (yyt); yyIndentSelector ("CompUnits"); yyt = yyt->ROOT.CompUnits; break;
case kCompUnits: yWriteCompUnits (yyt); goto yyExit;
case kNoCompUnit: yWriteNoCompUnit (yyt); goto yyExit;
case kCompUnit: yWriteCompUnit (yyt); yyIndentSelector ("Next"); yyt = yyt->CompUnit.Next; break;
case kDefMod: yWriteDefMod (yyt); yyIndentSelector ("Next"); yyt = yyt->DefMod.Next; break;
case kImplMod: yWriteImplMod (yyt); yyIndentSelector ("Next"); yyt = yyt->ImplMod.Next; break;
case kImports: yWriteImports (yyt); goto yyExit;
case kNoImport: yWriteNoImport (yyt); goto yyExit;
case kImport: yWriteImport (yyt); yyIndentSelector ("Next"); yyt = yyt->Import.Next; break;
case kFrom: yWriteFrom (yyt); yyIndentSelector ("Next"); yyt = yyt->From.Next; break;
case kObjects: yWriteObjects (yyt); yyIndentSelector ("Next"); yyt = yyt->Objects.Next; break;
case kImpIds: yWriteImpIds (yyt); goto yyExit;
case kNoImpId: yWriteNoImpId (yyt); goto yyExit;
case kImpId: yWriteImpId (yyt); yyIndentSelector ("Next"); yyt = yyt->ImpId.Next; break;
case kExports: (void) fputs (Tree_NodeName [kExports], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kNoExport: (void) fputs (Tree_NodeName [kNoExport], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kExport: yWriteExport (yyt); yyIndentSelector ("ExpIds"); yyt = yyt->Export.ExpIds; break;
case kExpIds: (void) fputs (Tree_NodeName [kExpIds], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kNoExpId: (void) fputs (Tree_NodeName [kNoExpId], yyf); (void) fputc ('\n', yyf); goto yyExit;
case kExpId: yWriteExpId (yyt); yyIndentSelector ("Next"); yyt = yyt->ExpId.Next; break;
case kDecls: yWriteDecls (yyt); goto yyExit;
case kNoDecl: yWriteNoDecl (yyt); goto yyExit;
case kDecl: yWriteDecl (yyt); yyIndentSelector ("Next"); yyt = yyt->Decl.Next; break;
case kVar: yWriteVar (yyt); yyIndentSelector ("Next"); yyt = yyt->Var.Next; break;
case kObject: yWriteObject (yyt); yyIndentSelector ("Next"); yyt = yyt->Object.Next; break;
case kConnectFrom: yWriteConnectFrom (yyt); yyIndentSelector ("Next"); yyt = yyt->ConnectFrom.Next; break;
case kConnectDecls: yWriteConnectDecls (yyt); yyIndentSelector ("Next"); yyt = yyt->ConnectDecls.Next; break;
case kConfig: yWriteConfig (yyt); yyIndentSelector ("Next"); yyt = yyt->Config.Next; break;
case kConst: yWriteConst (yyt); yyIndentSelector ("Next"); yyt = yyt->Const.Next; break;
case kTypeDecl: yWriteTypeDecl (yyt); yyIndentSelector ("Next"); yyt = yyt->TypeDecl.Next; break;
case kProc: yWriteProc (yyt); yyIndentSelector ("Next"); yyt = yyt->Proc.Next; break;
case kProcHead: yWriteProcHead (yyt); yyIndentSelector ("Next"); yyt = yyt->ProcHead.Next; break;
case kOpaque: yWriteOpaque (yyt); yyIndentSelector ("Next"); yyt = yyt->Opaque.Next; break;
case kConnectDests: yWriteConnectDests (yyt); goto yyExit;
case kNoConnectDest: yWriteNoConnectDest (yyt); goto yyExit;
case kConnectDest: yWriteConnectDest (yyt); yyIndentSelector ("Next"); yyt = yyt->ConnectDest.Next; break;
case kConnectDestUni: yWriteConnectDestUni (yyt); yyIndentSelector ("Next"); yyt = yyt->ConnectDestUni.Next; break;
case kConnectDestBi: yWriteConnectDestBi (yyt); yyIndentSelector ("Next"); yyt = yyt->ConnectDestBi.Next; break;
case kVarIds: yWriteVarIds (yyt); goto yyExit;
case kNoVarId: yWriteNoVarId (yyt); goto yyExit;
case kVarId: yWriteVarId (yyt); yyIndentSelector ("Next"); yyt = yyt->VarId.Next; break;
case kFormals: yWriteFormals (yyt); goto yyExit;
case kNoFormal: yWriteNoFormal (yyt); goto yyExit;
case kFormal: yWriteFormal (yyt); yyIndentSelector ("Next"); yyt = yyt->Formal.Next; break;
case kParIds: yWriteParIds (yyt); goto yyExit;
case kNoParId: yWriteNoParId (yyt); goto yyExit;
case kParId: yWriteParId (yyt); yyIndentSelector ("Next"); yyt = yyt->ParId.Next; break;
case kType: yWriteType (yyt); goto yyExit;
case kVector: yWriteVector (yyt); yyIndentSelector ("Scalar"); yyt = yyt->Vector.Scalar; break;
case kArray: yWriteArray (yyt); yyIndentSelector ("ElemType"); yyt = yyt->Array.ElemType; break;
case kRecord: yWriteRecord (yyt); yyIndentSelector ("Fields"); yyt = yyt->Record.Fields; break;
case kSetType: yWriteSetType (yyt); yyIndentSelector ("BaseType"); yyt = yyt->SetType.BaseType; break;
case kPointer: yWritePointer (yyt); yyIndentSelector ("TargetType"); yyt = yyt->Pointer.TargetType; break;
case kProcType: yWriteProcType (yyt); yyIndentSelector ("ResultType"); yyt = yyt->ProcType.ResultType; break;
case kSimpleType: yWriteSimpleType (yyt); goto yyExit;
case kEnumeration: yWriteEnumeration (yyt); yyIndentSelector ("EnumIds"); yyt = yyt->Enumeration.EnumIds; break;
case kSubrange: yWriteSubrange (yyt); yyIndentSelector ("Upb"); yyt = yyt->Subrange.Upb; break;
case kPrimaryType: yWritePrimaryType (yyt); goto yyExit;
case kVoid: yWriteVoid (yyt); goto yyExit;
case kTypeId: yWriteTypeId (yyt); goto yyExit;
case kTypeId0: yWriteTypeId0 (yyt); goto yyExit;
case kTypeId1: yWriteTypeId1 (yyt); yyIndentSelector ("TypeId"); yyt = yyt->TypeId1.TypeId; break;
case kFields: yWriteFields (yyt); goto yyExit;
case kNoField: yWriteNoField (yyt); goto yyExit;
case kField: yWriteField (yyt); yyIndentSelector ("Next"); yyt = yyt->Field.Next; break;
case kRecordSect: yWriteRecordSect (yyt); yyIndentSelector ("Next"); yyt = yyt->RecordSect.Next; break;
case kVariantSect: yWriteVariantSect (yyt); yyIndentSelector ("Next"); yyt = yyt->VariantSect.Next; break;
case kFieldIds: yWriteFieldIds (yyt); goto yyExit;
case kNoFieldId: yWriteNoFieldId (yyt); goto yyExit;
case kFieldId: yWriteFieldId (yyt); yyIndentSelector ("Next"); yyt = yyt->FieldId.Next; break;
case kTagField: yWriteTagField (yyt); yyIndentSelector ("Type"); yyt = yyt->TagField.Type; break;
case kTagField1: yWriteTagField1 (yyt); yyIndentSelector ("Type"); yyt = yyt->TagField1.Type; break;
case kTagField2: yWriteTagField2 (yyt); yyIndentSelector ("Type"); yyt = yyt->TagField2.Type; break;
case kVariants: yWriteVariants (yyt); goto yyExit;
case kNoVariant: yWriteNoVariant (yyt); goto yyExit;
case kVariant: yWriteVariant (yyt); yyIndentSelector ("Next"); yyt = yyt->Variant.Next; break;
case kFormalTypes: yWriteFormalTypes (yyt); goto yyExit;
case kNoFormalType: yWriteNoFormalType (yyt); goto yyExit;
case kFormalType: yWriteFormalType (yyt); yyIndentSelector ("Next"); yyt = yyt->FormalType.Next; break;
case kEnumIds: yWriteEnumIds (yyt); goto yyExit;
case kNoEnumId: yWriteNoEnumId (yyt); goto yyExit;
case kEnumId: yWriteEnumId (yyt); yyIndentSelector ("Next"); yyt = yyt->EnumId.Next; break;
case kExpr: yWriteExpr (yyt); goto yyExit;
case kNoExpr: yWriteNoExpr (yyt); goto yyExit;
case kMultiples: yWriteMultiples (yyt); yyIndentSelector ("Mop"); yyt = yyt->Multiples.Mop; break;
case kLastMultiple: yWriteLastMultiple (yyt); yyIndentSelector ("Mop"); yyt = yyt->LastMultiple.Mop; break;
case kMultiple: yWriteMultiple (yyt); yyIndentSelector ("Multiples"); yyt = yyt->Multiple.Multiples; break;
case kBinary: yWriteBinary (yyt); yyIndentSelector ("Rop"); yyt = yyt->Binary.Rop; break;
case kUnary: yWriteUnary (yyt); yyIndentSelector ("Mop"); yyt = yyt->Unary.Mop; break;
case kIntConst: yWriteIntConst (yyt); goto yyExit;
case kRealConst: yWriteRealConst (yyt); goto yyExit;
case kStringConst: yWriteStringConst (yyt); goto yyExit;
case kCharConst: yWriteCharConst (yyt); goto yyExit;
case kFuncCall: yWriteFuncCall (yyt); yyIndentSelector ("Actuals"); yyt = yyt->FuncCall.Actuals; break;
case kMove: yWriteMove (yyt); yyIndentSelector ("Expr"); yyt = yyt->Move.Expr; break;
case kReceive: yWriteReceive (yyt); yyIndentSelector ("Expr"); yyt = yyt->Receive.Expr; break;
case kReduce: yWriteReduce (yyt); yyIndentSelector ("Expr"); yyt = yyt->Reduce.Expr; break;
case kSet: yWriteSet (yyt); yyIndentSelector ("Elems"); yyt = yyt->Set.Elems; break;
case kBitSet: yWriteBitSet (yyt); yyIndentSelector ("Elems"); yyt = yyt->BitSet.Elems; break;
case kDesignator: yWriteDesignator (yyt); goto yyExit;
case kQualid: yWriteQualid (yyt); goto yyExit;
case kQualid0: yWriteQualid0 (yyt); goto yyExit;
case kQualid1: yWriteQualid1 (yyt); yyIndentSelector ("Qualid"); yyt = yyt->Qualid1.Qualid; break;
case kProcessor: yWriteProcessor (yyt); yyIndentSelector ("Proc"); yyt = yyt->Processor.Proc; break;
case kDimensions: yWriteDimensions (yyt); yyIndentSelector ("Actuals"); yyt = yyt->Dimensions.Actuals; break;
case kSelect: yWriteSelect (yyt); yyIndentSelector ("Designator"); yyt = yyt->Select.Designator; break;
case kSubscript: yWriteSubscript (yyt); yyIndentSelector ("Index"); yyt = yyt->Subscript.Index; break;
case kDeref: yWriteDeref (yyt); yyIndentSelector ("Designator"); yyt = yyt->Deref.Designator; break;
case kDirSpec: yWriteDirSpec (yyt); goto yyExit;
case kFuncSpec: yWriteFuncSpec (yyt); yyIndentSelector ("Reduce"); yyt = yyt->FuncSpec.Reduce; break;
case kProcSpec: yWriteProcSpec (yyt); yyIndentSelector ("Reduce"); yyt = yyt->ProcSpec.Reduce; break;
case kDimSpec: yWriteDimSpec (yyt); yyIndentSelector ("Reduce"); yyt = yyt->DimSpec.Reduce; break;
case kElems: yWriteElems (yyt); goto yyExit;
case kNoElem: yWriteNoElem (yyt); goto yyExit;
case kElem: yWriteElem (yyt); yyIndentSelector ("Next"); yyt = yyt->Elem.Next; break;
case kElemExpr: yWriteElemExpr (yyt); yyIndentSelector ("Next"); yyt = yyt->ElemExpr.Next; break;
case kElemRange: yWriteElemRange (yyt); yyIndentSelector ("Next"); yyt = yyt->ElemRange.Next; break;
case kActuals: yWriteActuals (yyt); goto yyExit;
case kNoActual: yWriteNoActual (yyt); goto yyExit;
case kActual: yWriteActual (yyt); yyIndentSelector ("Next"); yyt = yyt->Actual.Next; break;
case kActualExpr: yWriteActualExpr (yyt); yyIndentSelector ("Next"); yyt = yyt->ActualExpr.Next; break;
case kActualRange: yWriteActualRange (yyt); yyIndentSelector ("Next"); yyt = yyt->ActualRange.Next; break;
case kActualReduce: yWriteActualReduce (yyt); yyIndentSelector ("Next"); yyt = yyt->ActualReduce.Next; break;
case kActualStar: yWriteActualStar (yyt); yyIndentSelector ("Next"); yyt = yyt->ActualStar.Next; break;
case kStmts: yWriteStmts (yyt); goto yyExit;
case kNoStmt: yWriteNoStmt (yyt); goto yyExit;
case kStmt: yWriteStmt (yyt); yyIndentSelector ("Next"); yyt = yyt->Stmt.Next; break;
case kAssign: yWriteAssign (yyt); yyIndentSelector ("Next"); yyt = yyt->Assign.Next; break;
case kCall: yWriteCall (yyt); yyIndentSelector ("Next"); yyt = yyt->Call.Next; break;
case kIf: yWriteIf (yyt); yyIndentSelector ("Next"); yyt = yyt->If.Next; break;
case kCase: yWriteCase (yyt); yyIndentSelector ("Next"); yyt = yyt->Case.Next; break;
case kWhile: yWriteWhile (yyt); yyIndentSelector ("Next"); yyt = yyt->While.Next; break;
case kRepeat: yWriteRepeat (yyt); yyIndentSelector ("Next"); yyt = yyt->Repeat.Next; break;
case kLoop: yWriteLoop (yyt); yyIndentSelector ("Next"); yyt = yyt->Loop.Next; break;
case kLooppar: yWriteLooppar (yyt); yyIndentSelector ("Next"); yyt = yyt->Looppar.Next; break;
case kFor: yWriteFor (yyt); yyIndentSelector ("Next"); yyt = yyt->For.Next; break;
case kWith: yWriteWith (yyt); yyIndentSelector ("Next"); yyt = yyt->With.Next; break;
case kAll: yWriteAll (yyt); yyIndentSelector ("Next"); yyt = yyt->All.Next; break;
case kSend: yWriteSend (yyt); yyIndentSelector ("Next"); yyt = yyt->Send.Next; break;
case kLoad: yWriteLoad (yyt); yyIndentSelector ("Next"); yyt = yyt->Load.Next; break;
case kStore: yWriteStore (yyt); yyIndentSelector ("Next"); yyt = yyt->Store.Next; break;
case kExit: yWriteExit (yyt); yyIndentSelector ("Next"); yyt = yyt->Exit.Next; break;
case kReturn0: yWriteReturn0 (yyt); yyIndentSelector ("Next"); yyt = yyt->Return0.Next; break;
case kReturn1: yWriteReturn1 (yyt); yyIndentSelector ("Next"); yyt = yyt->Return1.Next; break;
case kElsifs: yWriteElsifs (yyt); goto yyExit;
case kNoElsif: yWriteNoElsif (yyt); goto yyExit;
case kElsif: yWriteElsif (yyt); yyIndentSelector ("Next"); yyt = yyt->Elsif.Next; break;
case kCases: yWriteCases (yyt); goto yyExit;
case kNoCase: yWriteNoCase (yyt); goto yyExit;
case kCases1: yWriteCases1 (yyt); yyIndentSelector ("Next"); yyt = yyt->Cases1.Next; break;
case kLabels: yWriteLabels (yyt); goto yyExit;
case kNoLabel: yWriteNoLabel (yyt); goto yyExit;
case kLabel: yWriteLabel (yyt); yyIndentSelector ("Next"); yyt = yyt->Label.Next; break;
case kLabelExpr: yWriteLabelExpr (yyt); yyIndentSelector ("Next"); yyt = yyt->LabelExpr.Next; break;
case kLabelRange: yWriteLabelRange (yyt); yyIndentSelector ("Next"); yyt = yyt->LabelRange.Next; break;
  default: goto yyExit;
  }
 }
yyExit:
 yyIndentLevel = yyLevel;
}

# define yyNil	0374
# define yyNoLabel	0375
# define yyLabelDef	0376
# define yyLabelUse	0377

tTree ReverseTree
# if defined __STDC__ | defined __cplusplus
 (tTree yyOld)
# else
 (yyOld) tTree yyOld;
# endif
{
 register tTree yyNew, yyNext, yyTail;
 yyNew = yyOld;
 yyTail = yyOld;
 for (;;) {
  switch (yyOld->Kind) {
case kCompUnit: yyNext = yyOld->CompUnit.Next; yyOld->CompUnit.Next = yyNew; break;
case kDefMod: yyNext = yyOld->DefMod.Next; yyOld->DefMod.Next = yyNew; break;
case kImplMod: yyNext = yyOld->ImplMod.Next; yyOld->ImplMod.Next = yyNew; break;
case kImport: yyNext = yyOld->Import.Next; yyOld->Import.Next = yyNew; break;
case kFrom: yyNext = yyOld->From.Next; yyOld->From.Next = yyNew; break;
case kObjects: yyNext = yyOld->Objects.Next; yyOld->Objects.Next = yyNew; break;
case kImpId: yyNext = yyOld->ImpId.Next; yyOld->ImpId.Next = yyNew; break;
case kExpId: yyNext = yyOld->ExpId.Next; yyOld->ExpId.Next = yyNew; break;
case kDecl: yyNext = yyOld->Decl.Next; yyOld->Decl.Next = yyNew; break;
case kVar: yyNext = yyOld->Var.Next; yyOld->Var.Next = yyNew; break;
case kObject: yyNext = yyOld->Object.Next; yyOld->Object.Next = yyNew; break;
case kConnectFrom: yyNext = yyOld->ConnectFrom.Next; yyOld->ConnectFrom.Next = yyNew; break;
case kConnectDecls: yyNext = yyOld->ConnectDecls.Next; yyOld->ConnectDecls.Next = yyNew; break;
case kConfig: yyNext = yyOld->Config.Next; yyOld->Config.Next = yyNew; break;
case kConst: yyNext = yyOld->Const.Next; yyOld->Const.Next = yyNew; break;
case kTypeDecl: yyNext = yyOld->TypeDecl.Next; yyOld->TypeDecl.Next = yyNew; break;
case kProc: yyNext = yyOld->Proc.Next; yyOld->Proc.Next = yyNew; break;
case kProcHead: yyNext = yyOld->ProcHead.Next; yyOld->ProcHead.Next = yyNew; break;
case kOpaque: yyNext = yyOld->Opaque.Next; yyOld->Opaque.Next = yyNew; break;
case kConnectDest: yyNext = yyOld->ConnectDest.Next; yyOld->ConnectDest.Next = yyNew; break;
case kConnectDestUni: yyNext = yyOld->ConnectDestUni.Next; yyOld->ConnectDestUni.Next = yyNew; break;
case kConnectDestBi: yyNext = yyOld->ConnectDestBi.Next; yyOld->ConnectDestBi.Next = yyNew; break;
case kVarId: yyNext = yyOld->VarId.Next; yyOld->VarId.Next = yyNew; break;
case kFormal: yyNext = yyOld->Formal.Next; yyOld->Formal.Next = yyNew; break;
case kParId: yyNext = yyOld->ParId.Next; yyOld->ParId.Next = yyNew; break;
case kField: yyNext = yyOld->Field.Next; yyOld->Field.Next = yyNew; break;
case kRecordSect: yyNext = yyOld->RecordSect.Next; yyOld->RecordSect.Next = yyNew; break;
case kVariantSect: yyNext = yyOld->VariantSect.Next; yyOld->VariantSect.Next = yyNew; break;
case kFieldId: yyNext = yyOld->FieldId.Next; yyOld->FieldId.Next = yyNew; break;
case kVariant: yyNext = yyOld->Variant.Next; yyOld->Variant.Next = yyNew; break;
case kFormalType: yyNext = yyOld->FormalType.Next; yyOld->FormalType.Next = yyNew; break;
case kEnumId: yyNext = yyOld->EnumId.Next; yyOld->EnumId.Next = yyNew; break;
case kElem: yyNext = yyOld->Elem.Next; yyOld->Elem.Next = yyNew; break;
case kElemExpr: yyNext = yyOld->ElemExpr.Next; yyOld->ElemExpr.Next = yyNew; break;
case kElemRange: yyNext = yyOld->ElemRange.Next; yyOld->ElemRange.Next = yyNew; break;
case kActual: yyNext = yyOld->Actual.Next; yyOld->Actual.Next = yyNew; break;
case kActualExpr: yyNext = yyOld->ActualExpr.Next; yyOld->ActualExpr.Next = yyNew; break;
case kActualRange: yyNext = yyOld->ActualRange.Next; yyOld->ActualRange.Next = yyNew; break;
case kActualReduce: yyNext = yyOld->ActualReduce.Next; yyOld->ActualReduce.Next = yyNew; break;
case kActualStar: yyNext = yyOld->ActualStar.Next; yyOld->ActualStar.Next = yyNew; break;
case kStmt: yyNext = yyOld->Stmt.Next; yyOld->Stmt.Next = yyNew; break;
case kAssign: yyNext = yyOld->Assign.Next; yyOld->Assign.Next = yyNew; break;
case kCall: yyNext = yyOld->Call.Next; yyOld->Call.Next = yyNew; break;
case kIf: yyNext = yyOld->If.Next; yyOld->If.Next = yyNew; break;
case kCase: yyNext = yyOld->Case.Next; yyOld->Case.Next = yyNew; break;
case kWhile: yyNext = yyOld->While.Next; yyOld->While.Next = yyNew; break;
case kRepeat: yyNext = yyOld->Repeat.Next; yyOld->Repeat.Next = yyNew; break;
case kLoop: yyNext = yyOld->Loop.Next; yyOld->Loop.Next = yyNew; break;
case kLooppar: yyNext = yyOld->Looppar.Next; yyOld->Looppar.Next = yyNew; break;
case kFor: yyNext = yyOld->For.Next; yyOld->For.Next = yyNew; break;
case kWith: yyNext = yyOld->With.Next; yyOld->With.Next = yyNew; break;
case kAll: yyNext = yyOld->All.Next; yyOld->All.Next = yyNew; break;
case kSend: yyNext = yyOld->Send.Next; yyOld->Send.Next = yyNew; break;
case kLoad: yyNext = yyOld->Load.Next; yyOld->Load.Next = yyNew; break;
case kStore: yyNext = yyOld->Store.Next; yyOld->Store.Next = yyNew; break;
case kExit: yyNext = yyOld->Exit.Next; yyOld->Exit.Next = yyNew; break;
case kReturn0: yyNext = yyOld->Return0.Next; yyOld->Return0.Next = yyNew; break;
case kReturn1: yyNext = yyOld->Return1.Next; yyOld->Return1.Next = yyNew; break;
case kElsif: yyNext = yyOld->Elsif.Next; yyOld->Elsif.Next = yyNew; break;
case kCases1: yyNext = yyOld->Cases1.Next; yyOld->Cases1.Next = yyNew; break;
case kLabel: yyNext = yyOld->Label.Next; yyOld->Label.Next = yyNew; break;
case kLabelExpr: yyNext = yyOld->LabelExpr.Next; yyOld->LabelExpr.Next = yyNew; break;
case kLabelRange: yyNext = yyOld->LabelRange.Next; yyOld->LabelRange.Next = yyNew; break;
  default: goto yyExit;
  }
  yyNew = yyOld;
  yyOld = yyNext;
 }
yyExit:
 switch (yyTail->Kind) {
case kCompUnit: yyTail->CompUnit.Next = yyOld; break;
case kDefMod: yyTail->DefMod.Next = yyOld; break;
case kImplMod: yyTail->ImplMod.Next = yyOld; break;
case kImport: yyTail->Import.Next = yyOld; break;
case kFrom: yyTail->From.Next = yyOld; break;
case kObjects: yyTail->Objects.Next = yyOld; break;
case kImpId: yyTail->ImpId.Next = yyOld; break;
case kExpId: yyTail->ExpId.Next = yyOld; break;
case kDecl: yyTail->Decl.Next = yyOld; break;
case kVar: yyTail->Var.Next = yyOld; break;
case kObject: yyTail->Object.Next = yyOld; break;
case kConnectFrom: yyTail->ConnectFrom.Next = yyOld; break;
case kConnectDecls: yyTail->ConnectDecls.Next = yyOld; break;
case kConfig: yyTail->Config.Next = yyOld; break;
case kConst: yyTail->Const.Next = yyOld; break;
case kTypeDecl: yyTail->TypeDecl.Next = yyOld; break;
case kProc: yyTail->Proc.Next = yyOld; break;
case kProcHead: yyTail->ProcHead.Next = yyOld; break;
case kOpaque: yyTail->Opaque.Next = yyOld; break;
case kConnectDest: yyTail->ConnectDest.Next = yyOld; break;
case kConnectDestUni: yyTail->ConnectDestUni.Next = yyOld; break;
case kConnectDestBi: yyTail->ConnectDestBi.Next = yyOld; break;
case kVarId: yyTail->VarId.Next = yyOld; break;
case kFormal: yyTail->Formal.Next = yyOld; break;
case kParId: yyTail->ParId.Next = yyOld; break;
case kField: yyTail->Field.Next = yyOld; break;
case kRecordSect: yyTail->RecordSect.Next = yyOld; break;
case kVariantSect: yyTail->VariantSect.Next = yyOld; break;
case kFieldId: yyTail->FieldId.Next = yyOld; break;
case kVariant: yyTail->Variant.Next = yyOld; break;
case kFormalType: yyTail->FormalType.Next = yyOld; break;
case kEnumId: yyTail->EnumId.Next = yyOld; break;
case kElem: yyTail->Elem.Next = yyOld; break;
case kElemExpr: yyTail->ElemExpr.Next = yyOld; break;
case kElemRange: yyTail->ElemRange.Next = yyOld; break;
case kActual: yyTail->Actual.Next = yyOld; break;
case kActualExpr: yyTail->ActualExpr.Next = yyOld; break;
case kActualRange: yyTail->ActualRange.Next = yyOld; break;
case kActualReduce: yyTail->ActualReduce.Next = yyOld; break;
case kActualStar: yyTail->ActualStar.Next = yyOld; break;
case kStmt: yyTail->Stmt.Next = yyOld; break;
case kAssign: yyTail->Assign.Next = yyOld; break;
case kCall: yyTail->Call.Next = yyOld; break;
case kIf: yyTail->If.Next = yyOld; break;
case kCase: yyTail->Case.Next = yyOld; break;
case kWhile: yyTail->While.Next = yyOld; break;
case kRepeat: yyTail->Repeat.Next = yyOld; break;
case kLoop: yyTail->Loop.Next = yyOld; break;
case kLooppar: yyTail->Looppar.Next = yyOld; break;
case kFor: yyTail->For.Next = yyOld; break;
case kWith: yyTail->With.Next = yyOld; break;
case kAll: yyTail->All.Next = yyOld; break;
case kSend: yyTail->Send.Next = yyOld; break;
case kLoad: yyTail->Load.Next = yyOld; break;
case kStore: yyTail->Store.Next = yyOld; break;
case kExit: yyTail->Exit.Next = yyOld; break;
case kReturn0: yyTail->Return0.Next = yyOld; break;
case kReturn1: yyTail->Return1.Next = yyOld; break;
case kElsif: yyTail->Elsif.Next = yyOld; break;
case kCases1: yyTail->Cases1.Next = yyOld; break;
case kLabel: yyTail->Label.Next = yyOld; break;
case kLabelExpr: yyTail->LabelExpr.Next = yyOld; break;
case kLabelRange: yyTail->LabelRange.Next = yyOld; break;
 default: ;
 }
 return yyNew;
}

# define yyInitOldToNewStoreSize 32

typedef struct { tTree yyOld, yyNew; } yytOldToNew;
static unsigned long yyOldToNewStoreSize = yyInitOldToNewStoreSize;
static yytOldToNew yyOldToNewStore [yyInitOldToNewStoreSize];
static yytOldToNew * yyOldToNewStorePtr = yyOldToNewStore;
static int yyOldToNewCount;

static void yyStoreOldToNew
# if defined __STDC__ | defined __cplusplus
 (tTree yyOld, tTree yyNew)
# else
 (yyOld, yyNew) tTree yyOld, yyNew;
# endif
{
 if (++ yyOldToNewCount == yyOldToNewStoreSize)
  ExtendArray ((char * *) & yyOldToNewStorePtr, & yyOldToNewStoreSize, sizeof (yytOldToNew));
 yyOldToNewStorePtr [yyOldToNewCount].yyOld = yyOld;
 yyOldToNewStorePtr [yyOldToNewCount].yyNew = yyNew;
}

static tTree yyMapOldToNew
# if defined __STDC__ | defined __cplusplus
 (tTree yyOld)
# else
 (yyOld) tTree yyOld;
# endif
{
 register int yyi;
 for (yyi = 1; yyi <= yyOldToNewCount; yyi ++)
  if (yyOldToNewStorePtr [yyi].yyOld == yyOld) return yyOldToNewStorePtr [yyi].yyNew;
}

static tTree yyCopyTree
# if defined __STDC__ | defined __cplusplus
 (tTree yyt, yyPtrtTree yyNew)
# else
 (yyt, yyNew) tTree yyt; yyPtrtTree yyNew;
# endif
{
 for (;;) {
  if (yyt == NoTree) { * yyNew = NoTree; return; }
  if (yyt->yyHead.yyMark == 0) { * yyNew = yyMapOldToNew (yyt); return; }
  yyALLOC (* yyNew, Tree_NodeSize [yyt->Kind])
  if (yyt->yyHead.yyMark > 1) { yyStoreOldToNew (yyt, * yyNew); }
  yyt->yyHead.yyMark = 0;

  switch (yyt->Kind) {
case kROOT: (* yyNew)->ROOT = yyt->ROOT;
yyt = yyt->ROOT.CompUnits;
yyNew = & (* yyNew)->ROOT.CompUnits; break;
case kCompUnits: (* yyNew)->CompUnits = yyt->CompUnits;
copytObjects ((* yyNew)->CompUnits.Objects1, yyt->CompUnits.Objects1)
copytVoid ((* yyNew)->CompUnits.Objects2, yyt->CompUnits.Objects2)
copytObjects ((* yyNew)->CompUnits.Objects3, yyt->CompUnits.Objects3)
copytVoid ((* yyNew)->CompUnits.Objects4In, yyt->CompUnits.Objects4In)
copytVoid ((* yyNew)->CompUnits.Objects4Out, yyt->CompUnits.Objects4Out)
copytEnv ((* yyNew)->CompUnits.Env1, yyt->CompUnits.Env1)
copytVoid ((* yyNew)->CompUnits.Env2, yyt->CompUnits.Env2)
copytEnv ((* yyNew)->CompUnits.Env3, yyt->CompUnits.Env3)
copyINDEX ((* yyNew)->CompUnits.ConfigGroupIn, yyt->CompUnits.ConfigGroupIn)
copytIdent ((* yyNew)->CompUnits.ImplIdent, yyt->CompUnits.ImplIdent)
copytObjects ((* yyNew)->CompUnits.ImplTypes, yyt->CompUnits.ImplTypes)
copyINDEX ((* yyNew)->CompUnits.PosIn, yyt->CompUnits.PosIn)
copyINDEX ((* yyNew)->CompUnits.PosOut, yyt->CompUnits.PosOut)
copytIdents ((* yyNew)->CompUnits.IdsIn, yyt->CompUnits.IdsIn)
copytIdents ((* yyNew)->CompUnits.IdsOut, yyt->CompUnits.IdsOut)
return;
case kNoCompUnit: (* yyNew)->NoCompUnit = yyt->NoCompUnit;
copytObjects ((* yyNew)->NoCompUnit.Objects1, yyt->NoCompUnit.Objects1)
copytVoid ((* yyNew)->NoCompUnit.Objects2, yyt->NoCompUnit.Objects2)
copytObjects ((* yyNew)->NoCompUnit.Objects3, yyt->NoCompUnit.Objects3)
copytVoid ((* yyNew)->NoCompUnit.Objects4In, yyt->NoCompUnit.Objects4In)
copytVoid ((* yyNew)->NoCompUnit.Objects4Out, yyt->NoCompUnit.Objects4Out)
copytEnv ((* yyNew)->NoCompUnit.Env1, yyt->NoCompUnit.Env1)
copytVoid ((* yyNew)->NoCompUnit.Env2, yyt->NoCompUnit.Env2)
copytEnv ((* yyNew)->NoCompUnit.Env3, yyt->NoCompUnit.Env3)
copyINDEX ((* yyNew)->NoCompUnit.ConfigGroupIn, yyt->NoCompUnit.ConfigGroupIn)
copytIdent ((* yyNew)->NoCompUnit.ImplIdent, yyt->NoCompUnit.ImplIdent)
copytObjects ((* yyNew)->NoCompUnit.ImplTypes, yyt->NoCompUnit.ImplTypes)
copyINDEX ((* yyNew)->NoCompUnit.PosIn, yyt->NoCompUnit.PosIn)
copyINDEX ((* yyNew)->NoCompUnit.PosOut, yyt->NoCompUnit.PosOut)
copytIdents ((* yyNew)->NoCompUnit.IdsIn, yyt->NoCompUnit.IdsIn)
copytIdents ((* yyNew)->NoCompUnit.IdsOut, yyt->NoCompUnit.IdsOut)
return;
case kCompUnit: (* yyNew)->CompUnit = yyt->CompUnit;
copytObjects ((* yyNew)->CompUnit.Objects1, yyt->CompUnit.Objects1)
copytVoid ((* yyNew)->CompUnit.Objects2, yyt->CompUnit.Objects2)
copytObjects ((* yyNew)->CompUnit.Objects3, yyt->CompUnit.Objects3)
copytVoid ((* yyNew)->CompUnit.Objects4In, yyt->CompUnit.Objects4In)
copytVoid ((* yyNew)->CompUnit.Objects4Out, yyt->CompUnit.Objects4Out)
copytEnv ((* yyNew)->CompUnit.Env1, yyt->CompUnit.Env1)
copytVoid ((* yyNew)->CompUnit.Env2, yyt->CompUnit.Env2)
copytEnv ((* yyNew)->CompUnit.Env3, yyt->CompUnit.Env3)
copyINDEX ((* yyNew)->CompUnit.ConfigGroupIn, yyt->CompUnit.ConfigGroupIn)
copytIdent ((* yyNew)->CompUnit.ImplIdent, yyt->CompUnit.ImplIdent)
copytObjects ((* yyNew)->CompUnit.ImplTypes, yyt->CompUnit.ImplTypes)
copyINDEX ((* yyNew)->CompUnit.PosIn, yyt->CompUnit.PosIn)
copyINDEX ((* yyNew)->CompUnit.PosOut, yyt->CompUnit.PosOut)
copytIdents ((* yyNew)->CompUnit.IdsIn, yyt->CompUnit.IdsIn)
copytIdents ((* yyNew)->CompUnit.IdsOut, yyt->CompUnit.IdsOut)
copyINDEX ((* yyNew)->CompUnit.Kind, yyt->CompUnit.Kind)
copytIdent ((* yyNew)->CompUnit.Ident, yyt->CompUnit.Ident)
copytPosition ((* yyNew)->CompUnit.Pos, yyt->CompUnit.Pos)
copytObject ((* yyNew)->CompUnit.Object, yyt->CompUnit.Object)
copytIdent ((* yyNew)->CompUnit.RealName, yyt->CompUnit.RealName)
yyt = yyt->CompUnit.Next;
yyNew = & (* yyNew)->CompUnit.Next; break;
case kDefMod: (* yyNew)->DefMod = yyt->DefMod;
copytObjects ((* yyNew)->DefMod.Objects1, yyt->DefMod.Objects1)
copytVoid ((* yyNew)->DefMod.Objects2, yyt->DefMod.Objects2)
copytObjects ((* yyNew)->DefMod.Objects3, yyt->DefMod.Objects3)
copytVoid ((* yyNew)->DefMod.Objects4In, yyt->DefMod.Objects4In)
copytVoid ((* yyNew)->DefMod.Objects4Out, yyt->DefMod.Objects4Out)
copytEnv ((* yyNew)->DefMod.Env1, yyt->DefMod.Env1)
copytVoid ((* yyNew)->DefMod.Env2, yyt->DefMod.Env2)
copytEnv ((* yyNew)->DefMod.Env3, yyt->DefMod.Env3)
copyINDEX ((* yyNew)->DefMod.ConfigGroupIn, yyt->DefMod.ConfigGroupIn)
copytIdent ((* yyNew)->DefMod.ImplIdent, yyt->DefMod.ImplIdent)
copytObjects ((* yyNew)->DefMod.ImplTypes, yyt->DefMod.ImplTypes)
copyINDEX ((* yyNew)->DefMod.PosIn, yyt->DefMod.PosIn)
copyINDEX ((* yyNew)->DefMod.PosOut, yyt->DefMod.PosOut)
copytIdents ((* yyNew)->DefMod.IdsIn, yyt->DefMod.IdsIn)
copytIdents ((* yyNew)->DefMod.IdsOut, yyt->DefMod.IdsOut)
copyINDEX ((* yyNew)->DefMod.Kind, yyt->DefMod.Kind)
copytIdent ((* yyNew)->DefMod.Ident, yyt->DefMod.Ident)
copytPosition ((* yyNew)->DefMod.Pos, yyt->DefMod.Pos)
copytObject ((* yyNew)->DefMod.Object, yyt->DefMod.Object)
copytIdent ((* yyNew)->DefMod.RealName, yyt->DefMod.RealName)
copytTree ((* yyNew)->DefMod.Imports, yyt->DefMod.Imports)
copytTree ((* yyNew)->DefMod.Exports, yyt->DefMod.Exports)
copytTree ((* yyNew)->DefMod.Decls, yyt->DefMod.Decls)
yyt = yyt->DefMod.Next;
yyNew = & (* yyNew)->DefMod.Next; break;
case kImplMod: (* yyNew)->ImplMod = yyt->ImplMod;
copytObjects ((* yyNew)->ImplMod.Objects1, yyt->ImplMod.Objects1)
copytVoid ((* yyNew)->ImplMod.Objects2, yyt->ImplMod.Objects2)
copytObjects ((* yyNew)->ImplMod.Objects3, yyt->ImplMod.Objects3)
copytVoid ((* yyNew)->ImplMod.Objects4In, yyt->ImplMod.Objects4In)
copytVoid ((* yyNew)->ImplMod.Objects4Out, yyt->ImplMod.Objects4Out)
copytEnv ((* yyNew)->ImplMod.Env1, yyt->ImplMod.Env1)
copytVoid ((* yyNew)->ImplMod.Env2, yyt->ImplMod.Env2)
copytEnv ((* yyNew)->ImplMod.Env3, yyt->ImplMod.Env3)
copyINDEX ((* yyNew)->ImplMod.ConfigGroupIn, yyt->ImplMod.ConfigGroupIn)
copytIdent ((* yyNew)->ImplMod.ImplIdent, yyt->ImplMod.ImplIdent)
copytObjects ((* yyNew)->ImplMod.ImplTypes, yyt->ImplMod.ImplTypes)
copyINDEX ((* yyNew)->ImplMod.PosIn, yyt->ImplMod.PosIn)
copyINDEX ((* yyNew)->ImplMod.PosOut, yyt->ImplMod.PosOut)
copytIdents ((* yyNew)->ImplMod.IdsIn, yyt->ImplMod.IdsIn)
copytIdents ((* yyNew)->ImplMod.IdsOut, yyt->ImplMod.IdsOut)
copyINDEX ((* yyNew)->ImplMod.Kind, yyt->ImplMod.Kind)
copytIdent ((* yyNew)->ImplMod.Ident, yyt->ImplMod.Ident)
copytPosition ((* yyNew)->ImplMod.Pos, yyt->ImplMod.Pos)
copytObject ((* yyNew)->ImplMod.Object, yyt->ImplMod.Object)
copytIdent ((* yyNew)->ImplMod.RealName, yyt->ImplMod.RealName)
copytTree ((* yyNew)->ImplMod.Imports, yyt->ImplMod.Imports)
copytTree ((* yyNew)->ImplMod.Decls, yyt->ImplMod.Decls)
copytTree ((* yyNew)->ImplMod.Stmts, yyt->ImplMod.Stmts)
copytPosition ((* yyNew)->ImplMod.BeginPos, yyt->ImplMod.BeginPos)
copytObjects ((* yyNew)->ImplMod.DefObjects1, yyt->ImplMod.DefObjects1)
copytObjects ((* yyNew)->ImplMod.DefObjects3, yyt->ImplMod.DefObjects3)
copytCObjects ((* yyNew)->ImplMod.GlobalPtrs, yyt->ImplMod.GlobalPtrs)
copytStrings ((* yyNew)->ImplMod.Strings, yyt->ImplMod.Strings)
yyt = yyt->ImplMod.Next;
yyNew = & (* yyNew)->ImplMod.Next; break;
case kImports: (* yyNew)->Imports = yyt->Imports;
copytObjects ((* yyNew)->Imports.Objects1, yyt->Imports.Objects1)
copytObjects ((* yyNew)->Imports.Objects2, yyt->Imports.Objects2)
copytEnv ((* yyNew)->Imports.Env1, yyt->Imports.Env1)
copytEnv ((* yyNew)->Imports.Env2, yyt->Imports.Env2)
copytLocalIds ((* yyNew)->Imports.LocalIdsIn, yyt->Imports.LocalIdsIn)
copytLocalIds ((* yyNew)->Imports.LocalIdsOut, yyt->Imports.LocalIdsOut)
return;
case kNoImport: (* yyNew)->NoImport = yyt->NoImport;
copytObjects ((* yyNew)->NoImport.Objects1, yyt->NoImport.Objects1)
copytObjects ((* yyNew)->NoImport.Objects2, yyt->NoImport.Objects2)
copytEnv ((* yyNew)->NoImport.Env1, yyt->NoImport.Env1)
copytEnv ((* yyNew)->NoImport.Env2, yyt->NoImport.Env2)
copytLocalIds ((* yyNew)->NoImport.LocalIdsIn, yyt->NoImport.LocalIdsIn)
copytLocalIds ((* yyNew)->NoImport.LocalIdsOut, yyt->NoImport.LocalIdsOut)
return;
case kImport: (* yyNew)->Import = yyt->Import;
copytObjects ((* yyNew)->Import.Objects1, yyt->Import.Objects1)
copytObjects ((* yyNew)->Import.Objects2, yyt->Import.Objects2)
copytEnv ((* yyNew)->Import.Env1, yyt->Import.Env1)
copytEnv ((* yyNew)->Import.Env2, yyt->Import.Env2)
copytLocalIds ((* yyNew)->Import.LocalIdsIn, yyt->Import.LocalIdsIn)
copytLocalIds ((* yyNew)->Import.LocalIdsOut, yyt->Import.LocalIdsOut)
yyt = yyt->Import.Next;
yyNew = & (* yyNew)->Import.Next; break;
case kFrom: (* yyNew)->From = yyt->From;
copytObjects ((* yyNew)->From.Objects1, yyt->From.Objects1)
copytObjects ((* yyNew)->From.Objects2, yyt->From.Objects2)
copytEnv ((* yyNew)->From.Env1, yyt->From.Env1)
copytEnv ((* yyNew)->From.Env2, yyt->From.Env2)
copytLocalIds ((* yyNew)->From.LocalIdsIn, yyt->From.LocalIdsIn)
copytLocalIds ((* yyNew)->From.LocalIdsOut, yyt->From.LocalIdsOut)
copytIdent ((* yyNew)->From.Ident, yyt->From.Ident)
copytPosition ((* yyNew)->From.Pos, yyt->From.Pos)
copytTree ((* yyNew)->From.ImpIds, yyt->From.ImpIds)
copytObject ((* yyNew)->From.Object1, yyt->From.Object1)
copytObject ((* yyNew)->From.Object2, yyt->From.Object2)
yyt = yyt->From.Next;
yyNew = & (* yyNew)->From.Next; break;
case kObjects: (* yyNew)->Objects = yyt->Objects;
copytObjects ((* yyNew)->Objects.Objects1, yyt->Objects.Objects1)
copytObjects ((* yyNew)->Objects.Objects2, yyt->Objects.Objects2)
copytEnv ((* yyNew)->Objects.Env1, yyt->Objects.Env1)
copytEnv ((* yyNew)->Objects.Env2, yyt->Objects.Env2)
copytLocalIds ((* yyNew)->Objects.LocalIdsIn, yyt->Objects.LocalIdsIn)
copytLocalIds ((* yyNew)->Objects.LocalIdsOut, yyt->Objects.LocalIdsOut)
copytTree ((* yyNew)->Objects.ImpIds, yyt->Objects.ImpIds)
yyt = yyt->Objects.Next;
yyNew = & (* yyNew)->Objects.Next; break;
case kImpIds: (* yyNew)->ImpIds = yyt->ImpIds;
copytObjects ((* yyNew)->ImpIds.Objects1, yyt->ImpIds.Objects1)
copytObjects ((* yyNew)->ImpIds.Objects2, yyt->ImpIds.Objects2)
copytEnv ((* yyNew)->ImpIds.Env1, yyt->ImpIds.Env1)
copytEnv ((* yyNew)->ImpIds.Env2, yyt->ImpIds.Env2)
copytLocalIds ((* yyNew)->ImpIds.LocalIdsIn, yyt->ImpIds.LocalIdsIn)
copytLocalIds ((* yyNew)->ImpIds.LocalIdsOut, yyt->ImpIds.LocalIdsOut)
return;
case kNoImpId: (* yyNew)->NoImpId = yyt->NoImpId;
copytObjects ((* yyNew)->NoImpId.Objects1, yyt->NoImpId.Objects1)
copytObjects ((* yyNew)->NoImpId.Objects2, yyt->NoImpId.Objects2)
copytEnv ((* yyNew)->NoImpId.Env1, yyt->NoImpId.Env1)
copytEnv ((* yyNew)->NoImpId.Env2, yyt->NoImpId.Env2)
copytLocalIds ((* yyNew)->NoImpId.LocalIdsIn, yyt->NoImpId.LocalIdsIn)
copytLocalIds ((* yyNew)->NoImpId.LocalIdsOut, yyt->NoImpId.LocalIdsOut)
return;
case kImpId: (* yyNew)->ImpId = yyt->ImpId;
copytObjects ((* yyNew)->ImpId.Objects1, yyt->ImpId.Objects1)
copytObjects ((* yyNew)->ImpId.Objects2, yyt->ImpId.Objects2)
copytEnv ((* yyNew)->ImpId.Env1, yyt->ImpId.Env1)
copytEnv ((* yyNew)->ImpId.Env2, yyt->ImpId.Env2)
copytLocalIds ((* yyNew)->ImpId.LocalIdsIn, yyt->ImpId.LocalIdsIn)
copytLocalIds ((* yyNew)->ImpId.LocalIdsOut, yyt->ImpId.LocalIdsOut)
copytIdent ((* yyNew)->ImpId.Ident, yyt->ImpId.Ident)
copytPosition ((* yyNew)->ImpId.Pos, yyt->ImpId.Pos)
copytType ((* yyNew)->ImpId.Type, yyt->ImpId.Type)
copytObject ((* yyNew)->ImpId.Object1, yyt->ImpId.Object1)
copytObject ((* yyNew)->ImpId.Object2, yyt->ImpId.Object2)
copyBOOLEAN ((* yyNew)->ImpId.IsRedeclared, yyt->ImpId.IsRedeclared)
yyt = yyt->ImpId.Next;
yyNew = & (* yyNew)->ImpId.Next; break;
case kExports: (* yyNew)->Exports = yyt->Exports;
return;
case kNoExport: (* yyNew)->NoExport = yyt->NoExport;
return;
case kExport: (* yyNew)->Export = yyt->Export;
copyBOOLEAN ((* yyNew)->Export.Qualified, yyt->Export.Qualified)
yyt = yyt->Export.ExpIds;
yyNew = & (* yyNew)->Export.ExpIds; break;
case kExpIds: (* yyNew)->ExpIds = yyt->ExpIds;
return;
case kNoExpId: (* yyNew)->NoExpId = yyt->NoExpId;
return;
case kExpId: (* yyNew)->ExpId = yyt->ExpId;
copytIdent ((* yyNew)->ExpId.Ident, yyt->ExpId.Ident)
copytPosition ((* yyNew)->ExpId.Pos, yyt->ExpId.Pos)
yyt = yyt->ExpId.Next;
yyNew = & (* yyNew)->ExpId.Next; break;
case kDecls: (* yyNew)->Decls = yyt->Decls;
copytObjects ((* yyNew)->Decls.Objects1, yyt->Decls.Objects1)
copytVoid ((* yyNew)->Decls.Objects2, yyt->Decls.Objects2)
copytObjects ((* yyNew)->Decls.Objects3, yyt->Decls.Objects3)
copytObjects ((* yyNew)->Decls.Objects4In, yyt->Decls.Objects4In)
copytObjects ((* yyNew)->Decls.Objects4Out, yyt->Decls.Objects4Out)
copytEnv ((* yyNew)->Decls.Env1, yyt->Decls.Env1)
copytVoid ((* yyNew)->Decls.Env2, yyt->Decls.Env2)
copytEnv ((* yyNew)->Decls.Env3, yyt->Decls.Env3)
copytEnv ((* yyNew)->Decls.Env4, yyt->Decls.Env4)
copyINDEX ((* yyNew)->Decls.ConfigGroupIn, yyt->Decls.ConfigGroupIn)
copyINDEX ((* yyNew)->Decls.ConfigGroupOut, yyt->Decls.ConfigGroupOut)
copytObjects ((* yyNew)->Decls.DefTypes, yyt->Decls.DefTypes)
copytObjects ((* yyNew)->Decls.DefObjects, yyt->Decls.DefObjects)
copytObjects ((* yyNew)->Decls.ImplTypes, yyt->Decls.ImplTypes)
copyINDEX ((* yyNew)->Decls.PosIn, yyt->Decls.PosIn)
copyINDEX ((* yyNew)->Decls.PosOut, yyt->Decls.PosOut)
copyINDEX ((* yyNew)->Decls.Kind, yyt->Decls.Kind)
copytIdent ((* yyNew)->Decls.Module, yyt->Decls.Module)
copytIdents ((* yyNew)->Decls.IdsIn, yyt->Decls.IdsIn)
copytIdents ((* yyNew)->Decls.IdsOut, yyt->Decls.IdsOut)
copytConnects ((* yyNew)->Decls.ConnectsIn, yyt->Decls.ConnectsIn)
copytConnects ((* yyNew)->Decls.ConnectsOut, yyt->Decls.ConnectsOut)
copytLocalIds ((* yyNew)->Decls.LocalIdsIn, yyt->Decls.LocalIdsIn)
copytLocalIds ((* yyNew)->Decls.LocalIdsOut, yyt->Decls.LocalIdsOut)
copyINDEX ((* yyNew)->Decls.CntIn, yyt->Decls.CntIn)
copyINDEX ((* yyNew)->Decls.CntOut, yyt->Decls.CntOut)
copyINDEX ((* yyNew)->Decls.Level, yyt->Decls.Level)
copyBOOLEAN ((* yyNew)->Decls.GlobalPtrs, yyt->Decls.GlobalPtrs)
return;
case kNoDecl: (* yyNew)->NoDecl = yyt->NoDecl;
copytObjects ((* yyNew)->NoDecl.Objects1, yyt->NoDecl.Objects1)
copytVoid ((* yyNew)->NoDecl.Objects2, yyt->NoDecl.Objects2)
copytObjects ((* yyNew)->NoDecl.Objects3, yyt->NoDecl.Objects3)
copytObjects ((* yyNew)->NoDecl.Objects4In, yyt->NoDecl.Objects4In)
copytObjects ((* yyNew)->NoDecl.Objects4Out, yyt->NoDecl.Objects4Out)
copytEnv ((* yyNew)->NoDecl.Env1, yyt->NoDecl.Env1)
copytVoid ((* yyNew)->NoDecl.Env2, yyt->NoDecl.Env2)
copytEnv ((* yyNew)->NoDecl.Env3, yyt->NoDecl.Env3)
copytEnv ((* yyNew)->NoDecl.Env4, yyt->NoDecl.Env4)
copyINDEX ((* yyNew)->NoDecl.ConfigGroupIn, yyt->NoDecl.ConfigGroupIn)
copyINDEX ((* yyNew)->NoDecl.ConfigGroupOut, yyt->NoDecl.ConfigGroupOut)
copytObjects ((* yyNew)->NoDecl.DefTypes, yyt->NoDecl.DefTypes)
copytObjects ((* yyNew)->NoDecl.DefObjects, yyt->NoDecl.DefObjects)
copytObjects ((* yyNew)->NoDecl.ImplTypes, yyt->NoDecl.ImplTypes)
copyINDEX ((* yyNew)->NoDecl.PosIn, yyt->NoDecl.PosIn)
copyINDEX ((* yyNew)->NoDecl.PosOut, yyt->NoDecl.PosOut)
copyINDEX ((* yyNew)->NoDecl.Kind, yyt->NoDecl.Kind)
copytIdent ((* yyNew)->NoDecl.Module, yyt->NoDecl.Module)
copytIdents ((* yyNew)->NoDecl.IdsIn, yyt->NoDecl.IdsIn)
copytIdents ((* yyNew)->NoDecl.IdsOut, yyt->NoDecl.IdsOut)
copytConnects ((* yyNew)->NoDecl.ConnectsIn, yyt->NoDecl.ConnectsIn)
copytConnects ((* yyNew)->NoDecl.ConnectsOut, yyt->NoDecl.ConnectsOut)
copytLocalIds ((* yyNew)->NoDecl.LocalIdsIn, yyt->NoDecl.LocalIdsIn)
copytLocalIds ((* yyNew)->NoDecl.LocalIdsOut, yyt->NoDecl.LocalIdsOut)
copyINDEX ((* yyNew)->NoDecl.CntIn, yyt->NoDecl.CntIn)
copyINDEX ((* yyNew)->NoDecl.CntOut, yyt->NoDecl.CntOut)
copyINDEX ((* yyNew)->NoDecl.Level, yyt->NoDecl.Level)
copyBOOLEAN ((* yyNew)->NoDecl.GlobalPtrs, yyt->NoDecl.GlobalPtrs)
return;
case kDecl: (* yyNew)->Decl = yyt->Decl;
copytObjects ((* yyNew)->Decl.Objects1, yyt->Decl.Objects1)
copytVoid ((* yyNew)->Decl.Objects2, yyt->Decl.Objects2)
copytObjects ((* yyNew)->Decl.Objects3, yyt->Decl.Objects3)
copytObjects ((* yyNew)->Decl.Objects4In, yyt->Decl.Objects4In)
copytObjects ((* yyNew)->Decl.Objects4Out, yyt->Decl.Objects4Out)
copytEnv ((* yyNew)->Decl.Env1, yyt->Decl.Env1)
copytVoid ((* yyNew)->Decl.Env2, yyt->Decl.Env2)
copytEnv ((* yyNew)->Decl.Env3, yyt->Decl.Env3)
copytEnv ((* yyNew)->Decl.Env4, yyt->Decl.Env4)
copyINDEX ((* yyNew)->Decl.ConfigGroupIn, yyt->Decl.ConfigGroupIn)
copyINDEX ((* yyNew)->Decl.ConfigGroupOut, yyt->Decl.ConfigGroupOut)
copytObjects ((* yyNew)->Decl.DefTypes, yyt->Decl.DefTypes)
copytObjects ((* yyNew)->Decl.DefObjects, yyt->Decl.DefObjects)
copytObjects ((* yyNew)->Decl.ImplTypes, yyt->Decl.ImplTypes)
copyINDEX ((* yyNew)->Decl.PosIn, yyt->Decl.PosIn)
copyINDEX ((* yyNew)->Decl.PosOut, yyt->Decl.PosOut)
copyINDEX ((* yyNew)->Decl.Kind, yyt->Decl.Kind)
copytIdent ((* yyNew)->Decl.Module, yyt->Decl.Module)
copytIdents ((* yyNew)->Decl.IdsIn, yyt->Decl.IdsIn)
copytIdents ((* yyNew)->Decl.IdsOut, yyt->Decl.IdsOut)
copytConnects ((* yyNew)->Decl.ConnectsIn, yyt->Decl.ConnectsIn)
copytConnects ((* yyNew)->Decl.ConnectsOut, yyt->Decl.ConnectsOut)
copytLocalIds ((* yyNew)->Decl.LocalIdsIn, yyt->Decl.LocalIdsIn)
copytLocalIds ((* yyNew)->Decl.LocalIdsOut, yyt->Decl.LocalIdsOut)
copyINDEX ((* yyNew)->Decl.CntIn, yyt->Decl.CntIn)
copyINDEX ((* yyNew)->Decl.CntOut, yyt->Decl.CntOut)
copyINDEX ((* yyNew)->Decl.Level, yyt->Decl.Level)
copyBOOLEAN ((* yyNew)->Decl.GlobalPtrs, yyt->Decl.GlobalPtrs)
yyt = yyt->Decl.Next;
yyNew = & (* yyNew)->Decl.Next; break;
case kVar: (* yyNew)->Var = yyt->Var;
copytObjects ((* yyNew)->Var.Objects1, yyt->Var.Objects1)
copytVoid ((* yyNew)->Var.Objects2, yyt->Var.Objects2)
copytObjects ((* yyNew)->Var.Objects3, yyt->Var.Objects3)
copytObjects ((* yyNew)->Var.Objects4In, yyt->Var.Objects4In)
copytObjects ((* yyNew)->Var.Objects4Out, yyt->Var.Objects4Out)
copytEnv ((* yyNew)->Var.Env1, yyt->Var.Env1)
copytVoid ((* yyNew)->Var.Env2, yyt->Var.Env2)
copytEnv ((* yyNew)->Var.Env3, yyt->Var.Env3)
copytEnv ((* yyNew)->Var.Env4, yyt->Var.Env4)
copyINDEX ((* yyNew)->Var.ConfigGroupIn, yyt->Var.ConfigGroupIn)
copyINDEX ((* yyNew)->Var.ConfigGroupOut, yyt->Var.ConfigGroupOut)
copytObjects ((* yyNew)->Var.DefTypes, yyt->Var.DefTypes)
copytObjects ((* yyNew)->Var.DefObjects, yyt->Var.DefObjects)
copytObjects ((* yyNew)->Var.ImplTypes, yyt->Var.ImplTypes)
copyINDEX ((* yyNew)->Var.PosIn, yyt->Var.PosIn)
copyINDEX ((* yyNew)->Var.PosOut, yyt->Var.PosOut)
copyINDEX ((* yyNew)->Var.Kind, yyt->Var.Kind)
copytIdent ((* yyNew)->Var.Module, yyt->Var.Module)
copytIdents ((* yyNew)->Var.IdsIn, yyt->Var.IdsIn)
copytIdents ((* yyNew)->Var.IdsOut, yyt->Var.IdsOut)
copytConnects ((* yyNew)->Var.ConnectsIn, yyt->Var.ConnectsIn)
copytConnects ((* yyNew)->Var.ConnectsOut, yyt->Var.ConnectsOut)
copytLocalIds ((* yyNew)->Var.LocalIdsIn, yyt->Var.LocalIdsIn)
copytLocalIds ((* yyNew)->Var.LocalIdsOut, yyt->Var.LocalIdsOut)
copyINDEX ((* yyNew)->Var.CntIn, yyt->Var.CntIn)
copyINDEX ((* yyNew)->Var.CntOut, yyt->Var.CntOut)
copyINDEX ((* yyNew)->Var.Level, yyt->Var.Level)
copyBOOLEAN ((* yyNew)->Var.GlobalPtrs, yyt->Var.GlobalPtrs)
copytTree ((* yyNew)->Var.VarIds, yyt->Var.VarIds)
copytTree ((* yyNew)->Var.Type, yyt->Var.Type)
copyBOOLEAN ((* yyNew)->Var.IsGlobal, yyt->Var.IsGlobal)
yyt = yyt->Var.Next;
yyNew = & (* yyNew)->Var.Next; break;
case kObject: (* yyNew)->Object = yyt->Object;
copytObjects ((* yyNew)->Object.Objects1, yyt->Object.Objects1)
copytVoid ((* yyNew)->Object.Objects2, yyt->Object.Objects2)
copytObjects ((* yyNew)->Object.Objects3, yyt->Object.Objects3)
copytObjects ((* yyNew)->Object.Objects4In, yyt->Object.Objects4In)
copytObjects ((* yyNew)->Object.Objects4Out, yyt->Object.Objects4Out)
copytEnv ((* yyNew)->Object.Env1, yyt->Object.Env1)
copytVoid ((* yyNew)->Object.Env2, yyt->Object.Env2)
copytEnv ((* yyNew)->Object.Env3, yyt->Object.Env3)
copytEnv ((* yyNew)->Object.Env4, yyt->Object.Env4)
copyINDEX ((* yyNew)->Object.ConfigGroupIn, yyt->Object.ConfigGroupIn)
copyINDEX ((* yyNew)->Object.ConfigGroupOut, yyt->Object.ConfigGroupOut)
copytObjects ((* yyNew)->Object.DefTypes, yyt->Object.DefTypes)
copytObjects ((* yyNew)->Object.DefObjects, yyt->Object.DefObjects)
copytObjects ((* yyNew)->Object.ImplTypes, yyt->Object.ImplTypes)
copyINDEX ((* yyNew)->Object.PosIn, yyt->Object.PosIn)
copyINDEX ((* yyNew)->Object.PosOut, yyt->Object.PosOut)
copyINDEX ((* yyNew)->Object.Kind, yyt->Object.Kind)
copytIdent ((* yyNew)->Object.Module, yyt->Object.Module)
copytIdents ((* yyNew)->Object.IdsIn, yyt->Object.IdsIn)
copytIdents ((* yyNew)->Object.IdsOut, yyt->Object.IdsOut)
copytConnects ((* yyNew)->Object.ConnectsIn, yyt->Object.ConnectsIn)
copytConnects ((* yyNew)->Object.ConnectsOut, yyt->Object.ConnectsOut)
copytLocalIds ((* yyNew)->Object.LocalIdsIn, yyt->Object.LocalIdsIn)
copytLocalIds ((* yyNew)->Object.LocalIdsOut, yyt->Object.LocalIdsOut)
copyINDEX ((* yyNew)->Object.CntIn, yyt->Object.CntIn)
copyINDEX ((* yyNew)->Object.CntOut, yyt->Object.CntOut)
copyINDEX ((* yyNew)->Object.Level, yyt->Object.Level)
copyBOOLEAN ((* yyNew)->Object.GlobalPtrs, yyt->Object.GlobalPtrs)
copytIdent ((* yyNew)->Object.Ident, yyt->Object.Ident)
copytPosition ((* yyNew)->Object.Pos, yyt->Object.Pos)
copytIdent ((* yyNew)->Object.CIdent, yyt->Object.CIdent)
copyBOOLEAN ((* yyNew)->Object.IsRedeclared, yyt->Object.IsRedeclared)
yyt = yyt->Object.Next;
yyNew = & (* yyNew)->Object.Next; break;
case kConnectFrom: (* yyNew)->ConnectFrom = yyt->ConnectFrom;
copytObjects ((* yyNew)->ConnectFrom.Objects1, yyt->ConnectFrom.Objects1)
copytVoid ((* yyNew)->ConnectFrom.Objects2, yyt->ConnectFrom.Objects2)
copytObjects ((* yyNew)->ConnectFrom.Objects3, yyt->ConnectFrom.Objects3)
copytObjects ((* yyNew)->ConnectFrom.Objects4In, yyt->ConnectFrom.Objects4In)
copytObjects ((* yyNew)->ConnectFrom.Objects4Out, yyt->ConnectFrom.Objects4Out)
copytEnv ((* yyNew)->ConnectFrom.Env1, yyt->ConnectFrom.Env1)
copytVoid ((* yyNew)->ConnectFrom.Env2, yyt->ConnectFrom.Env2)
copytEnv ((* yyNew)->ConnectFrom.Env3, yyt->ConnectFrom.Env3)
copytEnv ((* yyNew)->ConnectFrom.Env4, yyt->ConnectFrom.Env4)
copyINDEX ((* yyNew)->ConnectFrom.ConfigGroupIn, yyt->ConnectFrom.ConfigGroupIn)
copyINDEX ((* yyNew)->ConnectFrom.ConfigGroupOut, yyt->ConnectFrom.ConfigGroupOut)
copytObjects ((* yyNew)->ConnectFrom.DefTypes, yyt->ConnectFrom.DefTypes)
copytObjects ((* yyNew)->ConnectFrom.DefObjects, yyt->ConnectFrom.DefObjects)
copytObjects ((* yyNew)->ConnectFrom.ImplTypes, yyt->ConnectFrom.ImplTypes)
copyINDEX ((* yyNew)->ConnectFrom.PosIn, yyt->ConnectFrom.PosIn)
copyINDEX ((* yyNew)->ConnectFrom.PosOut, yyt->ConnectFrom.PosOut)
copyINDEX ((* yyNew)->ConnectFrom.Kind, yyt->ConnectFrom.Kind)
copytIdent ((* yyNew)->ConnectFrom.Module, yyt->ConnectFrom.Module)
copytIdents ((* yyNew)->ConnectFrom.IdsIn, yyt->ConnectFrom.IdsIn)
copytIdents ((* yyNew)->ConnectFrom.IdsOut, yyt->ConnectFrom.IdsOut)
copytConnects ((* yyNew)->ConnectFrom.ConnectsIn, yyt->ConnectFrom.ConnectsIn)
copytConnects ((* yyNew)->ConnectFrom.ConnectsOut, yyt->ConnectFrom.ConnectsOut)
copytLocalIds ((* yyNew)->ConnectFrom.LocalIdsIn, yyt->ConnectFrom.LocalIdsIn)
copytLocalIds ((* yyNew)->ConnectFrom.LocalIdsOut, yyt->ConnectFrom.LocalIdsOut)
copyINDEX ((* yyNew)->ConnectFrom.CntIn, yyt->ConnectFrom.CntIn)
copyINDEX ((* yyNew)->ConnectFrom.CntOut, yyt->ConnectFrom.CntOut)
copyINDEX ((* yyNew)->ConnectFrom.Level, yyt->ConnectFrom.Level)
copyBOOLEAN ((* yyNew)->ConnectFrom.GlobalPtrs, yyt->ConnectFrom.GlobalPtrs)
copytIdent ((* yyNew)->ConnectFrom.Ident, yyt->ConnectFrom.Ident)
copytPosition ((* yyNew)->ConnectFrom.Pos, yyt->ConnectFrom.Pos)
copytIdent ((* yyNew)->ConnectFrom.CIdent, yyt->ConnectFrom.CIdent)
copyBOOLEAN ((* yyNew)->ConnectFrom.IsRedeclared, yyt->ConnectFrom.IsRedeclared)
copytTree ((* yyNew)->ConnectFrom.From, yyt->ConnectFrom.From)
copytTree ((* yyNew)->ConnectFrom.To, yyt->ConnectFrom.To)
copytTree ((* yyNew)->ConnectFrom.ConnectDecls, yyt->ConnectFrom.ConnectDecls)
copytObject ((* yyNew)->ConnectFrom.Object, yyt->ConnectFrom.Object)
yyt = yyt->ConnectFrom.Next;
yyNew = & (* yyNew)->ConnectFrom.Next; break;
case kConnectDecls: (* yyNew)->ConnectDecls = yyt->ConnectDecls;
copytObjects ((* yyNew)->ConnectDecls.Objects1, yyt->ConnectDecls.Objects1)
copytVoid ((* yyNew)->ConnectDecls.Objects2, yyt->ConnectDecls.Objects2)
copytObjects ((* yyNew)->ConnectDecls.Objects3, yyt->ConnectDecls.Objects3)
copytObjects ((* yyNew)->ConnectDecls.Objects4In, yyt->ConnectDecls.Objects4In)
copytObjects ((* yyNew)->ConnectDecls.Objects4Out, yyt->ConnectDecls.Objects4Out)
copytEnv ((* yyNew)->ConnectDecls.Env1, yyt->ConnectDecls.Env1)
copytVoid ((* yyNew)->ConnectDecls.Env2, yyt->ConnectDecls.Env2)
copytEnv ((* yyNew)->ConnectDecls.Env3, yyt->ConnectDecls.Env3)
copytEnv ((* yyNew)->ConnectDecls.Env4, yyt->ConnectDecls.Env4)
copyINDEX ((* yyNew)->ConnectDecls.ConfigGroupIn, yyt->ConnectDecls.ConfigGroupIn)
copyINDEX ((* yyNew)->ConnectDecls.ConfigGroupOut, yyt->ConnectDecls.ConfigGroupOut)
copytObjects ((* yyNew)->ConnectDecls.DefTypes, yyt->ConnectDecls.DefTypes)
copytObjects ((* yyNew)->ConnectDecls.DefObjects, yyt->ConnectDecls.DefObjects)
copytObjects ((* yyNew)->ConnectDecls.ImplTypes, yyt->ConnectDecls.ImplTypes)
copyINDEX ((* yyNew)->ConnectDecls.PosIn, yyt->ConnectDecls.PosIn)
copyINDEX ((* yyNew)->ConnectDecls.PosOut, yyt->ConnectDecls.PosOut)
copyINDEX ((* yyNew)->ConnectDecls.Kind, yyt->ConnectDecls.Kind)
copytIdent ((* yyNew)->ConnectDecls.Module, yyt->ConnectDecls.Module)
copytIdents ((* yyNew)->ConnectDecls.IdsIn, yyt->ConnectDecls.IdsIn)
copytIdents ((* yyNew)->ConnectDecls.IdsOut, yyt->ConnectDecls.IdsOut)
copytConnects ((* yyNew)->ConnectDecls.ConnectsIn, yyt->ConnectDecls.ConnectsIn)
copytConnects ((* yyNew)->ConnectDecls.ConnectsOut, yyt->ConnectDecls.ConnectsOut)
copytLocalIds ((* yyNew)->ConnectDecls.LocalIdsIn, yyt->ConnectDecls.LocalIdsIn)
copytLocalIds ((* yyNew)->ConnectDecls.LocalIdsOut, yyt->ConnectDecls.LocalIdsOut)
copyINDEX ((* yyNew)->ConnectDecls.CntIn, yyt->ConnectDecls.CntIn)
copyINDEX ((* yyNew)->ConnectDecls.CntOut, yyt->ConnectDecls.CntOut)
copyINDEX ((* yyNew)->ConnectDecls.Level, yyt->ConnectDecls.Level)
copyBOOLEAN ((* yyNew)->ConnectDecls.GlobalPtrs, yyt->ConnectDecls.GlobalPtrs)
copytIdent ((* yyNew)->ConnectDecls.Ident, yyt->ConnectDecls.Ident)
copytPosition ((* yyNew)->ConnectDecls.Pos, yyt->ConnectDecls.Pos)
copytIdent ((* yyNew)->ConnectDecls.CIdent, yyt->ConnectDecls.CIdent)
copyBOOLEAN ((* yyNew)->ConnectDecls.IsRedeclared, yyt->ConnectDecls.IsRedeclared)
copytTree ((* yyNew)->ConnectDecls.Index, yyt->ConnectDecls.Index)
copyBOOLEAN ((* yyNew)->ConnectDecls.BiDirectional, yyt->ConnectDecls.BiDirectional)
copytTree ((* yyNew)->ConnectDecls.Config, yyt->ConnectDecls.Config)
copytTree ((* yyNew)->ConnectDecls.Actuals, yyt->ConnectDecls.Actuals)
copytTree ((* yyNew)->ConnectDecls.DirIn, yyt->ConnectDecls.DirIn)
copytObject ((* yyNew)->ConnectDecls.Object, yyt->ConnectDecls.Object)
copytObjects ((* yyNew)->ConnectDecls.IndexObjects, yyt->ConnectDecls.IndexObjects)
copytObject ((* yyNew)->ConnectDecls.LeftConfigObj, yyt->ConnectDecls.LeftConfigObj)
copytObject ((* yyNew)->ConnectDecls.RightConfigObj, yyt->ConnectDecls.RightConfigObj)
copytValue ((* yyNew)->ConnectDecls.IndexVal, yyt->ConnectDecls.IndexVal)
copyBOOLEAN ((* yyNew)->ConnectDecls.FirstDeclaration, yyt->ConnectDecls.FirstDeclaration)
copytIdent ((* yyNew)->ConnectDecls.PrevCIdent, yyt->ConnectDecls.PrevCIdent)
yyt = yyt->ConnectDecls.Next;
yyNew = & (* yyNew)->ConnectDecls.Next; break;
case kConfig: (* yyNew)->Config = yyt->Config;
copytObjects ((* yyNew)->Config.Objects1, yyt->Config.Objects1)
copytVoid ((* yyNew)->Config.Objects2, yyt->Config.Objects2)
copytObjects ((* yyNew)->Config.Objects3, yyt->Config.Objects3)
copytObjects ((* yyNew)->Config.Objects4In, yyt->Config.Objects4In)
copytObjects ((* yyNew)->Config.Objects4Out, yyt->Config.Objects4Out)
copytEnv ((* yyNew)->Config.Env1, yyt->Config.Env1)
copytVoid ((* yyNew)->Config.Env2, yyt->Config.Env2)
copytEnv ((* yyNew)->Config.Env3, yyt->Config.Env3)
copytEnv ((* yyNew)->Config.Env4, yyt->Config.Env4)
copyINDEX ((* yyNew)->Config.ConfigGroupIn, yyt->Config.ConfigGroupIn)
copyINDEX ((* yyNew)->Config.ConfigGroupOut, yyt->Config.ConfigGroupOut)
copytObjects ((* yyNew)->Config.DefTypes, yyt->Config.DefTypes)
copytObjects ((* yyNew)->Config.DefObjects, yyt->Config.DefObjects)
copytObjects ((* yyNew)->Config.ImplTypes, yyt->Config.ImplTypes)
copyINDEX ((* yyNew)->Config.PosIn, yyt->Config.PosIn)
copyINDEX ((* yyNew)->Config.PosOut, yyt->Config.PosOut)
copyINDEX ((* yyNew)->Config.Kind, yyt->Config.Kind)
copytIdent ((* yyNew)->Config.Module, yyt->Config.Module)
copytIdents ((* yyNew)->Config.IdsIn, yyt->Config.IdsIn)
copytIdents ((* yyNew)->Config.IdsOut, yyt->Config.IdsOut)
copytConnects ((* yyNew)->Config.ConnectsIn, yyt->Config.ConnectsIn)
copytConnects ((* yyNew)->Config.ConnectsOut, yyt->Config.ConnectsOut)
copytLocalIds ((* yyNew)->Config.LocalIdsIn, yyt->Config.LocalIdsIn)
copytLocalIds ((* yyNew)->Config.LocalIdsOut, yyt->Config.LocalIdsOut)
copyINDEX ((* yyNew)->Config.CntIn, yyt->Config.CntIn)
copyINDEX ((* yyNew)->Config.CntOut, yyt->Config.CntOut)
copyINDEX ((* yyNew)->Config.Level, yyt->Config.Level)
copyBOOLEAN ((* yyNew)->Config.GlobalPtrs, yyt->Config.GlobalPtrs)
copytIdent ((* yyNew)->Config.Ident, yyt->Config.Ident)
copytPosition ((* yyNew)->Config.Pos, yyt->Config.Pos)
copytIdent ((* yyNew)->Config.CIdent, yyt->Config.CIdent)
copyBOOLEAN ((* yyNew)->Config.IsRedeclared, yyt->Config.IsRedeclared)
copytTree ((* yyNew)->Config.Actuals, yyt->Config.Actuals)
copyBOOLEAN ((* yyNew)->Config.Respecified, yyt->Config.Respecified)
copytTree ((* yyNew)->Config.Qualid, yyt->Config.Qualid)
copytObject ((* yyNew)->Config.Object, yyt->Config.Object)
copytType ((* yyNew)->Config.Type, yyt->Config.Type)
copyINDEX ((* yyNew)->Config.NewConfigGroup, yyt->Config.NewConfigGroup)
copytObject ((* yyNew)->Config.View, yyt->Config.View)
copyBOOLEAN ((* yyNew)->Config.HasVariableSize, yyt->Config.HasVariableSize)
yyt = yyt->Config.Next;
yyNew = & (* yyNew)->Config.Next; break;
case kConst: (* yyNew)->Const = yyt->Const;
copytObjects ((* yyNew)->Const.Objects1, yyt->Const.Objects1)
copytVoid ((* yyNew)->Const.Objects2, yyt->Const.Objects2)
copytObjects ((* yyNew)->Const.Objects3, yyt->Const.Objects3)
copytObjects ((* yyNew)->Const.Objects4In, yyt->Const.Objects4In)
copytObjects ((* yyNew)->Const.Objects4Out, yyt->Const.Objects4Out)
copytEnv ((* yyNew)->Const.Env1, yyt->Const.Env1)
copytVoid ((* yyNew)->Const.Env2, yyt->Const.Env2)
copytEnv ((* yyNew)->Const.Env3, yyt->Const.Env3)
copytEnv ((* yyNew)->Const.Env4, yyt->Const.Env4)
copyINDEX ((* yyNew)->Const.ConfigGroupIn, yyt->Const.ConfigGroupIn)
copyINDEX ((* yyNew)->Const.ConfigGroupOut, yyt->Const.ConfigGroupOut)
copytObjects ((* yyNew)->Const.DefTypes, yyt->Const.DefTypes)
copytObjects ((* yyNew)->Const.DefObjects, yyt->Const.DefObjects)
copytObjects ((* yyNew)->Const.ImplTypes, yyt->Const.ImplTypes)
copyINDEX ((* yyNew)->Const.PosIn, yyt->Const.PosIn)
copyINDEX ((* yyNew)->Const.PosOut, yyt->Const.PosOut)
copyINDEX ((* yyNew)->Const.Kind, yyt->Const.Kind)
copytIdent ((* yyNew)->Const.Module, yyt->Const.Module)
copytIdents ((* yyNew)->Const.IdsIn, yyt->Const.IdsIn)
copytIdents ((* yyNew)->Const.IdsOut, yyt->Const.IdsOut)
copytConnects ((* yyNew)->Const.ConnectsIn, yyt->Const.ConnectsIn)
copytConnects ((* yyNew)->Const.ConnectsOut, yyt->Const.ConnectsOut)
copytLocalIds ((* yyNew)->Const.LocalIdsIn, yyt->Const.LocalIdsIn)
copytLocalIds ((* yyNew)->Const.LocalIdsOut, yyt->Const.LocalIdsOut)
copyINDEX ((* yyNew)->Const.CntIn, yyt->Const.CntIn)
copyINDEX ((* yyNew)->Const.CntOut, yyt->Const.CntOut)
copyINDEX ((* yyNew)->Const.Level, yyt->Const.Level)
copyBOOLEAN ((* yyNew)->Const.GlobalPtrs, yyt->Const.GlobalPtrs)
copytIdent ((* yyNew)->Const.Ident, yyt->Const.Ident)
copytPosition ((* yyNew)->Const.Pos, yyt->Const.Pos)
copytIdent ((* yyNew)->Const.CIdent, yyt->Const.CIdent)
copyBOOLEAN ((* yyNew)->Const.IsRedeclared, yyt->Const.IsRedeclared)
copytTree ((* yyNew)->Const.Expr, yyt->Const.Expr)
copytObject ((* yyNew)->Const.Object, yyt->Const.Object)
yyt = yyt->Const.Next;
yyNew = & (* yyNew)->Const.Next; break;
case kTypeDecl: (* yyNew)->TypeDecl = yyt->TypeDecl;
copytObjects ((* yyNew)->TypeDecl.Objects1, yyt->TypeDecl.Objects1)
copytVoid ((* yyNew)->TypeDecl.Objects2, yyt->TypeDecl.Objects2)
copytObjects ((* yyNew)->TypeDecl.Objects3, yyt->TypeDecl.Objects3)
copytObjects ((* yyNew)->TypeDecl.Objects4In, yyt->TypeDecl.Objects4In)
copytObjects ((* yyNew)->TypeDecl.Objects4Out, yyt->TypeDecl.Objects4Out)
copytEnv ((* yyNew)->TypeDecl.Env1, yyt->TypeDecl.Env1)
copytVoid ((* yyNew)->TypeDecl.Env2, yyt->TypeDecl.Env2)
copytEnv ((* yyNew)->TypeDecl.Env3, yyt->TypeDecl.Env3)
copytEnv ((* yyNew)->TypeDecl.Env4, yyt->TypeDecl.Env4)
copyINDEX ((* yyNew)->TypeDecl.ConfigGroupIn, yyt->TypeDecl.ConfigGroupIn)
copyINDEX ((* yyNew)->TypeDecl.ConfigGroupOut, yyt->TypeDecl.ConfigGroupOut)
copytObjects ((* yyNew)->TypeDecl.DefTypes, yyt->TypeDecl.DefTypes)
copytObjects ((* yyNew)->TypeDecl.DefObjects, yyt->TypeDecl.DefObjects)
copytObjects ((* yyNew)->TypeDecl.ImplTypes, yyt->TypeDecl.ImplTypes)
copyINDEX ((* yyNew)->TypeDecl.PosIn, yyt->TypeDecl.PosIn)
copyINDEX ((* yyNew)->TypeDecl.PosOut, yyt->TypeDecl.PosOut)
copyINDEX ((* yyNew)->TypeDecl.Kind, yyt->TypeDecl.Kind)
copytIdent ((* yyNew)->TypeDecl.Module, yyt->TypeDecl.Module)
copytIdents ((* yyNew)->TypeDecl.IdsIn, yyt->TypeDecl.IdsIn)
copytIdents ((* yyNew)->TypeDecl.IdsOut, yyt->TypeDecl.IdsOut)
copytConnects ((* yyNew)->TypeDecl.ConnectsIn, yyt->TypeDecl.ConnectsIn)
copytConnects ((* yyNew)->TypeDecl.ConnectsOut, yyt->TypeDecl.ConnectsOut)
copytLocalIds ((* yyNew)->TypeDecl.LocalIdsIn, yyt->TypeDecl.LocalIdsIn)
copytLocalIds ((* yyNew)->TypeDecl.LocalIdsOut, yyt->TypeDecl.LocalIdsOut)
copyINDEX ((* yyNew)->TypeDecl.CntIn, yyt->TypeDecl.CntIn)
copyINDEX ((* yyNew)->TypeDecl.CntOut, yyt->TypeDecl.CntOut)
copyINDEX ((* yyNew)->TypeDecl.Level, yyt->TypeDecl.Level)
copyBOOLEAN ((* yyNew)->TypeDecl.GlobalPtrs, yyt->TypeDecl.GlobalPtrs)
copytIdent ((* yyNew)->TypeDecl.Ident, yyt->TypeDecl.Ident)
copytPosition ((* yyNew)->TypeDecl.Pos, yyt->TypeDecl.Pos)
copytIdent ((* yyNew)->TypeDecl.CIdent, yyt->TypeDecl.CIdent)
copyBOOLEAN ((* yyNew)->TypeDecl.IsRedeclared, yyt->TypeDecl.IsRedeclared)
copytTree ((* yyNew)->TypeDecl.Type, yyt->TypeDecl.Type)
copytObject ((* yyNew)->TypeDecl.Object, yyt->TypeDecl.Object)
copytType ((* yyNew)->TypeDecl.Type1, yyt->TypeDecl.Type1)
copytType ((* yyNew)->TypeDecl.Type2, yyt->TypeDecl.Type2)
yyt = yyt->TypeDecl.Next;
yyNew = & (* yyNew)->TypeDecl.Next; break;
case kProc: (* yyNew)->Proc = yyt->Proc;
copytObjects ((* yyNew)->Proc.Objects1, yyt->Proc.Objects1)
copytVoid ((* yyNew)->Proc.Objects2, yyt->Proc.Objects2)
copytObjects ((* yyNew)->Proc.Objects3, yyt->Proc.Objects3)
copytObjects ((* yyNew)->Proc.Objects4In, yyt->Proc.Objects4In)
copytObjects ((* yyNew)->Proc.Objects4Out, yyt->Proc.Objects4Out)
copytEnv ((* yyNew)->Proc.Env1, yyt->Proc.Env1)
copytVoid ((* yyNew)->Proc.Env2, yyt->Proc.Env2)
copytEnv ((* yyNew)->Proc.Env3, yyt->Proc.Env3)
copytEnv ((* yyNew)->Proc.Env4, yyt->Proc.Env4)
copyINDEX ((* yyNew)->Proc.ConfigGroupIn, yyt->Proc.ConfigGroupIn)
copyINDEX ((* yyNew)->Proc.ConfigGroupOut, yyt->Proc.ConfigGroupOut)
copytObjects ((* yyNew)->Proc.DefTypes, yyt->Proc.DefTypes)
copytObjects ((* yyNew)->Proc.DefObjects, yyt->Proc.DefObjects)
copytObjects ((* yyNew)->Proc.ImplTypes, yyt->Proc.ImplTypes)
copyINDEX ((* yyNew)->Proc.PosIn, yyt->Proc.PosIn)
copyINDEX ((* yyNew)->Proc.PosOut, yyt->Proc.PosOut)
copyINDEX ((* yyNew)->Proc.Kind, yyt->Proc.Kind)
copytIdent ((* yyNew)->Proc.Module, yyt->Proc.Module)
copytIdents ((* yyNew)->Proc.IdsIn, yyt->Proc.IdsIn)
copytIdents ((* yyNew)->Proc.IdsOut, yyt->Proc.IdsOut)
copytConnects ((* yyNew)->Proc.ConnectsIn, yyt->Proc.ConnectsIn)
copytConnects ((* yyNew)->Proc.ConnectsOut, yyt->Proc.ConnectsOut)
copytLocalIds ((* yyNew)->Proc.LocalIdsIn, yyt->Proc.LocalIdsIn)
copytLocalIds ((* yyNew)->Proc.LocalIdsOut, yyt->Proc.LocalIdsOut)
copyINDEX ((* yyNew)->Proc.CntIn, yyt->Proc.CntIn)
copyINDEX ((* yyNew)->Proc.CntOut, yyt->Proc.CntOut)
copyINDEX ((* yyNew)->Proc.Level, yyt->Proc.Level)
copyBOOLEAN ((* yyNew)->Proc.GlobalPtrs, yyt->Proc.GlobalPtrs)
copytIdent ((* yyNew)->Proc.Ident, yyt->Proc.Ident)
copytPosition ((* yyNew)->Proc.Pos, yyt->Proc.Pos)
copytIdent ((* yyNew)->Proc.CIdent, yyt->Proc.CIdent)
copyBOOLEAN ((* yyNew)->Proc.IsRedeclared, yyt->Proc.IsRedeclared)
copytTree ((* yyNew)->Proc.Formals, yyt->Proc.Formals)
copytTree ((* yyNew)->Proc.ResultType, yyt->Proc.ResultType)
copytTree ((* yyNew)->Proc.Decls, yyt->Proc.Decls)
copytTree ((* yyNew)->Proc.Stmts, yyt->Proc.Stmts)
copytPosition ((* yyNew)->Proc.BeginPos, yyt->Proc.BeginPos)
copytObject ((* yyNew)->Proc.Object, yyt->Proc.Object)
copytType ((* yyNew)->Proc.Type, yyt->Proc.Type)
copyBOOLEAN ((* yyNew)->Proc.HasOpenVector, yyt->Proc.HasOpenVector)
copytCObjects ((* yyNew)->Proc.ValueOpens, yyt->Proc.ValueOpens)
copytCObjects ((* yyNew)->Proc.VAROpens, yyt->Proc.VAROpens)
copytCObjects ((* yyNew)->Proc.LocalPtrs, yyt->Proc.LocalPtrs)
copytStrings ((* yyNew)->Proc.Strings, yyt->Proc.Strings)
yyt = yyt->Proc.Next;
yyNew = & (* yyNew)->Proc.Next; break;
case kProcHead: (* yyNew)->ProcHead = yyt->ProcHead;
copytObjects ((* yyNew)->ProcHead.Objects1, yyt->ProcHead.Objects1)
copytVoid ((* yyNew)->ProcHead.Objects2, yyt->ProcHead.Objects2)
copytObjects ((* yyNew)->ProcHead.Objects3, yyt->ProcHead.Objects3)
copytObjects ((* yyNew)->ProcHead.Objects4In, yyt->ProcHead.Objects4In)
copytObjects ((* yyNew)->ProcHead.Objects4Out, yyt->ProcHead.Objects4Out)
copytEnv ((* yyNew)->ProcHead.Env1, yyt->ProcHead.Env1)
copytVoid ((* yyNew)->ProcHead.Env2, yyt->ProcHead.Env2)
copytEnv ((* yyNew)->ProcHead.Env3, yyt->ProcHead.Env3)
copytEnv ((* yyNew)->ProcHead.Env4, yyt->ProcHead.Env4)
copyINDEX ((* yyNew)->ProcHead.ConfigGroupIn, yyt->ProcHead.ConfigGroupIn)
copyINDEX ((* yyNew)->ProcHead.ConfigGroupOut, yyt->ProcHead.ConfigGroupOut)
copytObjects ((* yyNew)->ProcHead.DefTypes, yyt->ProcHead.DefTypes)
copytObjects ((* yyNew)->ProcHead.DefObjects, yyt->ProcHead.DefObjects)
copytObjects ((* yyNew)->ProcHead.ImplTypes, yyt->ProcHead.ImplTypes)
copyINDEX ((* yyNew)->ProcHead.PosIn, yyt->ProcHead.PosIn)
copyINDEX ((* yyNew)->ProcHead.PosOut, yyt->ProcHead.PosOut)
copyINDEX ((* yyNew)->ProcHead.Kind, yyt->ProcHead.Kind)
copytIdent ((* yyNew)->ProcHead.Module, yyt->ProcHead.Module)
copytIdents ((* yyNew)->ProcHead.IdsIn, yyt->ProcHead.IdsIn)
copytIdents ((* yyNew)->ProcHead.IdsOut, yyt->ProcHead.IdsOut)
copytConnects ((* yyNew)->ProcHead.ConnectsIn, yyt->ProcHead.ConnectsIn)
copytConnects ((* yyNew)->ProcHead.ConnectsOut, yyt->ProcHead.ConnectsOut)
copytLocalIds ((* yyNew)->ProcHead.LocalIdsIn, yyt->ProcHead.LocalIdsIn)
copytLocalIds ((* yyNew)->ProcHead.LocalIdsOut, yyt->ProcHead.LocalIdsOut)
copyINDEX ((* yyNew)->ProcHead.CntIn, yyt->ProcHead.CntIn)
copyINDEX ((* yyNew)->ProcHead.CntOut, yyt->ProcHead.CntOut)
copyINDEX ((* yyNew)->ProcHead.Level, yyt->ProcHead.Level)
copyBOOLEAN ((* yyNew)->ProcHead.GlobalPtrs, yyt->ProcHead.GlobalPtrs)
copytIdent ((* yyNew)->ProcHead.Ident, yyt->ProcHead.Ident)
copytPosition ((* yyNew)->ProcHead.Pos, yyt->ProcHead.Pos)
copytIdent ((* yyNew)->ProcHead.CIdent, yyt->ProcHead.CIdent)
copyBOOLEAN ((* yyNew)->ProcHead.IsRedeclared, yyt->ProcHead.IsRedeclared)
copytTree ((* yyNew)->ProcHead.Formals, yyt->ProcHead.Formals)
copytTree ((* yyNew)->ProcHead.ResultType, yyt->ProcHead.ResultType)
copytObject ((* yyNew)->ProcHead.Object, yyt->ProcHead.Object)
copytType ((* yyNew)->ProcHead.Type, yyt->ProcHead.Type)
copyBOOLEAN ((* yyNew)->ProcHead.HasOpenVector, yyt->ProcHead.HasOpenVector)
yyt = yyt->ProcHead.Next;
yyNew = & (* yyNew)->ProcHead.Next; break;
case kOpaque: (* yyNew)->Opaque = yyt->Opaque;
copytObjects ((* yyNew)->Opaque.Objects1, yyt->Opaque.Objects1)
copytVoid ((* yyNew)->Opaque.Objects2, yyt->Opaque.Objects2)
copytObjects ((* yyNew)->Opaque.Objects3, yyt->Opaque.Objects3)
copytObjects ((* yyNew)->Opaque.Objects4In, yyt->Opaque.Objects4In)
copytObjects ((* yyNew)->Opaque.Objects4Out, yyt->Opaque.Objects4Out)
copytEnv ((* yyNew)->Opaque.Env1, yyt->Opaque.Env1)
copytVoid ((* yyNew)->Opaque.Env2, yyt->Opaque.Env2)
copytEnv ((* yyNew)->Opaque.Env3, yyt->Opaque.Env3)
copytEnv ((* yyNew)->Opaque.Env4, yyt->Opaque.Env4)
copyINDEX ((* yyNew)->Opaque.ConfigGroupIn, yyt->Opaque.ConfigGroupIn)
copyINDEX ((* yyNew)->Opaque.ConfigGroupOut, yyt->Opaque.ConfigGroupOut)
copytObjects ((* yyNew)->Opaque.DefTypes, yyt->Opaque.DefTypes)
copytObjects ((* yyNew)->Opaque.DefObjects, yyt->Opaque.DefObjects)
copytObjects ((* yyNew)->Opaque.ImplTypes, yyt->Opaque.ImplTypes)
copyINDEX ((* yyNew)->Opaque.PosIn, yyt->Opaque.PosIn)
copyINDEX ((* yyNew)->Opaque.PosOut, yyt->Opaque.PosOut)
copyINDEX ((* yyNew)->Opaque.Kind, yyt->Opaque.Kind)
copytIdent ((* yyNew)->Opaque.Module, yyt->Opaque.Module)
copytIdents ((* yyNew)->Opaque.IdsIn, yyt->Opaque.IdsIn)
copytIdents ((* yyNew)->Opaque.IdsOut, yyt->Opaque.IdsOut)
copytConnects ((* yyNew)->Opaque.ConnectsIn, yyt->Opaque.ConnectsIn)
copytConnects ((* yyNew)->Opaque.ConnectsOut, yyt->Opaque.ConnectsOut)
copytLocalIds ((* yyNew)->Opaque.LocalIdsIn, yyt->Opaque.LocalIdsIn)
copytLocalIds ((* yyNew)->Opaque.LocalIdsOut, yyt->Opaque.LocalIdsOut)
copyINDEX ((* yyNew)->Opaque.CntIn, yyt->Opaque.CntIn)
copyINDEX ((* yyNew)->Opaque.CntOut, yyt->Opaque.CntOut)
copyINDEX ((* yyNew)->Opaque.Level, yyt->Opaque.Level)
copyBOOLEAN ((* yyNew)->Opaque.GlobalPtrs, yyt->Opaque.GlobalPtrs)
copytIdent ((* yyNew)->Opaque.Ident, yyt->Opaque.Ident)
copytPosition ((* yyNew)->Opaque.Pos, yyt->Opaque.Pos)
copytIdent ((* yyNew)->Opaque.CIdent, yyt->Opaque.CIdent)
copyBOOLEAN ((* yyNew)->Opaque.IsRedeclared, yyt->Opaque.IsRedeclared)
copytObject ((* yyNew)->Opaque.Object, yyt->Opaque.Object)
copytType ((* yyNew)->Opaque.Type1, yyt->Opaque.Type1)
copytType ((* yyNew)->Opaque.FullType, yyt->Opaque.FullType)
copytType ((* yyNew)->Opaque.Type2, yyt->Opaque.Type2)
yyt = yyt->Opaque.Next;
yyNew = & (* yyNew)->Opaque.Next; break;
case kConnectDests: (* yyNew)->ConnectDests = yyt->ConnectDests;
copytObjects ((* yyNew)->ConnectDests.Objects1, yyt->ConnectDests.Objects1)
copytVoid ((* yyNew)->ConnectDests.Objects2, yyt->ConnectDests.Objects2)
copytObjects ((* yyNew)->ConnectDests.Objects3, yyt->ConnectDests.Objects3)
copytObjects ((* yyNew)->ConnectDests.Objects4In, yyt->ConnectDests.Objects4In)
copytObjects ((* yyNew)->ConnectDests.Objects4Out, yyt->ConnectDests.Objects4Out)
copytObject ((* yyNew)->ConnectDests.LeftConfigObj, yyt->ConnectDests.LeftConfigObj)
copytObject ((* yyNew)->ConnectDests.RightConfigObj, yyt->ConnectDests.RightConfigObj)
copytEnv ((* yyNew)->ConnectDests.Env1, yyt->ConnectDests.Env1)
copytVoid ((* yyNew)->ConnectDests.Env2, yyt->ConnectDests.Env2)
copytEnv ((* yyNew)->ConnectDests.Env3, yyt->ConnectDests.Env3)
copytEnv ((* yyNew)->ConnectDests.Env4, yyt->ConnectDests.Env4)
copyINDEX ((* yyNew)->ConnectDests.Kind, yyt->ConnectDests.Kind)
copytIdent ((* yyNew)->ConnectDests.Module, yyt->ConnectDests.Module)
copytIdents ((* yyNew)->ConnectDests.IdsIn, yyt->ConnectDests.IdsIn)
copytIdents ((* yyNew)->ConnectDests.IdsOut, yyt->ConnectDests.IdsOut)
copytConnects ((* yyNew)->ConnectDests.ConnectsIn, yyt->ConnectDests.ConnectsIn)
copytConnects ((* yyNew)->ConnectDests.ConnectsOut, yyt->ConnectDests.ConnectsOut)
copytLocalIds ((* yyNew)->ConnectDests.LocalIdsIn, yyt->ConnectDests.LocalIdsIn)
copytLocalIds ((* yyNew)->ConnectDests.LocalIdsOut, yyt->ConnectDests.LocalIdsOut)
copyINDEX ((* yyNew)->ConnectDests.Level, yyt->ConnectDests.Level)
return;
case kNoConnectDest: (* yyNew)->NoConnectDest = yyt->NoConnectDest;
copytObjects ((* yyNew)->NoConnectDest.Objects1, yyt->NoConnectDest.Objects1)
copytVoid ((* yyNew)->NoConnectDest.Objects2, yyt->NoConnectDest.Objects2)
copytObjects ((* yyNew)->NoConnectDest.Objects3, yyt->NoConnectDest.Objects3)
copytObjects ((* yyNew)->NoConnectDest.Objects4In, yyt->NoConnectDest.Objects4In)
copytObjects ((* yyNew)->NoConnectDest.Objects4Out, yyt->NoConnectDest.Objects4Out)
copytObject ((* yyNew)->NoConnectDest.LeftConfigObj, yyt->NoConnectDest.LeftConfigObj)
copytObject ((* yyNew)->NoConnectDest.RightConfigObj, yyt->NoConnectDest.RightConfigObj)
copytEnv ((* yyNew)->NoConnectDest.Env1, yyt->NoConnectDest.Env1)
copytVoid ((* yyNew)->NoConnectDest.Env2, yyt->NoConnectDest.Env2)
copytEnv ((* yyNew)->NoConnectDest.Env3, yyt->NoConnectDest.Env3)
copytEnv ((* yyNew)->NoConnectDest.Env4, yyt->NoConnectDest.Env4)
copyINDEX ((* yyNew)->NoConnectDest.Kind, yyt->NoConnectDest.Kind)
copytIdent ((* yyNew)->NoConnectDest.Module, yyt->NoConnectDest.Module)
copytIdents ((* yyNew)->NoConnectDest.IdsIn, yyt->NoConnectDest.IdsIn)
copytIdents ((* yyNew)->NoConnectDest.IdsOut, yyt->NoConnectDest.IdsOut)
copytConnects ((* yyNew)->NoConnectDest.ConnectsIn, yyt->NoConnectDest.ConnectsIn)
copytConnects ((* yyNew)->NoConnectDest.ConnectsOut, yyt->NoConnectDest.ConnectsOut)
copytLocalIds ((* yyNew)->NoConnectDest.LocalIdsIn, yyt->NoConnectDest.LocalIdsIn)
copytLocalIds ((* yyNew)->NoConnectDest.LocalIdsOut, yyt->NoConnectDest.LocalIdsOut)
copyINDEX ((* yyNew)->NoConnectDest.Level, yyt->NoConnectDest.Level)
return;
case kConnectDest: (* yyNew)->ConnectDest = yyt->ConnectDest;
copytObjects ((* yyNew)->ConnectDest.Objects1, yyt->ConnectDest.Objects1)
copytVoid ((* yyNew)->ConnectDest.Objects2, yyt->ConnectDest.Objects2)
copytObjects ((* yyNew)->ConnectDest.Objects3, yyt->ConnectDest.Objects3)
copytObjects ((* yyNew)->ConnectDest.Objects4In, yyt->ConnectDest.Objects4In)
copytObjects ((* yyNew)->ConnectDest.Objects4Out, yyt->ConnectDest.Objects4Out)
copytObject ((* yyNew)->ConnectDest.LeftConfigObj, yyt->ConnectDest.LeftConfigObj)
copytObject ((* yyNew)->ConnectDest.RightConfigObj, yyt->ConnectDest.RightConfigObj)
copytEnv ((* yyNew)->ConnectDest.Env1, yyt->ConnectDest.Env1)
copytVoid ((* yyNew)->ConnectDest.Env2, yyt->ConnectDest.Env2)
copytEnv ((* yyNew)->ConnectDest.Env3, yyt->ConnectDest.Env3)
copytEnv ((* yyNew)->ConnectDest.Env4, yyt->ConnectDest.Env4)
copyINDEX ((* yyNew)->ConnectDest.Kind, yyt->ConnectDest.Kind)
copytIdent ((* yyNew)->ConnectDest.Module, yyt->ConnectDest.Module)
copytIdents ((* yyNew)->ConnectDest.IdsIn, yyt->ConnectDest.IdsIn)
copytIdents ((* yyNew)->ConnectDest.IdsOut, yyt->ConnectDest.IdsOut)
copytConnects ((* yyNew)->ConnectDest.ConnectsIn, yyt->ConnectDest.ConnectsIn)
copytConnects ((* yyNew)->ConnectDest.ConnectsOut, yyt->ConnectDest.ConnectsOut)
copytLocalIds ((* yyNew)->ConnectDest.LocalIdsIn, yyt->ConnectDest.LocalIdsIn)
copytLocalIds ((* yyNew)->ConnectDest.LocalIdsOut, yyt->ConnectDest.LocalIdsOut)
copyINDEX ((* yyNew)->ConnectDest.Level, yyt->ConnectDest.Level)
copytTree ((* yyNew)->ConnectDest.Expr, yyt->ConnectDest.Expr)
copytTree ((* yyNew)->ConnectDest.Config, yyt->ConnectDest.Config)
copytTree ((* yyNew)->ConnectDest.Actuals, yyt->ConnectDest.Actuals)
copytIdent ((* yyNew)->ConnectDest.DestDimId, yyt->ConnectDest.DestDimId)
copytIdent ((* yyNew)->ConnectDest.DestIdsId, yyt->ConnectDest.DestIdsId)
yyt = yyt->ConnectDest.Next;
yyNew = & (* yyNew)->ConnectDest.Next; break;
case kConnectDestUni: (* yyNew)->ConnectDestUni = yyt->ConnectDestUni;
copytObjects ((* yyNew)->ConnectDestUni.Objects1, yyt->ConnectDestUni.Objects1)
copytVoid ((* yyNew)->ConnectDestUni.Objects2, yyt->ConnectDestUni.Objects2)
copytObjects ((* yyNew)->ConnectDestUni.Objects3, yyt->ConnectDestUni.Objects3)
copytObjects ((* yyNew)->ConnectDestUni.Objects4In, yyt->ConnectDestUni.Objects4In)
copytObjects ((* yyNew)->ConnectDestUni.Objects4Out, yyt->ConnectDestUni.Objects4Out)
copytObject ((* yyNew)->ConnectDestUni.LeftConfigObj, yyt->ConnectDestUni.LeftConfigObj)
copytObject ((* yyNew)->ConnectDestUni.RightConfigObj, yyt->ConnectDestUni.RightConfigObj)
copytEnv ((* yyNew)->ConnectDestUni.Env1, yyt->ConnectDestUni.Env1)
copytVoid ((* yyNew)->ConnectDestUni.Env2, yyt->ConnectDestUni.Env2)
copytEnv ((* yyNew)->ConnectDestUni.Env3, yyt->ConnectDestUni.Env3)
copytEnv ((* yyNew)->ConnectDestUni.Env4, yyt->ConnectDestUni.Env4)
copyINDEX ((* yyNew)->ConnectDestUni.Kind, yyt->ConnectDestUni.Kind)
copytIdent ((* yyNew)->ConnectDestUni.Module, yyt->ConnectDestUni.Module)
copytIdents ((* yyNew)->ConnectDestUni.IdsIn, yyt->ConnectDestUni.IdsIn)
copytIdents ((* yyNew)->ConnectDestUni.IdsOut, yyt->ConnectDestUni.IdsOut)
copytConnects ((* yyNew)->ConnectDestUni.ConnectsIn, yyt->ConnectDestUni.ConnectsIn)
copytConnects ((* yyNew)->ConnectDestUni.ConnectsOut, yyt->ConnectDestUni.ConnectsOut)
copytLocalIds ((* yyNew)->ConnectDestUni.LocalIdsIn, yyt->ConnectDestUni.LocalIdsIn)
copytLocalIds ((* yyNew)->ConnectDestUni.LocalIdsOut, yyt->ConnectDestUni.LocalIdsOut)
copyINDEX ((* yyNew)->ConnectDestUni.Level, yyt->ConnectDestUni.Level)
copytTree ((* yyNew)->ConnectDestUni.Expr, yyt->ConnectDestUni.Expr)
copytTree ((* yyNew)->ConnectDestUni.Config, yyt->ConnectDestUni.Config)
copytTree ((* yyNew)->ConnectDestUni.Actuals, yyt->ConnectDestUni.Actuals)
copytIdent ((* yyNew)->ConnectDestUni.DestDimId, yyt->ConnectDestUni.DestDimId)
copytIdent ((* yyNew)->ConnectDestUni.DestIdsId, yyt->ConnectDestUni.DestIdsId)
yyt = yyt->ConnectDestUni.Next;
yyNew = & (* yyNew)->ConnectDestUni.Next; break;
case kConnectDestBi: (* yyNew)->ConnectDestBi = yyt->ConnectDestBi;
copytObjects ((* yyNew)->ConnectDestBi.Objects1, yyt->ConnectDestBi.Objects1)
copytVoid ((* yyNew)->ConnectDestBi.Objects2, yyt->ConnectDestBi.Objects2)
copytObjects ((* yyNew)->ConnectDestBi.Objects3, yyt->ConnectDestBi.Objects3)
copytObjects ((* yyNew)->ConnectDestBi.Objects4In, yyt->ConnectDestBi.Objects4In)
copytObjects ((* yyNew)->ConnectDestBi.Objects4Out, yyt->ConnectDestBi.Objects4Out)
copytObject ((* yyNew)->ConnectDestBi.LeftConfigObj, yyt->ConnectDestBi.LeftConfigObj)
copytObject ((* yyNew)->ConnectDestBi.RightConfigObj, yyt->ConnectDestBi.RightConfigObj)
copytEnv ((* yyNew)->ConnectDestBi.Env1, yyt->ConnectDestBi.Env1)
copytVoid ((* yyNew)->ConnectDestBi.Env2, yyt->ConnectDestBi.Env2)
copytEnv ((* yyNew)->ConnectDestBi.Env3, yyt->ConnectDestBi.Env3)
copytEnv ((* yyNew)->ConnectDestBi.Env4, yyt->ConnectDestBi.Env4)
copyINDEX ((* yyNew)->ConnectDestBi.Kind, yyt->ConnectDestBi.Kind)
copytIdent ((* yyNew)->ConnectDestBi.Module, yyt->ConnectDestBi.Module)
copytIdents ((* yyNew)->ConnectDestBi.IdsIn, yyt->ConnectDestBi.IdsIn)
copytIdents ((* yyNew)->ConnectDestBi.IdsOut, yyt->ConnectDestBi.IdsOut)
copytConnects ((* yyNew)->ConnectDestBi.ConnectsIn, yyt->ConnectDestBi.ConnectsIn)
copytConnects ((* yyNew)->ConnectDestBi.ConnectsOut, yyt->ConnectDestBi.ConnectsOut)
copytLocalIds ((* yyNew)->ConnectDestBi.LocalIdsIn, yyt->ConnectDestBi.LocalIdsIn)
copytLocalIds ((* yyNew)->ConnectDestBi.LocalIdsOut, yyt->ConnectDestBi.LocalIdsOut)
copyINDEX ((* yyNew)->ConnectDestBi.Level, yyt->ConnectDestBi.Level)
copytTree ((* yyNew)->ConnectDestBi.Expr, yyt->ConnectDestBi.Expr)
copytTree ((* yyNew)->ConnectDestBi.Config, yyt->ConnectDestBi.Config)
copytTree ((* yyNew)->ConnectDestBi.Actuals, yyt->ConnectDestBi.Actuals)
copytIdent ((* yyNew)->ConnectDestBi.DestDimId, yyt->ConnectDestBi.DestDimId)
copytIdent ((* yyNew)->ConnectDestBi.DestIdsId, yyt->ConnectDestBi.DestIdsId)
copytIdent ((* yyNew)->ConnectDestBi.Ident, yyt->ConnectDestBi.Ident)
copytPosition ((* yyNew)->ConnectDestBi.Pos, yyt->ConnectDestBi.Pos)
copytTree ((* yyNew)->ConnectDestBi.Index, yyt->ConnectDestBi.Index)
copytObject ((* yyNew)->ConnectDestBi.Object, yyt->ConnectDestBi.Object)
copytValue ((* yyNew)->ConnectDestBi.IndexVal, yyt->ConnectDestBi.IndexVal)
copytIdent ((* yyNew)->ConnectDestBi.CIdent, yyt->ConnectDestBi.CIdent)
copyBOOLEAN ((* yyNew)->ConnectDestBi.FirstDeclaration, yyt->ConnectDestBi.FirstDeclaration)
copytIdent ((* yyNew)->ConnectDestBi.PrevCIdent, yyt->ConnectDestBi.PrevCIdent)
copytIdent ((* yyNew)->ConnectDestBi.BiDirIdsId, yyt->ConnectDestBi.BiDirIdsId)
copytIdent ((* yyNew)->ConnectDestBi.IsinBiDirConnId, yyt->ConnectDestBi.IsinBiDirConnId)
yyt = yyt->ConnectDestBi.Next;
yyNew = & (* yyNew)->ConnectDestBi.Next; break;
case kVarIds: (* yyNew)->VarIds = yyt->VarIds;
copytObjects ((* yyNew)->VarIds.Objects3, yyt->VarIds.Objects3)
copytType ((* yyNew)->VarIds.Type, yyt->VarIds.Type)
copyADDRESS ((* yyNew)->VarIds.TypeTree, yyt->VarIds.TypeTree)
copyINDEX ((* yyNew)->VarIds.Kind, yyt->VarIds.Kind)
copytIdent ((* yyNew)->VarIds.Module, yyt->VarIds.Module)
copytIdents ((* yyNew)->VarIds.IdsIn, yyt->VarIds.IdsIn)
copytIdents ((* yyNew)->VarIds.IdsOut, yyt->VarIds.IdsOut)
copytLocalIds ((* yyNew)->VarIds.LocalIdsIn, yyt->VarIds.LocalIdsIn)
copytLocalIds ((* yyNew)->VarIds.LocalIdsOut, yyt->VarIds.LocalIdsOut)
copyINDEX ((* yyNew)->VarIds.Level, yyt->VarIds.Level)
return;
case kNoVarId: (* yyNew)->NoVarId = yyt->NoVarId;
copytObjects ((* yyNew)->NoVarId.Objects3, yyt->NoVarId.Objects3)
copytType ((* yyNew)->NoVarId.Type, yyt->NoVarId.Type)
copyADDRESS ((* yyNew)->NoVarId.TypeTree, yyt->NoVarId.TypeTree)
copyINDEX ((* yyNew)->NoVarId.Kind, yyt->NoVarId.Kind)
copytIdent ((* yyNew)->NoVarId.Module, yyt->NoVarId.Module)
copytIdents ((* yyNew)->NoVarId.IdsIn, yyt->NoVarId.IdsIn)
copytIdents ((* yyNew)->NoVarId.IdsOut, yyt->NoVarId.IdsOut)
copytLocalIds ((* yyNew)->NoVarId.LocalIdsIn, yyt->NoVarId.LocalIdsIn)
copytLocalIds ((* yyNew)->NoVarId.LocalIdsOut, yyt->NoVarId.LocalIdsOut)
copyINDEX ((* yyNew)->NoVarId.Level, yyt->NoVarId.Level)
return;
case kVarId: (* yyNew)->VarId = yyt->VarId;
copytObjects ((* yyNew)->VarId.Objects3, yyt->VarId.Objects3)
copytType ((* yyNew)->VarId.Type, yyt->VarId.Type)
copyADDRESS ((* yyNew)->VarId.TypeTree, yyt->VarId.TypeTree)
copyINDEX ((* yyNew)->VarId.Kind, yyt->VarId.Kind)
copytIdent ((* yyNew)->VarId.Module, yyt->VarId.Module)
copytIdents ((* yyNew)->VarId.IdsIn, yyt->VarId.IdsIn)
copytIdents ((* yyNew)->VarId.IdsOut, yyt->VarId.IdsOut)
copytLocalIds ((* yyNew)->VarId.LocalIdsIn, yyt->VarId.LocalIdsIn)
copytLocalIds ((* yyNew)->VarId.LocalIdsOut, yyt->VarId.LocalIdsOut)
copyINDEX ((* yyNew)->VarId.Level, yyt->VarId.Level)
copytIdent ((* yyNew)->VarId.Ident, yyt->VarId.Ident)
copytPosition ((* yyNew)->VarId.Pos, yyt->VarId.Pos)
copytObject ((* yyNew)->VarId.Object, yyt->VarId.Object)
copytIdent ((* yyNew)->VarId.CIdent, yyt->VarId.CIdent)
copyBOOLEAN ((* yyNew)->VarId.IsRedeclared, yyt->VarId.IsRedeclared)
yyt = yyt->VarId.Next;
yyNew = & (* yyNew)->VarId.Next; break;
case kFormals: (* yyNew)->Formals = yyt->Formals;
copytObjects ((* yyNew)->Formals.Objects3, yyt->Formals.Objects3)
copytTypes ((* yyNew)->Formals.Types, yyt->Formals.Types)
copytEnv ((* yyNew)->Formals.Env1, yyt->Formals.Env1)
copytVoid ((* yyNew)->Formals.Env2, yyt->Formals.Env2)
copytEnv ((* yyNew)->Formals.Env3, yyt->Formals.Env3)
copyBOOLEAN ((* yyNew)->Formals.HasOpenVector, yyt->Formals.HasOpenVector)
copyINDEX ((* yyNew)->Formals.PosIn, yyt->Formals.PosIn)
copyINDEX ((* yyNew)->Formals.PosOut, yyt->Formals.PosOut)
copyINDEX ((* yyNew)->Formals.Kind, yyt->Formals.Kind)
copytIdent ((* yyNew)->Formals.Module, yyt->Formals.Module)
copytIdents ((* yyNew)->Formals.IdsIn, yyt->Formals.IdsIn)
copytIdents ((* yyNew)->Formals.IdsOut, yyt->Formals.IdsOut)
copytLocalIds ((* yyNew)->Formals.LocalIdsIn, yyt->Formals.LocalIdsIn)
copytLocalIds ((* yyNew)->Formals.LocalIdsOut, yyt->Formals.LocalIdsOut)
copyINDEX ((* yyNew)->Formals.Level, yyt->Formals.Level)
return;
case kNoFormal: (* yyNew)->NoFormal = yyt->NoFormal;
copytObjects ((* yyNew)->NoFormal.Objects3, yyt->NoFormal.Objects3)
copytTypes ((* yyNew)->NoFormal.Types, yyt->NoFormal.Types)
copytEnv ((* yyNew)->NoFormal.Env1, yyt->NoFormal.Env1)
copytVoid ((* yyNew)->NoFormal.Env2, yyt->NoFormal.Env2)
copytEnv ((* yyNew)->NoFormal.Env3, yyt->NoFormal.Env3)
copyBOOLEAN ((* yyNew)->NoFormal.HasOpenVector, yyt->NoFormal.HasOpenVector)
copyINDEX ((* yyNew)->NoFormal.PosIn, yyt->NoFormal.PosIn)
copyINDEX ((* yyNew)->NoFormal.PosOut, yyt->NoFormal.PosOut)
copyINDEX ((* yyNew)->NoFormal.Kind, yyt->NoFormal.Kind)
copytIdent ((* yyNew)->NoFormal.Module, yyt->NoFormal.Module)
copytIdents ((* yyNew)->NoFormal.IdsIn, yyt->NoFormal.IdsIn)
copytIdents ((* yyNew)->NoFormal.IdsOut, yyt->NoFormal.IdsOut)
copytLocalIds ((* yyNew)->NoFormal.LocalIdsIn, yyt->NoFormal.LocalIdsIn)
copytLocalIds ((* yyNew)->NoFormal.LocalIdsOut, yyt->NoFormal.LocalIdsOut)
copyINDEX ((* yyNew)->NoFormal.Level, yyt->NoFormal.Level)
return;
case kFormal: (* yyNew)->Formal = yyt->Formal;
copytObjects ((* yyNew)->Formal.Objects3, yyt->Formal.Objects3)
copytTypes ((* yyNew)->Formal.Types, yyt->Formal.Types)
copytEnv ((* yyNew)->Formal.Env1, yyt->Formal.Env1)
copytVoid ((* yyNew)->Formal.Env2, yyt->Formal.Env2)
copytEnv ((* yyNew)->Formal.Env3, yyt->Formal.Env3)
copyBOOLEAN ((* yyNew)->Formal.HasOpenVector, yyt->Formal.HasOpenVector)
copyINDEX ((* yyNew)->Formal.PosIn, yyt->Formal.PosIn)
copyINDEX ((* yyNew)->Formal.PosOut, yyt->Formal.PosOut)
copyINDEX ((* yyNew)->Formal.Kind, yyt->Formal.Kind)
copytIdent ((* yyNew)->Formal.Module, yyt->Formal.Module)
copytIdents ((* yyNew)->Formal.IdsIn, yyt->Formal.IdsIn)
copytIdents ((* yyNew)->Formal.IdsOut, yyt->Formal.IdsOut)
copytLocalIds ((* yyNew)->Formal.LocalIdsIn, yyt->Formal.LocalIdsIn)
copytLocalIds ((* yyNew)->Formal.LocalIdsOut, yyt->Formal.LocalIdsOut)
copyINDEX ((* yyNew)->Formal.Level, yyt->Formal.Level)
copyBOOLEAN ((* yyNew)->Formal.IsVAR, yyt->Formal.IsVAR)
copytTree ((* yyNew)->Formal.ParIds, yyt->Formal.ParIds)
copytTree ((* yyNew)->Formal.Type, yyt->Formal.Type)
yyt = yyt->Formal.Next;
yyNew = & (* yyNew)->Formal.Next; break;
case kParIds: (* yyNew)->ParIds = yyt->ParIds;
copytObjects ((* yyNew)->ParIds.Objects3, yyt->ParIds.Objects3)
copytType ((* yyNew)->ParIds.Type, yyt->ParIds.Type)
copyADDRESS ((* yyNew)->ParIds.TypeTree, yyt->ParIds.TypeTree)
copyBOOLEAN ((* yyNew)->ParIds.IsVAR, yyt->ParIds.IsVAR)
copytType ((* yyNew)->ParIds.TypesIn, yyt->ParIds.TypesIn)
copytTypes ((* yyNew)->ParIds.TypesOut, yyt->ParIds.TypesOut)
copytIdents ((* yyNew)->ParIds.IdsIn, yyt->ParIds.IdsIn)
copytIdents ((* yyNew)->ParIds.IdsOut, yyt->ParIds.IdsOut)
copytLocalIds ((* yyNew)->ParIds.LocalIdsIn, yyt->ParIds.LocalIdsIn)
copytLocalIds ((* yyNew)->ParIds.LocalIdsOut, yyt->ParIds.LocalIdsOut)
copyINDEX ((* yyNew)->ParIds.Level, yyt->ParIds.Level)
return;
case kNoParId: (* yyNew)->NoParId = yyt->NoParId;
copytObjects ((* yyNew)->NoParId.Objects3, yyt->NoParId.Objects3)
copytType ((* yyNew)->NoParId.Type, yyt->NoParId.Type)
copyADDRESS ((* yyNew)->NoParId.TypeTree, yyt->NoParId.TypeTree)
copyBOOLEAN ((* yyNew)->NoParId.IsVAR, yyt->NoParId.IsVAR)
copytType ((* yyNew)->NoParId.TypesIn, yyt->NoParId.TypesIn)
copytTypes ((* yyNew)->NoParId.TypesOut, yyt->NoParId.TypesOut)
copytIdents ((* yyNew)->NoParId.IdsIn, yyt->NoParId.IdsIn)
copytIdents ((* yyNew)->NoParId.IdsOut, yyt->NoParId.IdsOut)
copytLocalIds ((* yyNew)->NoParId.LocalIdsIn, yyt->NoParId.LocalIdsIn)
copytLocalIds ((* yyNew)->NoParId.LocalIdsOut, yyt->NoParId.LocalIdsOut)
copyINDEX ((* yyNew)->NoParId.Level, yyt->NoParId.Level)
return;
case kParId: (* yyNew)->ParId = yyt->ParId;
copytObjects ((* yyNew)->ParId.Objects3, yyt->ParId.Objects3)
copytType ((* yyNew)->ParId.Type, yyt->ParId.Type)
copyADDRESS ((* yyNew)->ParId.TypeTree, yyt->ParId.TypeTree)
copyBOOLEAN ((* yyNew)->ParId.IsVAR, yyt->ParId.IsVAR)
copytType ((* yyNew)->ParId.TypesIn, yyt->ParId.TypesIn)
copytTypes ((* yyNew)->ParId.TypesOut, yyt->ParId.TypesOut)
copytIdents ((* yyNew)->ParId.IdsIn, yyt->ParId.IdsIn)
copytIdents ((* yyNew)->ParId.IdsOut, yyt->ParId.IdsOut)
copytLocalIds ((* yyNew)->ParId.LocalIdsIn, yyt->ParId.LocalIdsIn)
copytLocalIds ((* yyNew)->ParId.LocalIdsOut, yyt->ParId.LocalIdsOut)
copyINDEX ((* yyNew)->ParId.Level, yyt->ParId.Level)
copytIdent ((* yyNew)->ParId.Ident, yyt->ParId.Ident)
copytPosition ((* yyNew)->ParId.Pos, yyt->ParId.Pos)
copytObject ((* yyNew)->ParId.Object, yyt->ParId.Object)
copytIdent ((* yyNew)->ParId.CIdent, yyt->ParId.CIdent)
copyBOOLEAN ((* yyNew)->ParId.IsRedeclared, yyt->ParId.IsRedeclared)
yyt = yyt->ParId.Next;
yyNew = & (* yyNew)->ParId.Next; break;
case kType: (* yyNew)->Type = yyt->Type;
copytObjects ((* yyNew)->Type.Objects3, yyt->Type.Objects3)
copytObject ((* yyNew)->Type.TypeObj, yyt->Type.TypeObj)
copytType ((* yyNew)->Type.Type1, yyt->Type.Type1)
copytType ((* yyNew)->Type.Type2, yyt->Type.Type2)
copytEnv ((* yyNew)->Type.Env1, yyt->Type.Env1)
copytVoid ((* yyNew)->Type.Env2, yyt->Type.Env2)
copytEnv ((* yyNew)->Type.Env3, yyt->Type.Env3)
copyBOOLEAN ((* yyNew)->Type.IsInArray, yyt->Type.IsInArray)
copyINDEX ((* yyNew)->Type.PosIn, yyt->Type.PosIn)
copyINDEX ((* yyNew)->Type.PosOut, yyt->Type.PosOut)
copyINDEX ((* yyNew)->Type.Kind, yyt->Type.Kind)
copytIdent ((* yyNew)->Type.Module, yyt->Type.Module)
copytIdents ((* yyNew)->Type.IdsIn, yyt->Type.IdsIn)
copytIdents ((* yyNew)->Type.IdsOut, yyt->Type.IdsOut)
copytLocalIds ((* yyNew)->Type.LocalIdsIn, yyt->Type.LocalIdsIn)
copytLocalIds ((* yyNew)->Type.LocalIdsOut, yyt->Type.LocalIdsOut)
copyINDEX ((* yyNew)->Type.CntIn, yyt->Type.CntIn)
copyINDEX ((* yyNew)->Type.CntOut, yyt->Type.CntOut)
copyBOOLEAN ((* yyNew)->Type.HasVariableSize, yyt->Type.HasVariableSize)
copyBOOLEAN ((* yyNew)->Type.ContainsVector, yyt->Type.ContainsVector)
return;
case kVector: (* yyNew)->Vector = yyt->Vector;
copytObjects ((* yyNew)->Vector.Objects3, yyt->Vector.Objects3)
copytObject ((* yyNew)->Vector.TypeObj, yyt->Vector.TypeObj)
copytType ((* yyNew)->Vector.Type1, yyt->Vector.Type1)
copytType ((* yyNew)->Vector.Type2, yyt->Vector.Type2)
copytEnv ((* yyNew)->Vector.Env1, yyt->Vector.Env1)
copytVoid ((* yyNew)->Vector.Env2, yyt->Vector.Env2)
copytEnv ((* yyNew)->Vector.Env3, yyt->Vector.Env3)
copyBOOLEAN ((* yyNew)->Vector.IsInArray, yyt->Vector.IsInArray)
copyINDEX ((* yyNew)->Vector.PosIn, yyt->Vector.PosIn)
copyINDEX ((* yyNew)->Vector.PosOut, yyt->Vector.PosOut)
copyINDEX ((* yyNew)->Vector.Kind, yyt->Vector.Kind)
copytIdent ((* yyNew)->Vector.Module, yyt->Vector.Module)
copytIdents ((* yyNew)->Vector.IdsIn, yyt->Vector.IdsIn)
copytIdents ((* yyNew)->Vector.IdsOut, yyt->Vector.IdsOut)
copytLocalIds ((* yyNew)->Vector.LocalIdsIn, yyt->Vector.LocalIdsIn)
copytLocalIds ((* yyNew)->Vector.LocalIdsOut, yyt->Vector.LocalIdsOut)
copyINDEX ((* yyNew)->Vector.CntIn, yyt->Vector.CntIn)
copyINDEX ((* yyNew)->Vector.CntOut, yyt->Vector.CntOut)
copyBOOLEAN ((* yyNew)->Vector.HasVariableSize, yyt->Vector.HasVariableSize)
copyBOOLEAN ((* yyNew)->Vector.ContainsVector, yyt->Vector.ContainsVector)
copyBOOLEAN ((* yyNew)->Vector.IsOpen, yyt->Vector.IsOpen)
copytTree ((* yyNew)->Vector.Config, yyt->Vector.Config)
yyt = yyt->Vector.Scalar;
yyNew = & (* yyNew)->Vector.Scalar; break;
case kArray: (* yyNew)->Array = yyt->Array;
copytObjects ((* yyNew)->Array.Objects3, yyt->Array.Objects3)
copytObject ((* yyNew)->Array.TypeObj, yyt->Array.TypeObj)
copytType ((* yyNew)->Array.Type1, yyt->Array.Type1)
copytType ((* yyNew)->Array.Type2, yyt->Array.Type2)
copytEnv ((* yyNew)->Array.Env1, yyt->Array.Env1)
copytVoid ((* yyNew)->Array.Env2, yyt->Array.Env2)
copytEnv ((* yyNew)->Array.Env3, yyt->Array.Env3)
copyBOOLEAN ((* yyNew)->Array.IsInArray, yyt->Array.IsInArray)
copyINDEX ((* yyNew)->Array.PosIn, yyt->Array.PosIn)
copyINDEX ((* yyNew)->Array.PosOut, yyt->Array.PosOut)
copyINDEX ((* yyNew)->Array.Kind, yyt->Array.Kind)
copytIdent ((* yyNew)->Array.Module, yyt->Array.Module)
copytIdents ((* yyNew)->Array.IdsIn, yyt->Array.IdsIn)
copytIdents ((* yyNew)->Array.IdsOut, yyt->Array.IdsOut)
copytLocalIds ((* yyNew)->Array.LocalIdsIn, yyt->Array.LocalIdsIn)
copytLocalIds ((* yyNew)->Array.LocalIdsOut, yyt->Array.LocalIdsOut)
copyINDEX ((* yyNew)->Array.CntIn, yyt->Array.CntIn)
copyINDEX ((* yyNew)->Array.CntOut, yyt->Array.CntOut)
copyBOOLEAN ((* yyNew)->Array.HasVariableSize, yyt->Array.HasVariableSize)
copyBOOLEAN ((* yyNew)->Array.ContainsVector, yyt->Array.ContainsVector)
copyBOOLEAN ((* yyNew)->Array.IsOpen, yyt->Array.IsOpen)
copytTree ((* yyNew)->Array.Index, yyt->Array.Index)
yyt = yyt->Array.ElemType;
yyNew = & (* yyNew)->Array.ElemType; break;
case kRecord: (* yyNew)->Record = yyt->Record;
copytObjects ((* yyNew)->Record.Objects3, yyt->Record.Objects3)
copytObject ((* yyNew)->Record.TypeObj, yyt->Record.TypeObj)
copytType ((* yyNew)->Record.Type1, yyt->Record.Type1)
copytType ((* yyNew)->Record.Type2, yyt->Record.Type2)
copytEnv ((* yyNew)->Record.Env1, yyt->Record.Env1)
copytVoid ((* yyNew)->Record.Env2, yyt->Record.Env2)
copytEnv ((* yyNew)->Record.Env3, yyt->Record.Env3)
copyBOOLEAN ((* yyNew)->Record.IsInArray, yyt->Record.IsInArray)
copyINDEX ((* yyNew)->Record.PosIn, yyt->Record.PosIn)
copyINDEX ((* yyNew)->Record.PosOut, yyt->Record.PosOut)
copyINDEX ((* yyNew)->Record.Kind, yyt->Record.Kind)
copytIdent ((* yyNew)->Record.Module, yyt->Record.Module)
copytIdents ((* yyNew)->Record.IdsIn, yyt->Record.IdsIn)
copytIdents ((* yyNew)->Record.IdsOut, yyt->Record.IdsOut)
copytLocalIds ((* yyNew)->Record.LocalIdsIn, yyt->Record.LocalIdsIn)
copytLocalIds ((* yyNew)->Record.LocalIdsOut, yyt->Record.LocalIdsOut)
copyINDEX ((* yyNew)->Record.CntIn, yyt->Record.CntIn)
copyINDEX ((* yyNew)->Record.CntOut, yyt->Record.CntOut)
copyBOOLEAN ((* yyNew)->Record.HasVariableSize, yyt->Record.HasVariableSize)
copyBOOLEAN ((* yyNew)->Record.ContainsVector, yyt->Record.ContainsVector)
yyt = yyt->Record.Fields;
yyNew = & (* yyNew)->Record.Fields; break;
case kSetType: (* yyNew)->SetType = yyt->SetType;
copytObjects ((* yyNew)->SetType.Objects3, yyt->SetType.Objects3)
copytObject ((* yyNew)->SetType.TypeObj, yyt->SetType.TypeObj)
copytType ((* yyNew)->SetType.Type1, yyt->SetType.Type1)
copytType ((* yyNew)->SetType.Type2, yyt->SetType.Type2)
copytEnv ((* yyNew)->SetType.Env1, yyt->SetType.Env1)
copytVoid ((* yyNew)->SetType.Env2, yyt->SetType.Env2)
copytEnv ((* yyNew)->SetType.Env3, yyt->SetType.Env3)
copyBOOLEAN ((* yyNew)->SetType.IsInArray, yyt->SetType.IsInArray)
copyINDEX ((* yyNew)->SetType.PosIn, yyt->SetType.PosIn)
copyINDEX ((* yyNew)->SetType.PosOut, yyt->SetType.PosOut)
copyINDEX ((* yyNew)->SetType.Kind, yyt->SetType.Kind)
copytIdent ((* yyNew)->SetType.Module, yyt->SetType.Module)
copytIdents ((* yyNew)->SetType.IdsIn, yyt->SetType.IdsIn)
copytIdents ((* yyNew)->SetType.IdsOut, yyt->SetType.IdsOut)
copytLocalIds ((* yyNew)->SetType.LocalIdsIn, yyt->SetType.LocalIdsIn)
copytLocalIds ((* yyNew)->SetType.LocalIdsOut, yyt->SetType.LocalIdsOut)
copyINDEX ((* yyNew)->SetType.CntIn, yyt->SetType.CntIn)
copyINDEX ((* yyNew)->SetType.CntOut, yyt->SetType.CntOut)
copyBOOLEAN ((* yyNew)->SetType.HasVariableSize, yyt->SetType.HasVariableSize)
copyBOOLEAN ((* yyNew)->SetType.ContainsVector, yyt->SetType.ContainsVector)
yyt = yyt->SetType.BaseType;
yyNew = & (* yyNew)->SetType.BaseType; break;
case kPointer: (* yyNew)->Pointer = yyt->Pointer;
copytObjects ((* yyNew)->Pointer.Objects3, yyt->Pointer.Objects3)
copytObject ((* yyNew)->Pointer.TypeObj, yyt->Pointer.TypeObj)
copytType ((* yyNew)->Pointer.Type1, yyt->Pointer.Type1)
copytType ((* yyNew)->Pointer.Type2, yyt->Pointer.Type2)
copytEnv ((* yyNew)->Pointer.Env1, yyt->Pointer.Env1)
copytVoid ((* yyNew)->Pointer.Env2, yyt->Pointer.Env2)
copytEnv ((* yyNew)->Pointer.Env3, yyt->Pointer.Env3)
copyBOOLEAN ((* yyNew)->Pointer.IsInArray, yyt->Pointer.IsInArray)
copyINDEX ((* yyNew)->Pointer.PosIn, yyt->Pointer.PosIn)
copyINDEX ((* yyNew)->Pointer.PosOut, yyt->Pointer.PosOut)
copyINDEX ((* yyNew)->Pointer.Kind, yyt->Pointer.Kind)
copytIdent ((* yyNew)->Pointer.Module, yyt->Pointer.Module)
copytIdents ((* yyNew)->Pointer.IdsIn, yyt->Pointer.IdsIn)
copytIdents ((* yyNew)->Pointer.IdsOut, yyt->Pointer.IdsOut)
copytLocalIds ((* yyNew)->Pointer.LocalIdsIn, yyt->Pointer.LocalIdsIn)
copytLocalIds ((* yyNew)->Pointer.LocalIdsOut, yyt->Pointer.LocalIdsOut)
copyINDEX ((* yyNew)->Pointer.CntIn, yyt->Pointer.CntIn)
copyINDEX ((* yyNew)->Pointer.CntOut, yyt->Pointer.CntOut)
copyBOOLEAN ((* yyNew)->Pointer.HasVariableSize, yyt->Pointer.HasVariableSize)
copyBOOLEAN ((* yyNew)->Pointer.ContainsVector, yyt->Pointer.ContainsVector)
copyINDEX ((* yyNew)->Pointer.TypePos, yyt->Pointer.TypePos)
yyt = yyt->Pointer.TargetType;
yyNew = & (* yyNew)->Pointer.TargetType; break;
case kProcType: (* yyNew)->ProcType = yyt->ProcType;
copytObjects ((* yyNew)->ProcType.Objects3, yyt->ProcType.Objects3)
copytObject ((* yyNew)->ProcType.TypeObj, yyt->ProcType.TypeObj)
copytType ((* yyNew)->ProcType.Type1, yyt->ProcType.Type1)
copytType ((* yyNew)->ProcType.Type2, yyt->ProcType.Type2)
copytEnv ((* yyNew)->ProcType.Env1, yyt->ProcType.Env1)
copytVoid ((* yyNew)->ProcType.Env2, yyt->ProcType.Env2)
copytEnv ((* yyNew)->ProcType.Env3, yyt->ProcType.Env3)
copyBOOLEAN ((* yyNew)->ProcType.IsInArray, yyt->ProcType.IsInArray)
copyINDEX ((* yyNew)->ProcType.PosIn, yyt->ProcType.PosIn)
copyINDEX ((* yyNew)->ProcType.PosOut, yyt->ProcType.PosOut)
copyINDEX ((* yyNew)->ProcType.Kind, yyt->ProcType.Kind)
copytIdent ((* yyNew)->ProcType.Module, yyt->ProcType.Module)
copytIdents ((* yyNew)->ProcType.IdsIn, yyt->ProcType.IdsIn)
copytIdents ((* yyNew)->ProcType.IdsOut, yyt->ProcType.IdsOut)
copytLocalIds ((* yyNew)->ProcType.LocalIdsIn, yyt->ProcType.LocalIdsIn)
copytLocalIds ((* yyNew)->ProcType.LocalIdsOut, yyt->ProcType.LocalIdsOut)
copyINDEX ((* yyNew)->ProcType.CntIn, yyt->ProcType.CntIn)
copyINDEX ((* yyNew)->ProcType.CntOut, yyt->ProcType.CntOut)
copyBOOLEAN ((* yyNew)->ProcType.HasVariableSize, yyt->ProcType.HasVariableSize)
copyBOOLEAN ((* yyNew)->ProcType.ContainsVector, yyt->ProcType.ContainsVector)
copytTree ((* yyNew)->ProcType.FormalTypes, yyt->ProcType.FormalTypes)
yyt = yyt->ProcType.ResultType;
yyNew = & (* yyNew)->ProcType.ResultType; break;
case kSimpleType: (* yyNew)->SimpleType = yyt->SimpleType;
copytObjects ((* yyNew)->SimpleType.Objects3, yyt->SimpleType.Objects3)
copytObject ((* yyNew)->SimpleType.TypeObj, yyt->SimpleType.TypeObj)
copytType ((* yyNew)->SimpleType.Type1, yyt->SimpleType.Type1)
copytType ((* yyNew)->SimpleType.Type2, yyt->SimpleType.Type2)
copytEnv ((* yyNew)->SimpleType.Env1, yyt->SimpleType.Env1)
copytVoid ((* yyNew)->SimpleType.Env2, yyt->SimpleType.Env2)
copytEnv ((* yyNew)->SimpleType.Env3, yyt->SimpleType.Env3)
copyBOOLEAN ((* yyNew)->SimpleType.IsInArray, yyt->SimpleType.IsInArray)
copyINDEX ((* yyNew)->SimpleType.PosIn, yyt->SimpleType.PosIn)
copyINDEX ((* yyNew)->SimpleType.PosOut, yyt->SimpleType.PosOut)
copyINDEX ((* yyNew)->SimpleType.Kind, yyt->SimpleType.Kind)
copytIdent ((* yyNew)->SimpleType.Module, yyt->SimpleType.Module)
copytIdents ((* yyNew)->SimpleType.IdsIn, yyt->SimpleType.IdsIn)
copytIdents ((* yyNew)->SimpleType.IdsOut, yyt->SimpleType.IdsOut)
copytLocalIds ((* yyNew)->SimpleType.LocalIdsIn, yyt->SimpleType.LocalIdsIn)
copytLocalIds ((* yyNew)->SimpleType.LocalIdsOut, yyt->SimpleType.LocalIdsOut)
copyINDEX ((* yyNew)->SimpleType.CntIn, yyt->SimpleType.CntIn)
copyINDEX ((* yyNew)->SimpleType.CntOut, yyt->SimpleType.CntOut)
copyBOOLEAN ((* yyNew)->SimpleType.HasVariableSize, yyt->SimpleType.HasVariableSize)
copyBOOLEAN ((* yyNew)->SimpleType.ContainsVector, yyt->SimpleType.ContainsVector)
return;
case kEnumeration: (* yyNew)->Enumeration = yyt->Enumeration;
copytObjects ((* yyNew)->Enumeration.Objects3, yyt->Enumeration.Objects3)
copytObject ((* yyNew)->Enumeration.TypeObj, yyt->Enumeration.TypeObj)
copytType ((* yyNew)->Enumeration.Type1, yyt->Enumeration.Type1)
copytType ((* yyNew)->Enumeration.Type2, yyt->Enumeration.Type2)
copytEnv ((* yyNew)->Enumeration.Env1, yyt->Enumeration.Env1)
copytVoid ((* yyNew)->Enumeration.Env2, yyt->Enumeration.Env2)
copytEnv ((* yyNew)->Enumeration.Env3, yyt->Enumeration.Env3)
copyBOOLEAN ((* yyNew)->Enumeration.IsInArray, yyt->Enumeration.IsInArray)
copyINDEX ((* yyNew)->Enumeration.PosIn, yyt->Enumeration.PosIn)
copyINDEX ((* yyNew)->Enumeration.PosOut, yyt->Enumeration.PosOut)
copyINDEX ((* yyNew)->Enumeration.Kind, yyt->Enumeration.Kind)
copytIdent ((* yyNew)->Enumeration.Module, yyt->Enumeration.Module)
copytIdents ((* yyNew)->Enumeration.IdsIn, yyt->Enumeration.IdsIn)
copytIdents ((* yyNew)->Enumeration.IdsOut, yyt->Enumeration.IdsOut)
copytLocalIds ((* yyNew)->Enumeration.LocalIdsIn, yyt->Enumeration.LocalIdsIn)
copytLocalIds ((* yyNew)->Enumeration.LocalIdsOut, yyt->Enumeration.LocalIdsOut)
copyINDEX ((* yyNew)->Enumeration.CntIn, yyt->Enumeration.CntIn)
copyINDEX ((* yyNew)->Enumeration.CntOut, yyt->Enumeration.CntOut)
copyBOOLEAN ((* yyNew)->Enumeration.HasVariableSize, yyt->Enumeration.HasVariableSize)
copyBOOLEAN ((* yyNew)->Enumeration.ContainsVector, yyt->Enumeration.ContainsVector)
copytType ((* yyNew)->Enumeration.Type0, yyt->Enumeration.Type0)
yyt = yyt->Enumeration.EnumIds;
yyNew = & (* yyNew)->Enumeration.EnumIds; break;
case kSubrange: (* yyNew)->Subrange = yyt->Subrange;
copytObjects ((* yyNew)->Subrange.Objects3, yyt->Subrange.Objects3)
copytObject ((* yyNew)->Subrange.TypeObj, yyt->Subrange.TypeObj)
copytType ((* yyNew)->Subrange.Type1, yyt->Subrange.Type1)
copytType ((* yyNew)->Subrange.Type2, yyt->Subrange.Type2)
copytEnv ((* yyNew)->Subrange.Env1, yyt->Subrange.Env1)
copytVoid ((* yyNew)->Subrange.Env2, yyt->Subrange.Env2)
copytEnv ((* yyNew)->Subrange.Env3, yyt->Subrange.Env3)
copyBOOLEAN ((* yyNew)->Subrange.IsInArray, yyt->Subrange.IsInArray)
copyINDEX ((* yyNew)->Subrange.PosIn, yyt->Subrange.PosIn)
copyINDEX ((* yyNew)->Subrange.PosOut, yyt->Subrange.PosOut)
copyINDEX ((* yyNew)->Subrange.Kind, yyt->Subrange.Kind)
copytIdent ((* yyNew)->Subrange.Module, yyt->Subrange.Module)
copytIdents ((* yyNew)->Subrange.IdsIn, yyt->Subrange.IdsIn)
copytIdents ((* yyNew)->Subrange.IdsOut, yyt->Subrange.IdsOut)
copytLocalIds ((* yyNew)->Subrange.LocalIdsIn, yyt->Subrange.LocalIdsIn)
copytLocalIds ((* yyNew)->Subrange.LocalIdsOut, yyt->Subrange.LocalIdsOut)
copyINDEX ((* yyNew)->Subrange.CntIn, yyt->Subrange.CntIn)
copyINDEX ((* yyNew)->Subrange.CntOut, yyt->Subrange.CntOut)
copyBOOLEAN ((* yyNew)->Subrange.HasVariableSize, yyt->Subrange.HasVariableSize)
copyBOOLEAN ((* yyNew)->Subrange.ContainsVector, yyt->Subrange.ContainsVector)
copytTree ((* yyNew)->Subrange.BaseType, yyt->Subrange.BaseType)
copytTree ((* yyNew)->Subrange.Lwb, yyt->Subrange.Lwb)
copytType ((* yyNew)->Subrange.Type3, yyt->Subrange.Type3)
yyt = yyt->Subrange.Upb;
yyNew = & (* yyNew)->Subrange.Upb; break;
case kPrimaryType: (* yyNew)->PrimaryType = yyt->PrimaryType;
copytObjects ((* yyNew)->PrimaryType.Objects3, yyt->PrimaryType.Objects3)
copytObject ((* yyNew)->PrimaryType.TypeObj, yyt->PrimaryType.TypeObj)
copytType ((* yyNew)->PrimaryType.Type1, yyt->PrimaryType.Type1)
copytType ((* yyNew)->PrimaryType.Type2, yyt->PrimaryType.Type2)
copytEnv ((* yyNew)->PrimaryType.Env1, yyt->PrimaryType.Env1)
copytVoid ((* yyNew)->PrimaryType.Env2, yyt->PrimaryType.Env2)
copytEnv ((* yyNew)->PrimaryType.Env3, yyt->PrimaryType.Env3)
copyBOOLEAN ((* yyNew)->PrimaryType.IsInArray, yyt->PrimaryType.IsInArray)
copyINDEX ((* yyNew)->PrimaryType.PosIn, yyt->PrimaryType.PosIn)
copyINDEX ((* yyNew)->PrimaryType.PosOut, yyt->PrimaryType.PosOut)
copyINDEX ((* yyNew)->PrimaryType.Kind, yyt->PrimaryType.Kind)
copytIdent ((* yyNew)->PrimaryType.Module, yyt->PrimaryType.Module)
copytIdents ((* yyNew)->PrimaryType.IdsIn, yyt->PrimaryType.IdsIn)
copytIdents ((* yyNew)->PrimaryType.IdsOut, yyt->PrimaryType.IdsOut)
copytLocalIds ((* yyNew)->PrimaryType.LocalIdsIn, yyt->PrimaryType.LocalIdsIn)
copytLocalIds ((* yyNew)->PrimaryType.LocalIdsOut, yyt->PrimaryType.LocalIdsOut)
copyINDEX ((* yyNew)->PrimaryType.CntIn, yyt->PrimaryType.CntIn)
copyINDEX ((* yyNew)->PrimaryType.CntOut, yyt->PrimaryType.CntOut)
copyBOOLEAN ((* yyNew)->PrimaryType.HasVariableSize, yyt->PrimaryType.HasVariableSize)
copyBOOLEAN ((* yyNew)->PrimaryType.ContainsVector, yyt->PrimaryType.ContainsVector)
return;
case kVoid: (* yyNew)->Void = yyt->Void;
copytObjects ((* yyNew)->Void.Objects3, yyt->Void.Objects3)
copytObject ((* yyNew)->Void.TypeObj, yyt->Void.TypeObj)
copytType ((* yyNew)->Void.Type1, yyt->Void.Type1)
copytType ((* yyNew)->Void.Type2, yyt->Void.Type2)
copytEnv ((* yyNew)->Void.Env1, yyt->Void.Env1)
copytVoid ((* yyNew)->Void.Env2, yyt->Void.Env2)
copytEnv ((* yyNew)->Void.Env3, yyt->Void.Env3)
copyBOOLEAN ((* yyNew)->Void.IsInArray, yyt->Void.IsInArray)
copyINDEX ((* yyNew)->Void.PosIn, yyt->Void.PosIn)
copyINDEX ((* yyNew)->Void.PosOut, yyt->Void.PosOut)
copyINDEX ((* yyNew)->Void.Kind, yyt->Void.Kind)
copytIdent ((* yyNew)->Void.Module, yyt->Void.Module)
copytIdents ((* yyNew)->Void.IdsIn, yyt->Void.IdsIn)
copytIdents ((* yyNew)->Void.IdsOut, yyt->Void.IdsOut)
copytLocalIds ((* yyNew)->Void.LocalIdsIn, yyt->Void.LocalIdsIn)
copytLocalIds ((* yyNew)->Void.LocalIdsOut, yyt->Void.LocalIdsOut)
copyINDEX ((* yyNew)->Void.CntIn, yyt->Void.CntIn)
copyINDEX ((* yyNew)->Void.CntOut, yyt->Void.CntOut)
copyBOOLEAN ((* yyNew)->Void.HasVariableSize, yyt->Void.HasVariableSize)
copyBOOLEAN ((* yyNew)->Void.ContainsVector, yyt->Void.ContainsVector)
return;
case kTypeId: (* yyNew)->TypeId = yyt->TypeId;
copytObjects ((* yyNew)->TypeId.Objects3, yyt->TypeId.Objects3)
copytObject ((* yyNew)->TypeId.TypeObj, yyt->TypeId.TypeObj)
copytType ((* yyNew)->TypeId.Type1, yyt->TypeId.Type1)
copytType ((* yyNew)->TypeId.Type2, yyt->TypeId.Type2)
copytEnv ((* yyNew)->TypeId.Env1, yyt->TypeId.Env1)
copytVoid ((* yyNew)->TypeId.Env2, yyt->TypeId.Env2)
copytEnv ((* yyNew)->TypeId.Env3, yyt->TypeId.Env3)
copyBOOLEAN ((* yyNew)->TypeId.IsInArray, yyt->TypeId.IsInArray)
copyINDEX ((* yyNew)->TypeId.PosIn, yyt->TypeId.PosIn)
copyINDEX ((* yyNew)->TypeId.PosOut, yyt->TypeId.PosOut)
copyINDEX ((* yyNew)->TypeId.Kind, yyt->TypeId.Kind)
copytIdent ((* yyNew)->TypeId.Module, yyt->TypeId.Module)
copytIdents ((* yyNew)->TypeId.IdsIn, yyt->TypeId.IdsIn)
copytIdents ((* yyNew)->TypeId.IdsOut, yyt->TypeId.IdsOut)
copytLocalIds ((* yyNew)->TypeId.LocalIdsIn, yyt->TypeId.LocalIdsIn)
copytLocalIds ((* yyNew)->TypeId.LocalIdsOut, yyt->TypeId.LocalIdsOut)
copyINDEX ((* yyNew)->TypeId.CntIn, yyt->TypeId.CntIn)
copyINDEX ((* yyNew)->TypeId.CntOut, yyt->TypeId.CntOut)
copyBOOLEAN ((* yyNew)->TypeId.HasVariableSize, yyt->TypeId.HasVariableSize)
copyBOOLEAN ((* yyNew)->TypeId.ContainsVector, yyt->TypeId.ContainsVector)
copytIdent ((* yyNew)->TypeId.Ident, yyt->TypeId.Ident)
copytPosition ((* yyNew)->TypeId.Pos, yyt->TypeId.Pos)
copytObject ((* yyNew)->TypeId.Object, yyt->TypeId.Object)
return;
case kTypeId0: (* yyNew)->TypeId0 = yyt->TypeId0;
copytObjects ((* yyNew)->TypeId0.Objects3, yyt->TypeId0.Objects3)
copytObject ((* yyNew)->TypeId0.TypeObj, yyt->TypeId0.TypeObj)
copytType ((* yyNew)->TypeId0.Type1, yyt->TypeId0.Type1)
copytType ((* yyNew)->TypeId0.Type2, yyt->TypeId0.Type2)
copytEnv ((* yyNew)->TypeId0.Env1, yyt->TypeId0.Env1)
copytVoid ((* yyNew)->TypeId0.Env2, yyt->TypeId0.Env2)
copytEnv ((* yyNew)->TypeId0.Env3, yyt->TypeId0.Env3)
copyBOOLEAN ((* yyNew)->TypeId0.IsInArray, yyt->TypeId0.IsInArray)
copyINDEX ((* yyNew)->TypeId0.PosIn, yyt->TypeId0.PosIn)
copyINDEX ((* yyNew)->TypeId0.PosOut, yyt->TypeId0.PosOut)
copyINDEX ((* yyNew)->TypeId0.Kind, yyt->TypeId0.Kind)
copytIdent ((* yyNew)->TypeId0.Module, yyt->TypeId0.Module)
copytIdents ((* yyNew)->TypeId0.IdsIn, yyt->TypeId0.IdsIn)
copytIdents ((* yyNew)->TypeId0.IdsOut, yyt->TypeId0.IdsOut)
copytLocalIds ((* yyNew)->TypeId0.LocalIdsIn, yyt->TypeId0.LocalIdsIn)
copytLocalIds ((* yyNew)->TypeId0.LocalIdsOut, yyt->TypeId0.LocalIdsOut)
copyINDEX ((* yyNew)->TypeId0.CntIn, yyt->TypeId0.CntIn)
copyINDEX ((* yyNew)->TypeId0.CntOut, yyt->TypeId0.CntOut)
copyBOOLEAN ((* yyNew)->TypeId0.HasVariableSize, yyt->TypeId0.HasVariableSize)
copyBOOLEAN ((* yyNew)->TypeId0.ContainsVector, yyt->TypeId0.ContainsVector)
copytIdent ((* yyNew)->TypeId0.Ident, yyt->TypeId0.Ident)
copytPosition ((* yyNew)->TypeId0.Pos, yyt->TypeId0.Pos)
copytObject ((* yyNew)->TypeId0.Object, yyt->TypeId0.Object)
return;
case kTypeId1: (* yyNew)->TypeId1 = yyt->TypeId1;
copytObjects ((* yyNew)->TypeId1.Objects3, yyt->TypeId1.Objects3)
copytObject ((* yyNew)->TypeId1.TypeObj, yyt->TypeId1.TypeObj)
copytType ((* yyNew)->TypeId1.Type1, yyt->TypeId1.Type1)
copytType ((* yyNew)->TypeId1.Type2, yyt->TypeId1.Type2)
copytEnv ((* yyNew)->TypeId1.Env1, yyt->TypeId1.Env1)
copytVoid ((* yyNew)->TypeId1.Env2, yyt->TypeId1.Env2)
copytEnv ((* yyNew)->TypeId1.Env3, yyt->TypeId1.Env3)
copyBOOLEAN ((* yyNew)->TypeId1.IsInArray, yyt->TypeId1.IsInArray)
copyINDEX ((* yyNew)->TypeId1.PosIn, yyt->TypeId1.PosIn)
copyINDEX ((* yyNew)->TypeId1.PosOut, yyt->TypeId1.PosOut)
copyINDEX ((* yyNew)->TypeId1.Kind, yyt->TypeId1.Kind)
copytIdent ((* yyNew)->TypeId1.Module, yyt->TypeId1.Module)
copytIdents ((* yyNew)->TypeId1.IdsIn, yyt->TypeId1.IdsIn)
copytIdents ((* yyNew)->TypeId1.IdsOut, yyt->TypeId1.IdsOut)
copytLocalIds ((* yyNew)->TypeId1.LocalIdsIn, yyt->TypeId1.LocalIdsIn)
copytLocalIds ((* yyNew)->TypeId1.LocalIdsOut, yyt->TypeId1.LocalIdsOut)
copyINDEX ((* yyNew)->TypeId1.CntIn, yyt->TypeId1.CntIn)
copyINDEX ((* yyNew)->TypeId1.CntOut, yyt->TypeId1.CntOut)
copyBOOLEAN ((* yyNew)->TypeId1.HasVariableSize, yyt->TypeId1.HasVariableSize)
copyBOOLEAN ((* yyNew)->TypeId1.ContainsVector, yyt->TypeId1.ContainsVector)
copytIdent ((* yyNew)->TypeId1.Ident, yyt->TypeId1.Ident)
copytPosition ((* yyNew)->TypeId1.Pos, yyt->TypeId1.Pos)
copytObject ((* yyNew)->TypeId1.Object, yyt->TypeId1.Object)
yyt = yyt->TypeId1.TypeId;
yyNew = & (* yyNew)->TypeId1.TypeId; break;
case kFields: (* yyNew)->Fields = yyt->Fields;
copytObjects ((* yyNew)->Fields.Objects3, yyt->Fields.Objects3)
copytObjects ((* yyNew)->Fields.FieldsIn, yyt->Fields.FieldsIn)
copytObjects ((* yyNew)->Fields.FieldsOut, yyt->Fields.FieldsOut)
copytEnv ((* yyNew)->Fields.Env1, yyt->Fields.Env1)
copytVoid ((* yyNew)->Fields.Env2, yyt->Fields.Env2)
copytEnv ((* yyNew)->Fields.Env3, yyt->Fields.Env3)
copyINDEX ((* yyNew)->Fields.PosIn, yyt->Fields.PosIn)
copyINDEX ((* yyNew)->Fields.PosOut, yyt->Fields.PosOut)
copyINDEX ((* yyNew)->Fields.Kind, yyt->Fields.Kind)
copytIdent ((* yyNew)->Fields.Module, yyt->Fields.Module)
copytIdents ((* yyNew)->Fields.IdsIn, yyt->Fields.IdsIn)
copytIdents ((* yyNew)->Fields.IdsOut, yyt->Fields.IdsOut)
copytLocalIds ((* yyNew)->Fields.LocalIdsIn, yyt->Fields.LocalIdsIn)
copytLocalIds ((* yyNew)->Fields.LocalIdsOut, yyt->Fields.LocalIdsOut)
copyINDEX ((* yyNew)->Fields.CntIn, yyt->Fields.CntIn)
copyINDEX ((* yyNew)->Fields.CntOut, yyt->Fields.CntOut)
copyINDEX ((* yyNew)->Fields.nUnion, yyt->Fields.nUnion)
copytSelectors ((* yyNew)->Fields.Select, yyt->Fields.Select)
copyBOOLEAN ((* yyNew)->Fields.ContainsVector, yyt->Fields.ContainsVector)
return;
case kNoField: (* yyNew)->NoField = yyt->NoField;
copytObjects ((* yyNew)->NoField.Objects3, yyt->NoField.Objects3)
copytObjects ((* yyNew)->NoField.FieldsIn, yyt->NoField.FieldsIn)
copytObjects ((* yyNew)->NoField.FieldsOut, yyt->NoField.FieldsOut)
copytEnv ((* yyNew)->NoField.Env1, yyt->NoField.Env1)
copytVoid ((* yyNew)->NoField.Env2, yyt->NoField.Env2)
copytEnv ((* yyNew)->NoField.Env3, yyt->NoField.Env3)
copyINDEX ((* yyNew)->NoField.PosIn, yyt->NoField.PosIn)
copyINDEX ((* yyNew)->NoField.PosOut, yyt->NoField.PosOut)
copyINDEX ((* yyNew)->NoField.Kind, yyt->NoField.Kind)
copytIdent ((* yyNew)->NoField.Module, yyt->NoField.Module)
copytIdents ((* yyNew)->NoField.IdsIn, yyt->NoField.IdsIn)
copytIdents ((* yyNew)->NoField.IdsOut, yyt->NoField.IdsOut)
copytLocalIds ((* yyNew)->NoField.LocalIdsIn, yyt->NoField.LocalIdsIn)
copytLocalIds ((* yyNew)->NoField.LocalIdsOut, yyt->NoField.LocalIdsOut)
copyINDEX ((* yyNew)->NoField.CntIn, yyt->NoField.CntIn)
copyINDEX ((* yyNew)->NoField.CntOut, yyt->NoField.CntOut)
copyINDEX ((* yyNew)->NoField.nUnion, yyt->NoField.nUnion)
copytSelectors ((* yyNew)->NoField.Select, yyt->NoField.Select)
copyBOOLEAN ((* yyNew)->NoField.ContainsVector, yyt->NoField.ContainsVector)
return;
case kField: (* yyNew)->Field = yyt->Field;
copytObjects ((* yyNew)->Field.Objects3, yyt->Field.Objects3)
copytObjects ((* yyNew)->Field.FieldsIn, yyt->Field.FieldsIn)
copytObjects ((* yyNew)->Field.FieldsOut, yyt->Field.FieldsOut)
copytEnv ((* yyNew)->Field.Env1, yyt->Field.Env1)
copytVoid ((* yyNew)->Field.Env2, yyt->Field.Env2)
copytEnv ((* yyNew)->Field.Env3, yyt->Field.Env3)
copyINDEX ((* yyNew)->Field.PosIn, yyt->Field.PosIn)
copyINDEX ((* yyNew)->Field.PosOut, yyt->Field.PosOut)
copyINDEX ((* yyNew)->Field.Kind, yyt->Field.Kind)
copytIdent ((* yyNew)->Field.Module, yyt->Field.Module)
copytIdents ((* yyNew)->Field.IdsIn, yyt->Field.IdsIn)
copytIdents ((* yyNew)->Field.IdsOut, yyt->Field.IdsOut)
copytLocalIds ((* yyNew)->Field.LocalIdsIn, yyt->Field.LocalIdsIn)
copytLocalIds ((* yyNew)->Field.LocalIdsOut, yyt->Field.LocalIdsOut)
copyINDEX ((* yyNew)->Field.CntIn, yyt->Field.CntIn)
copyINDEX ((* yyNew)->Field.CntOut, yyt->Field.CntOut)
copyINDEX ((* yyNew)->Field.nUnion, yyt->Field.nUnion)
copytSelectors ((* yyNew)->Field.Select, yyt->Field.Select)
copyBOOLEAN ((* yyNew)->Field.ContainsVector, yyt->Field.ContainsVector)
yyt = yyt->Field.Next;
yyNew = & (* yyNew)->Field.Next; break;
case kRecordSect: (* yyNew)->RecordSect = yyt->RecordSect;
copytObjects ((* yyNew)->RecordSect.Objects3, yyt->RecordSect.Objects3)
copytObjects ((* yyNew)->RecordSect.FieldsIn, yyt->RecordSect.FieldsIn)
copytObjects ((* yyNew)->RecordSect.FieldsOut, yyt->RecordSect.FieldsOut)
copytEnv ((* yyNew)->RecordSect.Env1, yyt->RecordSect.Env1)
copytVoid ((* yyNew)->RecordSect.Env2, yyt->RecordSect.Env2)
copytEnv ((* yyNew)->RecordSect.Env3, yyt->RecordSect.Env3)
copyINDEX ((* yyNew)->RecordSect.PosIn, yyt->RecordSect.PosIn)
copyINDEX ((* yyNew)->RecordSect.PosOut, yyt->RecordSect.PosOut)
copyINDEX ((* yyNew)->RecordSect.Kind, yyt->RecordSect.Kind)
copytIdent ((* yyNew)->RecordSect.Module, yyt->RecordSect.Module)
copytIdents ((* yyNew)->RecordSect.IdsIn, yyt->RecordSect.IdsIn)
copytIdents ((* yyNew)->RecordSect.IdsOut, yyt->RecordSect.IdsOut)
copytLocalIds ((* yyNew)->RecordSect.LocalIdsIn, yyt->RecordSect.LocalIdsIn)
copytLocalIds ((* yyNew)->RecordSect.LocalIdsOut, yyt->RecordSect.LocalIdsOut)
copyINDEX ((* yyNew)->RecordSect.CntIn, yyt->RecordSect.CntIn)
copyINDEX ((* yyNew)->RecordSect.CntOut, yyt->RecordSect.CntOut)
copyINDEX ((* yyNew)->RecordSect.nUnion, yyt->RecordSect.nUnion)
copytSelectors ((* yyNew)->RecordSect.Select, yyt->RecordSect.Select)
copyBOOLEAN ((* yyNew)->RecordSect.ContainsVector, yyt->RecordSect.ContainsVector)
copytTree ((* yyNew)->RecordSect.FieldIds, yyt->RecordSect.FieldIds)
copytTree ((* yyNew)->RecordSect.Type, yyt->RecordSect.Type)
yyt = yyt->RecordSect.Next;
yyNew = & (* yyNew)->RecordSect.Next; break;
case kVariantSect: (* yyNew)->VariantSect = yyt->VariantSect;
copytObjects ((* yyNew)->VariantSect.Objects3, yyt->VariantSect.Objects3)
copytObjects ((* yyNew)->VariantSect.FieldsIn, yyt->VariantSect.FieldsIn)
copytObjects ((* yyNew)->VariantSect.FieldsOut, yyt->VariantSect.FieldsOut)
copytEnv ((* yyNew)->VariantSect.Env1, yyt->VariantSect.Env1)
copytVoid ((* yyNew)->VariantSect.Env2, yyt->VariantSect.Env2)
copytEnv ((* yyNew)->VariantSect.Env3, yyt->VariantSect.Env3)
copyINDEX ((* yyNew)->VariantSect.PosIn, yyt->VariantSect.PosIn)
copyINDEX ((* yyNew)->VariantSect.PosOut, yyt->VariantSect.PosOut)
copyINDEX ((* yyNew)->VariantSect.Kind, yyt->VariantSect.Kind)
copytIdent ((* yyNew)->VariantSect.Module, yyt->VariantSect.Module)
copytIdents ((* yyNew)->VariantSect.IdsIn, yyt->VariantSect.IdsIn)
copytIdents ((* yyNew)->VariantSect.IdsOut, yyt->VariantSect.IdsOut)
copytLocalIds ((* yyNew)->VariantSect.LocalIdsIn, yyt->VariantSect.LocalIdsIn)
copytLocalIds ((* yyNew)->VariantSect.LocalIdsOut, yyt->VariantSect.LocalIdsOut)
copyINDEX ((* yyNew)->VariantSect.CntIn, yyt->VariantSect.CntIn)
copyINDEX ((* yyNew)->VariantSect.CntOut, yyt->VariantSect.CntOut)
copyINDEX ((* yyNew)->VariantSect.nUnion, yyt->VariantSect.nUnion)
copytSelectors ((* yyNew)->VariantSect.Select, yyt->VariantSect.Select)
copyBOOLEAN ((* yyNew)->VariantSect.ContainsVector, yyt->VariantSect.ContainsVector)
copytTree ((* yyNew)->VariantSect.TagField, yyt->VariantSect.TagField)
copytTree ((* yyNew)->VariantSect.Variants, yyt->VariantSect.Variants)
copytTree ((* yyNew)->VariantSect.Else, yyt->VariantSect.Else)
copytIdent ((* yyNew)->VariantSect.UnionId, yyt->VariantSect.UnionId)
copytIdent ((* yyNew)->VariantSect.ElseId, yyt->VariantSect.ElseId)
yyt = yyt->VariantSect.Next;
yyNew = & (* yyNew)->VariantSect.Next; break;
case kFieldIds: (* yyNew)->FieldIds = yyt->FieldIds;
copytType ((* yyNew)->FieldIds.Type, yyt->FieldIds.Type)
copytObjects ((* yyNew)->FieldIds.FieldsIn, yyt->FieldIds.FieldsIn)
copytObjects ((* yyNew)->FieldIds.FieldsOut, yyt->FieldIds.FieldsOut)
copytIdents ((* yyNew)->FieldIds.IdsIn, yyt->FieldIds.IdsIn)
copytIdents ((* yyNew)->FieldIds.IdsOut, yyt->FieldIds.IdsOut)
copytLocalIds ((* yyNew)->FieldIds.LocalIdsIn, yyt->FieldIds.LocalIdsIn)
copytLocalIds ((* yyNew)->FieldIds.LocalIdsOut, yyt->FieldIds.LocalIdsOut)
copytSelectors ((* yyNew)->FieldIds.Select, yyt->FieldIds.Select)
return;
case kNoFieldId: (* yyNew)->NoFieldId = yyt->NoFieldId;
copytType ((* yyNew)->NoFieldId.Type, yyt->NoFieldId.Type)
copytObjects ((* yyNew)->NoFieldId.FieldsIn, yyt->NoFieldId.FieldsIn)
copytObjects ((* yyNew)->NoFieldId.FieldsOut, yyt->NoFieldId.FieldsOut)
copytIdents ((* yyNew)->NoFieldId.IdsIn, yyt->NoFieldId.IdsIn)
copytIdents ((* yyNew)->NoFieldId.IdsOut, yyt->NoFieldId.IdsOut)
copytLocalIds ((* yyNew)->NoFieldId.LocalIdsIn, yyt->NoFieldId.LocalIdsIn)
copytLocalIds ((* yyNew)->NoFieldId.LocalIdsOut, yyt->NoFieldId.LocalIdsOut)
copytSelectors ((* yyNew)->NoFieldId.Select, yyt->NoFieldId.Select)
return;
case kFieldId: (* yyNew)->FieldId = yyt->FieldId;
copytType ((* yyNew)->FieldId.Type, yyt->FieldId.Type)
copytObjects ((* yyNew)->FieldId.FieldsIn, yyt->FieldId.FieldsIn)
copytObjects ((* yyNew)->FieldId.FieldsOut, yyt->FieldId.FieldsOut)
copytIdents ((* yyNew)->FieldId.IdsIn, yyt->FieldId.IdsIn)
copytIdents ((* yyNew)->FieldId.IdsOut, yyt->FieldId.IdsOut)
copytLocalIds ((* yyNew)->FieldId.LocalIdsIn, yyt->FieldId.LocalIdsIn)
copytLocalIds ((* yyNew)->FieldId.LocalIdsOut, yyt->FieldId.LocalIdsOut)
copytSelectors ((* yyNew)->FieldId.Select, yyt->FieldId.Select)
copytIdent ((* yyNew)->FieldId.Ident, yyt->FieldId.Ident)
copytPosition ((* yyNew)->FieldId.Pos, yyt->FieldId.Pos)
copytObject ((* yyNew)->FieldId.Object, yyt->FieldId.Object)
copytIdent ((* yyNew)->FieldId.CIdent, yyt->FieldId.CIdent)
copyBOOLEAN ((* yyNew)->FieldId.IsRedeclared, yyt->FieldId.IsRedeclared)
yyt = yyt->FieldId.Next;
yyNew = & (* yyNew)->FieldId.Next; break;
case kTagField: (* yyNew)->TagField = yyt->TagField;
copytObjects ((* yyNew)->TagField.FieldsIn, yyt->TagField.FieldsIn)
copytObjects ((* yyNew)->TagField.FieldsOut, yyt->TagField.FieldsOut)
copytEnv ((* yyNew)->TagField.Env1, yyt->TagField.Env1)
copytVoid ((* yyNew)->TagField.Env2, yyt->TagField.Env2)
copytEnv ((* yyNew)->TagField.Env3, yyt->TagField.Env3)
copyINDEX ((* yyNew)->TagField.PosIn, yyt->TagField.PosIn)
copyINDEX ((* yyNew)->TagField.PosOut, yyt->TagField.PosOut)
copyINDEX ((* yyNew)->TagField.Kind, yyt->TagField.Kind)
copytIdent ((* yyNew)->TagField.Module, yyt->TagField.Module)
copytIdents ((* yyNew)->TagField.IdsIn, yyt->TagField.IdsIn)
copytIdents ((* yyNew)->TagField.IdsOut, yyt->TagField.IdsOut)
copytLocalIds ((* yyNew)->TagField.LocalIdsIn, yyt->TagField.LocalIdsIn)
copytLocalIds ((* yyNew)->TagField.LocalIdsOut, yyt->TagField.LocalIdsOut)
copytSelectors ((* yyNew)->TagField.Select, yyt->TagField.Select)
yyt = yyt->TagField.Type;
yyNew = & (* yyNew)->TagField.Type; break;
case kTagField1: (* yyNew)->TagField1 = yyt->TagField1;
copytObjects ((* yyNew)->TagField1.FieldsIn, yyt->TagField1.FieldsIn)
copytObjects ((* yyNew)->TagField1.FieldsOut, yyt->TagField1.FieldsOut)
copytEnv ((* yyNew)->TagField1.Env1, yyt->TagField1.Env1)
copytVoid ((* yyNew)->TagField1.Env2, yyt->TagField1.Env2)
copytEnv ((* yyNew)->TagField1.Env3, yyt->TagField1.Env3)
copyINDEX ((* yyNew)->TagField1.PosIn, yyt->TagField1.PosIn)
copyINDEX ((* yyNew)->TagField1.PosOut, yyt->TagField1.PosOut)
copyINDEX ((* yyNew)->TagField1.Kind, yyt->TagField1.Kind)
copytIdent ((* yyNew)->TagField1.Module, yyt->TagField1.Module)
copytIdents ((* yyNew)->TagField1.IdsIn, yyt->TagField1.IdsIn)
copytIdents ((* yyNew)->TagField1.IdsOut, yyt->TagField1.IdsOut)
copytLocalIds ((* yyNew)->TagField1.LocalIdsIn, yyt->TagField1.LocalIdsIn)
copytLocalIds ((* yyNew)->TagField1.LocalIdsOut, yyt->TagField1.LocalIdsOut)
copytSelectors ((* yyNew)->TagField1.Select, yyt->TagField1.Select)
yyt = yyt->TagField1.Type;
yyNew = & (* yyNew)->TagField1.Type; break;
case kTagField2: (* yyNew)->TagField2 = yyt->TagField2;
copytObjects ((* yyNew)->TagField2.FieldsIn, yyt->TagField2.FieldsIn)
copytObjects ((* yyNew)->TagField2.FieldsOut, yyt->TagField2.FieldsOut)
copytEnv ((* yyNew)->TagField2.Env1, yyt->TagField2.Env1)
copytVoid ((* yyNew)->TagField2.Env2, yyt->TagField2.Env2)
copytEnv ((* yyNew)->TagField2.Env3, yyt->TagField2.Env3)
copyINDEX ((* yyNew)->TagField2.PosIn, yyt->TagField2.PosIn)
copyINDEX ((* yyNew)->TagField2.PosOut, yyt->TagField2.PosOut)
copyINDEX ((* yyNew)->TagField2.Kind, yyt->TagField2.Kind)
copytIdent ((* yyNew)->TagField2.Module, yyt->TagField2.Module)
copytIdents ((* yyNew)->TagField2.IdsIn, yyt->TagField2.IdsIn)
copytIdents ((* yyNew)->TagField2.IdsOut, yyt->TagField2.IdsOut)
copytLocalIds ((* yyNew)->TagField2.LocalIdsIn, yyt->TagField2.LocalIdsIn)
copytLocalIds ((* yyNew)->TagField2.LocalIdsOut, yyt->TagField2.LocalIdsOut)
copytSelectors ((* yyNew)->TagField2.Select, yyt->TagField2.Select)
copytIdent ((* yyNew)->TagField2.Ident, yyt->TagField2.Ident)
copytObject ((* yyNew)->TagField2.Object, yyt->TagField2.Object)
copytIdent ((* yyNew)->TagField2.CIdent, yyt->TagField2.CIdent)
copyBOOLEAN ((* yyNew)->TagField2.IsRedeclared, yyt->TagField2.IsRedeclared)
yyt = yyt->TagField2.Type;
yyNew = & (* yyNew)->TagField2.Type; break;
case kVariants: (* yyNew)->Variants = yyt->Variants;
copytObjects ((* yyNew)->Variants.Objects3, yyt->Variants.Objects3)
copytObjects ((* yyNew)->Variants.FieldsIn, yyt->Variants.FieldsIn)
copytObjects ((* yyNew)->Variants.FieldsOut, yyt->Variants.FieldsOut)
copytEnv ((* yyNew)->Variants.Env1, yyt->Variants.Env1)
copytVoid ((* yyNew)->Variants.Env2, yyt->Variants.Env2)
copytEnv ((* yyNew)->Variants.Env3, yyt->Variants.Env3)
copyINDEX ((* yyNew)->Variants.PosIn, yyt->Variants.PosIn)
copyINDEX ((* yyNew)->Variants.PosOut, yyt->Variants.PosOut)
copyINDEX ((* yyNew)->Variants.Kind, yyt->Variants.Kind)
copytIdent ((* yyNew)->Variants.Module, yyt->Variants.Module)
copytIdents ((* yyNew)->Variants.IdsIn, yyt->Variants.IdsIn)
copytIdents ((* yyNew)->Variants.IdsOut, yyt->Variants.IdsOut)
copytLocalIds ((* yyNew)->Variants.LocalIdsIn, yyt->Variants.LocalIdsIn)
copytLocalIds ((* yyNew)->Variants.LocalIdsOut, yyt->Variants.LocalIdsOut)
copyINDEX ((* yyNew)->Variants.CntIn, yyt->Variants.CntIn)
copyINDEX ((* yyNew)->Variants.CntOut, yyt->Variants.CntOut)
copyINDEX ((* yyNew)->Variants.nStruct, yyt->Variants.nStruct)
copytSelectors ((* yyNew)->Variants.Select, yyt->Variants.Select)
return;
case kNoVariant: (* yyNew)->NoVariant = yyt->NoVariant;
copytObjects ((* yyNew)->NoVariant.Objects3, yyt->NoVariant.Objects3)
copytObjects ((* yyNew)->NoVariant.FieldsIn, yyt->NoVariant.FieldsIn)
copytObjects ((* yyNew)->NoVariant.FieldsOut, yyt->NoVariant.FieldsOut)
copytEnv ((* yyNew)->NoVariant.Env1, yyt->NoVariant.Env1)
copytVoid ((* yyNew)->NoVariant.Env2, yyt->NoVariant.Env2)
copytEnv ((* yyNew)->NoVariant.Env3, yyt->NoVariant.Env3)
copyINDEX ((* yyNew)->NoVariant.PosIn, yyt->NoVariant.PosIn)
copyINDEX ((* yyNew)->NoVariant.PosOut, yyt->NoVariant.PosOut)
copyINDEX ((* yyNew)->NoVariant.Kind, yyt->NoVariant.Kind)
copytIdent ((* yyNew)->NoVariant.Module, yyt->NoVariant.Module)
copytIdents ((* yyNew)->NoVariant.IdsIn, yyt->NoVariant.IdsIn)
copytIdents ((* yyNew)->NoVariant.IdsOut, yyt->NoVariant.IdsOut)
copytLocalIds ((* yyNew)->NoVariant.LocalIdsIn, yyt->NoVariant.LocalIdsIn)
copytLocalIds ((* yyNew)->NoVariant.LocalIdsOut, yyt->NoVariant.LocalIdsOut)
copyINDEX ((* yyNew)->NoVariant.CntIn, yyt->NoVariant.CntIn)
copyINDEX ((* yyNew)->NoVariant.CntOut, yyt->NoVariant.CntOut)
copyINDEX ((* yyNew)->NoVariant.nStruct, yyt->NoVariant.nStruct)
copytSelectors ((* yyNew)->NoVariant.Select, yyt->NoVariant.Select)
return;
case kVariant: (* yyNew)->Variant = yyt->Variant;
copytObjects ((* yyNew)->Variant.Objects3, yyt->Variant.Objects3)
copytObjects ((* yyNew)->Variant.FieldsIn, yyt->Variant.FieldsIn)
copytObjects ((* yyNew)->Variant.FieldsOut, yyt->Variant.FieldsOut)
copytEnv ((* yyNew)->Variant.Env1, yyt->Variant.Env1)
copytVoid ((* yyNew)->Variant.Env2, yyt->Variant.Env2)
copytEnv ((* yyNew)->Variant.Env3, yyt->Variant.Env3)
copyINDEX ((* yyNew)->Variant.PosIn, yyt->Variant.PosIn)
copyINDEX ((* yyNew)->Variant.PosOut, yyt->Variant.PosOut)
copyINDEX ((* yyNew)->Variant.Kind, yyt->Variant.Kind)
copytIdent ((* yyNew)->Variant.Module, yyt->Variant.Module)
copytIdents ((* yyNew)->Variant.IdsIn, yyt->Variant.IdsIn)
copytIdents ((* yyNew)->Variant.IdsOut, yyt->Variant.IdsOut)
copytLocalIds ((* yyNew)->Variant.LocalIdsIn, yyt->Variant.LocalIdsIn)
copytLocalIds ((* yyNew)->Variant.LocalIdsOut, yyt->Variant.LocalIdsOut)
copyINDEX ((* yyNew)->Variant.CntIn, yyt->Variant.CntIn)
copyINDEX ((* yyNew)->Variant.CntOut, yyt->Variant.CntOut)
copyINDEX ((* yyNew)->Variant.nStruct, yyt->Variant.nStruct)
copytSelectors ((* yyNew)->Variant.Select, yyt->Variant.Select)
copytTree ((* yyNew)->Variant.Labels, yyt->Variant.Labels)
copytTree ((* yyNew)->Variant.Variant, yyt->Variant.Variant)
copytIdent ((* yyNew)->Variant.StructId, yyt->Variant.StructId)
yyt = yyt->Variant.Next;
yyNew = & (* yyNew)->Variant.Next; break;
case kFormalTypes: (* yyNew)->FormalTypes = yyt->FormalTypes;
copytTypes ((* yyNew)->FormalTypes.Types, yyt->FormalTypes.Types)
copytEnv ((* yyNew)->FormalTypes.Env1, yyt->FormalTypes.Env1)
copytVoid ((* yyNew)->FormalTypes.Env2, yyt->FormalTypes.Env2)
copytEnv ((* yyNew)->FormalTypes.Env3, yyt->FormalTypes.Env3)
copyINDEX ((* yyNew)->FormalTypes.PosIn, yyt->FormalTypes.PosIn)
copyINDEX ((* yyNew)->FormalTypes.PosOut, yyt->FormalTypes.PosOut)
copyINDEX ((* yyNew)->FormalTypes.Kind, yyt->FormalTypes.Kind)
copytIdent ((* yyNew)->FormalTypes.Module, yyt->FormalTypes.Module)
copytIdents ((* yyNew)->FormalTypes.IdsIn, yyt->FormalTypes.IdsIn)
copytIdents ((* yyNew)->FormalTypes.IdsOut, yyt->FormalTypes.IdsOut)
copytLocalIds ((* yyNew)->FormalTypes.LocalIdsIn, yyt->FormalTypes.LocalIdsIn)
copytLocalIds ((* yyNew)->FormalTypes.LocalIdsOut, yyt->FormalTypes.LocalIdsOut)
return;
case kNoFormalType: (* yyNew)->NoFormalType = yyt->NoFormalType;
copytTypes ((* yyNew)->NoFormalType.Types, yyt->NoFormalType.Types)
copytEnv ((* yyNew)->NoFormalType.Env1, yyt->NoFormalType.Env1)
copytVoid ((* yyNew)->NoFormalType.Env2, yyt->NoFormalType.Env2)
copytEnv ((* yyNew)->NoFormalType.Env3, yyt->NoFormalType.Env3)
copyINDEX ((* yyNew)->NoFormalType.PosIn, yyt->NoFormalType.PosIn)
copyINDEX ((* yyNew)->NoFormalType.PosOut, yyt->NoFormalType.PosOut)
copyINDEX ((* yyNew)->NoFormalType.Kind, yyt->NoFormalType.Kind)
copytIdent ((* yyNew)->NoFormalType.Module, yyt->NoFormalType.Module)
copytIdents ((* yyNew)->NoFormalType.IdsIn, yyt->NoFormalType.IdsIn)
copytIdents ((* yyNew)->NoFormalType.IdsOut, yyt->NoFormalType.IdsOut)
copytLocalIds ((* yyNew)->NoFormalType.LocalIdsIn, yyt->NoFormalType.LocalIdsIn)
copytLocalIds ((* yyNew)->NoFormalType.LocalIdsOut, yyt->NoFormalType.LocalIdsOut)
return;
case kFormalType: (* yyNew)->FormalType = yyt->FormalType;
copytTypes ((* yyNew)->FormalType.Types, yyt->FormalType.Types)
copytEnv ((* yyNew)->FormalType.Env1, yyt->FormalType.Env1)
copytVoid ((* yyNew)->FormalType.Env2, yyt->FormalType.Env2)
copytEnv ((* yyNew)->FormalType.Env3, yyt->FormalType.Env3)
copyINDEX ((* yyNew)->FormalType.PosIn, yyt->FormalType.PosIn)
copyINDEX ((* yyNew)->FormalType.PosOut, yyt->FormalType.PosOut)
copyINDEX ((* yyNew)->FormalType.Kind, yyt->FormalType.Kind)
copytIdent ((* yyNew)->FormalType.Module, yyt->FormalType.Module)
copytIdents ((* yyNew)->FormalType.IdsIn, yyt->FormalType.IdsIn)
copytIdents ((* yyNew)->FormalType.IdsOut, yyt->FormalType.IdsOut)
copytLocalIds ((* yyNew)->FormalType.LocalIdsIn, yyt->FormalType.LocalIdsIn)
copytLocalIds ((* yyNew)->FormalType.LocalIdsOut, yyt->FormalType.LocalIdsOut)
copyBOOLEAN ((* yyNew)->FormalType.IsVAR, yyt->FormalType.IsVAR)
copytTree ((* yyNew)->FormalType.Type, yyt->FormalType.Type)
yyt = yyt->FormalType.Next;
yyNew = & (* yyNew)->FormalType.Next; break;
case kEnumIds: (* yyNew)->EnumIds = yyt->EnumIds;
copytType ((* yyNew)->EnumIds.Type, yyt->EnumIds.Type)
copytObjects ((* yyNew)->EnumIds.Objects, yyt->EnumIds.Objects)
copyINDEX ((* yyNew)->EnumIds.IndexIn, yyt->EnumIds.IndexIn)
copyINDEX ((* yyNew)->EnumIds.IndexOut, yyt->EnumIds.IndexOut)
copyINDEX ((* yyNew)->EnumIds.Kind, yyt->EnumIds.Kind)
copytIdent ((* yyNew)->EnumIds.Module, yyt->EnumIds.Module)
copytIdents ((* yyNew)->EnumIds.IdsIn, yyt->EnumIds.IdsIn)
copytIdents ((* yyNew)->EnumIds.IdsOut, yyt->EnumIds.IdsOut)
copytLocalIds ((* yyNew)->EnumIds.LocalIdsIn, yyt->EnumIds.LocalIdsIn)
copytLocalIds ((* yyNew)->EnumIds.LocalIdsOut, yyt->EnumIds.LocalIdsOut)
return;
case kNoEnumId: (* yyNew)->NoEnumId = yyt->NoEnumId;
copytType ((* yyNew)->NoEnumId.Type, yyt->NoEnumId.Type)
copytObjects ((* yyNew)->NoEnumId.Objects, yyt->NoEnumId.Objects)
copyINDEX ((* yyNew)->NoEnumId.IndexIn, yyt->NoEnumId.IndexIn)
copyINDEX ((* yyNew)->NoEnumId.IndexOut, yyt->NoEnumId.IndexOut)
copyINDEX ((* yyNew)->NoEnumId.Kind, yyt->NoEnumId.Kind)
copytIdent ((* yyNew)->NoEnumId.Module, yyt->NoEnumId.Module)
copytIdents ((* yyNew)->NoEnumId.IdsIn, yyt->NoEnumId.IdsIn)
copytIdents ((* yyNew)->NoEnumId.IdsOut, yyt->NoEnumId.IdsOut)
copytLocalIds ((* yyNew)->NoEnumId.LocalIdsIn, yyt->NoEnumId.LocalIdsIn)
copytLocalIds ((* yyNew)->NoEnumId.LocalIdsOut, yyt->NoEnumId.LocalIdsOut)
return;
case kEnumId: (* yyNew)->EnumId = yyt->EnumId;
copytType ((* yyNew)->EnumId.Type, yyt->EnumId.Type)
copytObjects ((* yyNew)->EnumId.Objects, yyt->EnumId.Objects)
copyINDEX ((* yyNew)->EnumId.IndexIn, yyt->EnumId.IndexIn)
copyINDEX ((* yyNew)->EnumId.IndexOut, yyt->EnumId.IndexOut)
copyINDEX ((* yyNew)->EnumId.Kind, yyt->EnumId.Kind)
copytIdent ((* yyNew)->EnumId.Module, yyt->EnumId.Module)
copytIdents ((* yyNew)->EnumId.IdsIn, yyt->EnumId.IdsIn)
copytIdents ((* yyNew)->EnumId.IdsOut, yyt->EnumId.IdsOut)
copytLocalIds ((* yyNew)->EnumId.LocalIdsIn, yyt->EnumId.LocalIdsIn)
copytLocalIds ((* yyNew)->EnumId.LocalIdsOut, yyt->EnumId.LocalIdsOut)
copytIdent ((* yyNew)->EnumId.Ident, yyt->EnumId.Ident)
copytPosition ((* yyNew)->EnumId.Pos, yyt->EnumId.Pos)
copytObject ((* yyNew)->EnumId.Object, yyt->EnumId.Object)
copytIdent ((* yyNew)->EnumId.CIdent, yyt->EnumId.CIdent)
copyBOOLEAN ((* yyNew)->EnumId.IsRedeclared, yyt->EnumId.IsRedeclared)
yyt = yyt->EnumId.Next;
yyNew = & (* yyNew)->EnumId.Next; break;
case kExpr: (* yyNew)->Expr = yyt->Expr;
copytEnv ((* yyNew)->Expr.Env, yyt->Expr.Env)
copyBOOLEAN ((* yyNew)->Expr.IsLval, yyt->Expr.IsLval)
copytType ((* yyNew)->Expr.Type, yyt->Expr.Type)
copyINDEX ((* yyNew)->Expr.Level, yyt->Expr.Level)
copyBOOLEAN ((* yyNew)->Expr.UseHelpVar, yyt->Expr.UseHelpVar)
copyBOOLEAN ((* yyNew)->Expr.THelpVar, yyt->Expr.THelpVar)
copyBOOLEAN ((* yyNew)->Expr.TakeHelpVar, yyt->Expr.TakeHelpVar)
copytIdent ((* yyNew)->Expr.HelpVar, yyt->Expr.HelpVar)
copyBOOLEAN ((* yyNew)->Expr.IsFirstDesignator, yyt->Expr.IsFirstDesignator)
copyBOOLEAN ((* yyNew)->Expr.HasProcOrDimSucc, yyt->Expr.HasProcOrDimSucc)
copyBOOLEAN ((* yyNew)->Expr.WriteVectorIndex, yyt->Expr.WriteVectorIndex)
copytTree ((* yyNew)->Expr.ProcOrDimSpec, yyt->Expr.ProcOrDimSpec)
copyBOOLEAN ((* yyNew)->Expr.WriteProcOrDimIndex, yyt->Expr.WriteProcOrDimIndex)
copyBOOLEAN ((* yyNew)->Expr.IsCConst, yyt->Expr.IsCConst)
copyBOOLEAN ((* yyNew)->Expr.IsP3Const, yyt->Expr.IsP3Const)
copyBOOLEAN ((* yyNew)->Expr.OpenAccessOrCall, yyt->Expr.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->Expr.GlobalPtrs, yyt->Expr.GlobalPtrs)
copytStrings ((* yyNew)->Expr.StrsIn, yyt->Expr.StrsIn)
copytStrings ((* yyNew)->Expr.StrsOut, yyt->Expr.StrsOut)
return;
case kNoExpr: (* yyNew)->NoExpr = yyt->NoExpr;
copytEnv ((* yyNew)->NoExpr.Env, yyt->NoExpr.Env)
copyBOOLEAN ((* yyNew)->NoExpr.IsLval, yyt->NoExpr.IsLval)
copytType ((* yyNew)->NoExpr.Type, yyt->NoExpr.Type)
copyINDEX ((* yyNew)->NoExpr.Level, yyt->NoExpr.Level)
copyBOOLEAN ((* yyNew)->NoExpr.UseHelpVar, yyt->NoExpr.UseHelpVar)
copyBOOLEAN ((* yyNew)->NoExpr.THelpVar, yyt->NoExpr.THelpVar)
copyBOOLEAN ((* yyNew)->NoExpr.TakeHelpVar, yyt->NoExpr.TakeHelpVar)
copytIdent ((* yyNew)->NoExpr.HelpVar, yyt->NoExpr.HelpVar)
copyBOOLEAN ((* yyNew)->NoExpr.IsFirstDesignator, yyt->NoExpr.IsFirstDesignator)
copyBOOLEAN ((* yyNew)->NoExpr.HasProcOrDimSucc, yyt->NoExpr.HasProcOrDimSucc)
copyBOOLEAN ((* yyNew)->NoExpr.WriteVectorIndex, yyt->NoExpr.WriteVectorIndex)
copytTree ((* yyNew)->NoExpr.ProcOrDimSpec, yyt->NoExpr.ProcOrDimSpec)
copyBOOLEAN ((* yyNew)->NoExpr.WriteProcOrDimIndex, yyt->NoExpr.WriteProcOrDimIndex)
copyBOOLEAN ((* yyNew)->NoExpr.IsCConst, yyt->NoExpr.IsCConst)
copyBOOLEAN ((* yyNew)->NoExpr.IsP3Const, yyt->NoExpr.IsP3Const)
copyBOOLEAN ((* yyNew)->NoExpr.OpenAccessOrCall, yyt->NoExpr.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->NoExpr.GlobalPtrs, yyt->NoExpr.GlobalPtrs)
copytStrings ((* yyNew)->NoExpr.StrsIn, yyt->NoExpr.StrsIn)
copytStrings ((* yyNew)->NoExpr.StrsOut, yyt->NoExpr.StrsOut)
return;
case kMultiples: (* yyNew)->Multiples = yyt->Multiples;
copytEnv ((* yyNew)->Multiples.Env, yyt->Multiples.Env)
copyBOOLEAN ((* yyNew)->Multiples.IsLval, yyt->Multiples.IsLval)
copytType ((* yyNew)->Multiples.Type, yyt->Multiples.Type)
copyINDEX ((* yyNew)->Multiples.Level, yyt->Multiples.Level)
copyBOOLEAN ((* yyNew)->Multiples.UseHelpVar, yyt->Multiples.UseHelpVar)
copyBOOLEAN ((* yyNew)->Multiples.THelpVar, yyt->Multiples.THelpVar)
copyBOOLEAN ((* yyNew)->Multiples.TakeHelpVar, yyt->Multiples.TakeHelpVar)
copytIdent ((* yyNew)->Multiples.HelpVar, yyt->Multiples.HelpVar)
copyBOOLEAN ((* yyNew)->Multiples.IsFirstDesignator, yyt->Multiples.IsFirstDesignator)
copyBOOLEAN ((* yyNew)->Multiples.HasProcOrDimSucc, yyt->Multiples.HasProcOrDimSucc)
copyBOOLEAN ((* yyNew)->Multiples.WriteVectorIndex, yyt->Multiples.WriteVectorIndex)
copytTree ((* yyNew)->Multiples.ProcOrDimSpec, yyt->Multiples.ProcOrDimSpec)
copyBOOLEAN ((* yyNew)->Multiples.WriteProcOrDimIndex, yyt->Multiples.WriteProcOrDimIndex)
copyBOOLEAN ((* yyNew)->Multiples.IsCConst, yyt->Multiples.IsCConst)
copyBOOLEAN ((* yyNew)->Multiples.IsP3Const, yyt->Multiples.IsP3Const)
copyBOOLEAN ((* yyNew)->Multiples.OpenAccessOrCall, yyt->Multiples.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->Multiples.GlobalPtrs, yyt->Multiples.GlobalPtrs)
copytStrings ((* yyNew)->Multiples.StrsIn, yyt->Multiples.StrsIn)
copytStrings ((* yyNew)->Multiples.StrsOut, yyt->Multiples.StrsOut)
copytType ((* yyNew)->Multiples.MultiType, yyt->Multiples.MultiType)
yyt = yyt->Multiples.Mop;
yyNew = & (* yyNew)->Multiples.Mop; break;
case kLastMultiple: (* yyNew)->LastMultiple = yyt->LastMultiple;
copytEnv ((* yyNew)->LastMultiple.Env, yyt->LastMultiple.Env)
copyBOOLEAN ((* yyNew)->LastMultiple.IsLval, yyt->LastMultiple.IsLval)
copytType ((* yyNew)->LastMultiple.Type, yyt->LastMultiple.Type)
copyINDEX ((* yyNew)->LastMultiple.Level, yyt->LastMultiple.Level)
copyBOOLEAN ((* yyNew)->LastMultiple.UseHelpVar, yyt->LastMultiple.UseHelpVar)
copyBOOLEAN ((* yyNew)->LastMultiple.THelpVar, yyt->LastMultiple.THelpVar)
copyBOOLEAN ((* yyNew)->LastMultiple.TakeHelpVar, yyt->LastMultiple.TakeHelpVar)
copytIdent ((* yyNew)->LastMultiple.HelpVar, yyt->LastMultiple.HelpVar)
copyBOOLEAN ((* yyNew)->LastMultiple.IsFirstDesignator, yyt->LastMultiple.IsFirstDesignator)
copyBOOLEAN ((* yyNew)->LastMultiple.HasProcOrDimSucc, yyt->LastMultiple.HasProcOrDimSucc)
copyBOOLEAN ((* yyNew)->LastMultiple.WriteVectorIndex, yyt->LastMultiple.WriteVectorIndex)
copytTree ((* yyNew)->LastMultiple.ProcOrDimSpec, yyt->LastMultiple.ProcOrDimSpec)
copyBOOLEAN ((* yyNew)->LastMultiple.WriteProcOrDimIndex, yyt->LastMultiple.WriteProcOrDimIndex)
copyBOOLEAN ((* yyNew)->LastMultiple.IsCConst, yyt->LastMultiple.IsCConst)
copyBOOLEAN ((* yyNew)->LastMultiple.IsP3Const, yyt->LastMultiple.IsP3Const)
copyBOOLEAN ((* yyNew)->LastMultiple.OpenAccessOrCall, yyt->LastMultiple.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->LastMultiple.GlobalPtrs, yyt->LastMultiple.GlobalPtrs)
copytStrings ((* yyNew)->LastMultiple.StrsIn, yyt->LastMultiple.StrsIn)
copytStrings ((* yyNew)->LastMultiple.StrsOut, yyt->LastMultiple.StrsOut)
copytType ((* yyNew)->LastMultiple.MultiType, yyt->LastMultiple.MultiType)
yyt = yyt->LastMultiple.Mop;
yyNew = & (* yyNew)->LastMultiple.Mop; break;
case kMultiple: (* yyNew)->Multiple = yyt->Multiple;
copytEnv ((* yyNew)->Multiple.Env, yyt->Multiple.Env)
copyBOOLEAN ((* yyNew)->Multiple.IsLval, yyt->Multiple.IsLval)
copytType ((* yyNew)->Multiple.Type, yyt->Multiple.Type)
copyINDEX ((* yyNew)->Multiple.Level, yyt->Multiple.Level)
copyBOOLEAN ((* yyNew)->Multiple.UseHelpVar, yyt->Multiple.UseHelpVar)
copyBOOLEAN ((* yyNew)->Multiple.THelpVar, yyt->Multiple.THelpVar)
copyBOOLEAN ((* yyNew)->Multiple.TakeHelpVar, yyt->Multiple.TakeHelpVar)
copytIdent ((* yyNew)->Multiple.HelpVar, yyt->Multiple.HelpVar)
copyBOOLEAN ((* yyNew)->Multiple.IsFirstDesignator, yyt->Multiple.IsFirstDesignator)
copyBOOLEAN ((* yyNew)->Multiple.HasProcOrDimSucc, yyt->Multiple.HasProcOrDimSucc)
copyBOOLEAN ((* yyNew)->Multiple.WriteVectorIndex, yyt->Multiple.WriteVectorIndex)
copytTree ((* yyNew)->Multiple.ProcOrDimSpec, yyt->Multiple.ProcOrDimSpec)
copyBOOLEAN ((* yyNew)->Multiple.WriteProcOrDimIndex, yyt->Multiple.WriteProcOrDimIndex)
copyBOOLEAN ((* yyNew)->Multiple.IsCConst, yyt->Multiple.IsCConst)
copyBOOLEAN ((* yyNew)->Multiple.IsP3Const, yyt->Multiple.IsP3Const)
copyBOOLEAN ((* yyNew)->Multiple.OpenAccessOrCall, yyt->Multiple.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->Multiple.GlobalPtrs, yyt->Multiple.GlobalPtrs)
copytStrings ((* yyNew)->Multiple.StrsIn, yyt->Multiple.StrsIn)
copytStrings ((* yyNew)->Multiple.StrsOut, yyt->Multiple.StrsOut)
copytTree ((* yyNew)->Multiple.Mop, yyt->Multiple.Mop)
copytType ((* yyNew)->Multiple.MultiType, yyt->Multiple.MultiType)
copytPosition ((* yyNew)->Multiple.Pos, yyt->Multiple.Pos)
copyINDEX ((* yyNew)->Multiple.Operator, yyt->Multiple.Operator)
copyINDEX ((* yyNew)->Multiple.COperator, yyt->Multiple.COperator)
yyt = yyt->Multiple.Multiples;
yyNew = & (* yyNew)->Multiple.Multiples; break;
case kBinary: (* yyNew)->Binary = yyt->Binary;
copytEnv ((* yyNew)->Binary.Env, yyt->Binary.Env)
copyBOOLEAN ((* yyNew)->Binary.IsLval, yyt->Binary.IsLval)
copytType ((* yyNew)->Binary.Type, yyt->Binary.Type)
copyINDEX ((* yyNew)->Binary.Level, yyt->Binary.Level)
copyBOOLEAN ((* yyNew)->Binary.UseHelpVar, yyt->Binary.UseHelpVar)
copyBOOLEAN ((* yyNew)->Binary.THelpVar, yyt->Binary.THelpVar)
copyBOOLEAN ((* yyNew)->Binary.TakeHelpVar, yyt->Binary.TakeHelpVar)
copytIdent ((* yyNew)->Binary.HelpVar, yyt->Binary.HelpVar)
copyBOOLEAN ((* yyNew)->Binary.IsFirstDesignator, yyt->Binary.IsFirstDesignator)
copyBOOLEAN ((* yyNew)->Binary.HasProcOrDimSucc, yyt->Binary.HasProcOrDimSucc)
copyBOOLEAN ((* yyNew)->Binary.WriteVectorIndex, yyt->Binary.WriteVectorIndex)
copytTree ((* yyNew)->Binary.ProcOrDimSpec, yyt->Binary.ProcOrDimSpec)
copyBOOLEAN ((* yyNew)->Binary.WriteProcOrDimIndex, yyt->Binary.WriteProcOrDimIndex)
copyBOOLEAN ((* yyNew)->Binary.IsCConst, yyt->Binary.IsCConst)
copyBOOLEAN ((* yyNew)->Binary.IsP3Const, yyt->Binary.IsP3Const)
copyBOOLEAN ((* yyNew)->Binary.OpenAccessOrCall, yyt->Binary.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->Binary.GlobalPtrs, yyt->Binary.GlobalPtrs)
copytStrings ((* yyNew)->Binary.StrsIn, yyt->Binary.StrsIn)
copytStrings ((* yyNew)->Binary.StrsOut, yyt->Binary.StrsOut)
copytPosition ((* yyNew)->Binary.Pos, yyt->Binary.Pos)
copyINDEX ((* yyNew)->Binary.Operator, yyt->Binary.Operator)
copytTree ((* yyNew)->Binary.Lop, yyt->Binary.Lop)
copyINDEX ((* yyNew)->Binary.COperator, yyt->Binary.COperator)
yyt = yyt->Binary.Rop;
yyNew = & (* yyNew)->Binary.Rop; break;
case kUnary: (* yyNew)->Unary = yyt->Unary;
copytEnv ((* yyNew)->Unary.Env, yyt->Unary.Env)
copyBOOLEAN ((* yyNew)->Unary.IsLval, yyt->Unary.IsLval)
copytType ((* yyNew)->Unary.Type, yyt->Unary.Type)
copyINDEX ((* yyNew)->Unary.Level, yyt->Unary.Level)
copyBOOLEAN ((* yyNew)->Unary.UseHelpVar, yyt->Unary.UseHelpVar)
copyBOOLEAN ((* yyNew)->Unary.THelpVar, yyt->Unary.THelpVar)
copyBOOLEAN ((* yyNew)->Unary.TakeHelpVar, yyt->Unary.TakeHelpVar)
copytIdent ((* yyNew)->Unary.HelpVar, yyt->Unary.HelpVar)
copyBOOLEAN ((* yyNew)->Unary.IsFirstDesignator, yyt->Unary.IsFirstDesignator)
copyBOOLEAN ((* yyNew)->Unary.HasProcOrDimSucc, yyt->Unary.HasProcOrDimSucc)
copyBOOLEAN ((* yyNew)->Unary.WriteVectorIndex, yyt->Unary.WriteVectorIndex)
copytTree ((* yyNew)->Unary.ProcOrDimSpec, yyt->Unary.ProcOrDimSpec)
copyBOOLEAN ((* yyNew)->Unary.WriteProcOrDimIndex, yyt->Unary.WriteProcOrDimIndex)
copyBOOLEAN ((* yyNew)->Unary.IsCConst, yyt->Unary.IsCConst)
copyBOOLEAN ((* yyNew)->Unary.IsP3Const, yyt->Unary.IsP3Const)
copyBOOLEAN ((* yyNew)->Unary.OpenAccessOrCall, yyt->Unary.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->Unary.GlobalPtrs, yyt->Unary.GlobalPtrs)
copytStrings ((* yyNew)->Unary.StrsIn, yyt->Unary.StrsIn)
copytStrings ((* yyNew)->Unary.StrsOut, yyt->Unary.StrsOut)
copytPosition ((* yyNew)->Unary.Pos, yyt->Unary.Pos)
copyINDEX ((* yyNew)->Unary.Operator, yyt->Unary.Operator)
copyINDEX ((* yyNew)->Unary.COperator, yyt->Unary.COperator)
yyt = yyt->Unary.Mop;
yyNew = & (* yyNew)->Unary.Mop; break;
case kIntConst: (* yyNew)->IntConst = yyt->IntConst;
copytEnv ((* yyNew)->IntConst.Env, yyt->IntConst.Env)
copyBOOLEAN ((* yyNew)->IntConst.IsLval, yyt->IntConst.IsLval)
copytType ((* yyNew)->IntConst.Type, yyt->IntConst.Type)
copyINDEX ((* yyNew)->IntConst.Level, yyt->IntConst.Level)
copyBOOLEAN ((* yyNew)->IntConst.UseHelpVar, yyt->IntConst.UseHelpVar)
copyBOOLEAN ((* yyNew)->IntConst.THelpVar, yyt->IntConst.THelpVar)
copyBOOLEAN ((* yyNew)->IntConst.TakeHelpVar, yyt->IntConst.TakeHelpVar)
copytIdent ((* yyNew)->IntConst.HelpVar, yyt->IntConst.HelpVar)
copyBOOLEAN ((* yyNew)->IntConst.IsFirstDesignator, yyt->IntConst.IsFirstDesignator)
copyBOOLEAN ((* yyNew)->IntConst.HasProcOrDimSucc, yyt->IntConst.HasProcOrDimSucc)
copyBOOLEAN ((* yyNew)->IntConst.WriteVectorIndex, yyt->IntConst.WriteVectorIndex)
copytTree ((* yyNew)->IntConst.ProcOrDimSpec, yyt->IntConst.ProcOrDimSpec)
copyBOOLEAN ((* yyNew)->IntConst.WriteProcOrDimIndex, yyt->IntConst.WriteProcOrDimIndex)
copyBOOLEAN ((* yyNew)->IntConst.IsCConst, yyt->IntConst.IsCConst)
copyBOOLEAN ((* yyNew)->IntConst.IsP3Const, yyt->IntConst.IsP3Const)
copyBOOLEAN ((* yyNew)->IntConst.OpenAccessOrCall, yyt->IntConst.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->IntConst.GlobalPtrs, yyt->IntConst.GlobalPtrs)
copytStrings ((* yyNew)->IntConst.StrsIn, yyt->IntConst.StrsIn)
copytStrings ((* yyNew)->IntConst.StrsOut, yyt->IntConst.StrsOut)
copytPosition ((* yyNew)->IntConst.Pos, yyt->IntConst.Pos)
copyINDEX ((* yyNew)->IntConst.Kind, yyt->IntConst.Kind)
copyULONG ((* yyNew)->IntConst.IntVal, yyt->IntConst.IntVal)
return;
case kRealConst: (* yyNew)->RealConst = yyt->RealConst;
copytEnv ((* yyNew)->RealConst.Env, yyt->RealConst.Env)
copyBOOLEAN ((* yyNew)->RealConst.IsLval, yyt->RealConst.IsLval)
copytType ((* yyNew)->RealConst.Type, yyt->RealConst.Type)
copyINDEX ((* yyNew)->RealConst.Level, yyt->RealConst.Level)
copyBOOLEAN ((* yyNew)->RealConst.UseHelpVar, yyt->RealConst.UseHelpVar)
copyBOOLEAN ((* yyNew)->RealConst.THelpVar, yyt->RealConst.THelpVar)
copyBOOLEAN ((* yyNew)->RealConst.TakeHelpVar, yyt->RealConst.TakeHelpVar)
copytIdent ((* yyNew)->RealConst.HelpVar, yyt->RealConst.HelpVar)
copyBOOLEAN ((* yyNew)->RealConst.IsFirstDesignator, yyt->RealConst.IsFirstDesignator)
copyBOOLEAN ((* yyNew)->RealConst.HasProcOrDimSucc, yyt->RealConst.HasProcOrDimSucc)
copyBOOLEAN ((* yyNew)->RealConst.WriteVectorIndex, yyt->RealConst.WriteVectorIndex)
copytTree ((* yyNew)->RealConst.ProcOrDimSpec, yyt->RealConst.ProcOrDimSpec)
copyBOOLEAN ((* yyNew)->RealConst.WriteProcOrDimIndex, yyt->RealConst.WriteProcOrDimIndex)
copyBOOLEAN ((* yyNew)->RealConst.IsCConst, yyt->RealConst.IsCConst)
copyBOOLEAN ((* yyNew)->RealConst.IsP3Const, yyt->RealConst.IsP3Const)
copyBOOLEAN ((* yyNew)->RealConst.OpenAccessOrCall, yyt->RealConst.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->RealConst.GlobalPtrs, yyt->RealConst.GlobalPtrs)
copytStrings ((* yyNew)->RealConst.StrsIn, yyt->RealConst.StrsIn)
copytStrings ((* yyNew)->RealConst.StrsOut, yyt->RealConst.StrsOut)
copytPosition ((* yyNew)->RealConst.Pos, yyt->RealConst.Pos)
copytStringRef ((* yyNew)->RealConst.RealVal, yyt->RealConst.RealVal)
return;
case kStringConst: (* yyNew)->StringConst = yyt->StringConst;
copytEnv ((* yyNew)->StringConst.Env, yyt->StringConst.Env)
copyBOOLEAN ((* yyNew)->StringConst.IsLval, yyt->StringConst.IsLval)
copytType ((* yyNew)->StringConst.Type, yyt->StringConst.Type)
copyINDEX ((* yyNew)->StringConst.Level, yyt->StringConst.Level)
copyBOOLEAN ((* yyNew)->StringConst.UseHelpVar, yyt->StringConst.UseHelpVar)
copyBOOLEAN ((* yyNew)->StringConst.THelpVar, yyt->StringConst.THelpVar)
copyBOOLEAN ((* yyNew)->StringConst.TakeHelpVar, yyt->StringConst.TakeHelpVar)
copytIdent ((* yyNew)->StringConst.HelpVar, yyt->StringConst.HelpVar)
copyBOOLEAN ((* yyNew)->StringConst.IsFirstDesignator, yyt->StringConst.IsFirstDesignator)
copyBOOLEAN ((* yyNew)->StringConst.HasProcOrDimSucc, yyt->StringConst.HasProcOrDimSucc)
copyBOOLEAN ((* yyNew)->StringConst.WriteVectorIndex, yyt->StringConst.WriteVectorIndex)
copytTree ((* yyNew)->StringConst.ProcOrDimSpec, yyt->StringConst.ProcOrDimSpec)
copyBOOLEAN ((* yyNew)->StringConst.WriteProcOrDimIndex, yyt->StringConst.WriteProcOrDimIndex)
copyBOOLEAN ((* yyNew)->StringConst.IsCConst, yyt->StringConst.IsCConst)
copyBOOLEAN ((* yyNew)->StringConst.IsP3Const, yyt->StringConst.IsP3Const)
copyBOOLEAN ((* yyNew)->StringConst.OpenAccessOrCall, yyt->StringConst.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->StringConst.GlobalPtrs, yyt->StringConst.GlobalPtrs)
copytStrings ((* yyNew)->StringConst.StrsIn, yyt->StringConst.StrsIn)
copytStrings ((* yyNew)->StringConst.StrsOut, yyt->StringConst.StrsOut)
copytPosition ((* yyNew)->StringConst.Pos, yyt->StringConst.Pos)
copytStringRef ((* yyNew)->StringConst.StringVal, yyt->StringConst.StringVal)
return;
case kCharConst: (* yyNew)->CharConst = yyt->CharConst;
copytEnv ((* yyNew)->CharConst.Env, yyt->CharConst.Env)
copyBOOLEAN ((* yyNew)->CharConst.IsLval, yyt->CharConst.IsLval)
copytType ((* yyNew)->CharConst.Type, yyt->CharConst.Type)
copyINDEX ((* yyNew)->CharConst.Level, yyt->CharConst.Level)
copyBOOLEAN ((* yyNew)->CharConst.UseHelpVar, yyt->CharConst.UseHelpVar)
copyBOOLEAN ((* yyNew)->CharConst.THelpVar, yyt->CharConst.THelpVar)
copyBOOLEAN ((* yyNew)->CharConst.TakeHelpVar, yyt->CharConst.TakeHelpVar)
copytIdent ((* yyNew)->CharConst.HelpVar, yyt->CharConst.HelpVar)
copyBOOLEAN ((* yyNew)->CharConst.IsFirstDesignator, yyt->CharConst.IsFirstDesignator)
copyBOOLEAN ((* yyNew)->CharConst.HasProcOrDimSucc, yyt->CharConst.HasProcOrDimSucc)
copyBOOLEAN ((* yyNew)->CharConst.WriteVectorIndex, yyt->CharConst.WriteVectorIndex)
copytTree ((* yyNew)->CharConst.ProcOrDimSpec, yyt->CharConst.ProcOrDimSpec)
copyBOOLEAN ((* yyNew)->CharConst.WriteProcOrDimIndex, yyt->CharConst.WriteProcOrDimIndex)
copyBOOLEAN ((* yyNew)->CharConst.IsCConst, yyt->CharConst.IsCConst)
copyBOOLEAN ((* yyNew)->CharConst.IsP3Const, yyt->CharConst.IsP3Const)
copyBOOLEAN ((* yyNew)->CharConst.OpenAccessOrCall, yyt->CharConst.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->CharConst.GlobalPtrs, yyt->CharConst.GlobalPtrs)
copytStrings ((* yyNew)->CharConst.StrsIn, yyt->CharConst.StrsIn)
copytStrings ((* yyNew)->CharConst.StrsOut, yyt->CharConst.StrsOut)
copytPosition ((* yyNew)->CharConst.Pos, yyt->CharConst.Pos)
copyUCHAR ((* yyNew)->CharConst.CharVal, yyt->CharConst.CharVal)
return;
case kFuncCall: (* yyNew)->FuncCall = yyt->FuncCall;
copytEnv ((* yyNew)->FuncCall.Env, yyt->FuncCall.Env)
copyBOOLEAN ((* yyNew)->FuncCall.IsLval, yyt->FuncCall.IsLval)
copytType ((* yyNew)->FuncCall.Type, yyt->FuncCall.Type)
copyINDEX ((* yyNew)->FuncCall.Level, yyt->FuncCall.Level)
copyBOOLEAN ((* yyNew)->FuncCall.UseHelpVar, yyt->FuncCall.UseHelpVar)
copyBOOLEAN ((* yyNew)->FuncCall.THelpVar, yyt->FuncCall.THelpVar)
copyBOOLEAN ((* yyNew)->FuncCall.TakeHelpVar, yyt->FuncCall.TakeHelpVar)
copytIdent ((* yyNew)->FuncCall.HelpVar, yyt->FuncCall.HelpVar)
copyBOOLEAN ((* yyNew)->FuncCall.IsFirstDesignator, yyt->FuncCall.IsFirstDesignator)
copyBOOLEAN ((* yyNew)->FuncCall.HasProcOrDimSucc, yyt->FuncCall.HasProcOrDimSucc)
copyBOOLEAN ((* yyNew)->FuncCall.WriteVectorIndex, yyt->FuncCall.WriteVectorIndex)
copytTree ((* yyNew)->FuncCall.ProcOrDimSpec, yyt->FuncCall.ProcOrDimSpec)
copyBOOLEAN ((* yyNew)->FuncCall.WriteProcOrDimIndex, yyt->FuncCall.WriteProcOrDimIndex)
copyBOOLEAN ((* yyNew)->FuncCall.IsCConst, yyt->FuncCall.IsCConst)
copyBOOLEAN ((* yyNew)->FuncCall.IsP3Const, yyt->FuncCall.IsP3Const)
copyBOOLEAN ((* yyNew)->FuncCall.OpenAccessOrCall, yyt->FuncCall.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->FuncCall.GlobalPtrs, yyt->FuncCall.GlobalPtrs)
copytStrings ((* yyNew)->FuncCall.StrsIn, yyt->FuncCall.StrsIn)
copytStrings ((* yyNew)->FuncCall.StrsOut, yyt->FuncCall.StrsOut)
copytTree ((* yyNew)->FuncCall.Designator, yyt->FuncCall.Designator)
yyt = yyt->FuncCall.Actuals;
yyNew = & (* yyNew)->FuncCall.Actuals; break;
case kMove: (* yyNew)->Move = yyt->Move;
copytEnv ((* yyNew)->Move.Env, yyt->Move.Env)
copyBOOLEAN ((* yyNew)->Move.IsLval, yyt->Move.IsLval)
copytType ((* yyNew)->Move.Type, yyt->Move.Type)
copyINDEX ((* yyNew)->Move.Level, yyt->Move.Level)
copyBOOLEAN ((* yyNew)->Move.UseHelpVar, yyt->Move.UseHelpVar)
copyBOOLEAN ((* yyNew)->Move.THelpVar, yyt->Move.THelpVar)
copyBOOLEAN ((* yyNew)->Move.TakeHelpVar, yyt->Move.TakeHelpVar)
copytIdent ((* yyNew)->Move.HelpVar, yyt->Move.HelpVar)
copyBOOLEAN ((* yyNew)->Move.IsFirstDesignator, yyt->Move.IsFirstDesignator)
copyBOOLEAN ((* yyNew)->Move.HasProcOrDimSucc, yyt->Move.HasProcOrDimSucc)
copyBOOLEAN ((* yyNew)->Move.WriteVectorIndex, yyt->Move.WriteVectorIndex)
copytTree ((* yyNew)->Move.ProcOrDimSpec, yyt->Move.ProcOrDimSpec)
copyBOOLEAN ((* yyNew)->Move.WriteProcOrDimIndex, yyt->Move.WriteProcOrDimIndex)
copyBOOLEAN ((* yyNew)->Move.IsCConst, yyt->Move.IsCConst)
copyBOOLEAN ((* yyNew)->Move.IsP3Const, yyt->Move.IsP3Const)
copyBOOLEAN ((* yyNew)->Move.OpenAccessOrCall, yyt->Move.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->Move.GlobalPtrs, yyt->Move.GlobalPtrs)
copytStrings ((* yyNew)->Move.StrsIn, yyt->Move.StrsIn)
copytStrings ((* yyNew)->Move.StrsOut, yyt->Move.StrsOut)
copytTree ((* yyNew)->Move.DirSpec, yyt->Move.DirSpec)
yyt = yyt->Move.Expr;
yyNew = & (* yyNew)->Move.Expr; break;
case kReceive: (* yyNew)->Receive = yyt->Receive;
copytEnv ((* yyNew)->Receive.Env, yyt->Receive.Env)
copyBOOLEAN ((* yyNew)->Receive.IsLval, yyt->Receive.IsLval)
copytType ((* yyNew)->Receive.Type, yyt->Receive.Type)
copyINDEX ((* yyNew)->Receive.Level, yyt->Receive.Level)
copyBOOLEAN ((* yyNew)->Receive.UseHelpVar, yyt->Receive.UseHelpVar)
copyBOOLEAN ((* yyNew)->Receive.THelpVar, yyt->Receive.THelpVar)
copyBOOLEAN ((* yyNew)->Receive.TakeHelpVar, yyt->Receive.TakeHelpVar)
copytIdent ((* yyNew)->Receive.HelpVar, yyt->Receive.HelpVar)
copyBOOLEAN ((* yyNew)->Receive.IsFirstDesignator, yyt->Receive.IsFirstDesignator)
copyBOOLEAN ((* yyNew)->Receive.HasProcOrDimSucc, yyt->Receive.HasProcOrDimSucc)
copyBOOLEAN ((* yyNew)->Receive.WriteVectorIndex, yyt->Receive.WriteVectorIndex)
copytTree ((* yyNew)->Receive.ProcOrDimSpec, yyt->Receive.ProcOrDimSpec)
copyBOOLEAN ((* yyNew)->Receive.WriteProcOrDimIndex, yyt->Receive.WriteProcOrDimIndex)
copyBOOLEAN ((* yyNew)->Receive.IsCConst, yyt->Receive.IsCConst)
copyBOOLEAN ((* yyNew)->Receive.IsP3Const, yyt->Receive.IsP3Const)
copyBOOLEAN ((* yyNew)->Receive.OpenAccessOrCall, yyt->Receive.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->Receive.GlobalPtrs, yyt->Receive.GlobalPtrs)
copytStrings ((* yyNew)->Receive.StrsIn, yyt->Receive.StrsIn)
copytStrings ((* yyNew)->Receive.StrsOut, yyt->Receive.StrsOut)
copytTree ((* yyNew)->Receive.DirSpec, yyt->Receive.DirSpec)
yyt = yyt->Receive.Expr;
yyNew = & (* yyNew)->Receive.Expr; break;
case kReduce: (* yyNew)->Reduce = yyt->Reduce;
copytEnv ((* yyNew)->Reduce.Env, yyt->Reduce.Env)
copyBOOLEAN ((* yyNew)->Reduce.IsLval, yyt->Reduce.IsLval)
copytType ((* yyNew)->Reduce.Type, yyt->Reduce.Type)
copyINDEX ((* yyNew)->Reduce.Level, yyt->Reduce.Level)
copyBOOLEAN ((* yyNew)->Reduce.UseHelpVar, yyt->Reduce.UseHelpVar)
copyBOOLEAN ((* yyNew)->Reduce.THelpVar, yyt->Reduce.THelpVar)
copyBOOLEAN ((* yyNew)->Reduce.TakeHelpVar, yyt->Reduce.TakeHelpVar)
copytIdent ((* yyNew)->Reduce.HelpVar, yyt->Reduce.HelpVar)
copyBOOLEAN ((* yyNew)->Reduce.IsFirstDesignator, yyt->Reduce.IsFirstDesignator)
copyBOOLEAN ((* yyNew)->Reduce.HasProcOrDimSucc, yyt->Reduce.HasProcOrDimSucc)
copyBOOLEAN ((* yyNew)->Reduce.WriteVectorIndex, yyt->Reduce.WriteVectorIndex)
copytTree ((* yyNew)->Reduce.ProcOrDimSpec, yyt->Reduce.ProcOrDimSpec)
copyBOOLEAN ((* yyNew)->Reduce.WriteProcOrDimIndex, yyt->Reduce.WriteProcOrDimIndex)
copyBOOLEAN ((* yyNew)->Reduce.IsCConst, yyt->Reduce.IsCConst)
copyBOOLEAN ((* yyNew)->Reduce.IsP3Const, yyt->Reduce.IsP3Const)
copyBOOLEAN ((* yyNew)->Reduce.OpenAccessOrCall, yyt->Reduce.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->Reduce.GlobalPtrs, yyt->Reduce.GlobalPtrs)
copytStrings ((* yyNew)->Reduce.StrsIn, yyt->Reduce.StrsIn)
copytStrings ((* yyNew)->Reduce.StrsOut, yyt->Reduce.StrsOut)
copytTree ((* yyNew)->Reduce.Reduce, yyt->Reduce.Reduce)
yyt = yyt->Reduce.Expr;
yyNew = & (* yyNew)->Reduce.Expr; break;
case kSet: (* yyNew)->Set = yyt->Set;
copytEnv ((* yyNew)->Set.Env, yyt->Set.Env)
copyBOOLEAN ((* yyNew)->Set.IsLval, yyt->Set.IsLval)
copytType ((* yyNew)->Set.Type, yyt->Set.Type)
copyINDEX ((* yyNew)->Set.Level, yyt->Set.Level)
copyBOOLEAN ((* yyNew)->Set.UseHelpVar, yyt->Set.UseHelpVar)
copyBOOLEAN ((* yyNew)->Set.THelpVar, yyt->Set.THelpVar)
copyBOOLEAN ((* yyNew)->Set.TakeHelpVar, yyt->Set.TakeHelpVar)
copytIdent ((* yyNew)->Set.HelpVar, yyt->Set.HelpVar)
copyBOOLEAN ((* yyNew)->Set.IsFirstDesignator, yyt->Set.IsFirstDesignator)
copyBOOLEAN ((* yyNew)->Set.HasProcOrDimSucc, yyt->Set.HasProcOrDimSucc)
copyBOOLEAN ((* yyNew)->Set.WriteVectorIndex, yyt->Set.WriteVectorIndex)
copytTree ((* yyNew)->Set.ProcOrDimSpec, yyt->Set.ProcOrDimSpec)
copyBOOLEAN ((* yyNew)->Set.WriteProcOrDimIndex, yyt->Set.WriteProcOrDimIndex)
copyBOOLEAN ((* yyNew)->Set.IsCConst, yyt->Set.IsCConst)
copyBOOLEAN ((* yyNew)->Set.IsP3Const, yyt->Set.IsP3Const)
copyBOOLEAN ((* yyNew)->Set.OpenAccessOrCall, yyt->Set.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->Set.GlobalPtrs, yyt->Set.GlobalPtrs)
copytStrings ((* yyNew)->Set.StrsIn, yyt->Set.StrsIn)
copytStrings ((* yyNew)->Set.StrsOut, yyt->Set.StrsOut)
copytTree ((* yyNew)->Set.BaseType, yyt->Set.BaseType)
yyt = yyt->Set.Elems;
yyNew = & (* yyNew)->Set.Elems; break;
case kBitSet: (* yyNew)->BitSet = yyt->BitSet;
copytEnv ((* yyNew)->BitSet.Env, yyt->BitSet.Env)
copyBOOLEAN ((* yyNew)->BitSet.IsLval, yyt->BitSet.IsLval)
copytType ((* yyNew)->BitSet.Type, yyt->BitSet.Type)
copyINDEX ((* yyNew)->BitSet.Level, yyt->BitSet.Level)
copyBOOLEAN ((* yyNew)->BitSet.UseHelpVar, yyt->BitSet.UseHelpVar)
copyBOOLEAN ((* yyNew)->BitSet.THelpVar, yyt->BitSet.THelpVar)
copyBOOLEAN ((* yyNew)->BitSet.TakeHelpVar, yyt->BitSet.TakeHelpVar)
copytIdent ((* yyNew)->BitSet.HelpVar, yyt->BitSet.HelpVar)
copyBOOLEAN ((* yyNew)->BitSet.IsFirstDesignator, yyt->BitSet.IsFirstDesignator)
copyBOOLEAN ((* yyNew)->BitSet.HasProcOrDimSucc, yyt->BitSet.HasProcOrDimSucc)
copyBOOLEAN ((* yyNew)->BitSet.WriteVectorIndex, yyt->BitSet.WriteVectorIndex)
copytTree ((* yyNew)->BitSet.ProcOrDimSpec, yyt->BitSet.ProcOrDimSpec)
copyBOOLEAN ((* yyNew)->BitSet.WriteProcOrDimIndex, yyt->BitSet.WriteProcOrDimIndex)
copyBOOLEAN ((* yyNew)->BitSet.IsCConst, yyt->BitSet.IsCConst)
copyBOOLEAN ((* yyNew)->BitSet.IsP3Const, yyt->BitSet.IsP3Const)
copyBOOLEAN ((* yyNew)->BitSet.OpenAccessOrCall, yyt->BitSet.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->BitSet.GlobalPtrs, yyt->BitSet.GlobalPtrs)
copytStrings ((* yyNew)->BitSet.StrsIn, yyt->BitSet.StrsIn)
copytStrings ((* yyNew)->BitSet.StrsOut, yyt->BitSet.StrsOut)
yyt = yyt->BitSet.Elems;
yyNew = & (* yyNew)->BitSet.Elems; break;
case kDesignator: (* yyNew)->Designator = yyt->Designator;
copytEnv ((* yyNew)->Designator.Env, yyt->Designator.Env)
copyBOOLEAN ((* yyNew)->Designator.IsLval, yyt->Designator.IsLval)
copytType ((* yyNew)->Designator.Type, yyt->Designator.Type)
copyINDEX ((* yyNew)->Designator.Level, yyt->Designator.Level)
copyBOOLEAN ((* yyNew)->Designator.UseHelpVar, yyt->Designator.UseHelpVar)
copyBOOLEAN ((* yyNew)->Designator.THelpVar, yyt->Designator.THelpVar)
copyBOOLEAN ((* yyNew)->Designator.TakeHelpVar, yyt->Designator.TakeHelpVar)
copytIdent ((* yyNew)->Designator.HelpVar, yyt->Designator.HelpVar)
copyBOOLEAN ((* yyNew)->Designator.IsFirstDesignator, yyt->Designator.IsFirstDesignator)
copyBOOLEAN ((* yyNew)->Designator.HasProcOrDimSucc, yyt->Designator.HasProcOrDimSucc)
copyBOOLEAN ((* yyNew)->Designator.WriteVectorIndex, yyt->Designator.WriteVectorIndex)
copytTree ((* yyNew)->Designator.ProcOrDimSpec, yyt->Designator.ProcOrDimSpec)
copyBOOLEAN ((* yyNew)->Designator.WriteProcOrDimIndex, yyt->Designator.WriteProcOrDimIndex)
copyBOOLEAN ((* yyNew)->Designator.IsCConst, yyt->Designator.IsCConst)
copyBOOLEAN ((* yyNew)->Designator.IsP3Const, yyt->Designator.IsP3Const)
copyBOOLEAN ((* yyNew)->Designator.OpenAccessOrCall, yyt->Designator.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->Designator.GlobalPtrs, yyt->Designator.GlobalPtrs)
copytStrings ((* yyNew)->Designator.StrsIn, yyt->Designator.StrsIn)
copytStrings ((* yyNew)->Designator.StrsOut, yyt->Designator.StrsOut)
return;
case kQualid: (* yyNew)->Qualid = yyt->Qualid;
copytEnv ((* yyNew)->Qualid.Env, yyt->Qualid.Env)
copyBOOLEAN ((* yyNew)->Qualid.IsLval, yyt->Qualid.IsLval)
copytType ((* yyNew)->Qualid.Type, yyt->Qualid.Type)
copyINDEX ((* yyNew)->Qualid.Level, yyt->Qualid.Level)
copyBOOLEAN ((* yyNew)->Qualid.UseHelpVar, yyt->Qualid.UseHelpVar)
copyBOOLEAN ((* yyNew)->Qualid.THelpVar, yyt->Qualid.THelpVar)
copyBOOLEAN ((* yyNew)->Qualid.TakeHelpVar, yyt->Qualid.TakeHelpVar)
copytIdent ((* yyNew)->Qualid.HelpVar, yyt->Qualid.HelpVar)
copyBOOLEAN ((* yyNew)->Qualid.IsFirstDesignator, yyt->Qualid.IsFirstDesignator)
copyBOOLEAN ((* yyNew)->Qualid.HasProcOrDimSucc, yyt->Qualid.HasProcOrDimSucc)
copyBOOLEAN ((* yyNew)->Qualid.WriteVectorIndex, yyt->Qualid.WriteVectorIndex)
copytTree ((* yyNew)->Qualid.ProcOrDimSpec, yyt->Qualid.ProcOrDimSpec)
copyBOOLEAN ((* yyNew)->Qualid.WriteProcOrDimIndex, yyt->Qualid.WriteProcOrDimIndex)
copyBOOLEAN ((* yyNew)->Qualid.IsCConst, yyt->Qualid.IsCConst)
copyBOOLEAN ((* yyNew)->Qualid.IsP3Const, yyt->Qualid.IsP3Const)
copyBOOLEAN ((* yyNew)->Qualid.OpenAccessOrCall, yyt->Qualid.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->Qualid.GlobalPtrs, yyt->Qualid.GlobalPtrs)
copytStrings ((* yyNew)->Qualid.StrsIn, yyt->Qualid.StrsIn)
copytStrings ((* yyNew)->Qualid.StrsOut, yyt->Qualid.StrsOut)
copytIdent ((* yyNew)->Qualid.Ident, yyt->Qualid.Ident)
copytPosition ((* yyNew)->Qualid.Pos, yyt->Qualid.Pos)
copytObject ((* yyNew)->Qualid.Object, yyt->Qualid.Object)
copyBOOLEAN ((* yyNew)->Qualid.IsGlobalPtr, yyt->Qualid.IsGlobalPtr)
return;
case kQualid0: (* yyNew)->Qualid0 = yyt->Qualid0;
copytEnv ((* yyNew)->Qualid0.Env, yyt->Qualid0.Env)
copyBOOLEAN ((* yyNew)->Qualid0.IsLval, yyt->Qualid0.IsLval)
copytType ((* yyNew)->Qualid0.Type, yyt->Qualid0.Type)
copyINDEX ((* yyNew)->Qualid0.Level, yyt->Qualid0.Level)
copyBOOLEAN ((* yyNew)->Qualid0.UseHelpVar, yyt->Qualid0.UseHelpVar)
copyBOOLEAN ((* yyNew)->Qualid0.THelpVar, yyt->Qualid0.THelpVar)
copyBOOLEAN ((* yyNew)->Qualid0.TakeHelpVar, yyt->Qualid0.TakeHelpVar)
copytIdent ((* yyNew)->Qualid0.HelpVar, yyt->Qualid0.HelpVar)
copyBOOLEAN ((* yyNew)->Qualid0.IsFirstDesignator, yyt->Qualid0.IsFirstDesignator)
copyBOOLEAN ((* yyNew)->Qualid0.HasProcOrDimSucc, yyt->Qualid0.HasProcOrDimSucc)
copyBOOLEAN ((* yyNew)->Qualid0.WriteVectorIndex, yyt->Qualid0.WriteVectorIndex)
copytTree ((* yyNew)->Qualid0.ProcOrDimSpec, yyt->Qualid0.ProcOrDimSpec)
copyBOOLEAN ((* yyNew)->Qualid0.WriteProcOrDimIndex, yyt->Qualid0.WriteProcOrDimIndex)
copyBOOLEAN ((* yyNew)->Qualid0.IsCConst, yyt->Qualid0.IsCConst)
copyBOOLEAN ((* yyNew)->Qualid0.IsP3Const, yyt->Qualid0.IsP3Const)
copyBOOLEAN ((* yyNew)->Qualid0.OpenAccessOrCall, yyt->Qualid0.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->Qualid0.GlobalPtrs, yyt->Qualid0.GlobalPtrs)
copytStrings ((* yyNew)->Qualid0.StrsIn, yyt->Qualid0.StrsIn)
copytStrings ((* yyNew)->Qualid0.StrsOut, yyt->Qualid0.StrsOut)
copytIdent ((* yyNew)->Qualid0.Ident, yyt->Qualid0.Ident)
copytPosition ((* yyNew)->Qualid0.Pos, yyt->Qualid0.Pos)
copytObject ((* yyNew)->Qualid0.Object, yyt->Qualid0.Object)
copyBOOLEAN ((* yyNew)->Qualid0.IsGlobalPtr, yyt->Qualid0.IsGlobalPtr)
return;
case kQualid1: (* yyNew)->Qualid1 = yyt->Qualid1;
copytEnv ((* yyNew)->Qualid1.Env, yyt->Qualid1.Env)
copyBOOLEAN ((* yyNew)->Qualid1.IsLval, yyt->Qualid1.IsLval)
copytType ((* yyNew)->Qualid1.Type, yyt->Qualid1.Type)
copyINDEX ((* yyNew)->Qualid1.Level, yyt->Qualid1.Level)
copyBOOLEAN ((* yyNew)->Qualid1.UseHelpVar, yyt->Qualid1.UseHelpVar)
copyBOOLEAN ((* yyNew)->Qualid1.THelpVar, yyt->Qualid1.THelpVar)
copyBOOLEAN ((* yyNew)->Qualid1.TakeHelpVar, yyt->Qualid1.TakeHelpVar)
copytIdent ((* yyNew)->Qualid1.HelpVar, yyt->Qualid1.HelpVar)
copyBOOLEAN ((* yyNew)->Qualid1.IsFirstDesignator, yyt->Qualid1.IsFirstDesignator)
copyBOOLEAN ((* yyNew)->Qualid1.HasProcOrDimSucc, yyt->Qualid1.HasProcOrDimSucc)
copyBOOLEAN ((* yyNew)->Qualid1.WriteVectorIndex, yyt->Qualid1.WriteVectorIndex)
copytTree ((* yyNew)->Qualid1.ProcOrDimSpec, yyt->Qualid1.ProcOrDimSpec)
copyBOOLEAN ((* yyNew)->Qualid1.WriteProcOrDimIndex, yyt->Qualid1.WriteProcOrDimIndex)
copyBOOLEAN ((* yyNew)->Qualid1.IsCConst, yyt->Qualid1.IsCConst)
copyBOOLEAN ((* yyNew)->Qualid1.IsP3Const, yyt->Qualid1.IsP3Const)
copyBOOLEAN ((* yyNew)->Qualid1.OpenAccessOrCall, yyt->Qualid1.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->Qualid1.GlobalPtrs, yyt->Qualid1.GlobalPtrs)
copytStrings ((* yyNew)->Qualid1.StrsIn, yyt->Qualid1.StrsIn)
copytStrings ((* yyNew)->Qualid1.StrsOut, yyt->Qualid1.StrsOut)
copytIdent ((* yyNew)->Qualid1.Ident, yyt->Qualid1.Ident)
copytPosition ((* yyNew)->Qualid1.Pos, yyt->Qualid1.Pos)
copytObject ((* yyNew)->Qualid1.Object, yyt->Qualid1.Object)
copyBOOLEAN ((* yyNew)->Qualid1.IsGlobalPtr, yyt->Qualid1.IsGlobalPtr)
yyt = yyt->Qualid1.Qualid;
yyNew = & (* yyNew)->Qualid1.Qualid; break;
case kProcessor: (* yyNew)->Processor = yyt->Processor;
copytEnv ((* yyNew)->Processor.Env, yyt->Processor.Env)
copyBOOLEAN ((* yyNew)->Processor.IsLval, yyt->Processor.IsLval)
copytType ((* yyNew)->Processor.Type, yyt->Processor.Type)
copyINDEX ((* yyNew)->Processor.Level, yyt->Processor.Level)
copyBOOLEAN ((* yyNew)->Processor.UseHelpVar, yyt->Processor.UseHelpVar)
copyBOOLEAN ((* yyNew)->Processor.THelpVar, yyt->Processor.THelpVar)
copyBOOLEAN ((* yyNew)->Processor.TakeHelpVar, yyt->Processor.TakeHelpVar)
copytIdent ((* yyNew)->Processor.HelpVar, yyt->Processor.HelpVar)
copyBOOLEAN ((* yyNew)->Processor.IsFirstDesignator, yyt->Processor.IsFirstDesignator)
copyBOOLEAN ((* yyNew)->Processor.HasProcOrDimSucc, yyt->Processor.HasProcOrDimSucc)
copyBOOLEAN ((* yyNew)->Processor.WriteVectorIndex, yyt->Processor.WriteVectorIndex)
copytTree ((* yyNew)->Processor.ProcOrDimSpec, yyt->Processor.ProcOrDimSpec)
copyBOOLEAN ((* yyNew)->Processor.WriteProcOrDimIndex, yyt->Processor.WriteProcOrDimIndex)
copyBOOLEAN ((* yyNew)->Processor.IsCConst, yyt->Processor.IsCConst)
copyBOOLEAN ((* yyNew)->Processor.IsP3Const, yyt->Processor.IsP3Const)
copyBOOLEAN ((* yyNew)->Processor.OpenAccessOrCall, yyt->Processor.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->Processor.GlobalPtrs, yyt->Processor.GlobalPtrs)
copytStrings ((* yyNew)->Processor.StrsIn, yyt->Processor.StrsIn)
copytStrings ((* yyNew)->Processor.StrsOut, yyt->Processor.StrsOut)
copytTree ((* yyNew)->Processor.Designator, yyt->Processor.Designator)
copytPosition ((* yyNew)->Processor.Pos, yyt->Processor.Pos)
yyt = yyt->Processor.Proc;
yyNew = & (* yyNew)->Processor.Proc; break;
case kDimensions: (* yyNew)->Dimensions = yyt->Dimensions;
copytEnv ((* yyNew)->Dimensions.Env, yyt->Dimensions.Env)
copyBOOLEAN ((* yyNew)->Dimensions.IsLval, yyt->Dimensions.IsLval)
copytType ((* yyNew)->Dimensions.Type, yyt->Dimensions.Type)
copyINDEX ((* yyNew)->Dimensions.Level, yyt->Dimensions.Level)
copyBOOLEAN ((* yyNew)->Dimensions.UseHelpVar, yyt->Dimensions.UseHelpVar)
copyBOOLEAN ((* yyNew)->Dimensions.THelpVar, yyt->Dimensions.THelpVar)
copyBOOLEAN ((* yyNew)->Dimensions.TakeHelpVar, yyt->Dimensions.TakeHelpVar)
copytIdent ((* yyNew)->Dimensions.HelpVar, yyt->Dimensions.HelpVar)
copyBOOLEAN ((* yyNew)->Dimensions.IsFirstDesignator, yyt->Dimensions.IsFirstDesignator)
copyBOOLEAN ((* yyNew)->Dimensions.HasProcOrDimSucc, yyt->Dimensions.HasProcOrDimSucc)
copyBOOLEAN ((* yyNew)->Dimensions.WriteVectorIndex, yyt->Dimensions.WriteVectorIndex)
copytTree ((* yyNew)->Dimensions.ProcOrDimSpec, yyt->Dimensions.ProcOrDimSpec)
copyBOOLEAN ((* yyNew)->Dimensions.WriteProcOrDimIndex, yyt->Dimensions.WriteProcOrDimIndex)
copyBOOLEAN ((* yyNew)->Dimensions.IsCConst, yyt->Dimensions.IsCConst)
copyBOOLEAN ((* yyNew)->Dimensions.IsP3Const, yyt->Dimensions.IsP3Const)
copyBOOLEAN ((* yyNew)->Dimensions.OpenAccessOrCall, yyt->Dimensions.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->Dimensions.GlobalPtrs, yyt->Dimensions.GlobalPtrs)
copytStrings ((* yyNew)->Dimensions.StrsIn, yyt->Dimensions.StrsIn)
copytStrings ((* yyNew)->Dimensions.StrsOut, yyt->Dimensions.StrsOut)
copytTree ((* yyNew)->Dimensions.Designator, yyt->Dimensions.Designator)
copytPosition ((* yyNew)->Dimensions.Pos, yyt->Dimensions.Pos)
copytIdent ((* yyNew)->Dimensions.SecondHelpVar, yyt->Dimensions.SecondHelpVar)
yyt = yyt->Dimensions.Actuals;
yyNew = & (* yyNew)->Dimensions.Actuals; break;
case kSelect: (* yyNew)->Select = yyt->Select;
copytEnv ((* yyNew)->Select.Env, yyt->Select.Env)
copyBOOLEAN ((* yyNew)->Select.IsLval, yyt->Select.IsLval)
copytType ((* yyNew)->Select.Type, yyt->Select.Type)
copyINDEX ((* yyNew)->Select.Level, yyt->Select.Level)
copyBOOLEAN ((* yyNew)->Select.UseHelpVar, yyt->Select.UseHelpVar)
copyBOOLEAN ((* yyNew)->Select.THelpVar, yyt->Select.THelpVar)
copyBOOLEAN ((* yyNew)->Select.TakeHelpVar, yyt->Select.TakeHelpVar)
copytIdent ((* yyNew)->Select.HelpVar, yyt->Select.HelpVar)
copyBOOLEAN ((* yyNew)->Select.IsFirstDesignator, yyt->Select.IsFirstDesignator)
copyBOOLEAN ((* yyNew)->Select.HasProcOrDimSucc, yyt->Select.HasProcOrDimSucc)
copyBOOLEAN ((* yyNew)->Select.WriteVectorIndex, yyt->Select.WriteVectorIndex)
copytTree ((* yyNew)->Select.ProcOrDimSpec, yyt->Select.ProcOrDimSpec)
copyBOOLEAN ((* yyNew)->Select.WriteProcOrDimIndex, yyt->Select.WriteProcOrDimIndex)
copyBOOLEAN ((* yyNew)->Select.IsCConst, yyt->Select.IsCConst)
copyBOOLEAN ((* yyNew)->Select.IsP3Const, yyt->Select.IsP3Const)
copyBOOLEAN ((* yyNew)->Select.OpenAccessOrCall, yyt->Select.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->Select.GlobalPtrs, yyt->Select.GlobalPtrs)
copytStrings ((* yyNew)->Select.StrsIn, yyt->Select.StrsIn)
copytStrings ((* yyNew)->Select.StrsOut, yyt->Select.StrsOut)
copytPosition ((* yyNew)->Select.Pos, yyt->Select.Pos)
copytIdent ((* yyNew)->Select.Field, yyt->Select.Field)
copytObject ((* yyNew)->Select.Object, yyt->Select.Object)
yyt = yyt->Select.Designator;
yyNew = & (* yyNew)->Select.Designator; break;
case kSubscript: (* yyNew)->Subscript = yyt->Subscript;
copytEnv ((* yyNew)->Subscript.Env, yyt->Subscript.Env)
copyBOOLEAN ((* yyNew)->Subscript.IsLval, yyt->Subscript.IsLval)
copytType ((* yyNew)->Subscript.Type, yyt->Subscript.Type)
copyINDEX ((* yyNew)->Subscript.Level, yyt->Subscript.Level)
copyBOOLEAN ((* yyNew)->Subscript.UseHelpVar, yyt->Subscript.UseHelpVar)
copyBOOLEAN ((* yyNew)->Subscript.THelpVar, yyt->Subscript.THelpVar)
copyBOOLEAN ((* yyNew)->Subscript.TakeHelpVar, yyt->Subscript.TakeHelpVar)
copytIdent ((* yyNew)->Subscript.HelpVar, yyt->Subscript.HelpVar)
copyBOOLEAN ((* yyNew)->Subscript.IsFirstDesignator, yyt->Subscript.IsFirstDesignator)
copyBOOLEAN ((* yyNew)->Subscript.HasProcOrDimSucc, yyt->Subscript.HasProcOrDimSucc)
copyBOOLEAN ((* yyNew)->Subscript.WriteVectorIndex, yyt->Subscript.WriteVectorIndex)
copytTree ((* yyNew)->Subscript.ProcOrDimSpec, yyt->Subscript.ProcOrDimSpec)
copyBOOLEAN ((* yyNew)->Subscript.WriteProcOrDimIndex, yyt->Subscript.WriteProcOrDimIndex)
copyBOOLEAN ((* yyNew)->Subscript.IsCConst, yyt->Subscript.IsCConst)
copyBOOLEAN ((* yyNew)->Subscript.IsP3Const, yyt->Subscript.IsP3Const)
copyBOOLEAN ((* yyNew)->Subscript.OpenAccessOrCall, yyt->Subscript.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->Subscript.GlobalPtrs, yyt->Subscript.GlobalPtrs)
copytStrings ((* yyNew)->Subscript.StrsIn, yyt->Subscript.StrsIn)
copytStrings ((* yyNew)->Subscript.StrsOut, yyt->Subscript.StrsOut)
copytTree ((* yyNew)->Subscript.Designator, yyt->Subscript.Designator)
copytPosition ((* yyNew)->Subscript.Pos, yyt->Subscript.Pos)
yyt = yyt->Subscript.Index;
yyNew = & (* yyNew)->Subscript.Index; break;
case kDeref: (* yyNew)->Deref = yyt->Deref;
copytEnv ((* yyNew)->Deref.Env, yyt->Deref.Env)
copyBOOLEAN ((* yyNew)->Deref.IsLval, yyt->Deref.IsLval)
copytType ((* yyNew)->Deref.Type, yyt->Deref.Type)
copyINDEX ((* yyNew)->Deref.Level, yyt->Deref.Level)
copyBOOLEAN ((* yyNew)->Deref.UseHelpVar, yyt->Deref.UseHelpVar)
copyBOOLEAN ((* yyNew)->Deref.THelpVar, yyt->Deref.THelpVar)
copyBOOLEAN ((* yyNew)->Deref.TakeHelpVar, yyt->Deref.TakeHelpVar)
copytIdent ((* yyNew)->Deref.HelpVar, yyt->Deref.HelpVar)
copyBOOLEAN ((* yyNew)->Deref.IsFirstDesignator, yyt->Deref.IsFirstDesignator)
copyBOOLEAN ((* yyNew)->Deref.HasProcOrDimSucc, yyt->Deref.HasProcOrDimSucc)
copyBOOLEAN ((* yyNew)->Deref.WriteVectorIndex, yyt->Deref.WriteVectorIndex)
copytTree ((* yyNew)->Deref.ProcOrDimSpec, yyt->Deref.ProcOrDimSpec)
copyBOOLEAN ((* yyNew)->Deref.WriteProcOrDimIndex, yyt->Deref.WriteProcOrDimIndex)
copyBOOLEAN ((* yyNew)->Deref.IsCConst, yyt->Deref.IsCConst)
copyBOOLEAN ((* yyNew)->Deref.IsP3Const, yyt->Deref.IsP3Const)
copyBOOLEAN ((* yyNew)->Deref.OpenAccessOrCall, yyt->Deref.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->Deref.GlobalPtrs, yyt->Deref.GlobalPtrs)
copytStrings ((* yyNew)->Deref.StrsIn, yyt->Deref.StrsIn)
copytStrings ((* yyNew)->Deref.StrsOut, yyt->Deref.StrsOut)
copytPosition ((* yyNew)->Deref.Pos, yyt->Deref.Pos)
yyt = yyt->Deref.Designator;
yyNew = & (* yyNew)->Deref.Designator; break;
case kDirSpec: (* yyNew)->DirSpec = yyt->DirSpec;
copytEnv ((* yyNew)->DirSpec.Env, yyt->DirSpec.Env)
copytObject ((* yyNew)->DirSpec.ConnectObj, yyt->DirSpec.ConnectObj)
copyINDEX ((* yyNew)->DirSpec.Level, yyt->DirSpec.Level)
copyBOOLEAN ((* yyNew)->DirSpec.OpenAccessOrCall, yyt->DirSpec.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->DirSpec.GlobalPtrs, yyt->DirSpec.GlobalPtrs)
copytStrings ((* yyNew)->DirSpec.StrsIn, yyt->DirSpec.StrsIn)
copytStrings ((* yyNew)->DirSpec.StrsOut, yyt->DirSpec.StrsOut)
return;
case kFuncSpec: (* yyNew)->FuncSpec = yyt->FuncSpec;
copytEnv ((* yyNew)->FuncSpec.Env, yyt->FuncSpec.Env)
copytObject ((* yyNew)->FuncSpec.ConnectObj, yyt->FuncSpec.ConnectObj)
copyINDEX ((* yyNew)->FuncSpec.Level, yyt->FuncSpec.Level)
copyBOOLEAN ((* yyNew)->FuncSpec.OpenAccessOrCall, yyt->FuncSpec.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->FuncSpec.GlobalPtrs, yyt->FuncSpec.GlobalPtrs)
copytStrings ((* yyNew)->FuncSpec.StrsIn, yyt->FuncSpec.StrsIn)
copytStrings ((* yyNew)->FuncSpec.StrsOut, yyt->FuncSpec.StrsOut)
copytTree ((* yyNew)->FuncSpec.DirOut, yyt->FuncSpec.DirOut)
copytTree ((* yyNew)->FuncSpec.DirOutIndex, yyt->FuncSpec.DirOutIndex)
copytTree ((* yyNew)->FuncSpec.Step, yyt->FuncSpec.Step)
yyt = yyt->FuncSpec.Reduce;
yyNew = & (* yyNew)->FuncSpec.Reduce; break;
case kProcSpec: (* yyNew)->ProcSpec = yyt->ProcSpec;
copytEnv ((* yyNew)->ProcSpec.Env, yyt->ProcSpec.Env)
copytObject ((* yyNew)->ProcSpec.ConnectObj, yyt->ProcSpec.ConnectObj)
copyINDEX ((* yyNew)->ProcSpec.Level, yyt->ProcSpec.Level)
copyBOOLEAN ((* yyNew)->ProcSpec.OpenAccessOrCall, yyt->ProcSpec.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->ProcSpec.GlobalPtrs, yyt->ProcSpec.GlobalPtrs)
copytStrings ((* yyNew)->ProcSpec.StrsIn, yyt->ProcSpec.StrsIn)
copytStrings ((* yyNew)->ProcSpec.StrsOut, yyt->ProcSpec.StrsOut)
copytTree ((* yyNew)->ProcSpec.Expr, yyt->ProcSpec.Expr)
yyt = yyt->ProcSpec.Reduce;
yyNew = & (* yyNew)->ProcSpec.Reduce; break;
case kDimSpec: (* yyNew)->DimSpec = yyt->DimSpec;
copytEnv ((* yyNew)->DimSpec.Env, yyt->DimSpec.Env)
copytObject ((* yyNew)->DimSpec.ConnectObj, yyt->DimSpec.ConnectObj)
copyINDEX ((* yyNew)->DimSpec.Level, yyt->DimSpec.Level)
copyBOOLEAN ((* yyNew)->DimSpec.OpenAccessOrCall, yyt->DimSpec.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->DimSpec.GlobalPtrs, yyt->DimSpec.GlobalPtrs)
copytStrings ((* yyNew)->DimSpec.StrsIn, yyt->DimSpec.StrsIn)
copytStrings ((* yyNew)->DimSpec.StrsOut, yyt->DimSpec.StrsOut)
copytTree ((* yyNew)->DimSpec.Actuals, yyt->DimSpec.Actuals)
copytIdent ((* yyNew)->DimSpec.HelpVar, yyt->DimSpec.HelpVar)
copytIdent ((* yyNew)->DimSpec.SecondHelpVar, yyt->DimSpec.SecondHelpVar)
yyt = yyt->DimSpec.Reduce;
yyNew = & (* yyNew)->DimSpec.Reduce; break;
case kElems: (* yyNew)->Elems = yyt->Elems;
copytEnv ((* yyNew)->Elems.Env, yyt->Elems.Env)
copyINDEX ((* yyNew)->Elems.Level, yyt->Elems.Level)
copyBOOLEAN ((* yyNew)->Elems.UseHelpVar, yyt->Elems.UseHelpVar)
copyBOOLEAN ((* yyNew)->Elems.IsCConst, yyt->Elems.IsCConst)
copyBOOLEAN ((* yyNew)->Elems.IsP3Const, yyt->Elems.IsP3Const)
copyBOOLEAN ((* yyNew)->Elems.OpenAccessOrCall, yyt->Elems.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->Elems.GlobalPtrs, yyt->Elems.GlobalPtrs)
copytStrings ((* yyNew)->Elems.StrsIn, yyt->Elems.StrsIn)
copytStrings ((* yyNew)->Elems.StrsOut, yyt->Elems.StrsOut)
return;
case kNoElem: (* yyNew)->NoElem = yyt->NoElem;
copytEnv ((* yyNew)->NoElem.Env, yyt->NoElem.Env)
copyINDEX ((* yyNew)->NoElem.Level, yyt->NoElem.Level)
copyBOOLEAN ((* yyNew)->NoElem.UseHelpVar, yyt->NoElem.UseHelpVar)
copyBOOLEAN ((* yyNew)->NoElem.IsCConst, yyt->NoElem.IsCConst)
copyBOOLEAN ((* yyNew)->NoElem.IsP3Const, yyt->NoElem.IsP3Const)
copyBOOLEAN ((* yyNew)->NoElem.OpenAccessOrCall, yyt->NoElem.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->NoElem.GlobalPtrs, yyt->NoElem.GlobalPtrs)
copytStrings ((* yyNew)->NoElem.StrsIn, yyt->NoElem.StrsIn)
copytStrings ((* yyNew)->NoElem.StrsOut, yyt->NoElem.StrsOut)
return;
case kElem: (* yyNew)->Elem = yyt->Elem;
copytEnv ((* yyNew)->Elem.Env, yyt->Elem.Env)
copyINDEX ((* yyNew)->Elem.Level, yyt->Elem.Level)
copyBOOLEAN ((* yyNew)->Elem.UseHelpVar, yyt->Elem.UseHelpVar)
copyBOOLEAN ((* yyNew)->Elem.IsCConst, yyt->Elem.IsCConst)
copyBOOLEAN ((* yyNew)->Elem.IsP3Const, yyt->Elem.IsP3Const)
copyBOOLEAN ((* yyNew)->Elem.OpenAccessOrCall, yyt->Elem.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->Elem.GlobalPtrs, yyt->Elem.GlobalPtrs)
copytStrings ((* yyNew)->Elem.StrsIn, yyt->Elem.StrsIn)
copytStrings ((* yyNew)->Elem.StrsOut, yyt->Elem.StrsOut)
yyt = yyt->Elem.Next;
yyNew = & (* yyNew)->Elem.Next; break;
case kElemExpr: (* yyNew)->ElemExpr = yyt->ElemExpr;
copytEnv ((* yyNew)->ElemExpr.Env, yyt->ElemExpr.Env)
copyINDEX ((* yyNew)->ElemExpr.Level, yyt->ElemExpr.Level)
copyBOOLEAN ((* yyNew)->ElemExpr.UseHelpVar, yyt->ElemExpr.UseHelpVar)
copyBOOLEAN ((* yyNew)->ElemExpr.IsCConst, yyt->ElemExpr.IsCConst)
copyBOOLEAN ((* yyNew)->ElemExpr.IsP3Const, yyt->ElemExpr.IsP3Const)
copyBOOLEAN ((* yyNew)->ElemExpr.OpenAccessOrCall, yyt->ElemExpr.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->ElemExpr.GlobalPtrs, yyt->ElemExpr.GlobalPtrs)
copytStrings ((* yyNew)->ElemExpr.StrsIn, yyt->ElemExpr.StrsIn)
copytStrings ((* yyNew)->ElemExpr.StrsOut, yyt->ElemExpr.StrsOut)
copytTree ((* yyNew)->ElemExpr.Elem, yyt->ElemExpr.Elem)
yyt = yyt->ElemExpr.Next;
yyNew = & (* yyNew)->ElemExpr.Next; break;
case kElemRange: (* yyNew)->ElemRange = yyt->ElemRange;
copytEnv ((* yyNew)->ElemRange.Env, yyt->ElemRange.Env)
copyINDEX ((* yyNew)->ElemRange.Level, yyt->ElemRange.Level)
copyBOOLEAN ((* yyNew)->ElemRange.UseHelpVar, yyt->ElemRange.UseHelpVar)
copyBOOLEAN ((* yyNew)->ElemRange.IsCConst, yyt->ElemRange.IsCConst)
copyBOOLEAN ((* yyNew)->ElemRange.IsP3Const, yyt->ElemRange.IsP3Const)
copyBOOLEAN ((* yyNew)->ElemRange.OpenAccessOrCall, yyt->ElemRange.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->ElemRange.GlobalPtrs, yyt->ElemRange.GlobalPtrs)
copytStrings ((* yyNew)->ElemRange.StrsIn, yyt->ElemRange.StrsIn)
copytStrings ((* yyNew)->ElemRange.StrsOut, yyt->ElemRange.StrsOut)
copytTree ((* yyNew)->ElemRange.Lwb, yyt->ElemRange.Lwb)
copytTree ((* yyNew)->ElemRange.Upb, yyt->ElemRange.Upb)
yyt = yyt->ElemRange.Next;
yyNew = & (* yyNew)->ElemRange.Next; break;
case kActuals: (* yyNew)->Actuals = yyt->Actuals;
copytEnv ((* yyNew)->Actuals.Env, yyt->Actuals.Env)
copyULONG ((* yyNew)->Actuals.ReduceNumber, yyt->Actuals.ReduceNumber)
copyULONG ((* yyNew)->Actuals.ActualsNumber, yyt->Actuals.ActualsNumber)
copytTypes ((* yyNew)->Actuals.Types, yyt->Actuals.Types)
copytTypes ((* yyNew)->Actuals.Formals, yyt->Actuals.Formals)
copyINDEX ((* yyNew)->Actuals.Level, yyt->Actuals.Level)
copyBOOLEAN ((* yyNew)->Actuals.UseHelpVar, yyt->Actuals.UseHelpVar)
copyBOOLEAN ((* yyNew)->Actuals.IsCConst, yyt->Actuals.IsCConst)
copyBOOLEAN ((* yyNew)->Actuals.IsP3Const, yyt->Actuals.IsP3Const)
copyBOOLEAN ((* yyNew)->Actuals.OpenAccessOrCall, yyt->Actuals.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->Actuals.GlobalPtrs, yyt->Actuals.GlobalPtrs)
copytStrings ((* yyNew)->Actuals.StrsIn, yyt->Actuals.StrsIn)
copytStrings ((* yyNew)->Actuals.StrsOut, yyt->Actuals.StrsOut)
return;
case kNoActual: (* yyNew)->NoActual = yyt->NoActual;
copytEnv ((* yyNew)->NoActual.Env, yyt->NoActual.Env)
copyULONG ((* yyNew)->NoActual.ReduceNumber, yyt->NoActual.ReduceNumber)
copyULONG ((* yyNew)->NoActual.ActualsNumber, yyt->NoActual.ActualsNumber)
copytTypes ((* yyNew)->NoActual.Types, yyt->NoActual.Types)
copytTypes ((* yyNew)->NoActual.Formals, yyt->NoActual.Formals)
copyINDEX ((* yyNew)->NoActual.Level, yyt->NoActual.Level)
copyBOOLEAN ((* yyNew)->NoActual.UseHelpVar, yyt->NoActual.UseHelpVar)
copyBOOLEAN ((* yyNew)->NoActual.IsCConst, yyt->NoActual.IsCConst)
copyBOOLEAN ((* yyNew)->NoActual.IsP3Const, yyt->NoActual.IsP3Const)
copyBOOLEAN ((* yyNew)->NoActual.OpenAccessOrCall, yyt->NoActual.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->NoActual.GlobalPtrs, yyt->NoActual.GlobalPtrs)
copytStrings ((* yyNew)->NoActual.StrsIn, yyt->NoActual.StrsIn)
copytStrings ((* yyNew)->NoActual.StrsOut, yyt->NoActual.StrsOut)
return;
case kActual: (* yyNew)->Actual = yyt->Actual;
copytEnv ((* yyNew)->Actual.Env, yyt->Actual.Env)
copyULONG ((* yyNew)->Actual.ReduceNumber, yyt->Actual.ReduceNumber)
copyULONG ((* yyNew)->Actual.ActualsNumber, yyt->Actual.ActualsNumber)
copytTypes ((* yyNew)->Actual.Types, yyt->Actual.Types)
copytTypes ((* yyNew)->Actual.Formals, yyt->Actual.Formals)
copyINDEX ((* yyNew)->Actual.Level, yyt->Actual.Level)
copyBOOLEAN ((* yyNew)->Actual.UseHelpVar, yyt->Actual.UseHelpVar)
copyBOOLEAN ((* yyNew)->Actual.IsCConst, yyt->Actual.IsCConst)
copyBOOLEAN ((* yyNew)->Actual.IsP3Const, yyt->Actual.IsP3Const)
copyBOOLEAN ((* yyNew)->Actual.OpenAccessOrCall, yyt->Actual.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->Actual.GlobalPtrs, yyt->Actual.GlobalPtrs)
copytStrings ((* yyNew)->Actual.StrsIn, yyt->Actual.StrsIn)
copytStrings ((* yyNew)->Actual.StrsOut, yyt->Actual.StrsOut)
copyBOOLEAN ((* yyNew)->Actual.IsVAR, yyt->Actual.IsVAR)
copytType ((* yyNew)->Actual.Formal, yyt->Actual.Formal)
yyt = yyt->Actual.Next;
yyNew = & (* yyNew)->Actual.Next; break;
case kActualExpr: (* yyNew)->ActualExpr = yyt->ActualExpr;
copytEnv ((* yyNew)->ActualExpr.Env, yyt->ActualExpr.Env)
copyULONG ((* yyNew)->ActualExpr.ReduceNumber, yyt->ActualExpr.ReduceNumber)
copyULONG ((* yyNew)->ActualExpr.ActualsNumber, yyt->ActualExpr.ActualsNumber)
copytTypes ((* yyNew)->ActualExpr.Types, yyt->ActualExpr.Types)
copytTypes ((* yyNew)->ActualExpr.Formals, yyt->ActualExpr.Formals)
copyINDEX ((* yyNew)->ActualExpr.Level, yyt->ActualExpr.Level)
copyBOOLEAN ((* yyNew)->ActualExpr.UseHelpVar, yyt->ActualExpr.UseHelpVar)
copyBOOLEAN ((* yyNew)->ActualExpr.IsCConst, yyt->ActualExpr.IsCConst)
copyBOOLEAN ((* yyNew)->ActualExpr.IsP3Const, yyt->ActualExpr.IsP3Const)
copyBOOLEAN ((* yyNew)->ActualExpr.OpenAccessOrCall, yyt->ActualExpr.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->ActualExpr.GlobalPtrs, yyt->ActualExpr.GlobalPtrs)
copytStrings ((* yyNew)->ActualExpr.StrsIn, yyt->ActualExpr.StrsIn)
copytStrings ((* yyNew)->ActualExpr.StrsOut, yyt->ActualExpr.StrsOut)
copyBOOLEAN ((* yyNew)->ActualExpr.IsVAR, yyt->ActualExpr.IsVAR)
copytType ((* yyNew)->ActualExpr.Formal, yyt->ActualExpr.Formal)
copytTree ((* yyNew)->ActualExpr.Expr, yyt->ActualExpr.Expr)
copytIdent ((* yyNew)->ActualExpr.HelpVar, yyt->ActualExpr.HelpVar)
copytIdent ((* yyNew)->ActualExpr.String, yyt->ActualExpr.String)
yyt = yyt->ActualExpr.Next;
yyNew = & (* yyNew)->ActualExpr.Next; break;
case kActualRange: (* yyNew)->ActualRange = yyt->ActualRange;
copytEnv ((* yyNew)->ActualRange.Env, yyt->ActualRange.Env)
copyULONG ((* yyNew)->ActualRange.ReduceNumber, yyt->ActualRange.ReduceNumber)
copyULONG ((* yyNew)->ActualRange.ActualsNumber, yyt->ActualRange.ActualsNumber)
copytTypes ((* yyNew)->ActualRange.Types, yyt->ActualRange.Types)
copytTypes ((* yyNew)->ActualRange.Formals, yyt->ActualRange.Formals)
copyINDEX ((* yyNew)->ActualRange.Level, yyt->ActualRange.Level)
copyBOOLEAN ((* yyNew)->ActualRange.UseHelpVar, yyt->ActualRange.UseHelpVar)
copyBOOLEAN ((* yyNew)->ActualRange.IsCConst, yyt->ActualRange.IsCConst)
copyBOOLEAN ((* yyNew)->ActualRange.IsP3Const, yyt->ActualRange.IsP3Const)
copyBOOLEAN ((* yyNew)->ActualRange.OpenAccessOrCall, yyt->ActualRange.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->ActualRange.GlobalPtrs, yyt->ActualRange.GlobalPtrs)
copytStrings ((* yyNew)->ActualRange.StrsIn, yyt->ActualRange.StrsIn)
copytStrings ((* yyNew)->ActualRange.StrsOut, yyt->ActualRange.StrsOut)
copyBOOLEAN ((* yyNew)->ActualRange.IsVAR, yyt->ActualRange.IsVAR)
copytType ((* yyNew)->ActualRange.Formal, yyt->ActualRange.Formal)
copytTree ((* yyNew)->ActualRange.Lwb, yyt->ActualRange.Lwb)
copytTree ((* yyNew)->ActualRange.Upb, yyt->ActualRange.Upb)
yyt = yyt->ActualRange.Next;
yyNew = & (* yyNew)->ActualRange.Next; break;
case kActualReduce: (* yyNew)->ActualReduce = yyt->ActualReduce;
copytEnv ((* yyNew)->ActualReduce.Env, yyt->ActualReduce.Env)
copyULONG ((* yyNew)->ActualReduce.ReduceNumber, yyt->ActualReduce.ReduceNumber)
copyULONG ((* yyNew)->ActualReduce.ActualsNumber, yyt->ActualReduce.ActualsNumber)
copytTypes ((* yyNew)->ActualReduce.Types, yyt->ActualReduce.Types)
copytTypes ((* yyNew)->ActualReduce.Formals, yyt->ActualReduce.Formals)
copyINDEX ((* yyNew)->ActualReduce.Level, yyt->ActualReduce.Level)
copyBOOLEAN ((* yyNew)->ActualReduce.UseHelpVar, yyt->ActualReduce.UseHelpVar)
copyBOOLEAN ((* yyNew)->ActualReduce.IsCConst, yyt->ActualReduce.IsCConst)
copyBOOLEAN ((* yyNew)->ActualReduce.IsP3Const, yyt->ActualReduce.IsP3Const)
copyBOOLEAN ((* yyNew)->ActualReduce.OpenAccessOrCall, yyt->ActualReduce.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->ActualReduce.GlobalPtrs, yyt->ActualReduce.GlobalPtrs)
copytStrings ((* yyNew)->ActualReduce.StrsIn, yyt->ActualReduce.StrsIn)
copytStrings ((* yyNew)->ActualReduce.StrsOut, yyt->ActualReduce.StrsOut)
copyBOOLEAN ((* yyNew)->ActualReduce.IsVAR, yyt->ActualReduce.IsVAR)
copytType ((* yyNew)->ActualReduce.Formal, yyt->ActualReduce.Formal)
copytTree ((* yyNew)->ActualReduce.Qualid, yyt->ActualReduce.Qualid)
copytIdent ((* yyNew)->ActualReduce.HelpVar, yyt->ActualReduce.HelpVar)
yyt = yyt->ActualReduce.Next;
yyNew = & (* yyNew)->ActualReduce.Next; break;
case kActualStar: (* yyNew)->ActualStar = yyt->ActualStar;
copytEnv ((* yyNew)->ActualStar.Env, yyt->ActualStar.Env)
copyULONG ((* yyNew)->ActualStar.ReduceNumber, yyt->ActualStar.ReduceNumber)
copyULONG ((* yyNew)->ActualStar.ActualsNumber, yyt->ActualStar.ActualsNumber)
copytTypes ((* yyNew)->ActualStar.Types, yyt->ActualStar.Types)
copytTypes ((* yyNew)->ActualStar.Formals, yyt->ActualStar.Formals)
copyINDEX ((* yyNew)->ActualStar.Level, yyt->ActualStar.Level)
copyBOOLEAN ((* yyNew)->ActualStar.UseHelpVar, yyt->ActualStar.UseHelpVar)
copyBOOLEAN ((* yyNew)->ActualStar.IsCConst, yyt->ActualStar.IsCConst)
copyBOOLEAN ((* yyNew)->ActualStar.IsP3Const, yyt->ActualStar.IsP3Const)
copyBOOLEAN ((* yyNew)->ActualStar.OpenAccessOrCall, yyt->ActualStar.OpenAccessOrCall)
copyBOOLEAN ((* yyNew)->ActualStar.GlobalPtrs, yyt->ActualStar.GlobalPtrs)
copytStrings ((* yyNew)->ActualStar.StrsIn, yyt->ActualStar.StrsIn)
copytStrings ((* yyNew)->ActualStar.StrsOut, yyt->ActualStar.StrsOut)
copyBOOLEAN ((* yyNew)->ActualStar.IsVAR, yyt->ActualStar.IsVAR)
copytType ((* yyNew)->ActualStar.Formal, yyt->ActualStar.Formal)
copytIdent ((* yyNew)->ActualStar.HelpVar, yyt->ActualStar.HelpVar)
yyt = yyt->ActualStar.Next;
yyNew = & (* yyNew)->ActualStar.Next; break;
case kStmts: (* yyNew)->Stmts = yyt->Stmts;
copytEnv ((* yyNew)->Stmts.Env, yyt->Stmts.Env)
copyINDEX ((* yyNew)->Stmts.Level, yyt->Stmts.Level)
copyBOOLEAN ((* yyNew)->Stmts.IsVectorExit, yyt->Stmts.IsVectorExit)
copytConfigs ((* yyNew)->Stmts.ExitConfigsIn, yyt->Stmts.ExitConfigsIn)
copytConfigs ((* yyNew)->Stmts.ExitConfigsOut, yyt->Stmts.ExitConfigsOut)
copytConfigs ((* yyNew)->Stmts.ReturnConfigsIn, yyt->Stmts.ReturnConfigsIn)
copytConfigs ((* yyNew)->Stmts.ReturnConfigsOut, yyt->Stmts.ReturnConfigsOut)
copyBOOLEAN ((* yyNew)->Stmts.GlobalPtrs, yyt->Stmts.GlobalPtrs)
copytStrings ((* yyNew)->Stmts.StrsIn, yyt->Stmts.StrsIn)
copytStrings ((* yyNew)->Stmts.StrsOut, yyt->Stmts.StrsOut)
copytType ((* yyNew)->Stmts.Type, yyt->Stmts.Type)
return;
case kNoStmt: (* yyNew)->NoStmt = yyt->NoStmt;
copytEnv ((* yyNew)->NoStmt.Env, yyt->NoStmt.Env)
copyINDEX ((* yyNew)->NoStmt.Level, yyt->NoStmt.Level)
copyBOOLEAN ((* yyNew)->NoStmt.IsVectorExit, yyt->NoStmt.IsVectorExit)
copytConfigs ((* yyNew)->NoStmt.ExitConfigsIn, yyt->NoStmt.ExitConfigsIn)
copytConfigs ((* yyNew)->NoStmt.ExitConfigsOut, yyt->NoStmt.ExitConfigsOut)
copytConfigs ((* yyNew)->NoStmt.ReturnConfigsIn, yyt->NoStmt.ReturnConfigsIn)
copytConfigs ((* yyNew)->NoStmt.ReturnConfigsOut, yyt->NoStmt.ReturnConfigsOut)
copyBOOLEAN ((* yyNew)->NoStmt.GlobalPtrs, yyt->NoStmt.GlobalPtrs)
copytStrings ((* yyNew)->NoStmt.StrsIn, yyt->NoStmt.StrsIn)
copytStrings ((* yyNew)->NoStmt.StrsOut, yyt->NoStmt.StrsOut)
copytType ((* yyNew)->NoStmt.Type, yyt->NoStmt.Type)
return;
case kStmt: (* yyNew)->Stmt = yyt->Stmt;
copytEnv ((* yyNew)->Stmt.Env, yyt->Stmt.Env)
copyINDEX ((* yyNew)->Stmt.Level, yyt->Stmt.Level)
copyBOOLEAN ((* yyNew)->Stmt.IsVectorExit, yyt->Stmt.IsVectorExit)
copytConfigs ((* yyNew)->Stmt.ExitConfigsIn, yyt->Stmt.ExitConfigsIn)
copytConfigs ((* yyNew)->Stmt.ExitConfigsOut, yyt->Stmt.ExitConfigsOut)
copytConfigs ((* yyNew)->Stmt.ReturnConfigsIn, yyt->Stmt.ReturnConfigsIn)
copytConfigs ((* yyNew)->Stmt.ReturnConfigsOut, yyt->Stmt.ReturnConfigsOut)
copyBOOLEAN ((* yyNew)->Stmt.GlobalPtrs, yyt->Stmt.GlobalPtrs)
copytStrings ((* yyNew)->Stmt.StrsIn, yyt->Stmt.StrsIn)
copytStrings ((* yyNew)->Stmt.StrsOut, yyt->Stmt.StrsOut)
copytType ((* yyNew)->Stmt.Type, yyt->Stmt.Type)
copytPosition ((* yyNew)->Stmt.Pos, yyt->Stmt.Pos)
yyt = yyt->Stmt.Next;
yyNew = & (* yyNew)->Stmt.Next; break;
case kAssign: (* yyNew)->Assign = yyt->Assign;
copytEnv ((* yyNew)->Assign.Env, yyt->Assign.Env)
copyINDEX ((* yyNew)->Assign.Level, yyt->Assign.Level)
copyBOOLEAN ((* yyNew)->Assign.IsVectorExit, yyt->Assign.IsVectorExit)
copytConfigs ((* yyNew)->Assign.ExitConfigsIn, yyt->Assign.ExitConfigsIn)
copytConfigs ((* yyNew)->Assign.ExitConfigsOut, yyt->Assign.ExitConfigsOut)
copytConfigs ((* yyNew)->Assign.ReturnConfigsIn, yyt->Assign.ReturnConfigsIn)
copytConfigs ((* yyNew)->Assign.ReturnConfigsOut, yyt->Assign.ReturnConfigsOut)
copyBOOLEAN ((* yyNew)->Assign.GlobalPtrs, yyt->Assign.GlobalPtrs)
copytStrings ((* yyNew)->Assign.StrsIn, yyt->Assign.StrsIn)
copytStrings ((* yyNew)->Assign.StrsOut, yyt->Assign.StrsOut)
copytType ((* yyNew)->Assign.Type, yyt->Assign.Type)
copytPosition ((* yyNew)->Assign.Pos, yyt->Assign.Pos)
copytTree ((* yyNew)->Assign.Designator, yyt->Assign.Designator)
copytTree ((* yyNew)->Assign.Expr, yyt->Assign.Expr)
yyt = yyt->Assign.Next;
yyNew = & (* yyNew)->Assign.Next; break;
case kCall: (* yyNew)->Call = yyt->Call;
copytEnv ((* yyNew)->Call.Env, yyt->Call.Env)
copyINDEX ((* yyNew)->Call.Level, yyt->Call.Level)
copyBOOLEAN ((* yyNew)->Call.IsVectorExit, yyt->Call.IsVectorExit)
copytConfigs ((* yyNew)->Call.ExitConfigsIn, yyt->Call.ExitConfigsIn)
copytConfigs ((* yyNew)->Call.ExitConfigsOut, yyt->Call.ExitConfigsOut)
copytConfigs ((* yyNew)->Call.ReturnConfigsIn, yyt->Call.ReturnConfigsIn)
copytConfigs ((* yyNew)->Call.ReturnConfigsOut, yyt->Call.ReturnConfigsOut)
copyBOOLEAN ((* yyNew)->Call.GlobalPtrs, yyt->Call.GlobalPtrs)
copytStrings ((* yyNew)->Call.StrsIn, yyt->Call.StrsIn)
copytStrings ((* yyNew)->Call.StrsOut, yyt->Call.StrsOut)
copytType ((* yyNew)->Call.Type, yyt->Call.Type)
copytPosition ((* yyNew)->Call.Pos, yyt->Call.Pos)
copytTree ((* yyNew)->Call.Designator, yyt->Call.Designator)
copytTree ((* yyNew)->Call.Actuals, yyt->Call.Actuals)
copytType ((* yyNew)->Call.CheckProcs, yyt->Call.CheckProcs)
copytObject ((* yyNew)->Call.AllocOrDealloc, yyt->Call.AllocOrDealloc)
yyt = yyt->Call.Next;
yyNew = & (* yyNew)->Call.Next; break;
case kIf: (* yyNew)->If = yyt->If;
copytEnv ((* yyNew)->If.Env, yyt->If.Env)
copyINDEX ((* yyNew)->If.Level, yyt->If.Level)
copyBOOLEAN ((* yyNew)->If.IsVectorExit, yyt->If.IsVectorExit)
copytConfigs ((* yyNew)->If.ExitConfigsIn, yyt->If.ExitConfigsIn)
copytConfigs ((* yyNew)->If.ExitConfigsOut, yyt->If.ExitConfigsOut)
copytConfigs ((* yyNew)->If.ReturnConfigsIn, yyt->If.ReturnConfigsIn)
copytConfigs ((* yyNew)->If.ReturnConfigsOut, yyt->If.ReturnConfigsOut)
copyBOOLEAN ((* yyNew)->If.GlobalPtrs, yyt->If.GlobalPtrs)
copytStrings ((* yyNew)->If.StrsIn, yyt->If.StrsIn)
copytStrings ((* yyNew)->If.StrsOut, yyt->If.StrsOut)
copytType ((* yyNew)->If.Type, yyt->If.Type)
copytPosition ((* yyNew)->If.Pos, yyt->If.Pos)
copytTree ((* yyNew)->If.Cond, yyt->If.Cond)
copytTree ((* yyNew)->If.Then, yyt->If.Then)
copytTree ((* yyNew)->If.Elsifs, yyt->If.Elsifs)
copytTree ((* yyNew)->If.Else, yyt->If.Else)
yyt = yyt->If.Next;
yyNew = & (* yyNew)->If.Next; break;
case kCase: (* yyNew)->Case = yyt->Case;
copytEnv ((* yyNew)->Case.Env, yyt->Case.Env)
copyINDEX ((* yyNew)->Case.Level, yyt->Case.Level)
copyBOOLEAN ((* yyNew)->Case.IsVectorExit, yyt->Case.IsVectorExit)
copytConfigs ((* yyNew)->Case.ExitConfigsIn, yyt->Case.ExitConfigsIn)
copytConfigs ((* yyNew)->Case.ExitConfigsOut, yyt->Case.ExitConfigsOut)
copytConfigs ((* yyNew)->Case.ReturnConfigsIn, yyt->Case.ReturnConfigsIn)
copytConfigs ((* yyNew)->Case.ReturnConfigsOut, yyt->Case.ReturnConfigsOut)
copyBOOLEAN ((* yyNew)->Case.GlobalPtrs, yyt->Case.GlobalPtrs)
copytStrings ((* yyNew)->Case.StrsIn, yyt->Case.StrsIn)
copytStrings ((* yyNew)->Case.StrsOut, yyt->Case.StrsOut)
copytType ((* yyNew)->Case.Type, yyt->Case.Type)
copytPosition ((* yyNew)->Case.Pos, yyt->Case.Pos)
copyBOOLEAN ((* yyNew)->Case.Default, yyt->Case.Default)
copytTree ((* yyNew)->Case.Expr, yyt->Case.Expr)
copytTree ((* yyNew)->Case.Cases, yyt->Case.Cases)
copytTree ((* yyNew)->Case.Else, yyt->Case.Else)
yyt = yyt->Case.Next;
yyNew = & (* yyNew)->Case.Next; break;
case kWhile: (* yyNew)->While = yyt->While;
copytEnv ((* yyNew)->While.Env, yyt->While.Env)
copyINDEX ((* yyNew)->While.Level, yyt->While.Level)
copyBOOLEAN ((* yyNew)->While.IsVectorExit, yyt->While.IsVectorExit)
copytConfigs ((* yyNew)->While.ExitConfigsIn, yyt->While.ExitConfigsIn)
copytConfigs ((* yyNew)->While.ExitConfigsOut, yyt->While.ExitConfigsOut)
copytConfigs ((* yyNew)->While.ReturnConfigsIn, yyt->While.ReturnConfigsIn)
copytConfigs ((* yyNew)->While.ReturnConfigsOut, yyt->While.ReturnConfigsOut)
copyBOOLEAN ((* yyNew)->While.GlobalPtrs, yyt->While.GlobalPtrs)
copytStrings ((* yyNew)->While.StrsIn, yyt->While.StrsIn)
copytStrings ((* yyNew)->While.StrsOut, yyt->While.StrsOut)
copytType ((* yyNew)->While.Type, yyt->While.Type)
copytPosition ((* yyNew)->While.Pos, yyt->While.Pos)
copytTree ((* yyNew)->While.Cond, yyt->While.Cond)
copytTree ((* yyNew)->While.Stmts, yyt->While.Stmts)
yyt = yyt->While.Next;
yyNew = & (* yyNew)->While.Next; break;
case kRepeat: (* yyNew)->Repeat = yyt->Repeat;
copytEnv ((* yyNew)->Repeat.Env, yyt->Repeat.Env)
copyINDEX ((* yyNew)->Repeat.Level, yyt->Repeat.Level)
copyBOOLEAN ((* yyNew)->Repeat.IsVectorExit, yyt->Repeat.IsVectorExit)
copytConfigs ((* yyNew)->Repeat.ExitConfigsIn, yyt->Repeat.ExitConfigsIn)
copytConfigs ((* yyNew)->Repeat.ExitConfigsOut, yyt->Repeat.ExitConfigsOut)
copytConfigs ((* yyNew)->Repeat.ReturnConfigsIn, yyt->Repeat.ReturnConfigsIn)
copytConfigs ((* yyNew)->Repeat.ReturnConfigsOut, yyt->Repeat.ReturnConfigsOut)
copyBOOLEAN ((* yyNew)->Repeat.GlobalPtrs, yyt->Repeat.GlobalPtrs)
copytStrings ((* yyNew)->Repeat.StrsIn, yyt->Repeat.StrsIn)
copytStrings ((* yyNew)->Repeat.StrsOut, yyt->Repeat.StrsOut)
copytType ((* yyNew)->Repeat.Type, yyt->Repeat.Type)
copytPosition ((* yyNew)->Repeat.Pos, yyt->Repeat.Pos)
copytTree ((* yyNew)->Repeat.Stmts, yyt->Repeat.Stmts)
copytTree ((* yyNew)->Repeat.Cond, yyt->Repeat.Cond)
yyt = yyt->Repeat.Next;
yyNew = & (* yyNew)->Repeat.Next; break;
case kLoop: (* yyNew)->Loop = yyt->Loop;
copytEnv ((* yyNew)->Loop.Env, yyt->Loop.Env)
copyINDEX ((* yyNew)->Loop.Level, yyt->Loop.Level)
copyBOOLEAN ((* yyNew)->Loop.IsVectorExit, yyt->Loop.IsVectorExit)
copytConfigs ((* yyNew)->Loop.ExitConfigsIn, yyt->Loop.ExitConfigsIn)
copytConfigs ((* yyNew)->Loop.ExitConfigsOut, yyt->Loop.ExitConfigsOut)
copytConfigs ((* yyNew)->Loop.ReturnConfigsIn, yyt->Loop.ReturnConfigsIn)
copytConfigs ((* yyNew)->Loop.ReturnConfigsOut, yyt->Loop.ReturnConfigsOut)
copyBOOLEAN ((* yyNew)->Loop.GlobalPtrs, yyt->Loop.GlobalPtrs)
copytStrings ((* yyNew)->Loop.StrsIn, yyt->Loop.StrsIn)
copytStrings ((* yyNew)->Loop.StrsOut, yyt->Loop.StrsOut)
copytType ((* yyNew)->Loop.Type, yyt->Loop.Type)
copytPosition ((* yyNew)->Loop.Pos, yyt->Loop.Pos)
copytTree ((* yyNew)->Loop.Stmts, yyt->Loop.Stmts)
copytConfigs ((* yyNew)->Loop.ExitConfigs, yyt->Loop.ExitConfigs)
yyt = yyt->Loop.Next;
yyNew = & (* yyNew)->Loop.Next; break;
case kLooppar: (* yyNew)->Looppar = yyt->Looppar;
copytEnv ((* yyNew)->Looppar.Env, yyt->Looppar.Env)
copyINDEX ((* yyNew)->Looppar.Level, yyt->Looppar.Level)
copyBOOLEAN ((* yyNew)->Looppar.IsVectorExit, yyt->Looppar.IsVectorExit)
copytConfigs ((* yyNew)->Looppar.ExitConfigsIn, yyt->Looppar.ExitConfigsIn)
copytConfigs ((* yyNew)->Looppar.ExitConfigsOut, yyt->Looppar.ExitConfigsOut)
copytConfigs ((* yyNew)->Looppar.ReturnConfigsIn, yyt->Looppar.ReturnConfigsIn)
copytConfigs ((* yyNew)->Looppar.ReturnConfigsOut, yyt->Looppar.ReturnConfigsOut)
copyBOOLEAN ((* yyNew)->Looppar.GlobalPtrs, yyt->Looppar.GlobalPtrs)
copytStrings ((* yyNew)->Looppar.StrsIn, yyt->Looppar.StrsIn)
copytStrings ((* yyNew)->Looppar.StrsOut, yyt->Looppar.StrsOut)
copytType ((* yyNew)->Looppar.Type, yyt->Looppar.Type)
copytPosition ((* yyNew)->Looppar.Pos, yyt->Looppar.Pos)
copytTree ((* yyNew)->Looppar.Qualid, yyt->Looppar.Qualid)
copytTree ((* yyNew)->Looppar.Stmts, yyt->Looppar.Stmts)
copytConfigs ((* yyNew)->Looppar.ExitConfigs, yyt->Looppar.ExitConfigs)
yyt = yyt->Looppar.Next;
yyNew = & (* yyNew)->Looppar.Next; break;
case kFor: (* yyNew)->For = yyt->For;
copytEnv ((* yyNew)->For.Env, yyt->For.Env)
copyINDEX ((* yyNew)->For.Level, yyt->For.Level)
copyBOOLEAN ((* yyNew)->For.IsVectorExit, yyt->For.IsVectorExit)
copytConfigs ((* yyNew)->For.ExitConfigsIn, yyt->For.ExitConfigsIn)
copytConfigs ((* yyNew)->For.ExitConfigsOut, yyt->For.ExitConfigsOut)
copytConfigs ((* yyNew)->For.ReturnConfigsIn, yyt->For.ReturnConfigsIn)
copytConfigs ((* yyNew)->For.ReturnConfigsOut, yyt->For.ReturnConfigsOut)
copyBOOLEAN ((* yyNew)->For.GlobalPtrs, yyt->For.GlobalPtrs)
copytStrings ((* yyNew)->For.StrsIn, yyt->For.StrsIn)
copytStrings ((* yyNew)->For.StrsOut, yyt->For.StrsOut)
copytType ((* yyNew)->For.Type, yyt->For.Type)
copytPosition ((* yyNew)->For.Pos, yyt->For.Pos)
copytTree ((* yyNew)->For.Qualid, yyt->For.Qualid)
copytTree ((* yyNew)->For.From, yyt->For.From)
copytTree ((* yyNew)->For.To, yyt->For.To)
copytTree ((* yyNew)->For.By, yyt->For.By)
copytTree ((* yyNew)->For.Stmts, yyt->For.Stmts)
copytValue ((* yyNew)->For.ToVal, yyt->For.ToVal)
copytValue ((* yyNew)->For.ByVal, yyt->For.ByVal)
yyt = yyt->For.Next;
yyNew = & (* yyNew)->For.Next; break;
case kWith: (* yyNew)->With = yyt->With;
copytEnv ((* yyNew)->With.Env, yyt->With.Env)
copyINDEX ((* yyNew)->With.Level, yyt->With.Level)
copyBOOLEAN ((* yyNew)->With.IsVectorExit, yyt->With.IsVectorExit)
copytConfigs ((* yyNew)->With.ExitConfigsIn, yyt->With.ExitConfigsIn)
copytConfigs ((* yyNew)->With.ExitConfigsOut, yyt->With.ExitConfigsOut)
copytConfigs ((* yyNew)->With.ReturnConfigsIn, yyt->With.ReturnConfigsIn)
copytConfigs ((* yyNew)->With.ReturnConfigsOut, yyt->With.ReturnConfigsOut)
copyBOOLEAN ((* yyNew)->With.GlobalPtrs, yyt->With.GlobalPtrs)
copytStrings ((* yyNew)->With.StrsIn, yyt->With.StrsIn)
copytStrings ((* yyNew)->With.StrsOut, yyt->With.StrsOut)
copytType ((* yyNew)->With.Type, yyt->With.Type)
copytPosition ((* yyNew)->With.Pos, yyt->With.Pos)
copytTree ((* yyNew)->With.Designator, yyt->With.Designator)
copytTree ((* yyNew)->With.Stmts, yyt->With.Stmts)
yyt = yyt->With.Next;
yyNew = & (* yyNew)->With.Next; break;
case kAll: (* yyNew)->All = yyt->All;
copytEnv ((* yyNew)->All.Env, yyt->All.Env)
copyINDEX ((* yyNew)->All.Level, yyt->All.Level)
copyBOOLEAN ((* yyNew)->All.IsVectorExit, yyt->All.IsVectorExit)
copytConfigs ((* yyNew)->All.ExitConfigsIn, yyt->All.ExitConfigsIn)
copytConfigs ((* yyNew)->All.ExitConfigsOut, yyt->All.ExitConfigsOut)
copytConfigs ((* yyNew)->All.ReturnConfigsIn, yyt->All.ReturnConfigsIn)
copytConfigs ((* yyNew)->All.ReturnConfigsOut, yyt->All.ReturnConfigsOut)
copyBOOLEAN ((* yyNew)->All.GlobalPtrs, yyt->All.GlobalPtrs)
copytStrings ((* yyNew)->All.StrsIn, yyt->All.StrsIn)
copytStrings ((* yyNew)->All.StrsOut, yyt->All.StrsOut)
copytType ((* yyNew)->All.Type, yyt->All.Type)
copytPosition ((* yyNew)->All.Pos, yyt->All.Pos)
copytTree ((* yyNew)->All.Qualid, yyt->All.Qualid)
copytTree ((* yyNew)->All.Stmts, yyt->All.Stmts)
yyt = yyt->All.Next;
yyNew = & (* yyNew)->All.Next; break;
case kSend: (* yyNew)->Send = yyt->Send;
copytEnv ((* yyNew)->Send.Env, yyt->Send.Env)
copyINDEX ((* yyNew)->Send.Level, yyt->Send.Level)
copyBOOLEAN ((* yyNew)->Send.IsVectorExit, yyt->Send.IsVectorExit)
copytConfigs ((* yyNew)->Send.ExitConfigsIn, yyt->Send.ExitConfigsIn)
copytConfigs ((* yyNew)->Send.ExitConfigsOut, yyt->Send.ExitConfigsOut)
copytConfigs ((* yyNew)->Send.ReturnConfigsIn, yyt->Send.ReturnConfigsIn)
copytConfigs ((* yyNew)->Send.ReturnConfigsOut, yyt->Send.ReturnConfigsOut)
copyBOOLEAN ((* yyNew)->Send.GlobalPtrs, yyt->Send.GlobalPtrs)
copytStrings ((* yyNew)->Send.StrsIn, yyt->Send.StrsIn)
copytStrings ((* yyNew)->Send.StrsOut, yyt->Send.StrsOut)
copytType ((* yyNew)->Send.Type, yyt->Send.Type)
copytPosition ((* yyNew)->Send.Pos, yyt->Send.Pos)
copytTree ((* yyNew)->Send.DirSpec, yyt->Send.DirSpec)
copytTree ((* yyNew)->Send.From, yyt->Send.From)
copytTree ((* yyNew)->Send.To, yyt->Send.To)
yyt = yyt->Send.Next;
yyNew = & (* yyNew)->Send.Next; break;
case kLoad: (* yyNew)->Load = yyt->Load;
copytEnv ((* yyNew)->Load.Env, yyt->Load.Env)
copyINDEX ((* yyNew)->Load.Level, yyt->Load.Level)
copyBOOLEAN ((* yyNew)->Load.IsVectorExit, yyt->Load.IsVectorExit)
copytConfigs ((* yyNew)->Load.ExitConfigsIn, yyt->Load.ExitConfigsIn)
copytConfigs ((* yyNew)->Load.ExitConfigsOut, yyt->Load.ExitConfigsOut)
copytConfigs ((* yyNew)->Load.ReturnConfigsIn, yyt->Load.ReturnConfigsIn)
copytConfigs ((* yyNew)->Load.ReturnConfigsOut, yyt->Load.ReturnConfigsOut)
copyBOOLEAN ((* yyNew)->Load.GlobalPtrs, yyt->Load.GlobalPtrs)
copytStrings ((* yyNew)->Load.StrsIn, yyt->Load.StrsIn)
copytStrings ((* yyNew)->Load.StrsOut, yyt->Load.StrsOut)
copytType ((* yyNew)->Load.Type, yyt->Load.Type)
copytPosition ((* yyNew)->Load.Pos, yyt->Load.Pos)
copyBOOLEAN ((* yyNew)->Load.SizeDef, yyt->Load.SizeDef)
copytTree ((* yyNew)->Load.What, yyt->Load.What)
copytTree ((* yyNew)->Load.From, yyt->Load.From)
copytTree ((* yyNew)->Load.Size, yyt->Load.Size)
yyt = yyt->Load.Next;
yyNew = & (* yyNew)->Load.Next; break;
case kStore: (* yyNew)->Store = yyt->Store;
copytEnv ((* yyNew)->Store.Env, yyt->Store.Env)
copyINDEX ((* yyNew)->Store.Level, yyt->Store.Level)
copyBOOLEAN ((* yyNew)->Store.IsVectorExit, yyt->Store.IsVectorExit)
copytConfigs ((* yyNew)->Store.ExitConfigsIn, yyt->Store.ExitConfigsIn)
copytConfigs ((* yyNew)->Store.ExitConfigsOut, yyt->Store.ExitConfigsOut)
copytConfigs ((* yyNew)->Store.ReturnConfigsIn, yyt->Store.ReturnConfigsIn)
copytConfigs ((* yyNew)->Store.ReturnConfigsOut, yyt->Store.ReturnConfigsOut)
copyBOOLEAN ((* yyNew)->Store.GlobalPtrs, yyt->Store.GlobalPtrs)
copytStrings ((* yyNew)->Store.StrsIn, yyt->Store.StrsIn)
copytStrings ((* yyNew)->Store.StrsOut, yyt->Store.StrsOut)
copytType ((* yyNew)->Store.Type, yyt->Store.Type)
copytPosition ((* yyNew)->Store.Pos, yyt->Store.Pos)
copyBOOLEAN ((* yyNew)->Store.SizeDef, yyt->Store.SizeDef)
copytTree ((* yyNew)->Store.What, yyt->Store.What)
copytTree ((* yyNew)->Store.To, yyt->Store.To)
copytTree ((* yyNew)->Store.Size, yyt->Store.Size)
yyt = yyt->Store.Next;
yyNew = & (* yyNew)->Store.Next; break;
case kExit: (* yyNew)->Exit = yyt->Exit;
copytEnv ((* yyNew)->Exit.Env, yyt->Exit.Env)
copyINDEX ((* yyNew)->Exit.Level, yyt->Exit.Level)
copyBOOLEAN ((* yyNew)->Exit.IsVectorExit, yyt->Exit.IsVectorExit)
copytConfigs ((* yyNew)->Exit.ExitConfigsIn, yyt->Exit.ExitConfigsIn)
copytConfigs ((* yyNew)->Exit.ExitConfigsOut, yyt->Exit.ExitConfigsOut)
copytConfigs ((* yyNew)->Exit.ReturnConfigsIn, yyt->Exit.ReturnConfigsIn)
copytConfigs ((* yyNew)->Exit.ReturnConfigsOut, yyt->Exit.ReturnConfigsOut)
copyBOOLEAN ((* yyNew)->Exit.GlobalPtrs, yyt->Exit.GlobalPtrs)
copytStrings ((* yyNew)->Exit.StrsIn, yyt->Exit.StrsIn)
copytStrings ((* yyNew)->Exit.StrsOut, yyt->Exit.StrsOut)
copytType ((* yyNew)->Exit.Type, yyt->Exit.Type)
copytPosition ((* yyNew)->Exit.Pos, yyt->Exit.Pos)
yyt = yyt->Exit.Next;
yyNew = & (* yyNew)->Exit.Next; break;
case kReturn0: (* yyNew)->Return0 = yyt->Return0;
copytEnv ((* yyNew)->Return0.Env, yyt->Return0.Env)
copyINDEX ((* yyNew)->Return0.Level, yyt->Return0.Level)
copyBOOLEAN ((* yyNew)->Return0.IsVectorExit, yyt->Return0.IsVectorExit)
copytConfigs ((* yyNew)->Return0.ExitConfigsIn, yyt->Return0.ExitConfigsIn)
copytConfigs ((* yyNew)->Return0.ExitConfigsOut, yyt->Return0.ExitConfigsOut)
copytConfigs ((* yyNew)->Return0.ReturnConfigsIn, yyt->Return0.ReturnConfigsIn)
copytConfigs ((* yyNew)->Return0.ReturnConfigsOut, yyt->Return0.ReturnConfigsOut)
copyBOOLEAN ((* yyNew)->Return0.GlobalPtrs, yyt->Return0.GlobalPtrs)
copytStrings ((* yyNew)->Return0.StrsIn, yyt->Return0.StrsIn)
copytStrings ((* yyNew)->Return0.StrsOut, yyt->Return0.StrsOut)
copytType ((* yyNew)->Return0.Type, yyt->Return0.Type)
copytPosition ((* yyNew)->Return0.Pos, yyt->Return0.Pos)
copytType ((* yyNew)->Return0.ResultType, yyt->Return0.ResultType)
yyt = yyt->Return0.Next;
yyNew = & (* yyNew)->Return0.Next; break;
case kReturn1: (* yyNew)->Return1 = yyt->Return1;
copytEnv ((* yyNew)->Return1.Env, yyt->Return1.Env)
copyINDEX ((* yyNew)->Return1.Level, yyt->Return1.Level)
copyBOOLEAN ((* yyNew)->Return1.IsVectorExit, yyt->Return1.IsVectorExit)
copytConfigs ((* yyNew)->Return1.ExitConfigsIn, yyt->Return1.ExitConfigsIn)
copytConfigs ((* yyNew)->Return1.ExitConfigsOut, yyt->Return1.ExitConfigsOut)
copytConfigs ((* yyNew)->Return1.ReturnConfigsIn, yyt->Return1.ReturnConfigsIn)
copytConfigs ((* yyNew)->Return1.ReturnConfigsOut, yyt->Return1.ReturnConfigsOut)
copyBOOLEAN ((* yyNew)->Return1.GlobalPtrs, yyt->Return1.GlobalPtrs)
copytStrings ((* yyNew)->Return1.StrsIn, yyt->Return1.StrsIn)
copytStrings ((* yyNew)->Return1.StrsOut, yyt->Return1.StrsOut)
copytType ((* yyNew)->Return1.Type, yyt->Return1.Type)
copytPosition ((* yyNew)->Return1.Pos, yyt->Return1.Pos)
copytTree ((* yyNew)->Return1.Result, yyt->Return1.Result)
copyBOOLEAN ((* yyNew)->Return1.OpenAccessOrCall, yyt->Return1.OpenAccessOrCall)
copytType ((* yyNew)->Return1.ResultType, yyt->Return1.ResultType)
yyt = yyt->Return1.Next;
yyNew = & (* yyNew)->Return1.Next; break;
case kElsifs: (* yyNew)->Elsifs = yyt->Elsifs;
copytEnv ((* yyNew)->Elsifs.Env, yyt->Elsifs.Env)
copyINDEX ((* yyNew)->Elsifs.Level, yyt->Elsifs.Level)
copyBOOLEAN ((* yyNew)->Elsifs.IsVectorExit, yyt->Elsifs.IsVectorExit)
copytConfigs ((* yyNew)->Elsifs.ExitConfigsIn, yyt->Elsifs.ExitConfigsIn)
copytConfigs ((* yyNew)->Elsifs.ExitConfigsOut, yyt->Elsifs.ExitConfigsOut)
copytConfigs ((* yyNew)->Elsifs.ReturnConfigsIn, yyt->Elsifs.ReturnConfigsIn)
copytConfigs ((* yyNew)->Elsifs.ReturnConfigsOut, yyt->Elsifs.ReturnConfigsOut)
copyBOOLEAN ((* yyNew)->Elsifs.GlobalPtrs, yyt->Elsifs.GlobalPtrs)
copytStrings ((* yyNew)->Elsifs.StrsIn, yyt->Elsifs.StrsIn)
copytStrings ((* yyNew)->Elsifs.StrsOut, yyt->Elsifs.StrsOut)
copytType ((* yyNew)->Elsifs.Type, yyt->Elsifs.Type)
return;
case kNoElsif: (* yyNew)->NoElsif = yyt->NoElsif;
copytEnv ((* yyNew)->NoElsif.Env, yyt->NoElsif.Env)
copyINDEX ((* yyNew)->NoElsif.Level, yyt->NoElsif.Level)
copyBOOLEAN ((* yyNew)->NoElsif.IsVectorExit, yyt->NoElsif.IsVectorExit)
copytConfigs ((* yyNew)->NoElsif.ExitConfigsIn, yyt->NoElsif.ExitConfigsIn)
copytConfigs ((* yyNew)->NoElsif.ExitConfigsOut, yyt->NoElsif.ExitConfigsOut)
copytConfigs ((* yyNew)->NoElsif.ReturnConfigsIn, yyt->NoElsif.ReturnConfigsIn)
copytConfigs ((* yyNew)->NoElsif.ReturnConfigsOut, yyt->NoElsif.ReturnConfigsOut)
copyBOOLEAN ((* yyNew)->NoElsif.GlobalPtrs, yyt->NoElsif.GlobalPtrs)
copytStrings ((* yyNew)->NoElsif.StrsIn, yyt->NoElsif.StrsIn)
copytStrings ((* yyNew)->NoElsif.StrsOut, yyt->NoElsif.StrsOut)
copytType ((* yyNew)->NoElsif.Type, yyt->NoElsif.Type)
return;
case kElsif: (* yyNew)->Elsif = yyt->Elsif;
copytEnv ((* yyNew)->Elsif.Env, yyt->Elsif.Env)
copyINDEX ((* yyNew)->Elsif.Level, yyt->Elsif.Level)
copyBOOLEAN ((* yyNew)->Elsif.IsVectorExit, yyt->Elsif.IsVectorExit)
copytConfigs ((* yyNew)->Elsif.ExitConfigsIn, yyt->Elsif.ExitConfigsIn)
copytConfigs ((* yyNew)->Elsif.ExitConfigsOut, yyt->Elsif.ExitConfigsOut)
copytConfigs ((* yyNew)->Elsif.ReturnConfigsIn, yyt->Elsif.ReturnConfigsIn)
copytConfigs ((* yyNew)->Elsif.ReturnConfigsOut, yyt->Elsif.ReturnConfigsOut)
copyBOOLEAN ((* yyNew)->Elsif.GlobalPtrs, yyt->Elsif.GlobalPtrs)
copytStrings ((* yyNew)->Elsif.StrsIn, yyt->Elsif.StrsIn)
copytStrings ((* yyNew)->Elsif.StrsOut, yyt->Elsif.StrsOut)
copytType ((* yyNew)->Elsif.Type, yyt->Elsif.Type)
copytTree ((* yyNew)->Elsif.Cond, yyt->Elsif.Cond)
copytTree ((* yyNew)->Elsif.Stmts, yyt->Elsif.Stmts)
yyt = yyt->Elsif.Next;
yyNew = & (* yyNew)->Elsif.Next; break;
case kCases: (* yyNew)->Cases = yyt->Cases;
copytEnv ((* yyNew)->Cases.Env, yyt->Cases.Env)
copyINDEX ((* yyNew)->Cases.Level, yyt->Cases.Level)
copyBOOLEAN ((* yyNew)->Cases.IsVectorExit, yyt->Cases.IsVectorExit)
copytConfigs ((* yyNew)->Cases.ExitConfigsIn, yyt->Cases.ExitConfigsIn)
copytConfigs ((* yyNew)->Cases.ExitConfigsOut, yyt->Cases.ExitConfigsOut)
copytConfigs ((* yyNew)->Cases.ReturnConfigsIn, yyt->Cases.ReturnConfigsIn)
copytConfigs ((* yyNew)->Cases.ReturnConfigsOut, yyt->Cases.ReturnConfigsOut)
copyBOOLEAN ((* yyNew)->Cases.GlobalPtrs, yyt->Cases.GlobalPtrs)
copytStrings ((* yyNew)->Cases.StrsIn, yyt->Cases.StrsIn)
copytStrings ((* yyNew)->Cases.StrsOut, yyt->Cases.StrsOut)
copytType ((* yyNew)->Cases.Type, yyt->Cases.Type)
return;
case kNoCase: (* yyNew)->NoCase = yyt->NoCase;
copytEnv ((* yyNew)->NoCase.Env, yyt->NoCase.Env)
copyINDEX ((* yyNew)->NoCase.Level, yyt->NoCase.Level)
copyBOOLEAN ((* yyNew)->NoCase.IsVectorExit, yyt->NoCase.IsVectorExit)
copytConfigs ((* yyNew)->NoCase.ExitConfigsIn, yyt->NoCase.ExitConfigsIn)
copytConfigs ((* yyNew)->NoCase.ExitConfigsOut, yyt->NoCase.ExitConfigsOut)
copytConfigs ((* yyNew)->NoCase.ReturnConfigsIn, yyt->NoCase.ReturnConfigsIn)
copytConfigs ((* yyNew)->NoCase.ReturnConfigsOut, yyt->NoCase.ReturnConfigsOut)
copyBOOLEAN ((* yyNew)->NoCase.GlobalPtrs, yyt->NoCase.GlobalPtrs)
copytStrings ((* yyNew)->NoCase.StrsIn, yyt->NoCase.StrsIn)
copytStrings ((* yyNew)->NoCase.StrsOut, yyt->NoCase.StrsOut)
copytType ((* yyNew)->NoCase.Type, yyt->NoCase.Type)
return;
case kCases1: (* yyNew)->Cases1 = yyt->Cases1;
copytEnv ((* yyNew)->Cases1.Env, yyt->Cases1.Env)
copyINDEX ((* yyNew)->Cases1.Level, yyt->Cases1.Level)
copyBOOLEAN ((* yyNew)->Cases1.IsVectorExit, yyt->Cases1.IsVectorExit)
copytConfigs ((* yyNew)->Cases1.ExitConfigsIn, yyt->Cases1.ExitConfigsIn)
copytConfigs ((* yyNew)->Cases1.ExitConfigsOut, yyt->Cases1.ExitConfigsOut)
copytConfigs ((* yyNew)->Cases1.ReturnConfigsIn, yyt->Cases1.ReturnConfigsIn)
copytConfigs ((* yyNew)->Cases1.ReturnConfigsOut, yyt->Cases1.ReturnConfigsOut)
copyBOOLEAN ((* yyNew)->Cases1.GlobalPtrs, yyt->Cases1.GlobalPtrs)
copytStrings ((* yyNew)->Cases1.StrsIn, yyt->Cases1.StrsIn)
copytStrings ((* yyNew)->Cases1.StrsOut, yyt->Cases1.StrsOut)
copytType ((* yyNew)->Cases1.Type, yyt->Cases1.Type)
copytTree ((* yyNew)->Cases1.Labels, yyt->Cases1.Labels)
copytTree ((* yyNew)->Cases1.Stmts, yyt->Cases1.Stmts)
yyt = yyt->Cases1.Next;
yyNew = & (* yyNew)->Cases1.Next; break;
case kLabels: (* yyNew)->Labels = yyt->Labels;
copytEnv ((* yyNew)->Labels.Env, yyt->Labels.Env)
return;
case kNoLabel: (* yyNew)->NoLabel = yyt->NoLabel;
copytEnv ((* yyNew)->NoLabel.Env, yyt->NoLabel.Env)
return;
case kLabel: (* yyNew)->Label = yyt->Label;
copytEnv ((* yyNew)->Label.Env, yyt->Label.Env)
yyt = yyt->Label.Next;
yyNew = & (* yyNew)->Label.Next; break;
case kLabelExpr: (* yyNew)->LabelExpr = yyt->LabelExpr;
copytEnv ((* yyNew)->LabelExpr.Env, yyt->LabelExpr.Env)
copytTree ((* yyNew)->LabelExpr.Expr, yyt->LabelExpr.Expr)
copytValue ((* yyNew)->LabelExpr.LabelVal, yyt->LabelExpr.LabelVal)
yyt = yyt->LabelExpr.Next;
yyNew = & (* yyNew)->LabelExpr.Next; break;
case kLabelRange: (* yyNew)->LabelRange = yyt->LabelRange;
copytEnv ((* yyNew)->LabelRange.Env, yyt->LabelRange.Env)
copytTree ((* yyNew)->LabelRange.Lwb, yyt->LabelRange.Lwb)
copytTree ((* yyNew)->LabelRange.Upb, yyt->LabelRange.Upb)
copytValue ((* yyNew)->LabelRange.LwbVal, yyt->LabelRange.LwbVal)
copytValue ((* yyNew)->LabelRange.UpbVal, yyt->LabelRange.UpbVal)
yyt = yyt->LabelRange.Next;
yyNew = & (* yyNew)->LabelRange.Next; break;
  default: ;
  }
 }
}

tTree CopyTree
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 tTree yyNew;
 yyMark (yyt);
 yyOldToNewCount = 0;
 yyCopyTree (yyt, & yyNew);
 return yyNew;
}

static bool yyCheckTree ARGS((tTree yyt));

bool CheckTree
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyMark (yyt);
 return yyCheckTree (yyt);
}

static bool yyCheckChild
# if defined __STDC__ | defined __cplusplus
 (tTree yyParent, tTree yyyChild, Tree_tKind yyType, char * yySelector)
# else
 (yyParent, yyyChild, yyType, yySelector)
 tTree yyParent, yyyChild;
 Tree_tKind yyType;
 char * yySelector;
# endif
{
 bool yySuccess = Tree_IsType (yyyChild, yyType);
 if (! yySuccess) {
  (void) fputs ("CheckTree: parent = ", stderr);
  WriteTreeNode (stderr, yyParent);
  (void) fprintf (stderr, "\nselector: %s child = ", yySelector);
  WriteTreeNode (stderr, yyyChild);
  (void) fputc ('\n', stderr);
 }
 return yyCheckTree (yyyChild) && yySuccess;
}

static bool yyCheckTree
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 bool yyResult;
 if (yyt == NoTree) return false;
 else if (yyt->yyHead.yyMark == 0) return true;
 yyt->yyHead.yyMark = 0;

 yyResult = true;
 switch (yyt->Kind) {
case kROOT:
yyResult = yyCheckChild (yyt, yyt->ROOT.CompUnits, kCompUnits, "CompUnits") && yyResult;
break;
case kCompUnit:
yyResult = yyCheckChild (yyt, yyt->CompUnit.Next, kCompUnits, "Next") && yyResult;
break;
case kDefMod:
yyResult = yyCheckChild (yyt, yyt->DefMod.Next, kCompUnits, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->DefMod.Imports, kImports, "Imports") && yyResult;
yyResult = yyCheckChild (yyt, yyt->DefMod.Exports, kExports, "Exports") && yyResult;
yyResult = yyCheckChild (yyt, yyt->DefMod.Decls, kDecls, "Decls") && yyResult;
break;
case kImplMod:
yyResult = yyCheckChild (yyt, yyt->ImplMod.Next, kCompUnits, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ImplMod.Imports, kImports, "Imports") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ImplMod.Decls, kDecls, "Decls") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ImplMod.Stmts, kStmts, "Stmts") && yyResult;
break;
case kImport:
yyResult = yyCheckChild (yyt, yyt->Import.Next, kImports, "Next") && yyResult;
break;
case kFrom:
yyResult = yyCheckChild (yyt, yyt->From.Next, kImports, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->From.ImpIds, kImpIds, "ImpIds") && yyResult;
break;
case kObjects:
yyResult = yyCheckChild (yyt, yyt->Objects.Next, kImports, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Objects.ImpIds, kImpIds, "ImpIds") && yyResult;
break;
case kImpId:
yyResult = yyCheckChild (yyt, yyt->ImpId.Next, kImpIds, "Next") && yyResult;
break;
case kExport:
yyResult = yyCheckChild (yyt, yyt->Export.ExpIds, kExpIds, "ExpIds") && yyResult;
break;
case kExpId:
yyResult = yyCheckChild (yyt, yyt->ExpId.Next, kExpIds, "Next") && yyResult;
break;
case kDecl:
yyResult = yyCheckChild (yyt, yyt->Decl.Next, kDecls, "Next") && yyResult;
break;
case kVar:
yyResult = yyCheckChild (yyt, yyt->Var.Next, kDecls, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Var.VarIds, kVarIds, "VarIds") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Var.Type, kType, "Type") && yyResult;
break;
case kObject:
yyResult = yyCheckChild (yyt, yyt->Object.Next, kDecls, "Next") && yyResult;
break;
case kConnectFrom:
yyResult = yyCheckChild (yyt, yyt->ConnectFrom.Next, kDecls, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ConnectFrom.From, kExpr, "From") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ConnectFrom.To, kExpr, "To") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ConnectFrom.ConnectDecls, kConnectDecls, "ConnectDecls") && yyResult;
break;
case kConnectDecls:
yyResult = yyCheckChild (yyt, yyt->ConnectDecls.Next, kDecls, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ConnectDecls.Index, kExpr, "Index") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ConnectDecls.Config, kQualid, "Config") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ConnectDecls.Actuals, kActuals, "Actuals") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ConnectDecls.DirIn, kConnectDests, "DirIn") && yyResult;
break;
case kConfig:
yyResult = yyCheckChild (yyt, yyt->Config.Next, kDecls, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Config.Actuals, kActuals, "Actuals") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Config.Qualid, kQualid, "Qualid") && yyResult;
break;
case kConst:
yyResult = yyCheckChild (yyt, yyt->Const.Next, kDecls, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Const.Expr, kExpr, "Expr") && yyResult;
break;
case kTypeDecl:
yyResult = yyCheckChild (yyt, yyt->TypeDecl.Next, kDecls, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->TypeDecl.Type, kType, "Type") && yyResult;
break;
case kProc:
yyResult = yyCheckChild (yyt, yyt->Proc.Next, kDecls, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Proc.Formals, kFormals, "Formals") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Proc.ResultType, kType, "ResultType") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Proc.Decls, kDecls, "Decls") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Proc.Stmts, kStmts, "Stmts") && yyResult;
break;
case kProcHead:
yyResult = yyCheckChild (yyt, yyt->ProcHead.Next, kDecls, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ProcHead.Formals, kFormals, "Formals") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ProcHead.ResultType, kType, "ResultType") && yyResult;
break;
case kOpaque:
yyResult = yyCheckChild (yyt, yyt->Opaque.Next, kDecls, "Next") && yyResult;
break;
case kConnectDest:
yyResult = yyCheckChild (yyt, yyt->ConnectDest.Next, kConnectDests, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ConnectDest.Expr, kExpr, "Expr") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ConnectDest.Config, kQualid, "Config") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ConnectDest.Actuals, kActuals, "Actuals") && yyResult;
break;
case kConnectDestUni:
yyResult = yyCheckChild (yyt, yyt->ConnectDestUni.Next, kConnectDests, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ConnectDestUni.Expr, kExpr, "Expr") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ConnectDestUni.Config, kQualid, "Config") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ConnectDestUni.Actuals, kActuals, "Actuals") && yyResult;
break;
case kConnectDestBi:
yyResult = yyCheckChild (yyt, yyt->ConnectDestBi.Next, kConnectDests, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ConnectDestBi.Expr, kExpr, "Expr") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ConnectDestBi.Config, kQualid, "Config") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ConnectDestBi.Actuals, kActuals, "Actuals") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ConnectDestBi.Index, kExpr, "Index") && yyResult;
break;
case kVarId:
yyResult = yyCheckChild (yyt, yyt->VarId.Next, kVarIds, "Next") && yyResult;
break;
case kFormal:
yyResult = yyCheckChild (yyt, yyt->Formal.Next, kFormals, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Formal.ParIds, kParIds, "ParIds") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Formal.Type, kType, "Type") && yyResult;
break;
case kParId:
yyResult = yyCheckChild (yyt, yyt->ParId.Next, kParIds, "Next") && yyResult;
break;
case kVector:
yyResult = yyCheckChild (yyt, yyt->Vector.Config, kQualid, "Config") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Vector.Scalar, kType, "Scalar") && yyResult;
break;
case kArray:
yyResult = yyCheckChild (yyt, yyt->Array.Index, kSimpleType, "Index") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Array.ElemType, kType, "ElemType") && yyResult;
break;
case kRecord:
yyResult = yyCheckChild (yyt, yyt->Record.Fields, kFields, "Fields") && yyResult;
break;
case kSetType:
yyResult = yyCheckChild (yyt, yyt->SetType.BaseType, kSimpleType, "BaseType") && yyResult;
break;
case kPointer:
yyResult = yyCheckChild (yyt, yyt->Pointer.TargetType, kType, "TargetType") && yyResult;
break;
case kProcType:
yyResult = yyCheckChild (yyt, yyt->ProcType.FormalTypes, kFormalTypes, "FormalTypes") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ProcType.ResultType, kType, "ResultType") && yyResult;
break;
case kEnumeration:
yyResult = yyCheckChild (yyt, yyt->Enumeration.EnumIds, kEnumIds, "EnumIds") && yyResult;
break;
case kSubrange:
yyResult = yyCheckChild (yyt, yyt->Subrange.BaseType, kType, "BaseType") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Subrange.Lwb, kExpr, "Lwb") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Subrange.Upb, kExpr, "Upb") && yyResult;
break;
case kTypeId1:
yyResult = yyCheckChild (yyt, yyt->TypeId1.TypeId, kTypeId, "TypeId") && yyResult;
break;
case kField:
yyResult = yyCheckChild (yyt, yyt->Field.Next, kFields, "Next") && yyResult;
break;
case kRecordSect:
yyResult = yyCheckChild (yyt, yyt->RecordSect.Next, kFields, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->RecordSect.FieldIds, kFieldIds, "FieldIds") && yyResult;
yyResult = yyCheckChild (yyt, yyt->RecordSect.Type, kType, "Type") && yyResult;
break;
case kVariantSect:
yyResult = yyCheckChild (yyt, yyt->VariantSect.Next, kFields, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->VariantSect.TagField, kTagField, "TagField") && yyResult;
yyResult = yyCheckChild (yyt, yyt->VariantSect.Variants, kVariants, "Variants") && yyResult;
yyResult = yyCheckChild (yyt, yyt->VariantSect.Else, kFields, "Else") && yyResult;
break;
case kFieldId:
yyResult = yyCheckChild (yyt, yyt->FieldId.Next, kFieldIds, "Next") && yyResult;
break;
case kTagField:
yyResult = yyCheckChild (yyt, yyt->TagField.Type, kTypeId, "Type") && yyResult;
break;
case kTagField1:
yyResult = yyCheckChild (yyt, yyt->TagField1.Type, kTypeId, "Type") && yyResult;
break;
case kTagField2:
yyResult = yyCheckChild (yyt, yyt->TagField2.Type, kTypeId, "Type") && yyResult;
break;
case kVariant:
yyResult = yyCheckChild (yyt, yyt->Variant.Next, kVariants, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Variant.Labels, kLabels, "Labels") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Variant.Variant, kFields, "Variant") && yyResult;
break;
case kFormalType:
yyResult = yyCheckChild (yyt, yyt->FormalType.Next, kFormalTypes, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->FormalType.Type, kType, "Type") && yyResult;
break;
case kEnumId:
yyResult = yyCheckChild (yyt, yyt->EnumId.Next, kEnumIds, "Next") && yyResult;
break;
case kMultiples:
yyResult = yyCheckChild (yyt, yyt->Multiples.Mop, kExpr, "Mop") && yyResult;
break;
case kLastMultiple:
yyResult = yyCheckChild (yyt, yyt->LastMultiple.Mop, kExpr, "Mop") && yyResult;
break;
case kMultiple:
yyResult = yyCheckChild (yyt, yyt->Multiple.Mop, kExpr, "Mop") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Multiple.Multiples, kMultiples, "Multiples") && yyResult;
break;
case kBinary:
yyResult = yyCheckChild (yyt, yyt->Binary.Lop, kExpr, "Lop") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Binary.Rop, kExpr, "Rop") && yyResult;
break;
case kUnary:
yyResult = yyCheckChild (yyt, yyt->Unary.Mop, kExpr, "Mop") && yyResult;
break;
case kFuncCall:
yyResult = yyCheckChild (yyt, yyt->FuncCall.Designator, kDesignator, "Designator") && yyResult;
yyResult = yyCheckChild (yyt, yyt->FuncCall.Actuals, kActuals, "Actuals") && yyResult;
break;
case kMove:
yyResult = yyCheckChild (yyt, yyt->Move.DirSpec, kDirSpec, "DirSpec") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Move.Expr, kExpr, "Expr") && yyResult;
break;
case kReceive:
yyResult = yyCheckChild (yyt, yyt->Receive.DirSpec, kDirSpec, "DirSpec") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Receive.Expr, kExpr, "Expr") && yyResult;
break;
case kReduce:
yyResult = yyCheckChild (yyt, yyt->Reduce.Reduce, kQualid, "Reduce") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Reduce.Expr, kExpr, "Expr") && yyResult;
break;
case kSet:
yyResult = yyCheckChild (yyt, yyt->Set.BaseType, kQualid, "BaseType") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Set.Elems, kElems, "Elems") && yyResult;
break;
case kBitSet:
yyResult = yyCheckChild (yyt, yyt->BitSet.Elems, kElems, "Elems") && yyResult;
break;
case kQualid1:
yyResult = yyCheckChild (yyt, yyt->Qualid1.Qualid, kQualid, "Qualid") && yyResult;
break;
case kProcessor:
yyResult = yyCheckChild (yyt, yyt->Processor.Designator, kDesignator, "Designator") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Processor.Proc, kExpr, "Proc") && yyResult;
break;
case kDimensions:
yyResult = yyCheckChild (yyt, yyt->Dimensions.Designator, kDesignator, "Designator") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Dimensions.Actuals, kActuals, "Actuals") && yyResult;
break;
case kSelect:
yyResult = yyCheckChild (yyt, yyt->Select.Designator, kDesignator, "Designator") && yyResult;
break;
case kSubscript:
yyResult = yyCheckChild (yyt, yyt->Subscript.Designator, kDesignator, "Designator") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Subscript.Index, kExpr, "Index") && yyResult;
break;
case kDeref:
yyResult = yyCheckChild (yyt, yyt->Deref.Designator, kDesignator, "Designator") && yyResult;
break;
case kFuncSpec:
yyResult = yyCheckChild (yyt, yyt->FuncSpec.DirOut, kQualid, "DirOut") && yyResult;
yyResult = yyCheckChild (yyt, yyt->FuncSpec.DirOutIndex, kExpr, "DirOutIndex") && yyResult;
yyResult = yyCheckChild (yyt, yyt->FuncSpec.Step, kExpr, "Step") && yyResult;
yyResult = yyCheckChild (yyt, yyt->FuncSpec.Reduce, kQualid, "Reduce") && yyResult;
break;
case kProcSpec:
yyResult = yyCheckChild (yyt, yyt->ProcSpec.Expr, kExpr, "Expr") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ProcSpec.Reduce, kQualid, "Reduce") && yyResult;
break;
case kDimSpec:
yyResult = yyCheckChild (yyt, yyt->DimSpec.Actuals, kActuals, "Actuals") && yyResult;
yyResult = yyCheckChild (yyt, yyt->DimSpec.Reduce, kQualid, "Reduce") && yyResult;
break;
case kElem:
yyResult = yyCheckChild (yyt, yyt->Elem.Next, kElems, "Next") && yyResult;
break;
case kElemExpr:
yyResult = yyCheckChild (yyt, yyt->ElemExpr.Next, kElems, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ElemExpr.Elem, kExpr, "Elem") && yyResult;
break;
case kElemRange:
yyResult = yyCheckChild (yyt, yyt->ElemRange.Next, kElems, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ElemRange.Lwb, kExpr, "Lwb") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ElemRange.Upb, kExpr, "Upb") && yyResult;
break;
case kActual:
yyResult = yyCheckChild (yyt, yyt->Actual.Next, kActuals, "Next") && yyResult;
break;
case kActualExpr:
yyResult = yyCheckChild (yyt, yyt->ActualExpr.Next, kActuals, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ActualExpr.Expr, kExpr, "Expr") && yyResult;
break;
case kActualRange:
yyResult = yyCheckChild (yyt, yyt->ActualRange.Next, kActuals, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ActualRange.Lwb, kExpr, "Lwb") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ActualRange.Upb, kExpr, "Upb") && yyResult;
break;
case kActualReduce:
yyResult = yyCheckChild (yyt, yyt->ActualReduce.Next, kActuals, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->ActualReduce.Qualid, kQualid, "Qualid") && yyResult;
break;
case kActualStar:
yyResult = yyCheckChild (yyt, yyt->ActualStar.Next, kActuals, "Next") && yyResult;
break;
case kStmt:
yyResult = yyCheckChild (yyt, yyt->Stmt.Next, kStmts, "Next") && yyResult;
break;
case kAssign:
yyResult = yyCheckChild (yyt, yyt->Assign.Next, kStmts, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Assign.Designator, kDesignator, "Designator") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Assign.Expr, kExpr, "Expr") && yyResult;
break;
case kCall:
yyResult = yyCheckChild (yyt, yyt->Call.Next, kStmts, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Call.Designator, kDesignator, "Designator") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Call.Actuals, kActuals, "Actuals") && yyResult;
break;
case kIf:
yyResult = yyCheckChild (yyt, yyt->If.Next, kStmts, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->If.Cond, kExpr, "Cond") && yyResult;
yyResult = yyCheckChild (yyt, yyt->If.Then, kStmts, "Then") && yyResult;
yyResult = yyCheckChild (yyt, yyt->If.Elsifs, kElsifs, "Elsifs") && yyResult;
yyResult = yyCheckChild (yyt, yyt->If.Else, kStmts, "Else") && yyResult;
break;
case kCase:
yyResult = yyCheckChild (yyt, yyt->Case.Next, kStmts, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Case.Expr, kExpr, "Expr") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Case.Cases, kCases, "Cases") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Case.Else, kStmts, "Else") && yyResult;
break;
case kWhile:
yyResult = yyCheckChild (yyt, yyt->While.Next, kStmts, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->While.Cond, kExpr, "Cond") && yyResult;
yyResult = yyCheckChild (yyt, yyt->While.Stmts, kStmts, "Stmts") && yyResult;
break;
case kRepeat:
yyResult = yyCheckChild (yyt, yyt->Repeat.Next, kStmts, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Repeat.Stmts, kStmts, "Stmts") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Repeat.Cond, kExpr, "Cond") && yyResult;
break;
case kLoop:
yyResult = yyCheckChild (yyt, yyt->Loop.Next, kStmts, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Loop.Stmts, kStmts, "Stmts") && yyResult;
break;
case kLooppar:
yyResult = yyCheckChild (yyt, yyt->Looppar.Next, kStmts, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Looppar.Qualid, kQualid, "Qualid") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Looppar.Stmts, kStmts, "Stmts") && yyResult;
break;
case kFor:
yyResult = yyCheckChild (yyt, yyt->For.Next, kStmts, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->For.Qualid, kQualid, "Qualid") && yyResult;
yyResult = yyCheckChild (yyt, yyt->For.From, kExpr, "From") && yyResult;
yyResult = yyCheckChild (yyt, yyt->For.To, kExpr, "To") && yyResult;
yyResult = yyCheckChild (yyt, yyt->For.By, kExpr, "By") && yyResult;
yyResult = yyCheckChild (yyt, yyt->For.Stmts, kStmts, "Stmts") && yyResult;
break;
case kWith:
yyResult = yyCheckChild (yyt, yyt->With.Next, kStmts, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->With.Designator, kDesignator, "Designator") && yyResult;
yyResult = yyCheckChild (yyt, yyt->With.Stmts, kStmts, "Stmts") && yyResult;
break;
case kAll:
yyResult = yyCheckChild (yyt, yyt->All.Next, kStmts, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->All.Qualid, kQualid, "Qualid") && yyResult;
yyResult = yyCheckChild (yyt, yyt->All.Stmts, kStmts, "Stmts") && yyResult;
break;
case kSend:
yyResult = yyCheckChild (yyt, yyt->Send.Next, kStmts, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Send.DirSpec, kDirSpec, "DirSpec") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Send.From, kExpr, "From") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Send.To, kDesignator, "To") && yyResult;
break;
case kLoad:
yyResult = yyCheckChild (yyt, yyt->Load.Next, kStmts, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Load.What, kDesignator, "What") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Load.From, kDesignator, "From") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Load.Size, kDesignator, "Size") && yyResult;
break;
case kStore:
yyResult = yyCheckChild (yyt, yyt->Store.Next, kStmts, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Store.What, kDesignator, "What") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Store.To, kDesignator, "To") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Store.Size, kDesignator, "Size") && yyResult;
break;
case kExit:
yyResult = yyCheckChild (yyt, yyt->Exit.Next, kStmts, "Next") && yyResult;
break;
case kReturn0:
yyResult = yyCheckChild (yyt, yyt->Return0.Next, kStmts, "Next") && yyResult;
break;
case kReturn1:
yyResult = yyCheckChild (yyt, yyt->Return1.Next, kStmts, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Return1.Result, kExpr, "Result") && yyResult;
break;
case kElsif:
yyResult = yyCheckChild (yyt, yyt->Elsif.Next, kElsifs, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Elsif.Cond, kExpr, "Cond") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Elsif.Stmts, kStmts, "Stmts") && yyResult;
break;
case kCases1:
yyResult = yyCheckChild (yyt, yyt->Cases1.Next, kCases, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Cases1.Labels, kLabels, "Labels") && yyResult;
yyResult = yyCheckChild (yyt, yyt->Cases1.Stmts, kStmts, "Stmts") && yyResult;
break;
case kLabel:
yyResult = yyCheckChild (yyt, yyt->Label.Next, kLabels, "Next") && yyResult;
break;
case kLabelExpr:
yyResult = yyCheckChild (yyt, yyt->LabelExpr.Next, kLabels, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->LabelExpr.Expr, kExpr, "Expr") && yyResult;
break;
case kLabelRange:
yyResult = yyCheckChild (yyt, yyt->LabelRange.Next, kLabels, "Next") && yyResult;
yyResult = yyCheckChild (yyt, yyt->LabelRange.Lwb, kExpr, "Lwb") && yyResult;
yyResult = yyCheckChild (yyt, yyt->LabelRange.Upb, kExpr, "Upb") && yyResult;
break;
 default: ;
 }
 return yyResult;
}

# define yyyWrite	1
# define yyyRead	2
# define yyyQuit	3

static char yyyString [32], yyCh;
static int yyLength, yyState;

static bool yyyIsEqual
# if defined __STDC__ | defined __cplusplus
 (char * yya)
# else
 (yya) char * yya;
# endif
{
 register int yyi;
 if (yyLength >= 0 && yyyString [yyLength] == ' ') {
  if (yyLength != strlen (yya)) return false;
  for (yyi = 0; yyi < yyLength; yyi ++)
   if (yyyString [yyi] != yya [yyi]) return false;
 } else {
  if (yyLength >= strlen (yya)) return false;
  for (yyi = 0; yyi <= yyLength; yyi ++)
   if (yyyString [yyi] != yya [yyi]) return false;
 }
 return true;
}

void QueryTree
# if defined __STDC__ | defined __cplusplus
 (tTree yyt)
# else
 (yyt) tTree yyt;
# endif
{
 yyState = yyyWrite;
 for (;;) {
  switch (yyState) {
  case yyyQuit : return;
  case yyyWrite: WriteTreeNode (stdout, yyt); yyState = yyyRead;
  case yyyRead : (void) printf ("? "); yyLength = -1; yyCh = getc (stdin);
   while (yyCh != '\n' && yyCh > 0)
    { yyyString [++ yyLength] = yyCh; yyCh = getc (stdin); }
   if (yyCh < 0) { (void) fputs ("QueryTree: eof reached\n", stderr);
    yyState = yyyQuit; return; }
   if      (yyyIsEqual ("parent")) { yyState = yyyWrite; return; }
   
else if (yyyIsEqual ("quit"  )) { yyState = yyyQuit ; return; }
else if (yyyIsEqual ("QuerySymbols"  )) {
int yySave= yyState;
start_QuerySymbols();
yyState = yySave;
}
   else if (yyt != NoTree) {
    switch (yyt->Kind) {
case kROOT: if (false) ;
else if (yyyIsEqual ("CompUnits")) QueryTree (yyt->ROOT.CompUnits);
break;
case kCompUnit: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->CompUnit.Next);
break;
case kDefMod: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->DefMod.Next);
else if (yyyIsEqual ("Imports")) QueryTree (yyt->DefMod.Imports);
else if (yyyIsEqual ("Exports")) QueryTree (yyt->DefMod.Exports);
else if (yyyIsEqual ("Decls")) QueryTree (yyt->DefMod.Decls);
break;
case kImplMod: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->ImplMod.Next);
else if (yyyIsEqual ("Imports")) QueryTree (yyt->ImplMod.Imports);
else if (yyyIsEqual ("Decls")) QueryTree (yyt->ImplMod.Decls);
else if (yyyIsEqual ("Stmts")) QueryTree (yyt->ImplMod.Stmts);
break;
case kImport: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Import.Next);
break;
case kFrom: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->From.Next);
else if (yyyIsEqual ("ImpIds")) QueryTree (yyt->From.ImpIds);
break;
case kObjects: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Objects.Next);
else if (yyyIsEqual ("ImpIds")) QueryTree (yyt->Objects.ImpIds);
break;
case kImpId: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->ImpId.Next);
break;
case kExport: if (false) ;
else if (yyyIsEqual ("ExpIds")) QueryTree (yyt->Export.ExpIds);
break;
case kExpId: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->ExpId.Next);
break;
case kDecl: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Decl.Next);
break;
case kVar: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Var.Next);
else if (yyyIsEqual ("VarIds")) QueryTree (yyt->Var.VarIds);
else if (yyyIsEqual ("Type")) QueryTree (yyt->Var.Type);
break;
case kObject: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Object.Next);
break;
case kConnectFrom: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->ConnectFrom.Next);
else if (yyyIsEqual ("From")) QueryTree (yyt->ConnectFrom.From);
else if (yyyIsEqual ("To")) QueryTree (yyt->ConnectFrom.To);
else if (yyyIsEqual ("ConnectDecls")) QueryTree (yyt->ConnectFrom.ConnectDecls);
break;
case kConnectDecls: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->ConnectDecls.Next);
else if (yyyIsEqual ("Index")) QueryTree (yyt->ConnectDecls.Index);
else if (yyyIsEqual ("Config")) QueryTree (yyt->ConnectDecls.Config);
else if (yyyIsEqual ("Actuals")) QueryTree (yyt->ConnectDecls.Actuals);
else if (yyyIsEqual ("DirIn")) QueryTree (yyt->ConnectDecls.DirIn);
break;
case kConfig: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Config.Next);
else if (yyyIsEqual ("Actuals")) QueryTree (yyt->Config.Actuals);
else if (yyyIsEqual ("Qualid")) QueryTree (yyt->Config.Qualid);
break;
case kConst: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Const.Next);
else if (yyyIsEqual ("Expr")) QueryTree (yyt->Const.Expr);
break;
case kTypeDecl: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->TypeDecl.Next);
else if (yyyIsEqual ("Type")) QueryTree (yyt->TypeDecl.Type);
break;
case kProc: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Proc.Next);
else if (yyyIsEqual ("Formals")) QueryTree (yyt->Proc.Formals);
else if (yyyIsEqual ("ResultType")) QueryTree (yyt->Proc.ResultType);
else if (yyyIsEqual ("Decls")) QueryTree (yyt->Proc.Decls);
else if (yyyIsEqual ("Stmts")) QueryTree (yyt->Proc.Stmts);
break;
case kProcHead: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->ProcHead.Next);
else if (yyyIsEqual ("Formals")) QueryTree (yyt->ProcHead.Formals);
else if (yyyIsEqual ("ResultType")) QueryTree (yyt->ProcHead.ResultType);
break;
case kOpaque: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Opaque.Next);
break;
case kConnectDest: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->ConnectDest.Next);
else if (yyyIsEqual ("Expr")) QueryTree (yyt->ConnectDest.Expr);
else if (yyyIsEqual ("Config")) QueryTree (yyt->ConnectDest.Config);
else if (yyyIsEqual ("Actuals")) QueryTree (yyt->ConnectDest.Actuals);
break;
case kConnectDestUni: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->ConnectDestUni.Next);
else if (yyyIsEqual ("Expr")) QueryTree (yyt->ConnectDestUni.Expr);
else if (yyyIsEqual ("Config")) QueryTree (yyt->ConnectDestUni.Config);
else if (yyyIsEqual ("Actuals")) QueryTree (yyt->ConnectDestUni.Actuals);
break;
case kConnectDestBi: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->ConnectDestBi.Next);
else if (yyyIsEqual ("Expr")) QueryTree (yyt->ConnectDestBi.Expr);
else if (yyyIsEqual ("Config")) QueryTree (yyt->ConnectDestBi.Config);
else if (yyyIsEqual ("Actuals")) QueryTree (yyt->ConnectDestBi.Actuals);
else if (yyyIsEqual ("Index")) QueryTree (yyt->ConnectDestBi.Index);
break;
case kVarId: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->VarId.Next);
break;
case kFormal: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Formal.Next);
else if (yyyIsEqual ("ParIds")) QueryTree (yyt->Formal.ParIds);
else if (yyyIsEqual ("Type")) QueryTree (yyt->Formal.Type);
break;
case kParId: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->ParId.Next);
break;
case kVector: if (false) ;
else if (yyyIsEqual ("Config")) QueryTree (yyt->Vector.Config);
else if (yyyIsEqual ("Scalar")) QueryTree (yyt->Vector.Scalar);
break;
case kArray: if (false) ;
else if (yyyIsEqual ("Index")) QueryTree (yyt->Array.Index);
else if (yyyIsEqual ("ElemType")) QueryTree (yyt->Array.ElemType);
break;
case kRecord: if (false) ;
else if (yyyIsEqual ("Fields")) QueryTree (yyt->Record.Fields);
break;
case kSetType: if (false) ;
else if (yyyIsEqual ("BaseType")) QueryTree (yyt->SetType.BaseType);
break;
case kPointer: if (false) ;
else if (yyyIsEqual ("TargetType")) QueryTree (yyt->Pointer.TargetType);
break;
case kProcType: if (false) ;
else if (yyyIsEqual ("FormalTypes")) QueryTree (yyt->ProcType.FormalTypes);
else if (yyyIsEqual ("ResultType")) QueryTree (yyt->ProcType.ResultType);
break;
case kEnumeration: if (false) ;
else if (yyyIsEqual ("EnumIds")) QueryTree (yyt->Enumeration.EnumIds);
break;
case kSubrange: if (false) ;
else if (yyyIsEqual ("BaseType")) QueryTree (yyt->Subrange.BaseType);
else if (yyyIsEqual ("Lwb")) QueryTree (yyt->Subrange.Lwb);
else if (yyyIsEqual ("Upb")) QueryTree (yyt->Subrange.Upb);
break;
case kTypeId1: if (false) ;
else if (yyyIsEqual ("TypeId")) QueryTree (yyt->TypeId1.TypeId);
break;
case kField: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Field.Next);
break;
case kRecordSect: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->RecordSect.Next);
else if (yyyIsEqual ("FieldIds")) QueryTree (yyt->RecordSect.FieldIds);
else if (yyyIsEqual ("Type")) QueryTree (yyt->RecordSect.Type);
break;
case kVariantSect: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->VariantSect.Next);
else if (yyyIsEqual ("TagField")) QueryTree (yyt->VariantSect.TagField);
else if (yyyIsEqual ("Variants")) QueryTree (yyt->VariantSect.Variants);
else if (yyyIsEqual ("Else")) QueryTree (yyt->VariantSect.Else);
break;
case kFieldId: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->FieldId.Next);
break;
case kTagField: if (false) ;
else if (yyyIsEqual ("Type")) QueryTree (yyt->TagField.Type);
break;
case kTagField1: if (false) ;
else if (yyyIsEqual ("Type")) QueryTree (yyt->TagField1.Type);
break;
case kTagField2: if (false) ;
else if (yyyIsEqual ("Type")) QueryTree (yyt->TagField2.Type);
break;
case kVariant: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Variant.Next);
else if (yyyIsEqual ("Labels")) QueryTree (yyt->Variant.Labels);
else if (yyyIsEqual ("Variant")) QueryTree (yyt->Variant.Variant);
break;
case kFormalType: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->FormalType.Next);
else if (yyyIsEqual ("Type")) QueryTree (yyt->FormalType.Type);
break;
case kEnumId: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->EnumId.Next);
break;
case kMultiples: if (false) ;
else if (yyyIsEqual ("Mop")) QueryTree (yyt->Multiples.Mop);
break;
case kLastMultiple: if (false) ;
else if (yyyIsEqual ("Mop")) QueryTree (yyt->LastMultiple.Mop);
break;
case kMultiple: if (false) ;
else if (yyyIsEqual ("Mop")) QueryTree (yyt->Multiple.Mop);
else if (yyyIsEqual ("Multiples")) QueryTree (yyt->Multiple.Multiples);
break;
case kBinary: if (false) ;
else if (yyyIsEqual ("Lop")) QueryTree (yyt->Binary.Lop);
else if (yyyIsEqual ("Rop")) QueryTree (yyt->Binary.Rop);
break;
case kUnary: if (false) ;
else if (yyyIsEqual ("Mop")) QueryTree (yyt->Unary.Mop);
break;
case kFuncCall: if (false) ;
else if (yyyIsEqual ("Designator")) QueryTree (yyt->FuncCall.Designator);
else if (yyyIsEqual ("Actuals")) QueryTree (yyt->FuncCall.Actuals);
break;
case kMove: if (false) ;
else if (yyyIsEqual ("DirSpec")) QueryTree (yyt->Move.DirSpec);
else if (yyyIsEqual ("Expr")) QueryTree (yyt->Move.Expr);
break;
case kReceive: if (false) ;
else if (yyyIsEqual ("DirSpec")) QueryTree (yyt->Receive.DirSpec);
else if (yyyIsEqual ("Expr")) QueryTree (yyt->Receive.Expr);
break;
case kReduce: if (false) ;
else if (yyyIsEqual ("Reduce")) QueryTree (yyt->Reduce.Reduce);
else if (yyyIsEqual ("Expr")) QueryTree (yyt->Reduce.Expr);
break;
case kSet: if (false) ;
else if (yyyIsEqual ("BaseType")) QueryTree (yyt->Set.BaseType);
else if (yyyIsEqual ("Elems")) QueryTree (yyt->Set.Elems);
break;
case kBitSet: if (false) ;
else if (yyyIsEqual ("Elems")) QueryTree (yyt->BitSet.Elems);
break;
case kQualid1: if (false) ;
else if (yyyIsEqual ("Qualid")) QueryTree (yyt->Qualid1.Qualid);
break;
case kProcessor: if (false) ;
else if (yyyIsEqual ("Designator")) QueryTree (yyt->Processor.Designator);
else if (yyyIsEqual ("Proc")) QueryTree (yyt->Processor.Proc);
break;
case kDimensions: if (false) ;
else if (yyyIsEqual ("Designator")) QueryTree (yyt->Dimensions.Designator);
else if (yyyIsEqual ("Actuals")) QueryTree (yyt->Dimensions.Actuals);
break;
case kSelect: if (false) ;
else if (yyyIsEqual ("Designator")) QueryTree (yyt->Select.Designator);
break;
case kSubscript: if (false) ;
else if (yyyIsEqual ("Designator")) QueryTree (yyt->Subscript.Designator);
else if (yyyIsEqual ("Index")) QueryTree (yyt->Subscript.Index);
break;
case kDeref: if (false) ;
else if (yyyIsEqual ("Designator")) QueryTree (yyt->Deref.Designator);
break;
case kFuncSpec: if (false) ;
else if (yyyIsEqual ("DirOut")) QueryTree (yyt->FuncSpec.DirOut);
else if (yyyIsEqual ("DirOutIndex")) QueryTree (yyt->FuncSpec.DirOutIndex);
else if (yyyIsEqual ("Step")) QueryTree (yyt->FuncSpec.Step);
else if (yyyIsEqual ("Reduce")) QueryTree (yyt->FuncSpec.Reduce);
break;
case kProcSpec: if (false) ;
else if (yyyIsEqual ("Expr")) QueryTree (yyt->ProcSpec.Expr);
else if (yyyIsEqual ("Reduce")) QueryTree (yyt->ProcSpec.Reduce);
break;
case kDimSpec: if (false) ;
else if (yyyIsEqual ("Actuals")) QueryTree (yyt->DimSpec.Actuals);
else if (yyyIsEqual ("Reduce")) QueryTree (yyt->DimSpec.Reduce);
break;
case kElem: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Elem.Next);
break;
case kElemExpr: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->ElemExpr.Next);
else if (yyyIsEqual ("Elem")) QueryTree (yyt->ElemExpr.Elem);
break;
case kElemRange: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->ElemRange.Next);
else if (yyyIsEqual ("Lwb")) QueryTree (yyt->ElemRange.Lwb);
else if (yyyIsEqual ("Upb")) QueryTree (yyt->ElemRange.Upb);
break;
case kActual: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Actual.Next);
break;
case kActualExpr: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->ActualExpr.Next);
else if (yyyIsEqual ("Expr")) QueryTree (yyt->ActualExpr.Expr);
break;
case kActualRange: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->ActualRange.Next);
else if (yyyIsEqual ("Lwb")) QueryTree (yyt->ActualRange.Lwb);
else if (yyyIsEqual ("Upb")) QueryTree (yyt->ActualRange.Upb);
break;
case kActualReduce: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->ActualReduce.Next);
else if (yyyIsEqual ("Qualid")) QueryTree (yyt->ActualReduce.Qualid);
break;
case kActualStar: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->ActualStar.Next);
break;
case kStmt: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Stmt.Next);
break;
case kAssign: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Assign.Next);
else if (yyyIsEqual ("Designator")) QueryTree (yyt->Assign.Designator);
else if (yyyIsEqual ("Expr")) QueryTree (yyt->Assign.Expr);
break;
case kCall: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Call.Next);
else if (yyyIsEqual ("Designator")) QueryTree (yyt->Call.Designator);
else if (yyyIsEqual ("Actuals")) QueryTree (yyt->Call.Actuals);
break;
case kIf: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->If.Next);
else if (yyyIsEqual ("Cond")) QueryTree (yyt->If.Cond);
else if (yyyIsEqual ("Then")) QueryTree (yyt->If.Then);
else if (yyyIsEqual ("Elsifs")) QueryTree (yyt->If.Elsifs);
else if (yyyIsEqual ("Else")) QueryTree (yyt->If.Else);
break;
case kCase: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Case.Next);
else if (yyyIsEqual ("Expr")) QueryTree (yyt->Case.Expr);
else if (yyyIsEqual ("Cases")) QueryTree (yyt->Case.Cases);
else if (yyyIsEqual ("Else")) QueryTree (yyt->Case.Else);
break;
case kWhile: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->While.Next);
else if (yyyIsEqual ("Cond")) QueryTree (yyt->While.Cond);
else if (yyyIsEqual ("Stmts")) QueryTree (yyt->While.Stmts);
break;
case kRepeat: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Repeat.Next);
else if (yyyIsEqual ("Stmts")) QueryTree (yyt->Repeat.Stmts);
else if (yyyIsEqual ("Cond")) QueryTree (yyt->Repeat.Cond);
break;
case kLoop: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Loop.Next);
else if (yyyIsEqual ("Stmts")) QueryTree (yyt->Loop.Stmts);
break;
case kLooppar: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Looppar.Next);
else if (yyyIsEqual ("Qualid")) QueryTree (yyt->Looppar.Qualid);
else if (yyyIsEqual ("Stmts")) QueryTree (yyt->Looppar.Stmts);
break;
case kFor: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->For.Next);
else if (yyyIsEqual ("Qualid")) QueryTree (yyt->For.Qualid);
else if (yyyIsEqual ("From")) QueryTree (yyt->For.From);
else if (yyyIsEqual ("To")) QueryTree (yyt->For.To);
else if (yyyIsEqual ("By")) QueryTree (yyt->For.By);
else if (yyyIsEqual ("Stmts")) QueryTree (yyt->For.Stmts);
break;
case kWith: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->With.Next);
else if (yyyIsEqual ("Designator")) QueryTree (yyt->With.Designator);
else if (yyyIsEqual ("Stmts")) QueryTree (yyt->With.Stmts);
break;
case kAll: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->All.Next);
else if (yyyIsEqual ("Qualid")) QueryTree (yyt->All.Qualid);
else if (yyyIsEqual ("Stmts")) QueryTree (yyt->All.Stmts);
break;
case kSend: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Send.Next);
else if (yyyIsEqual ("DirSpec")) QueryTree (yyt->Send.DirSpec);
else if (yyyIsEqual ("From")) QueryTree (yyt->Send.From);
else if (yyyIsEqual ("To")) QueryTree (yyt->Send.To);
break;
case kLoad: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Load.Next);
else if (yyyIsEqual ("What")) QueryTree (yyt->Load.What);
else if (yyyIsEqual ("From")) QueryTree (yyt->Load.From);
else if (yyyIsEqual ("Size")) QueryTree (yyt->Load.Size);
break;
case kStore: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Store.Next);
else if (yyyIsEqual ("What")) QueryTree (yyt->Store.What);
else if (yyyIsEqual ("To")) QueryTree (yyt->Store.To);
else if (yyyIsEqual ("Size")) QueryTree (yyt->Store.Size);
break;
case kExit: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Exit.Next);
break;
case kReturn0: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Return0.Next);
break;
case kReturn1: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Return1.Next);
else if (yyyIsEqual ("Result")) QueryTree (yyt->Return1.Result);
break;
case kElsif: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Elsif.Next);
else if (yyyIsEqual ("Cond")) QueryTree (yyt->Elsif.Cond);
else if (yyyIsEqual ("Stmts")) QueryTree (yyt->Elsif.Stmts);
break;
case kCases1: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Cases1.Next);
else if (yyyIsEqual ("Labels")) QueryTree (yyt->Cases1.Labels);
else if (yyyIsEqual ("Stmts")) QueryTree (yyt->Cases1.Stmts);
break;
case kLabel: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->Label.Next);
break;
case kLabelExpr: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->LabelExpr.Next);
else if (yyyIsEqual ("Expr")) QueryTree (yyt->LabelExpr.Expr);
break;
case kLabelRange: if (false) ;
else if (yyyIsEqual ("Next")) QueryTree (yyt->LabelRange.Next);
else if (yyyIsEqual ("Lwb")) QueryTree (yyt->LabelRange.Lwb);
else if (yyyIsEqual ("Upb")) QueryTree (yyt->LabelRange.Upb);
break;
    default: ;
    }
   }
  }
 }
}

void BeginTree ()
{
/* line 172 "parallaxis.cg" */

Options_Init();
Positions_Init();
UniqueIds_Init();

NoExpr       = mNoExpr();
NoQualid     = mQualid0(NoIdent, NoPosition);
Tree_Integer = mTypeId0(MakeIdent("INTEGER", 7), NoPosition);
Tree_Boolean = mTypeId0(MakeIdent("BOOLEAN", 7), NoPosition);
Tree_Char    = mTypeId0(MakeIdent("CHAR", 4), NoPosition);


}

void CloseTree ()
{
}
